#include "options.inc"

c
c--------------------------------------------------------
c  Templates to read surface tracer fluxes from dataset
c  stored in external files.
c
c  Notes:
c   heat flux should be in cal/s/cm**2
c   restoring temperature should be in deg C
c   restoring coeff. for temp. should be in cal/s/cm**2/K
c   salt flux should be in (psu/1000-35)/s/cm**2
c   restoring salinity should be in psu/1000-35
c   restoring coeff. for sal. should be in cm/s
c
c   Two subroutines are defined:
c   "read_dims_tr" and "read_tr" both called in prep_sbc (in prep_main.F) 
c   Each tracer can be treated different, i.e. could
c   have different grids and is  referenced by "ntr"
c   Header of subroutines should not be touched.
c   CPP directives are set in prep_template.F
c
c                            c.eden  nov 2002
c--------------------------------------------------------
c
#ifdef read_density_flx_ecmwf
c
c--------------------------------------------------------
c    use a 3 year monthly mean climatology from the european
c    ECMWF model (same data used in the DYNAMO project)
c--------------------------------------------------------
c
       subroutine read_dims_tr(nx,ny,nt,ntr)
       use prep_module
       implicit none
       integer nx,ny,nt,ntr
       character*32 stamp
       real :: dpm
       integer :: io
#include "netcdf.inc"
       integer :: iret,ncid,vid,ndims,dims(4)
       if (ntr == 1 ) then
        print*,' reading heat flux boundary conditions from'
        print*,' Barniers ECMWF analysis, which were also used'
        print*,' in the DYNAMO project'
        nt=12
        call getunit(io,'data/ecmwf/ecmwf_BB.qnet','usr ieee')
        read (io); read (io) stamp, dpm, nx, ny
        close(io)
       elseif (ntr == 2) then
        print*,' reading salt flux boundary condition from'
        print*,' monthly climatological SSS (file ts.dta) '
        print*,' and using a fixed restoring time scale '
#ifdef read_salt_fl_from_E5
        print*,' reading salt flux data from E5 exp. '
#endif
        nt=12; nx=imt; ny=jmt
#if defined  prep_for_LEDWELL || defined prep_for_OBC_tracer
       elseif (ntr >= 3) then
        print*,' for tracer #',ntr,' there is no flux'
c     however read some dummy data in any case
        iret=nf_open('data/U10/u10.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'u10',vid)
        iret=NF_INQ_VARNDIMS(NCID, vid, ndims)  
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
        call ncclos (ncid, iret)
#endif

#ifdef  prep_for_CFC 
       elseif (ntr == 3) then
        print*,' for tracer 3 we are using a climatology'
        print*,' of U(10m) for the restoring time scale '
        iret=nf_open('data/U10/u10.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'u10',vid)
        iret=NF_INQ_VARNDIMS(NCID, vid, ndims)  
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
        call ncclos (ncid, iret)
#endif

#ifdef  prep_for_NPZD
       elseif (ntr >= 3 .and. ntr<=6 ) then
        print*,' for passive tracer in the NPZD model ',
     &         'we are using a climatology of solar radiation'
        nt=12
        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
        read (io); read (io) stamp, dpm, nx, ny
        close(io)
       elseif (ntr == 7 .or. ntr==8 
#ifdef  prep_for_ACO2
     &       .or. ntr >= 9  
#endif
     &               ) then
        print*,' for DIC/O2 we are using a climatology'
        print*,' of U(10m) for the restoring time scale '
#ifdef read_piston_velocity_U10
        print*,' reading from file data/U10/u10.cdf'
        iret=nf_open('data/U10/u10.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'u10',vid)
        iret=NF_INQ_VARNDIMS(NCID, vid, ndims)  
        if (ndims/=3) then
         print*,' number of dimensions for variable not equal 3'
         print*,ndims
         call halt_stop(' in read_dims_tr (NPZD) ')
        endif
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
        call ncclos (ncid, iret)
#endif
#ifdef read_piston_velocity_WSPD
        print*,' reading from file data/U10/wspd_mcycle.cdf'
        iret=nf_open('data/U10/wspd_mcycle.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'wspd',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx);nx=nx+2
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
        call ncclos (ncid, iret)
        print*,' this is converted to piston velocity during model run'
        print*,' and time series of pressure for DIC boundary condition'
#endif
#ifndef  prep_for_ACO2
       elseif (ntr ==9 ) then
c     this is for dissolved organic carbon 
        print*,' for passive tracer in the NPZD model ',
     &         'we are using a climatology of solar radiation'
        nt=12
        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
        read (io); read (io) stamp, dpm, nx, ny
        close(io)
#endif
#endif
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_dims_tr




       subroutine read_tr(tr_clim,tr_rest,tr_flux,
     &                    x,y,time,toffset,nx,ny,nt,ntr)
c
       ! returns inverse restoring time scale for tracers 
       ! number ntr in tr_rest
       ! and climatology to restore against in tr_clim
       ! nx,ny are horizontal dimensions of the data
       ! nt the time steps,
       ! x/y the longitude/latitude of the grid
       ! should mask data with spval
       ! return also net fluxes in Barniers heat flux formulation
       ! or alternatively the shortwave solar radiation in the net flux array
       ! if available 
       ! Units: mom units for tr_clim and tr_rest
c       
       use prep_module
       implicit none
       integer nx,ny,nt,ntr,m
       real tr_clim(nx,ny,nt) ,x(nx), y(ny)
       real tr_rest(nx,ny,nt) 
       real tr_flux(nx,ny,nt) ,time(nt),toffset
       character*32 stamp
       real, allocatable, dimension(:,:,:) :: qnet,qnec,airt,qsol
       real, allocatable, dimension(:,:)   :: mask
       real :: dpm
       integer  k,n,io,i,j
       real,parameter ::rhonull=1.026, Cpw=0.955, dimfac=0.2389e-4
       real,parameter ::qfac = dimfac/(rhonull*Cpw)
#include "netcdf.inc"
       integer :: iret,ncid,vid,dims(4),lonid,latid,corner(4),edges(4)
       character (len=80) :: dname
#ifdef netcdf_real4
      real (kind=4) :: v4(nx,ny) ,x4(nx),y4(ny),sp
#else
      real :: v4(nx,ny) ,x4(nx),y4(ny),sp
#endif
       time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
       toffset=0.0

       if (ntr == 1) then
c     SBC for heat comes from Barniers formulation
        allocate( qnet(nx,ny,nt), qnec(nx,ny,nt), airt(nx,ny,nt))
        allocate( mask(nx,ny), qsol(nx,ny,nt))
        call getunit(io,'data/ecmwf/ecmwf_BB.qnet','usr ieee')
        do n=1,nt
         read (io); read (io) stamp, dpm, k, k, k, x,y,qnet(:,:,n)
         time(n)=dpm
        enddo
        close(io)
        call getunit(io,'data/ecmwf/ecmwf_BB.qnec','usr ieee')
        do n=1,nt
         read (io); read (io) stamp, dpm, k, k, k, x,y,qnec(:,:,n)
        enddo
        close(io)
        call getunit(io,'data/ecmwf/ecmwf_BB.airt','usr ieee')
        do n=1,nt
         read (io); read (io) stamp, dpm, k, k, k, x,y,airt(:,:,n)
        enddo
        close(io)
        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
        do n=1,nt
         read (io); read (io) stamp, dpm, k, k, k, x,y,qsol(:,:,n)
        enddo
        close(io)
        where (qnec/=0.) 
             tr_clim(:,:,:) = airt + qnet/qnec
c             tr_flux(:,:,:) = qnet  ! store net heat flux
             tr_flux(:,:,:) = qsol/41868.0  ! no store shortwave radiation in the array
        elsewhere
             tr_clim(:,:,:) = spval
        end where
        tr_rest(:,:,:) = qnec*qfac
!     land apply mask
        call getunit(io,'data/ecmwf/ecmwf_BB.mask','usr ieee')
        read (io) ; read (io); read (io) mask; close(io)
        do n=1,nt
         where (mask==0.) tr_clim(:,:,n) = spval
         where (mask==0.) tr_rest(:,:,n) = spval
         where (mask==0.) tr_flux(:,:,n) = spval
        enddo
        deallocate( qnet, qnec, airt,mask,qsol)
       elseif (ntr == 2) then
c    surface salt flux for salinity
#ifdef read_salt_fl_from_E5
c      read salt flux from previous model solution
c      (to implement mixed boundary conditions)
        iret=nf_open(
     &'/users/model/ceden/dov3/N_atl/E5_bbl/salt_fl_mmean_ufo.cdf'
     &              , NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'salt_fl',vid)
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,n,1/); edges=(/nx,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4)
         where( v4 /= sp) v4 = v4/10.  ! convert to cgs
         where( v4 == sp) v4 = -1000.0
         tr_flux(:,:,n)=v4
        enddo
        where( tr_flux == -1000.0 ) tr_flux = spval
        call ncclos (ncid, iret)
#else
        tr_flux=0. ! unknown otherwise 
c      (flux is not used for restoring formulation)
#endif
        tr_rest=1./15.0*dzt(1)/86400.
c        tr_rest=1./15.0*dzt(1)/86400.*10.0
c     read restoring salinity from previously interpolated data
c     which are also used for the initial conditions, sponge layers,  etc.
        call getunit(io,'ts.dta','usr ieee')
        do n=1,nt
         read(io) ; read(io) tr_clim(:,:,n) ! spval is already correct
         where( kmt == 0) tr_clim(:,:,n)=spval
         do m=3,number_tr
          read(io) ! tracer
         enddo
         do k=2,km; do m=1,number_tr
           read(io) ! rest of the levels
        enddo; enddo; enddo
        close(io)
        x=xt;y=yt
#ifdef limAmazoneSSS
c     this is a bug fix for spurious dispersion error in the Amazon river region
        do j = 1,ny
         if (yt(j).ge.-10. .and. yt(j).le.10.) then
          tr_clim = max(tr_clim,-0.005)
         endif
        enddo
#endif
#if defined  prep_for_LEDWELL || defined prep_for_OBC_tracer
       elseif (ntr >= 3) then
c    SBC for tracer 3 is no flux but read dummy data
        tr_clim=0.; tr_flux=0.; tr_rest=0.
        iret=nf_open('data/U10/u10.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'u10',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
        iret=nf_inq_varid(ncid,dname,lonid)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
        iret=nf_inq_varid(ncid,dname,latid)
        iret= nf_get_vara_real (ncid,lonid ,1,nx,x4); x=x4+360.
        iret= nf_get_vara_real (ncid,latid ,1,ny,y4); y=y4
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        call ncclos (ncid, iret)
#endif

#ifdef  prep_for_CFC 
       elseif (ntr == 3) then
c     SBC for CFC11 and CFC12 (wind in 10m)
        tr_clim=0.; tr_flux=0.
        tr_rest=1./15.0*dzt(1)/86400.
        iret=nf_open('data/U10/u10.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'u10',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
        iret=nf_inq_varid(ncid,dname,lonid)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
        iret=nf_inq_varid(ncid,dname,latid)
        iret= nf_get_vara_real (ncid,lonid ,1,nx,x4); x=x4+360.
        iret= nf_get_vara_real (ncid,latid ,1,ny,y4); y=y4
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,n,1/); edges=(/nx,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4)
         where( v4 == sp) v4 = -1000.0
         tr_rest(:,:,n)=v4
        enddo
        where( tr_rest== -1000.0 ) tr_rest = spval
        call ncclos (ncid, iret)
#endif

#ifdef  prep_for_NPZD
       elseif (ntr == 3) then
c    SBC for nutrient growing function (solar radiation)
        tr_clim=0.; tr_flux=0.; tr_rest=1./15.0*dzt(1)/86400.
        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
        do n=1,nt
         read (io); read (io) stamp, dpm, k, k, k, x,y,tr_clim(:,:,n)
        enddo
        close(io)
        allocate( mask(nx,ny))
        call getunit(io,'data/ecmwf/ecmwf_BB.mask','usr ieee')
        read (io) ; read (io); read (io) mask; close(io)
        do n=1,nt
         where (mask==0.) tr_clim(:,:,n) = spval
         where (mask==0.) tr_rest(:,:,n) = spval
         where (mask==0.) tr_flux(:,:,n) = spval
        enddo
        deallocate( mask)
       elseif (ntr > 3 .and. ntr <=6) then
c       phyto, zoo plankton and detritus, no surface fluxes
        tr_clim=0.0; tr_flux=0.0; tr_rest=0.0
c     read dummy values, only for grid
        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
        read (io); read (io) stamp, dpm, k, k, k, x,y
        close(io)
       elseif (ntr ==7 .or. ntr == 8
#ifdef  prep_for_ACO2
     &       .or. ntr >= 9  
#endif
     &             ) then
c       SBC for DIC: piston velocity  depends on u10 (same as for CFC)
c       SBC for O2: same as for DIC
        tr_clim=0.; tr_flux=0.
#ifdef read_piston_velocity_U10
        iret=nf_open('data/U10/u10.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'u10',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
        iret=nf_inq_varid(ncid,dname,lonid)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
        iret=nf_inq_varid(ncid,dname,latid)
        iret= nf_get_vara_real (ncid,lonid ,1,nx,x4); x=x4+360.
        iret= nf_get_vara_real (ncid,latid ,1,ny,y4); y=y4
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,n,1/); edges=(/nx,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4)
         do i=1,nx; do j=1,ny
            if( v4(i,j) == sp) v4(i,j) = -1000.0
            tr_rest(i,j,n)=v4(i,j)
            if( tr_rest(i,j,n)== -1000.0 ) tr_rest(i,j,n) = spval
         enddo; enddo
        enddo
        call ncclos (ncid, iret)
#endif
#ifdef read_piston_velocity_WSPD
        iret=nf_open('data/U10/wspd_mcycle.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'wspd',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
        iret=nf_inq_varid(ncid,dname,lonid)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
        iret=nf_inq_varid(ncid,dname,latid)
        iret= nf_get_vara_real (ncid,lonid ,1,nx-2,x4(2:nx-1)); x=x4
        x(nx)=2*x(nx-1)-x(nx-2)
        x(1)=x(2)-(x(3)-x(2))
        iret= nf_get_vara_real (ncid,latid ,1,ny,y4); y=y4
        y=y(ny:1:-1)
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,n,1/); edges=(/nx-2,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4(2:nx-1,:))
         v4=v4(:,ny:1:-1)
         v4(nx,:)=v4(2,:)
         v4(1,:)=v4(nx-1,:)
         do i=1,nx; do j=1,ny
            if( v4(i,j) == sp) v4(i,j) = -1000.0
            if( v4(i,j) /= sp) v4(i,j) = v4(i,j)*0.01+202.65
            tr_rest(i,j,n)=v4(i,j)
            if( tr_rest(i,j,n)== -1000.0 ) tr_rest(i,j,n) = spval
         enddo; enddo
        enddo
        call ncclos (ncid, iret)
c     now read slp and store in tr_clim
        iret=nf_open('data/ncep/slp.mon.ltm.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'slp',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,n,1/); edges=(/nx-2,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4(2:nx-1,:))
         v4=v4(:,ny:1:-1)
         v4(nx,:)=v4(2,:)
         v4(1,:)=v4(nx-1,:)
         do i=1,nx; do j=1,ny
            if( v4(i,j) == sp) v4(i,j) = -1000.0
            if( v4(i,j) /= sp) v4(i,j) = v4(i,j)
            tr_clim(i,j,n)=v4(i,j)
            if( tr_clim(i,j,n)== -1000.0 ) tr_clim(i,j,n) = spval
         enddo; enddo
        enddo
        call ncclos (ncid, iret)
#endif

#ifndef  prep_for_ACO2
       elseif (ntr ==9 ) then ! no flux condition for DOC
        tr_clim=0.; tr_flux=0.; tr_rest=0.0
c     read dummy values, only for grid
        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
        read (io); read (io) stamp, dpm, k, k, k, x,y
        close(io)
#endif
#endif
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_tr



#elif defined read_density_flx_pml_ncep
c
c--------------------------------------------------------
c     Density flux for PML formulation from mean NCEP
c--------------------------------------------------------
c
       subroutine read_dims_tr(nx,ny,nt,ntr)
       use prep_module
       implicit none
       integer nx,ny,nt,ntr
       character*32 stamp
       real :: dpm
       integer :: io
#include "netcdf.inc"
       integer :: iret,ncid,vid,ndims,dims(4)
       if (ntr == 1 ) then
        print*,' for tracer 1 we are computing variables'
        print*,' necessary for Seagers PML '
        iret=nf_open('data/ncep_for_pml/shum.mon.ltm.nc',
     &                NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'shum',vid)
        iret=NF_INQ_VARNDIMS(NCID, vid, ndims)  
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(4), nt)
        call ncclos (ncid, iret)
       elseif (ntr == 2) then
        print*,' reading salt flux boundary condition from'
        print*,' monthly climatological SSS (file ts.dta) '
        print*,' and using a fixed restoring time scale '
        nt=12; nx=imt; ny=jmt
       elseif (ntr == 3) then
        print*,' for tracer 3 we are computing variables'
        print*,' necessary for Seagers PML '
        iret=nf_open('data/ncep_for_pml/uwnd.mon.ltm.nc',
     &                NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'uwnd',vid)
        iret=NF_INQ_VARNDIMS(NCID, vid, ndims)  
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
        call ncclos (ncid, iret)
       elseif (ntr == 4) then
        print*,' for tracer 4 we are also computing variables'
        print*,' necessary for Seagers PML '
        iret=nf_open('data/ncep_for_pml/nswrs.mon.ltm.nc',
     &                NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'nswrs',vid)
        iret=NF_INQ_VARNDIMS(NCID, vid, ndims)  
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
        call ncclos (ncid, iret)
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_dims_tr




       subroutine read_tr(tr_clim,tr_rest,tr_flux,
     &                    x,y,time,toffset,nx,ny,nt,ntr)
c
       ! returns inverse restoring time scale for tracers 
       ! number ntr in tr_rest
       ! and climatology to restore against in tr_clim
       ! nx,ny are horizontal dimensions of the data
       ! nt the time steps,
       ! x/y the longitude/latitude of the grid
       ! should mask data with spval
       ! return also net fluxes in Barniers heat flux formulation
       ! or alternatively the shortwave solar radiation in the net flux array
       ! if available 
       ! Units: mom units for tr_clim and tr_rest
c       
       use prep_module
       implicit none
       integer nx,ny,nt,ntr,m
       real tr_clim(nx,ny,nt) ,x(nx), y(ny)
       real tr_rest(nx,ny,nt) 
       real tr_flux(nx,ny,nt) ,time(nt),toffset
       character*32 stamp
       real, allocatable, dimension(:,:,:) :: qnet,qnec,airt,qsol
       real, allocatable, dimension(:,:)   :: mask
       real :: dpm
       integer  k,n,io,i,j
       real,parameter ::rhonull=1.026, Cpw=0.955, dimfac=0.2389e-4
       real,parameter ::qfac = dimfac/(rhonull*Cpw)
#include "netcdf.inc"
       integer :: iret,ncid,vid,dims(4),lonid,latid,corner(4),edges(4)
       character (len=80) :: dname
#ifdef netcdf_real4
      real (kind=4) :: v4(nx,ny) ,x4(nx),y4(ny),sp
#else
      real :: v4(nx,ny) ,x4(nx),y4(ny),sp
#endif
       time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
       toffset=0.0

       if (ntr == 1) then

        tr_clim=0.; tr_flux=0.; tr_rest=0.
c
c       specific humidity to  sst_rest
c
        iret=nf_open('data/ncep_for_pml/shum.mon.ltm.nc',
     &                NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'shum',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
        iret=nf_inq_varid(ncid,dname,lonid)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
        iret=nf_inq_varid(ncid,dname,latid)
        iret= nf_get_vara_real (ncid,lonid ,1,nx,x4); x=x4
        iret= nf_get_vara_real (ncid,latid ,1,ny,y4); y=y4
        y=y(ny:1:-1)
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,1,n/); edges=(/nx,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4)
         v4=v4(:,ny:1:-1)
         where( v4 == sp) v4 = -1000.0
         tr_rest(:,:,n)=v4
        enddo
        where( tr_rest/= -1000.0 ) tr_rest = tr_rest/1000.0
        where( tr_rest== -1000.0 ) tr_rest = spval
        call ncclos (ncid, iret)

c
c        air temperature to tr_clim
c
        iret=nf_open('data/ncep_for_pml/air.mon.ltm.nc',
     &                NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'air',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,1,n/); edges=(/nx,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4)
         v4=v4(:,ny:1:-1)
         where( v4 == sp) v4 = -1000.0
         tr_clim(:,:,n)=v4
        enddo
        where( tr_clim/= -1000.0 ) tr_clim = tr_clim+273.15
        where( tr_clim== -1000.0 ) tr_clim = spval
        call ncclos (ncid, iret)


        apply_landmask = .false.


       elseif (ntr == 2) then
c    surface salt flux for salinity
        tr_flux=0. ! unknown 
c      (flux is not used for restoring formulation)
        tr_rest=1./15.0*dzt(1)/86400.
c        tr_rest=1./15.0*dzt(1)/86400.*10.0
c     read restoring salinity from previously interpolated data
c     which are also used for the initial conditions, sponge layers,  etc.
        call getunit(io,'ts.dta','usr ieee')
        do n=1,nt
         read(io) ; read(io) tr_clim(:,:,n) ! spval is already correct
         where( kmt == 0) tr_clim(:,:,n)=spval
         do m=3,number_tr
          read(io) ! tracer
         enddo
         do k=2,km; do m=1,number_tr
           read(io) ! rest of the levels
        enddo; enddo; enddo
        close(io)
        x=xt;y=yt
#ifdef limAmazoneSSS
c     this is a bug fix for spurious dispersion error in the Amazon river region
        do j = 1,ny
         if (yt(j).ge.-10. .and. yt(j).le.10.) then
          tr_clim = max(tr_clim,-0.005)
         endif
        enddo
#endif

c    SBC for Seagers PML 
c      they are stored in str03_flux/clim/rest
       elseif (ntr == 3) then

        tr_clim=0.; tr_flux=0.; tr_rest=0.
c
c      uwind to tr_rest
c
        iret=nf_open('data/ncep_for_pml/uwnd.mon.ltm.nc',
     &                NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'uwnd',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
        iret=nf_inq_varid(ncid,dname,lonid)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
        iret=nf_inq_varid(ncid,dname,latid)
        iret= nf_get_vara_real (ncid,lonid ,1,nx,x4); x=x4
        iret= nf_get_vara_real (ncid,latid ,1,ny,y4); y=y4
        y=y(ny:1:-1)
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,n,1/); edges=(/nx,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4)
         v4=v4(:,ny:1:-1)
         where( v4 == sp) v4 = -1000.0
         tr_rest(:,:,n)=v4
        enddo
        where( tr_rest== -1000.0 ) tr_rest = spval
        call ncclos (ncid, iret)
c
c      vwind to tr_clim
c
        iret=nf_open('data/ncep_for_pml/vwnd.mon.ltm.nc',
     &                NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'vwnd',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,n,1/); edges=(/nx,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4)
         v4=v4(:,ny:1:-1)
         where( v4 == sp) v4 = -1000.0
         tr_clim(:,:,n)=v4
        enddo
        where( tr_clim== -1000.0 ) tr_clim = spval
        call ncclos (ncid, iret)
c
c      wspd to tr_flux
c
        iret=nf_open('data/ncep_for_pml/wspd.mon.ltm.nc',
     &                NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'wspd',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,n,1/); edges=(/nx,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4)
         v4=v4(:,ny:1:-1)
         where( v4 == sp) v4 = -1000.0
         tr_flux(:,:,n)=v4
        enddo
        where( tr_flux/= -1000.0 ) tr_flux = 
     &                       tr_flux*0.0099999998+202.64999
        where( tr_flux== -1000.0 ) tr_flux = spval
        call ncclos (ncid, iret)

        apply_landmask = .false.

       elseif (ntr == 4) then
        tr_clim=0.; tr_flux=0.; tr_rest=0.
c
c      qsol to tr_flux 4
c
        iret=nf_open('data/ncep_for_pml/nswrs.mon.ltm.nc',
     &                NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'nswrs',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
        iret=nf_inq_varid(ncid,dname,lonid)
        dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
        iret=nf_inq_varid(ncid,dname,latid)
        iret= nf_get_vara_real (ncid,lonid ,1,nx,x4); x=x4
        iret= nf_get_vara_real (ncid,latid ,1,ny,y4); y=y4
        y=y(ny:1:-1)
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,n,1/); edges=(/nx,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4)
         v4=v4(:,ny:1:-1)
         where( v4 == sp) v4 = -1000.0
         tr_flux(:,:,n)=v4
        enddo
        where( tr_flux/= -1000.0 ) tr_flux = -tr_flux/41868.0
        where( tr_flux== -1000.0 ) tr_flux = spval
        call ncclos (ncid, iret)

c
c      cloud cover to tr_clim
c
        iret=nf_open('data/ncep_for_pml/tcdc_mcycle.cdf',
     &                NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'tcdc',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         corner=(/1,1,n,1/); edges=(/nx,ny,1,1/)
         iret= nf_get_vara_real (ncid,vid ,corner,edges,v4)
         v4=v4(:,ny:1:-1)
         where( v4 == sp) v4 = -1000.0
         tr_clim(:,:,n)=v4
        enddo
        where( tr_clim/= -1000.0 ) tr_clim =(tr_clim*0.1+3276.5)/100
        where( tr_clim== -1000.0 ) tr_clim =spval
        call ncclos (ncid, iret)

        apply_landmask = .false.

       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_tr


#elif defined read_density_flx_ncep_monthly
c
c--------------------------------------------------------
c    use a 3 year monthly mean climatology from the european
c    ECMWF model (same data used in the DYNAMO project)
c    plus anomalies from NCEP/NCAR data for heat flux
c--------------------------------------------------------
c

       module density_flx_ncep_monthly
       integer           :: end_nt = 300*12   ! start and end index of months to be read
       integer,parameter :: start_nt = 25*12+1   ! start and end index of months to be read
       integer,parameter :: start_year = 1948 +(start_nt)/12! start year to be read
       end module density_flx_ncep_monthly

       subroutine read_dims_tr(nx,ny,nt,ntr)
       use prep_module
       use density_flx_ncep_monthly
       implicit none
       integer nx,ny,nt,ntr
       character*32 stamp
       real :: dpm
       integer :: io
#include "netcdf.inc"
       integer :: iret,ncid,vid,ndims,dims(4)
       if (ntr == 1 ) then
        print*,' reading heat flux boundary conditions from'
        print*,' Barniers ECMWF analysis, which were also used'
        print*,' in the DYNAMO project'
        print*,' plus heat flux anomalies from the NCEP/NCAR data'
        call getunit(io,'data/ecmwf/ecmwf_BB.qnet','usr ieee')
        read (io); read (io) stamp, dpm, nx, ny
        close(io)
        iret=nf_open('data/ncep/net_hflx_anom.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'hfl',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
        end_nt=min(end_nt,int(nt/12)*12 )
        nt=end_nt - start_nt + 1
        call ncclos (ncid, iret)

       elseif (ntr == 2) then
        print*,' reading salt flux boundary condition from'
        print*,' monthly climatological SSS (file ts.dta) '
        print*,' and using a fixed restoring time scale '
        nt=12; nx=imt; ny=jmt

#ifdef  prep_for_NPZD

       elseif (ntr == 3 ) then
        print*,' for Nitrate in the NPZD model ',
     &         'we are using NCEP/NCAR solar radiation'
        iret=nf_open('data/ncep/nswrs.mon.mean.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'nswrs',vid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
        nx=nx+2 ! append some rows
        ny=ny+4
        end_nt=min(end_nt,int(nt/12)*12 )
        nt=end_nt - start_nt + 1
        call ncclos (ncid, iret)

       elseif (ntr > 3 .and. ntr<=6 ) then
        print*,' for P/Z/D in the NPZD model ',
     &         'we are using a dummy climatology of solar radiation'
        nt=12
        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
        read (io); read (io) stamp, dpm, nx, ny
        close(io)

       elseif (ntr == 7 .or. ntr==8 ) then
        print*,' for DIC/O2 we are using a NCEP/NCAR'
        print*,' time series of U(10m) for the restoring time scale '
        print*,' this is converted to piston velocity during model run'
        print*,' and time series of pressure for DIC boundary condition'

        iret=nf_open('data/ncep/wspd.mon.mean.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'wspd',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
        nx=nx+2 ! append some rows
        ny=ny+4
        end_nt=min(end_nt,int(nt/12)*12 )
        nt=end_nt - start_nt + 1
        call ncclos (ncid, iret)

       elseif (ntr ==9 ) then
        print*,' for DOC in the NPZD model ',
     &         'we are using a climatology of solar radiation'
        nt=12
        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
        read (io); read (io) stamp, dpm, nx, ny
        close(io)

#endif
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_dims_tr




       subroutine read_tr(tr_clim,tr_rest,tr_flux,
     &                    x,y,time,toffset,nx,ny,nt,ntr)
c
       ! returns inverse restoring time scale for tracers 
       ! number ntr in tr_rest
       ! and climatology to restore against in tr_clim
       ! nx,ny are horizontal dimensions of the data
       ! nt the time steps,
       ! x/y the longitude/latitude of the grid
       ! should mask data with spval
       ! return also net fluxes in Barniers heat flux formulation
       ! if available 
       ! Units: mom units for tr_clim and tr_rest
c       
       use time_type_module
       use prep_module
       use density_flx_ncep_monthly
       implicit none
       integer nx,ny,nt,ntr,m
       real tr_clim(nx,ny,nt) ,x(nx), y(ny)
       real tr_rest(nx,ny,nt) 
       real tr_flux(nx,ny,nt) ,time(nt),toffset
       character*32 stamp
       real, allocatable, dimension(:,:,:) :: qnet,qnec,airt
       real, allocatable, dimension(:,:)   :: mask
       real :: dpm
       integer  k,n,io,i,j
       real,parameter ::rhonull=1.026, Cpw=0.955, dimfac=0.2389e-4
       real,parameter ::qfac = dimfac/(rhonull*Cpw)
#include "netcdf.inc"
       integer :: iret,ncid,vid,dims(4),lonid,latid,corner(4),edges(4)
       character (len=80) :: dname
#ifdef netcdf_real4
      real (kind=4) :: v4(nx,ny) ,x4(nx),y4(ny),sp
#else
      real :: v4(nx,ny) ,x4(nx),y4(ny),sp
#endif
      real (kind=4) :: mtime(12),spv,add_offset,scale_factor,spv2
      real (kind=4), allocatable :: x2(:),y2(:),hfl2(:,:),tx(:)
      real (kind=4), allocatable :: hfl3(:,:),nmask(:,:),slp(:,:)
       character*80 name
      integer :: nx2,ny2,varid,ncid2
      real, allocatable   :: work_t(:)
      integer :: init_t=1, lenw_t,nn
      type(time_type) :: t1

       time(1:12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
       mtime = (/31,28,31,30,31,30,31,31,30,31,30,31/)
       toffset=0.0

       if (ntr == 1) then
c     SBC for heat comes from Barniers formulation
        allocate( qnet(nx,ny,12), qnec(nx,ny,12), airt(nx,ny,12))
        allocate( mask(nx,ny))
        call getunit(io,'data/ecmwf/ecmwf_BB.qnet','usr ieee')
        do n=1,12
         read (io); read (io) stamp, dpm, k, k, k, x,y,qnet(:,:,n)
         mtime(n)=dpm
        enddo
        close(io)
        call getunit(io,'data/ecmwf/ecmwf_BB.qnec','usr ieee')
        do n=1,12
         read (io); read (io) stamp, dpm, k, k, k, x,y,qnec(:,:,n)
        enddo
        close(io)
        call getunit(io,'data/ecmwf/ecmwf_BB.airt','usr ieee')
        do n=1,12
         read (io); read (io) stamp, dpm, k, k, k, x,y,airt(:,:,n)
        enddo
        close(io)
        call getunit(io,'data/ecmwf/ecmwf_BB.mask','usr ieee')
        read (io) ; read (io); read (io) mask; close(io)
c
c   read land/sea mask for NCEP data
c
        iret=nf_open('data/ncep/lsmask.19294.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'lsmask',varid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
        allocate( nmask(nx2,ny2) )
        iret= nf_get_vara_real(ncid,varid,(/1,1,1/),(/nx2,ny2,1/),nmask)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        call ncclos (ncid, iret)
c
c      read NCEP data
c
        iret=nf_open('data/ncep/net_hflx_anom.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'hfl',varid)
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        nx2=nx2+2 ! append some rows
        ny2=ny2+4
        allocate(x2(nx2),y2(ny2), hfl2(nx2,ny2),tx(nx2),hfl3(nx,ny))
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
        iret=NF_INQ_VARID (NCID, name, lonid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
        iret=NF_INQ_VARID (NCID, name, latid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif

        iret= nf_get_vara_real (ncid,lonid ,1,nx2-2,x2(2:nx2-1))
        x2(nx2)=2*x2(nx2-1)-x2(nx2-2)
        x2(1)=x2(2)-(x2(3)-x2(2))
        iret= nf_get_vara_real (ncid,latid ,1,ny2-4,y2(3:ny2-2)) 
        y2(ny2-1)=2*y2(ny2-2)-y2(ny2-3)
        y2(2)=y2(3)-(y2(4)-y2(3))
        y2(ny2)=2*y2(ny2-1)-y2(ny2-2)
        y2(1)=y2(2)-(y2(3)-y2(2))
        y2=y2(ny2:1:-1)
        iret = nf_get_att_real(ncid, varid, 'missing_value', spv)
c
c    read each month and interpolate on ECMWF grid
c
        print*,' interpolating data '
        lenw_t = 10*max(nx,ny)
        allocate( work_t(lenw_t) )
        t1 =  set_date(start_year, 1, 1, 0, 0, 0)
        toffset=t1%days
        do n=1,nt
         hfl2=spv
         iret= nf_get_vara_real (ncid,varid ,
     &     (/1,1,n+start_nt-1/),(/nx2-2,ny2-4,1/),hfl2(2:nx2-1,3:ny2-2))

         where( nmask == -1) hfl2(2:nx2-1,3:ny2-2) = spv
c     acount for appended rows and switch latitudinal ordering
         hfl2(nx2,:)=hfl2(2,:)
         hfl2(1,:)  =hfl2(nx2-1,:)
         hfl2(:,:) = hfl2(:,ny2:1:-1)
c    convert special values
         where( hfl2 == spv) hfl2=spval
c     interpolate
         call tranlon (hfl2(1,1), nx2, nx2-2, ny2, x2, x,nx, tx)
         call ctf (hfl2(1,1), nx2, ny2, tx, y2, 
     &                  hfl3(1,1),nx, ny, 1, nx, 1, ny,
     &                  x, y, init_t, work_t, lenw_t,spval)
         init_t=0 ! we can use the same interpolation weights
c     add mean
         nn = mod(n-1,12)+1
         where( hfl3 == spval) hfl3=0.
         where (qnec(:,:,nn)/=0.) 
          tr_clim(:,:,n)=airt(:,:,nn)+(qnet(:,:,nn)-hfl3)/qnec(:,:,nn)
          tr_flux(:,:,n)=qnet(:,:,nn)-hfl3
         elsewhere
             tr_clim(:,:,n) = spval
         end where
         tr_rest(:,:,n) = qnec(:,:,nn)*qfac
         where (mask==0.) tr_clim(:,:,n) = spval
         where (mask==0.) tr_rest(:,:,n) = spval
         where (mask==0.) tr_flux(:,:,n) = spval
         time(n)=mtime(nn)
        enddo
        call ncclos (ncid, iret)
        print*,' done '
        deallocate(x2,y2,tx,hfl2,hfl3,work_t,nmask)
        deallocate( qnet, qnec, airt,mask)

       elseif (ntr == 2) then
c    surface salt flux for salinity
        tr_flux=0. ! unknown otherwise 
c      (flux is not used for restoring formulation)
        tr_rest=1./15.0*dzt(1)/86400.
c        tr_rest=1./15.0*dzt(1)/86400.*10.0
c     read restoring salinity from previously interpolated data
c     which are also used for the initial conditions, sponge layers,  etc.
        call getunit(io,'ts.dta','usr ieee')
        do n=1,nt
         read(io) ; read(io) tr_clim(:,:,n) ! spval is already correct
         where( kmt == 0) tr_clim(:,:,n)=spval
         do m=3,number_tr
          read(io) ! tracer
         enddo
         do k=2,km; do m=1,number_tr
           read(io) ! rest of the levels
        enddo; enddo; enddo
        close(io)
        x=xt;y=yt

#ifdef  prep_for_NPZD

       elseif (ntr == 3) then
c    SBC for nutrient growing function (solar radiation)
        tr_clim=0.; tr_flux=0.; tr_rest=1./15.0*dzt(1)/86400.
c        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
c        do n=1,nt
c         read (io); read (io) stamp, dpm, k, k, k, x,y,tr_clim(:,:,n)
c        enddo
c        close(io)
c        allocate( mask(nx,ny))
c        call getunit(io,'data/ecmwf/ecmwf_BB.mask','usr ieee')
c        read (io) ; read (io); read (io) mask; close(io)
c        do n=1,nt
c         where (mask==0.) tr_clim(:,:,n) = spval
c         where (mask==0.) tr_rest(:,:,n) = spval
c         where (mask==0.) tr_flux(:,:,n) = spval
c        enddo
c        deallocate( mask)

c
c   read land/sea mask for NCEP data
c
        print*,' reading NCEP land/sea mask'
        iret=nf_open('data/ncep/lsmask.19294.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'lsmask',varid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
        allocate( nmask(nx2,ny2) )
        iret= nf_get_vara_real(ncid,varid,(/1,1,1/),(/nx2,ny2,1/),nmask)
        call ncclos (ncid, iret)
c
c      read NCEP data
c
        iret=nf_open('data/ncep/nswrs.mon.mean.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'nswrs',varid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        nx2=nx2+2 ! append some rows
        ny2=ny2+4
        allocate(x2(nx2),y2(ny2),hfl2(nx2,ny2) )
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
        iret=NF_INQ_VARID (NCID, name, lonid)
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
        iret=NF_INQ_VARID (NCID, name, latid)

        iret= nf_get_vara_real (ncid,lonid ,1,nx2-2,x2(2:nx2-1))
        x2(nx2)=2*x2(nx2-1)-x2(nx2-2)
        x2(1)=x2(2)-(x2(3)-x2(2))
        iret= nf_get_vara_real (ncid,latid ,1,ny2-4,y2(3:ny2-2)) 
        y2(ny2-1)=2*y2(ny2-2)-y2(ny2-3)
        y2(2)=y2(3)-(y2(4)-y2(3))
        y2(ny2)=2*y2(ny2-1)-y2(ny2-2)
        y2(1)=y2(2)-(y2(3)-y2(2))
        y2=y2(ny2:1:-1)
        iret = nf_get_att_real(ncid, varid, 'missing_value', spv)
        add_offset=0.0
        iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
        scale_factor=1.0
        iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
        x=x2;y=y2
c
c    read each month 
c
        t1 =  set_date(start_year, 1, 1, 0, 0, 0)
        toffset=t1%days
        do n=1,nt
         hfl2=spv
         iret=nf_inq_varid(ncid,'nswrs',varid)
         iret= nf_get_vara_real (ncid,varid ,
     &     (/1,1,n+start_nt-1/),(/nx2-2,ny2-4,1/),hfl2(2:nx2-1,3:ny2-2))
         where( nmask == -1) hfl2(2:nx2-1,3:ny2-2) = spv
c      change sign and account for scaling
         where( hfl2 /= spv) hfl2=-hfl2*scale_factor+add_offset 
c     acount for appended rows and switch latitudinal ordering
         hfl2(nx2,:)=hfl2(2,:)
         hfl2(1,:)  =hfl2(nx2-1,:)
         hfl2(:,:) = hfl2(:,ny2:1:-1)
c    convert special values and units
         where( hfl2 == spv) hfl2=spval
         tr_clim(:,:,n) = hfl2
c     add mean
         nn = mod(n-1,12)+1
         time(n)=mtime(nn)
        enddo
        print*,' done '
        deallocate(x2,y2,hfl2,nmask)
        call ncclos (ncid, iret)

       elseif (ntr > 3 .and. ntr <=6) then
c       phyto, zoo plankton and detritus, no surface fluxes
        tr_clim=0.0; tr_flux=0.0; tr_rest=0.0
        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
        read (io); read (io) stamp, dpm, k, k, k, x,y
        close(io)

       elseif (ntr ==7 .or. ntr == 8) then
c       SBC for DIC: piston velocity  depends on u10 (same as for CFC)
c       SBC for O2: same as for DIC
        tr_clim=0.; tr_flux=0.
c
c   read land/sea mask for NCEP data
c
        iret=nf_open('data/ncep/land.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'land',varid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
        allocate( nmask(nx2,ny2) )
        iret= nf_get_vara_real(ncid,varid,(/1,1,1/),(/nx2,ny2,1/),nmask)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        call ncclos (ncid, iret)
c
c      read wind speed data
c
        print*,' reading wind speed data';call sub_flush(6)
        iret=nf_open('data/ncep/wspd.mon.mean.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'wspd',varid)
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        nx2=nx2+2 ! append some rows
        ny2=ny2+4
        allocate(x2(nx2),y2(ny2),hfl2(nx2,ny2),slp(nx2,ny2))
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
        iret=NF_INQ_VARID (NCID, name, lonid)
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
        iret=NF_INQ_VARID (NCID, name, latid)

        iret= nf_get_vara_real (ncid,lonid ,1,nx2-2,x2(2:nx2-1))
        x2(nx2)=2*x2(nx2-1)-x2(nx2-2)
        x2(1)=x2(2)-(x2(3)-x2(2))
        iret= nf_get_vara_real (ncid,latid ,1,ny2-4,y2(3:ny2-2)) 
        y2(ny2-1)=2*y2(ny2-2)-y2(ny2-3)
        y2(2)=y2(3)-(y2(4)-y2(3))
        y2(ny2)=2*y2(ny2-1)-y2(ny2-2)
        y2(1)=y2(2)-(y2(3)-y2(2))
        y2=y2(ny2:1:-1)
        iret = nf_get_att_real(ncid, varid, 'missing_value', spv)
        add_offset=0.0
        iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
        scale_factor=1.0
        iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
        x=x2;y=y2
c
c      read SLP data
c
        print*,' reading SLP data';call sub_flush(6)
        iret=nf_open('data/ncep/slp.mon.mean.nc',NF_nowrite,ncid2)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid2,'slp',varid)
        iret = nf_get_att_real(ncid2, varid, 'missing_value', spv2)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
c
c    read each month and interpolate on ECMWF grid
c
        t1 =  set_date(start_year, 1, 1, 0, 0, 0)
        toffset=t1%days
        do n=1,nt
         hfl2=spv
         iret=nf_inq_varid(ncid,'wspd',varid)
         iret= nf_get_vara_real (ncid,varid ,
     &    (/1,1,n+start_nt-1/),(/nx2-2,ny2-4,1/),hfl2(2:nx2-1,3:ny2-2))
         where( nmask == -1) hfl2(2:nx2-1,3:ny2-2) = spv
         where( hfl2 /= spv) hfl2=hfl2*scale_factor+add_offset
c     acount for appended rows and switch latitudinal ordering
         hfl2(nx2,:)=hfl2(2,:)
         hfl2(1,:)  =hfl2(nx2-1,:)
         hfl2(:,:) = hfl2(:,ny2:1:-1)
c    convert special values and units
         where( hfl2 == spv) hfl2=spval
         tr_rest(:,:,n) = hfl2

         slp=spv2
         iret=nf_inq_varid(ncid2,'slp',varid)
         iret= nf_get_vara_real (ncid2,varid ,
     &    (/1,1,n+start_nt-1/),(/nx2-2,ny2-4,1/), slp(2:nx2-1,3:ny2-2))
         where( nmask == -1) slp(2:nx2-1,3:ny2-2) = spv2
         where( slp /= spv) slp=slp*1.0
c     acount for appended rows and switch latitudinal ordering
         slp(nx2,:)=slp(2,:)
         slp(1,:)  =slp(nx2-1,:)
         slp(:,:) = slp(:,ny2:1:-1)
c    convert special values and units
         where( slp == spv2) slp=spval
         tr_clim(:,:,n) = slp
c     the time
         nn = mod(n-1,12)+1
         time(n)=mtime(nn)
        enddo
        print*,' done '
        deallocate(x2,y2,hfl2,nmask,slp)
        call ncclos (ncid, iret)


       elseif (ntr ==9 ) then ! no flux condition for DOC
        tr_clim=0.; tr_flux=0.; tr_rest=0.0
        call getunit(io,'data/ecmwf/ecmwf_BB.qsol','usr ieee')
        read (io); read (io) stamp, dpm, k, k, k, x,y
        close(io)
#endif
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_tr



#elif defined read_density_flx_nao_proxy
c
c--------------------------------------------------------
c    use the 3 year monthly mean ECMWF climatology plus
c    NAO related time series of heat flux anomalies
c    (which is given by the product of the monthly NAO-index
c    and the monthly regression patterns of the 
c    NCEP net heat flux anomalies with the NAO-index). 
c    Same forcing was used in Eden+Jung 01, J.Clim.
c
c    NOTE: Start and end year of the NAO time series to be used
c    have to be set in the common block hflx_nao_reg.
c    The NAO-index is given for 1865 to 2001 a subset of this
c    period can be set with the common block hflx_nao_reg
c    See also prep_template_tau.F 
c--------------------------------------------------------
c
       subroutine read_dims_tr(nx,ny,nt,ntr)
       use prep_module
       implicit none
       integer nx,ny,nt,ntr
       character*32 stamp
       real :: dpm
       integer :: io
#include "netcdf.inc"
       integer :: iret,ncid,vid,ndims,dims(4)
       integer :: start_y,end_y
       common / hflx_nao_reg/ start_y,end_y

       if (ntr == 1 ) then
        print*,' reading heat flux boundary conditions from'
        print*,' Barniers ECMWF analysis, which were also used'
        print*,' in the DYNAMO project'
        print*,' plus NAO related heat flux anomalies from NCEP/NCAR'
        call getunit(io,'data/ecmwf/ecmwf_BB.qnet','usr ieee')
        read (io); read (io) stamp, dpm, nx, ny
        close(io)
        iret=nf_open('data/NAO_reg/nao_monthly.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'nao',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs, nt)
        call ncclos (ncid, iret)
c     start/end_y gives starting and end year of NAO time series
        start_y = max(1865,1865); end_y = min(1948,nt/12+1864) ! 
c        start_y = max(1947,1865); end_y = min(5948,nt/12+1864) ! 
        nt = (end_y-start_y+1)*12
        print*,' from Jan. of year ',start_y
        print*,' to Dec. of year   ',end_y
        print*,' nt=',nt
       elseif (ntr == 2) then
        print*,' reading salt flux boundary condition from'
        print*,' monthly climatological SSS (file ts.dta) '
        print*,' and using a fixed restoring time scale '
#ifdef read_salt_fl_from_E5
        print*,' option read_salt_fl_from_E5 is not working here'
        stop
#endif
        nt=12; nx=imt; ny=jmt
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_dims_tr


       subroutine read_tr(tr_clim,tr_rest,tr_flux,
     &                    x,y,time,toffset,nx,ny,nt,ntr)
c
       ! returns inverse restoring time scale for tracers 
       ! number ntr in tr_rest
       ! and climatology to restore against in tr_clim
       ! nx,ny are horizontal dimensions of the data
       ! nt the time steps,
       ! x/y the longitude/latitude of the grid
       ! should mask data with spval
       ! return also net fluxes in Barniers heat flux formulation
       ! if available 
       ! Units: mom units for tr_clim and tr_rest
c       
       use prep_module
       use time_type_module
       implicit none
       integer nx,ny,nt,ntr,m,nn
       real tr_clim(nx,ny,nt) ,x(nx), y(ny)
       real tr_rest(nx,ny,nt) 
       real tr_flux(nx,ny,nt) ,time(nt),toffset
       character*32 stamp
       real, allocatable, dimension(:,:,:) :: qnet,qnec,airt
       real, allocatable, dimension(:,:)   :: mask
       real :: dpm
       integer  k,n,io,i,j
       real,parameter ::rhonull=1.026, Cpw=0.955, dimfac=0.2389e-4
       real,parameter ::qfac = dimfac/(rhonull*Cpw)
#include "netcdf.inc"
       integer :: iret,ncid,vid,dims(4),lonid,latid,corner(4),edges(4)
       character (len=80) :: dname
#ifdef netcdf_real4
      real (kind=4) :: v4(nx,ny) ,x4(nx),y4(ny),sp
#else
      real :: v4(nx,ny) ,x4(nx),y4(ny),sp
#endif
      integer :: init_t=1, lenw_t,nx2,ny2
      real (kind=4), allocatable :: x2(:),y2(:),hflx(:,:,:),tx(:),
     &               hflx2(:,:)
      character*80 name
      real (kind=4) ::  spv,add_offset,scale_factor
      real, allocatable   :: work_t(:)
      type(time_type) :: t1
      real :: mtime(12)
      integer :: start_y,end_y
      common / hflx_nao_reg/ start_y,end_y

       if (ntr == 1) then
c     read mean data from Barniers formulation
        allocate( qnet(nx,ny,12), qnec(nx,ny,12), airt(nx,ny,12))
        allocate( mask(nx,ny))
        call getunit(io,'data/ecmwf/ecmwf_BB.qnet','usr ieee')
        do n=1,12
         read (io); read (io) stamp, dpm, k, k, k, x,y,qnet(:,:,n)
         mtime(n)=dpm
        enddo
        close(io)
        call getunit(io,'data/ecmwf/ecmwf_BB.qnec','usr ieee')
        do n=1,12
         read (io); read (io) stamp, dpm, k, k, k, x,y,qnec(:,:,n)
        enddo
        close(io)
        call getunit(io,'data/ecmwf/ecmwf_BB.airt','usr ieee')
        do n=1,12
         read (io); read (io) stamp, dpm, k, k, k, x,y,airt(:,:,n)
        enddo
        close(io)
c
c     read NAO regression patterns
c
        iret=nf_open('data/NAO_reg/reg_hflx.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'hflx_reg',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
        nx2=nx2+2 ! append some rows
        ny2=ny2+4
        print*,' nx2 = ',nx2, 'ny2=',ny2
        allocate(x2(nx2),y2(ny2), hflx2(nx2,ny2), tx(nx2),
     &           hflx(nx,ny,12) )
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
        iret=NF_INQ_VARID (NCID, name, lonid)
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
        iret=NF_INQ_VARID (NCID, name, latid)

        iret= nf_get_vara_real (ncid,lonid ,1,nx2-2,x2(2:nx2-1))
        x2(nx2)=2*x2(nx2-1)-x2(nx2-2)
        x2(1)=x2(2)-(x2(3)-x2(2))
        iret= nf_get_vara_real (ncid,latid ,1,ny2-4,y2(3:ny2-2)) 
        y2(ny2-1)=2*y2(ny2-2)-y2(ny2-3)
        y2(2)=y2(3)-(y2(4)-y2(3))
        y2(ny2)=2*y2(ny2-1)-y2(ny2-2)
        y2(1)=y2(2)-(y2(3)-y2(2))
        y2=y2(ny2:1:-1)
        iret = nf_get_att_real(ncid, vid, 'missing_value', spv)
        add_offset=0.0
        iret= nf_get_att_real (ncid,vid ,'add_offset',add_offset)
        scale_factor=1.0
        iret= nf_get_att_real (ncid,vid ,'scale_factor',scale_factor)
        print*,' missing_value of hflx_reg = ',spv
        print*,' add_offset for   hflx_reg = ',add_offset
        print*,' scale_factor for hflx_reg = ',scale_factor

c     read each month and interpolate on ECMWF grid
        print*,' interpolating data '
        lenw_t = 10*max(nx,ny)
        allocate( work_t(lenw_t) )
        do n=1,12
         hflx2=spv
         iret= nf_get_vara_real (ncid,vid ,
     &          (/1,1,n/),(/nx2-2,ny2-4,1/),hflx2(2:nx2-1,3:ny2-2))
         hflx2(nx2,:)=hflx2(2,:)
         hflx2(1,:)  =hflx2(nx2-1,:)
         hflx2(:,:)  =hflx2(:,ny2:1:-1)
         where( hflx2 == spv) hflx2=spval
         where( hflx2 /= spval) hflx2=(hflx2*scale_factor+add_offset)
         call tranlon (hflx2(1,1), nx2, nx2-2, ny2, x2, x,nx, tx)
         call ctf (hflx2(1,1), nx2, ny2, tx, y2, 
     &                  hflx(1,1,n),nx, ny, 1, nx, 1, ny,
     &                  x, y, init_t, work_t, lenw_t,spval)
         init_t=0 ! we can use the same interpolation weights
        enddo
        call ncclos (ncid, iret)
        print*,' done '
        deallocate(x2,y2,tx,work_t,hflx2)

c     read NAO index, multiply with regression pattern and add mean
c     change sign of regression patterns here !!!!
        iret=nf_open('data/NAO_reg/nao_monthly.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'nao',vid)
        t1 =  set_date(start_y, 1, 1, 0, 0, 0)
        toffset=t1%days

        allocate(hflx2(nx,ny))
        do n=1,nt
         nn = mod(n-1,12)+1
         time(n)=mtime(nn)
         iret= nf_get_vara_real (ncid,vid ,n+(start_y-1865)*12,1,spv)
c         print*,' n=',n,nn,' nao(n)=',spv
         where (qnec(:,:,nn)/=0.) 
             hflx2(:,:)     = qnet(:,:,nn)+ hflx(:,:,nn)*spv*(-1)
             tr_clim(:,:,n) = airt(:,:,nn) + hflx2(:,:)/qnec(:,:,nn)
             tr_flux(:,:,n) = hflx2(:,:)
             tr_rest(:,:,n) = qnec(:,:,nn)*qfac
         elsewhere
             tr_clim(:,:,n) = spval
             tr_rest(:,:,n) = spval
             tr_flux(:,:,n) = spval
         end where
        enddo
        call ncclos (ncid, iret)
        deallocate(hflx2,hflx)
!     apply land mask
        call getunit(io,'data/ecmwf/ecmwf_BB.mask','usr ieee')
        read (io) ; read (io); read (io) mask; close(io)
        do n=1,nt
         where (mask==0.) tr_clim(:,:,n) = spval
         where (mask==0.) tr_rest(:,:,n) = spval
         where (mask==0.) tr_flux(:,:,n) = spval
        enddo
        deallocate( qnet, qnec, airt,mask)

       elseif (ntr == 2) then
c    surface salt flux for salinity
        tr_flux=0. ! unknown otherwise 
c      (flux is not used for restoring formulation)
        tr_rest=1./15.0*dzt(1)/86400.
c     read restoring salinity from previously interpolated data
c     which are also used for the initial conditions, sponge layers,  etc.
        call getunit(io,'ts.dta','usr ieee')
        do n=1,nt
         read(io) ; read(io) tr_clim(:,:,n) ! spval is already correct
         where( kmt == 0) tr_clim(:,:,n)=spval
         do m=3,number_tr
          read(io) ! tracer
         enddo
         do k=2,km; do m=1,number_tr
           read(io) ! rest of the levels
        enddo; enddo; enddo
        close(io)
        x=xt;y=yt
        time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
        toffset=0.0
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_tr


#elif defined read_density_flx_nao_ideal
c
c--------------------------------------------------------
c    use the 3 year monthly mean ECMWF climatology plus
c    NAO related heat flux anomalies
c    (which is given by 
c    the monthly regression patterns of the 
c    NCEP net heat flux anomalies with the NAO-index). 
c    Same forcing was used in Eden+Willebrand 01, J.Clim.
c    See also prep_template_tau.F 
c--------------------------------------------------------
c
       subroutine read_dims_tr(nx,ny,nt,ntr)
       use prep_module
       implicit none
       integer nx,ny,nt,ntr
       character*32 stamp
       real :: dpm
       integer :: io

       if (ntr == 1 ) then
        print*,' reading heat flux boundary conditions from'
        print*,' Barniers ECMWF analysis, which were also used'
        print*,' in the DYNAMO project'
        print*,' plus NAO related heat flux anomalies from NCEP/NCAR'
        call getunit(io,'data/ecmwf/ecmwf_BB.qnet','usr ieee')
        read (io); read (io) stamp, dpm, nx, ny
        close(io)
        nt=12
       elseif (ntr == 2) then
        print*,' reading salt flux boundary condition from'
        print*,' monthly climatological SSS (file ts.dta) '
        print*,' and using a fixed restoring time scale '
#ifdef read_salt_fl_from_E5
        print*,' option read_salt_fl_from_E5 is not working here'
        stop
#endif
        nt=12; nx=imt; ny=jmt
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_dims_tr


       subroutine read_tr(tr_clim,tr_rest,tr_flux,
     &                    x,y,time,toffset,nx,ny,nt,ntr)
c
       ! returns inverse restoring time scale for tracers 
       ! number ntr in tr_rest
       ! and climatology to restore against in tr_clim
       ! nx,ny are horizontal dimensions of the data
       ! nt the time steps,
       ! x/y the longitude/latitude of the grid
       ! should mask data with spval
       ! return also net fluxes in Barniers heat flux formulation
       ! if available 
       ! Units: mom units for tr_clim and tr_rest
c       
       use prep_module
       use time_type_module
       implicit none
       integer nx,ny,nt,ntr,m,nn
       real tr_clim(nx,ny,nt) ,x(nx), y(ny)
       real tr_rest(nx,ny,nt) 
       real tr_flux(nx,ny,nt) ,time(nt),toffset
       character*32 stamp
       real, allocatable, dimension(:,:,:) :: qnet,qnec,airt
       real, allocatable, dimension(:,:)   :: mask
       real :: dpm
       integer  k,n,io,i,j
       real,parameter ::rhonull=1.026, Cpw=0.955, dimfac=0.2389e-4
       real,parameter ::qfac = dimfac/(rhonull*Cpw)
#include "netcdf.inc"
       integer :: iret,ncid,vid,dims(4),lonid,latid,corner(4),edges(4)
       character (len=80) :: dname
#ifdef netcdf_real4
      real (kind=4) :: v4(nx,ny) ,x4(nx),y4(ny),sp
#else
      real :: v4(nx,ny) ,x4(nx),y4(ny),sp
#endif
      integer :: init_t=1, lenw_t,nx2,ny2
      real (kind=4), allocatable :: x2(:),y2(:),hflx(:,:,:),tx(:),
     &               hflx2(:,:)
      character*80 name
      real (kind=4) ::  spv,add_offset,scale_factor
      real, allocatable   :: work_t(:)
      type(time_type) :: t1
      real :: mtime(12)

       if (ntr == 1) then
c     read mean data from Barniers formulation
        allocate( qnet(nx,ny,12), qnec(nx,ny,12), airt(nx,ny,12))
        allocate( mask(nx,ny))
        call getunit(io,'data/ecmwf/ecmwf_BB.qnet','usr ieee')
        do n=1,12
         read (io); read (io) stamp, dpm, k, k, k, x,y,qnet(:,:,n)
         mtime(n)=dpm
        enddo
        close(io)
        call getunit(io,'data/ecmwf/ecmwf_BB.qnec','usr ieee')
        do n=1,12
         read (io); read (io) stamp, dpm, k, k, k, x,y,qnec(:,:,n)
        enddo
        close(io)
        call getunit(io,'data/ecmwf/ecmwf_BB.airt','usr ieee')
        do n=1,12
         read (io); read (io) stamp, dpm, k, k, k, x,y,airt(:,:,n)
        enddo
        close(io)
c
c     read NAO regression patterns
c
        iret=nf_open('data/NAO_reg/reg_hflx.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'hflx_reg',vid)
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
        nx2=nx2+2 ! append some rows
        ny2=ny2+4
        print*,' nx2 = ',nx2, 'ny2=',ny2
        allocate(x2(nx2),y2(ny2), hflx2(nx2,ny2), tx(nx2),
     &           hflx(nx,ny,12) )
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
        iret=NF_INQ_VARID (NCID, name, lonid)
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
        iret=NF_INQ_VARID (NCID, name, latid)

        iret= nf_get_vara_real (ncid,lonid ,1,nx2-2,x2(2:nx2-1))
        x2(nx2)=2*x2(nx2-1)-x2(nx2-2)
        x2(1)=x2(2)-(x2(3)-x2(2))
        iret= nf_get_vara_real (ncid,latid ,1,ny2-4,y2(3:ny2-2)) 
        y2(ny2-1)=2*y2(ny2-2)-y2(ny2-3)
        y2(2)=y2(3)-(y2(4)-y2(3))
        y2(ny2)=2*y2(ny2-1)-y2(ny2-2)
        y2(1)=y2(2)-(y2(3)-y2(2))
        y2=y2(ny2:1:-1)
        iret = nf_get_att_real(ncid, vid, 'missing_value', spv)
        add_offset=0.0
        iret= nf_get_att_real (ncid,vid ,'add_offset',add_offset)
        scale_factor=1.0
        iret= nf_get_att_real (ncid,vid ,'scale_factor',scale_factor)
        print*,' missing_value of hflx_reg = ',spv
        print*,' add_offset for   hflx_reg = ',add_offset
        print*,' scale_factor for hflx_reg = ',scale_factor

c     read each month and interpolate on ECMWF grid
        print*,' interpolating data '
        lenw_t = 10*max(nx,ny)
        allocate( work_t(lenw_t) )
        do n=1,12
         hflx2=spv
         iret= nf_get_vara_real (ncid,vid ,
     &          (/1,1,n/),(/nx2-2,ny2-4,1/),hflx2(2:nx2-1,3:ny2-2))
         hflx2(nx2,:)=hflx2(2,:)
         hflx2(1,:)  =hflx2(nx2-1,:)
         hflx2(:,:)  =hflx2(:,ny2:1:-1)
         where( hflx2 == spv) hflx2=spval
         where( hflx2 /= spval) hflx2=(hflx2*scale_factor+add_offset)
         call tranlon (hflx2(1,1), nx2, nx2-2, ny2, x2, x,nx, tx)
         call ctf (hflx2(1,1), nx2, ny2, tx, y2, 
     &                  hflx(1,1,n),nx, ny, 1, nx, 1, ny,
     &                  x, y, init_t, work_t, lenw_t,spval)
         init_t=0 ! we can use the same interpolation weights
        enddo
        call ncclos (ncid, iret)
        print*,' done '
        deallocate(x2,y2,tx,work_t,hflx2)

c     read NAO index, multiply with regression pattern and add mean
c     change sign of regression patterns here !!!!
        t1 =  set_date(1999, 1, 1, 0, 0, 0)
        toffset=t1%days

        allocate(hflx2(nx,ny))
        do n=1,nt
         nn = mod(n-1,12)+1
         time(n)=mtime(nn)
         where (qnec(:,:,nn)/=0.) 
             hflx2(:,:)     = qnet(:,:,nn)+ hflx(:,:,nn)*3.0*(-1)
             tr_clim(:,:,n) = airt(:,:,nn) + hflx2(:,:)/qnec(:,:,nn)
             tr_flux(:,:,n) = hflx2(:,:)
             tr_rest(:,:,n) = qnec(:,:,nn)*qfac
         elsewhere
             tr_clim(:,:,n) = spval
             tr_rest(:,:,n) = spval
             tr_flux(:,:,n) = spval
         end where
        enddo
        deallocate(hflx2,hflx)
!     apply land mask
        call getunit(io,'data/ecmwf/ecmwf_BB.mask','usr ieee')
        read (io) ; read (io); read (io) mask; close(io)
        do n=1,nt
         where (mask==0.) tr_clim(:,:,n) = spval
         where (mask==0.) tr_rest(:,:,n) = spval
         where (mask==0.) tr_flux(:,:,n) = spval
        enddo
        deallocate( qnet, qnec, airt,mask)
       elseif (ntr == 2) then
c    surface salt flux for salinity
        tr_flux=0. ! unknown otherwise 
c      (flux is not used for restoring formulation)
        tr_rest=1./15.0*dzt(1)/86400.
c     read restoring salinity from previously interpolated data
c     which are also used for the initial conditions, sponge layers,  etc.
        call getunit(io,'ts.dta','usr ieee')
        do n=1,nt
         read(io) ; read(io) tr_clim(:,:,n) ! spval is already correct
         where( kmt == 0) tr_clim(:,:,n)=spval
         do m=3,number_tr
          read(io) ! tracer
         enddo
         do k=2,km; do m=1,number_tr
           read(io) ! rest of the levels
        enddo; enddo; enddo
        close(io)
        x=xt;y=yt
        time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
        toffset=0.0
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_tr

#elif defined read_density_flx_omip
c
c--------------------------------------------------------
c    use the monthly mean OMIP climatology 
c--------------------------------------------------------
c
       subroutine read_dims_tr(nx,ny,nt,ntr)
       use prep_module
       implicit none
       integer nx,ny,nt,ntr
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4)

       if (ntr == 1 ) then
        print*,' reading heat flux boundary condition from'
        print*,' monthly mean climatology from OMIP '
        iret=nf_open('data/OMIP/mean_net_heatflux.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'net_heat',varid)
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)  
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)  ;nt=12
        call ncclos (ncid, iret)
       elseif (ntr == 2) then
        print*,' reading salt flux boundary condition from'
        print*,' monthly climatological SSS (file ts.dta) '
        print*,' and using a fixed restoring time scale '
#ifdef read_salt_fl_from_E5
        print*,' option read_salt_fl_from_E5 is not working here'
        stop
#endif
        nt=12; nx=imt; ny=jmt
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_dims_tr


       subroutine read_tr(tr_clim,tr_rest,tr_flux,
     &                    x,y,time,toffset,nx,ny,nt,ntr)
c
       ! returns inverse restoring time scale for tracers 
       ! number ntr in tr_rest
       ! and climatology to restore against in tr_clim
       ! nx,ny are horizontal dimensions of the data
       ! nt the time steps,
       ! x/y the longitude/latitude of the grid
       ! should mask data with spval
       ! return also net fluxes in Barniers heat flux formulation
       ! if available 
       ! Units: mom units for tr_clim and tr_rest
c       
       use prep_module
       implicit none
       integer nx,ny,nt,ntr
       real tr_clim(nx,ny,nt) ,x(nx), y(ny), tr_rest(nx,ny,nt) 
       real tr_flux(nx,ny,nt) ,time(nt),toffset
#include "netcdf.inc"
      integer :: iret,ncid,vid,dims(4),aid,n,m,k,io
      character (len=80) :: name
#ifdef netcdf_real4
      real (kind=4),allocatable :: v4(:,:,:),mask(:,:)
      real (kind=4) :: sp
#else
      real ,allocatable :: v4(:,:,:),mask(:,:)
      real  :: sp
#endif
       real,parameter ::rhonull=1.026, Cpw=0.955, dimfac=0.2389e-4
       real,parameter ::qfac = dimfac/(rhonull*Cpw)

       if (ntr == 1) then
        allocate( v4(nx,ny,nt), mask(nx,ny) )
c     read land mask
         mask=1.0
        iret=nf_open('data/OMIP/land_sea_mask.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'lsm',vid)
        iret= nf_get_vara_real(ncid,vid,(/1,1/),(/nx,ny/),mask)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        call ncclos (ncid, iret)
c     read net heat flux
        iret=nf_open('data/OMIP/mean_net_heatflux.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'net_heat',vid)
        iret= nf_get_vara_real(ncid,vid,(/1,1,1/),(/nx,ny,nt/),v4)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         where ( v4(:,:,n) == sp ) v4(:,:,n)=spval
         where ( mask == 0.0  )    v4(:,:,n)=spval
         tr_flux(:,:,n)=v4(:,:,n)
        enddo
        ! read grid info
        iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
        iret=nf_inq_varid(ncid,name,aid)
        iret= nf_get_vara_real(ncid,aid ,1,nx,v4(:,1,1))
        x=v4(:,1,1)
        name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
        iret=nf_inq_varid(ncid,name,aid)
        iret= nf_get_vara_real (ncid,aid ,1,ny,v4(1,:,1)) 
        y=v4(1,:,1)
        call ncclos (ncid, iret)
c     read dq/dt
        iret=nf_open('data/OMIP/mean_dq_dt.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'dq_dt',vid)
        iret= nf_get_vara_real(ncid,vid,(/1,1,1/),(/nx,ny,nt/),v4)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         where ( v4(:,:,n) == sp ) v4(:,:,n)=spval
         where ( mask == 0.0  )    v4(:,:,n)=spval
         tr_rest(:,:,n)=max(5.0,v4(:,:,n)*-1)
        enddo
        call ncclos (ncid, iret)
c     read SST
        iret=nf_open('data/OMIP/mean_sst.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'SST',vid)
        iret= nf_get_vara_real(ncid,vid,(/1,1,1/),(/nx,ny,nt/),v4)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
        do n=1,nt
         where ( v4(:,:,n) == sp ) v4(:,:,n)=spval
         where ( mask == 0.0  )    v4(:,:,n)=spval
         tr_clim(:,:,n)=v4(:,:,n)-273.15
        enddo
        call ncclos (ncid, iret)
c    construct Haney forcing, flip second dimension up/down
c    and convert units to MOM units
        do n=1,nt
         where (tr_rest(:,:,n)/=spval .and. tr_clim(:,:,n)/=spval 
     &           .and. tr_flux(:,:,n) /=spval  ) 
          tr_clim(:,:,n) = tr_clim(:,:,n) 
     &                      + tr_flux(:,:,n)/tr_rest(:,:,n)
          tr_rest(:,:,n) = tr_rest(:,:,n)*qfac
         elsewhere
          tr_clim(:,:,n) = spval
          tr_rest(:,:,n) = spval
          tr_flux(:,:,n) = spval
         end where
         tr_clim(:,:,n)=tr_clim(:,ny:1:-1,n)
         tr_flux(:,:,n)=tr_flux(:,ny:1:-1,n)
         tr_rest(:,:,n)=tr_rest(:,ny:1:-1,n)
        enddo
        y=y(ny:1:-1)
        deallocate(v4,mask)
        toffset=0.0
        time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
       elseif (ntr == 2) then
c    surface salt flux for salinity
        tr_flux=0. ! unknown otherwise 
c      (flux is not used for restoring formulation)
        tr_rest=1./15.0*dzt(1)/86400.
c     read restoring salinity from previously interpolated data
c     which are also used for the initial conditions, sponge layers,  etc.
        call getunit(io,'ts.dta','usr ieee')
        do n=1,nt
         read(io) ; read(io) tr_clim(:,:,n) ! spval is already correct
         where( kmt == 0) tr_clim(:,:,n)=spval
         do m=3,number_tr
          read(io) ! tracer
         enddo
         do k=2,km; do m=1,number_tr
           read(io) ! rest of the levels
        enddo; enddo; enddo
        close(io)
        x=xt;y=yt
        time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
        toffset=0.0
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_tr


#elif defined read_density_flx_T511
c
c--------------------------------------------------------
c    use the daily data from ECMWF/T511
c--------------------------------------------------------
c
       subroutine read_dims_tr(nx,ny,nt,ntr)
       use prep_module
       implicit none
       integer nx,ny,nt,ntr
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4),nn
      integer :: start_y, fraction_y, nfraction_y,full_y
      common / flx_ncep/ start_y,fraction_y,nfraction_y,full_y
      character (len=80) :: file
      namelist /T511_time/ start_y,fraction_y,nfraction_y

       call getunit(ncid,'namelist.T511_time','fsr')
       read(ncid, nml = T511_time) 
       close(ncid)

       if (ntr == 1 ) then
        print*,' reading heat flux boundary condition from'
        print*,' daily data from ECMWF/T511 '
        print*,' year ',start_y,' in ',fraction_y,' fractions'
        print*,' current fraction ',nfraction_y
        write(file,'("data/ecmwf_T511/SSHF_",i4,".cdf")') start_y
        iret=nf_open(file,NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'SSHF',varid)
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)  
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn) 
        call ncclos (ncid, iret)
        full_y = nn
        print*,' days in year:',full_y
        if (mod(full_y,fraction_y)/=0) then
          print*,'fraction must be integer divider of 365'
          print*,'but ', mod(full_y,fraction_y)
          stop
        endif
        nt=full_y/fraction_y ! must be an integer
       elseif (ntr == 2) then
        print*,' no salt flux here'
        iret=nf_open('data/ecmwf_T511/SSHF_2001.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'SSHF',varid)
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)  
        iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt) ; nt=1
        call ncclos (ncid, iret)
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_dims_tr


       subroutine read_tr(tr_clim,tr_rest,tr_flux,
     &                    x,y,time,toffset,nx,ny,nt,ntr)
c
       ! returns inverse restoring time scale for tracers 
       ! number ntr in tr_rest
       ! and climatology to restore against in tr_clim
       ! nx,ny are horizontal dimensions of the data
       ! nt the time steps,
       ! x/y the longitude/latitude of the grid
       ! should mask data with spval
       ! return also net fluxes in Barniers heat flux formulation
       ! if available 
       ! Units: mom units for tr_clim and tr_rest
c       
       use prep_module
       use time_type_module
       implicit none
       integer nx,ny,nt,ntr
       real tr_clim(nx,ny,nt) ,x(nx), y(ny), tr_rest(nx,ny,nt) 
       real tr_flux(nx,ny,nt) ,time(nt),toffset
#include "netcdf.inc"
      integer :: iret,ncid,varid,xid,yid,i,j,n,n1,nn
      integer :: corner(4),edges(4),dims(4)
      character (len=80) :: name,file
#ifdef netcdf_real4
      real (kind=4),allocatable :: v4(:,:,:)
      real (kind=4) :: sp
      real (kind=4) :: add_offset,scale_factor
#else
      real ,allocatable :: v4(:,:,:)
      real  :: sp
      real  :: add_offset,scale_factor
#endif
        
       real :: mask(nx,ny),sp2,mask2(nx,ny),fxa
       type(time_type) :: t1,t2,t3
       real,parameter ::rhonull=1.026, Cpw=0.955, dimfac=0.2389e-4
       real,parameter ::qfac = dimfac/(rhonull*Cpw)
       integer :: start_y, fraction_y, nfraction_y,full_y
       common / flx_ncep/ start_y,fraction_y,nfraction_y,full_y

       
       if (ntr == 1) then

c   read land mask
      iret=nf_open('data/ecmwf_T511/land-sea-mask.nc.new',
     &              NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'tcw',varid)
      corner=(/1,1,1,1/); edges = (/nx,ny,1,1/)
      allocate( v4(nx,ny,1) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      add_offset=0.0
      iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
      do j=1,ny; do i=1,nx
        mask(i,j)=0.0
        fxa = v4(i,ny-j+1,1)*scale_factor + add_offset
        if (fxa.gt. 0.1)  mask(i,j)=1.
        mask2(i,j)=0.0
        if (fxa.gt. 0.5)  mask2(i,j)=1.
      enddo; enddo
      deallocate(v4)
      call ncclos (ncid, iret)

c     we have to manipulate the land mask a bit
      mask(705:712,288:300)=mask2(705:712,288:300) ! this is Scotland
      mask(635:645,306:312)=mask2(635:645,306:312) ! East greenland
      mask(585:600,310:318)=mask2(585:600,310:318)

      ! read grid info
        iret=nf_open('data/ecmwf_T511/land-sea-mask.nc',NF_nowrite,ncid)
        iret=nf_inq_varid(ncid,'lsm',varid)
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        file='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),file) 
        iret=nf_inq_varid(ncid,file,xid)
        allocate(v4(nx,1,1) )
        iret= nf_get_vara_real (ncid,xid ,1,nx,v4); x=v4(1:nx,1,1)
        deallocate(v4)
        file='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),file) 
        iret=nf_inq_varid(ncid,file,yid)
        allocate(v4(ny,1,1) )
        iret= nf_get_vara_real (ncid,yid ,1,ny,v4); 
        do j=1,ny
           y(j)=v4(ny-j+1,1,1)
        enddo
        deallocate(v4)
        call ncclos (ncid, iret)
        ! time vector
        t1 =  set_date(start_y, 1, 1, 0, 0, 0)
        toffset=t1%days + (nfraction_y-1)*(full_y/fraction_y)
        write(file,'("data/ecmwf_T511/SSHF_",i4,".cdf")') start_y
        iret=nf_open(file,NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'SSHF',varid)
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        call ncclos (ncid, iret)
        do n=1,nt
         time(n) =  365.0/(full_y*1.0)
        enddo

        print*,' reading year ',start_y
        call sub_flush(6)
        write(file,'("data/ecmwf_T511/SSHF_",i4,".cdf")') start_y
        iret=nf_open(file,NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'SSHF',varid)
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
        n1=1+(nfraction_y-1)*(full_y/fraction_y)
        nn=nfraction_y*(full_y/fraction_y)
     
        corner=(/1,1,n1,1/); edges = (/nx,ny,nt,1/)
        allocate( v4(nx,ny,nt) )
        iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)

        do n=1,nt; do j=1,ny; do i=1,nx
          if (mask(i,j) /= 1.0 ) then
           tr_flux(i,j,n) =v4(i,j,n)
          else
           tr_flux(i,j,n) = spval
          endif
        enddo; enddo; enddo
        call ncclos (ncid, iret)

        if (full_y /= 365 ) then
         iret=nf_open('data/ecmwf_T511/tair_leap.cdf',NF_nowrite,ncid)
        else
         iret=nf_open('data/ecmwf_T511/tair_2001.cdf',NF_nowrite,ncid)
        endif

        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'TAIR',varid)
        corner=(/1,1,n1,1/); edges = (/nx,ny,nt,1/)
        iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
        iret= nf_get_att_real (ncid,varid ,'missing_value',sp)
        do n=1,nt; do j=1,ny; do i=1,nx
          if (v4(i,j,n) /= sp ) then
           tr_clim(i,j,n) =v4(i,j,n)
          else
           tr_clim(i,j,n) = spval
          endif
        enddo; enddo; enddo
        call ncclos (ncid, iret)

        if (full_y /= 365 ) then
         iret=nf_open('data/ecmwf_T511/q2_leap.cdf',NF_nowrite,ncid)
        else
         iret=nf_open('data/ecmwf_T511/q2_2001.cdf',NF_nowrite,ncid)
        endif

        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'Q2',varid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        corner=(/1,1,n1,1/); edges = (/nx,ny,nt,1/)
        iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret= nf_get_att_real (ncid,varid ,'missing_value',sp)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        do n=1,nt; do j=1,ny; do i=1,nx
          if (v4(i,j,n) /= sp ) then
           tr_rest(i,j,n) =v4(i,j,n)
          else
           tr_rest(i,j,n) = spval
          endif
        enddo; enddo; enddo
        call ncclos (ncid, iret)

        deallocate(v4)

        do n=1,nt; do j=1,ny; do i=1,nx
         if (tr_rest(i,j,n)/=spval .and. tr_clim(i,j,n)/=spval 
     &    .and. tr_flux(i,j,n) /=spval.and.tr_rest(i,j,n)/=0.0  ) then
          tr_clim(i,j,n) = tr_clim(i,j,n) 
     &                      + tr_flux(i,j,n)/tr_rest(i,j,n)
          tr_rest(i,j,n) = tr_rest(i,j,n)*qfac
         else
          tr_clim(i,j,n) = spval
          tr_rest(i,j,n) = spval
          tr_flux(i,j,n) = spval
         endif
        enddo; enddo; enddo

       elseif (ntr == 2) then
c no flux here
        tr_flux=0. 
        tr_rest=0.
        tr_clim=0.
        iret=nf_open('data/ecmwf_T511/land-sea-mask.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'lsm',varid)
        ! read grid info
        iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
        file='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),file) 
        iret=nf_inq_varid(ncid,file,xid)
        allocate(v4(nx,1,1) )
        iret= nf_get_vara_real (ncid,xid ,1,nx,v4); x=v4(1:nx,1,1)
        deallocate(v4)
        file='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),file) 
        iret=nf_inq_varid(ncid,file,yid)
        allocate(v4(ny,1,1) )
        iret= nf_get_vara_real (ncid,yid ,1,ny,v4); 
        do j=1,ny
         y(j)=v4(ny-j+1,1,1)
        enddo
        deallocate(v4)
        call ncclos (ncid, iret)
       else
        print*,' do not know SBC for tracer ',ntr
        call halt_stop(' in read_tr')
       endif
       end subroutine read_tr
#endif

#include "options.inc"



       module variances_module
c
c=======================================================================
c      perform averages for some second moments 
c
c      Note that:   sum((T_prime)^2) = sum(T^2) - N bar(T)^2
c      and that N is lost when converting sum(T) to NetCDF
c
c      namelist parameter to be used:
c
c          enable_monthly_variances
c          enable_seasonal_variances
c          enable_daily_variances
c
c      u u_t  +  u u u_x  = - u p_x/rho_0  = - (u p/rho_0)_x + p/rho_0 u_x 
c                = -(u p/rho_0)_x  - p/rho_0 w_z = -(u p/rho_0)_x  - (wp/rho_0)_z + w p_z/rho_0 
c      (u^2/2)_t + u u u_x  + (up/rho_0)_x+(wp/rho_0)_z = w p_z/rho_0 = - g w rho/rho_0 = w b  
c
c
c ------------------------------------------------
c what is needed for the fluxes
c  eddy fluxes :
c sum(ub) = sum( u_bar b_bar + ubar b_prime + u_prime b_bar + u_prime b_prime)
c         = N u_bar b_bar + sum(u_prime b_prime)
c sum(u_prime b_prime)/N = sum(ub)/N - u_bar b_bar
c
c  fluxes of variance:
c sum(ub^2) = u_bar sum(b^2) + sum(u_prime b^2)
c  = u_bar ( sum(b_prime^2) + N b_bar^2) + sum( u_prime (b_bar + b_prime)^2)
c  = N u_bar b_bar^2 + u_bar sum(b_prime^2) 
c  + sum( u_prime (b_bar^2 + b_prime^2 + 2b_bar b_prime ) )
c  = N u_bar b_bar^2 + u_bar sum(b_prime^2) 
c  + sum( u_prime b_prime^2) + 2 b_bar sum( u_prime b_prime  )
c
c  u_bar sum(b_prime^2)/N + sum( u_prime b_prime^2)/N = 
c       sum(ub^2)/N - u_bar b_bar^2 - 2 b_bar sum(u_prime b_prime)/N
c    =  sum(ub^2)/N - u_bar b_bar^2 - 2 b_bar (sum(ub)/N - u_bar b_bar)
c    =  sum(ub^2)/N + u_bar b_bar^2 - 2 b_bar sum(ub)/N
c  
c  so we need u_bar b_bar sum(ub) sum(ub^2) and sum(b^2)
c  ( the last one only to separate out the triple fluxes)
c
c  we write b_bar, etc averaged on the three edges of the tracer boxes
c ------------------------------------------------
c
c=======================================================================
c
       implicit none
       real, allocatable, dimension(:,:,:,:) :: umean,uvar
       real, allocatable, dimension(:,:,:)   :: uv,T2,T4
       real, allocatable, dimension(:,:,:)   :: bmean
       real, allocatable, dimension(:,:,:)   :: var_tracer
       real, allocatable, dimension(:,:,:,:) :: mean_adv
       real, allocatable, dimension(:,:,:,:) :: mean_eddy_flux
       real, allocatable, dimension(:,:,:,:) :: mean_var_flux
       integer :: counter  = 0
       logical :: active = .false.
       end module variances_module


       subroutine init_variances
c
c      initialize module (should be done in any case)
c
       use spflame_module
       use variances_module
       implicit none
       character (len=80) :: name
       integer :: io,k,n,nr_blk,i,j,m
       real, allocatable ::  buf(:,:)
       logical :: eof , nofile

       if (enable_monthly_variances.or.
     &     enable_seasonal_variances.or.
     &     enable_daily_variances ) active = .true.

       if (.not. active) return ! return if not active

       if (my_pe==0) then
        print*,''
        print*,' setting up averages of second moments'
        if (enable_daily_variances) then
         print*,' based on daily means '
        endif
        if (enable_monthly_variances) then
         print*,' based on monthly means '
        endif
        if (enable_seasonal_variances) then
         print*,' based on seasonal means '
        endif
       endif
c
c      allocate memory and initialize fields and counter
c
       allocate( umean(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1,2) )
       allocate( uvar(is_pe:ie_pe,km,js_pe:je_pe,2) )
       umean=0.; uvar=0. 
       allocate( uv(is_pe:ie_pe,km,js_pe:je_pe) )
       allocate( T2(is_pe:ie_pe,km,js_pe:je_pe) )
       allocate( T4(is_pe:ie_pe,km,js_pe:je_pe) )
       uv=0.0;T2=0;T4=0.

       allocate(       mean_adv(is_pe:ie_pe,km,js_pe:je_pe,3) )
       allocate(    bmean(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) )
       allocate(     var_tracer(is_pe:ie_pe,km,js_pe:je_pe) )
       allocate( mean_eddy_flux(is_pe:ie_pe,km,js_pe:je_pe,3) )
       allocate(  mean_var_flux(is_pe:ie_pe,km,js_pe:je_pe,3) )
       mean_adv=0.0; bmean=0.0; var_tracer=0.0
       mean_eddy_flux=0.0; mean_var_flux = 0.0

       counter = 0
c
c      read unfinished averages
c
       if (my_pe==0) then
        write(name,'("variances_",i3,".dta")') sub_domain
        call replace_space_zero(name)
        print*,' reading unfinished variances from file ',
     &          name(1:len_trim(name))
        call get_free_iounit(io);nofile=.false.
        open(io,file=name,form='unformatted',status='old',err=30)
        read(io) counter
        print*,' (counter=',counter,')'
        goto 40
 30     nofile=.true.
 40     continue
       endif

       call bcast_integer(counter,1,0)
       call bcast_logical(nofile,1,0)

       if (nofile) then
        if (my_pe==0) then
         print*,''
         print*,'---------------------------------------------'
         print*,' WARNING : cannot read file ',name(1:len_trim(name))
         print*,'---------------------------------------------'
         print*,''
        endif
        return
       endif

       allocate( buf(imt,jmt) )

       do n=1,2
        do k=1,km
         if (my_pe==0) read(io) buf
         call pe0_send_2D(buf)
         umean(is_pe:ie_pe,k,js_pe:je_pe,n)=
     &       buf(is_pe:ie_pe,js_pe:je_pe)
        enddo
       enddo

       do n=1,2
        do k=1,km
         if (my_pe==0) read(io) buf
         call pe0_send_2D(buf)
         uvar(is_pe:ie_pe,k,js_pe:je_pe,n)=
     &        buf(is_pe:ie_pe,js_pe:je_pe)
        enddo
       enddo

       do k=1,km
           if (my_pe==0) read(io) buf ! uv
           call pe0_send_2D(buf)
           uv(is_pe:ie_pe,k,js_pe:je_pe)=
     &        buf(is_pe:ie_pe,js_pe:je_pe)
       enddo

       do k=1,km
        do n=1,3  ! sum(u)
           if (my_pe==0) read(io) buf 
           call pe0_send_2D(buf)
           mean_adv(is_pe:ie_pe,k,js_pe:je_pe,n)=
     &        buf(is_pe:ie_pe,js_pe:je_pe)
        enddo
        if (my_pe==0) read(io) buf 
        call pe0_send_2D(buf)
        bmean(is_pe:ie_pe,k,js_pe:je_pe)=buf(is_pe:ie_pe,js_pe:je_pe)

        if (my_pe==0) read(io) buf 
        call pe0_send_2D(buf)
        var_tracer(is_pe:ie_pe,k,js_pe:je_pe)=
     &        buf(is_pe:ie_pe,js_pe:je_pe)
        do m=1,3 ! sum(ub)
            if (my_pe==0) read(io) buf 
            call pe0_send_2D(buf)
            mean_eddy_flux(is_pe:ie_pe,k,js_pe:je_pe,m)=
     &        buf(is_pe:ie_pe,js_pe:je_pe)
        enddo
        do m=1,3 ! sum(ub^2)
            if (my_pe==0) read(io) buf 
            call pe0_send_2D(buf)
            mean_var_flux(is_pe:ie_pe,k,js_pe:je_pe,m)=
     &        buf(is_pe:ie_pe,js_pe:je_pe)
        enddo
       enddo ! k=1,km

       deallocate( buf )

       if (my_pe==0) then
         close(io)
         print*,' done setting up variance averaging'
       endif

       end subroutine init_variances



       subroutine write_unfinished_variances
       use spflame_module
       use variances_module
       implicit none
       character (len=80) :: name
       integer :: i,j,k,n,io,m
       real, allocatable ::  buf(:,:)
c
c      determine file name
c
       write(name,'("variances_",i3,".dta")') sub_domain
       call replace_space_zero(name)
       if (my_pe==0) then
          print*,' writing unfinished variances to file ',
     &             name(1:len_trim(name))
          call get_free_iounit(io)
          open(io,file=name,form='unformatted',status='unknown')
          write(io) counter
       endif

       allocate( buf(imt,jmt) )

       do n=1,2
        do k=1,km
         buf(is_pe:ie_pe,js_pe:je_pe)=umean(is_pe:ie_pe,k,js_pe:je_pe,n)
         call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
        enddo
       enddo

       do n=1,2
        do k=1,km
         buf(is_pe:ie_pe,js_pe:je_pe)=uvar(is_pe:ie_pe,k,js_pe:je_pe,n)
         call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
        enddo
       enddo

       do k=1,km
        buf(is_pe:ie_pe,js_pe:je_pe)=uv(is_pe:ie_pe,k,js_pe:je_pe)
        call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
       enddo

       do k=1,km
          do n=1,3  ! sum(u)
           buf(is_pe:ie_pe,js_pe:je_pe) = 
     &           mean_adv(is_pe:ie_pe,k,js_pe:je_pe,n)
           call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
          enddo
          buf(is_pe:ie_pe,js_pe:je_pe)=bmean(is_pe:ie_pe,k,js_pe:je_pe)
          call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
          buf(is_pe:ie_pe,js_pe:je_pe)=
     &        var_tracer(is_pe:ie_pe,k,js_pe:je_pe)
          call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
          do m=1,3 ! sum(ub)
            buf(is_pe:ie_pe,js_pe:je_pe)=
     &        mean_eddy_flux(is_pe:ie_pe,k,js_pe:je_pe,m)
            call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
          enddo
          do m=1,3 ! sum(ub^2)
            buf(is_pe:ie_pe,js_pe:je_pe)=
     &        mean_var_flux(is_pe:ie_pe,k,js_pe:je_pe,m)
            call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
           enddo
       enddo ! k=1,km

       deallocate(buf)

       if (my_pe==0) close(io)

       end subroutine write_unfinished_variances






       subroutine variances
c
c      perform averages of second moments
c
       use spflame_module
       use variances_module
       implicit none
       integer :: i,j,k,n,m
       real :: sig(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1)
       real :: fxa

       if (.not. active) return ! return if not active

       if (.not. eulerback1 ) then ! not for first part of euler backward

        counter=counter+1 ! increase counter

        do n=1,2  ! average U and V
         do j=js_pe,je_pe
          do k=1,km
           do i=is_pe,ie_pe
            umean(i,k,j,n)=umean(i,k,j,n)+u(i,k,j,n,tau)
            uvar(i,k,j,n) =uvar(i,k,j,n) +u(i,k,j,n,tau)**2
           enddo
          enddo
         enddo
        enddo
c
c     this is not exact but simpler
c
        do j=js_pe,je_pe
          do k=1,km
           do i=is_pe,ie_pe
            uv(i,k,j)     = uv(i,k,j) + u(i,k,j,1,tau)*u(i,k,j,2,tau)  ! u*v
           enddo
          enddo
        enddo
c
c     sum(u)
c
        do j=js_pe,je_pe
         do k=1,km
           do i=is_pe,ie_pe
            mean_adv(i,k,j,1)=mean_adv(i,k,j,1)+adv_vet(i,k,j)
            mean_adv(i,k,j,2)=mean_adv(i,k,j,2)+adv_vnt(i,k,j)
            mean_adv(i,k,j,3)=mean_adv(i,k,j,3)+adv_vbt(i,k,j)
           enddo
         enddo
        enddo
c
c     calculate model potential density
c
        do j=js_pe-1,je_pe+1
          do k=1,km
           call model_dens(t(is_pe-1,k,j,1,tau), t(is_pe-1,k,j,2,tau),
     &                           sig(is_pe-1,k,j),1,ie_pe-is_pe+3
#ifdef partial_cell
     &                       ,ztp(is_pe-1,k,j)
#endif
     &                       )
          enddo
        enddo
c
c     sum(b), sum(b^2), sum(ub) and sum(ub^2)
c 
        do j=js_pe,je_pe
          do k=1,km
           do i=is_pe,ie_pe
            fxa = sig(i,k,j) 
            bmean(i,k,j)=bmean(i,k,j)+fxa
            var_tracer(i,k,j) =var_tracer(i,k,j)+fxa**2

            fxa = 0.5*(sig(i,k,j) + sig(i+1,k,j))
            mean_eddy_flux(i,k,j,1)=mean_eddy_flux(i,k,j,1)
     &                +fxa*adv_vet(i,k,j)
            mean_var_flux(i,k,j,1)=mean_var_flux(i,k,j,1)
     &                +fxa**2*adv_vet(i,k,j)

            fxa = 0.5*(sig(i,k,j) + sig(i,k,j+1))
            mean_eddy_flux(i,k,j,2)=mean_eddy_flux(i,k,j,2)
     &                +fxa*adv_vnt(i,k,j)
            mean_var_flux(i,k,j,2)=mean_var_flux(i,k,j,2)
     &                +fxa**2*adv_vnt(i,k,j)
           enddo
          enddo

          do k=1,km-1
           do i=is_pe,ie_pe
            fxa = 0.5*(sig(i,k,j) + sig(i,k+1,j))
            mean_eddy_flux(i,k,j,3)=mean_eddy_flux(i,k,j,3)
     &                +fxa*adv_vbt(i,k,j)
            mean_var_flux(i,k,j,3)=mean_var_flux(i,k,j,3)
     &                +fxa**2*adv_vbt(i,k,j)
           enddo
          enddo
        enddo
c
c       write finished averages to a binary file
c
        if ((end_of_month .and.enable_monthly_variances ).or. 
     &      (end_of_day   .and.enable_daily_variances   ).or. 
     &      (end_of_season.and.enable_seasonal_variances)) then
c
c        write netcdf file 
c
         call calculate_variances()
         call write_variances()
c
c        zero out counter and arrays
c
         counter=0
         umean=0.;uvar=0.; uv=0.
         mean_adv=0.0; bmean=0.0; var_tracer=0.0
         mean_eddy_flux=0.0; mean_var_flux = 0.0
        endif !  end_of_month ...
       endif ! eulerback1
       if (last_time_step) call write_unfinished_variances()
       end subroutine variances







       subroutine calculate_variances
       use spflame_module
       use variances_module
       implicit none
       integer :: i,j,k,n
       integer :: is,ie,js,je
       real :: fxa,fxb,fxc
       real :: fx(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1)

       is=is_pe; ie=ie_pe; js=js_pe; je=je_pe
c
c          sum(T*) = sum(T^2) - N T_bar^2 c     N T_bar = sum(T_n) c     1/N [sum(T_n)]^2 = N T_bar^2
c
       do n=1,2
        do j=js,je
         do k=1,km
          do i=is,ie
           uvar(i,k,j,n)= uvar(i,k,j,n)-umean(i,k,j,n)**2/counter 
           uvar(i,k,j,n)= uvar(i,k,j,n)/counter
           umean(i,k,j,n)= umean(i,k,j,n)/counter
           uv(i,k,j)= uv(i,k,j)/counter-umean(i,k,j,1)*umean(i,k,j,2)
          enddo
         enddo
        enddo
       enddo
       uvar = uvar * 1e-4; uv = uv * 1e-4; umean = umean * 1e-2
c
c  T4 = u_prime^2 (u_bar)_x + v_prime^2 (v_bar)_y + u_prime v_prime ( (u_bar)_y + (v_bar)x )
c
       call border_exchg(umean(:,:,:,1),km,1)
       call border_exchg(umean(:,:,:,2),km,1)
       do k=1,km
        do j=js,je
         do i=is,ie
          fxa=0.5*100*
     &      ((umean(i+1,k,j,1)-umean(i  ,k,j,1))*dxtr(i+1)*csur(j) 
     &      +(umean(i  ,k,j,1)-umean(i-1,k,j,1))*dxtr(i  )*csur(j) )
          fxb=0.5*100*
     &      ((umean(i,k,j+1,2)-umean(i,k,j  ,2))*dytr(j+1) 
     &      +(umean(i,k,j  ,2)-umean(i,k,j-1,2))*dytr(j  ) )
          T4(i,k,j)= uvar(i,k,j,1)*fxa +uvar(i,k,j,2)*fxb 
     &              +uv(i,k,j)*(fxa+fxb)
         enddo
        enddo
       enddo
c
c        Density stuff.  Convert density to buoyancy:   b = - g rho/rho_0
c            b has units of accelaration m/s^2 
c
       fxa = - grav/rho0  /100.
       mean_adv=mean_adv/100;  
       mean_eddy_flux=mean_eddy_flux/100 * fxa; 
       mean_var_flux = mean_var_flux/100 * fxa**2;
       bmean = bmean*fxa 

       mean_adv=mean_adv/counter
       bmean=bmean/counter
       var_tracer=(var_tracer-bmean**2*counter )/counter

       call border_exchg(bmean,km,1)
       do j=js,je
        do k=1,km
         do i=is,ie
          fxa = 0.5*( bmean(i,k,j)+bmean(i+1,k,j) )
          mean_eddy_flux(i,k,j,1) = mean_eddy_flux(i,k,j,1)/counter 
     &         -mean_adv(i,k,j,1)*fxa
          mean_var_flux(i,k,j,1) = mean_var_flux(i,k,j,1)/counter 
     &         -mean_adv(i,k,j,1)*fxa**2-2*fxa*mean_eddy_flux(i,k,j,1)

          fxa = 0.5*( bmean(i,k,j)+bmean(i,k,j+1) )
          mean_eddy_flux(i,k,j,2) = mean_eddy_flux(i,k,j,2)/counter 
     &         -mean_adv(i,k,j,2)*fxa
          mean_var_flux(i,k,j,2) = mean_var_flux(i,k,j,2)/counter 
     &         -mean_adv(i,k,j,2)*fxa**2-2*fxa*mean_eddy_flux(i,k,j,2)
         enddo
        enddo
       enddo

       do j=js,je
        do k=1,km-1
         do i=is,ie
            fxa = 0.5*( bmean(i,k,j)+bmean(i,k+1,j) )
            mean_eddy_flux(i,k,j,3) = mean_eddy_flux(i,k,j,3)/counter 
     &         -mean_adv(i,k,j,3)*fxa
            mean_var_flux(i,k,j,3) = mean_var_flux(i,k,j,3)/counter 
     &         -mean_adv(i,k,j,3)*fxa**2-2*fxa*mean_eddy_flux(i,k,j,3)
         enddo
        enddo
       enddo


c  T2 =   u'b' b_x / b_z  + v'b' b_y /b_z

       fx=0.0;T2=0.0
       do j=js,je
        do k=1,km
         do i=is,ie
          fx(i,k,j)=mean_eddy_flux(i,k,j,1)*
     &          100*(bmean(i+1,k,j)-bmean(i,k,j))*dxur(i)*cstr(j) 
         enddo
        enddo
       enddo
       call border_exchg(fx,km,1)
       do j=js,je
        do k=2,km-1
         do i=is,ie
          T2(i,k,j) = 0.5*(fx(i,k,j)+fx(i-1,k,j))
         enddo
        enddo
       enddo

       fx=0.0
       do j=js,je
        do k=1,km
         do i=is,ie
          fx(i,k,j)=mean_eddy_flux(i,k,j,2)*
     &          100*(bmean(i,k,j+1)-bmean(i,k,j))*dyur(j) 
         enddo
        enddo
       enddo
       call border_exchg(fx,km,1)
       do j=js,je
        do k=2,km-1
         do i=is,ie
          T2(i,k,j) = 0.5*(fx(i,k,j)+fx(i,k,j-1))
         enddo
        enddo
       enddo

       fx=0.0
       do j=js,je
        do k=1,km-1
         do i=is,ie
          fx(i,k,j)=100*(bmean(i,k+1,j)-bmean(i,k,j))*dzwr(k) 
         enddo
        enddo
       enddo
       do j=js,je
        do k=2,km-1
         do i=is,ie
          fxa = 0.5*(fx(i,k,j)+fx(i,k-1,j))
          if (fxa/=0.0) T2(i,k,j) = T2(i,k,j)/ fxa
         enddo
        enddo
       enddo

       end subroutine calculate_variances







       subroutine write_variances
       use spflame_module
       use variances_module
       implicit none
#ifdef netcdf_diagnostics
#include "netcdf.inc"
       character (len=80) :: fname,name,unit
       integer :: year,month,day
       integer :: ncid,iret,i,j,k,dims(4),start(4),count(4)
       real    :: spval=-9.9e12, tt
       integer :: lon_tdim,lon_tid,lon_udim,lon_uid
       integer :: lat_tdim,lat_tid,lat_udim,lat_uid
       integer :: depth_tdim,depth_tid,depth_wdim,depth_wid
       integer :: itimedim,itimeid,uid,vid,trid(nt),npe,n
       integer :: uvarid,umeanid,vvarid,vmeanid,uvid,T4id
       integer :: ubid,vbid,wbid,bmid,T2id
       integer :: ubbid,vbbid,wbbid,bbid
       integer :: is,ie,js,je
#ifdef netcdf_real4
      real (kind=4) :: var(is_pe:ie_pe,js_pe:je_pe)
      real (kind=4) , allocatable :: v2(:)
#else
      real          :: var(is_pe:ie_pe,js_pe:je_pe)
      real          , allocatable :: v2(:)
#endif


       is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

       year  = get_year(get_current_time())
       month = get_month_of_year(get_current_time())
       day   = get_day_of_month(get_current_time())

       write(fname,'("T4_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            sub_domain,year,month,day
       do i=1,len_trim(fname);if (fname(i:i)==' ')fname(i:i)='0';enddo

       if (my_pe == 0) then
        print*,' Writing variances to  NetCDF output file ',
     &         fname(1:len_trim(fname))
        ncid = nccre (fname, NCCLOB, iret)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        call store_info_cdf(ncid)
c       dimensions
        lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
        Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
        Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
        Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
        depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
        depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
        iTimedim  = ncddef(ncid, 'Time', 1, iret)
c       grid variables
        dims(1)  = Lon_tdim
        Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
        dims(1)  = Lon_udim
        Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
        dims(1)  = Lat_tdim
        Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
        dims(1)  = Lat_udim
        Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
        dims(1)  = iTimedim
        iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
        dims(1)  = depth_wdim
        depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
        dims(1)  = depth_tdim
        depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c       attributes of the grid
        name = 'Longitude on T grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Longitude on U grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on T grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on U grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Depth of T Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
        call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
        name = 'Depth of W Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
        call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
        name = 'Time                    '; unit = 'days            '
        call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
        call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c       variables
        dims=(/lon_udim,lat_udim,depth_tdim,itimedim/)
        uvarid= ncvdef (ncid,'uvar' , NCFLOAT,4,dims,iret)
        umeanid=ncvdef (ncid,'umean', NCFLOAT,4,dims,iret)
        vvarid= ncvdef (ncid,'vvar' , NCFLOAT,4,dims,iret)
        vmeanid=ncvdef (ncid,'vmean', NCFLOAT,4,dims,iret)
        uvid  = ncvdef (ncid,'uv'   , NCFLOAT,4,dims,iret)
        T4id  = ncvdef (ncid,'T4'   , NCFLOAT,4,dims,iret)

c       attributes of variables
        name = 'Variance of zonal velocity'; unit = 'm^2/s^2'
        call dvcdf(ncid,uvarid,name,24,unit,16,spval)
        name = 'Mean of zonal velocity'; unit = 'm/s'
        call dvcdf(ncid,umeanid,name,24,unit,16,spval)
        name = 'Variance of meridional velocity'; unit = 'm^2/s^2'
        call dvcdf(ncid,vvarid,name,24,unit,16,spval)
        name = 'Mean of meridional velocity'; unit = 'm/s'
        call dvcdf(ncid,vmeanid,name,24,unit,16,spval)
        name = 'Hor. velocity correlation'; unit = 'm^2/s^2'
        call dvcdf(ncid,uvid,name,24,unit,16,spval)

        name = 'EKE-> MKE'; unit = 'm^2/s^3'
        call dvcdf(ncid,T4id,name,24,unit,16,spval)

c       global attrubutes
        iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        call ncendf(ncid, iret)

c       write grid
        allocate( v2(max(imt,jmt,km)) )
        v2(1:imt)=xt
        call ncvpt(ncid, Lon_tid, 1, imt,v2, iret)
        v2(1:imt)=xu
        call ncvpt(ncid, Lon_uid, 1, imt,v2, iret)
        v2(1:jmt)=yt
        call ncvpt(ncid, Lat_tid, 1, jmt,v2, iret)
        v2(1:jmt)=yu
        call ncvpt(ncid, Lat_uid, 1, jmt,v2, iret)
        v2(1:km)=zt/100.
        call ncvpt(ncid, depth_tid, 1, km,v2, iret)
        v2(1:km)=zw/100.
        call ncvpt(ncid, depth_wid, 1, km,v2, iret)
        call read_stamp(current_stamp,tt ); v2(1)=tt
        call ncvpt(ncid, itimeid, 1, 1,v2, iret)
        deallocate(v2)
        call ncclos (ncid, iret)
       endif

c      loop over PEs
       do npe=0,n_pes
        call barrier
        if (my_pe==npe) then
         iret=nf_open(fname,NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         iret=nf_inq_varid(ncid,'umean',umeanid)
         iret=nf_inq_varid(ncid,'uvar',uvarid)
         iret=nf_inq_varid(ncid,'vmean',vmeanid)
         iret=nf_inq_varid(ncid,'vvar',vvarid)
         iret=nf_inq_varid(ncid,'uv',uvid)
         iret=nf_inq_varid(ncid,'T4',T4id)

         where( umask(is:ie,1:km,js:je) == 0. ) 
          umean(is:ie,:,js:je,1) = spval
          umean(is:ie,:,js:je,2) = spval
          uvar(is:ie,:,js:je,1) = spval
          uvar(is:ie,:,js:je,2) = spval
          uv(is:ie,:,js:je) = spval
          T4(is:ie,:,js:je) = spval
         end where

         do k=1,km
          start=(/is,js,k,1/); count=(/ie-is+1,je-js+1,1,1/)
          var=umean(:,k,:,1)
          iret= nf_put_vara_real (ncid,umeanid,start,count,var )
          var=umean(:,k,:,2)
          iret= nf_put_vara_real (ncid,vmeanid,start,count,var )
          var=uvar(:,k,:,1)
          iret= nf_put_vara_real (ncid,uvarid,start,count,var )
          var=uvar(:,k,:,2)
          iret= nf_put_vara_real (ncid,vvarid,start,count,var )
          var=uv(:,k,:)
          iret= nf_put_vara_real (ncid,uvid,start,count,var )
          var=T4(:,k,:)
          iret= nf_put_vara_real (ncid,t4id,start,count,var )
         enddo
         call ncclos (ncid, iret)
        endif
        call barrier
       enddo


       write(fname,'("T2_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            sub_domain,year,month,day
       do i=1,len_trim(fname);if (fname(i:i)==' ')fname(i:i)='0';enddo

       if (my_pe == 0) then
        print*,' Writing variances to  NetCDF output file ',
     &         fname(1:len_trim(fname))
        ncid = nccre (fname, NCCLOB, iret)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        call store_info_cdf(ncid)
c       dimensions
        lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
        Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
        Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
        Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
        depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
        depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
        iTimedim  = ncddef(ncid, 'Time', 1, iret)
c       grid variables
        dims(1)  = Lon_tdim
        Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
        dims(1)  = Lon_udim
        Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
        dims(1)  = Lat_tdim
        Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
        dims(1)  = Lat_udim
        Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
        dims(1)  = iTimedim
        iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
        dims(1)  = depth_wdim
        depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
        dims(1)  = depth_tdim
        depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c       attributes of the grid
        name = 'Longitude on T grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Longitude on U grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on T grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on U grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Depth of T Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
        call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
        name = 'Depth of W Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
        call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
        name = 'Time                    '; unit = 'days            '
        call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
        call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c       variables
        dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
        T2id  = ncvdef (ncid,'T2'   , NCFLOAT,4,dims,iret)
        bmid  = ncvdef (ncid,'b'   , NCFLOAT,4,dims,iret)
        dims=(/lon_udim,lat_tdim,depth_tdim,itimedim/)
        ubid  = ncvdef (ncid,'ub'   , NCFLOAT,4,dims,iret)
        dims=(/lon_tdim,lat_udim,depth_tdim,itimedim/)
        vbid  = ncvdef (ncid,'vb'   , NCFLOAT,4,dims,iret)
        dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
        wbid  = ncvdef (ncid,'wb'   , NCFLOAT,4,dims,iret)

c       attributes of variables
        name = 'EPE-> MPE'; unit = 'm^2/s^3'
        call dvcdf(ncid,T2id,name,24,unit,16,spval)
        name = 'Zonal eddy buoyancy flux'; unit = 'm^2/s^3'
        call dvcdf(ncid,ubid,name,24,unit,16,spval)
        name = 'Meridional eddy buoyancy flux'; unit = 'm^2/s^3'
        call dvcdf(ncid,vbid,name,24,unit,16,spval)
        name = 'Vertical eddy buoyancy flux'; unit = 'm^2/s^3'
        call dvcdf(ncid,wbid,name,24,unit,16,spval)
        name = 'Mean buoyancy'; unit = 'm/s^2'
        call dvcdf(ncid,bmid,name,24,unit,16,spval)

c       global attrubutes
        iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        call ncendf(ncid, iret)

c       write grid
        allocate( v2(max(imt,jmt,km)) )
        v2(1:imt)=xt
        call ncvpt(ncid, Lon_tid, 1, imt,v2, iret)
        v2(1:imt)=xu
        call ncvpt(ncid, Lon_uid, 1, imt,v2, iret)
        v2(1:jmt)=yt
        call ncvpt(ncid, Lat_tid, 1, jmt,v2, iret)
        v2(1:jmt)=yu
        call ncvpt(ncid, Lat_uid, 1, jmt,v2, iret)
        v2(1:km)=zt/100.
        call ncvpt(ncid, depth_tid, 1, km,v2, iret)
        v2(1:km)=zw/100.
        call ncvpt(ncid, depth_wid, 1, km,v2, iret)
        call read_stamp(current_stamp,tt ); v2(1)=tt
        call ncvpt(ncid, itimeid, 1, 1,v2, iret)
        deallocate(v2)
        call ncclos (ncid, iret)
       endif

c      loop over PEs
       do npe=0,n_pes
        call barrier
        if (my_pe==npe) then
         iret=nf_open(fname,NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         iret=nf_inq_varid(ncid,'T2',T2id)
         iret=nf_inq_varid(ncid,'ub',ubid)
         iret=nf_inq_varid(ncid,'vb',vbid)
         iret=nf_inq_varid(ncid,'wb',wbid)
         iret=nf_inq_varid(ncid,'b', bmid)

         where( tmask(is:ie,1:km,js:je) == 0. ) 
          bmean(is:ie,:,js:je) = spval
         end where
         where( umask(is:ie,1:km,js:je) == 0. ) 
          mean_eddy_flux(is:ie,:,js:je,1)=spval
          mean_eddy_flux(is:ie,:,js:je,2)=spval
          mean_eddy_flux(is:ie,:,js:je,3)=spval
          T2(is:ie,:,js:je)=spval
         end where

         do k=1,km
          start=(/is,js,k,1/); count=(/ie-is+1,je-js+1,1,1/)
          var(is:ie,js:je)=bmean(is:ie,k,js:je)
          iret= nf_put_vara_real(ncid,bmid,start,count,var )
          if (iret.ne.0) print*,nf_strerror(iret)
          var(is:ie,js:je)=mean_eddy_flux(is:ie,k,js:je,1)
          iret= nf_put_vara_real(ncid,ubid,start,count,var )
          var(is:ie,js:je)=mean_eddy_flux(is:ie,k,js:je,2)
          iret= nf_put_vara_real(ncid,vbid,start,count,var )
          var(is:ie,js:je)=mean_eddy_flux(is:ie,k,js:je,3)
          iret= nf_put_vara_real(ncid,wbid,start,count,var )
          var(is:ie,js:je)=T2(is:ie,k,js:je)
          iret= nf_put_vara_real(ncid,t2id,start,count,var )
         enddo
         call ncclos (ncid, iret)
        endif
        call barrier
       enddo



       write(fname,'("variances_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            sub_domain,year,month,day
       do i=1,len_trim(fname);if (fname(i:i)==' ')fname(i:i)='0';enddo

       if (my_pe == 0) then
        print*,' Writing variances to  NetCDF output file ',
     &         fname(1:len_trim(fname))
        ncid = nccre (fname, NCCLOB, iret)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        call store_info_cdf(ncid)
c       dimensions
        lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
        Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
        Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
        Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
        depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
        depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
        iTimedim  = ncddef(ncid, 'Time', 1, iret)
c       grid variables
        dims(1)  = Lon_tdim
        Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
        dims(1)  = Lon_udim
        Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
        dims(1)  = Lat_tdim
        Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
        dims(1)  = Lat_udim
        Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
        dims(1)  = iTimedim
        iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
        dims(1)  = depth_wdim
        depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
        dims(1)  = depth_tdim
        depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c       attributes of the grid
        name = 'Longitude on T grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Longitude on U grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on T grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on U grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Depth of T Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
        call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
        name = 'Depth of W Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
        call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
        name = 'Time                    '; unit = 'days            '
        call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
        call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c       variables
        dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
        bbid  = ncvdef (ncid,'bb'   , NCFLOAT,4,dims,iret)
        dims=(/lon_udim,lat_tdim,depth_tdim,itimedim/)
        ubbid  = ncvdef (ncid,'ubb'   , NCFLOAT,4,dims,iret)
        dims=(/lon_tdim,lat_udim,depth_tdim,itimedim/)
        vbbid  = ncvdef (ncid,'vbb'   , NCFLOAT,4,dims,iret)
        dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
        wbbid  = ncvdef (ncid,'wbb'   , NCFLOAT,4,dims,iret)

c       attributes of variables
        name = 'Zonal variance buoyancy flux'; unit = 'm^3/s^5'
        call dvcdf(ncid,ubbid,name,24,unit,16,spval)
        name = 'Meridional variance buoyancy flux'; unit = 'm^3/s^5'
        call dvcdf(ncid,vbbid,name,24,unit,16,spval)
        name = 'Vertical variance buoyancy flux'; unit = 'm^3/s^5'
        call dvcdf(ncid,wbbid,name,24,unit,16,spval)
        name = 'Buoyancy variance'; unit = 'm^2/s^4'
        call dvcdf(ncid,bbid,name,24,unit,16,spval)

c       global attrubutes
        iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        call ncendf(ncid, iret)

c       write grid
        allocate( v2(max(imt,jmt,km)) )
        v2(1:imt)=xt
        call ncvpt(ncid, Lon_tid, 1, imt,v2, iret)
        v2(1:imt)=xu
        call ncvpt(ncid, Lon_uid, 1, imt,v2, iret)
        v2(1:jmt)=yt
        call ncvpt(ncid, Lat_tid, 1, jmt,v2, iret)
        v2(1:jmt)=yu
        call ncvpt(ncid, Lat_uid, 1, jmt,v2, iret)
        v2(1:km)=zt/100.
        call ncvpt(ncid, depth_tid, 1, km,v2, iret)
        v2(1:km)=zw/100.
        call ncvpt(ncid, depth_wid, 1, km,v2, iret)
        call read_stamp(current_stamp,tt ); v2(1)=tt
        call ncvpt(ncid, itimeid, 1, 1,v2, iret)
        deallocate(v2)
        call ncclos (ncid, iret)
       endif

c      loop over PEs
       do npe=0,n_pes
        call barrier
        if (my_pe==npe) then
         iret=nf_open(fname,NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         iret=nf_inq_varid(ncid,'ubb',ubbid)
         iret=nf_inq_varid(ncid,'vbb',vbbid)
         iret=nf_inq_varid(ncid,'wbb',wbbid)
         iret=nf_inq_varid(ncid,'bb', bbid)

         where( tmask(is:ie,1:km,js:je) == 0. ) 
          var_tracer(is:ie,:,js:je) = spval
         end where
         where( umask(is:ie,1:km,js:je) == 0. ) 
          mean_var_flux(is:ie,:,js:je,1)=spval
          mean_var_flux(is:ie,:,js:je,2)=spval
          mean_var_flux(is:ie,:,js:je,3)=spval
         end where

         do k=1,km
          start=(/is,js,k,1/); count=(/ie-is+1,je-js+1,1,1/)
          var(is:ie,js:je)=var_tracer(is:ie,k,js:je)
          iret= nf_put_vara_real (ncid,bbid,start,count,var )
          var(is:ie,js:je)=mean_var_flux(is:ie,k,js:je,1)
          iret= nf_put_vara_real (ncid,ubbid,start,count,var )
          var(is:ie,js:je)=mean_var_flux(is:ie,k,js:je,2)
          iret= nf_put_vara_real (ncid,vbbid,start,count,var )
          var(is:ie,js:je)=mean_var_flux(is:ie,k,js:je,3)
          iret= nf_put_vara_real (ncid,wbbid,start,count,var )
         enddo
         call ncclos (ncid, iret)
        endif
        call barrier
       enddo

       if (my_pe==0) print*,'done'
#else
       if (my_pe==0) then
         print*,' ERROR : writing variances without netcdf'
         print*,'   is not yet implemented'
       endif
       call halt_stop(' in write_variances')
#endif
       end subroutine write_variances

c
c   program to convert an pflame restart file
c   to an spflame restart file
c


      program cv_rest
      implicit none
      integer :: io,nt=2,itt,ierr, io2,j,k,i
      integer (kind=8) :: itt2,ii,jj
      character (len=32) :: stamp
      character (len=40) :: tr_name

      integer :: imt,jmt,km ,n
      real, allocatable  :: dat4(:,:)
      real (kind=8) , allocatable :: dat8(:,:)
      real, allocatable  :: tr4(:,:,:)
      real (kind=8) , allocatable  :: tr8(:,:,:)

      print*,' Converting pflame to spflame'

      call get_commandline_arg_int(1,imt,ierr)
      if (ierr/=0) goto 99
      call get_commandline_arg_int(2,jmt,ierr)
      if (ierr/=0) goto 99
      call get_commandline_arg_int(3,km,ierr)
      if (ierr/=0) goto 99

      allocate(dat4(imt,jmt), tr4(imt,jmt,nt+2))
      allocate(dat8(imt,jmt), tr8(imt,km,nt+2))

      call get_free_iounit(io)
      open(io,file='restart_pflame.dta',form='unformatted',status='old')

      read(io) stamp
      read(io) itt2
      itt=itt2

      print*,' time stamp = ',stamp
      print*,' itt        = ',itt
      print*,' nt         = ',nt 

      call get_free_iounit(io2)
      open(io2,file='new_restart.dta',form='unformatted',status='new')

      write(io2) itt,stamp,nt
c
c     barotropic mode
c
      dat4=0.0  ! write guess fields
      write(io2)dat4
      write(io2)dat4
      read(io)   ! streamfct at tau
      read(io)  ii,jj,dat8; dat4=dat8
      print*, 'psi(,,2) min,max [Sv]:',
     &                  minval(dat4)/1.e12,maxval(dat4)/1.e12
      write(io2)dat4  ! psi(:,:,1)
      write(io2)dat4 ! psi(:,:,2)

      read(io)   ! streamfct at tau+1
      read(io)  

      read(io)   ! guess value 1 
      read(io)  
      read(io)   ! guess value 2
      read(io)  
      read(io)   ! kmt mask
      read(io)  

      tr4=0.0;tr8=0.0
      do k=1,km

       rewind(io)
       do n=1,12; read(io); enddo

       do j=1,jmt
        print*,' reading pflame data  ... k,j=',k,j
        read(io) 
        read(io) ii,tr8
        do i=1,imt
         do n=1,nt+2
           tr4(i,j,n)=tr8(i,k,n)
         enddo
        enddo
       enddo
       print*,' done reading pflame data'

       print*,' writing spflame data'
       do n=1,nt
        write(io2) ((tr4(i,j,n),i=1,imt),j=1,jmt)
        write(io2) ((tr4(i,j,n),i=1,imt),j=1,jmt)
       enddo
       do n=1,2
        write(io2) ((tr4(i,j,nt+n),i=1,imt),j=1,jmt)
        write(io2) ((tr4(i,j,nt+n),i=1,imt),j=1,jmt)
       enddo
       print*,' done writing spflame data'
      enddo

      do j=1,jmt ! read t,u at tau+1
        read(io)
        read(io)
      enddo

      ! read dml from ktmix 
      read(io)
      read(io) ii,jj,dat8; dat4=dat8
      write(io2) dat4

      ! tkemix ? no

      close(io)
      close(io2)

      stop
 99   print*,' program needs command line parameter:'
      print*,'<executable> imt jmt km nt'

      end program cv_rest



      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"

#define use_fast_drtsafe_routine

#ifdef drive_test_co2
c return as well equilibrium DIC
c#define calculate_C_eq
c return also H+ concentration
c#define calc_htotal_also
#endif

      module pco2_module
c-----------------------------------------------------------------------
c   Module for surface pCO2 calculation (see below)
c-----------------------------------------------------------------------
      implicit none
      integer, parameter :: imax = 2000 ! max. vector length
      real, dimension(imax) :: k0,k1,k2,kw,kb,ks,kf,k1p,k2p,k3p,ksi,ff  ! Mehrbach constants
      real, dimension(imax) :: bt,st,ft   ! borate sulfate and fluor ??
      real, dimension(imax) :: pt,dic,ta  ! phosphate, DIC and alkalinity
      real, parameter :: rho0 = 1024.0    ! unit conversion factor
      real, parameter :: rrho02 = 1.0/rho0**2
      real, parameter :: sit=0.0077/rho0   ! silicate in mol/m**3, taken as constant
      real, parameter :: permeg=1.e-6, permil = 1.0/rho0 ! unit conversion
c      real, parameter :: atmpres = 1.0  ! atmospheric pressure in atm = 1013.25 mbar
      integer :: i
#ifdef  calculate_C_eq
      real, dimension(imax) :: co2star_eq
#endif
      end module pco2_module


      subroutine co2calc(t,s_in,dic_in,nit,slp,imt,
     &                   pco2_air,dco2,pco2_water
#ifdef  calculate_C_eq
     &                      , dic_eq
#endif
#ifdef calc_htotal_also
     &                      , htotal_out
#endif
     &)
c-------------------------------------------------------------------------
c   Calculate pco2* from total alkalinity and total CO2 at
c   temperature (t), salinity (s) and "atmpres" atmosphere total pressure. 
c--------------------------------------------------------------------------
       use timing_module
       use pco2_module
       implicit none
c      INPUT
       integer :: imt         ! vector length
       real   :: t(imt)        ! temperature deg C
       real   :: s_in(imt)     ! salinity in (PSU-35)/1000
       real   :: dic_in(imt)   ! diss. inorg. carbon  in mmol/m^3
       real   :: nit(imt)      ! nitrate in mmol/m^3
       real   :: slp(imt)      ! Sea level pressure in mbar
       real   :: pco2_air      ! atmospheric mole fraction CO2 in dry air (ppmv) 
c      OUTPUT
       real   :: dco2(imt)     ! difference in CO2 at sea surface and saturation CO2 in mol/m^3
       real   :: pco2_water(imt) ! partial pressure of CO2 at sea surface  (ppmv)
#ifdef  calculate_C_eq
       real   :: dic_eq(imt)   ! DIC in equilibrium mol/m^3
#endif
#ifdef calc_htotal_also
       real   :: htotal_out(imt)   ! H+ concentration
#endif

c      local work variables
       real :: tk,tk100,tk1002,invtk,dlogtk
       real :: is,is2,sqrtis,s2,sqrts,s15,scl
       real :: htotal(imt),s(imt),htotal2,co2star,pco2

c      stuff for the iteration
       real, external :: dic_iter
#ifdef  calculate_C_eq
       real, external :: dic_iter_C_eq
#endif

#ifdef use_fast_drtsafe_routine
       real :: drtsafe, uuu, x1, x2, fl, fh, df, swap, dx ,dxold, xl, xh
       real :: f, xacc, temp
       integer :: maxit, j
#else
       real, external :: drtsafe
#endif
       real :: lower_bound = 1.0e-6
       real :: upper_bound = 1.0e-9
       real :: accuracy = 1.e-10
       real :: atmpres

c       ---------------------------------------------------------------------

c        call tic('co2_flux')
        if (imt > imax) then
          print*,' imt larger than imax = ',imax
          print*,' increase imax in pco2_module'
          call halt_stop('in co2calc')
        endif

        do i=1,imt
         s(i) = s_in(i)*1000.0+35.0
         is2=s(i)*s(i)
         dic(i) = dic_in(i)          *rrho02
c         ta(i)  = (2310.0*s(i)/35.0) *rrho02  ! old OMIP fit
         ta(i) = ( -0.5487*is2*s(i) + 59.919*is2   ! new fit from K. Friis for North Atl.
     &            - 2122.3*S(i) + 26722 )*rrho02
        
	 pt(i)  = nit(i)/16.0        *rrho02
        enddo

C     Calculate all constants needed to convert between various measured
C     carbon species. References for each equation are noted in the code. 
C     Once calculated, the constants are
C     stored and passed in the common block "const". The original version of this
C     code was based on the code by Dickson in Version 2 of "Handbook of Methods
C     for the Analysis of the Various Parameters of the Carbon Dioxide System
C     in Seawater", DOE, 1994 (SOP No. 3, p25-26). 

        do i=1,imt
         tk = 273.15 + t(i)
         tk100 = tk/100.0
         tk1002=tk100*tk100
         invtk=1.0/tk
         dlogtk=log(tk)
         is=19.924*s(i)/(1000.-1.005*s(i))
         is2=is*is
         sqrtis=sqrt(is)
         s2=s(i)*s(i)
         sqrts=sqrt(s(i))
         s15=s(i)**1.5
         scl=s(i)/1.80655
C        f = k0(1-pH2O)*correction term for non-ideality
C        Weiss & Price (1980, Mar. Chem., 8, 347-359; Eq 13 with table 6 values)
         ff(i) = exp(-162.8301 + 218.2968/tk100  +
     &		90.9241*log(tk100) - 1.47696*tk1002 +
     &		s(i)*(.025695 - .025225*tk100 + 
     &		0.0049867*tk1002))
C        K0 from Weiss 1974
         k0(i) = exp(93.4517/tk100 - 60.2409 + 23.3585 * log(tk100) +
     &		s(i)*(.023517 - 0.023656 * tk100 + 0.0047036 * tk1002))
C        k1 = [H][HCO3]/[H2CO3]
C        k2 = [H][CO3]/[HCO3]
C        Millero p.664 (1995) using Mehrbach et al. data on seawater scale 
         k1(i)=10**(-1*(3670.7*invtk - 62.008 + 9.7944*dlogtk -
     &		0.0118 * s(i) + 0.000116*s2))
         k2(i)=10**(-1*(1394.7*invtk + 4.777 - 
     &		0.0184*s(i) + 0.000118*s2))
C        kb = [H][BO2]/[HBO2]
C        Millero p.669 (1995) using data from Dickson (1990)
         kb(i)=exp((-8966.90 - 2890.53*sqrts - 77.942*s(i) +
     &		1.728*s15 - 0.0996*s2)*invtk +
     &		(148.0248 + 137.1942*sqrts + 1.62142*s(i)) +
     &		(-24.4344 - 25.085*sqrts - 0.2474*s(i)) *
     &		dlogtk + 0.053105*sqrts*tk)
C        k1p = [H][H2PO4]/[H3PO4]
C        DOE(1994) eq 7.2.20 with footnote using data from Millero (1974)
         k1p(i) = exp(-4576.752*invtk + 115.525 - 18.453 * dlogtk +
     &		(-106.736*invtk + 0.69171) * sqrts +
     &		(-0.65643*invtk - 0.01844) * s(i))
C        k2p = [H][HPO4]/[H2PO4]
C        DOE(1994) eq 7.2.23 with footnote using data from Millero (1974))
         k2p(i) = exp(-8814.715*invtk + 172.0883 - 27.927 * dlogtk +
     &		(-160.340*invtk + 1.3566) * sqrts +
     &		(0.37335*invtk - 0.05778) * s(i) )
C        k3p = [H][PO4]/[HPO4]
C        DOE(1994) eq 7.2.26 with footnote using data from Millero (1974)
         k3p(i) = exp(-3070.75*invtk - 18.141 + 
     &		(17.27039*invtk + 2.81197) *
     &		sqrts + (-44.99486*invtk - 0.09984) * s(i))
C        ksi = [H][SiO(OH)3]/[Si(OH)4]
C        Millero p.671 (1995) using data from Yao and Millero (1995)
         ksi(i) = exp(-8904.2*invtk + 117.385 - 19.334 * dlogtk +
     &		(-458.79*invtk + 3.5913) * sqrtis +
     &		(188.74*invtk - 1.5998) * is +
     &		(-12.1652*invtk + 0.07871) * is2 +
     &		log(1.0-0.001005*s(i)))
C        kw = [H][OH]
C        Millero p.670 (1995) using composite data
         kw(i) = exp(-13847.26*invtk + 148.9652 - 23.6521 * dlogtk +
     &		(118.67*invtk - 5.977 + 1.0495 * dlogtk) *
     &		sqrts - 0.01615 * s(i))
C        ks = [H][SO4]/[HSO4]
C        Dickson (1990, J. chem. Thermodynamics 22, 113)
         ks(i)=exp(-4276.1*invtk + 141.328 - 23.093*dlogtk +
     &		(-13856*invtk + 324.57 - 47.986*dlogtk) * sqrtis +
     &		(35474*invtk - 771.54 + 114.723*dlogtk) * is -
     &		2698*invtk*is**1.5 + 1776*invtk*is2 +
     &		log(1.0 - 0.001005*s(i)))
C        kf = [H][F]/[HF]
C        Dickson and Riley (1979) -- change pH scale to total
         kf(i)=exp(1590.2*invtk - 12.641 + 1.525*sqrtis +
     &		log(1.0 - 0.001005*s(i)) + 
     &		log(1.0 + (0.1400/96.062)*(scl)/ks(i)))
C        Calculate concentrations for borate, sulfate, and fluoride
C        Uppstrom (1974)
	 bt(i) = 0.000232 * scl/10.811
C        Morris & Riley (1966)
	 st(i) = 0.14 * scl/96.062
C        Riley (1965)
	 ft(i) = 0.000067 * scl/18.9984
       enddo

C      Calculate [H+] total when DIC and TA are known at T, S and 1 atm.
C      The solution converges to err of xacc. The solution must be within
C      the range x1 to x2.
C
C      If DIC and TA are known then either a root finding or iterative method
C      must be used to calculate htotal. In this case we use the Newton-Raphson
C      "safe" method taken from "Numerical Recipes" (function "rtsafe.f" with
C      error trapping removed).
C
C      As currently set, this procedure iterates about 12 times. The x1 and x2
C      values set below will accomodate ANY oceanographic values. If an initial
C      guess of the pH is known, then the number of iterations can be reduced to
C      about 5 by narrowing the gap between x1 and x2. It is recommended that
C      the first few time steps be run with x1 and x2 set as below. After that,
C      set x1 and x2 to the previous value of the pH +/- ~0.5. The current
C      setting of xacc will result in co2star accurate to 3 significant figures
C      (xx.y). Making xacc bigger will result in faster convergence also, but this
C      is not recommended (xacc of 10**-9 drops precision to 2 significant figures).
C
C      Parentheses added around negative exponents (Keith Lindsay)
C
c       call toc('co2_flux')

c       call tic('co2_flux_iter')

#ifdef  calculate_C_eq
c    calculate DIC equilibrium concentration
       do i=1,imt
        atmpres=slp(i)/1013.25 ! mbar to atm
        co2star_eq(i)= pco2_air*permeg*ff(i)*atmpres 
       enddo
       do i=1,imt
	htotal(i) = drtsafe(dic_iter_C_eq,lower_bound,upper_bound,accuracy)
       enddo
       do i=1,imt
        dic_eq(i)=co2star_eq(i)*
     &            (1.0+k1(i)/htotal(i)+k1(i)*k2(i)/htotal(i)**2)
     &             /rrho02/1000.0  ! in mol/m^3
       enddo
#endif

#ifdef use_fast_drtsafe_routine
         MAXIT=100
         x1 = lower_bound
         x2 = upper_bound
         xacc = accuracy
       do i=1,imt
c        htotal(i) = drtsafe(dic_iter,lower_bound,upper_bound,accuracy)
c        REAL FUNCTION DRTSAFE(FUNCD,X1,X2,XACC)
C        File taken from Numerical Recipes. Modified  R.M.Key 4/94
         uuu= dic_iter(X1,FL,DF)
         uuu= dic_iter(X2,FH,DF)
         IF(FL .LT. 0.0) THEN
           XL=X1
           XH=X2
         ELSE
           XH=X1
           XL=X2
           SWAP=FL
           FL=FH
           FH=SWAP
         END IF
         DRTSAFE=.5*(X1+X2)
         DXOLD=ABS(X2-X1)
         DX=DXOLD
         uuu= dic_iter(DRTSAFE,F,DF)
         DO 100, J=1,MAXIT
           IF(((DRTSAFE-XH)*DF-F)*((DRTSAFE-XL)*DF-F) .GE. 0.0 .OR.
     &	      ABS(2.0*F) .GT. ABS(DXOLD*DF)) THEN
             DXOLD=DX
             DX=0.5*(XH-XL)
             DRTSAFE=XL+DX
             IF(XL .EQ. DRTSAFE) goto 101
           ELSE
             DXOLD=DX
             DX=F/DF
             TEMP=DRTSAFE
             DRTSAFE=DRTSAFE-DX
             IF(TEMP .EQ. DRTSAFE) goto 101
	   END IF
           IF(ABS(DX) .LT. XACC) goto 101
           uuu= dic_iter(DRTSAFE,F,DF)
           IF(F .LT. 0.0) THEN
             XL=DRTSAFE
             FL=F
           ELSE
             XH=DRTSAFE
             FH=F
           END IF
  100    CONTINUE
  101    continue
c        RETURN
c        END function drtsafe
         htotal(i) = drtsafe
       enddo
#else
       do i=1,imt
	htotal(i) = drtsafe(dic_iter,lower_bound,upper_bound,accuracy)
       enddo
#endif
#ifdef calc_htotal_also
        htotal_out(1:imt)=htotal(1:imt)
#endif
c       call toc('co2_flux_iter')

c       call tic('co2_flux')

       do i=1,imt
C       Calculate [CO2*] as defined in DOE Methods Handbook 1994 Ver.2, 
C       ORNL/CDIAC-74, Dickson and Goyet, eds. (Ch 2 p 10, Eq A.49)
	htotal2=htotal(i)*htotal(i)
	co2star=dic(i)*htotal2/(htotal2 + k1(i)*htotal(i) + k1(i)*k2(i)) ! mol/kg
        atmpres=slp(i)/1013.25 ! mbar to atm
        dco2(i)= ( pco2_air*permeg*ff(i)*atmpres - co2star )/permil   ! mol/m^3
        pco2_water(i) = co2star/ff(i)/permeg/atmpres                  ! ppm or uatm

C         Convert units of output arguments
c             Note: co2star and dco2star are calculated in mol/kg within this routine 
c             Thus Convert now from mol/kg -> mol/m^3
c              co2star  = co2star / permil
c             Note: pCO2surf and dpCO2 are calculated in atm above. 
c             Thus convert now to uatm
c              pCO2(i) = pCO2(i) / permeg
C
      enddo
c      call toc('co2_flux')

      end subroutine co2calc





      subroutine co2calc_fast(t,s_in,dic_in,nit,slp,imt,
     &                   pco2_air,dco2,pco2_water
     &)
c-------------------------------------------------------------------------
c   Calculate pco2* from total alkalinity and total CO2 at
c   temperature (t), salinity (s) and "atmpres" atmosphere total pressure. 
c   using a fit of pH as a function of DIC, SALT and TEMP
c   valid range is 1940<DIC<2200 mmol/m^3
c                  -5<T<25 degC and 31.5<S<37.5 PSU
c   accuracy within this range is as good as for other routine
c--------------------------------------------------------------------------
       use timing_module
       implicit none
c      INPUT
       integer :: imt         ! vector length
       real   :: t(imt)        ! temperature deg C
       real   :: s_in(imt)     ! salinity in (PSU-35)/1000
       real   :: dic_in(imt)   ! diss. inorg. carbon  in mmol/m^3
       real   :: nit(imt)      ! nitrate in mmol/m^3 not used anyway
       real   :: slp(imt)      ! Sea level pressure in mbar
       real   :: pco2_air      ! atmospheric mole fraction CO2 in dry air (ppmv) 
c      OUTPUT
       real   :: dco2(imt)     ! difference in CO2 at sea surface and saturation CO2 in mol/m^3
       real   :: pco2_water(imt) ! partial pressure of CO2 at sea surface  (ppmv)

      real, parameter :: rho0 = 1024.0    ! unit conversion factor
      real, parameter :: rrho02 = 1.0/rho0**2
      real, parameter :: permeg=1.e-6, permil = 1.0/rho0 ! unit conversion
c      local work variables
       real :: tk,tk100,tk1002,invtk,dlogtk,s2
       real :: htotal,s,htotal2,co2star,pco2
       real :: dic,ff,k1,k2,atmpres,pH_fit,xx,yy,zz
       real :: xx2,yy2,zz2
       integer :: i

       do i=1,imt
        s = s_in(i)*1000.0+35.0
        dic = dic_in(i)*rrho02
        tk = 273.15 + t(i)
        tk100 = tk/100.0
        tk1002=tk100*tk100
        invtk=1.0/tk
        dlogtk=log(tk)
        s2=s*s
C        f = k0(1-pH2O)*correction term for non-ideality
C        Weiss & Price (1980, Mar. Chem., 8, 347-359; Eq 13 with table 6 values)
        ff = exp(-162.8301 + 218.2968/tk100  +
     &		90.9241*log(tk100) - 1.47696*tk1002 +
     &		s*(.025695 - .025225*tk100 + 
     &		0.0049867*tk1002))
C        k1 = [H][HCO3]/[H2CO3]
C        k2 = [H][CO3]/[HCO3]
C        Millero p.664 (1995) using Mehrbach et al. data on seawater scale 
        k1=10**(-1*(3670.7*invtk - 62.008 + 9.7944*dlogtk -
     &		0.0118 * s + 0.000116*s2))
        k2=10**(-1*(1394.7*invtk + 4.777 - 
     &		0.0184*s + 0.000118*s2))
c    calculate pH from estimated fit
      xx=dic_in(i)-2000.0; yy=s-35.0; zz=t(i);
      xx2=xx*xx; yy2=yy*yy; zz2=zz*zz;
      pH_fit=8.456655e+00+(-1.688880e-03)*xx 
     & +(7.390822e-02)*yy+(-1.739867e-02)*zz 
     & +(-1.864020e-06)*xx2+(-2.034953e-03)*yy2 
     & +(6.480540e-05)*zz2 
     & +(8.483447e-07)*xx*zz+(1.945036e-04)*xx*yy 
     & +(-4.480909e-05)*yy*zz 
     & +(-2.946383e-09)*xx**3+(-1.420486e-03)*yy**3 
     & +(-4.430561e-07)*zz**3 
     & +(-1.515261e-05)*xx*yy2+(5.880059e-07)*yy*xx2  
     & +(4.673103e-08)*xx*zz2+(1.772955e-08)*zz*xx2 
     & +(-1.897002e-06)*yy*zz2+(2.194509e-05)*zz*yy2 
     & +(-1.493190e-06)*xx*yy*zz   
	htotal = 10**(-pH_fit)
C       Calculate [CO2*] as defined in DOE Methods Handbook 1994 Ver.2, 
C       ORNL/CDIAC-74, Dickson and Goyet, eds. (Ch 2 p 10, Eq A.49)
	htotal2=htotal*htotal
	co2star=dic*htotal2/(htotal2 + k1*htotal + k1*k2) ! mol/kg
        atmpres=slp(i)/1013.25 ! mbar to atm
        dco2(i)= ( pco2_air*permeg*ff*atmpres - co2star )/permil   ! mol/m^3
        pco2_water(i) = co2star/ff/permeg/atmpres                  ! ppm or uatm
      enddo
      end subroutine co2calc_fast



      real function dic_iter(x,fn,df)
c-------------------------------------------------------------------------
c   This routine expresses TA as a function of DIC, htotal and constants.
c   It also calculates the derivative of this function with respect to 
c   htotal. It is used in the iterative solution for htotal. In the call
c   "x" is the input value for htotal, "fn" is the calculated value for TA
c   and "df" is the value for dTA/dhtotal
c-------------------------------------------------------------------------
       use pco2_module
       implicit none
       real :: x
       real :: fn,df
       real :: k12,k12p,k123p,x2,x3,a,c,a2,da,b,b2,db

	x2=x*x
	x3=x2*x
	k12 = k1(i)*k2(i)
	k12p = k1p(i)*k2p(i)
	k123p = k12p*k3p(i)
	c = 1.0 + st(i)/ks(i)
	a = x3 + k1p(i)*x2 + k12p*x + k123p
	a2=a*a
	da = 3.0*x2 + 2.0*k1p(i)*x + k12p
	b = x2 + k1(i)*x + k12
	b2=b*b
	db = 2.0*x + k1(i)
C
C	fn = hco3+co3+borate+oh+hpo4+2*po4+silicate+hfree+hso4+hf+h3po4-ta
C
	fn = k1(i)*x*dic(i)/b +
     &	     2.0*dic(i)*k12/b +
     &	     bt(i)/(1.0 + x/kb(i)) +
     &	     kw(i)/x +
     &	     pt(i)*k12p*x/a +
     &	     2.0*pt(i)*k123p/a +
     &	     sit/(1.0 + x/ksi(i)) -
     &	     x/c -
     &	     st(i)/(1.0 + ks(i)/x/c) -
     &	     ft(i)/(1.0 + kf(i)/x) -
     &	     pt(i)*x3/a -
     &	     ta(i)
C
C	df = dfn/dx
C
	df = ((k1(i)*dic(i)*b) - k1(i)*x*dic(i)*db)/b2 -
     &	     2.0*dic(i)*k12*db/b2 -
     &	     bt(i)/kb(i)/(1.0+x/kb(i))**2 -
     &	     kw(i)/x2 +
     &	     (pt(i)*k12p*(a - x*da))/a2 
     &	     - 2.0*pt(i)*k123p*da/a2 
     &	     - sit/ksi(i)/(1.0+x/ksi(i))**2 - 1.0/c 
     &	     + st(i)*(1.0 + ks(i)/x/c)**(-2)*(ks(i)/c/x2) 
     &	     + ft(i)*(1.0 + kf(i)/x)**(-2)*kf(i)/x2 
     &	     - pt(i)*x2*(3.0*a-x*da)/a2

      dic_iter = 0.0

      end function dic_iter


#ifdef  calculate_C_eq

      real function dic_iter_C_eq(x,fn,df)
c-------------------------------------------------------------------------
c   This routine expresses TA as a function of CO2star, htotal and constants.
c   It also calculates the derivative of this function with respect to 
c   htotal. It is used in the iterative solution for htotal. In the call
c   "x" is the input value for htotal, "fn" is the calculated value for TA
c   and "df" is the value for dTA/dhtotal
c-------------------------------------------------------------------------
       use pco2_module
       implicit none
       real :: x
       real :: fn,df
       real :: k12,k12p,k123p,x2,x3,a,c,a2,da,b,b2,db

	x2=x*x
	x3=x2*x
	k12 = k1(i)*k2(i)
	k12p = k1p(i)*k2p(i)
	k123p = k12p*k3p(i)
	c = 1.0 + st(i)/ks(i)
	a = x3 + k1p(i)*x2 + k12p*x + k123p
	a2=a*a
	da = 3.0*x2 + 2.0*k1p(i)*x + k12p
	b = x2 + k1(i)*x + k12
	b2=b*b
	db = 2.0*x + k1(i)
C
C	fn = hco3+co3+borate+oh+hpo4+2*po4+silicate+hfree+hso4+hf+h3po4-ta
C
	fn = 
     &       k1(i)/x*co2star_eq(i) +
     &       2*k12/x2*co2star_eq(i) +
     &	     bt(i)/(1.0 + x/kb(i)) +
     &	     kw(i)/x +
     &	     pt(i)*k12p*x/a +
     &	     2.0*pt(i)*k123p/a +
     &	     sit/(1.0 + x/ksi(i)) -
     &	     x/c -
     &	     st(i)/(1.0 + ks(i)/x/c) -
     &	     ft(i)/(1.0 + kf(i)/x) -
     &	     pt(i)*x3/a -
     &	     ta(i)
C
C	df = dfn/dx
C
	df = 
     &       -k1(i)/x2*co2star_eq(i) 
     &       -4*k12/x3*co2star_eq(i) +
     &	     bt(i)/kb(i)/(1.0+x/kb(i))**2 -
     &	     kw(i)/x2 +
     &	     (pt(i)*k12p*(a - x*da))/a2 
     &	     - 2.0*pt(i)*k123p*da/a2 
     &	     - sit/ksi(i)/(1.0+x/ksi(i))**2 - 1.0/c 
     &	     + st(i)*(1.0 + ks(i)/x/c)**(-2)*(ks(i)/c/x2) 
     &	     + ft(i)*(1.0 + kf(i)/x)**(-2)*kf(i)/x2 
     &	     - pt(i)*x2*(3.0*a-x*da)/a2

      dic_iter_C_eq = 0.0

      end function dic_iter_C_eq

#endif


      REAL FUNCTION DRTSAFE(FUNCD,X1,X2,XACC)
C     File taken from Numerical Recipes. Modified  R.M.Key 4/94
      MAXIT=100
      uuu= FUNCD(X1,FL,DF)
      uuu= FUNCD(X2,FH,DF)
      IF(FL .LT. 0.0) THEN
        XL=X1
        XH=X2
      ELSE
        XH=X1
        XL=X2
        SWAP=FL
        FL=FH
        FH=SWAP
      END IF
      DRTSAFE=.5*(X1+X2)
      DXOLD=ABS(X2-X1)
      DX=DXOLD
      uuu= FUNCD(DRTSAFE,F,DF)
      DO 100, J=1,MAXIT
        IF(((DRTSAFE-XH)*DF-F)*((DRTSAFE-XL)*DF-F) .GE. 0.0 .OR.
     &	      ABS(2.0*F) .GT. ABS(DXOLD*DF)) THEN
          DXOLD=DX
          DX=0.5*(XH-XL)
          DRTSAFE=XL+DX
          IF(XL .EQ. DRTSAFE)RETURN
        ELSE
          DXOLD=DX
          DX=F/DF
          TEMP=DRTSAFE
          DRTSAFE=DRTSAFE-DX
          IF(TEMP .EQ. DRTSAFE)RETURN
	END IF
        IF(ABS(DX) .LT. XACC)RETURN
        uuu= FUNCD(DRTSAFE,F,DF)
        IF(F .LT. 0.0) THEN
          XL=DRTSAFE
          FL=F
        ELSE
          XH=DRTSAFE
          FH=F
        END IF
  100  CONTINUE
      RETURN
      END function drtsafe




#ifdef drive_test_co2

      program test
       use timing_module
      implicit none
      real, allocatable :: t(:),s(:),dic(:),pco2_air(:),nit(:)
      integer :: imt = 1,n1,n2,n3,n4,i,i1,i2,i3,i4,ii,n5,i5

      real :: trange(3) = (/-5.,25.,1.0/)
      real :: srange(3) = (/32.,38.,1.0/) ! start, end and spacing in TS space
      real :: nitrange(3) = (/980.,1030.,10.0/) ! start, end and spacing in TS space
      real :: dicrange(3) = (/1950.,2200.0,25.0/) 
      real :: pco2range(3) = (/278.0,388.0,10.0/) 
      real  :: pco2_water,dco2,dic_eq,htotal

      character(len=80) :: name,unit

#include "netcdf.inc"
      integer :: ncid,iret,tdim,sdim,tid,sid,pco2id,dicid
      integer :: dicdim,dco2id,pco2dim,pco2_waterid
      integer :: dic_eqid,htotid,pco2_water2id,dco22id

      n1=(trange(2)-trange(1))/trange(3)
      n2=(srange(2)-srange(1))/srange(3)
      n3=(dicrange(2)-dicrange(1))/dicrange(3)
      n4=(pco2range(2)-pco2range(1))/pco2range(3)
      n5=(nitrange(2)-nitrange(1))/nitrange(3)
      print*,' n1=',n1,' n2=',n2,' n3=',n3,' n4=',n4,' n5=',n5
      allocate( t(n1), s(n2), dic(n3), pco2_air(n4),nit(n5) )

      t(1)=trange(1)
      do i=2,n1; t(i)=t(i-1)+trange(3); enddo
      s(1)=srange(1)
      do i=2,n2; s(i)=s(i-1)+srange(3); enddo
      dic(1)=dicrange(1)
      do i=2,n3; dic(i)=dic(i-1)+dicrange(3); enddo
      pco2_air(1)=pco2range(1)
      do i=2,n4; pco2_air(i)=pco2_air(i-1)+pco2range(3); enddo
      nit(1)=nitrange(1)
      do i=2,n5; nit(i)=nit(i-1)+nitrange(3); enddo

      ncid   = nccre ('co2_test.cdf', NCCLOB, iret)
      iret   = nf_set_fill(ncid, NF_NOFILL, iret)
      tdim   = ncddef(ncid, 'x', n1, iret)
      sdim   = ncddef(ncid, 'y', n2, iret)
      dicdim = ncddef(ncid, 'dic', n3, iret)

      tid  = ncvdef (ncid,'x',NCFLOAT,1,tdim,iret)
      name = 'Potential temparature'
      call ncaptc(ncid,tid,'long_name',NCCHAR,len_trim(name),name,iret) 
      name = 'deg C'
      call ncaptc(ncid,tid,'units',NCCHAR,len_trim(name),name,iret) 

      sid  = ncvdef (ncid,'y',NCFLOAT,1,sdim,iret)
      name = 'Salinity'
      call ncaptc(ncid,sid,'long_name',NCCHAR,len_trim(name),name,iret) 
      name = 'psu'
      call ncaptc(ncid,sid,'units',NCCHAR,len_trim(name),name,iret) 

      dicid  = ncvdef (ncid,'dic',NCFLOAT,1,dicdim,iret)
      name = 'Dissolved inorganic carbon'
      call ncaptc(ncid,dicid,'long_name',
     &            NCCHAR,len_trim(name),name,iret) 
      name = 'mmol/m**3'
      call ncaptc(ncid,dicid,'units',NCCHAR,len_trim(name),name,iret) 

      pco2dim = ncddef(ncid, 'pco2', n4, iret)
c      pco2dim = ncddef(ncid, 'nit', n5, iret)
      pco2id  = ncvdef (ncid,'pco2',NCFLOAT,1,pco2dim,iret)
c      pco2id  = ncvdef (ncid,'nit',NCFLOAT,1,pco2dim,iret)
      name = 'CO2 partial pressure'
c      name = 'SLP'
      call ncaptc(ncid,pco2id,'long_name',
     &            NCCHAR,len_trim(name),name,iret) 
      name = 'ppmv'
c      name = 'mbar'
      call ncaptc(ncid,pco2id,'units',NCCHAR,len_trim(name),name,iret) 

      pco2_waterid  = ncvdef (ncid,'pCO2_water_fit',NCFLOAT,4,
     &                   (/tdim,sdim,dicdim,pco2dim/),iret)
      name = 'Oceanic pCO2 at sea surface'
      call ncaptc(ncid,pco2_waterid,'long_name',NCCHAR,
     &            len_trim(name),name,iret) 
      name = 'ppmv'
      call ncaptc(ncid,pco2_waterid,'units',
     &  NCCHAR,len_trim(name),name,iret) 


      pco2_water2id  = ncvdef (ncid,'pCO2_water',NCFLOAT,4,
     &                   (/tdim,sdim,dicdim,pco2dim/),iret)
      name = 'Oceanic pCO2 at sea surface from fit'
      call ncaptc(ncid,pco2_water2id,'long_name',NCCHAR,
     &            len_trim(name),name,iret) 
      name = 'ppmv'
      call ncaptc(ncid,pco2_water2id,'units',
     &  NCCHAR,len_trim(name),name,iret) 


      dco2id  = ncvdef (ncid,'dCO2',NCFLOAT,4,
     &                   (/tdim,sdim,dicdim,pco2dim/),iret)
      name = 'Air-sea diff of CO2 concentration'
      call ncaptc(ncid,dco2id,'long_name',NCCHAR,
     &            len_trim(name),name,iret) 
      name = 'mol/m^3'
      call ncaptc(ncid,dco2id,'units',NCCHAR,len_trim(name),name,iret) 

      dco22id  = ncvdef (ncid,'dCO2_fit',NCFLOAT,4,
     &                   (/tdim,sdim,dicdim,pco2dim/),iret)
      name = 'Air-sea diff of CO2 concentration from fit'
      call ncaptc(ncid,dco22id,'long_name',NCCHAR,
     &            len_trim(name),name,iret) 
      name = 'mol/m^3'
      call ncaptc(ncid,dco22id,'units',NCCHAR,len_trim(name),name,iret) 


#ifdef  calculate_C_eq
      dic_eqid  = ncvdef (ncid,'DIC_eq',NCFLOAT,4,
     &                   (/tdim,sdim,dicdim,pco2dim/),iret)
      name = 'DIC equilibrium concentration'
      call ncaptc(ncid,dic_eqid,'long_name',NCCHAR,
     &            len_trim(name),name,iret) 
      name = 'mol/m^3'
      call ncaptc(ncid,dic_eqid,'units',NCCHAR,len_trim(name),name,iret) 
#endif
#ifdef calc_htotal_also
      htotid  = ncvdef (ncid,'htotal',NCFLOAT,4,
     &                   (/tdim,sdim,dicdim,pco2dim/),iret)
      name = 'H+ concentration'
      call ncaptc(ncid,htotid,'long_name',NCCHAR,
     &            len_trim(name),name,iret) 
      name = 'mol/m^3'
      call ncaptc(ncid,htotid,'units',NCCHAR,len_trim(name),name,iret) 
#endif

      call ncendf(ncid, iret)

      call ncvpt(ncid, tid, 1, n1,t,iret)
      call ncvpt(ncid, sid, 1, n2,s,iret)
      call ncvpt(ncid, dicid, 1, n3,dic,iret)
      call ncvpt(ncid, pco2id, 1, n4,pco2_air,iret)
c      call ncvpt(ncid, pco2id, 1, n5,nit,iret)


      do i1=1,n1
      do i2=1,n2
      do i3=1,n3
      do i4=1,n4
c      do i4=1,n5
       call tic('old')
        CALL co2calc
     &  (t(i1),(s(i2)-35)/1000.0,dic(i3),2.0,1013.25,1,
     &                 pco2_air(i4),dco2,pco2_water
c     &  (t(i1),(s(i2)-35)/1000.0,dic(i3),2.0,nit(i4),1,
c     &                 pco2_air(1),dco2,pco2_water
#ifdef  calculate_C_eq
     &              , dic_eq
#endif
#ifdef calc_htotal_also
     &              , htotal
#endif
     &)
       call toc('old')


        call ncvpt(ncid, pco2_waterid, (/i1,i2,i3,i4/), (/1,1,1,1/),
     &              pCO2_water,iret)
        call ncvpt(ncid, dco2id, (/i1,i2,i3,i4/), (/1,1,1,1/),dCO2,iret)
#ifdef  calculate_C_eq
        call ncvpt(ncid,dic_eqid, (/i1,i2,i3,i4/), 
     &                         (/1,1,1,1/),dic_eq,iret)
#endif
#ifdef calc_htotal_also
        call ncvpt(ncid,htotid, (/i1,i2,i3,i4/), 
     &                         (/1,1,1,1/),htotal,iret)
#endif


       call tic('new')
        CALL co2calc_fast
     &  (t(i1),(s(i2)-35)/1000.0,dic(i3),2.0,1013.25,1,
     &                 pco2_air(i4),dco2,pco2_water
c     &  (t(i1),(s(i2)-35)/1000.0,dic(i3),2.0,nit(i4),1,
c     &                 pco2_air(1),dco2,pco2_water
#ifdef  calculate_C_eq
     &              , dic_eq
#endif
#ifdef calc_htotal_also
     &              , htotal
#endif
     &)
       call toc('new')

        call ncvpt(ncid, pco2_water2id, (/i1,i2,i3,i4/), (/1,1,1,1/),
     &              pCO2_water,iret)
        call ncvpt(ncid, dco22id,(/i1,i2,i3,i4/),(/1,1,1,1/),dCO2,iret)

      enddo
      enddo
      enddo
      enddo

      call ncclos (ncid, iret)


      print*,' old time summary    = ',
     &   timing_secs('old') ,' s'
      print*,' new time summary    = ',
     &   timing_secs('new') ,' s'

#ifdef notdef
      t        = 10.0
      s        = (35.0-35.0)/1000.0
      Nit      = 5.0
      dic      = 1980.0
      pco2_air = 270.0

      print*,' Input : '
      print*,' Temperature = ',t,' deg C'
      print*,' Salinity    = ',s*1000.0+35,' psu'
      print*,' DIC         = ',dic,' mmol/m^3'
      print*,' Nitrate     = ',nit,' mmol/m^3'
      print*,' Pco2 air    = ',pco2_air,' ppmv'
      CALL co2calc(t,s,dic,nit,1013.25,1,pco2_air,dco2,pco2_water)
      print*,' Output : '
      print*,' Pco2 water  = ',pco2_water,' ppmv'
      print*,' Air-sea diff. of CO2 conc. = ',dco2,' mol/m^3'
#endif 

      end program test


      subroutine halt_stop(string)
      character*(*) :: string
      print*,string
      stop
      end 
      subroutine barrier()
      end 


#endif

#include "options.inc"


c
c  local CPP defines for writing NetCDF snapshots
c
c  write UV 
#define write_UV
c  wrtie T and S
#define write_TS
c  write SSH
c#define write_eta
c#define write_ubar

c  write wind stress components
#define write_tau
c  write surface heat/salt fluxes
#define write_tracer_fluxes

c  write the forcing of the barotr. mode
c#define write_barotropic_forcing
c  write the restoring b.c. for TS at the open boundaries
c#define write_restore_TS_obc
c  write blue density
c#define write_blue_density
c  write also the blue parameter
c#define write_blue_parameter
c  write vertical velocity
#define write_adv_vbt
c  write T/S climatologies and restoring time scales
c#define write_surface_restoring
c  write the forcing for the KT model
c#define write_ustar
c  write the penetration depth of wind stirring
c#define write_ktmix_dml
c  write the hor. diffusivity/viscosity
c#define write_am_scale
c#define write_ambi_scale
c#define write_ah_scale
c#define write_ahbi_scale
c  write the GM velocities
c#define write_gm_velocity
c  write some informations from convection algorythm
c#define write_ventilated_depth
c#define write_convection_below_ml
c  write vertical diffusivity
c#define write_vert_diff
c#define write_vert_visc
c#define write_tkemix
c#define write_Nsqr





      subroutine init_snap_cdf
c
c-----------------------------------------------------------------------
c     initialize NetCDF snapshot file
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer ncid,iret,i,j,k,n
      integer lon_tdim,lon_udim,lat_tdim,lat_udim,itimedim
      integer depth_wdim,depth_wid, depth_tdim,depth_tid
      integer lon_tid,lon_uid,lat_tid,lat_uid,itimeid
      integer ipsiid,itopoid,itauxid,itauyid,ihtpid
      integer rhoid,brhoid ,zu1id,zu2id,guessid,ptdid
      integer uid,vid,trid(nt),wid,balphaid
      integer tobcnid,sobcnid, tobcsid,sobcsid
      integer tobcwid,sobcwid, tobceid,sobceid
      integer stfid(nt),ivz,ivz2,ekeid
      integer ihfrestid,isfrestid,iustarid,idmlid
      integer ihfclimid,isfclimid,sshid,ubarid,vbarid
      integer iamid,iahid,iahbiid,iambiid,adv_sid
      integer ugmid,vgmid,wgmid,diffvid,viscvid,Nsqrid
      integer dims(4), corner(4), edges(4)
      character name*24, unit*16, text*80
      real :: spval=-9.9e12
#ifdef netcdf_real4
      real (kind=4), allocatable :: var4(:)
#else
      real         , allocatable :: var4(:)
#endif
       integer :: year,month,day
c
c    overiding namelist input for file name
c
       year  = get_year(get_current_time())
       month = get_month_of_year(get_current_time())
       day   = get_day_of_month(get_current_time())
       write(snap_file,'("snap_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            sub_domain,year,month,day
       call replace_space_zero(snap_file)

      if (my_pe == 0) then
      print*,' initializing NetCDF output file ',
     &        snap_file(1:len_trim(snap_file))

      ncid = nccre (snap_file, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call store_info_cdf(ncid)
c     dimensions
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
      dims(1)  = Lon_udim
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_wdim
      depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c     2 dim variables on t grid
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = iTimedim
      ipsiid  = ncvdef (ncid,'psi', NCFLOAT,3,dims,iret)
      itopoid = ncvdef (ncid,'topo', NCFLOAT,2,dims,iret)
#ifdef partial_cell
      ihtpid = ncvdef (ncid,'htp', NCFLOAT,2,dims,iret)
#endif
#ifdef write_tracer_fluxes
      do n=1,nt
       name='heat_fl';if (n==2) name='salt_fl'
       if (n>2) then
         write(name, '("tracer_",i2,"_sflux")') n
         call replace_space_zero(name)
       endif
       stfid(n) = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
      enddo
#endif
#ifdef write_surface_restoring
      ihfrestid = ncvdef (ncid,'T_rest', NCFLOAT,3,dims,iret)
      ihfclimid = ncvdef (ncid,'T_clim', NCFLOAT,3,dims,iret)
      isfrestid = ncvdef (ncid,'S_rest', NCFLOAT,3,dims,iret)
      isfclimid = ncvdef (ncid,'S_clim', NCFLOAT,3,dims,iret)
#endif
#if defined write_eta 
      if (enable_freesurf) 
     &      sshid = ncvdef (ncid,'eta', NCFLOAT,3,dims,iret)
#endif
#if defined write_ubar
      if (enable_freesurf)  then
         ubarid = ncvdef (ncid,'ubar', NCFLOAT,3,dims,iret)
         vbarid = ncvdef (ncid,'vbar', NCFLOAT,3,dims,iret)
      endif
#endif

      if (enable_ktmix.or.enable_tkemix) then
#if defined write_ustar 
       iustarid = ncvdef (ncid,'ustar', NCFLOAT,3,dims,iret)
#endif
      endif
      if (enable_ktmix) then
#ifdef write_ktmix_dml
       idmlid = ncvdef (ncid,'dml', NCFLOAT,3,dims,iret)
#endif
      endif
      if (enable_expl_convection) then
#ifdef write_ventilated_depth
       ivz = ncvdef (ncid,'convect', NCFLOAT,3,dims,iret)
#endif
#ifdef write_convection_below_ml
       ivz2 = ncvdef (ncid,'convect2', NCFLOAT,3,dims,iret)
#endif
      endif
c     3 dim variables
      dims(1) = Lon_udim; dims(2) = Lat_udim
      dims(3) = depth_tdim; dims(4) = iTimedim
#ifdef write_UV
      uid=ncvdef (ncid,'u', NCFLOAT,4,dims,iret)
      vid=ncvdef (ncid,'v', NCFLOAT,4,dims,iret)
#endif
#if defined write_gm_velocity 
      if (enable_diffusion_isoneutral.or.
     &    enable_diffusion_isopycnic) then
       dims=(/lon_udim,lat_tdim,depth_tdim,itimedim/)
       ugmid=ncvdef (ncid,'u_gm', NCFLOAT,4,dims,iret)
       dims=(/lon_tdim,lat_udim,depth_tdim,itimedim/)
       vgmid=ncvdef (ncid,'v_gm', NCFLOAT,4,dims,iret)
      endif
#endif
c     2 dim variables on u grid
      dims(1) = Lon_udim; dims(2) = Lat_udim; dims(3) = iTimedim
#ifdef write_tau
      itauxid=ncvdef (ncid,'taux', NCFLOAT,3,dims,iret)
      itauyid=ncvdef (ncid,'tauy', NCFLOAT,3,dims,iret)
#endif
#ifdef write_barotropic_forcing
      zu1id=ncvdef (ncid,'zu1', NCFLOAT,3,dims,iret)
      zu2id=ncvdef (ncid,'zu2', NCFLOAT,3,dims,iret)
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = iTimedim
      guessid=ncvdef (ncid,'guess', NCFLOAT,3,dims,iret)
      ptdid=ncvdef (ncid,'ptd', NCFLOAT,3,dims,iret)
      dims(1) = Lon_udim; dims(2) = Lat_udim; dims(3) = iTimedim
#endif
#if defined write_am_scale 
      iamid=ncvdef (ncid,'am', NCFLOAT,2,dims,iret)
#endif
#if defined write_ambi_scale 
      iambiid=ncvdef (ncid,'ambi', NCFLOAT,2,dims,iret)
#endif
#if defined write_ah_scale 
      iahid=ncvdef (ncid,'ah', NCFLOAT,2,dims,iret)
#endif
#if defined write_ahbi_scale 
      iahbiid=ncvdef (ncid,'ahbi', NCFLOAT,2,dims,iret)
#endif
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = depth_tdim
      dims(4) = iTimedim
#ifdef write_TS
      do n=1,nt
       name='temp';if (n==2) name='salt'
       if (n>2) then
         write(name, '("tracer_",i2)') n
         call replace_space_zero(name)
       endif
       trid(n)=ncvdef (ncid,name, NCFLOAT,4,dims,iret)
      enddo
#endif
      if (enable_blue) then
#if defined write_blue_density 
       rhoid=ncvdef (ncid,'rho', NCFLOAT,4,dims,iret)
       brhoid=ncvdef (ncid,'blue_rho', NCFLOAT,4,dims,iret)
#endif
#if defined write_blue_parameter
       balphaid=ncvdef (ncid,'blue_alpha', NCFLOAT,3,dims,iret)
#endif
      endif
#ifdef write_adv_vbt
      dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
      wid=ncvdef (ncid,'w', NCFLOAT,4,dims,iret)
#endif
#if defined write_gm_velocity 
      if (enable_diffusion_isoneutral.or.
     &    enable_diffusion_isopycnic) then
       dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
       wgmid=ncvdef (ncid,'w_gm', NCFLOAT,4,dims,iret)
      endif
#endif
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = depth_wdim
      dims(4) = iTimedim
#ifdef write_vert_diff
      diffvid=ncvdef (ncid,'diff_cbt', NCFLOAT,4,dims,iret)
#endif
#ifdef write_vert_visc
      dims(1) = Lon_udim; dims(2) = Lat_udim; dims(3) = depth_wdim
      dims(4) = iTimedim
      viscvid=ncvdef (ncid,'visc_cbu', NCFLOAT,4,dims,iret)
#endif
#ifdef write_Nsqr
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = depth_wdim
      dims(4) = iTimedim
      Nsqrid=ncvdef (ncid,'Nsqr', NCFLOAT,4,dims,iret)
#endif

#ifdef write_tkemix
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = depth_wdim
      dims(4) = iTimedim
      if (enable_tkemix) then
       ekeid=ncvdef (ncid,'tke', NCFLOAT,4,dims,iret)
      endif
#endif

#ifdef write_restore_TS_obc
      dims(1) = Lon_tdim; dims(2) = depth_tdim; dims(3) = iTimedim
      tobcnid=ncvdef (ncid,'t_obc_north', NCFLOAT,3,dims,iret)
      sobcnid=ncvdef (ncid,'s_obc_north', NCFLOAT,3,dims,iret)
      tobcsid=ncvdef (ncid,'t_obc_south', NCFLOAT,3,dims,iret)
      sobcsid=ncvdef (ncid,'s_obc_south', NCFLOAT,3,dims,iret)
      dims(1) = Lat_tdim
      tobcwid=ncvdef (ncid,'t_obc_west', NCFLOAT,3,dims,iret)
      sobcwid=ncvdef (ncid,'s_obc_west', NCFLOAT,3,dims,iret)
      tobceid=ncvdef (ncid,'t_obc_east', NCFLOAT,3,dims,iret)
      sobceid=ncvdef (ncid,'s_obc_east', NCFLOAT,3,dims,iret)
#endif
c     attributes of the grid
      name = 'Longitude on T grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on U grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of W Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_wid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_wid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c     attributes of variables
      name = 'Topography            '; unit = 'm    '
      call dvcdf(ncid,itopoid,name,24,unit,16,spval)
#ifdef partial_cell
      name = 'Depth of partial cells'; unit = 'm    '
      call dvcdf(ncid,ihtpid,name,24,unit,16,spval)
#endif
      name = 'STREAMFUNCTION        '; unit = 'Sv    '
      call dvcdf(ncid,ipsiid,name,24,unit,16,spval)
#ifdef write_TS
      do n=1,nt
       name='Temperature';if (n==2) name='Salinity'
       if (n>2) write(name,'("Tracer Nr.",i2)') n
       unit='deg C'; if (n==2) unit='PSU'
       if (n>2) unit='  '
       call dvcdf(ncid,trid(n),name,24,unit,16,spval)
      enddo
#endif
#ifdef write_UV
      name = 'ZONAL VELOCITY     '; unit = 'm/s'
      call dvcdf(ncid,uid,name,24,unit,16,spval)
      name = 'MERIDIONAL VELOCITY     '; unit = 'm/s'
      call dvcdf(ncid,vid,name,24,unit,16,spval)
#endif
#if defined write_gm_velocity 
      if (enable_diffusion_isoneutral.or.
     &    enable_diffusion_isopycnic) then
       name = 'ZONAL BOLUS VELOCITY '; unit = 'm/s'
       call dvcdf(ncid,ugmid,name,24,unit,16,spval)
       name = 'MERIDIONAL BOLUS VELOCITY'; unit = 'm/s'
       call dvcdf(ncid,vgmid,name,24,unit,16,spval)
       name = 'VERTICAL BOLUS VELOCITY'; unit = 'm/s'
       call dvcdf(ncid,wgmid,name,24,unit,16,spval)
      endif
#endif
      if (enable_blue) then
#if defined write_blue_density 
       name = 'Density     '; unit = 'kg/m^3'
       call dvcdf(ncid,rhoid,name,24,unit,16,spval)
       name = 'Density from sub domain '; unit = 'kg/m^3'
       call dvcdf(ncid,brhoid,name,24,unit,16,spval)
#endif
#if defined write_blue_parameter
       name = 'Blue parameter'; unit = '--'
       call dvcdf(ncid,balphaid,name,24,unit,16,spval)
#endif
      endif
#ifdef write_adv_vbt
      name = 'Vertical Velocity  '; unit = 'm/s'
      call dvcdf(ncid,wid,name,24,unit,16,spval)
#endif
#ifdef write_vert_diff
      name = 'Vertical Diffusivity'; unit = 'cm^2/s'
      call dvcdf(ncid,diffvid,name,24,unit,16,spval)
#endif
#ifdef write_vert_visc
      name = 'Vertical Viscosity'; unit = 'cm^2/s'
      call dvcdf(ncid,viscvid,name,24,unit,16,spval)
#endif
#ifdef write_Nsqr
      name = 'Brunt-Vaisala frequency'; unit = '1/s^2'
      call dvcdf(ncid,Nsqrid,name,24,unit,16,spval)
#endif
#ifdef write_tkemix
      if (enable_tkemix) then
       name = 'Turbulent kinetic energy'; unit = 'm^2/s^2'
       call dvcdf(ncid,ekeid,name,24,unit,16,spval)
      endif
#endif
#ifdef write_tracer_fluxes
      do n=1,nt
       name = 'Surface heat flux'; unit = 'W/m^2'
       if (n==2) then
        name = 'Surface salt flux'; unit = 'kg/m**2/s'
       endif
       if (n>2) then
        write(name,'("Surface flux tracer ",i2)') n
        call replace_space_zero(name)
        unit = '  '
       endif
       call dvcdf(ncid,stfid(n),name,24,unit,16,spval)
      enddo
#endif
#ifdef write_surface_restoring
      name = 'Temp. restoring coeff.'; unit = 'W/m^2/K'
      call dvcdf(ncid,ihfrestid,name,24,unit,16,spval)
      name = 'Sal. restoring coeff.'; unit = 'kg/m**2/s'
      call dvcdf(ncid,isfrestid,name,24,unit,16,spval)
      name = 'Temp. restoring clim.'; unit = 'deg C'
      call dvcdf(ncid,ihfclimid,name,24,unit,16,spval)
      name = 'Sal. restoring clim.'; unit = 'psu'
      call dvcdf(ncid,isfclimid,name,24,unit,16,spval)
#endif
#if defined  write_eta 
      if (enable_freesurf) then
       name = 'Sea surface height'; unit = 'm'
       call dvcdf(ncid,sshid,name,24,unit,16,spval)
      endif
#endif
#if defined  write_ubar
      if (enable_freesurf) then
       name = 'Barotropic velocity'; unit = 'm/s'
       call dvcdf(ncid,ubarid,name,24,unit,16,spval)
       name = 'Barotropic velocity'; unit = 'm/s'
       call dvcdf(ncid,vbarid,name,24,unit,16,spval)
      endif
#endif
      if (enable_ktmix.or.enable_tkemix) then
#if defined write_ustar
       name = 'U^star'; unit = '(cm/s)^3'
       call dvcdf(ncid,iustarid,name,24,unit,16,spval)
#endif
      endif
      if (enable_ktmix) then
#ifdef write_ktmix_dml
       name = 'Mixed layer depth due to wind stirring'; unit = 'm'
       call dvcdf(ncid,idmlid,name,24,unit,16,spval)
#endif
      endif
      if (enable_expl_convection) then
#ifdef write_ventilated_depth
       name = 'Ventilated depth'; unit = 'm'
       call dvcdf(ncid,ivz,name,24,unit,16,spval)
#endif
#ifdef write_convection_below_ml
       name = 'Convection below Mixel Layer'; unit = '# of lev.'
       call dvcdf(ncid,ivz2,name,24,unit,16,spval)
#endif
      endif
#ifdef write_tau
      name = 'ZONAL WIND STRESS'; unit = 'N/m^2'
      call dvcdf(ncid,itauxid,name,24,unit,16,spval)
      name = 'MERIDIONAL WIND STRESS'; unit = 'N/m^2'
      call dvcdf(ncid,itauyid,name,24,unit,16,spval)
#endif
#ifdef write_barotropic_forcing
      name = 'Zonal comp. of barotr. forcing'; unit = '*'
      call dvcdf(ncid,zu1id,name,24,unit,16,spval)
      name = 'Mer. comp. of barotr. forcing'; unit = '*'
      call dvcdf(ncid,zu2id,name,24,unit,16,spval)
      name = 'Last change in streamfct'; unit = 'Sv*dt'
      call dvcdf(ncid,guessid,name,24,unit,16,spval)
      name = 'Actual change in streamfct'; unit = 'Sv*dt'
      call dvcdf(ncid,ptdid,name,24,unit,16,spval)
#endif
#if defined write_am_scale 
      name = 'Hor. harm. viscosity'; unit = 'm^2/s'
      call dvcdf(ncid,iamid,name,24,unit,16,spval)
#endif
#if defined write_ambi_scale 
      name = 'Hor. biharm. viscosity'; unit = 'm^4/s'
      call dvcdf(ncid,iambiid,name,24,unit,16,spval)
#endif
#if defined write_ah_scale
      name = 'Hor. harm. Diffusivity'; unit = 'm^2/s'
      call dvcdf(ncid,iahid,name,24,unit,16,spval)
#endif
#if defined write_ahbi_scale
      name = 'Hor. biharm. Diffusivity'; unit = 'm^4/s'
      call dvcdf(ncid,iahbiid,name,24,unit,16,spval)
#endif
#ifdef write_restore_TS_obc
      name = 'Restoring Temp. at northern obc'; unit = 'deg C'
      call dvcdf(ncid,tobcnid,name,24,unit,16,spval)
      name = 'Restoring Sal. at northern obc'; unit = 'psu'
      call dvcdf(ncid,sobcnid,name,24,unit,16,spval)
      name = 'Restoring Temp. at southern obc'; unit = 'deg C'
      call dvcdf(ncid,tobcsid,name,24,unit,16,spval)
      name = 'Restoring Sal. at southern obc'; unit = 'psu'
      call dvcdf(ncid,sobcsid,name,24,unit,16,spval)
      name = 'Restoring Temp. at western obc'; unit = 'deg C'
      call dvcdf(ncid,tobcwid,name,24,unit,16,spval)
      name = 'Restoring Sal. at western obc'; unit = 'psu'
      call dvcdf(ncid,sobcwid,name,24,unit,16,spval)
      name = 'Restoring Temp. at eastern obc'; unit = 'deg C'
      call dvcdf(ncid,tobceid,name,24,unit,16,spval)
      name = 'Restoring Sal. at eastern obc'; unit = 'psu'
      call dvcdf(ncid,sobceid,name,24,unit,16,spval)
#endif
      call ncendf(ncid, iret)

      Corner=0; edges=0; Corner(1) = 1; edges(1) = imt
      allocate( var4(max(imt,jmt,km)) )
      var4(1:imt)=xt
      call ncvpt(ncid, Lon_tid, corner, edges,var4, iret)
      var4(1:imt)=xu
      call ncvpt(ncid, Lon_uid, corner, edges,var4, iret)
      corner(1) = 1; edges(1) = jmt
      var4(1:jmt)=yt
      call ncvpt(ncid, Lat_tid, corner, edges,var4, iret)
      var4(1:jmt)=yu
      call ncvpt(ncid, Lat_uid, corner, edges,var4, iret)
      corner(1) = 1; edges(1) = km
      var4(1:km)=zt/100.
      call ncvpt(ncid, depth_tid, corner, edges,var4, iret)
      corner(1) = 1; edges(1) = km
      var4(1:km)=zw/100.
      call ncvpt(ncid, depth_wid, corner, edges,var4, iret)
      deallocate(var4)
      call ncclos (ncid, iret)
      print*,' done'
      endif
#endif
      end subroutine init_snap_cdf



      subroutine diag_snap
c
c-----------------------------------------------------------------------
c     write to NetCDF snapshot file
c-----------------------------------------------------------------------
c
      use spflame_module
#if defined write_gm_velocity 
      use isoneutral_module
      use isopycnic_module
#endif
      use blue_module
      use freesurf_module
      implicit none
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer ncid,iret,n, corner(4), edges(4)
      real :: spval=-9.9e12
      integer ipsiid,itdimid,ilen,itopoid,ihtpid
      integer itauxid,itauyid, uid,vid,wid,trid(nt)
#ifdef netcdf_real4
      real (kind=4) :: var(is_pe:ie_pe,js_pe:je_pe)
      real (kind=4) , allocatable :: v2(:)
#else
      real var(is_pe:ie_pe,js_pe:je_pe)
      real, allocatable :: v2(:)
#endif
      integer i,j,k,is,ie,js,je
      integer rhoid,brhoid ,zu1id,zu2id,guessid,ptdid
      integer npe,ierr,itimeid, stfid(nt),ivz,ivz2
      integer tobcnid,sobcnid,tobcsid,sobcsid
      integer tobcwid,sobcwid, tobceid,sobceid
      integer ihfrestid,isfrestid,iustarid,idmlid
      integer ihfclimid,isfclimid, balphaid
      integer iamid,iahid,iambiid,iahbiid,adv_sid,sshid,ubarid,vbarid
      integer ugmid,vgmid,wgmid,diffvid,ekeid,viscvid,Nsqrid
      character (len=80) :: name
      real, allocatable :: u_gm(:,:,:),v_gm(:,:,:)
      real, allocatable :: w_gm(:,:,:)
      real :: fxa
#ifdef write_Nsqr
      real :: Nsqr(is_pe:ie_pe,km,js_pe:je_pe)  
      real, dimension(is_pe:ie_pe)    :: ro1,ro2
#endif

       if (my_pe==0)
     &  print*,' --> writing a snapshot of sub_domain to file ',
     &        snap_file(1:len_trim(snap_file))

#if defined write_gm_velocity 
      if (enable_diffusion_isoneutral.or.
     &    enable_diffusion_isopycnic) then
       allocate( u_gm(is_pe-1:ie_pe,  km,js_pe  :je_pe) ); u_gm=0.
       allocate( v_gm(is_pe  :ie_pe,  km,js_pe-1:je_pe) ); v_gm=0.
       allocate( w_gm(is_pe  :ie_pe,0:km,js_pe  :je_pe) ); w_gm=0.
       if (enable_diffusion_isoneutral) then
        call isoneutral_adv(u_gm,v_gm,w_gm)
       else
        u_gm=adv_vetiso
        v_gm=adv_vntiso
        w_gm=adv_vbtiso
       endif
      endif
#endif
#ifdef write_Nsqr
      Nsqr=0.
      do j=js_pe,je_pe
       do k=1,km-1
        call model_dens(t(is_pe,k  ,j,1,tau),t(is_pe,k  ,j,2,tau),
     &                  ro1(is_pe),k, ie_pe-is_pe+1
#ifdef partial_cell
     &                       ,ztp(is_pe,k,j)
#endif
     &                       )
        call model_dens(t(is_pe,k+1,j,1,tau),t(is_pe,k+1,j,2,tau),
     &                  ro2(is_pe),k, ie_pe-is_pe+1
#ifdef partial_cell
     &                       ,ztp(is_pe,k,j)
#endif
     &                       )
        do i=is_pe,ie_pe
#ifndef partial_cell
         fxa = -grav/rho0*dzwr(k)
#endif
#ifdef partial_cell
         fxa = -grav/(rho0*dhwt(i,k,j))
#endif
         Nsqr(i,k,j) =fxa*(ro1(i)-ro2(i))*tmask(i,k+1,j)
        enddo
       enddo
      enddo
#endif

       do npe=0,n_pes
       call barrier

       if (my_pe==npe) then

       iret=nf_open(snap_file,NF_WRITE,ncid)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)

       iret=nf_inq_varid(ncid,'psi',ipsiid)
       iret=nf_inq_varid(ncid,'topo',itopoid)
#ifdef partial_cell
       iret=nf_inq_varid(ncid,'htp',ihtpid)
#endif
#ifdef write_UV
       iret=nf_inq_varid(ncid,'u',uid)
       iret=nf_inq_varid(ncid,'v',vid)
#endif
#ifdef write_adv_vbt
       iret=nf_inq_varid(ncid,'w',wid)
#endif
#if defined write_gm_velocity 
       if (enable_diffusion_isoneutral.or.
     &     enable_diffusion_isopycnic) then
        iret=nf_inq_varid(ncid,'u_gm',ugmid)
        iret=nf_inq_varid(ncid,'v_gm',vgmid)
        iret=nf_inq_varid(ncid,'w_gm',wgmid)
       endif
#endif
#ifdef write_vert_diff
       iret=nf_inq_varid(ncid,'diff_cbt',diffvid)
#endif
#ifdef write_vert_visc
       iret=nf_inq_varid(ncid,'visc_cbu',viscvid)
#endif
#ifdef write_Nsqr
       iret=nf_inq_varid(ncid,'Nsqr',Nsqrid)
#endif
#ifdef write_tkemix
       if (enable_tkemix) then
        iret=nf_inq_varid(ncid,'tke',ekeid)
       endif
#endif
#ifdef write_TS
       do n=1,nt
        name='temp';if (n==2) name='salt'
        if (n>2) then
          write(name, '("tracer_",i2)') n
          call replace_space_zero(name)
        endif
        iret=nf_inq_varid(ncid,name,trid(n))
       enddo
#endif
       if (enable_blue) then
#if defined write_blue_density 
        iret=nf_inq_varid(ncid,'rho',rhoid)
        iret=nf_inq_varid(ncid,'blue_rho',brhoid)
#endif
#if defined write_blue_parameter
        iret=nf_inq_varid(ncid,'blue_alpha',balphaid)
#endif
       endif
#ifdef write_tau
       iret=nf_inq_varid(ncid,'taux',itauxid)
       iret=nf_inq_varid(ncid,'tauy',itauyid)
#endif
#ifdef write_tracer_fluxes
       do n=1,nt
        name='heat_fl';if (n==2) name='salt_fl'
        if (n>2) then
          write(name, '("tracer_",i2,"_sflux")') n
          call replace_space_zero(name)
        endif
        iret=nf_inq_varid(ncid,name,stfid(n))
       enddo
#endif
#ifdef write_surface_restoring
       iret=nf_inq_varid(ncid,'T_rest',ihfrestid)
       iret=nf_inq_varid(ncid,'S_rest',isfrestid)
       iret=nf_inq_varid(ncid,'T_clim',ihfclimid)
       iret=nf_inq_varid(ncid,'S_clim',isfclimid)
#endif
#if defined write_eta 
       if (enable_freesurf) then
        iret=nf_inq_varid(ncid,'eta',sshid)
       endif
#endif
#if defined write_ubar
       if (enable_freesurf) then
        iret=nf_inq_varid(ncid,'ubar',ubarid)
        iret=nf_inq_varid(ncid,'vbar',vbarid)
       endif
#endif
       if (enable_ktmix.or.enable_tkemix) then
#if defined write_ustar 
        iret=nf_inq_varid(ncid,'ustar',iustarid)
#endif
       endif
       if (enable_ktmix) then
#ifdef write_ktmix_dml
        iret=nf_inq_varid(ncid,'dml',idmlid)
#endif
       endif
       if (enable_expl_convection) then
#ifdef write_ventilated_depth
        iret=nf_inq_varid(ncid,'convect',ivz)
#endif
#ifdef write_convection_below_ml
        iret=nf_inq_varid(ncid,'convect2',ivz2)
#endif
       endif
#ifdef write_barotropic_forcing
       iret=nf_inq_varid(ncid,'zu1',zu1id)
       iret=nf_inq_varid(ncid,'zu2',zu2id)
       iret=nf_inq_varid(ncid,'guess',guessid)
       iret=nf_inq_varid(ncid,'ptd',ptdid)
#endif
#if defined write_am_scale 
       iret=nf_inq_varid(ncid,'am',iamid)
#endif
#if defined write_ambi_scale 
       iret=nf_inq_varid(ncid,'ambi',iambiid)
#endif
#if defined write_ah_scale 
       iret=nf_inq_varid(ncid,'ah',iahid)
#endif
#if defined write_ahbi_scale 
       iret=nf_inq_varid(ncid,'ahbi',iahbiid)
#endif

       iret=nf_inq_varid(ncid,'Time',itimeid)
#ifdef write_restore_TS_obc
       iret=nf_inq_varid(ncid,'t_obc_north',tobcnid)
       iret=nf_inq_varid(ncid,'s_obc_north',sobcnid)
       iret=nf_inq_varid(ncid,'t_obc_south',tobcsid)
       iret=nf_inq_varid(ncid,'s_obc_south',sobcsid)
       iret=nf_inq_varid(ncid,'t_obc_west',tobcwid)
       iret=nf_inq_varid(ncid,'s_obc_west',sobcwid)
       iret=nf_inq_varid(ncid,'t_obc_east',tobceid)
       iret=nf_inq_varid(ncid,'s_obc_east',sobceid)
#endif

       iret=nf_inq_dimid(ncid,'Time',itdimid)
       iret=nf_inq_dimlen(ncid, itdimid,ilen)

       if (my_pe==0) then
         ilen=ilen+1
         corner(1)=ilen
         edges(1)=1
         call read_stamp(current_stamp,fxa)
         print*,' at stamp=',current_stamp,
     &          ' (days since origin : ',fxa,')',
     &          ' (time steps in file : ',ilen,')'
         var(is_pe,js_pe)=fxa
         iret= nf_put_vara_real (ncid,itimeid , corner, edges,var)
       endif

       Corner = (/is_pe,js_pe,ilen,0/)
       edges  = (/ie_pe-is_pe+1,je_pe-js_pe+1,1,0/)
       var=psi(is_pe:ie_pe,js_pe:je_pe,1)/1e12
       where( tmask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
       iret= nf_put_vara_real (ncid,ipsiid , corner, edges,var)

#ifdef write_tau
       var=smf(is_pe:ie_pe,js_pe:je_pe,1)/10.
       where( umask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
       iret= nf_put_vara_real (ncid,itauxid , corner, edges,var)

       var=smf(is_pe:ie_pe,js_pe:je_pe,2)/10.
       where( umask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
       iret= nf_put_vara_real (ncid,itauyid , corner, edges,var)
#endif

       is=max(2,is_pe); ie=min(imt-1,ie_pe)
       js=max(2,js_pe); je=min(jmt-1,je_pe)

#ifdef write_tracer_fluxes
       do n=1,nt
        var=spval
        var(is:ie,js:je)=stf(is:ie,js:je,n)
        if (n==1) var(is:ie,js:je)=var(is:ie,js:je)*41868
        if (n==2) var(is:ie,js:je)=var(is:ie,js:je)*10
        where( tmask(is:ie,1,js:je) == 0. ) var(is:ie,js:je)= spval
        iret= nf_put_vara_real (ncid,stfid(n) , corner, edges,var)
       enddo
#endif
#ifdef write_surface_restoring
       var=spval
       var(is:ie,js:je)=stf_rest(is:ie,js:je,1)*41868.  
       where( tmask(is:ie,1,js:je) == 0. ) var(is:ie,js:je)= spval
       iret= nf_put_vara_real (ncid,ihfrestid , corner, edges,var)

       var=spval
       var(is:ie,js:je)=stf_rest(is:ie,js:je,2)   ! do not known what to do
       where( tmask(is:ie,1,js:je) == 0. ) var(is:ie,js:je)= spval
       iret= nf_put_vara_real (ncid,isfrestid , corner, edges,var)

       var=spval
       var(is:ie,js:je)=stf_clim(is:ie,js:je,1)
       where( tmask(is:ie,1,js:je) == 0. ) var(is:ie,js:je)= spval
       iret= nf_put_vara_real (ncid,ihfclimid , corner, edges,var)

       var=spval
       var(is:ie,js:je)=stf_clim(is:ie,js:je,2)*1000.+35.
       where( tmask(is:ie,1,js:je) == 0. ) var(is:ie,js:je)= spval
       iret= nf_put_vara_real (ncid,isfclimid , corner, edges,var)
#endif
#if defined  write_eta 
       if (enable_freesurf) then
        var=spval
        var(is:ie,js:je)=etat(is:ie,js:je,3)/100.
        where( tmask(is:ie,1,js:je) == 0. ) var(is:ie,js:je)= spval
        iret= nf_put_vara_real (ncid,sshid , corner, edges,var)
       endif
#endif
#if defined  write_ubar
       if (enable_freesurf) then
        var=spval
        var(is:ie,js:je)=ubar(is:ie,js:je,1)/100.
        where( umask(is:ie,1,js:je) == 0. ) var(is:ie,js:je)= spval
        iret= nf_put_vara_real (ncid,ubarid , corner, edges,var)
        var(is:ie,js:je)=ubar(is:ie,js:je,2)/100.
        where( umask(is:ie,1,js:je) == 0. ) var(is:ie,js:je)= spval
        iret= nf_put_vara_real (ncid,vbarid , corner, edges,var)
       endif
#endif


       if (enable_ktmix.or.enable_tkemix) then
#if defined write_ustar 
        var=spval; var(is:ie,js:je)=ustar(is:ie,js:je)
        where( tmask(is:ie,1,js:je) == 0. ) var(is:ie,js:je)= spval
        iret= nf_put_vara_real (ncid,iustarid , corner, edges,var)
#endif
       endif
       if (enable_ktmix) then
#ifdef write_ktmix_dml
        var=spval; var(is:ie,js:je)=dml(is:ie,js:je)/100.
        where( tmask(is:ie,1,js:je) == 0. ) var(is:ie,js:je)= spval
        iret= nf_put_vara_real (ncid,idmlid , corner, edges,var)
#endif
       endif
       if (enable_expl_convection) then
#ifdef write_ventilated_depth
        var=spval; 
        do j=js,je
         do i=is,ie
          var(i,j)=zt( max(1, min(km,lcven(i,j)) )  )/100.
         enddo
        enddo
        iret= nf_put_vara_real (ncid,ivz, corner, edges,var)
#endif
#ifdef write_convection_below_ml
        var(is:ie,js:je)=lctot(is:ie,js:je)-lcven(is:ie,js:je)
        where( tmask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var= spval
        iret= nf_put_vara_real (ncid,ivz2 , corner, edges,var)
#endif
       endif

#ifdef write_barotropic_forcing
       var=zu(is_pe:ie_pe,js_pe:je_pe,1)
c       where( umask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
       iret= nf_put_vara_real (ncid,zu1id , corner, edges,var)
       var=zu(is_pe:ie_pe,js_pe:je_pe,2)
c       where( umask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
       iret= nf_put_vara_real (ncid,zu2id , corner, edges,var)
       var=guess(is_pe:ie_pe,js_pe:je_pe)
       where( tmask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
       iret= nf_put_vara_real (ncid,guessid , corner, edges,var)
       var=ptd(is_pe:ie_pe,js_pe:je_pe)
       where( tmask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
       iret= nf_put_vara_real (ncid,ptdid , corner, edges,var)
#endif

       if (ilen==1) then
        var=0.
        do j=js_pe,je_pe 
         do k=1,km
          do i=is_pe,ie_pe
           var(i,j)=var(i,j)+tmask(i,k,j)*dzt(k)/100.
          enddo
         enddo
        enddo
        iret= nf_put_vara_real(ncid,itopoid,corner, edges,var)
        if (iret.ne.0) print*,nf_strerror(iret),my_pe
#ifdef partial_cell
        var=htp(is_pe:ie_pe,js_pe:je_pe)/100.
        iret= nf_put_vara_real(ncid,ihtpid,corner, edges,var)
#endif
#if defined write_am_scale 
        var=am_scale(is_pe:ie_pe,js_pe:je_pe)*am/1e4
        where( umask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
        iret= nf_put_vara_real (ncid,iamid , corner, edges,var)
#endif
#if defined write_ambi_scale 
        var=ambi_scale(is_pe:ie_pe,js_pe:je_pe)*ambi/1e8
        where( umask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
        iret= nf_put_vara_real (ncid,iambiid , corner, edges,var)
#endif
#if defined write_ah_scale 
        var=ah_scale(is_pe:ie_pe,js_pe:je_pe)*ah/1e4
        where( tmask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
        iret= nf_put_vara_real (ncid,iahid , corner, edges,var)
#endif
#if defined write_ahbi_scale 
        var=ahbi_scale(is_pe:ie_pe,js_pe:je_pe)*ahbi/1e8
        where( tmask(is_pe:ie_pe,1,js_pe:je_pe) == 0. ) var = spval
        iret= nf_put_vara_real (ncid,iahbiid , corner, edges,var)
#endif
#if defined write_blue_parameter
        if (enable_blue) then
         do k=1,km
          Corner = (/is_pe,js_pe,k,ilen/)
          edges  = (/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
          var=blue_alpha(is_pe:ie_pe,k,js_pe:je_pe)
          where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
          iret= nf_put_vara_real (ncid,balphaid,corner,edges,var)
         enddo
        endif
#endif
       endif

       do k=1,km
        Corner = (/is_pe,js_pe,k,ilen/)
        edges  = (/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
#ifdef write_UV
        var=u(is_pe:ie_pe,k,js_pe:je_pe,1,tau)/100.
        where( umask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
        iret= nf_put_vara_real (ncid,uid , corner, edges,var)
        var=u(is_pe:ie_pe,k,js_pe:je_pe,2,tau)/100.
        where( umask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
        iret= nf_put_vara_real (ncid,vid , corner, edges,var)
#endif
#ifdef write_TS
        do n=1,nt
         var=t(is_pe:ie_pe,k,js_pe:je_pe,n,tau)
         if (n==2) var=var*1000+35.
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
         iret= nf_put_vara_real (ncid,trid(n) , corner, edges,var)
        enddo
#endif
#if defined write_blue_density 
        if (enable_blue) then
         var=rho(is_pe:ie_pe,k,js_pe:je_pe)*1000.
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
         iret= nf_put_vara_real (ncid,rhoid , corner, edges,var)
         var = (blue_rho(is_pe:ie_pe,k,js_pe:je_pe,blue_p1)*blue_f1+
     &          blue_rho(is_pe:ie_pe,k,js_pe:je_pe,blue_p2)*blue_f2)
     &         *1000.
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
         iret= nf_put_vara_real (ncid,brhoid , corner, edges,var)
        endif
#endif

#ifdef write_adv_vbt
        var=spval
        var(is:ie,js:je)=adv_vbt(is:ie,k,js:je)/100.
        where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
        iret= nf_put_vara_real (ncid,wid , corner, edges,var)
#endif
#ifdef write_vert_diff
        var=spval
        var(is:ie,js:je)=diff_cbt(is:ie,k,js:je)
        where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
        iret= nf_put_vara_real (ncid,diffvid , corner, edges,var)
#endif
#ifdef write_vert_visc
        var=spval
        var(is:ie,js:je)=visc_cbu(is:ie,k,js:je)
        where( umask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
        iret= nf_put_vara_real (ncid,viscvid , corner, edges,var)
#endif
#ifdef write_Nsqr
        var=spval
        var(is:ie,js:je)=Nsqr(is:ie,k,js:je)
        where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
        iret= nf_put_vara_real (ncid,Nsqrid , corner, edges,var)
#endif
#ifdef write_tkemix
        if (enable_tkemix) then
         var=spval
         var(is:ie,js:je)=eke(is:ie,k,js:je,tau)/1.e4
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
         iret= nf_put_vara_real (ncid,ekeid , corner, edges,var)
        endif
#endif
       enddo


#ifdef write_restore_TS_obc
       do k=1,km
        Corner = (/is_pe,k,ilen,1/)
        edges  = (/ie_pe-is_pe+1,1,1,0/)

        allocate(v2(is_pe:ie_pe) )

        if (my_blk_j == n_pes_j ) then
         v2=spval
         if (enable_obc_north .and. restore_TS_obc_north) 
     *       v2=ts_obc_north(is_pe:ie_pe,k,1)
         where( tmask(is_pe:ie_pe,k,je_pe) == 0. ) v2 = spval
         iret= nf_put_vara_real (ncid,tobcnid , corner, edges,v2)

         v2=spval
         if (enable_obc_north .and. restore_TS_obc_north) 
     &      v2=ts_obc_north(is_pe:ie_pe,k,2)*1000.+35.
         where( tmask(is_pe:ie_pe,k,je_pe) == 0. ) v2 = spval
         iret= nf_put_vara_real (ncid,sobcnid , corner, edges,v2)
        endif

        if (my_blk_j == 1) then
         v2=spval
         if (enable_obc_south .and. restore_TS_obc_south) 
     &         v2=ts_obc_south(is_pe:ie_pe,k,1)
         where( tmask(is_pe:ie_pe,k,js_pe) == 0. ) v2 = spval
         iret= nf_put_vara_real (ncid,tobcsid , corner, edges,v2)

         v2=spval
         if (enable_obc_south .and. restore_TS_obc_south) 
     &         v2=ts_obc_south(is_pe:ie_pe,k,2)*1000.+35.
         where( tmask(is_pe:ie_pe,k,js_pe) == 0. ) v2 = spval
         iret= nf_put_vara_real (ncid,sobcsid , corner, edges,v2)
        endif

        deallocate( v2 )

        Corner = (/js_pe,k,ilen,0/)
        edges  = (/je_pe-js_pe+1,1,1,0/)

        allocate(v2(js_pe:je_pe) )

        if (my_blk_i == n_pes_i) then
         v2=spval
         if (enable_obc_east .and. restore_TS_obc_east) 
     &       v2=ts_obc_east(js_pe:je_pe,k,1)
         where( tmask(ie_pe,k,js_pe:je_pe) == 0. ) v2 = spval
         iret= nf_put_vara_real (ncid,tobceid , corner, edges,v2)

         v2=spval
         if (enable_obc_east .and. restore_TS_obc_east) 
     &       v2=ts_obc_east(js_pe:je_pe,k,2)*1000.+35.
         where( tmask(ie_pe,k,js_pe:je_pe) == 0. ) v2 = spval
         iret= nf_put_vara_real (ncid,sobceid , corner, edges,v2)

        endif

        if (my_blk_i == 1) then
         v2=spval
         if (enable_obc_west .and. restore_TS_obc_west) 
     &       v2=ts_obc_west(js_pe:je_pe,k,1)
         where( tmask(is_pe,k,js_pe:je_pe) == 0. ) v2 = spval
         iret= nf_put_vara_real (ncid,tobcwid , corner, edges,v2)
c
         v2=spval
         if (enable_obc_west .and. restore_TS_obc_west) 
     &       v2=ts_obc_west(js_pe:je_pe,k,2)*1000.+35.
         where( tmask(is_pe,k,js_pe:je_pe) == 0. ) v2 = spval
         iret= nf_put_vara_real (ncid,sobcwid , corner, edges,v2)

        endif

        deallocate(v2)

       enddo
#endif

#if defined write_gm_velocity 
       if (enable_diffusion_isoneutral.or.
     &     enable_diffusion_isopycnic) then
        do k=1,km
         Corner = (/is_pe,js_pe,k,ilen/)
         edges  = (/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
         do j=js_pe,je_pe
          do i=is_pe,ie_pe
           var(i,j) = u_gm(i,k,j)/100.
          enddo
         enddo
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
         iret= nf_put_vara_real (ncid,ugmid , corner, edges,var)
         do j=js_pe,je_pe
          do i=is_pe,ie_pe 
           var(i,j) = v_gm(i,k,j)/csu(j)/100.
          enddo
         enddo
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
         iret= nf_put_vara_real (ncid,vgmid , corner, edges,var)
         do j=js_pe,je_pe
          do i=is_pe,ie_pe
           var(i,j) = w_gm(i,k,j)   /100.
          enddo
         enddo
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe) == 0. ) var = spval
         iret= nf_put_vara_real (ncid,wgmid , corner, edges,var)
        enddo
       endif
#endif

       call ncclos (ncid, iret)
       endif
       call barrier
      enddo

#if defined write_gm_velocity 
      if (enable_diffusion_isoneutral.or.
     &    enable_diffusion_isopycnic) then
       deallocate( u_gm,v_gm,w_gm )
      endif
#endif
#else
c
c     write to binary files here
c

#endif
      end subroutine diag_snap

#include "options.inc"

c
c     prepare forcing for BB here
c
#define prepare_for_BB

c#define prepare_for_BB_for_D3
c correct for a strange point in Bay of Fundi with this option

#define prepare_for_BB_for_E1





      subroutine prep_BB
      use prep_module
      implicit none
#ifdef prepare_for_BB
      integer nx,ny,nt
      real, allocatable :: tau(:,:,:,:),x(:),y(:)
      real, allocatable :: vec(:,:,:),nvec(:,:,:)
      real, allocatable :: ntr_flux(:,:,:)
      real, allocatable :: tr_flux(:,:,:)
      logical verbose
      integer :: n


      print*,' reading wind stress data '
      call read_dims_tauBB(nx,ny,nt)
      print*,' nx=',nx,' ny=',ny,' nt=',nt

       allocate(tau(nx,ny,nt,2),x(nx),y(ny))
       tau=0.;x=0.;y=0.
       call read_tauBB(tau,x,y,nx,ny,nt,spval)

       allocate( vec(nx,ny,2), nvec(imt,jmt,2) )
       vec=0.;nvec=0.
       print*,' interpolating data '
       verbose=.true.
       do n=1,nt
        print*,'n=',n
        vec(:,:,1)=tau(:,:,n,1)
        vec(:,:,2)=tau(:,:,n,2)
        call rot_intrp_vctr(vec, x, y, nx, ny, 
     &                      nvec, xu, yu ,
     &              imt,jmt, psir, thetar, phir,spval,verbose)
        verbose=.false.

#ifdef prepare_for_BB_for_D3
c
c       Bay of Fundi
c
        nvec(104,208,:)=0.
#endif

        call fillgaps(imt,jmt,km,1,kmu,nvec(1,1,1),spval, 2,.true.)
        call fillgaps(imt,jmt,km,1,kmu,nvec(1,1,2),spval, 2,.true.)

        print*,' writing wind stress to output file for n=',n
        call write_tauBB_to_cdf(nvec,nt,n)
       enddo
       deallocate( tau,vec,nvec)
       print*,' done '

       print*,' reading heat flux data '
       allocate(  ntr_flux(imt,jmt,nt) )
       ntr_flux = 0.
       allocate(tr_flux(nx,ny,nt) )
       x=0;y=0;tr_flux=0.
       call read_trBB(tr_flux,x,y,nx,ny,nt,spval)

       print*,' interpolating data '
       verbose=.true.
       do n=1,nt
        print*,'nt=',n
         call rot_intrp_sclr (tr_flux(:,:,n), x, y, nx, ny, 
     &                        ntr_flux(:,:,n), xt, yt,
     &               imt, jmt, psir, thetar, phir,spval,verbose)
         verbose=.false.
         call fillgaps(imt, jmt, km, 1, kmt, ntr_flux(:,:,n), 
     &                     spval, 2,.true.)
       enddo
       deallocate(tr_flux,x,y)
       print*,' done '

       print*,' writing heat flux to output file '
       call write_trBB_to_cdf(ntr_flux,nt)
       deallocate( ntr_flux)

      print*,' reading sst feedback pattern data '
      call read_sstf_BB_dim(nx,ny,nt)
      print*,' nx=',nx,' ny=',ny,' nt=',nt

       allocate(  ntr_flux(imt,jmt,nt) )
       ntr_flux = 0.
       allocate(tr_flux(nx,ny,nt),x(nx),y(ny) )
       x=0;y=0;tr_flux=0.
       call read_sstf_BB(tr_flux,x,y,nx,ny,nt,spval)

       print*,' interpolating data '
       verbose=.true.
       do n=1,nt
        print*,'nt=',n
         call rot_intrp_sclr (tr_flux(:,:,n), x, y, nx, ny, 
     &                        ntr_flux(:,:,n), xt, yt,
     &               imt, jmt, psir, thetar, phir,spval,verbose)
         verbose=.false.
         call fillgaps(imt, jmt, km, 1, kmt, ntr_flux(:,:,n), 
     &                     spval, 2,.true.)
       enddo
       deallocate(tr_flux,x,y)
       print*,' done '

       print*,' writing sst feeback pattern to output file '
       call write_sstf_BB_to_cdf(ntr_flux,nt)
       deallocate( ntr_flux)



      print*,' reading mean sst data '
      call read_sstm_BB_dim(nx,ny,nt)
      print*,' nx=',nx,' ny=',ny,' nt=',nt

       allocate(  ntr_flux(imt,jmt,nt) )
       ntr_flux = 0.
       allocate(tr_flux(nx,ny,nt),x(nx),y(ny) )
       x=0;y=0;tr_flux=0.
       call read_sstm_BB(tr_flux,x,y,nx,ny,nt,spval)

       print*,' interpolating data '
       verbose=.true.
       do n=1,nt
        print*,'nt=',n
         call rot_intrp_sclr (tr_flux(:,:,n), x, y, nx, ny, 
     &                        ntr_flux(:,:,n), xt, yt,
     &               imt, jmt, psir, thetar, phir,spval,verbose)
         verbose=.false.
         call fillgaps(imt, jmt, km, 1, kmt, ntr_flux(:,:,n), 
     &                     spval, 2,.true.)
       enddo
       deallocate(tr_flux,x,y)
       print*,' done '

       print*,' writing mean sst pattern to output file '
       call write_sstm_BB_to_cdf(ntr_flux,nt)
       deallocate( ntr_flux)

#endif
      end subroutine prep_BB

#ifdef prepare_for_BB

      subroutine read_dims_tauBB(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      character (len=80) :: infile,name
      integer :: iret,ncid,txid,dims(4)
      infile = '/users/model/ceden/dov3/nao_reg/reg_tau_nao.cdf'

      iret=nf_open(infile,NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'taux_reg',txid)
      iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
      call ncclos (ncid, iret)
      end subroutine


      subroutine  read_tauBB(tau,x,y,nx,ny,nt,spval)
      implicit none
      integer nx,ny,nt
      real :: tau(nx,ny,nt,2),x(nx),y(ny),spval
#include "netcdf.inc"
      character (len=80) :: infile,name
      integer :: iret,ncid,txid,tyid,latid,lonid,n
      integer :: corner(4),edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4) :: tau4(nx,ny,nt),x4(nx),y4(ny), spv
#else
      real          :: tau4(nx,ny,nt),x4(nx),y4(ny), spv
#endif

      infile = '/users/model/ceden/dov3/nao_reg/reg_tau_nao.cdf'
      iret=nf_open(infile,NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'taux_reg',txid)
      iret=nf_inq_varid(ncid,'tauy_reg',tyid)
      iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=NF_INQ_VARID (NCID, name, lonid)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=NF_INQ_VARID (NCID, name, latid)

      corner=1; edges(1)=nx; 
      iret= nf_get_vara_real (ncid,lonid ,corner,edges,x4);x=x4
      corner=1; edges(1)=ny; 
      iret= nf_get_vara_real (ncid,latid ,corner,edges,y4);y=y4

      iret = nf_get_att_real(ncid, txid, 'missing_value', spv)

      corner=(/1,1,1,1/); edges=(/nx,ny,nt,1/); 
      iret= nf_get_vara_real (ncid,txid ,corner,edges,tau4)
      tau(:,:,:,1)=tau4
      iret= nf_get_vara_real (ncid,tyid ,corner,edges,tau4)
      tau(:,:,:,2)=tau4
      where( tau == spv) tau=spval
!      convert N/m**2 to dyn/cm**2 
      where( tau /= spval) tau=tau*10.
      call ncclos (ncid, iret)
      end subroutine




      subroutine  read_trBB(hflx,x,y,nx,ny,nt,spval)
      implicit none
      integer nx,ny,nt
      real :: hflx(nx,ny,nt),x(nx),y(ny),spval
#include "netcdf.inc"
      character (len=80) :: infile,name
      integer :: iret,ncid,hflxid,latid,lonid,n
      integer :: corner(4),edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4) :: hflx4(nx,ny,nt),x4(nx),y4(ny),spv
#else
      real          :: hflx4(nx,ny,nt),x4(nx),y4(ny),spv
#endif
      real,parameter :: dimfac=0.2389e-4

      infile = '/users/model/ceden/dov3/nao_reg/reg_hflx_nao.cdf'
      iret=nf_open(infile,NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'HFLAN_reg',hflxid)
      iret=NF_INQ_VARDIMID (NCID,hflxid,DIMS)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=NF_INQ_VARID (NCID, name, lonid)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=NF_INQ_VARID (NCID, name, latid)

      corner=1; edges(1)=nx; 
      iret= nf_get_vara_real (ncid,lonid ,corner,edges,x4);x=x4
      corner=1; edges(1)=ny; 
      iret= nf_get_vara_real (ncid,latid ,corner,edges,y4);y=y4

      iret = nf_get_att_real(ncid,hflxid, 'missing_value', spv)

      corner=(/1,1,1,1/); edges=(/nx,ny,nt,1/); 
      iret= nf_get_vara_real (ncid,hflxid ,corner,edges,hflx4)
      hflx=hflx4
      where( hflx == spv) hflx=spval
      ! convert W/m^2 to cal/s/cm**2
      where( hflx /= spval) hflx=hflx*dimfac
      call ncclos (ncid, iret)
      end subroutine



      subroutine  read_sstf_BB_dim(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      character (len=80) :: infile,name
      integer :: iret,ncid,sstfid,latid,lonid,n
      integer :: corner(4),edges(4),dims(4)
      infile = '/users/model/ceden/dov3/nao_reg/sst_pattern2_ufo.cdf'
      iret=nf_open(infile,NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'sst',sstfid)
      iret=NF_INQ_VARDIMID (NCID,sstfid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
      call ncclos (ncid, iret)
      end subroutine  read_sstf_BB_dim





      subroutine  read_sstf_BB(sstf,x,y,nx,ny,nt,spval)
      implicit none
      integer nx,ny,nt
      real :: sstf(nx,ny,nt),x(nx),y(ny),spval
#include "netcdf.inc"
      character (len=80) :: infile,name
      integer :: iret,ncid,sstfid,latid,lonid,n
      integer :: corner(4),edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4) :: sstf4(nx,ny,nt),x4(nx),y4(ny),spv
#else
      real          :: sstf4(nx,ny,nt),x4(nx),y4(ny),spv
#endif

      infile = '/users/model/ceden/dov3/nao_reg/sst_pattern2_ufo.cdf'
      iret=nf_open(infile,NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'sst',sstfid)
      iret=NF_INQ_VARDIMID (NCID,sstfid,DIMS)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=NF_INQ_VARID (NCID, name, lonid)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=NF_INQ_VARID (NCID, name, latid)

      corner=1; edges(1)=nx; 
      iret= nf_get_vara_real (ncid,lonid ,corner,edges,x4);x=x4
      corner=1; edges(1)=ny; 
      iret= nf_get_vara_real (ncid,latid ,corner,edges,y4);y=y4

      iret = nf_get_att_real(ncid,sstfid, 'missing_value', spv)

      corner=(/1,1,1,1/); edges=(/nx,ny,1,1/); 
      iret= nf_get_vara_real (ncid,sstfid ,corner,edges,sstf4)
      sstf=sstf4
      do n=2,nt
       sstf(:,:,n)=sstf(:,:,1)
      enddo
      where( sstf == spv) sstf=spval
      call ncclos (ncid, iret)
      end subroutine




      subroutine  read_sstm_BB_dim(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      character (len=80) :: infile,name
      integer :: iret,ncid,sstfid,latid,lonid,n
      integer :: corner(4),edges(4),dims(4)
      infile = 
#ifdef prepare_for_BB_for_D3
     &'/users/model/ceden/dov3/N_atl/DS1_1/sst_mmean_ufo.cdf'
#endif
#ifdef prepare_for_BB_for_E1
     &'/users/model/ceden/dov3/N_atl/E5_bbl/sst_mmean_ufo.cdf'
#endif
      iret=nf_open(infile,NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'temp',sstfid)
      iret=NF_INQ_VARDIMID (NCID,sstfid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(4), nt)
      call ncclos (ncid, iret)
      end subroutine  read_sstm_BB_dim




      subroutine  read_sstm_BB(sstf,x,y,nx,ny,nt,spval)
      implicit none
      integer nx,ny,nt
      real :: sstf(nx,ny,nt),x(nx),y(ny),spval
#include "netcdf.inc"
      character (len=80) :: infile,name
      integer :: iret,ncid,sstfid,latid,lonid,n
      integer :: corner(4),edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4) :: sstf4(nx,ny,nt),x4(nx),y4(ny),spv
#else
      real          :: sstf4(nx,ny,nt),x4(nx),y4(ny),spv
#endif

      infile = 
#ifdef prepare_for_BB_for_D3
     &'/users/model/ceden/dov3/N_atl/DS1_1/sst_mmean_ufo.cdf'
#endif
#ifdef prepare_for_BB_for_E1
     &'/users/model/ceden/dov3/N_atl/E5_bbl/sst_mmean_ufo.cdf'
#endif
      iret=nf_open(infile,NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'temp',sstfid)
      iret=NF_INQ_VARDIMID (NCID,sstfid,DIMS)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=NF_INQ_VARID (NCID, name, lonid)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=NF_INQ_VARID (NCID, name, latid)

      corner=1; edges(1)=nx; 
      iret= nf_get_vara_real (ncid,lonid ,corner,edges,x4);x=x4
      corner=1; edges(1)=ny; 
      iret= nf_get_vara_real (ncid,latid ,corner,edges,y4);y=y4

      iret = nf_get_att_real(ncid,sstfid, 'missing_value', spv)

      corner=(/1,1,1,1/); edges=(/nx,ny,1,nt/); 
      iret= nf_get_vara_real (ncid,sstfid ,corner,edges,sstf4)
      sstf=sstf4
      where( sstf == spv) sstf=spval
      call ncclos (ncid, iret)
      end subroutine




      subroutine write_tauBB_to_cdf(tau,nt,k)
!     write the k.th time level
!     if k=1 then define variables
      use prep_module
      implicit none
#include "netcdf.inc"
      integer nt,n,k
      real tau(imt,jmt,2)
      integer ncid,iret,i
      integer itauxid,itauyid,timedim,timeid,tstrtid,taveid
      integer lon_udim,lat_udim
      integer  corner(4), edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4) , allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      integer :: nn,dpm(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
      integer :: toffset = 0*365
      character(len=80) :: name,unit

      iret=nf_open('forcing.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)

      if (k==1) then

      print*,' defining variable for tauxBB,tauyBB in NetCDF file'
      iret=nf_redef(ncid)

      i=nt; timedim  = ncddef(ncid, 'time_tauBB', i, iret)

      dims(1)=timedim;i=1
      timeid = ncvdef (ncid,'time_tauBB', NCFLOAT,i,dims,iret)
      tstrtid = ncvdef (ncid,'tstrt_tauBB', NCFLOAT,i,dims,iret)
      taveid = ncvdef (ncid,'tave_tauBB', NCFLOAT,i,dims,iret)

      name = 'Time'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'long_name', NCCHAR, i, name, iret) 

      name = 'Start of averaging period'; i=len_trim(name)
      call ncaptc(ncid, tstrtid, 'long_name', NCCHAR, i, name, iret) 

      name = 'averaging period'; i=len_trim(name)
      call ncaptc(ncid, taveid, 'long_name', NCCHAR, i, name, iret) 

      name = 'days'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, taveid, 'units', NCCHAR, i, name, iret) 
      name = '01-JAN-0000 00:00:00'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'time_origin', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'time_origin', NCCHAR, i, name, iret) 

      name = 'no_leap'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'calendar_type',NCCHAR,i,name,iret) 
      name = 'tstrt_tauBB'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'start_ave_period',NCCHAR,i,name,iret) 
      name = 'tave_tauBB'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'ave_period',NCCHAR,i,name,iret) 
c
      iret=nf_inq_dimid(ncid,'Longitude_u',lon_udim)
      iret=nf_inq_dimid(ncid,'Latitude_u',lat_udim)
      dims(1) = Lon_udim; dims(2) = Lat_udim; dims(3) = timedim; i=3
      itauxid   = ncvdef (ncid,'tauxBB', NCFLOAT,i,dims,iret)
      itauyid   = ncvdef (ncid,'tauyBB', NCFLOAT,i,dims,iret)
      name = 'Zonal Wind Stress     '
      unit = 'dyn/cm^2'
      call dvcdf(ncid,itauxid,name,24,unit,16,spval)
      name = 'Meridional Wind Stress     '
      unit = 'dyn/cm^2'
      call dvcdf(ncid,itauyid,name,24,unit,16,spval)
      iret=nf_enddef(ncid)

      allocate(var(nt,1)); var(1,1)=dpm(1)+toffset
      do n=2,nt
       nn=mod(n-1,12)+1; var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      do n=1,nt
       nn=mod(n-1,12)+1; var(n,1)=var(n,1)-dpm(nn)/2.
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, timeid, corner, edges,var, iret)

      var(1,1)=toffset
      do n=2,nt
       nn=mod(n-2,12)+1; 
       var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, tstrtid, corner, edges,var, iret)

      do n=1,nt
       nn=mod(n-1,12)+1; 
       var(n,1)=dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, taveid, corner, edges,var, iret)
 
      deallocate(var)
      endif !k==1

      iret=nf_inq_varid(ncid,'tauxBB',itauxid)
      iret=nf_inq_varid(ncid,'tauyBB',itauyid)

      edges(1)=imt; edges(2)=jmt; corner=1
      allocate(var(imt,jmt) )
      corner(3)=k; edges(3)=1
      var=tau(:,:,1)
      where( var == spval ) var = spval+100.
      where( kmu==0 ) var=spval
      call ncvpt(ncid, itauxid, corner, edges,var, iret)
      var=tau(:,:,2)
      where( var == spval ) var = spval+100.
      where( kmu==0 ) var=spval
      call ncvpt(ncid, itauyid, corner, edges,var, iret)
      call ncclos (ncid, iret)
      deallocate(var)
      end subroutine



      subroutine write_trBB_to_cdf(hflx,nt)
      use prep_module
      implicit none
#include "netcdf.inc"
      integer nt,n
      real hflx(imt,jmt,nt)
      integer ncid,iret,i
      integer hflxid,timedim,timeid,tstrtid,taveid
      integer lon_tdim,lat_tdim
      integer corner(4), edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4) , allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      integer :: nn,dpm(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
      integer :: toffset = 0*365
      character(len=80) :: name,unit

      iret=nf_open('forcing.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      iret=nf_redef(ncid)

      i=nt; timedim  = ncddef(ncid, 'time_hflxBB', i, iret)

      dims(1)=timedim;i=1
      timeid = ncvdef (ncid,'time_hflxBB', NCFLOAT,i,dims,iret)
      tstrtid = ncvdef (ncid,'tstrt_hflxBB', NCFLOAT,i,dims,iret)
      taveid = ncvdef (ncid,'tave_hflxBB', NCFLOAT,i,dims,iret)

      name = 'Time'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'long_name', NCCHAR, i, name, iret) 

      name = 'Start of averaging period'; i=len_trim(name)
      call ncaptc(ncid, tstrtid, 'long_name', NCCHAR, i, name, iret) 

      name = 'averaging period'; i=len_trim(name)
      call ncaptc(ncid, taveid, 'long_name', NCCHAR, i, name, iret) 

      name = 'days'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, taveid, 'units', NCCHAR, i, name, iret) 
      name = '01-JAN-0000 00:00:00'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'time_origin', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'time_origin', NCCHAR, i, name, iret) 

      name = 'no_leap'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'calendar_type',NCCHAR,i,name,iret) 
      name = 'tstrt_hflxBB'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'start_ave_period',NCCHAR,i,name,iret) 
      name = 'tave_hflxBB'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'ave_period',NCCHAR,i,name,iret) 
c
      iret=nf_inq_dimid(ncid,'Longitude_t',lon_tdim)
      iret=nf_inq_dimid(ncid,'Latitude_t',lat_tdim)
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = timedim; i=3
      hflxid   = ncvdef (ncid,'hflxBB', NCFLOAT,i,dims,iret)

      name = 'Heat flux anomaly'
      unit = 'cal/s/cm**2'
      call dvcdf(ncid,hflxid,name,24,unit,16,spval)

      iret=nf_enddef(ncid)

      allocate(var(nt,1)); var(1,1)=dpm(1)+toffset
      do n=2,nt
       nn=mod(n-1,12)+1; var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      do n=1,nt
       nn=mod(n-1,12)+1; var(n,1)=var(n,1)-dpm(nn)/2.
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, timeid, corner, edges,var, iret)

      var(1,1)=toffset
      do n=2,nt
       nn=mod(n-2,12)+1; 
       var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, tstrtid, corner, edges,var, iret)

      do n=1,nt
       nn=mod(n-1,12)+1; 
       var(n,1)=dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, taveid, corner, edges,var, iret)

      edges(1)=imt; edges(2)=jmt; corner=1
      deallocate(var);allocate(var(imt,jmt) )
      do n=1,nt
       corner(3)=n; edges(3)=1
       var=hflx(:,:,n)
       call ncvpt(ncid,hflxid, corner, edges,var, iret)
      enddo
      call ncclos (ncid, iret)
      deallocate(var)
      end




      subroutine write_sstf_BB_to_cdf(hflx,nt)
      use prep_module
      implicit none
#include "netcdf.inc"
      integer nt,n
      real hflx(imt,jmt,nt)
      integer ncid,iret,i
      integer hflxid,timedim,timeid,tstrtid,taveid
      integer lon_tdim,lat_tdim
      integer corner(4), edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4) , allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      integer :: nn,dpm(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
      integer :: toffset = 0*365
      character(len=80) :: name,unit

      iret=nf_open('forcing.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      iret=nf_redef(ncid)

      i=nt; timedim  = ncddef(ncid, 'time_sstfBB', i, iret)

      dims(1)=timedim;i=1
      timeid = ncvdef (ncid,'time_sstfBB', NCFLOAT,i,dims,iret)
      tstrtid = ncvdef (ncid,'tstrt_sstfBB', NCFLOAT,i,dims,iret)
      taveid = ncvdef (ncid,'tave_sstfBB', NCFLOAT,i,dims,iret)

      name = 'Time'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'long_name', NCCHAR, i, name, iret) 

      name = 'Start of averaging period'; i=len_trim(name)
      call ncaptc(ncid, tstrtid, 'long_name', NCCHAR, i, name, iret) 

      name = 'averaging period'; i=len_trim(name)
      call ncaptc(ncid, taveid, 'long_name', NCCHAR, i, name, iret) 

      name = 'days'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, taveid, 'units', NCCHAR, i, name, iret) 
      name = '01-JAN-0000 00:00:00'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'time_origin', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'time_origin', NCCHAR, i, name, iret) 

      name = 'no_leap'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'calendar_type',NCCHAR,i,name,iret) 
      name = 'tstrt_sstfBB'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'start_ave_period',NCCHAR,i,name,iret) 
      name = 'tave_sstfBB'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'ave_period',NCCHAR,i,name,iret) 
c
      iret=nf_inq_dimid(ncid,'Longitude_t',lon_tdim)
      iret=nf_inq_dimid(ncid,'Latitude_t',lat_tdim)
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = timedim; i=3
      hflxid   = ncvdef (ncid,'sstf_BB', NCFLOAT,i,dims,iret)

      name = 'SST feedback pattern'
      unit = 'degC'
      call dvcdf(ncid,hflxid,name,24,unit,16,spval)

      iret=nf_enddef(ncid)

      allocate(var(nt,1)); var(1,1)=dpm(1)+toffset
      do n=2,nt
       nn=mod(n-1,12)+1; var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      do n=1,nt
       nn=mod(n-1,12)+1; var(n,1)=var(n,1)-dpm(nn)/2.
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, timeid, corner, edges,var, iret)

      var(1,1)=toffset
      do n=2,nt
       nn=mod(n-2,12)+1; 
       var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, tstrtid, corner, edges,var, iret)

      do n=1,nt
       nn=mod(n-1,12)+1; 
       var(n,1)=dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, taveid, corner, edges,var, iret)

      edges(1)=imt; edges(2)=jmt; corner=1
      deallocate(var);allocate(var(imt,jmt) )
      do n=1,nt
       corner(3)=n; edges(3)=1
       var=hflx(:,:,n)
       call ncvpt(ncid,hflxid, corner, edges,var, iret)
      enddo
      call ncclos (ncid, iret)
      deallocate(var)
      end




      subroutine write_sstm_BB_to_cdf(hflx,nt)
      use prep_module
      implicit none
#include "netcdf.inc"
      integer nt,n
      real hflx(imt,jmt,nt)
      integer ncid,iret,i
      integer hflxid,timedim,timeid,tstrtid,taveid
      integer lon_tdim,lat_tdim
      integer corner(4), edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4) , allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
c      integer, parameter :: lsstm = 4
c      integer :: nn,dpm(lsstm) = (/90,91,92,92/)
      integer, parameter :: lsstm = 12
      integer :: nn,dpm(lsstm) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
      integer :: toffset = 0*365
      character(len=80) :: name,unit

      iret=nf_open('forcing.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      iret=nf_redef(ncid)

      i=nt; timedim  = ncddef(ncid, 'time_sstmBB', i, iret)

      dims(1)=timedim;i=1
      timeid = ncvdef (ncid,'time_sstmBB', NCFLOAT,i,dims,iret)
      tstrtid = ncvdef (ncid,'tstrt_sstmBB', NCFLOAT,i,dims,iret)
      taveid = ncvdef (ncid,'tave_sstmBB', NCFLOAT,i,dims,iret)

      name = 'Time'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'long_name', NCCHAR, i, name, iret) 

      name = 'Start of averaging period'; i=len_trim(name)
      call ncaptc(ncid, tstrtid, 'long_name', NCCHAR, i, name, iret) 

      name = 'averaging period'; i=len_trim(name)
      call ncaptc(ncid, taveid, 'long_name', NCCHAR, i, name, iret) 

      name = 'days'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, taveid, 'units', NCCHAR, i, name, iret) 
      name = '01-JAN-0000 00:00:00'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'time_origin', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'time_origin', NCCHAR, i, name, iret) 

      name = 'no_leap'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'calendar_type',NCCHAR,i,name,iret) 
      name = 'tstrt_sstmBB'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'start_ave_period',NCCHAR,i,name,iret) 
      name = 'tave_sstmBB'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'ave_period',NCCHAR,i,name,iret) 
c
      iret=nf_inq_dimid(ncid,'Longitude_t',lon_tdim)
      iret=nf_inq_dimid(ncid,'Latitude_t',lat_tdim)
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = timedim; i=3
      hflxid   = ncvdef (ncid,'sstm_BB', NCFLOAT,i,dims,iret)

      name = 'mean SST'
      unit = 'degC'
      call dvcdf(ncid,hflxid,name,24,unit,16,spval)

      iret=nf_enddef(ncid)

      allocate(var(nt,1)); var(1,1)=dpm(1)+toffset
      do n=2,nt
       nn=mod(n-1,lsstm)+1; var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      do n=1,nt
       nn=mod(n-1,lsstm)+1; var(n,1)=var(n,1)-dpm(nn)/2.
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, timeid, corner, edges,var, iret)

      var(1,1)=toffset
      do n=2,nt
       nn=mod(n-2,lsstm)+1; 
       var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, tstrtid, corner, edges,var, iret)

      do n=1,nt
       nn=mod(n-1,lsstm)+1; 
       var(n,1)=dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, taveid, corner, edges,var, iret)

      edges(1)=imt; edges(2)=jmt; corner=1
      deallocate(var);allocate(var(imt,jmt) )
      do n=1,nt
       corner(3)=n; edges(3)=1
       var=hflx(:,:,n)
       call ncvpt(ncid,hflxid, corner, edges,var, iret)
      enddo
      call ncclos (ncid, iret)
      deallocate(var)
      end
#endif

#include "options.inc"

c---------------------------------------------------------------
c
c     A simple pelagic ecosystem model  (NPZD)
c     taken from Oschlies and Garcon, 1999, 
c                 Glob. Biogeochem. Cycles, 13, 135-160
c     acting as sources for dissolved inorganic carbon and oxygen
c
c     linked in the code in passive_tracer.F and in driver.F
c
c---------------------------------------------------------------



c local cpp options
c#define test_minmax
#define prevent_tracer_from_zero
c
c put any detritus at bottom to zero (into sediment)
c to prevent spurious accumulation at shelfs
c
c#define detritus_sedimentation
c another, more realistic version
c#define detritus_slow_sedimentation
c
c account for denitrification in case of low oxygen concentration
c
c#define denitrification
c
c
c delta CO_2 concentration depends also on sea level pressure
c account for that
c#define account_for_slp_in_co2_flux
c
c atmospheric pCO2 depends on latitude and season
c account for that
c#define account_for_seasonality_in_pco2
c
c
c default is wanninkhof 92 for piston velocity
c#define use_wanninkhof99
c
#define use_fast_co2_subr
c
      module npzd_module
      implicit none

      real :: alphabio = 0.025 /86400. ! add docu for biological parameters
      real :: abio     = 0.6   /86400.
      real :: bbio     = 1.066
      real :: cbio     = 1.0
      real :: dbio     = 2500.0
      real :: gbio     = 2.0  /86400.
      real :: epsbio   = 1.0  /86400.
      real :: a_npz    = 0.75
      real :: d_npz    = 0.03 /86400.
      real :: parbio   = 0.43
      real :: rk1bio   = 0.5
      real :: phiphy   = 0.03 /86400.
      real :: phizoo   = 0.20 /86400.
      real :: remina   = 0.05 /86400.
      real :: remina_slow   = 1./365. /86400.
      real :: w_detr   = 5.0  /86400.* 100.0
      real :: dkcbio   = 0.03

      real :: s_doc = 1./50.0/86400.0 ! production rate of DOC
      real :: r_doc = 1./800.0 /86400.0 ! reminarilisation rate for DOC

      integer :: ts_npzd ! number of time steps within NPZD model
      integer :: kmeuph  ! deepest level of  euphotic zone
c
c   Atmpospheric carbon dioxide partial pressure
c   in yearly intervals, from 1765 extending to the year 2200. Data are
c   from the spline fit to ico-core measurements of Friedli
c   et al., and the Mauna Loa observations by Keeling et al.,
c   combined with the IPCC scenario S650 (This scenario ends
c   at a steady concentration of 650 ppm in the year 2200).
c   PCO2(I) is the partial pressure in the middle of the year I
c   (i.e. year I + 0.5).

      real :: pco2_air_fixed = 278.0 ! fixed value instead of time series
      real :: pco2_air               ! actual value for both time series and fixed value
      integer :: pco2series_index   ! pointer for the interpolation method
      integer,parameter :: pco2series_dim=2200-1765+1
#ifdef notdef
      real :: pco2series(pco2series_dim) = (/
     &    277.965, 277.995, 278.027, 278.063, 278.101, 278.142, 278.186, ! - 1771
     &    278.233, 278.284, 278.337, 278.393, 278.452, 278.514, 278.579, ! - 1778
     &    278.648, 278.719, 278.794, 278.872, 278.953, 279.038, 279.125, ! - 1785
     &    279.216, 279.311, 279.409, 279.510, 279.614, 279.722, 279.833, ! - 1892
     &    279.948, 280.066, 280.188, 280.313, 280.441, 280.573, 280.708, ! - 1799
     &    280.845, 280.984, 281.124, 281.266, 281.408, 281.551, 281.693, ! - 1806
     &    281.835, 281.976, 282.116, 282.254, 282.390, 282.523, 282.653, ! - 1764+7*7
     &    282.779, 282.902, 283.021, 283.134, 283.244, 283.349, 283.452, ! - 1764+7*8
     &    283.551, 283.648, 283.743, 283.836, 283.929, 284.020, 284.112, ! - 1764+7*9
     &    284.203, 284.296, 284.390, 284.486, 284.584, 284.686, 284.791, ! - 1764+7*10 = 1834
     &    284.900, 285.013, 285.132, 285.256, 285.387, 285.523, 285.665, ! - 1764+7*11
     &    285.809, 285.953, 286.097, 286.239, 286.379, 286.516, 286.650, ! - 1764+7*12
     &    286.781, 286.909, 287.033, 287.154, 287.272, 287.387, 287.497, ! - 1764+7*13
     &    287.605, 287.711, 287.816, 287.920, 288.025, 288.131, 288.239, ! - 1764+7*14 = 1862
     &    288.350, 288.465, 288.584, 288.708, 288.838, 288.974, 289.115, ! - 1764+7*15
     &    289.262, 289.416, 289.576, 289.744, 289.919, 290.101, 290.292, ! - 1764+7*16
     &    290.490, 290.695, 290.908, 291.128, 291.354, 291.586, 291.824, ! - 1764+7*17
     &    292.066, 292.312, 292.562, 292.815, 293.071, 293.328, 293.586, ! - 1764+7*18
     &    293.843, 294.098, 294.350, 294.599, 294.842, 295.082, 295.320, ! - 1764+7*19
     &    295.558, 295.796, 296.038, 296.283, 296.535, 296.793, 297.061, ! - 1764+7*20 = 1904
     &    297.336, 297.620, 297.909, 298.204, 298.504, 298.806, 299.111, ! - 1764+7*21
     &    299.419, 299.728, 300.040, 300.352, 300.666, 300.980, 301.294, ! - 1764+7*22 = 1918
     &    301.609, 301.923, 302.237, 302.551, 302.863, 303.172, 303.478, ! - 1764+7*23
     &    303.780, 304.076, 304.367, 304.651, 304.931, 305.207, 305.478, ! - 1764+7*24
     &    305.747, 306.013, 306.280, 306.546, 306.815, 307.087, 307.365, ! - 1764+7*25 = 1939
     &    307.649, 307.942, 308.244, 308.559, 308.886, 309.227, 309.582, ! - 1764+7*26 = 1946
     &    309.954, 310.341, 310.746, 311.170, 311.612, 312.075, 312.559, ! - 1764+7*27 = 1953
     &    313.065, 313.596, 314.151, 314.733, 315.343, 315.981, 316.644, ! - 1764+7*28 = 1960
     &    317.327, 318.024, 318.738, 319.483, 320.275, 321.125, 322.038, ! - 1764+7*29 = 1967
     &    323.013, 324.052, 325.149, 326.294, 327.481, 328.697, 329.930, ! - 1764+7*30 = 1974
     &    331.189, 332.492, 333.847, 335.250, 336.687, 338.148, 339.625, ! - 1764+7*31 = 1981
     &    341.122, 342.646, 344.202, 345.792, 347.419, 349.084, 350.770, ! - 1764+7*32 = 1988
     &    352.470, 354.170, 355.874, 357.587, 359.309, 361.040, 362.779, ! - 1764+7*33 = 1995
     &    364.526, 366.282, 368.046, 369.818, 371.598, 373.386, 375.183, ! - 1764+7*34 = 2002
     &    376.987, 378.799, 380.618, 382.445, 384.280, 386.122, 387.971, ! - 1764+7*35
     &    389.827, 391.691, 393.561, 395.438, 397.321, 399.211, 401.108, ! - 1764+7*36
     &    403.010, 404.919, 406.833, 408.754, 410.680, 412.612, 414.549, ! - 1764+7*37
     &    416.491, 418.438, 420.390, 422.347, 424.308, 426.274, 428.244, ! - 1764+7*38
     &    430.217, 432.195, 434.176, 436.161, 438.149, 440.140, 442.134, ! - 1764+7*39
     &    444.131, 446.130, 448.132, 450.135, 452.141, 454.148, 456.156, ! - 1764+7*40 = 2044
     &    458.166, 460.177, 462.188, 464.200, 466.213, 468.225, 470.238, ! - 1764+7*41
     &    472.250, 474.261, 476.272, 478.281, 480.289, 482.296, 484.301, ! - 1764+7*42
     &    486.304, 488.304, 490.302, 492.298, 494.290, 496.279, 498.264, ! - 1764+7*43
     &    500.246, 502.224, 504.197, 506.166, 508.130, 510.089, 512.043, ! - 1764+7*44
     &    513.991, 515.933, 517.869, 519.799, 521.722, 523.638, 525.548,
     &    527.450, 529.344, 531.230, 533.108, 534.978, 536.839, 538.692,
     &    540.535, 542.369, 544.193, 546.007, 547.811, 549.605, 551.388,
     &    553.160, 554.921, 556.671, 558.409, 560.136, 561.850, 563.552,
     &    565.242, 566.919, 568.583, 570.234, 571.872, 573.496, 575.106,
     &    576.703, 578.285, 579.853, 581.407, 582.945, 584.469, 585.978,
     &    587.471, 588.949, 590.411, 591.858, 593.289, 594.703, 596.101,
     &    597.483, 598.849, 600.197, 601.529, 602.844, 604.142, 605.422,
     &    606.686, 607.932, 609.160, 610.371, 611.564, 612.739, 613.896,
     &    615.035, 616.156, 617.259, 618.344, 619.411, 620.459, 621.488,
     &    622.499, 623.492, 624.466, 625.422, 626.358, 627.276, 628.176,
     &    629.057, 629.919, 630.762, 631.587, 632.392, 633.179, 633.948,
     &    634.697, 635.428, 636.140, 636.834, 637.509, 638.165, 638.803,
     &    639.422, 640.023, 640.605, 641.169, 641.714, 642.242, 642.751,
     &    643.242, 643.714, 644.169, 644.606, 645.025, 645.427, 645.811,
     &    646.177, 646.525, 646.857, 647.170, 647.467, 647.747, 648.010,
     &    648.255, 648.485, 648.697, 648.893, 649.072, 649.236, 649.383,
     &    649.514, 649.629, 649.728, 649.812, 649.880, 649.933, 649.970,
     &    649.993, 650.000 /)
#else
      real :: pco2series(pco2series_dim) 
#endif
c
c   local array for pCO2 air-sea difference (all calulated in npzd_sflx)
c
      real, allocatable :: diff_co2(:,:) ! in mol/m^3
      real, allocatable :: pco2_water(:,:) ! partial pressure of surface CO2  (ppmv)
      real, allocatable :: o2_sat(:,:)  ! O2 saturation concentration at sea surface
c
c    frequency (in time steps) of updates for diff_co2/pco2_water
c
      integer  :: pco2_update_int = 10
c
c   Redfield ratio of C/N
c
      real :: redfield_CN = 6.6
      real :: redfield_CN2 = 15
c
c   Redfield ratio of O/N
chd   oxygen concentrations are in ml/l; donstant
chd   redfieldratio of N/O2=1/10 (ocmip) is assumed;
chd   it is: mlO2/l = 10*22.3916/1000 mmolN/m^3 
c
      real :: redfield_ON = 0.223916

#ifdef denitrification
c
c   treshold of oxygen for denitrification
c
      real :: o2_threshold = 0.08
#endif
c
c    diagnostic array
c
      real, allocatable  :: dnut_diag(:,:,:)

      end module npzd_module


      subroutine npzd_init
c---------------------------------------------------------------
c   Initialization of the NPZD module
c---------------------------------------------------------------
      use spflame_module
      use passive_tracer_module
      use npzd_module
      implicit none

      type( time_type) :: start
      type( time_type), allocatable :: interval(:)
      integer :: indp,k,n

      if (my_pe == 0) then
       print*,''
       print*,' Initialization of NPZD model'
       print*,''
      endif
c
c   display mapping of tracer number to biological variable
c
      if (my_pe==0) then
       print*,' Tracer # ',n_npzd(1),' will be nutrient'
       print*,' Tracer # ',n_npzd(2),' will be phytoplancton'
       print*,' Tracer # ',n_npzd(3),' will be zooplancton'
       print*,' Tracer # ',n_npzd(4),' will be detritus'
       print*,'  (',n_nutrient,n_phyto,n_zoo,n_detritus,')'
       if (enable_co2) then
        print*,' Tracer # ',n_co2,' will be dissolved inorganic carbon'
       endif
       if (enable_o2) then
        print*,' Tracer # ',n_o2,' will be total dissolved oxygen'
       endif
       if (enable_doc) then
        print*,' we have DOC as part of the NPZD model'
        print*,' Tracer # ',n_doc,' will be dissolved organic carbon'
       endif
c    print out values of parameters for NPZD
       print*,' the parameter for the ecosystem model:'
       print*,' alphabio = ',alphabio*86400,' 1/days' 
       print*,' abio     = ', abio* 86400., ' 1/days'
       print*,' bbio     = ', bbio 
       print*,' cbio     = ', cbio 
       print*,' dbio     = ', dbio
       print*,' gbio     = ', gbio*86400.,' 1/days'
       print*,' epsbio   = ',epsbio*86400.,' 1/days'
       print*,' a_npz    = ',a_npz
       print*,' d_npz    = ',d_npz*86400., ' 1/days'
       print*,' parbio   = ',parbio
       print*,' rk1bio   = ',rk1bio
       print*,' dkcbio   = ',dkcbio
       print*,' phiphy   = ',1./phiphy/86400.,' days'
       print*,' phizoo   = ',1./phizoo/86400.,' days'
       print*,' remina   = ',1./remina/86400.,' days'
       print*,' w_detr   = ',w_detr *86400./100.0 ,' m/day'
      endif
c
c   time step for NPZD model
c
      ts_npzd=max(1,nint(time_step*2. / 900.))
      if (my_pe==0) then
       print*,' NPZD model will do ',ts_npzd,' time steps'
       print*,' time step in NPZD model will be ',
     &          time_step/ts_npzd,'sec.'
      endif
c
c   Depth of euphotic zone
c
      kmeuph = indp(200.0e2,zt,km)
      if (my_pe==0) 
     &    print*,' depth of euphotic zone ',zt(kmeuph)/100.0,'m'

      if (enable_co2 .and. enable_pco2_series) then
c
c    interpolation setup for atmospheric partial pressure of CO2
c
       if (my_pe==0) then
         print*,' using realistic time series of atmospheric CO2 '
         print*, 'for suface fluxes of dissolved inorganic carbon'
         print*, 'time series starts in (model) year ',ref_year_co2
       endif

       start = set_date(ref_year_co2,1, 1, 0 , 0 ,0)
       allocate(interval(pco2series_dim))

       if (get_calendar_type() == THIRTY_DAY_MONTHS ) then
        do k=1,pco2series_dim
         call set_time(interval(k), 0, 360 )
        enddo
       elseif (get_calendar_type() == NO_LEAP ) then
        do k=1,pco2series_dim
         call set_time(interval(k), 0, 365 )
        enddo
       else 
        print*,' wrong calendar type for CO2'
        call halt_stop(' in npzd_init')
       endif

       call init_forcing_interp(pco2series_dim,.false.,
     &                          start,interval,pco2series_index)
       deallocate(interval)

       if (my_pe==0) then
        print*,' reading time series of atmospheric CO2 '
        print*,' from file pco2_series.dta'
       endif

       call getunit(n,'pco2_series.dta','fsr')
       do k=1,pco2series_dim
        read(n, * ) pco2series(k)
       enddo
       close(n)

      endif ! enable_co2 and enable pco2_series

      if (enable_co2 .and. .not. enable_pco2_series .and. my_pe==0) then
         print*,' using a fixed value for atmospheric CO2 '
         print*, ' pco2_air_fixed =  ',pco2_air_fixed
      endif

      if (enable_co2) then
       allocate( diff_co2( is_pe:ie_pe, js_pe:je_pe ) )
       allocate( pco2_water( is_pe:ie_pe, js_pe:je_pe ) )
       diff_co2=0.0; pco2_water=0.0
       if (my_pe==0) then
         print*,' updating air-sea difference of CO2 concentration',
     &            ' every ',pco2_update_int,' model time step'
         print*,' Redfield ratio of C/N = ',redfield_CN
       endif
      endif

      if (enable_o2) then
       allocate( o2_sat( is_pe:ie_pe, js_pe:je_pe ) )
       o2_sat = 0.0 ! diagnostic array
       if (my_pe==0) print*,' Redfield ratio of O/N = ',redfield_ON
      endif

      if (enable_doc) then
        if (my_pe == 0) then
          print*,' Okay, DOC is modeled as well ...'
          print*,' decay rate of DOC is ',1./r_doc/86400.,' days'
          print*,' production rate of DOC ',1./s_doc/86400.,'days'
          print*,' CN of DOC is ',redfield_CN2
        endif
      endif

      if (enable_diag_npzd) then
       if (my_pe==0) then
        print*,' diagnosing monthly means of npzd model'
       endif
       call init_npzd_averages()
       allocate( dnut_diag(is_pe:ie_pe,km,js_pe:je_pe) )
       dnut_diag = 0.
      endif

      if (my_pe==0) then
#ifdef detritus_sedimentation
        print*,' put any detritus at bottom to zero (into sediment)'
        print*,' to prevent spurious accumulation at shelfs'
#endif
#ifdef detritus_slow_sedimentation
        print*,' put detritus at bottom to zero (into sediment)'
        print*,' with a e-folding time scale of ',
     &                  1./remina_slow/86400.,' days'
#endif
#ifdef denitrification
        print*,' account for denitrification in case of '
        print*,' low oxygen concentration of ',o2_threshold
#endif
#ifdef prevent_tracer_from_zero
        print*,' put negative values of biological variables to zero'
#endif
        print*,' account for the dilutive effect of salt flux'
        print*,' account for bug in CO2 fluxes'
#ifdef account_for_slp_in_co2_flux
        print*,' account for slp calculating CO2 fluxes'
#endif
#ifdef account_for_seasonality_in_pco2
        print*,' account for seasonality in atmos. pCO2'
#endif
#ifdef use_wanninkhof99
        print*,' using Wanninkhof+McGillis 99 for piston velocity'
#else
        print*,' using Wanninkhof 92 for piston velocity'
#endif
#ifdef use_fast_co2_subr
       print*,' using fast routine for surface DIC-Eq. calculation'
#endif

      endif
      if (my_pe == 0) print*,  'done'

      end subroutine npzd_init


      subroutine npzd_sflx
c---------------------------------------------------------------
c   apply surface fluxes for biological variables
c---------------------------------------------------------------
      use spflame_module
      use passive_tracer_module
      use npzd_module
      implicit none
      integer :: n,i,j,is,ie,js,je,p1,p2
      real, dimension(is_pe:ie_pe) :: kw,sc,slp
      real :: f1,f2,pco2_atmos
      logical, save :: init = .true.

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do n=1,nt_npzd
c    no surface flux for biological tracers
       do j=js,je
         do i=is,ie
           stf(i,j,n_npzd(n)) = 0.0
         enddo
       enddo
      enddo

      if (enable_co2) then
c    calculate CO2 surface flux
       if (enable_pco2_series) then
        call forcing_interp(pco2series_index,p1,p2,f1,f2)
        pco2_air=pco2series(p1)*f1+pco2series(p2)*f2
       else
        pco2_air = pco2_air_fixed
       endif

       do j=js,je
#ifdef use_wanninkhof99
        call wanninkhof99(
#else
        call wanninkhof(
#endif
     &    t(is,1,j,1,tau),stf_rest(is,j,n_co2),kw(is),ie-is+1)

        if (init.or. mod(itt,pco2_update_int)==0)  then
#ifdef account_for_slp_in_co2_flux
         slp(is:ie)=stf_clim(is:ie,j,n_co2)
         where( tmask(is:ie,1,j) == 0.0 ) slp(is:ie)=1.0
#else
         slp(is:ie)=1013.25
#endif

#ifdef account_for_seasonality_in_pco2

       if (get_calendar_type() == THIRTY_DAY_MONTHS ) then
         f1 = get_day_of_year(get_current_time())*1.0/360.
       elseif (get_calendar_type() == NO_LEAP ) then
         f1 = get_day_of_year(get_current_time())*1.0/365.
       else 
         print*,'ERROR: wrong calendar type '
         call halt_stop(' in npzd_flux (file npzd_model.F)')
       endif
c
c    Seasonality in atmos. pCO2 depends on latitude
c    and there is also a constant latitudinal gradient
c    (after Conway et al 1994, JGR)
c
        pco2_atmos =  pco2_air
     &   +(7.6558*(tanh( (yt(j)-24.7554)/ 26.5702 ) +1) +1.3971)
     &      *(0.9626*sin(f1*2*pi-0.1349)
     &       -0.2708*sin(f1*4*pi-0.5242)   )
     &   -yt(j)**3*2.6829e-06 + yt(j)**2*3.3458e-05
     &   +yt(j)*0.0353 + 1.2472
#else
         pco2_atmos = pco2_air
#endif

#ifdef use_fast_co2_subr
         call co2calc_fast(t(is,1,j,1,tau),t(is,1,j,2,tau),
#else
         call co2calc(t(is,1,j,1,tau),t(is,1,j,2,tau),
#endif
     &                t(is,1,j,n_co2,taum1),t(is,1,j,n_nutrient,tau),
     &                slp(is),ie-is+1,pco2_atmos,
     &                diff_co2(is,j),pco2_water(is,j))
        endif
        call schmidt_co2(t(is,1,j,1,tau),sc(is),ie-is+1)
        do i=is,ie
         kw(i) = kw(i)*sqrt(660.0/sc(i))/3600.0
         stf(i,j,n_co2)= kw(i) * diff_co2(i,j) *1000 ! dco2 comes in mol/m^3 instead of mmol/m^3
        enddo
       enddo ! j

c
c    For all rigid lid models we must take into account the concentration
c    dilution effect of the salt flux
c    but add this term as a source term in the first model
c    level instead to the surface fluxes.
c    This is done in routine npzd_model.
c

      endif ! enable_co2

      if (enable_o2) then
c    calculate O2 surface flux
       do j=js,je
#ifdef use_wanninkhof99
        call wanninkhof99(
#else
        call wanninkhof(
#endif
     &     t(is,1,j,1,tau),stf_rest(is,j,n_o2),kw(is),ie-is+1)
        call schmidt_o2(t(is,1,j,1,tau),sc(is),ie-is+1)
        call eqconc_o2(t(is,1,j,1,tau),t(is,1,j,2,tau), 
     &                     o2_sat(is,j),ie-is+1)
        do i=is,ie
         kw(i) = kw(i)*sqrt(660.0/sc(i))/3600.0
         stf(i,j,n_o2)= kw(i) * (o2_sat(i,j) -t(i,1,j,n_o2,taum1) )
        enddo
       enddo ! j
      endif ! enable_o2

      if (init) init = .false.
      end subroutine npzd_sflx


      subroutine npzd_model
c---------------------------------------------------------------
c   time step the NPZD model
c---------------------------------------------------------------
      use spflame_module
      use passive_tracer_module
      use npzd_module
      implicit none
      integer :: i,k,j,n,is,ie,js,je
      real :: daylen,dtsb,cobeta
      real :: fx1,fx2,fx3,fx4,fu1,fu2,vpbio,radbio
      real :: adv_fb(is_pe:ie_pe,0:km)
      real :: betaf(is_pe:ie_pe,0:km+1)
      real :: rayb(0:km)
      real :: avej(is_pe:ie_pe,km)
      real :: biotr(is_pe:ie_pe,km,nt_npzd),dnut(is_pe:ie_pe,km)
      real :: ddet(is_pe:ie_pe,km),biodoc,drem(is_pe:ie_pe,km)
      real :: o2mask(is_pe:ie_pe,km)
      real :: bion,biop,bioz,biod,u_npz,g_npz
      real :: denom
      real :: s_ref,dic_ref,exu,resp,cn2
      real :: maxtr(nt_npzd)
      real :: mintr(nt_npzd)
      integer :: maxtr_ijk(nt_npzd,3)
      integer :: mintr_ijk(nt_npzd,3)

      integer :: nn_o2,nn_co2,nn_doc  ! pointer to CO2, O2, DOC in nt_npzd

      logical, save :: init = .true.

      k=4 ! construct pointer to CO2,O2 in nt_npzd
      if (enable_co2) then
          nn_co2=k+1; k=k+1  ! always # 5
      endif
      if (enable_o2) then
          nn_o2=k+1; k=k+1  ! sometimes 5, else 6
      endif
      if (enable_doc) then
          nn_doc=k+1; k=k+1  ! it depends
      endif

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c   treatment of open boundaries: 
c   deactivate  biol. model there, cut off negative values
c
      if (my_blk_j == 1 .and. enable_obc_south) then
       j=2 ; js=3
       do n=1,nt_npzd
        do k=1,km
         do i=is,ie
           t(i,k,j,n_npzd(n),taup1) = max(0.0,t(i,k,j,n_npzd(n),taup1))
         enddo
        enddo
       enddo
      endif

      if (my_blk_j == n_pes_j .and. enable_obc_north) then
       j=jmt-1 ; je=jmt-2
       do n=1,nt_npzd
        do k=1,km
         do i=is,ie
           t(i,k,j,n_npzd(n),taup1) = max(0.0,t(i,k,j,n_npzd(n),taup1))
         enddo
        enddo
       enddo
      endif

      if ( my_blk_i == 1 .and. enable_obc_west) then
       i=2; is=3
       do n=1,nt_npzd
        do j=js,je
         do k=1,km
           t(i,k,j,n_npzd(n),taup1) = max(0.0,t(i,k,j,n_npzd(n),taup1))
         enddo
        enddo
       enddo
      endif

      if ( my_blk_i == n_pes_i .and. enable_obc_east) then
       i=imt-1; ie=imt-2
       do n=1,nt_npzd
        do j=js,je
         do k=1,km
           t(i,k,j,n_npzd(n),taup1) = max(0.0,t(i,k,j,n_npzd(n),taup1))
         enddo
        enddo
       enddo
      endif

#ifdef test_minmax
c
c   test global min/max before biol. model
c
      maxtr=-1e15; mintr= 1e15; maxtr_ijk = -1; mintr_ijk = -1
      do n=1,nt_npzd
       do j=js,je
        do k=1,km
          do i=is,ie
            if (maxtr(n) < t(i,k,j,n_npzd(n),taup1) ) then
              maxtr(n) = t(i,k,j,n_npzd(n),taup1)
              maxtr_ijk(n,:) = (/i,j,k/)
            endif
            if (mintr(n) > t(i,k,j,n_npzd(n),taup1) ) then
              mintr(n) = t(i,k,j,n_npzd(n),taup1)
              mintr_ijk(n,:) = (/i,j,k/)
            endif
          enddo
        enddo
       enddo
       print'(a,i3,a,f12.8,a,i3,i3,i3)',
     &   ' min tr(phys) ',n,' : ' ,mintr(n),' (i,j,k)=',mintr_ijk(n,:)
      enddo 
#endif

      if (enable_diag_npzd) dnut_diag=0.0
c
c   time step within NPZD model
c
      dtsb=c2dt/float(ts_npzd)  
      do j=js,je

       call get_daylen(j,daylen,cobeta)
       daylen=max(1.e-12,daylen)
c
c    compute daily averaged light-limited growth rate
c    analytical integration over layer thickness and day
c    after Evans and Parslow (1985)
c
       avej(:,:)= 0.0
       fx1 = 0.5*daylen*daylen/alphabio
       rayb(0) = 1.0
       do k=1,km 
        rayb(k)= exp(-zw(k)/(cobeta*dbio))
       enddo

       do k=1,kmeuph
        do i=is,ie
          radbio = max(1.0,parbio*stf_clim(i,j,n_npzd(1)))
          vpbio = abio*bbio**(cbio*t(i,k,j,1,tau))
          fx3 = fx1*vpbio/(radbio*rayb(k-1))
          fx4 = fx1*vpbio/(radbio*rayb(k))
          fu1 = sqrt(fx3**2.+daylen**2.)
          fu1 = fu1-daylen*log((daylen+fu1)/fx3)
          fu2 = sqrt(fx4**2.+daylen**2.)
          fu2 = fu2-daylen*log((daylen+fu2)/fx4)
          avej(i,k) = -1.*vpbio/dzt(k) * cobeta*dbio
     &                    *(fu1 - fu2 - fx3 + fx4)
        enddo
       enddo
c
c    transfer tracer at tau-1 to temporary arrays
c
       do n=1,nt_npzd
        do k=1,km
          do i=is,ie
            biotr(i,k,n) = t(i,k,j,n_npzd(n),taum1) 
          enddo
        enddo
       enddo
c
c    begin time stepping over 2*dt in NPZD model with Euler forward
c
       do n = 1,ts_npzd
c
c     This is the NPZD model:
c      (P: phytoplankton, Z: Zooplankton, N: Nitrate and D: Detritus)
c
c      dP/dt = u(N,Temp.,Light) P - p_P P - g(P) P Z 
c
c      dZ/dt = a g(P) P Z - d Z - p_Z Z^2
c
c      dN/dt = r D + d Z - u(N,Temp.,Light) P  [ + r_d DOC ]
c
c      dD/dt = (1-s)[ (1-a) g(P) P Z + p_P P + p_Z Z^2] -r D + w_D dD/dz
c
c     optional (for s>0) is dissolved organic carbon (DOC):
c      dDOC/dt =   s[ (1-a) g(P) P Z + p_P P + p_Z Z^2] -r_d DOC  
c
#ifdef denitrification
        o2mask=1.0
        if (enable_o2) then
c
c     If O2 falls below a small threshold, remineralisation
c     is done using NO3 instead of O2. Therefore account for that
c     process by subtracting 6.67 r D from N budget. The grazing function
c     for activity of zoo plankton is also set to zero in that case.
c     Contruct a mask to handle denitrification
c
         do k=1,km
          do i=is,ie
            if (biotr(i,k,nn_o2) <= o2_threshold) 
     &        o2mask(i,k)=1.0-tmask(i,k,j)
          enddo
         enddo
        endif
#endif

        do k=1,km
         do i=is,ie
c
#ifdef prevent_tracer_from_zero
          bion = max(0.0,biotr(i,k,1))
          biop = max(0.0,biotr(i,k,2))
          bioz = max(0.0,biotr(i,k,3))
          biod = max(0.0,biotr(i,k,4))
#else
          bion = biotr(i,k,1)
          biop = biotr(i,k,2)
          bioz = biotr(i,k,3)
          biod = biotr(i,k,4)
#endif
c
c   -- phytoplankton equation
c
c      use Liebigs Law of the Minimum (Liebig, 1845) for growth rate
c      (minimum of light-limited and nutrient limited growth rates; 
c      although chlorophyll is not explicitly considered, this will 
c      later allow for a diagnostic determination of a Chl:N ratio 
c      depending on light- or nutrient-limited growth. 
c      --> Hurtt and Armstrong, 1996)
c      saturation growth rate (infinite light, infinite nutrients)
          vpbio = abio*bbio**(cbio*t(i,k,j,1,tau))
c      growth rate
          u_npz = min(avej(i,k),vpbio*bion/(rk1bio+bion))
c      grazing function
          g_npz = gbio*epsbio*biop/(gbio+epsbio*biop*biop)
#ifdef denitrification
     &         *o2mask(i,k)
c      In case of low oxygen, activity of zoo plankton is set to zero 
#endif
c
          biotr(i,k,2) = biotr(i,k,2) + dtsb * biop * (
     &         u_npz - phiphy - g_npz*bioz )*tmask(i,k,j)
c
c   -- zooplankton equation
c
          biotr(i,k,3) = biotr(i,k,3) + dtsb * bioz * (
     &         a_npz*g_npz*biop - d_npz - phizoo*bioz )*tmask(i,k,j)
c
c   -- nutrient equation
c
          dnut(i,k)    =   (remina*biod + d_npz*bioz - u_npz*biop)
     &                         *dtsb*tmask(i,k,j)
          biotr(i,k,1) = biotr(i,k,1) + dnut(i,k)
c
c   -- detritus equation
c
          ddet(i,k) = (1.-a_npz)*g_npz*biop*bioz 
     &                + phiphy*biop + phizoo*bioz*bioz
          drem(i,k) = remina*biod
          biotr(i,k,4) = biotr(i,k,4) 
     &       + dtsb * (ddet(i,k) - drem(i,k) )*tmask(i,k,j)
         enddo
        enddo

#ifdef denitrification
c
c     If O2 falls below a small threshold, remineralisation
c     is done using NO3 instead of O2. Therefore account for that
c     process by subtracting 6.67 r D from N budget. If NO3 falls
c     below zero, other processes are taking over. Set NO3 to zero
c     in that case.
c
        do k=1,km
         do i=is,ie
          biotr(i,k,1) = max(0.0,   biotr(i,k,1)-
     &         (1.0-o2mask(i,k))*drem(i,k)*6.67*dtsb*tmask(i,k,j))
         enddo
        enddo
c
c     note that the array dnut is not affected by this process
c
#endif



        if (enable_co2) then
c
c     change CO2 according to a constant Redfield ratio 
c
         do k=1,km
          do i=is,ie
           biotr(i,k,nn_co2)=biotr(i,k,nn_co2)+redfield_CN*dnut(i,k)
          enddo
         enddo
        endif

        if (enable_o2) then
c
c     Change oxygen concentration due to biological activity
chd   oxygen concentrations are in ml/l; donstant
chd   redfieldratio of N/O2=1/10 (ocmip) is assumed;
chd   it is: mlO2/l = 10*22.3916/1000 mmolN/m^3 
c
         do k=1,km
          do i=is,ie
           biotr(i,k,nn_o2) = biotr(i,k,nn_o2) - redfield_ON*dnut(i,k)
#ifdef denitrification
     &     + drem(i,k)*dtsb*tmask(i,k,j)*(1.0-o2mask(i,k))*redfield_ON
c      do not change oxygen by remineralisation anymore if o2<o2_threshold
#endif
          enddo
         enddo

        endif


        if (enable_doc) then
c
c   -- DOC equation
c 
         do k=1,km
          do i=is,ie
c          (0.05+50*tanh(N*50))
           bion  = biotr(i,k,1)
           biop  = biotr(i,k,2)
c           exu  = s_doc*biotr(i,k,2)
           exu = 5+99*tanh(bion*50)
           exu = 1./exu/86400.*biop
           resp = r_doc*biotr(i,k,nn_doc)
           biotr(i,k,nn_doc)=biotr(i,k,nn_doc)
     &             +(exu-resp)*dtsb*tmask(i,k,j)
c        correct other tracers:
c            DIN
           biotr(i,k,1)=biotr(i,k,1)+dtsb*tmask(i,k,j)*resp
c            P_N
           biotr(i,k,2)=biotr(i,k,2)-dtsb*tmask(i,k,j)*exu
c             O2
           biotr(i,k,nn_o2)=biotr(i,k,nn_o2)-dtsb*tmask(i,k,j)*
     &              (resp)*redfield_ON
c             CO2
c           cn2=redfield_CN2-(redfield_CN2-redfield_CN)*tanh(bion)
           biotr(i,k,nn_co2)=biotr(i,k,nn_co2)+dtsb*tmask(i,k,j)*
     &      ( redfield_CN2*resp - (redfield_CN2-redfield_CN)*exu )
          enddo
         enddo
        endif


        if (enable_diag_npzd) then
c
c     diagnose sinks/sources of nutrients to be averaged
c
         do k=1,km
          do i=is,ie
           dnut_diag(i,k,j)=dnut_diag(i,k,j)+dnut(i,k)
          enddo
         enddo
        endif

       enddo ! time steps
c
c    transfer from temporary arrays and add tendency to tracer at tau +1
c
       do n=1,nt_npzd
        do k=1,km
          do i=is,ie
#ifdef prevent_tracer_from_zero
           t(i,k,j,n_npzd(n),taup1) = max(0.0,
     &         t(i,k,j,n_npzd(n),taup1)  +
     &       ( biotr(i,k,n) - t(i,k,j,n_npzd(n),taum1 ) ) )
#else
           t(i,k,j,n_npzd(n),taup1) = 
     &         t(i,k,j,n_npzd(n),taup1)  +
     &       ( biotr(i,k,n) - t(i,k,j,n_npzd(n),taum1 ) ) 
#endif
          enddo
        enddo
       enddo
c
c    add tendency due to sinking of detritus
c
       n=n_npzd(4)
       do k=1,km-1
        do i=is,ie
	 adv_fb(i,k)=-w_detr*(t(i,k,j,n,tau) + t(i,k+1,j,n,tau))
        enddo
       enddo

c    no flux boundary conditions
       do i=is,ie
        adv_fb(i,0)       =0.0
        adv_fb(i,km)      =0.0
        adv_fb(i,kmt(i,j))=0.0
       enddo

c    compute delimiter for outgoing flux
       betaf=2.
       do k=1,km
        do i=is,ie
         denom =      -min(0.,adv_fb(i,k  )*dzt2r(k))
         denom = denom+max(0.,adv_fb(i,k-1)*dzt2r(k))

         denom = denom*c2dt
         denom = sign(1.,denom)*max(1.e-15,abs(denom)) ! should be positive anyway

         betaf(i,k)=t(i,k,j,n,taum1)/denom
        enddo
       enddo

c    delimit vertical flux
       do k=0,km
        do i=is,ie
           adv_fb(i,k)=
     &         min(1.,betaf(i,k  ))*min(0.,adv_fb(i,k))
     &       + min(1.,betaf(i,k+1))*max(0.,adv_fb(i,k))
        enddo
       enddo

       do k=1,km
        do i=is,ie
	  t(i,k,j,n,taup1) = t(i,k,j,n,taup1) - 
     &           c2dt*tmask(i,k,j)*(adv_fb(i,k-1) - adv_fb(i,k))
#ifdef partial_cell
     &               *.5/dht(i,k,j)
#else
     &               *dzt2r(k)
#endif
        enddo
       enddo

#ifdef detritus_sedimentation
c    put any detritus at bottom into sediment
       n=n_npzd(4)
       do i=is,ie
        t(i,km,j,n,taup1) = 0.0
       enddo
       do k=1,km-1
        do i=is,ie
         t(i,k,j,n,taup1) = tmask(i,k+1,j)*t(i,k,j,n,taup1)
        enddo
       enddo
#endif
#ifdef detritus_slow_sedimentation
c    different, sligthly more realistic formulation 
       n=n_npzd(4)
       do k=1,km-1
        do i=is,ie
         t(i,k,j,n,taup1) = t(i,k,j,n,taup1) - c2dt*
     &           t(i,k,j,n,taum1)*remina_slow*
     &             (1-tmask(i,k+1,j))*tmask(i,k,j)
        enddo
       enddo
       k=km
       do i=is,ie
         t(i,k,j,n,taup1) = t(i,k,j,n,taup1) - c2dt*
     &           t(i,k,j,n,taum1)*remina_slow*tmask(i,k,j)
       enddo
#endif

       if (enable_co2 .and. .not. enable_freesurf) then
c
c    For all rigid lid models we must take into account the concentration
c    dilution effect of the salt flux
c

c    stf(:,:,2)=dzt(1)/tau ( S* - SSS)
c    after OMIP abiotic-Howto:  E-P =  (S*-SSS)/S_ref *dz/tau
c                         and:  F_dic = DIC_ref*(E-P)
c  
c     (stf(,,2)*1000)/S_ref = E-P
c
c    for S*>SSS :  stf(,,2)>0
c    that means put salinity into ocean, take freshwater out of ocean
c    DIC concentration should increase ->  F_dic >0
c     -> should work 
c
c       do j=js,je
c        do i=is,ie
c         stf(i,j,n_co2)= stf(i,j,n_co2)
c     &                 + dic_ref*(stf(i,j,2)*1000)/s_ref
c        enddo
c       enddo ! j
         s_ref=35; dic_ref=2000.
         do i=is,ie
           s_ref=t(i,1,j,2,tau)*1000.0+35.0
           dic_ref = t(i,1,j,n_co2,tau)
           t(i,1,j,n_co2,taup1) = t(i,1,j,n_co2,taup1) + c2dt*
     &           dic_ref*(stf(i,j,2)*1000)/s_ref/dzt(1)*tmask(i,1,j)
         enddo 
       endif

      enddo ! j loop

#ifdef test_minmax
c
c   global min/max
c
      maxtr=-1e15; mintr= 1e15; maxtr_ijk = -1; mintr_ijk = -1
      do n=1,nt_npzd
       do j=js,je
        do k=1,km
          do i=is,ie
            if (maxtr(n) < t(i,k,j,n_npzd(n),taup1) ) then
              maxtr(n) = t(i,k,j,n_npzd(n),taup1)
              maxtr_ijk(n,:) = (/i,j,k/)
            endif
            if (mintr(n) > t(i,k,j,n_npzd(n),taup1) ) then
              mintr(n) = t(i,k,j,n_npzd(n),taup1)
              mintr_ijk(n,:) = (/i,j,k/)
            endif
          enddo
        enddo
       enddo
      enddo 

      print*,' max tracer : ',maxtr
      do n=1,nt_npzd
       print'(a,i3,a,f12.8,a,i3,i3,i3)',
     &   ' min tracer   ',n,' : ' ,mintr(n),' (i,j,k)=',mintr_ijk(n,:)
      enddo
#endif


       if (enable_diag_npzd) then
         dnut_diag= dnut_diag/c2dt  
         call npzd_averages()
       endif

      end subroutine npzd_model



      subroutine get_daylen(j,daylen,cobeta)
      use spflame_module
      implicit none
      integer, intent(in) :: j
      real, intent(out)   :: daylen,cobeta
      real :: fx1,fx2,timeyear,declin
c
c   solar declination 
c
      timeyear = get_day_of_year(get_current_time()) /365.
      fx1    = 2.0*pi*(timeyear-int(timeyear))
      declin = 0.006918
     &      -0.399912*cos(   fx1)+0.070257*sin(   fx1)
     &      -0.006758*cos(2.*fx1)+0.000907*sin(2.*fx1)
     &      -0.002697*cos(3.*fx1)+0.001480*sin(3.*fx1)
c
c   compute solar angle at noon (and assume that this is the equivalent
c   daily averaged incidence angle for direct+diffuse radiation)
c   1. cobeta is cos(incidence angle of solar radiation at noon)
c
      fx1    = pi/180.*yt(j)
      cobeta = max(0.,sin(fx1)*sin(declin)+cos(fx1)*cos(declin))
c
c   2. cobeta is cos(incidence angle in water)
c      using Snells law: sin(water)=sin(air)/1.33
c
      cobeta = sqrt(1.-(1.-cobeta**2.)/1.33**2.)
c
c   finally,length of day
c
      fx2    = max(-1., min( 1.,-tan(fx1)*tan(declin)) )
      daylen = acos(fx2)/pi
      end subroutine get_daylen




      subroutine schmidt_co2(t,sc,len)
c-----------------------------------------------------------------------
c    Computes the Schmidt number of CO2 in seawater using the 
c    formulation presented by Wanninkhof (1992, J. Geophys. Res., 97,
c    7373-7382).  Input is temperature in deg C.
c-----------------------------------------------------------------------
      implicit none
      integer :: len
      real    :: t(len),sc(len)
      integer :: i
      do i=1,len
       sc(i) = 2073.1 - 125.62*t(i) + 3.6276*t(i)*t(i) 
     &       - 0.043219*t(i)*t(i)*t(i)
      enddo
      end subroutine schmidt_co2




      subroutine schmidt_o2(t,sc,len)
c-----------------------------------------------------------------------
c   Computes the Schmidt number of oxygen in seawater using the
c   formulation proposed by Keeling et al. (1998, Global Biogeochem.
c   Cycles, 12, 141-163).  Input is temperature in deg C.
c-----------------------------------------------------------------------
      implicit none
      integer :: len
      real    :: t(len),sc(len)
      integer :: i
      do i=1,len
       sc(i) = 1638.0-81.83*t(i)+1.483*t(i)*t(i) 
     &             - 0.008004*t(i)*t(i)*t(i)
      enddo
      end subroutine schmidt_o2



      subroutine eqconc_o2(t,s,osa,len)
c-----------------------------------------------------------------------
C   Computes the oxygen saturation concentration at 1 atm 
c   total pressure in ml/l given the temperature 
c   (t, in deg C) and the salinity (s, in permil, or psu). 
C   FROM GARCIA AND GORDON (1992), LIMNOLOGY and OCEANOGRAPHY.
C   THE FORMULA USED IS FROM PAGE 1310, EQUATION (8).
C   *** NOTE: THE "A3*TS^2" TERM (IN THE PAPER) IS INCORRECT. ***
C   *** IT SHOULD not BE THERE.                                ***
C   osa IS DEFINED BETWEEN T(freezing) <= T <= 40(deg C) AND
c   0 permil <= S <= 42 permil
C   CHECK VALUE:  T = 10.0 deg C, S = 35.0 permil,osa = 0.282015 mol/m^3
c     Convert from ml/l to mol/m^3  osa = o2sato/22391.6*1000.0
c-----------------------------------------------------------------------
      implicit none
      integer :: len
      real :: t(len), s(len), osa(len)
      real :: TT, TK, TS, TS2, TS3, TS4, TS5, CO ,SS
      integer :: i
      real :: A0= 2.00907, A1= 3.22014, A2= 4.05010 
      real :: A3= 4.94457, A4=-2.56847E-1, A5= 3.88767 
      real :: B0=-6.24523E-3, B1=-7.37614E-3
      real :: B2=-1.03410E-2, B3=-8.17083E-3, Cc0=-4.88682E-7
      do i=1,len
         TT  = 298.15-t(i)
         TK  = 273.15+t(i)
         TS  = LOG(TT/TK)
         TS2 = TS*TS
         TS3 = TS2*TS
         TS4 = TS3*TS
         TS5 = TS4*TS
         ss  = s(i)*1000.0+35.0
         CO  = A0 + A1*TS + A2*TS2 + A3*TS3 + A4*TS4 + A5*TS5
     $        + ss*(B0 + B1*TS + B2*TS2 + B3*TS3)
     $        + Cc0*(ss*ss)
         osa(i) = EXP(CO)
      enddo
      end subroutine eqconc_o2

#include "options.inc"


c
c     convert binary output of averaged blue correction
c     to NetCDF format
c
      module cv_blue_module
      integer :: imt,jmt,km

      real (kind=4), allocatable, dimension(:,:,:) :: mean_blue
      integer :: counter
      real (kind=4), allocatable, dimension(:)   :: xt,yt,zt
      integer, allocatable, dimension(:,:)     :: kmt
      end module cv_blue_module

      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end


      program cv_blue
      use cv_blue_module
      implicit none
      character (len=80) :: infile,outfile
      integer :: ierr,i
      character (len=14) :: c14
      character (len=1) :: c1
      character (len=2) :: c2
      character (len=4) :: c4
      integer :: year,month,day,domain

      print*,' Converting averaged quantities written by SPFLAME ',
     &       ' to NetCDF file '

      call get_commandline_arg(1,infile,ierr)
      if (ierr/=0) goto 99
      print*,' reading from file ',infile(1:len_trim(infile))

      read(infile,'(a14,i3,a2,i4,a1,i2,a1,i2,a4)') 
     &            c14,domain,c2,year,c1,month,c1,day,c4
      write(outfile,
     &   '("blue_averages_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            domain,year,month,day
      do i=1,len_trim(outfile);
        if (outfile(i:i)==' ')outfile(i:i)='0';
      enddo
      print*,' sub domain = ',domain
      print*,' year/month/day  = ',year,month,day
      print*,' writing to file ',outfile
      call read_blue_averages(infile)
      call write_blue_averages(outfile,year,month,day,domain)
      stop

 99   print*,' program needs command line parameter'
      print*,' 1. input binary file name (written by spflame)'
      end program cv_blue


      subroutine read_blue_averages(infile)
      use cv_blue_module
      implicit none
      character (len=*) :: infile
      real (kind=4), allocatable :: buf(:,:)
      integer :: i,j,k,io,n

      allocate( buf(imt,jmt) ); buf=0.
      io=10
      open(io,file=infile,form='unformatted')
      read(io) imt,jmt,km
      print*,' imt=',imt,' jmt=',jmt,' km=',km

      allocate( mean_blue(imt,km,jmt) )
      allocate( xt(imt),yt(jmt),zt(km))
      allocate( kmt(imt,jmt) )

      read(io) xt,yt,zt
      read(io) counter
      print*,' counter for averages=',counter
      read(io) kmt
      do k=1,km
         read(io) mean_blue(:,k,:)
      enddo
      close(io)
      deallocate(buf)
      end subroutine read_blue_averages


      subroutine write_blue_averages(outfile,year,month,day,domain)
      use cv_blue_module
      implicit none
      character (len=80) :: outfile,name,unit
      integer :: year,month,day,domain
#include "netcdf.inc"
      integer ncid,iret,i,j,k,dims(4),start(4),count(4)
      real (kind=4) :: spval=-9.9e12, tt
      integer :: lon_tdim,lon_tid
      integer :: lat_tdim,lat_tid
      integer :: depth_tdim,depth_tid
      integer :: itimedim,itimeid
      integer :: blueid,n,len
      integer :: 
     &days_in_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)

      tt=(year-1900)*365 + day
      do n=1,month-1
       tt=tt+days_in_month(n)
      enddo
      tt=tt-days_in_month(month)/2. ! always monthly averages

      print*,' writing to file ',outfile

      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c       dimensions
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', 1, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c     attributes of the grid
      name = 'Longitude on T grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &'31-DEC-1899 00:00:00', iret)
c     variables
      dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
      blueid=ncvdef (ncid,'blue_corr', NCFLOAT,4,dims,iret)
c     attributes of variables
      name = 'Correction to momentum equation'; unit = 'kg/m^3'
      call dvcdf_here(ncid,blueid,name,24,unit,16,spval)

      iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        if (iret.ne.0) print*,nf_strerror(iret)

      write( name,'("SFLAME sub domain # ",i3)') domain
      name=name(1:len_trim(name))//' monthly means'
      len=len_trim(name)
      iret= nf_put_att_text(ncid,nf_global,'history',len,name)

      call ncendf(ncid, iret)

      zt=zt/100.

      call ncvpt(ncid, Lon_tid, 1, imt,xt, iret)
      call ncvpt(ncid, Lat_tid, 1, jmt,yt, iret)
      call ncvpt(ncid, depth_tid, 1, km,zt, iret)
      call ncvpt(ncid, itimeid, 1, 1,tt, iret)

c     convert to SI units and divide by N
      mean_blue=mean_blue*1000.  /counter  ! g/cm^3 -> kg/m^3

c     apply land mask and write to file
      do k=1,km
       where( kmt <k ) mean_blue(:,k,:) = spval
       start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
       iret= nf_put_vara_real(ncid,blueid,start,count,mean_blue(:,k,:))
      enddo
      call ncclos (ncid, iret)

      end subroutine write_blue_averages




      subroutine dvcdf_here(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c     define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character*(*) name, unit
      real (kind=4):: spval,vv
#include "netcdf.inc"
      vv=spval
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncapt (ncid,ivarid, 'missing_value',NCFLOAT,1,vv,iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncapt (ncid,ivarid, '_FillValue', NCFLOAT, 1,vv, iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf_here

c
c   program to convert restart files
c   Here not to netcdf, but to include e.g. more tracers
c   or to convert from single to double precision
c

c#define change_time_stamp
c#define  add_ledwell_tracer
c#define with_ktmix
#define with_tkemix

c#define convert_real4_to_real8
#define convert_real8_to_real4

      program cv_rest
      implicit none
      integer :: io,nt,itt,ierr, io2,nt2,io3
      character (len=32) :: stamp
      character (len=40) :: tr_name

      integer :: imt,jmt,km  , i,j,k,n
      integer, allocatable :: kmt(:,:)

#ifdef convert_real4_to_real8
      real (kind=4), allocatable  :: dat_in(:,:)
      real (kind=8), allocatable  :: dat_out(:,:)
#elif defined convert_real8_to_real4
      real (kind=8), allocatable  :: dat_in(:,:)
      real (kind=4), allocatable  :: dat_out(:,:)
#else
      real, allocatable  :: dat_in(:,:)
      real, allocatable  :: dat_out(:,:)
#endif

      real, allocatable  :: tr(:,:,:,:)
      real :: x
      integer :: indp
      real,allocatable :: xt(:), yt(:), xu(:), yu(:), zt(:),zw(:)

      print*,' Converting '

      call get_commandline_arg_int(1,imt,ierr)
      if (ierr/=0) goto 99
      call get_commandline_arg_int(2,jmt,ierr)
      if (ierr/=0) goto 99
      call get_commandline_arg_int(3,km,ierr)
      if (ierr/=0) goto 99
      call get_commandline_arg_int(4,nt2,ierr)
      if (ierr/=0) goto 99

      allocate(kmt(imt,jmt) )
      allocate(dat_in(imt,jmt), dat_out(imt,jmt) )
c
c     read topography to zero out special values
c
      call getunit (io, 'kmt.dta', 'usr ieee')
      read (io) ! no checks
c       skip header record and read dimensional info
      read (io) 
      read (io) i, j, k
      read (io) 
      read (io) kmt
      close(io)

#ifdef add_ledwell_tracer

      print*,
     & ' =>Reading the grid definition from file grid.dta'
      call getunit (io, 'grid.dta', 'u s r ieee')
      read (io) ! no checks for awi id
      read (io) i, j, k
      allocate( xt(imt), yt(jmt), xu(imt), yu(jmt))
      allocate( zt(km),zw(km) )
      read (io) (x,i=1,imt)
     &,         (x,j=1,jmt)
     &,         (x,i=1,imt)
     &,         (x,j=1,jmt)
     &,         (x,k=1,km)
     &,         (x,k=0,km)
     &,         (xt(i),i=1,imt)
     &,         (xu(i),i=1,imt)
     &,         (yt(j),j=1,jmt)
     &,         (yu(j),j=1,jmt)
     &,         (zt(k),k=1,km)
     &,         (zw(k),k=1,km)
      close(io)
#endif


      call get_free_iounit(io)
      open(io,file='old_restart.dta',form='unformatted',status='old')

      read(io) itt,stamp,nt

      call get_free_iounit(io2)
      open(io2,file='new_restart.dta',form='unformatted',status='new')

      print*,' time stamp = ',stamp

#ifdef change_time_stamp
c      stamp ='m/d/y= 2/ 1/1990, h:m:s=22:30: 0' 
      stamp ='m/d/y= 1/14/1990, h:m:s=16:30:00' 
      print*,' new time stamp = ',stamp
#endif


      print*,' itt        = ',itt
      print*,' nt         = ',nt
      print*,' nt2        = ',nt2
      write(io2) itt,stamp,nt2

      allocate(tr(imt,jmt,km,nt+1:nt2))

#ifdef add_ledwell_tracer
      tr=0.

c      i=indp(360.0-(80.2),xt,imt)
c      j=indp(28.0,yt,jmt)
c      k=indp(150.0e2,zt,km)
c      print*,' adding a dye at i,j,k=',i,j,k,' x,y,z=',xt(i),yt(j),zt(k)
c      print*,' for tracer # 3'
c      tr(i,j,k,3)=1.0

      i=indp(360.0-(28.0+15./60.),xt,imt)
      j=indp(25.0+40.0/60.0,yt,jmt)
      k=indp(310.0e2,zt,km)
      print*,' adding a dye at i,j,k=',i,j,k,' x,y,z=',xt(i),yt(j),zt(k)
      print*,' for tracer # 3'
      tr(i,j,k,3)=1.0

      i=indp(360.0-40.0,xt,imt)
      j=indp(20.0,yt,jmt)
      k=indp(332.7e2,zt,km)
      print*,' adding a dye at i,j,k=',i,j,k,' x,y,z=',xt(i),yt(j),zt(k)
      print*,' for tracer # 4'
      tr(i,j,k,4)=1.0

      i=indp(360.0-35.0,xt,imt)
      j=indp(22.0,yt,jmt)
      k=indp(332.7e2,zt,km)
      print*,' adding a dye at i,j,k=',i,j,k,' x,y,z=',xt(i),yt(j),zt(k)
      print*,' for tracer # 5'
      tr(i,j,k,5)=1.0

      i=indp(360.0-(60.),xt,imt)
      j=indp(42.5,yt,jmt)
      k=indp(1500.0e2,zt,km)
      print*,' adding a dye at i,j,k=',i,j,k,' x,y,z=',xt(i),yt(j),zt(k)
      print*,' for tracer # 3'
      tr(i,j,k,3)=1.0


      i=indp(360.0-76.0,xt,imt)
      j=indp(26.0,yt,jmt)
      k=indp(1438.7e2,zt,km)
      print*,' adding a dye at i,j,k=',i,j,k,' x,y,z=',xt(i),yt(j),zt(k)
      print*,' for tracer # 4'
      tr(i,j,k,4)=1.0

#else
c
c     read initial data
c
      do n=nt+1,nt2
        write(tr_name, '("tracer_",i2,".mom.ic")') n
        call replace_space_zero(tr_name)
        print*,' reading initial conditions from file ',
     &            tr_name(1:len_trim(tr_name))
        call getunit (io3,tr_name, 'u s r ieee')
        read(io3)  
        do j=1,jmt
         read(io3)  
         read(io3) stamp,x,k,k,k,x,k,(x,i=1,imt),(x,k=1,km),tr(:,j,:,n)
         do i=1,imt
          if (kmt(i,j)<km) tr(i,j,kmt(i,j)+1:km,n)=0.
         enddo
        enddo
        close(io3)
      enddo
#endif
c
c     barotropic mode
c
      print*,' reading writing barotropic mode '
      read(io)  dat_in ! ptd
      dat_out=dat_in
      write(io2)dat_out

      read(io)  dat_in ! guess
      dat_out=dat_in
      write(io2)dat_out

      read(io)  dat_in! psi(,,1)
      print*, 'psi(,,1) min,max [Sv]:',
     &                  minval(dat_in)/1.e12,maxval(dat_in)/1.e12
      dat_out=dat_in
      write(io2)dat_out

      read(io)  dat_in ! psi(,,2)
      print*, 'psi(,,2) min,max [Sv]:',
     &                  minval(dat_in)/1.e12,maxval(dat_in)/1.e12
      dat_out=dat_in
      write(io2)dat_out

      do k=1,km
       print*,' writing tracers k= ',k,' von ',km

       do n=1,nt ! read only nt_in tracers
        read(io) dat_in ! t(,k,,n,taum1)
        dat_out=dat_in
        write(io2) dat_out
        read(io) dat_in ! t(,k,,n,tau)
        dat_out=dat_in
        write(io2) dat_out
       enddo

c      add new tracer
       do n=nt+1,nt2
        write(io2) tr(:,:,k,n)
        write(io2) tr(:,:,k,n)
       enddo

       do n=1,2
        read(io) dat_in ! u(,k,,n,taum1)
        dat_out=dat_in
        write(io2) dat_out
        read(io) dat_in ! u(,k,,n,tau)
        dat_out=dat_in
        write(io2) dat_out
       enddo
      enddo

#ifdef with_ktmix
      ! ktmix ?
       print*,' writing dml '
      read(io) dat_in ! dml
      dat_out=dat_in
      write(io2) dat_out
#endif

#ifdef with_tkemix
      ! tkemix
      do k=1,km
       print*,' writing eke k= ',k,' von ',km
        read(io) dat_in ! eke(,k,,n,taum1)
        dat_out=dat_in
        write(io2) dat_out

        read(io) dat_in ! eke(,k,,n,tau)
        dat_out=dat_in
        write(io2) dat_out
      enddo
#endif

      close(io)
      close(io2)

      stop
 99   print*,' program needs command line parameter:'
      print*,'<executable> imt jmt km nt2'

      end program cv_rest



      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"

c
c--------------------------------------------------------
c  local cpp directives for topography generation
c--------------------------------------------------------
c
c use either etopo5 or etopo2 topography
c
#define use_ETOPO5_topography
c#define use_ETOPO2_topography
c
c--------------------------------------------------------
c  local cpp directives for initial conditions
c--------------------------------------------------------
c
c  NOTE: enable only one of the following four switches
c
c  read IC conditions from global Levitus 94 climatology
c  Note that SSS restoring data and data for eventual sponge layers
c  come as well from this dataset for this choice
#define read_ic_from_LEV94
c
c  read IC conditions from a combined Levitus 94 and 
c  Levitus 98 dataset, resulting in higher spatial
c  resolution (1/4 deg). This dataset covers the Atlantic
c  domain only.
c#define read_ic_from_LEV98
c
c  read initial conditions from the annual mean
c  WOCE SAC climatology.
c#define read_ic_from_SAC
c
c  read initial conditions from model climatology 
c  itself. (can be useful for semi-progn. method).
c#define read_ic_from_E5

c
c  some switches for preparing initial conditions
c  for passive tracers.
c
c  setup CFC
c#define  prep_for_CFC 
c  setup nitrat based ecosystem model +CO2 +O2 + DOC
c#define  prep_for_NPZD
c  setup in addition CFC11/12 another CO2 and antr. CO2
c#define  prep_for_ACO2
c  setup simple passive tracers 
c#define  prep_for_LEDWELL
c
c#define prep_for_OBC_tracer
c
c--------------------------------------------------------
c  local cpp directives for surface boundary setup 
c--------------------------------------------------------
c
c read wind stress either from ECMWF analysis (same forcing
c as used in the DYNAMO project), from NCEP/NCAR monthly wind stress
c anomalies plus the ECMWF climatology, from daily NCEP/NCAR data
c or from NAO-related wind stress (useful for the Atlantic only,
c see Eden+Jung, J. Clim. 2001), or other wind stress products.
c
c  NOTE: enable only one of the following 11 switches
c
#define read_tau_ecmwf
c#define read_tau_omip
c#define read_tau_dasilva
c#define read_tau_ecco
c#define read_tau_ncep_monthly
c#define read_tau_ncep_clim
c#define read_tau_ncep
c#define read_tau_ncep_daily
c#define read_tau_ncep_daily_large_file
c#define read_tau_T511_daily_large_file
c#define read_tau_nao_proxy
c#define read_tau_nao_ideal
c
c
c same for friction velocity
c
c  NOTE: enable only one of the following 4 switches
c
c#define read_ustar_ecmwf
c#define read_ustar_omip
c#define read_ustar_ncep_monthly
#define read_ustar_T511
c
c same for the heat fluxes
c
c  NOTE: enable only one of the following 7 switches
c
#define read_density_flx_ecmwf
c#define read_density_flx_ncep_monthly
c#define read_density_flx_omip
c#define read_density_flx_nao_proxy
c#define read_density_flx_nao_ideal
c#define read_density_flx_pml_ncep
c#define read_density_flx_T511
c
c
c  this is for the piston velocity (only for switch read_density_flx_ecmwf
c   and prep_for_NPZD)
c#define read_piston_velocity_U10
#define read_piston_velocity_WSPD
c
c
c  enable this in combination with the above two
c  and switch on diagnosed freshwater flux boundary condition
c  for salinity.
c#define read_salt_fl_from_E5
c this is for HS4_2
c#define limAmazoneSSS
c
c--------------------------------------------------------
c  local cpp directives for OBC setup 
c--------------------------------------------------------
c
c  NOTE: enable only one of the following switches
c  in this section. They are setting up 
c  specific configurations.
c
c  course resolution North Atlantic model
c#define read_psi_for_K1
c  4/3 deg resolution North Atlantic model
c  (similar to the one in Eden+Jung, 2001)
c#define read_psi_for_E1
c  1/3 deg resolution North Atlantic model
c#define read_psi_for_D3
c  1/3 deg resolution tropical Atlantic model
c#define read_psi_for_Q1
c  same as D1 but open northern boundary
c#define read_psi_for_D4
c  same as E1 but open northern boundary
c#define read_psi_for_E7
c  1/12 deg resolution North Atlantic model
c#define read_psi_for_HS2
c  same as HS2 but open northern boundary and med sea
c#define read_psi_for_HS3
c  1/12 deg resolution subpolar North Atlantic model
c#define read_psi_for_HS4
c  1/12 deg resolution subpolar North Atlantic model
c  with different north boundary condition
c#define read_psi_for_LS1
c  ACC model
c#define read_psi_for_A1

c--------------------------------------------------------
c  local cpp directives for sponge layer setup 
c--------------------------------------------------------

c  same as above but for the sponge layers
c  NOTE: enable only one of the following switches
c  in this section. They are setting up 
c  specific configurations.
c
c#define prep_sponge_for_K1
c#define prep_sponge_for_E1
c#define prep_sponge_for_D3
c#define prep_sponge_for_D4
c#define prep_sponge_for_E7
c#define prep_sponge_for_E0
c#define prep_sponge_for_HS2
c#define prep_sponge_for_HS3
c#define prep_sponge_for_PAC
c#define prep_sponge_for_I1

c
c--------------------------------------------------------
c  now include other template files
c--------------------------------------------------------
c
#include "prep_template_topo.F"
#include "prep_template_ic.F"
#include "prep_template_tau.F"
#include "prep_template_sflx.F"
#include "prep_template_obcpsi.F"
#include "prep_template_sponge.F"

#include "options.inc"

c
c--------------------------------------------------------
c     preparation of the topography
c--------------------------------------------------------
c

#ifdef partial_cell
c I have used this one for E5 setup
c#define auto_find_digged_points

c this one for the DS setup
c#define preserve_mask_in_regions
#endif

      subroutine prep_topo
      use prep_module
      use island_module
      implicit none
      integer nx,ny
      real, allocatable :: rose(:,:),x(:),y(:),nrose(:,:)
      real, allocatable :: tmprose(:,:)
      real, allocatable :: tx(:)
      real, allocatable :: fmsk(:,:),srose(:,:)
      integer, allocatable :: map(:,:)
      integer i,j ,k
      integer :: indp
#ifdef partial_cell
      integer :: kmt_bak(imt,jmt),is,ie,js,je
      real  :: rose_digged(imt,jmt)
#endif
      real :: p_cell_min

      integer, parameter :: maxipp=40000,mnisle=500
      integer iperm(maxipp),jperm(maxipp)
      integer nippts(mnisle), iofs(mnisle)
      integer nisle
      logical error
      character(len=80) :: FLAME_ID ='no flame id '
      character(len=32+80+60) :: iotext='no stamp, no iotext '

      integer :: lenw,init
      real, allocatable :: work(:)

      print*,''
      print*,' Setting up the topography mask'
      print*,''

      allocate(map(imt,jmt) )
c
c     call templates to read topography file
c
      call read_rose_dims(nx,ny)
      print*,' data set dimensions are ',nx,ny
      allocate( rose( nx,ny), x(nx), y(ny), tx(nx) )
      print*,' now reading data '
      call read_rose(rose,x,y,nx,ny)
c
      print*,' interpolating data'
      allocate( nrose(imt,jmt), fmsk(imt,jmt), srose(imt,jmt) )
      if (.not.rotated_grid) then
c       use cheaper routine here
        lenw=10*max(nx,ny); allocate(work(lenw))
        init=1
        if (cyclic) then
         call tranlon (rose, nx, nx-2, ny, x, xt(2:imt-1),imt-2, tx)
         call ctf (rose,nx, ny, tx, y, 
     &                nrose,imt, jmt, 2, imt-1, 1, jmt,
     &                xt, yt, init, work, lenw,spval)
        else
         call tranlon (rose, nx, nx-2, ny, x, xt,imt, tx)
         call ctf (rose,nx, ny, tx, y, 
     &                nrose,imt, jmt, 1, imt, 1, jmt,
     &                xt, yt, init, work, lenw,spval)
        endif
        deallocate(work)
      else
c      there is one point at i=1 which is the same as i=nx
c      this is no good for interpolator
c       call rot_intrp_sclr (rose(1:nx-1,:), x, y, 
       allocate(tmprose(nx-1,ny))
       do i=1,nx-1;do j=1,ny
        tmprose(i,j)=rose(i,j)
       enddo;enddo
       print*,'ok'
       call rot_intrp_sclr (tmprose, x, y, 
     &              nx-1, ny, nrose, xt, yt,
     &              imt, jmt, psir, thetar, phir,spval,.true.)
       print*,'ok'
       deallocate(tmprose)
      endif
      print*,' interpolation done'
      deallocate( rose,x,y, tx)

      if (cyclic) then
        nrose(1,:)=nrose(imt-1,:); nrose(imt,:)=nrose(2,:)
      else
        nrose(1,:)=nrose(2,:); nrose(imt,:)=nrose(imt-1,:)
      endif
c
c-----------------------------------------------------------------------
c     convert depths from meters to cm and change sign. set min 
c     allowable depth
c     also set a mask 'fmsk' to be used in 'sfltr'.
c     -> since etopo5 changed its sign. the following procedure was
c        altered slightly; jk, may-05-1997
c-----------------------------------------------------------------------
c
      do j=1,jmt
        do i=1,imt
          fmsk(i,j)=1.0
          map(i,j)=0
          if (nrose(i,j) < 0. ) then
            nrose(i,j) = -nrose(i,j)*100.0
          else
            nrose(i,j) = 0.
            fmsk(i,j)=0.
            map(i,j)=1.
          endif
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     set topographic modifications on model grid here
c-----------------------------------------------------------------------
c
c     set artificial walls at northern & southern boundaries
c
      nrose(:,1 )  = 0; fmsk(:,1 )  = 0
      nrose(:,jmt) = 0; fmsk(:,jmt) = 0

      if (.not. cyclic) then
        nrose(1,: )  = 0; fmsk(1,: )  = 0
        nrose(imt,:) = 0; fmsk(imt,:) = 0
      endif
c
c     smooth, but preserve coastline
c
      srose=nrose
      if (topo_smooth_ntimes .ne. 0) then

        print*,' smoothing ',topo_smooth_ntimes,' times'

        call sfltr (srose, imt, imt, jmt, fmsk, 
c     &         2, imt-1, 2, jmt-1, topo_smooth_ntimes,cyclic)
     &         1, imt, 1, jmt, topo_smooth_ntimes,cyclic)
      endif

      allocate( kmt(imt,jmt) )

      if (read_grid_topo) then
c
c-----------------------------------------------------------------------
c       now read a previosly generated kmt mask 
c       and forget about the data
c-----------------------------------------------------------------------
c
        call read_bin_kmt()

      else
c
c-----------------------------------------------------------------------
c     discretize topography to  "kmt" (min = 2 levels)
c-----------------------------------------------------------------------
c
        do j=1,jmt
         do i=2,imt-1
          kmt(i,j) = 0
          if (srose(i,j) /= 0) then
           kmt(i,j) = max(kmt_min,indp (srose(i,j), zw, km))
c            kmt(i,j) = indp (srose(i,j), zw, km)
          endif
         enddo
        enddo
c
c-----------------------------------------------------------------------
c      apply boundary conditions
c-----------------------------------------------------------------------
c
       call set_kmt_bc()
c
c-----------------------------------------------------------------------
c     limit the minimum number of levels. kmt_min should be >= 2
c-----------------------------------------------------------------------
c
       if (kmt_min <2) then
        print*,' kmt_min must be greater than 2'
        stop
       endif
 
       do i=2,imt-1
        do j=jmt-1,2,-1
          if (kmt(i,j) /= 0 .and. kmt(i,j) < kmt_min) then
            kmt(i,j)=max(kmt(i,j), kmt_min, 2)
          endif
        enddo
       enddo

      endif ! read_grid_topo

#ifdef partial_cell
c
c-----------------------------------------------------------------------
c     construct partial cell from undiscretised kmt mask
c     htp = depth to ocean bottom at T-cells (cm)
c-----------------------------------------------------------------------
c
      allocate( htp(imt,jmt), hup(imt,jmt) )
      htp=0. ; hup=0.
      rose_digged=spval
      kmt_bak=kmt

      do j=1,jmt
       do i=1,imt
         if (kmt(i,j)==0) then
          htp(i,j)=0.  ! preserve coastline
         else
          if (srose(i,j) > 0.) then
            if (zw(kmt(i,j)) > srose(i,j) ) then
               ! fill with a partial cell
               htp(i,j)=max(zw(kmt_min),srose(i,j))
               if (zw( max(1,kmt(i,j)-1) ) > htp(i,j)) then
                  ! seems to be an artifically digged point
#ifdef auto_find_digged_points
                  if (zw( max(1,kmt(i,j)-1) ) 
     &                -dzt( max(1,kmt(i,j)))/5.> htp(i,j)) then
#endif
                     ! artifically digged point, preserve depth
                     htp(i,j)=zw(kmt(i,j))
c                     print*,' found an articially deep point at ',
c     &                     ' i=',i,' j=',j,' ,... preserving '
                     rose_digged(i,j)=srose(i,j)/100.
#ifdef auto_find_digged_points
                  else
c                     ! artifically digged point, remove that stuff
 30                   kmt(i,j) = kmt(i,j)-1
                      if (kmt(i,j)<kmt_min) then
                        ! no partial cell possible, too shallow
                        kmt(i,j)=kmt_min
                        htp(i,j)=zw(kmt(i,j))
                        rose_digged(i,j)=srose(i,j)/100.
                        goto 35
                      endif
                      if (zw( max(1,kmt(i,j)-1) ) > htp(i,j)) goto 30
 35                  continue

                  endif
#endif
               endif
            elseif (zw(kmt(i,j)) < srose(i,j) ) then
 20               if (kmt(i,j)==km) then
                    htp(i,j)=zw(kmt(i,j)) ! max depth reached
c                    print*,' max. depth reached for i=',i,' j=',j
                  else  
                   ! increase kmt(i,j) and fill with a partial cell beneath
                   kmt(i,j)=kmt(i,j)+1
                   htp(i,j)=srose(i,j)
                   if (zw(kmt(i,j)) < htp(i,j)) then
c                      print*,' digging',i,j
                      goto 20 ! still to shallow, go to the next deeper box
                   else
c                    print*,' depth increased at i=',i,' j=',j
                   endif
                   
                  endif
            else
              htp(i,j)=zw(kmt(i,j)) ! the best case
            endif
          else
           htp(i,j)=zw(kmt(i,j))  ! we have here an artificial water point
           rose_digged(i,j)=srose(i,j)/100.
          endif
         endif ! kmt==0
       enddo
      enddo

#ifdef preserve_mask_in_regions
c
c     now preserve to water depth from the old mask in some sensitive regions
c

c 1. Denmark Strait

      js = indp (65.6, yt, jmt);je = indp (66.7, yt, jmt)
      is = indp (360-28.0,xt,imt);ie=indp (360-26., xt, imt)
      do j=js,je
       do i=is,ie
         if (htp(i,j) > 0.) then
           if (zw(kmt(i,j)) > htp(i,j) ) then
              htp(i,j)=zw(kmt(i,j))
           endif
         endif
       enddo
      enddo

c 2. Faroer channel
c    okay

c 3. Florida Strait
c     okay

c
c    I do not care about the rest ...
c

#endif
c
c     a check
c
      do j=1,jmt
       do i=1,imt
        if (htp(i,j)>zw(max(1,kmt(i,j)))) then
         print*,' error at i=',i,' j=',j
         print*,' htp(i,j)=',htp(i,j)
         print*,' zw(kmt(i,j))=',zw(max(1, kmt(i,j) ))
         print*,' srose(i,j)=',srose(i,j)
         stop
        endif
        if (htp(i,j)<zw(max(1, kmt(i,j)-1 )).and.kmt(i,j)/=0) then
         print*,' error at i=',i,' j=',j
         print*,' htp(i,j)=',htp(i,j)
         print*,' zw(kmt(i,j)-1)=',zw(max(1, kmt(i,j)-1 ))
         print*,' srose(i,j)=',srose(i,j)
         print*,' kmt(i,j)=',kmt(i,j)
         stop
        endif
       enddo
      enddo
c
c---------------------------------------------------------------------
c     do not allow partial cells thickness less than min(dzt(k))
c     (arbitrarily 50m minimum in coarse models ... otherwise dzt(1))
c---------------------------------------------------------------------
c
      p_cell_min = min(50.0e2,zw(1))
      do k=2,km
        if (p_cell_min .gt. (zw(k)-zw(k-1))) p_cell_min = zw(k)-zw(k-1) 
      enddo
      do j=2,jmt-1
        do i=2,imt-1
	  k = kmt(i,j)
	  if (k .lt. 2) then
	    htp(i,j) = 0.0
	  else
	    if ((htp(i,j)-zw(k-1)) .lt. p_cell_min) then
c             print*,' WARNING: partial cell limit violated'
c             print*,' at i=',i,' j=',j,' htp(i,j)=',htp(i,j)
c             print*,' zw(k-1)=',zw(k-1)
c             print*,' zw(k)=',zw(k),' p_cell_min',p_cell_min
             htp(i,j) = zw(k-1) + p_cell_min
	    endif
	  endif
        enddo
      enddo 
#endif
c
c-----------------------------------------------------------------------
c     test for "island perimeter violations"
c     channels between different land masses must be at least 2 ocean
c     cells wide to prevent conflicting values of the stream function
c     on these island perimeter points.
c-----------------------------------------------------------------------
c
 10   continue
#ifdef partial_cell
      kmt_bak=kmt
#endif
       write (6,'(/a/)')
     &  'Searching for and correcting island PERIMETER VIOLATIONS...'
       call isleperim(kmt,map, iperm, jperm, iofs, 
     &        nippts, nisle
     &,       imt, jmt, mnisle, maxipp,0,cyclic,
     &        enable_obc_north,enable_obc_south,
     &        enable_obc_west,enable_obc_east,.true.)

       if (.not. read_grid_topo) then
        write (6,'(/a/)')
     &   'Searching for isolated bays, potholes, etc ...'
        call fill_bays_and_stuff(kmt,imt,jmt,kmt_min,error,
                            ! check for potholes, trenches/corners
     &                          .false., .false.)
       else
        print*,' searching for depth violations and isolated bays only'
        call fill_bays_and_stuff(kmt,imt,jmt,kmt_min,error,
                            ! leave potholes, trenches/corners
                            ! perform only necessary checks
     &                          .true., .true.)
       endif

#ifdef partial_cell
       do j=1,jmt
        do i=1,imt
          if (kmt_bak(i,j)/=kmt(i,j) ) then
           if (kmt(i,j)==0) then
            htp(i,j)=0.
           else
            htp(i,j)=zw(kmt(i,j))
           endif
          endif
        enddo
       enddo
#endif
      if (error) goto 10
c
c---------------------------------------------------------------------
c     topography for u grid,  it is needed afterwards
c---------------------------------------------------------------------
c
      allocate(kmu(imt,jmt))
      kmu=0
      do j=1,jmt-1
        do i=1,imt-1
           kmu(i,j) = min (kmt(i,j), kmt(i+1,j), 
     &                     kmt(i,j+1), kmt(i+1,j+1))
        enddo
      enddo
      if (enable_obc_north) kmu(:,jmt) = kmu(:,jmt-1)
      if (enable_obc_south) kmu(:,1) = kmu(:,2)
      if (enable_obc_west) kmu(1,:) = kmu(2,:)
      if (enable_obc_east) kmu(imt,:) = kmu(imt-1,:)
      if ((enable_obc_north .or. enable_obc_south .or.
     & enable_obc_west  .or. enable_obc_east) .and..not.cyclic ) then 
c      checks in case of o.b.c
       kmu(imt-1:imt,1)=0.
       kmu(1,1)=0.
       kmu(1,jmt-1:jmt)=0.
c      done
      endif
      if (cyclic) kmu(imt,:) = kmu(2,:)

#ifdef partial_cell

c
c     construct hup to show it in the netcdf file
c
      hup=0.
      do j=1,jmt-1
        do i=2,imt-1
          hup(i,j) = min( htp(i,j),htp(i+1,j),htp(i,j+1),htp(i+1,j+1))
	enddo
      enddo

      if (enable_obc_north) hup(:,jmt) = hup(:,jmt-1)
      if (enable_obc_south) hup(:,1)   = hup(:,2)
      if (enable_obc_west)  hup(1,:)   = hup(2,:)
      if (enable_obc_east)  hup(imt,:) = hup(imt-1,:)

      if ((enable_obc_north .or. enable_obc_south .or.
     &     enable_obc_west  .or. enable_obc_east).and..not.cyclic) then 
c      checks in case of o.b.c
       hup(imt-1:imt,1)=0.
       hup(1,1)=0.
       hup(1,jmt-1:jmt)=0.
c      done
      endif

      if (cyclic) hup(imt,:) = hup(2,:)
      if (cyclic) hup(1,:) = hup(imt-1,:)

#endif

c      call showmap(map,imt,jmt)
      deallocate(map) 
c
c---------------------------------------------------------------------
c     write the topography to netcdf file 
c---------------------------------------------------------------------
c
      call write_kmt_to_cdf(nrose,srose
#ifdef partial_cell
     & ,rose_digged
#endif
     &     )

      deallocate( nrose, fmsk, srose )
c
c---------------------------------------------------------------------
c     write the kmt to binary file new_kmt.dta
c---------------------------------------------------------------------
c
      call write_bin_kmt()

      print*,''
      print*,' Topography generation done'
      print*,''

      end subroutine

 
      subroutine sfltr (a, im, il, jl, f, i1, i2, j1, j2, 
     &                  nfil,cyclic)
c
c-----------------------------------------------------------------------
c     this 2 dimensional symmetric filter is based on a weighting of
c     1/4  1/2  1/4. 
c     f is the mask field = 0 over land & 1 in ocean
c     a is the data to be smooth. It must be zero over land !
c     nfil is the number of smoothing passes
c     i1 .. i2 are the points along the 1st dimension to smooth
c     j1 .. j2 are the points along the 2nd dimension to smooth
c     this filter behaves as if there is a no flux boundary condition
c     across coastlines. It therefore preserves coasts.
c     note: this filter does not take into account variable grids
c-----------------------------------------------------------------------
c           
      dimension a(im,jl), s(im,jl), f(im,jl)
      logical cyclic
c
      if (nfil .eq. 0) return
c
      do 20 j=1,jl
        do 10 i=1,il
          if (f(i,j) .eq. 0.0 .and. a(i,j) .ne. 0.0) then
            print *,' "a" is not zero but "f" is zero in "sfltr"'
            print *,' i=',i,' j=',j,' a(i,j)=',a(i,j)
            stop
          endif
10      continue
20    continue
c
      is = max (i1,2); ie = min (i2,il-1)
      js = max (j1,2); je = min (j2,jl-1)
      print *,' '
      print *,' ==> Applying smoothing filter ', nfil,' times over'
      print *,
     $'     domain defined by is=',is,', ie=',ie,', js=',js,', je=',je
      print *,' '
c
      do 100 n=1,nfil
        do 50 j=js,je
          do 40 i=2,il-1
            if (i .ge. is .and. i .le. ie) then
              x1p = 0.25*f(i,j)
              x2p = 1.0-0.25*(f(i-1,j+1)+f(i+1,j+1))
              x3p = 0.25*f(i,j)
              x1c = 0.25*f(i,j)
              x2c = 1.0-0.25*(f(i-1,j)+f(i+1,j))
              x3c= 0.25*f(i,j)
              x1m = 0.25*f(i,j)
              x2m = 1.0-0.25*(f(i-1,j-1)+f(i+1,j-1))
              x3m = 0.25*f(i,j)
              y1m = 0.25*f(i,j)
              y2m = 1.0-0.25*(f(i-1,j+1)+f(i-1,j-1))
              y3m = 0.25*f(i,j)
              y1c = 0.25*f(i,j)
              y2c = 1.0-0.25*(f(i,j+1)+f(i,j-1))
              y3c = 0.25*f(i,j)
              y1p = 0.25*f(i,j)
              y2p = 1.0-0.25*(f(i+1,j+1)+f(i+1,j-1))
              y3p = 0.25*f(i,j)
              s(i,j) = 
     $        x1p*y1m*a(i-1,j+1) + x2p*y1c*a(i,j+1) + x3p*y1p*a(i+1,j+1)
     $      + x1c*y2m*a(i-1,j)   + x2c*y2c*a(i,j)   + x3c*y2p*a(i+1,j)
     $      + x1m*y3m*a(i-1,j-1) + x2m*y3c*a(i,j-1) + x3m*y3p*a(i+1,j-1)
            else
              s(i,j) = a(i,j)
            endif
40        continue  
50      continue
        if (cyclic) then
         do  j=js,je
          s(1,j)  = s(il-1,j); s(il,j) = s(2,j)
         enddo
        else
         do j=js,je
          s(1,j)  = 0.0; s(il,j) = 0.0
         enddo
        endif
        do 80 j=js,je
          do 70 i=1,il
            a(i,j) = s(i,j)
70        continue  
80      continue
100   continue
      end subroutine


      subroutine fill_bays_and_stuff(kmt,imt,jmt,kmt_min,error,
     &   leave_potholes,leave_trenches)
      implicit none
      integer imt,jmt,kmt(imt,jmt),nkmt(imt,jmt),kmt_min
      integer kmu,i,j,k
      logical :: error , leave_potholes,leave_trenches

      kmu(i,j) = min(kmt(i,j), kmt(i+1,j), kmt(i,j+1), kmt(i+1,j+1))
      error=.false.
c
c-----------------------------------------------------------------------
c     limit the minimum number of levels. kmt_min should be >= 2
c-----------------------------------------------------------------------
c
      if (kmt_min <2) then
        print*,' kmt_min must be greater than 2'
        stop
      endif

      do i=2,imt-1
        do j=jmt-1,2,-1
          if (kmt(i,j) /= 0 .and. kmt(i,j) < kmt_min) then
            kmt(i,j)=max(kmt(i,j), kmt_min, 2)
            error=.true.
            print*,' minimal depth violation at i=',i,' j=',j
          endif
        enddo
      enddo
      call set_kmt_bc()
c
c-----------------------------------------------------------------------
c     detect isolated bays:
c     These are situations where an ocean point on the "t" grid is
c     surrounded by 4 land points on the "u" grid (the 4 verticies of
c     the "t" cell) which prevents lateral advection of tracers (T & S).
c     These points sometimes lead to numerical instabilities and can be
c     eliminated by changing the ocean "t" cell to a land value.
c-----------------------------------------------------------------------
c
      nkmt=kmt
      do i=2,imt-1
        do j=jmt-1,2,-1
          if (kmt(i,j) .ne. 0) then
            if (kmu(i  ,j) == 0 .and. kmu(i  ,j-1) == 0 .and.
     &          kmu(i-1,j) == 0 .and. kmu(i-1,j-1) == 0) then
c             option 1: fill cell to land
              nkmt(i,j)=0
c             option 2: interactive user changes
c             option 3: leave nonadvective bay (requires no kmt changes)
              error=.true.
              print*,' found isolated bay at i=',i,' j=',j
            end if
          endif
        enddo
      enddo
      kmt=nkmt
      call set_kmt_bc()


      if (.not. leave_potholes) then
c
c-----------------------------------------------------------------------
c     detect potholes:
c     These are situations where an ocean point on the "t" grid is
c     deeper than its 4 surrounding neighbor cells, which prevents
c     lateral and vertical advection of tracers at this depth.
c     These points usually cause no problems, but they also do not
c     contribute to ocean circulation.  They may be eliminated by
c     changing kmt at this "t" grid location to the maximum of kmt on
c     the 4 neighboring locations.
c-----------------------------------------------------------------------

      nkmt=kmt
      do i=2,imt-1
        do j=jmt-1,2,-1
          if (kmt(i+1,j) .lt. kmt(i,j) .and.
     &        kmt(i-1,j) .lt. kmt(i,j) .and.
     &        kmt(i,j+1) .lt. kmt(i,j) .and.
     &        kmt(i,j-1) .lt. kmt(i,j)) then
c
c           option 1: fill this cell to the max of its neighbors
c           note: this still is not enough to guarantee flow
c
            nkmt(i,j) = max(kmt(i+1,j), kmt(i-1,j),
     &                      kmt(i,j+1), kmt(i,j-1))
c
c           option 2: interactive user changes
c           option 3: leave pothole (requires no kmt changes)
c
              print*,' found pothole at i=',i,' j=',j
              error=.true.
          endif
        enddo
      enddo
      kmt=nkmt
      call set_kmt_bc()
 
      endif


      if (.not. leave_trenches) then
c
c     Search for isolated corners and trenches, i.e. "t" grid boxes 
c     at any depth that can`t be influenced by advection
c     -------------------------------------------------------------
c
c      Examples: (x=land, .=sea)
c
c      1) x...x   2) .....   3) xxx..   4) x....
c         xx.xx      .....      xx..x      xx...
c         xx.xx      xx.xx      x..xx      x..xx
c         x...x      xxxxx      ..xxx      x....
c
c      Note: Case 4 is not covered by the present routine! However, it
c            is probably arguable if a diffusive flux should be 
c            possible through a gap like that.
c
c      This procedure mimics a check that will later be repeated for
c      the surface level in MOM`s iperim.F.

c     Compute number of vertical levels on the "u" grid
c     -------------------------------------------------

      nkmt=kmt
      do j=2, jmt-1
        do i=2, imt-1
          k = kmt(i,j)
          if (k .ne. 0) then
            if (kmu(i,j) .lt. k .and. kmu(i-1,j) .lt. k .and.
     &        kmu(i,j-1) .lt. k .and. kmu(i-1,j-1) .lt. k) then
              k = max (kmu(i,j),   kmu(i-1,j), 
     &                 kmu(i,j-1), kmu(i-1,j-1))
c             guarantee min. number of levels:
              if (k.ne.0 .and. k.lt.kmt_min) k = kmt_min 
              nkmt(i,j)=k
              error=.true.
              print*,' found isolated trench/corner at i=',i,' j=',j
            endif
          endif
        end do
      end do
      kmt=nkmt
      call set_kmt_bc()

      endif

      end subroutine 


      subroutine set_kmt_bc()
      use prep_module
c-----------------------------------------------------------------------
c      apply boundary conditions
c-----------------------------------------------------------------------
       if (cyclic) then
         kmt(1,:)   = kmt(imt-1,:); kmt(imt,:) = kmt(2,:)
       else
         kmt(imt,:) = 0; kmt(1,:) = 0
         if (enable_obc_east) then
          kmt(imt,:) = kmt(imt-1,:)
          i=imt-1
          do j=1,jmt
           k=min(min(kmt(i,j),kmt(i-1,j)),min(kmt(i,j),kmt(i-2,j)))
           if (k /= kmt(i,j)) then
            print*,' Changing Topography at eastern OB. '
            print*,'  at i=',i,' j=',j
            print*,'  new kmt(i,j)=',k, 'old kmt(i,j)=',kmt(i,j)
            kmt(i-2:i+1,j)=k
           endif
          enddo
         endif
         if (enable_obc_west) then
          kmt(1,:) = kmt(2,:)
          i=2
          do j=1,jmt
           k=min(min(kmt(i,j),kmt(i+1,j)),min(kmt(i+2,j),kmt(i,j)))
           if (k /= kmt(i,j)) then
            print*,' Changing Topography at western OB. '
            print*,'  at i=',i,' j=',j
            print*,'  new kmt(i,j)=',k, 'old kmt(i,j)=',kmt(i,j)
            kmt(i-1:i+2,j)=k
           endif
          enddo
         endif
       endif
       kmt(:,jmt) = 0 ; kmt(:,1) = 0
       if (enable_obc_north) then
         kmt(:,jmt) = kmt(:,jmt-1)
         j=jmt-1
         do i=1,imt
          k=min(min(kmt(i,j),kmt(i,j-1)),min(kmt(i,j),kmt(i,j-2)))
          if (k /= kmt(i,j)) then
           print*,' Changing Topography at northern OB. '
           print*,'  at i=',i,' j=',j
           print*,'  new kmt(i,j)=',k,' old kmt(i,j)=',kmt(i,j)
           kmt(i,j-2:j+1)=k
          endif
         enddo
       endif
       if (enable_obc_south) then
         kmt(:,1) = kmt(:,2)
         j=2
         do i=1,imt
          k=min(min(kmt(i,j),kmt(i,j+1)),min(kmt(i,j),kmt(i,j+2)))
          if (k /= kmt(i,j)) then
           print*,' Changing Topography at southern OB. '
           print*,'  at i=',i,' j=',j
           print*,'  new kmt(i,j)=',k,' old kmt(i,j)=',kmt(i,j)
           kmt(i,j-1:j+2)=k
          endif
         enddo
       endif
      end subroutine




      subroutine read_bin_kmt()
      use prep_module
      implicit none
      integer  :: i,j,k,io
      character(len=80) :: FLAME_ID ='no flame id '
      character(len=32+80+60) :: iotext='no stamp, no iotext '

      print*,' reading topography mask from file ',
     &    old_kmt_file(1:len_trim(old_kmt_file))

      call getunit(io,old_kmt_file,'usr ieee')
      read (io) flame_id  ! no checks
c       skip header record and read dimensional info
      read (io) 
      read (io) i, j, k
c       check that grid sizes in argument list 
      if (i/=imt .or. j /= jmt .or. k/= km) then
c        check i,j,k
         print*,' Error: '
         print*,' read imt,jmt,km=',i,j,k
         print*,' previously defined as ',imt,jmt,km
         call halt_stop(' reading kmt file ')
      endif
      read (io) 
      read (io) kmt
      close (io)
      end subroutine



      subroutine write_bin_kmt()
      use prep_module
      implicit none
      integer  :: io
      character(len=80) :: FLAME_ID ='no flame id '
      character(len=32+80+60) :: iotext='no stamp, no iotext '

      print*,' writing topography mask to file ',
     &    new_kmt_file(1:len_trim(new_kmt_file))

      call getunit(io,new_kmt_file,'usr ieee')
      write (io) flame_id ! no checks
      write (io) iotext
      write (io) imt, jmt, km
      write (io) iotext
      write (io) kmt
      close (io)
#ifdef partial_cell
      print*,' writing partial cell mask to file ',
     &    new_htp_file(1:len_trim(new_htp_file))

      call getunit(io,new_htp_file,'usr ieee')
      write (io) flame_id ! no checks
      write (io)  iotext
      write (io) imt, jmt, km
      write (io)  iotext
      write (io)  htp
      close (io)
#endif
      end subroutine

#include "options.inc"


      subroutine cobc (j)
      use spflame_module
      implicit none
      integer, intent(in) :: j
      integer i,k,n,is,ie
      real var,var1
      real diff_fb(is_pe:ie_pe,0:km)
      real ADV_Ty(is_pe:ie_pe,km)
      real vad(is_pe:ie_pe,km),phase_vel(is_pe:ie_pe,km,nt)
c
c-----------------------------------------------------------------------
c     at open boundaries always laplacian formulation is used (at tau)
c     (same as for interior but for tau !!)
c
c     notice: I have changed the standard code here and have
c             used now scaling for the diffusivity
c
c     SPFLAME version : c.eden
c-----------------------------------------------------------------------
c
      real diff_fe_ha(is_pe-1:ie_pe,km,j)
      real diff_tx,diff_ty,diff_tz
      real T_i,T_j
      integer ip,jp
#ifdef partial_cell
      real dhte,dhtn,dhwe,dhwn
      dhte(i,k,j)   = min(dht(i+1,k,j),dht(i,k,j))
      dhtn(i,k,j)   = min(dht(i,k,j+1),dht(i,k,j))
      dhwe(i,k,j)   = min(dhwt(i+1,k,j),dhwt(i,k,j))
      dhwn(i,k,j)   = min(dhwt(i,k,j+1),dhwt(i,k,j))

      T_i(i,k,j,n,ip) = t(i+ip,max(1,k-1),j,n,tau) - dhwe(i,k-1,j)
     &            *(t(i+ip,max(1,k-1),j,n,tau) - t(i+ip,k,j,n,tau))
     &               /dhwt(i+ip,k-1,j)
      T_j(i,k,j,n,jp) = t(i,max(1,k-1),j+jp,n,tau) - dhwn(i,k-1,j)
     &            *(t(i,max(1,k-1),j+jp,n,tau) - t(i,k,j+jp,n,tau))
     &               /dhwt(i,k-1,j+jp)
#else
      T_i(i,k,j,n,ip) = t(i+ip,k,j,n,tau)
      T_j(i,k,j,n,jp) = t(i,k,j+jp,n,tau)
#endif
      DIFF_Tx(i,k,j) = (diff_fe_ha(i,  k,j)*tmask(i+1,k,j)
     &                - diff_fe_ha(i-1,k,j)*tmask(i-1,k,j))*cstdxtr(i,j)
#ifdef partial_cell
     &                             /dht(i,k,j)
#endif
      DIFF_Ty(i,k,j) = ahc_north_ha(j)*tmask(i,k,j+1)*
     &                     (t_j(i,k,j,n,1) - t_j(i,k,j,n,0))
     &                         *ah_scale(i,j)
#ifdef partial_cell
     &                         /dht(i,k,j)*dhtn(i,k,j)
#endif
     &                   - ahc_south_ha(j)*tmask(i,k,j-1)*
     &                     (t_j(i,k,j,n,0) - t_j(i,k,j,n,-1))
     &                         *ah_scale(i,j)
#ifdef partial_cell
     &                         /dht(i,k,j)*dhtn(i,k,j-1)
#endif
      DIFF_Tz(i,k) = (diff_fb(i,k-1) - diff_fb(i,k))
#ifdef partial_cell
     &               /dht(i,k,j)
#else
     &               *dztr(k)
#endif
      real obcs,obcn,data

      obcs=1./(86400.*5.); obcn=1./(86400.*5.) ! hardwired 5 day time scale
 
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
c
      if (j .eq. 2) then
c
c       my_blk_j was already tested
c
c-----------------------------------------------------------------------
c       1) compute the advective velocity "vad" 
c          at the north face of the "t" grid box
c
c       2) compute phase velocity at the southern boundary: c1s
c-----------------------------------------------------------------------
c
        var = -dyu(j+1)/dt 
        do k=1,km
          do i=is,ie
             vad(i,k)=(u(i,k,j,2,tau)*dxt(i)+u(i-1,k,j,2,tau)
     &            *dxt(i-1))/(dxt(i)+dxt(i-1))*tmask(i,k,j)
             if (vad(i,k).gt.0) vad(i,k)=0.
c	     
	     do n=1,nt
	      var1=t(i,k,j+2,n,taum1)-t(i,k,j+1,n,taum1)
	      if (var1.eq.0.) then
		phase_vel(i,k,n)=var
	      else
		phase_vel(i,k,n)=var*(t(i,k,j+1,n,tau)-t(i,k,j+1,n,taum1))
     &                            /var1*tmask(i,k,j)
                if (phase_vel(i,k,n).gt. 0.) phase_vel(i,k,n)=0.
		if (phase_vel(i,k,n).lt.var) phase_vel(i,k,n)=var
	      endif
	     enddo
          enddo
        enddo
      endif
c
      if (j .eq. jmt-1) then
c
c-----------------------------------------------------------------------
c       1) compute the advective velocity "vad" 
c          at the south face of the "t" grid box
c
c       2) compute phase velocity at the northern boundary: c1n
c-----------------------------------------------------------------------
c
        var=dyu(j-1)/dt
        do k=1,km
          do i=is,ie
           vad(i,k)=(u(i,k,j-1,2,tau)*dxt(i)+u(i-1,k,j-1,2,tau)
     &             *dxt(i-1))/(dxt(i)+dxt(i-1))*tmask(i,k,j)
           if (vad(i,k).lt.0) vad(i,k)=0.
           do n=1,nt
            var1=t(i,k,j-1,n,taum1)-t(i,k,j-2,n,taum1)
	    if (var1.eq.0.) then
 	      phase_vel(i,k,n)=var
	    else
 	      phase_vel(i,k,n)=-var*(t(i,k,j-1,n,tau)-t(i,k,j-1,n,taum1))
     &                           /var1*tmask(i,k,j)
              if (phase_vel(i,k,n).lt.  0) phase_vel(i,k,n)=0.
	      if (phase_vel(i,k,n).gt.var) phase_vel(i,k,n)=var
	    endif
	   enddo
          enddo
        enddo
      endif
c
      do n=1,nt
c
c-----------------------------------------------------------------------
c           diffusive flux across eastern face of "T" cells
c           (use constant horizontal diffusion)
c-----------------------------------------------------------------------
c
        do k=1,km
         do i=is-1,ie
          diff_fe_ha(i,k,j)  = ah_cstdxur(i,j)*
     &                     (t_i(i,k,j,n,1) - t_i(i,k,j,n,0))
     &                         *ah_scale(i,j)
#ifdef partial_cell
     &                         *dhte(i,k,j)
#endif
         enddo
        enddo
c
c-----------------------------------------------------------------------
c           diffusive flux across bottom face of "T" cells
c           use constant vertical diffusion
c-----------------------------------------------------------------------
c
        do k=1,km-1
          do i=is,ie
             diff_fb(i,k) =  kappa_h*
     &                         (t(i,k,j,n,tau) - t(i,k+1,j,n,tau))
#ifdef partial_cell
     &                   /dhwt(i,k,j)
#else
     &                   *dzwr(k)
#endif
          enddo
        enddo

        diff_fb(is:ie,km)=0.
        do i=is,ie
          diff_fb(i,0)        = stf(i,j,n)
          diff_fb(i,kmt(i,j)) = btf(i,j,n)
        enddo
c
c-----------------------------------------------------------------------
c    calculate values for meridional diffusion and advection of tracers
c-----------------------------------------------------------------------
c
        if (j .eq. 2) then
c
c    radiation condition at the southern wall
c    -------------------------------------------
c
         do k=1,km
           do i=is,ie
              ADV_Ty(i,k)=-(phase_vel(i,k,n)+vad(i,k))
     &                  *(t(i,k,j+1,n,tau)-t(i,k,j,n,tau))/dyu(j)
           enddo
         enddo
        end if
c
        if (j .eq. jmt-1) then
c
c    radiation condition at the northern wall
c    -------------------------------------------
c
         do k=1,km
           do i=is,ie
              ADV_Ty(i,k)=-(phase_vel(i,k,n)+vad(i,k))
     &                  *(t(i,k,j,n,tau)-t(i,k,j-1,n,tau))/dyu(j-1)
           enddo
         enddo
        end if
c
c-----------------------------------------------------------------------
c           construct tracer source terms
c           here: force n/s wall to observed values
c-----------------------------------------------------------------------
c
        do k=1,km
         do i=is,ie
          source(i,k,j) = 0.
         enddo
        enddo
c
	if (j == 2 .and. restore_TS_obc_south.and. n<=2 ) then
	    do k=1,km
	      do i=is,ie
                   data=ts_obc_south(i,k,n)
                   source(i,k,j) = source(i,k,j) - 
     &                               obcs*(t(i,k,j,n,tau) - data)
              enddo
	    enddo
	endif
c
	if (j .eq. jmt-1 .and. restore_TS_obc_north.and. n<=2 ) then
	    do k=1,km
	      do i=is,ie
                   data=ts_obc_north(i,k,n)
                   source(i,k,j) = source(i,k,j) - 
     &                               obcn*(t(i,k,j,n,tau) - data)
              enddo
	    enddo
	endif
c
c-----------------------------------------------------------------------
c      calculate the new tracer quantities 
c-----------------------------------------------------------------------
c
        do k=1,km
          do i=is,ie
                t(i,k,j,n,taup1) = t(i,k,j,n,tau) + dt*(
     &                  DIFF_Tx(i,k,j) + DIFF_Tz(i,k)
     &                + DIFF_Ty(i,k,j)+ ADV_Ty(i,k) 
     &                + source(i,k,j) )*tmask(i,k,j)
          enddo
        enddo

      enddo  ! tracer loop

      end subroutine cobc






      subroutine cobc2 (is,ie, js, je, i, n)
      use spflame_module
      implicit none
      integer, intent(in) :: is,ie,js,je,i,n
      integer ii,j,k
      real diff_fb(0:km,js:je)
      real ADV_Tx(km,js:je)
      real uad(km,js:je)
      real phase_vel(km,js:je)
      real var,var2
      real T_i,T_j
      integer ip,jp
#ifdef partial_cell
      real dhte,dhtn,dhwe,dhwn
      dhte(i,k,j)   = min(dht(i+1,k,j),dht(i,k,j))
      dhtn(i,k,j)   = min(dht(i,k,j+1),dht(i,k,j))
      dhwe(i,k,j)   = min(dhwt(i+1,k,j),dhwt(i,k,j))
      dhwn(i,k,j)   = min(dhwt(i,k,j+1),dhwt(i,k,j))

      T_i(i,k,j,n,ip) = t(i+ip,max(1,k-1),j,n,tau) - dhwe(i,k-1,j)
     &            *(t(i+ip,max(1,k-1),j,n,tau) - t(i+ip,k,j,n,tau))
     &               /dhwt(i+ip,k-1,j)
      T_j(i,k,j,n,jp) = t(i,max(1,k-1),j+jp,n,tau) - dhwn(i,k-1,j)
     &            *(t(i,max(1,k-1),j+jp,n,tau) - t(i,k,j+jp,n,tau))
     &               /dhwt(i,k-1,j+jp)
#else
      T_i(i,k,j,n,ip) = t(i+ip,k,j,n,tau)
      T_j(i,k,j,n,jp) = t(i,k,j+jp,n,tau)
#endif
c
c-----------------------------------------------------------------------
c     at open boundaries always laplacian formulation is used (at tau)
c-----------------------------------------------------------------------
c
      real diff_fe_ha(i-1:i,km,js_pe:je_pe)
      real diff_ty,diff_tx,diff_tz

      DIFF_Tx(i,k,j) = (diff_fe_ha(i,  k,j)*tmask(i+1,k,j)
     &                - diff_fe_ha(i-1,k,j)*tmask(i-1,k,j))*cstdxtr(i,j)
#ifdef partial_cell
     &                             /dht(i,k,j)
#endif

      DIFF_Ty(i,k,j) = ahc_north_ha(j)*tmask(i,k,j+1)*
     &                     (t_j(i,k,j,n,1) - t_j(i,k,j,n,0))
     &                         *ah_scale(i,j)
#ifdef partial_cell
     &                         /dht(i,k,j)*dhtn(i,k,j)
#endif
     &                   - ahc_south_ha(j)*tmask(i,k,j-1)*
     &                     (t_j(i,k,j,n,0) - t_j(i,k,j,n,-1))
     &                         *ah_scale(i,j)
#ifdef partial_cell
     &                         /dht(i,k,j)*dhtn(i,k,j-1)
#endif

      DIFF_Tz(i,k,j) = (diff_fb(k-1,j) - diff_fb(k,j))
#ifdef partial_cell
     &               /dht(i,k,j)
#else
     &               *dztr(k)
#endif

      real obce,obcw,data

      obce=1./(86400.*5.); obcw=1./(86400.*5.)
c
      if (i .eq. 2  ) then
        do k=1,km
          do j=js,je
             var = -dxu(i+1)*csu(j)/dt 
             uad(k,j)=(u(i,k,j,1,tau)*dyt(j)+u(i,k,j-1,1,tau)
     &            *dyt(j-1))/(dyt(j)+dyt(j-1))*tmask(i,k,j)
             if (uad(k,j).gt.0) uad(k,j)=0.
	     var2=t(i+2,k,j,n,taum1)-t(i+1,k,j,n,taum1)
	     if (var2.eq.0.) then
		phase_vel(k,j)=var
             else
		phase_vel(k,j)=var*(t(i+1,k,j,n,tau)-t(i+1,k,j,n,taum1))
     &                            /var2*tmask(i,k,j)
                if (phase_vel(k,j).gt. 0.) phase_vel(k,j)=0.
		if (phase_vel(k,j).lt.var) phase_vel(k,j)=var
	     endif
             if (j .eq. 2)     uad(k,j)=0.
             if (j .eq. jmt-1) uad(k,j)=0.
          enddo
        enddo
      endif
c
      if (i .eq. imt-1  ) then
        do k=1,km
          do j=js,je
             var = dxu(i-2)*csu(j)/dt 
             uad(k,j)=(u(i-1,k,j,1,tau)*dyt(j)+u(i-1,k,j-1,1,tau)
     &            *dyt(j-1))/(dyt(j)+dyt(j-1))*tmask(i,k,j)
             if (uad(k,j).lt.0) uad(k,j)=0.
	     var2=t(i-1,k,j,n,taum1)-t(i-2,k,j,n,taum1)
	     if (var2.eq.0.) then
		phase_vel(k,j)=var
	     else
		phase_vel(k,j)=-var*(t(i-1,k,j,n,tau)
     &                -t(i-1,k,j,n,taum1))/var2*tmask(i,k,j)
                if (phase_vel(k,j).lt. 0.) phase_vel(k,j)=0.
		if (phase_vel(k,j).gt.var) phase_vel(k,j)=var
	     endif
             if (j .eq. 2)     uad(k,j)=0.
             if (j .eq. jmt-1) uad(k,j)=0.
          enddo
        enddo
      endif
c
c-----------------------------------------------------------------------
c           diffusive flux across eastern face of "T" cells
c           (use constant horizontal diffusion)
c-----------------------------------------------------------------------
c
      do j=js,je
         do k=1,km
           do ii=i-1,i
             diff_fe_ha(ii,k,j)  =ah_cstdxur(ii,j)*
     &                         (t_i(ii,k,j,n,1) - t_i(ii,k,j,n,0))
     &                         *ah_scale(i,j)
#ifdef partial_cell
     &                         *dhte(i,k,j)
#endif
           enddo
         enddo
      enddo
c
c-----------------------------------------------------------------------
c           diffusive flux across bottom face of "T" cells
c           use constant vertical diffusion
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km-1
	        diff_fb(k,j) = kappa_h*
     &                         (t(i,k,j,n,tau) - t(i,k+1,j,n,tau))
#ifdef partial_cell
     &                   /dhwt(i,k,j)
#else
     &                   *dzwr(k)
#endif
        enddo
      enddo
      diff_fb(km,js:je)=0.
      do j=js,je
         diff_fb(0,j)  = stf(i,j,n)
         diff_fb(kmt(i,j),j) = btf(i,j,n)
      enddo
c
c-----------------------------------------------------------------------
c    radiation condition for lateral advection of tracers
c-----------------------------------------------------------------------
c
      if (i .eq.  2) then
c
c         western wall:
c         -------------
c
        do j=js,je
           do k=1,km
              ADV_Tx(k,j)=-(phase_vel(k,j)+uad(k,j))
     &         *(t(i+1,k,j,n,tau)-t(i,k,j,n,tau))*dxur(i)*csur(j)
           enddo
        enddo
      endif
c
      if (i .eq. imt-1  ) then
c
c         eastern wall:
c         -------------
c
        do j=js,je
           do k=1,km
              ADV_Tx(k,j)=-(phase_vel(k,j)+uad(k,j))
     &         *(t(i,k,j,n,tau)-t(i-1,k,j,n,tau))*dxur(i-1)*csur(j)
           enddo
        enddo
      endif
c
c-----------------------------------------------------------------------
c           construct tracer source terms
c           here: force w/e wall to observed values
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
          source(i,k,j) = 0.
        enddo
      enddo
c
      if (i .eq. 2 .and. restore_TS_obc_west .and. n<=2) then
	    do j=js,je
	      do k=1,km
                   data=ts_obc_west(j,k,n)
                   source(i,k,j) = source(i,k,j) - 
     &                               obcw*(t(i,k,j,n,tau) - data)
              enddo
	    enddo
      endif
c
      if (i .eq.  imt-1 .and. restore_TS_obc_east .and. n<=2) then
	    do j=js,je
	      do k=1,km
                   data=ts_obc_east(j,k,n)
                   source(i,k,j) = source(i,k,j) - 
     &                               obce*(t(i,k,j,n,tau) - data)
              enddo
	    enddo
      endif
c
c-----------------------------------------------------------------------
c     calculate the new tracer quantities 
c-----------------------------------------------------------------------
c
      do j=js,je
         do k=1,km
                t(i,k,j,n,taup1) = t(i,k,j,n,tau) + dt*(
     &                  DIFF_Tx(i,k,j) 
     &                + DIFF_Tz(i,k,j) 
     &                + DIFF_Ty(i,k,j) 
     &                + ADV_Tx(k,j) 
     &                + source(i,k,j)  )*tmask(i,k,j)
         enddo
      enddo
c
      end subroutine cobc2

#include "options.inc"




      subroutine init_diag
c
c-----------------------------------------------------------------------
c     initialize all diagnostics here
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      if (my_pe==0) then
       print*,' Initialising diagnostics '
#ifdef netcdf_diagnostics
       print*,' writing to NetCDF files '
#else 
       print*,' writing to unformatted files '
#endif
      endif
      if (enable_snapshots)   call init_snap_cdf
      if (enable_overturning) call init_over_cdf
      if (enable_heat_tr)     call init_heat_tr_cdf
                              call init_averages
                              call init_variances
      if (enable_timeseries)  call init_diag_timeserie
      if (enable_diag_press)  call init_diag_press
      if (enable_diag_float)  call diag_float_init
      if (enable_diag_blue)   call diag_blue_init

      if (my_pe==0) print*,' done'
      end subroutine init_diag


      subroutine diag
c
c-----------------------------------------------------------------------
c     call diagnostics here
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none

      if (enable_stability_tests) call stab()
      if (enable_ts_monitor.and. .not. eulerback2) 
     &               call diag_ts_monitor
      if (enable_snapshots .and. snapshot_time_step) 
     &               call diag_snap
      if (enable_overturning .and. snapshot_time_step) 
     &               call diag_over
c      called in tracer, we need adv_fn and diff_fn
c      if (enable_heat_tr .and. snapshot_time_step) 
c     &               call diag_heat_tr
      call averages
      call variances
      if (enable_timeseries .and. snapshot_time_step) 
     &               call diag_timeserie()
      if (enable_diag_press .and. snapshot_time_step)  
     &               call diag_press()

      if (enable_diag_float .and. .not. eulerback1) call diag_float
      if (enable_diag_blue  .and. .not. eulerback1) call diag_blue

      end subroutine diag



      subroutine diag_ts_monitor()
c
c-----------------------------------------------------------------------
c     diagnose some basinwide averages and write to stdout
c-----------------------------------------------------------------------
c
      use spflame_module
      use freesurf_module
      implicit none
      integer i,j,k,n,is,ie,js,je
      real :: totke=0.,tbar(nt),tvar(nt)
      real :: darea,fx,etaq
      character (len=80) :: string

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      tbar=0.; tvar=0.
      do j=js,je
        fx = rho0*0.5*csu(j)*dyu(j)
        do k=1,km
         do i=is,ie
          totke = totke + u(i,k,j,1,tau)**2*fx*dxu(i)
#ifdef partial_cell
     &              *dhu(i,k,j)
#else
     &              *dzt(k)
#endif
          totke = totke + u(i,k,j,2,tau)**2*fx*dxu(i)
#ifdef partial_cell
     &              *dhu(i,k,j)
#else
     &              *dzt(k)
#endif
         enddo
        enddo
        do n=1,nt
         do k=1,km
          do i=is,ie
           darea = dxt(i)*cst(j)*dyt(j)*tmask(i,k,j)
#ifdef partial_cell
     &              *dht(i,k,j)
#else
     &              *dzt(k)
#endif
           tbar(n)=tbar(n)+t(i,k,j,n,tau)*darea
           tvar(n)=tvar(n)+t(i,k,j,n,tau)**2*darea
         enddo
        enddo
       enddo
      enddo
      call global_sum(totke); 
      call global_sum_vec(tbar,nt)
      call global_sum_vec(tvar,nt) 
      totke  = totke  /ucellv
      tbar  = tbar/tcellv
      tvar  = tvar/tcellv - tbar**2

      if (enable_freesurf) then

       etaq=0.
       do j=js,je
         do i=is,ie
           darea = dxt(i)*cst(j)*dyt(j)*tmask(i,1,j)
           etaq=etaq+etat(i,j,3)*darea
         enddo
       enddo
       call global_sum(etaq); 
       etaq=etaq/tcella(1)

       if (my_pe==0)  print*,
     &  ' domain ',sub_domain,
     &  ' : (itt=',itt,' ',current_stamp,')',
     &  ' etab=',etaq,
     &  ' ke=',totke,' tbar=',tbar,' tvar=',tvar

      else
       if (my_pe==0) print*,
c     &  print'(a,i1,a,i8,4a,i3,a,e12.7,a,e12.7,a,e12.7)',
     &  ' domain ',sub_domain,
     &  ' : (itt=',itt,' ',current_stamp,')',
     &  ' itts=',itts_solver,
     &  ' ke=',totke,' tbar=',tbar,' tvar=',tvar
      endif

      end subroutine diag_ts_monitor

#include "options.inc"

c
c--------------------------------------------------------
c      templates to read surface wind stress (tau) and
c      surface "friction velocity" (ustar) data
c      from external files.
c
c     Notes:
c      "friction velocity" is needed for turbulence closure 
c      models and parameterisations in spflame.
c      wind stress should be in  dyn/cm**2
c      friction velocity should be (cm/s)**3
c
c      Four subroutines are defined:
c      "read_dims_tau" and "read_tau" both called
c      in prep_sbc (in prep_main.F) and
c      "read_dims_ustar" and read_ustar called
c      in prep_sbc as well.
c      Header of subroutines should not be touched.
c      CPP directives are set in prep_template.F
c
c                            c.eden  nov 2002
c--------------------------------------------------------
c
#ifdef read_tau_ecmwf
c
c--------------------------------------------------------
c    use a 3 year monthly mean climatology from the european
c    ECMWF model (same data used in the DYNAMO project)
c--------------------------------------------------------
c
      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt,io
      character*32 stamp
      real (kind=4) :: dpm
      integer (kind=4) nx_,ny_
      print*,' reading monthly wind stress data from ECMWF'
      open(10,file='data/ecmwf/ecmwf_BB.tau',form='unformatted')
      read (10); read (10) stamp, dpm, nx_, ny_
      nx=nx_;ny=ny_; nt=12
      close(10)
      end subroutine read_dims_tau


      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt)

      integer io,n,k,kk,i,j
      real cleanmsk(nx,ny)
      character*32 stamp,s
      real (kind=4) dpm(nt), x4(nx),y4(ny),u(nx,ny),v(nx,ny),
     &               mask4(nx,ny)
      integer (kind=4) k4
      toffset=0.0
      open(10,file='data/ecmwf/ecmwf_BB.tau',form='unformatted')
      do n=1,nt
        read (10); read (10) s, dpm(n), k4, k4, k4, x4,y4,u,v
        time(n)=dpm(n)
        tau(:,:,n,1)=u
        tau(:,:,n,2)=v
        x=x4;y=y4;
      enddo
      close(10)
c   read land mask
      open(10,file='data/ecmwf/ecmwf_BB.mask',form='unformatted')
      read (10) ; read (10); read (10) mask4
      mask=mask4
      close(10)
      cleanmsk = mask
      do j=2, ny-1
        do i=2, nx-1
          if (cleanmsk(i,j)/=0. .and. 
     &        cleanmsk(i+1,j)==0. .and. cleanmsk(i-1,j)==0. .and. 
     &        cleanmsk(i,j+1)==0. .and. cleanmsk(i,j-1)==0.)
     &        mask(i,j) = 0.
        end do
      end do
c   convert N/m**2 to dyn/cm**2 
      tau= 10.*tau
c   apply mask
      do n=1,nt
        where (mask==0.) tau(:,:,n,1) = spval
        where (mask==0.) tau(:,:,n,2) = spval
      enddo
      end subroutine read_tau
c
c
#elif defined read_tau_ncep_monthly
c
c--------------------------------------------------------
c    use the 3 year monthly mean ECMWF climatology plus
c    wind stress anomalies from NCEP/NCAR data.
c    Same forcing was used in Eden+Willebrand, 01, J.Clim.
c--------------------------------------------------------
c
      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt,io
      character*32 stamp
      real (kind=4) :: dpm
      integer (kind=4) nx_,ny_
#include "netcdf.inc"
       integer :: iret, ncid,dims(4),vid

      print*,' reading monthly wind stress data from ECMWF'
      print*,' plus wind stress anomalies from NCEP/NCAR'
      open(10,file='data/ecmwf/ecmwf_BB.tau',form='unformatted')
      read (10); read (10) stamp, dpm, nx_, ny_
      nx=nx_;ny=ny_; 
      close(10)
      iret=nf_open('data/ncep/taux_anom.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'uflx',vid)
      iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
      call ncclos (ncid, iret)
      end subroutine read_dims_tau


      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      use time_type_module
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt),mtime(12)
      integer io,n,k,kk,i,j
      real cleanmsk(nx,ny)
      character*32 stamp,s
      real :: mtau(nx,ny,12,2) 
      real (kind=4) dpm(nt), x4(nx),y4(ny),u(nx,ny),v(nx,ny),
     &               mask4(nx,ny)
      integer (kind=4) k4
#include "netcdf.inc"
      integer :: ncid,txid,tyid,dims(4),lonid,latid,iret,ncid2
      integer :: nid
      character*80 name
      real (kind=4) ::  spv
      real (kind=4), allocatable :: x2(:),y2(:),tau2(:,:,:),tx(:)
      real (kind=4), allocatable :: regx(:,:),regy(:,:),nmask(:,:)
      real, allocatable   :: work_t(:)
      integer :: init_t=1, lenw_t,nx2,ny2,nn
      type(time_type) :: t1

      open(10,file='data/ecmwf/ecmwf_BB.tau',form='unformatted')
      do n=1,12
        read (10); read (10) s, dpm(n), k4, k4, k4, x4,y4,u,v
        mtime(n)=dpm(n)
        mtau(:,:,n,1)=u
        mtau(:,:,n,2)=v
        x=x4;y=y4;
      enddo
      close(10)
c   read land mask
      open(10,file='data/ecmwf/ecmwf_BB.mask',form='unformatted')
      read (10) ; read (10); read (10) mask4
      mask=mask4
      close(10)
      cleanmsk = mask
      do j=2, ny-1
        do i=2, nx-1
          if (cleanmsk(i,j)/=0. .and. 
     &        cleanmsk(i+1,j)==0. .and. cleanmsk(i-1,j)==0. .and. 
     &        cleanmsk(i,j+1)==0. .and. cleanmsk(i,j-1)==0.)
     &        mask(i,j) = 0.
        end do
      end do
c   convert N/m**2 to dyn/cm**2 and apply mask
      do n=1,12
        mtau(:,:,n,1)= 10.*mtau(:,:,n,1)
        mtau(:,:,n,2)= 10.*mtau(:,:,n,2)
        where (mask==0.) mtau(:,:,n,1) = spval
        where (mask==0.) mtau(:,:,n,2) = spval
      enddo
c
c   read land/sea mask for NCEP data
c
      iret=nf_open('data/ncep/lsmask.19294.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'lsmask',txid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
      allocate( nmask(nx2,ny2) )
      iret= nf_get_vara_real (ncid,txid ,(/1,1,1/),(/nx2,ny2,1/),nmask)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      call ncclos (ncid, iret)
c
c   read NCEP/NCAR wind stress anomalies
c
      iret=nf_open('data/ncep/taux_anom.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_open('data/ncep/tauy_anom.cdf',NF_nowrite,ncid2)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'uflx',txid)
      iret=nf_inq_varid(ncid2,'vflx',tyid)
      iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
      nx2=nx2+2 ! append some rows
      ny2=ny2+4

      allocate(x2(nx2),y2(ny2), tau2(nx2,ny2,2), tx(nx2),
     &         regx(nx,ny), regy(nx,ny) )
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=NF_INQ_VARID (NCID, name, lonid)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=NF_INQ_VARID (NCID, name, latid)

      iret= nf_get_vara_real (ncid,lonid ,1,nx2-2,x2(2:nx2-1))
      x2(nx2)=2*x2(nx2-1)-x2(nx2-2)
      x2(1)=x2(2)-(x2(3)-x2(2))
      iret= nf_get_vara_real (ncid,latid ,1,ny2-4,y2(3:ny2-2)) 
      y2(ny2-1)=2*y2(ny2-2)-y2(ny2-3)
      y2(2)=y2(3)-(y2(4)-y2(3))
      y2(ny2)=2*y2(ny2-1)-y2(ny2-2)
      y2(1)=y2(2)-(y2(3)-y2(2))
      y2=y2(ny2:1:-1)
      iret = nf_get_att_real(ncid, txid, 'missing_value', spv)

c   read each month and interpolate on ECMWF grid
      print*,' interpolating data '
      lenw_t = 10*max(nx,ny)
      allocate( work_t(lenw_t) )
      t1 =  set_date(1948, 1, 1, 0, 0, 0)
      toffset=t1%days
      do n=1,nt
        tau2=spv
        iret= nf_get_vara_real (ncid,txid ,
     &         (/1,1,n/),(/nx2-2,ny2-4,1/),tau2(2:nx2-1,3:ny2-2,1))
        iret= nf_get_vara_real (ncid2,tyid ,
     &         (/1,1,n/),(/nx2-2,ny2-4,1/),tau2(2:nx2-1,3:ny2-2,2))

        where( nmask == -1) tau2(2:nx2-1,3:ny2-2,1) = spv
        where( nmask == -1) tau2(2:nx2-1,3:ny2-2,2) = spv
c     acount for appended rows and switch latitudinal ordering
        tau2(nx2,:,:)=tau2(2,:,:)
        tau2(1,:,:)  =tau2(nx2-1,:,:)
        tau2(:,:,:) = tau2(:,ny2:1:-1,:)
c    convert special values
        where( tau2 == spv) tau2=spval
!      convert N/m**2 to dyn/cm**2  and change sign
        where( tau2 /= spval) tau2=tau2*(-10.)
c     interpolate
        call tranlon (tau2(1,1,1), nx2, nx2-2, ny2, x2, x,nx, tx)
        call tranlon (tau2(1,1,2), nx2, nx2-2, ny2, x2, x,nx, tx)
        call ctf (tau2(1,1,1), nx2, ny2, tx, y2, 
     &                  regx(1,1),nx, ny, 1, nx, 1, ny,
     &                  x, y, init_t, work_t, lenw_t,spval)
        init_t=0 ! we can use the same interpolation weights
        call ctf (tau2(1,1,2), nx2, ny2, tx, y2, 
     &                  regy(1,1),nx, ny, 1, nx, 1, ny,
     &                  x, y, init_t, work_t, lenw_t,spval)
c     add mean
        nn = mod(n-1,12)+1
        where( regx == spval) regx=0.
        where( regy == spval) regy=0.
        tau(:,:,n,1)=mtau(:,:,nn,1)+regx(:,:)
        tau(:,:,n,2)=mtau(:,:,nn,2)+regy(:,:)
        where (mask==0.) tau(:,:,n,1) = spval
        where (mask==0.) tau(:,:,n,2) = spval
        time(n)=mtime(nn)
c     care about time
      enddo
      call ncclos (ncid, iret)
      call ncclos (ncid2, iret)
      print*,' done '
      deallocate(x2,y2,tx,tau2,regx,regy, work_t,nmask)
      end subroutine read_tau
c
#elif defined read_tau_nao_proxy
c
c--------------------------------------------------------
c    use the 3 year monthly mean ECMWF climatology plus
c    NAO related time series of wind stress anomalies
c    (which is given by the product of the monthly NAO-index
c    and the monthly regression patterns of taux/tauy with
c    the NAO-index). 
c    Same forcing was used in Eden+Jung 01, J.Clim.
c
c    NOTE: Start and end year of the NAO time series to be used
c    have to be set in the common block tau_nao_reg.
c    The NAO-index is given for 1865 to 2001 a subset of this
c    period can be set with the common block tau_nao_reg
c    See also prep_template_sflx.F 
c--------------------------------------------------------
c
      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt,io
      character*32 stamp
      real (kind=4) :: dpm
      integer (kind=4) nx_,ny_
#include "netcdf.inc"
      integer :: ncid,iret,nid,dims
       integer :: start_y,end_y
       common / tau_nao_reg/ start_y,end_y

      print*,' reading monthly wind stress data from ECMWF'
      print*,' plus NAO related wind stress anomalies from NCEP/NCAR'
      open(10,file='data/ecmwf/ecmwf_BB.tau',form='unformatted')
      read (10); read (10) stamp, dpm, nx_, ny_
      nx=nx_;ny=ny_; nt=12
      close(10)
      iret=nf_open('data/NAO_reg/nao_monthly.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'nao',nid)
      iret=NF_INQ_VARDIMID (NCID,nid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs, nt)
      call ncclos (ncid, iret)
c     start/end_y gives starting and end year of NAO time series
        start_y = max(1865,1865); end_y = min(1948,nt/12+1864) ! 
c        start_y = max(1947,1865); end_y = min(5948,nt/12+1864) ! 
      nt = (end_y-start_y+1)*12
      print*,' from Jan. of year ',start_y
      print*,' to Dec. of year   ',end_y
      print*,' nt=',nt
      end subroutine read_dims_tau

      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      use time_type_module
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt),mtime(12)
      integer io,n,k,kk,i,j
      real cleanmsk(nx,ny)
      character*32 stamp,s
      real :: mtau(nx,ny,12,2) 
      real (kind=4) dpm(nt), x4(nx),y4(ny),u(nx,ny),v(nx,ny),
     &               mask4(nx,ny)
      integer (kind=4) k4
#include "netcdf.inc"
      integer :: ncid,txid,tyid,dims(4),lonid,latid,iret
      integer :: nid
      character*80 name
      real (kind=4) ::  spv,add_offset,scale_factor
      real (kind=4), allocatable :: x2(:),y2(:),tau2(:,:,:),tx(:)
      real (kind=4), allocatable :: regx(:,:,:),regy(:,:,:)
      real, allocatable   :: work_t(:)
      integer :: init_t=1, lenw_t,nx2,ny2,nn
      type(time_type) :: t1
      integer :: start_y,end_y
      common / tau_nao_reg/ start_y,end_y

      open(10,file='data/ecmwf/ecmwf_BB.tau',form='unformatted')
      do n=1,12
        read (10); read (10) s, dpm(n), k4, k4, k4, x4,y4,u,v
        mtime(n)=dpm(n)
        mtau(:,:,n,1)=u
        mtau(:,:,n,2)=v
        x=x4;y=y4;
      enddo
      close(10)
c   read land mask
      open(10,file='data/ecmwf/ecmwf_BB.mask',form='unformatted')
      read (10) ; read (10); read (10) mask4
      mask=mask4
      close(10)
      cleanmsk = mask
      do j=2, ny-1
        do i=2, nx-1
          if (cleanmsk(i,j)/=0. .and. 
     &        cleanmsk(i+1,j)==0. .and. cleanmsk(i-1,j)==0. .and. 
     &        cleanmsk(i,j+1)==0. .and. cleanmsk(i,j-1)==0.)
     &        mask(i,j) = 0.
        end do
      end do
c   convert N/m**2 to dyn/cm**2 and apply mask
      do n=1,12
        mtau(:,:,n,1)= 10.*mtau(:,:,n,1)
        mtau(:,:,n,2)= 10.*mtau(:,:,n,2)
        where (mask==0.) mtau(:,:,n,1) = spval
        where (mask==0.) mtau(:,:,n,2) = spval
      enddo
c
c   read NAO monthly regression patterns
c
      iret=nf_open('data/NAO_reg/reg_tau.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'taux_reg',txid)
      iret=nf_inq_varid(ncid,'tauy_reg',tyid)
      iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
      nx2=nx2+2 ! append some rows
      ny2=ny2+4
      print*,' nx2 = ',nx2, 'ny2=',ny2

      allocate(x2(nx2),y2(ny2), tau2(nx2,ny2,2), tx(nx2),
     &         regx(nx,ny,12), regy(nx,ny,12) )
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=NF_INQ_VARID (NCID, name, lonid)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=NF_INQ_VARID (NCID, name, latid)

      iret= nf_get_vara_real (ncid,lonid ,1,nx2-2,x2(2:nx2-1))
      x2(nx2)=2*x2(nx2-1)-x2(nx2-2)
      x2(1)=x2(2)-(x2(3)-x2(2))
      iret= nf_get_vara_real (ncid,latid ,1,ny2-4,y2(3:ny2-2)) 
      y2(ny2-1)=2*y2(ny2-2)-y2(ny2-3)
      y2(2)=y2(3)-(y2(4)-y2(3))
      y2(ny2)=2*y2(ny2-1)-y2(ny2-2)
      y2(1)=y2(2)-(y2(3)-y2(2))
      y2=y2(ny2:1:-1)
      iret = nf_get_att_real(ncid, txid, 'missing_value', spv)
      add_offset=0.0
      iret= nf_get_att_real (ncid,txid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,txid ,'scale_factor',scale_factor)

c   read each month and interpolate on ECMWF grid
      print*,' interpolating data '
      lenw_t = 10*max(nx,ny)
      allocate( work_t(lenw_t) )
      do n=1,12
        tau2=spv
        iret= nf_get_vara_real (ncid,txid ,
     &         (/1,1,n/),(/nx2-2,ny2-4,1/),tau2(2:nx2-1,3:ny2-2,1))
        iret= nf_get_vara_real (ncid,tyid ,
     &         (/1,1,n/),(/nx2-2,ny2-4,1/),tau2(2:nx2-1,3:ny2-2,2))
        tau2(nx2,:,:)=tau2(2,:,:)
        tau2(1,:,:)  =tau2(nx2-1,:,:)
        tau2(:,:,:) = tau2(:,ny2:1:-1,:)
        where( tau2 == spv) tau2=spval
!      convert N/m**2 to dyn/cm**2  and change sign
        where( tau2 /= spval) tau2=(tau2*scale_factor+add_offset)*(-10.)
        call tranlon (tau2(1,1,1), nx2, nx2-2, ny2, x2, x,nx, tx)
        call tranlon (tau2(1,1,2), nx2, nx2-2, ny2, x2, x,nx, tx)
        call ctf (tau2(1,1,1), nx2, ny2, tx, y2, 
     &                  regx(1,1,n),nx, ny, 1, nx, 1, ny,
     &                  x, y, init_t, work_t, lenw_t,spval)
        init_t=0 ! we can use the same interpolation weights
        call ctf (tau2(1,1,2), nx2, ny2, tx, y2, 
     &                  regy(1,1,n),nx, ny, 1, nx, 1, ny,
     &                  x, y, init_t, work_t, lenw_t,spval)
      enddo
      call ncclos (ncid, iret)
      print*,' done '

c   read NAO index, multiply with regression pattern and add mean
      iret=nf_open('data/NAO_reg/nao_monthly.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'nao',nid)
      t1 =  set_date(start_y, 1, 1, 0, 0, 0)
      toffset=t1%days
      do n=1,nt
        nn = mod(n-1,12)+1
        time(n)=mtime(nn)
        iret= nf_get_vara_real (ncid,nid ,n+(start_y-1865)*12,1,spv)
c        print*,' n=',n,nn,' nao(n)=',spv
        tau(:,:,n,1)=mtau(:,:,nn,1)+spv*regx(:,:,nn)
        tau(:,:,n,2)=mtau(:,:,nn,2)+spv*regy(:,:,nn)
        where (mask==0.) tau(:,:,n,1) = spval
        where (mask==0.) tau(:,:,n,2) = spval
      enddo
      call ncclos (ncid, iret)
      deallocate(x2,y2,tx,tau2,regx,regy, work_t)
      end subroutine read_tau
c
c
#elif defined read_tau_nao_ideal
c
c--------------------------------------------------------
c    use the 3 year monthly mean ECMWF climatology plus
c    NAO related wind stress anomalies (NAO index of +3)
c    (which is given by 
c    the monthly regression patterns of taux/tauy with
c    the NAO-index). 
c    Same forcing was used in Eden+Willebrand 01, J.Clim.
c    See also prep_template_sflx.F 
c--------------------------------------------------------
c
      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt,io
      character*32 stamp
      real (kind=4) :: dpm
      integer (kind=4) nx_,ny_

      print*,' reading monthly wind stress data from ECMWF'
      print*,' plus contant NAO related wind stress anomalies '
      open(10,file='data/ecmwf/ecmwf_BB.tau',form='unformatted')
      read (10); read (10) stamp, dpm, nx_, ny_
      nx=nx_;ny=ny_; nt=12
      close(10)
      print*,' nt=',nt
      end subroutine read_dims_tau

      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      use time_type_module
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt),mtime(12)
      integer io,n,k,kk,i,j
      real cleanmsk(nx,ny)
      character*32 stamp,s
      real :: mtau(nx,ny,12,2) 
      real (kind=4) dpm(nt), x4(nx),y4(ny),u(nx,ny),v(nx,ny),
     &               mask4(nx,ny)
      integer (kind=4) k4
#include "netcdf.inc"
      integer :: ncid,txid,tyid,dims(4),lonid,latid,iret
      integer :: nid
      character*80 name
      real (kind=4) ::  spv,add_offset,scale_factor
      real (kind=4), allocatable :: x2(:),y2(:),tau2(:,:,:),tx(:)
      real (kind=4), allocatable :: regx(:,:,:),regy(:,:,:)
      real, allocatable   :: work_t(:)
      integer :: init_t=1, lenw_t,nx2,ny2,nn
      type(time_type) :: t1

      open(10,file='data/ecmwf/ecmwf_BB.tau',form='unformatted')
      do n=1,12
        read (10); read (10) s, dpm(n), k4, k4, k4, x4,y4,u,v
        mtime(n)=dpm(n)
        mtau(:,:,n,1)=u
        mtau(:,:,n,2)=v
        x=x4;y=y4;
      enddo
      close(10)
c   read land mask
      open(10,file='data/ecmwf/ecmwf_BB.mask',form='unformatted')
      read (10) ; read (10); read (10) mask4
      mask=mask4
      close(10)
      cleanmsk = mask
      do j=2, ny-1
        do i=2, nx-1
          if (cleanmsk(i,j)/=0. .and. 
     &        cleanmsk(i+1,j)==0. .and. cleanmsk(i-1,j)==0. .and. 
     &        cleanmsk(i,j+1)==0. .and. cleanmsk(i,j-1)==0.)
     &        mask(i,j) = 0.
        end do
      end do
c   convert N/m**2 to dyn/cm**2 and apply mask
      do n=1,12
        mtau(:,:,n,1)= 10.*mtau(:,:,n,1)
        mtau(:,:,n,2)= 10.*mtau(:,:,n,2)
        where (mask==0.) mtau(:,:,n,1) = spval
        where (mask==0.) mtau(:,:,n,2) = spval
      enddo
c
c   read NAO monthly regression patterns
c
      iret=nf_open('data/NAO_reg/reg_tau.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'taux_reg',txid)
      iret=nf_inq_varid(ncid,'tauy_reg',tyid)
      iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
      nx2=nx2+2 ! append some rows
      ny2=ny2+4
      print*,' nx2 = ',nx2, 'ny2=',ny2

      allocate(x2(nx2),y2(ny2), tau2(nx2,ny2,2), tx(nx2),
     &         regx(nx,ny,12), regy(nx,ny,12) )
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=NF_INQ_VARID (NCID, name, lonid)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=NF_INQ_VARID (NCID, name, latid)

      iret= nf_get_vara_real (ncid,lonid ,1,nx2-2,x2(2:nx2-1))
      x2(nx2)=2*x2(nx2-1)-x2(nx2-2)
      x2(1)=x2(2)-(x2(3)-x2(2))
      iret= nf_get_vara_real (ncid,latid ,1,ny2-4,y2(3:ny2-2)) 
      y2(ny2-1)=2*y2(ny2-2)-y2(ny2-3)
      y2(2)=y2(3)-(y2(4)-y2(3))
      y2(ny2)=2*y2(ny2-1)-y2(ny2-2)
      y2(1)=y2(2)-(y2(3)-y2(2))
      y2=y2(ny2:1:-1)
      iret = nf_get_att_real(ncid, txid, 'missing_value', spv)
      add_offset=0.0
      iret= nf_get_att_real (ncid,txid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,txid ,'scale_factor',scale_factor)

c   read each month and interpolate on ECMWF grid
      print*,' interpolating data '
      lenw_t = 10*max(nx,ny)
      allocate( work_t(lenw_t) )
      do n=1,12
        tau2=spv
        iret= nf_get_vara_real (ncid,txid ,
     &         (/1,1,n/),(/nx2-2,ny2-4,1/),tau2(2:nx2-1,3:ny2-2,1))
        iret= nf_get_vara_real (ncid,tyid ,
     &         (/1,1,n/),(/nx2-2,ny2-4,1/),tau2(2:nx2-1,3:ny2-2,2))
        tau2(nx2,:,:)=tau2(2,:,:)
        tau2(1,:,:)  =tau2(nx2-1,:,:)
        tau2(:,:,:) = tau2(:,ny2:1:-1,:)
        where( tau2 == spv) tau2=spval
!      convert N/m**2 to dyn/cm**2  and change sign
        where( tau2 /= spval) tau2=(tau2*scale_factor+add_offset)*(-10.)
        call tranlon (tau2(1,1,1), nx2, nx2-2, ny2, x2, x,nx, tx)
        call tranlon (tau2(1,1,2), nx2, nx2-2, ny2, x2, x,nx, tx)
        call ctf (tau2(1,1,1), nx2, ny2, tx, y2, 
     &                  regx(1,1,n),nx, ny, 1, nx, 1, ny,
     &                  x, y, init_t, work_t, lenw_t,spval)
        init_t=0 ! we can use the same interpolation weights
        call ctf (tau2(1,1,2), nx2, ny2, tx, y2, 
     &                  regy(1,1,n),nx, ny, 1, nx, 1, ny,
     &                  x, y, init_t, work_t, lenw_t,spval)
      enddo
      call ncclos (ncid, iret)
      print*,' done '

c   multiply 3 with regression pattern and add mean
      t1 =  set_date(1999, 1, 1, 0, 0, 0)
      toffset=t1%days
      do n=1,nt
        nn = mod(n-1,12)+1
        print*,' n=',n,nn
        time(n)=mtime(nn)
        tau(:,:,n,1)=mtau(:,:,nn,1)+3.0*regx(:,:,nn)
        tau(:,:,n,2)=mtau(:,:,nn,2)+3.0*regy(:,:,nn)
        where (mask==0.) tau(:,:,n,1) = spval
        where (mask==0.) tau(:,:,n,2) = spval
      enddo
      deallocate(x2,y2,tx,tau2,regx,regy, work_t)
      end subroutine read_tau
c
c
#elif defined read_tau_ncep_daily
c
c--------------------------------------------------------
c     use daily wind stress data from the
c     NCEP/NCAR reanalysis project
c     (two parameter have to be set: start_y and end_y
c      denoting the start and end year taken from the
c      reanalysis data, e.g. start_y=1990, end_y=1998)
c--------------------------------------------------------

      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4),nn,k
      character (len=80) :: file
      integer :: start_y,end_y        
      common / tau_ncep/ start_y,end_y
      start_y = 1998
      end_y   = 1999
      print*,' reading daily wind stress data from NCEP '
      print*,' for years ',start_y,' to ',end_y
      nt=0
      do k=start_y,end_y
       write(file,'("data/ncep_daily/uflx.sfc.gauss.",i4,".nc")') k
       iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=nf_inq_varid(ncid,'uflx',varid)
       iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
       iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
       iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
       iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
       nt=nt+nn
       call ncclos (ncid, iret)
      enddo
      end subroutine read_dims_tau


      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      use time_type_module
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt)
#include "netcdf.inc"
      integer :: iret,ncid,varid,corner(4),edges(4),k,dims(4),nn
      integer :: n1,i,j,n,xid,yid
      character (len=80) :: file
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:,:)
      real (kind=4) :: add_offset,scale_factor
#else
      real , allocatable :: v4(:,:,:)
      real  :: add_offset,scale_factor
#endif
      type(time_type) :: t1,t2,t3
      integer :: start_y,end_y
      common / tau_ncep/ start_y,end_y
c   read land mask
      iret=nf_open('data/ncep_daily/lsmask.19294.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'lsmask',varid)
      corner=(/1,1,1,1/); edges = (/nx,ny,1,1/)
      allocate( v4(nx,ny,1) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      do j=1,ny; do i=1,nx
         mask(i,j)=v4(i,ny-j+1,1)
      enddo; enddo
      deallocate(v4)
      ! read grid info
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),file) 
      iret=nf_inq_varid(ncid,file,xid)
      allocate(v4(nx,1,1) )
      iret= nf_get_vara_real (ncid,xid ,1,nx,v4); x=v4(1:nx,1,1)
      deallocate(v4)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),file) 
      iret=nf_inq_varid(ncid,file,yid)
      allocate(v4(ny,1,1) )
      iret= nf_get_vara_real (ncid,yid ,1,ny,v4); 
      do j=1,ny
         y(j)=v4(ny-j+1,1,1)
      enddo
      deallocate(v4)
      call ncclos (ncid, iret)
      ! time vector
      t1 =  set_date(start_y, 1, 1, 0, 0, 0)
      toffset=t1%days
      n1=1
      do k=start_y,end_y
       write(file,'("data/ncep_daily/uflx.sfc.gauss.",i4,".nc")') k
       iret=nf_open(file,NF_nowrite,ncid)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=nf_inq_varid(ncid,'uflx',varid)
       iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
       iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
       call ncclos (ncid, iret)
       do n=n1,n1+nn-1
         time(n) =  365.0/(nn*1.0)
       enddo
       n1=n1+nn
      enddo
      n1=1
      do k=start_y,end_y
       print*,' reading year ',k
       call sub_flush(6)
       write(file,'("data/ncep_daily/uflx.sfc.gauss.",i4,".nc")') k
       iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=nf_inq_varid(ncid,'uflx',varid)
       iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
       iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
       corner=(/1,1,1,1/); edges = (/nx,ny,nn,1/)
       allocate( v4(nx,ny,nn) )
       iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
       add_offset=0.0
       iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
       scale_factor=1.0
       iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
c    convert N/m**2 to dyn/cm**2 and change sign
       do n=n1,n1+nn-1; do j=1,ny; do i=1,nx
          if (mask(i,ny-j+1) == 0.0 ) then
           tau(i,ny-j+1,n,1) = 
     &       (v4(i,j,n-n1+1)*scale_factor+add_offset)*(-10.0)
          else
           tau(i,ny-j+1,n,1) = spval
          endif
       enddo; enddo; enddo
       call ncclos (ncid, iret)
       write(file,'("data/ncep_daily/vflx.sfc.gauss.",i4,".nc")') k
       iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=nf_inq_varid(ncid,'vflx',varid)
       iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
       add_offset=0.0
       iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
       scale_factor=1.0
       iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
c    convert N/m**2 to dyn/cm**2 and change sign
       do n=n1,n1+nn-1; do j=1,ny; do i=1,nx
          if (mask(i,ny-j+1) == 0.0 ) then
           tau(i,ny-j+1,n,2) = 
     &        (v4(i,j,n-n1+1)*scale_factor+add_offset)*(-10.0)
          else
           tau(i,ny-j+1,n,2) = spval
          endif
       enddo; enddo; enddo
       call ncclos (ncid, iret)
       deallocate(v4)
       n1=n1+nn
      enddo
      end subroutine read_tau


#elif defined read_tau_ncep_daily_large_file
c
c--------------------------------------------------------
c     use daily wind stress data from the
c     NCEP/NCAR reanalysis project
c     start_y : year of forcing
c     fraction_y : year is divided into n fractions
c     nfraction_y : actual fraction within year
c--------------------------------------------------------

      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4),nn,k
      character (len=80) :: file
      integer :: start_y, fraction_y, nfraction_y,full_y
      common / tau_ncep/ start_y,fraction_y,nfraction_y,full_y
      namelist /ncep_time/ start_y,fraction_y,nfraction_y

      call getunit(ncid,'namelist.ncep_time','fsr')
      read(ncid, nml = ncep_time) 
      close(ncid)

      print*,' reading daily wind stress data from NCEP '
      print*,' year ',start_y,' in ',fraction_y,' fractions'
      print*,' current fraction ',nfraction_y
      write(file,'("data/ncep_daily/uflx.sfc.gauss.",i4,".nc")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'uflx',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
      full_y = nn
      print*,' days in year:',full_y
      if (mod(full_y,fraction_y)/=0) then
        print*,'fraction must be integer divider of 365'
        print*,'but ', mod(full_y,fraction_y)
        stop
      endif
      nt=full_y/fraction_y ! must be an integer
      call ncclos (ncid, iret)
      end subroutine read_dims_tau


      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      use time_type_module
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt)
#include "netcdf.inc"
      integer :: iret,ncid,varid,corner(4),edges(4),k,dims(4),nn
      integer :: n1,i,j,n,xid,yid
      character (len=80) :: file
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:,:)
      real (kind=4) :: add_offset,scale_factor
#else
      real , allocatable :: v4(:,:,:)
      real  :: add_offset,scale_factor
#endif
      type(time_type) :: t1,t2,t3
      integer :: start_y, fraction_y, nfraction_y,full_y
      common / tau_ncep/ start_y,fraction_y,nfraction_y,full_y
c   read land mask
      iret=nf_open('data/ncep_daily/lsmask.19294.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'lsmask',varid)
      corner=(/1,1,1,1/); edges = (/nx,ny,1,1/)
      allocate( v4(nx,ny,1) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      do j=1,ny; do i=1,nx
         mask(i,j)=v4(i,ny-j+1,1)
      enddo; enddo
      deallocate(v4)
      ! read grid info
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),file) 
      iret=nf_inq_varid(ncid,file,xid)
      allocate(v4(nx,1,1) )
      iret= nf_get_vara_real (ncid,xid ,1,nx,v4); x=v4(1:nx,1,1)
      deallocate(v4)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),file) 
      iret=nf_inq_varid(ncid,file,yid)
      allocate(v4(ny,1,1) )
      iret= nf_get_vara_real (ncid,yid ,1,ny,v4); 
      do j=1,ny
         y(j)=v4(ny-j+1,1,1)
      enddo
      deallocate(v4)
      call ncclos (ncid, iret)
      ! time vector
      t1 =  set_date(start_y, 1, 1, 0, 0, 0)
      toffset=t1%days + (nfraction_y-1)*(full_y/fraction_y)
      write(file,'("data/ncep_daily/uflx.sfc.gauss.",i4,".nc")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'uflx',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      call ncclos (ncid, iret)
      do n=1,nt
       time(n) =  365.0/(full_y*1.0)
      enddo


      print*,' reading year ',start_y
      call sub_flush(6)
      write(file,'("data/ncep_daily/uflx.sfc.gauss.",i4,".nc")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'uflx',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
      n1=1+(nfraction_y-1)*(full_y/fraction_y)
      nn=nfraction_y*(full_y/fraction_y)
     
      corner=(/1,1,n1,1/); edges = (/nx,ny,nt,1/)
      allocate( v4(nx,ny,nt) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      add_offset=0.0
      iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
c    convert N/m**2 to dyn/cm**2 and change sign
      do n=1,nt; do j=1,ny; do i=1,nx
          if (mask(i,ny-j+1) == 0.0 ) then
           tau(i,ny-j+1,n,1) = 
     &       (v4(i,j,n)*scale_factor+add_offset)*(-10.0)
          else
           tau(i,ny-j+1,n,1) = spval
          endif
      enddo; enddo; enddo
      call ncclos (ncid, iret)

      write(file,'("data/ncep_daily/vflx.sfc.gauss.",i4,".nc")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'vflx',varid)
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      add_offset=0.0
      iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
c    convert N/m**2 to dyn/cm**2 and change sign
      do n=1,nt; do j=1,ny; do i=1,nx
          if (mask(i,ny-j+1) == 0.0 ) then
           tau(i,ny-j+1,n,2) = 
     &        (v4(i,j,n)*scale_factor+add_offset)*(-10.0)
          else
           tau(i,ny-j+1,n,2) = spval
          endif
      enddo; enddo; enddo
      call ncclos (ncid, iret)
      deallocate(v4)

      end subroutine read_tau

#elif defined read_tau_T511_daily_large_file
c
c--------------------------------------------------------
c     use daily wind stress data from the
c     ECMWF model with T511 resolution
c     three parameter have to be set: start_y, fraction_y and nfraction_y
c     start_y : year of forcing
c     fraction_y : year is divided into n fractions
c     nfraction_y : actual fraction within year
c--------------------------------------------------------

      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4),nn,k
      character (len=80) :: file
      integer :: start_y, fraction_y, nfraction_y,full_y
      common / tau_ncep/ start_y,fraction_y,nfraction_y,full_y
      namelist /T511_time/ start_y,fraction_y,nfraction_y

      call getunit(ncid,'namelist.T511_time','fsr')
      read(ncid, nml = T511_time) 
      close(ncid)
      print*,' reading daily wind stress data from ECMWF/T511'
      print*,' year ',start_y,' in ',fraction_y,' fractions'
      print*,' current fraction ',nfraction_y
      write(file,'("data/ecmwf_T511/EWSS_",i4,".cdf")') start_y
      print*,'reading from file ',file
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'EWSS',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
      full_y = nn
      print*,' days in year:',full_y
      if (mod(full_y,fraction_y)/=0) then
        print*,'fraction must be integer divider of 365'
        print*,'but ', mod(full_y,fraction_y)
        stop
      endif
      nt=full_y/fraction_y ! must be an integer
      call ncclos (ncid, iret)
      end subroutine read_dims_tau


      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      use time_type_module
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt)
#include "netcdf.inc"
      integer :: iret,ncid,varid,corner(4),edges(4),k,dims(4),nn
      integer :: n1,i,j,n,xid,yid
      character (len=80) :: file
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:,:)
      real (kind=4) :: add_offset,scale_factor
#else
      real , allocatable :: v4(:,:,:)
      real  :: add_offset,scale_factor
#endif
      real :: mask2(nx,ny),fxa
      type(time_type) :: t1,t2,t3
      integer :: start_y, fraction_y, nfraction_y,full_y
      common / tau_ncep/ start_y,fraction_y,nfraction_y,full_y
c   read land mask
      iret=nf_open('data/ecmwf_T511/land-sea-mask.nc.new',
     &              NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'tcw',varid)
      corner=(/1,1,1,1/); edges = (/nx,ny,1,1/)
      allocate( v4(nx,ny,1) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      add_offset=0.0
      iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
      do j=1,ny; do i=1,nx
        mask(i,j)=0.0
        fxa = v4(i,ny-j+1,1)*scale_factor + add_offset
        if (fxa.gt. 0.1)  mask(i,j)=1.
        mask2(i,j)=0.0
        if (fxa.gt. 0.5)  mask2(i,j)=1.
      enddo; enddo
      deallocate(v4)
      call ncclos (ncid, iret)

c     we have to manipulate the land mask a bit
      mask(705:712,288:300)=mask2(705:712,288:300) ! this is Scotland
      mask(635:645,306:312)=mask2(635:645,306:312) ! East greenland
      mask(585:600,310:318)=mask2(585:600,310:318)

      ! read grid info from other file (because of corrupt netcdf-lib in Kiel)
      ! this lib cannot read double variables into floats
      iret=nf_open('data/ecmwf_T511/land-sea-mask.nc',NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'lsm',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),file) 
      iret=nf_inq_varid(ncid,file,xid)
      allocate(v4(nx,1,1) )
      print*,' reading axis ',file
      iret= nf_get_vara_real(ncid,xid,1,nx,v4); 
      x=v4(1:nx,1,1)
      deallocate(v4)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),file) 
      iret=nf_inq_varid(ncid,file,yid)
      allocate(v4(ny,1,1) )
      print*,' reading axis ',file
      iret= nf_get_vara_real (ncid,yid ,1,ny,v4); 
      do j=1,ny
         y(j)=v4(ny-j+1,1,1)
      enddo
      deallocate(v4)
      call ncclos (ncid, iret)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      ! time vector
      t1 =  set_date(start_y, 1, 1, 0, 0, 0)
      toffset=t1%days + (nfraction_y-1)*(full_y/fraction_y)
      write(file,'("data/ecmwf_T511/EWSS_",i4,".cdf")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'EWSS',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      call ncclos (ncid, iret)
      do n=1,nt
       time(n) =  365.0/(full_y*1.0)
      enddo

      print*,' reading year ',start_y
      call sub_flush(6)
      write(file,'("data/ecmwf_T511/EWSS_",i4,".cdf")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'EWSS',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
      n1=1+(nfraction_y-1)*(full_y/fraction_y)
      nn=nfraction_y*(full_y/fraction_y)
     
      corner=(/1,1,n1,1/); edges = (/nx,ny,nt,1/)
      allocate( v4(nx,ny,nt) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
c    convert N/m**2 to dyn/cm**2 
      do n=1,nt; do j=1,ny; do i=1,nx
          if (mask(i,j) /= 1.0 ) then
           tau(i,j,n,1) =v4(i,j,n)*10.0
          else
           tau(i,j,n,1) = spval
          endif
      enddo; enddo; enddo
      call ncclos (ncid, iret)

      write(file,'("data/ecmwf_T511/NSSS_",i4,".cdf")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'NSSS',varid)
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
c    convert N/m**2 to dyn/cm**2 
      do n=1,nt; do j=1,ny; do i=1,nx
          if (mask(i,j) /= 1.0 ) then
           tau(i,j,n,2) =v4(i,j,n)*10.0
          else
           tau(i,j,n,2) = spval
          endif
      enddo; enddo; enddo
      call ncclos (ncid, iret)
      deallocate(v4)

      end subroutine read_tau

#elif defined read_tau_T511_daily_large_file_smooth
c
c--------------------------------------------------------
c     use smoothed daily wind stress data from the
c     ECMWF model with T511 resolution
c     three parameter have to be set: start_y, fraction_y and nfraction_y
c     start_y : year of forcing
c     fraction_y : year is divided into n fractions
c     nfraction_y : actual fraction within year
c--------------------------------------------------------

      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4),nn,k
      character (len=80) :: file
      integer :: start_y, fraction_y, nfraction_y,full_y
      common / tau_ncep/ start_y,fraction_y,nfraction_y,full_y
      namelist /T511_time/ start_y,fraction_y,nfraction_y

      call getunit(ncid,'namelist.T511_time','fsr')
      read(ncid, nml = T511_time) 
      close(ncid)
      print*,' reading daily wind stress data from ECMWF/T511'
      print*,' year ',start_y,' in ',fraction_y,' fractions'
      print*,' current fraction ',nfraction_y
      write(file,'("data/ecmwf_T511/smooth/EWSS_",i4,".cdf")') start_y
      print*,'reading from file ',file
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'EWSS',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
      full_y = nn
      print*,' days in year:',full_y
      if (mod(full_y,fraction_y)/=0) then
        print*,'fraction must be integer divider of 365'
        print*,'but ', mod(full_y,fraction_y)
        stop
      endif
      nt=full_y/fraction_y ! must be an integer
      call ncclos (ncid, iret)
      end subroutine read_dims_tau


      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      use time_type_module
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt)
#include "netcdf.inc"
      integer :: iret,ncid,varid,corner(4),edges(4),k,dims(4),nn
      integer :: n1,i,j,n,xid,yid
      character (len=80) :: file
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:,:)
      real (kind=4) :: add_offset,scale_factor,sp
#else
      real , allocatable :: v4(:,:,:)
      real  :: add_offset,scale_factor,sp
#endif
      integer :: indp
      real :: mask2(nx,ny),fxa
      type(time_type) :: t1,t2,t3
      integer :: start_y, fraction_y, nfraction_y,full_y
      common / tau_ncep/ start_y,fraction_y,nfraction_y,full_y
c   read land mask
      iret=nf_open('data/ecmwf_T511/land-sea-mask.nc.new',
     &              NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'tcw',varid)
      corner=(/1,1,1,1/); edges = (/nx,ny,1,1/)
      allocate( v4(nx,ny,1) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      add_offset=0.0
      iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
      do j=1,ny; do i=1,nx
        mask(i,j)=0.0
        fxa = v4(i,ny-j+1,1)*scale_factor + add_offset
        if (fxa.gt. 0.1)  mask(i,j)=1.
        mask2(i,j)=0.0
        if (fxa.gt. 0.5)  mask2(i,j)=1.
      enddo; enddo
      deallocate(v4)
      call ncclos (ncid, iret)

c     we have to manipulate the land mask a bit
      mask(705:712,288:300)=mask2(705:712,288:300) ! this is Scotland
      mask(635:645,306:312)=mask2(635:645,306:312) ! East greenland
      mask(585:600,310:318)=mask2(585:600,310:318)

      ! read grid info from other file (because of corrupt netcdf-lib in Kiel)
      ! this lib cannot read double variables into floats
      iret=nf_open('data/ecmwf_T511/land-sea-mask.nc',NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'lsm',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),file) 
      iret=nf_inq_varid(ncid,file,xid)
      allocate(v4(nx,1,1) )
      print*,' reading axis ',file
      iret= nf_get_vara_real(ncid,xid,1,nx,v4); 
      x=v4(1:nx,1,1)
      deallocate(v4)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),file) 
      iret=nf_inq_varid(ncid,file,yid)
      allocate(v4(ny,1,1) )
      print*,' reading axis ',file
      iret= nf_get_vara_real (ncid,yid ,1,ny,v4); 
      do j=1,ny
         y(j)=v4(ny-j+1,1,1)
      enddo
      deallocate(v4)
      call ncclos (ncid, iret)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      ! time vector
      t1 =  set_date(start_y, 1, 1, 0, 0, 0)
      toffset=t1%days + (nfraction_y-1)*(full_y/fraction_y)
      write(file,'("data/ecmwf_T511/smooth/EWSS_",i4,".cdf")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'EWSS',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      call ncclos (ncid, iret)
      do n=1,nt
       time(n) =  365.0/(full_y*1.0)
      enddo

      print*,' reading year ',start_y
      call sub_flush(6)
      write(file,'("data/ecmwf_T511/smooth/EWSS_",i4,".cdf")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'EWSS',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
      n1=1+(nfraction_y-1)*(full_y/fraction_y)
      nn=nfraction_y*(full_y/fraction_y)
     
      corner=(/1,1,n1,1/); edges = (/nx,ny,nt,1/)
      allocate( v4(nx,ny,nt) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      iret= nf_get_att_real  (ncid,varid ,'missing_value',sp)
c    convert N/m**2 to dyn/cm**2 
      do n=1,nt; do j=1,ny; do i=1,nx
          if (v4(i,j,n) /= sp ) then
           tau(i,j,n,1) =v4(i,j,n)*10.0
           mask(i,j)=0.
          else
           tau(i,j,n,1) = spval
           mask(i,j)=1.
          endif
      enddo; enddo; enddo
      call ncclos (ncid, iret)

      write(file,'("data/ecmwf_T511/smooth/NSSS_",i4,".cdf")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'NSSS',varid)
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      iret= nf_get_att_real  (ncid,varid ,'missing_value',sp)
c    convert N/m**2 to dyn/cm**2 
      do n=1,nt; do j=1,ny; do i=1,nx
          if (v4(i,j,n) /= sp ) then
           tau(i,j,n,2) =v4(i,j,n)*10.0
          else
           tau(i,j,n,2) = spval
          endif
      enddo; enddo; enddo
      call ncclos (ncid, iret)
      deallocate(v4)

      i=indp(290.2,x,nx); j=indp(11.51,y,ny)
      tau(i,j,:,:) = 0.; mask(i,j)=0.
      i=indp(276.5,x,nx); j=indp(12.73,y,ny)
      tau(i,j,:,:) = 0.; mask(i,j)=0.
      i=indp(354.3,x,nx); j=indp(56.38,y,ny)
      tau(i,j,:,:) = 0.; mask(i,j)=0.
      i=indp(354.1,x,nx); j=indp(57.43,y,ny)
      tau(i,j,:,:) = 0.; mask(i,j)=0.
      i=indp(319.1,x,nx); j=indp(64.83,y,ny)
      tau(i,j,:,:) = 0.; mask(i,j)=0.
      i=indp(296.6,x,nx); j=indp(65.39,y,ny)
      tau(i,j,:,:) = 0.; mask(i,j)=0.

      end subroutine read_tau


#elif defined read_tau_ncep_clim
c
c--------------------------------------------------------
c     use climatological monthly mean wind stress data from the
c     NCEP/NCAR reanalysis project
c--------------------------------------------------------

      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4)
      character (len=80) :: file
      print*,' reading clim. monthly wind stress data from NCEP '
      file='data/ncep_for_pml/uflx.mon.ltm.nc'
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'uflx',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
      call ncclos (ncid, iret)
      end subroutine read_dims_tau


      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      use time_type_module
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt)
#include "netcdf.inc"
      integer :: iret,ncid,varid,corner(4),edges(4),k,dims(4),nn
      integer :: n1,i,j,n,xid,yid
      character (len=80) :: file
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:,:)
      real (kind=4) :: add_offset,scale_factor
#else
      real , allocatable :: v4(:,:,:)
      real  :: add_offset,scale_factor
#endif

c   read land mask
      iret=nf_open('data/ncep_daily/lsmask.19294.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'lsmask',varid)
      corner=(/1,1,1,1/); edges = (/nx,ny,1,1/)
      allocate( v4(nx,ny,1) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      do j=1,ny; do i=1,nx
         mask(i,j)=v4(i,ny-j+1,1)
      enddo; enddo
      deallocate(v4)
      ! read grid info
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),file) 
      iret=nf_inq_varid(ncid,file,xid)
      allocate(v4(nx,1,1) )
      iret= nf_get_vara_real (ncid,xid ,1,nx,v4); x=v4(1:nx,1,1)
      deallocate(v4)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),file) 
      iret=nf_inq_varid(ncid,file,yid)
      allocate(v4(ny,1,1) )
      iret= nf_get_vara_real (ncid,yid ,1,ny,v4); 
      do j=1,ny
         y(j)=v4(ny-j+1,1,1)
      enddo
      deallocate(v4)
      call ncclos (ncid, iret)

      file='data/ncep_for_pml/uflx.mon.ltm.nc'
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'uflx',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      corner=(/1,1,1,1/); edges = (/nx,ny,nt,1/)
      allocate( v4(nx,ny,nt) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      add_offset=0.0
      iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
c    convert N/m**2 to dyn/cm**2 and change sign
      do j=1,ny
       do i=1,nx
          if (mask(i,ny-j+1) == 0.0 ) then
           tau(i,ny-j+1,:,1) = 
     &       (v4(i,j,:)*scale_factor+add_offset)*(-10.0)
          else
           tau(i,ny-j+1,:,1) = spval
          endif
       enddo
      enddo
      call ncclos (ncid, iret)
      deallocate(v4)


      file='data/ncep_for_pml/vflx.mon.ltm.nc'
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'vflx',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      corner=(/1,1,1,1/); edges = (/nx,ny,nt,1/)
      allocate( v4(nx,ny,nt) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      add_offset=0.0
      iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
c    convert N/m**2 to dyn/cm**2 and change sign
      do j=1,ny
       do i=1,nx
          if (mask(i,ny-j+1) == 0.0 ) then
           tau(i,ny-j+1,:,2) = 
     &       (v4(i,j,:)*scale_factor+add_offset)*(-10.0)
          else
           tau(i,ny-j+1,:,2) = spval
          endif
       enddo
      enddo
      call ncclos (ncid, iret)
      deallocate(v4)
c   time
      toffset=0.0
      time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
      end subroutine read_tau

#elif defined read_tau_ncep
c
c--------------------------------------------------------
c     use monthly mean wind stress data from the
c     NCEP/NCAR reanalysis project
c--------------------------------------------------------

      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4)
      character (len=80) :: file
      integer :: start_y, nyear, year0
      common / flx_ncep/ start_y,nyear, year0

      start_y=1999
      nyear = 5
      year0=1948

      print*,' reading clim. monthly wind stress data from NCEP '
      print*,' start year = ',start_y
      print*,' number of years = ',nyear

      file='data/ncep/uflx.mon.mean.nc'
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'uflx',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
      nt=12*nyear
      call ncclos (ncid, iret)
      end subroutine read_dims_tau


      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      use time_type_module
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt)
#include "netcdf.inc"
      integer :: iret,ncid,varid,corner(4),edges(4),k,dims(4),nn
      integer :: n1,i,j,n,xid,yid
      character (len=80) :: file
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:,:)
      real (kind=4) :: add_offset,scale_factor
#else
      real , allocatable :: v4(:,:,:)
      real  :: add_offset,scale_factor
#endif
      integer :: start_y, nyear, year0
      common / flx_ncep/ start_y,nyear, year0
      type(time_type) :: t1,t2,t3
      real :: dpm(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)

c   read land mask
      iret=nf_open('data/ncep/lsmask.19294.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'lsmask',varid)
      corner=(/1,1,1,1/); edges = (/nx,ny,1,1/)
      allocate( v4(nx,ny,1) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      do j=1,ny; do i=1,nx
         mask(i,j)=v4(i,ny-j+1,1)
      enddo; enddo
      deallocate(v4)
      ! read grid info
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),file) 
      iret=nf_inq_varid(ncid,file,xid)
      allocate(v4(nx,1,1) )
      iret= nf_get_vara_real (ncid,xid ,1,nx,v4); x=v4(1:nx,1,1)
      deallocate(v4)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),file) 
      iret=nf_inq_varid(ncid,file,yid)
      allocate(v4(ny,1,1) )
      iret= nf_get_vara_real (ncid,yid ,1,ny,v4); 
      do j=1,ny
         y(j)=v4(ny-j+1,1,1)
      enddo
      deallocate(v4)
      call ncclos (ncid, iret)

      file='data/ncep/uflx.mon.mean.nc'
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'uflx',varid)
      n=(start_y-year0)*12
      corner=(/1,1,n+1,1/); edges = (/nx,ny,nt,1/)
      allocate( v4(nx,ny,nt) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      add_offset=0.0
      iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
c    convert N/m**2 to dyn/cm**2 and change sign
      do j=1,ny
       do i=1,nx
          if (mask(i,ny-j+1) == 0.0 ) then
           tau(i,ny-j+1,:,1) = 
     &       (v4(i,j,:)*scale_factor+add_offset)*(-10.0)
          else
           tau(i,ny-j+1,:,1) = spval
          endif
       enddo
      enddo
      call ncclos (ncid, iret)
      deallocate(v4)


      file='data/ncep/vflx.mon.mean.nc'
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'vflx',varid)
      n=(start_y-year0)*12
      corner=(/1,1,n+1,1/); edges = (/nx,ny,nt,1/)
      allocate( v4(nx,ny,nt) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      add_offset=0.0
      iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
c    convert N/m**2 to dyn/cm**2 and change sign
      do j=1,ny
       do i=1,nx
          if (mask(i,ny-j+1) == 0.0 ) then
           tau(i,ny-j+1,:,2) = 
     &       (v4(i,j,:)*scale_factor+add_offset)*(-10.0)
          else
           tau(i,ny-j+1,:,2) = spval
          endif
       enddo
      enddo
      call ncclos (ncid, iret)
      deallocate(v4)
c   time
      t1 =  set_date(start_y, 1, 1, 0, 0, 0)
      toffset=t1%days 
      do n=1,nyear
       do j=1,12
        time((n-1)*12+j )=dpm(j)
       enddo
      enddo
      end subroutine read_tau

#elif defined read_tau_omip
c
c--------------------------------------------------------
c    use a monthly mean climatology from the OMIP II
c    data (derived from ECMWF reanalysis data)
c--------------------------------------------------------
c
      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4)
      print*,' reading monthly wind stress data from OMIP'
      iret=nf_open('data/OMIP/mean_zonal_stress.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'stress_x',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt); nt=12
      call ncclos (ncid, iret)
      end subroutine read_dims_tau

      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt)
#include "netcdf.inc"
      integer :: iret,ncid,txid,tyid,dims(4),aid,n
      character (len=80) :: name
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:,:)
#else
      real, allocatable :: v4(:,:,:)
#endif
      allocate(v4(nx,ny,nt))
c   read taux
      iret=nf_open('data/OMIP/mean_zonal_stress.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'stress_x',txid)
      iret= nf_get_vara_real(ncid,txid,(/1,1,1/),(/nx,ny,nt/),v4)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      tau(:,:,:,1)=v4
      ! read grid info
      iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=nf_inq_varid(ncid,name,aid)
      iret= nf_get_vara_real(ncid,aid ,1,nx,v4(:,1,1))
      x=v4(:,1,1)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=nf_inq_varid(ncid,name,aid)
      iret= nf_get_vara_real (ncid,aid ,1,ny,v4(1,:,1)) 
      y=v4(1,:,1)
      call ncclos (ncid, iret)
c   read tauy
      iret=nf_open('data/OMIP/mean_merid_stress.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'stress_y',txid)
      iret= nf_get_vara_real(ncid,txid,(/1,1,1/),(/nx,ny,nt/),v4)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      tau(:,:,:,2)= v4
      call ncclos (ncid, iret)
c   read land mask
      iret=nf_open('data/OMIP/land_sea_mask.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'lsm',txid)
      iret= nf_get_vara_real(ncid,txid,(/1,1/),(/nx,ny/),v4(1,1,1))
      mask=v4(:,:,1)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      call ncclos (ncid, iret)
c   apply land mask
      do n=1,nt
        where ( mask == 0.0 ) tau(:,:,n,1)=spval
        where ( mask == 0.0 ) tau(:,:,n,2)=spval
      enddo
      deallocate(v4)
c   flip second dimension up/down
      y=y(ny:1:-1)
      tau=tau(:,ny:1:-1,:,:)
      mask=mask(:,ny:1:-1)
c   convert N/m^2 to dyn/cm^2
      do n=1,nt
        where ( mask /= 0.0 ) tau(:,:,n,1)=tau(:,:,n,1)*10.0
        where ( mask /= 0.0 ) tau(:,:,n,2)=tau(:,:,n,2)*10.0
      enddo
c   time
      toffset=0.0
      time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
      end subroutine read_tau
c
#elif defined read_tau_dasilva
c
c--------------------------------------------------------
c    use a monthly mean climatology from Da Silva 1994
c    (derived from COADS data)
c--------------------------------------------------------
c
      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4)
      print*,' reading monthly wind stress data from DaSilva94'
      iret=nf_open('data/DaSilva94/taux.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'taux3',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt); nt=12
      call ncclos (ncid, iret)
      end subroutine read_dims_tau

      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt)
#include "netcdf.inc"
      integer :: iret,ncid,txid,tyid,dims(4),aid,n
      character (len=80) :: name
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:,:)
      real (kind=4) :: sp,add_offset,scale_factor
#else
      real, allocatable :: v4(:,:,:)
      real  :: sp,add_offset,scale_factor
#endif
      allocate(v4(nx,ny,nt))
c   read taux
      iret=nf_open('data/DaSilva94/taux.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'taux3',txid)
      iret= nf_get_vara_real(ncid,txid,(/1,1,1/),(/nx,ny,nt/),v4)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      tau(:,:,:,1)=v4
      iret= nf_get_att_real (ncid,txid ,'missing_value',sp)
      where (tau(:,:,:,1) == sp ) tau(:,:,:,1)=spval
      add_offset=0.0
      iret= nf_get_att_real (ncid,txid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,txid ,'scale_factor',scale_factor)
      where (tau(:,:,:,1)/=spval) 
     &     tau(:,:,:,1)=tau(:,:,:,1)*scale_factor+add_offset
      ! read grid info
      iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=nf_inq_varid(ncid,name,aid)
      iret= nf_get_vara_real(ncid,aid ,1,nx,v4(:,1,1))
      x=v4(:,1,1)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=nf_inq_varid(ncid,name,aid)
      iret= nf_get_vara_real (ncid,aid ,1,ny,v4(1,:,1)) 
      y=v4(1,:,1)
      call ncclos (ncid, iret)
c   read tauy
      iret=nf_open('data/DaSilva94/tauy.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'tauy3',txid)
      iret= nf_get_vara_real(ncid,txid,(/1,1,1/),(/nx,ny,nt/),v4)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      tau(:,:,:,2)=v4
      iret= nf_get_att_real (ncid,txid ,'missing_value',sp)
      where (tau(:,:,:,2) == sp ) tau(:,:,:,2)=spval
      add_offset=0.0
      iret= nf_get_att_real (ncid,txid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,txid ,'scale_factor',scale_factor)
      where (tau(:,:,:,2)/=spval) 
     &     tau(:,:,:,2)=tau(:,:,:,2)*scale_factor+add_offset
      call ncclos (ncid, iret)
      deallocate(v4)
c   read land mask
      mask=1.0
      where ( tau(:,:,1,1)==spval)mask=0.0
c   convert N/m^2 to dyn/cm^2
      do n=1,nt
        where ( mask /= 0.0 ) tau(:,:,n,1)=tau(:,:,n,1)*10.0
        where ( mask /= 0.0 ) tau(:,:,n,2)=tau(:,:,n,2)*10.0
      enddo
c   time
      toffset=0.0
      time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
      end subroutine read_tau

#elif defined read_tau_ecco
c
c--------------------------------------------------------
c    use a monthly mean climatology from ECCO
c    (assimilated data into 2x2 deg ocean model. 
c     Control parameter are initial and surface boundary 
c     conditions. Assimilation period is 1992-1997.
c     Climatology is taken as average over this period.)
c--------------------------------------------------------
c
      subroutine read_dims_tau(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4)
      print*,' reading monthly wind stress data from ECCO'
      iret=nf_open('data/ECCO/tau_mean.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'taux',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), nx) ! axis are swaped 
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), ny) ! somehow
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)  ! ordering is T,Y,Z
      call ncclos (ncid, iret)
      end subroutine read_dims_tau

      subroutine read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
      implicit none
      integer :: nx,ny,nt
      real :: spval, tau(nx,ny,nt,2) ,x(nx), y(ny),mask(nx,ny)
      real :: toffset,time(nt)
#include "netcdf.inc"
      integer :: iret,ncid,txid,tyid,dims(4),aid,n,j
      character (len=80) :: name
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:,:)
      real (kind=4) :: sp,add_offset,scale_factor
#else
      real, allocatable :: v4(:,:,:)
      real  :: sp,add_offset,scale_factor
#endif
      allocate(v4(ny,nx,nt)) ! axes are somehow swaped in file
c   read taux
      iret=nf_open('data/ECCO/tau_mean.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'taux',txid)
      iret= nf_get_vara_real(ncid,txid,(/1,1,1/),(/ny,nx,nt/),v4)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      do n=1,nt
      do j=1,ny
        tau(:,j,n,1)=v4(j,:,n)
      enddo
      enddo
      iret= nf_get_att_real (ncid,txid ,'missing_value',sp)
      where (tau(:,:,:,1) == sp ) tau(:,:,:,1)=spval
      ! read grid info
      iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=nf_inq_varid(ncid,name,aid)
      iret= nf_get_vara_real(ncid,aid ,1,ny,v4(:,1,1))
      y=v4(:,1,1)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=nf_inq_varid(ncid,name,aid)
      iret= nf_get_vara_real (ncid,aid ,1,nx,v4(1,:,1)) 
      x=v4(1,:,1)
      call ncclos (ncid, iret)
c   read tauy
      iret=nf_open('data/ECCO/tau_mean.cdf',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'tauy',txid)
      iret= nf_get_vara_real(ncid,txid,(/1,1,1/),(/ny,nx,nt/),v4)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      do n=1,nt
      do j=1,ny
        tau(:,j,n,2)=v4(j,:,n)
      enddo
      enddo
      iret= nf_get_att_real (ncid,txid ,'missing_value',sp)
      where (tau(:,:,:,2) == sp ) tau(:,:,:,2)=spval
      call ncclos (ncid, iret)
      deallocate(v4)
c   read land mask
      mask=1.0
      where ( tau(:,:,1,1)==spval) mask=0.0
c   convert N/m^2 to dyn/cm^2
      do n=1,nt
        where ( mask /= 0.0 ) tau(:,:,n,1)=tau(:,:,n,1)*10.0
        where ( mask /= 0.0 ) tau(:,:,n,2)=tau(:,:,n,2)*10.0
      enddo
c   time
      toffset=0.0
      time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
      end subroutine read_tau

#endif





#ifdef read_ustar_ecmwf
c
c--------------------------------------------------------
c    use a monthly mean climatology from the ECMWF
c    DYNAMO data for friction velocity.
c--------------------------------------------------------
c
       subroutine read_dims_ustar(nx,ny,nt)
       implicit none
       integer nx,ny,nt,io
       character*32 stamp
       real (kind=4) :: dpm
       integer (kind=4) nx_,ny_
       print*,' reading frcition velocity data from ECMWF'
       open(10,file='data/ecmwf/ecmwf_BB.ustar',form='unformatted')
       read (10); read (10) stamp, dpm, nx_, ny_
       nx=nx_;ny=ny_; nt=12;
       close(10)
       end subroutine read_dims_ustar

       subroutine read_ustar(ustar,x,y,nx,ny,nt,spval,time,toffset)
       implicit none
       integer :: nx,ny,nt
       real :: spval, ustar(nx,ny,nt) ,x(nx), y(ny),time(nt),toffset
       character*32 s
       real (kind=4) u4(nx,ny) 
       real (kind=4) x4(nx), y4(ny)
       real (kind=4) dpm,   mask(nx,ny)
       integer (kind=4) k,n
       real :: factor,rho_air = 1.29, rho_wat = 1026.
       open(10,file='data/ecmwf/ecmwf_BB.ustar',form='unformatted')
       do n=1,nt
        read (10); read (10) s, dpm, k, k, k, x4,y4,u4(:,:)
        x=x4;y=y4; ustar(:,:,n)=u4
       enddo
       close(10)
c    convert ustar
c    the ustar**3 field is referenced to air-density (1.29 kg/m**3), 
c    therefore re-reference to density of water (1035 kg/m**3)
c    i.e. rho_wat*(vstar**2)=rho_air*(ustar**2), when vstar is the 
c    friction velocity in water and ustar the one in air.
!    reference to dens. in water and convert (m/s)**3 to (cm/s)**3
       factor = 1.e+06 * (rho_air/rho_wat)**1.5
       ustar = factor*ustar
!   apply land mask
       open(10,file='data/ecmwf/ecmwf_BB.mask',form='unformatted')
       read (10) ; read (10); read (10) mask; close(10)
       do n=1,nt
        where (mask==0.) ustar(:,:,n) = spval
       enddo
       toffset=0.0
       time = (/31,28,31,30,31,30,31,31,30,31,30,31/)
       end subroutine read_ustar

#elif defined read_ustar_ncep_monthly
c
c--------------------------------------------------------
c    use a monthly mean climatology from the ECMWF
c    DYNAMO data for friction velocity.
c--------------------------------------------------------
c
       subroutine read_dims_ustar(nx,ny,nt)
       implicit none
       integer nx,ny,nt,io
       character*32 stamp
       real (kind=4) :: dpm
       integer (kind=4) nx_,ny_
#include "netcdf.inc"
       integer :: iret, ncid,dims(4),vid

       print*,' reading frcition velocity data from ECMWF '
       print*,' plus anomalies from NCEP/NCAR'
       open(10,file='data/ecmwf/ecmwf_BB.ustar',form='unformatted')
       read (10); read (10) stamp, dpm, nx_, ny_
       nx=nx_;ny=ny_; 
       close(10)
       iret=nf_open('data/ncep/ustar_anom.cdf',NF_nowrite,ncid)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=nf_inq_varid(ncid,'ustar',vid)
       iret=NF_INQ_VARDIMID (NCID,vid,DIMS)
       iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)
       call ncclos (ncid, iret)
       end subroutine read_dims_ustar



       subroutine read_ustar(ustar,x,y,nx,ny,nt,spval,time,toffset)
       use time_type_module
       implicit none
       integer :: nx,ny,nt
       real :: spval, ustar(nx,ny,nt) ,x(nx), y(ny),time(nt),toffset
       character*32 s
       real (kind=4) u4(nx,ny) , mtime(12), mustar(nx,ny,12)
       real (kind=4) x4(nx), y4(ny)
       real (kind=4) dpm,   mask(nx,ny)
       integer (kind=4) k,n
       real :: factor,rho_air = 1.29, rho_wat = 1026.
#include "netcdf.inc"
       integer :: ncid,txid,dims(4),lonid,latid,iret
       character*80 name
       integer :: nx2,ny2
       real (kind=4) ::  spv
       real (kind=4), allocatable :: x2(:),y2(:),ustar2(:,:),tx(:)
       real (kind=4), allocatable :: ustar3(:,:),nmask(:,:)
       real, allocatable   :: work_t(:)
       integer :: init_t=1, lenw_t,nn
       type(time_type) :: t1

       open(10,file='data/ecmwf/ecmwf_BB.ustar',form='unformatted')
       do n=1,12
        read (10); read (10) s, dpm, k, k, k, x4,y4,u4(:,:)
        x=x4;y=y4; mustar(:,:,n)=u4
       enddo
       close(10)
c    convert ustar
       factor = 1.e+06 * (rho_air/rho_wat)**1.5
       mustar = factor*mustar
!    apply land mask
       open(10,file='data/ecmwf/ecmwf_BB.mask',form='unformatted')
       read (10) ; read (10); read (10) mask; close(10)
       do n=1,12
        where (mask==0.) mustar(:,:,n) = spval
       enddo
       mtime = (/31,28,31,30,31,30,31,31,30,31,30,31/)
c
c   read land/sea mask for NCEP data
c
       iret=nf_open('data/ncep/lsmask.19294.nc',NF_nowrite,ncid)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=nf_inq_varid(ncid,'lsmask',txid)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
       iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
       iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
       allocate( nmask(nx2,ny2) )
       iret= nf_get_vara_real (ncid,txid ,(/1,1,1/),(/nx2,ny2,1/),nmask)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       call ncclos (ncid, iret)
c
c    read NCEP anomalies
c
       iret=nf_open('data/ncep/ustar_anom.cdf',NF_nowrite,ncid)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=nf_inq_varid(ncid,'ustar',txid)
       iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
       iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx2)
       iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny2)
       nx2=nx2+2 ! append some rows
       ny2=ny2+4

       allocate(x2(nx2),y2(ny2), ustar2(nx2,ny2),tx(nx2),ustar3(nx,ny))
       name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
       iret=NF_INQ_VARID (NCID, name, lonid)
       name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
       iret=NF_INQ_VARID (NCID, name, latid)

       iret= nf_get_vara_real (ncid,lonid ,1,nx2-2,x2(2:nx2-1))
       x2(nx2)=2*x2(nx2-1)-x2(nx2-2)
       x2(1)=x2(2)-(x2(3)-x2(2))
       iret= nf_get_vara_real (ncid,latid ,1,ny2-4,y2(3:ny2-2)) 
       y2(ny2-1)=2*y2(ny2-2)-y2(ny2-3)
       y2(2)=y2(3)-(y2(4)-y2(3))
       y2(ny2)=2*y2(ny2-1)-y2(ny2-2)
       y2(1)=y2(2)-(y2(3)-y2(2))
       y2=y2(ny2:1:-1)
       iret = nf_get_att_real(ncid, txid, 'missing_value', spv)

c    read each month and interpolate on ECMWF grid
       print*,' interpolating data '
       lenw_t = 10*max(nx,ny)
       allocate( work_t(lenw_t) )
       t1 =  set_date(1948, 1, 1, 0, 0, 0)
       toffset=t1%days
       do n=1,nt
        ustar2=spv
        iret= nf_get_vara_real (ncid,txid ,
     &         (/1,1,n/),(/nx2-2,ny2-4,1/),ustar2(2:nx2-1,3:ny2-2))

        where( nmask == -1) ustar2(2:nx2-1,3:ny2-2) = spv
c     acount for appended rows and switch latitudinal ordering
        ustar2(nx2,:)=ustar2(2,:)
        ustar2(1,:)  =ustar2(nx2-1,:)
        ustar2(:,:) = ustar2(:,ny2:1:-1)
c    convert special values
        where( ustar2 == spv) ustar2=spval
c     interpolate
        call tranlon (ustar2(1,1), nx2, nx2-2, ny2, x2, x,nx, tx)
        call ctf (ustar2(1,1), nx2, ny2, tx, y2, 
     &                  ustar3(1,1),nx, ny, 1, nx, 1, ny,
     &                  x, y, init_t, work_t, lenw_t,spval)
        init_t=0 ! we can use the same interpolation weights
c     add mean
        nn = mod(n-1,12)+1
        where( ustar3 == spval) ustar3=0.
        ustar(:,:,n)=mustar(:,:,nn)+ustar3(:,:)
        where (mask==0.) ustar(:,:,n) = spval
        where (mask/=0. .and. ustar(:,:,n) < 0.0) ustar(:,:,n) = 0.0
        time(n)=mtime(nn)
       enddo
       call ncclos (ncid, iret)
       print*,' done '
       deallocate(x2,y2,tx,ustar2,ustar3,work_t,nmask)
       end subroutine read_ustar

#elif defined read_ustar_omip
c
c--------------------------------------------------------
c    use a daily climatology from the OMIP
c    wind stress data for friction velocity.
c--------------------------------------------------------
      subroutine read_dims_ustar(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4)
      print*,' reading daily friction velocity data from OMIP'
      iret=nf_open('data/OMIP365/north_south_stress.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'stress_y',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)  
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nt)  
      call ncclos (ncid, iret)
      end subroutine read_dims_ustar



      subroutine read_ustar(ustar,x,y,nx,ny,nt,spval,time,toffset)
      implicit none
      integer :: nx,ny,nt
      real :: spval, ustar(nx,ny,nt) ,x(nx), y(ny),time(nt),toffset
#include "netcdf.inc"
      integer :: iret,ncid,txid,tyid,dims(4),aid,n,i,j
      character (len=80) :: name
#ifdef netcdf_real4
      real (kind=4),allocatable :: taux(:,:,:),tauy(:,:,:),mask(:,:)
      real (kind=4) :: sp
#else
      real ,allocatable :: taux(:,:,:),tauy(:,:,:),mask(:,:)
      real  :: sp
#endif
      real :: rho_air = 1.29, rho_wat = 1026.
      allocate( taux(nx,ny,nt), tauy(nx,ny,nt), mask(nx,ny) )
c   read land mask
      mask=1.0
      iret=nf_open('data/OMIP/land_sea_mask.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'lsm',txid)
      iret= nf_get_vara_real(ncid,txid,(/1,1/),(/nx,ny/),mask)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      call ncclos (ncid, iret)
c   read taux
      iret=nf_open('data/OMIP365/east_west_stress.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'stress_x',txid)
      iret= nf_get_vara_real(ncid,txid,(/1,1,1/),(/nx,ny,nt/),taux)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret= nf_get_att_real (ncid,txid ,'missing_value',sp)
      do n=1,nt
        where ( taux(:,:,n) == sp ) taux(:,:,n)=spval
        where ( mask == 0.0  )      taux(:,:,n)=spval
      enddo
      ! read grid info
      iret=NF_INQ_VARDIMID (NCID,txid,DIMS)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),name) 
      iret=nf_inq_varid(ncid,name,aid)
      iret= nf_get_vara_real(ncid,aid ,1,nx,tauy(:,1,1))
      x=tauy(:,1,1)
      name='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),name) 
      iret=nf_inq_varid(ncid,name,aid)
      iret= nf_get_vara_real (ncid,aid ,1,ny,tauy(1,:,1)) 
      y=tauy(1,:,1)
      call ncclos (ncid, iret)
c   read tauy
      iret=nf_open('data/OMIP365/north_south_stress.nc',NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'stress_y',txid)
      iret= nf_get_vara_real(ncid,txid,(/1,1,1/),(/nx,ny,nt/),tauy)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret= nf_get_att_real (ncid,txid ,'missing_value',sp)
      do n=1,nt
        where ( tauy(:,:,n) == sp ) tauy(:,:,n)=spval
        where ( mask == 0.0  )      tauy(:,:,n)=spval
      enddo
      call ncclos (ncid, iret)
c   ustar**2 = tau/rho_w    ustar**3 = (tau/rho_w)**3/2
!    reference to dens. in water and convert (m/s)**3 to (cm/s)**3
      do n=1,nt
        do i=1,nx
        do j=1,ny
         if ( mask(i,j) /= 0.0 .and. taux(i,j,n)/=spval
     &              .and.tauy(i,j,n)/=spval )   then
          taux(i,j,n)= (taux(i,j,n)**2 + tauy(i,j,n)**2 )**0.5 
          ustar(i,j,n) = 1.e6*(taux(i,j,n)/rho_wat)**1.5
         else 
          ustar(i,j,n) =  spval
         end if
       enddo
       enddo
      enddo
c   flip second dimension up/down
      toffset=0.0
      y=y(ny:1:-1)
      do n=1,nt
       ustar(:,:,n)=ustar(:,ny:1:-1,n)
       time(n)=1.0
      enddo
      deallocate(taux,tauy,mask)
      end subroutine read_ustar

#elif defined read_ustar_T511
c
c--------------------------------------------------------
c    use daily data from ECMWF/T511
c    wind stress data for friction velocity.
c--------------------------------------------------------
      subroutine read_dims_ustar(nx,ny,nt)
      implicit none
      integer nx,ny,nt
#include "netcdf.inc"
      integer :: iret,ncid,varid,dims(4),nn
      character (len=80) :: file
      integer :: start_y, fraction_y, nfraction_y,full_y
      common / flx_ncep/ start_y,fraction_y,nfraction_y,full_y
      namelist /T511_time/ start_y,fraction_y,nfraction_y

      call getunit(ncid,'namelist.T511_time','fsr')
      read(ncid, nml = T511_time) 
      close(ncid)

      print*,' reading daily friction velocity data from ECMWF/T511'
      print*,' year ',start_y,' in ',fraction_y,' fractions'
      print*,' current fraction ',nfraction_y
      write(file,'("data/ecmwf_T511/EWSS_",i4,".cdf")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'EWSS',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)  
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)  
      call ncclos (ncid, iret)
      full_y = nn
      print*,' days in year:',full_y
      if (mod(full_y,fraction_y)/=0) then
          print*,'fraction must be integer divider of 365'
          print*,'but ', mod(full_y,fraction_y)
          stop
      endif
      nt=full_y/fraction_y ! must be an integer
      end subroutine read_dims_ustar



      subroutine read_ustar(ustar,x,y,nx,ny,nt,spval,time,toffset)
      use time_type_module
      implicit none
      integer :: nx,ny,nt
      real :: spval, ustar(nx,ny,nt) ,x(nx), y(ny),time(nt),toffset
#include "netcdf.inc"
      integer :: iret,ncid,txid,tyid,dims(4),aid,n,i,j,varid
      integer :: corner(4),edges(4),xid,yid,nn,n1,n2
      character (len=80) :: name,file
#ifdef netcdf_real4
      real (kind=4),allocatable :: taux(:,:,:),tauy(:,:,:),mask(:,:)
      real (kind=4) :: sp
      real (kind=4),allocatable :: v4(:,:,:)
      real (kind=4) :: add_offset,scale_factor
#else
      real ,allocatable :: taux(:,:,:),tauy(:,:,:),mask(:,:)
      real  :: sp
      real ,allocatable :: v4(:,:,:)
      real  :: add_offset,scale_factor
#endif
      real :: mask2(nx,ny)
      type(time_type) :: t1,t2,t3
      real :: rho_air = 1.29, rho_wat = 1026., fxa
      integer :: start_y, fraction_y, nfraction_y,full_y
      common / flx_ncep/ start_y,fraction_y,nfraction_y,full_y

      allocate( taux(nx,ny,nt), tauy(nx,ny,nt), mask(nx,ny) )

c   read land mask
      iret=nf_open('data/ecmwf_T511/land-sea-mask.nc.new',
     &              NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'tcw',varid)
      corner=(/1,1,1,1/); edges = (/nx,ny,1,1/)
      allocate( v4(nx,ny,1) )
      iret= nf_get_vara_real (ncid,varid ,corner,edges,v4)
      add_offset=0.0
      iret= nf_get_att_real (ncid,varid ,'add_offset',add_offset)
      scale_factor=1.0
      iret= nf_get_att_real (ncid,varid ,'scale_factor',scale_factor)
      do j=1,ny; do i=1,nx
        mask(i,j)=0.0
        fxa = v4(i,ny-j+1,1)*scale_factor + add_offset
        if (fxa.gt. 0.1)  mask(i,j)=1.
        mask2(i,j)=0.0
        if (fxa.gt. 0.5)  mask2(i,j)=1.
      enddo; enddo
      deallocate(v4)
      call ncclos (ncid, iret)

c     we have to manipulate the land mask a bit
      mask(705:712,288:300)=mask2(705:712,288:300) ! this is Scotland
      mask(635:645,306:312)=mask2(635:645,306:312) ! East greenland
      mask(585:600,310:318)=mask2(585:600,310:318)

      ! read grid info
      iret=nf_open('data/ecmwf_T511/land-sea-mask.nc',NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'lsm',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),file) 
      iret=nf_inq_varid(ncid,file,xid)
      allocate(v4(nx,1,1) )
      iret= nf_get_vara_real (ncid,xid ,1,nx,v4); x=v4(1:nx,1,1)
      deallocate(v4)
      file='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),file) 
      iret=nf_inq_varid(ncid,file,yid)
      allocate(v4(ny,1,1) )
      iret= nf_get_vara_real (ncid,yid ,1,ny,v4); 
      do j=1,ny
           y(j)=v4(ny-j+1,1,1)
      enddo
      deallocate(v4)
      call ncclos (ncid, iret)
      ! time vector
      t1 =  set_date(start_y, 1, 1, 0, 0, 0)
      toffset=t1%days + (nfraction_y-1)*(full_y/fraction_y)
      write(file,'("data/ecmwf_T511/EWSS_",i4,".cdf")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'EWSS',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      call ncclos (ncid, iret)
      do n=1,nt
        time(n) =  365.0/(full_y*1.0)
      enddo

c   read taux and tauy

      print*,' reading year ',start_y
      call sub_flush(6)
      write(file,'("data/ecmwf_T511/EWSS_",i4,".cdf")') start_y
      iret=nf_open(file,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'EWSS',varid)
      iret=NF_INQ_VARDIMID (NCID,varid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nn)
      n1=1+(nfraction_y-1)*(full_y/fraction_y)
      nn=nfraction_y*(full_y/fraction_y)
      corner=(/1,1,n1,1/); edges = (/nx,ny,nt,1/)
      iret= nf_get_vara_real (ncid,varid ,corner,edges,taux)
      call ncclos (ncid, iret)

      write(file,'("data/ecmwf_T511/NSSS_",i4,".cdf")') start_y
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_open(file,NF_nowrite,ncid)
      iret=nf_inq_varid(ncid,'NSSS',varid)
      iret= nf_get_vara_real (ncid,varid ,corner,edges,tauy)
      call ncclos (ncid, iret)

c   ustar**2 = tau/rho_w    ustar**3 = (tau/rho_w)**3/2
!    reference to dens. in water and convert (m/s)**3 to (cm/s)**3
      do n=1,nt
        do i=1,nx
        do j=1,ny
         if ( mask(i,j) /= 1.0) then 
          taux(i,j,n)= (taux(i,j,n)**2 + tauy(i,j,n)**2 )**0.5 
          ustar(i,j,n) = 1.e6*(taux(i,j,n)/rho_wat)**1.5
         else 
          ustar(i,j,n) =  spval
         end if
       enddo
       enddo
      enddo
      deallocate(taux,tauy,mask)
      end subroutine read_ustar


#endif

! local defines : (should be set by Makefile)
c#define  drive_tmngr

       module time_manager_module
c
c-------------------------------------------------------------------------
c      use this module as a time manager of a complete integration.
c      time derivatives could be written like:
c      h(::,taup1) = h(::,taum1) + c2dt* forcing(tau,taum1)
c
c      a typical main loop of a model could look like:
c
c       call init_time_manager(dt_in,runlen,snap_int,restart_stamp )
c 10    continue
c 20     call time_step_begin()
c        ... stuff to integrate the model ...
c        if (snapshot_time_step) diagnose the model
c        call time_step_end()
c        if (eulerback2) goto 20    ! do the second part of the euler backw. 
c       if (.not. eorun ) goto 10
c                                         aug 2001  c. eden
c-------------------------------------------------------------------------
c
       use time_type_module
       implicit none

       integer             :: mixing_freq = 17     ! freq. in time steps of 
                                                   ! mixing time steps
       character (len=80)  :: mixing_type = 'euler_backward' 
                     ! type of mixing time step
                     ! 'euler_backward' and 'euler_foreward' are implemented
                     ! note that euler_backward is more dissipative and
                     ! damps also spatial scales ...
       type( time_type )          :: initial_time    ! the initial time, for which
                                                     ! the model was started
       type( time_type )          :: current_time    ! the current model time
       type( time_type )          :: restart_time    ! the time of the last restart
       type( time_type )          :: stop_time       ! the time of the end of
                                                     ! the present integration
       type( time_type )          :: snapshot_time   ! the time for the next
                                                     ! snapshot to write
       type( time_type )          :: snapshot_inctime! the interval between 
                                                     ! snapshots
       integer          :: initial_year  = 1900      ! initial date
       integer          :: initial_month = 01
       integer          :: initial_day   = 01
       integer          :: initial_hour  = 00
       integer          :: initial_min   = 00
       integer          :: initial_sec   = 00
       real             :: dt,c2dt           ! time step in secs and 2*dt
                                             ! or 1*dt for an euler step
       integer          :: itt = 1           ! number of time steps
                                             ! in present integration
       integer          :: taum1=0,tau=1,taup1=2 ! pointer to data
                                                 ! which depends on time
           ! tau points to the present time step, taum1, taup1 to the
           ! previous and next time step. For an euler time step, taum1
           ! equals tau.
       integer,private  :: otaum1=0, intermediate ! pointer for eulerbackward
       character        :: current_stamp*32       ! current time stamp 
       logical          :: eulerback1= .false.    ! is this the first part of
                                                  ! an euler backward step?
       logical          :: eulerback2= .false.    ! is this the second part of
                                                  ! an euler backward step?
       logical          :: eulerfore = .false.    ! is this an euler foreward step?
       logical          :: end_of_run           = .false. ! is the end of run reached
       logical          :: last_time_step       = .false. ! is this the last time step
       logical          :: snapshot_time_step   = .false. ! write a snapshots?
       logical          :: end_of_year          = .false. ! end of year
       logical          :: end_of_season        = .false.
       logical          :: end_of_month         = .false.
       logical          :: end_of_day           = .false.
       logical          :: time_manager_verbose = .true.  ! be verbose
       logical          :: tmngr_initialized    = .false.
       logical   :: enable_mixing_time_steps = .true.
c
c      time interpolator stuff
c
       type forcing_time_type
         integer :: ntimes  
         logical :: periodical
         logical :: busy 
         type(time_type), pointer :: mid_points(:)
         type(time_type), pointer :: str_points(:)
         type(time_type), pointer :: end_points(:)
       end type
       integer, parameter :: max_forcings = 100
       integer :: nr_forcings = 0
       type( forcing_time_type ) :: forcing(max_forcings)

       contains

       subroutine init_time_manager(dt_in,runlen_in,snap_int_in,
     &                              restart_stamp_in,itt_in)
c
c-------------------------------------------------------------------------
c      initialze the whole time manager
c-------------------------------------------------------------------------
c 
       real, intent(in) :: dt_in    ! time step in seconds
       real, intent(in) :: runlen_in   ! length of run in days
       real, intent(in) :: snap_int_in ! snapshot interval in days
       character, intent(in) ::  restart_stamp_in*32
                                    ! year,months, etc of restart
       integer, intent(in) :: itt_in! counter of time steps
                                    ! of the restart
       type( time_type ):: time  
       integer :: n

      if (.not. tmngr_initialized ) then
         tmngr_initialized = .true.
         do n=1,max_forcings
           forcing(n)%busy=.false.
           forcing(n)%ntimes=0
         enddo
       endif

!      set the time step counter
       itt=itt_in

!      set the time steps
       dt=dt_in
       c2dt=2.*dt
       if (int(dt)*1. /= dt) then
         print*,' ERROR: use of timesteps with fractional seconds'
         call halt_stop(' in init_time_manager')
       endif

!      default calendar type to be used
       call set_calendar_type(no_leap)

!      set initial time
       initial_time = set_date(initial_year, initial_month, initial_day,
     &                         initial_hour, initial_min, initial_sec)

!      set restart time
       restart_time = get_stamp(restart_stamp_in)

!      update current time
       current_time = restart_time
       call set_stamp(current_stamp, current_time )

!      set end of integration
       call set_time ( time,
     &        nint( (runlen_in-int(runlen_in))*60*60*24 ), 
     &        int(runlen_in))
       stop_time = current_time + time 

!      set next snapshot time
       snapshot_time = initial_time

       call set_time(snapshot_inctime ,
     &        nint( (snap_int_in-int(snap_int_in))*60*60*24 ), 
     &        int(snap_int_in))

       if (snap_int_in>0.) then
 20     snapshot_time = snapshot_time + snapshot_inctime
        if (snapshot_time < current_time ) goto 20
       else
        snapshot_time=current_time
       endif

       if ( time_manager_verbose ) then
        print*,' '
        print*,' setting up the model integration for'
        print*,' ',runlen_in,' days, snapshot interval is ',
     &          snap_int_in,' days'
        print*,' time step will be ',dt,' seconds'
        print*,' '
       endif

       end subroutine init_time_manager

       subroutine disable_mixing_time_steps
       enable_mixing_time_steps = .false.
       end subroutine disable_mixing_time_steps

       subroutine time_step_begin()
c
c-------------------------------------------------------------------------
c      set up some things for each time step
c      use this before doing stuff in the present time step
c-------------------------------------------------------------------------
c
       type( time_type ):: time  

       if (mod(itt,mixing_freq) == 0 .and. 
     &            enable_mixing_time_steps) then ! start a mixing time step
c       if (mod(itt,mixing_freq) == 0) then ! start a mixing time step

         c2dt  = 1.0*dt

         if     (mixing_type == 'euler_backward') then

          if (eulerback2) then

           eulerback1 = .false. ! second part of euler backward step
           eulerback2 = .true.  ! second part of euler backward step
           eulerfore  = .false.
           c2dt  = 1.0*dt

          else

           eulerback1=.true. ! first part of euler backward step
           eulerback2=.false.
           eulerfore =.false.
           otaum1=taum1           ! we do not need this pointer, but remember it
           taum1=tau              ! set tau and taum1 to the same arrays
                                  ! and compute intermediate step in taup1
                                  ! see in time_step_end what happens next
          endif
         elseif (mixing_type == 'euler_foreward') then

          otaum1=taum1      ! remember that pointer which is not needed here
          taum1=tau         ! simple euler foreward step
          eulerback1=.false.
          eulerback2=.false.
          eulerfore =.true.

         else
          call halt_stop(' other mixing time steps than'//
     &                   ' euler backward and euler foreward'//
     &                   ' are not implemented so for ')
         endif

       else

         eulerfore =.false.
         eulerback1=.false.
         eulerback2=.false.
         c2dt  = 2.0*dt

       endif

c      is this the last time step ? 

       call set_time(time,nint(dt),0)
       if ( current_time + time >= stop_time) last_time_step = .true.
c      do nothing if this is the first part of an eulerbackward step
       if (eulerback1) last_time_step = .false.

c      is this a snapshot time step ?

       if ( current_time >= snapshot_time .and. .not. eulerback1  ) then 
        snapshot_time_step = .true.
        snapshot_time = snapshot_time + snapshot_inctime
        if (snapshot_time <= current_time) then
         snapshot_time = current_time
        endif
       else
        snapshot_time_step = .false.
       endif

       call set_time(time,nint(dt),0)
       time=current_time+time

c      is this the end of the year ?
       end_of_year= .false.
       if (get_year(time) /= get_year( current_time) )
     &     end_of_year = .true.
       if (eulerback1) end_of_year=.false.

c      is this the end of the season ?
       end_of_season= .false.
       if (get_season_of_year(time) /= get_season_of_year(current_time))
     &     end_of_season = .true.
       if (eulerback1) end_of_season=.false.

c      is this the end of the month ?
       end_of_month= .false.
       if (get_month_of_year(time) /= get_month_of_year(current_time))
     &     end_of_month = .true.
       if (eulerback1) end_of_month=.false.

c      is this the end of the day ?
       end_of_day= .false.
       if (get_day_of_month(time) /= get_day_of_month( current_time))
     &     end_of_day = .true.
       if (eulerback1) end_of_day=.false.

c      implement other switches here

       end subroutine time_step_begin



       subroutine time_step_end()
c
c-------------------------------------------------------------------------
c      increments all pointers and the time
c      use this after done all stuff in the present time step
c-------------------------------------------------------------------------
c

       if (eulerfore) then
c
c       end of an euler foreward step
c
        eulerback1=.false.
        eulerback2=.false.
        eulerfore =.false.
c        taum1=tau   ! was already set to this value
        tau=taup1
        taup1=otaum1
        call time_goes_by()

       elseif (eulerback1) then
c
c       end of the first part of an euler backward step
c
        eulerback1=.false.        ! start now the second part of the backward step
        eulerback2=.true.         ! start now the second part of the backward step
        eulerfore =.false.
        tau=taup1                 ! in taup1 the intermediate step was computed
                                  ! now compute the end result: taum1 
                                  ! stays the same and forcing at tau becomes now
                                  ! the intermediate result, forcing at taum1
                                  ! is still the tau from previous leapfrog step
        intermediate = taup1      ! we have to remember that pointer
        taup1=otaum1              ! store the end result of this step
                                  ! in the so far unused array

       elseif (eulerback2) then
c
c       end of the second part of an euler backward step
c
        eulerback1=.false.
        eulerback2=.false.
        eulerfore =.false.
        tau  =taup1               ! taum1 was unchanged during the backward step
                                  ! and still points to tau of the previous
                                  ! leapfrog step
        taup1=intermediate        ! store future results in an array which is not
                                  ! needed anymore.
        call time_goes_by()

       else
c
c       end of a leapfrog time step
c
        eulerback1=.false.
        eulerback2=.false.
        eulerfore =.false.

        otaum1=taum1
        taum1= tau
        tau  = taup1
        taup1= otaum1
        call time_goes_by()
       endif

       end subroutine time_step_end


       subroutine time_goes_by
c
c-------------------------------------------------------------------------
c      as times goes by
c-------------------------------------------------------------------------
c
       type( time_type ):: time  
       itt=itt+1
       call set_time(time,nint(dt),0)
       current_time = current_time + time 
       call set_stamp(current_stamp, current_time )
       if ( current_time >= stop_time) end_of_run = .true.
       end subroutine time_goes_by


       subroutine set_stamp (stamp, time)
c
c-------------------------------------------------------------------------
c      converts time to character string
c-------------------------------------------------------------------------
c
       implicit none
       type( time_type ), intent(in) :: time
       character, intent(out) :: stamp*32
c     author:       R.C. Pacanowski     e-mail=>  rcp@gfdl.gov
       integer year, month, day, hour, min, sec
       call get_date(time,year,month,day,hour,min,sec)
       if (year .le. 9999) then
         write (stamp,'(a6,i2,a1,i2,a1,i4,a8,i2,a1,i2,a1,i2)') 
     &                'm/d/y=',month,'/',day,'/'
     &,                year,', h:m:s=', hour,':', min,':', sec
       elseif (year .ge. 10000 .and. year .le. 99999) then
         write (stamp,'(a6,i2,a1,i2,a1,i5,a7,i2,a1,i2,a1,i2)')
     &            'm/d/y=',month,'/',day,'/'
     &,           year,',h:m:s=', hour,':', min,':', sec
       elseif (year .ge. 100000 .and. year .le. 999999) then
         write (stamp,'(a6,i2,a1,i2,a1,i6,a6,i2,a1,i2,a1,i2)')
     &            'm/d/y=',month,'/',day,'/'
     &,           year,'h:m:s=', hour,':',  min,':', sec
       else
         write (*,*) '=>Error: year=',year,',is too large in set_stamp.'
         call halt_stop(' in set_stamp')
       endif
       end subroutine set_stamp


       function get_stamp (stamp)
c
c-------------------------------------------------------------------------
c       converts character string to time type
c-------------------------------------------------------------------------
c
       implicit none
       type( time_type ) :: get_stamp
       character, intent(in) ::  stamp*32
       integer   year, month, day, hour, min, sec
       character skip6*6, skip7*7, skip8*8, skip1*1
c      author:       R.C. Pacanowski     e-mail=>  rcp@gfdl.gov
c
c      for years: 0..9999
       if (stamp(17:17) .eq. ',') then 
        read  (stamp, '(a6,i2,a1,i2,a1,i4,a8,i2,a1,i2,a1,i2)')
     &      skip6, month, skip1, day, skip1, year, skip8, hour
     &,     skip1, min, skip1, sec
c      for years:  10000..99999
       elseif (stamp(18:18) .eq. ',') then
        read  (stamp, '(a6,i2,a1,i2,a1,i5,a7,i2,a1,i2,a1,i2)')
     &      skip6, month, skip1, day, skip1, year, skip7, hour
     &,     skip1, min, skip1, sec
c      for years:  100000..999999
       elseif (stamp(19:19) .eq. 'h') then
        read  (stamp, '(a6,i2,a1,i2,a1,i6,a6,i2,a1,i2,a1,i2)')
     &      skip6, month, skip1, day, skip1, year, skip6, hour
     &,     skip1, min, skip1, sec
       else
        write (*,*) '=>Error: year is too large in get_stamp.'
        call halt_stop(' in get_stamp')
       endif
       get_stamp = set_date(year,month,day,hour,min,sec)
       end function get_stamp

       function get_current_time()
c-------------------------------------------------------------------------
c      get the current model time
c-------------------------------------------------------------------------
       type (time_type) :: get_current_time
       get_current_time = current_time
       end function get_current_time

       function get_stop_time()
c-------------------------------------------------------------------------
c      get the time of the en of run
c-------------------------------------------------------------------------
       type (time_type) :: get_stop_time
       get_stop_time = stop_time
       end function get_stop_time

       function get_itts_til_eorun()
c-------------------------------------------------------------------------
c      get number of time steps til end of run
c-------------------------------------------------------------------------
       integer :: get_itts_til_eorun
       type (time_type) :: time
       call set_time(time,nint(dt),0)
       get_itts_til_eorun=(stop_time - current_time)/time
       end function get_itts_til_eorun

       function get_initial_time()
c-------------------------------------------------------------------------
c      get the initial model time
c-------------------------------------------------------------------------
       type (time_type) :: get_initial_time
       get_initial_time = initial_time
       end function get_initial_time

       function get_month_of_year(time)
       integer get_month_of_year
       type (time_type) :: time
       integer year, month, day, hour, min, sec
       call get_date(time,year,month,day,hour,min,sec)
       get_month_of_year=month
       end function get_month_of_year

       function get_day_of_month(time)
       integer get_day_of_month
       type (time_type) :: time
       integer year, month, day, hour, min, sec
       call get_date(time,year,month,day,hour,min,sec)
       get_day_of_month = day
       end function get_day_of_month

       function get_season_of_year(time)
       integer get_season_of_year
       type (time_type) :: time
       integer year, month, day, hour, min, sec
       call get_date(time,year,month,day,hour,min,sec)
       if (month >=1 .and. month <= 3 ) get_season_of_year=1 ! J/F/M
       if (month >=4 .and. month <= 6 ) get_season_of_year=2 ! A/M/J
       if (month >=7 .and. month <= 9 ) get_season_of_year=3 ! J/A/S
       if (month >=10.and. month <= 12) get_season_of_year=4 ! O/N/D
       end function get_season_of_year

       function get_year(time)
       integer get_year
       type (time_type) :: time
       integer year, month, day, hour, min, sec
       call get_date(time,year,month,day,hour,min,sec)
       get_year=year
       end function get_year


       function get_day_of_year(time)
       real :: get_day_of_year
       type (time_type) :: time
       integer year, month, day, hour, min, sec
       call get_date(time,year,month,day,hour,min,sec)
       get_day_of_year = time_in_days(time - set_date(year,1,1,0,0,0) )
       end function get_day_of_year


       subroutine init_forcing_interp(nr,p,sp,interval,index)
c
c-------------------------------------------------------------------------
c      initialize forcing interpolation slots
c      input:
c      nr: number of time steps for the forcing data
c      p:  periodical data?
c      sp: start time of the averarging period of the 1. time step
c      interval : averaging periods for all time steps
c      output:
c      index: index of slot for further references
c-------------------------------------------------------------------------
c
       integer, intent(in) :: nr
       logical, intent(in) :: p
       type( time_type), intent(in) :: sp,interval(nr)
       integer, intent(out) :: index
       integer :: n
       character*32 s1

       if (time_manager_verbose) then
        print*,''
        print*,'Initializing time interpolation slot #',
     &            nr_forcings+1
        print*,'periodical : ',p
       endif

       nr_forcings=nr_forcings+1
       index = nr_forcings
       if (index > max_forcings) then
         print*, ' Number of slots for forcing interpolation ' 
         print*, ' exceeds max_forcings=',max_forcings
         call halt_stop(' in init_interp_forcing')
       endif

       if (p .and. get_calendar_type() == Julian ) then
        print*,''
        print*,' WARNING: '
        print*,' you are trying to use periodical forcing '
        print*,' and a calendar with leap year '
        print*,' that may result in wrong interpolations'
        print*,''
       endif

       forcing(index)%busy = .true.
       forcing(index)%ntimes = nr
       forcing(index)%periodical = p

       allocate( forcing(index)%mid_points(nr) )
       allocate( forcing(index)%str_points(nr) )
       allocate( forcing(index)%end_points(nr) )
       forcing(index)%str_points(1)=sp
       forcing(index)%end_points(1)=sp+interval(1)
       forcing(index)%mid_points(1)=sp+interval(1)/2
       do n=2,nr
        forcing(index)%str_points(n)=forcing(index)%end_points(n-1)
        forcing(index)%end_points(n)=forcing(index)%end_points(n-1)+
     &                               interval(n)
        forcing(index)%mid_points(n)=forcing(index)%str_points(n)+
     &                               interval(n)/2
       enddo     

       if (time_manager_verbose) then
        do n=1,nr
         call set_stamp(s1,forcing(index)%str_points(n))
         print*,'time step #',n,' starts at ',s1,' ave.period=',
     &     time_in_days(interval(n)),' days'
        enddo
        print*,'ok done'
        print*,''
       endif

       end subroutine init_forcing_interp


       subroutine forcing_interp(index,data1,data2,fac1,fac2)
c
c-------------------------------------------------------------------------
c      get indeeces to time steps in forcing data 
c      and interpolation factors, such that the current forcing
c      becomes   f_data(...,data1)*fac1+f_data(...,data2)*fac2
c-------------------------------------------------------------------------
c
       integer, intent(in) :: index 
       integer, intent(out) ::  data1,data2
       real, intent(out) ::  fac1,fac2
       type( time_type) ::  t1,t2,tcov
       integer n,nr

       if (.not.forcing(index)%busy) then
         print*,' ERROR: you are trying to access '
         print*,'   forcing interpolation with index ',index
         print*,'   which was not intialized yet '
         call halt_stop(' in forcing_inertp')
       endif

       nr = forcing(index)%ntimes 
       tcov=forcing(index)%end_points(nr)-forcing(index)%str_points(1)

       if ( forcing(index)%periodical ) then
c       shift all times by tcov if they do not fit into current_time
 10     if ( current_time > forcing(index)%end_points(nr) ) then
         do n=1,nr
          forcing(index)%mid_points(n)=forcing(index)%mid_points(n)+tcov
          forcing(index)%str_points(n)=forcing(index)%str_points(n)+tcov
          forcing(index)%end_points(n)=forcing(index)%end_points(n)+tcov
         enddo
         goto 10
        elseif ( current_time < forcing(index)%str_points(1) ) then
         do n=1,forcing(index)%ntimes
          forcing(index)%mid_points(n)=forcing(index)%mid_points(n)-tcov
          forcing(index)%str_points(n)=forcing(index)%str_points(n)-tcov
          forcing(index)%end_points(n)=forcing(index)%end_points(n)-tcov
         enddo
         goto 10
        endif
       endif

c      increment data2 til it is just greater than current_time
       data2=1
 20    if ( data2 <= nr ) then
        if (forcing(index)%mid_points(data2) < current_time ) then
         data2=data2+1
         go to 20
        endif
       endif

c      get the interpolation factors and data pointers
       if (data2 == 1) then
          if ( forcing(index)%periodical ) then
           data1=nr
           t1 = current_time-(forcing(index)%mid_points(data1)-tcov)
           t2 = forcing(index)%mid_points(data2) - current_time
           fac2=time_in_days(t1)/time_in_days(t1+t2)
           fac1=time_in_days(t2)/time_in_days(t1+t2)
          else
           data1=1
           fac1=0.
           fac2=1.
          endif
       elseif (data2 <= nr ) then
          data1=data2-1
          t1 = current_time - forcing(index)%mid_points(data1)
          t2 = forcing(index)%mid_points(data2) - current_time
          fac2=time_in_days(t1)/time_in_days(t1+t2)
          fac1=time_in_days(t2)/time_in_days(t1+t2)
       else
          if ( forcing(index)%periodical ) then
           data2=1
           data1=nr
           t1 = current_time - forcing(index)%mid_points(data1)
           t2 = forcing(index)%mid_points(data2)+tcov - current_time
           fac2=time_in_days(t1)/time_in_days(t1+t2)
           fac1=time_in_days(t2)/time_in_days(t1+t2)
          else
           data1 = nr
           data2 = nr
           fac1=0.
           fac2=1.
          endif
       endif
       end subroutine forcing_interp


       subroutine get_forcing_interp_stamps(index,p,ss,se,sm)
c
c-------------------------------------------------------------------------
c      returns the start, end and mid time in stamps for
c      the interpolation slot index for time step p
c-------------------------------------------------------------------------
c
       integer, intent(in) :: index,p
       character, intent(out) :: ss*32
       character, intent(out),optional :: se*32
       character, intent(out),optional :: sm*32

       if (.not.forcing(index)%busy) then
         print*,' ERROR: you are trying to access '
         print*,'   forcing interpolation with index ',index
         print*,'   which was not intialized yet '
         call halt_stop(' in get_forcing_inertp_stamps')
       endif

       call set_stamp(ss,forcing(index)%str_points(p))
       if (present(se)) call set_stamp(se,forcing(index)%end_points(p))
       if (present(sm)) call set_stamp(sm,forcing(index)%mid_points(p))

       end subroutine get_forcing_interp_stamps



       subroutine update_forcing_cache(index,p1,p2,pointer,load,tname)
c
c-------------------------------------------------------------------------
c      translate time steps p1 and p2 in forcing data set 
c      forcing(:,p1) and forcing(:,p2) to
c      positions of a cache for the forcing such that 
c      cache(:,p1)=forcing(:,pointer(p1)) and 
c      cache(:,p2)=forcing(:,pointer(p2))
c      (p1 and p2 will be changed on output)
c      logical load(2) is true if forcing data has to be load
c      into the cache , which is not done here.
c      After loading the cache the forcing for the current model time step
c      becomes cache(:,p1)*fac1+cache(:,p2)*fac2, the factors
c      has to be determined with subr. forcing_interp
c-------------------------------------------------------------------------
c
       implicit none
       integer :: pointer(2),index
       integer :: p1,p2,ipos1,ipos2
       logical :: load(2)
       character(len=32) :: ss,se,sm,tname

       if (p1 /= pointer(1) .and. p1 /= pointer(2) ) then
        ipos1=1; if (p2 == pointer(1) ) ipos1=2
        pointer(ipos1) = p1
        load(ipos1) = .true.
       else
        if (p1 == pointer(1)) ipos1=1
        if (p1 == pointer(2)) ipos1=2
        load(ipos1) = .false.
       endif

       if (p2 /= pointer(1) .and. p2 /= pointer(2) ) then
        ipos2=1; if (p1 == pointer(1) ) ipos2=2
        pointer(ipos2) = p2
        load(ipos2) = .true.
       else
        if (p2 == pointer(1)) ipos2=1
        if (p2 == pointer(2)) ipos2=2
        load(ipos2) = .false.
       endif

       if (load(ipos1).and. time_manager_verbose ) then 
        call get_forcing_interp_stamps(index,p1,ss,se,sm)
        print*,' reading data for ',tname,' for time step #',p1,
     &          ' to cache position',ipos1
        print*,' time step #',p1,' begins at ',ss
        print*,' time step #',p1,' ends at   ',se
        print*,' time step #',p1,' middle at ',sm
       endif

       if (load(ipos2).and. time_manager_verbose ) then 
        call get_forcing_interp_stamps(index,p2,ss,se,sm)
        print*,' reading data for ',tname,' for time step #',p2,
     &          ' to cache position',ipos2
        print*,' time step #',p2,' begins at ',ss
        print*,' time step #',p2,' ends at   ',se
        print*,' time step #',p2,' middle at ',sm
       endif

       p1=ipos1; p2=ipos2
       end subroutine update_forcing_cache

       end module time_manager_module


#ifdef drive_tmngr
c
c      test the time manager here
c
       subroutine halt_stop(s)
       character (len=*) :: s
       print*,s
       stop
       end subroutine halt_stop

       program test_tmngr
       use time_manager_module
       implicit none
       real :: dt_in=1200., runlen=0.25, snap_int=0.0
       character (len=32) :: 
     &      stamp ='m/d/y= 1/ 1/1900, h:m:s= 0: 0: 0' 
       type( time_type) :: start,interval(12)
       integer :: p1,p2,pointer(2),index
       real    :: f1,f2
       character(len=80) :: text = 'test data set'
       logical load(2)

       time_manager_verbose=.true.  ! be verbose
       call init_time_manager(dt_in,runlen,snap_int,stamp,1 )

       start= get_stamp(stamp)
       interval(:)%days=365
       interval(:)%seconds=0
       call init_forcing_interp(2,.true.,start,interval,index)

  20   continue
      
        call time_step_begin()
        print*,'date: ',current_stamp,' itt=',itt
c        print*,'taum1=',taum1,' tau=',tau,' taup1=',taup1,eulerback1
        if (snapshot_time_step) print*,' writing a snapshot'

        call forcing_interp(index,p1,p2,f1,f2)
        call update_forcing_cache(index,p1,p2,pointer,load,text)

        print*,''
        print*,' data in cache at pos #1 point to data(',pointer(1),')'
        if (load(1)) print*,' data has to be loaded to cache pos #1'
        print*,' data in cache at pos #2 point to data(',pointer(2),')'
        if (load(2)) print*,' data has to be loaded to cache pos #1'
        print*,' interpolated data for this time step:'
        print*,' cache pos #',p1,'*',f1,'+ cache pos #',p2,'*',f2
        print*,'  = data(',pointer(p1),')*',f1,
     &         '+ data(',pointer(p2),')*',f2
        print*,''

        call time_step_end()

       if (.not. end_of_run ) goto 20

       end program test_tmngr

#endif

#include "options.inc"


c
c=======================================================================
c  convert binary output of averaged second moments to NetCDF format
c=======================================================================
c
c
c  real variables are 8 or 4 bytes long set by
c#define real_8
c
c#define large_fluxfile
#define define_in_fluxfile_eddyflux
#define define_in_fluxfile_varianceflux

      module kind_mod
#ifdef real_8
      integer, parameter::  r_knd  = selected_real_kind(13)
#else
      integer, parameter::  r_knd  = selected_real_kind(6)
#endif

      end module kind_mod



      module cv_var_module
      use kind_mod
      integer :: imt,jmt,km,nt
      real (kind=r_knd), allocatable, dimension(:,:,:,:) :: mean_u,var_u
      real (kind=r_knd), allocatable, dimension(:,:) :: mean_ssh,var_ssh
      integer :: counter
      real (kind=r_knd), allocatable, dimension(:)  :: xt,yt,xu,yu,zt,zw
      integer, allocatable, dimension(:,:)     :: kmt,kmu
      logical :: enable_monthly_variances = .false.
      logical :: enable_seasonal_variances = .false.
      logical :: enable_freesurf = .false.
      logical :: energy = .false., energy_ext = .false.
      logical :: var_fluxes = .false.
      real (kind=r_knd), allocatable, dimension(:,:,:) :: uv,rhom
      real (kind=r_knd), allocatable, dimension(:,:,:,:) :: urho,upress
      real (kind=r_knd), allocatable, dimension(:,:,:) :: wrho,pressm
      real (kind=r_knd),allocatable,dimension(:,:,:,:)  ::mean_adv
      real (kind=r_knd),allocatable,dimension(:,:,:,:,:)::mean_tracer
      real (kind=r_knd),allocatable,dimension(:,:,:,:,:)::var_tracer
      real (kind=r_knd),allocatable,dimension(:,:,:,:,:)::mean_eddy_flux
      real (kind=r_knd),allocatable,dimension(:,:,:,:,:)::mean_var_flux
#ifdef large_fluxfile
      real (kind=r_knd),allocatable,dimension(:,:,:,:,:)::theta
      real (kind=r_knd),allocatable,dimension(:,:,:,:,:)::eddy_flux
#endif
      end module cv_var_module


      program cv_var
      use cv_var_module
      implicit none
      character (len=80) :: infile,outfile
      integer :: ierr,i
      character (len=9) :: c9
      character (len=1) :: c1
      character (len=2) :: c2
      character (len=4) :: c4
      integer :: year,month,day,domain

      print*,' Converting averaged second moments written by SPFLAME',
     &       ' to NetCDF file '

      call get_commandline_arg(1,infile,ierr)
      if (ierr/=0) goto 99
      print*,' reading from file ',infile(1:len_trim(infile))

      read(infile,'(a10,i3,a2,i4,a1,i2,a1,i2,a4)') 
     &            c9,domain,c2,year,c1,month,c1,day,c4
      print*,' sub domain = ',domain
      print*,' year/month/day  = ',year,month,day
      call read_variances(infile)

#ifdef notdef
c old version
      write(outfile,'("variances_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            domain,year,month,day
      call replace_space_zero(outfile)
      call write_variances(outfile,year,month,day,domain)
#endif

c   new version, split into several files

      write(outfile,'("eke_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            domain,year,month,day
      call replace_space_zero(outfile)
      call write_variances_eke(outfile,year,month,day,domain)

      if (energy) then
       write(outfile,'("energy_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            domain,year,month,day
       call replace_space_zero(outfile)
       call write_variances_energy(outfile,year,month,day,domain)
      endif

      if (var_fluxes) then
       write(outfile,'("varflux_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            domain,year,month,day
       call replace_space_zero(outfile)
       call write_variances_fluxes(outfile,year,month,day,domain)
      endif

      stop

 99   print*,' program needs command line parameter'
      print*,' 1. input binary file name (written by spflame)'
      end program cv_var


      subroutine read_variances(infile)
      use cv_var_module
      implicit none
      character (len=*) :: infile
      character (len=3) :: ssh
      real (kind=r_knd), allocatable :: buf(:,:)
      integer :: i,j,k,io,n,nr,m
      logical :: eof = .false.
      character (len=80) :: name

      call getunit(io,infile,'usr ieee')
      read(io) imt,jmt,km,nt
      print*,' imt=',imt,' jmt=',jmt,' km=',km,' nt=',nt
      allocate( var_u(imt,km,jmt,nt) ); var_u=0.0
      allocate( mean_u(imt,km,jmt,2) ); mean_u=0.0
      allocate( mean_ssh(imt,jmt) );mean_ssh=0.0
      allocate( var_ssh(imt,jmt) ); var_ssh=0.0
      allocate( xt(imt),yt(jmt),xu(imt),yu(jmt),zt(km),zw(0:km))
      zw=0.0
      allocate( kmt(imt,jmt),kmu(imt,jmt) ); kmu=0

      read(io) xt,yt,xu,yu,zt,zw(1:km)
      read(io) counter
      print*,' counter for averages=',counter
      read(io) enable_monthly_variances
      read(io) enable_seasonal_variances
      read(io) kmt
      do j=1,jmt-1
        do i=1,imt-1
           kmu(i,j) = min (kmt(i,j), kmt(i+1,j), 
     &                     kmt(i,j+1), kmt(i+1,j+1))
        enddo
      enddo

      print*,' zt(1:5)=',zt(1:5)
      allocate( buf(imt,jmt) )

      do while (.not. eof) 
       read (io,end=50) nr,name
       goto 60
 50    eof=.true.
 60    continue

       if (.not. eof) then

        if (name(1:5) == 'umean') then
  
         print*,' found mean velocity '
         do n=1,2
          do k=1,km
           print*,'k=',k,'/',km
           read(io) buf
           mean_u(:,k,:,n)=  buf
          enddo
         enddo

        elseif (name(1:4) == 'uvar' ) then

         print*,' found variance of velocity '

         do n=1,2
          do k=1,km
           print*,'k=',k,'/',km
           read(io) buf
           var_u(:,k,:,n)=  buf
          enddo
         enddo

        elseif (name(1:6) == 'energy') then

         print*,' found energy conversion terms '

         energy=.true.
         allocate( uv(imt,km,jmt) ); uv=0.0
         allocate( rhom(imt,km,jmt) ); rhom=0.0
         allocate( urho(imt,km,jmt,2) ); urho=0.0
         do k=1,km
          read(io) buf; uv(:,k,:)=  buf
          read(io) buf; rhom(:,k,:)=  buf
          read(io) buf; urho(:,k,:,1)=  buf
          read(io) buf; urho(:,k,:,2)=  buf
         enddo

        elseif (name(1:6) == 'en_ext') then

         print*,' found extended energy conversion terms '
         energy_ext=.true.
         allocate( wrho(imt,km,jmt) ); wrho=0.0
         allocate( pressm(imt,km,jmt) ); pressm=0.0
         allocate( upress(imt,km,jmt,3) ); upress=0.0
         do k=1,km
          read(io) buf; wrho(:,k,:)=  buf
          read(io) buf; pressm(:,k,:)=  buf
          read(io) buf; upress(:,k,:,1)=  buf
          read(io) buf; upress(:,k,:,2)=  buf
          read(io) buf; upress(:,k,:,3)=  buf
         enddo

        elseif (name(1:10) == 'var_fluxes') then
         print*,' found fluxes of variance '
         var_fluxes = .true.
         allocate(       mean_adv(imt        ,km,jmt        ,3) )
#ifdef large_fluxfile
         allocate(    mean_tracer(imt        ,km,jmt        ,3,nt+1) )
         allocate(     var_tracer(imt        ,km,jmt        ,3,nt+1) )
         allocate( mean_eddy_flux(imt        ,km,jmt        ,3,nt+1) )
         allocate(  mean_var_flux(imt        ,km,jmt        ,3,nt+1) )
#else
         allocate(    mean_tracer(imt,km,jmt,3,nt+1:nt+1) )
         allocate(     var_tracer(imt,km,jmt,3,nt+1:nt+1) )
         allocate( mean_eddy_flux(imt,km,jmt,3,nt+1:nt+1) )
         allocate(  mean_var_flux(imt,km,jmt,3,nt+1:nt+1) )
#endif
         mean_adv=0.0; mean_tracer=0.0; var_tracer=0.0
         mean_eddy_flux=0.0; mean_var_flux = 0.0; 
#ifdef large_fluxfile
         allocate(          theta(imt        ,km,jmt        ,3,nt+1) )
         allocate(      eddy_flux(imt        ,km,jmt        ,3,nt+1) )
         theta=0; eddy_flux=0.
#endif
         do k=1,km
          print*,'k=',k,'/',km
#ifdef large_fluxfile
          do n=1,3  ! sum(u)
           read(io) buf ; mean_adv(:,k,:,n)= buf
          enddo
          do n=1,nt+1 ! sum(b)
           do m=1,3 
            read(io) buf ; mean_tracer(:,k,:,m,n)=buf
           enddo
          enddo
          do n=1,nt+1 ! sum(b^2)
           do m=1,3 
            read(io) buf ; var_tracer(:,k,:,m,n)=buf
           enddo
          enddo
          do n=1,nt+1  ! sum(ub)
           do m=1,3 
            read(io) buf ; mean_eddy_flux(:,k,:,m,n)=buf
           enddo
          enddo
          do n=1,nt+1  ! sum(ub^2)
           do m=1,3 
            read(io) buf ; mean_var_flux(:,k,:,m,n)=buf
           enddo
          enddo
#else
          do n=1,3  ! sum(u)
           read(io) buf ; mean_adv(:,k,:,n)= buf
          enddo
          do m=1,3*nt; read(io) ; enddo
          do m=1,3 
            read(io) buf ; mean_tracer(:,k,:,m,nt+1)=buf
          enddo
          do m=1,3*nt; read(io) ; enddo
          do m=1,3 
            read(io) buf ; var_tracer(:,k,:,m,nt+1)=buf
          enddo
          do m=1,3*nt; read(io) ; enddo
          do m=1,3 
            read(io) buf ; mean_eddy_flux(:,k,:,m,nt+1)=buf
          enddo
          do m=1,3*nt; read(io) ; enddo
          do m=1,3 
            read(io) buf ; mean_var_flux(:,k,:,m,nt+1)=buf
          enddo
#endif
         enddo

        elseif (name(1:6) == 'sshvar' ) then

         print*,' found variance of SSH'
         read(io) var_ssh
         enable_freesurf= .true.

        elseif (name(1:7) == 'sshmean' ) then

         print*,' found mean of SSH'
         read(io) mean_ssh
         enable_freesurf= .true.

        else  

         print*,' WARNING : cannot read variable ',name,' in file'
         print*,' skipping this variable ...'
         do n=1,nr
          read(io)
         enddo

        endif

       endif

      enddo
      close(io)

      end subroutine read_variances










      subroutine write_variances_eke(outfile,year,month,day,domain)
      use cv_var_module
      implicit none
      character (len=80) :: outfile,name,unit,varname,varlname
      integer :: year,month,day,domain
#include "netcdf.inc"
      integer ncid,iret,i,j,k,dims(4),start(4),count(4),m
      real (kind=r_knd) :: spval=-9.9e12, tt
      real (kind=r_knd) :: dx,dy,rhox,rhoy,ux,vy,uy,vx,rhodz
      real, parameter :: pi       = 
     &        3.14159265358979323846264338327950588
      real, parameter :: radius   = 6370.0e3
      real :: degtm   = radius/180*pi
      real (kind=r_knd) :: buf1(imt,jmt),buf2(imt,jmt),buf3(imt,jmt)
      real (kind=r_knd), allocatable :: mean_wt(:,:,:),mean_wu(:,:,:)
      real (kind=r_knd), allocatable :: eke(:,:,:),mke(:,:,:)
      real (kind=r_knd) :: dxt,dxu,dxum,dyt,dyu,dyum,cst,csu,cstp
      real (kind=r_knd) :: due,duw,dun,dus,dzt,dx1,dx2,dz

      integer :: lon_tdim,lon_tid
      integer :: lon_udim,lon_uid
      integer :: lat_tdim,lat_tid
      integer :: lat_udim,lat_uid
      integer :: depth_tdim,depth_tid
      integer :: depth_wdim,depth_wid
      integer :: itimedim,itimeid
      integer :: ekeid,mkeid,sshid,msshid,n,len
      integer :: t2id,t4id,T2xid,T2yid,t1id,t3id
      integer :: ubid(nt+1),vbid(nt+1),wbid(nt+1)
      integer :: ub2id(nt+1),vb2id(nt+1),wb2id(nt+1)
      integer :: ubbid(nt+1),vbbid(nt+1),wbbid(nt+1)
      integer :: tmid(nt+1),tvid(nt+1)
      integer :: 
     &days_in_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)

      tt=(year-1900)*365 + day
      do n=1,month-1
       tt=tt+days_in_month(n)
      enddo

      if (enable_monthly_variances) then
        tt=tt-days_in_month(month)/2.
      elseif (enable_seasonal_variances) then
        tt=tt-(days_in_month(month)    ! month should be always ge 3
     &        +days_in_month(month-1)
     &        +days_in_month(month-2))/2.
      endif

      print*,' writing to file ',outfile(1:len_trim(outfile))

      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c     dimensions
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', 1, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
      dims(1)  = Lon_udim
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_wdim
      depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c     attributes of the grid
      name = 'Longitude on T grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on U grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
      name = 'Depth of W Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
      call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &'31-DEC-1899 00:00:00', iret)
c     variables
      dims=(/lon_udim,lat_udim,depth_tdim,itimedim/)
      ekeid=ncvdef (ncid,'eke', NCFLOAT,4,dims,iret)
      mkeid=ncvdef (ncid,'mke', NCFLOAT,4,dims,iret)
      name = 'Eddy kinetic energy'; unit = 'm^/s^2'
      call dvcdf_here(ncid,ekeid,name,len_trim(name),unit,16,spval)
      name = 'Mean kinetic energy'; unit = 'm^2/s^2'
      call dvcdf_here(ncid,mkeid,name,len_trim(name),unit,16,spval)

      if (enable_freesurf) then
       dims=(/lon_tdim,lat_tdim,itimedim,1/)
       sshid=ncvdef (ncid,'ssh_rms', NCFLOAT,3,dims,iret)
       msshid=ncvdef (ncid,'ssh_mean', NCFLOAT,3,dims,iret)
c      attributes of variables
       name = 'Rms of Sea Surface height'; unit = 'm'
       call dvcdf_here(ncid,sshid,name,len_Trim(name),unit,16,spval)
       name = 'Mean Sea Surface height'; unit = 'm'
       call dvcdf_here(ncid,msshid,name,len_Trim(name),unit,16,spval)
      endif


      iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        if (iret.ne.0) print*,nf_strerror(iret)

      write( name,'("SFLAME sub domain # ",i3)') domain
      if (enable_monthly_variances) 
     &   name=name(1:len_trim(name))//' monthly means'
      if (enable_seasonal_variances) 
     &   name=name(1:len_trim(name))//' seasonal means'
      len=len_trim(name)
      iret= nf_put_att_text(ncid,nf_global,'history',len,name)

      call ncendf(ncid, iret)

      zt=zt/100.; zw=zw/100.

#ifdef real_8
      iret= nf_put_vara_double (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_double (ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_double (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_double (ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_double (ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_double (ncid,depth_wid,1,km,zw)
      iret= nf_put_vara_double (ncid,itimeid,1,1,tt)
#else
      iret= nf_put_vara_real (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_real (ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_real (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_real (ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_real (ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_real (ncid,depth_wid,1,km,zw)
      iret= nf_put_vara_real (ncid,itimeid,1,1,tt)
#endif

c     convert to SI units
      mean_u=mean_u/100.   
      var_u=var_u/100./100. 
      mean_ssh=mean_ssh/100.
      var_ssh=var_ssh/100./100.

c
c    get means and variances:
c     sum(T*) = sum(T^2) - N T_bar^2
c     N T_bar = sum(T_n)
c     1/N [sum(T_n)]^2 = N T_bar^2
c
      do n=1,2
       do j=1,jmt
        do k=1,km
         do i=1,imt
          var_u(i,k,j,n)= var_u(i,k,j,n)-mean_u(i,k,j,n)**2/counter 
          var_u(i,k,j,n)= var_u(i,k,j,n)/counter
          mean_u(i,k,j,n)= mean_u(i,k,j,n)/counter
         enddo
        enddo
       enddo
      enddo

c
c   store energy terms  in var_u and mean_u
c
      allocate(eke(imt,km,jmt) , mke(imt,km,jmt) )
      do j=1,jmt
       do k=1,km
        do i=1,imt
         eke(i,k,j)=(var_u(i,k,j,1)+var_u(i,k,j,2))/2.
         mke(i,k,j)=(mean_u(i,k,j,1)**2+mean_u(i,k,j,2)**2)/2.
        enddo
       enddo
      enddo

c
c   care about external mode
c
      do j=1,jmt
       do i=1,imt
        var_ssh(i,j)= var_ssh(i,j)-mean_ssh(i,j)**2/counter 
        var_ssh(i,j)= sqrt(var_ssh(i,j)/counter)
        mean_ssh(i,j)= mean_ssh(i,j)/counter
       enddo
      enddo

c     apply land mask and write to file
      do k=1,km
         where( kmu <k ) eke(:,k,:) = spval
         where( kmu <k ) mke(:,k,:) = spval
         start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
         iret=nf_put_vara_double(ncid,mkeid,start,count,mke(:,k,:))
         iret=nf_put_vara_double (ncid,ekeid,start,count,eke(:,k,:))
#else
         iret=nf_put_vara_real(ncid,mkeid,start,count,mke(:,k,:))
         iret=nf_put_vara_real(ncid,ekeid,start,count,eke(:,k,:))
#endif
      enddo


      if (enable_freesurf) then
       where( kmt == 0) mean_ssh = spval
       where( kmt == 0) var_ssh = spval
       start=(/1,1,1,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
       iret= nf_put_vara_double(ncid,sshid,start,count,var_ssh)
       iret= nf_put_vara_double(ncid,msshid,start,count,mean_ssh)
#else
       iret= nf_put_vara_real (ncid,sshid,start,count,var_ssh)
       iret= nf_put_vara_real (ncid,msshid,start,count,mean_ssh)
#endif
      endif
      call ncclos (ncid, iret)
      deallocate(eke,mke)
      end subroutine write_variances_eke




      subroutine write_variances_energy(outfile,year,month,day,domain)
      use cv_var_module
      implicit none
      character (len=80) :: outfile,name,unit,varname,varlname
      integer :: year,month,day,domain
#include "netcdf.inc"
      integer ncid,iret,i,j,k,dims(4),start(4),count(4),m
      real (kind=r_knd) :: spval=-9.9e12, tt
      real (kind=r_knd) :: dx,dy,rhox,rhoy,ux,vy,uy,vx,rhodz
      real, parameter :: pi       = 
     &        3.14159265358979323846264338327950588
      real, parameter :: radius   = 6370.0e3
      real :: degtm   = radius/180*pi
      real (kind=r_knd) :: buf1(imt,jmt),buf2(imt,jmt),buf3(imt,jmt)
      real (kind=r_knd), allocatable :: mean_wt(:,:,:),mean_wu(:,:,:)
      real (kind=r_knd) :: dxt,dxu,dxum,dyt,dyu,dyum,cst,csu,cstp
      real (kind=r_knd) :: due,duw,dun,dus,dzt,dx1,dx2,dz

      integer :: lon_tdim,lon_tid
      integer :: lon_udim,lon_uid
      integer :: lat_tdim,lat_tid
      integer :: lat_udim,lat_uid
      integer :: depth_tdim,depth_tid
      integer :: depth_wdim,depth_wid
      integer :: itimedim,itimeid
      integer :: ekeid,mkeid,sshid,msshid,n,len
      integer :: t2id,t4id,T2xid,T2yid,t1id,t3id
      integer :: ubid(nt+1),vbid(nt+1),wbid(nt+1)
      integer :: ub2id(nt+1),vb2id(nt+1),wb2id(nt+1)
      integer :: ubbid(nt+1),vbbid(nt+1),wbbid(nt+1)
      integer :: tmid(nt+1),tvid(nt+1)
      integer :: 
     &days_in_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)

      tt=(year-1900)*365 + day
      do n=1,month-1
       tt=tt+days_in_month(n)
      enddo

      if (enable_monthly_variances) then
        tt=tt-days_in_month(month)/2.
      elseif (enable_seasonal_variances) then
        tt=tt-(days_in_month(month)    ! month should be always ge 3
     &        +days_in_month(month-1)
     &        +days_in_month(month-2))/2.
      endif

      print*,' writing to file ',outfile(1:len_trim(outfile))

      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c     dimensions
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', 1, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
      dims(1)  = Lon_udim
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_wdim
      depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c     attributes of the grid
      name = 'Longitude on T grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on U grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
      name = 'Depth of W Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
      call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &'31-DEC-1899 00:00:00', iret)
c     variables


       dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
       t2id=ncvdef (ncid,'T2', NCFLOAT,4,dims,iret)
       name = 'Baroclinic conversion rate'; unit = '(kg/m^3)^2/s'
       call dvcdf_here(ncid,T2id,name,len_Trim(name),unit,16,spval)

       dims=(/lon_udim,lat_udim,depth_tdim,itimedim/)
       T4id=ncvdef (ncid,'T4', NCFLOAT,4,dims,iret)
       name = 'Barotropic conversion rate'; unit = '(m/s)^2/s'
       call dvcdf_here(ncid,T4id,name,len_Trim(name),unit,16,spval)

       dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
       t2xid=ncvdef (ncid,'T2x', NCFLOAT,4,dims,iret)
       name = 'Zonal baroclinic conversion rate'; unit = '(kg/m^3)^2/s'
       call dvcdf_here(ncid,T2xid,name,len_Trim(name),unit,16,spval)

      if (energy_ext) then
       dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
       T3id=ncvdef (ncid,'T3', NCFLOAT,4,dims,iret)
       name = 'T3'; unit = ' '
       call dvcdf_here(ncid,T3id,name,len_Trim(name),unit,16,spval)
       dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
       T1id=ncvdef (ncid,'T1', NCFLOAT,4,dims,iret)
       name = 'T1'; unit = ' '
       call dvcdf_here(ncid,T1id,name,len_Trim(name),unit,16,spval)
      endif

      iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        if (iret.ne.0) print*,nf_strerror(iret)

      write( name,'("SFLAME sub domain # ",i3)') domain
      if (enable_monthly_variances) 
     &   name=name(1:len_trim(name))//' monthly means'
      if (enable_seasonal_variances) 
     &   name=name(1:len_trim(name))//' seasonal means'
      len=len_trim(name)
      iret= nf_put_att_text(ncid,nf_global,'history',len,name)

      call ncendf(ncid, iret)

#ifdef real_8
      iret= nf_put_vara_double (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_double (ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_double (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_double (ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_double (ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_double (ncid,depth_wid,1,km,zw)
      iret= nf_put_vara_double (ncid,itimeid,1,1,tt)
#else
      iret= nf_put_vara_real (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_real (ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_real (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_real (ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_real (ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_real (ncid,depth_wid,1,km,zw)
      iret= nf_put_vara_real (ncid,itimeid,1,1,tt)
#endif


c     convert to SI units

       urho=urho/100.0 * 1000.0
       uv = uv/100.0/100.0
       rhom = rhom *1000.0

      if (energy_ext) then
        wrho=wrho/100.0*1000.0
        pressm=pressm /100.0 /100.0 *1000.0
        upress=upress/100.0 /100.0/100.0 *1000.0
      endif

c    get means and variances:
c     sum(T*) = sum(T^2) - N T_bar^2
c     N T_bar = sum(T_n)
c     1/N [sum(T_n)]^2 = N T_bar^2
c

       do j=1,jmt
        do k=1,km
         do i=1,imt
           rhom(i,k,j)=rhom(i,k,j)/counter
           urho(i,k,j,1)= urho(i,k,j,1) /counter
     &                  - rhom(i,k,j)*mean_u(i,k,j,1)
           urho(i,k,j,2)= urho(i,k,j,2) /counter
     &                  - rhom(i,k,j)*mean_u(i,k,j,2)
           uv(i,k,j)= uv(i,k,j) /counter
     &                  - mean_u(i,k,j,1)*mean_u(i,k,j,2)
         enddo
        enddo
       enddo

      if (energy_ext) then
c   
c    get T1 and T3
c    first calculate mean vertical velocity
       allocate(mean_wu(imt,km,jmt) ,mean_wt(imt,km,jmt) )
       mean_wu=0.; mean_wt=0.
c
c    vertical velocity on T grid
       do k=1,km
        buf1=0.0;buf2=0.0
        do j=2,jmt-1
          do i=2,imt-1
            dxt = (xu(i)-xu(i-1))*degtm
            dxu = (xt(i+1)-xt(i))*degtm
            dxum = (xt(i)-xt(i-1))*degtm
            dyt = (yu(j)-yu(j-1))*degtm
            dyu = (yt(j+1)-yt(j))*degtm
            dyum = (yt(j)-yt(j-1))*degtm
            csu  = cos( yu(j)/180*pi )
            buf1(i,j) = 0.5*(mean_u(i,k,j,1)*dyu +    ! adv_vet
     &                        mean_u(i,k,j-1,1)*dyum)/dyt
            buf2(i,j) = 0.5*(mean_u(i,k,j,2)*dxu +    ! adv_vnt
     &                        mean_u(i-1,k,j,2)*dxum)*csu/dxt
          enddo
        enddo
        do j=2,jmt
          do i=2,imt
            dxt = (xu(i)-xu(i-1))*degtm
            dyt = (yu(j)-yu(j-1))*degtm
            dzt  = (zw(k)- zw(k-1))
            cst  = cos(yt(j)/180*pi)
            mean_wt(i,k,j) =
     &                   ((buf1(i,j) - buf1(i-1,j))/dxt
     &                   +(buf2(i,j) - buf2(i,j-1))/dyt
     &                   )/cst*dzt
          enddo
        enddo
       end do

       do j=1,jmt
        do k=2,km ! mean_wt(:,0,:)=0.0
          do i=1,imt
            mean_wt(i,k,j) = mean_wt(i,k,j) + mean_wt(i,k-1,j)
          enddo
        enddo
       end do

c    and vertical velocity on the u grid
       do j=2,jmt-1
        do k=1,km
          do i=2,imt-1
            duw = (xu(i)   - xt(i))*degtm
	    due = (xt(i+1) - xu(i))*degtm
	    dun = (yt(j+1) - yu(j))*degtm
            dus = (yu(j)   - yt(j))*degtm
            dxu = (xt(i+1)-xt(i))*degtm
            dyu = (yt(j+1)-yt(j))*degtm
            csu = cos( yu(j)/180*pi )
            cst  = cos( yt(j)/180*pi )
            cstp = cos( yt(j+1)/180*pi )
	    mean_wu(i,k,j) = 1./dyu/csu/dxu*(
     &                    mean_wt(i,k,j)*duw*dus*cst
     &                  + mean_wt(i+1,k,j)*due*dus*cst
     &                  + mean_wt(i,k,j+1)*duw*dun*cstp
     &                  + mean_wt(i+1,k,j+1)*due*dun*cstp )
          enddo
        enddo
       enddo

c    now get means and variances of averaged quantities
c    store T3 in wrho and T1 in pressm

       do j=1,jmt
        do k=1,km
         do i=1,imt
           pressm(i,k,j)=pressm(i,k,j)/counter
           wrho(i,k,j)= wrho(i,k,j) /counter
     &                  - rhom(i,k,j)*mean_wt(i,k,j)
           upress(i,k,j,1)= upress(i,k,j,1) /counter
     &                  - pressm(i,k,j)*mean_u(i,k,j,1)
           upress(i,k,j,2)= upress(i,k,j,2) /counter
     &                  - pressm(i,k,j)*mean_u(i,k,j,2)
           upress(i,k,j,3)= upress(i,k,j,3) /counter
     &                  - pressm(i,k,j)*mean_wu(i,k,j)
           pressm(i,k,j)=rhom(i,k,j)*mean_wt(i,k,j)
         enddo
        enddo
       enddo

       deallocate( mean_wt, mean_wu)
      endif ! energy_ext


c
c    get T2 = u_prime rho_prime (rho_bar)_x and v_prime rho_prime (rho_bar)_y 
c    store T2 in rhom
c
       do j=1,jmt-1
        do k=1,km
         do i=1,imt-1
          dx=(xt(i+1)-xt(i))*cos(yt(j)/180*pi)*degtm
          rhox = (rhom(i+1,k,j) - rhom(i,k,j))/dx
          urho(i,k,j,1)= urho(i,k,j,1) *rhox
          dy=(yt(j+1)-yt(j))*degtm
          rhoy = (rhom(i,k,j+1) - rhom(i,k,j))/dy
          urho(i,k,j,2)= urho(i,k,j,2) *rhoy
         enddo
        enddo
       enddo
       rhom=0.0 ! here we are loosing rho_bar, it becomes T2
       do k=1,km
        buf1=urho(:,k,:,1)
        buf2=urho(:,k,:,2)
        urho(:,k,:,1:2)=0.0
        do j=2,jmt-1
         do i=2,imt-1
           urho(i,k,j,1)=(buf1(i,j)+buf1(i-1,j) )/2.0
           urho(i,k,j,2)=(buf2(i,j)+buf2(i-1,j) )/2.0
           rhom(i,k,j)= urho(i,k,j,1)+urho(i-1,k,j,2) 
         enddo
        enddo
       enddo
c
c    get T4 = 
c    u_prime^2 (u_bar)_x + v_prime^2 (v_bar)_y + 
c    u_prime v_prime ( (u_bar)_y + (v_bar)x )
c     store T4 in uv and first part of T4 in urho(:,:,:,1)
c
       do k=1,km
        buf1=0.0;buf2=0.0;
        buf3=uv(:,k,:);uv(:,k,:)=0.0
        do j=2,jmt-1
         do i=2,imt-1
          dx=(xu(i+1)-xu(i))*cos(yu(j)/180*pi)*degtm
          ux = (mean_u(i+1,k,j,1) - mean_u(i,k,j,1))/dx
          dx=(xu(i)-xu(i-1))*cos(yu(j)/180*pi)*degtm
          ux = (ux + (mean_u(i,k,j,1) - mean_u(i-1,k,j,1))/dx )/2.0

          buf1(i,j)= var_u(i,k,j,1)*ux

          dy=(yu(j+1)-yu(j))*degtm
          vy = (mean_u(i,k,j+1,2) - mean_u(i,k,j,2))/dy
          dy=(yu(j)-yu(j-1))*degtm
          vy = (vy + (mean_u(i,k,j,2) - mean_u(i,k,j-1,2))/dy )/2.0

          buf2(i,j)= var_u(i,k,j,2)*vy

          dx=(xu(i+1)-xu(i))*cos(yu(j)/180*pi)*degtm
          vx = (mean_u(i+1,k,j,2) - mean_u(i,k,j,2))/dx
          dx=(xu(i)-xu(i-1))*cos(yu(j)/180*pi)*degtm
          vx = (vx + (mean_u(i,k,j,2) - mean_u(i-1,k,j,2))/dx )/2.0

          dy=(yu(j+1)-yu(j))*degtm
          uy = (mean_u(i,k,j+1,1) - mean_u(i,k,j,1))/dy
          dy=(yu(j)-yu(j-1))*degtm
          uy = (uy + (mean_u(i,k,j,1) - mean_u(i,k,j-1,1))/dy )/2.0

          uv(i,k,j)=  buf1(i,j) + buf2(i,j) +buf3(i,j)*(vx+uy)

         enddo
        enddo
       enddo



       do k=1,km
         where( kmu <k ) uv(:,k,:) = spval
         where( kmt <k ) rhom(:,k,:) = spval
         where( kmt <k ) urho(:,k,:,1) = spval
         start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
         iret=nf_put_vara_double(ncid,T4id,start,count,uv(:,k,:))
         iret=nf_put_vara_double(ncid,T2id,start,count,rhom(:,k,:))
         iret=nf_put_vara_double(ncid,T2xid,start,count,urho(:,k,:,1))
#else
         iret=nf_put_vara_real(ncid,T4id,start,count,uv(:,k,:))
         iret=nf_put_vara_real(ncid,T2id,start,count,rhom(:,k,:))
         iret=nf_put_vara_real(ncid,T2xid,start,count,urho(:,k,:,1))
#endif
       enddo

      if (energy_ext) then
       do k=1,km
         where( kmt <k ) wrho(:,k,:) = spval
         where( kmt <k ) pressm(:,k,:) = spval
         start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
         iret=nf_put_vara_double(ncid,T1id,start,count,pressm(:,k,:))
         iret=nf_put_vara_double(ncid,T3id,start,count,wrho(:,k,:))
#else
         iret=nf_put_vara_real(ncid,T1id,start,count,pressm(:,k,:))
         iret=nf_put_vara_real(ncid,T3id,start,count,wrho(:,k,:))
#endif
       enddo
      endif


      call ncclos (ncid, iret)
      end subroutine write_variances_energy



      subroutine write_variances_fluxes(outfile,year,month,day,domain)
      use cv_var_module
      implicit none
      character (len=80) :: outfile,name,unit,varname,varlname
      integer :: year,month,day,domain
#include "netcdf.inc"
      integer ncid,iret,i,j,k,dims(4),start(4),count(4),m
      real (kind=r_knd) :: spval=-9.9e12, tt
      real (kind=r_knd) :: dx,dy,rhox,rhoy,ux,vy,uy,vx,rhodz
      real, parameter :: pi       = 
     &        3.14159265358979323846264338327950588
      real, parameter :: radius   = 6370.0e3
      real :: degtm   = radius/180*pi
      real (kind=r_knd) :: buf1(imt,jmt),buf2(imt,jmt),buf3(imt,jmt)
      real (kind=r_knd), allocatable :: mean_wt(:,:,:),mean_wu(:,:,:)
      real (kind=r_knd) :: dxt,dxu,dxum,dyt,dyu,dyum,cst,csu,cstp
      real (kind=r_knd) :: due,duw,dun,dus,dzt,dx1,dx2,dz

      integer :: lon_tdim,lon_tid
      integer :: lon_udim,lon_uid
      integer :: lat_tdim,lat_tid
      integer :: lat_udim,lat_uid
      integer :: depth_tdim,depth_tid
      integer :: depth_wdim,depth_wid
      integer :: itimedim,itimeid
      integer :: ekeid,mkeid,sshid,msshid,n,len
      integer :: t2id,t4id,T2xid,T2yid,t1id,t3id
      integer :: ubid(nt+1),vbid(nt+1),wbid(nt+1)
      integer :: ub2id(nt+1),vb2id(nt+1),wb2id(nt+1)
      integer :: ubbid(nt+1),vbbid(nt+1),wbbid(nt+1)
      integer :: tmid(nt+1),tvid(nt+1)
      integer :: 
     &days_in_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)

      tt=(year-1900)*365 + day
      do n=1,month-1
       tt=tt+days_in_month(n)
      enddo

      if (enable_monthly_variances) then
        tt=tt-days_in_month(month)/2.
      elseif (enable_seasonal_variances) then
        tt=tt-(days_in_month(month)    ! month should be always ge 3
     &        +days_in_month(month-1)
     &        +days_in_month(month-2))/2.
      endif

      print*,' writing to file ',outfile(1:len_trim(outfile))

      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c     dimensions
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', 1, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
      dims(1)  = Lon_udim
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_wdim
      depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c     attributes of the grid
      name = 'Longitude on T grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on U grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
      name = 'Depth of W Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
      call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &'31-DEC-1899 00:00:00', iret)

#ifdef large_fluxfile
       do n=1,nt+1
#else
       do n=nt+1,nt+1
#endif
        if (n==1) then
         varname='T'        
         varlname = 'temperature'
         unit = 'mK/s'
        elseif (n==2) then
         varname='S'        
         varlname = 'salinity'
         unit = 'm/s'
        elseif (n==nt+1) then
         varname='sig0'        
         varlname = 'pot. density'
         unit = 'kg/m^2/s'
        else
         write(varname,'("tr_",i2)') n
         call replace_space_zero(varname)
         write(varlname,'("tracer ",i2)') n
         unit = 'm/s '
        endif

#ifdef define_in_fluxfile_eddyflux
        dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
        tmid(n)=ncvdef (ncid,'mean_'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name = 'Mean '//varlname(1:len_trim(varlname)); 
        call dvcdf_here(ncid,tmid(n),name,len_Trim(name),unit,16,spval)

        dims=(/lon_udim,lat_tdim,depth_tdim,itimedim/)
        ubid(n)=ncvdef (ncid,'u'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name = 'Zonal eddy flux of '//varlname(1:len_trim(varlname)); 
        call dvcdf_here(ncid,ubid(n),name,len_Trim(name),unit,16,spval)

        dims=(/lon_tdim,lat_udim,depth_tdim,itimedim/)
        vbid(n)=ncvdef (ncid,'v'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name='Meridional eddy flux of '//varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,vbid(n),name,len_Trim(name),unit,16,spval)

        dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
        wbid(n)=ncvdef (ncid,'w'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name='Vertical eddy flux of '//varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,wbid(n),name,len_Trim(name),unit,16,spval)
#endif

#ifdef define_in_fluxfile_varianceflux
        dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
        tvid(n)=ncvdef (ncid,'var_'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name = 'Variance of '//varlname(1:len_trim(varlname)); 
        call dvcdf_here(ncid,tvid(n),name,len_Trim(name),unit,16,spval)

        dims=(/lon_udim,lat_tdim,depth_tdim,itimedim/)
        ubbid(n)=ncvdef (ncid,'u'//varname(1:len_trim(varname))//'2'
     &                 , NCFLOAT,4,dims,iret)
        name = 'Zonal variance flux of '//varlname(1:len_trim(varlname)); 
        call dvcdf_here(ncid,ubbid(n),name,len_Trim(name),unit,16,spval)

        dims=(/lon_tdim,lat_udim,depth_tdim,itimedim/)
        vbbid(n)=ncvdef (ncid,'v'//varname(1:len_trim(varname))//'2'
     &                 , NCFLOAT,4,dims,iret)
        name='Meridional variance flux of '//
     &                     varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,vbbid(n),name,len_Trim(name),unit,16,spval)

        dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
        wbbid(n)=ncvdef (ncid,'w'//varname(1:len_trim(varname))//'2'
     &                 , NCFLOAT,4,dims,iret)
        name='Vertical variance flux of '//
     &                    varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,wbbid(n),name,len_Trim(name),unit,16,spval)
#endif

#ifdef large_fluxfile

        ub2id(n)=ncvdef (ncid,'u2'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name = 'Zonal eddy flux 2 of '//varlname(1:len_trim(varlname)); 
        call dvcdf_here(ncid,ub2id(n),name,len_Trim(name),unit,16,spval)

        vb2id(n)=ncvdef (ncid,'v2'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name='Meridional eddy flux 2 of '//
     &           varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,vb2id(n),name,len_Trim(name),unit,16,spval)

        wb2id(n)=ncvdef (ncid,'w2'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name='Vertical eddy flux 2 of '//varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,wb2id(n),name,len_Trim(name),unit,16,spval)
#endif

       enddo

      iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        if (iret.ne.0) print*,nf_strerror(iret)

      write( name,'("SFLAME sub domain # ",i3)') domain
      if (enable_monthly_variances) 
     &   name=name(1:len_trim(name))//' monthly means'
      if (enable_seasonal_variances) 
     &   name=name(1:len_trim(name))//' seasonal means'
      len=len_trim(name)
      iret= nf_put_att_text(ncid,nf_global,'history',len,name)

      call ncendf(ncid, iret)

#ifdef real_8
      iret= nf_put_vara_double (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_double (ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_double (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_double (ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_double (ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_double (ncid,depth_wid,1,km,zw)
      iret= nf_put_vara_double (ncid,itimeid,1,1,tt)
#else
      iret= nf_put_vara_real (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_real (ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_real (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_real (ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_real (ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_real (ncid,depth_wid,1,km,zw)
      iret= nf_put_vara_real (ncid,itimeid,1,1,tt)
#endif


         mean_adv=mean_adv/100;  
         mean_eddy_flux=mean_eddy_flux/100; 
         mean_var_flux = mean_var_flux/100;
c
c    get means and variances:
c     sum(T*) = sum(T^2) - N T_bar^2
c     N T_bar = sum(T_n)
c     1/N [sum(T_n)]^2 = N T_bar^2
c

c
c    get the mean quantities and fluxes
c
c sum(u_prime b_prime)/N = sum(ub)/N - u_bar b_bar
c  u_bar sum(b_prime^2)/N + sum( u_prime b_prime^2)/N = 
c       sum(ub^2)/N - u_bar b_bar^2 - 2 b_bar sum(u_prime b_prime)/N
        mean_adv=mean_adv/counter
        mean_tracer=mean_tracer/counter
c        var_tracer=var_tracer/counter
c     sum(T*) = sum(T^2) - N T_bar^2
c     N T_bar = sum(T_n)
c     1/N [sum(T_n)]^2 = N T_bar^2
#ifdef large_fluxfile
        do n=1,nt+1
#else
        do n=nt+1,nt+1
#endif
        do m=1,3
        do j=1,jmt
         do k=1,km
          do i=1,imt
          var_tracer(i,k,j,m,n)= (var_tracer(i,k,j,m,n)-
     &               mean_tracer(i,k,j,m,n)**2*counter )/counter
           mean_eddy_flux(i,k,j,m,n) = mean_eddy_flux(i,k,j,m,n)/counter 
     &           - mean_adv(i,k,j,m)*mean_tracer(i,k,j,m,n)
           mean_var_flux(i,k,j,m,n) = mean_var_flux(i,k,j,m,n)/counter 
     &           - mean_adv(i,k,j,m)*mean_tracer(i,k,j,m,n)**2
     &           - 2*mean_tracer(i,k,j,m,n)*mean_eddy_flux(i,k,j,m,n)
          enddo
         enddo
        enddo
        enddo
        enddo

#ifdef large_fluxfile
c
c     now compute the gauge vector potential for the eddy fluxes
c
        do n=1,nt+1

         do j=1,jmt-1
          do k=1,km-1
           do i=2,imt
c
c     theta_1 = (G_2 b_z - G_3 b_y) /( b_x^2+b_y^2+b_z^2)
c     with G= bar( u phi_prime )
c      is on grid:  T grid in x,  U grid in y, W Grid in z
c
            dx1=(xu(i)-xu(i-1))*cos(yt(j)/180*pi)*degtm
            dx2=(xu(i)-xu(i-1))*cos(yt(j+1)/180*pi)*degtm
            dy=(yt(j+1)-yt(j))*degtm
            dz  = zt(k+1)- zt(k)
            rhodz= 0.25*(
     &        ((mean_tracer(i,k,j,1,n)-mean_tracer(i-1,k,j,1,n))/dx1)**2
     &   +((mean_tracer(i,k,j+1,1,n)-mean_tracer(i-1,k,j+1,1,n))/dx2)**2
     &  +((mean_tracer(i,k+1,j,1,n)-mean_tracer(i-1,k+1,j,1,n))/dx1)**2+
     &((mean_tracer(i,k+1,j+1,1,n)-mean_tracer(i-1,k+1,j+1,1,n))/dx2)**2
     &            )
     &       +((mean_tracer(i,k,j,2,n)-mean_tracer(i,k+1,j,2,n))/dz)**2
     &       +((mean_tracer(i,k,j+1,3,n)-mean_tracer(i,k,j,3,n))/dy)**2
            if (rhodz==0.0) rhodz=1e-10
            theta(i,k,j,1,n)= (
     &       0.5*(mean_var_flux(i,k,j,2,n)+mean_var_flux(i,k+1,j,2,n))
     &       *(mean_tracer(i,k,j,2,n)-mean_tracer(i,k+1,j,2,n))/dz
     &      -0.5*(mean_var_flux(i,k,j,3,n)+mean_var_flux(i,k,j+1,3,n))
     &       *(mean_tracer(i,k,j+1,3,n)-mean_tracer(i,k,j,3,n))/dy )
     &        /rhodz
           enddo
          enddo
         enddo

         do j=2,jmt
          do k=1,km-1
           do i=1,imt-1
c
c     theta_2 = (G_3 b_x - G_1 b_z) /( b_x^2+b_y^2+b_z^2)
c      is on grid:  U grid in x,  T grid in y, W Grid in z
c
            dx=(xt(i+1)-xt(i))*cos(yt(j)/180*pi)*degtm
            dz=zt(k+1)-zt(k)
            dy = (yu(j)-yu(j-1))*degtm
            rhodz=
     &        ((mean_tracer(i+1,k,j,3,n)-mean_tracer(i,k,j,1,n))/dx)**2
     &       +((mean_tracer(i,k,j,1,n)-mean_tracer(i,k+1,j,1,n))/dz)**2
     &       +0.25*(
     &       +((mean_tracer(i,k,j,2,n)-mean_tracer(i,k,j-1,2,n))/dy)**2
     &   +((mean_tracer(i+1,k,j,2,n)-mean_tracer(i+1,k,j-1,2,n))/dy)**2
     & +((mean_tracer(i,k+1,j,2,n)-mean_tracer(i,k+1,j-1,2,n))/dy)**2+
     &((mean_tracer(i+1,k+1,j,2,n)-mean_tracer(i+1,k+1,j-1,2,n))/dy)**2
     &            )
            if (rhodz==0.0) rhodz=1e-10
            theta(i,k,j,2,n)= (
     &       0.5*(mean_var_flux(i,k,j,3,n)+mean_var_flux(i+1,k,j,3,n))
     &       *(mean_tracer(i+1,k,j,3,n)-mean_tracer(i,k,j,3,n))/dx
     &      -0.5*(mean_var_flux(i,k,j,1,n)+mean_var_flux(i,k+1,j,1,n))
     &       *(mean_tracer(i,k,j,1,n)-mean_tracer(i,k+1,j,1,n))/dz )
     &        /rhodz
           enddo
          enddo
         enddo

         do j=1,jmt-1
          do k=2,km
           do i=1,imt-1
c
c     theta_3 = (G_1 b_y - G_2 b_x) /( b_x^2+b_y^2+b_z^2)
c      is on grid:  U grid in x,  U grid in y, T Grid in z
c
            dy = (yt(j+1)-yt(j))*degtm
            dx = (xt(i+1)-xt(i))*cos(yu(j)/180*pi)*degtm
            dz = zw(k)-zw(k-1)
            rhodz=
     &        ((mean_tracer(i+1,k,j,2,n)-mean_tracer(i,k,j,2,n))/dx)**2
     &       +((mean_tracer(i,k,j+1,1,n)-mean_tracer(i,k,j,1,n))/dy)**2
     &       +0.25*(
     &       +((mean_tracer(i,k-1,j,3,n)-mean_tracer(i,k,j,3,n))/dz)**2
     &   +((mean_tracer(i,k-1,j+1,3,n)-mean_tracer(i,k,j+1,3,n))/dz)**2
     &   +((mean_tracer(i+1,k-1,j,3,n)-mean_tracer(i+1,k,j,3,n))/dz)**2
     &+((mean_tracer(i+1,k-1,j+1,3,n)-mean_tracer(i+1,k,j+1,3,n))/dz)**2
     &            )
            if (rhodz==0.0) rhodz=1e-10
            theta(i,k,j,3,n)= (
     &       0.5*(mean_var_flux(i,k,j,1,n)+mean_var_flux(i,k,j+1,1,n))
     &       *(mean_tracer(i,k,j+1,1,n)-mean_tracer(i,k,j,1,n))/dy
     &      -0.5*(mean_var_flux(i+1,k,j,2,n)+mean_var_flux(i,k,j,2,n))
     &       *(mean_tracer(i+1,k,j,2,n)-mean_tracer(i,k,j,2,n))/dx )
     &        /rhodz
           enddo
          enddo
         enddo

c  now remove the vector potential flux from the eddy fluxes

         do j=2,jmt
          do k=2,km
           do i=2,imt
c        F_1 = u_prime b_prime - (theta_2)_z + (theta_3)_y
            dy = (yu(j)-yu(j-1))*degtm
            dz = zw(k)-zw(k-1)
            eddy_flux(i,k,j,1,n)=mean_eddy_flux(i,k,j,1,n)
     &         -(theta(i,k-1,j,2,n)-theta(i,k,j,2,n) )/dz
     &         +(theta(i,k,j,3,n)-theta(i,k,j-1,3,n) )/dy
c        F_2 = v_prime b_prime - (theta_1)_z + (theta_3)_x
            dx = (xu(i)-xu(i-1))*cos(yu(j)/180*pi)*degtm
            dz = zw(k)-zw(k-1)
            eddy_flux(i,k,j,2,n)=mean_eddy_flux(i,k,j,2,n)
     &         -(theta(i,k-1,j,1,n)-theta(i,k,j,1,n) )/dz
     &         +(theta(i,k,j,3,n)-theta(i-1,k,j,3,n) )/dx
c        F_3 = w_prime b_prime - (theta_2)_x + (theta_1)_y
            dy = (yu(j)-yu(j-1))*degtm
            dx = (xu(i)-xu(i-1))*cos(yt(j)/180*pi)*degtm
            eddy_flux(i,k,j,3,n)=mean_eddy_flux(i,k,j,3,n)
     &         -(theta(i,k,j,2,n)-theta(i-1,k,j,2,n) )/dx
     &         +(theta(i,k,j,1,n)-theta(i,k,j-1,1,n) )/dy
           enddo
          enddo
         enddo


        enddo

#endif



       do k=1,km
#ifdef large_fluxfile
         do n=1,nt+1
#else
         do n=nt+1,nt+1
#endif
          do m=1,3
           where( kmt <k ) mean_adv(:,k,:,m) = spval
           where( kmt <k ) mean_tracer(:,k,:,m,n) = spval
           where( kmt <k ) var_tracer(:,k,:,m,n) = spval
           where( kmt <k ) mean_eddy_flux(:,k,:,m,n) = spval
#ifdef large_fluxfile
           where( kmt <k ) eddy_flux(:,k,:,m,n) = spval
#endif
           where( kmt <k ) mean_var_flux(:,k,:,m,n) = spval
          enddo
         enddo

         start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef large_fluxfile
         do n=1,nt+1
#else
         do n=nt+1,nt+1
#endif
#ifdef real_8
          iret=nf_put_vara_double(ncid,tmid(n),start,count,
     &           mean_tracer(:,k,:,1,n))
          iret=nf_put_vara_double(ncid,tvid(n),start,count,
     &           var_tracer(:,k,:,1,n))
          iret=nf_put_vara_double(ncid,ubid(n),start,count,
     &           mean_eddy_flux(:,k,:,1,n))
          iret=nf_put_vara_double(ncid,vbid(n),start,count,
     &           mean_eddy_flux(:,k,:,2,n))
          iret=nf_put_vara_double(ncid,ubbid(n),start,count,
     &           mean_var_flux(:,k,:,1,n))
          iret=nf_put_vara_double(ncid,vbbid(n),start,count,
     &           mean_var_flux(:,k,:,2,n))
          iret=nf_put_vara_double(ncid,wbid(n),start,count,
     &           mean_eddy_flux(:,k,:,3,n))
          iret=nf_put_vara_double(ncid,wbbid(n),start,count,
     &           mean_var_flux(:,k,:,3,n))
#ifdef large_fluxfile
          iret=nf_put_vara_double(ncid,ub2id(n),start,count,
     &           eddy_flux(:,k,:,1,n))
          iret=nf_put_vara_double(ncid,vb2id(n),start,count,
     &           eddy_flux(:,k,:,2,n))
          iret=nf_put_vara_double(ncid,wb2id(n),start,count,
     &           eddy_flux(:,k,:,3,n))
#endif
#else
          iret=nf_put_vara_real(ncid,tmid(n),start,count,
     &           mean_tracer(:,k,:,1,n))
          iret=nf_put_vara_real(ncid,tvid(n),start,count,
     &           var_tracer(:,k,:,1,n))
          iret=nf_put_vara_real(ncid,ubid(n),start,count,
     &           mean_eddy_flux(:,k,:,1,n))
          iret=nf_put_vara_real(ncid,vbid(n),start,count,
     &           mean_eddy_flux(:,k,:,2,n))
          iret=nf_put_vara_real(ncid,ubbid(n),start,count,
     &           mean_var_flux(:,k,:,1,n))
          iret=nf_put_vara_real(ncid,vbbid(n),start,count,
     &           mean_var_flux(:,k,:,2,n))
          iret=nf_put_vara_real(ncid,wbid(n),start,count,
     &           mean_eddy_flux(:,k,:,3,n))
          iret=nf_put_vara_real(ncid,wbbid(n),start,count,
     &           mean_var_flux(:,k,:,3,n))
#ifdef large_fluxfile
          iret=nf_put_vara_real(ncid,ub2id(n),start,count,
     &           eddy_flux(:,k,:,1,n))
          iret=nf_put_vara_real(ncid,vb2id(n),start,count,
     &           eddy_flux(:,k,:,2,n))
          iret=nf_put_vara_real(ncid,wb2id(n),start,count,
     &           eddy_flux(:,k,:,3,n))
#endif
#endif
         enddo
       enddo

      call ncclos (ncid, iret)
      end subroutine write_variances_fluxes



      subroutine dvcdf_here(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      use kind_mod
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character*(*) name, unit
      real (kind=r_knd):: spval
#include "netcdf.inc"
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
#ifdef real_8
      iret=nf_put_att_double(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_double(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#else
      iret=nf_put_att_real(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_real(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#endif
c        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf_here


      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s; stop
      end

#ifdef notdef
      subroutine write_variances(outfile,year,month,day,domain)
      use cv_var_module
      implicit none
      character (len=80) :: outfile,name,unit,varname,varlname
      integer :: year,month,day,domain
#include "netcdf.inc"
      integer ncid,iret,i,j,k,dims(4),start(4),count(4),m
      real (kind=r_knd) :: spval=-9.9e12, tt
      real (kind=r_knd) :: dx,dy,rhox,rhoy,ux,vy,uy,vx,rhodz
      real, parameter :: pi       = 
     &        3.14159265358979323846264338327950588
      real, parameter :: radius   = 6370.0e3
      real :: degtm   = radius/180*pi
      real (kind=r_knd) :: buf1(imt,jmt),buf2(imt,jmt),buf3(imt,jmt)
      real (kind=r_knd), allocatable :: mean_wt(:,:,:),mean_wu(:,:,:)
      real (kind=r_knd) :: dxt,dxu,dxum,dyt,dyu,dyum,cst,csu,cstp
      real (kind=r_knd) :: due,duw,dun,dus,dzt,dx1,dx2,dz

      integer :: lon_tdim,lon_tid
      integer :: lon_udim,lon_uid
      integer :: lat_tdim,lat_tid
      integer :: lat_udim,lat_uid
      integer :: depth_tdim,depth_tid
      integer :: depth_wdim,depth_wid
      integer :: itimedim,itimeid
      integer :: ekeid,mkeid,sshid,msshid,n,len
      integer :: t2id,t4id,T2xid,T2yid,t1id,t3id
      integer :: ubid(nt+1),vbid(nt+1),wbid(nt+1)
      integer :: ub2id(nt+1),vb2id(nt+1),wb2id(nt+1)
      integer :: ubbid(nt+1),vbbid(nt+1),wbbid(nt+1)
      integer :: tmid(nt+1),tvid(nt+1)
      integer :: 
     &days_in_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)

      tt=(year-1900)*365 + day
      do n=1,month-1
       tt=tt+days_in_month(n)
      enddo

      if (enable_monthly_variances) then
        tt=tt-days_in_month(month)/2.
      elseif (enable_seasonal_variances) then
        tt=tt-(days_in_month(month)    ! month should be always ge 3
     &        +days_in_month(month-1)
     &        +days_in_month(month-2))/2.
      endif

      print*,' writing to file ',outfile(1:len_trim(outfile))

      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c     dimensions
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', 1, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
      dims(1)  = Lon_udim
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_wdim
      depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c     attributes of the grid
      name = 'Longitude on T grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on U grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
      name = 'Depth of W Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
      call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &'31-DEC-1899 00:00:00', iret)
c     variables
      dims=(/lon_udim,lat_udim,depth_tdim,itimedim/)
      ekeid=ncvdef (ncid,'eke', NCFLOAT,4,dims,iret)
      mkeid=ncvdef (ncid,'mke', NCFLOAT,4,dims,iret)
      name = 'Eddy kinetic energy'; unit = 'm^/s^2'
      call dvcdf_here(ncid,ekeid,name,len_trim(name),unit,16,spval)
      name = 'Mean kinetic energy'; unit = 'm^2/s^2'
      call dvcdf_here(ncid,mkeid,name,len_trim(name),unit,16,spval)

      if (enable_freesurf) then
       dims=(/lon_tdim,lat_tdim,itimedim,1/)
       sshid=ncvdef (ncid,'ssh_rms', NCFLOAT,3,dims,iret)
       msshid=ncvdef (ncid,'ssh_mean', NCFLOAT,3,dims,iret)
c      attributes of variables
       name = 'Rms of Sea Surface height'; unit = 'm'
       call dvcdf_here(ncid,sshid,name,len_Trim(name),unit,16,spval)
       name = 'Mean Sea Surface height'; unit = 'm'
       call dvcdf_here(ncid,msshid,name,len_Trim(name),unit,16,spval)
      endif

      if (energy) then
       dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
       t2id=ncvdef (ncid,'T2', NCFLOAT,4,dims,iret)
       name = 'Baroclinic conversion rate'; unit = '(kg/m^3)^2/s'
       call dvcdf_here(ncid,T2id,name,len_Trim(name),unit,16,spval)

       dims=(/lon_udim,lat_udim,depth_tdim,itimedim/)
       T4id=ncvdef (ncid,'T4', NCFLOAT,4,dims,iret)
       name = 'Barotropic conversion rate'; unit = '(m/s)^2/s'
       call dvcdf_here(ncid,T4id,name,len_Trim(name),unit,16,spval)

       dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
       t2xid=ncvdef (ncid,'T2x', NCFLOAT,4,dims,iret)
       name = 'Zonal baroclinic conversion rate'; unit = '(kg/m^3)^2/s'
       call dvcdf_here(ncid,T2xid,name,len_Trim(name),unit,16,spval)
      endif

      if (energy_ext) then
       dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
       T3id=ncvdef (ncid,'T3', NCFLOAT,4,dims,iret)
       name = 'T3'; unit = ' '
       call dvcdf_here(ncid,T3id,name,len_Trim(name),unit,16,spval)
       dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
       T1id=ncvdef (ncid,'T1', NCFLOAT,4,dims,iret)
       name = 'T1'; unit = ' '
       call dvcdf_here(ncid,T1id,name,len_Trim(name),unit,16,spval)
      endif

      if (var_fluxes) then
       do n=1,nt+1
        if (n==1) then
         varname='T'        
         varlname = 'temperature'
         unit = 'mK/s'
        elseif (n==2) then
         varname='S'        
         varlname = 'salinity'
         unit = 'm/s'
        elseif (n==nt+1) then
         varname='sig0'        
         varlname = 'pot. density'
         unit = 'kg/m^2/s'
        else
         write(varname,'("tr_",i2)') n
         call replace_space_zero(varname)
         write(varlname,'("tracer ",i2)') n
         unit = 'm/s '
        endif

        dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
        tmid(n)=ncvdef (ncid,'mean_'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name = 'Mean '//varlname(1:len_trim(varlname)); 
        call dvcdf_here(ncid,tmid(n),name,len_Trim(name),unit,16,spval)

        dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
        tvid(n)=ncvdef (ncid,'var_'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name = 'Variance of '//varlname(1:len_trim(varlname)); 
        call dvcdf_here(ncid,tvid(n),name,len_Trim(name),unit,16,spval)

        dims=(/lon_udim,lat_tdim,depth_tdim,itimedim/)
        ubid(n)=ncvdef (ncid,'u'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name = 'Zonal eddy flux of '//varlname(1:len_trim(varlname)); 
        call dvcdf_here(ncid,ubid(n),name,len_Trim(name),unit,16,spval)

        ubbid(n)=ncvdef (ncid,'u'//varname(1:len_trim(varname))//'2'
     &                 , NCFLOAT,4,dims,iret)
        name = 'Zonal variance flux of '//varlname(1:len_trim(varlname)); 
        call dvcdf_here(ncid,ubbid(n),name,len_Trim(name),unit,16,spval)

        ub2id(n)=ncvdef (ncid,'u2'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name = 'Zonal eddy flux 2 of '//varlname(1:len_trim(varlname)); 
        call dvcdf_here(ncid,ub2id(n),name,len_Trim(name),unit,16,spval)

        dims=(/lon_tdim,lat_udim,depth_tdim,itimedim/)
        vbid(n)=ncvdef (ncid,'v'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name='Meridional eddy flux of '//varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,vbid(n),name,len_Trim(name),unit,16,spval)

        vbbid(n)=ncvdef (ncid,'v'//varname(1:len_trim(varname))//'2'
     &                 , NCFLOAT,4,dims,iret)
        name='Meridional variance flux of '//
     &                     varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,vbbid(n),name,len_Trim(name),unit,16,spval)

        vb2id(n)=ncvdef (ncid,'v2'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name='Meridional eddy flux 2 of '//
     &           varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,vb2id(n),name,len_Trim(name),unit,16,spval)

        dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
        wbid(n)=ncvdef (ncid,'w'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name='Vertical eddy flux of '//varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,wbid(n),name,len_Trim(name),unit,16,spval)

        wbbid(n)=ncvdef (ncid,'w'//varname(1:len_trim(varname))//'2'
     &                 , NCFLOAT,4,dims,iret)
        name='Vertical variance flux of '//
     &                    varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,wbbid(n),name,len_Trim(name),unit,16,spval)

        wb2id(n)=ncvdef (ncid,'w2'//varname(1:len_trim(varname))
     &                 , NCFLOAT,4,dims,iret)
        name='Vertical eddy flux 2 of '//varlname(1:len_trim(varlname))
        call dvcdf_here(ncid,wb2id(n),name,len_Trim(name),unit,16,spval)

       enddo
      endif

      iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        if (iret.ne.0) print*,nf_strerror(iret)

      write( name,'("SFLAME sub domain # ",i3)') domain
      if (enable_monthly_variances) 
     &   name=name(1:len_trim(name))//' monthly means'
      if (enable_seasonal_variances) 
     &   name=name(1:len_trim(name))//' seasonal means'
      len=len_trim(name)
      iret= nf_put_att_text(ncid,nf_global,'history',len,name)

      call ncendf(ncid, iret)

      zt=zt/100.; zw=zw/100.

#ifdef real_8
      iret= nf_put_vara_double (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_double (ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_double (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_double (ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_double (ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_double (ncid,depth_wid,1,km,zw)
      iret= nf_put_vara_double (ncid,itimeid,1,1,tt)
#else
      iret= nf_put_vara_real (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_real (ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_real (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_real (ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_real (ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_real (ncid,depth_wid,1,km,zw)
      iret= nf_put_vara_real (ncid,itimeid,1,1,tt)
#endif

c     convert to SI units
      mean_u=mean_u/100.   
      var_u=var_u/100./100. 
      mean_ssh=mean_ssh/100.
      var_ssh=var_ssh/100./100.

      if (energy) then
       urho=urho/100.0 * 1000.0
       uv = uv/100.0/100.0
       rhom = rhom *1000.0
      endif

      if (energy_ext) then
        wrho=wrho/100.0*1000.0
        pressm=pressm /100.0 /100.0 *1000.0
        upress=upress/100.0 /100.0/100.0 *1000.0
      endif

      if (var_fluxes) then
         mean_adv=mean_adv/100;  
         mean_eddy_flux=mean_eddy_flux/100; 
         mean_var_flux = mean_var_flux/100;
      endif
c
c    get means and variances:
c     sum(T*) = sum(T^2) - N T_bar^2
c     N T_bar = sum(T_n)
c     1/N [sum(T_n)]^2 = N T_bar^2
c
      do n=1,2
       do j=1,jmt
        do k=1,km
         do i=1,imt
          var_u(i,k,j,n)= var_u(i,k,j,n)-mean_u(i,k,j,n)**2/counter 
          var_u(i,k,j,n)= var_u(i,k,j,n)/counter
          mean_u(i,k,j,n)= mean_u(i,k,j,n)/counter
         enddo
        enddo
       enddo
      enddo

      if (energy) then
       do j=1,jmt
        do k=1,km
         do i=1,imt
           rhom(i,k,j)=rhom(i,k,j)/counter
           urho(i,k,j,1)= urho(i,k,j,1) /counter
     &                  - rhom(i,k,j)*mean_u(i,k,j,1)
           urho(i,k,j,2)= urho(i,k,j,2) /counter
     &                  - rhom(i,k,j)*mean_u(i,k,j,2)
           uv(i,k,j)= uv(i,k,j) /counter
     &                  - mean_u(i,k,j,1)*mean_u(i,k,j,2)
         enddo
        enddo
       enddo
      endif

      if (energy_ext) then
c   
c    get T1 and T3
c    first calculate mean vertical velocity
       allocate(mean_wu(imt,km,jmt) ,mean_wt(imt,km,jmt) )
       mean_wu=0.; mean_wt=0.
c
c    vertical velocity on T grid
       do k=1,km
        buf1=0.0;buf2=0.0
        do j=2,jmt-1
          do i=2,imt-1
            dxt = (xu(i)-xu(i-1))*degtm
            dxu = (xt(i+1)-xt(i))*degtm
            dxum = (xt(i)-xt(i-1))*degtm
            dyt = (yu(j)-yu(j-1))*degtm
            dyu = (yt(j+1)-yt(j))*degtm
            dyum = (yt(j)-yt(j-1))*degtm
            csu  = cos( yu(j)/180*pi )
            buf1(i,j) = 0.5*(mean_u(i,k,j,1)*dyu +    ! adv_vet
     &                        mean_u(i,k,j-1,1)*dyum)/dyt
            buf2(i,j) = 0.5*(mean_u(i,k,j,2)*dxu +    ! adv_vnt
     &                        mean_u(i-1,k,j,2)*dxum)*csu/dxt
          enddo
        enddo
        do j=2,jmt
          do i=2,imt
            dxt = (xu(i)-xu(i-1))*degtm
            dyt = (yu(j)-yu(j-1))*degtm
            dzt  = (zw(k)- zw(k-1))
            cst  = cos(yt(j)/180*pi)
            mean_wt(i,k,j) =
     &                   ((buf1(i,j) - buf1(i-1,j))/dxt
     &                   +(buf2(i,j) - buf2(i,j-1))/dyt
     &                   )/cst*dzt
          enddo
        enddo
       end do

       do j=1,jmt
        do k=2,km ! mean_wt(:,0,:)=0.0
          do i=1,imt
            mean_wt(i,k,j) = mean_wt(i,k,j) + mean_wt(i,k-1,j)
          enddo
        enddo
       end do

c    and vertical velocity on the u grid
       do j=2,jmt-1
        do k=1,km
          do i=2,imt-1
            duw = (xu(i)   - xt(i))*degtm
	    due = (xt(i+1) - xu(i))*degtm
	    dun = (yt(j+1) - yu(j))*degtm
            dus = (yu(j)   - yt(j))*degtm
            dxu = (xt(i+1)-xt(i))*degtm
            dyu = (yt(j+1)-yt(j))*degtm
            csu = cos( yu(j)/180*pi )
            cst  = cos( yt(j)/180*pi )
            cstp = cos( yt(j+1)/180*pi )
	    mean_wu(i,k,j) = 1./dyu/csu/dxu*(
     &                    mean_wt(i,k,j)*duw*dus*cst
     &                  + mean_wt(i+1,k,j)*due*dus*cst
     &                  + mean_wt(i,k,j+1)*duw*dun*cstp
     &                  + mean_wt(i+1,k,j+1)*due*dun*cstp )
          enddo
        enddo
       enddo

c    now get means and variances of averaged quantities
c    store T3 in wrho and T1 in pressm

       do j=1,jmt
        do k=1,km
         do i=1,imt
           pressm(i,k,j)=pressm(i,k,j)/counter
           wrho(i,k,j)= wrho(i,k,j) /counter
     &                  - rhom(i,k,j)*mean_wt(i,k,j)
           upress(i,k,j,1)= upress(i,k,j,1) /counter
     &                  - pressm(i,k,j)*mean_u(i,k,j,1)
           upress(i,k,j,2)= upress(i,k,j,2) /counter
     &                  - pressm(i,k,j)*mean_u(i,k,j,2)
           upress(i,k,j,3)= upress(i,k,j,3) /counter
     &                  - pressm(i,k,j)*mean_wu(i,k,j)
           pressm(i,k,j)=rhom(i,k,j)*mean_wt(i,k,j)
         enddo
        enddo
       enddo

       deallocate( mean_wt, mean_wu)
      endif ! energy_ext


      if (energy) then
c
c    get T2 = u_prime rho_prime (rho_bar)_x and v_prime rho_prime (rho_bar)_y 
c    store T2 in rhom
c
       do j=1,jmt-1
        do k=1,km
         do i=1,imt-1
          dx=(xt(i+1)-xt(i))*cos(yt(j)/180*pi)*degtm
          rhox = (rhom(i+1,k,j) - rhom(i,k,j))/dx
          urho(i,k,j,1)= urho(i,k,j,1) *rhox
          dy=(yt(j+1)-yt(j))*degtm
          rhoy = (rhom(i,k,j+1) - rhom(i,k,j))/dy
          urho(i,k,j,2)= urho(i,k,j,2) *rhoy
         enddo
        enddo
       enddo
       rhom=0.0 ! here we are loosing rho_bar, it becomes T2
       do k=1,km
        buf1=urho(:,k,:,1)
        buf2=urho(:,k,:,2)
        urho(:,k,:,1:2)=0.0
        do j=2,jmt-1
         do i=2,imt-1
           urho(i,k,j,1)=(buf1(i,j)+buf1(i-1,j) )/2.0
           urho(i,k,j,2)=(buf2(i,j)+buf2(i-1,j) )/2.0
           rhom(i,k,j)= urho(i,k,j,1)+urho(i-1,k,j,2) 
         enddo
        enddo
       enddo
c
c    get T4 = 
c    u_prime^2 (u_bar)_x + v_prime^2 (v_bar)_y + 
c    u_prime v_prime ( (u_bar)_y + (v_bar)x )
c     store T4 in uv and first part of T4 in urho(:,:,:,1)
c
       do k=1,km
        buf1=0.0;buf2=0.0;
        buf3=uv(:,k,:);uv(:,k,:)=0.0
        do j=2,jmt-1
         do i=2,imt-1
          dx=(xu(i+1)-xu(i))*cos(yu(j)/180*pi)*degtm
          ux = (mean_u(i+1,k,j,1) - mean_u(i,k,j,1))/dx
          dx=(xu(i)-xu(i-1))*cos(yu(j)/180*pi)*degtm
          ux = (ux + (mean_u(i,k,j,1) - mean_u(i-1,k,j,1))/dx )/2.0

          buf1(i,j)= var_u(i,k,j,1)*ux

          dy=(yu(j+1)-yu(j))*degtm
          vy = (mean_u(i,k,j+1,2) - mean_u(i,k,j,2))/dy
          dy=(yu(j)-yu(j-1))*degtm
          vy = (vy + (mean_u(i,k,j,2) - mean_u(i,k,j-1,2))/dy )/2.0

          buf2(i,j)= var_u(i,k,j,2)*vy

          dx=(xu(i+1)-xu(i))*cos(yu(j)/180*pi)*degtm
          vx = (mean_u(i+1,k,j,2) - mean_u(i,k,j,2))/dx
          dx=(xu(i)-xu(i-1))*cos(yu(j)/180*pi)*degtm
          vx = (vx + (mean_u(i,k,j,2) - mean_u(i-1,k,j,2))/dx )/2.0

          dy=(yu(j+1)-yu(j))*degtm
          uy = (mean_u(i,k,j+1,1) - mean_u(i,k,j,1))/dy
          dy=(yu(j)-yu(j-1))*degtm
          uy = (uy + (mean_u(i,k,j,1) - mean_u(i,k,j-1,1))/dy )/2.0

          uv(i,k,j)=  buf1(i,j) + buf2(i,j) +buf3(i,j)*(vx+uy)

         enddo
        enddo
       enddo

      endif ! energy

      if (var_fluxes) then
c
c    get the mean quantities and fluxes
c
c sum(u_prime b_prime)/N = sum(ub)/N - u_bar b_bar
c  u_bar sum(b_prime^2)/N + sum( u_prime b_prime^2)/N = 
c       sum(ub^2)/N - u_bar b_bar^2 - 2 b_bar sum(u_prime b_prime)/N
        mean_adv=mean_adv/counter
        mean_tracer=mean_tracer/counter
c        var_tracer=var_tracer/counter
c     sum(T*) = sum(T^2) - N T_bar^2
c     N T_bar = sum(T_n)
c     1/N [sum(T_n)]^2 = N T_bar^2
        do n=1,nt+1
        do m=1,3
        do j=1,jmt
         do k=1,km
          do i=1,imt
          var_tracer(i,k,j,m,n)= (var_tracer(i,k,j,m,n)-
     &               mean_tracer(i,k,j,m,n)**2*counter )/counter
           mean_eddy_flux(i,k,j,m,n) = mean_eddy_flux(i,k,j,m,n)/counter 
     &           - mean_adv(i,k,j,m)*mean_tracer(i,k,j,m,n)
           mean_var_flux(i,k,j,m,n) = mean_var_flux(i,k,j,m,n)/counter 
     &           - mean_adv(i,k,j,m)*mean_tracer(i,k,j,m,n)**2
     &           - 2*mean_tracer(i,k,j,m,n)*mean_eddy_flux(i,k,j,m,n)
          enddo
         enddo
        enddo
        enddo
        enddo
c
c     now compute the gauge vector potential for the eddy fluxes
c
        do n=1,nt+1

         do j=1,jmt-1
          do k=1,km-1
           do i=2,imt
c
c     theta_1 = (G_2 b_z - G_3 b_y) /( b_x^2+b_y^2+b_z^2)
c     with G= bar( u phi_prime )
c      is on grid:  T grid in x,  U grid in y, W Grid in z
c
            dx1=(xu(i)-xu(i-1))*cos(yt(j)/180*pi)*degtm
            dx2=(xu(i)-xu(i-1))*cos(yt(j+1)/180*pi)*degtm
            dy=(yt(j+1)-yt(j))*degtm
            dz  = zt(k+1)- zt(k)
            rhodz= 0.25*(
     &        ((mean_tracer(i,k,j,1,n)-mean_tracer(i-1,k,j,1,n))/dx1)**2
     &   +((mean_tracer(i,k,j+1,1,n)-mean_tracer(i-1,k,j+1,1,n))/dx2)**2
     &  +((mean_tracer(i,k+1,j,1,n)-mean_tracer(i-1,k+1,j,1,n))/dx1)**2+
     &((mean_tracer(i,k+1,j+1,1,n)-mean_tracer(i-1,k+1,j+1,1,n))/dx2)**2
     &            )
     &       +((mean_tracer(i,k,j,2,n)-mean_tracer(i,k+1,j,2,n))/dz)**2
     &       +((mean_tracer(i,k,j+1,3,n)-mean_tracer(i,k,j,3,n))/dy)**2
            if (rhodz==0.0) rhodz=1e-10
            theta(i,k,j,1,n)= (
     &       0.5*(mean_var_flux(i,k,j,2,n)+mean_var_flux(i,k+1,j,2,n))
     &       *(mean_tracer(i,k,j,2,n)-mean_tracer(i,k+1,j,2,n))/dz
     &      -0.5*(mean_var_flux(i,k,j,3,n)+mean_var_flux(i,k,j+1,3,n))
     &       *(mean_tracer(i,k,j+1,3,n)-mean_tracer(i,k,j,3,n))/dy )
     &        /rhodz
           enddo
          enddo
         enddo

         do j=2,jmt
          do k=1,km-1
           do i=1,imt-1
c
c     theta_2 = (G_3 b_x - G_1 b_z) /( b_x^2+b_y^2+b_z^2)
c      is on grid:  U grid in x,  T grid in y, W Grid in z
c
            dx=(xt(i+1)-xt(i))*cos(yt(j)/180*pi)*degtm
            dz=zt(k+1)-zt(k)
            dy = (yu(j)-yu(j-1))*degtm
            rhodz=
     &        ((mean_tracer(i+1,k,j,3,n)-mean_tracer(i,k,j,1,n))/dx)**2
     &       +((mean_tracer(i,k,j,1,n)-mean_tracer(i,k+1,j,1,n))/dz)**2
     &       +0.25*(
     &       +((mean_tracer(i,k,j,2,n)-mean_tracer(i,k,j-1,2,n))/dy)**2
     &   +((mean_tracer(i+1,k,j,2,n)-mean_tracer(i+1,k,j-1,2,n))/dy)**2
     & +((mean_tracer(i,k+1,j,2,n)-mean_tracer(i,k+1,j-1,2,n))/dy)**2+
     &((mean_tracer(i+1,k+1,j,2,n)-mean_tracer(i+1,k+1,j-1,2,n))/dy)**2
     &            )
            if (rhodz==0.0) rhodz=1e-10
            theta(i,k,j,2,n)= (
     &       0.5*(mean_var_flux(i,k,j,3,n)+mean_var_flux(i+1,k,j,3,n))
     &       *(mean_tracer(i+1,k,j,3,n)-mean_tracer(i,k,j,3,n))/dx
     &      -0.5*(mean_var_flux(i,k,j,1,n)+mean_var_flux(i,k+1,j,1,n))
     &       *(mean_tracer(i,k,j,1,n)-mean_tracer(i,k+1,j,1,n))/dz )
     &        /rhodz
           enddo
          enddo
         enddo

         do j=1,jmt-1
          do k=2,km
           do i=1,imt-1
c
c     theta_3 = (G_1 b_y - G_2 b_x) /( b_x^2+b_y^2+b_z^2)
c      is on grid:  U grid in x,  U grid in y, T Grid in z
c
            dy = (yt(j+1)-yt(j))*degtm
            dx = (xt(i+1)-xt(i))*cos(yu(j)/180*pi)*degtm
            dz = zw(k)-zw(k-1)
            rhodz=
     &        ((mean_tracer(i+1,k,j,2,n)-mean_tracer(i,k,j,2,n))/dx)**2
     &       +((mean_tracer(i,k,j+1,1,n)-mean_tracer(i,k,j,1,n))/dy)**2
     &       +0.25*(
     &       +((mean_tracer(i,k-1,j,3,n)-mean_tracer(i,k,j,3,n))/dz)**2
     &   +((mean_tracer(i,k-1,j+1,3,n)-mean_tracer(i,k,j+1,3,n))/dz)**2
     &   +((mean_tracer(i+1,k-1,j,3,n)-mean_tracer(i+1,k,j,3,n))/dz)**2
     &+((mean_tracer(i+1,k-1,j+1,3,n)-mean_tracer(i+1,k,j+1,3,n))/dz)**2
     &            )
            if (rhodz==0.0) rhodz=1e-10
            theta(i,k,j,3,n)= (
     &       0.5*(mean_var_flux(i,k,j,1,n)+mean_var_flux(i,k,j+1,1,n))
     &       *(mean_tracer(i,k,j+1,1,n)-mean_tracer(i,k,j,1,n))/dy
     &      -0.5*(mean_var_flux(i+1,k,j,2,n)+mean_var_flux(i,k,j,2,n))
     &       *(mean_tracer(i+1,k,j,2,n)-mean_tracer(i,k,j,2,n))/dx )
     &        /rhodz
           enddo
          enddo
         enddo

c  now remove the vector potential flux from the eddy fluxes

         do j=2,jmt
          do k=2,km
           do i=2,imt
c        F_1 = u_prime b_prime - (theta_2)_z + (theta_3)_y
            dy = (yu(j)-yu(j-1))*degtm
            dz = zw(k)-zw(k-1)
            eddy_flux(i,k,j,1,n)=mean_eddy_flux(i,k,j,1,n)
     &         -(theta(i,k-1,j,2,n)-theta(i,k,j,2,n) )/dz
     &         +(theta(i,k,j,3,n)-theta(i,k,j-1,3,n) )/dy
c        F_2 = v_prime b_prime - (theta_1)_z + (theta_3)_x
            dx = (xu(i)-xu(i-1))*cos(yu(j)/180*pi)*degtm
            dz = zw(k)-zw(k-1)
            eddy_flux(i,k,j,2,n)=mean_eddy_flux(i,k,j,2,n)
     &         -(theta(i,k-1,j,1,n)-theta(i,k,j,1,n) )/dz
     &         +(theta(i,k,j,3,n)-theta(i-1,k,j,3,n) )/dx
c        F_3 = w_prime b_prime - (theta_2)_x + (theta_1)_y
            dy = (yu(j)-yu(j-1))*degtm
            dx = (xu(i)-xu(i-1))*cos(yt(j)/180*pi)*degtm
            eddy_flux(i,k,j,3,n)=mean_eddy_flux(i,k,j,3,n)
     &         -(theta(i,k,j,2,n)-theta(i-1,k,j,2,n) )/dx
     &         +(theta(i,k,j,1,n)-theta(i,k,j-1,1,n) )/dy
           enddo
          enddo
         enddo


        enddo


      endif ! var_fluxes

c
c   store energy terms  in var_u and mean_u
c
      do j=1,jmt
       do k=1,km
        do i=1,imt
         var_u(i,k,j,1)=(var_u(i,k,j,1)+var_u(i,k,j,2))/2.
         mean_u(i,k,j,1)=(mean_u(i,k,j,1)**2+mean_u(i,k,j,2)**2)/2.
        enddo
       enddo
      enddo

c
c   care about external mode
c
      do j=1,jmt
       do i=1,imt
        var_ssh(i,j)= var_ssh(i,j)-mean_ssh(i,j)**2/counter 
        var_ssh(i,j)= sqrt(var_ssh(i,j)/counter)
        mean_ssh(i,j)= mean_ssh(i,j)/counter
       enddo
      enddo

c     apply land mask and write to file
      do k=1,km
         where( kmu <k ) mean_u(:,k,:,1) = spval
         where( kmu <k ) var_u(:,k,:,1) = spval
         start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
         iret=nf_put_vara_double(ncid,mkeid,start,count,mean_u(:,k,:,1))
         iret=nf_put_vara_double (ncid,ekeid,start,count,var_u(:,k,:,1))
#else
         iret=nf_put_vara_real(ncid,mkeid,start,count,mean_u(:,k,:,1))
         iret=nf_put_vara_real(ncid,ekeid,start,count,var_u(:,k,:,1))
#endif
      enddo

      if (energy) then
       do k=1,km
         where( kmu <k ) uv(:,k,:) = spval
         where( kmt <k ) rhom(:,k,:) = spval
         where( kmt <k ) urho(:,k,:,1) = spval
         start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
         iret=nf_put_vara_double(ncid,T4id,start,count,uv(:,k,:))
         iret=nf_put_vara_double(ncid,T2id,start,count,rhom(:,k,:))
         iret=nf_put_vara_double(ncid,T2xid,start,count,urho(:,k,:,1))
#else
         iret=nf_put_vara_real(ncid,T4id,start,count,uv(:,k,:))
         iret=nf_put_vara_real(ncid,T2id,start,count,rhom(:,k,:))
         iret=nf_put_vara_real(ncid,T2xid,start,count,urho(:,k,:,1))
#endif
       enddo
      endif

      if (energy_ext) then
       do k=1,km
         where( kmt <k ) wrho(:,k,:) = spval
         where( kmt <k ) pressm(:,k,:) = spval
         start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
         iret=nf_put_vara_double(ncid,T1id,start,count,pressm(:,k,:))
         iret=nf_put_vara_double(ncid,T3id,start,count,wrho(:,k,:))
#else
         iret=nf_put_vara_real(ncid,T1id,start,count,pressm(:,k,:))
         iret=nf_put_vara_real(ncid,T3id,start,count,wrho(:,k,:))
#endif
       enddo
      endif

      if (var_fluxes) then
       do k=1,km
         do n=1,nt+1
          do m=1,3
           where( kmt <k ) mean_adv(:,k,:,m) = spval
           where( kmt <k ) mean_tracer(:,k,:,m,n) = spval
           where( kmt <k ) var_tracer(:,k,:,m,n) = spval
           where( kmt <k ) mean_eddy_flux(:,k,:,m,n) = spval
           where( kmt <k ) eddy_flux(:,k,:,m,n) = spval
           where( kmt <k ) mean_var_flux(:,k,:,m,n) = spval
          enddo
         enddo
         start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
         do n=1,nt+1
          iret=nf_put_vara_double(ncid,tmid(n),start,count,
     &           mean_tracer(:,k,:,1,n))
          iret=nf_put_vara_double(ncid,tvid(n),start,count,
     &           var_tracer(:,k,:,1,n))
          iret=nf_put_vara_double(ncid,ubid(n),start,count,
     &           mean_eddy_flux(:,k,:,1,n))
          iret=nf_put_vara_double(ncid,vbid(n),start,count,
     &           mean_eddy_flux(:,k,:,2,n))
          iret=nf_put_vara_double(ncid,wbid(n),start,count,
     &           mean_eddy_flux(:,k,:,3,n))
          iret=nf_put_vara_double(ncid,ubbid(n),start,count,
     &           mean_var_flux(:,k,:,1,n))
          iret=nf_put_vara_double(ncid,vbbid(n),start,count,
     &           mean_var_flux(:,k,:,2,n))
          iret=nf_put_vara_double(ncid,wbbid(n),start,count,
     &           mean_var_flux(:,k,:,3,n))
          iret=nf_put_vara_double(ncid,ub2id(n),start,count,
     &           eddy_flux(:,k,:,1,n))
          iret=nf_put_vara_double(ncid,vb2id(n),start,count,
     &           eddy_flux(:,k,:,2,n))
          iret=nf_put_vara_double(ncid,wb2id(n),start,count,
     &           eddy_flux(:,k,:,3,n))
         enddo
#else
         do n=1, nt+1
          iret=nf_put_vara_real(ncid,tmid(n),start,count,
     &           mean_tracer(:,k,:,1,n))
          iret=nf_put_vara_real(ncid,tvid(n),start,count,
     &           var_tracer(:,k,:,1,n))
          iret=nf_put_vara_real(ncid,ubid(n),start,count,
     &           mean_eddy_flux(:,k,:,1,n))
          iret=nf_put_vara_real(ncid,vbid(n),start,count,
     &           mean_eddy_flux(:,k,:,2,n))
          iret=nf_put_vara_real(ncid,wbid(n),start,count,
     &           mean_eddy_flux(:,k,:,3,n))
          iret=nf_put_vara_real(ncid,ubbid(n),start,count,
     &           mean_var_flux(:,k,:,1,n))
          iret=nf_put_vara_real(ncid,vbbid(n),start,count,
     &           mean_var_flux(:,k,:,2,n))
          iret=nf_put_vara_real(ncid,wbbid(n),start,count,
     &           mean_var_flux(:,k,:,3,n))
          iret=nf_put_vara_real(ncid,ub2id(n),start,count,
     &           eddy_flux(:,k,:,1,n))
          iret=nf_put_vara_real(ncid,vb2id(n),start,count,
     &           eddy_flux(:,k,:,2,n))
          iret=nf_put_vara_real(ncid,wb2id(n),start,count,
     &           eddy_flux(:,k,:,3,n))
         enddo
#endif
       enddo
      endif

      if (enable_freesurf) then
       where( kmt == 0) mean_ssh = spval
       where( kmt == 0) var_ssh = spval
       start=(/1,1,1,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
       iret= nf_put_vara_double(ncid,sshid,start,count,var_ssh)
       iret= nf_put_vara_double(ncid,msshid,start,count,mean_ssh)
#else
       iret= nf_put_vara_real (ncid,sshid,start,count,var_ssh)
       iret= nf_put_vara_real (ncid,msshid,start,count,mean_ssh)
#endif
      endif
      call ncclos (ncid, iret)
      end subroutine write_variances

#endif

#include "options.inc"


c
c ------------------------------------------------------
c     fold the forcing for SPFLAME with this programm
c     fully automatic if you want. 
c     However, there is one command line parameter: imtf
c                              aug 2001  c eden
c ------------------------------------------------------
c

      program prep_fold
      implicit none
      character (len=80) :: infile,outfile
      integer, allocatable ::  kmt(:,:)
      integer :: imt,jmt,km,imtf, imtf_given,m
      integer   :: ncid,iret,n,ncout
      integer   :: xtid,ytid,ztid,kmtid
      integer   :: start(4),count(4),dims(4)
      character (len=80) :: name
      integer :: ret
#include "netcdf.inc"

      print*,' Folding forcing data'

      imtf_given=-1
      call  get_commandline_arg_int(1,imtf_given,iret)

      if (iret/=0) then
       print*,' you might want to preset imtf '
       imtf_given=-1
      else
       print*,' read imtf =',imtf_given,' from command line'
      endif

      call  get_commandline_arg(2,infile,iret)
      if (iret/=0) infile='forcing.cdf'
      call  get_commandline_arg(3,outfile,iret)
      if (iret/=0) outfile='forcing_folded.cdf'

      print*,' reading from file ',infile(1:len_trim(infile))
      print*,' writing to file ',outfile(1:len_trim(outfile))

      iret=nf_open(infile,NF_noWRITE,ncid)
      ncout = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncout, NF_NOFILL, iret)

c     read grid 

      iret=nf_inq_varid(ncid,'xt',xtid)
      iret=nf_inq_varid(ncid,'yt',ytid)
      iret=nf_inq_varid(ncid,'zt',ztid)

      iret=NF_INQ_VARDIMID (NCID,xtid,dims)
      iret=NF_INQ_DIMLEN (NCID, dims(1), imt)
      iret=NF_INQ_VARDIMID (NCID,ytid,dims)
      iret=NF_INQ_DIMLEN (NCID, dims(1), jmt)
      iret=NF_INQ_VARDIMID (NCID,ztid,dims)
      iret=NF_INQ_DIMLEN (NCID, dims(1), km)

      print*,'imt=',imt,' jmt=',jmt,' km=',km

c     determine possible folding


      iret=nf_inq_varid(ncid,'kmt',kmtid)
      if (iret == 0) then
       allocate( kmt(imt,jmt) )
       start=(/1,1,1,1/); count=(/imt,jmt,1,1/)
       iret= nf_get_vara_int(ncid,kmtid ,start,count,kmt)
       call try_fold(kmt,imt,jmt,imtf)
      else
        print*,' Cannot find variable kmt in file'
        print*,' NetCDF error message:', nf_strerror(iret)
      endif

      print*,' determined minimal possible folding =',imtf
      if (imtf_given > 0) then
        print*,' however setting imtf to ',imtf_given
        imtf=imtf_given
      endif

c
c     define x-axis in new file
c
      iret = ncddef(ncout, 'Longitude_t',imtf,iret)
      iret = ncddef(ncout, 'Longitude_u',imtf,iret)
      call move_var_cdf(ncid,ncout,'Longitude_t','spv',ret)
      call move_var_cdf(ncid,ncout,'Longitude_u','spv',ret)
c
c     grid
c
      call move_var_cdf(ncid,ncout,'xt','spv',ret)
      call move_var_cdf(ncid,ncout,'xu','spv',ret)
      call move_var_cdf(ncid,ncout,'yt','spv',ret)
      call move_var_cdf(ncid,ncout,'yu','spv',ret)
      call move_var_cdf(ncid,ncout,'zt','spv',ret)
      call move_var_cdf(ncid,ncout,'zw','spv',ret)
      call move_var_cdf(ncid,ncout,'dxtdeg','spv',ret)
      call move_var_cdf(ncid,ncout,'dxudeg','spv',ret)
      call move_var_cdf(ncid,ncout,'dytdeg','spv',ret)
      call move_var_cdf(ncid,ncout,'dyudeg','spv',ret)
      call move_var_cdf(ncid,ncout,'dzt','spv',ret)
      call move_var_cdf(ncid,ncout,'dzw','spv',ret)
      call move_var_cdf(ncid,ncout,'glat','spv',ret)
c
c     topography
c
      call move_var_cdf(ncid,ncout,'kmt','max',ret)
      call move_var_cdf(ncid,ncout,'topo','max',ret)
#ifdef partial_cell
      call move_var_cdf(ncid,ncout,'htp','max',ret)
#endif
      call move_var_cdf(ncid,ncout,'rose','max',ret)
      call move_var_cdf(ncid,ncout,'raw_rose','max',ret)
c
c     initial cond.
c
      call move_var_cdf(ncid,ncout,'temp_ic','spv',ret)
      call move_var_cdf(ncid,ncout,'salt_ic','spv',ret)
      call move_var_cdf(ncid,ncout,'temp_mean','spv',ret)
      call move_var_cdf(ncid,ncout,'salt_mean','spv',ret)
      m=3
 20    write(name,'("tracer_",i2,"_ic")') m
       call replace_space_zero(name)
       call move_var_cdf(ncid,ncout,name,'spv',ret)
      if (ret==0) then; m=m+1; goto 20; endif
      m=3
 25   write(name,'("tracer_",i2,"_mean")') m
       call replace_space_zero(name)
       call move_var_cdf(ncid,ncout,name,'spv',ret)
      if (ret==0) then; m=m+1; goto 25; endif
c
c     s b c
c
      call move_var_cdf(ncid,ncout,'taux','spv',ret)
      call move_var_cdf(ncid,ncout,'tauy','spv',ret)
      call move_var_cdf(ncid,ncout,'sst_clim','spv',ret)
      call move_var_cdf(ncid,ncout,'sst_rest','spv',ret)
      call move_var_cdf(ncid,ncout,'sst_flux','spv',ret)
      call move_var_cdf(ncid,ncout,'sss_clim','spv',ret)
      call move_var_cdf(ncid,ncout,'sss_rest','spv',ret)
      call move_var_cdf(ncid,ncout,'sss_flux','spv',ret)
      call move_var_cdf(ncid,ncout,'ustar','spv',ret)
      m=3
 30    write(name,'("str_",i2,"_clim")') m
       call replace_space_zero(name)
       call move_var_cdf(ncid,ncout,name,'spv',ret)
       write(name,'("str_",i2,"_rest")') m
       call replace_space_zero(name)
       call move_var_cdf(ncid,ncout,name,'spv',ret)
       write(name,'("str_",i2,"_flux")') m
       call replace_space_zero(name)
       call move_var_cdf(ncid,ncout,name,'spv',ret)
      if (ret==0) then; m=m+1; goto 30; endif
c
c     obc
c
      call move_var_cdf(ncid,ncout,'temp_obc_south','spv',ret)
      call move_var_cdf(ncid,ncout,'salt_obc_south','spv',ret)
      call move_var_cdf(ncid,ncout,'psi_obc_south','spv',ret)
      call move_var_cdf(ncid,ncout,'temp_obc_north','spv',ret)
      call move_var_cdf(ncid,ncout,'salt_obc_north','spv',ret)
      call move_var_cdf(ncid,ncout,'psi_obc_north','spv',ret)
      call move_var_cdf(ncid,ncout,'temp_obc_east','spv',ret)
      call move_var_cdf(ncid,ncout,'salt_obc_east','spv',ret)
      call move_var_cdf(ncid,ncout,'psi_obc_east','spv',ret)
      call move_var_cdf(ncid,ncout,'temp_obc_west','spv',ret)
      call move_var_cdf(ncid,ncout,'salt_obc_west','spv',ret)
      call move_var_cdf(ncid,ncout,'psi_obc_west','spv',ret)
      m=3
 40    write(name,'("tr",i2,"_obc_north")') m
       call replace_space_zero(name)
       call move_var_cdf(ncid,ncout,name,'spv',ret)
      if (ret==0) then; m=m+1; goto 40; endif
      m=3
 50    write(name,'("tr",i2,"_obc_south")') m
       call replace_space_zero(name)
       call move_var_cdf(ncid,ncout,name,'spv',ret)
      if (ret==0) then; m=m+1; goto 50; endif
      m=3
 60    write(name,'("tr",i2,"_obc_east")') m
       call replace_space_zero(name)
       call move_var_cdf(ncid,ncout,name,'spv',ret)
      if (ret==0) then; m=m+1; goto 60; endif
      m=3
 70    write(name,'("tr",i2,"_obc_west")') m
       call replace_space_zero(name)
       call move_var_cdf(ncid,ncout,name,'spv',ret)
      if (ret==0) then; m=m+1; goto 70; endif
c
c     if blue density is in the file
c
      call move_var_cdf(ncid,ncout,'temp_blue','spv',ret)
      call move_var_cdf(ncid,ncout,'salt_blue','spv',ret)
c
c     if blue mean density is in the file
c
      call move_var_cdf(ncid,ncout,'temp_blue_mean','spv',ret)
      call move_var_cdf(ncid,ncout,'salt_blue_mean','spv',ret)
c
c     check if BB forcing files are present
c
      call move_var_cdf(ncid,ncout,'tauxBB','spv',ret)
      call move_var_cdf(ncid,ncout,'tauyBB','spv',ret)
      call move_var_cdf(ncid,ncout,'hflxBB','spv',ret)
      call move_var_cdf(ncid,ncout,'sstf_BB','spv',ret)
      call move_var_cdf(ncid,ncout,'sstm_BB','spv',ret)
c
c     sponge layers need special treament
c 
      call move_sponges(ncid,ncout,imt,imtf,jmt,km)

      call ncclos (ncid, iret)
      call ncclos (ncout, iret)

      end program prep_fold


      subroutine move_sponges(ncin,ncout,imt,imtf,jmt,km)
      implicit none
      integer :: ncin,ncout,imt,imtf,jmt,km,nt
      integer :: n,nr_spg,dims(4),nr_nspg,id,natts,k,m
      character (len=2) :: number,nr2
      character (len=80) :: name,unit,s
      integer :: is,ie,js,je,tid,sid,tsid,iret
      integer :: t1id,s1id,ts1id,t2id,s2id,ts2id
      integer :: start(4),count(4),x1dim,x2dim,ydim,zdim,tdim
      real (kind=4), allocatable  :: buf(:,:,:,:,:)
      integer :: ret ,i
      character (len=4) :: tr_name(99)
#include "netcdf.inc"

      iret= nf_get_att_int(ncin,nf_global,'number_of_sponge_layers',
     &                     nr_spg  )
      if (iret/=0) nr_spg = 0
c
c     set tracer names
c
      do m=1,99
        if (m==1) then
         tr_name(m) = 'temp'
        elseif (m==2) then
         tr_name(m) = 'salt'
        else
         write(tr_name(m),'("tr",i2)') m
         do i=1,len_trim(tr_name(m))
          if (tr_name(m)(i:i)==' ')tr_name(m)(i:i)='0'
         enddo
        endif
      enddo

      nr_nspg=nr_spg
      do n=1,nr_spg

       print*,' processing sponge layer #',n

       write(number,'(i2)') n
       if (number(1:1) == ' ') number(1:1)='0'
c
c      get range of sponge layer from temperature
c
       iret=nf_inq_varid(ncin,'temp_spg_'//number,tid)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=NF_INQ_VARDIMID (ncin,tid,dims)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=NF_INQ_DIMLEN (ncin, dims(3), km)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret= nf_get_att_int(ncin,tid,'range',dims )
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       is=dims(1);ie=dims(2);js=dims(3);je=dims(4)

       print*,' is=',is,' ie=',ie,' js=',js,' je=',je,'km=',km



       if (ie <= imtf ) then
c
c       just transfer
c
        print*,' we can just transfer this sponge layer'

        m=1
 20     continue
         call move_var_cdf(ncin,ncout,tr_name(m)//'_spg_'//number,
     &                    'spv',ret)
         call move_var_cdf(ncin,ncout,tr_name(m)//'_tscl_spg_'//number,
     &                    'spv',ret)
        if (ret==0) then; m=m+1; goto 20; endif

       elseif (is>=imtf) then
c
c       just transfer and adjust is and ie
c
        print*,' we can transfer this sponge layer'
        print*,' and adjust is and ie '

        m=1
 30     continue

         call move_var_cdf(ncin,ncout,tr_name(m)//'_spg_'//number,
     &                    'spv',ret)
         call move_var_cdf(ncin,ncout,tr_name(m)//'_tscl_spg_'//number,
     &                    'spv',ret)

         if (ret==0) then
          dims(1)=is-imtf+2
          dims(2)=ie-imtf+2
c
          iret=nf_inq_varid(ncout,tr_name(m)//'_spg_'//number,tid)
          if (iret/=0) then; print*,' cannot find var.';stop;endif
          iret=nf_inq_varid(ncout,tr_name(m)//'_tscl_spg_'//number,tsid)
          if (iret/=0) then; print*,' cannot find var.';stop;endif

          iret = nf_redef(ncout)
          iret=nf_set_fill(ncout, NF_NOFILL, iret)

          iret= nf_put_att_int(ncout,tid,'range',nf_int,4,dims)
          iret= nf_put_att_int(ncout,tsid,'range',nf_int,4,dims)

          iret = nf_enddef(ncout)
c
c         adjust maybe also the x-axis of sponge layer
c
         endif

        if (ret==0) then; m=m+1; goto 30; endif

       else
c
c       we have to split the sponge layer into two parts
c
        print*,' this sponge layer has to be to splitted '
        nr_nspg=nr_nspg+1
        write(nr2,'(i2)') nr_nspg
        if (nr2(1:1) == ' ') nr2(1:1)='0'

        m=1
 40     continue

c        time dimension and y-axis can be shared by both
         call move_var_cdf(ncin,ncout,
     &       'time_spg_'//number//'_'//tr_name(m),'spv',ret)
         if (ret/=0) goto 50  ! no more tracers

         if (m==1) then
          call move_var_cdf(ncin,ncout,'Lat_spg_'//number,'spv',ret)
         endif
c
         iret=nf_inq_varid(ncin,tr_name(m)//'_spg_'//number,tid)
         print*,' CHECK for depth axis'
c  check for depth axis
         iret=NF_INQ_VARDIMID(ncin,tid,dims)
         s='';iret=NF_INQ_DIMNAME(NCin,dims(3), s) ! depth axis
         print*,'name of depth axis',s
         iret=nf_inq_varid(ncout,s,tsid)
         if (iret/=0) then
           call move_var_cdf(ncin,ncout,s,'spv',ret)
         else
          print*,' depth axis already defined'
         endif

         iret=nf_inq_varid(ncin,tr_name(m)//'_tscl_spg_'//number,tsid)

         iret= NF_INQ_DIMLEN (NCin, DIMs(4), nt)

         allocate( buf(is:ie,js:je,km,nt,2) )

         start=1; count=(/ie-is+1,je-js+1,km,nt/)
         iret= nf_get_vara_real(ncin,tid,start,count,buf(:,:,:,:,1))
         iret= nf_get_vara_real(ncin,tsid,start,count,buf(:,:,:,:,2))

         iret = nf_redef(ncout)
         iret=nf_set_fill(ncout, NF_NOFILL, iret)
        
         if (m==1) then
          x1dim = ncddef(ncout, 'Lon_spg_'//number,imtf-1-is+1 , iret)
          x2dim = ncddef(ncout, 'Lon_spg_'//nr2   ,ie-imtf+1 , iret)
         else
          iret=NF_INQ_DIMID(ncout,'Lon_spg_'//number,x1dim)
          iret=NF_INQ_DIMID(ncout,'Lon_spg_'//nr2,   x2dim)
         endif
         iret=NF_INQ_DIMID(ncout,'Lat_spg_'//number,ydim)
         iret=NF_INQ_DIMID(ncout,
     &                'time_spg_'//number//'_'//tr_name(m),tdim)
         iret=NF_INQ_DIMID(ncout,'depth_t',zdim)

         dims=(/x1dim,ydim,zdim,tdim/)
         t1id = ncvdef (ncout,tr_name(m)//'_spg_'//number,
     &                  ncfloat,4,dims,iret)
         ts1id = ncvdef (ncout,tr_name(m)//'_tscl_spg_'//number,
     &                   ncfloat,4,dims,iret)

         dims=(/x2dim,ydim,zdim,tdim/)
         t2id = ncvdef (ncout,tr_name(m)//'_spg_'//nr2,
     &                  ncfloat,4,dims,iret)
         ts2id = ncvdef (ncout,tr_name(m)//'_tscl_spg_'//nr2,
     &                   ncfloat,4,dims,iret)

         iret =  NF_INQ_VARNATTS (NCin, tid, natts)
         do k=1,natts
          name='';iret= NF_INQ_ATTNAME (NCin, tid, k, name)
          iret= NF_COPY_ATT(NCIN, tid, name, NCOUT, t1id)
          iret= NF_COPY_ATT(NCIN, tid, name, NCOUT, t2id)
         enddo

         iret =  NF_INQ_VARNATTS (NCin, tsid, natts)
         do k=1,natts
          name='';iret= NF_INQ_ATTNAME (NCin, tsid, k, name)
          iret= NF_COPY_ATT(NCIN, tsid, name, NCOUT, ts1id)
          iret= NF_COPY_ATT(NCIN, tsid, name, NCOUT, ts2id)
         enddo

         dims=(/is,imtf-1,js,je/)
         iret= nf_put_att_int(ncout,t1id,'range',nf_int,4,dims)
         iret= nf_put_att_int(ncout,ts1id,'range',nf_int,4,dims)

         dims=(/imtf-imtf+2,ie-imtf+2,js,je/)
         iret= nf_put_att_int(ncout,t2id,'range',nf_int,4,dims)
         iret= nf_put_att_int(ncout,ts2id,'range',nf_int,4,dims)
c
c        maybe care also about x-axis but not really needed
c
         iret = nf_enddef(ncout)

         start=1; count=(/imtf-1-is+1,je-js+1,km,nt/)
         iret= nf_put_vara_real(ncout,t1id ,start,count,
     &                          buf(is:imtf-1,:,:,:,1)) 
         iret= nf_put_vara_real(ncout,ts1id ,start,count,
     &                          buf(is:imtf-1,:,:,:,2)) 

         start=1; count=(/ie-imtf+1,je-js+1,km,nt/)
         iret= nf_put_vara_real(ncout,t2id ,start,count,
     &                          buf(imtf:ie,:,:,:,1)) 
         iret= nf_put_vara_real(ncout,ts2id ,start,count,
     &                          buf(imtf:ie,:,:,:,2)) 

         deallocate(buf)

 50      continue

        if (ret==0) then; m=m+1; goto 40; endif

       endif ! transfer decision

       print*,' '
       print*,' Done processing sponge layer #',number
       print*,' '

      enddo ! loop over sponge layers
c
c     the new nr of sponges
c
      iret = nf_redef(ncout)
      iret= nf_put_att_int(ncout,nf_global,'number_of_sponge_layers',
     &                     nf_int,1,nr_nspg  )
      iret = nf_enddef(ncout)

      print*,' new number of sponge layer:',nr_nspg

      end subroutine move_sponges



      recursive subroutine  move_var_cdf(ncin,ncout,name,maxi,ret)
      implicit none
      integer :: ncin,ncout
      character*(*) name
      character*(*) maxi
      integer :: ret 
#include "netcdf.inc"
      integer :: idi,ido,xtype,ndims,dimin(4),dimout(4)
      integer :: natts,n,iret
      character (len=80) :: s
      integer :: start(4),count(4),count2(4),len,aid
      real (kind=4), allocatable  :: buff(:,:,:,:)
      integer, allocatable        :: bufi(:,:,:,:)
      real (kind=8), allocatable  :: bufd(:,:,:,:)
      logical :: axis = .false.
      real (kind=4) :: spval
      logical :: use_max = .false.  ! use maximum criterium to fold

      if (maxi(1:3) == 'max' ) use_max=.true.
      if (maxi(1:3) == 'spv' ) use_max=.false.

      iret=nf_inq_varid(ncin,name,idi)
      if (iret/=0) then
        print*,' WARING: cannot find variable ',
     &          name(1:len_trim(name)),' in input file'
        ret=-1
        return
      else
        print*,' moving variable ',
     &          name(1:len_trim(name)),' to output file'
        if (use_max) print*,' using maximum criterium to fold '
      endif

      iret=NF_INQ_VARTYPE(ncin,idi, xtype)
      iret=NF_INQ_VARNDIMS(ncin,idi, ndims)
      if (ndims>4) then
        print*,' cannot handle more than 4 dimensions'
        print*,' but found ',ndims
        stop
      endif
      iret=NF_INQ_VARDIMID(ncin,idi,dimin)

      do n=1,ndims
       s='';iret=NF_INQ_DIMNAME(NCin,dimin(n), s) 
       iret=NF_INQ_DIMID(NCout,s,dimout(n)) 
       if (iret/=0) then
        print*,' WARNING: cannot find dimension ',s(1:len_trim(s)),
     &        ' in output file'
        print*,' try to define it ...'
        iret= NF_INQ_DIMLEN (NCin, DIMin(n), len)
        print*,' dimension length = ',len
        iret = nf_redef(ncout)
        iret=nf_set_fill(ncout, NF_NOFILL, iret)
        dimout(n) = ncddef(ncout, s, len, iret)
        print*,' try to find axis variables for that dimension'
        iret=nf_inq_varid(ncin,s,aid)
        if (iret==0) then
         print*,' okay found it and transfering it'
         if (s(1:len_trim(s))==name(1:len_trim(name))) then
           print*,' that was already the variable which we want to '
           axis = .true.
         else
           call move_var_cdf(ncin,ncout,s,maxi,ret)
         endif

         s='';iret= nf_get_att_text(ncin,aid ,'ave_period',s)
         if (iret==0) then
           print*,' found also attribute ave_period, transfering also'
           call move_var_cdf(ncin,ncout,s,maxi,ret)
         endif
         s='';iret= nf_get_att_text(ncin,aid ,'start_ave_period',s)
         if (iret==0) then
           print*,' found also attribute start_ave_period,'
     &            //' transfering also'
           call move_var_cdf(ncin,ncout,s,maxi,ret)
         endif
         print*,'okay'         
         print*,''         
        else
         print*,' negative '
        endif
        iret = nf_enddef(ncout)
       endif
      enddo


      iret = nf_redef(ncout)
      iret=nf_set_fill(ncout, NF_NOFILL, iret)

      ido = ncvdef (ncout,name, xtype,ndims,dimout,iret)

      iret =  NF_INQ_VARNATTS (NCin, idi, natts)
      do n=1,natts
       s='';iret= NF_INQ_ATTNAME (NCin, idi, n, s)
       iret= NF_COPY_ATT(NCIN, idi, s, NCOUT, ido)
      enddo

      iret = nf_enddef(ncout)

      start=1; count=1; count2=1;
      do n=1,ndims
       iret= NF_INQ_DIMLEN (NCin, DIMin(n), count(n))
       iret= NF_INQ_DIMLEN (NCout, DIMout(n), count2(n))
      enddo

      if (count(1) > count2(1) .and. ndims>1 ) then
c      missing value must be of type ncfloat !!!
       iret = nf_get_att_real(ncout, ido, 'missing_value', spval) 
       if (iret/=0) then
        print*,' ERROR: cannot find attribute missing value'
        print*,' for variable'
        stop
       endif
      endif

      print*,'    (# of dimensions=',ndims,
     &       ' new dimensions = ',count2,')'

      if (xtype == nclong) then

       allocate( bufi(count(1),count(2),count(3),count(4)) )
       iret= nf_get_vara_int(ncin,idi ,start,count,bufi)

       if (count(1) > count2(1) .and. ndims>1 ) then
        call foldi(bufi,count2(1),count(1),count(2),
     &                  count(3),count(4),spval,use_max)
        print*,'    folding integer variable ',name(1:len_trim(name))
       endif
       iret= nf_put_vara_int(ncout,ido ,start,count2,
     &   bufi(1:count2(1),1:count2(2),1:count2(3),1:count2(4)) )

       deallocate(bufi)

      elseif (xtype == ncfloat) then


       allocate( buff(count(1),count(2),count(3),count(4)) )
       iret= nf_get_vara_real(ncin,idi ,start,count,buff)

       if (count(1) > count2(1) .and. ndims>1 ) then
        call foldf(buff,count2(1),count(1),count(2),
     &                  count(3),count(4),spval,use_max)
        print*,'    folding real variable ',name(1:len_trim(name))
       endif
       iret= nf_put_vara_real(ncout,ido ,start,count2,
     &   buff(1:count2(1),1:count2(2),1:count2(3),1:count2(4)) )

       deallocate(buff)


      elseif (xtype == ncdouble) then

       allocate( bufd(count(1),count(2),count(3),count(4)) )
       iret= nf_get_vara_double(ncin,idi ,start,count,bufd)

       if (count(1) > count2(1) .and. ndims>1 ) then
        call foldd(bufd,count2(1),count(1),count(2),
     &                  count(3),count(4),spval,use_max)
        print*,'    folding double variable ',name(1:len_trim(name))
       endif
       iret= nf_put_vara_double(ncout,ido ,start,count2,
     &   bufd(1:count2(1),1:count2(2),1:count2(3),1:count2(4)) )

       deallocate(bufd)

      else
       print*,' do not know how to handle NCtype ',xtype
       stop
      endif

      ret=0

      end



      subroutine try_fold(kmt,imtuf,jmt,maxfold)
      implicit none
      integer imtuf,jmt,kmt(imtuf,jmt)

      integer maxfold,i,j,l1(imtuf),l2(imtuf),l3(imtuf),mask(imtuf)
      integer m1,m2,imtm1,imt,ii
      logical twin
      character (len=1) :: mark
c
      maxfold=0
      do j=1,jmt-1
c
c transfer j-row and set mask
c
       do i=1,imtuf
        l1(i)=kmt(i,j)
        mask(i)=0
        if(kmt(i,j).gt.0) mask(i)=1
       end do
c
c look for eastern and western boundaries
c
       do i=1,imtuf
        if(mask(i).ne.0)goto 234
       end do
  234  m1=i-1
       do i=imtuf,1,-1
        if(mask(i).ne.0)goto 345
       end do
  345  m2=i+1
c
c determine imt
c
c       imt=imtuf-max(m1,imtuf-m2)+2   ! too soft
       imt=imtuf-(m1+imtuf-m2)+3  ! see Iceland for explanation
c       imt=imtuf-(m1+imtuf-m2)+2  ! without is(ce)land constraint
       imt=max(imt,imtuf/2+2)
       imtm1=imt-1
c
c clear buffers
c
       do i=1,imtuf
        l2(i)=0
        l3(i)=0
       end do
c
c fold l1 to l2
c
       do i=1,imtuf
        l2(i)=l1(i)
       end do
       do i=imtm1,imtuf
        ii=i-imt+2
        l2(ii)=max(l1(i),l1(ii))
       end do
       do i=imt+1,imtuf
        l2(i)=0
       end do
c
c unfold l2 to l3
c
       do i=1,imtuf
        l3(i)=l2(i)
       end do
       l3(1)=l2(imtm1)
       do i=imt,imtuf
        l3(i)=l2(i-imt+2)
       end do
c
c mask l3
c
       do i=1,imtuf
        l3(i)=l3(i)*mask(i)
       end do
c
c compare l1 and l3
c
       twin=.true.
       do i=1,imtuf
        if(l1(i).ne.l3(i))twin=.false.
       end do
       if (.not.twin) then
        write(6,'('' ...trying imt='',i5)')imt
        write(6,'(''     i  mask    l1    l2    l3'')')
        do i=1,imtuf
         mark=' '
         if(l1(i).ne.l3(i))mark='!'
         write(6,'(5i6,1x,a)')i,mask(i),l1(i),l2(i),l3(i),mark
        end do
        stop
       end if
c       write(6,'('' folding at j='',i5,'' possible with imt='',i5)')
c     &        j,imt
       maxfold=max(maxfold,imt)
      end do
c
      write(6,'(/'' overall folding possible with imt='',i5/)')maxfold
c

      end subroutine try_fold



      subroutine foldf(a,imtf,imtuf,jmt,km,nt,spval,use_max)
      implicit none
      integer imtf,imtuf,jmt,km,nt
      real (kind=4) :: a(imtuf,jmt,km,nt)
      integer i,j,k,ii,n
      real (kind=4) :: spval
      logical :: use_max
      do n=1,nt
      do k=1,km
       do j=1,jmt
        do i=imtf-1,imtuf
        ii=i-imtf+2
        if (use_max) then
         a(ii,j,k,n)=max(a(i,j,k,n),a(ii,j,k,n))
        else        
         if (a(ii,j,k,n) == spval) a(ii,j,k,n) = a(i,j,k,n)
        endif
        enddo
        do i=imtf+1,imtuf
         a(i,j,k,n)=0
        end do
        a(imtf,j,k,n)=a(2,j,k,n) ! apply cyclic boundary condition
       end do
      enddo
      enddo

      end



      subroutine foldd(a,imtf,imtuf,jmt,km,nt,spval,use_max)
      implicit none
      integer imtf,imtuf,jmt,km,nt
      real (kind=8) a(imtuf,jmt,km,nt)
      integer i,j,k,ii,n
      real (kind=4) :: spval
      logical :: use_max
      do n=1,nt
      do k=1,km
       do j=1,jmt
        do i=imtf-1,imtuf
        ii=i-imtf+2
        if (use_max) then
         a(ii,j,k,n)=max(a(i,j,k,n),a(ii,j,k,n))
        else
         if (a(ii,j,k,n) == spval) a(ii,j,k,n) = a(i,j,k,n)
        endif
        enddo
        do i=imtf+1,imtuf
         a(i,j,k,n)=0
        end do
        a(imtf,j,k,n)=a(2,j,k,n) ! apply cyclic boundary condition
       end do
      enddo
      enddo
      end



      subroutine foldi(a,imtf,imtuf,jmt,km,nt,spval,use_max)
      implicit none
      integer imtf,imtuf,jmt,km,nt
      integer a(imtuf,jmt,km,nt)
      integer i,j,k,ii,n
      real (kind=4) :: spval
      logical :: use_max
      do n=1,nt
      do k=1,km
       do j=1,jmt
        do i=imtf-1,imtuf
        ii=i-imtf+2
        if (use_max) then
         a(ii,j,k,n)=max(a(i,j,k,n),a(ii,j,k,n))
        else
         if (a(ii,j,k,n) == spval) a(ii,j,k,n) = a(i,j,k,n)
        endif 
        enddo
        do i=imtf+1,imtuf
         a(i,j,k,n)=0
        end do
        a(imtf,j,k,n)=a(2,j,k,n) ! apply cyclic boundary condition
       end do
      enddo
      enddo
      end

c
c     util need this mpp stuff
c     which is disabled here anyway
c
      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"



      subroutine diag_press
c
c-----------------------------------------------------------------------
c     solve for the surface pressure, compute SSH and bottom pressure
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      real, dimension(is_pe:ie_pe,js_pe:je_pe,-1:1,-1:1) :: coef
      real, dimension(is_pe:ie_pe,js_pe:je_pe)           :: forc,hsp
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1)   :: res
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1,2) :: nabla_p
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1)   :: sfp

      integer :: i,j,k,n,is,ie,js,je
      real :: spval=-9.9e12,tt
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer :: npe,ncid,iret,sfpid,hspid,timedim,timeid
      integer :: corner(4),edges(4)
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:)
#else
      real         , allocatable :: v4(:,:)
#endif
#else
      integer :: io
      real :: buf(imt,jmt)
#endif

      if (my_pe==0) then
       print*,' diagnosing surface pressure '
      endif

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      nabla_p = 0.
      do n=1,2
       do j=js,je
        do k=1,km
         do i=is,ie
          nabla_p(i,j,n) = nabla_p(i,j,n) +
     &       (u(i,k,j,n,taup1)-u(i,k,j,n,taum1))/c2dt 
#ifdef partial_cell
     &                       *dhu(i,k,j)
#else
     &                       *dzt(k)
#endif
         enddo
        enddo
       enddo
       do j=js,je
        do i=is,ie
          nabla_p(i,j,n) = nabla_p(i,j,n)*hr(i,j)-zu(i,j,n)
        enddo
       enddo
      enddo
      call border_exchg(nabla_p(:,:,1),1,1)
      call set_cyclic(  nabla_p(:,:,1),1,1)
      call border_exchg(nabla_p(:,:,2),1,1)
      call set_cyclic(  nabla_p(:,:,2),1,1)

      coef=0.; forc=0.; res=0.; sfp=0.
      call spforc (nabla_p, forc )
      call spc9pt (coef)
      call congr (sfp, res, forc, coef, eps_surf_press,.false.)
c     ssh=sfp/(rho0*grav)/100.
      sfp=sfp*10./100000. ! cgs -> SI ,pascal -> bar
      if (my_pe==0) print*,' iterations of the solver : ',itts_solver
c
c     remove mean and checkerboard
c
      call checkerboard(sfp)
      call border_exchg(sfp,1,1)
      call set_cyclic(  sfp,1,1)

c      call zero_level(sfp,' surface pressure')
      call border_exchg(sfp,1,1)
      call set_cyclic(  sfp,1,1)
c
c     hydrostatic pressure
c
      hsp=0.
      do j=js,je
       do k=1,km
        do i=is,ie
         hsp(i,j) = hsp(i,j) - grav*rho(i,k,j)*tmask(i,k,j)
#ifdef partial_cell
     &                       *dhu(i,k,j)
#else
     &                       *dzt(k)
#endif
        enddo
       enddo
      enddo
      hsp = hsp*10 /100000. ! cgs -> SI, pascal -> bar

      if (my_pe==0) then
       print*,' --> writing diagnostic pressure to file ',
     &        diag_press_file(1:len_trim(diag_press_file))
      endif

#ifdef netcdf_diagnostics
c     write to netcdf format here
      do npe=0,n_pes
       call barrier
       if (my_pe==npe) then
        iret=nf_open(diag_press_file,NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_varid(ncid,'sfp',sfpid)
        iret=nf_inq_varid(ncid,'hsp',hspid)
        iret=nf_inq_varid(ncid,'Time',timeid)
        iret=nf_inq_dimid(ncid,'Time',timedim)
        iret=nf_inq_dimlen(ncid, timedim,n)
        allocate( v4(is_pe:ie_pe,js_pe:je_pe) )
        if (my_pe==0) then
         n=n+1
         corner(1)=n
         edges(1)=1
         call read_stamp(current_stamp,tt)
         print*,' at stamp=',current_stamp,
     &          ' (days since origin : ',tt,')',
     &          ' (time steps in file : ',n,')'
         v4(is_pe,js_pe)=tt
         iret= nf_put_vara_real (ncid,timeid, corner,edges,v4)
        endif
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        v4=sfp(is_pe:ie_pe,js_pe:je_pe)
        where( tmask(is_pe:ie_pe,1,js_pe:je_pe)==0) v4=spval
        iret= nf_put_vara_real (ncid,sfpid ,corner, edges,v4)
        v4=hsp(is_pe:ie_pe,js_pe:je_pe)
        where( tmask(is_pe:ie_pe,1,js_pe:je_pe)==0) v4=spval
        iret= nf_put_vara_real (ncid,hspid ,corner, edges,v4)
        call ncclos (ncid, iret)
       endif
       call barrier
      enddo
#else
      if (my_pe==0) then
       call getunit(io,diag_press_file,'usa ieee')
       write (io) current_stamp, itt
       write (io) imt,jmt
       write (io) spval
       write (io) xt,yt
      endif

      buf(is_pe:ie_pe,js_pe:je_pe)=sfp(is_pe:ie_pe,js_pe:je_pe)
      where(tmask(is_pe:ie_pe,1,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf

      buf(is_pe:ie_pe,js_pe:je_pe)=hsp(is_pe:ie_pe,js_pe:je_pe)
      where(tmask(is_pe:ie_pe,1,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf

      if (my_pe==0) close(io)

#endif
      end subroutine diag_press




      subroutine init_diag_press
      use spflame_module
      implicit none
#ifdef netcdf_diagnostics

#include "netcdf.inc"
      integer ncid,iret,i,j,k
      real :: spval=-9.9e12
      integer lat_tdim,itimedim, lon_tdim
      integer lat_tid,itimeid,lon_tid,sfpid,hspid
      integer dims(4), corner(4), edges(4)
      character name*24, unit*16, text*80
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:)
#else
      real         , allocatable :: v4(:)
#endif

      if (my_pe == 0) then
      print*,' initializing NetCDF output file ',
     &        diag_press_file(1:len_trim(diag_press_file))
      ncid = nccre (diag_press_file, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call store_info_cdf(ncid)
c     dimensions
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)

      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      sfpid=ncvdef (ncid,'sfp', NCFLOAT,3,dims,iret)
      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      hspid=ncvdef (ncid,'hsp', NCFLOAT,3,dims,iret)
c     attributes of the grid
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on T grid      '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c     attributes of variables
      name = 'Sea surface pressure'; unit = 'bar'
      call dvcdf(ncid,sfpid,name,24,unit,16,spval)
      name = 'Hydrostatic pressure'; unit = 'bar'
      call dvcdf(ncid,hspid,name,24,unit,16,spval)
      call ncendf(ncid, iret)

      allocate( v4(max(imt,jmt)) )
      corner(1) = 1; edges(1) = jmt
      v4(1:jmt)=yt
      call ncvpt(ncid, Lat_tid, corner, edges,v4, iret)
      corner(1) = 1; edges(1) = imt
      v4(1:imt)=xt
      call ncvpt(ncid, lon_tid, corner, edges,v4, iret)
      deallocate(v4)
      call ncclos (ncid, iret)
      print*,' done'
      endif ! my_pe==0
#else
c     needs no intialisaztion
#endif
      end subroutine init_diag_press

#include "options.inc"

c#define convert_restart
c
c
#ifdef convert_restart
c
c     convert binary restart file of averaged blue correction
c     (annual mean version) to NetCDF format
c
#else
c
c     convert binary file containing averaged blue correction
c     (annual mean version) written during model run to NetCDF format
c
#endif
c
c#define real_8

      module kind_mod
#ifdef real_8
      integer, parameter::  r_knd  = selected_real_kind(13)
#else
      integer, parameter::  r_knd  = selected_real_kind(6)
#endif
      end module kind_mod


      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end


      program cv_blue_mean
      use kind_mod
      implicit none

      real (kind=r_knd), allocatable, dimension(:,:,:) :: corr
      real (kind=r_knd), allocatable, dimension(:)   :: xt,yt,zt
      real (kind=r_knd) :: dd
      real (kind=r_knd) :: spval=-9.9e12

      integer :: imt,jmt,km
      integer :: counter
      integer, allocatable, dimension(:,:)     :: kmt
      integer :: i,j,k,io
      character (len=80) :: infile,outfile

#include "netcdf.inc"
      character (len=80) :: name,unit
      integer ncid,iret,dims(4),start(4),count(4)
      integer :: lon_tdim,lon_tid
      integer :: lat_tdim,lat_tid
      integer :: depth_tdim,depth_tid
      integer :: itimedim,itimeid
      integer :: blueid,n,len
      integer :: year,month,day,domain

      character (len=15) :: c15
      character (len=1) :: c1
      character (len=2) :: c2
      character (len=4) :: c4


#ifdef convert_restart
      print*,' Converting blue_mean restart written by SPFLAME ',
     &       ' to NetCDF file '
      call get_commandline_arg(1,infile,iret)
      if (iret/=0) goto 99
      print*,' reading from file ',infile(1:len_trim(infile))
      call get_commandline_arg(2,outfile,iret)
      if (iret/=0) goto 99
      print*,' writing to file ',outfile(1:len_trim(outfile))
#else
      print*,' Converting blue_mean correction written by SPFLAME ',
     &       ' to NetCDF file '
      call get_commandline_arg(1,infile,iret)
      if (iret/=0) goto 99
      print*,' reading from file ',infile(1:len_trim(infile))

      read(infile,'(a15,i3,a2,i4,a1,i2,a1,i2,a4)') 
     &            c15,domain,c2,year,c1,month,c1,day,c4

      write(outfile,
     &   '("blue_mean_corr_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            domain,year,month,day
      do i=1,len_trim(outfile);
        if (outfile(i:i)==' ')outfile(i:i)='0';
      enddo
      print*,' sub domain = ',domain
      print*,' year/month/day  = ',year,month,day
      print*,' writing to file ',outfile

#endif

#ifdef convert_restart
c     read in the grid from a binary file
      print*,
     & ' =>Reading the grid definition from file grid.dta'
      call getunit (io, 'grid.dta', 'u s r ieee')
      read (io) ! no checks for awi id
      read (io) imt, jmt, km

      print*,' found dimensions: '
      print*,' imt=',imt,' jmt=',jmt,' km=',km

      allocate( xt(imt), yt(jmt), zt(km) )
      
      read (io) (dd,i=1,imt)
     &,         (dd,j=1,jmt)
     &,         (dd,i=1,imt)
     &,         (dd,j=1,jmt)
     &,         (dd,k=1,km)
     &,         (dd,k=0,km)
     &,         (xt(i),i=1,imt)
     &,         (dd,i=1,imt)
     &,         (yt(j),j=1,jmt)
     &,         (dd,j=1,jmt)
     &,         (zt(k),k=1,km)
     &,         (dd,k=1,km)

      close (io)

      allocate( kmt(imt,jmt) )
      print*,
     & ' =>Reading a "kmt" field from binary file kmt.dta'
      call getunit (io, 'kmt.dta', 'usr ieee')
      read (io) ! no checks
c       skip header record and read dimensional info
      read (io) 
      read (io) i, j, k
c      check i,j,k
      if (i/=imt .or. j /= jmt .or. k/= km) then
         print*,' Error: '
         print*,' read imt,jmt,km=',i,j,k
         print*,' but previously ',imt,jmt,km
        call halt_stop(' reading kmt file ')
       endif
      read (io) 
      read (io) kmt
      close(io)

      allocate( corr( imt,jmt,km) )

      call getunit (io, infile, 'usr ieee')
      read (io) counter
      do k=1,km
        read(io) corr(:,:,k),corr(:,:,k)
      enddo
      close(io)
#else
c
c     all contained in one file
c
      call getunit (io, infile, 'usr ieee')
      read(io) imt,jmt,km
      print*,' imt=',imt,' jmt=',jmt,' km=',km
      allocate( xt(imt),yt(jmt),zt(km))
      allocate( kmt(imt,jmt) )
      allocate( corr(imt,jmt,km) )
      read(io) xt,yt,zt
      read(io) counter
      print*,' counter for averages=',counter
      read(io) kmt
      do k=1,km
         read(io) corr(:,:,k)
      enddo
      close(io)

#endif


      dd=365./2. 

      print*,' writing to file ',outfile

      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c       dimensions
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', 1, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c     attributes of the grid
      name = 'Longitude on T grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &'31-DEC-1899 00:00:00', iret)
c     variables
      dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
      blueid=ncvdef (ncid,'blue_corr', NCFLOAT,4,dims,iret)
c     attributes of variables
      name = 'Correction to momentum equation'; unit = 'kg/m^3'
      call dvcdf_here(ncid,blueid,name,24,unit,16,spval)
      call ncendf(ncid, iret)

      zt=zt/100.

#ifdef real_8
      iret= nf_put_vara_double(ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_double(ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_double(ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_double(ncid,itimeid,1,1,dd)
#else
      call ncvpt(ncid, Lon_tid, 1, imt,xt, iret)
      call ncvpt(ncid, Lat_tid, 1, jmt,yt, iret)
      call ncvpt(ncid, depth_tid, 1, km,zt, iret)
      call ncvpt(ncid, itimeid, 1, 1,dd, iret)
#endif

c     convert to SI units 
      corr=corr*1000.   ! g/cm^3 -> kg/m^3

c     apply land mask and write to file
      do k=1,km
       where( kmt <k ) corr(:,:,k) = spval
       start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
       iret= nf_put_vara_double(ncid,blueid,start,count,corr(:,:,k))
#else
       iret= nf_put_vara_real(ncid,blueid,start,count,corr(:,:,k))
#endif
      enddo
      call ncclos (ncid, iret)

      stop

 99   print*,' program needs command line parameter'
#ifdef convert_restart
      print*,' 1. input binary file (blue_mean restart file)'
      print*,' 1. output NetCDF file '
#else
      print*,' 1. input binary file'
#endif

      end program cv_blue_mean



      subroutine dvcdf_here(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c     define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      use kind_mod
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character*(*) name, unit
      real (kind=r_knd):: spval
      real (kind=4):: vv
#include "netcdf.inc"
      vv=spval
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncapt (ncid,ivarid, 'missing_value',NCFLOAT,1,vv,iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncapt (ncid,ivarid, '_FillValue', NCFLOAT, 1,vv, iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf_here

#include "options.inc"
c
c--------------------------------------------------------------
c      Routines for communication between processors
c      based on MPI 1.0
c
c             C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c--------------------------------------------------------------
c
#ifdef no_mpp
c
c--------------------------------------------------------------
c     some dummy routines, if MPI service is disabled
c--------------------------------------------------------------
c
      subroutine mpi_comm_rank(comm,my_pe,ierr)
      implicit none
      integer comm,my_pe,ierr
      ierr=0
      my_pe=0
      end subroutine mpi_comm_rank

      subroutine mpi_comm_size(comm,n_pes,ierr)
      implicit none
      integer comm,n_pes,ierr
      ierr=0
      n_pes=1
      end subroutine mpi_comm_size

      subroutine mpi_init(ierr)
      integer ierr
      end subroutine mpi_init

      subroutine mpi_finalize(ierr)
      integer ierr
      end subroutine mpi_finalize
#endif



      subroutine mpi_test()
c
c--------------------------------------------------------------
c     test some basic mpi routines, i.e. the type declaration
c     in sub_mpif.h
c--------------------------------------------------------------
c
#ifndef no_mpp
      implicit none
      integer :: ierr,my_pe=-1,all_pes
      integer :: xint,xint2
      real    :: xreal,xreal2
#include "sub_mpif.h"
c
c   get some mpi infos first
c
      print*,' performing MPI test ...'
      call mpi_comm_rank(MPI_COMM_WORLD,my_pe,ierr)
      if (ierr/=0) goto 20
      call mpi_comm_size(MPI_COMM_WORLD,all_pes,ierr)
      if (ierr/=0) goto 20
c
c   try first global barrier
c
      print*,' tyring first global barrier for PE #',my_pe
      call mpi_barrier(mpi_comm_world, ierr)
      if (ierr/=0) goto 20
c
c   try broadcasting
c
      print*,' tyring global broadcast for PE #',my_pe
      xreal = 1.0
      call mpi_bcast(xreal,1,impireal,0,mpi_comm_world,ierr)
      if (ierr/=0) goto 20
      xint = 1
      call mpi_bcast(xint,1,impiinteger,0,mpi_comm_world,ierr)
      if (ierr/=0) goto 20
c
c   check results of broadcasting
c
      if (xreal /= 1.0 ) then
       print*,' fatal: MPI test failed on broadcasting reals for ',
     &             'PE #',my_pe
       call halt_stop(' in mpi_test')
      endif
      if (xint /= 1 ) then
       print*,' fatal: MPI test failed on broadcasting integer for ',
     &             'PE #',my_pe
       call halt_stop(' in mpi_test')
      endif
      call mpi_barrier(mpi_comm_world, ierr)
      if (ierr/=0) goto 20

c
c   try global sum
c
      xreal = 2.0
      call mpi_allreduce(xreal,xreal2,1,impireal,MPI_SUM,
     &            mpi_comm_world,ierr)
      if (ierr/=0) goto 20
      xint = 2.0
      call mpi_allreduce(xint,xint2,1,impiinteger,MPI_SUM,
     &            mpi_comm_world,ierr)
      if (ierr/=0) goto 20
c
c   check results 
c
      xreal = xreal2/all_pes
      if (xreal /= 2.0 ) then
       print*,' fatal: MPI test failed on global sum (real) for ',
     &             'PE #',my_pe
       call halt_stop(' in mpi_test')
      endif
      xint = xint2/all_pes
      if (xint /= 2.0 ) then
       print*,' fatal: MPI test failed on global sum (int) for ',
     &             'PE #',my_pe
       call halt_stop(' in mpi_test')
      endif
      call mpi_barrier(mpi_comm_world, ierr)
      if (ierr/=0) goto 20

c
c   try point to point protocol
c
c   to be done
      call mpi_barrier(mpi_comm_world, ierr)
      if (ierr/=0) goto 20

      print*,' MPI test okay for PE #',my_pe,' .'

      return
      stop

 20   continue
      print*,' fatal: MPI test failed on'
      print*,' PE #',my_pe,' error message:'
      call print_mpi_error(ierr)
      call halt_stop(' in mpi_test')
#else
      print*,' performing MPI test ...'
      print*,' no MPI service present ',
     &         '(disable cpp option no_mpp to enable MPP)'
      return
#endif
      end subroutine mpi_test


      subroutine split_pes(domains,n_pes_domains,
     &   my_comm,sub_domain,sub_domain_pe0)
c
c--------------------------------------------------------------
c     split all PEs into several groups, which
c     are the sub domains
c--------------------------------------------------------------
c
      implicit none
      integer, intent(in)  :: domains                ! number of domains
      integer, intent(in)  :: n_pes_domains(domains) ! number of pes in domains
      integer, intent(out) :: sub_domain             ! number of sub domain
      integer, intent(out) :: my_comm                ! local communicator
      integer, intent(out) :: sub_domain_pe0(domains)! rank of leading PE of 
                                                     ! sub domain in global 
                                                     ! address space
#ifdef no_mpp
      sub_domain=0
      my_comm=1
      sub_domain_pe0=0

#else
# include "sub_mpif.h"
      integer ierr,all_pes,my_pe
      integer color,key,n,k
      call mpi_barrier(mpi_comm_world, ierr)
      call mpi_comm_size(MPI_COMM_WORLD,all_pes,ierr)
      call mpi_comm_rank(MPI_COMM_WORLD,my_pe,ierr)


      k=0
      do n=1,domains
        k=k+n_pes_domains(n)
      enddo
      if (k /= all_pes) then
        if (my_pe == 0) then
         print*,' Number of all PEs (=',all_pes,')'
         print*,' does not match number of PEs in sub domains'
         do n=1,domains
          print*,' nr of PEs in domain ',n,' = ',n_pes_domains(n)
         enddo
        endif
        call halt_stop(' in split_pes ')
      endif


      k=0
      color=-1
      do n=1,domains
        sub_domain_pe0(n)=k
        k=k+n_pes_domains(n)
        if (my_pe < k.and. color == -1 ) then
          color=n
          key=my_pe-(k-n_pes_domains(n))
c          key=0
          sub_domain=n-1
        endif
      enddo
      call mpi_comm_split(MPI_COMM_WORLD,color,key,my_comm,ierr)
      call print_mpi_error(ierr)
c      print*,'color=',color,'key=',key,'my_pe=',my_pe,'comm',my_comm
      call mpi_barrier(mpi_comm_world, ierr)


#endif
      end subroutine split_pes



      subroutine print_mpi_error(ierr)
c
c--------------------------------------------------------------
c     print out MPI error message
c--------------------------------------------------------------
c
#ifndef no_mpp
      implicit none
      integer :: ierr,ierr2,len
      character*80 :: string
      if (ierr/=0) then
       call MPI_ERROR_STRING(ierr,string, LEN, ierr2)
       print*,' MPI ERROR:',ierr
       print*,'           ',string(1:len)
      endif
#else
      implicit none
      integer :: ierr
#endif
      end subroutine print_mpi_error



      subroutine halt_stop(string)
c--------------------------------------------------------------
c     controlled stop
c--------------------------------------------------------------
      implicit none
      character*(*) :: string
      integer :: ierr,code,my_pe
#ifndef no_mpp
#include "sub_mpif.h"
#endif

#ifdef no_mpp
      print*,string
#else
      call mpi_comm_rank(MPI_COMM_WORLD,my_pe,ierr)
      print*,' global pe #',my_pe,' : ',string
      print*,' global pe #',my_pe,' aborting '
#endif

#ifdef no_mpp
      call abort()
#else
      code=99
      call MPI_ABORT(mpi_comm_world, code, IERR)
#endif

      end subroutine halt_stop



      subroutine barrier
c
c--------------------------------------------------------------
c     A barrier for the local sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
      integer :: ierr

      call mpi_barrier(my_comm, ierr)
      call print_mpi_error(ierr)
#endif
      end subroutine barrier




      subroutine bcast_real(x,len,pe)
c
c--------------------------------------------------------------
c     Broadcast a real vector to the local sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
      integer len,ierr,pe
      real x(len)
#include "sub_mpif.h"
      call mpi_barrier(my_comm, ierr)
      call mpi_bcast(x,len,impireal,pe,my_comm,ierr)
#else
      implicit none
      integer :: len,pe
      real :: x
#endif
      end subroutine bcast_real

      subroutine bcast_integer(x,len,pe)
c
c--------------------------------------------------------------
c     Broadcast a integer vector to the local sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
      integer len,ierr,pe
      integer x(len)
#include "sub_mpif.h"
      call mpi_barrier(my_comm, ierr)
      call mpi_bcast(x,len,impiinteger,pe,my_comm,ierr)
#else
      implicit none
      integer :: len,x,pe
#endif
      end subroutine bcast_integer

      subroutine bcast_char(x,len,pe)
c
c--------------------------------------------------------------
c     Broadcast a character vector to the local sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
      integer len,ierr,pe
      character x(*)
#include "sub_mpif.h"
      call mpi_barrier(my_comm, ierr)
      call mpi_bcast(x,len,mpi_character,pe,my_comm,ierr)
#else
      implicit none
      integer :: len,pe
      character x(*)
#endif
      end subroutine bcast_char


      subroutine bcast_logical(x,len,pe)
c
c--------------------------------------------------------------
c     Broadcast a logical vector to the local sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
      integer len,ierr,pe
      logical x(len)
#include "sub_mpif.h"
      call mpi_barrier(my_comm, ierr)
      call mpi_bcast(x,len,mpi_logical,pe,my_comm,ierr)
#else
      implicit none
      integer :: len,pe
      logical :: x
#endif
      end subroutine bcast_logical





      subroutine bcast_world_real(x,len,pe)
c
c--------------------------------------------------------------
c     Broadcast a real vector to all sub domains
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
      integer len,ierr,pe
      real x(len)
#include "sub_mpif.h"
      call mpi_barrier(mpi_comm_world, ierr)
      call mpi_bcast(x,len,impireal,pe,mpi_comm_world,ierr)
#else
      implicit none
      integer :: len,pe
      real :: x
#endif
      end subroutine bcast_world_real

      subroutine bcast_world_integer(x,len,pe)
c
c--------------------------------------------------------------
c     Broadcast an integer vector to all sub domains
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
      integer len,ierr,pe
      integer x(len)
#include "sub_mpif.h"
      call mpi_barrier(mpi_comm_world, ierr)
      call mpi_bcast(x,len,impiinteger,pe,mpi_comm_world,ierr)
#else
      implicit none
      integer :: len,pe
      integer x
#endif
      end subroutine bcast_world_integer

      subroutine bcast_world_logical(x,len,pe)
c
c--------------------------------------------------------------
c     Broadcast a logical vector to all sub domains
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
      integer len,ierr,pe
      logical x(len)
#include "sub_mpif.h"
      call mpi_barrier(mpi_comm_world, ierr)
      call mpi_bcast(x,len,mpi_logical,pe,mpi_comm_world,ierr)
#else
      implicit none
      integer :: len,pe
      logical x
#endif
      end subroutine bcast_world_logical



      subroutine recv_integer(x,len,pe,tag)
c
c--------------------------------------------------------------
c     Reveive an integer vector from PE pe in local sub domain
c--------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer len,ierr,pe,tag
      integer x(len)
#ifndef no_mpp
#include "sub_mpif.h"
      integer :: status(MPI_STATUS_SIZE)
      call mpi_recv(x,len,MPI_INTEGER,pe,tag,my_comm,Status,ierr)
#endif
      end subroutine recv_integer

      subroutine send_integer(x,len,pe,tag)
c
c--------------------------------------------------------------
c     Send an integer vector to PE pe in local sub domain
c--------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer len,ierr,pe,tag
      integer x(len)
#ifndef no_mpp
#include "sub_mpif.h"
      call mpi_send (x,len,MPI_INTEGER,pe,tag,my_comm,ierr)
#endif
      end subroutine send_integer


      subroutine recv_world_integer(x,len,pe,tag)
c
c--------------------------------------------------------------
c     Receive an integer vector from PE pe in global space
c--------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer len,ierr,pe,tag
      integer x(len)
#ifndef no_mpp
#include "sub_mpif.h"
      integer :: status(MPI_STATUS_SIZE)
      call mpi_recv(x,len,MPI_INTEGER,pe,tag,
     &              mpi_comm_world,Status,ierr)
#endif
      end subroutine recv_world_integer

      subroutine send_world_integer(x,len,pe,tag)
c
c--------------------------------------------------------------
c     Send an integer vector to PE pe in global space
c--------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer len,ierr,pe,tag
      integer x(len)
#ifndef no_mpp
#include "sub_mpif.h"
      call mpi_send (x,len,MPI_INTEGER,pe,tag,
     &               mpi_comm_world,ierr)
#endif
      end subroutine send_world_integer


      subroutine global_sum(x)
c
c--------------------------------------------------------------
c     Do a sum of real x over all PEs in sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      real    :: x, x_sym,x_sym2
      integer :: ierr
c     skip this copying overhead  here
      x_sym = x
      call mpi_allreduce(x_sym,x_sym2,1,impireal,MPI_SUM,my_comm,ierr)
      call print_mpi_error(ierr)
      x = x_sym2
#else
      implicit none
      real :: x
#endif
      end subroutine global_sum

      subroutine global_sum_int(x)
c
c--------------------------------------------------------------
c     Do a sum of integer x over all PEs in sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      integer    :: x, x_sym,x_sym2
      integer :: ierr
c     skip this copying overhead  here
      x_sym = x
      call mpi_allreduce(x_sym,x_sym2,1,impiinteger,
     &                   MPI_SUM,my_comm,ierr)
      call print_mpi_error(ierr)
      x = x_sym2
#else
      implicit none
      real :: x
#endif
      end subroutine global_sum_int



      subroutine global_sum_vec(x,len)
c
c--------------------------------------------------------------
c     Do a sum of real vecter x(len) over all PEs in sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      integer :: ierr,len
      real    :: x(len), x_sym(len),x_sym2(len)
c     skip this copying overhead  here
      x_sym(1:len) = x(1:len)
      call mpi_allreduce(x_sym,x_sym2,len,impireal,MPI_SUM,my_comm,ierr)
      call print_mpi_error(ierr)
      x(1:len) = x_sym2(1:len)
#else
      implicit none
      real :: x
      integer :: len
#endif
      end subroutine global_sum_vec



      subroutine global_lor(x)
c
c--------------------------------------------------------------
c     Do a OR of logical x over all PEs in sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      logical    :: x, x_sym,x_sym2
      integer :: ierr
c     skip this copying overhead  here
      x_sym = x
      call mpi_allreduce(x_sym,x_sym2,1,mpi_logical,
     &                   MPI_LOR,my_comm,ierr)
      call print_mpi_error(ierr)
      x = x_sym2
#else
      implicit none
      logical :: x
#endif
      end subroutine global_lor


      subroutine global_lor_vec(x,len)
c
c--------------------------------------------------------------
c     Do a OR of logical x over all PEs in sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      logical    :: x(len), x_sym(len),x_sym2(len)
      integer :: ierr,len
c     skip this copying overhead  here
      x_sym = x
      call mpi_allreduce(x_sym,x_sym2,len,mpi_logical,
     &                   MPI_LOR,my_comm,ierr)
      call print_mpi_error(ierr)
      x = x_sym2
#else
      implicit none
      logical :: x
      integer :: len
#endif
      end subroutine global_lor_vec




      subroutine global_max(x)
c
c--------------------------------------------------------------
c     Get the max of real x over all PEs in sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      real    :: x, x_sym,x_sym2
      integer :: ierr
c     skip this copying overhead  here
      x_sym = x
      call mpi_allreduce(x_sym,x_sym2,1,impireal,MPI_MAX,my_comm,ierr)
      call print_mpi_error(ierr)
      x = x_sym2
#else
      implicit none
      real :: x
#endif
      end subroutine global_max

      subroutine global_min(x)
c
c--------------------------------------------------------------
c     Get the a min of real x over all PEs in sub domain
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      real    :: x, x_sym,x_sym2
      integer :: ierr
c     skip this copying overhead  here
      x_sym = x
      call mpi_allreduce(x_sym,x_sym2,1,impireal,MPI_MIN,my_comm,ierr)
      x = x_sym2
#else
      implicit none
      real :: x
#endif
      end subroutine global_min

#include "options.inc"
c
c-----------------------------------------------------------------------
c      Templates for hardwired grid, topography, surface boundary
c      and initial concitions.
c-----------------------------------------------------------------------
c

      module eddy1b_module
c      real :: Bv0 = 0.004, g=9.81 
c      real :: fac = -20.0
c      real :: tscl = 1./(86400.0*20.0)
      real :: Bv0 = 0.004, g=9.81 
      real :: fac = -10.0
      real :: tscl = 1./(86400.0*1.0)
      end module eddy1b_module

      subroutine grid_template()
c-----------------------------------------------------------------------
c     set up a grid here
c-----------------------------------------------------------------------
      use spflame_module
      use eddy1b_module
      implicit none
      real :: dx=0.,dy=0.,dz=0.,x0=0.,y0=0.,sumt,sumu
      integer i,k
c     equidistant vertical grid
      integer,parameter :: km_in = 20
      real ddz(km_in)
      data ddz/ 20*100.e2/
c     small eddy resolving region
      x0=280.; y0=30.; dx = 1./3.; dy = dx*cos(y0/180.*pi)

      if (my_pe==0) then
        print*,''
        print*,'setting up a simple grid '
        print*,' dx= ',dx,' dy= ',dy
        print*,''
      endif
      dxtdeg =  dx  ; dytdeg =  dy  ; dxudeg =  dx  ; dyudeg =  dy  
      xt(1)=x0; xu(1)=x0+dxtdeg(1)/2.
      do i=2,imt
        xt(i)=xt(i-1)+dxtdeg(i); xu(i)=xu(i-1)+dxudeg(i)
      enddo
      yt(1)=y0; yu(1)=y0+dytdeg(1)/2.
      do i=2,jmt
        yt(i)=yt(i-1)+dytdeg(i); yu(i)=yu(i-1)+dyudeg(i)
      enddo
      if (km /= km_in ) then
        print*,' km must be ',km_in
        stop
      endif
      dzt=ddz; dzw(1) = dzt(1); sumt = dzt(1)
      sumu = 0.5*dzt(1) + dzw(1)
      do i=2,km
       sumt = sumt + dzt(i)
       dzw(i) = 2*(sumt-sumu)
       sumu = sumu + dzw(i)
      enddo
      zt(1) = 0.5*dzt(1); zw(1) = dzt(1)
      do i=2,km
        zw(i) = zw(i-1) + dzt(i); zt(i) = zt(i-1) + dzw(i-1)
      enddo
      dzw(0)  = zt(1); dzw(km) = zw(km) - zt(km)
      end subroutine grid_template



      subroutine kmt_template
c-----------------------------------------------------------------------
c     set up a simple topography
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      kmt_big=km
      end subroutine kmt_template



      subroutine htp_template
c-----------------------------------------------------------------------
c     set up a simple topography for partial cells
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      htp=zw(km)
      end subroutine htp_template



      subroutine init_cond_template
c-----------------------------------------------------------------------
c     setup simple initial conditions
c     for temperature, salinity and velocity
c     Note that streamfunction is diagnosed from full velocities.
c-----------------------------------------------------------------------
      use spflame_module
      use freesurf_module
      use eddy1b_module
      implicit none
      integer :: i,j,k,n
      real :: x,y,z,h0,h_w,T0
c-----------------------------------------------------------------------
c        A mesoscale front
c-----------------------------------------------------------------------
      do j=js_pe,je_pe
       do k=1,km
        do i=is_pe,ie_pe
            t(i,k,j,2,:) = 0.   ! salinity equals 35 PSU
            x=float(i)/float(imt)
            y=float(j)/float(jmt)
            T0=20+y*fac
            t(i,k,j,1,:) = T0+1/(g*alpha_lin)*zt(k)/100.*Bv0**2
     &       + 0.01*sin( x*2.0*2*pi)
            t(i,k,j,1,:) = t(i,k,j,1,:)*tmask(i,k,j)
        enddo 
       enddo
      enddo

      do n=1,nt
       call set_cyclic_4th_order(t(:,:,:,n,0),km,2)
       call set_cyclic_4th_order(t(:,:,:,n,1),km,2)
      enddo
      end subroutine init_cond_template


      subroutine sbc_template
c-----------------------------------------------------------------------
c     setup simple surface boundary conditions
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
c     no wind stress      
      smf=0.
c       no heat or salt fluxes
      stf_clim=0.
      stf_rest=0.
c       no wind stirring
      if (enable_ktmix.or.enable_tkemix) ustar=0.     ! no wind stirring
      end subroutine sbc_template



      subroutine blue_template
c-----------------------------------------------------------------------
c     setup simple temp / salinity arrays for BLUE
c-----------------------------------------------------------------------
      use spflame_module
      use blue_module
      implicit none
      end subroutine blue_template



      subroutine sponge_template(n)
c-----------------------------------------------------------------------
c     setup simple sponge layers. 
c-----------------------------------------------------------------------
      use spflame_module
      use eddy1b_module
      implicit none
      integer, intent(in) :: n ! number of the tracer
      integer :: i,j,k
      real :: x,y,z,h0,h_w,T0
      integer :: spg_width = 3

      if (n==1) then

       do j=js_pe,je_pe
         do k=1,km
          do i=is_pe,ie_pe
           x=float(i)/float(imt)
           y=float(j)/float(jmt)
           T0=20+y*fac+1/(g*alpha_lin)*zt(k)/100.*Bv0**2
           source(i,k,j)=source(i,k,j)+
     &        tscl*(T0-t(i,k,j,n,taum1))*tmask(i,k,j)
          enddo
         enddo
       enddo

      elseif (n==2) then

       if (my_blk_j==1) then
        do j=2,(spg_width+1)
         do k=1,km
          T0=1.0
          do i=is_pe,ie_pe
           source(i,k,j)=source(i,k,j)+
     &         tscl/(j-1.)*(T0-t(i,k,j,n,taum1))*tmask(i,k,j)
     &        *exp( - (zt(k)-500.e2)**2/ (250.e2)**2 )
          enddo
         enddo
        enddo
       endif
       if (my_blk_j==n_pes_j) then
        do j=jmt-1,jmt-spg_width,-1
         do k=1,km
          T0 = -1.0
          do i=is_pe,ie_pe
           source(i,k,j)=source(i,k,j)+
     &          tscl/(-1*(j-jmt))*
     &        (T0-t(i,k,j,n,taum1))*tmask(i,k,j)
     &        *exp( - (zt(k)-1500.e2)**2/ (250.e2)**2 )
          enddo
         enddo
        enddo
       endif


      endif
      end subroutine sponge_template

#include "options.inc"

c
c-----------------------------------------------------------------------
c     convert the nice netcdf forcing file to binary files
c     so that we do not have to use netcdf library for IO
c
c     output is grid.dta/ kmt.dta in the old FLAME format
c          temp.mom.ic/salt.mom.ic also in that old format
c     Byte length for real depends on this cpp directive
#define real_8
c
c
c     taux.mom,tauy.mom is a different format 
c     sst_clim.mom sst_rest.mom sss_clim.mom sss_rest.mom
c     and ustar.mom also in special format
c
c     writes also blue T/S files if present in netcdf file
c
c     to do: write file for glat 
c
#define new_cdf_file_names
c     use new outfile file naming for netcdf files
c#define apply_topo_mask_to_sbc
c     apply topographic mask to sbc to zero out land values
c     (this was the default up to Apr 2005).
c-----------------------------------------------------------------------
c

      module kind_mod
#ifdef real_8
      integer, parameter::  r_knd  = selected_real_kind(13)
#else
      integer, parameter::  r_knd  = selected_real_kind(6)
#endif
      end module kind_mod


      module prep_to_bin_mod
      use kind_mod
      use time_manager_module
      implicit none
      integer :: imt,jmt,km
      integer , allocatable :: kmt(:,:),kmu(:,:)
      real (kind=r_knd), allocatable, dimension(:) :: xt,yt,zt
      character (len=80) :: 
#ifdef new_cdf_file_names
     &     grid_file    = 'forcing_folded.cdf',
     &     ic_file      = 'forcing_folded_ic.cdf',
     &     ic_tr_file   = 'forcing_folded_ic_tracer.cdf',
     &     wind_file    = 'forcing_folded_wind.cdf',
     &     sflx_file    = 'forcing_folded_sflx.cdf',
     &     sflx_tr_file = 'forcing_folded_sflx_tracer.cdf',
     &     obc_file     = 'forcing_folded_obc.cdf',
     &     sponge_file  = 'forcing_folded_sponge.cdf'
#else
     &     grid_file    = 'forcing_folded.cdf',
     &     ic_file      = 'forcing_folded.cdf',
     &     ic_tr_file   = 'forcing_folded.cdf',
     &     wind_file    = 'forcing_folded.cdf',
     &     sflx_file    = 'forcing_folded.cdf',
     &     sflx_tr_file = 'forcing_folded.cdf',
     &     obc_file     = 'forcing_folded.cdf',
     &     sponge_file  = 'forcing_folded.cdf'
#endif
      end module prep_to_bin_mod


      program prep_to_bin
      use prep_to_bin_mod
      implicit none
      character (len=32) :: stamp 
      integer :: m,ret
      character (len=80) :: vname,fname

#include "netcdf.inc"
      integer   ncid,iret, xtid,ytid,ztid,dims(4)

      stamp ='m/d/y= 1/ 1/1900, h:m:s= 0: 0: 0' 
      call init_time_manager(3600.,5.0,5.0,stamp,0)

      iret=nf_open(grid_file,NF_noWRITE,ncid)

      iret=nf_inq_varid(ncid,'xt',xtid)
      iret=nf_inq_varid(ncid,'yt',ytid)
      iret=nf_inq_varid(ncid,'zt',ztid)
      iret=NF_INQ_VARDIMID (ncid,xtid,dims)
      iret=NF_INQ_DIMLEN   (ncid, dims(1), imt)
      iret=NF_INQ_VARDIMID (ncid,ytid,dims)
      iret=NF_INQ_DIMLEN   (ncid, dims(1), jmt)
      iret=NF_INQ_VARDIMID (ncid,ztid,dims)
      iret=NF_INQ_DIMLEN   (ncid, dims(1), km)
      call ncclos (ncid, iret)

      print*,'imt=',imt,' jmt=',jmt,' km=',km

      allocate( xt(imt), yt(jmt),  zt(km))
      allocate( kmt(imt,jmt), kmu(imt,jmt))


      call write_grid()
      call write_topo()
      call write_ic()
      call write_blue()
      call write_blue_mean()
      call write_sbc('taux','taux.mom',.true.,ret)
      call write_sbc('tauy','tauy.mom',.true.,ret)
      call write_sbc('ustar','ustar.mom',.false.,ret)

      call write_sbc('sst_clim','sst_clim.mom',.false.,ret)
      call write_sbc('sst_rest','sst_rest.mom',.false.,ret)
      call write_sbc('sst_flux','sst_flux.mom',.false.,ret)

      call write_sbc('sss_clim','sss_clim.mom',.false.,ret)
      call write_sbc('sss_rest','sss_rest.mom',.false.,ret)
      call write_sbc('sss_flux','sss_flux.mom',.false.,ret)

      m=3
 20   continue
       write(vname,'("str_",i2,"_clim")') m
       call replace_space_zero(vname)
       write(fname,'("str_",i2,"_clim.mom")') m
       call replace_space_zero(fname)
       call write_sbc(vname,fname,.false.,ret)

       write(vname,'("str_",i2,"_rest")') m
       call replace_space_zero(vname)
       write(fname,'("str_",i2,"_rest.mom")') m
       call replace_space_zero(fname)
       call write_sbc(vname,fname,.false.,ret)

       write(vname,'("str_",i2,"_flux")') m
       call replace_space_zero(vname)
       write(fname,'("str_",i2,"_flux.mom")') m
       call replace_space_zero(fname)
       call write_sbc(vname,fname,.false.,ret)

      if (ret==0) then; m=m+1; goto 20 ; endif

      call write_obc('south','obc_south.mom',1000)
      call write_obc('north','obc_north.mom',1000)
      call write_obc('east','obc_east.mom',1000)
      call write_obc('west','obc_west.mom',1000)

      call write_sponge(1000)

      call write_sbc('tauxBB','taux_BB.mom',.true.,ret)
      call write_sbc('tauyBB','tauy_BB.mom',.true.,ret)
      call write_sbc('hflxBB','hflx_BB.mom',.false.,ret)
      call write_sbc('sstm_BB','sst_mean_BB.mom',.false.,ret)
      call write_sbc('sstf_BB','sst_feed_BB.mom',.false.,ret)

c      call ncclos (ncid, iret)

      end program prep_to_bin





      subroutine write_sponge(ntr_max)
      use prep_to_bin_mod
      implicit none
      integer :: ntr_max
      character (len=80)::  vname,name,fname
      character (len=32):: stamp
      integer :: itm,n,id,tid,k,nspg,i,kk
      integer :: is,ie,js,je,io
      type( time_type) :: time
      character(len=2) :: number
      character(len=4) :: tr_name
      integer :: m,ntr

      real (kind=r_knd), allocatable :: trbuf(:,:,:),aprec(:)
      real (kind=r_knd), allocatable :: tsbuf(:,:,:)
      real (kind=r_knd) :: tstart

#include "netcdf.inc"
      integer   ncid,iret, start(4),count(4),dims(4)

      iret=nf_open(sponge_file,NF_noWRITE,ncid)

      if (iret /=0) then
       print*,' cannot find Sponge netcdf file '
       return
      endif 

      iret= nf_get_att_int(ncid,nf_global,'number_of_sponge_layers',
     &                     nspg  )

      do k=1,nspg

       print*,' processing sponge layer #',k

       write(number,'(i2)') k
       if (number(1:1) == ' ') number(1:1)='0'

       vname='temp_spg_'//number
       iret=nf_inq_varid(ncid,vname,id)
       if (iret /=0) then
        print*,' cannot find variable ',vname ,' in netcdf file'
        return
       endif

       m=3
 20    continue
        write(tr_name,'("tr",i2)') m
        call replace_space_zero(tr_name)
        iret=nf_inq_varid(ncid,tr_name//'_spg_'//number,id)
       if (iret==0) then; m=m+1; goto 20; endif
       ntr=m-1
       print*,' found ',ntr,' variables for sponge layer in netcdf file'
       if (ntr_max < ntr) then
        print*,' However, restricting number to ',ntr_max
        ntr=ntr_max
       endif

       iret=nf_inq_varid(ncid,'temp_spg_'//number,id)
       iret=NF_INQ_VARDIMID (NCID,id,dims)
       iret=NF_INQ_DIMLEN (NCID, dims(4), itm)
       name='';iret=NF_INQ_DIMname (NCID, dims(4), name)
       iret=nf_inq_varid(ncid,name,tid)

       print*,' time steps for sponge layer=',itm

       allocate( aprec(itm) )

       name='';iret= nf_get_att_text(ncid,tid ,'ave_period',name)
       iret=nf_inq_varid(ncid,name,id)
#ifdef real_8
       iret= nf_get_vara_double(ncid,id ,1,itm,aprec)
#else
       iret= nf_get_vara_real(ncid,id ,1,itm,aprec)
#endif

       name='';iret= nf_get_att_text(ncid,tid ,'start_ave_period',name)
       iret=nf_inq_varid(ncid,name,id)

#ifdef real_8
       iret= nf_get_vara_double(ncid,id,1,1,tstart);
#else
       iret= nf_get_vara_real(ncid,id,1,1,tstart);
#endif
       call set_time(time,
     &                int((tstart-int(tstart))*24*60*60),int(tstart))
       call set_stamp (stamp, time)

       iret=nf_inq_varid(ncid,vname,id)
       iret= nf_get_att_int(ncid,id,'range',dims )
       is=dims(1);ie=dims(2);js=dims(3);je=dims(4)

       print*,' range = ',is,ie,js,je
       allocate( trbuf(is:ie,js:je,ntr), tsbuf(is:ie,js:je,ntr)  )

       write(name, '("sponge_",i2,".mom")') k
       do i=1,len_trim(name)
         if (name(i:i) == ' ') name(i:i)='0'
       enddo

       print*,' writing sponge layer # ',k,' to file ',
     &   name(1:len_trim(name))

       call getunit(io,name,'usr ieee')
       write (io) nspg,itm,is,ie,js,je,stamp,aprec

       start=(/1,1,1,1/); count=(/ie-is+1,je-js+1,1,1/); 
       do n=1,itm
        start(4)=n
        do kk=1,km
         start(3)=kk
         do m=1,ntr

          if (m==1) then
           tr_name = 'temp'
          elseif (m==2) then
           tr_name = 'salt'
          else
           write(tr_name,'("tr",i2)') m
           call replace_space_zero(tr_name)
          endif
         
          iret=nf_inq_varid(ncid,tr_name//'_spg_'//number,id)
          if (iret/=0) then; print*,' cannot find var.';stop;endif
#ifdef real_8
          iret= nf_get_vara_double(ncid,id,start,count,trbuf(:,:,m))
#else
          iret= nf_get_vara_real(ncid,id,start,count,trbuf(:,:,m))
#endif
          iret=nf_inq_varid(ncid,tr_name//'_tscl_spg_'//number,id)
          if (iret/=0) then; print*,' cannot find var.';stop;endif
#ifdef real_8
          iret= nf_get_vara_double(ncid,id,start,count,tsbuf(:,:,m))
#else
          iret= nf_get_vara_real(ncid,id,start,count,tsbuf(:,:,m))
#endif
         enddo
         write(io) trbuf,tsbuf
        enddo
       enddo
       close(io)
       deallocate(aprec, trbuf,tsbuf)
      enddo
      call ncclos (ncid, iret)
      end subroutine write_sponge


      subroutine write_obc(orient,fname,ntr_max)
      use prep_to_bin_mod
      implicit none
      integer :: ntr_max
      character (len=*) :: orient,fname
      character (len=80)::  vname,name,tstr
      character (len=4)::  tr_name
      character (len=32):: stamp
      integer :: itm,n,id,tid,fdim,io,m,ntr
      type( time_type) :: time

      real (kind=r_knd), allocatable :: trbuf(:,:,:),aprec(:)
      real (kind=r_knd), allocatable :: pbuf(:)
      real (kind=r_knd) :: tstart

#include "netcdf.inc"
      integer   ncid,iret, start(4),count(4),dims(4)

      iret=nf_open(obc_file,NF_noWRITE,ncid)

      if (iret /=0) then
       print*,' cannot find OBC netcdf file '
       return
      endif 

      print*,' writing OBC ',orient,' to file ',
     &   fname(1:len_trim(fname))

      tstr=orient
      vname = 'temp_obc_'//tstr(1:len_trim(tstr))
      
      iret=nf_inq_varid(ncid,vname,id)
      if (iret /=0) then
        print*,' cannot find variable ',vname(1:len_trim(vname)) ,
     &             ' in netcdf file'
        return
      endif
      iret=NF_INQ_VARDIMID (NCID,id,dims)
      iret=NF_INQ_DIMLEN (NCID, dims(3), itm)
      name='';iret=NF_INQ_DIMname (NCID, dims(3), name)
      iret=nf_inq_varid(ncid,name,tid)

      allocate( aprec(itm) )
      name='';iret= nf_get_att_text(ncid,tid ,'ave_period',name)
      iret=nf_inq_varid(ncid,name,id)
#ifdef real_8
      iret= nf_get_vara_double(ncid,id ,1,itm,aprec)
#else
      iret= nf_get_vara_real(ncid,id ,1,itm,aprec)
#endif

      name='';iret= nf_get_att_text(ncid,tid ,'start_ave_period',name)
      iret=nf_inq_varid(ncid,name,id)

#ifdef real_8
      iret= nf_get_vara_double(ncid,id,1,1,tstart);
#else
      iret= nf_get_vara_real(ncid,id,1,1,tstart);
#endif
      call set_time(time,
     &                int((tstart-int(tstart))*24*60*60),int(tstart))
      call set_stamp (stamp, time)

      fdim=jmt
      if (orient == 'south' .or. orient == 'north' ) fdim=imt
      print*,' orientation ',orient,' fdim=',fdim

      m=3
 20   continue
        write(tr_name,'("tr",i2)') m
        call replace_space_zero(tr_name)
        iret=nf_inq_varid(ncid,
     &     tr_name//'_obc_'//tstr(1:len_trim(tstr)),id)
      if (iret==0) then; m=m+1; goto 20; endif
      ntr=m-1
      print*,' found ',ntr,' variables for tracers in netcdf file'
      if (ntr_max < ntr) then
        print*,' However, restricting number to ',ntr_max
        ntr=ntr_max
      endif

      allocate( trbuf(fdim,km,ntr), pbuf(fdim)  )

      call getunit(io,fname,'usr ieee')

      write (io) itm,stamp,aprec
      do n=1,itm

       do m=1,ntr

        if (m==1) then
         tr_name = 'temp'
        elseif (m==2) then
         tr_name = 'salt'
        else
         write(tr_name,'("tr",i2)') m
         call replace_space_zero(tr_name)
        endif

        start=(/1,1,n,1/); count=(/fdim,km,1,1/); 
        iret=nf_inq_varid(ncid,
     &        tr_name//'_obc_'//tstr(1:len_trim(tstr)),id)
        if (iret/=0) then; print*,' cannot find var.';stop;endif
#ifdef real_8
        iret= nf_get_vara_double(ncid,id,start,count,trbuf(:,:,m))
#else
        iret= nf_get_vara_real(ncid,id,start,count,trbuf(:,:,m))
#endif
       enddo

       start=(/1,n,1,1/); count=(/fdim,1,1,1/); 
       iret=nf_inq_varid(ncid,'psi_obc_'//tstr(1:len_trim(tstr)),id)
          if (iret/=0) then; print*,' cannot find var.';stop;endif
#ifdef real_8
       iret= nf_get_vara_double(ncid,id,start,count,pbuf)
#else
       iret= nf_get_vara_real(ncid,id,start,count,pbuf)
#endif
       write(io) trbuf,pbuf
      enddo
      close(io)
      deallocate(aprec, trbuf,pbuf)
      call ncclos (ncid, iret)

      end subroutine write_obc




      subroutine write_sbc(vname,fname,ugrid,ret)
      use prep_to_bin_mod
      implicit none
      character(len=*) :: vname,fname
      logical :: ugrid
      integer :: ret
      integer :: itm,n,id,tid,io
      character(len=80):: name
      character(len=32):: stamp
      type( time_type) :: time
      real (kind=r_knd), allocatable :: buf(:,:),aprec(:)
      real (kind=r_knd) :: tstart

#include "netcdf.inc"
      integer   ncid,iret, start(4),count(4),dims(4)

      if (vname=='taux') then
       iret=nf_open(wind_file(1:len_trim(wind_file)),NF_noWRITE,ncid)
      elseif (vname=='tauy') then
       iret=nf_open(wind_file,NF_noWRITE,ncid)
      elseif (vname=='ustar') then
       iret=nf_open(wind_file,NF_noWRITE,ncid)
      elseif (vname=='sst_clim') then
       iret=nf_open(sflx_file,NF_noWRITE,ncid)
      elseif (vname=='sst_rest') then
       iret=nf_open(sflx_file,NF_noWRITE,ncid)
      elseif (vname=='sst_flux') then
       iret=nf_open(sflx_file,NF_noWRITE,ncid)
      elseif (vname=='sss_clim') then
       iret=nf_open(sflx_file,NF_noWRITE,ncid)
      elseif (vname=='sss_rest') then
       iret=nf_open(sflx_file,NF_noWRITE,ncid)
      elseif (vname=='sss_flux') then
       iret=nf_open(sflx_file,NF_noWRITE,ncid)
      else
       iret=nf_open(sflx_tr_file,NF_noWRITE,ncid)
      endif

      ret=0
      if (iret /=0) then
        print*,' cannot open netcdf file for variable',vname
        ret=-1
        return
      endif

      iret=nf_inq_varid(ncid,vname,id)
      if (iret /=0) then
        print*,' cannot find variable ',vname(1:len_trim(vname)) ,
     &         ' in netcdf file'
        ret=-1
        return
      endif

       iret=NF_INQ_VARDIMID (NCID,id,dims)
       iret=NF_INQ_DIMLEN (NCID, dims(3), itm)
       name='';iret=NF_INQ_DIMname (NCID, dims(3), name)
       iret=nf_inq_varid(ncid,name,tid)

       allocate( aprec(itm) , buf(imt,jmt) )

       name='';iret= nf_get_att_text(ncid,tid ,'ave_period',name)
       iret=nf_inq_varid(ncid,name,id)
#ifdef real_8
       iret= nf_get_vara_double(ncid,id ,1,itm,aprec)
#else
       iret= nf_get_vara_real(ncid,id ,1,itm,aprec)
#endif

       name='';iret= nf_get_att_text(ncid,tid ,'start_ave_period',name)
       iret=nf_inq_varid(ncid,name,id)

#ifdef real_8
       iret= nf_get_vara_double(ncid,id,1,1,tstart)
#else
       iret= nf_get_vara_real(ncid,id,1,1,tstart)
#endif
       call set_time(time,
     &                int((tstart-int(tstart))*24*60*60),int(tstart))
       call set_stamp (stamp, time)

       iret=nf_inq_varid(ncid,vname,id)

       print*,' writing SBC ',vname(1:len_trim(vname)),
     &        ' to file ',fname(1:len_trim(fname))

       call getunit(io,fname,'usr ieee')
       write (io) itm,stamp,aprec
       do n=1,itm
        start=(/1,1,n,1/); count=(/imt,jmt,1,1/); 
#ifdef real_8
        iret= nf_get_vara_double(ncid,id,start,count,buf)
#else
        iret= nf_get_vara_real(ncid,id,start,count,buf)
#endif

#ifdef apply_topo_mask_to_sbc
        if (ugrid) then
         where( kmu == 0 ) buf = 0.
        else
         where( kmt == 0 ) buf = 0.
        endif
#endif
        write(io) buf
       enddo
       close(io)
       deallocate(aprec,buf)
      call ncclos (ncid, iret)
      end subroutine write_sbc






      subroutine write_blue()
      use prep_to_bin_mod
      implicit none
      integer :: itm,n,tempid,saltid,tid,j,id,io1,io2
      character(len=80):: name
      character(len=32):: stamp
      type( time_type) :: time
      real (kind=r_knd), allocatable :: buf(:,:,:),aprec(:)
      real (kind=r_knd) :: tstart

#include "netcdf.inc"
      integer   ncid,iret, start(4),count(4),dims(4)

      iret=nf_open(grid_file,NF_noWRITE,ncid)
       iret=nf_inq_varid(ncid,'temp_blue',tempid)
       if (iret /=0) then
        print*,' cannot find variable temp_blue in netcdf file'
        return
       endif
       iret=nf_inq_varid(ncid,'salt_blue',saltid)
       if (iret /=0) then
        print*,' cannot find variable salt_blue in netcdf file'
        return
       endif

       iret=NF_INQ_VARDIMID (NCID,tempid,dims)
       iret=NF_INQ_DIMLEN (NCID, dims(4), itm)
       name='';iret=NF_INQ_DIMname (NCID, dims(4), name)
       iret=nf_inq_varid(ncid,name,tid)

       allocate( aprec(itm) , buf(imt,jmt,km) )

       name='';iret= nf_get_att_text(ncid,tid ,'ave_period',name)
       iret=nf_inq_varid(ncid,name,id)
#ifdef real_8
       iret= nf_get_vara_double(ncid,id ,1,itm,aprec)
#else
       iret= nf_get_vara_real(ncid,id ,1,itm,aprec)
#endif

       name='';iret= nf_get_att_text(ncid,tid ,'start_ave_period',name)
       iret=nf_inq_varid(ncid,name,id)

#ifdef real_8
       iret= nf_get_vara_double(ncid,id,1,1,tstart)
#else
       iret= nf_get_vara_real(ncid,id,1,1,tstart)
#endif
       call set_time(time,
     &                int((tstart-int(tstart))*24*60*60),int(tstart))
       call set_stamp (stamp, time)
       
       call getunit(io1,'blue_temp.mom','usr ieee')
       print*,' writing temperature to file blue_temp.mom'
       call getunit(io2,'blue_salt.mom','usr ieee')
       print*,' writing salinity to file blue_temp.mom'
       write (io1) itm,stamp,aprec
       write (io2) itm,stamp,aprec
       do n=1,itm
        start=(/1,1,1,n/); count=(/imt,jmt,km,1/); 
#ifdef real_8
        iret= nf_get_vara_double(ncid,tempid,start,count,buf)
#else
        iret= nf_get_vara_real(ncid,tempid,start,count,buf)
#endif
        do j=1,km
         where( kmt < j ) buf(:,:,j) = 0.
        enddo
        do j=1,jmt
         write(io1) buf(:,j,:)
        enddo
#ifdef real_8
        iret= nf_get_vara_double(ncid,saltid,start,count,buf)
#else
        iret= nf_get_vara_real(ncid,saltid,start,count,buf)
#endif
        do j=1,km
         where( kmt < j ) buf(:,:,j) = 0.
        enddo
        do j=1,jmt
         write(io2) buf(:,j,:)
        enddo
       enddo
       close(io1); close(io2)
       deallocate(aprec,buf)
      call ncclos (ncid, iret)
      end subroutine write_blue



      subroutine write_blue_mean()
      use prep_to_bin_mod
      implicit none
      integer :: tempid,saltid,j,io
      real (kind=r_knd), allocatable :: buf2(:,:,:), buf1(:,:,:)

#include "netcdf.inc"
      integer   ncid,iret, start(4),count(4),dims(4)

      iret=nf_open(grid_file,NF_noWRITE,ncid)

       iret=nf_inq_varid(ncid,'temp_blue_mean',tempid)
       if (iret /=0) then
        print*,' cannot find variable temp_blue_mean in netcdf file'
        return
       endif
       iret=nf_inq_varid(ncid,'salt_blue_mean',saltid)
       if (iret /=0) then
        print*,' cannot find variable salt_blue_mean in netcdf file'
        return
       endif

       allocate( buf1(imt,jmt,km) , buf2(imt,jmt,km) )
       
       call getunit(io,'blue_mean.mom','usr ieee')
       print*,' writing TS to file blue_mean.mom'
 
       start=(/1,1,1,1/); count=(/imt,jmt,km,1/); 
#ifdef real_8
       iret= nf_get_vara_double(ncid,tempid,start,count,buf1)
       iret= nf_get_vara_double(ncid,saltid,start,count,buf2)
#else
       iret= nf_get_vara_real(ncid,tempid,start,count,buf1)
       iret= nf_get_vara_real(ncid,saltid,start,count,buf2)
#endif
        do j=1,km
         where( kmt < j ) buf1(:,:,j) = 0.
         where( kmt < j ) buf2(:,:,j) = 0.
        enddo
        do j=1,jmt
         write(io) buf1(:,j,:),buf2(:,j,:)
        enddo
       close(io)
      deallocate(buf2,buf1)
      call ncclos (ncid, iret)
      end subroutine write_blue_mean





      subroutine write_ic()
      use prep_to_bin_mod
      implicit none
      character(len=80) :: vname,fname
      character(len=80) :: FLAME_ID ='no flame id '
      character(len=32+80+60) :: iotext='no stamp, no iotext '
      character(len=32) :: stamp='no stamp '
      integer :: n,j,id,i,k, mm=1, io
      real (kind=r_knd) :: dpm = 30.
      real(kind=r_knd) , allocatable :: buf(:,:)

#include "netcdf.inc"
      integer   ncid,iret, start(4),count(4),dims(4)


      allocate( buf(imt,km) )

      do n=1,99
       if (n==1) fname='temp.mom.ic'
       if (n==2) fname='salt.mom.ic'
       if (n==1) vname='temp_ic'
       if (n==2) vname='salt_ic'
       if (n>2) then
        write(fname, '("tracer_",i2,".mom.ic")') n
        do i=1,len_trim(fname)
         if (fname(i:i) == ' ') fname(i:i)='0'
        enddo
        write(vname, '("tracer_",i2,"_ic")') n
        do i=1,len_trim(vname)
         if (vname(i:i) == ' ') vname(i:i)='0'
        enddo
       endif

       if (n>2) then
        iret=nf_open(ic_tr_file,NF_noWRITE,ncid)
       else
        iret=nf_open(ic_file,NF_noWRITE,ncid)
       endif

       if (iret ==0) then
        iret=nf_inq_varid(ncid,vname,id)
        if (iret ==0) then
         print*,' writing initial conditions for tracer ',
     &          vname(1:len_trim(vname)),' to file ',
     &     fname(1:len_trim(fname))
         call getunit(io,fname,'usr ieee')
         write (io) flame_id
         do j=1,jmt
          write(io) iotext
          start=(/1,j,1,1/)
          count=(/imt,1,km,0/); 
#ifdef real_8
          iret= nf_get_vara_double(ncid,id,start,count,buf)
#else
          iret= nf_get_vara_real(ncid,id,start,count,buf)
#endif
c        apply maybe land mask
          write(io) stamp, dpm, imt,km,j, yt(j),mm,
     &         (xt(i),i=1,imt),(zt(k),k=1,km), 
     &         ((buf(i,k),i=1,imt),k=1,km)
         enddo
         close(io)
        endif
        call ncclos (ncid, iret)
       endif

      enddo ! n
      deallocate( buf )
      end subroutine write_ic





      subroutine write_topo()
      use prep_to_bin_mod
      implicit none
      character(len=80) :: FLAME_ID ='no flame id '
      character(len=32+80+60) :: iotext='no stamp, no iotext '
      integer i,j,io
      real (kind=r_knd), allocatable :: htp(:,:) 

#include "netcdf.inc"
      integer   ncid,iret, start(4),count(4),dims(4),kmtid,htpid

      iret=nf_open(grid_file,NF_noWRITE,ncid)

      iret=nf_inq_varid(ncid,'kmt',kmtid)
#ifdef partial_cell
      iret=nf_inq_varid(ncid,'htp',htpid)
#endif

      start=1;count(1)=imt;count(2)=jmt
      iret= nf_get_vara_int (ncid,kmtid,start,count,kmt)
      if (iret==0) then
      print*,' writing topography to file kmt.dta'
      call getunit(io,'kmt.dta','usr ieee')
      write (io) flame_id ! no checks
      write (io) iotext
      write (io) imt, jmt, km
      write (io) iotext
      write (io) kmt
      close (io)
      else
       print*,' cannot find topography in netcdf file'
       stop
      endif
#ifdef partial_cell
      allocate(htp(imt,jmt))
#ifdef real_8
      iret= nf_get_vara_double(ncid,htpid,start,count,htp)
#else
      iret= nf_get_vara_real(ncid,htpid,start,count,htp)
#endif
c      htp=htp_

      if (iret==0) then
      print*,' writing partial cells to file htp.dta'
      call getunit(io,'htp.dta','usr ieee')
      write (io) flame_id ! no checks
      write (io) iotext
      write (io) imt, jmt, km
      write (io) iotext
      write (io) htp
      close (io)
      deallocate(htp)
      else
       print*,' cannot find partial cells in netcdf file'
       stop
      endif
#endif
      kmu=0
      do j=1,jmt-1
        do i=1,imt-1
           kmu(i,j) = min (kmt(i,j), kmt(i+1,j), 
     &                         kmt(i,j+1), kmt(i+1,j+1))
        enddo
      enddo
      call ncclos (ncid, iret)
      end subroutine write_topo



 
      subroutine write_grid()
      use prep_to_bin_mod
      implicit none
      integer  :: i,j,k,io,iret2=0
      character(len=80) :: FLAME_ID ='no flame id '
      real (kind=8), allocatable :: v8(:)
      real (kind=r_knd), allocatable, dimension(:) :: 
     & xu,yu,zw,dzt,dzw,dxtdeg,dxudeg,dytdeg,dyudeg

#include "netcdf.inc"
      integer   ncid,iret
      integer   xtid,ytid,ztid,xuid,yuid,zwid
      integer   dxtid,dytid,dxuid,dyuid,dztid,dzwid
      integer   start(4),count(4),dims(4)

      call getunit(io,'grid.dta','usr ieee')
      print*,' writing grid informations to file grid.dta'

      write (io) flame_id   ! this the the flame ID check
      write (io) imt, jmt, km
      allocate( dxtdeg(imt), dxudeg(imt),  xu(imt))
      allocate( dytdeg(jmt), dyudeg(jmt),  yu(jmt))
      allocate( dzt(km), dzw(0:km), zw(km))
      allocate(v8(imt) )

      iret=nf_open(grid_file,NF_noWRITE,ncid)
      iret=nf_inq_varid(ncid,'xt',xtid)
      iret=nf_inq_varid(ncid,'yt',ytid)
      iret=nf_inq_varid(ncid,'zt',ztid)
      iret=nf_inq_varid(ncid,'xu',xuid)
      iret=nf_inq_varid(ncid,'yu',yuid)
      iret=nf_inq_varid(ncid,'zw',zwid)
      iret=nf_inq_varid(ncid,'dxtdeg',dxtid)
      iret=nf_inq_varid(ncid,'dytdeg',dytid)
      iret=nf_inq_varid(ncid,'dxudeg',dxuid)
      iret=nf_inq_varid(ncid,'dyudeg',dyuid)
      iret=nf_inq_varid(ncid,'dzt',dztid)
      iret=nf_inq_varid(ncid,'dzw',dzwid)

      iret= nf_get_vara_double(ncid,xtid ,1,imt,v8);xt=v8
      if (iret/=0) iret2=iret
      iret= nf_get_vara_double(ncid,xuid ,1,imt,v8);xu=v8
      if (iret/=0) iret2=iret
      iret= nf_get_vara_double(ncid,dxtid ,1,imt,v8);dxtdeg=v8
      if (iret/=0) iret2=iret
      iret= nf_get_vara_double(ncid,dxuid ,1,imt,v8);dxudeg=v8
      if (iret/=0) iret2=iret
      deallocate(v8); allocate(v8(jmt) )
      iret= nf_get_vara_double(ncid,ytid ,1,jmt,v8);yt=v8
      if (iret/=0) iret2=iret
      iret= nf_get_vara_double(ncid,yuid ,1,jmt,v8);yu=v8
      if (iret/=0) iret2=iret
      iret= nf_get_vara_double(ncid,dytid ,1,jmt,v8);dytdeg=v8
      if (iret/=0) iret2=iret
      iret= nf_get_vara_double(ncid,dyuid ,1,jmt,v8);dyudeg=v8
      if (iret/=0) iret2=iret
      deallocate(v8); allocate(v8(km) )
      iret= nf_get_vara_double(ncid,ztid ,1,km,v8);zt=v8
      if (iret/=0) iret2=iret
      iret= nf_get_vara_double(ncid,dztid ,1,km,v8);dzt=v8
      if (iret/=0) iret2=iret
      deallocate(v8); allocate(v8(km+1) )
      iret= nf_get_vara_double(ncid,zwid ,1,km+1,v8);zw=v8(2:km+1)
      if (iret/=0) iret2=iret
      iret= nf_get_vara_double(ncid,dzwid ,1,km+1,v8);
      if (iret/=0) iret2=iret
      if (iret2/=0) then
       print*,' Problem reading grid infos from  netcdf file'
       stop
      endif
      dzw(0:km)=v8(1:km+1)
      deallocate(v8)
      write (io)(dxtdeg(i),i=1,imt), (dytdeg(j),j=1,jmt)
     &,         (dxudeg(i),i=1,imt),  (dyudeg(j),j=1,jmt)
     &,         (dzt(k),k=1,km),      (dzw(k),k=0,km)
     &,         (xt(i),i=1,imt),      (xu(i),i=1,imt)
     &,         (yt(j),j=1,jmt),      (yu(j),j=1,jmt)
     &,         (zt(k),k=1,km),       (zw(k),k=1,km)
       close (io)
       print*,'done'
      call ncclos (ncid, iret)
      end subroutine write_grid

      subroutine halt_stop(string)
      character (len=*) :: string
      print *,string
      stop
      end 

#include "options.inc"


      module diag_blue_module
      implicit none
      integer :: counter
      real, allocatable, dimension(:,:,:) :: corr
      end module diag_blue_module


      subroutine diag_blue_init() 
      use spflame_module
      use blue_module
      use diag_blue_module
      implicit none
      character (len=80) :: name
      integer :: io,k
      real, allocatable ::  buf(:,:)

      if (my_pe==0) print*,' initializing diagnostics for BLUE'

      if (.not.enable_blue) then
       if (my_pe==0) then
        print*,' '
        print*,' WARNING: '
        print*,' you have to switch on BLUE in order to use this option'
        print*,' '
       endif
       return
      endif

      allocate( corr(is_pe:ie_pe,km,js_pe:je_pe) )
      counter = 0; corr = 0.

      write(name,'("blue_averages_",i3,".dta")') sub_domain
      call replace_space_zero(name)
      if (my_pe==0) then
        print*,''
        print*,' reading unfinished averages for BLUE from file ',
     &          name(1:len_trim(name))
      endif

      call get_free_iounit(io)
      open(io,file=name,form='unformatted',status='old',err=20)
      read(io) counter
      allocate( buf(imt,jmt) )
      do k=1,km
       if (my_pe==0) read(io) buf
       call pe0_send_2D(buf)
       corr(is_pe:ie_pe,k,js_pe:je_pe)=buf(is_pe:ie_pe,js_pe:je_pe)
      enddo
      close(io)
      deallocate(buf)
      if (my_pe==0) print*,' done'

      return

 20   if (my_pe==0) then
        print*,''
        print*,'---------------------------------------------'
        print*,' WARNING : cannot read file ',name(1:len_trim(name))
        print*,'---------------------------------------------'
        print*,''
      endif
      end subroutine diag_blue_init 




      subroutine diag_blue() 
      use spflame_module
      use blue_module
      use diag_blue_module
      implicit none
      character (len=80) :: name
      integer :: io,k,i,j
      integer :: year,month,day
      real, allocatable ::  buf(:,:)

      if (.not.enable_blue) return
c
c     average
c
      counter=counter+1

      if (enable_blue_smooth) then

       do j=js_pe,je_pe
        do k=1,km
         do i=is_pe,ie_pe
          corr(i,k,j)=corr(i,k,j)+blue_rhom(i,k,j)
         enddo
        enddo
       enddo

      else

       do j=js_pe,je_pe
        do k=1,km
         do i=is_pe,ie_pe
          corr(i,k,j)=corr(i,k,j)+
     &        (1.-blue_alpha(i,k,j))*(
     &                blue_rho(i,k,j,blue_p1)*blue_f1+
     &                blue_rho(i,k,j,blue_p2)*blue_f2  - rho(i,k,j) )
         enddo
        enddo
       enddo

      endif
c
c     check for end of month, then write out file and initialize again
c
      if   (end_of_month )  then

#ifdef netcdf_diagnostics
c      not yet implemented
#else
       year  = get_year(get_current_time())
       month = get_month_of_year(get_current_time())
       day   = get_day_of_month(get_current_time())
       write(name,'("blue_averages_",i3,"_y",i4,"m",i2,"d",i2,".dta")') 
     &            sub_domain,year,month,day
       call replace_space_zero(name)

       if (my_pe==0) then
         print*,' writing BLUE averages to file ',name(1:len_trim(name))
         call getunit(io, name,'u s r ieee')
         write(io) imt,jmt,km
         write(io) xt,yt,zt
         write(io) counter
         write(io) kmt_big
       endif
       allocate( buf(imt,jmt) ); buf=0.
       do k=1,km
         buf(is_pe:ie_pe,js_pe:je_pe)=corr(is_pe:ie_pe,k,js_pe:je_pe)
         call pe0_recv_2D(buf)
         if (my_pe==0) write(io) buf
       enddo
       deallocate(buf)
       if (my_pe==0) then
        close(io)
        print*,'done'
       endif
#endif

       counter=0; corr=0.
      endif
c
c     write unfinished averages to be read in the next run
c
      if (last_time_step) then

       write(name,'("blue_averages_",i3,".dta")') sub_domain
       call replace_space_zero(name)
       if (my_pe==0) then
        print*,''
        print*,' writing unfinished averages for BLUE from file ',
     &          name(1:len_trim(name))

        call get_free_iounit(io)
        open(io,file=name,form='unformatted',status='unknown')
        write(io) counter
       endif

       allocate( buf(imt,jmt) )
       do k=1,km
         buf(is_pe:ie_pe,js_pe:je_pe)=corr(is_pe:ie_pe,k,js_pe:je_pe)
         call pe0_recv_2D(buf)
         if (my_pe==0) write(io) buf
       enddo
       deallocate(buf)

       if (my_pe==0) then
        close(io)
        print*,' done '
        print*,''
       endif

      endif

      end subroutine diag_blue 

#include "options.inc"

c----------------------------------------------------------------
c
c     BBL module for spflame
c 
c     this module implements the bottom boundary layer 
c     parameterization by Beckmann and Doescher, JPO, 97
c
c     it is linked in the main code by calls of 
c     bbl_init in setup.F, adv_vel_bbl at the
c     end of adv_vel.F and of add_bbl at the end 
c     of the tracer loop in tracer.F
c     (see also advective operators in tracer.F)
c
c     Mar 2001, C.Eden
c
c     written for MOM2.1 by:   Ralf Doescher
c     date:                    Dec, 1997
c
c     based on:
c
c !---------------------------------------------------------------
c |              Beckmann and Doescher, 1997:                    |
c |    A method for improved representation of dense water       |
c | spreading over topography in geopotential-coordinate models. |
c |      J. Phys. Oceanogr., 27, 4, 1997, 581 - 591.             |
c !---------------------------------------------------------------
c
c     FOR NON-COMMERCIAL USE ONLY
c
c----------------------------------------------------------------


      module bbl_module
      implicit none

      real, allocatable    :: h_sigma(:,:)
      real, allocatable    :: rhodiffxp(:,:),rhodiffyp(:,:)
      real, allocatable    :: ahc_north_sigma(:),ahc_south_sigma(:)

      real, allocatable    :: sigma_weight(:,:,:)
      integer, allocatable :: kt_upper_fac(:,:,:)

      real, allocatable    :: adv_vnt_s(:,:)
      real, allocatable    :: adv_vet_s(:,:)
      real, allocatable    :: adv_vbt_su(:,:,:)

      integer, allocatable :: ipdown(:,:),jpdown(:,:)
      integer, allocatable :: ifac(:,:,:),jfac(:,:,:)
      integer, allocatable :: im1fac(:,:,:),jm1fac(:,:,:)

      end module bbl_module


      subroutine bbl_init
c----------------------------------------------------------------
c     do some initializations for BBL
c----------------------------------------------------------------
      use spflame_module
      use bbl_module
      implicit none
      integer is,ie,js,je
      integer i,j,k,jm1,jp1
      integer kk,kkm1,kanf,ifacc,im1facc,jfacc,jm1facc,ibottom
      integer ijall
      integer merkupper(is_pe:ie_pe)

      if (my_pe == 0) then
       print*,''
       print*,' Initialization of BBL parameterization'
       print*,''
       print*,' ah_sigma               = ',ah_sigma
       print*,' ah_sigma_min           = ',ah_sigma_min
       print*,' enable adv.  transport = ',enable_bbl_advection
       print*,' enable diff. transport = ',enable_bbl_diffusion
       print*,''
       if (enable_bbl_only_north) then
        print*,' Note:'
        print*,' BBL is working only north of 45N and south of 45S'
       endif
      endif

#ifdef partial_cell
      if (my_pe == 0) then
       print*,''
       print*,'ERROR: option partial cell is incompatible with BBL'
       print*,''
      endif
      call halt_stop(' in bbl_init')
#endif
c
c     allocate momory for the working arrays
c
      is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      allocate( h_sigma(is-1:ie+1,js-1:je+1) )
      h_sigma=0.
      allocate( rhodiffxp(is-1:ie,js-1:je))
      rhodiffxp=0.
      allocate( rhodiffyp(is-1:ie,js-1:je))
      rhodiffyp=0.
      allocate( ahc_north_sigma(js-1:je+1))
      ahc_north_sigma=0.
      allocate( ahc_south_sigma(js-1:je+1))
      ahc_south_sigma=0.

      if (enable_bbl_advection) then

       allocate( sigma_weight(is:ie,km,js:je) )
       sigma_weight=0.
       allocate( kt_upper_fac(is:ie,km,js:je) )
       kt_upper_fac=0
       allocate(adv_vnt_s(is-1:ie+1,      js-1:je+1) )
       adv_vnt_s=0.
       allocate(adv_vet_s(is-1:ie+1,      js-1:je+1) )
       adv_vet_s=0.
       allocate(adv_vbt_su(is-1:ie+1,0:km,js-1:je+1) )
       adv_vbt_su=0.

       allocate(ipdown(is-1:ie+1,js-1:je+1) )
       ipdown=1
       allocate(jpdown(is-1:ie+1,js-1:je+1) )
       jpdown=1

       allocate(ifac(is-1:ie+1,km,js-1:je+1) )
       ifac=1
       allocate(jfac(is-1:ie+1,km,js-1:je+1) )
       jfac=1
       allocate(im1fac(is-1:ie+1,km,js-1:je+1) )
       im1fac=1
       allocate(jm1fac(is-1:ie+1,km,js-1:je+1) )
       jm1fac=1

      endif
c
c     set up things which are done only once in the run
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      h_sigma=0.
      do j=js-1,je+1
       do i=is-1,ie+1
        if(kmt_big(i,j).ne.0) h_sigma(i,j) = dzt(kmt_big(i,j))
       enddo
      enddo

      do j=js-1,je+1
        jm1 = max(1,j-1)
        jp1 = min(jmt,j+1)
        ahc_north_sigma(j) = ah_sigma*csu(j)*dyur(j)
     &                           *cstr(j)*dytr(j)
        ahc_south_sigma(j) = ah_sigma*csu(jm1)*dyur(jm1)
     &                           *cstr(j)*dytr(j)
      enddo

      if (enable_bbl_advection) then
c
c      define weight factor for sigma advection
c
       sigma_weight(:,:,:) = 0.0
 
       do j=js,je
         do i=is,ie
           if(kmt_big(i,j).ne.0) then
            kk   = kmt_big(i,j)
            kkm1 = kmt_big(i,j)-1
            sigma_weight(i,kk  ,j)   = 1.0    ! big Ts
            sigma_weight(i,kkm1,j)   = 1.0    ! first small ts
            kanf=max(1,min(kmt_big(i,j),kmt_big(i,j+1),kmt_big(i,j-1),
     &                                 kmt_big(i+1,j),kmt_big(i-1,j)))
!           second small t:
            sigma_weight(i,kanf:kmt_big(i,j),j) =   1.0
           endif
         enddo
       enddo

       do j=js,je
         do i=is,ie
          merkupper(i)=0
         enddo
         do k=1,km
          do i=is,ie

           ifacc   = 1; im1facc = 1; jfacc   = 1
           jm1facc = 1; ibottom = 1
           kt_upper_fac(i,k,j) = 0
           if(k.ge.kmt_big(i+1,j)) ifacc   = 0
           if(k.ge.kmt_big(i-1,j)) im1facc = 0
           if(k.ge.kmt_big(i,j+1)) jfacc   = 0
           if(k.ge.kmt_big(i,j-1)) jm1facc = 0
           if(k.ge.kmt_big(i,j)) then
              ifacc   = 0; im1facc = 0
              jfacc   = 0; jm1facc = 0; ibottom = 0
           endif

           if(merkupper(i).eq.0) then
            ijall = ifacc*im1facc*jfacc*jm1facc
            if(ijall.eq.0) then
             if( 0.eq.kmt_big(i+1,j  ).or.
     &           0.eq.kmt_big(i-1,j  ).or.
     &           0.eq.kmt_big(i  ,j-1).or.
     &           0.eq.kmt_big(i  ,j+1) ) then
              merkupper(i) = 1
             endif
            endif
           endif

           if(merkupper(i).eq.0) then

            ijall = ifacc*im1facc*jfacc*jm1facc
            if(ijall.eq.0) then
             if( k.eq.kmt_big(i+1,j  ).or.
     &           k.eq.kmt_big(i-1,j  ).or.
     &           k.eq.kmt_big(i  ,j-1).or.
     &           k.eq.kmt_big(i  ,j+1) ) then
              kt_upper_fac(i,k,j) = 1
              merkupper(i) = 1
             endif

             if( k.le.kmt_big(i+1,j )-1.and.
     &           k.le.kmt_big(i-1,j )-1.and.
     &           k.le.kmt_big(i  ,j-1)-1.and.
     &           k.le.kmt_big(i  ,j+1)-1 ) then
              kt_upper_fac(i,k,j) = 1
              merkupper(i) = 1
             endif
            endif

            if( k.eq.kmt_big(i  ,j  )-1.and.
     &          k.le.kmt_big(i+1,j  )-1.and.
     &          k.le.kmt_big(i-1,j  )-1.and.
     &          k.le.kmt_big(i  ,j-1)-1.and.
     &          k.le.kmt_big(i  ,j+1)-1 ) then
              kt_upper_fac(i,k,j) = 1
              merkupper(i) = 1
            endif

            if( k.eq.kmt_big(i+1,j  )-1.and.
     &          k.eq.kmt_big(i-1,j  )-1.and.
     &          k.eq.kmt_big(i  ,j-1)-1.and.
     &          k.eq.kmt_big(i  ,j+1)-1 ) then
              kt_upper_fac(i,k,j) = 1
              merkupper(i) = 1
            endif

           endif
         
          enddo
         enddo
       enddo

      endif

      if (my_pe == 0) print*,' done'

      end subroutine bbl_init


      subroutine adv_vel_bbl
c
c=======================================================================
c     calculate advection velocities for tracer equations     
c     compute advective terms in BBL formulation
c=======================================================================
c
      use spflame_module
      use bbl_module
      implicit none
      integer :: is,ie,js,je
      integer :: i,j,k,kn,klo,kk

#ifdef vector_host
      integer :: kvec(is_pe-1:ie_pe)
      real    :: tvec(is_pe-1:ie_pe)
      real    :: svec(is_pe-1:ie_pe)
      real    :: rvec(is_pe-1:ie_pe)
      real    :: tpvec(is_pe-1:ie_pe)
      real    :: spvec(is_pe-1:ie_pe)
      real    :: rpvec(is_pe-1:ie_pe)
#ifdef partial_cell
      real    :: ztpvec(is_pe-1:ie_pe)
#endif
#endif

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

c     compute cross-slope density gradients for a sigma diffusion condition

#ifdef vector_host
c
c     vector version of the code
c
      kvec=1;tvec=0.;svec=0.;spvec=0.;tpvec=0.;rvec=0.;rpvec=0.

      do j=js-1,je

       do i=is-1,ie
        k=kmt_big(i,j)
        if ( k /= 0 ) then
         kn=kmt_big(i+1,j)
         if ( kn > 1 ) then
          kvec(i) = max(k,kn)
#ifdef partial_cell
          ztpvec(i) = ztp(i,kvec(i),j)
#endif
          tvec(i) = t(i  ,k ,j,1,tau)
          svec(i) = t(i  ,k ,j,2,tau)
          tpvec(i)= t(i+1,kn,j,1,tau)
          spvec(i)= t(i+1,kn,j,2,tau)
         endif
        endif 
       enddo
       call model_dens_kvec(tvec ,svec ,rvec ,kvec,ie-is+2
#ifdef partial_cell
     &                      ,ztpvec
#endif
     &    )
       call model_dens_kvec(tpvec,spvec,rpvec,kvec,ie-is+2
#ifdef partial_cell
     &                      ,ztpvec
#endif
     &    )
       do i=is-1,ie
        rhodiffxp(i,j)=rvec(i)-rpvec(i)
       enddo

       do i=is-1,ie
        k=kmt_big(i,j)
        if ( k /= 0 ) then
         kn=kmt_big(i,j+1)
         if ( kn > 1 ) then
          kvec(i) = max(k,kn)
#ifdef partial_cell
          ztpvec(i) = ztp(i,kvec(i),j)
#endif
          tvec(i) = t(i,k ,j  ,1,tau)
          svec(i) = t(i,k ,j  ,2,tau)
          tpvec(i)= t(i,kn,j+1,1,tau)
          spvec(i)= t(i,kn,j+1,2,tau)
         endif
        endif 
       enddo
       call model_dens_kvec(tvec ,svec ,rvec ,kvec,ie-is+2 
#ifdef partial_cell
     &                      ,ztpvec
#endif
     &    )
       call model_dens_kvec(tpvec,spvec,rpvec,kvec,ie-is+2 
#ifdef partial_cell
     &                      ,ztpvec
#endif
     &    )
       do i=is-1,ie
        rhodiffyp(i,j)=rvec(i)-rpvec(i)
       enddo

      enddo

#else
c
c     scalar version of the code
c
      do j=js-1,je
          do i=is-1,ie
            k=kmt_big(i,j)
            if ( k /= 0 ) then

              kn=kmt_big(i+1,j)
              if ( kn > 1 ) then
                klo=max(k,kn)
                rhodiffxp(i,j)=
     &    model_dens_scalar(t(i  ,k ,j,1,tau),t(i  ,k ,j,2,tau),klo
#ifdef partial_cell
     &                       ,ztp(i,klo,j)
#endif
     &                       )
     &   -model_dens_scalar(t(i+1,kn,j,1,tau),t(i+1,kn,j,2,tau),klo
#ifdef partial_cell
     &                       ,ztp(i+1,klo,j)
#endif
     &                       )
              endif

              kn=kmt_big(i,j+1)
              if ( kn > 1 ) then
                klo=max(k,kn)
                rhodiffyp(i,j)=
     &    model_dens_scalar(t(i,k ,j  ,1,tau),t(i,k ,j  ,2,tau),klo
#ifdef partial_cell
     &                       ,ztp(i,klo,j)
#endif
     &                       )
     &   -model_dens_scalar(t(i,kn,j+1,1,tau),t(i,kn,j+1,2,tau),klo
#ifdef partial_cell
     &                       ,ztp(i,klo,j+1)
#endif
     &                       )
              endif

            endif 
          enddo
      enddo
#endif


       if (enable_bbl_only_north) then
        do j=js-1,je
c          if (j .lt. 828) then
          if ( abs(yt(j)) < 45.1 ) then
            rhodiffyp(i,j)=0.
            rhodiffxp(i,j)=0.
          endif
        enddo
       endif


c     the advective velocity adv_vnt is located at the northern
c     interface of the ij-box. Consequently, advective velocities 
c     in the bbl (adv_vnt_s) are also infered from the northern 
c     interface.
c     Viewed from the ij-position, adv_vnt is multiplied by 
c     dzt(upper)/dzt(lower) only if the adjacent northern neigbor 
c     bottombox is located above the level of the ij-bottombox.
c     Consequential treatment in ADV_Ty_s (in fdift.h) leads
c     to mass conservation.
c     In short: 
c     v1 *  interface_area_upper =
c     v1 * (interface_area_upper/interface_area_lower) 
c        * interface_area_lower

      if (enable_bbl_advection) then
c
c     sigma_advection velocity on northern face of "T" cells.

       do j=js-1,je
        do i=is-1,ie
          adv_vnt_s(i,j) = 0.
          if (kmt_big(i,j+1)>0 .and. kmt_big(i,j)>0) then
            adv_vnt_s(i,j)  = adv_vnt(i,kmt_big(i,j),j)
            if (kmt_big(i,j) > kmt_big(i,j+1)) then
              adv_vnt_s(i,j) = adv_vnt(i,kmt_big(i,j+1),j)
     &            *dzt(kmt_big(i,j+1))/dzt(kmt_big(i,j))
            endif
          endif
        enddo
       end do

       call set_cyclic(adv_vnt_s,1,1)
       if (my_blk_i == 1 .and. enable_obc_west) 
     &              adv_vnt_s(1,:) = adv_vnt_s(2,:)
       if (my_blk_i == n_pes_i .and. enable_obc_east) 
     &              adv_vnt_s(imt,:) = adv_vnt_s(imt-1,:)
c
c     sigma_advection velocity on eastern face of "T" cells.
c
       do j=js-1,je
        do i=is-1,ie
          adv_vet_s(i,j) = 0.
          if(kmt_big(i+1,j)>0.and.kmt_big(i,j)>0) then
            adv_vet_s(i,j) = adv_vet(i,kmt_big(i,j),j)
            if(kmt_big(i,j) > kmt_big(i+1,j)) then
              adv_vet_s(i,j) = adv_vet(i,kmt_big(i+1,j),j) 
     &           * dzt(kmt_big(i+1,j)) / dzt(kmt_big(i,j)) 
            endif
          endif
        enddo
       enddo

       call set_cyclic(adv_vet_s,1,1)
       if (my_blk_i == 1 .and. enable_obc_west) 
     &              adv_vet_s(1,:) = adv_vet_s(2,:)
       if (my_blk_i == n_pes_i .and. enable_obc_east) 
     &              adv_vet_s(imt,:) = adv_vet_s(imt-1,:)
c
c     sigma_advection vertical velocity on upper face of bottom cells.
c      construct divergence of advection velocity * level thickness
c
       do j=js-1,je
          do i=is-1,ie

            jpdown(i,j)=1
            ipdown(i,j)=1
            k=kmt_big(i,j)
            if (k > kmt_big(i,j+1)) then         ! flag downhill flow
              jpdown(i,j) = max(0.,-1.*sign(1.,adv_vnt_s(i,j)))
            else if (k<kmt_big(i,j+1)) then
              jpdown(i,j) = max(0.,+1.*sign(1.,adv_vnt_s(i,j)))
            endif
            if (jpdown(i,j) == 1) then   ! cross-check with density difference
              if ((k>kmt_big(i,j+1).and.rhodiffyp(i,j).lt.0.).or.
     &            (k<kmt_big(i,j+1).and.rhodiffyp(i,j).gt.0.)) then
                continue                        ! denser water upstream
              else
                jpdown(i,j)=0
              endif
            endif

            if (k .gt. kmt_big(i+1,j)) then
              ipdown(i,j) = max(0.,-1.*sign(1.,adv_vet_s(i,j)))
            else if (k.lt.kmt_big(i+1,j)) then
              ipdown(i,j) = max(0.,+1.*sign(1.,adv_vet_s(i,j)))
            endif
            if (ipdown(i,j) .eq. 1) then
              if ((k.gt.kmt_big(i+1,j).and.rhodiffxp(i,j).lt.0.).or.
     &            (k.lt.kmt_big(i+1,j).and.rhodiffxp(i,j).gt.0.)) then
                continue
              else
                ipdown(i,j)=0
              endif
            endif

          enddo
       enddo

       call set_cyclic_int(ipdown,1,1)
       call set_cyclic_int(jpdown,1,1)
       if (my_blk_i == 1 .and. enable_obc_west) then
             ipdown(1,:) = ipdown(2,:)
             jpdown(1,:) = jpdown(2,:)
       endif
       if (my_blk_i == n_pes_i .and. enable_obc_east)  then
             ipdown(imt,:) = ipdown(imt-1,:)
             jpdown(imt,:) = jpdown(imt-1,:)
       endif
c
c     construct vertical velocity on the bottom face of outer
c     "T" cells adjacent to the sigma bottom layer
c
       do j=js,je
c
c       determine masks for blending out "redirected" downslope flow:
c
        do k=1,km                ! initialize whole water column with 1
          do i=is,ie
            ifac(i,k,j)   = 1; im1fac(i,k,j) = 1
            jfac(i,k,j)   = 1; jm1fac(i,k,j) = 1
          enddo
        enddo

#ifdef vector_host
        do k=1,km
         do i=is,ie          ! set sides of topo-steps and bathymetry to 0
          if (k>=kmt_big(i+1,j)+1)    ifac(i,k,j) = 0
          if (k>=kmt_big(i-1,j)+1)  im1fac(i,k,j) = 0
          if (k>=kmt_big(i,j+1)+1)    jfac(i,k,j) = 0
          if (k>=kmt_big(i,j-1)+1)  jm1fac(i,k,j) = 0
         enddo
        enddo
#else
        do i=is,ie          ! set sides of topo-steps and bathymetry to 0
          do k=min(kmt_big(i+1,j)+1,km),km
            ifac(i,k,j)   = 0
          enddo
          do k=min(kmt_big(i-1,j)+1,km),km
            im1fac(i,k,j) = 0
          enddo
          do k=min(kmt_big(i,j+1)+1,km),km
            jfac(i,k,j)   = 0
          enddo
          do k=min(kmt_big(i,j-1)+1,km),km
            jm1fac(i,k,j) = 0
          enddo
        enddo
#endif

        do i=is,ie         ! determine sign at k-level of topo step
          k=kmt_big(i+1,j)
          if (k.gt.0) then
!           import (0) or export (1) ?
            ifac(i,k,j)  = max(0.,+1.*sign(1.,adv_vet(i,k,j)))
!           if import, set mask to 0 for dense downslope flow:
!              (adv_vet=0 -> ifac=1, which is correct, 
!                                    strange as it may seem j.d.)
!              (note: mask stays 1 if density diff. across step =0!)
            if (ifac(i,k,j).eq.0) then
              kk=kmt_big(i,j)
              if ((kk.gt.k .and. rhodiffxp(i,j).lt.0.) .or.
     &            (kk.lt.k .and. rhodiffxp(i,j).gt.0.)) then
                continue
              else
                ifac(i,k,j)=1
              endif
            endif
          endif
        enddo

        do i=is,ie
          k=kmt_big(i-1,j)
          if (k.gt.0) then
            im1fac(i,k,j)= max(0.,-1.*sign(1.,adv_vet(i-1,k,j)))
            if (im1fac(i,k,j).eq.0) then
              kk=kmt_big(i,j)
              if ((kk.gt.k .and. -1.0*rhodiffxp(i-1,j).lt.0.) .or.
     &            (kk.lt.k .and. -1.0*rhodiffxp(i-1,j).gt.0.)) then
                continue
              else
                im1fac(i,k,j)=1
              endif
            endif
          endif
        enddo

        do i=is,ie
          k=kmt_big(i,j+1)
          if (k.gt.0) then
            jfac(i,k,j)  = max(0.,+1.*sign(1.,adv_vnt(i,k,j)))
            if (jfac(i,k,j).eq.0) then
              kk=kmt_big(i,j)
              if ((kk.gt.k .and. rhodiffyp(i,j).lt.0.) .or.
     &            (kk.lt.k .and. rhodiffyp(i,j).gt.0.)) then
                continue
              else
                jfac(i,k,j)=1
             endif
            endif
          endif
        enddo

        do i=is,ie
          k=kmt_big(i,j-1)
          if (k.gt.0) then
            jm1fac(i,k,j)= max(0.,-1.*sign(1.,adv_vnt(i,k,j-1)))
            if (jm1fac(i,k,j).eq.0) then
              kk=kmt_big(i,j)
              if ((kk.gt.k .and. -1.0*rhodiffyp(i,j-1).lt.0.) .or.
     &            (kk.lt.k .and. -1.0*rhodiffyp(i,j-1).gt.0.)) then
                continue
              else
                jm1fac(i,k,j)=1
              endif
            endif
          endif
        enddo


#ifdef vector_host
        do k=1,km
         do i=is,ie                 ! set local bathymetry points to 0
          if (k>=kmt_big(i,j)) then
            ifac(i,k,j)   = 0; im1fac(i,k,j) = 0
            jfac(i,k,j)   = 0; jm1fac(i,k,j) = 0
          endif
         enddo
        enddo
#else
        do i=is,ie                 ! set local bathymetry points to 0
          do k=max(1,kmt_big(i,j)),km
            ifac(i,k,j)   = 0; im1fac(i,k,j) = 0
            jfac(i,k,j)   = 0; jm1fac(i,k,j) = 0
          enddo
        enddo
#endif

       enddo


       call set_cyclic_int(ifac,km,1)
       call set_cyclic_int(jfac,km,1)
       call set_cyclic_int(im1fac,km,1)
       call set_cyclic_int(jm1fac,km,1)

       if (my_blk_i == 1 .and. enable_obc_west)  then
              ifac(1,:,:) = ifac(2,:,:)
              jfac(1,:,:) = jfac(2,:,:)
              im1fac(1,:,:) = im1fac(2,:,:)
              jm1fac(1,:,:) = jm1fac(2,:,:)
       endif
       if (my_blk_i == n_pes_i .and. enable_obc_east)  then
              ifac(imt,:,:) = ifac(imt-1,:,:)
              jfac(imt,:,:) = jfac(imt-1,:,:)
              im1fac(imt,:,:) = im1fac(imt-1,:,:)
              jm1fac(imt,:,:) = jm1fac(imt-1,:,:)
       endif

       do j=js,je

c       construct divergence of advection velocity * level thickness

c       set "adv_vbt_su" at surface to 0.0 (rigid-lid) or dh/dt (free surf)

        do i=is,ie
          adv_vbt_su(i,0,j)   = 0.
        enddo

        do k=1,km
          do i=is,ie
            adv_vbt_su(i,k,j) =
     &      ((adv_vet(i,k,j)*ifac(i,k,j) - 
     &                           adv_vet(i-1,k,j)*im1fac(i,k,j))*dxtr(i)
     &      +(adv_vnt(i,k,j)*jfac(i,k,j) - 
     &                        adv_vnt(i,k,j-1)*jm1fac(i,k,j))*dytr(j)
     &                   )*cstr(j)*dzt(k)
          enddo
        enddo

c
c       integrate downward to define "adv_vbt" at the bottom of levels
c
        do k=1,km
          do i=is,ie
            adv_vbt_su(i,k,j) = adv_vbt_su(i,k  ,j)
     &                        + adv_vbt_su(i,k-1,j)
          enddo
        enddo

        do i=is,ie        ! integrate and delete afterwards?
          k=kmt_big(i,j)
          if(k.ge.2) then
            adv_vbt_su(i,k,j) = 0.
          endif
        enddo

       enddo


       call set_cyclic(adv_vbt_su,km+1,1)
       if (my_blk_i == 1 .and. enable_obc_west) 
     &              adv_vbt_su(1,:,:) = adv_vbt_su(2,:,:)
       if (my_blk_i == n_pes_i .and. enable_obc_east) 
     &              adv_vbt_su(imt,:,:) = adv_vbt_su(imt-1,:,:)

      endif

      end subroutine adv_vel_bbl
      




      subroutine add_bbl(n,is,ie,js,je,adv_fe,adv_fb)
c=======================================================================
c     add what necessary for BBL to tracer tendency
c=======================================================================
      use spflame_module
      use bbl_module
      implicit none
      integer, intent(in) :: n,is,ie,js,je
      real, intent(in) ::  adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real, intent(in) ::  adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)

      integer i,j,k,kn,ibottom,kb
      integer kmt_jp1,kmt_jm1
      integer kmt_ip1,kmt_im1
      real factxp,factxm
      real factyp,factym
c     the following 2 arrays are needed for sigma_bottom_advection only
      real adv_fe_s(is_pe-1:ie_pe,js_pe:je_pe)  
      real adv_fb_su(is_pe:ie_pe,0:km,js_pe:je_pe) 
c
c     redefined operators
c
      real ADV_Ty_s
      ADV_Ty_s(i,j) = (
     &                ( 1.0 * 
     &         adv_vnt_s(i,j) * jpdown(i,j) *  
     &                         h_sigma(i,j) *
     &                        (t(i,kmt_jp1,j+1,n,tau) +
     &                         t(i,kmt(i,j ),j  ,n,tau)) 
     &       + adv_vnt(i,k,j) * (1-jpdown(i,j)) * 
     &                         h_sigma(i,j) *
     &                        (t(i,k,j+1,n,tau) +
     &                         t(i,k,j  ,n,tau)) )
     &              - (  1.0 * 
     &         adv_vnt_s(i,j-1) * jpdown(i,j-1) * 
     &                         h_sigma(i,j-1) *
     &                        (t(i,kmt(i,j  ),j  ,n,tau) +
     &                         t(i,kmt_jm1,j-1,n,tau))
     &     + adv_vnt(i,k,j-1) * (1-jpdown(i,j-1)) * 
     &                         h_sigma(i,j) *
     &                        (t(i,k,j  ,n,tau) +
     &                         t(i,k,j-1,n,tau)) )
     &                 ) * cstdyt2r(j) / h_sigma(i,j)

      real ADV_Tx_s
      ADV_Tx_s(i,j) = (
     &                ( h_sigma(i  ,j) * ipdown(i,j) *
     &         adv_fe_s(i,j) )
     &              + ( h_sigma(i  ,j) * (1-ipdown(i,j)) *
     &         adv_fe(i,k,j) )
     &              - ( h_sigma(i-1,j) * ipdown(i-1,j) *
     &         adv_fe_s(i-1,j) )
     &              - ( h_sigma(i  ,j) * (1-ipdown(i-1,j)) *
     &         adv_fe(i-1,k,j) )
     &                ) * cstdxt2r(i,j) / h_sigma(i,j)


      real ADV_Tz_s
      ADV_Tz_s(i,j) =  (adv_fb_su(i,k-1,j)  )
     &                                       *dzt2r(k)

      real ADV_Tx_su
      ADV_Tx_su(i,k,j) = 
     &  (adv_fe(i,k,j)*ifac(i,k,j) - adv_fe(i-1,k,j)*im1fac(i,k,j))
     &                   *cstdxt2r(i,j)

      real ADV_Ty_su
      ADV_Ty_su(i,k,j) = 
     &   (jfac(i,k,j)*adv_vnt(i,k,j)*(t(i,k,j,n,tau)+t(i,k,j+1,n,tau))
     &  - jm1fac(i,k,j)*adv_vnt(i,k,j-1)*
     &                               (t(i,k,j-1,n,tau)+t(i,k,j,n,tau))
     &                )*cstdyt2r(j)

      real ADV_Tz_su
      ADV_Tz_su(i,k,j) =ibottom*(
     &    adv_fb_su(i,k-1,j) * (1-kt_upper_fac(i,k,j)) 
     &  + adv_fb(i,k-1,j)    *    kt_upper_fac(i,k,j) 
     &  - adv_fb_su(i,k,j) )
     &               *dzt2r(k)


c     this array is needed for sigma_bottom_diffusion only
      real diff_fe_s(is_pe-1:ie_pe,js_pe:je_pe) 

      real DIFF_Tx_s
      DIFF_Tx_s(i,j) = (
     &   ( 0.5 * (h_sigma(i+1,j)+h_sigma(i,j)) *
     &   factxp*diff_fe_s(i  ,j)*tmask(i+1,kmt_ip1,j) )
     &     - ( 0.5 * (h_sigma(i-1,j)+h_sigma(i,j)) *
     &   factxm*diff_fe_s(i-1,j)*tmask(i-1,kmt_im1,j) )
     &   ) * cstdxtr(i,j) / h_sigma(i,j)

      real DIFF_Ty_s
      DIFF_Ty_s(i,j) =
     &   (
     &   (
     &   factyp*ahc_north_sigma(j) * tmask(i,kmt_jp1,j+1) *
     &   ( 0.5 * (h_sigma(i,j+1)+h_sigma(i,j)) ) *
     &   (t(i,kmt_jp1,j+1,n,taum1) - t(i,kmt(i,j),j,n,taum1))
     &   )
     & - (
     &   factym*ahc_south_sigma(j) * tmask(i,kmt_jm1,j-1) *
     &   ( 0.5 * (h_sigma(i,j)+h_sigma(i,j-1)) ) *
     &   (t(i,kmt(i,j),j,n,taum1) - t(i,kmt_jm1,j-1,n,taum1))
     &   )
     &   ) / h_sigma(i,j)



      if (enable_bbl_advection) then
c
c      calculate 2*advective flux in sigma bottom layer across
c      eastern face of "T" cells. north face component is built
c      into ADV_Ty_s
c
       do j=js,je
        do i=is-1,ie
            if(kmt_big(i+1,j).ne.0.and.kmt_big(i,j).ne.0) then
              adv_fe_s(i,j) = 
     &        adv_vet_s(i,j) *
     &       ( t(i,  kmt_big(i  ,j),j,n,tau) +
     &         t(i+1,kmt_big(i+1,j),j,n,tau) )
            else
              adv_fe_s(i,j) = 0.0
            endif

        enddo
       enddo
c
c      calculate 2*advective flux (for speed) across bottom face of
c      "T" cells. 
c
       do j=js,je
        do k=1,km-1
         do i=is,ie
           adv_fb_su(i,k,j) =
     &         adv_vbt_su(i,k,j) *(t(i,k,  j,n,tau  ) +
     &                             t(i,k+1,j,n,tau  ))
         enddo
        enddo
#ifndef vector_host
        do i=is,ie
         kb=kmt_big(i,j)
         adv_fb_su(i,kb,j) = 0.
         adv_fb_su(i,0 ,j) = 0.
         do k=kb,km
          adv_fb_su(i,k,j) = 0.
         enddo
        enddo
#endif
#ifdef vector_host
        adv_fb_su(:,0,j) = 0.
        do k=1,km
         do i=is,ie
          if (k>=kmt_big(i,j)) adv_fb_su(i,k,j) = 0.
         enddo
        enddo
#endif
       enddo
c
c      Time integration of sigma advection within the
c      inner bottom layer (big Ts, bottom boxes)
c
       do j=js,je
        do i=is,ie
          k=kmt_big(i,j)
          if(k.ne.0) then   
           kmt_im1 = max(1,kmt_big(i-1,j))
           kmt_ip1 = max(1,kmt_big(i+1,j))
           kmt_jp1 = max(1,kmt_big(i,j+1))
           kmt_jm1 = max(1,kmt_big(i,j-1))
           t(i,k,j,n,taup1) = t(i,k,j,n,taup1)+c2dt*
     &                  ( -1.0 * ADV_Tx_s(i,j)*sigma_weight(i,k,j)
     &                    -1.0 * ADV_Ty_s(i,j)*sigma_weight(i,k,j)
     &                    -1.0 * ADV_Tz_s(i,j)*sigma_weight(i,k,j)
     &                  ) * tmask(i,k,j)
          endif       
        enddo
       enddo
c
c      advection in the outer sigma influenced near bottom boxes
c      (small ts, no bottom boxes)
c
       do j=js,je
         do k=1,km
          do i=is,ie
           if(sigma_weight(i,k,j).ne.0.0) then
            ibottom = 1; if(k.ge.kmt_big(i,j)) ibottom = 0
            t(i,k,j,n,taup1) = t(i,k,j,n,taup1)
     &                 + sigma_weight(i,k,j)*c2dt*
     &                  ( -1.0 * ADV_Tx_su(i,k,j)
     &                    -1.0 * ADV_Ty_su(i,k,j)
     &                    -1.0 * ADV_Tz_su(i,k,j)
     &                  )* tmask(i,k,j)
           endif
          enddo
         enddo
       enddo


      endif

      if (enable_bbl_diffusion) then

c       compute diffusive flux across eastern face of "T" cells,
c       diffusive flux across northern face of "T" cells is
c       computed in DIFF_Ty_s 

         do j=js,je
          do i=is-1,ie
            if(kmt_big(i+1,j).ne.0.and.kmt_big(i,j).ne.0) then
              diff_fe_s(i,j) = ah_sigma*cstr(j)*dxur(i)*
     &            ( t(i+1,kmt_big(i+1,j),j,n,taum1) -
     &              t(i  ,kmt_big(i  ,j),j,n,taum1) )
            else
              diff_fe_s(i,j) = 0.0
            endif
          enddo
         enddo
c
c      Time integration of sigma diffusion within the
c      inner bottom layer (big Ts, bottom boxes)
c
c      compute factors for a sigma diffusion condition
c
       do j=js,je
        do i=is,ie
         k=kmt_big(i,j)
         if(k.ne.0) then       ! start k.ne.0

            factxm=0.0; factxp=0.0; factym=0.0; factyp=0.0
            kn=kmt_big(i-1,j)
            factxm=ah_sigma_min/ah_sigma
            if(kn.gt.1) then
              if((k.gt.kn.and.-1.0*rhodiffxp(i-1,j).lt.0.0).or.
     &           (k.lt.kn.and.-1.0*rhodiffxp(i-1,j).gt.0.0)) then
                factxm=1.
              else
                factxm=ah_sigma_min/ah_sigma
              endif
            endif

            kn=kmt_big(i+1,j)
            factxp=ah_sigma_min/ah_sigma
            if(kn.gt.1) then
              if((k.gt.kn.and.rhodiffxp(i,j).lt.0.0).or.
     &           (k.lt.kn.and.rhodiffxp(i,j).gt.0.0)) then
                factxp=1.
              else
                factxp=ah_sigma_min/ah_sigma
              endif
            endif

            kn=kmt_big(i,j-1)
            factym=ah_sigma_min/ah_sigma
            if(kn.gt.1) then
              if((k.gt.kn.and.-1.0*rhodiffyp(i,j-1).lt.0.0).or.
     &           (k.lt.kn.and.-1.0*rhodiffyp(i,j-1).gt.0.0)) then
                factym=1.
              else
                factym=ah_sigma_min/ah_sigma
              endif
            endif

            kn=kmt_big(i,j+1)
            factyp=ah_sigma_min/ah_sigma
            if(kn.gt.1) then
              if((k.gt.kn.and.rhodiffyp(i,j).lt.0.0).or.
     &           (k.lt.kn.and.rhodiffyp(i,j).gt.0.0)) then
                factyp=1.
              else
                factyp=ah_sigma_min/ah_sigma
              endif
            endif

            kmt_im1 = max(1,kmt_big(i-1,j))
            kmt_ip1 = max(1,kmt_big(i+1,j))
            kmt_jp1 = max(1,kmt_big(i,j+1))
            kmt_jm1 = max(1,kmt_big(i,j-1))

            t(i,k,j,n,taup1) = t(i,k,j,n,taup1)+c2dt*
     &          (DIFF_Tx_s(i,j) + DIFF_Ty_s(i,j))*tmask(i,k,j)

         endif       ! end k.ne.0
        enddo
       enddo
      endif



      end subroutine add_bbl

#include "options.inc"
c
c-----------------------------------------------------------------------
c     diagnose meridional overturning 
c     and write to either NetCDF or binary file
c-----------------------------------------------------------------------
c
      subroutine init_over_cdf
      use spflame_module
      implicit none
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer ncid,iret,i,j,k
      real :: spval=-9.9e12
      integer lat_udim,itimedim, depth_tdim,depth_tid
      integer lat_uid,itimeid,vsfid, dims(4), corner(4), edges(4)
      character name*24, unit*16, text*80
#ifdef netcdf_real4
      real (kind=4) , allocatable :: v2(:)
#else
      real          , allocatable :: v2(:)
#endif
      if (my_pe == 0) then
      print*,' initializing NetCDF output file ',over_file
      ncid = nccre (over_file, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call store_info_cdf(ncid)
c     dimensions
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c     grid variables
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
      dims=(/lat_udim,depth_tdim,itimedim,1/)
      vsfid=ncvdef (ncid,'vsf', NCFLOAT,3,dims,iret)
c     attributes of the grid
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c     attributes of variables
      name = 'Meridional overturning'; unit = 'Sv'
      call dvcdf(ncid,vsfid,name,24,unit,16,spval)
      call ncendf(ncid, iret)
      allocate( v2(max(km,jmt)) )
      corner(1) = 1; edges(1) = jmt
      v2(1:jmt)=yu
      call ncvpt(ncid, Lat_uid, corner, edges,v2, iret)
      corner(1) = 1; edges(1) = km
      v2(1:km)=zt/100.
      call ncvpt(ncid, depth_tid, corner, edges,v2, iret)
      deallocate(v2)
      call ncclos (ncid, iret)
      print*,' done'; call sub_flush(6)
      endif ! my_pe==0
#else
c     needs no intialisaztion
#endif
      end subroutine init_over_cdf


      subroutine diag_over
      use spflame_module
      implicit none
      integer i,j,k, is,ie,js,je
      real vbarx(km),vsf(js_pe:je_pe,km)
#ifdef netcdf_diagnostics
#include "netcdf.inc"

#ifdef netcdf_real4
      real (kind=4) :: var(js_pe:je_pe,km)
#else
      real          :: var(js_pe:je_pe,km)
#endif

#else
      integer :: io
      character (len=80) :: iotext
      character (len=60) :: expnam
      real :: vsf_big(jmt,km), reltim = 0.
#endif
      integer ncid,iret,npe
      real :: spval=-9.9e12, tt
      integer vsfid,timeid,timedim,len
      integer corner(4), edges(4)

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      do j=js_pe,je_pe
       do k=1,km
        vbarx=0.
        do i=is, ie
         vbarx(k) = vbarx(k) + u(i,k,j,2,tau)*csu(j)*dxu(i)*umask(i,k,j)
#ifdef partial_cell
     &                      *dhu(i,k,j)
#else
     &                      *dzt(k)
#endif
        enddo
        if (k == 1) then
         vsf(j,k) = vbarx(k)
	else
         vsf(j,k) = vsf(j,k-1) + vbarx(k)
	endif
       enddo
       call sum_along_jrow(vsf(j,:),km)
#ifdef netcdf_diagnostics
       do k=1,km
        npe=0
        do i=1,imt
         if (kmt_big(i,j)>=k) npe=1
        enddo
        vsf(j,k)=vsf(j,k)/1.e12*npe+spval*(1-npe)
       enddo
#endif
      enddo

      if (my_pe==0)
     &  print*,' --> writing overturning to file ',
     &        over_file(1:len_trim(over_file))

#ifdef netcdf_diagnostics
c     write to netcdf format here
      do npe=0,n_pes,n_pes_i
       call barrier
       if (my_pe==npe) then
        iret=nf_open(over_file,NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_varid(ncid,'vsf',vsfid)
        iret=nf_inq_varid(ncid,'Time',timeid)
        iret=nf_inq_dimid(ncid,'Time',timedim)
        iret=nf_inq_dimlen(ncid, timedim,len)
        if (my_pe==0) then
         len=len+1
         corner(1)=len
         edges(1)=1
         call read_stamp(current_stamp,tt)
         print*,' at stamp=',current_stamp,
     &          ' (days since origin : ',tt,')',
     &          ' (time steps in file : ',len,')'
         var(js_pe,1)=tt
         iret= nf_put_vara_real (ncid,timeid, corner,edges,var(js_pe,1))
        endif
        corner=(/js_pe,1,len,1/); edges=(/je_pe-js_pe+1,km,1,1/)
        var=vsf
        iret= nf_put_vara_real (ncid,vsfid ,corner, edges,var)
        call ncclos (ncid, iret)
       endif
       call barrier
      enddo
#else
c     write old flame format here
      if ( my_pe == 0) then
       call getunit (io, over_file,'u s a ieee')
       iotext = 'no iotext'
       expnam = 'SPFLAME, some experiment'
       write (io) current_stamp, iotext, expnam
c           reltim = prelyr
       write (io) jmt, km, reltim
       write (io) current_stamp, iotext, expnam
       write (io) zw
       write (io) current_stamp, iotext, expnam
       write (io) yu
c          vsf_big(1:je_pe,:)=vsf(1:je_pe,:)
       write (io) current_stamp, iotext, expnam
      endif
      vsf_big(js_pe:je_pe,:)=vsf
c      call pe0_recv_vec_along_jrow(vsf_big,km)
      call pe0_recv_merid_vec(vsf_big,km,1)
      if ( my_pe == 0) then
       write(io) vsf_big
       close(io)
      endif
#endif
      end subroutine diag_over

#include "options.inc"


c=======================================================================
c    simple program which sums files written by diag_variances.
c    Useful to sum monthly averages to seasonal or annual averages
c=======================================================================
c
c#define real_8
c
      module kind_mod
#ifdef real_8
      integer, parameter::  r_knd  = selected_real_kind(13)
#else
      integer, parameter::  r_knd  = selected_real_kind(6)
#endif

      end module kind_mod


      program sum_var
      use kind_mod
      implicit none
      real,parameter :: version = 0.1
      integer :: nr_com,nr_infiles
      character (len=80), allocatable :: infile(:)
      character (len=80) :: outfile,ident
      integer , allocatable :: ioin(:)
      integer :: ioout,imt,jmt,km,nt,counter,icounter,blk,m,ierr,n
      real (kind=r_knd), allocatable, dimension(:)  :: xt,yt,xu,yu,zt,zw
      logical :: enable_monthly_variances = .false.
      logical :: enable_seasonal_variances = .false.
      integer, allocatable, dimension(:,:)     :: kmt
      real (kind=r_knd), allocatable, dimension(:,:)     :: buf,buf2
      character (len=2000) :: outstr,str2

      print'(" This is sum_var.x :: version ",f5.3)',version

c  read command line input
      call get_commandline_argnr(nr_com)
      if (nr_com<3) goto 100
      nr_infiles = nr_com-1
      allocate( infile(nr_infiles) ,ioin(nr_infiles) )
      call get_commandline_arg(nr_com,outfile,ierr)
c    write some information to stdout
      outstr=' averaging variances n files :'
      do n=1,nr_infiles
       call get_commandline_arg(n,infile(n),ierr)
       outstr=outstr(1:len_trim(outstr))//
     &            infile(n)(1:len_trim(infile(n)))//','
      enddo
      outstr=outstr(1:len_trim(outstr)-1)//' and writing to file '//
     &   outfile(1:len_trim(outfile))
      print*,outstr(1:len_trim(outstr))

c   open input files 
      do n=1,nr_infiles
       call getunit(ioin(n),infile(n),'usr ieee')
      enddo
      call getunit(ioout,outfile,'usr ieee')

c   read and write
      do n=1,nr_infiles
       read(ioin(n)) imt,jmt,km,nt
      enddo
      print*,' imt=',imt,' jmt=',jmt,' km=',km,' nt=',nt
      write(ioout) imt,jmt,km,nt

      allocate( xt(imt),yt(jmt),xu(imt),yu(jmt),zt(km),zw(0:km))
      allocate( kmt(imt,jmt) )

      icounter=0
      do n=1,nr_infiles
        read(ioin(n)) xt,yt,xu,yu,zt,zw(1:km)
        read(ioin(n)) counter; icounter=icounter+counter
        print*,' counter for averages in file ',
     &           infile(n)(1:len_trim(infile(n))),' =',counter
        read(ioin(n)) enable_monthly_variances
        read(ioin(n)) enable_seasonal_variances
        read(ioin(n)) kmt
      enddo

      write(ioout) xt,yt,xu,yu,zt,zw(1:km)
      write(ioout) icounter
      write(ioout) enable_monthly_variances
      write(ioout) enable_seasonal_variances
      write(ioout) kmt

      allocate( buf(imt,jmt),buf2(imt,jmt) )

 10   read(ioin(1), end=20) blk,ident ! number of blocks and name
      do n=2,nr_infiles
        read(ioin(n)) blk,ident  ! number of blocks and name
      enddo
      print*,' found section ',ident(1:len_trim(ident))
      write(ioout) blk,ident
      do m=1,blk
        buf=0.0
        do n=1,nr_infiles
          read(ioin(n)) buf2 ; buf=buf+buf2
        enddo
        write(ioout) buf
      enddo
      goto 10
 20   continue

c   close all files 
      close (ioout)
      do n=1,nr_infiles
        close(ioin(n))
      enddo
      print*,'all done, bye'
      stop
 100  print*,' program needs command line parameter'
      print*,' input file names, output file name'
      print*,' files must be variances written by SPFLAME'
      stop
      end program sum_var



c   dummy routines

      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"

c
c-----------------------------------------------------------------------
c
c     convert NetCDF files containing the blue correction
c     to forcing files for the model run
c
c-----------------------------------------------------------------------
c
      subroutine halt_stop(string)
      character (len=*) :: string
      print *,string
      stop
      end 

      program prep_blue_const
      implicit none
      integer :: itm,imt,jmt,km,len
      real (kind=4), allocatable :: buf(:,:,:),aprec(:)
      integer :: n,io,i,k,j
      character(len=32):: stamp
      integer :: 
     &days_in_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
#include "netcdf.inc"
      integer :: iret,ncid,blueid
      integer   start(4),count(4),dims(4)
      real (kind=4) :: spval
      character (len=80) :: infile,outfile

      print*,' Converting blue_const forcing file ',
     &       ' from NetCDF to binary '

      call get_commandline_arg(1,infile,iret)
      if (iret/=0) goto 99
      print*,' reading from file ',infile(1:len_trim(infile))
      call get_commandline_arg(2,outfile,iret)
      if (iret/=0) goto 99
      print*,' writing to file ',outfile(1:len_trim(outfile))

      iret=nf_open(infile, NF_nowrite,ncid)

      iret=nf_inq_varid(ncid,'blue_corr',blueid)

      if (iret /= 0 ) then
        print*,' cannotfind variable blue_corr in file'
        call halt_stop(' ERROR ')
      endif

      iret=NF_INQ_VARDIMID (NCID,blueid,dims)
      iret= nf_get_att_real (ncid,blueid ,'missing_value',spval)

      iret=NF_INQ_DIMLEN (NCID, dims(1), imt)
      iret=NF_INQ_DIMLEN (NCID, dims(2), jmt)
      iret=NF_INQ_DIMLEN (NCID, dims(3), km)
      iret=NF_INQ_DIMLEN (NCID, dims(4), len)

      print*,' imt=',imt
      print*,' jmt=',jmt
      print*,' km =',km
      print*,' len=',len

      if (len==1) then
        print*,' found an annual mean correction '
        itm=2
      elseif (len==12) then
        print*,' found a monthly mean correction '
        itm=12
      else
         print*,' do not know what average period '
         call halt_stop(' in prep_const')
      endif

      allocate( aprec(itm) )
      allocate( buf(imt,jmt,km) )

      stamp ='m/d/y= 1/ 1/1900, h:m:s= 0: 0: 0' 

      if (len==1) then
        aprec(:)=365.
      elseif (len==12) then
        do n=1,itm
         aprec(n)=days_in_month(n)
        enddo
      else
         print*,' do not know what average period '
         call halt_stop(' in prep_const')
      endif
       
      call getunit(io,outfile,'usr ieee')
      print*,' writing blue correction '
      write (io) itm,stamp,aprec
      do n=1,itm
        print*,' time step #',n,' (well, really #',min(n,len),')'
        start=(/1,1,1,min(n,len)/); count=(/imt,jmt,km,1/); 
        iret= nf_get_vara_real(ncid,blueid,start,count,buf)
        if (iret /= 0 ) then
         print*,' problem reading variable blue_corr from file'
         call halt_stop(' ERROR ')
        endif
        where( buf == spval ) buf = 0.
        buf = buf /1000. ! convert to cgs units
        do j=1,jmt
         write(io) buf(:,j,:)
        enddo
      enddo
      close(io)
      call ncclos (ncid, iret)

      print*,' all done'

      stop

 99   print*,' program needs command line parameter'
      print*,' 1. input NetCDF file '
      print*,' 2. output binary file '

      end program prep_blue_const

#include "options.inc"



#ifdef netcdf_diagnostics

      subroutine store_info_cdf(ncid)
c
c-----------------------------------------------------------------------
c     store some documentation about this run in a netcdf file
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer, intent(in) :: ncid
#include "netcdf.inc"
      integer :: iret,len
      character (len=200) :: text,text2

c      iret= nf_put_att_real(ncid,nf_global,'',nf_float,1,sp)

      write(text,'("SPFLAME Version ",f5.3)') version
#ifdef no_mpp
      text=text(1:len_trim(text))//' without MPP'
#else
      text=text(1:len_trim(text))//' with MPI'
#endif
      len=len_trim(text)
      iret= nf_put_att_text(ncid,nf_global,'history',len,text)
#ifndef no_mpp
c
c     domain decomposition
c
      iret= nf_put_att_int(ncid,nf_global,'n_pes_i',nf_int,1,n_pes_i)
      iret= nf_put_att_int(ncid,nf_global,'n_pes_j',nf_int,1,n_pes_j)
      iret= nf_put_att_int(ncid,nf_global,'i_blk',nf_int,1,i_blk)
      iret= nf_put_att_int(ncid,nf_global,'j_blk',nf_int,1,j_blk)
c
c     sub domain setup
c
      iret= nf_put_att_int(ncid,nf_global,'mother',nf_int,1,mother)
      iret= nf_put_att_int(ncid,nf_global,'nr_childs',nf_int,
     &                     1,nr_childs)
      if (nr_childs>0) then
       iret= nf_put_att_int(ncid,nf_global,'childs',
     &                      nf_int,nr_childs,childs(1:nr_childs))
      endif
      if (mother>0) then
       iret= nf_put_att_int(ncid,nf_global,'zoom_region',
     &                      nf_int,4,is_zoom,ie_zoom,js_zoom,je_zoom)
       iret= nf_put_att_int(ncid,nf_global,'zoom_fac',nf_int,
     &                      1,zoom_fac)
       iret= nf_put_att_int(ncid,nf_global,'zoom_fac_k',nf_int,
     &                      1,zoom_fac_k)
       iret= nf_put_att_int(ncid,nf_global,'topo_smooth_iterations',
     &                      nf_int,1,topo_smooth_iterations)
       text='no'
# ifdef sub_use_ref_topo_in_sub_domain
       text='yes'
# endif
       len=len_trim(text)
       iret= nf_put_att_text(ncid,nf_global,
     &                       'ref_topo_in_sub_domain',len,text)
       text='no'
# ifdef sub_hand_tuning_topo_in_sub_domain
       text='yes'
# endif
       iret= nf_put_att_text(ncid,nf_global,
     &              'hand_tuning_topo_in_sub_domain',len,text)
       text2 = 'normal'
#ifdef sub_wide_obc_friction_zone
       text2='wide'
#endif
#ifdef sub_narrow_obc_friction_zone
       text2='narrow'
#endif
       text='extent '//text2;text2='normal'
#ifdef sub_high_obc_friction_zone
       text2='high'
#endif
#ifdef sub_quadratic_obc_friction_zone
       text2='quadratic'
#endif
       text=text(1:len_trim(text))//' amplitude '//text2
       len=len_trim(text)
       iret= nf_put_att_text(ncid,nf_global,'obc_friction',len,text)
      endif ! mother > 0
#endif
c
c     general setup
c
#if defined linear_density
      text='linear'
#elif defined flame_density
      text='3. order polynomial taken from FLAME'
#elif defined polynomial_fit_density
      text='3. order polynomial fit'
#elif defined mcdougall_density
      text='Jackett and McDougall'
#elif defined  MWJ_density
      text='Jackett, Wright and McDougall'
#else
       error
#endif
      len=len_trim(text)
      iret= nf_put_att_text(ncid,nf_global,'eq_of_state',len,text)
      text='spherical earth'
      if (enable_beta_plane)   text='beta plane'
      if (enable_f_plane)      text='f plane'
      if (enable_rotated_grid) text='spherical earth, but rotated grid'
      len=len_trim(text)
      iret= nf_put_att_text(ncid,nf_global,'coriolis_setup',len,text)
      text = 'no'
      if (enable_blue) text = 'yes'
      len=len_trim(text)
      iret= nf_put_att_text(ncid,nf_global,'with_blue',len,text)
      text='Central differences'
      if (enable_quicker_advection) text='Quicker'
      if (enable_flux_delimiter)
     &  text=text(1:len_trim(text))//
     &    ' and flux delimiter for passive tracer'
      len=len_trim(text)
      iret= nf_put_att_text(ncid,nf_global,'advection_scheme',len,text)
      text = 'no'
#ifdef partial_cell
      text = 'yes'
#endif
      len=len_trim(text)
      iret= nf_put_att_text(ncid,nf_global,'with_partial_cell',len,text)
c
c     parameterisations
c
      text=''
      if (enable_friction_harmonic) then
        write(text2,'(" harmonic, am=",e12.6," cm^2/s")') am
        text=text(1:len_trim(text))//text2
      endif
      if (enable_friction_biharmonic) then
        write(text2,'(" biharmonic, ambi=",e12.6," cm^4/s")') ambi
        text=text(1:len_trim(text))//text2
      endif
      if (enable_friction_cosine_scal) 
     & text=text(1:len_trim(text))//' scaled with cosine of latitude'
      len=len_trim(text)
      iret= nf_put_att_text(ncid,nf_global,'hor_friction',len,text)

      text=''
      if (enable_diffusion_harmonic) then
        write(text2,'(" harmonic, ah=",e12.6," cm^2/s")') ah
        text=text(1:len_trim(text))//text2
      endif
      if (enable_diffusion_biharmonic) then
        write(text2,'(" biharmonic, ahbi=",e12.6," cm^4/s")') ahbi
        text=text(1:len_trim(text))//text2
      endif
      if (enable_diffusion_cosine_scal)  then
       if (enable_diffusion_harmonic .or.
     &    enable_diffusion_biharmonic) then
        text=text(1:len_trim(text))//' scaled with cosine of latitude'
       endif
      endif
      if (enable_diffusion_isoneutral) then
        write(text2,'(" isoneutral, ahisop=",e12.6," cm^2/s")') ahisop
        text=text(1:len_trim(text))//text2
        write(text2,'(" ,athkdf=",e12.6," cm^2/s")') athkdf
        text=text(1:len_trim(text))//text2
        write(text2,'(" ,ahsteep=",e12.6," cm^2/s")') ahsteep
        text=text(1:len_trim(text))//text2
        write(text2,'(" ,del_dm=",e12.6," s_dem=",e)') del_dm,s_dm
        text=text(1:len_trim(text))//text2
      endif
      if (enable_diffusion_isopycnic) then
        write(text2,'(" isopycnal, ahisop=",e12.6," cm^2/s")') ahisop
        text=text(1:len_trim(text))//text2
        write(text2,'(" ,athkdf=",e12.6," cm^2/s")') athkdf
        text=text(1:len_trim(text))//text2
        write(text2,'(" ,del_dm=",e12.6," s_dem=",e)') del_dm,s_dm
        text=text(1:len_trim(text))//text2
      endif
      len=len_trim(text)
      iret= nf_put_att_text(ncid,nf_global,'hor_diffusion',len,text)

      if (enable_const_vert_mixing) then
        write(text,'("constant, kappa_m=",e12.6," kappa_h=",e12.6)') 
     &            kappa_m,kappa_h
      endif
      if (enable_cgh_vert_mixing) then
        text=' CGH vertical mixing'
      endif
      if (enable_tkemix) then
        text=' TKE vertical mixing'
      endif
      if (enable_implicit_vert_fric) 
     &   text=text(1:len_trim(text))//' implicit momentum mixing'
      if (enable_implicit_vert_diff) 
     &   text=text(1:len_trim(text))//' implicit tracer mixing'
      len=len_trim(text)
      iret= nf_put_att_text(ncid,nf_global,'vert_mixing',len,text)

      end subroutine store_info_cdf



      subroutine dvcdf(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c     define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character (len=*) :: name, unit
      real :: spval
#ifdef netcdf_real4
      real (kind=4) :: vv
#else
      real :: vv
#endif
#include "netcdf.inc"
      vv=spval
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncapt (ncid,ivarid, 'missing_value',NCFLOAT,1,vv,iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncapt (ncid,ivarid, '_FillValue', NCFLOAT, 1,vv, iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf
#else
      subroutine store_info_cdf(ncid)
      integer :: ncid
      end subroutine store_info_cdf
#endif

#include "options.inc"



      module spflame_module

c==============================================================
c     Main module for SPFLAME
c                               Jul 2001   c.eden
c==============================================================

      use time_manager_module
      use dens_module
      use timing_module
      implicit none

      real, parameter :: version = 1.0

!     set some physical and mathematical constants       
      real, parameter :: rho0     = 1.035
      real, parameter :: rho0r    = 1./rho0
      real, parameter :: grav     = 980.6
      real, parameter :: radius   = 6370.0e5
      real, parameter :: pi       = 
     &        3.14159265358979323846264338327950588
      real, parameter :: omega    = pi/43082.0

!     extent of model domain, number of tracers
      integer            :: imt=0,jmt=0,km=0,nt=0 
!     time step in sec., length of run in days
      real               :: time_step=0.,runlen=0.
!     restart stuff, time stamp of last restart
      character (len=32) :: restart_stamp    
      integer            :: itt_restart  ! time step of last restart
      logical :: read_restart = .false.  ! read from restart file

!     PE number and number of PEs in sub domain
      integer :: my_pe,n_pes      
!     number of all PEs in i/j-direction
      integer :: n_pes_i=0,n_pes_j=0
!     hor. extent of PE domains in i/j-direction
      integer :: i_blk,j_blk      
!     hor. start/end index of this PE domain
      integer :: is_pe,ie_pe,js_pe,je_pe  
!     number of this PE in i/j-dir.
      integer :: my_blk_j,my_blk_i        
!     max number of sub domain and actual number
      integer :: domains   
      integer, parameter :: max_domains=100
      integer :: sub_domain_pe0(max_domains) ! first PE of each sub domain
!     mpi communicator for sub domain and number of this sub domain
!                                         (only used for IO file name)
      integer :: my_comm,sub_domain       
      integer :: mother = -1, childs(max_domains) ! number of the mother domain 
      integer :: nr_childs = 0                    ! and numbers of the child domains
!     factor for zooming of sub domain and indices of sub domain in mother domain
      integer :: zoom_fac=0,is_zoom=0,ie_zoom=0,js_zoom=0,je_zoom=0
!     zoom factor in k-dir. and number of levels in mother domain
      integer :: zoom_fac_k = 1, km_mother 
!     smooth mother-topography for sub domain nn times
      integer :: topo_smooth_iterations = 1 


!     general setup
      logical :: cyclic              = .false. ! cyclic boundary conditions
      logical :: enable_freesurf     = .false. ! free surface or rigid lid
      logical :: enable_beta_plane   = .false. ! beta plane
      integer :: beta_plane_j0       = 1       ! reference grid point 
      logical :: enable_f_plane      = .false. ! f plane
      logical :: enable_rotated_grid = .false. ! use a rotated grid a binary file of
                                               ! unrotated latitudes have to be provided
      logical :: enable_simple_grid = .false. ! generate a simple grid, otherwise 
                                              ! binary file will be read, 
                                              ! see also file setup_template.F
      logical :: enable_simple_topo = .false. ! same for topography
      logical :: enable_simple_initial_cond = .false. 
      logical :: enable_simple_sbc = .false. 
      logical :: enable_simple_obc = .false. 
      logical :: enable_simple_spg = .false. 
      logical :: enable_sponge     = .false.   ! try to read sponge data from file

!   SBC setup
      logical :: enable_salt_flux_sbc            = .false.  ! salt flux instead of restoring
      logical :: enable_shortwave_sbc            = .false.  ! penetrative solar radiation

!     open boundary setup
      logical :: enable_obc_north = .false.  ! open northern boundary 
      logical :: enable_obc_south = .false.
      logical :: enable_obc_west  = .false.
      logical :: enable_obc_east  = .false.

      logical :: restore_TS_obc_north = .false. ! restore to TS field in addition
      logical :: restore_TS_obc_south = .false. ! to the radiation condition
      logical :: restore_TS_obc_west  = .false.
      logical :: restore_TS_obc_east  = .false.

      logical :: prescribe_psi_obc_north = .false.! prescribe streamfct. do not use
      logical :: prescribe_psi_obc_south = .false. ! an orlanski radiation cond.
      logical :: prescribe_psi_obc_west  = .false.
      logical :: prescribe_psi_obc_east  = .false.

      logical :: enable_obc_adjust_islands = .false.

      ! the following parameters define a frictional sponge for obc south
      ! for mother domain only
      logical :: enable_obc_south_sponge       = .false.
      logical :: enable_obc_south_sponge_harm  = .false.
      logical :: enable_obc_south_sponge_diff  = .false.
      integer :: obc_south_sponge_width   = 45 
      real    :: obc_south_sponge_scale   = 6.
      real    :: obc_south_sponge_fac     = 10.
      ! same for obc_north
      logical :: enable_obc_north_sponge       = .false.
      logical :: enable_obc_north_sponge_harm  = .false.
      logical :: enable_obc_north_sponge_diff  = .false.
      integer :: obc_north_sponge_width   = 45 
      real    :: obc_north_sponge_scale   = 6.
      real    :: obc_north_sponge_fac     = 10.
      ! same for obc_east
      logical :: enable_obc_east_sponge       = .false.
      logical :: enable_obc_east_sponge_harm  = .false.
      logical :: enable_obc_east_sponge_diff  = .false.
      integer :: obc_east_sponge_width   = 45 
      real    :: obc_east_sponge_scale   = 6.
      real    :: obc_east_sponge_fac     = 10.
      ! same for obc_west
      logical :: enable_obc_west_sponge       = .false.
      logical :: enable_obc_west_sponge_harm  = .false.
      logical :: enable_obc_west_sponge_diff  = .false.
      integer :: obc_west_sponge_width   = 45 
      real    :: obc_west_sponge_scale   = 6.
      real    :: obc_west_sponge_fac     = 10.

!     basic horizontal mixing setup
      logical :: enable_diffusion_harmonic   = .false.! harmonic (z-level) diffusion
      logical :: enable_diffusion_biharmonic = .false.
      logical :: enable_diffusion_isoneutral = .false. ! new scheme by Griffith
      logical :: enable_diffusion_isopycnic  = .false. ! old Redi/Cox scheme
      logical :: enable_friction_harmonic    = .false.! harmonic friction
      logical :: enable_friction_biharmonic  = .false.! biharmonic ( del^4 u )

      logical :: enable_isopycnic_horvar     = .false. ! horizontal varying thickness diff 
                                                        ! in Redi/Cox scheme (for eddy-perm. appl.)
      logical :: enable_no_isopyc_medwater   = .false. ! no isopycnic diffusion in Gibraltar area (only HS_4)


      logical :: enable_friction_cosine_scal  = .false. ! scale all diff/fric.parameters
      logical :: enable_diffusion_cosine_scal = .false. ! with cosine of latitude

!     basic vertical mixing setup
      logical :: enable_implicit_vert_diff   = .false. ! semi-implicit vert diffusion
      logical :: enable_implicit_vert_fric   = .false. ! semi-implicit vert friction
      logical :: enable_const_vert_mixing        = .false.! constant vertical mix.
      logical :: enable_cgh_vert_mixing          = .false.! Cummins et al mix.
      logical :: enable_cgh_vert_momentum_mixing = .false.! also for momentum
      logical :: enable_cgh_impl_convection      = .false.! implicit convection scheme
      logical :: enable_kpp_vert_mixing          = .false.! not yet implemented
      logical :: enable_expl_convection          = .false.! explicit convection scheme
      logical :: enable_impl_convection          = .false.! implicit convection scheme
      logical :: enable_ktmix                    = .false.! Kraus Turner wind stirring
      logical :: enable_tkemix                   = .false.! Gaspar et al 90 TKE mixing 


!     BLUE setup
      logical :: enable_blue         = .false. ! enables the BLUE approach
      logical :: enable_blue_smooth  = .false. ! smoothed version of BLUE
      logical :: enable_blue_const   = .false. ! constant forcing version of BLUE
      logical :: enable_blue_tapered = .false. ! boundary tapering
      integer :: ismooth_blue  = 2             ! index for smoothing running mean 
      integer :: ilook_blue = 1                ! index for boundary tapering
      logical :: enable_blue_mean    = .false. ! enables the mean BLUE approach
      logical :: enable_blue_simple  = .false. ! setup BLUE for simple configuration
                                               ! see also file setup_template.F

!     basic horizontal mixing parameter
      real :: ah=2e7              ! constant harmonic diffusivity (cm^2/s)
      real :: am=1e8              ! constant harmonic viscosity (cm^2/s)
      real :: ahbi=2e19           ! constant biharmonic diffusivity (cm^4/s)
      real :: ambi=2e19           ! constant biharmonic viscosity (cm^4/s)
      real :: slmx    = 1.0/100.0 ! Maximum isoneutral slope for -Dgkw_taper
      real :: del_dm = 4.0/1000.0 ! transition for scaling isoneutral 
                                  ! diffusivities with -Ddm_taper
      real :: s_dm = 1.0/1000.0   ! half width scaling for diffusivity with -Ddm_taper
      real :: ahisop  = 1.e7      ! Redi isoneutral diffusivity (cm2/sec)
      real :: athkdf  = 1.e7      ! Gent and McWilliams diffusivity (cm2/sec)
      real :: athkdf_ep = 1.e7    ! same for module epflux
      real :: athkdf_ep2= 1.e7    ! same for module epflux
      real :: ahsteep = 1.e7      ! Horizontal diffusivity used in regions 
                                    ! of steep slopes (cm2/sec)
      real :: isohv_a1  = 0.5     ! for horizontal varying ahisop/ahthkdf coeff.
      real :: isohv_a2  = 2.0     ! for horizontal varying ahisop/ahthkdf coeff.
     
      real :: aidif_tracer   = 0.0 ! parameter for implicit vertical mixing
      real :: aidif_momentum = 0.0 ! 0.5 is Crank-Nicholsen, they are set automatically

!     constant vertical mixing parameters
      real :: kappa_h=0.3         ! constant vertical diffusivity (cm^2/s)
                                  ! NOTE: always used at open boundaries
      real :: kappa_m=10          ! constant vertical viscosity (cm^2/s)

!     parameter for Cummins, et al (JPO, 20, 1990, 817-830) vertical mixing
      real :: cgh_vdcfac(2) = (/1.e-3,1.e-2/)
      real :: diff_cbt_cut  = 4.0
      real :: diff_cbt_back = 0.1
      real :: wndmix        = 50.0
      real :: visc_cbu_cut  = 10.0
      real :: visc_cbu_back = 1.0

!     Kraus Turner mixed layer model, see vmixc.F
      real    :: effwind=0.8, z_scale=5000.0

!     penetration scale for shortwave radiation
      real ::  rpart_shortwave  = 0.58
      real ::  efold1_shortwave = 35.0e0
      real ::  efold2_shortwave = 23.0e2

!     TKE closure scheme a la Gaspar et al
!     standard parameters were given by A.Oschlies
      real :: C_eps        =0.7   ! coef. of the Kolmogoroff dissipation
      real :: C_kappa      =0.1   ! coeff. for vertical eddy coef.
      real :: C_tke        =30.   ! coef. for the tke vert. diff. coeff.
      real :: tke_min      =4.e-2 ! minimum value of tke (cm2/s2)
      real :: tke_min_surf =1.    ! surface minimum value of tke (cm2/s2)
      real :: tke_surf_fac =3.0   ! coef. of the surface input of tke
      integer :: nmxl      =2     ! = 0/1/2/3 flag for mixing length used
!     NOTE:  also used for tkemix are parameters diff_cbt_cut, diff_cbt_back,
!            visc_cbu_cut, visc_cbu_back from CGH mixing

      real :: visc_cnu,visc_ceu    ! do not touch these
      real :: diff_cet,diff_cnt    ! do not know why

!     parameter for bottom drag, see setvbc.F
      real :: cdbot=0.,tidaloff=0.

!     bottom boundary layer parametrisation
      logical :: enable_bbl            = .false. ! enable BBL
      logical :: enable_bbl_advection  = .false. ! enable adv. transport in BBL
      logical :: enable_bbl_diffusion  = .false. ! enable diffusive transport
      real :: ah_sigma=1.0e8           ! diffusivity in sigma layer (cm^2/s)
      real :: ah_sigma_min=1e1         ! minimal diffusivity (cm^2/s)
      logical :: enable_bbl_only_north = .false. ! enable BBl only north of 45N and south of 45S
                                                  ! i.e. not for the Med Sea overflow

!     advection schemes
      logical :: enable_quicker_advection = .false.  ! quicker advection for tracers
      logical :: enable_upstream_advection= .false.  ! upstream advection for tracers
      logical :: enable_4th_advection     = .false.  ! 4.th ord. advection for tracers
      logical :: enable_fct_advection     = .false.  ! FCT advection for tracers
      logical :: enable_flux_delimiter    = .false.  ! limit flux for passive tracers
!     using the multidim. pos. definite adv. scheme (MPDCD) by Lafore, et al 1998

!     icemask shots off the surface heat and salt fluxes
!     if SST falls below the freezing point
      logical :: enable_icemask =  .false.
!     account for effect of ocean currents on wind stress
!     (should be small)
      logical :: enable_windstress_feedback =  .false.

!     hor. diagnostic fields for convective adjustment
c     lctot = total of number of levels involved in convection
c     lcven = number of levels ventilated (convection to surface)
      integer, allocatable :: lctot(:,:), lcven(:,:)

!     parameter for the poisson solver
      real    :: eps_solver=1.e8 
      integer :: max_itts_solver=500

!     Diagnostics setup
      real    :: snap_int=0. ! snaphost interval, also used for all other diagnostics
      logical :: enable_snapshots   = .false.    ! NetCDF snapshot
      logical :: enable_timeseries  = .false.    ! Timeseries output
      logical :: enable_ts_monitor  = .true.     ! Time step monitor
      logical :: enable_overturning = .false.    ! meridional overturning
      logical :: enable_heat_tr     = .false.    ! meridional tracer transports
      logical :: enable_diag_press     = .false. ! diagnostic surface/bottom pressure
      logical :: enable_diag_float     = .false. ! float diagnostics
      logical :: enable_diag_blue      = .false. ! BLUE diagnostics
      real    :: eps_surf_press = 1.e-4          ! epsilon for surf. press. in solver 

      character (len=80) :: snap_file='snap.cdf'  ! snapshot netcdf filename
      character (len=80) :: over_file      ='vsf.cdf' 
      character (len=80) :: heat_tr_file   ='heat_tr.cdf'  
      character (len=80) :: diag_press_file='diag_press.cdf'  
      character (len=80) :: diag_float_file='float.cdf'  
 
      logical :: enable_annual_averages   = .false.  ! annual averaged quantities
      logical :: enable_seasonal_averages = .false.
      logical :: enable_monthly_averages  = .false.
      logical :: enable_daily_averages    = .false.
      logical :: enable_seasonal_variances= .false.  ! same for second order moments
      logical :: enable_monthly_variances = .false.
      logical :: enable_daily_variances   = .false.

      logical :: enable_show_island_map   = .false.  ! show a map of islands in stdout
      logical :: enable_stability_tests   = .false.  ! CFL, etc. However very slow


!     basinwide integrated area and volume of T-cell and U-cell grid boxes
      real, allocatable :: tcella(:),ucella(:)
      real :: tcellv,ucellv
      integer :: itts_solver ! last number of iteration needed in the poisson solver
        
!     main working arrays
      real, allocatable :: rho(:,:,:)
      real, allocatable :: u(:,:,:,:,:),t(:,:,:,:,:)

!     advection and diffusion
      real, allocatable :: adv_vnt(:,:,:)
      real, allocatable :: adv_vet(:,:,:)
      real, allocatable :: adv_vbt(:,:,:)

      real, allocatable :: adv_vnu(:,:,:)
      real, allocatable :: adv_veu(:,:,:)
      real, allocatable :: adv_vbu(:,:,:)

      real, allocatable :: visc_cbu(:,:,:)
      real, allocatable :: diff_cbt(:,:,:)

!     barotropic mode and forcing for it
      real, allocatable :: zu(:,:,:),psi(:,:,:),ptd(:,:),guess(:,:)

!     topography related arrays
      integer, allocatable :: kmt(:,:),kmu(:,:),map(:,:)
      integer, allocatable :: kmt_big(:,:) ! topography for entire model
      real,    allocatable :: hr(:,:)
      real,    allocatable :: tmask(:,:,:)
      real,    allocatable :: umask(:,:,:)

!     other arrays
      real, allocatable :: source(:,:,:)
      real, allocatable :: am_scale(:,:)
      real, allocatable :: ambi_scale(:,:)
      real, allocatable :: ah_scale(:,:)
      real, allocatable :: ahbi_scale(:,:)
      real, allocatable :: adv_scale(:,:)

!     grid variables
      real,allocatable :: xt(:), yt(:), xu(:), yu(:),
     & dxtdeg(:), dytdeg(:), dxudeg(:), dyudeg(:),
     & dxt(:), dyt(:), dxu(:), dyu(:),
     & dytr(:),dyt2r(:), dyt4r(:), dyur(:),dyu2r(:), dyu4r(:),
     & phi(:),phit(:), cst(:),csu(:),sine(:),
     & cstr(:),csur(:),tng(:),
     & cstdytr(:), cstdyt2r(:),csudyur(:),csudyu2r(:),
     & cst_dytr(:),csu_dyur(:),
     & dus(:),dun(:),
     & dxtr(:),dxt2r(:),dxur(:), dxu2r(:),
     & dxt4r(:),dxu4r(:),
     & dxmetr(:),duw(:),due(:),
     & zt(:),zw(:),dzt(:),dzw(:),
     & c2dzt(:), dztr(:), dzt2r(:),
     & rho0dztr(:), dzwr(:), dzw2r(:),
     & rho0csudyur(:), dztur(:), dztlr(:)

!     grid related variables
      real, allocatable :: rho0csudxur(:,:), csudxu2r(:,:),
     &                     am_csudxtr(:,:)  
      real, allocatable :: cstdxtr(:,:), cstdxt2r(:,:),
     &                     ah_cstdxur(:,:) 

      real, allocatable :: cori(:,:,:)  ! +/-coriolis factor, always 2 dimensional
      real, allocatable :: am3_biha(:),am4_biha(:,:),advmet(:,:)
      real, allocatable :: am3_ha(:),am4_ha(:,:)

      real, allocatable :: amc_north_ha(:),amc_south_ha(:)
      real, allocatable :: ahc_north_ha(:),ahc_south_ha(:)

!     surface  boundary conditions
      real, allocatable :: smf(:,:,:),bmf(:,:,:)
      real, allocatable :: stf(:,:,:),btf(:,:,:)
      real, allocatable :: stf_rest(:,:,:),stf_clim(:,:,:)
      real, allocatable :: icemask(:,:),ustar(:,:),dml(:,:)
      real, allocatable :: qsol(:,:),divpen_shortwave(:)

!     open boundary conditions
      real, allocatable :: c1ps(:),c1pn(:),c1pe(:),c1pw(:)
      real, allocatable :: psi_wall_north(:)
      real, allocatable :: psi_wall_east(:)
      real, allocatable :: psi_wall_west(:)
      real, allocatable :: psi_wall_south(:)
      real, allocatable :: ts_obc_south(:,:,:)
      real, allocatable :: ts_obc_north(:,:,:)
      real, allocatable :: ts_obc_east(:,:,:)
      real, allocatable :: ts_obc_west(:,:,:)

!     TKE stuff
      real, allocatable :: eke(:,:,:,:)

!     partial bottom cells
!
!     htp   = depth (cm) from surface to the bottom of partial T-cells
!     hup   = depth (cm) from surface to the bottom of partial U-cells
!     dh = delta thickness, dhwt = vertical distance between T points 
!     fracdz(k,0) = fractional distance between grid point and cell top
!     fracdz(k,1) = fractional distance between grid point and cell bot
!     ztp : corresponding to zt
!
      real, dimension(:,:)  , allocatable :: htp, hup
      real, dimension(:,:,:), allocatable :: dht, dhu, dhwt
      real, dimension(:,:,:), allocatable :: pc_sink_ha
      real, dimension(:,:,:), allocatable :: pc_sink_biha
      real, dimension(:,:,:), allocatable :: ztp
      real, dimension(:,:)  , allocatable :: fracdz

      end module spflame_module

      subroutine init_spflame_module
c
c-----------------------------------------------------------------------
c     Initialization of the main module
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
c
c     the main namelist 
c

      namelist /spflame_basic/ 
c
c                 domain, number of tracers and PE decomposition
c
     &            imt,jmt,km,nt,n_pes_i,n_pes_j,
c
c                 time stepping
c
     &            time_step,runlen

      namelist /spflame_nesting_setup/ 
c
c                 nesting of sub domains
c
     &            mother, childs, nr_childs,
     &            zoom_fac,is_zoom,ie_zoom,js_zoom,je_zoom, zoom_fac_k,
     &            topo_smooth_iterations

      namelist /spflame_general_setup/ 
c
c                 general setup
c
     &            cyclic, read_restart,  enable_freesurf,
     &            enable_beta_plane, beta_plane_j0, enable_f_plane,
     &            enable_rotated_grid,
     &            enable_simple_grid, enable_simple_topo ,
     &            enable_simple_initial_cond  ,
     &            enable_simple_sbc, enable_simple_obc ,
     &            enable_simple_spg , enable_sponge

      namelist /spflame_hor_mixing_setup/ 
c
c                 basic horizontal mixing setup
c
     &            enable_diffusion_harmonic   ,
     &            enable_diffusion_biharmonic ,
     &            enable_diffusion_isoneutral ,
     &            enable_diffusion_isopycnic ,
     &            enable_isopycnic_horvar ,
     &            enable_no_isopyc_medwater ,
     &            enable_friction_harmonic    ,
     &            enable_friction_biharmonic  ,
     &            enable_friction_cosine_scal  ,
     &            enable_diffusion_cosine_scal  

      namelist /spflame_vert_mixing_setup/ 
c
c                 basic vertical mixing setup
c
     &            enable_implicit_vert_diff,
     &            enable_implicit_vert_fric,
     &            enable_const_vert_mixing        ,        
     &            enable_cgh_vert_mixing          ,        
     &            enable_cgh_vert_momentum_mixing ,        
     &            enable_cgh_impl_convection      ,  
     &            enable_kpp_vert_mixing          ,  
     &            enable_expl_convection          ,  
     &            enable_impl_convection          ,  
     &            enable_ktmix,               
     &            enable_tkemix                     

      namelist /spflame_advection_scheme/ 
c
c                 advection schemes
c
     &            enable_quicker_advection,
     &            enable_upstream_advection,
     &            enable_4th_advection,
     &            enable_fct_advection,
     &            enable_flux_delimiter


      namelist /spflame_obc_setup/ 
c
c                 Open boundaries set up
c
     &            enable_obc_north, enable_obc_south,
     &            enable_obc_west,  enable_obc_east,
     &            restore_TS_obc_north, restore_TS_obc_south,
     &            restore_TS_obc_west,  restore_TS_obc_east,
     &            prescribe_psi_obc_north, prescribe_psi_obc_south,
     &            prescribe_psi_obc_west,  prescribe_psi_obc_east,
     &            enable_obc_south_sponge ,  obc_south_sponge_fac   ,
     &            enable_obc_south_sponge_harm ,
     &            enable_obc_south_sponge_diff,
     &            obc_south_sponge_width,obc_south_sponge_scale ,
     &            enable_obc_north_sponge ,  obc_north_sponge_fac  ,
     &            enable_obc_north_sponge_harm ,
     &            enable_obc_north_sponge_diff ,
     &            obc_north_sponge_width , obc_north_sponge_scale ,
     &            enable_obc_east_sponge ,  obc_east_sponge_fac  ,
     &            enable_obc_east_sponge_harm ,
     &            enable_obc_east_sponge_diff ,
     &            obc_east_sponge_width , obc_east_sponge_scale ,
     &            enable_obc_west_sponge ,  obc_west_sponge_fac  ,
     &            enable_obc_west_sponge_harm ,
     &            enable_obc_west_sponge_diff ,
     &            obc_west_sponge_width , obc_west_sponge_scale ,
     &            enable_obc_adjust_islands

      namelist /spflame_sbc_setup/ 
c
c                   surface boundary setup
c
     &            enable_salt_flux_sbc,     ! fixed salt flux
     &            enable_shortwave_sbc,     ! shortwave penetration
     &            enable_icemask,           !  icemask, zero order ice model
     &            enable_windstress_feedback,! effect of ocean currents on wind stress
     &            efold1_shortwave,efold2_shortwave,rpart_shortwave
c                                   Shortwave radiation penetration scale

      namelist /spflame_blue_setup/ 
c
c                 Blue stuff
c
     &            enable_blue,enable_blue_simple,
     &            enable_blue_smooth,enable_blue_const,ismooth_blue,
     &            enable_blue_tapered, ilook_blue, enable_blue_mean

      namelist /spflame_bbl_setup/
c
c                 bottom boundary layer parametrisation
c
     &            enable_bbl,  
     &            enable_bbl_advection, enable_bbl_diffusion,
     &            ah_sigma, ah_sigma_min,enable_bbl_only_north


      namelist /spflame_mixing_parameters/ 
c
c                 horizontal mixing parameters
c
     &            ambi,ahbi,ah,am, isohv_a1,isohv_a2,
     &            ahisop,athkdf,slmx,ahsteep,del_dm,s_dm,
c
c                 vertical mixing parameters
c
     &            kappa_m,kappa_h,
     &            cgh_vdcfac, diff_cbt_cut, diff_cbt_back, 
     &            wndmix,     visc_cbu_cut, visc_cbu_back,
c
c                 bottom friction
c
     &            tidaloff,cdbot,
c
c                 Kraus Turner model
c
     &            effwind, z_scale,
c
c                 TKE model
c
     &            C_eps,C_kappa,C_tke,
     &            tke_min,tke_min_surf,tke_surf_fac,nmxl

      namelist /spflame_solver/ 
c
c                 poisson solver
c
     &            eps_solver,
     &            max_itts_solver


      namelist /spflame_diagnostics/ 
c
c                 Diagnostics
c
     &            snap_int,
     &            enable_snapshots,
     &            enable_timeseries,
     &            enable_ts_monitor,
     &            enable_overturning,over_file,
     &            enable_heat_tr,heat_tr_file,
     &            enable_diag_press,diag_press_file,eps_surf_press,
     &            enable_annual_averages,
     &            enable_seasonal_averages,
     &            enable_monthly_averages,
     &            enable_daily_averages,
     &            enable_seasonal_variances,
     &            enable_monthly_variances,
     &            enable_daily_variances,
     &            enable_show_island_map,
     &            enable_stability_tests,
     &            enable_diag_float,diag_float_file,
     &            enable_diag_blue


      integer k,ierr,n
      character (len=80) :: name

      call mpi_comm_rank(my_comm,my_pe,ierr)
      call mpi_comm_size(my_comm,n_pes,ierr)

      if (my_pe == 0) then
       print*,''
       print*,' ------------------------------------------'
       print*,''
       print'("      SPFLAME version ",f5.3)',version
       print*,''
       print*,' ------------------------------------------'
       print*,''
       print*,'       reading namelist input'
      endif

c     read in namelist for this specific sub_domain 

      write(name, '("namelist.spflame_",i3)') sub_domain
      do k=1,len_trim(name); if (name(k:k)==' ')name(k:k)='0'
      enddo
      call get_free_iounit(n)
      open(n,file=name,form='formatted',status='old')
      read(n,nml = spflame_basic) 
      read(n,nml = spflame_nesting_setup) 
      read(n,nml = spflame_general_setup) 
      read(n,nml = spflame_hor_mixing_setup) 
      read(n,nml = spflame_vert_mixing_setup) 
      read(n,nml = spflame_advection_scheme) 
      read(n,nml = spflame_obc_setup) 
      read(n,nml = spflame_sbc_setup) 
      read(n,nml = spflame_blue_setup) 
      read(n,nml = spflame_bbl_setup) 
      read(n,nml = spflame_mixing_parameters) 
      read(n,nml = spflame_solver) 
      read(n,nml = spflame_diagnostics) 
      close(n)
c
c     do the MPP setup
c
      if (mother<0) then
       if (my_pe==0) then
        print*,''
        print*,' sub_domain #',sub_domain
        call getunit(n,'document_000.dta','fsr')
        write(n,'("SPFLAME Version ",f5.3)') version
        write(n,*) 'spflame namelist input:'
        write(n,nml = spflame_basic) 
        write(n,nml = spflame_hor_mixing_setup) 
        write(n,nml = spflame_vert_mixing_setup) 
        write(n,nml = spflame_blue_setup) 
        write(n,nml = spflame_bbl_setup) 
        write(n,nml = spflame_mixing_parameters) 
        write(n,nml = spflame_advection_scheme) 
        write(n,nml = spflame_solver) 
        write(n,nml = spflame_nesting_setup) 
        write(n,nml = spflame_general_setup) 
        write(n,nml = spflame_obc_setup) 
        write(n,nml = spflame_sbc_setup) 
        write(n,nml = spflame_diagnostics) 
        close(n)
        print*,''
        print*,' namelist input written to file document_000.dta '
        print*,''
       endif
       km_mother=km
      else
       if (my_pe==0) then
        print*,''
        print*,' sub_domain #',sub_domain
        write(name, '("document_",i3,".dta")') sub_domain
        do k=1,len_trim(name); if (name(k:k)==' ')name(k:k)='0'
        enddo
        call getunit(n,name,'fsr')
        write(n,'("SPFLAME Version ",f5.3)') version
        write(n,*) 'spflame namelist input:'
        write(n,nml = spflame_basic) 
        write(n,nml = spflame_hor_mixing_setup) 
        write(n,nml = spflame_vert_mixing_setup) 
        write(n,nml = spflame_blue_setup) 
        write(n,nml = spflame_bbl_setup) 
        write(n,nml = spflame_mixing_parameters) 
        write(n,nml = spflame_advection_scheme) 
        write(n,nml = spflame_solver) 
        write(n,nml = spflame_nesting_setup) 
        write(n,nml = spflame_general_setup) 
        write(n,nml = spflame_obc_setup) 
        write(n,nml = spflame_sbc_setup) 
        write(n,nml = spflame_diagnostics) 
        close(n)
        print*,''
        print*,' namelist input written to file ',name(1:len_trim(name))
        print*,''
       endif
c
c      checks for zoom_fac
c      zoom_fac must be odd
c
       if ( mod(zoom_fac,2) /= 1 .or. zoom_fac < 3) 
     &     call halt_stop(' zoom_fac must be odd and greater than 3')
c       if ( mod(zoom_fac,2) /= 1 .or. zoom_fac < 1) 
c     &     call halt_stop(' zoom_fac must be odd and greater than 0')
       if ( mod(zoom_fac_k,2) /= 1 .or. zoom_fac_k < 1) 
     &     call halt_stop(' zoom_fac_k must be odd and greater than 0')
c
c      checks for is_zoom and ie_zoom
       if ( is_zoom < 1 .or. js_zoom < 1 ) 
     &   call halt_stop(' sub domain chosen by is_zoom,'//
     &      ' etc must be inside mother domain ')
c
       imt=(ie_zoom-is_zoom)*zoom_fac+1
       jmt=(je_zoom-js_zoom)*zoom_fac+1
       km_mother=km
       km = km*zoom_fac_k
      endif ! mother <0

      if (n_pes /= n_pes_i*n_pes_j) then
       if (my_pe == 0) then
        print*,' Number of PEs (=',n_pes,') do not '
        print*,' match the chosen domain decomposition '
        print*,' n_pes_i=',n_pes_i,' n_pes_j=',n_pes_j
       endif
       call halt_stop('error ')
      endif
c
c     domain decomposition for each PE
c
      i_blk = (imt-1)/n_pes_i + 1    ! i-extent of each block
      j_blk = (jmt-1)/n_pes_j + 1    ! j-extent of each block
      my_blk_i = mod(my_pe,n_pes_i)+1! number of PE in i-dir.
      my_blk_j = (my_pe)/n_pes_i + 1 ! number of PE in j-dir.
      is_pe = (my_blk_i-1)*i_blk + 1 ! start index in i-dir of this PE
      ie_pe = min(my_blk_i*i_blk,imt)
      js_pe = (my_blk_j-1)*j_blk + 1
      je_pe = min(my_blk_j*j_blk,jmt)
      call barrier
c
c     check for incorrect domain decomposition
c     it happens that weird values are computed be the above algorythm
c
      if (my_blk_j==n_pes_j .and. js_pe>=je_pe-2) then
       print*,' ERROR:'
       print*,' domain decompositon impossible in j-direction'
       print*,' choose other number of PEs in j-direction'
       call halt_stop(' in init_spflame_module')
      endif

      if (my_blk_i==n_pes_i .and. is_pe>=ie_pe-2) then
       print*,' ERROR:'
       print*,' domain decompositon impossible in i-direction'
       print*,' choose other number of PEs in i-direction'
       call halt_stop(' in init_spflame_module')
      endif
c
c     print out the PE decomposition, let all PEs talk
c
      if (my_pe==0) then
       print*,''
       print*,' SPFLAME sub domain setup: '
       print*,''
       print*,' imt=',imt,' jmt=',jmt,' km=',km
       print*,' n_pes_i=',n_pes_i,' n_pes_j=',n_pes_j
       print*,' i_blk=',i_blk,' j_blk=',j_blk
      endif
      call barrier
      do n=0,n_pes-1
       if (my_pe==n) then
        print*,''
        print*,' sub domain PE #',n
        print*,' my_blk_i=',my_blk_i,' my_blk_j=',my_blk_j
        print*,' is_pe=',is_pe,' ie_pe=',ie_pe
        print*,' js_pe=',js_pe,' je_pe=',je_pe
        print*,''
       endif
       call barrier
      enddo

      call allocate_spflame_module

      end subroutine init_spflame_module


      subroutine  allocate_spflame_module
c
c-----------------------------------------------------------------------
c     Allocation of all arrays in the main module
c     dimensions are restricted to the PE domain
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer  :: is,ie,js,je,k
      real, parameter    :: rini = 0.0
      integer, parameter :: iini = 0

      is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      allocate( u(is-2:ie+2,km,js-2:je+2,2,0:2) ); u=rini
      allocate( t(is-2:ie+2,km,js-2:je+2,nt,0:2) ); t=rini
      allocate( rho(is-1:ie+1,km,js-1:je+1)); rho=rini
      allocate( adv_vnt(is-1:ie+1,  km,js-1:je+1) );adv_vnt=rini
      allocate( adv_vet(is-1:ie+1,  km,js-1:je+1) );adv_vet=rini
      allocate( adv_vbt(is-1:ie+1,0:km,js-1:je+1) );adv_vbt=rini
      allocate( adv_vnu(is-1:ie+1,  km,js-1:je+1) );adv_vnu=rini
      allocate( adv_veu(is-1:ie+1,  km,js-1:je+1) );adv_veu=rini
      allocate( adv_vbu(is-1:ie+1,0:km,js-1:je+1) );adv_vbu=rini
      allocate( visc_cbu(is:ie,km,js:je) ); visc_cbu=rini
      allocate( diff_cbt(is:ie,km,js:je) ); diff_cbt=rini
      allocate( smf(is:ie,js:je,2) ); smf=rini
      allocate( bmf(is:ie,js:je,2) ); bmf=rini
      allocate( stf(is:ie,js:je,nt), btf(is:ie,js:je,nt) )
      stf=rini; btf=rini
      allocate( stf_rest(is:ie,js:je,nt), stf_clim(is:ie,js:je,nt) )
      stf_rest=rini; stf_clim=rini
      if (enable_icemask) then
       allocate( icemask(is:ie,js:je) ); icemask=rini
      endif
      if (enable_ktmix) then
       allocate( dml(is:ie,js:je) );   dml=rini
      endif
      if (enable_tkemix .or. enable_ktmix) then
       allocate( ustar(is:ie,js:je) ); ustar=rini
      endif
      if (enable_shortwave_sbc) then
       allocate( qsol(is:ie,js:je) ); qsol=rini
       allocate( divpen_shortwave(km) ); divpen_shortwave=rini
      endif
      if (enable_tkemix) then
       allocate( eke(is:ie,km,js:je,0:2) ); eke= rini
      endif
      allocate( zu(is-1:ie+1,js-1:je+1,2) ); zu=rini
      allocate( psi(is-1:ie+1,js-1:je+1,2) ); psi=rini
      allocate( ptd(is-1:ie+1,js-1:je+1) ); ptd=0.
      allocate( guess(is-1:ie+1,js-1:je+1) ); guess=0.
      allocate( kmt(is:ie,js:je) ); kmt=iini
      allocate( kmt_big(imt,jmt) ); kmt_big=iini
      allocate( kmu(is:ie,js:je) ); kmu=iini
      allocate( map(is:ie,js:je) ); map=iini
      allocate( hr(is-1:ie+1,js-1:je+1) ); hr=rini
      if (mother<0) then
       allocate( umask(is-2:ie+2,km,js-2:je+2) )  
       allocate( tmask(is-2:ie+2,km,js-2:je+2) )
      else
c      these boundaries are needed for smoothing the forcing from mother domain
       k=max(2,zoom_fac/2)
       allocate( umask(is-k:ie+k,km,js-k:je+k) )  
       allocate( tmask(is-k:ie+k,km,js-k:je+k) )
      endif
      umask=rini; tmask=rini
      allocate( source(is:ie,km,js:je) )
!     scaling of ah,ahbi am and ambi, eg. near open boundaries
      allocate( am_scale(is-2:ie+2,js-2:je+2) )
      am_scale=1.
      allocate( ambi_scale(is-2:ie+2,js-2:je+2) )
      ambi_scale=1.
      allocate( ah_scale(is-2:ie+2,js-2:je+2) )
      ah_scale=1.
      allocate( ahbi_scale(is-2:ie+2,js-2:je+2) )
      ahbi_scale=1.
!     grid variables are dimensioned over the whole model domain
      allocate( xt(imt), yt(jmt), xu(imt), yu(jmt))
      allocate( dxtdeg(imt), dytdeg(jmt), dxudeg(imt), dyudeg(jmt))
      allocate( dxt(imt), dyt(jmt), dxu(imt), dyu(jmt))
      allocate( dytr(jmt),dyt2r(jmt),dyt4r(jmt) )
      allocate( dyur(jmt),dyu2r(jmt), dyu4r(jmt) )
      allocate( phi(jmt),phit(jmt), cst(jmt),csu(jmt),sine(jmt))
      allocate( cstr(jmt),csur(jmt),tng(jmt))
      allocate( cstdytr(jmt), cstdyt2r(jmt),csudyur(jmt),csudyu2r(jmt))
      allocate( cst_dytr(jmt),csu_dyur(jmt))
      allocate( dus(jmt),dun(jmt))
      allocate( dxtr(imt),dxt2r(imt),dxur(imt), dxu2r(imt))
      allocate( dxt4r(imt),dxu4r(imt))
      allocate( dxmetr(imt),duw(imt),due(imt))
      allocate( zt(km),zw(km),dzt(km),dzw(0:km) )
      allocate( c2dzt(km), dztr(km), dzt2r(km) )
      allocate( rho0dztr(km), dzwr(0:km), dzw2r(0:km) )
      allocate( rho0csudyur(jmt) )
      allocate( dztur(km), dztlr(km) )

      allocate(rho0csudxur(is-1:ie+1,js-1:je+1) )
      allocate(csudxu2r   (is-1:ie+1,js-1:je+1) )
      allocate(am_csudxtr (is-1:ie+1,js-1:je+1)   )
      allocate(cstdxtr    (is-1:ie+1,js-1:je+1) )
      allocate(cstdxt2r   (is-1:ie+1,js-1:je+1) )
      allocate(ah_cstdxur (is-1:ie+1,js-1:je+1)  )
      allocate( cori(is:ie,js:je,2) )
      allocate( am3_biha(jmt),am4_biha(jmt,2),advmet(jmt,2) )
      allocate( am3_ha(jmt)  ,am4_ha(jmt,2) )
      allocate( amc_north_ha(jmt), amc_south_ha(jmt) )
      allocate( ahc_north_ha(jmt), ahc_south_ha(jmt) )
!     needed for diagnostics
      allocate( tcella(km), ucella(km) )
      if (enable_expl_convection) then
       allocate( lcven(is:ie,js:je), lctot(is:ie,js:je) )
      endif
!     open boundary conditions
      allocate( c1ps(is:ie),c1pn(is:ie),c1pe(js:je),c1pw(js:je) )
      allocate( psi_wall_north(imt) ); psi_wall_north=0.
      allocate( psi_wall_east(jmt) );  psi_wall_east=0.
      allocate( psi_wall_west(jmt) );  psi_wall_west=0.
      allocate( psi_wall_south(imt) ); psi_wall_south=0.
      if (restore_TS_obc_south) then
       allocate( ts_obc_south(is:ie,km,nt) ); ts_obc_south =0.
      endif
      if (restore_TS_obc_north) then
       allocate( ts_obc_north(is:ie,km,nt) ); ts_obc_north =0.
      endif
      if (restore_TS_obc_east) then
       allocate( ts_obc_east(js:je,km,nt) ); ts_obc_east =0.
      endif
      if (restore_TS_obc_west) then
       allocate( ts_obc_west(js:je,km,nt) ); ts_obc_west =0.
      endif
#ifdef partial_cell
      allocate( htp(imt,jmt), hup(imt,jmt) )
      htp=rini;hup=rini
      allocate( dht(is_pe-2:ie_pe+2,km,js_pe-2:je_pe+2) )
      allocate( dhu(is_pe-2:ie_pe+2,km,js_pe-2:je_pe+2) )
      allocate( dhwt(is_pe-2:ie_pe+2,0:km,js_pe-2:je_pe+2) )
      allocate( ztp(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) )
      allocate( pc_sink_biha(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) )
      allocate( pc_sink_ha(is_pe:ie_pe,km,js_pe:je_pe) )
      allocate( fracdz(km,0:1) )
      dht=rini;dhu=rini;dhwt=rini;ztp=rini;pc_sink_biha=rini
      pc_sink_ha=rini;fracdz=rini
#endif
      end subroutine allocate_spflame_module

#include "options.inc"

c
c-----------------------------------------------------------------------
c     Module which handles IO for forcing functions
c-----------------------------------------------------------------------
c

      module obc_io_module
      implicit none
c
c-----------------------------------------------------------------------
c     read in and time interpolate open boundary conditions
c     from a netcdf or binary file, which have to be prepared
c     beforehand. 
c
c     linked in the code in subr. setup and tracer only
c
c                                       c.eden
c-----------------------------------------------------------------------
c
      type :: obc_type
        integer index         ! the index for the time interpolator
        logical active     
        logical ts_active     
        logical psi_active     
        real, pointer :: ts_cache(:,:,:,:) ! cache for 2 time steps 
                                           ! of T/S and time scale
        integer cache_pointer(2)   ! pointer for the cache
        real, pointer :: psi_cache(:,:) ! cache for 2 time steps 
        integer length             ! number of time steps of the data
        character (len=80) :: file
        character (len=1) :: orient
        integer :: fdim
        integer :: ntr ! number of actual tracers in input files
      end type obc_type

      type (obc_type) :: obc(4)
      logical  :: netcdf_obc_verbose = .true.

      end module obc_io_module


      subroutine obc_initialize
c-----------------------------------------------------------------------
c     initialize the open boundary time interpolation
c-----------------------------------------------------------------------
      use spflame_module
      use obc_io_module
      implicit none
      integer :: n,io,k
      type( time_type) :: start
      type( time_type), allocatable :: interval(:)
      real, allocatable :: aprec(:)
      character (len=32) :: stamp

      if (my_pe==0) print*,' '
      if (my_pe==0) 
     &   print*,' Initialising of open boundary forcing data '
      if (my_pe==0) print*,' '

      if (my_pe==0 ) then 
       netcdf_obc_verbose=.true.
      else
       netcdf_obc_verbose=.false.
      endif

      obc(1)%orient='n'
      obc(2)%orient='s'
      obc(3)%orient='e'
      obc(4)%orient='w'
      obc(1)%file='obc_north.mom'
      obc(2)%file='obc_south.mom'
      obc(3)%file='obc_east.mom'
      obc(4)%file='obc_west.mom'

      obc(:)%active=.false.
      obc(:)%ts_active=.false.
      obc(:)%psi_active=.false.

      n=1
      if (enable_obc_north.and.my_blk_j==n_pes_j) then
        obc(n)%active=.true.
        if (restore_TS_obc_north) obc(n)%ts_active=.true.
        if (prescribe_psi_obc_north) obc(n)%psi_active=.true.
        obc(n)%fdim=imt
      endif

      n=2
      if (enable_obc_south.and.my_blk_j==1) then
        obc(n)%active=.true.
        if (restore_TS_obc_south) obc(n)%ts_active=.true.
        if (prescribe_psi_obc_south) obc(n)%psi_active=.true.
        obc(n)%fdim=imt
      endif

      n=3
      if (enable_obc_east.and.my_blk_i==n_pes_i) then
        obc(n)%active=.true.
        if (restore_TS_obc_east) obc(n)%ts_active=.true.
        if (prescribe_psi_obc_east) obc(n)%psi_active=.true.
        obc(n)%fdim=jmt
      endif

      n=4
      if (enable_obc_west.and.my_blk_i==1) then
        obc(n)%active=.true.
        if (restore_TS_obc_west) obc(n)%ts_active=.true.
        if (prescribe_psi_obc_west) obc(n)%psi_active=.true.
        obc(n)%fdim=jmt
      endif

      do n=1,4
       if (obc(n)%active) then
        if (obc(n)%ts_active .or. obc(n)%psi_active ) then
         if (my_pe==0) print*,' activating OBC ',obc(n)%orient
         allocate( obc(n)%ts_cache(obc(n)%fdim,km,nt,2) )
         obc(n)%ts_cache(obc(n)%fdim,km,nt,2) = 0.
         allocate( obc(n)%psi_cache(obc(n)%fdim,2) )
         obc(n)%psi_cache(obc(n)%fdim,2) = 0.
         obc(n)%cache_pointer=-1 ! this is important
         if (my_pe==0) print*,' reading file :',obc(n)%file
         call getunit(io,obc(n)%file,'usr ieee')
         read (io) obc(n)%length
         if (my_pe==0) print*,' time steps :',obc(n)%length
         allocate(interval(obc(n)%length))
         allocate(aprec(obc(n)%length))
         rewind(io)
         read (io)  k,stamp,aprec
         if (my_pe==0) print*,' starting at ',stamp
         start= get_stamp(stamp)
         do k=1,obc(n)%length
           call set_time(interval(k),
     &               int((aprec(k)-int(aprec(k)))*24*60*60),
     &               int(aprec(k)))
         enddo
         call init_forcing_interp(obc(n)%length,.true.,
     &                            start,interval,obc(n)%index)
         obc(n)%ntr=nt
 20      rewind(io)
         read(io)
         read (io,err=30) obc(n)%ts_cache(:,:,1:obc(n)%ntr,1), 
     &                    obc(n)%psi_cache(:,1) 
         goto 40
 30      continue
         if (obc(n)%ntr > 2 ) then
          obc(n)%ntr=obc(n)%ntr-1
          goto 20
         else
          if (my_pe==0) print*,' cannot read input file'
          call halt_stop(' in OBC initialization' )
         endif
 40      close(io)
         if (my_pe==0) print*,' found ',obc(n)%ntr,' tracers in files'
         deallocate(interval,aprec)
        endif
       endif
      enddo


      if (my_pe==0) print*,' '
      if (my_pe==0) 
     &   print*,' Initialisation of open boundary forcing data done'
      if (my_pe==0) print*,' '

      end subroutine obc_initialize



      subroutine obc_read
      use spflame_module
      use obc_io_module
      implicit none
      integer :: k,p1,p2,kk,i,j
      real    :: f1,f2
      logical load(2)
      character(len=80) :: text
      integer :: io,n
      real :: dummy
      integer is,ie,js,je
#ifdef SR8000_host
      real, allocatable :: buf(:,:,:), buf2(:)
#endif

      is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      do k=1,4
       if (obc(k)%psi_active.or.obc(k)%ts_active) then

        call forcing_interp(obc(k)%index,p1,p2,f1,f2)
        write(text,'(" obc data orientation : ",a1)') obc(k)%orient
        call update_forcing_cache(obc(k)%index,p1,p2,
     &                obc(k)%cache_pointer(:),load,text)
        do kk=1,2
         if (load(kk)) then

#ifdef SR8000_host
c there is apparently a bug in fortran types and precexpio option
c for the compiler on the SR8000: use the following work around

           if (obc(k)%ts_active.or.obc(k)%psi_active) then
            call getunit(io,obc(k)%file,'usr ieee')
            allocate( buf(obc(k)%fdim,km,obc(k)%ntr) )
            allocate( buf2(obc(k)%fdim) )
            read (io)  ! length
            do n=1,obc(k)%cache_pointer(kk)-1
             read(io)
            enddo
            read(io)
     &         (((buf(i,j,n),i=1,obc(k)%fdim),j=1,km),n=1,obc(k)%ntr),
     &               (buf2(i),i=1,obc(k)%fdim)
            if (obc(k)%ts_active) then
              obc(k)%ts_cache(:,:,1:obc(k)%ntr,kk) =buf
            endif
            if (obc(k)%psi_active) then
              obc(k)%psi_cache(1:obc(k)%fdim,kk) =buf2(1:obc(k)%fdim)
            endif
            close(io)
            deallocate(buf, buf2)
           endif

#else
           call getunit(io,obc(k)%file,'usr ieee')
           if (obc(k)%ts_active.or.obc(k)%psi_active) then
            read (io)  ! length
            do n=1,obc(k)%cache_pointer(kk)-1
             read(io)
            enddo
            if (obc(k)%ts_active.and.obc(k)%psi_active) then
             read (io)obc(k)%ts_cache(:,:,1:obc(k)%ntr,kk), 
     &                obc(k)%psi_cache(:,kk) 
            elseif (obc(k)%ts_active) then
             read (io)obc(k)%ts_cache(:,:,1:obc(k)%ntr,kk) 
            elseif (obc(k)%psi_active) then
             read (io)(dummy,i=1,obc(k)%fdim*km*obc(k)%ntr),
     &                 obc(k)%psi_cache(:,kk) 
            endif
           endif
           close(io)
#endif

         endif ! load(kk)
        enddo

        if (obc(k)%ts_active.and.obc(k)%orient=='n')
     &   ts_obc_north(is:ie,:,:)=obc(k)%ts_cache(is:ie,:,:,p1)*f1+
     &                           obc(k)%ts_cache(is:ie,:,:,p2)*f2
        if (obc(k)%ts_active.and.obc(k)%orient=='s')
     &   ts_obc_south(is:ie,:,:)=obc(k)%ts_cache(is:ie,:,:,p1)*f1+
     &                           obc(k)%ts_cache(is:ie,:,:,p2)*f2
        if (obc(k)%ts_active.and.obc(k)%orient=='w')
     &   ts_obc_west(js:je,:,:)=obc(k)%ts_cache(js:je,:,:,p1)*f1+
     &                          obc(k)%ts_cache(js:je,:,:,p2)*f2
        if (obc(k)%ts_active.and.obc(k)%orient=='e')
     &   ts_obc_east(js:je,:,:)=obc(k)%ts_cache(js:je,:,:,p1)*f1+
     &                          obc(k)%ts_cache(js:je,:,:,p2)*f2

        if (obc(k)%psi_active.and.obc(k)%orient=='n') 
     &   psi_wall_north(is:ie) = obc(k)%psi_cache(is:ie,p1)*f1+
     &                           obc(k)%psi_cache(is:ie,p2)*f2
        if (obc(k)%psi_active.and.obc(k)%orient=='s') 
     &   psi_wall_south(is:ie) = obc(k)%psi_cache(is:ie,p1)*f1+
     &                           obc(k)%psi_cache(is:ie,p2)*f2
        if (obc(k)%psi_active.and.obc(k)%orient=='w')
     &   psi_wall_west(js:je) = obc(k)%psi_cache(js:je,p1)*f1+
     &                          obc(k)%psi_cache(js:je,p2)*f2
        if (obc(k)%psi_active.and.obc(k)%orient=='e') 
     &   psi_wall_east(js:je) = obc(k)%psi_cache(js:je,p1)*f1+
     &                          obc(k)%psi_cache(js:je,p2)*f2

       endif
      enddo
      end subroutine obc_read



      module sponge_module
c
c-----------------------------------------------------------------------c
c     read in and time interpolate data for sponge layers
c     from a netcdf or binary file, which have to be prepared
c     beforehand. 
c
c     linked in the code in subr. setup and tracer only
c
c                                       c.eden
c-----------------------------------------------------------------------
c
      implicit none

      type :: spg_type
        integer is,ie,js,je   ! start and end indicees for the sponge layer
        integer isb,ieb,jsb,jeb ! same but restricted to the PE domain
        integer index         ! the index for the time interpolator
        logical active        ! true if sponge layer is in PE domain
        real, pointer :: cache(:,:,:,:,:) ! cache for 2 time steps 
                                          ! of T/S and time scale
        integer cache_pointer(2)   ! pointer for the cache
        integer length             ! number of time steps of the data
        integer ntr                ! number of tracer in input file
      end type spg_type
      integer :: number_of_spg ! total number of sponge layers
                                       ! use not more than 99
      type(spg_type), allocatable :: spg(:) ! the sponge layers
      logical :: netcdf_spg_verbose = .true. ! be verbose
      end module sponge_module


      subroutine sponge_initialize
c
c-----------------------------------------------------------------------
c     initialize the sponge layer time interpolation
c-----------------------------------------------------------------------
c
      use spflame_module
      use sponge_module
      implicit none
      integer k,n,io,i
      character (len=80) :: name
      character (len=32) :: stamp
      type( time_type) :: start
      type( time_type), allocatable :: interval(:)
      real, allocatable :: aprec(:)
      real, allocatable :: trbuf(:,:,:)

      if (my_pe==0) print*,' '
      if (my_pe==0) 
     &   print*,' Initialising of sponge layer data '
      if (my_pe==0) print*,' '

      netcdf_spg_verbose=.false.
      if (my_pe==0 ) netcdf_spg_verbose=.true.

      if (my_pe==0) then
       print*,' reading sponge informations from file sponge_01.mom'
      endif
      call getunit(io,'sponge_01.mom','usr ieee')
      read (io) number_of_spg
      close(io)

      if (my_pe==0) then
        print*,' found ',number_of_spg,' sponge layers'
      endif

      allocate(spg(number_of_spg));

      do n=1,number_of_spg
       if (my_pe==0) print*,' initializing layer #',n
c      read time dimension and horizontal location for sponge
c      layer number n
       write(name, '("sponge_",i2,".mom")') n
       do i=1,len_trim(name)
         if (name(i:i) == ' ') name(i:i)='0'
       enddo
       if (my_pe==0) print*,' reading from file ',name(1:len_trim(name))
       call getunit(io,name,'usr ieee')
       read (io) i,spg(n)%length,
     &             spg(n)%is,spg(n)%ie,spg(n)%js,spg(n)%je
       if (my_pe==0) print*,' time steps :',spg(n)%length
       if (my_pe==0) print*,' range of sponge :',
     &             spg(n)%is,spg(n)%ie,spg(n)%js,spg(n)%je
c      see how many tracers are actually in file
       if (my_pe==0) then
 
        allocate(trbuf(spg(n)%is:spg(n)%ie,spg(n)%js:spg(n)%je,nt*2))
        spg(n)%ntr = nt
20      rewind(io)
         read(io)
         do i=1,km
           read(io, err=30) trbuf(:,:,1:spg(n)%ntr*2)
         enddo
         goto 40
 30      continue
         if (spg(n)%ntr > 2 ) then
          spg(n)%ntr=spg(n)%ntr-1
          goto 20
         else
          if (my_pe==0) print*,' cannot read input file'
          call halt_stop(' in sponge initialization' )
         endif
 40     continue
        deallocate( trbuf )
       endif ! my_pe == 0

       call bcast_integer(spg(n)%ntr,1,0)
       rewind(io)

       if (my_pe==0) print*,' found ',spg(n)%ntr,' tracers in file' 
       call sub_flush(6)
c
c      restrict array to PE domain
       spg(n)%jsb=max(js_pe,spg(n)%js)
       spg(n)%jeb=min(je_pe,spg(n)%je)
       spg(n)%isb=max(is_pe,spg(n)%is)
       spg(n)%ieb=min(ie_pe,spg(n)%ie)

       if (spg(n)%jeb >= spg(n)%jsb .and.
     &     spg(n)%ieb >= spg(n)%isb ) then

        spg(n)%active=.true.
        allocate( spg(n)%cache(spg(n)%isb:spg(n)%ieb,km,
     &                   spg(n)%jsb:spg(n)%jeb,spg(n)%ntr*2,2) )
        spg(n)%cache=0.
        spg(n)%cache_pointer=-1

        allocate(interval(spg(n)%length))
        allocate(aprec(spg(n)%length))
c       read the time variables for sponge layer # n
        read (io)  k,k,i,i,i,i,stamp,aprec
        start= get_stamp (stamp)
        do k=1,spg(n)%length
         call set_time(interval(k),
     &                 int((aprec(k)-int(aprec(k)))*24*60*60),
     &                 int(aprec(k)))
        enddo
        call init_forcing_interp(spg(n)%length,.true.,
     &                           start,interval,spg(n)%index)
        deallocate(interval,aprec)
       else
        spg(n)%active=.false.
       endif
       close(io)
       call sub_flush(6)
      enddo

      if (my_pe==0) print*,' '
      if (my_pe==0) 
     &   print*,' Initialisation of sponge layer data done'
      if (my_pe==0) print*,' '
       call sub_flush(6)

      end subroutine sponge_initialize




      subroutine sponge_read(n)
c
c-----------------------------------------------------------------------
c     read data from netcdf file and compute source term
c     for tracer number n
c-----------------------------------------------------------------------
c
      use spflame_module
      use sponge_module
      implicit none
      integer, intent(in) :: n ! number of the tracer
      integer :: k,p1,p2,kk,i,j,m
      real    :: f1,f2,tstar,tscl
      logical load(2)
      character(len=80) :: text
      integer :: io
      character (len=80) :: name
      real, allocatable :: trbuf(:,:,:),tsbuf(:,:,:)
      character(len=2) :: number
      
      do k=1,number_of_spg
       write(number,'(i2)') k
       if (number(1:1) == ' ') number(1:1)='0'
       if (spg(k)%active) then

        call forcing_interp(spg(k)%index,p1,p2,f1,f2)
        write(text,'(" sponge layer #",i3)') k
        call update_forcing_cache(spg(k)%index,p1,p2,
     &                spg(k)%cache_pointer(:),load,text)
        do kk=1,2
         if (load(kk)) then
           write(name, '("sponge_",i2,".mom")') k
           do i=1,len_trim(name)
            if (name(i:i) == ' ') name(i:i)='0'
           enddo
           call getunit(io,name,'usr ieee')
           read (io)
           do i=1,(spg(k)%cache_pointer(kk)-1)*km
            read(io)
           enddo
           allocate(trbuf(spg(k)%is:spg(k)%ie,spg(k)%js:spg(k)%je,
     &              spg(k)%ntr))
           allocate(tsbuf(spg(k)%is:spg(k)%ie,spg(k)%js:spg(k)%je,
     &              spg(k)%ntr))
           do i=1,km
            read(io) trbuf,tsbuf
            do m=1,spg(k)%ntr
             spg(k)%cache(:,i,:,m,kk)=trbuf(spg(k)%isb:spg(k)%ieb,
     &                                 spg(k)%jsb:spg(k)%jeb,m)
             spg(k)%cache(:,i,:,spg(k)%ntr+m,kk)=
     &        tsbuf(spg(k)%isb:spg(k)%ieb,spg(k)%jsb:spg(k)%jeb,m)
            enddo
           enddo
           close(io)
           deallocate(trbuf,tsbuf) 
         endif
        enddo

        if (n<= spg(k)%ntr ) then

         do j=spg(k)%jsb,spg(k)%jeb
          do kk=1,km
           do i=spg(k)%isb,spg(k)%ieb
            tstar= spg(k)%cache(i,kk,j,n,p1)*f1+
     &             spg(k)%cache(i,kk,j,n,p2)*f2
            tscl = spg(k)%cache(i,kk,j,spg(k)%ntr+n,p1)*f1+
     &             spg(k)%cache(i,kk,j,spg(k)%ntr+n,p2)*f2
c           restore to tracer at tau-1
            source(i,kk,j)=source(i,kk,j)+
     &        tscl*(tstar-t(i,kk,j,n,taum1))*tmask(i,kk,j)
           enddo
          enddo
         enddo
        endif

       endif
      enddo
      end subroutine sponge_read


      module sbc_io_module
c
c-----------------------------------------------------------------------c
c     read in and time interpolate surface boundary conditions
c     from a netcdf or binary file, which have to be prepared
c     beforehand. 
c
c     linked in the code in subr. setup and vmixc only
c
c                                       c.eden
c-----------------------------------------------------------------------
c
      implicit none
      integer                     :: number_of_sbc
      integer                     :: number_of_ustar
      integer                     :: number_of_qsol
      integer,allocatable         :: sbc_index(:)
      real,allocatable            :: sbc_cache(:,:,:,:)
      integer,allocatable         :: sbc_cache_pointer(:,:) 
      integer,allocatable         :: sbc_length(:) 
      character(len=32),allocatable         :: sbc_name(:) 
      character(len=80),allocatable         :: filename(:) 
      end module sbc_io_module


      subroutine sbc_initialize
c-----------------------------------------------------------------------
c     initialize the SBC time interpolation
c-----------------------------------------------------------------------
      use spflame_module
      use sbc_io_module
      implicit none
      integer k,n,io,m
      type( time_type) :: start
      type( time_type), allocatable :: interval(:)
      real, allocatable :: aprec(:)
      character (len=32) :: stamp
      character (len=80) :: name
      real :: pen(0:km),swarg1,swarg2
      
      if (my_pe==0) then
       print*,' '
       print*,' Initialising of surface boundary forcing data '
       print*,' '
       if  (enable_salt_flux_sbc) then
        print*,' using a fixed salt flux b.c. '
       endif
       if (enable_shortwave_sbc) then
        print*,' using penetrative solar radiation '
       endif
      endif
c
c     Number of files to be read
c
      number_of_sbc = 2+nt*2  ! normal setup: taux,tauy,sst/sss_clim/rest

      if (enable_ktmix.or.enable_tkemix) then
        number_of_sbc   = number_of_sbc+1
        number_of_ustar = number_of_sbc
      endif

      if (enable_shortwave_sbc) then
        number_of_sbc   = number_of_sbc+1
        number_of_qsol  = number_of_sbc
c
c     Initialize penetration profile for solar radiation
c     and store divergence in divpen
c     note that pen(0) is set 0.0 instead of 1.0 to compensate for the
c     shortwave part of the total surface flux in "stf(i,1)"
c
        pen(0) = 0.0
        do k=1,km
         swarg1 = -min(zw(k)/efold1_shortwave,70.0)
         swarg2 = -min(zw(k)/efold2_shortwave,70.0)
         pen(k) = rpart_shortwave*exp(swarg1) 
     &         + (1.0-rpart_shortwave)*exp(swarg2)
  	 divpen_shortwave(k) = (pen(k-1) - pen(k))/dzt(k)
        enddo
        if (my_pe==0) then
          print*,' A part of ',rpart_shortwave,' of the solar radiation'
          print*,' penetrates exponentially with a length scale of'
          print*,efold1_shortwave,' cm the rest with a length scale of'
          print*,efold2_shortwave,' cm'
          print*,' Resulting exponential penetration profile: '
          do k=0,km
            print*,' k=',k,' zw(k)=', zw(k),' pen(k)=', pen(k)
          enddo
        endif
      endif

      allocate(sbc_index(number_of_sbc));sbc_index=9999999
      allocate(sbc_cache(number_of_sbc,is_pe:ie_pe,js_pe:je_pe,2))
      sbc_cache=0.
      allocate(sbc_cache_pointer(number_of_sbc,2))
      sbc_cache_pointer = -1
      allocate(sbc_length(number_of_sbc)); sbc_length=0
      allocate(sbc_name(number_of_sbc)); sbc_name='noname'
      allocate(filename(number_of_sbc)); filename='noname.cdf'

      sbc_name(1)='taux'
      sbc_name(2)='tauy'
      sbc_name(3)='sst_clim'
      sbc_name(4)='sst_rest'
      sbc_name(5)='sss_clim'
      if  (enable_salt_flux_sbc) then
       sbc_name(6)='sss_flux'
      else
       sbc_name(6)='sss_rest'
      endif
      if (enable_ktmix.or.enable_tkemix) then
          sbc_name(number_of_ustar)='ustar'
      endif
      if (enable_shortwave_sbc) then
          sbc_name(number_of_qsol)='qsol'
      endif

      if (my_pe==0) print*,' using binary files '
      filename(1)='taux.mom'
      filename(2)='tauy.mom'
      filename(3)='sst_clim.mom'
      filename(4)='sst_rest.mom'
      filename(5)='sss_clim.mom'
      if  (enable_salt_flux_sbc) then
       filename(6)='sss_flux.mom'
      else
       filename(6)='sss_rest.mom'
      endif
      if (enable_ktmix.or.enable_tkemix) then
         filename(number_of_ustar)='ustar.mom'
      endif
      if (enable_shortwave_sbc) then
         filename(number_of_qsol)='qsol.mom'
      endif

      do m=3,nt

       write(name,'("str_",i2,"_clim")') m
       call replace_space_zero(name)
       sbc_name(6+(m-3)*2+1)=name(1:32)
       write(name,'("str_",i2,"_clim.mom")') m
       call replace_space_zero(name)
       filename(6+(m-3)*2+1)=name

       write(name,'("str_",i2,"_rest")') m
       call replace_space_zero(name)
       sbc_name(6+(m-3)*2+2)=name(1:32)
       write(name,'("str_",i2,"_rest.mom")') m
       call replace_space_zero(name)
       filename(6+(m-3)*2+2)=name

      enddo

      do n=1,number_of_sbc
       call getunit(io,filename(n),'usr ieee')
       read (io) sbc_length(n)
       rewind(io)
       allocate(interval(sbc_length(n)))
       allocate(aprec(sbc_length(n)))
       read (io)  k,stamp,aprec
       close(io)
       start= get_stamp (stamp)
       do k=1,sbc_length(n)
        call set_time(interval(k),
     &               int((aprec(k)-int(aprec(k)))*24*60*60),
     &               int(aprec(k)))
       enddo
       call init_forcing_interp(sbc_length(n),.true.,
     &                          start,interval,sbc_index(n))
       deallocate(interval,aprec)
      enddo

      if (my_pe==0) print*,' '
      if (my_pe==0) 
     &   print*,' Initialising of surface boundary forcing data done'
      if (my_pe==0) print*,' '
      end subroutine sbc_initialize


      subroutine sbc_read
c
c-----------------------------------------------------------------------
c     interpolate in time between adjacent months,
c     read in new data from netcdf files into cache if necessary.
c-----------------------------------------------------------------------
c
      use spflame_module
      use sbc_io_module
      implicit none
      real :: buf(imt,jmt),f1,f2
      integer :: p1,p2,i,j,k,kk,io,m
      logical load(2)

      do k=1,number_of_sbc
       call forcing_interp(sbc_index(k),p1,p2,f1,f2)
       call update_forcing_cache(sbc_index(k),p1,p2,
     &                sbc_cache_pointer(k,:),load,sbc_name(k))
       do kk=1,2
        if (load(kk)) then
         if (my_pe==0) then 
          call getunit(io,filename(k),'usr ieee')
          read (io) 
          do i=1,sbc_cache_pointer(k,kk)-1 
           read (io)  
          enddo
          read (io) buf
          close(io)
         endif
         call bcast_real(buf,imt*jmt,0)
         sbc_cache(k,:,:,kk)=buf(is_pe:ie_pe,js_pe:je_pe)
        endif
       enddo

       if (k==1.or.k==2) then

        smf(is_pe:ie_pe,js_pe:je_pe,k) = 
     &     sbc_cache(k,:,:,p1)*f1+sbc_cache(k,:,:,p2)*f2

       elseif ( k <= nt*2+2 ) then

        m=floor((k-3.)/2.) +1  ! number of tracer for this tracer

        if (ceiling( (k-3.)/2.+1 )==m) then
         stf_clim(is_pe:ie_pe,js_pe:je_pe,m) = 
     &     sbc_cache(k,:,:,p1)*f1+sbc_cache(k,:,:,p2)*f2

         if  (enable_salt_flux_sbc) then
c
c        here we are using a fixed salt flux
c        sft = rest*(clim-t(...taum1)
c          with clim = t(...,taum1)+1 and rest = flux
c        stf = flux*(t(...,taum1)+1-t(...taum1)= flux
c
          if (m==2)  stf_clim(is_pe:ie_pe,js_pe:je_pe,m)=
     &      t(is_pe:ie_pe,1,js_pe:je_pe,2,taum1)+1.
c
c        note that this could be also made nicer with
c        a logical :: restoring_sbc(1:nt)
c
         endif
        else
         stf_rest(is_pe:ie_pe,js_pe:je_pe,m) = 
     &     sbc_cache(k,:,:,p1)*f1+sbc_cache(k,:,:,p2)*f2
        endif


       elseif (k==number_of_ustar .and. 
     &          (enable_ktmix.or.enable_tkemix) ) then
        ustar(is_pe:ie_pe,js_pe:je_pe) = 
     &     sbc_cache(k,:,:,p1)*f1+sbc_cache(k,:,:,p2)*f2
       elseif (k==number_of_qsol .and. enable_shortwave_sbc)  then
        qsol(is_pe:ie_pe,js_pe:je_pe) = 
     &     sbc_cache(k,:,:,p1)*f1+sbc_cache(k,:,:,p2)*f2
       else
          print*,' error in sbc_read '
          call halt_stop(' in sbc_read')
       endif
      enddo

      end subroutine sbc_read

#include "options.inc"

c
c ------------------------------------------------------
c   template to read topography from external data file
c   which is currently "data/etopo5/etopo5.cdf"
c   containing a 5 minute global topgraphy by Smith et al
c   or data/etopo2/etopo2.top containing a 2 min. version
c
c   Notes: Called by prep_topo (in prep_topo.F)
c          defines two subroutines: 
c           "read_rose_dims" and "read_rose"
c          rose should be given in meters
c          Header of subroutines should not be touched.
c          CPP directives are set in prep_template.F
c
c                            c.eden  nov 2002
c ------------------------------------------------------
c

#ifdef use_ETOPO5_topography

      subroutine read_rose(rose,x,y,nx,ny)
      implicit none
#include "netcdf.inc"
      integer :: nx,ny
      real rose(nx,ny),x(nx),y(ny)
      character*80 infile,name
      character*80 dname
      integer  ncid,iret,rid,ndims,latid,lonid
      integer  corner(4), edges(4), dims(4)
#ifdef netcdf_real4
      real (kind=4) , allocatable :: var4(:,:) ,x4(:),y4(:)
#else
      real , allocatable :: var4(:,:) ,x4(:),y4(:)
#endif

      infile='data/etopo5/etopo5.cdf'
      name='rose'

      iret=nf_open(infile,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,name,rid)
      iret=NF_INQ_VARNDIMS(NCID, rid, ndims)  
      if (ndims/=2) then
       print*,' number of dimensions for variable not equal 2'
       print*,ndims
       stop
      endif
      iret=NF_INQ_VARDIMID (NCID,rid,DIMS)
      iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
      iret=NF_INQ_VARID (NCID, dNAME, lonid)
      iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
      iret=NF_INQ_VARID (NCID, dNAME, latid)
      corner=1; edges(1)=nx; edges(2)=ny
      allocate( var4( nx,ny), x4(nx), y4(ny) )
      iret= nf_get_vara_real (ncid,rid ,corner,edges,var4)
      rose=var4
      edges(1)=ny
      iret= nf_get_vara_real (ncid,latid ,corner,edges,y4); y=y4
      edges(1)=nx 
      iret= nf_get_vara_real (ncid,lonid,corner,edges,x4);x=x4
      deallocate(var4,y4,x4)
      call ncclos (ncid, iret)
      end subroutine read_rose




      subroutine read_rose_dims(nx,ny)
      implicit none
#include "netcdf.inc"
      integer nx,ny
      character*80 infile,name
      character*80 dname
      integer  ncid,iret,rid,ndims,latid,lonid
      integer dims(4)

      infile='data/etopo5/etopo5.cdf'
      name='rose'
      print*,' reading topography from file ',
     &      infile(1:len_trim(infile))

      iret=nf_open(infile,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,name,rid)
      iret=NF_INQ_VARNDIMS(NCID, rid, ndims)  
      if (ndims/=2) then
       print*,' number of dimensions for variable not equal 2'
       print*,ndims
       stop
      endif
      iret=NF_INQ_VARDIMID (NCID,rid,DIMS)
      iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
      iret=NF_INQ_VARID (NCID, dNAME, lonid)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), ndims); nx=ndims
      iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
      iret=NF_INQ_VARID (NCID, dNAME, latid)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ndims); ny=ndims
      call ncclos (ncid, iret)
      end subroutine read_rose_dims

#endif

#ifdef use_ETOPO2_topography

c
c   read data from unformatted fortran data file
c
      subroutine read_rose(rose,x,y,nx,ny)
      implicit none
      integer :: nx,ny
      real rose(nx,ny),x(nx),y(ny)
      character*80 infile
      real (kind=4), allocatable :: rose4(:,:) ,x4(:),y4(:)
      integer :: io,j
      infile='data/etopo2/etopo2.top'
      allocate( rose4(nx,ny) ,x4(nx),y4(ny) )
      call getunit(io, infile, 'u s r ieee')
      read (io)nx,ny
      read (io)x4; x=x4
      read (io)y4; y=y4
      do j=1,ny
        read(io) rose4(:,j)
      enddo
      close(io)
      rose=rose4*-1
      deallocate(rose4,x4,y4)
      end subroutine read_rose


      subroutine read_rose_dims(nx,ny)
      implicit none
      integer nx,ny
      character*80 infile
      integer :: io
      infile='data/etopo2/etopo2.top'
      print*,' reading topography from file ',
     &      infile(1:len_trim(infile))
      call getunit(io, infile, 'u s r ieee')
      read (io)nx,ny
      close(io)
      end subroutine read_rose_dims


#endif

#include "options.inc"


      subroutine tracer ()
c
c=======================================================================
c     compute tracers at "tau+1"
c     original author:   r.c.pacanowski       e-mail rcp@gfdl.gov
c     SPFLAME version:   c.eden
c=======================================================================
c
      use spflame_module
      use bbl_module
      implicit none
c-----------------------------------------------------------------------
c     local arrays
c-----------------------------------------------------------------------
      integer is,ie,js,je,is1,ie1,js1,je1,ip,jp
      integer i,j,k,n
      real :: tend(is_pe:ie_pe), fxa
      real T_i,T_j
#ifdef partial_cell
      real dhte,dhtn,dhwe,dhwn
      dhte(i,k,j)   = min(dht(i+1,k,j),dht(i,k,j))
      dhtn(i,k,j)   = min(dht(i,k,j+1),dht(i,k,j))
      dhwe(i,k,j)   = min(dhwt(i+1,k,j),dhwt(i,k,j))
      dhwn(i,k,j)   = min(dhwt(i,k,j+1),dhwt(i,k,j))
      T_i(i,k,j,n,ip) = t(i+ip,max(1,k-1),j,n,taum1) - dhwe(i,k-1,j)
     &            *(t(i+ip,max(1,k-1),j,n,taum1) - t(i+ip,k,j,n,taum1))
     &               /dhwt(i+ip,k-1,j)
      T_j(i,k,j,n,jp) = t(i,max(1,k-1),j+jp,n,taum1) - dhwn(i,k-1,j)
     &            *(t(i,max(1,k-1),j+jp,n,taum1) - t(i,k,j+jp,n,taum1))
     &               /dhwt(i,k-1,j+jp)
#else
      T_i(i,k,j,n,ip) = t(i+ip,k,j,n,taum1)
      T_j(i,k,j,n,jp) = t(i,k,j+jp,n,taum1)
#endif
c
c-----------------------------------------------------------------------
c     advective terms
c-----------------------------------------------------------------------
c
      real adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
      real adv_tx
      ADV_Tx(i,k,j) = (adv_fe(i,k,j) - adv_fe(i-1,k,j))*cstdxt2r(i,j)
#ifdef partial_cell
     &                             /dht(i,k,j)
#endif
      real adv_ty
      ADV_Ty(i,k,j) = (adv_fn(i,k,j) - adv_fn(i,k,j-1))*cstdyt2r(j)
# ifdef partial_cell
     &                             /dht(i,k,j)
# endif
      real adv_tz
      ADV_Tz(i,k,j) = (adv_fb(i,k-1,j) - adv_fb(i,k,j))
#ifdef partial_cell
     &               *.5/dht(i,k,j)
#else
     &               *dzt2r(k)
#endif
c
c-----------------------------------------------------------------------
c     diffusive terms
c-----------------------------------------------------------------------
c
      real :: diff_fe(is_pe-1:ie_pe,km,js_pe:je_pe) 
      real :: diff_fn(is_pe:ie_pe,km,js_pe-1:je_pe) 
      real :: diff_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
      real diff_tx
      DIFF_Tx(i,k,j) = (diff_fe(i,  k,j)*tmask(i+1,k,j)
     &            - diff_fe(i-1,k,j)*tmask(i-1,k,j))*cstdxtr(i,j)
#ifdef partial_cell
     &                             /dht(i,k,j)
#endif
      real diff_ty
      DIFF_Ty(i,k,j) = (diff_fn(i,k,j  )*tmask(i,k,j+1)
     &             - diff_fn(i,k,j-1)*tmask(i,k,j-1))*cstdytr(j)
#ifdef partial_cell
     &                             /dht(i,k,j)
#endif
      real DIFF_Tz
      DIFF_Tz(i,k,j) = (diff_fb(i,k-1,j) - diff_fb(i,k,j))
     &                 *(1.-aidif_tracer)
#ifdef partial_cell
     &               /dht(i,k,j)
#else
     &               *dztr(k)
#endif
c
c     part of vertical diffusive flux due to isopyncal mixing
c     which is solved explicitly, other part is contained
c     in the vertical diffusivity diff_cbt and solved implicitly
c
      real, allocatable :: diff_fbiso(:,:,:)
      real DIFF_Tz_iso
      DIFF_Tz_iso(i,k,j) = (diff_fbiso(i,k-1,j) - diff_fbiso(i,k,j))
#ifdef partial_cell
     &               /dht(i,k,j)
#else
     &               *dztr(k)
#endif
c

#ifdef detailed_timing
      call tic('tracer main')
#endif
      if (enable_diffusion_isoneutral.or. 
     &    enable_diffusion_isopycnic) then
       allocate( diff_fbiso(is_pe:ie_pe,0:km,js_pe:je_pe) )
       diff_fbiso=0.
      endif

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

#ifdef detailed_timing
      call tic('tracer obc')
#endif

c
c     care about TS values for open boundaries, read also psi
c
      if (.not.enable_simple_obc) call obc_read()
c
      js1=js
      if (my_blk_j == 1 .and. enable_obc_south) then
       call cobc(2); js1=3
      endif

      je1=je       
      if (my_blk_j == n_pes_j .and. enable_obc_north) then
       je1=jmt-2
      endif

#ifdef detailed_timing
      call toc('tracer obc')
#endif

      do n=1,nt
c
c-----------------------------------------------------------------------
c       calculate 2*advective flux across 
c       east/north/bottom faces of "T" cells.
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
        call tic('tracer adv')
#endif

        if (enable_quicker_advection) then
c
c        quicker scheme
c
         call adv_east_flux_quicker(n,adv_fe)
         call adv_north_flux_quicker(n,adv_fn)
         call adv_bottom_flux_quicker(n,adv_fb)

        elseif (enable_upstream_advection) then
c
c        upstream advection scheme
c
         call adv_flux_upstream(n,adv_fe,adv_fn,adv_fb)

        elseif (enable_4th_advection) then
c
c        4 th order advection scheme
c
         call adv_flux_4th(n,adv_fe,adv_fn,adv_fb)

        elseif (enable_fct_advection) then
c
c         FCT advection scheme
c
         call adv_flux_fct(n,adv_fe,adv_fn,adv_fb)

        else
c
c        centered differences
c
         do j=js,je
#ifdef vector_host
          adv_fe(is-1:ie,1:km,j) = adv_vet(is-1:ie,1:km,j)*
     &           (t(is-1:ie,1:km,j,n,tau)+t(is:ie+1,1:km,j,n,tau))
#else
          do k=1,km
            do i=is-1,ie
	      adv_fe(i,k,j) = adv_vet(i,k,j)*(t(i,  k,j,n,tau) + 
     &                                        t(i+1,k,j,n,tau))
            enddo
          enddo
#endif
         enddo

         do j=js-1,je
#ifdef vector_host
	  adv_fn(is:ie,1:km,j) = adv_vnt(is:ie,1:km,j)*
     &      (t(is:ie,1:km,j,n,tau) + t(is:ie,1:km,j+1,n,tau))
#else
          do k=1,km
           do i=is,ie
	    adv_fn(i,k,j) = adv_vnt(i,k,j)*(t(i,k,j  ,n,tau) + 
     &                                      t(i,k,j+1,n,tau))
           enddo
          enddo
#endif
         enddo

         do j=js,je
#ifdef vector_host
	  adv_fb(is:ie,1:km-1,j) = adv_vbt(is:ie,1:km-1,j)*
     &          (t(is:ie,1:km-1,j,n,tau) + t(is:ie,2:km,j,n,tau))
#else
          do k=1,km-1
            do i=is,ie
	      adv_fb(i,k,j)  = adv_vbt(i,k,j)*(t(i,k,  j,n,tau) +
     &                                         t(i,k+1,j,n,tau))
            enddo
          enddo
#endif
         enddo
         
        endif

        if (enable_diffusion_isopycnic .and. n>2) then
          call isopycnic_add_gm(n,adv_fe,adv_fn,adv_fb)
        endif

#ifdef detailed_timing
        call toc('tracer adv')
#endif
c
c-----------------------------------------------------------------------
c       calculate diffusive flux across eastern and northern faces 
c       of "T" cells due to various parameterizations for diffusion.
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
        call tic('tracer diff')
#endif
        if (enable_diffusion_harmonic) then
c
c        diffusive flux on eastern face of "T" cells
c
         do j=js,je
          do k=1,km
            do i=is-1,ie              
              diff_fe(i,k,j) = ah_cstdxur(i,j)*
     &             (t_i(i,k,j,n,1) - t_i(i,k,j,n,0))*ah_scale(i,j)
#ifdef partial_cell
     &                         *dhte(i,k,j)
#endif
            enddo
          enddo
         enddo
c
c        north face 
c
          do j=js-1,je
            fxa=ah*csu_dyur(j)
            do k=1,km
              do i=is,ie
                diff_fn(i,k,j) =fxa*
     &            (T_j(i,k,j,n,1)-T_j(i,k,j,n,0))*ah_scale(i,j)
#ifdef partial_cell
     &                           *dhtn(i,k,j)
#endif
              enddo
            enddo
          enddo
c 
        else
         diff_fe=0.
         diff_fn=0.
        endif
c
c-----------------------------------------------------------------------
c       calculate diffusive flux across bottom face of "T" cells
c-----------------------------------------------------------------------
c
        do j=js,je
          do k=1,km-1
            do i=is,ie
              diff_fb(i,k,j) = diff_cbt(i,k,j)*
     &                         (t(i,k,j,n,taum1) - t(i,k+1,j,n,taum1))
#ifdef partial_cell
     &                   /dhwt(i,k,j)
#else
     &                   *dzwr(k)
#endif
            enddo
          enddo
        enddo

#ifdef detailed_timing
        call toc('tracer diff')
#endif
c
c-----------------------------------------------------------------------
c       set boundary conditions on "t" cells for vertical diffusion
c       and vertical advection
c-----------------------------------------------------------------------
c
        diff_fb(is:ie,km,js:je)=0.
        do j=js,je
          do i=is,ie
            diff_fb(i,0,j)  = stf(i,j,n)
            diff_fb(i,kmt(i,j),j) = btf(i,j,n)
	    adv_fb(i,0,j)   = adv_vbt(i,0,j)*(t(i,1,j,n,tau) +
     &                                       t(i,1,j,n,tau)) 
	    adv_fb(i,km,j)  = 0.
          enddo
        enddo
c
c-----------------------------------------------------------------------
c       add diffusive fluxes along isopycnals/neutral surfaces
c-----------------------------------------------------------------------
c
        if (enable_diffusion_isoneutral) then
          call isoneutral_flux(n,diff_fe,diff_fn,diff_fbiso)
        endif

        if (enable_diffusion_isopycnic) then
         call isopycnic_flux(n,diff_fe,diff_fn,diff_fbiso)
        endif
c
c-----------------------------------------------------------------------
c       add biharmonic diffusive fluxes
c-----------------------------------------------------------------------
c
        if (enable_diffusion_biharmonic) then
          call delsqt(n,diff_fe,diff_fn)
        endif
c
c-----------------------------------------------------------------------
c       limit advective fluxes for passive tracer
c       (works for positive tracers only)
c-----------------------------------------------------------------------
c
        if (n>2 .and. enable_flux_delimiter) then
         call delimit_adv_flux(n,adv_fe,adv_fn,adv_fb)
         if (enable_diffusion_isoneutral.or.
     &    enable_diffusion_isopycnic) then
          call delimit_all_fluxes(n,adv_fe,adv_fn,adv_fb,
     &                                     diff_fe,diff_fn,diff_fbiso)
         endif
        endif
c
c-----------------------------------------------------------------------
c       set source term for "T" cells
c-----------------------------------------------------------------------
c
        do j=js,je
          do k=1,km
            do i=is,ie
	      source(i,k,j) = 0.
            enddo
          enddo
        enddo

        if (enable_sponge) then
         if (enable_simple_spg) then
          call sponge_template(n)
         else
          call sponge_read(n)
         endif
        endif

        if (enable_shortwave_sbc .and. n==1 ) then
c
c=======================================================================
c       incorporate short wave penetration via the "source" 
c       term. note that the divergence of shortwave for the first
c       level "divpen(1)" is compensating for the effect of having
c       the shortwave component already included in the total
c       surface tracer flux "stf(i,j,1)"
c
c       incorporating the penetrative shortwave radiative flux into
c       the vertical diffusive flux term directly is not correct when
c       vertical diffusion is solved implicitly. The tri-diagonal
c       solver takes diffusion coefficients at tops and bottoms of
c       cells but not the fluxes.
c=======================================================================
c
         do j=js,je
	  do k=1,km
	    do i=is,ie
              source(i,k,j) = source(i,k,j)
     &                       + qsol(i,j)*divpen_shortwave(k) 
            enddo
          enddo
         enddo

        endif
c
c-----------------------------------------------------------------------
c       solve for "tau+1" tracer at center of "T" cells using statement
c       functions to represent each component of the calculation 
c       choose start and end indices for "full" calculation
c       or calculate zonal open boundary conditions
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
        call tic('tracer obc')
#endif

        is1=is
        if ( my_blk_i == 1 .and. enable_obc_west) then
           call cobc2 (is,ie,js,je,2,n)
           is1=max(is,3)
        endif

        ie1=ie
        if ( my_blk_i == n_pes_i .and. enable_obc_east) then
          call cobc2 (is,ie,js,je,imt-1,n)
          ie1=min(ie,imt-2)
        endif

#ifdef detailed_timing
        call toc('tracer obc')
c
        call tic('tracer tendency')
#endif

        do j=js1,je1
         do k=1,km
          if (enable_bbl.and.enable_bbl_advection) then
           do i=is1,ie1
	    tend(i) = DIFF_Tz(i,k,j)+ source(i,k,j) +
     &         (- ADV_Tx(i,k,j) - ADV_Ty(i,k,j) - ADV_Tz(i,k,j))
     &                 *(1.0-sigma_weight(i,k,j))
     & 	           + DIFF_Tx(i,k,j)+ DIFF_Ty(i,k,j)
           enddo
          else
           do i=is1,ie1
	    tend(i) = DIFF_Tz(i,k,j)+ source(i,k,j)
     &             - ADV_Tx(i,k,j)-ADV_Ty(i,k,j)-ADV_Tz(i,k,j)
     & 	           + DIFF_Tx(i,k,j)+ DIFF_Ty(i,k,j)
           enddo
          endif
          if (enable_diffusion_isoneutral.or.
     &        enable_diffusion_isopycnic   ) then
           do i=is1,ie1
            tend(i)=tend(i)+DIFF_Tz_iso(i,k,j)
           enddo
          endif
          do i=is1,ie1
	   t(i,k,j,n,taup1) = t(i,k,j,n,taum1) + 
     &                 c2dt*tend(i)*tmask(i,k,j)
          enddo
         enddo
        enddo

#ifdef detailed_timing
        call toc('tracer tendency')
#endif
c
c-----------------------------------------------------------------------
c       add in dT/dt component due to explicit bolus advection
c       (for isoneutral this part is absorbed in diffusive (skew) flux.
c-----------------------------------------------------------------------
c
        if (enable_diffusion_isopycnic) then
         if (n>2) then
c  advection velocities already added to advective fluxes for passive tracers
         else
          call isopycnic_add_div_gm(n,is1,ie1,js1,je1)
         endif
        endif
c
c-----------------------------------------------------------------------
c       add in dT/dt component due to Bottom boundary layer
c       of Beckmann + Doescher.
c-----------------------------------------------------------------------
c
        if (enable_bbl) then
         call add_bbl(n,is1,ie1,js1,je1,adv_fe,adv_fb)
        endif

#ifdef detailed_timing
        call tic('tracer implicit')
#endif
c
c-----------------------------------------------------------------------
c       add in dT/dt component due to implicit vertical diffusion
c       (open boundaries use always explicit vertical diffusion with kappa_h)
c-----------------------------------------------------------------------
c
        if (enable_implicit_vert_diff)
     &   call implicit_vert_diff(n,is1,ie1,js1,je1)

#ifdef detailed_timing
        call toc('tracer implicit')
#endif
c
c-----------------------------------------------------------------------
c       Diagnostics which depends on the advective/ diffusive
c       fluxes for tracer n.
c-----------------------------------------------------------------------
c
        if (enable_heat_tr .and. snapshot_time_step) 
     &         call diag_heat_tr(n,adv_fn,diff_fn)

      enddo  ! n loop

      if (my_blk_j == n_pes_j.and. enable_obc_north) call cobc(jmt-1)
c
c-----------------------------------------------------------------------
c     explicit convection: adjust column if gravitationally unstable
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
      call tic('tracer convect')
#endif
      if (enable_expl_convection) call convect (taup1)
#ifdef detailed_timing
      call toc('tracer convect')
#endif
c
c-----------------------------------------------------------------------
c     Kraus-Turner-Mixing
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
      call tic('tracer ktmix')
#endif
      if (enable_ktmix) call Ktmix
#ifdef detailed_timing
      call toc('tracer ktmix')
#endif
c
c-----------------------------------------------------------------------
c      Add tendencies due to "unphysical" sources :)
c-----------------------------------------------------------------------
c
       call tic('passive tracer')
       call passive_tracer_add()
       call toc('passive tracer')
c
c-----------------------------------------------------------------------
c      set boundary conditions at each PE
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
      call tic('tracer mpp')
#endif
      do n=1,nt
c        call set_cyclic(t(:,:,:,n,taup1),km,2)
        call set_cyclic(t(is_pe-2,1,js_pe-2,n,taup1),km,2)
        if (enable_quicker_advection.or.enable_4th_advection
     &                             .or. enable_fct_advection) 
     &      call set_cyclic_4th_order(t(:,:,:,n,taup1),km,2)
        if (my_blk_j == 1 .and. enable_obc_south) 
     &        t(:,:,1,n,taup1) = t(:,:,2,n,taup1)
        if (my_blk_j == n_pes_j .and. enable_obc_north)
     &        t(:,:,jmt,n,taup1) = t(:,:,jmt-1,n,taup1)
        if (my_blk_i == 1 .and. enable_obc_west) 
     &        t(1,:,:,n,taup1) = t(2,:,:,n,taup1)
        if (my_blk_i == n_pes_i .and. enable_obc_east) 
     &        t(imt,:,:,n,taup1) = t(imt-1,:,:,n,taup1)
c        call border_exchg(t(:,:,:,n,taup1),km,2)
        call border_exchg(t(is_pe-2,1,js_pe-2,n,taup1),km,2)
      enddo
#ifdef detailed_timing
      call toc('tracer mpp')
#endif
c
      if (enable_diffusion_isoneutral.or.
     &    enable_diffusion_isopycnic) 
     &    deallocate( diff_fbiso )

#ifdef detailed_timing
      call toc('tracer main')
#endif
      end subroutine tracer





      subroutine delsqt (n,diff_fe,diff_fn)
      use spflame_module
      implicit none
      integer is,ie,js,je,i,j,k,n,ip,jp,ism1,iep1,jsm1,jep1
      real :: diff_fe(is_pe-1:ie_pe,km,js_pe:je_pe) 
      real :: diff_fn(is_pe:ie_pe,km,js_pe-1:je_pe) 
      real T_i,T_j
#ifdef partial_cell
      real dhte,dhtn,dhwe,dhwn
      dhte(i,k,j)   = min(dht(i+1,k,j),dht(i,k,j))
      dhtn(i,k,j)   = min(dht(i,k,j+1),dht(i,k,j))
      dhwe(i,k,j)   = min(dhwt(i+1,k,j),dhwt(i,k,j))
      dhwn(i,k,j)   = min(dhwt(i,k,j+1),dhwt(i,k,j))
      T_i(i,k,j,n,ip) = t(i+ip,max(1,k-1),j,n,taum1) - dhwe(i,k-1,j)
     &            *(t(i+ip,max(1,k-1),j,n,taum1) - t(i+ip,k,j,n,taum1))
     &               /dhwt(i+ip,k-1,j)
      T_j(i,k,j,n,jp) = t(i,max(1,k-1),j+jp,n,taum1) - dhwn(i,k-1,j)
     &            *(t(i,max(1,k-1),j+jp,n,taum1) - t(i,k,j+jp,n,taum1))
     &               /dhwt(i,k-1,j+jp)
#else
      T_i(i,k,j,n,ip) = t(i+ip,k,j,n,taum1)
      T_j(i,k,j,n,jp) = t(i,k,j+jp,n,taum1)
#endif

      real ::  diff_fe_biha(is_pe-2:ie_pe+1,km,js_pe-1:je_pe+1) 
      real ::  diff_fn_biha(is_pe-1:ie_pe+1,km,js_pe-2:je_pe+1) 
      real ::  del2(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) 
      real diff_tx,diff_ty
      DIFF_Tx(i,k,j) = (diff_fe_biha(i,  k,j)*tmask(i+1,k,j)
     &            - diff_fe_biha(i-1,k,j)*tmask(i-1,k,j))*cstdxtr(i,j)
#ifdef partial_cell
     &                             /dht(i,k,j)
#endif
      DIFF_Ty(i,k,j) = (diff_fn_biha(i,k,j  )*tmask(i,k,j+1)
     &                - diff_fn_biha(i,k,j-1)*tmask(i,k,j-1))*cstdytr(j)
#ifdef partial_cell
     &                             /dht(i,k,j)
#endif

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
      ism1=max(2,is-1); iep1=min(imt-1,ie+1)
      jsm1=max(2,js-1); jep1=min(jmt-1,je+1)
c
c=======================================================================
c     compute del**2 of prognostic variables on MW rows "js" ... "je"
c     and gradients of del**2 quantities for variable "n" in the
c     tracer equation
c=======================================================================

c
c-----------------------------------------------------------------------
c       diffusive flux across eastern face of "T" cell
c       diffusive flux across northern face of "T" cell
c-----------------------------------------------------------------------
c
c       fe ism1-1:iep1 jsm1:jep1
        do j=js-1,je+1
          do k=1,km
            do i=ism1-1,iep1
              diff_fe_biha(i,k,j) = diff_cet*cstr(j)*dxur(i)*
     &                   (t_i(i,k,j,n,1) - t_i(i,k,j,n,0))
     &                        *ahbi_scale(i,j)
#ifdef partial_cell
     &                        *dhte(i,k,j)
#endif
            enddo
          enddo
        enddo

c       fn jsm1:iep1 jsm1-1:jep1
        do j=jsm1-1,jep1
          do k=1,km
            do i=is-1,ie+1
              diff_fn_biha(i,k,j) = diff_cnt*csu(j)*dyur(j)* 
     &                     (t_j(i,k,j,n,1) - t_j(i,k,j,n,0))
     &                         *ahbi_scale(i,j)
#ifdef partial_cell
     &                         *dhtn(i,k,j)
#endif
            enddo
          enddo
        enddo
c
c       compute -ah*del**2 of tracer
c
c       del2 is-1:ie+1 js-1:je+1
        do j=jsm1,jep1
          do k=1,km
            do i=ism1,iep1
	      del2(i,k,j) = -DIFF_Tx(i,k,j) - DIFF_Ty(i,k,j)
            enddo
          enddo
          if (my_blk_i == 1 .and. enable_obc_west) then
             del2(1,:,:) = del2(2,:,:)
          elseif (my_blk_i == 1)   then
             del2(1,:,:) = 0.
          endif
          if (my_blk_i == n_pes_i .and. enable_obc_east) then
            del2(imt,:,:) = del2(imt-1,:,:)
          elseif (my_blk_i == n_pes_i) then
            del2(imt,:,:) = 0.
          endif
        enddo

        call set_cyclic(del2(:,:,:),km,1)
c
c       set -del**2 = 0 on southern wall
c
        if (my_blk_j == 1)  del2(is-1:ie+1,:,1) = 0.
c
c       set -del**2 = 0 on northern wall
c
        if (my_blk_j == n_pes_j)  del2(is-1:ie+1,:,jmt) = 0.

c-----------------------------------------------------------------------
c       diffusive flux across eastern face of "T" cell
c       diffusive flux across northern face of "T" cell
c-----------------------------------------------------------------------
c      fe  is-1:ie js:je
        do j=js,je
          do k=1,km
            do i=is-1,ie
              diff_fe(i,k,j) = diff_fe(i,k,j)+
     &                         diff_cet*cstr(j)*dxur(i)*
     &                         (del2(i+1,k,j)-del2(i,k,j))        
     &                        *ahbi_scale(i,j)
#ifdef partial_cell
     &                        *dhte(i,k,j)
#endif
            enddo
          enddo
        enddo
c      fn  is:ie js-1:je
        do j=js-1,je
          do k=1,km
            do i=is,ie
              diff_fn(i,k,j) = diff_fn(i,k,j) +
     &                         diff_cnt*csu(j)*dyur(j)*
     &                        (del2(i,k,j+1) - del2(i,k,j))
     &                         *ahbi_scale(i,j)
#ifdef partial_cell
     &                         *dhtn(i,k,j)
#endif
            enddo
          enddo
        enddo
	end subroutine delsqt

#include "options.inc"
c
c-----------------------------------------------------------------------
c     preparation module
c-----------------------------------------------------------------------
c
      module prep_module
      implicit none
!     domain size
      integer imt,jmt,km
      integer :: number_tr = 2  ! numer of tracer

!     parameter which determines the grid, see MOM2 grids.F for explanation
      integer :: nxlon, nylat,nzdepth           
      integer,parameter :: max_regions = 100
      real :: x_lon(max_regions), dx_lon(max_regions)
      real :: y_lat(max_regions), dy_lat(max_regions)
      real :: z_depth(max_regions), dz_depth(max_regions)

!     the grid
      real, allocatable :: xt(:),xu(:)
      real, allocatable :: yt(:),yu(:)
      real, allocatable :: zt(:),zw(:),dzt(:),dzw(:)
      real, allocatable :: dxtdeg(:),dxudeg(:)
      real, allocatable :: dytdeg(:),dyudeg(:)
!     topography
      integer, allocatable :: kmt(:,:),kmu(:,:)
      real, allocatable :: htp(:,:),hup(:,:)  ! for partial cells

      logical :: cyclic= .false.   ! cyclic boundary condition
      logical :: enable_obc_north = .false.  ! open boundary at the north?
      logical :: enable_obc_south = .false.
      logical :: enable_obc_east = .false.
      logical :: enable_obc_west = .false.
      logical :: read_grid_topo = .false.    ! read in grid.dta and kmt.dta
      logical :: stop_after_topo = .false.   ! stop after generating 
                                             ! the grid and the
                                             ! topography
      logical :: isotropic = .false.         ! make an mercator projection
      logical :: flame_vert_grid = .false.   ! use the flame vertical grid
      logical :: pop_vert_grid   = .false.   ! use the POP 1/10 deg vertical grid


      logical :: rotated_grid = .true.       ! use other interpolation routines
      real (kind=8) phir,thetar,psir         ! rotation angles
      real (kind=8) gltnp,glnnp,gltpp,glnpp  ! latitude/long. of the 
                                             ! rotated north pole

      integer :: topo_smooth_ntimes=0, kmt_min=4 ! smoothing of topography,
                                                 ! minimal depth

      logical :: enable_blue      = .false.  ! prepare for blue
      logical :: enable_blue_mean = .false.  ! prepare for blue second approach

      real, parameter :: spval = -1.e20

      character (len=80) :: old_grid_file = 'old_grid.dta'
      character (len=80) :: new_grid_file = 'new_grid.dta'
      character (len=80) :: old_kmt_file  = 'old_kmt.dta'
      character (len=80) :: new_kmt_file  = 'new_kmt.dta'
      character (len=80) :: new_htp_file  = 'new_htp.dta'
      character (len=80) :: old_htp_file  = 'old_htp.dta'

      real :: tol_gcell = 1.0e-3  ! a factor used for the grid generation
      logical :: centered_t = .false. ! the grid can be t centered

      logical :: apply_landmask = .true.

      end module prep_module



      program prep_main
      use prep_module
      use time_type_module
      implicit none

      namelist /prep/ nxlon, nylat,nzdepth,
     &          x_lon,dx_lon,y_lat,dy_lat,z_depth,dz_depth,
     &          isotropic,flame_vert_grid,pop_vert_grid,cyclic,
     &          gltnp,glnnp,gltpp,glnpp,
     &          topo_smooth_ntimes,kmt_min,
     &          enable_obc_north, enable_obc_south,
     &          enable_obc_east,  enable_obc_west,
     &          read_grid_topo,stop_after_topo,
     &          rotated_grid, enable_blue, enable_blue_mean,
     &          number_tr,tol_gcell,centered_t

      call set_calendar_type(no_leap)

      open(10,file='namelist.prep',form='formatted')
      read(10, nml = prep )
      close(10)

      if (.not. rotated_grid) then
c       insure that no rotation at all is made
c       so that we can use simpler interpolation routines
        gltnp=90.;glnnp=90.
        gltpp=0.; glnpp=0.
      endif

      call prep_grid
      call sub_flush(6)
      call init_out_cdf
      call sub_flush(6)
      call prep_rot
      call sub_flush(6)
      call prep_topo
      call sub_flush(6)

      if (.not. stop_after_topo) then
       call prep_ic
       call sub_flush(6)
       call prep_sbc_tau
       call sub_flush(6)
       call prep_sbc_sflx
       call sub_flush(6)
       call prep_sponge
       call sub_flush(6)
       call prep_obc
       call sub_flush(6)
#ifdef BB_model
       call prep_BB()
       call sub_flush(6)
#endif
      endif

      end program prep_main



      subroutine prep_rot
      use prep_module
      implicit none
      integer i,j
      real (kind=8) rad
      real  (kind=8) rlnpp,rltpp,rltnp,rlnnp
      real  (kind=8) glt,gln,rlt,rln
      real,  allocatable :: glat(:,:)
      real :: p

c-----------------------------------------------------------------------
c     any spherical grid rotation can be achieved by specifying three, 
c     Euler angle, solid body rotations. the first rotation angle phir
c     is defined as a rotation about the original z axis. the second 
c     rotation angle thetar is defined as a rotation about the new x 
c     axis. the final rotation angle psir is defined as a rotation about
c     the new z axis. one method of deciding on the values of these 
c     angles is to define the geographic (unrotated) latitude and 
c     longitude of the north pole of the rotated grid. this defines 
c     the angles phir and thetar. The latitude of the new grid is now
c     specified but the longitude is still arbitrary. to define the new 
c     grid longitude, specify the geographic location of any point on 
c     the rotated grid`s prime meridian. the angle psir is then 
c     calculated as the rotation angle necessary to place this point on 
c     the prime meridian of the rotated grid.
c
c     for example, to set up a model with an equatorial grid over the 
c     Arctic and North Atlantic, one could specify the rotated grid pole
c     to be at 0 N, 110 W and a prime meridian point to be at 0 N O E. 
c     This specifies a grid rotation in which the new grid equator is 
c     defined along the 20 W and 160 E meridians. The rotated grid 
c     longitude would be east, north of the geographic equator and west 
c     to the south. The geographic pole would be at 0 N and 90 E.
c
c     latitudes and longitudes should be specified such that N and E are
c     positive and S and W are negative.
c 
c     gltnp = geographic latitude of the rotated grid north pole 
c     glnnp = geographic longitude of the rotated grid north pole
c     gltpp = geographic latitude of a prime point on the rotated grid
c     glnpp = geographic longitude of a prime point on the rotated grid
c-----------------------------------------------------------------------
c
c      if (precision(p) < 10) then
c       write(6,'(/a/)') '=>Warning: 64bit precision is recommended'
c       call halt_stop('')
c      endif
c
      rad = acos(-1.)/180.
c
c-----------------------------------------------------------------------
c     calculate the Euler angles required for the rotation
c-----------------------------------------------------------------------
c
      phir   = (glnnp - 90.)*rad
      thetar = (gltnp - 90.)*rad
c
c     set rotation angle psir to zero and rotate prime meridian point to
c     find the required angle psir to give the point a longitude of zero
c
      psir = 0.
      call rotate (gltpp, glnpp, phir, thetar, psir, rltpp, rlnpp)
      psir = rlnpp*rad

      print*,'psir=',psir/rad,' thetar=',thetar/rad,' phir=',phir/rad
c
c-----------------------------------------------------------------------
c     write out the grid definitions and rotation angles
c-----------------------------------------------------------------------
c
      call rotate (gltnp, glnnp, phir, thetar, psir, rltnp, rlnnp)
      call rotate (gltpp, glnpp, phir, thetar, psir, rltpp, rlnpp)
c
      write(6     ,'(/,a,/)') 'Rotated Model Grid Definitions:'
      write(6     ,'(16x,a)') '    Geographic              Rotated     '
      write(6     ,'(16x,a)')'Latitude  Longitude   Latitude  Longitude'
      write(6     ,'(a,4f11.3)') 'North Pole: ', gltnp, glnnp
     &,                           rltnp, rlnnp
      write(6     ,'(a,4f11.3)') 'Prime point:', gltpp, glnpp
     &,                           rltpp, rlnpp
c
      write(6     ,'(//,a,/)') 'Rotation Angles:'
      write(6     ,'(a,f11.3,a)') 'phir:       ', phir/rad, ' deg'
      write(6     ,'(a,f11.3,a)') 'thetar:     ', thetar/rad, ' deg'
      write(6     ,'(a,f11.3,a)') 'psir:       ', psir/rad, ' deg'
c
c-----------------------------------------------------------------------
c     calculate and write the geographic latitude of the model grid 
c-----------------------------------------------------------------------
c
c     latitude of velocity grid is needed to calculate Coriolis
c
      allocate( glat(imt,jmt) )
      do j=1,jmt
        do i=1,imt
          rlt=yu(j);rln=xu(i)
          call rotate (rlt, rln, -psir, -thetar, -phir, glt, gln)
          glat(i,j) = glt
        enddo
      enddo
      call write_glat_to_cdf(glat)
      deallocate(glat)
c
c-----------------------------------------------------------------------
c     write the locations of the corners of the rotated model grid
c-----------------------------------------------------------------------
c
      write(6     ,'(/,/,a,/)') 'Rotated Model Grid Corners:'
      write(6     ,'(16x,a)') '    Geographic              Rotated  '
      write(6     ,'(16x,a)') 
     &                'Latitude  Longitude   Latitude  Longitude'
      rlt=yt(jmt);rln=xt(1)
      call rotate (rlt, rln, -psir, -thetar, -phir, glt, gln)
      write(6     ,'(a,4f11.3)') 'NW corner:  ', glt, gln, yt(jmt)
     &,                             xt(1)
      rlt=yt(jmt);rln=xt(imt)
      call rotate (rlt, rln, -psir, -thetar, -phir, glt, gln)
      write(6     ,'(a,4f11.3)') 'NE corner:  ', glt, gln, yt(jmt)
     &,                             xt(imt)
      rlt=yt(1);rln=xt(1)
      call rotate (rlt, rln, -psir, -thetar, -phir, glt, gln)
      write(6     ,'(a,4f11.3)') 'SW corner:  ', glt, gln, yt(1), xt(1)
      rlt=yt(1);rln=xt(imt)
      call rotate (rlt, rln, -psir, -thetar, -phir, glt, gln)
      write(6     ,'(a,4f11.3,//)') 'SE corner:  ', glt, gln, yt(1)
     &,                             xt(imt)
      end subroutine prep_rot
      




       subroutine prep_ic
c
c--------------------------------------------------------
c      prepare the initial conditions
c      the data are also needed for sponge layers,
c      open boundaries and maybe for surface boundary conditions
c--------------------------------------------------------
c
       use prep_module
       implicit none
       integer nx,ny,nz,nt,n,k,j,m,ierr,i
       real, allocatable :: dtr(:,:,:,:),x(:),y(:),z(:),tx(:)
       real, allocatable :: ntr(:,:,:)
       real, allocatable :: tr(:,:,:,:)
       integer :: init_v,lenw_v
       real, allocatable :: work_v(:)
       integer :: init_h,lenw_h
       real, allocatable :: work_h(:)
       logical :: verbose=.true.

       call init_forcing_file('forcing_ic.cdf')
       if (number_tr>2) then
        call init_forcing_file('forcing_ic_tracer.cdf')
       endif

       print*,' reading global T/S fields from file'
       call read_dims_ic(nx,ny,nz,nt)
       print*,' nx=',nx,' ny=',ny,' nz=',nz,' nt=',nt
c      allocate working arrays
       allocate(dtr(nx,ny,nz,number_tr),x(nx),y(ny),z(nz+1),tx(nx)
     &       ,stat=ierr)
       if (ierr/=0) call halt_stop('allocate failed ')
       allocate(ntr(imt,jmt,nz+1))
       dtr=0.; x=0.; y=0.; z=0.; ntr=0.
       allocate(tr(imt,jmt,km,number_tr)); tr=0.

       print*,' interpolating data'
       do n=1,nt
c       read monthly means
        print*,' reading raw data for month =',n
        call sub_flush(6)
        call read_ic(nx,ny,nz,number_tr,n,x,y,z,dtr,spval)
        z(nz+1)=10000.
        if (.not.rotated_grid) then
         lenw_h=10*max(imt,jmt); allocate(work_h(lenw_h))
         init_h=1
        endif
        lenw_v=10*max(imt,km); allocate(work_v(lenw_v))
        init_v=1

        do m=1,number_tr
         print*,' working on tracer #',m
         print*,' interpolating horizontally '
         call sub_flush(6)
         do k=1,nz
          if (rotated_grid) then
           call rot_intrp_sclr(dtr(:,:,k,m), x, y, nx, ny, 
     &                        ntr(:,:,k), xt, yt,
     &               imt, jmt, psir, thetar, phir,spval,verbose)
           verbose=.false.
          else
c         use cheaper subroutine here
           call tranlon (dtr(:,:,k,m), nx, nx-2, ny, x, xt,imt, tx)
           call ctf (dtr(:,:,k,m), nx, ny, tx, y, 
     &                  ntr(:,:,k),imt, jmt, 1, imt, 1, jmt,
     &                  xt, yt, init_h, work_H, lenw_h,spval)
           init_h=0 ! we can use the same interpolation weights
          endif
         enddo
c
c       extrapolate to abyssal ocean
c
         print*,' interpolating vertically'
         call sub_flush(6)
         ntr(:,:,nz+1)=ntr(:,:,nz)
         do j=1,jmt
          call ctf (ntr(:,j,:), imt, nz+1, xt, z, 
     &              tr(:,j,:,m),imt, km, 1, imt, 1, km,
     &              xt, zt/100., init_v, work_v, lenw_v,spval)
          init_v=0
         enddo
        enddo ! m

        deallocate(work_v)
        if (.not.rotated_grid) deallocate(work_h)

        print*,' try to fill gaps horizontally  '
        call sub_flush(6)
        do k=1,km
         do m=1,number_tr
          call fillgaps(imt, jmt, km, k, kmt, tr(:,:,k,m), 
     &                     spval, 0,.false.)
         enddo
        enddo
        print*,' try to fill gaps vertically  '
        call sub_flush(6)
        do j=1,jmt
         do m=1,number_tr
          call fillholes(imt, jmt, km, j, kmt, tr(:,j,:,m), 
     &                      spval, 1,.true.)
         enddo
        enddo
        print*,' successfull interpolation for month ',n
        call sub_flush(6)

        ! store january values as initial conditions
        if (n==1) call write_ic_to_cdf(tr,'initial')

        ! write monthly values to a temporary file
        call write_ts_to_file(n,tr)

        ! write monthly mean values to netcdf file for BLUE
        if (enable_blue) call write_blue_to_cdf(
     &                  tr(1,1,1,1),tr(1,1,1,2),nt,n)

       enddo ! n

       ! store also mean values in netcdf file
       ! assuming equal months here, which is a good approximation
       deallocate(ntr)
       allocate(ntr(imt,jmt,km)); ntr=0.
       tr=0
       if (enable_blue_mean)  then
        do n=1,nt
         do m=1,number_tr
          call read_atr_from_file(n,m,ntr)
          do k=1,km; do j=1,jmt; do i=1,imt 
           if (ntr(i,j,k) /=spval ) then
            tr(i,j,k,m)=tr(i,j,k,m)+ntr(i,j,k)
           else
            tr(i,j,k,m)=spval
           endif
          enddo; enddo; enddo
         enddo
        enddo
        do k=1,km; do j=1,jmt; do i=1,imt 
         do m=1,number_tr
          if (tr(i,j,k,m) /=spval ) tr(i,j,k,m)=tr(i,j,k,m)/nt
         enddo
        enddo; enddo; enddo
c        call write_ic_to_cdf(tr,'mean')
        call sub_flush(6)
        ! write annual mean values to netcdf file for BLUE mean
        call write_blue_mean_to_cdf(tr(1,1,1,1),tr(1,1,1,2))
       endif

       deallocate(dtr,x,tx,y,z,ntr,tr )
       end subroutine prep_ic



       subroutine prep_sbc_tau
c
c--------------------------------------------------------
c      prepare surface boundary conditions for momentum
c--------------------------------------------------------
c
       use prep_module
       implicit none
       integer nx,ny,nt,ntr
       real, allocatable :: tau(:,:,:,:),x(:),y(:),mask(:,:)
       real, allocatable :: vec(:,:,:),nvec(:,:,:)
       real, allocatable :: time(:),tx(:)
       real :: toffset
       integer :: n,k,m
       real, allocatable :: ustar(:,:,:),nustar(:,:)
       logical verbose
       integer :: init_t = 1,lenw_t
       real , allocatable :: work_t(:)

       call init_forcing_file('forcing_wind.cdf')

       print*,' reading wind stress data '
       call read_dims_tau(nx,ny,nt)
       print*,' nx=',nx,' ny=',ny,' nt=',nt

       allocate(tau(nx,ny,nt,2),x(nx),y(ny),mask(nx,ny),time(nt) )
       tau=0.;x=0.;y=0.
       call read_tau(tau,x,y,mask,nx,ny,nt,spval,time,toffset)
       call sub_flush(6)
       allocate( vec(nx,ny,2), nvec(imt,jmt,2) ); vec=0.;nvec=0.

       print*,' interpolating data '
       call sub_flush(6)
       verbose=.true.
       if (.not.rotated_grid) then
          init_t=1
          allocate(tx(nx))
          lenw_t = 10*max(imt,jmt)
          allocate( work_t(lenw_t) )
       endif
       do n=1,nt
        call sub_flush(6)
        vec(:,:,1)=tau(:,:,n,1)
        vec(:,:,2)=tau(:,:,n,2)
        if (rotated_grid) then
          call rot_intrp_vctr(vec, x, y, nx, ny, 
     &                      nvec, xu, yu ,
     &              imt,jmt, psir, thetar, phir,spval,verbose)
           verbose=.false.
        else
c         use cheaper subroutine here
           call tranlon (vec(:,:,1), nx, nx-2, ny, x, xu,imt, tx)
           call tranlon (vec(:,:,2), nx, nx-2, ny, x, xu,imt, tx)
           call ctf (vec(:,:,1), nx, ny, tx, y, 
     &                  nvec(:,:,1),imt, jmt, 1, imt, 1, jmt,
     &                  xu, yu, init_t, work_t, lenw_t,spval)
           init_t=0 ! we can use the same interpolation weights
           call ctf (vec(:,:,2), nx, ny, tx, y, 
     &                  nvec(:,:,2),imt, jmt, 1, imt, 1, jmt,
     &                  xu, yu, init_t, work_t, lenw_t,spval)
        endif
        call fillgaps(imt, jmt, km, 1, kmu, nvec(1,1,1), 
     &                 spval, 2,.true.)
        call fillgaps(imt, jmt, km, 1, kmu, nvec(1,1,2), 
     &                 spval, 2,.true.)

c        print*,' writing wind stress to output file for n=',n
        call sub_flush(6)
        call write_tau_to_cdf(nvec,nt,n,time,toffset)
       enddo
       deallocate( tau,x,y,mask,vec,nvec, time)
       if (.not.rotated_grid) deallocate(tx,work_t)
       print*,' done '

c#ifdef notdef
       print*,' reading ustar data '
       call sub_flush(6)
       call read_dims_ustar(nx,ny,nt)
       print*,' nx=',nx,' ny=',ny,' nt=',nt
       allocate(ustar(nx,ny,nt),x(nx),y(ny),time(nt) )
       ustar=0.;x=0.;y=0.;time=0.0
       call read_ustar(ustar,x,y,nx,ny,nt,spval,time,toffset)
       allocate(  nustar(imt,jmt)); nustar=0.
       print*,' interpolating data '
       verbose=.true.
       if (.not.rotated_grid) then
          init_t=1
          allocate(tx(nx))
          lenw_t = 10*max(imt,jmt)
          allocate( work_t(lenw_t) )
       endif
       do n=1,nt
        if (rotated_grid) then
          call rot_intrp_sclr (ustar(1,1,n), x, y, nx, ny, 
     &                       nustar, xt, yt,
     &               imt, jmt, psir, thetar, phir,spval,verbose)
          verbose=.false.
        else
c         use cheaper subroutine here
           call tranlon (ustar(1,1,n), nx, nx-2, ny, x, xt,imt, tx)
           call ctf (ustar(1,1,n), nx, ny, tx, y, 
     &                  nustar,imt, jmt, 1, imt, 1, jmt,
     &                  xt, yt, init_t, work_t, lenw_t,spval)
           init_t=0 ! we can use the same interpolation weights
        endif
        call fillgaps(imt, jmt, km, 1, kmt, nustar, 
     &                     spval, 2,.true.)
        print*,' writing ustar to output file for n=',n
        call write_ustar_to_cdf(nustar,nt,n,time,toffset)
       enddo
       print*,' done '
       if (.not.rotated_grid) deallocate(tx,work_t)
       deallocate( ustar,x,y,nustar,time)
       call sub_flush(6)
c#endif
       end subroutine prep_sbc_tau

      
       subroutine prep_sbc_sflx
c
c--------------------------------------------------------
c      prepare surface boundary conditions for tracer
c--------------------------------------------------------
c
       use prep_module
       implicit none
       integer nx,ny,nt,ntr
       real, allocatable :: x(:),y(:)
       real, allocatable :: time(:),tx(:)
       real :: toffset
       integer :: n,k,m
       real, allocatable :: ntr_clim(:,:),ntr_rest(:,:)
       real, allocatable :: tr_clim(:,:,:),tr_rest(:,:,:)
       real, allocatable :: ntr_flux(:,:), tr_flux(:,:,:)
       logical verbose
       integer :: init_t = 1,lenw_t
       real , allocatable :: work_t(:)

       call init_forcing_file('forcing_sflx.cdf')
       if (number_tr>2) then
         call init_forcing_file('forcing_sflx_tracer.cdf')
       endif

       print*,' reading tracer flux data '
       call sub_flush(6)

       do m=1,number_tr

        print*,' Surface boundary conditions for tracer ',m
        call sub_flush(6)
        call read_dims_tr(nx,ny,nt,m)
        print*,' nx=',nx,' ny=',ny,' nt=',nt
        call sub_flush(6)

        allocate(  ntr_clim(imt,jmt) )
        allocate(  ntr_rest(imt,jmt) )
        allocate(  ntr_flux(imt,jmt) )
        ntr_clim=0.; ntr_rest=0.; ntr_flux = 0.
        allocate(tr_clim(nx,ny,nt),tr_rest(nx,ny,nt),
     &           x(nx),y(ny),tr_flux(nx,ny,nt),time(nt) )
        x=0;y=0;tr_clim=0;tr_rest=0; tr_flux=0.; time=0.0

        apply_landmask = .true.
        call read_tr(tr_clim,tr_rest,tr_flux,x,y,
     &                    time,toffset,nx,ny,nt,m)

        print*,' interpolating data '
        call sub_flush(6)
        verbose=.true.
        if (.not.rotated_grid) then
          init_t=1
          allocate(tx(nx))
          lenw_t = 10*max(imt,jmt)
          allocate( work_t(lenw_t) )
        endif
        do n=1,nt
         print*,'nt=',n
         call sub_flush(6)

         if (rotated_grid) then
          call rot_intrp_sclr (tr_clim(:,:,n), x, y, nx, ny, 
     &                        ntr_clim(:,:), xt, yt,
     &               imt, jmt, psir, thetar, phir,spval,verbose)
          verbose=.false.
          call rot_intrp_sclr (tr_rest(:,:,n), x, y, nx, ny, 
     &                        ntr_rest(:,:), xt, yt,
     &                imt, jmt, psir, thetar, phir,spval,verbose)
          call rot_intrp_sclr (tr_flux(:,:,n), x, y, nx, ny, 
     &                        ntr_flux(:,:), xt, yt,
     &                imt, jmt, psir, thetar, phir,spval,verbose)
         else
c         use cheaper subroutine here
           call tranlon (tr_clim(1,1,n), nx, nx-2, ny, x, xt,imt, tx)
           call ctf (tr_clim(1,1,n), nx, ny, tx, y, 
     &                  ntr_clim,imt, jmt, 1, imt, 1, jmt,
     &                  xt, yt, init_t, work_t, lenw_t,spval)
           init_t=0 ! we can use the same interpolation weights
           call tranlon (tr_rest(1,1,n), nx, nx-2, ny, x, xt,imt, tx)
           call ctf (tr_rest(1,1,n), nx, ny, tx, y, 
     &                  ntr_rest,imt, jmt, 1, imt, 1, jmt,
     &                  xt, yt, init_t, work_t, lenw_t,spval)
           call tranlon (tr_flux(1,1,n), nx, nx-2, ny, x, xt,imt, tx)
           call ctf (tr_flux(1,1,n), nx, ny, tx, y, 
     &                  ntr_flux,imt, jmt, 1, imt, 1, jmt,
     &                  xt, yt, init_t, work_t, lenw_t,spval)
         endif
         if (apply_landmask) then
         call fillgaps(imt, jmt, km, 1, kmt, ntr_clim(:,:), 
     &                     spval, 2,.true.)
         call fillgaps(imt, jmt, km, 1, kmt, ntr_rest(:,:), 
     &                     spval, 2,.true.)
         call fillgaps(imt, jmt, km, 1, kmt, ntr_flux(:,:), 
     &                     spval, 2,.true.)
         endif
         call write_tr_to_cdf(ntr_clim,ntr_rest,ntr_flux,
     &                                time,toffset,nt,m,n)
        enddo ! n: number of time step
        if (.not.rotated_grid) deallocate(tx,work_t)
        deallocate(tr_clim,tr_rest,tr_flux,x,y)
        deallocate( ntr_clim,ntr_rest,ntr_flux,time)
       enddo ! m=1,number_tr
       print*,' done '
       call sub_flush(6)
       print*,' done '
       call sub_flush(6)
       end subroutine prep_sbc_sflx

      
 
       subroutine prep_obc
c--------------------------------------------------------
c      prepare open boundary conditions
c--------------------------------------------------------
       use prep_module
       implicit none
       integer n

       real psi_south(12,imt)
       real psi_west(12,jmt)

       call init_forcing_file('forcing_obc.cdf')

       print*,' preparing open boundaries'
       call sub_flush(6)


       if (enable_obc_north) then

        print*,' preparing northern open boundaries'
        call sub_flush(6)
c
c      write northern obc,  no data for psi
c
        psi_south=0.
        call read_psi_north(psi_south,kmt(:,jmt-1),imt)
        do n=1,12
         where( kmt(:,jmt-1) ==0 ) psi_south(n,:)=spval
        enddo
        call write_obc_to_cdf(psi_south,'n',12)
       endif

       if (enable_obc_south) then

        print*,' preparing southern open boundaries'
        call sub_flush(6)
c
c      read streamfunction for southern boundary
c
        psi_south=0.
        call read_psi_south(psi_south,kmt(:,2),imt)
        do n=1,12
        where( kmt(:,2) ==0 ) psi_south(n,:)=spval
        enddo
c
c      write southern obc 
c
        call write_obc_to_cdf(psi_south,'s',12)
       endif

       if (enable_obc_east) then

        print*,' preparing eastern open boundaries'
        call sub_flush(6)
        psi_west=0.
c        print*,' not yeyt readdy ';stop
c        call read_psi_east(psi_west,kmt(imt-1,:),jmt)
        do n=1,12
         where( kmt(imt-1,:) ==0 ) psi_west(n,:)=spval
        enddo
        call write_obc_to_cdf(psi_west,'e',12)
       endif

       if (enable_obc_west) then

        print*,' preparing western open boundaries'
        call sub_flush(6)
        psi_west=0.
c        print*,' not yeyt readdy ';stop
c        call read_psi_west(psi_west,kmt(2,:),jmt)
        do n=1,12
         where( kmt(2,:) ==0 ) psi_west(n,:)=spval
        enddo
        call write_obc_to_cdf(psi_west,'w',12)
       endif
       print*,' done preparing open boundaries'
      
       end subroutine prep_obc

c
c     island_module need this mpp stuff
c     which is disabled here anyway
c
      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"

c
c     convert unformatted written data containing
c     overturning to NetCDF format
c
c
c      or:
c
c     read meridional velocity from snapshot or
c     averaged file to compute overturning
#ifdef partial_cell
c     from an experiment with partial cells
#endif
c
c  real variables are 8 or 4 bytes long set by
c#define real_8



      module kind_mod
#ifdef real_8
      integer, parameter::  r_knd  = selected_real_kind(13)
#else
      integer, parameter::  r_knd  = selected_real_kind(6)
#endif
      end module kind_mod


      module cv_vsf_module
      use kind_mod
      use time_manager_module
      integer :: imt,jmt,km,itm
      real (kind=r_knd),allocatable :: xt(:), yt(:), xu(:), yu(:),
     & dxtdeg(:), dytdeg(:), dxudeg(:), dyudeg(:),
     & dxt(:), dyt(:), dxu(:), dyu(:),
     & zt(:),zw(:),dzt(:),dzw(:),time(:)
      integer, dimension(:,:), allocatable :: kmt, kmu
      real (kind=r_knd), dimension(:,:), allocatable :: htp, hup
      real (kind=r_knd), dimension(:,:,:), allocatable :: dht, dhu
      real (kind=r_knd), dimension(:,:,:), allocatable :: vsf
      real (kind=r_knd), parameter :: radius   = 6370.0e5
      real (kind=r_knd), parameter :: pi       = 
     &        3.14159265358979323846264338327950588
      real (kind=r_knd), parameter :: radian   = 360./(2.*pi)
      real (kind=r_knd), parameter :: degtcm   = radius/radian
      real (kind=r_knd) :: spval = -9.9e15
      character (len=32) :: istamp ='m/d/y= 1/ 1/1900, h:m:s= 0: 0: 0' 
      end module cv_vsf_module




      program cv_vsf
      use cv_vsf_module
      implicit none
      character (len=80) :: infile,outfile
      integer :: ierr
      print*,' Converting overturning written by SPFLAME ',
     &       ' to NetCDF file '
      call set_calendar_type(no_leap)
      call get_commandline_arg(1,infile,ierr)
      if (ierr/=0) goto 99
      print*,' reading from file ',infile(1:len_trim(infile))
      call get_commandline_arg(2,outfile,ierr)
      if (ierr/=0) goto 99
      print*,' writing to file ',outfile(1:len_trim(outfile))
      call read_grid
c      call read_vel(infile)
      call read_vsf(infile)
      call write_vsf(outfile)
      stop
 99   print*,' program needs command line parameter'
      print*,' 1. input binary file name (written by spflame)'
      print*,' 2. output NetCDF file name '
      end program cv_vsf


      subroutine read_vsf(infile)
c
c-----------------------------------------------------------------------
c     reads meridional overturning vsf
c-----------------------------------------------------------------------
c
      use cv_vsf_module
      implicit none
      character (len=*) :: infile
      character (len=32) :: stamp
      type( time_type ) :: t
      integer :: io,k,n,j,i
      real  (kind=r_knd):: x

      call getunit (io, infile,'u s r ieee')
      itm=0
 10   continue
      do k=1,8; read (io,end=20); enddo
      itm=itm+1
      goto 10
 20   continue
      print*,' found ',itm,' time steps in file ',infile
      rewind(io)
      allocate( vsf(jmt,km,itm), time(itm) )
      vsf=spval
      do n=1,itm
       read (io) stamp ! iotext, expnam
       t =  get_stamp (stamp) - get_stamp(istamp)
       time(n)=t%days + t%seconds/60./60./24.
       print*,' n=',n,' days since origin=',time(n),' date ',stamp
       read (io) j, k
       if ((j/=jmt) .or. (k/=km)) then
        print*,' found jmt=',j,' km=',k,' in file ',infile
        print*,' previous definition was jmt=',jmt,' km=',km
        stop
       endif
       read (io) ! stamp ! iotext, expnam
       read (io) ! zw
       read (io) !current_stamp, iotext, expnam
       read (io) !yu
       read (io) !current_stamp, iotext, expnam
       read (io) vsf(:,:,n)

       do j=1,jmt
        do k=1,km
         x=0
         do i=2,imt-1
          if (kmu(i,j)>=k) x=1
         enddo
         vsf(j,k,n)=vsf(j,k,n)/1.e12*x+spval*(1-x)
        enddo
       enddo
      enddo
      close(io)

      end subroutine read_vsf


      subroutine read_vel(infile)
c
c-----------------------------------------------------------------------
c     reads meridional velocity and computes vsf
c-----------------------------------------------------------------------
c
      use cv_vsf_module
      implicit none
      character (len=*) :: infile
#include "netcdf.inc"
      integer :: iret,ncid,vid,dim(4),timeid,sshid
      integer corner(4), edges(4)
      character (len=80) :: s
      real (kind=r_knd), allocatable :: vbarx(:),ssh(:,:,:)
      real (kind=r_knd), dimension(:,:,:,:), allocatable :: v
      real (kind=r_knd) :: x
      integer :: k,n,i,j
      logical :: freesurf=.false.

      print*,' reading meridional velocity from file ',
     &     infile(1:len_trim(infile))
      iret=nf_open(infile,NF_NOWRITE,ncid)
      iret=nf_inq_varid(ncid,'v',vid)
      iret=NF_INQ_VARDIMID(ncid,vid,dim)
      iret= NF_INQ_DIMLEN (ncid, DIM(4), itm)
      s='';iret=NF_INQ_DIMNAME(ncid,dim(4), s) 
      iret=nf_inq_varid(ncid,s,timeid)
      print*,' time steps in file: ',itm
      allocate( v(imt,jmt,km,itm), time(itm) );v=0.;time=0.
      iret=nf_inq_varid(ncid,'ssh',sshid)
      if (iret == 0) then
        freesurf=.true.
        print*,' found free surface in snapshot'
        print*,' assuming that the exp. used free surface '
        allocate(ssh(imt,jmt,itm))
        corner=1; edges=(/imt,jmt,itm,1/)
#ifdef real_8
        iret= nf_get_vara_double(ncid,sshid, corner,edges,ssh)
        iret = nf_get_att_double(ncid, sshid, 'missing_value', spval)
#else
        iret= nf_get_vara_real (ncid,sshid, corner,edges,ssh)
        iret = nf_get_att_real(ncid, sshid, 'missing_value', spval)
#endif
        where( ssh/=spval) ssh=ssh*100. ! convert to cm
        where( ssh==spval) ssh=0.
      endif

      corner=1; edges=(/itm,1,1,1/)
#ifdef real_8
      iret= nf_get_vara_double(ncid,timeid, corner,edges,time)
#else
      iret= nf_get_vara_real (ncid,timeid, corner,edges,time)
#endif
      corner=1; edges=(/imt,jmt,km,itm/)
#ifdef real_8
      iret= nf_get_vara_double(ncid,vid, corner,edges,v)
      iret = nf_get_att_double(ncid, vid, 'missing_value', spval)
#else
      iret= nf_get_vara_real (ncid,vid, corner,edges,v)
      iret = nf_get_att_real(ncid, vid, 'missing_value', spval)
#endif
      where( v/=spval) v=v*100 ! convert to cm/s
      where( v==spval) v=0.
      call ncclos (ncid, iret)

      allocate( vbarx(km) );vbarx=0.
      allocate( vsf(jmt,km,itm) )
      vsf=spval

      do n=1,itm
      do j=2,jmt-1
       do k=1,km
        vbarx=0.
        do i=2,imt-1
         vbarx(k) = vbarx(k) + v(i,j,k,n)*dxu(i)
#ifdef partial_cell
     &                                          *dhu(i,k,j)
#else
     &                                          *dzt(k)
#endif
     &        *cos(yu(j)/radian)
        enddo
        if (k == 1) then
         if (freesurf) then
          do i=2,imt-1
           vbarx(k) = vbarx(k) + v(i,j,k,n)*dxu(i)*
     &                   0.5*((ssh(i,j  ,n)+ssh(i-1,j  ,n)*0.5)
     &                       +(ssh(i,j-1,n)+ssh(i-1,j-1,n)*0.5)) 
          enddo
         endif
         vsf(j,k,n) = vbarx(k)
	else
         vsf(j,k,n) = vsf(j,k-1,n) + vbarx(k)
	endif
       enddo
       do k=1,km
        x=0
        do i=2,imt-1
         if (kmu(i,j)>=k) x=1
        enddo
        vsf(j,k,n)=vsf(j,k,n)/1.e12*x+spval*(1-x)
       enddo
      enddo
      enddo
      deallocate(vbarx,v)
      end subroutine read_vel


      subroutine write_vsf(outfile)
      use cv_vsf_module
      implicit none
      character (len=*) :: outfile
      real  (kind=r_knd):: x
      integer :: i,j,k,n
#include "netcdf.inc"
      integer :: iret,ncid,lat_udim,lat_uid
      integer :: depth_tdim,depth_tid,itimedim,itimeid
      integer :: dims(4),vsfid
      character name*24, unit*16, text*80
      integer corner(4), edges(4)

      print*,' writing meridional overturning to file ',
     &     outfile(1:len_trim(outfile))
      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c     grid variables
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
      dims=(/lat_udim,depth_tdim,itimedim,1/)
      vsfid=ncvdef (ncid,'vsf', NCFLOAT,3,dims,iret)
c     attributes of the grid
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '01-JAN-1900 00:00:00', iret)
c     attributes of variables
      name = 'Meridional overturning'; unit = 'Sv'
      call dvcdf_here(ncid,vsfid,name,24,unit,16,spval)
      call ncendf(ncid, iret)
      zt=zt/100.
      corner=(/1,1,1,1/); edges=(/jmt,km,itm,1/)
#ifdef real_8
      iret= nf_put_vara_double(ncid,lat_uid ,1, jmt,yu)
      iret= nf_put_vara_double(ncid,depth_tid ,1, km,zt)
      iret= nf_put_vara_double(ncid,itimeid ,1, itm,time)
      iret= nf_put_vara_double(ncid,vsfid ,corner, edges,vsf)
#else
      iret= nf_put_vara_real(ncid,lat_uid ,1, jmt,yu)
      iret= nf_put_vara_real(ncid,depth_tid ,1, km,zt)
      iret= nf_put_vara_real(ncid,itimeid ,1, itm,time)
      iret= nf_put_vara_real(ncid,vsfid ,corner, edges,vsf)
#endif
      call ncclos (ncid, iret)

      end subroutine write_vsf
 


      subroutine read_grid ()
c
c-----------------------------------------------------------------------
c     read in the grid from a binary file
c-----------------------------------------------------------------------
c
      use cv_vsf_module
      implicit none
      integer i,j,k,io,kb

      print*,
     & ' =>Reading the grid definition from file grid.dta'
      call getunit (io, 'grid.dta', 'u s r ieee')
      read (io) ! no checks for awi id
      read (io) imt, jmt, km
      allocate( xt(imt), yt(jmt), xu(imt), yu(jmt))
      allocate( dxtdeg(imt), dytdeg(jmt), dxudeg(imt), dyudeg(jmt))
      allocate( dxt(imt), dyt(jmt), dxu(imt), dyu(jmt))
      allocate( zt(km),zw(km),dzt(km),dzw(0:km) )
      
      read (io) (dxtdeg(i),i=1,imt)
     &,         (dytdeg(j),j=1,jmt)
     &,         (dxudeg(i),i=1,imt)
     &,         (dyudeg(j),j=1,jmt)
     &,         (dzt(k),k=1,km)
     &,         (dzw(k),k=0,km)
     &,         (xt(i),i=1,imt)
     &,         (xu(i),i=1,imt)
     &,         (yt(j),j=1,jmt)
     &,         (yu(j),j=1,jmt)
     &,         (zt(k),k=1,km)
     &,         (zw(k),k=1,km)

      do j=1,jmt
        dyt(j) = dytdeg(j)*degtcm
        dyu(j) = dyudeg(j)*degtcm
      enddo
      do i=1,imt
        dxt(i) = dxtdeg(i)*degtcm
        dxu(i) = dxudeg(i)*degtcm
      enddo

      close (io)

      allocate( kmt(imt,jmt), kmu(imt,jmt) )
      print*,
     & ' =>Reading a "kmt" field from binary file kmt.dta'
      call getunit (io, 'kmt.dta', 'usr ieee')
      read (io) ! no checks
c       skip header record and read dimensional info
      read (io) 
      read (io) i, j, k
      read (io) 
      read (io) kmt
      close(io)

      kmu=0
      do j=1,jmt-1
        do i=1,imt-1
           kmu(i,j) = min (kmt(i,j), kmt(i+1,j), 
     &                         kmt(i,j+1), kmt(i+1,j+1))
        enddo
      enddo

#ifdef partial_cell
      allocate( htp(imt,jmt), hup(imt,jmt) )
      allocate( dht(imt,km,jmt), dhu(imt,km,jmt) )

      print*,
     & ' =>Reading a "htp" field from binary file htp.dta'
      call getunit (io, 'htp.dta', 'usr ieee')
      read (io) ! no checks
c       skip header record and read dimensional info
      read (io) 
      read (io) i, j, k
      read (io) 
      read (io) htp
      close(io)

      hup=0.
      do j=1,jmt-1
        do i=1,imt-1
          hup(i,j) = min( htp(i,j),htp(i+1,j),htp(i,j+1),htp(i+1,j+1))
	enddo
      enddo

      do k=1,km
       dht(:,k,:)=dzt(k)
       dhu(:,k,:)=dzt(k)
      enddo

      do j=1,jmt
	do i=1,imt
	  kb = kmt(i,j)
	  if (kb .gt. 1) then
	    dht(i,kb,j) = htp(i,j) - zw(kb-1)
	  endif
	enddo
      enddo
c

      do j=1,jmt-1
        do k=1,km
          do i=1,imt-1
	    dhu(i,k,j) = min(dht(i,k,j), dht(i+1,k,j), dht(i,k,j+1)
     &,                      dht(i+1,k,j+1))
	  enddo
          dhu(1,k,j)   = dht(1,k,j)
          dhu(imt,k,j) = dht(imt,k,j)
	enddo
      enddo
#endif

      end subroutine read_grid



      subroutine dvcdf_here(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      use kind_mod
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character*(*) name, unit
      real (kind=r_knd):: spval
#include "netcdf.inc"
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
#ifdef real_8
      iret=nf_put_att_double(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_double(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#else
      iret=nf_put_att_real(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_real(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#endif
c        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf_here


      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"


       module npzd_averages_module
c
c=======================================================================
c      perform averages of NPZD model
c      and write to NetCDF 
c      SPFLAME version:   c.eden
c=======================================================================
c
c      local cpp directives:
c
       implicit none
       real, allocatable, dimension(:,:,:) :: dnutmean
       real, allocatable, dimension(:,:,:) :: dco2mean
       real, allocatable, dimension(:,:) :: pco2_mean,o2_mean
       real :: airco2_mean
       integer :: counter 
       end module npzd_averages_module


       subroutine init_npzd_averages
       use spflame_module
       use npzd_averages_module
       implicit none
       if (my_pe==0) print*,' initialising NPZD diagnostic averages'
       allocate( dnutmean(is_pe:ie_pe,km,js_pe:je_pe) )
       allocate( dco2mean(is_pe:ie_pe,km,js_pe:je_pe) )
       allocate( pco2_mean(is_pe:ie_pe,js_pe:je_pe) ); pco2_mean=0.
       allocate( o2_mean(is_pe:ie_pe,js_pe:je_pe) ); o2_mean=0.
       airco2_mean=0.0; dnutmean=0.; dco2mean=0.; pco2_mean=0.
       o2_mean=0.; counter=0
       call read_unfinished_npzd_averages()
       if (my_pe==0) 
     &         print*,' done initialising NPZD diagnostic averages'
       end subroutine init_npzd_averages


       subroutine npzd_averages
       use spflame_module
       use npzd_averages_module
       use passive_tracer_module
       use npzd_module
       implicit none
       integer :: i,k,j

       if (.not. eulerback1 ) then
         counter=counter+1
         dnutmean=dnutmean+
     &         dnut_diag(is_pe:ie_pe,1:km,js_pe:je_pe)*redfield_CN
         if (enable_co2) then
          do j=js_pe,je_pe
           do k=1,km
            do i=is_pe,ie_pe
            dco2mean(i,k,j)=dco2mean(i,k,j)+
     &            (t(i,k,j,n_co2,taup1)-t(i,k,j,n_co2,taum1) )/c2dt
            enddo
           enddo
          enddo
         endif
         pco2_mean(is_pe:ie_pe,js_pe:je_pe)= 
     &       pco2_mean(is_pe:ie_pe,js_pe:je_pe)+
     &       pco2_water(is_pe:ie_pe,js_pe:je_pe)
         airco2_mean = airco2_mean + pco2_air
         o2_mean(is_pe:ie_pe,js_pe:je_pe)= 
     &       o2_mean(is_pe:ie_pe,js_pe:je_pe)
     &      +o2_sat(is_pe:ie_pe,js_pe:je_pe)
       endif ! eulerback1
       if (end_of_month) then
         call write_npzd_averages_cdf()
         counter=0 ; dnutmean=0.; dco2mean=0.
         pco2_mean=0.0; airco2_mean = 0.0; o2_mean=0.0
       endif
       if (last_time_step) call write_unfinished_npzd_averages()
       end subroutine npzd_averages


       subroutine write_unfinished_npzd_averages()
       use spflame_module
       use npzd_averages_module
       implicit none
       character (len=80) :: name,ident
       integer i,j,k,io,n,is,ie,js,je
       real, allocatable ::  buf(:,:)

       is=is_pe; ie=ie_pe; js=js_pe; je=je_pe
       write(name,'("npzd_averages_",i3,".dta")') sub_domain
       do i=1,len_trim(name); if (name(i:i) == ' ') name(i:i)='0'; enddo

       if (my_pe==0) then
        print*,''
        print*,' writing  NPZD unfinished averages to file ',
     &          name(1:len_trim(name))
        call get_free_iounit(io)
        open(io,file=name,form='unformatted',status='unknown')
        write(io) counter
       endif

       allocate( buf(imt,jmt) )

       ident = 'dnut'
       if (my_pe==0) write(io) ident
       do k=1,km
        buf(is:ie,js:je)=dnutmean(is:ie,k,js:je)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
       enddo

       ident = 'dco2'
       if (my_pe==0) write(io) ident
       do k=1,km
        buf(is:ie,js:je)=dco2mean(is:ie,k,js:je)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
       enddo

       ident = 'pco2_water'
       if (my_pe==0) write(io) ident
       buf(is:ie,js:je)=pco2_mean(is:ie,js:je)
       call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
       if (my_pe==0) write(io) airco2_mean

       ident = 'o2_sat'
       if (my_pe==0) write(io) ident
       buf(is:ie,js:je)=o2_mean(is:ie,js:je)
       call pe0_recv_2D(buf); if (my_pe==0) write(io) buf

       if (my_pe==0) close(io)
       deallocate( buf )
       end subroutine write_unfinished_npzd_averages


       subroutine read_unfinished_npzd_averages()
       use spflame_module
       use npzd_averages_module
       implicit none
       character (len=80) :: name,ident
       integer i,j,k,io,n,is,ie,js,je
       real, allocatable ::  buf(:,:)
       logical :: ok

       is=is_pe; ie=ie_pe; js=js_pe; je=je_pe
       write(name,'("npzd_averages_",i3,".dta")') sub_domain
       do i=1,len_trim(name); if (name(i:i) == ' ') name(i:i)='0'; enddo

       if (my_pe==0) then
        print*,''
        print*,' reading NPZD averages from file ',
     &          name(1:len_trim(name))
       endif

       call get_free_iounit(io)
       open(io,file=name,form='unformatted',status='old',err=200)
       read(io) counter
       allocate( buf(imt,jmt) )

 10    ident=''; ok = .true.
       if (my_pe==0) then 
        read(io,end=20) ident
        goto 30
 20     ok = .false.
 30     continue
       endif
       call bcast_logical(ok,1,0)
       call bcast_char(ident,80,0)

       if (ident(1:4) == 'dnut') then

        do k=1,km
         if (my_pe==0) read(io) buf
         call pe0_send_2D(buf)
         dnutmean(is:ie,k,js:je)=buf(is:ie,js:je)
        enddo

       elseif (ident(1:4) == 'dco2' ) then

        do k=1,km
         if (my_pe==0) read(io) buf
         call pe0_send_2D(buf)
         dco2mean(is:ie,k,js:je)=buf(is:ie,js:je)
        enddo

       elseif (ident(1:10) == 'pco2_water' ) then

        if (my_pe==0) read(io) buf; call pe0_send_2D(buf)
        pco2_mean(is:ie,js:je)=buf(is:ie,js:je)
        if (my_pe==0) read(io) airco2_mean
        call bcast_real(airco2_mean,1,0)

       elseif (ident(1:6) == 'o2_sat' ) then
        if (my_pe==0) read(io) buf; call pe0_send_2D(buf)
        o2_mean(is:ie,js:je)=buf(is:ie,js:je)

       else
         if (my_pe==0) print*,' cannot read ',ident,' in ',name
       endif
       if (ok) goto 10  ! read next item til end of file

       close(io)
       if (my_pe==0) then
        print*,' done '
        print*,''
       endif
       deallocate( buf )
       return

 200   if (my_pe==0) then
        print*,''
        print*,'---------------------------------------------'
        print*,' WARNING : cannot read file ',name(1:len_trim(name))
        print*,'---------------------------------------------'
        print*,''
       endif

       end subroutine read_unfinished_npzd_averages


       subroutine write_npzd_averages_cdf()
       use spflame_module
       use npzd_averages_module
       implicit none
#ifdef netcdf_diagnostics
c
c      write averaged quantities to a nice NetCDF file
c
       character (len=80) :: fname,name,unit
       integer :: year,month,day
#include "netcdf.inc"
       integer :: ncid,iret,i,j,k,dims(4),start(4),count(4)
       real    :: spval=-9.9e12, tt
       integer :: lon_tdim,lon_tid,lon_udim,lon_uid
       integer :: lat_tdim,lat_tid,lat_udim,lat_uid
       integer :: depth_tdim,depth_tid,depth_wdim,depth_wid
       integer :: itimedim,itimeid,dnutid,npe,n,dco2id
       integer :: pco2_id,o2_id,airco2_id
       integer :: is,ie,js,je
#ifdef netcdf_real4
      real (kind=4) :: var(is_pe:ie_pe,js_pe:je_pe)
      real (kind=4) , allocatable :: v2(:)
#else
      real          :: var(is_pe:ie_pe,js_pe:je_pe)
      real          , allocatable :: v2(:)
#endif

       is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

       year  = get_year(get_current_time())
       month = get_month_of_year(get_current_time())
       day   = get_day_of_month(get_current_time())
       write(fname,'("npzd_averages_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            sub_domain,year,month,day
       do i=1,len_trim(fname);if (fname(i:i)==' ')fname(i:i)='0';enddo

       if (my_pe == 0) then
        print*,' Writing NPZD averages to  NetCDF output file ',
     &         fname(1:len_trim(fname))
        ncid = nccre (fname, NCCLOB, iret)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        call store_info_cdf(ncid)
c       dimensions
        lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
        Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
        Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
        Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
        depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
        depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
        iTimedim  = ncddef(ncid, 'Time', 1, iret)
c       grid variables
        dims(1)  = Lon_tdim
        Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
        dims(1)  = Lon_udim
        Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
        dims(1)  = Lat_tdim
        Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
        dims(1)  = Lat_udim
        Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
        dims(1)  = iTimedim
        iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
        dims(1)  = depth_wdim
        depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
        dims(1)  = depth_tdim
        depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c       attributes of the grid
        name = 'Longitude on T grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Longitude on U grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on T grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on U grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Depth of T Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
        call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
        name = 'Depth of W Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
        call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
        name = 'Time                    '; unit = 'days            '
        call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
        call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c       variables
        dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
        dnutid=ncvdef (ncid,'dnut', NCFLOAT,4,dims,iret)
        dco2id=ncvdef (ncid,'dco2', NCFLOAT,4,dims,iret)

        dims=(/lon_tdim,lat_tdim,itimedim,1/)
        pco2_id=ncvdef (ncid,'pco2_water', NCFLOAT,3,dims,iret)
        dims=(/itimedim,1,1,1/)
        airco2_id=ncvdef (ncid,'pco2_air', NCFLOAT,1,dims,iret)
        dims=(/lon_tdim,lat_tdim,itimedim,1/)
        o2_id=ncvdef (ncid,'o2_sat', NCFLOAT,3,dims,iret)
c       attributes of variables
        name = 'Nutrient consumption of DIC'; unit = 'mmol/m^3/s'
        call dvcdf(ncid,dnutid,name,len_trim(name),
     &                 unit,len_trim(unit),spval)
        name = 'Total change of DIC'; unit = 'mmol/m^3/s'
        call dvcdf(ncid,dco2id,name,len_trim(name),
     &                 unit,len_trim(unit),spval)
        name = 'Sea surface CO2 partial pressure'; unit = 'ppmv'
        call dvcdf(ncid,pco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
        name = 'Atmospheric CO2 partial pressure'; unit = 'ppmv'
        call dvcdf(ncid,airco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
        name = 'Sea surface O2 saturation concentration'; 
        unit = 'mol/m^3'
        call dvcdf(ncid,o2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)

c       global attrubutes
        iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        call ncendf(ncid, iret)
c       write grid
        allocate( v2(max(imt,jmt,km)) )
        v2(1:imt)=xt
        call ncvpt(ncid, Lon_tid, 1, imt,v2, iret)
        v2(1:imt)=xu
        call ncvpt(ncid, Lon_uid, 1, imt,v2, iret)
        v2(1:jmt)=yt
        call ncvpt(ncid, Lat_tid, 1, jmt,v2, iret)
        v2(1:jmt)=yu
        call ncvpt(ncid, Lat_uid, 1, jmt,v2, iret)
        v2(1:km)=zt/100.
        call ncvpt(ncid, depth_tid, 1, km,v2, iret)
        v2(1:km)=zw/100.
        call ncvpt(ncid, depth_wid, 1, km,v2, iret)
        call read_stamp(current_stamp,tt ); v2(1)=tt
        call ncvpt(ncid, itimeid, 1, 1,v2, iret)
        deallocate(v2)
        call ncclos (ncid, iret)
       endif ! my_pe == 0

c      loop over PEs
       do npe=0,n_pes
        call barrier
        if (my_pe==npe) then
         iret=nf_open(fname,NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         iret=nf_inq_varid(ncid,'dnut',dnutid)
         iret=nf_inq_varid(ncid,'dco2',dco2id)
         iret=nf_inq_varid(ncid,'pco2_water',pco2_id)
         iret=nf_inq_varid(ncid,'pco2_air',airco2_id)
         iret=nf_inq_varid(ncid,'o2_sat',o2_id)

c        divide with number of averaged time steps 
         dnutmean=dnutmean/counter
         dco2mean=dco2mean/counter
c        convert to SI units
c        apply land mask
         where( tmask(is:ie,1:km,js:je) == 0. ) dnutmean(:,:,:) = spval
         where( tmask(is:ie,1:km,js:je) == 0. ) dco2mean(:,:,:) = spval
         pco2_mean=pco2_mean/counter
         airco2_mean=airco2_mean/counter
         where(tmask(is:ie,1,js:je)==0.) pco2_mean(is:ie,js:je) = spval
         o2_mean=o2_mean/counter
         where(tmask(is:ie,1,js:je)==0.) o2_mean(is:ie,js:je) = spval
         ! write PE domain to file
         do k=1,km
          start=(/is,js,k,1/); count=(/ie-is+1,je-js+1,1,1/)
          var=dnutmean(:,k,:)
          iret= nf_put_vara_real (ncid,dnutid,start,count,var )
          var=dco2mean(:,k,:)
          iret= nf_put_vara_real (ncid,dco2id,start,count,var )
         enddo
         var(is:ie,js:je)=pco2_mean(is:ie,js:je)
         start=(/is,js,1,1/); count=(/ie-is+1,je-js+1,1,1/)
         iret= nf_put_vara_real (ncid,pco2_id,start,count,var )
         var(is,js)=airco2_mean
         iret= nf_put_vara_real(ncid,airco2_id,1,1,var(is,js) )
         var=o2_mean(:,:)
         start=(/is,js,1,1/); count=(/ie-is+1,je-js+1,1,1/)
         iret= nf_put_vara_real (ncid,o2_id,start,count,var )
         call ncclos (ncid, iret)
        endif
        call barrier
       enddo
       if (my_pe==0) then
        print*,'done'
       endif
#endif
      end subroutine write_npzd_averages_cdf

#include "options.inc"


      subroutine stab
      use spflame_module
      implicit none
      real tdig,cflcrt,epsln
      integer maxcfl,i,j,k,numcfl,io
      real cl,cosur,f1,f2,f3
      real cflu,cflv,cflwu,cflwt
      real umax,vmax,wmax
      real pcflu,pcflv,pcflwu,pcflwt
      integer is,ie,js,je,ks,ke,kk


      real :: ramb,rahb,rame,ramn,rahe,rahn
      real :: reyx,reyy,reyz
      real :: reynx=0.,reyny=0.,reynz=0.
      real :: reynu,reynv,reynw
      real :: reynmu,reynmv,reynmw
      integer :: ireynx,jreynx,kreynx
      integer :: ireyny,jreyny,kreyny
      integer :: ireynz,jreynz,kreynz
      real :: pecx,pecy,pecz
      real :: peclx=0.,pecly=0.,peclz=0.
      real :: peclu,peclv,peclw
      real :: peclmu,peclmv,peclmw
      integer :: ipeclx,jpeclx,kpeclx
      integer :: ipecly,jpecly,kpecly
      integer :: ipeclz,jpeclz,kpeclz

c-----------------------------------------------------------------------
c     test for various measures of stability  
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c     SPFLAME version : c.eden
c-----------------------------------------------------------------------
c

      tdig     = 1.e-4
      cflcrt   = 1.5
      maxcfl   = 3
      epsln=1e-12
      io=6

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c      Checking vertical diffusive criteria
c-----------------------------------------------------------------------
c
      do j=js,je
       do k=1,km
        do i=is,ie
         if (.not. enable_implicit_vert_fric) then
          if ((dt*visc_cbu(i,k,j))/dzt(k)**2 >= .25) 
     &     print*,' vertical diffusive criterium for momentum ',
     &      'exceeded at (i,j,k)=',i,j,k,' visc_cbu(i,k,j)*dt/dz^2=',
     &      visc_cbu(i,k,j)*dt/dzt(k)**2,' use implicit vertical mixing'
         endif
         if (.not. enable_implicit_vert_diff) then
          if ((dt*diff_cbt(i,k,j))/dzt(k)**2 >= .25) 
     &     print*,' vertical diffusive criterium for tracer ',
     &      'exceeded at (i,j,k)=',i,j,k,' diff_cbt(i,k,j)*dt/dz^2=',
     &      diff_cbt(i,k,j)*dt/dzt(k)**2,' use implicit vertical mixing'
         endif
        enddo
       enddo
      enddo
c
c-----------------------------------------------------------------------
c     scan for CFL violations. save locations of closest approach to
c     local CFL limit.
c-----------------------------------------------------------------------
c
      do j=js,je
       cl = cflcrt * 0.5
       cosur = max(csur(j),epsln)
       do k=1,km
        f1    = dt*dyur(j)
        f2    = dt*dzwr(k)
	f3    = dt*cosur
        do i=is,ie
          cflu  = abs(f3*dxur(i)*u(i,k,j,1,tau))
          cflv  = abs(f1*u(i,k,j,2,tau))
          cflwu = abs(f2*adv_vbu(i,k,j))*umask(i,k,j)
          cflwt = abs(f2*adv_vbt(i,k,j))*tmask(i,k,j)
          if (cflu .ge. cl .or. cflv .ge. cl .or. cflwu .ge. cl .or.
     &        cflwt .ge. cl) then
c          if (cflu .ge. cl .or. cflv .ge. cl) then
            umax  = 0.5*csu(j)*dxu(i)/dt
            pcflu = abs(100.0*u(i,k,j,1,tau)/umax)
            vmax  = 0.5*dyu(j)/dt
            pcflv = abs(100.0*u(i,k,j,2,tau)/vmax)
            wmax  = 0.5*dzw(k)/dt
            pcflwu= abs(100.0*adv_vbu(i,k,j)/wmax)
            pcflwt= abs(100.0*adv_vbt(i,k,j)/wmax)
            write (io,
     &  '(/,a,i4,a1,i3,a1,i3,a13,f6.3,/,4(/,a,f8.2,a,g15.8,a,/))')
     &       ' ==> CFL exceeded at coordinate (i,j,k) = (',i,
     &      ',',j,',',k,') by factor =',cflcrt,
     &       ' u reached   ', pcflu,' % of the CFL limit (',umax,')',
     &       ' v reached   ', pcflv,' % of the CFL limit (',vmax,')',
     &     ' adv_vbu reached', pcflwu,' % of the CFL limit (',wmax,')',
     &     ' adv_vbt reached', pcflwt,' % of the CFL limit (',wmax,')'
          endif
        enddo
      enddo

#ifdef notdef
      do k=1,km
        vmax  = 0.5*dyu(j)/dt
        wmax  = 0.5*dzw(k)/dt
        do i=is,ie
          umax  = 0.5*csu(j)*dxu(i)/dt
          if (abs(100.0*u(i,k,j,1,tau)/umax) .gt. cflup) then
            cflup = abs(100.0*u(i,k,j,1,tau)/umax)
            cflum = u(i,k,j,1,tau)
            icflu = i
            jcflu = j
            kcflu = k
          endif
          if (abs(100.0*u(i,k,j,2,tau)/vmax) .gt. cflvp) then
            cflvp = abs(100.0*u(i,k,j,2,tau)/vmax)
            cflvm = u(i,k,j,2,tau)
            icflv = i
            jcflv = j
            kcflv = k
          endif
          if (abs(100.0*umask(i,k,j)*adv_vbu(i,k,j)/wmax) .gt. cflwup)
     &      then
            cflwup = abs(100.0*adv_vbu(i,k,j)/wmax)
            cflwum = adv_vbu(i,k,j)
            icflwu = i
            jcflwu = j
            kcflwu = k
          endif
          if (abs(100.0*tmask(i,k,j)*adv_vbt(i,k,j)/wmax) .gt. cflwtp)
     &      then
            cflwtp = abs(100.0*adv_vbt(i,k,j)/wmax)
            cflwtm = adv_vbt(i,k,j)
            icflwt = i
            jcflwt = j
            kcflwt = k
          endif
       enddo
      enddo
#endif
      enddo

c
c-----------------------------------------------------------------------
c     look for max peclet numbers using velocities at "tau".
c     look for max reynolds numbers using velocities at "tau".
c-----------------------------------------------------------------------
c

      do j=js,je
       do k=1,km
        do i=is,ie
	  ramb = 1./(visc_cbu(i,k,j) + epsln)
	  rahb = 1./(diff_cbt(i,k,j) + epsln)
          rame = 1./(am*am_scale(i,j)+ epsln)
          ramn = 1./(am*am_scale(i,j)+ epsln)
          rahe = 1./(ah*ah_scale(i,j)+ epsln)
          rahn = 1./(ah*ah_scale(i,j)+ epsln)

          reyx = abs(u(i,k,j,1,tau)*dxu(i))*rame
          if (reyx .gt. reynx) then
            ireynx = i ; jreynx = j ; kreynx = k
            reynx  = reyx
            reynu  = u(i,k,j,1,tau)
            reynmu = 1./rame
          endif
          reyy = abs(u(i,k,j,2,tau)*dyu(j))*ramn
          if (reyy .gt. reyny) then
            ireyny = i ; jreyny = j ; kreyny = k
            reyny  = reyy
            reynv  = u(i,k,j,2,tau)
            reynmv = 1./ramn
          endif
	  kk = min(k+1,km)
	  if (k .ge. kmu(i,j)) then
	    reyz = 0.
	  else 
            reyz =umask(i,kk,j)*abs(adv_vbu(i,k,j)*dzw(k))*ramb
          endif
	  if (reyz .gt. reynz) then
            ireynz = i ; jreynz = j ; kreynz = k
            reynz  = reyz
            reynw  = adv_vbu(i,k,j)
            reynmw = 1./ramb
          endif


          pecx = abs(u(i,k,j,1,tau)*dxu(i))*rahe
          if (pecx .gt. peclx) then
            ipeclx = i ; jpeclx = j ; kpeclx = k
            peclx  = pecx
            peclu  = u(i,k,j,1,tau)
            peclmu = 1./rahe
          endif
          pecy = abs(u(i,k,j,2,tau)*dyu(j))*rahn
          if (pecy .gt. pecly) then
            ipecly = i ; jpecly = j ; kpecly = k
            pecly  = pecy
            peclv  = u(i,k,j,2,tau)
            peclmv = 1./rahn
          endif
	  kk = min(k+1,km)
	  if (k .ge. kmt(i,j)) then
	    pecz = 0.0
	  else 
            pecz =tmask(i,kk,j)*abs(adv_vbt(i,k,j)*dzw(k))*rahb
          endif
	  if (pecz .gt. peclz) then
            ipeclz = i ; jpeclz = j ; kpeclz = k
            peclz  = pecz
            peclw  = adv_vbt(i,k,j)
            peclmw = 1./rahb
          endif
        enddo
       enddo
      enddo

#ifdef notdef
      print*,' max x-Pecl.# for PE=',my_pe,' at (i,j,k)=(',
     &       ipeclx,jpeclx,kpeclx,') = ',peclx
      print*,' max y-Pecl.# for PE=',my_pe,' at (i,j,k)=(',
     &       ipecly,jpecly,kpecly,') = ',pecly
      print*,' max z-Pecl.# for PE=',my_pe,' at (i,j,k)=(',
     &       ipeclz,jpeclz,kpeclz,') = ',peclz

      print*,' max x-Reyn.# for PE=',my_pe,' at (i,j,k)=(',
     &       ireynx,jreynx,kreynx,') = ',reynx
      print*,' max y-Reyn.# for PE=',my_pe,' at (i,j,k)=(',
     &       ireyny,jreyny,kreyny,') = ',reyny
      print*,' max z-Reyn.# for PE=',my_pe,' at (i,j,k)=(',
     &       ireynz,jreynz,kreynz,') = ',reynz
#endif

#ifdef notdef
c
c-----------------------------------------------------------------------
c     look for ficticious creation of local extremum for tracers
c     by finding local min and max tracer at "tau" and comparing to
c     tracer at "tau+1"
c-----------------------------------------------------------------------
c
      call getunit (iostab, 'iostab', 'fsa')
      ks = max(2,kscfl)
      ke = min(km-1,kecfl)
      is = max(2,iscfl)
      ie = min(imt-1,iecfl)
      do n=1,nt
        do k=ks,ke
          do i=is,ie
	    if (tmask(i,k,j) .ne. c0) then
	      tbig = max(t(i,k,j,n,tau),t(i,k,j,n,taum1))
	      tsml = min(t(i,k,j,n,tau),t(i,k,j,n,taum1))
	      do jj=j-1,j+1,2
	        if (tmask(i,k,jj) .ne. c0) then
		  tbig = max(tbig,t(i,k,jj,n,tau),t(i,k,jj,n,taum1))
		  tsml = min(tsml,t(i,k,jj,n,tau),t(i,k,jj,n,taum1))
		endif
	      enddo
c
	      do ii=i-1,i+1,2
	        if (tmask(ii,k,j) .ne. c0) then
		  tbig = max(tbig,t(ii,k,j,n,tau),t(ii,k,j,n,taum1))
		  tsml = min(tsml,t(ii,k,j,n,tau),t(ii,k,j,n,taum1))
		endif
	      enddo
c
	      do kk=k-1,k+1,2
	        if (tmask(i,kk,j) .ne. c0) then
		  tbig = max(tbig,t(i,kk,j,n,tau),t(i,kk,j,n,taum1))
		  tsml = min(tsml,t(i,kk,j,n,tau),t(i,kk,j,n,taum1))
		endif
	      enddo
c
              tcrit = tdig*abs(t(i,k,j,n,taup1))
              if (tmask(i,k,j) .ne. c0 .and. 
     &          ((t(i,k,j,n,taup1) .gt. tbig + tcrit)
     &	        .or. (t(i,k,j,n,taup1) .lt. tsml - tcrit))) then
		write (iostab,'(i4, i4, i4, i2, 3g14.7)')
     &           i, k, j, n, t(i,k,j,n,taup1), tsml, tbig
              endif
	    endif
	  enddo
	enddo
      enddo
      close (iostab)
#endif
c      
9100  format(1x,a12,1x,'ts=',i10,1x,',j=',i3,', lat=',f6.2
     &,', lon:',f6.2,' ==> ',f6.2,', depth(m):',f6.1,' ==> ',f6.1
     &,', scaling=',1pg10.3)
      end subroutine stab

#include "options.inc"
c
c ------------------------------------------------------
c     templates to read climatology of temperature/salinity
c     and other tracers from external files used for initial
c     conditions, open boundaries and sponge layers.
c
c     Notes:
c      temperature should be potential temperature in
c      deg C, salinity in (psu-35)/1000.
c      Two subroutines are defined:
c       "read_dims_ic" and "read_ic" both called
c      in prep_ic (in prep_main.F).
c      Header of subroutines should not be touched.
c      CPP directives are set in prep_template.F
c
c                            c.eden  nov 2002
c ------------------------------------------------------
c


#ifdef read_ic_from_LEV94
c
c ------------------------------------------------------
c    read from WOA94 (Levitus 94)
c    (given as monthly means for T and S)
c ------------------------------------------------------
c
      subroutine read_dims_ic(nx,ny,nz,nt)
      implicit none
#include "netcdf.inc"
      integer nx,ny,nz,nt
      integer  ncid,iret,rid,ndims,latid,lonid
      integer dims(4)
      character (len=80) :: infile ='data/WOA94/lev94.cdf'
      print*,' reading T/S climatology from file ',
     &      infile(1:len_trim(infile))
      iret=nf_open(infile, NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'temp',rid)
      iret=NF_INQ_VARNDIMS(NCID, rid, ndims)  
      if (ndims/=4) then
       print*,' number of dimensions for variable not equal 4'
       call halt_stop(' in read_dims_ic (LEV94)')
      endif
      iret=NF_INQ_VARDIMID (NCID,rid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nz)
      iret=NF_INQ_DIMLEN (NCID, DIMs(4), nt)
      call ncclos (ncid, iret)
      end subroutine read_dims_ic


      subroutine read_ic(nx,ny,nz,ntr,nt,x,y,z,tr,spval)
      implicit none
      integer nx,ny,nz,nt,ntr
      real x(nx),y(ny),tr(nx,ny,nz,ntr),z(nz)
      real spval
#include "netcdf.inc"
      integer  ncid,iret,latid,lonid,tid,sid,zid,n
      integer  dims(4),corner(4),edges(4)
#ifdef netcdf_real4
      real (kind=4) :: v4(nx,ny,nz) ,x4(nx),y4(ny),z4(nz),sp
#else
      real :: v4(nx,ny,nz) ,x4(nx),y4(ny),z4(nz),sp
#endif
      integer :: indp,i,j,k,ii,jj,kk
      real :: fxa, fxb
      character*80 dname
      character (len=80) :: infile = 'data/WOA94/lev94.cdf'
      iret=nf_open(infile, NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'temp',tid)
      iret=nf_inq_varid(ncid,'salt',sid)
      iret=NF_INQ_VARDIMID (NCID,tid,DIMS)
      dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
      iret=nf_inq_varid(ncid,dname,lonid)
      dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
      iret=nf_inq_varid(ncid,dname,latid)
      dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(3),dname) 
      iret=nf_inq_varid(ncid,dname,zid)
      corner=1; edges(1)=nx; 
      iret= nf_get_vara_real (ncid,lonid ,corner,edges,x4); x=x4
      corner=1; edges(1)=ny; 
      iret= nf_get_vara_real (ncid,latid ,corner,edges,y4); y=y4
      corner=1; edges(1)=nz; 
      iret= nf_get_vara_real (ncid,zid ,corner,edges,z4); z=z4
      tr=0. ! setting all other tracers to zero
      corner=(/1,1,1,nt/); edges=(/nx,ny,nz,1/)
      iret= nf_get_vara_real (ncid,tid ,corner,edges,v4)
      iret= nf_get_att_real (ncid,tid ,'missing_value',sp)
      where( v4 == sp) v4 = -1000.0
      tr(:,:,:,1)=v4
      where( tr(:,:,:,1) <= -1000.0) tr(:,:,:,1) = spval
      iret= nf_get_vara_real (ncid,sid ,corner,edges,v4)
      iret= nf_get_att_real (ncid,sid ,'missing_value',sp)
c   apply special values, convert to cgs units
      where( v4 == sp) v4 = -1000.0
      tr(:,:,:,2)=v4
      where( tr(:,:,:,2) <= -1000.0 ) tr(:,:,:,2) = spval
      where( tr(:,:,:,2) /= spval) 
     &             tr(:,:,:,2) = (tr(:,:,:,2)-35.)/1000
      call ncclos (ncid, iret)

#ifdef  prep_for_CFC
c    initial condition is just zero
#endif
#ifdef  prep_for_LEDWELL
      if (ntr>=3) then
       print*,' constructing artificial initial conditions for tracer3'
       print*,' not yet implimented for LEV94'
       stop
      endif
#endif
#ifdef prep_for_OBC_tracer
      if (ntr>=3) then
       print*,' constructing initial conditions for tracer3'
       print*,' not yet implimented for LEV94'
       stop
      endif
#endif
#ifdef  prep_for_NPZD
      if (ntr>=3) then
       print*,' constructing initial conditions for tracer3'
       tr(:,:,:,4)=1e-2  ! phyto plankton
       tr(:,:,:,5)=1e-2  ! zoo
       tr(:,:,:,6)=1e-2  ! detritus
       print*,' reading nitrate from file data/WOA98/no3_annual.nc'
       iret=nf_open('data/WOA98/no3_annual.nc',NF_nowrite,ncid)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=nf_inq_varid(ncid,'NO3',tid)
       v4=-99.9
       corner=(/1,1,1,1/); edges=(/nx-2,ny,nz,1/)
       iret= nf_get_vara_real (ncid,tid ,corner,edges,v4(2:nx-1,:,:))
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       tr(:,:,:,3)=v4
       where( tr(:,:,:,3) <= -99.9) tr(:,:,:,3) = spval
       call ncclos (ncid, iret)
c    limit nitrate to prevent spurious biological production
c    in restoring zones like the open boundary
       do k=1,nz
        do j=1,ny
          do i=1,nx
            if ( tr(i,j,k,3) <= 5.0 .and. tr(i,j,k,3)>=-1.0 ) then
                tr(i,j,k,3)=0.0
            endif
          enddo
        enddo
       enddo

       if (ntr >= 7) then
c       dissolved inorganic carbon
        print*,' reading DIC from data/GLODAP/glodap_dic.cdf'
        iret=nf_open('data/GLODAP/glodap_dic.cdf',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'ALK',tid)
        iret= nf_get_att_real (ncid,tid ,'missing_value',sp)
        v4=sp
        corner=(/1,1,1,1/); edges=(/nx-181+1,ny,nz,1/)
        iret= nf_get_vara_real (ncid,tid ,corner,edges,v4(181:nx,:,:))
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        corner=(/181,1,1,1/); edges=(/180,ny,nz,1/)
        iret= nf_get_vara_real (ncid,tid ,corner,edges,
     &                   v4(1:180,:,:))
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        where( v4 == sp) v4 = -1000.0
        tr(:,:,:,7)=v4
        where( tr(:,:,:,7) <= -1000.0) tr(:,:,:,7) = spval
        call ncclos (ncid, iret)
       endif

       if (ntr >= 8) then
c       total dissolved oxygen
        print*,' reading O2 from WOA98/oxygen_annual.nc'
        iret=nf_open('data/WOA98/oxygen_annual.nc',NF_nowrite,ncid)
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        iret=nf_inq_varid(ncid,'O2',tid)
        v4=-99.9
        corner=(/1,1,1,1/); edges=(/nx-2,ny,nz,1/)
        iret= nf_get_vara_real (ncid,tid ,corner,edges,v4(2:nx-1,:,:))
        if (iret/=0) then; print*,nf_strerror(iret);stop;endif
        tr(:,:,:,8)=v4
        where( tr(:,:,:,8) <= -99.9) tr(:,:,:,8) = spval
        call ncclos (ncid, iret)
       endif

       if (ntr >= 9) then
c        DOC, not yet implemented
       endif
      endif
#endif

      end subroutine read_ic

#elif defined read_ic_from_LEV98

c ------------------------------------------------------
c   read from a combined WOA94 + WOA98 dataset.
c   the high resolution (1/4 deg) seasonal mean data of 
c   WOA98 was combined with the monthly mean temporal
c   resolution of WOA94.
c ------------------------------------------------------

      subroutine read_dims_ic(nx,ny,nz,nt)
      implicit none
      integer nx,ny,nz,nt
      character*32 stamp
      real  dpm
      integer io
      print*,' reading T/S climatology from WOA9497'
      call getunit(io,'data/WOA9497/ann.temp','usr ieee')
      read (io); read (io) stamp, dpm, nx, ny
      close(io)
      nt=12; nz=33
      end subroutine read_dims_ic


      subroutine read_ic(nx,ny,nz,ntr,nt,x,y,z,tr,spval)
      implicit none
      integer nx,ny,nz,nt,ntr,indp
      real x(nx),y(ny),tr(nx,ny,nz,ntr),z(nz)
      real spval,dpm
      integer n,k,l,io,i,j,is,ie,js,je,ks,ke
      character(len=3) :: month(12)
      character(len=32) :: stamp
      data month/'jan','feb','mar','apr',
     &  'may','jun','jul','aug','sep','oct','nov','dec'/
      print*,' reading T/S climatology from WOA9497'
       tr=0. ! setting all other tracers to zero
       call getunit(io,'data/WOA9497/ann.temp','usr ieee')
       do k=1,19
        read(io); read(io)
       enddo
       do k=20,nz
        read(io); read(io) stamp, dpm, l,l,l,l,l,x,y,z,tr(:,:,k,1)
       enddo
       close(io)
       call getunit(io,'data/WOA9497/ann.salt','usr ieee')
       do k=1,19
        read(io); read(io)
       enddo
       do k=20,nz
        read(io); read(io) stamp, dpm, l,l,l,l,l,x,y,z,tr(:,:,k,2)
       enddo
       close(io)
       call getunit(io,'data/WOA9497/'//month(nt)//'.temp','usr ieee')
       do k=1,19
        read(io); read(io) stamp, dpm, l,l,l,l,l,x,y,z,tr(:,:,k,1)
       enddo
       close(io)
       call getunit(io,'data/WOA9497/'//month(nt)//'.salt','usr ieee')
       do k=1,19
        read(io); read(io) stamp, dpm, l,l,l,l,l,x,y,z,tr(:,:,k,2)
       enddo
       close(io)
c    apply special values, convert to cgs units
       do k=1,nz; do j=1,ny; do i=1,nx
         if (tr(i,j,k,2) > -99.9) tr(i,j,k,2)=(tr(i,j,k,2)-35.0)/1000.0
       enddo; enddo; enddo
       z=z/100
       do k=1,nz; do j=1,ny; do i=1,nx
         if (tr(i,j,k,1) <= -99.9) then
           tr(i,j,k,1)=spval; tr(i,j,k,2)=spval
         endif
       enddo; enddo; enddo

c    other tracers:

#ifdef  prep_for_ACO2
c    initial condition is just zero
#endif
#ifdef  prep_for_CFC
c    initial condition is just zero
#endif
#ifdef  prep_for_LEDWELL
      if (ntr>=3) then
       print*,' constructing artificial initial conditions for tracer3'
       print*,' not yet implimented for WOA9498'
      endif
#endif
#ifdef prep_for_OBC_tracer
      if (ntr>=3) then
       print*,' constructing initial conditions for tracer3'
       print*,' just zeros, except for '
       tr(:,:,:,3:ntr)=0.0
c    at y = 11.9N:12.2N from 60W to 56W    tr=1
       is=indp(360.0-60.0,x,nx)
       ie=indp(360.0-56.0,x,nx)
       js=indp(11.9,y,ny)
       je=indp(15.0,y,ny)
       ks=indp(1000.0,z,nz)
       print*,'is,ie,js,je,ks = ',is,ie,js,je,ks
       tr(is:ie,js:je,ks:nz,3)=1.0
       print*,' okay'
      endif
#endif
#ifdef  prep_for_NPZD
      if (ntr>=3) then
       print*,' reading Nitrate from WOA98/ann.no3'
       call getunit(io,'data/WOA98/ann.no3','usr ieee')
       do k=1,nz
        read(io); read(io) stamp, dpm, l,l,l,l,l,x,y,z,tr(:,:,k,3)
       enddo
       close(io)
       tr(:,:,:,4)=1e-2  ! phyto plankton
       tr(:,:,:,5)=1e-2  ! zoo
       tr(:,:,:,6)=1e-2  ! detritus

c    limit nitrate to prevent spurious biological production
c    in restoring zones like the open boundary
       do k=1,nz
        do j=1,ny
          do i=1,nx
            if ( tr(i,j,k,3) <= 5.0 .and. tr(i,j,k,3)>=-1.0 ) then
                tr(i,j,k,3)=0.0
            endif
          enddo
        enddo
       enddo

c    at southern boundary, set biology to zero
c    otherwise it will leak into model domain by restoring
       print*,' special !!!!'
       tr(:,200:230,:,4:6) = 0.0

       if (ntr >= 7) then
c       dissolved inorganic carbon
c        print*,' reading DIC from FRIIS/ann.pre_dic'
c        call getunit(io,'data/FRIIS/ann.pre_dic','usr ieee')
c        print*,' reading DIC from GOYET/ann.tco2'
c        call getunit(io,'data/GOYET/ann.tco2','usr ieee')
        print*,' reading DIC from GLODAP/ann.pre_dic'
        call getunit(io,'data/GLODAP/ann.pre_dic','usr ieee')
        do k=1,nz
         read(io); read(io) stamp, dpm, l,l,l,l,l,x,y,z,
     &     ((tr(i,j,k,7),i=1,nx),j=1,ny)
         do j=1,ny
          do i=1,nx
            if (tr(i,j,k,7)<0.0) then
                tr(i,j,k,7)=-99.9
            elseif (tr(i,j,k,7)> 5000.0) then
                tr(i,j,k,7)=-99.9
            endif
          enddo
         enddo
        enddo
        close(io)
       endif
       if (ntr >= 8) then
c       total dissolved oxygen
        print*,' reading O2 from WOA98/ann.oxygen'
        call getunit(io,'data/WOA98/ann.oxygen','usr ieee')
        do k=1,nz
         read(io); read(io) stamp, dpm, l,l,l,l,l,x,y,z,tr(:,:,k,8)
        enddo
        close(io)
       endif
#ifdef  prep_for_ACO2
       if (ntr >= 9) then
c       dissolved inorganic carbon from fixed pco2_air
        print*,' reading CO2_C from GLODAP/ann.pre_dic'
        call getunit(io,'data/GLODAP/ann.pre_dic','usr ieee')
c        print*,' reading DIC from FRIIS/ann.pre_dic'
c        call getunit(io,'data/FRIIS/ann.pre_dic','usr ieee')
c        print*,' reading DIC from GOYET/ann.tco2'
c        call getunit(io,'data/GOYET/ann.tco2','usr ieee')
        do k=1,nz
         read(io); read(io) stamp, dpm, l,l,l,l,l,x,y,z,
     &     ((tr(i,j,k,9),i=1,nx),j=1,ny)
         do j=1,ny
          do i=1,nx
            if (tr(i,j,k,9)<0.0) then
                tr(i,j,k,9)=-99.9
            elseif (tr(i,j,k,9)> 5000.0) then
                tr(i,j,k,9)=-99.9
            endif
          enddo
         enddo
        enddo
        close(io)
       endif
#else
       if (ntr >= 9) then
c      dissolved organic carbon
         tr(:,:,:,9)=0.0
       endif
#endif
c      convert to cgs units
       z=z/100
c      apply special values
       do n=3,ntr; do k=1,nz; do j=1,ny; do i=1,nx
         if (tr(i,j,k,n) <= -99.9) tr(i,j,k,n)=spval
       enddo; enddo; enddo; enddo
      endif
#endif

      end subroutine read_ic




#elif defined read_ic_from_SAC

c ------------------------------------------------------
c   read from the SAC (Woce) climatology 
c    (annual mean only)
c    (note that the data comes as in situ temperature)
c ------------------------------------------------------

      subroutine read_dims_ic(nx,ny,nz,nt)
      implicit none
#include "netcdf.inc"
      integer nx,ny,nz,nt
      integer  ncid,iret,rid,ndims,latid,lonid
      integer dims(4)
      character (len=80) :: infile ='data/SAC/sac_wtso.cdf'
      print*,' reading T/S climatology from file ',
     &      infile(1:len_trim(infile))
      nt=12
      iret=nf_open(infile,NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'TEMP',rid)
      iret=NF_INQ_VARNDIMS(NCID, rid, ndims)  
      if (ndims/=3) then
       print*,' number of dimensions for variable not equal 3'
       print*,ndims
       call halt_stop(' in read_dims_ic (SAC)')
      endif
      iret=NF_INQ_VARDIMID (NCID,rid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), ndims); nx=ndims
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ndims); ny=ndims
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), ndims); nz=ndims
      call ncclos (ncid, iret)
      end subroutine read_dims_ic


      subroutine read_ic(nx,ny,nz,ntr,nt,x,y,z,tr,spval)
      implicit none
      integer nx,ny,nz,nt,ntr
      real x(nx),y(ny),tr(nx,ny,nz,ntr),z(nz)
      real spval, fxa
#include "netcdf.inc"
      integer  ncid,iret,latid,lonid,tid,sid,zid,n
      integer  dims(4),corner(4),edges(4),i,j,k
#ifdef netcdf_real4
      real (kind=4) :: v4(nx,ny,nz) ,x4(nx),y4(ny),z4(nz),sp
#else
      real :: v4(nx,ny,nz) ,x4(nx),y4(ny),z4(nz),sp
#endif
      character*80 dname
      character (len=80) :: infile = 'data/SAC/sac_wtso.cdf'
      iret=nf_open(infile, NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'TEMP',tid)
      iret=nf_inq_varid(ncid,'SAL',sid)
      iret=NF_INQ_VARDIMID (NCID,tid,DIMS)
      dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
      iret=nf_inq_varid(ncid,dname,lonid)
      dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
      iret=nf_inq_varid(ncid,dname,latid)
      dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(3),dname) 
      iret=nf_inq_varid(ncid,dname,zid)
      corner=1; edges(1)=nx; 
      iret= nf_get_vara_real (ncid,lonid ,corner,edges,x4); x=x4
      corner=1; edges(1)=ny; 
      iret= nf_get_vara_real (ncid,latid ,corner,edges,y4); y=y4
      corner=1; edges(1)=nz; 
      iret= nf_get_vara_real (ncid,zid ,corner,edges,z4); z=z4
      tr=0. ! setting all other tracers to zero
      corner=1; edges(1)=nx; edges(2)=ny; edges(3)=nz
      iret= nf_get_vara_real (ncid,tid ,corner,edges,v4)
      iret= nf_get_att_real (ncid,tid ,'missing_value',sp)
      where( v4 == sp) v4 = -1000.0
      tr(:,:,:,1)=v4
      where( tr(:,:,:,1) <= -1000.0) tr(:,:,:,1) = spval
      iret= nf_get_vara_real (ncid,sid ,corner,edges,v4)
      iret= nf_get_att_real (ncid,sid ,'missing_value',sp)
      where( v4 == sp) v4 = -1000.0
      tr(:,:,:,2)=v4
      where( tr(:,:,:,2) <= -1000.0 ) tr(:,:,:,2) = spval
c   convert in situ to potential temperature
      do i=1,nx; do j=1,ny; do k=1,nz
          if (tr(i,j,k,1) /=spval ) then
           call potem(tr(i,j,k,1),tr(i,j,k,2),z(k),fxa)
           tr(i,j,k,1)=fxa
          endif
      enddo; enddo; enddo;
      where( tr(:,:,:,2) /= spval) 
     &             tr(:,:,:,2) = (tr(:,:,:,2)-35.)/1000
      call ncclos (ncid, iret)
      end subroutine read_ic


      subroutine potem (t, s, p, theta)
c     this subroutine calculates potential temperature as a function
c     of in-situ temperature, salinity, and pressure.
c     input [units]:
c       in-situ temperature (t): [degrees centigrade]
c       salinity (s): [per mil] psu ??
c       pressure (p): [decibars, approx. as meters of depth]
c     output [units]:
c       potential temperature (theta): [degrees centigrade]
c     references:
c        based on Fofonoff and Froese (1958) as shown in ...
c        Fofonoff, N., The Sea: Vol 1, (ed. M. Hill). Interscience,
c          New York, 1962, page 17, table iv.
      implicit real (a-h,o-z)
      b1    = -1.60d-5*p
      b2    = 1.014d-5*p*t
      t2    = t*t
      t3    = t2*t
      b3    = -1.27d-7*p*t2
      b4    = 2.7d-9*p*t3
      b5    = 1.322d-6*p*s
      b6    = -2.62d-8*p*s*t
      s2    = s*s
      p2    = p*p
      b7    = 4.1d-9*p*s2
      b8    = 9.14d-9*p2
      b9    = -2.77d-10*p2*t
      b10   = 9.5d-13*p2*t2
      b11   = -1.557d-13*p2*p
      potmp = b1+b2+b3+b4+b5+b6+b7+b8+b9+b10+b11
      theta = t-potmp
      end subroutine potem


#elif defined read_ic_from_E5

c ------------------------------------------------------
c   read from model climatology
c ------------------------------------------------------

      subroutine read_dims_ic(nx,ny,nz,nt)
      implicit none
#include "netcdf.inc"
      integer nx,ny,nz,nt
      integer  ncid,iret,rid,ndims,latid,lonid
      integer dims(4)
      character (len=80) :: infile = 
     &  '/users/model/ceden/dov3/N_atl/E5_bbl/ts_mmean_ufo.cdf'
      print*,' reading T/S climatology from file ',
     &      infile(1:len_trim(infile))
      iret=nf_open(infile, NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'temp',rid)
      iret=NF_INQ_VARNDIMS(NCID, rid, ndims)  
      if (ndims/=4) then
       print*,' number of dimensions for variable not equal 4'
       call halt_stop(' in read_dims_ic (E5)')
      endif
      iret=NF_INQ_VARDIMID (NCID,rid,DIMS)
      iret=NF_INQ_DIMLEN (NCID, DIMs(1), nx)
      iret=NF_INQ_DIMLEN (NCID, DIMs(2), ny)
      iret=NF_INQ_DIMLEN (NCID, DIMs(3), nz)
      iret=NF_INQ_DIMLEN (NCID, DIMs(4), nt)
      call ncclos (ncid, iret)
      end subroutine read_dims_ic



      subroutine read_ic(nx,ny,nz,ntr,nt,x,y,z,tr,spval)
      implicit none
      integer nx,ny,nz,nt,ntr
      real x(nx),y(ny),tr(nx,ny,nz,ntr),z(nz)
      real spval
#include "netcdf.inc"
      integer  ncid,iret,latid,lonid,tid,sid,zid,n
      integer  dims(4),corner(4),edges(4)
#ifdef netcdf_real4
      real (kind=4) :: v4(nx,ny,nz) ,x4(nx),y4(ny),z4(nz),sp
#else
      real :: v4(nx,ny,nz) ,x4(nx),y4(ny),z4(nz),sp
#endif
      character*80 dname
      character (len=80) :: infile = 
     &  '/users/model/ceden/dov3/N_atl/E5_bbl/ts_mmean_ufo.cdf'
      iret=nf_open(infile, NF_nowrite,ncid)
      if (iret/=0) then; print*,nf_strerror(iret);stop;endif
      iret=nf_inq_varid(ncid,'temp',tid)
      iret=nf_inq_varid(ncid,'salt',sid)
      iret=NF_INQ_VARDIMID (NCID,tid,DIMS)
      dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(1),dname) 
      iret=nf_inq_varid(ncid,dname,lonid)
      dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(2),dname) 
      iret=nf_inq_varid(ncid,dname,latid)
      dname='';iret=NF_INQ_DIMNAME (NCID, DIMs(3),dname) 
      iret=nf_inq_varid(ncid,dname,zid)
      corner=1; edges(1)=nx; 
      iret= nf_get_vara_real (ncid,lonid ,corner,edges,x4); x=x4
      corner=1; edges(1)=ny; 
      iret= nf_get_vara_real (ncid,latid ,corner,edges,y4); y=y4
      corner=1; edges(1)=nz; 
      iret= nf_get_vara_real (ncid,zid ,corner,edges,z4); z=z4
      tr=0. ! setting all other tracers to zero
      corner=(/1,1,1,nt/); edges=(/nx,ny,nz,1/)
      iret= nf_get_vara_real (ncid,tid ,corner,edges,v4)
      iret= nf_get_att_real (ncid,tid ,'missing_value',sp)
      where( v4 == sp) v4 = -1000.0
      tr(:,:,:,1)=v4
      where( tr(:,:,:,1) <= -1000.0) tr(:,:,:,1) = spval
      iret= nf_get_vara_real (ncid,sid ,corner,edges,v4)
      iret= nf_get_att_real (ncid,sid ,'missing_value',sp)
      where( v4 == sp) v4 = -1000.0
      tr(:,:,:,2)=v4
      where( tr(:,:,:,2) <= -1000.0 ) tr(:,:,:,2) = spval
      where( tr(:,:,:,2) /= spval) 
     &             tr(:,:,:,2) = (tr(:,:,:,2)-35.)/1000
      call ncclos (ncid, iret)
      end subroutine read_ic
#endif

#include "options.inc"


      subroutine clinic 
c
c=======================================================================
c     compute internal mode velocity components for "tau+1"
c     original author:   r.c.pacanowski       e-mail rcp@gfdl.gov
c     SPFLAME version:   c.eden
c=======================================================================
c
      use spflame_module
      use freesurf_module
      implicit none
      integer :: is,ie,js,je,i,j,k,n
      integer :: is1,ie1,js1,je1
      real    :: baru(is_pe:ie_pe),fxa,fxb
      real    :: grad_p(is_pe:ie_pe,km,js_pe:je_pe,2) 
#ifdef partial_cell
      real dhue,dhun
      dhue(i,k,j)   = min(dhu(i+1,k,j),dhu(i,k,j))
      dhun(i,k,j)   = min(dhu(i,k,j+1),dhu(i,k,j))
#endif
c
c-----------------------------------------------------------------------
c     advective terms
c-----------------------------------------------------------------------
c
      real :: adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real :: adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real :: adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
      real :: adv_ux,adv_uy,adv_uz,adv_metric

      ADV_Ux(i,k,j)   = (adv_fe(i,k,j) - adv_fe(i-1,k,j))*csudxu2r(i,j)
#ifdef partial_cell
     &                             /dhu(i,k,j)
#endif

      ADV_Uy(i,k,j) =(adv_fn(i,k,j) - adv_fn(i,k,j-1))*csudyu2r(j)
#ifdef partial_cell
     &                             /dhu(i,k,j)
#endif

      ADV_Uz(i,k,j) = (adv_fb(i,k-1,j) - adv_fb(i,k,j))
#ifdef partial_cell
     &                *0.5/dhu(i,k,j)
#else
     &                *dzt2r(k)
#endif
      ADV_metric(i,k,j,n)=advmet(j,n)*u(i,k,j,1,tau)*u(i,k,j,3-n,tau)
c
c-----------------------------------------------------------------------
c     viscosity
c-----------------------------------------------------------------------
c
      real :: DIFF_ux,diff_fe(is_pe-1:ie_pe,  km,js_pe  :je_pe) 
      real :: DIFF_Uy,diff_fn(is_pe  :ie_pe,  km,js_pe-1:je_pe) 
      real :: DIFF_uz,diff_fb(is_pe  :ie_pe,0:km,js_pe  :je_pe)
      real :: diff_metric(is_pe:ie_pe,km,js_pe:je_pe)
      real :: del2(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1,2)

      DIFF_Ux(i,k,j) = (diff_fe(i,k,j) - diff_fe(i-1,k,j))
     &                      *rho0csudxur(i,j)
#ifdef partial_cell
     &                            /dhu(i,k,j)
#endif

      DIFF_Uy(i,k,j) = (diff_fn(i,k,j)-diff_fn(i,k,j-1))
     &            *rho0csudyur(j)
#if defined partial_cell
     &            /dhu(i,k,j)
#endif

      DIFF_Uz(i,k,j) = (diff_fb(i,k-1,j) - diff_fb(i,k,j))
     &                 *(1.-aidif_momentum)
#if defined partial_cell
     &                 /(rho0*dhu(i,k,j))
#else
     &                 *rho0dztr(k)
#endif


#ifdef detailed_timing
      call tic('clinic main')
#endif

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     calculate hydrostatic pressure gradient
c-----------------------------------------------------------------------
c
      call pressure_gradient(grad_p)
c
c-----------------------------------------------------------------------
c     calculate del**2 u for biharmonic friction first to insure
c     correct treatment of biharmonic metric terms.
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
      call tic('clinic biha')
#endif

      if (enable_friction_biharmonic) call delsqu(del2)

#ifdef detailed_timing
      call toc('clinic biha')
#endif
c
c-----------------------------------------------------------------------
c     solve for one component of velocity at a time
c     n = 1 => zonal component
c     n = 2 => meridional component
c-----------------------------------------------------------------------
c
      do n=1,2
c
c-----------------------------------------------------------------------
c       calculate 2*advective flux (for speed) across east face of
c       "u" cells.
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
      call tic('clinic adv')
#endif
        do j=js,je
          do k=1,km
            do i=is-1,ie
	      adv_fe(i,k,j) = adv_veu(i,k,j)*(u(i,  k,j,n,tau) + 
     &                                        u(i+1,k,j,n,tau))
            enddo
          enddo
        enddo
c
c-----------------------------------------------------------------------
c       2*advective flux across northern face of "u" cells 
c-----------------------------------------------------------------------
c
        do j=js-1,je
         do k=1,km
          do i=is,ie
	    adv_fn(i,k,j) = adv_vnu(i,k,j)*(u(i,k,j  ,n,tau) + 
     &                                      u(i,k,j+1,n,tau))
          enddo
         enddo
        enddo
#ifdef detailed_timing
        call toc('clinic adv')
#endif
c
c-----------------------------------------------------------------------
c       diffusive flux across east face of "u" cell
c       diffusive flux across north face of "u" cell
c-----------------------------------------------------------------------

#ifdef detailed_timing
        call tic('clinic diff')
#endif
        if (enable_friction_harmonic) then
c
c       calculate diffusive flux on northern faces of "u" cells 
c       with laplacian friction
c
         do j=js-1,je
          fxa=am*cst(j+1)*dytr(j+1)
          do k=1,km
           do i=is,ie
              diff_fn(i,k,j) = fxa*am_scale(i,j+1)*
     &                          (u(i,k,j+1,n,taum1) - u(i,k,j,n,taum1))
#if defined partial_cell
     &                           *dhun(i,k,j)          
#endif
           enddo
          enddo
         enddo
c
c       calculate diffusive flux on eastern faces of "u" cells 
c       with laplacian friction
c
         do j=js,je
          do k=1,km
            do i=is-1,ie
              diff_fe(i,k,j) = am_csudxtr(i,j)*
     &                          (u(i+1,k,j,n,taum1) - u(i,k,j,n,taum1))
     &                           *am_scale(i,j)
#if defined partial_cell
     &                           *dhue(i,k,j)          
#endif
            enddo
          enddo
         enddo
c
c        calculate metric term
c
         do j=js,je
          do k=1,km
           do i=is,ie
            diff_metric(i,k,j)=am3_ha(j)*u(i,k,j,n,taum1)*am_scale(i,j)
     &                       + am4_ha(j,n)*dxmetr(i)*am_scale(i,j)
     &                    *(u(i+1,k,j,3-n,taum1)-u(i-1,k,j,3-n,taum1))
#ifdef partial_cell
     &                        +pc_sink_ha(i,k,j)*u(i,k,j,n,taum1)
#endif
            enddo
          enddo
         enddo

        else
         diff_fn=0.
         diff_fe=0.
         diff_metric=0.
        endif

#ifdef detailed_timing
        call toc('clinic diff')
#endif
c
c-----------------------------------------------------------------------
c       calculate diffusive flux on eastern and northern faces of
c      "u" cells with biharmonic friction
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
        call tic('clinic biha')
#endif
        if (enable_friction_biharmonic) then

c        fe is-1:ie js:je
         do j=js,je
          do k=1,km
            do i=is-1,ie
              diff_fe(i,k,j) = diff_fe(i,k,j)+
     &                         visc_ceu*csur(j)*dxtr(i+1)*
     &                        (del2(i+1,k,j,n)-del2(i,k,j,n))
     &                        *ambi_scale(i+1,j)
#if defined partial_cell
     &                        *dhue(i,k,j)          
#endif
            enddo
          enddo
         enddo
c        fn is:ie js-1:je
         do j=js-1,je
          do k=1,km
            do i=is,ie
              diff_fn(i,k,j) = diff_fn(i,k,j)+
     &                         visc_cnu*cst(j+1)*dytr(j+1)*
     &                        (del2(i,k,j+1,n) - del2(i,k,j,n))
     &                        *ambi_scale(i,j+1)
#if defined partial_cell
     &                        *dhun(i,k,j)          
#endif
            enddo
          enddo
         enddo
c
c        calculate metric term
c
         do j=js,je
          do k=1,km
           do i=is,ie
            diff_metric(i,k,j) = diff_metric(i,k,j)+
     &         am3_biha(j)*del2(i,k,j,n)*ambi_scale(i,j)
     & +am4_biha(j,n)*(del2(i+1,k,j,3-n) - del2(i-1,k,j,3-n))*dxmetr(i)
     &                            *ambi_scale(i,j)
#if defined partial_cell
     &                        +pc_sink_biha(i,k,j)*del2(i,k,j,n)
#endif
           enddo
          enddo
         enddo

        endif

#ifdef detailed_timing
        call toc('clinic biha')
#endif
c
c-----------------------------------------------------------------------
c       calculate 2*advective flux (for speed) on bottom face of
c       "u" cell. also diffusive flux on bottom face of "u" cell
c-----------------------------------------------------------------------
c
        do j=js,je
          do k=1,km-1
            do i=is,ie
	      adv_fb(i,k,j) = adv_vbu(i,k,j)*(u(i,k,  j,n,tau) +
     &                                        u(i,k+1,j,n,tau))
              diff_fb(i,k,j) = visc_cbu(i,k,j)*
     &                         (u(i,k,j,n,taum1) - u(i,k+1,j,n,taum1))
# ifdef partial_cell
     &                      /min(dhwt(i,k,j),   dhwt(i+1,k,j)
     &,                           dhwt(i,k,j+1), dhwt(i+1,k,j+1))
# else
     &                        *dzwr(k)
# endif

            enddo
          enddo
        enddo
        diff_fb(is:ie,km,js:je)=0.
c
c-----------------------------------------------------------------------
c       set surface and bottom vert b.c. on "u" cells for mixing
c       set surface and bottom vert b.c. on "u" cells for advection
c-----------------------------------------------------------------------
c
        do j=js,je
          do i=is,ie
            diff_fb(i,0,j)  = smf(i,j,n)
            diff_fb(i,kmu(i,j),j) = bmf(i,j,n)
	    adv_fb(i,0,j)   = adv_vbu(i,0,j)*(u(i,1,j,n,tau) +
     &                                        u(i,1,j,n,tau)) 
	    adv_fb(i,km,j)  = 0.
          enddo
        enddo

c
c-----------------------------------------------------------------------
c       solve for the internal mode part of du/dt at center of 
c       "u" cells by neglecting the surface pressure gradients. use
c       statement functions to represent each component of the 
c       calculation. 
c       Open boundaries need special treatment.
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
        call tic('clinic obc')
#endif

        if (enable_obc_south.and. my_blk_j==1) then
         js1=3; j=2
         do k=1,km
            do i=is,ie
	      u(i,k,j,n,taup1) = (DIFF_Uz(i,k,j) - grad_p(i,k,j,n) 
     &           + DIFF_Ux(i,k,j) + DIFF_Uy(i,k,j) +diff_metric(i,k,j)
     &           + cori(i,j,n)*u(i,k,j,3-n,tau) 
     &              )*umask(i,k,j)
            enddo
         enddo
	 u(:,:,1,n,taup1) = u(:,:,2,n,taup1)
        else
         js1=js
        endif

        if (enable_obc_north.and. my_blk_j==n_pes_j) then
         je1=jmt-3; j=jmt-2
         do k=1,km
            do i=is,ie
	      u(i,k,j,n,taup1) = (DIFF_Uz(i,k,j) - grad_p(i,k,j,n) 
     &           + DIFF_Ux(i,k,j) + DIFF_Uy(i,k,j) +diff_metric(i,k,j)
     &           + cori(i,j,n)*u(i,k,j,3-n,tau) 
     &              )*umask(i,k,j)
            enddo
         enddo
	 u(:,:,jmt  ,n,taup1) = u(:,:,jmt-2,n,taup1)
	 u(:,:,jmt-1,n,taup1) = u(:,:,jmt-2,n,taup1)
        else
         je1=je
        endif

        if (enable_obc_west.and. my_blk_i==1) then
         is1=3; i=2
         do j=js,je
           do k=1,km
	      u(i,k,j,n,taup1) = (DIFF_Uz(i,k,j)- grad_p(i,k,j,n) 
     &           + DIFF_Ux(i,k,j) + DIFF_Uy(i,k,j) +diff_metric(i,k,j)
     &           + cori(i,j,n)*u(i,k,j,3-n,tau) 
     &              )*umask(i,k,j)
            enddo
         enddo
	 u(i-1,:,:,n,taup1) = u(i,:,:,n,taup1)
        else
         is1=is
        endif

        if (enable_obc_east.and. my_blk_i==n_pes_i) then
         ie1=imt-3; i=imt-2
         do j=js,je
           do k=1,km
	      u(i,k,j,n,taup1) = (DIFF_Uz(i,k,j) - grad_p(i,k,j,n) 
     &           + DIFF_Ux(i,k,j) + DIFF_Uy(i,k,j) +diff_metric(i,k,j)
     &           + cori(i,j,n)*u(i,k,j,3-n,tau) 
     &              )*umask(i,k,j)
           enddo
         enddo
         u(i+1,:,:,n,taup1) = u(i,:,:,n,taup1)
         u(i+2,:,:,n,taup1) = u(i,:,:,n,taup1)
        else
         ie1=ie
        endif
#ifdef detailed_timing
        call toc('clinic obc')
#endif
c
c       and now the interior
c
#ifdef detailed_timing
        call tic('clinic tend')
#endif
        do j=js1,je1
          do k=1,km
            do i=is1,ie1
	      u(i,k,j,n,taup1) = (
     &           DIFF_Uz(i,k,j) 
     &           -  ADV_Ux(i,k,j) - ADV_Uy(i,k,j) - ADV_Uz(i,k,j) 
     &           + ADV_metric(i,k,j,n) 
     &           + DIFF_Ux(i,k,j) + DIFF_Uy(i,k,j) +diff_metric(i,k,j)
     &          - grad_p(i,k,j,n) + cori(i,j,n)*u(i,k,j,3-n,tau) 
     &              )*umask(i,k,j)
            enddo
          enddo
        enddo

#ifdef detailed_timing
        call toc('clinic tend')
#endif

#ifdef detailed_timing
        call tic('clinic impli')
#endif

#ifdef relax_traditional_approx
        if (n==1) then
         do j=js,je
          do k=1,km-1
            do i=is,ie
	      u(i,k,j,n,taup1) = u(i,k,j,n,taup1)+ 
     &                  2.0*omega*csu(j)*adv_vbu(i,k,j)
            enddo
          enddo
         enddo
        endif
#endif
c
c-----------------------------------------------------------------------
c       add in du/dt component due to implicit vertical diffusion
c-----------------------------------------------------------------------
c
        if (enable_implicit_vert_fric)
     &    call implicit_vert_fric(n,is,ie,js,je)

#ifdef detailed_timing
        call toc('clinic impli')
#endif
c
c-----------------------------------------------------------------------
c       construct the vertical average of du/dt for forcing
c       the barotropic equation
c-----------------------------------------------------------------------
c
        if (enable_freesurf) then

         do j=js,je
          do i=is,ie
           zu(i,j,n) =  .5*adv_fb(i,0,j)*umask(i,1,j)
          enddo
          do k=1,km
           do i=is,ie
	    zu(i,j,n) = zu(i,j,n) +
     &       (  u(i,k,j,n,taup1)-cori(i,j,n)*u(i,k,j,3-n,tau) )
#if defined partial_cell
     &                       *dhu(i,k,j) 
#else
     &                       *dzt(k) 
#endif

           enddo
          enddo
         enddo

        else

         zu(:,:,n) = 0.
         do j=js,je
          do k=1,km
            do i=is,ie
              zu(i,j,n) = zu(i,j,n) + u(i,k,j,n,taup1)
#ifdef partial_cell
     &                       *dhu(i,k,j)
#else
     &                       *dzt(k)
#endif
            enddo
          enddo
         enddo
         do j=js,je
          do i=is,ie
            zu(i,j,n) = zu(i,j,n)*hr(i,j)
          enddo
         enddo

        endif
c
c-----------------------------------------------------------------------
c       end of velocity component "n" loop
c-----------------------------------------------------------------------
c
      enddo ! n
c
c-----------------------------------------------------------------------
c     compute "tau+1" velocities accounting for implicit part of the
c     coriolis term if treated implicitly. velocities are in error by an
c     arbitrary constant related to neglecting the unknown surface
c     pressure gradients
c-----------------------------------------------------------------------
c
      do j=js,je
       do k=1,km
        do i=is,ie
         u(i,k,j,1,taup1) = u(i,k,j,1,taum1) + c2dt*u(i,k,j,1,taup1)
         u(i,k,j,2,taup1) = u(i,k,j,2,taum1) + c2dt*u(i,k,j,2,taup1)
        enddo
       enddo
      enddo
c
c-----------------------------------------------------------------------
c     subtract incorrect vertical means (related to ignoring horizontal
c     gradients of the surface pressure) to get pure internal modes.
c-----------------------------------------------------------------------
c
      do n=1,2
       do j=js,je
        baru=0.
        do k=1,km
         do i=is,ie
          baru(i) = baru(i) + u(i,k,j,n,taup1)*umask(i,k,j)
#ifdef partial_cell
     &                                    *dhu(i,k,j)
#else
     &                                    *dzt(k)
#endif
         enddo
        enddo
        if (enable_freesurf) then
c
c        account for changing total depth
c
         do k=1,km
          do i=is,ie
           u(i,k,j,n,taup1) = u(i,k,j,n,taup1)
     &                      - umask(i,k,j)*baru(i)*depthur(i,j)
          enddo
         enddo
        else
         do k=1,km
          do i=is,ie
           u(i,k,j,n,taup1) = u(i,k,j,n,taup1)
     &                      - umask(i,k,j)*baru(i)*hr(i,j)
          enddo
         enddo
        endif
       enddo

c       boundary exchange for taup1 is done in tropic or freesurf
c        call border_exchg(u(:,:,:,n,taup1),km,2)

      enddo

#ifdef detailed_timing
      call toc('clinic main')
#endif

      end subroutine clinic 





      subroutine delsqu (del2)
      use spflame_module
      implicit none
c
c=======================================================================
c     compute del**2 of momentum
c=======================================================================
c
      integer is,ie,js,je,i,j,k,n
      integer ism1,iep1,jsm1,jep1

      real :: del2(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1,2)
      real :: diff_fe_biha(is_pe-2:ie_pe+1,km,js_pe-1:je_pe+1) 
      real :: diff_fn_biha(is_pe-1:ie_pe+1,km,js_pe-2:je_pe+1) 
      real diff_ux,diff_uy
      DIFF_Ux(i,k,j) = (diff_fe_biha(i,k,j) - diff_fe_biha(i-1,k,j))
     &                 *rho0csudxur(i,j)
#ifdef partial_cell
     &                 /dhu(i,k,j)
#endif
      DIFF_Uy(i,k,j) = (diff_fn_biha(i,k,j) - diff_fn_biha(i,k,j-1))
     &                 *rho0csudyur(j)
#ifdef partial_cell
     &                 /dhu(i,k,j)
#endif
#ifdef partial_cell
      real dhue,dhun
      dhue(i,k,j)   = min(dhu(i+1,k,j),dhu(i,k,j))
      dhun(i,k,j)   = min(dhu(i,k,j+1),dhu(i,k,j))
#endif

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
      ism1=max(2,is-1); iep1=min(imt-1,ie+1)
      jsm1=max(2,js-1); jep1=min(jmt-1,je+1)
      
      do n=1,2
c
c-----------------------------------------------------------------------
c       diffusive flux across east face of "u" cell
c       diffusive flux across north face of "u" cell
c-----------------------------------------------------------------------
c
c      fe ism1-1:iep1 jsm1:jep1

       do j=js-1,je+1
          do k=1,km
            do i=ism1-1,iep1
              diff_fe_biha(i,k,j) = visc_ceu*csur(j)*dxtr(i+1)*
     &                         (u(i+1,k,j,n,taum1) - u(i,k,j,n,taum1))
     &                         *ambi_scale(i,j)
#ifdef partial_cell
     &                         *dhue(i,k,j)
#endif
            enddo
          enddo
       enddo

c      fn ism1:iep1 jsm1-1:jep1
       do j=jsm1-1,jep1
          do k=1,km
            do i=is-1,ie+1
              diff_fn_biha(i,k,j) =visc_cnu*cst(j+1)*dytr(j+1)* 
     &                        (u(i,k,j+1,n,taum1) - u(i,k,j,n,taum1))
     &                         *ambi_scale(i,j+1)
#ifdef partial_cell
     &                         *dhun(i,k,j)
#endif
            enddo
          enddo
       enddo
c
c       compute -am*del**2
c
c     del2 is-1:ie+1 js-1:je+1
       do j=jsm1,jep1
          do k=1,km
            do i=ism1,iep1
	      del2(i,k,j,n) = (-DIFF_Ux(i,k,j) - DIFF_Uy(i,k,j) 
     &            - am3_biha(j)*u(i,k,j,n,taum1) 
     &                         *ambi_scale(i,j)
     &            - am4_biha(j,n)*
     &                         ambi_scale(i,j)*
     &         (u(i+1,k,j,3-n,taum1) - u(i-1,k,j,3-n,taum1))*dxmetr(i)
#if defined partial_cell
     &                        -pc_sink_biha(i,k,j)*u(i,k,j,n,taum1)
#endif
     &                        )*umask(i,k,j)
            enddo
          enddo

          if (my_blk_i == 1) then
            if (enable_obc_west) then
             do k=1,km
               del2(1,k,j,n) = del2(2,k,j,n) + DIFF_Ux(2,k,j)
             enddo
            else
             del2(1,:,j,n) = 0.
            endif
          endif
          if (my_blk_i == n_pes_i) then
            if (enable_obc_east) then
             do k=1,km
               del2(imt,k,j,n) = del2(imt-1,k,j,n) + DIFF_Ux(imt-1,k,j)
             enddo
            else
             del2(imt,:,j,n) = 0.
            endif
          endif
       enddo

       call set_cyclic(del2(:,:,:,n),km,1)

       if (my_blk_j == 1)  then
         if (enable_obc_south) then
          do k=1,km
           do i=is-1,ie+1
            del2(i,k,1,n) = del2(i,k,2,n) + DIFF_Uy(i,k,2) 
           enddo
          enddo
         else
          del2(is-1:ie+1,:,1,n) = 0.
         endif
       endif

       if (my_blk_j == n_pes_j)  then
         if (enable_obc_north) then
          do k=1,km
            do i=is-1,ie+1
	      del2(i,k,jmt,n) = del2(i,k,jmt-1,n) + DIFF_Uy(i,k,jmt-1) 
            enddo
          enddo
         else
	  del2(is-1:ie+1,:,jmt,n) = 0.
         endif
       endif

      enddo ! n

      end subroutine delsqu 






      subroutine pressure_gradient(grad_p)
      use spflame_module
      implicit none
      real :: grad_p(is_pe:ie_pe,km,js_pe:je_pe,2) 
      integer :: i,j,k,is,ie,js,je,kb
      real    :: fxa,fxb,t1,t2,t3,t4

#ifdef partial_cell
      real :: rhoij,rhoip1,rhojp1,rhoip1jp1
      real :: pressure(is_pe:ie_pe+1,km,js_pe:je_pe+1)
#endif
      integer :: ii,ik,ij
      real :: tempik
      tempik(ii,ik,ij) = rho(ii,ik-1,ij) + rho(ii,ik,ij)  !kk
c

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     construct the hydrostatic pressure gradients: 1 = dp/dx; 2 = dp/dy
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
      call tic('clinic density')
#endif

      do j=js-1,je+1
        do k=1,km
         call model_dens(t(is-1,k,j,1,tau), t(is-1,k,j,2,tau),
     &                   rho(is-1,k,j),k,ie-is+3
#ifdef partial_cell
     &                       ,ztp(is-1,k,j)
#endif
     &                       )
        enddo
      enddo

      if (enable_blue)      call add_blue_to_rho()
      if (enable_blue_mean) call add_blue_mean_to_rho()

#ifdef detailed_timing
      call toc('clinic density')
#endif

#ifndef partial_cell
c
c     compute horizontal pressure gradient at the first level
c
      do j=js,je
        fxa  = grav*rho0r*dzw(0)*csur(j)
        fxb  = grav*rho0r*dzw(0)*dyu2r(j)
        do i=is,ie
          t1              = rho(i+1,1,j+1) - rho(i  ,1,j)
          t2              = rho(i  ,1,j+1) - rho(i+1,1,j)
          grad_p(i,1,j,1) = (t1-t2)*fxa*dxu2r(i)
          grad_p(i,1,j,2) = (t1+t2)*fxb
        enddo
      enddo

c
c     compute the change in pressure gradient between levels
c     (faster this way)
c
      do j=js,je
        fxa = grav*rho0r*csur(j)*0.5
        fxb = grav*rho0r*dyu4r(j)
        do k=2,km
          do i=is,ie
            t1              = tempik(i+1,k,j+1) - tempik(i  ,k,j)
            t2              = tempik(i  ,k,j+1) - tempik(i+1,k,j)
            t3              = fxa*(t1-t2)*dxu2r(i)*dzw(k-1)
            t4              = fxb*(t1+t2)   *dzw(k-1)
            grad_p(i,k,j,1) = grad_p(i,k-1,j,1) + t3
            grad_p(i,k,j,2) = grad_p(i,k-1,j,2) + t4
          enddo
        enddo
      enddo

#else
c
c     compute hydrostatic pressure anomaly
c
      do j=js,je+1
	do i=is,ie+1
         pressure(i,1,j) = rho(i,1,j)*grav*dzw(0)
	 kb = max(kmt_big(i,j),1)
         do k=2,kb
          pressure(i,k,j) = pressure(i,k-1,j) 
     &              + (rho(i,k-1,j)+rho(i,k,j)) 
     &                  *0.5*grav*dhwt(i,k-1,j)
         enddo
	 fxa = pressure(i,kb,j)
         do k=kb+1,km
            pressure(i,k,j) = fxa
         enddo
       enddo
      enddo
c
c     compute pressure gradient
c
      do j=js,je
        fxa  = rho0r*csur(j)
        fxb  = rho0r*dyu2r(j)
	do k=1,km
          do i=is,ie
            t1              = pressure(i+1,k,j+1) - pressure(i  ,k,j)
            t2              = pressure(i  ,k,j+1) - pressure(i+1,k,j)
            grad_p(i,k,j,1) = (t1-t2)*fxa*dxu2r(i)*umask(i,k,j)
            grad_p(i,k,j,2) = (t1+t2)*fxb*umask(i,k,j)
          enddo
        enddo
      enddo
c
c     add in correction due to variable thickness partial cell
c
      do j=js,je
        fxa = grav*rho0r*csur(j)
        fxb = grav*rho0r*dyu4r(j)
        do i=is,ie
          k = kmu(i,j)
	  if (k .gt. 1) then
	    rhoij     = rho(i,k,j)
	    rhoip1    = rho(i+1,k,j)
	    rhojp1    = rho(i,k,j+1)
	    rhoip1jp1 = rho(i+1,k,j+1)
            grad_p(i,k,j,1) = grad_p(i,k,j,1) - umask(i,k,j)*fxa
     &         *dxu4r(i)*((rhoip1 + rhoij)*(ztp(i+1,k,j) - ztp(i,k,j))
     &           +(rhoip1jp1 + rhojp1)*(ztp(i+1,k,j+1) - ztp(i,k,j+1)))
            grad_p(i,k,j,2) = grad_p(i,k,j,2) - umask(i,k,j)*fxb*(  
     &                    (rhojp1 + rhoij)*(ztp(i,k,j+1) - ztp(i,k,j))
     &           +(rhoip1jp1 + rhoip1)*(ztp(i+1,k,j+1) - ztp(i+1,k,j)))
          endif
	enddo
      enddo
#endif
c

      end subroutine pressure_gradient

#include "options.inc"

c
c=======================================================================
c      solve:
c             A * dpsi = forc
c     SPFLAME version:   c.eden
c=======================================================================
c

      module congrad_module
      implicit none

      logical, allocatable :: imask(:)
      integer, allocatable :: iperm(:),jperm(:), iofs(:)
      integer, allocatable :: nippts(:),nippts_all(:)
      real, allocatable :: Zresisle(:),Zinv_isle(:),sum_isle(:)

      integer mnisle,nisle,maxipp
      integer imain,imain_pe

      end module congrad_module

      subroutine init_congrad()
      use spflame_module
      use congrad_module
      use island_module
      implicit none

      integer, allocatable :: iperm_all(:),jperm_all(:), iofs_all(:)
      logical, allocatable :: imask_all(:)
      integer map_big(imt,jmt),nn,isle,n,i,j

      if (my_pe==0) then
       print*,' Initialisation of Poisson solver, looking for islands'
      endif

      mnisle=500    ! max. number of islands
      maxipp=40000 ! max. number of island perimeter points

      allocate(imask_all(-mnisle:mnisle) )
      imask_all=.false.
      allocate(iperm_all(maxipp) )
      iperm_all=0
      allocate(jperm_all(maxipp) )
      jperm_all=0
      allocate(iofs_all(mnisle) )
      iofs_all=0
      allocate(nippts_all(mnisle) )
      nippts_all=0

      call isleperim (kmt_big, map_big, 
     &    iperm_all, jperm_all, iofs_all, nippts_all, nisle,
     &    imt, jmt,  mnisle, maxipp,my_pe,cyclic,
     &    enable_obc_north,enable_obc_south,
     &    enable_obc_west,enable_obc_east,.false.)

      if (my_pe==0 .and. enable_show_island_map) then
         call showmap(map_big,imt,jmt)
      endif
      
      map(is_pe:ie_pe,js_pe:je_pe)=map_big(is_pe:ie_pe,js_pe:je_pe)

      maxipp=nippts_all(1)
      do isle=2,nisle
       maxipp=maxipp+nippts_all(isle)
      enddo  

      if (my_pe==0) print*,' overall island perimeter points ',maxipp

      allocate(Zresisle(nisle))
      Zresisle=0.
      allocate(Zinv_isle(nisle))
      Zinv_isle=0.
      allocate(sum_isle(nisle))
      sum_isle=0.

      allocate(imask(-nisle:nisle) )
      imask=.false.
      allocate(iperm(maxipp) )
      iperm=0
      allocate(jperm(maxipp) )
      jperm=0
      allocate(iofs(nisle) )
      iofs=0
      allocate(nippts(nisle) )
      nippts=0
c
c     set mask for land mass perimeters on which to perform calculations
c     imask(-n) = .false.  [no equations ever on dry land mass n]
c     imask(0)  = .true.   [equations at all mid ocean points]
c     imask(n)  = .true./.false [controls whether there will be
c                                equations on the ocean perimeter of
c                                land mass n]
c
      do isle=-nisle,nisle
        if (isle .ge. 0 .and. isle .le. nisle) then
          imask(isle) = .true.
        else
          imask(isle) = .false.
        end if
      end do
c
c     user-specified changes to island mask
c       imask(1) = .true.
c       imask(2) = .true.
c
c     there are problems if imask is set .true. for a nonexistent
c     island.
c
c    Get the island perimeter points on the actual PE
c
      nn = 0
      do isle=1,nisle
        iofs(isle) = nn
        do n=1,nippts_all(isle)
          i = iperm_all(iofs_all(isle)+n)
          j = jperm_all(iofs_all(isle)+n)
          if(i.ge.is_pe.and.i.le.ie_pe.and.
     +       j.ge.js_pe.and.j.le.je_pe) then
            nn = nn+1
            iperm(nn) = i
            jperm(nn) = j
          endif
        end do
        nippts(isle) = nn - iofs(isle)
      end do

c     # of landmass to fix drifting streamfunction
      imain=1

c     determine on which PE this points is
      j = ( jperm_all(iofs(imain)+1) - 2 ) / j_blk + 1 
      i = ( iperm_all(iofs(imain)+1) - 2 ) / i_blk + 1
      imain_pe = ( j - 1 ) * n_pes_i + i - 1

      if (my_pe==0) then
        print*,''
        print*,' fix streamfunction to zero on landmass ',imain
        print*,' which is on PE #',imain_pe
        print*,''
      endif

      deallocate(imask_all, iperm_all, jperm_all, iofs_all )

      if (my_pe==0) print*,' done'

      end subroutine init_congrad


      subroutine congr  (dpsi, res, forc, cf, epsilon,islands)
      use spflame_module
      implicit none
c=======================================================================
c                            C O N G R A D
c      solve:
c             A * dpsi = forc
c      author:      Charles Goldberg        e-mail: chg@gfdl.gov
c
c=======================================================================

      real, dimension(is_pe:ie_pe,js_pe:je_pe,-1:1,-1:1) :: cf
      real, dimension(is_pe:ie_pe,js_pe:je_pe) :: forc

      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: dpsi
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: Z,Zres,As
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: s
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: res
      real :: epsilon
      logical :: islands
      real dot2,absmax
      external dot2,absmax
      integer i,j,k
      real Zresmax, estimated_error
      real betakm1,betak,betak_min,alpha,betaquot
      logical diverged,converged
      integer key
      real smax,step,step1,cfactor
      real convergence_rate,s_dot_as
      integer is,ie,js,je
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
 

      Z=0. ; Zres=0.; As=0.; s=0.      

c-----------------------------------------------------------------------
c     impose boundary conditions on guess
c     dpsi(0) = guess
c-----------------------------------------------------------------------
c
      call set_cyclic(dpsi,1,1)
c
c-----------------------------------------------------------------------
c     make approximate inverse operator Z (always even symmetry)
c-----------------------------------------------------------------------
c
      call make_inv (cf, Z, islands)
      call set_cyclic(Z,1,1)
c
c-----------------------------------------------------------------------
c     res(0)  = forc - A * dpsi(0)
c     impose cyclic and/or symmetry conditions on res(i,j)
c-----------------------------------------------------------------------
c

      call op9_vec(cf, dpsi, res)
      do j=js,je
        do i=is,ie
          res(i,j) = forc(i,j) - res(i,j)
        end do
      end do
      call set_cyclic(res,1,1)
c
c-----------------------------------------------------------------------
c     Zres(k-1) = Z * res(k-1)
c     see if guess is a solution, bail out to avoid division by zero
c-----------------------------------------------------------------------
c
      k = 0
      diverged=.false.

      call inv_op(1, Z, res, Zres, islands)


c
c     set borders of Zres using cyclic/symmetry, if defined.
c
      call set_cyclic(Zres,1,1)
c
      Zresmax = absmax(Zres)
c
c     Assume convergence rate of 0.99 to extrapolate error
c
      if (100.0 * Zresmax .lt. epsilon) then
	  estimated_error = 100.0 * Zresmax 
	  goto 101
      endif
c
c-----------------------------------------------------------------------
c     beta(0) = 1
c     s(0)    = zerovector()
c-----------------------------------------------------------------------
c
      betakm1 = 1.0
      s=0.
c
c-----------------------------------------------------------------------
c     begin iteration loop
c-----------------------------------------------------------------------
c
      do k = 1,max_itts_solver
c
c-----------------------------------------------------------------------
c       Zres(k-1) = Z * res(k-1)
c-----------------------------------------------------------------------
c
        key = 2;if(k==1) key=1
        call inv_op(key, Z, res, Zres, islands)


c        call set_cyclic(Zres,1,1)

c       set borders of Zres using cyclic/symmetry, if defined.
!kk     in case of T3E, perm_border is called within inv_op
c
c-----------------------------------------------------------------------
c       beta(k)   = res(k-1) * Zres(k-1)
c-----------------------------------------------------------------------
c
        betak = dot2(Zres, res)

c        if (my_pe==0) print*,'k=',k,betak,betakm1,betak/betakm1


        if (k .eq. 1) then
          betak_min = abs(betak)
	elseif (k .gt. 2) then
          betak_min = min(betak_min, abs(betak))
          if (abs(betak) .gt. 100.0*betak_min) then
	    write (6,'(/a/a/)')
     &      'WARNING: conjugate gradient terminated because correction'
     &,     '         steps are diverging. Probable cause...roundoff'
            smax = absmax(s)
            step = abs(alpha) * smax
	    estimated_error=step*convergence_rate/(1.0-convergence_rate)
            diverged=.true.
	    go to 101
	  endif
	endif
c
c-----------------------------------------------------------------------
c       s(k)      = Zres(k-1) + (beta(k)/beta(k-1)) * s(k-1)
c-----------------------------------------------------------------------
c
        betaquot = betak/betakm1
        do j=js,je
          do i=is,ie
            s(i,j) = Zres(i,j) + betaquot * s(i,j)
          end do
        end do
        call set_cyclic(s,1,1)
*
****    Distribute the borders of the domain of the actaul PE
****    to it`s neighbors
*
        call border_exchg(s,1,1)
c
c-----------------------------------------------------------------------
c       As(k)     = A * s(k)
c-----------------------------------------------------------------------
c
        call op9_vec(cf, s, As)
        call set_cyclic(As,1,1)
c
c-----------------------------------------------------------------------
c       If s=0 then the division for alpha(k) gives a float exception.
c       Assume convergence rate of 0.99 to extrapolate error.
c       Also assume alpha(k) ~ 1.
c-----------------------------------------------------------------------
c

        s_dot_As = dot2(s, As)

        if (abs(s_dot_As) .lt. abs(betak)*1.e-10) then
          smax = absmax(s)
	  estimated_error = 100.0 * smax 
	  goto 101
	endif
c
c-----------------------------------------------------------------------
c       alpha(k)  = beta(k) / (s(k) * As(k))
c-----------------------------------------------------------------------
c
        alpha = betak / s_dot_As
c
c-----------------------------------------------------------------------
c       update values:
c       dpsi(k)   = dpsi(k-1) + alpha(k) * s(k)
c       res(k)    = res(k-1) - alpha(k) * As(k)
c-----------------------------------------------------------------------
c
        do j=js_pe,je_pe
          do i=is_pe,ie_pe
            dpsi (i,j) = dpsi(i,j) + alpha * s(i,j)
            res  (i,j) = res (i,j) - alpha * As(i,j)
          end do
        end do

        if (islands) call avg_dist (res)
c        call set_cyclic(res,1,1)
c
        smax = absmax(s)
c        print*,' smax=',smax
c
c-----------------------------------------------------------------------
c       test for convergence
c       if (estimated_error) < epsilon) exit
c-----------------------------------------------------------------------
c
        step = abs(alpha) * smax
        if (k .eq. 1) then
          step1 = step
          estimated_error = step
          if (step .lt. epsilon) goto 101
        else if (step .lt. epsilon) then
          cfactor = log(step/step1)
          convergence_rate = exp(cfactor/(k-1))
	  estimated_error = step*convergence_rate/(1.0-convergence_rate)
          if (estimated_error .lt. epsilon) goto 101
        end if
c
        betakm1 = betak
c
      end do
c
c-----------------------------------------------------------------------
c     end of iteration loop
c-----------------------------------------------------------------------
c
  101 continue
      if ((k .gt. max_itts_solver).or.(diverged)) then
        cfactor = log(step/step1)
        convergence_rate = exp(cfactor/(k-1))
	estimated_error = step*convergence_rate/(1.0-convergence_rate)
        converged = .false.
        if (my_pe==0) then
          print*,' Poisson solver is not converged in sub domain # ',
     &             sub_domain
          print*,' after ',k,' iterations (max_itts_solver=',
     &             max_itts_solver,' )'
          print*,' estimated error= ',estimated_error,
     &             '( epsilon=',epsilon,' )'
        endif
        call  halt_stop(' solver not converged ')
      else
        converged = .true.
      end if
      itts_solver = k
c
c-----------------------------------------------------------------------
c     return the last increment of dpsi in the argument res
c-----------------------------------------------------------------------
c
      if (itts_solver .eq. 0) then
        do j=js_pe,je_pe
          do i=is_pe,ie_pe
            res(i,j) = Zres(i,j)
          end do
        end do
      else
        do j=js_pe,je_pe
          do i=is_pe,ie_pe
            res(i,j) = alpha * s(i,j)
          end do
        end do
      endif
      if (islands) call remove_drift(dpsi)

      end subroutine congr

      subroutine remove_drift(pp)
      use spflame_module
      use congrad_module
      implicit none
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: pp
      integer i,j
      real dpsi1
      if (my_pe==imain_pe) 
     &    dpsi1 = pp(iperm(iofs(imain)+1),jperm(iofs(imain)+1))
      call bcast_real(dpsi1,1,imain_pe)
      do j=js_pe,je_pe
          do i=is_pe,ie_pe
           if (map(i,j) .le. 0) then
             pp(i,j)=pp(i,j)-dpsi1
           endif
          enddo
      enddo
      end subroutine remove_drift

      function absmax(f)
      use spflame_module
      implicit none
      integer i,j
      real amax,absmax
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: f

      amax = 0.0
      do i=is_pe,ie_pe
       do j=js_pe,je_pe
        amax = max(amax, abs(f(i,j)))
       end do
      end do
      call global_max(amax)
      absmax = amax
      end function absmax


      function dot2 (dp_vec, res_vec)
      use spflame_module
      implicit none
c
c     this dot product produces the correct answers because for
c     ocean perimeter subscripts, ij=isle, the value on a
c     type(dpsi_type) vector, dp_vec(isle)=dp_vec(i,j), i.e., the true
c     value is replicated, and for a type(res_type) vector,
c     res_vec(isle) = sum (res_vec(i,j)), i.e., the true value is the
c     accumulation of the distributed values.
c
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: dp_vec,res_vec
      real sum,dot2
      integer i,j
      integer is,ie,js,je
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      sum = 0.
      do j=js,je
        do i=is,ie
          sum = sum + dp_vec(i,j) * res_vec(i,j)
        enddo
      enddo
      call global_sum(sum)
      dot2 = sum
      end function dot2



      subroutine op9_vec(cf, dpsi, ores)
      use spflame_module
      implicit none
c                       res = A * dpsi
c
c     this subroutine does not collect the terms of the true value
c     of res(isle) = sum (res(i,j)).  the contributions to the sum
c     remain distributed among the T cells (i,j) that form the
c     ocean perimeter of land_mass(isle).
c
c     at present, borders are not computed [i=1 or imt] [j=1 or jmt]
c
      real, dimension(is_pe:ie_pe,js_pe:je_pe,-1:1,-1:1) :: cf
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: dpsi,ores
      integer i,j
      integer is,ie,js,je
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
        do i=is,ie
          ores(i,j) =
     &               cf(i,j,-1,-1) * dpsi(i-1,j-1) +
     &               cf(i,j, 0,-1) * dpsi(i  ,j-1) +
     &               cf(i,j, 1,-1) * dpsi(i+1,j-1)
        end do
        do i=is,ie
          ores(i,j) = ores(i,j) +
     &               cf(i,j,-1, 0) * dpsi(i-1,j  ) +
     &               cf(i,j, 0, 0) * dpsi(i  ,j  ) +
     &               cf(i,j, 1, 0) * dpsi(i+1,j  )
        end do
        do i=is,ie
          ores(i,j) = ores(i,j) +
     &               cf(i,j,-1, 1) * dpsi(i-1,j+1) +
     &               cf(i,j, 0, 1) * dpsi(i  ,j+1) +
     &               cf(i,j, 1, 1) * dpsi(i+1,j+1)
        end do
      end do
      end subroutine op9_vec


      subroutine inv_op(key, Z, ores, Zres, islands)
      use spflame_module
      use congrad_module
      implicit none
      integer key,i,j
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: Z,ores,Zres
      logical :: islands
c
c     apply and approximate inverse Z or the operator A
c
c     res is type(res_type), i.e., perimeter values res(isle)
c         are the sum of the distributed contributions res(i,j)
c     Zres is type(dpsi_type), i.e., perimeter values Zres(isle)
c         must be replicated at each perimeter point Zres(i,j)
c
c     borders  of Zres [i=1 or imt] [j=1 or jmt] must be defined
c     and must satisfy cyclic and/or symmetry, if defined.
c
c     currently, Z is diagonal:  Z(ij) = 1/A(ij)
c     and is stored in type(dpsi_type) format, i.e., Z(isle) is
c     replicated and stored in each Z(i,j) in the perimeter of
c     land_mass(isle).
c
      do j=js_pe,je_pe
        do i=is_pe,ie_pe
          Zres(i,j) = Z(i,j) * ores(i,j)
        end do
      end do
c
c     sum contributions to Zres(isle)
c     distribute Zres(isle) to all perimeter points
      if (islands) call sum_dist (key, Zres)
c
      end subroutine  inv_op


      subroutine make_inv (cf, Z, islands)
      use spflame_module
      use congrad_module
      implicit none
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: Z
      real, dimension(is_pe:ie_pe,js_pe:je_pe,-1:1,-1:1) :: cf
      integer i,j,isle,n
      integer is,ie,js,je
      logical :: islands
c
      is=max(is_pe,1); ie=min(ie_pe,imt)
      js=max(1,js_pe); je=min(je_pe,jmt)
c
c     construct an approximate inverse Z to A
c
c     Z will be diagonal:  Z(ij) = 1/A(ij)
c     and values for ocean perimeter entries Z(isle) will be replicated
c     at all T cells Z(i,j) in the ocean perimeter of land_mass(isle).
c
c     T cells (i,j) for which there is no diagonal coefficient
c     i.e., A(ij)=A(i,j)=0, are masked off by assigning Z(i,j)=0.
c     there are effectively no equations and no variables dpsi(i,j)
c     at these points.
c
c     copy diagonal coefficients of A to Z

      do j=js,je
        do i=is,ie
          Z(i,j) = cf(i,j,0,0)
        end do
      end do
c
c     for each land_mass(isle),
c     sum the contributions to cfdiag(isle)=A(isle,isle)
c     now stored in Z(i,j) at ocean perimeter T cells and replicate
c     the sum in all Z(i,j) for which (i,j) is in ocean perimeter
c     of land_mass(isle).
c
      if (islands) call sum_dist (1, Z)
c
c     now invert Z
c
      do j=js,je
        do i=is,ie
          if (Z(i,j) /= 0.0) then
            Z(i,j) = 1./Z(i,j)
          else
            Z(i,j) = 0.0
          end if
        end do
      end do
c
c     make inverse zero on island perimeters that are not integrated
c
      if (islands) then
       do isle=1,nisle
        if (.not. imask(isle)) then
          do n=1,nippts(isle)
            i = iperm(iofs(isle)+n)
            j = jperm(iofs(isle)+n)
            if(j >= js_pe-1 .and. j <= je_pe+1)   then
               Z(i,j) = 0.0
            end if
          end do
        end if
        if(Zresisle(isle) /= 0.0)  then
           Zinv_isle(isle) = 1./Zresisle(isle)
        end if
       end do
      endif
      end subroutine make_inv





      subroutine sum_dist (key,Zres)
      use spflame_module
      use congrad_module
      implicit none
      integer key,isle,n,i,j
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: Zres
c
c     sum contributions to Zres(isle)
c     distribute Zres(isle) to all perimeter points
c
c     this subroutine converts a type(res_type) vector with
c     distributed contributions to perimeter values
c        Zres(isle) = sum (Zres(i,j))
c     into a type (dpsi_type) vector with replicated values
c     for land_mass perimeters
c        Zres(isle) = Zres(i,j)
c     for all (i,j) in the ocean perimeter of land_mass(isle).
c
c     Ketelsens work is to prevent the communication 
c     of the island perimeter values of Zres during the iteration
c     However, I do not understand this code. Do you ?
c
c       if key == 1:
c           Islands sums over Zres are computed on PE domain
c           a sum over all PEs computed and
c           Zres is set to thesee sums on the islands perimeter points
c           the sum over 1 (sum_isle) is also computed and saved here for later use.
c
c       if key != 2:
c           Zres(isle) is multiplied with sum_isle(isle)
c            and Zresisle is multiplied with Zinv_isle and sum_isle(1)
c
c     sum contributions to Zres(isle)
c
      if(key == 1)   then
         do isle=1,nisle
           if (imask(isle)) then
             Zresisle(isle) = 0.0
             sum_isle(isle) = 0.0
             do n=1,nippts(isle)
               i = iperm(iofs(isle)+n)
               j = jperm(iofs(isle)+n)
               if(j >= js_pe-1 .and. j <= je_pe+1)   then
                  Zresisle(isle) = Zresisle(isle) + Zres(i,j)
                  sum_isle(isle) = sum_isle(isle) + 1.
               end if
             end do
           end if
         end do
         if ( nisle > 0 ) then
           call global_sum_vec(Zresisle,nisle)
           call global_sum_vec(sum_isle,nisle)
         endif
c
c     distribute Zres(isle) to all perimeter points
c
         do isle=1,nisle
           if (imask(isle)) then
             do n=1,nippts(isle)
               i = iperm(iofs(isle)+n)
               j = jperm(iofs(isle)+n)
               if(j >= js_pe-1 .and. j <= je_pe+1)   then
                  Zres(i,j) = Zresisle(isle)
               end if
             end do
           end if
         end do
      else
         do isle=1,nisle
           if (imask(isle)) then
#ifdef SX5_host
ce optimisation for sxf90, NEC cross compiler
c  yields a few percent perfomance, about 15% cpu time 
c  less in congr
!CDIR NODEP
#endif
             do n=1,nippts(isle)
               i = iperm(iofs(isle)+n)
               j = jperm(iofs(isle)+n)
               if(j >= js_pe-1 .and. j <= je_pe+1)   then
                  Zres(i,j) = Zres(i,j)*sum_isle(isle)
               end if
             end do
             Zresisle(isle) = Zresisle(isle) * Zinv_isle(isle) 
     &                                       * sum_isle(isle)
           end if
         end do
      end if
      call  perm_border (Zres)
      end subroutine sum_dist 






      subroutine avg_dist (Zres)
      use spflame_module
      use congrad_module
      use island_module
      implicit none
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: Zres
      integer isle,n,i,j
c
c     avg contributions to Zres(isle)
c     distribute Zres(isle) to all perimeter points
c
c     this subroutine converts a type(res_type) vector with
c     distributed contributions to perimeter values
c        Zres(isle) = avg (Zres(i,j))
c     into a type (dpsi_type) vector with replicated values
c     for land_mass perimeters
c        Zres(isle) = Zres(i,j)
c     for all (i,j) in the ocean perimeter of land_mass(isle).
c
c     avg contributions to Zres(isle)
c
      do isle=1,nisle
        if (imask(isle)) then
          Zresisle(isle) = 0.0
          do n=1,nippts(isle)
            i = iperm(iofs(isle)+n)
            j = jperm(iofs(isle)+n)
            Zresisle(isle) = Zresisle(isle) + Zres(i,j)
          end do
        end if
      end do
      if ( nisle > 0 ) then
          call global_sum_vec(Zresisle,nisle)
      endif
c
c     distribute Zres(isle) to all perimeter points
c
      do isle=1,nisle
        if (imask(isle)) then
          Zresisle(isle) = Zresisle(isle)/nippts_all(isle)
          do n=1,nippts(isle)
            i = iperm(iofs(isle)+n)
            j = jperm(iofs(isle)+n)
            if(j >= js_pe-1 .and. j <= je_pe+1)   then
               Zres(i,j) = Zresisle(isle)
            end if
          end do
        end if
      end do
      call  perm_border (Zres)
      end subroutine avg_dist 



      subroutine perm_border (Zres)
      use spflame_module
      use congrad_module
      implicit none
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: Zres
      integer :: isle,n,j
      integer, allocatable, save :: jp_upper(:),jp_lower(:)
      integer              ,save :: i_last_pe,i_first_pe
      logical ::  first = .true.

      if (cyclic) then

!     At first call, look for isles at boundary. Store isle number
!     in jp_upper and jp_upper, respectively. Send values to opposite
!     boundary PE.

        if(first)   then
         allocate( jp_upper(jmt), jp_lower(jmt) )

         i_last_pe  =  my_blk_j * n_pes_i - 1
         i_first_pe =  (my_blk_j - 1) * n_pes_i
         jp_upper   = 0
         jp_lower   = 0
         do isle=1,nisle
           if (imask(isle)) then
             do n=1,nippts(isle)
                if (my_pe .eq. i_first_pe) then
                   if(iperm(iofs(isle)+n) == 2)    then
                      jp_upper(jperm(iofs(isle)+n)) = isle
                   end  if
                end if
                if (my_pe .eq. i_last_pe) then
                   if(iperm(iofs(isle)+n) == imt-1)    then
                      jp_lower(jperm(iofs(isle)+n)) = isle
                   end  if
                end if
             end do
           end if
         end do

         if ( (nisle > 0) .and. (n_pes_i > 1)) then
          if (my_pe .eq. i_first_pe)
     &     call send_integer(jp_upper(1),jmt,i_last_pe,1)
          if (my_pe .eq. i_last_pe)
     &     call recv_integer(jp_upper(1),jmt,i_first_pe,1)
          if (my_pe .eq. i_last_pe)
     &     call send_integer(jp_lower(1),jmt,i_first_pe,2)
          if (my_pe .eq. i_first_pe)
     &     call recv_integer(jp_lower(1),jmt,i_last_pe,2)
         endif

         first = .false.
        end if

!     Set values at cyclic boundaries

        if (my_pe == i_first_pe .and. nisle > 0 ) then
         do j=js_pe,je_pe
            if(jp_lower(j) > 0)   then
               Zres (1,j) =  Zresisle (jp_lower(j))
            end if
         end do
        end if

        if (my_pe == i_last_pe .and. nisle > 0 ) then
         do j=js_pe,je_pe
            if(jp_upper(j) > 0)   then
               Zres (imt,j) = Zresisle (jp_upper(j))
            end if
         end do
        end if
      endif 
      end subroutine perm_border 

#include "options.inc"




      subroutine adv_vel()
      use spflame_module
      use freesurf_module
      implicit none
      integer is,ie,js,je,i,j,k
      real dys,dyr,dyn,asw,ase,anw,ane
c
c=======================================================================
c     calculate advection velocities for momentum and tracer equations     
c     SPFLAME version:   c.eden
c=======================================================================
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     advection velocity on northern face of "T" cells. Note the
c     imbedded cosine.
c     adv_vnt = WT_AVG_X(u(1,1,1,2,tau))
c-----------------------------------------------------------------------
c
      do j=js-1,je+1
        do k=1,km
          do i=is,ie+1
#ifdef partial_cell
            adv_vnt(i,k,j) = (u(i  ,k,j,2,tau)*dxu(i  )*dhu(i  ,k,j) +
     &                        u(i-1,k,j,2,tau)*dxu(i-1)*dhu(i-1,k,j)
     &                       )*csu(j)*dxt2r(i)
#else
            adv_vnt(i,k,j) = (u(i,k,j,2,tau)*dxu(i) +   
     &                     u(i-1,k,j,2,tau)*dxu(i-1))*csu(j)*dxt2r(i)
#endif
          enddo
        enddo
      enddo

      call set_cyclic(adv_vnt,km,1)
      if (my_blk_i == 1 .and. enable_obc_west) 
     &              adv_vnt(1,:,:) = adv_vnt(2,:,:)
      if (my_blk_i == n_pes_i .and. enable_obc_east) 
     &              adv_vnt(imt,:,:) = adv_vnt(imt-1,:,:)
c
c-----------------------------------------------------------------------
c     advection velocity on the eastern face of "T" cells
c     adv_vnt = WT_AVG_Y(u(1,1,1,1,tau))
c-----------------------------------------------------------------------
c
      do j=js,je+1
        do k=1,km
          do i=is-1,ie+1
#ifdef partial_cell
            adv_vet(i,k,j) = (u(i,k,j  ,1,tau)*dyu(j  )*dhu(i,k,j  )
     &                      + u(i,k,j-1,1,tau)*dyu(j-1)*dhu(i,k,j-1)
     &                       )*dyt2r(j)
#else
            adv_vet(i,k,j) = (u(i,k,j,1,tau)*dyu(j) + 
     &                     u(i,k,j-1,1,tau)*dyu(j-1))*dyt2r(j)
#endif
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     construct vertical velocity on the bottom face of "T" cells
c-----------------------------------------------------------------------
c
      if (enable_freesurf) then

       call calc_convU

       do j=js,je+1
        do i=is,ie+1
          adv_vbt(i,0,j)   = convU(i,j)
        enddo     
       enddo     

      else

       do j=js,je+1
        do i=is,ie+1
          adv_vbt(i,0,j)   = 0.
        enddo     
       enddo     

      endif

      do j=js,je+1
        do k=1,km
          do i=is,ie+1
            adv_vbt(i,k,j) =
     &                   ((adv_vet(i,k,j) - adv_vet(i-1,k,j))*dxtr(i)
     &                   +(adv_vnt(i,k,j) - adv_vnt(i,k,j-1))*dytr(j)
#ifdef partial_cell
     &                   )*cstr(j)
#else
     &                   )*cstr(j)*dzt(k)
#endif
          enddo
        enddo
        do k=1,km
          do i=is,ie+1
            adv_vbt(i,k,j) = adv_vbt(i,k,j) + adv_vbt(i,k-1,j)
          enddo
        enddo
      end do

      call set_cyclic(adv_vbt,km+1,1)
      if (my_blk_i == 1 .and. enable_obc_west)        
     &                 adv_vbt(1,:,:) = adv_vbt(2,:,:)
      if (my_blk_i == n_pes_i .and. enable_obc_east)  
     &                 adv_vbt(imt,:,:) = adv_vbt(imt-1,:,:)
c
c-----------------------------------------------------------------------
c     construct advection velocity on the northern face of "u" cells by
c     averaging advection velocity on northern face of "t" cells 
c     note: je-1 is used instead of jemw to account for possible non
c           integral number of MW`s in jmt 
c     adv_vnu = LINEAR_INTRP_Y(WT_AVG_X(adv_vnt))
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=1,km
          do i=is,ie
	    adv_vnu(i,k,j) = ((adv_vnt(i,k,j)*duw(i) 
     &                       + adv_vnt(i+1,k,j)*due(i)
     &                        )*dus(j+1) +
     &                        (adv_vnt(i,k,j+1)*duw(i) 
     &                       + adv_vnt(i+1,k,j+1)*due(i)
     &                        )*dun(j))*dytr(j+1)*dxur(i)
          enddo
        enddo
      enddo

      call set_cyclic(adv_vnu,km,1)
      if (my_blk_i == 1 .and. enable_obc_west)    
     &                   adv_vnu(1,:,:) = adv_vnu(2,:,:)
      if (my_blk_i == n_pes_i .and. enable_obc_east) 
     &                   adv_vnu(imt,:,:) = adv_vnu(imt-1,:,:)
c
c-----------------------------------------------------------------------
c     construct advection velocity on the eastern face of "u" cells by
c     averaging advection velocity on eastern face of "t" cells 
c     note: take special care of zonal b.c. on this term.
c     adv_veu = LINEAR_INTRP_X(WT_AVG_Y(adv_vet))
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
          do i=is-1,ie
	    adv_veu(i,k,j) = ((adv_vet(i,k,j)*dus(j)
     &                       + adv_vet(i,k,j+1)*dun(j)
     &                        )*duw(i+1) +    
     &                        (adv_vet(i+1,k,j)*dus(j)
     &                       + adv_vet(i+1,k,j+1)*dun(j)
     &                        )*due(i))*dyur(j)*dxtr(i+1)
          enddo
        enddo
      enddo

      call set_cyclic(adv_veu,km,1)
      if (my_blk_i == 1 .and. enable_obc_west) 
     &           adv_veu(1,:,:) = adv_veu(2,:,:)
      if (my_blk_i == n_pes_i .and. enable_obc_east) then
          adv_veu(imt,:,:) = adv_veu(imt-1,:,:)
      elseif (my_blk_i == n_pes_i) then
          adv_veu(imt,:,:) = 0.
      endif
c
c-----------------------------------------------------------------------
c     construct advection velocity on the bottom face of "u" cells by
c     averaging advection velocity on bottom face of "t" cells 
c-----------------------------------------------------------------------
c
c
#ifdef partial_cell
c
c      this is the way MOM 3 calculates adv_cbu
c      use it for partial cell only, it should be however the same, 
c      maybe faster
c
      do j=js,je
c
c       construct vertical velocity at top of first level
c
	dyn  = dun(j)*cst(j+1)
	dys  = dus(j)*cst(j)
	dyr  = dyur(j)*csur(j)
        k=0
        do i=is,ie
	  asw = duw(i)*dys
	  anw = duw(i)*dyn
	  ase = due(i)*dys
	  ane = due(i)*dyn
	  adv_vbu(i,k,j) = dyr*dxur(i)*(
     &                    adv_vbt(i,k,j)*asw + adv_vbt(i+1,k,j)*ase
     &                  + adv_vbt(i,k,j+1)*anw + adv_vbt(i+1,k,j+1)*ane)
        enddo
c
c       construct divergence of advection velocity * level thickness
c
        do k=1,km
          do i=is,ie
            adv_vbu(i,k,j) =
     &                   ((adv_veu(i,k,j) - adv_veu(i-1,k,j))*dxur(i)
     &                   +(adv_vnu(i,k,j) - adv_vnu(i,k,j-1))*dyur(j)
#ifdef partial_cell
     &                   )*csur(j)
#else
     &                   )*csur(j)*dzt(k)
#endif
          enddo
        enddo
c
c       integrate downward to define "adv_vbu" at the bottom of levels
c
        do k=1,km
          do i=is,ie
            adv_vbu(i,k,j) = adv_vbu(i,k,j) + adv_vbu(i,k-1,j)
          enddo
        enddo
      enddo
c
#else
c
c      this is the way MOM 2 calculates adv_cbu
c

      do j=js,je
        do k=0,km
          do i=is,ie
	    adv_vbu(i,k,j) = dyur(j)*csur(j)*dxur(i)*(
     &                    adv_vbt(i,k,j)*duw(i)*dus(j)*cst(j)
     &                  + adv_vbt(i+1,k,j)*due(i)*dus(j)*cst(j)
     &                  + adv_vbt(i,k,j+1)*duw(i)*dun(j)*cst(j+1)
     &                  + adv_vbt(i+1,k,j+1)*due(i)*dun(j)*cst(j+1) )
          enddo
        enddo
      enddo
#endif

      call set_cyclic(adv_vbu,km+1,1)
      if (my_blk_i == 1 .and. enable_obc_west) 
     &         adv_vbu(1,:,:) = adv_vbu(2,:,:)
      if (my_blk_i == n_pes_i .and. enable_obc_east) 
     &         adv_vbu(imt,:,:) = adv_vbu(imt-1,:,:)


      if (enable_bbl) call adv_vel_bbl

      end subroutine adv_vel
      

c
c=======================================================================
c     Module Quicker Advection for SPFLAME
c     taken from MOM 3, originally written by
c       r.c.pacanowski       e-mail rcp@gfdl.gov
c
c     it is linked in the main code in setup
c     and tracer (see also topog for array tmask)
c
c       c.eden
c=======================================================================
c
      module quicker_module
      implicit none

      real, allocatable :: quick_x(:,:)
      real, allocatable :: curv_xp(:,:),curv_xn(:,:)

      real, allocatable :: quick_y(:,:)
      real, allocatable :: curv_yp(:,:),curv_yn(:,:)

      real, allocatable :: quick_z(:,:)
      real, allocatable :: curv_zp(:,:),curv_zn(:,:)

      end module



      subroutine init_quicker
c=======================================================================
c     Initialisation of Quicker Advection module
c=======================================================================
      use spflame_module
      use quicker_module
      implicit none
      integer i,j,k,ip2,jp1,jp2,jm1,kp1,kp2,km1

      if (my_pe==0) then
       print*,' Initialisation of quicker advection scheme'
       print*,''
       print*,' using Quicker advection for all tracers'
       print*,' instead of centered differences'
       print*,''
      endif

      if (enable_4th_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled 4th order scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_quiekcer')
      endif

      if (enable_fct_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled FCT scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_quiekcer')
      endif

      if (enable_upstream_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled upstream scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_quiekcer')
      endif

      allocate( quick_x(imt,2) ); quick_x=0.
      allocate( curv_xp(imt,3) ); curv_xp=0.
      allocate( curv_xn(imt,3) ); curv_xn=0.

      do i=2,imt-1
        ip2=min(i+2,imt)
        if (i == imt-1 .and. cyclic) ip2=3
        quick_x(i,1) = 2.*dxt(i+1)/(dxt(i+1)+dxt(i))
        quick_x(i,2) = 2.*dxt(i  )/(dxt(i+1)+dxt(i))
        curv_xp(i,1) = 2.*dxt(i)*dxt(i+1)/
     &               ((dxt(i-1)+2.0*dxt(i)+dxt(i+1))*(dxt(i)+dxt(i+1)))
        curv_xp(i,2) =-2.*dxt(i)*dxt(i+1)/((dxt(i)+dxt(i+1))
     &                                  *(dxt(i-1)+dxt(i)))
        curv_xp(i,3) = 2.*dxt(i)*dxt(i+1)/
     &               ((dxt(i-1)+2.0*dxt(i)+dxt(i+1))*(dxt(i-1)+dxt(i)))
        curv_xn(i,1) = 2.*dxt(i)*dxt(i+1)/
     &             ((dxt(i)+2.0*dxt(i+1)+dxt(ip2))*(dxt(i+1)+dxt(ip2)))
        curv_xn(i,2) =-2.*dxt(i)*dxt(i+1)/((dxt(i+1)+dxt(ip2))
     &                                  *(dxt(i)+dxt(i+1)))
        curv_xn(i,3) = 2.*dxt(i)*dxt(i+1)/
     &               ((dxt(i)+2.0*dxt(i+1)+dxt(ip2))*(dxt(i)+dxt(i+1)))
      enddo

      if (cyclic) then
        quick_x(1,:)   = quick_x(imt-1,:)
	quick_x(imt,:) = quick_x(2,:)
        curv_xp(1,:)   = curv_xp(imt-1,:)
	curv_xp(imt,:) = curv_xp(2,:)
        curv_xn(1,:)   = curv_xn(imt-1,:)
	curv_xn(imt,:) = curv_xn(2,:)
      endif

      allocate( quick_y(jmt,2) ); quick_y=0.
      allocate( curv_yp(jmt,3) ); curv_yp=0.
      allocate( curv_yn(jmt,3) ); curv_yn=0.

      do j=1,jmt
        jp2 = min(j+2,jmt); jp1 = min(j+1,jmt); jm1 = max(j-1,1)
        quick_y(j,1) = 2.*dyt(jp1)/(dyt(jp1)+dyt(j))
        quick_y(j,2) = 2.*dyt(j  )/(dyt(jp1)+dyt(j))
        curv_yp(j,1) = 2.*dyt(j)*dyt(jp1)/
     &               ((dyt(jm1)+2.0*dyt(j)+dyt(jp1))*(dyt(j)+dyt(jp1)))
        curv_yp(j,2) =-2.*dyt(j)*dyt(jp1)/((dyt(j)+dyt(jp1))
     &                                  *(dyt(jm1)+dyt(j)))
        curv_yp(j,3) = 2.*dyt(j)*dyt(jp1)/
     &               ((dyt(jm1)+2.0*dyt(j)+dyt(jp1))*(dyt(jm1)+dyt(j)))
        curv_yn(j,1) = 2.*dyt(j)*dyt(jp1)/
     &             ((dyt(j)+2.0*dyt(jp1)+dyt(jp2))*(dyt(jp1)+dyt(jp2)))
        curv_yn(j,2) =-2.*dyt(j)*dyt(jp1)/((dyt(jp1)+dyt(jp2))
     &                                  *(dyt(j)+dyt(jp1)))
        curv_yn(j,3) = 2.*dyt(j)*dyt(jp1)/
     &               ((dyt(j)+2.0*dyt(jp1)+dyt(jp2))*(dyt(j)+dyt(jp1)))
      enddo
c
      allocate( quick_z(km,2) ); quick_z=0.
      allocate( curv_zp(km,3) ); curv_zp=0.
      allocate( curv_zn(km,3) ); curv_zn=0.

      do k=1,km
        kp2 = min(k+2,km); kp1 = min(k+1,km); km1 = max(k-1,1)
        quick_z(k,1) = 2.*dzt(kp1)/(dzt(kp1)+dzt(k))
        quick_z(k,2) = 2.*dzt(k  )/(dzt(kp1)+dzt(k))
        curv_zp(k,1) = 2.*dzt(k)*dzt(kp1)/
     &               ((dzt(km1)+2.0*dzt(k)+dzt(kp1))*(dzt(k)+dzt(kp1)))
        curv_zp(k,2) =-2.*dzt(k)*dzt(kp1)/((dzt(k)+dzt(kp1))
     &                                  *(dzt(km1)+dzt(k)))
        curv_zp(k,3) = 2.*dzt(k)*dzt(kp1)/
     &               ((dzt(km1)+2.0*dzt(k)+dzt(kp1))*(dzt(km1)+dzt(k)))
c
        curv_zn(k,1) = 2.*dzt(k)*dzt(kp1)/
     &             ((dzt(k)+2.0*dzt(kp1)+dzt(kp2))*(dzt(kp1)+dzt(kp2)))
        curv_zn(k,2) =-2.*dzt(k)*dzt(kp1)/((dzt(kp1)+dzt(kp2))
     &                                  *(dzt(k)+dzt(kp1)))
        curv_zn(k,3) = 2.*dzt(k)*dzt(kp1)/
     &               ((dzt(k)+2.0*dzt(kp1)+dzt(kp2))*(dzt(k)+dzt(kp1)))
      enddo
      if (my_pe==0) print*,' done'
      end subroutine init_quicker


      subroutine adv_east_flux_quicker(n,adv_fe)
c=======================================================================
c     3rd order advective tracer flux
c=======================================================================
      use spflame_module
      use quicker_module
      implicit none
      real adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      integer is,ie,js,je,n, i,j,k,ip2
      real totvel,upos,uneg,eastmsk,westmsk

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     calculate 2*advective flux across eastern face of T cells.  (It`s
c     done this way for performance issues).  In grid points near land
c     points and near bottom and surface, project the curvature coeff of
c     the land point to the center point.
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
          do i=is-1,ie
            ip2=min(i+2,imt)
            if (i == imt-1 .and. cyclic) ip2=i+2
            totvel = adv_vet(i,k,j)
            upos = .5*(totvel + abs(totvel))
     &                             *tmask(i,k,j)*tmask(i+1,k,j)
            uneg = .5*(totvel - abs(totvel))
     &                             *tmask(i+1,k,j)*tmask(i,k,j)
c           eastmsk is one only in grid points just east of land:
            eastmsk=tmask(i,k,j)*(1-tmask(i-1,k,j))
c           westmsk is one only in grid points just west of land:
            westmsk=tmask(i+1,k,j)*(1-tmask(ip2,k,j))
	    adv_fe(i,k,j) =
     &                  totvel*(
     &                          quick_x(i,1)*t(i,  k,j,n,tau) 
     &                        + quick_x(i,2)*t(i+1,k,j,n,tau))
     &                  - upos*(curv_xp(i,1)*t(i+1,k,j,n,taum1)
     &                         +curv_xp(i,2)*t(i  ,k,j,n,taum1)
     &                         +curv_xp(i,3)
     &        *(t(i-1,k,j,n,taum1)*(1-eastmsk)
     &         +t(i,k,j,n,taum1)*eastmsk))
     &                  - uneg*(curv_xn(i,1)
     &        *(t(ip2,k,j,n,taum1)*(1-westmsk)+
     &          t(i+1,k,j,n,taum1)*westmsk)
     &                         +curv_xn(i,2)*t(i+1,k,j,n,taum1)
     &                         +curv_xn(i,3)*t(i  ,k,j,n,taum1))
          enddo
        enddo
      enddo
      end subroutine adv_east_flux_quicker




      subroutine adv_north_flux_quicker(n,adv_fn)
c=======================================================================
c     3rd order advective tracer flux
c=======================================================================
      use spflame_module
      use quicker_module
      implicit none
      real adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      integer is,ie,js,je,n,i,j,k,jp2
      real totvel,vpos,vneg,rnormsk,soutmsk

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     calculate 2*advective flux across northern face of T cells.
c     (It`s done this way for performance issues)
c-----------------------------------------------------------------------
c
      do j=js-1,je
        jp2 = min(jmt,j+2)
        do k=1,km
          do i=is,ie
            totvel = adv_vnt(i,k,j)
            vpos = .5*(totvel + abs(totvel))
     &                             *tmask(i,k,j)*tmask(i,k,j+1)
            vneg = .5*(totvel - abs(totvel))
     &                             *tmask(i,k,j+1)*tmask(i,k,j)
c           rnormsk is one only in grid points just north of land:
            rnormsk=tmask(i,k,j)*(1-tmask(i,k,j-1))
c           soutmsk is one only in grid points just south of land:
            soutmsk=tmask(i,k,j+1)*(1-tmask(i,k,jp2))
	    adv_fn(i,k,j) = totvel*(
     &                          quick_y(j,1)*t(i,k,j  ,n,tau)
     &                        + quick_y(j,2)*t(i,k,j+1,n,tau))
     &                  - vpos*(curv_yp(j,1)*t(i,k,j+1,n,taum1)
     &                         +curv_yp(j,2)*t(i,k,j  ,n,taum1)
     &                         +curv_yp(j,3)*
     &         (t(i,k,j-1,n,taum1)*(1-rnormsk)
     &         +t(i,k,j  ,n,taum1)*rnormsk))
     &                  - vneg*(curv_yn(j,1)*
     &         (t(i,k,jp2,n,taum1)*(1-soutmsk) +
     &          t(i,k,j+1,n,taum1)*soutmsk)
     &                         +curv_yn(j,2)*t(i,k,j+1,n,taum1)
     &                         +curv_yn(j,3)*t(i,k,j  ,n,taum1))
          enddo
        enddo
      enddo
      end subroutine adv_north_flux_quicker


      subroutine adv_bottom_flux_quicker(n,adv_fb)
c=======================================================================
c     3rd order advective tracer flux
c=======================================================================
      use spflame_module
      use quicker_module
      implicit none
      real adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
      integer is,ie,js,je,n,i,j,k
      real totvel,wpos,wneg,upmsk

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     calculate 2*advective flux across bottom face of T cells.
c     (It`s done this way for performance issues)
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=2,km-2
          do i=is,ie
            totvel = adv_vbt(i,k,j)
            wpos = .5*(totvel + abs(totvel))
     &             *tmask(i,k+2,j)*tmask(i,k+1,j)             
            wneg = .5*(totvel - abs(totvel))
     &                            *tmask(i,k,j)*tmask(i,k+1,j)
c           upmsk is one only in grid points just above land:
            upmsk=tmask(i,k,j)*(1-tmask(i,k-1,j))
	    adv_fb(i,k,j)  = totvel*(
     &                          quick_z(k,1)*t(i,k  ,j,n,tau) 
     &                        + quick_z(k,2)*t(i,k+1,j,n,tau))
     &                  - wneg*(curv_zp(k,1)*t(i,k+1,j,n,taum1)
     &                         +curv_zp(k,2)*t(i,k  ,j,n,taum1)
     &                         +curv_zp(k,3)*t(i,k-1,j,n,taum1))
     &                  - wpos*(curv_zn(k,1)*t(i,k+2,j,n,taum1)
     &                         +curv_zn(k,2)*t(i,k+1,j,n,taum1)
     &                         +curv_zn(k,3)*
     &        (t(i,k  ,j,n,taum1)*(1-upmsk)+t(i,k+1,j,n,taum1)*upmsk))
          enddo
        enddo

	k=1
        do i=is,ie
          totvel = adv_vbt(i,k,j)
          wpos = .5*(totvel + abs(totvel))
     &         *tmask(i,k+2,j)*tmask(i,k+1,j)*tmask(i,k,j)

          wneg = .5*(totvel - abs(totvel))
     &         *tmask(i,k,j)*tmask(i,k+1,j)
	  adv_fb(i,k,j)  = totvel*(
     &                        quick_z(k,1)*t(i,k  ,j,n,tau)
     &                      + quick_z(k,2)*t(i,k+1,j,n,tau))
     &                - wneg*(curv_zp(k,1)*t(i,k+1,j,n,taum1)
     &                         +curv_zp(k,2)*t(i,k  ,j,n,taum1)
     &                         +curv_zp(k,3)*t(i,k  ,j,n,taum1))
     &                - wpos*(curv_zn(k,1)*t(i,k+2,j,n,taum1)
     &                       +curv_zn(k,2)*t(i,k+1,j,n,taum1)
     &                       +curv_zn(k,3)*t(i,k  ,j,n,taum1))
        enddo

	k=km-1
        do i=is,ie
          totvel = adv_vbt(i,k,j)
          wneg = .5*(totvel - abs(totvel))
     &             *tmask(i,k-1,j)*tmask(i,k,j)*tmask(i,k+1,j)
          wpos = .5*(totvel + abs(totvel))
     &                            *tmask(i,k+1,j)*tmask(i,k,j)
	  adv_fb(i,k,j)  = totvel*(
     &                        quick_z(k,1)*t(i,k  ,j,n,tau) 
     &                      + quick_z(k,2)*t(i,k+1,j,n,tau))
     &                - wneg*(curv_zp(k,1)*t(i,k+1,j,n,taum1)
     &                       +curv_zp(k,2)*t(i,k  ,j,n,taum1)
     &                       +curv_zp(k,3)*t(i,k-1,j,n,taum1))
     &                - wpos*(curv_zn(k,1)*t(i,k+1,j,n,taum1)
     &                       +curv_zn(k,2)*t(i,k+1,j,n,taum1)
     &                       +curv_zn(k,3)*t(i,k  ,j,n,taum1))
        enddo
      enddo

      end subroutine adv_bottom_flux_quicker



      subroutine init_adv_flux_4th
c=======================================================================
c     Initialisation of 4.th order advection module
c=======================================================================
      use spflame_module
      implicit none

      if (my_pe==0) then
       print*,' Initialisation of 4.th order advection scheme'
       print*,''
       print*,' using 4.th order advection for all tracers'
       print*,' instead of centered differences'
       print*,''
      endif

      if (enable_quicker_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled Quicker scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_adv_flux_4th')
      endif

      if (enable_fct_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled FCT scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_adv_flux_4th')
      endif

      if (enable_upstream_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled upstream scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_adv_flux_4th')
      endif

      if (my_pe==0) print*,' done'
      end subroutine init_adv_flux_4th



      subroutine adv_flux_4th (n,adv_fe,adv_fn,adv_fb)
      use spflame_module
      implicit none
      real adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
c
c=======================================================================
c     4th order advective tracer flux
c     author:   r.c.pacanowski       e-mail rcp@gfdl.gov
c=======================================================================
c
      integer :: n,i,k,j,is,ie,js,je
      real    :: mask
      real,parameter  :: a2nd = 1.0,     b2nd = 0.0
      real,parameter  :: a4th = 7.0/6.0, b4th = -1.0/6.0

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     calculate 2*advective flux across eastern face of T cells.
c     (It`s done this way for performance issues)
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
          do i=is-1,ie
            mask = tmask(i-1,k,j)*tmask(i+2,k,j)
            adv_fe(i,k,j) = adv_vet(i,k,j)*(
     &       (a2nd*(1.0-mask) + a4th*mask)*(t(i,  k,j,n,tau) + 
     &                                      t(i+1,k,j,n,tau))+
     &       (b2nd*(1.0-mask) + b4th*mask)*(t(i-1,  k,j,n,tau) + 
     &                                      t(i+2,k,j,n,tau)))
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     2*advective flux across northern face of T cells 
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=1,km
          do i=is,ie
            mask = tmask(i,k,j-1)*tmask(i,k,j+2)
            adv_fn(i,k,j) = adv_vnt(i,k,j)*(
     &       (a2nd*(1.0-mask) + a4th*mask)*(t(i,  k,j,n,tau) + 
     &                                      t(i,k,j+1,n,tau))+
     &       (b2nd*(1.0-mask) + b4th*mask)*(t(i,  k,j-1,n,tau) + 
     &                                      t(i,k,j+2,n,tau)))
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     calculate 2*advective flux across bottom face of T cells.
c     (It`s done this way for performance issues)
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=2,km-2
            do i=is,ie
              mask = tmask(i,k-1,j)*tmask(i,k+2,j)
              adv_fb(i,k,j) = adv_vbt(i,k,j)*(
     &         (a2nd*(1.0-mask) + a4th*mask)*(t(i,  k,j,n,tau) + 
     &                                        t(i,k+1,j,n,tau))+
     &         (b2nd*(1.0-mask) + b4th*mask)*(t(i,k-1,j,n,tau) + 
     &                                        t(i,k+2,j,n,tau)))
            enddo
        enddo
	k = 1
        do i=is,ie
         adv_fb(i,k,j) = adv_vbt(i,k,j)*(t(i,k  ,j,n,tau) + 
     &                                   t(i,k+1,j,n,tau))
         adv_fb(i,km-1,j)=adv_vbt(i,km-1,j)*(t(i,km-1,j,n,tau) + 
     &                                      t(i,km  ,j,n,tau))
        enddo
      enddo

      end subroutine adv_flux_4th



      subroutine init_adv_flux_upstream
c=======================================================================
c     Initialisation of upstream advection module
c=======================================================================
      use spflame_module
      implicit none

      if (my_pe==0) then
       print*,' Initialisation of upstream advection scheme'
       print*,''
       print*,' using upstream advection for all tracers'
       print*,' instead of centered differences'
       print*,''
      endif

      if (enable_quicker_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled Quicker scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_adv_flux_4th')
      endif

      if (enable_fct_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled FCT scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_adv_flux_4th')
      endif

      if (enable_4th_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled 4th order scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_adv_flux_upstream')
      endif

      if (my_pe==0) print*,' done'
      end subroutine init_adv_flux_upstream



      subroutine adv_flux_upstream (n,adv_fe,adv_fn,adv_fb)
      use spflame_module
      implicit none
      real adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
c
c=======================================================================
c     upstream advective tracer flux
c     author:   r.c.pacanowski       e-mail rcp@gfdl.gov
c=======================================================================
c
      integer :: n,i,k,j,is,ie,js,je
      real    :: totadv
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     calculate 2*advective flux across northern, 
c     eastern and bottom faces of T cells
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=1,km
          do i=is,ie
            totadv = adv_vnt(i,k,j)
            adv_fn(i,k,j) = totadv*
     &                       (t(i,k,j,n,taum1) + t(i,k,j+1,n,taum1))
     &                      + abs(totadv)*
     &                       (t(i,k,j,n,taum1) - t(i,k,j+1,n,taum1))
          enddo
        enddo
      enddo

      do j=js,je
        do k=1,km
          do i=is-1,ie
            totadv = adv_vet(i,k,j)
            adv_fe(i,k,j) = totadv*
     &                       (t(i,k,j,n,taum1) + t(i+1,k,j,n,taum1))
     &                      + abs(totadv)*
     &                       (t(i,k,j,n,taum1) - t(i+1,k,j,n,taum1))
          enddo
        enddo
      enddo

      do j=js,je
        do k=1,km-1
          do i=is,ie
            totadv = adv_vbt(i,k,j)
            adv_fb(i,k,j) = totadv*
     &                      (t(i,k+1,j,n,taum1) + t(i,k,j,n,taum1))
     &                    + abs(totadv)*
     &                      (t(i,k+1,j,n,taum1) - t(i,k,j,n,taum1))
          enddo
        enddo
        do i=is,ie
          adv_fb(i,0,j) = adv_vbt(i,0,j)*2.0*t(i,1,j,n,taum1)
          adv_fb(i,km,j) = 0.
        enddo
      enddo

      end subroutine adv_flux_upstream




      subroutine adv_flux_2nd (n,adv_fe,adv_fn,adv_fb)
      use spflame_module
      implicit none
      real adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
c
c=======================================================================
c     second order advective tracer flux
c     author:   r.c.pacanowski       e-mail rcp@gfdl.gov
c=======================================================================
c
      integer :: n,i,k,j,is,ie,js,je

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     calculate 2*advective flux across northern, 
c     eastern and bottom faces of T cells
c-----------------------------------------------------------------------
c
       do j=js,je
         do k=1,km
            do i=is-1,ie
	      adv_fe(i,k,j) = adv_vet(i,k,j)*(t(i,  k,j,n,tau) + 
     &                                        t(i+1,k,j,n,tau))
            enddo
         enddo
       enddo

       do j=js-1,je
         do k=1,km
           do i=is,ie
	    adv_fn(i,k,j) = adv_vnt(i,k,j)*(t(i,k,j  ,n,tau) + 
     &                                      t(i,k,j+1,n,tau))
           enddo
         enddo
       enddo

       do j=js,je
         do k=1,km-1
            do i=is,ie
	      adv_fb(i,k,j)  = adv_vbt(i,k,j)*(t(i,k,  j,n,tau) +
     &                                         t(i,k+1,j,n,tau))
            enddo
         enddo
         do i=is,ie
	    adv_fb(i,0,j)   = adv_vbt(i,0,j)*2.*t(i,1,j,n,tau) 
	    adv_fb(i,km,j)  = 0.
         enddo
       enddo

      end subroutine adv_flux_2nd



      subroutine init_adv_flux_fct
c=======================================================================
c     Initialisation of FCT advection module
c=======================================================================
      use spflame_module
      implicit none
c
c     some compiler switches for FCT module, 
c     could become namelist parameter as well
c
c#define dlimiter_1
#define dlimiter_2
#define fct_3d
#define fct_4th

      if (my_pe==0) then
       print*,' Initialisation of FCT advection scheme'
       print*,''
       print*,' using FCT advection for all tracers'
       print*,' instead of centered differences'
       print*,''
#ifdef dlimiter_1
       print*,' using first form of delimiter '
#endif
#ifdef dlimiter_2
       print*,' using second form of delimiter '
#endif
#ifdef fct_3d
       print*,' delimiting fluxes 3 dimensional as well '
#endif
#ifdef fct_4th
       print*,' using 4.th order scheme for antidiff. fluxes '
#else
       print*,' using 2.th order scheme for antidiff. fluxes '
#endif
      endif

      if (enable_quicker_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled Quicker scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_adv_flux_fct')
      endif

      if (enable_4th_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled 4th order scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_adv_flux_fct')
      endif
      if (enable_upstream_advection) then
       if (my_pe==0) then
        print*,' ERROR:'
        print*,' You have enabled upstream scheme as well '
        print*,' this will not work '
       endif
       call halt_stop(' in init_adv_flux_fct')
      endif

      if (my_pe==0) print*,' done'

      end subroutine init_adv_flux_fct





      subroutine adv_flux_fct (n,adv_fe,adv_fn,adv_fb)
      use spflame_module
      implicit none
      integer :: n
      real adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
c
c=======================================================================
c     computes advective fluxes using a flux-corrected transport scheme
c
c        for reference see
c        Gerdes, R., C. Koeberle and J. Willebrand, 1991
c        the influence of numerical advection schemes on the results of 
c        ocean general circulation models. Clim Dynamics 5, 211-226 
c        and
c        Zalesak, S. T., 1979: Fully multidimensional flux-corrected 
c        transport algorithms for fluids. J. Comp. Phys. 31, 335-362. 
c
c     input: n
c
c     output:
c       adv_fn = 2*advective flux across northern face of T-cell
c       adv_fe = 2*advective flux across eastern face of T-cell
c       adv_fb = 2*advective flux across bottom face of T-cell
c
c     author:   C. Koeberle       e-mail ckoeberl@awi-bremerhaven.de
c
c                                   SPFLAME version   C. Eden April 2002
c=======================================================================
c               
      integer :: i,k,j,is,ie,js,je
      real :: fxa,fxb,totadv
      real,parameter :: epsln   = 1.0e-15  !  for single precision
      real, dimension(is_pe-2:ie_pe+2) :: dcf, Trmin, Trmax,
     &                            Cpos, Cneg, flxlft, flxrgt
      real :: Rpl(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) 
      real :: Rmn(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) 
      real :: t_lo(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) 
      real :: anti_fn(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) 
      real :: anti_fe(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) 
      real :: anti_fb(is_pe-1:ie_pe+1,0:km,js_pe-1:je_pe+1) 

      real :: adv_fn_hi(is_pe:ie_pe,km,js_pe-1:je_pe)
      real :: adv_fe_hi(is_pe-1:ie_pe,km,js_pe:je_pe)
      real :: adv_fb_hi(is_pe:ie_pe,0:km,js_pe:je_pe)
# ifdef fct_3d
      real :: tmpext(is_pe:ie_pe,km,js_pe:je_pe,2)
# endif
c
c-----------------------------------------------------------------------
c      FCT statement functions
c
c      calculate some variables needed as one-dimensional delimiters to 
c      raw anti-diffusive fluxes 
c
c      1) calculate P+/P-: maximal/minimal possible growth/decay of T
c      2) calculate Q+/Q-: maximal/minimal allowed growth/decay of T 
c           the appropriate choice of this "allowed" is the key
c           for the success of this scheme...
c      3) calculate ration R+- of Q+- to P+-, that is maximal/minimal 
c         possible change of T if no limit would be active, 
c         must be at least 1
c
c-----------------------------------------------------------------------
c
c     here the calculations of the flux delimiters are done as statement
c     functions for simplicity always loop along one row of POINTS
c 
c     maximal/minimal possible change at grid point
c     this variable is related to a point
c
      real :: pplus,pminus
      Pplus(i)  = c2dt*dcf(i)*(max(0.,flxlft(i))-min(0.,flxrgt(i)))
      Pminus(i) = c2dt*dcf(i)*(max(0.,flxrgt(i))-min(0.,flxlft(i)))
c
c     maximal/minimal feasible change at grid point
c     this variable is related to a point
c
      real :: qplus,qminus
      Qplus(i)  = Trmax(i) - t_lo(i,k,j) 
      Qminus(i) = t_lo(i,k,j) - Trmin(i)
c
c     ratio of Q and P to get delimiter
c     this variable is related to a point
c
      real :: Rpls,Rmns
      Rpls(i)  = min(1.,tmask(i,k,j)*Qplus(i)/(Pplus(i)+epsln)) 
      Rmns(i)  = min(1.,tmask(i,k,j)*Qminus(i)/(Pminus(i)+epsln))
c
c-----------------------------------------------------------------------
c     advective terms
c-----------------------------------------------------------------------
c
      real :: adv_tx
      ADV_Tx(i,k,j) = (adv_fe(i,k,j) - adv_fe(i-1,k,j))*cstdxt2r(i,j)
#ifdef partial_cell
     &                             /dht(i,k,j)
#endif
      real :: adv_ty
      ADV_Ty(i,k,j) = (adv_fn(i,k,j) - adv_fn(i,k,j-1))*cstdyt2r(j)
#ifdef partial_cell
     &                             /dht(i,k,j)
#endif
      real :: adv_tz
      ADV_Tz(i,k,j) = (adv_fb(i,k-1,j) - adv_fb(i,k,j))
#ifdef partial_cell
     &               *.5/dht(i,k,j)
#else
     &               *dzt2r(k)
#endif

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     calculate 2*advective (low order scheme) flux across northern, 
c     eastern and bottom faces of T cells
c-----------------------------------------------------------------------
c
      call adv_flux_upstream (n,adv_fe,adv_fn,adv_fb)
c
c-----------------------------------------------------------------------
c       solve for "tau+1" tracer at center of T cells 
c       - low order solution -
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
          do i=is,ie
	    t_lo(i,k,j) = (t(i,k,j,n,taum1) - c2dt
     &                      *(ADV_Tx(i,k,j) + ADV_Ty(i,k,j) + 
     &                        ADV_Tz(i,k,j))*tmask(i,k,j))
          enddo
        enddo
      enddo

#ifdef dlimiter_2
      call set_cyclic(t_lo,km,1)
      call border_exchg(t_lo,km,1)
      if (my_blk_j == n_pes_j ) t_lo(:,:,jmt)=0. 
      if (my_blk_j ==1 )        t_lo(:,:,1)=0.
#endif
c
c-----------------------------------------------------------------------
c       next calculate raw antidiffusive fluxes, that is high order 
c       scheme flux (leap frog) minus the low order (upstream) 
c-----------------------------------------------------------------------
c
#ifdef fct_4th
      call adv_flux_4th (n,adv_fe_hi,adv_fn_hi,adv_fb_hi)
#else
      call adv_flux_2nd (n,adv_fe_hi,adv_fn_hi,adv_fb_hi)
#endif

      do j=js,je
        do k=1,km
          do i=is-1,ie
            anti_fe(i,k,j) = adv_fe_hi(i,k,j)-adv_fe(i,k,j)
          enddo
        enddo
      enddo

      do j=js-1,je
        do k=1,km
          do i=is,ie
            anti_fn(i,k,j) = adv_fn_hi(i,k,j)-adv_fn(i,k,j)
          enddo
        enddo
      enddo
c
      do j=js,je
        do k=0,km
          do i=is,ie
            anti_fb(i,k,j) = adv_fb_hi(i,k,j)-adv_fb(i,k,j)
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c       now calculate and apply one-dimensional delimiters to these 
c       raw antidiffusive fluxes 
c
c       1) calculate T*, that are all halfway neighbors of T
c       2) calculate ratio R+- of Q+- to P+-, that is maximal/minimal 
c          possible change of T if no limit would be active, 
c          must be at least 1
c       3) choose correct ratio depending on direction of flow as a 
c          delimiter
c       4) apply this delimiter to raw antidiffusive flux
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c       delimit x-direction
c-----------------------------------------------------------------------
c
      do j=js,je 
        do k=1,km
c
c         prepare some data for use in statement function   
# ifdef dlimiter_1
c
c         running mean of two adjacent points
c
          do i=is,ie+1
            Trmax(i) = 0.5*(t(i-1,k,j,n,tau) + t(i,k,j,n,tau))
          enddo
# endif
c
c         extremum of low order solution central point and adjacent 
c         halfway neighbours; check for land
c
          do i=is,ie
# ifdef dlimiter_1
            fxa = tmask(i-1,k,j)*Trmax(i) +
     &            (1.-tmask(i-1,k,j))*t_lo(i,k,j)
            fxb = tmask(i+1,k,j)*Trmax(i+1) +
     &            (1.-tmask(i+1,k,j))*t_lo(i,k,j)
# endif
# ifdef dlimiter_2
            fxa = tmask(i-1,k,j)*t_lo(i-1,k,j) +
     &            (1.-tmask(i-1,k,j))*t_lo(i,k,j)
            fxb = tmask(i+1,k,j)*t_lo(i+1,k,j) +
     &            (1.-tmask(i+1,k,j))*t_lo(i,k,j)
# endif
            Trmax(i) = max(fxa,fxb,t_lo(i,k,j))
            Trmin(i) = min(fxa,fxb,t_lo(i,k,j))
# ifdef fct_3d
            tmpext(i,k,j,1) = Trmax(i)
            tmpext(i,k,j,2) = Trmin(i)
# endif
            dcf(i) = cstdxt2r(i,j)
            flxlft(i) = anti_fe(i-1,k,j)
            flxrgt(i) = anti_fe(i,k,j)
          enddo
c
c         calculate ratio R           
c
          do i=is,ie
            Rpl(i,k,j) = Rpls(i)
            Rmn(i,k,j) = Rmns(i)
          enddo
        enddo
      enddo

      call set_cyclic(Rmn,km,1)
      call border_exchg(Rmn,km,1)
      call set_cyclic(Rpl,km,1)
      call border_exchg(Rpl,km,1)

      do j=js,je 
        do k=1,km
c
c         calculate delimiter using ratio at adjacent points         
c
          do i=is-1,ie
            Cpos(i) = min(Rpl(i+1,k,j),Rmn(i,k,j))
            Cneg(i) = min(Rpl(i,k,j),Rmn(i+1,k,j))
          enddo
c
c         finally apply appropriate delimiter to flux
c
          do i=is-1,ie
            anti_fe(i,k,j) = 0.5*((Cpos(i) + Cneg(i))
     &                               *anti_fe(i,k,j) +
     &                               (Cpos(i) - Cneg(i))
     &                               *abs(anti_fe(i,k,j)))
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c       delimit y-direction
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
c
c         prepare some data for use in statement function       
c
          do i=is,ie
# ifdef dlimiter_1
            fxa = 0.5*tmask(i,k,j-1)*(t(i,k,j-1,n,tau) + 
     &            t(i,k,j,n,tau)) +
     &            (1.-tmask(i,k,j-1))*t_lo(i,k,j)
            fxb = 0.5*tmask(i,k,j+1)*(t(i,k,j,n,tau) +
     &            t(i,k,j+1,n,tau)) +
     &            (1.-tmask(i,k,j+1))*t_lo(i,k,j)
# endif
# ifdef dlimiter_2
            fxa = tmask(i,k,j-1)*t_lo(i,k,j-1) +
     &            (1.-tmask(i,k,j-1))*t_lo(i,k,j)
            fxb = 0.5*tmask(i,k,j+1)*(t(i,k,j,n,tau) +
     &            t(i,k,j+1,n,tau)) +
     &            (1.-tmask(i,k,j+1))*t_lo(i,k,j)
# endif
            Trmax(i) = max(fxa,fxb,t_lo(i,k,j))
            Trmin(i) = min(fxa,fxb,t_lo(i,k,j))
# ifdef fct_3d
            tmpext(i,k,j,1) = max(Trmax(i),tmpext(i,k,j,1))
            tmpext(i,k,j,2) = min(Trmin(i),tmpext(i,k,j,2))
# endif
            dcf(i) = cstdyt2r(j)
            flxlft(i) = anti_fn(i,k,j-1)
            flxrgt(i) = anti_fn(i,k,j)
          enddo
c
c         calculate ratio R, related to a point          
c
          do i=is,ie
            Rpl(i,k,j) = Rpls(i)
            Rmn(i,k,j) = Rmns(i)
          enddo
        enddo
      enddo

      call border_exchg(Rmn,km,1)
      call border_exchg(Rpl,km,1)

      if (my_blk_j == n_pes_j ) then
       Rmn(:,:,jmt)=0. !! really zero ??
       Rpl(:,:,jmt)=0.
      endif
      if (my_blk_j ==1 ) then
       Rmn(:,:,1)=0.
       Rpl(:,:,1)=0.
      endif

      do j=js-1,je 
        do k=1,km
c
c         calculate delimiter using ratio at adjacent points
c
          do i=is,ie
            Cpos(i) = min(Rpl(i,k,j+1),Rmn(i,k,j))
            Cneg(i) = min(Rpl(i,k,j),Rmn(i,k,j+1))
          enddo
c
c         finally get delimiter c dependent on direction of flux and 
c         apply it to raw antidiffusive flux
c
          do i=is,ie
            anti_fn(i,k,j) = 0.5*((Cpos(i) + Cneg(i))
     &                             *anti_fn(i,k,j) +
     &                             (Cpos(i) - Cneg(i))
     &                             *abs(anti_fn(i,k,j)))
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c       delimit z-direction
c-----------------------------------------------------------------------
c
      do j=js,je 
        do k=1,km
c
c         prepare some data for use in statement function
c
          do i=is,ie
            dcf(i) = 
# ifdef partial_cell
     &               0.5/dht(i,k,j) ! unchanged j, probably wrong in MOM3
# else
     &               dzt2r(k)
# endif
            flxlft(i) = anti_fb(i,k,j)
            flxrgt(i) = anti_fb(i,k-1,j)
            if (k .gt. 1)then
# ifdef dlimiter_1
              fxa = 0.5*tmask(i,k-1,j)*
     &              (t(i,k-1,j,n,tau) + t(i,k,j,n,tau)) + 
     &              (1.-tmask(i,k-1,j))*t_lo(i,k,j)
# endif
# ifdef dlimiter_2
              fxa = tmask(i,k-1,j)*t_lo(i,k-1,j) +
     &              (1.-tmask(i,k-1,j))*t_lo(i,k,j)
# endif
            else
              fxa = t_lo(i,k,j)
            endif
# ifdef dlimiter_1
            if (k .lt. km) then
              fxb = 0.5*tmask(i,k+1,j)*
     &              (t(i,k,j,n,tau)+t(i,k+1,j,n,tau)) +
     &              (1.-tmask(i,k+1,j))*t_lo(i,k,j)
# endif
# ifdef dlimiter_2
            if (k .lt. km) then
              fxb = tmask(i,k+1,j)*t_lo(i,k+1,j) +
     &              (1.-tmask(i,k+1,j))*t_lo(i,k,j)
# endif
            else
              fxb = t_lo(i,k,j)
            endif
            Trmax(i) = max(fxa,fxb,t_lo(i,k,j))
            Trmin(i) = min(fxa,fxb,t_lo(i,k,j))
# ifdef fct_3d
            tmpext(i,k,j,1) = max(Trmax(i),tmpext(i,k,j,1))
            tmpext(i,k,j,2) = min(Trmin(i),tmpext(i,k,j,2))
# endif
          enddo
c
c         calculate delimiter using ratio at adjacent points
c         this variable is related to an arc (between two points,
c         the same way as fluxes are defined.)
c
          do i=is,ie
            Rpl(i,k,j) = Rpls(i)
            Rmn(i,k,j) = Rmns(i)
          enddo
c
        enddo
      enddo

      do j=js,je 
        do k=1,km-1
c
c         calculate delimiter using ratio at adjacent points
c         this variable is related to an arc (between two points,
c         the same way as fluxes are defined.)
c
          do i=is,ie
            Cneg(i) = min(Rpl(i,k+1,j),Rmn(i,k,j))
            Cpos(i) = min(Rpl(i,k,j),Rmn(i,k+1,j))
          enddo
c
c         finally get delimiter c dependent on direction of flux and 
c         apply it to raw antidiffusive flux
c
          do i=is,ie
            anti_fb(i,k,j) = 0.5*((Cpos(i)+Cneg(i))
     &                               *anti_fb(i,k,j) +
     &                               (Cpos(i)-Cneg(i))
     &                               *abs(anti_fb(i,k,j)))
          enddo
        enddo
        do i=is,ie
          anti_fb(i,0,j)  = 0.
          anti_fb(i,km,j) = 0.
        enddo

      enddo ! j loop


# ifdef fct_3d
c
c-----------------------------------------------------------------------
c     then calculate and apply 3-d delimiter to just delimited 
c     antidiffusive fluxes   
c-----------------------------------------------------------------------
c
      do j=js,je 
        do k=1,km
c
c         prepare some data for use in statement function
c
          do i=is,ie
            Trmax(i) = tmpext(i,k,j,1)
            Trmin(i) = tmpext(i,k,j,2)
          enddo
c
          do i=is,ie
            Rpl(i,k,j) = min(1.,tmask(i,k,j)*Qplus(i)/
     &                           (epsln+c2dt*(
     &                           cstdxt2r(i,j)
     &                             *(max(0.,anti_fe(i-1,k,j)) - 
     &                               min(0.,anti_fe(i,k,j))) +
     &                           cstdyt2r(j)
     &                             *(max(0.,anti_fn(i,k,j-1)) -
     &                               min(0.,anti_fn(i,k,j))) +
#  ifdef partial_cell
     &                          (0.5/dht(i,k,j)) ! unchanged j
#  else
     &                           dzt2r(k)
#  endif
     &                             *(max(0.,anti_fb(i,k,j)) -
     &                               min(0.,anti_fb(i,k-1,j)))
     &                           )))
c
            Rmn(i,k,j) = min(1.,tmask(i,k,j)*Qminus(i)/
     &                            (epsln+c2dt*(
     &                            cstdxt2r(i,j)
     &                              *(max(0.,anti_fe(i,k,j)) -
     &                                min(0.,anti_fe(i-1,k,j))) +
     &                            cstdyt2r(j)
     &                              *(max(0.,anti_fn(i,k,j)) -
     &                                min(0.,anti_fn(i,k,j-1))) +
#  ifdef partial_cell
     &                          (0.5/dht(i,k,j)) ! unchanged j
#  else
     &                           dzt2r(k)
#  endif
     &                              *(max(0.,anti_fb(i,k-1,j)) -
     &                                min(0.,anti_fb(i,k,j)))
     &                            )))
c
          enddo
        enddo
      enddo

      call set_cyclic(Rmn,km,1)
      call border_exchg(Rmn,km,1)
      call set_cyclic(Rpl,km,1)
      call border_exchg(Rpl,km,1)

c
c       finally apply 3-d delimiters to precorrected fluxes
c
      do j=js,je 
        do k=1,km
          do i=is-1,ie
            Cpos(i) = min(Rpl(i+1,k,j),Rmn(i,k,j))
            Cneg(i) = min(Rpl(i,k,j),  Rmn(i+1,k,j))
          enddo
          do i=is-1,ie
            anti_fe(i,k,j) = 0.5*((Cpos(i) + Cneg(i))
     &                               *anti_fe(i,k,j) +
     &                               (Cpos(i) - Cneg(i))
     &                               *abs(anti_fe(i,k,j)))
          enddo
        enddo
      enddo
c
      do j=js-1,je 
        do k=1,km
          do i=is,ie
            Cpos(i) = min(Rpl(i,k,j+1),Rmn(i,k,j))
            Cneg(i) = min(Rpl(i,k,j),Rmn(i,k,j+1))
          enddo
          do i=is,ie
            anti_fn(i,k,j) = 0.5*((Cpos(i) + Cneg(i))
     &                             *anti_fn(i,k,j) +
     &                             (Cpos(i) - Cneg(i))
     &                             *abs(anti_fn(i,k,j)))
          enddo
        enddo
      enddo
c
      do j=js,je 
        do k=1,km-1
          do i=is,ie
            Cneg(i) = min(Rpl(i,k+1,j),Rmn(i,k,j))
            Cpos(i) = min(Rpl(i,k,j),Rmn(i,k+1,j))
          enddo
          do i=is,ie
            anti_fb(i,k,j) = 0.5*((Cpos(i) + Cneg(i))
     &                               *anti_fb(i,k,j) +
     &                               (Cpos(i) - Cneg(i))
     &                               *abs(anti_fb(i,k,j)))
          enddo
        enddo
      enddo
c
# endif
c
c-----------------------------------------------------------------------
c     complete advective fluxes by adding low order fluxes to 
c     delimited antidiffusive fluxes    
c-----------------------------------------------------------------------
c
      do j=js,je 
        do k=1,km
          do i=is-1,ie
            adv_fe(i,k,j) = (anti_fe(i,k,j) + adv_fe(i,k,j))
     &                         *tmask(i,k,j)
          enddo
        enddo
      enddo

      do j=js-1,je 
        do k=1,km
          do i=is,ie
            adv_fn(i,k,j) = (anti_fn(i,k,j) + adv_fn(i,k,j))
     &                         *tmask(i,k,j)
          enddo
        enddo
      enddo 

      do j=js,je 
        do k=1,km
          do i=is,ie
            adv_fb(i,k,j) = (anti_fb(i,k,j) + adv_fb(i,k,j))
     &                           *tmask(i,k,j)
          enddo
        enddo
      enddo 

      end subroutine adv_flux_fct

#include "options.inc"
c
c--------------------------------------------------------
c     some netcdf output stuff
c--------------------------------------------------------
c



      subroutine init_forcing_file(forcing_file)
      use prep_module
      implicit none
#include "netcdf.inc"
      integer   ncid,iret,n
      integer lon_tdim,lat_tdim,itimedim,depth_tdim,depth_wid
      integer lon_tid ,lat_tid ,itimeid, depth_tid,depth_wdim
      integer lon_udim,lat_udim, lon_uid ,lat_uid
      integer dims(4), corner(4), edges(4),i
#ifdef netcdf_real4
      real (kind=4), allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      character name*80, unit*80, text*80
      character (len=*) :: forcing_file

      ncid = nccre (forcing_file , NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      i=imt; lon_tdim  = ncddef(ncid, 'Longitude_t', i, iret)
      i=jmt; Lat_tdim  = ncddef(ncid, 'Latitude_t',  i, iret)
      i=imt; lon_udim  = ncddef(ncid, 'Longitude_u', i, iret)
      i=jmt; Lat_udim  = ncddef(ncid, 'Latitude_u',  i, iret)
      i=km;  depth_tdim= ncddef(ncid, 'depth_t',  i, iret)
      i=km+1;depth_wdim= ncddef(ncid, 'depth_w',  i, iret)

      dims(1)  = Lon_tdim
      i=1
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,i,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,i,dims,iret)
      dims(1)  = Lon_udim
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,i,dims,iret)
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,i,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,i,dims,iret)
      dims(1)  = depth_wdim
      depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,i,dims,iret)
c
      name = 'Longitude on rotated T grid'
      unit = 'degrees_W       '
      i=len_trim(name)
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, i, unit, iret) 

      name = 'Longitude on rotated U grid'
      unit = 'degrees_W       '
      i=len_trim(name)
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, i, unit, iret) 

      name = 'Latitude on rotated T grid'
      unit = 'degrees_N       '
      i=len_trim(name)
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, i, unit, iret) 

      name = 'Latitude on rotated U grid'
      unit = 'degrees_N       '
      i=len_trim(name)
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, i, unit, iret) 

      name = 'Depth of T Grid points  '
      unit = 'm '
      i=len_trim(name)
      call ncaptc(ncid, depth_tid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, depth_tid, 'units',     NCCHAR, i, unit, iret) 
c
      name = 'Depth of W Grid points  '
      unit = 'm '
      i=len_trim(name)
      call ncaptc(ncid, depth_wid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, depth_wid, 'units',     NCCHAR, i, unit, iret) 

      call ncendf(ncid, iret)

      allocate( var(imt,1) )
      Corner=0; edges=0
      Corner(1) = 1; edges(1) = imt
      var(1:imt,1)=xt
      call ncvpt(ncid, Lon_tid, corner, edges,var, iret)
      Corner(1) = 1; edges(1) = imt
      var(1:imt,1)=xu
      call ncvpt(ncid, Lon_uid, corner, edges,var, iret)
      deallocate(var);allocate(var(jmt,1))
      corner(1) = 1; edges(1) = jmt
      var(1:jmt,1)=yt
      call ncvpt(ncid, Lat_tid, corner, edges,var, iret)
      corner(1) = 1; edges(1) = jmt
      var(1:jmt,1)=yu
      call ncvpt(ncid, Lat_uid, corner, edges,var, iret)
      deallocate(var);allocate(var(km,1))
      corner(1) = 1; edges(1) = km
      var(1:km,1)=zt/100.
      call ncvpt(ncid, depth_tid, corner, edges,var, iret)
      deallocate(var);allocate(var(km+1,1))
      var(2:km+1,1)=zw(1:km)/100.;var(1,1)=0.
      corner(1) = 1; edges(1) = km+1
      call ncvpt(ncid, depth_wid, corner, edges,var, iret)

      deallocate(var)
c
      call ncclos (ncid, iret)
      end subroutine init_forcing_file





      subroutine init_out_cdf()
      use prep_module
      implicit none
#include "netcdf.inc"
      integer   ncid,iret,n
      integer lon_tdim,lat_tdim,itimedim,depth_tdim,depth_wid
      integer lon_tid ,lat_tid ,itimeid, depth_tid,depth_wdim
      integer lon_udim,lat_udim
      integer lon_uid ,lat_uid
      integer ixtid,iytid,ixuid,iyuid,iztid,izwid
      integer dxtid,dytid,dxuid,dyuid,dztid,dzwid
      integer ikmtid, iroseid,iraw_roseid,iglatid
      integer itauxid,itauyid, ihtpid,topoid,rosebud,hupid
      integer dims(4), corner(4), edges(4),i
#ifdef netcdf_real4
      real (kind=4), allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      real (kind=8), allocatable :: v8(:)

      character name*80, unit*80, text*80

      ncid = nccre ('forcing.cdf', NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      i=imt; lon_tdim  = ncddef(ncid, 'Longitude_t', i, iret)
      i=jmt; Lat_tdim  = ncddef(ncid, 'Latitude_t',  i, iret)
      i=imt; lon_udim  = ncddef(ncid, 'Longitude_u', i, iret)
      i=jmt; Lat_udim  = ncddef(ncid, 'Latitude_u',  i, iret)
      i=km;  depth_tdim= ncddef(ncid, 'depth_t',  i, iret)
      i=km+1;depth_wdim= ncddef(ncid, 'depth_w',  i, iret)

      dims(1)  = Lon_tdim
      i=1
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,i,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,i,dims,iret)
      dims(1)  = Lon_udim
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,i,dims,iret)
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,i,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,i,dims,iret)
      dims(1)  = depth_wdim
      depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,i,dims,iret)
c
      name = 'Longitude on rotated T grid'
      unit = 'degrees_W       '
      i=len_trim(name)
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, i, unit, iret) 

      name = 'Longitude on rotated U grid'
      unit = 'degrees_W       '
      i=len_trim(name)
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, i, unit, iret) 

      name = 'Latitude on rotated T grid'
      unit = 'degrees_N       '
      i=len_trim(name)
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, i, unit, iret) 

      name = 'Latitude on rotated U grid'
      unit = 'degrees_N       '
      i=len_trim(name)
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, i, unit, iret) 

      name = 'Depth of T Grid points  '
      unit = 'm '
      i=len_trim(name)
      call ncaptc(ncid, depth_tid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, depth_tid, 'units',     NCCHAR, i, unit, iret) 
c
      name = 'Depth of W Grid points  '
      unit = 'm '
      i=len_trim(name)
      call ncaptc(ncid, depth_wid, 'long_name', NCCHAR, i, name, iret) 
      i=len_trim(unit)
      call ncaptc(ncid, depth_wid, 'units',     NCCHAR, i, unit, iret) 


c     write also grid related quantities
c
      i=1
      ixtid   = ncvdef(ncid,'xt',NCdouble,i,lon_tdim,iret)
      ixuid   = ncvdef(ncid,'xu',NCdouble,i,lon_udim,iret)
      iytid   = ncvdef(ncid,'yt',NCdouble,i,lat_tdim,iret)
      iyuid   = ncvdef(ncid,'yu',NCdouble,i,lat_udim,iret)
      iztid   = ncvdef(ncid,'zt',NCdouble,i,Depth_tdim,iret)
      izwid   = ncvdef(ncid,'zw',NCdouble,i,Depth_wdim,iret)
      dxtid   = ncvdef(ncid,'dxtdeg',NCdouble,i,lon_tdim,iret)
      dxuid   = ncvdef(ncid,'dxudeg',NCdouble,i,lon_udim,iret)
      dytid   = ncvdef(ncid,'dytdeg',NCdouble,i,lat_tdim,iret)
      dyuid   = ncvdef(ncid,'dyudeg',NCdouble,i,lat_udim,iret)
      dztid   = ncvdef(ncid,'dzt',NCdouble,i,Depth_tdim,iret)
      dzwid   = ncvdef(ncid,'dzw',NCdouble,i,Depth_wdim,iret)
c
      i=2
      dims(1) = Lon_tdim
      dims(2) = Lat_tdim
      ikmtid    = ncvdef (ncid,'kmt',   NClong,i,dims,iret)
      iroseid   = ncvdef (ncid,'rose', NCFLOAT,i,dims,iret)
      iraw_roseid   = ncvdef (ncid,'raw_rose', NCFLOAT,i,dims,iret)
      iglatid   = ncvdef (ncid,'glat', NCFLOAT,i,dims,iret)
      topoid   = ncvdef (ncid,'topo', NCFLOAT,i,dims,iret)
#ifdef partial_cell
      ihtpid   = ncvdef (ncid,'htp', NCFLOAT,i,dims,iret)
      rosebud  = ncvdef (ncid,'rose_digged', NCFLOAT,i,dims,iret)
      hupid   = ncvdef (ncid,'hup', NCFLOAT,i,dims,iret)
#endif

      name = 'Model topography'
      unit = 'vertical index'
      call dvcdf(ncid,ikmtid,name,len_trim(name),unit,16,spval)

      name = 'Bottom of deepest wet T-grid point'
      unit = 'cm'
      call dvcdf(ncid,topoid,name,len_trim(name),unit,2,spval)

      name = 'Topography before disretisation'
      unit = 'm'
      call dvcdf(ncid,iroseid,name,len_trim(name),unit,1,spval)

      name = 'Topography before smoothing,etc'
      unit = 'm'
      call dvcdf(ncid,iraw_roseid,name,len_trim(name),unit,1,spval)

      name = 'Latitude in unrotated grid'
      unit = 'deg'
      call dvcdf(ncid,iglatid,name,len_trim(name),unit,3,spval)

#ifdef partial_cell
      name = 'Depth of partial bottom t cells'
      unit = 'cm'
      call dvcdf(ncid,ihtpid,name,len_trim(name),unit,2,spval)
      name = 'Depth of topography before discretisation and digging'
      unit = 'm'
      call dvcdf(ncid,rosebud,name,len_trim(name),unit,2,spval)
      name = 'Depth of partial bottom u-cells'
      unit = 'cm'
      call dvcdf(ncid,hupid,name,len_trim(name),unit,2,spval)
#endif

      call ncendf(ncid, iret)

      allocate( var(imt,1) )
      Corner=0; edges=0
      Corner(1) = 1; edges(1) = imt
      var(1:imt,1)=xt
      call ncvpt(ncid, Lon_tid, corner, edges,var, iret)
      Corner(1) = 1; edges(1) = imt
      var(1:imt,1)=xu
      call ncvpt(ncid, Lon_uid, corner, edges,var, iret)
      deallocate(var);allocate(var(jmt,1))
      corner(1) = 1; edges(1) = jmt
      var(1:jmt,1)=yt
      call ncvpt(ncid, Lat_tid, corner, edges,var, iret)
      corner(1) = 1; edges(1) = jmt
      var(1:jmt,1)=yu
      call ncvpt(ncid, Lat_uid, corner, edges,var, iret)
      deallocate(var);allocate(var(km,1))
      corner(1) = 1; edges(1) = km
      var(1:km,1)=zt/100.
      call ncvpt(ncid, depth_tid, corner, edges,var, iret)
      deallocate(var);allocate(var(km+1,1))
      var(2:km+1,1)=zw(1:km)/100.;var(1,1)=0.
      corner(1) = 1; edges(1) = km+1
      call ncvpt(ncid, depth_wid, corner, edges,var, iret)


      deallocate(var)
c
c
      allocate(v8(imt))
      corner(1) = 1; edges(1) = imt; v8=xt
      call ncvpt(ncid, ixtid, corner, edges,v8, iret)
      corner(1) = 1; edges(1) = imt; v8=xu
      call ncvpt(ncid, ixuid, corner, edges,v8, iret)
      corner(1) = 1; edges(1) = imt; v8=dxtdeg
      call ncvpt(ncid, dxtid, corner, edges,v8, iret)
      corner(1) = 1; edges(1) = imt; v8=dxudeg
      call ncvpt(ncid, dxuid, corner, edges,v8, iret)

      deallocate(v8);allocate(v8(jmt))
      corner(1) = 1; edges(1) = jmt; v8=yt
      call ncvpt(ncid, iytid, corner, edges,v8, iret)
      corner(1) = 1; edges(1) = jmt; v8=yu
      call ncvpt(ncid, iyuid, corner, edges,v8, iret)
      corner(1) = 1; edges(1) = jmt; v8=dytdeg
      call ncvpt(ncid, dytid, corner, edges,v8, iret)
      corner(1) = 1; edges(1) = jmt; v8=dyudeg
      call ncvpt(ncid, dyuid, corner, edges,v8, iret)

      deallocate(v8);allocate(v8(km))
      corner(1) = 1; edges(1) = km; v8=zt
      call ncvpt(ncid, iztid, corner, edges,v8, iret)
      corner(1) = 1; edges(1) = km; v8=dzt
      call ncvpt(ncid, dztid, corner, edges,v8, iret)
      deallocate(v8);allocate(v8(km+1))
      corner(1) = 1; edges(1) = km+1; v8(2:km+1)=zw; v8(1)=0.
      call ncvpt(ncid, izwid, corner, edges,v8, iret)
      corner(1) = 1; edges(1) = km+1; v8(1:km+1)=dzw(0:km)
      call ncvpt(ncid, dzwid, corner, edges,v8, iret)

      deallocate(v8)
c
      call ncclos (ncid, iret)

      end


      subroutine write_kmt_to_cdf(nrose,srose
#ifdef partial_cell
     & ,rose_digged
#endif
     &     )
      use prep_module
      implicit none
#include "netcdf.inc"
      real nrose(imt,jmt),srose(imt,jmt)
#ifdef partial_cell
      real rose_digged(imt,jmt)
#endif
      integer  ncid,iret,htpid,topoid,i,j
      integer  ikmtid, iroseid,iraw_roseid
      integer  corner(4), edges(4)
      integer , allocatable :: ivar(:,:)
#ifdef netcdf_real4
      real (kind=4), allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif

      iret=nf_open('forcing.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      iret=nf_inq_varid(ncid,'kmt',ikmtid)
      iret=nf_inq_varid(ncid,'topo',topoid)
      iret=nf_inq_varid(ncid,'rose',iroseid)
      iret=nf_inq_varid(ncid,'raw_rose',iraw_roseid)
      corner=1; edges(1)=imt; edges(2)=jmt
      allocate(ivar(imt,jmt) )
      ivar=kmt
      call ncvpt(ncid, ikmtid, corner, edges,ivar, iret)
      deallocate(ivar);allocate(var(imt,jmt) )
      var=srose/100.
      call ncvpt(ncid, iroseid, corner, edges,var, iret)
      var=nrose/100.
      call ncvpt(ncid, iraw_roseid, corner, edges,var, iret)
#ifdef partial_cell
      iret=nf_inq_varid(ncid,'htp',htpid)
      var=htp
      call ncvpt(ncid, htpid, corner, edges,var, iret)
      iret=nf_inq_varid(ncid,'rose_digged',htpid)
      var=rose_digged
      call ncvpt(ncid, htpid, corner, edges,var, iret)
      iret=nf_inq_varid(ncid,'hup',htpid)
      var=hup
      call ncvpt(ncid, htpid, corner, edges,var, iret)
#endif
      do i=1,imt
       do j=1,jmt
        if (kmt(i,j) == 0 ) then 
         var(i,j)=0.0
        else
         var(i,j)=zw(kmt(i,j))
        endif
       enddo
      enddo
      call ncvpt(ncid, topoid, corner, edges,var, iret)
      call ncclos (ncid, iret)
      deallocate(var)
      end


      subroutine write_glat_to_cdf(glat)
      use prep_module
      implicit none
#include "netcdf.inc"
      real glat(imt,jmt)
      integer  ncid,iret
      integer iglatid
      integer corner(4), edges(4)
#ifdef netcdf_real4
      real (kind=4) , allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      iret=nf_open('forcing.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      iret=nf_inq_varid(ncid,'glat',iglatid)
      corner=1; edges(1)=imt; edges(2)=jmt
      allocate(var(imt,jmt) ); var=glat
      call ncvpt(ncid, iglatid, corner, edges,var, iret)
      call ncclos (ncid, iret)
      deallocate(var)
      end


      subroutine write_tau_to_cdf(tau,nt,k,time,toffset)
!     write the k.th time level
!     if k=1 then define variables
      use prep_module
      implicit none
#include "netcdf.inc"
      integer :: nt,n,k
      real :: tau(imt,jmt,2),time(nt),toffset

      integer  ncid,iret,i
      integer  itauxid,itauyid,timedim,timeid,tstrtid,taveid
      integer lon_udim,lat_udim
      integer  corner(4), edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4), allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      integer :: nn
c      integer :: nn,dpm(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
c      integer :: toffset = 0*365


      character(len=80) :: name,unit

      iret=nf_open('forcing_wind.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)

      if (k==1) then

      print*,' defining variable for taux,tauy in NetCDF file'
      iret=nf_redef(ncid)

      timedim  = ncddef(ncid, 'time_tau', nt, iret)

      dims(1)=timedim
      timeid = ncvdef (ncid,'time_tau', NCFLOAT,1,dims,iret)
      tstrtid = ncvdef (ncid,'tstrt_tau', NCFLOAT,1,dims,iret)
      taveid = ncvdef (ncid,'tave_tau', NCFLOAT,1,dims,iret)

      name = 'Time'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'long_name', NCCHAR, i, name, iret) 
      name = 'Start of averaging period'; i=len_trim(name)
      call ncaptc(ncid, tstrtid, 'long_name', NCCHAR, i, name, iret) 
      name = 'averaging period'; i=len_trim(name)
      call ncaptc(ncid, taveid, 'long_name', NCCHAR, i, name, iret) 
      name = 'days'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, taveid, 'units', NCCHAR, i, name, iret) 
      name = '01-JAN-0001 00:00:00'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'time_origin', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'time_origin', NCCHAR, i, name, iret) 

      name = 'noleap'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'calendar',NCCHAR,i,name,iret) 
      name = 'tstrt_tau'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'start_ave_period',NCCHAR,i,name,iret) 
      name = 'tave_tau'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'ave_period',NCCHAR,i,name,iret) 
c
      iret=nf_inq_dimid(ncid,'Longitude_u',lon_udim)
      iret=nf_inq_dimid(ncid,'Latitude_u',lat_udim)
      dims(1) = Lon_udim; dims(2) = Lat_udim; dims(3) = timedim
      itauxid   = ncvdef (ncid,'taux', NCFLOAT,3,dims,iret)
      itauyid   = ncvdef (ncid,'tauy', NCFLOAT,3,dims,iret)
      name = 'Zonal Wind Stress     '
      unit = 'dyn/cm^2'
      call dvcdf(ncid,itauxid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
      name = 'Meridional Wind Stress     '
      unit = 'dyn/cm^2'
      call dvcdf(ncid,itauyid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
      iret=nf_enddef(ncid)

      allocate(var(nt,1)); var(1,1)=time(1)+toffset
      do n=2,nt
       var(n,1)=var(n-1,1)+time(n)
      enddo
      do n=1,nt
       var(n,1)=var(n,1)-time(n)/2.
      enddo
      call ncvpt(ncid, timeid,1,nt,var, iret) ! mid points

      var(1,1)=toffset
      do n=2,nt
       var(n,1)=var(n-1,1)+time(n-1)
      enddo
      call ncvpt(ncid, tstrtid,1, nt,var, iret) ! start of avering period

      var(1:nt,1)=time(1:nt)
      call ncvpt(ncid, taveid, 1, nt,var, iret) ! averaging period
 
      deallocate(var)
      endif !k==1


      iret=nf_inq_varid(ncid,'taux',itauxid)
      iret=nf_inq_varid(ncid,'tauy',itauyid)

      edges(1)=imt; edges(2)=jmt; corner=1
      allocate(var(imt,jmt) )
      corner(3)=k; edges(3)=1
      var=tau(:,:,1)
      where( var == spval ) var = spval+100.
      where( kmu==0 ) var=spval
      call ncvpt(ncid, itauxid, corner, edges,var, iret)
      var=tau(:,:,2)
      where( var == spval ) var = spval+100.
      where( kmu==0 ) var=spval
      call ncvpt(ncid, itauyid, corner, edges,var, iret)
      call ncclos (ncid, iret)
      deallocate(var)
      end subroutine



      subroutine write_tr_to_cdf(tr_clim,tr_rest,tr_flux,
     &                                      time,toffset,nt,m,k)
!     write tracer restoring time scales, climatologies and 
!     net fluxes to netcdf file

      use prep_module
      implicit none
#include "netcdf.inc"
      integer nt,n,m ! m: number of tracer, nt : nr of all time steps
      integer :: k ! number of time step to be written
      real tr_clim(imt,jmt)
      real tr_rest(imt,jmt)
      real tr_flux(imt,jmt)
      real time(nt),toffset
      integer  ncid,iret,i
      integer  timedim,timeid,tstrtid,taveid
      integer  trrid,trfid,trcid
      integer  lon_tdim,lat_tdim
      integer  corner(4), edges(4),dims(4)
      character(len=80) :: name,unit
#ifdef netcdf_real4
      real (kind=4), allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      integer :: nn
      character(len=80) :: tr_name
c
c     determine name for tracer
c
      if     (m==1) then; tr_name = 'sst'
      elseif (m==2) then; tr_name = 'sss'
      else
       write(tr_name,'("str_",i2)') m
       call replace_space_zero(tr_name)
      endif
      if (m>2) then
       iret=nf_open('forcing_sflx_tracer.cdf',NF_WRITE,ncid)
      else
       iret=nf_open('forcing_sflx.cdf',NF_WRITE,ncid)
      endif
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      if (k==1) then ! define variable in netcdf file
       print*,' writing variable ',tr_name,' to NetCDF file'
       iret=nf_redef(ncid)
c
c     define time related quantities
       timedim  = ncddef(ncid,'time_'//tr_name, nt, iret)
       timeid = ncvdef (ncid,'time_'//tr_name, NCFLOAT,1,timedim,iret)
       tstrtid= ncvdef (ncid,'tstrt_'//tr_name,NCFLOAT,1,timedim,iret)
       taveid = ncvdef (ncid,'tave_'//tr_name, NCFLOAT,1,timedim,iret)
       name = 'Time'; i=len_trim(name)
       call ncaptc(ncid, timeid, 'long_name', NCCHAR, i, name, iret) 
       name = 'Start of averaging period'; i=len_trim(name)
       call ncaptc(ncid, tstrtid, 'long_name', NCCHAR, i, name, iret) 
       name = 'averaging period'; i=len_trim(name)
       call ncaptc(ncid, taveid, 'long_name', NCCHAR, i, name, iret) 
       name = 'days'; i=len_trim(name)
       call ncaptc(ncid, timeid, 'units', NCCHAR, i, name, iret) 
       call ncaptc(ncid, tstrtid,'units', NCCHAR, i, name, iret) 
       call ncaptc(ncid, taveid, 'units', NCCHAR, i, name, iret) 
       name = '01-JAN-0001 00:00:00'; i=len_trim(name)
       call ncaptc(ncid, timeid, 'time_origin', NCCHAR, i, name, iret) 
       call ncaptc(ncid, tstrtid,'time_origin', NCCHAR, i, name, iret) 
       name = 'noleap'; i=len_trim(name)
       call ncaptc(ncid, timeid, 'calendar',NCCHAR,i,name,iret) 
       name = 'tstrt_'//tr_name; i=len_trim(name)
       call ncaptc(ncid, timeid, 'start_ave_period',NCCHAR,i,name,iret) 
       name = 'tave_'//tr_name; i=len_trim(name)
       call ncaptc(ncid, timeid, 'ave_period',NCCHAR,i,name,iret) 
c
c    define tracer flux related variables
       iret=nf_inq_dimid(ncid,'Longitude_t',lon_tdim)
       iret=nf_inq_dimid(ncid,'Latitude_t',lat_tdim)
       dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = timedim
       name=tr_name(1:len_trim(tr_name))//'_clim'
       trcid   = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       name=tr_name(1:len_trim(tr_name))//'_rest'
       trrid   = ncvdef (ncid,name, NCFLOAT,3,dims,iret)
       name=tr_name(1:len_trim(tr_name))//'_flux'
       trfid   = ncvdef (ncid,name, NCFLOAT,3,dims,iret)

       if (m==1) then
        name = 'Appearant atmospheric temperature'; unit = 'deg C'
        call dvcdf(ncid,trcid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
        name = 'Haney coefficientf or SST'; unit = 'cal/s/cm**2/K'
        call dvcdf(ncid,trrid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
        name = 'Net heat flux'; unit = 'cal/s/cm**2'
        call dvcdf(ncid,trfid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
       elseif (m==2) then
        name = 'Climatological salinity'; unit = 'psu'
        call dvcdf(ncid,trcid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
        name = 'inverse restoring time scale '//
     &         'for SSS times 1. level thickness'; unit = 'cm/s'
        call dvcdf(ncid,trrid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
        name = 'Net salt flux'; unit = 'psu/s/cm**2'
        call dvcdf(ncid,trfid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
       else
        name = 'Climatological distribution'; unit = 'unknown'
        call dvcdf(ncid,trcid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
        name = 'Restoring time scale ' ; unit = 'cm/s'
        call dvcdf(ncid,trrid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
        name = 'Net tracer flux'; unit = 'unkown/s/cm**2'
        call dvcdf(ncid,trfid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
       endif ! m==1
       iret=nf_enddef(ncid)
c
c    store time related stuff
       allocate(var(nt,1)); var(1,1)=time(1)+toffset
       do n=2,nt; var(n,1)=var(n-1,1)+time(n); enddo
       do n=1,nt; var(n,1)=var(n,1)-time(n)/2.; enddo
       call ncvpt(ncid, timeid, 1, nt,var, iret)
       var(1,1)=toffset
       do n=2,nt; var(n,1)=var(n-1,1)+time(n-1); enddo
       call ncvpt(ncid, tstrtid, 1, nt,var, iret)
       var(1:nt,1)=time(1:nt)
       call ncvpt(ncid, taveid, 1, nt,var, iret)
       deallocate(var);
      endif ! k==1
c
c     store tracer flux
      name=tr_name(1:len_trim(tr_name))//'_clim'
      iret=nf_inq_varid(ncid,name,trcid)
      name=tr_name(1:len_trim(tr_name))//'_rest'
      iret=nf_inq_varid(ncid,name,trrid)
      name=tr_name(1:len_trim(tr_name))//'_flux'
      iret=nf_inq_varid(ncid,name,trfid)
      allocate(var(imt,jmt))
      var=tr_clim(:,:)
      call ncvpt(ncid,trcid, (/1,1,k/),(/imt,jmt,1/) ,var, iret)
      var=tr_rest(:,:)
      call ncvpt(ncid,trrid, (/1,1,k/),(/imt,jmt,1/) ,var, iret)
      var=tr_flux(:,:)
      call ncvpt(ncid,trfid, (/1,1,k/),(/imt,jmt,1/) ,var, iret)
      call ncclos (ncid, iret)
      deallocate(var)
      end subroutine



      subroutine write_ustar_to_cdf(ustar,nt,k,time,toffset)
!     write the k.th time level
!     if k=1 then define variables
      use prep_module
      implicit none
#include "netcdf.inc"
      integer :: nt,n,k, ncid,iret,i
      real :: ustar(imt,jmt),time(nt),toffset
      integer  ustarid,timedim,timeid,tstrtid,taveid
      integer lon_tdim,lat_tdim, corner(4), edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4), allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      integer :: nn

      character(len=80) :: name,unit

      iret=nf_open('forcing_wind.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)

      if (k==1) then

      print*,' defining variable for ustar in NetCDF file'
      iret=nf_redef(ncid)

      timedim  = ncddef(ncid, 'time_ustar', nt, iret)

      dims(1)=timedim
      timeid = ncvdef (ncid,'time_ustar', NCFLOAT,1,dims,iret)
      tstrtid = ncvdef (ncid,'tstrt_ustar', NCFLOAT,1,dims,iret)
      taveid = ncvdef (ncid,'tave_ustar', NCFLOAT,1,dims,iret)

      name = 'Time'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'long_name', NCCHAR, i, name, iret) 
      name = 'Start of averaging period'; i=len_trim(name)
      call ncaptc(ncid, tstrtid, 'long_name', NCCHAR, i, name, iret) 
      name = 'averaging period'; i=len_trim(name)
      call ncaptc(ncid, taveid, 'long_name', NCCHAR, i, name, iret) 
      name = 'days'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, taveid, 'units', NCCHAR, i, name, iret) 
      name = '01-JAN-0001 00:00:00'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'time_origin', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'time_origin', NCCHAR, i, name, iret) 

      name = 'noleap'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'calendar',NCCHAR,i,name,iret) 
      name = 'tstrt_ustar'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'start_ave_period',NCCHAR,i,name,iret) 
      name = 'tave_ustar'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'ave_period',NCCHAR,i,name,iret) 
c
      iret=nf_inq_dimid(ncid,'Longitude_t',lon_tdim)
      iret=nf_inq_dimid(ncid,'Latitude_t',lat_tdim)
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = timedim

      ustarid   = ncvdef (ncid,'ustar', NCFLOAT,3,dims,iret)
      name = 'Surface friction velocity (**3)'
      unit = '(cm/s)^3'
      call dvcdf(ncid,ustarid,name,len_trim(name),
     &                 unit,len_trim(unit),spval)

      iret=nf_enddef(ncid)

      allocate(var(nt,1)); var(1,1)=time(1)+toffset
      do n=2,nt
       var(n,1)=var(n-1,1)+time(n)
      enddo
      do n=1,nt
       var(n,1)=var(n,1)-time(n)/2.
      enddo
      call ncvpt(ncid, timeid,1,nt,var, iret) ! mid points

      var(1,1)=toffset
      do n=2,nt
       var(n,1)=var(n-1,1)+time(n-1)
      enddo
      call ncvpt(ncid, tstrtid,1, nt,var, iret) ! start of avering period

      var(1:nt,1)=time(1:nt)
      call ncvpt(ncid, taveid, 1, nt,var, iret) ! averaging period
 
      deallocate(var)
      endif !k==1

      iret=nf_inq_varid(ncid,'ustar',ustarid)

      edges(1)=imt; edges(2)=jmt; corner=1
      allocate(var(imt,jmt) )
      corner(3)=k; edges(3)=1
      var=ustar
      call ncvpt(ncid,ustarid, corner, edges,var, iret)
      call ncclos (ncid, iret)
      deallocate(var)
      end subroutine




      subroutine write_blue_to_cdf(temp,salt,nt,month)
      use prep_module
      implicit none
#include "netcdf.inc"
      integer nt,n,month
      real temp(imt,jmt,km),salt(imt,jmt,km)

      integer ncid,iret,i
      integer tid,sid,timedim,timeid,tstrtid,taveid
      integer lon_tdim,lat_tdim,depth_tdim
      integer corner(4), edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4), allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      integer :: nn,dpm(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
      integer :: toffset = 0*365
      character(len=80) :: name,unit

      iret=nf_open('forcing_ic.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)

      if (month==1) then

       print*,' defining variables for blue T/S'

      iret=nf_redef(ncid)

      i=nt; timedim  = ncddef(ncid, 'time_blue', i, iret)

      dims(1)=timedim;i=1
      timeid = ncvdef (ncid,'time_blue', NCFLOAT,i,dims,iret)
      tstrtid = ncvdef (ncid,'tstrt_blue', NCFLOAT,i,dims,iret)
      taveid = ncvdef (ncid,'tave_blue', NCFLOAT,i,dims,iret)

      name = 'Time'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'long_name', NCCHAR, i, name, iret) 

      name = 'Start of averaging period'; i=len_trim(name)
      call ncaptc(ncid, tstrtid, 'long_name', NCCHAR, i, name, iret) 

      name = 'averaging period'; i=len_trim(name)
      call ncaptc(ncid, taveid, 'long_name', NCCHAR, i, name, iret) 

      name = 'days'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, taveid, 'units', NCCHAR, i, name, iret) 
      name = '01-JAN-0001 00:00:00'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'time_origin', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid, 'time_origin', NCCHAR, i, name, iret) 

      name = 'noleap'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'calendar',NCCHAR,i,name,iret) 
      name = 'tstrt_blue'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'start_ave_period',NCCHAR,i,name,iret) 
      name = 'tave_blue'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'ave_period',NCCHAR,i,name,iret) 
c
      iret=nf_inq_dimid(ncid,'Longitude_t',lon_tdim)
      iret=nf_inq_dimid(ncid,'Latitude_t',lat_tdim)
      iret=nf_inq_dimid(ncid,'depth_t',depth_tdim)
      dims = (/Lon_tdim, Lat_tdim, depth_tdim, timedim/); i=4
      tid   = ncvdef (ncid,'temp_blue', NCFLOAT,i,dims,iret)
      sid   = ncvdef (ncid,'salt_blue', NCFLOAT,i,dims,iret)

      name = 'BLUE temperature'
      unit = 'degC'
      call dvcdf(ncid,tid,name,
     &     len_trim(name),unit,len_trim(unit),spval)
      name = 'BLUE salinity'
      unit = '(psu-35)/1000'
      call dvcdf(ncid,sid,name,
     &     len_trim(name),unit,len_trim(unit),spval)

      iret=nf_enddef(ncid)

      allocate(var(nt,1)); var(1,1)=dpm(1)+toffset
      do n=2,nt
       nn=mod(n-1,12)+1; var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      do n=1,nt
       nn=mod(n-1,12)+1; var(n,1)=var(n,1)-dpm(nn)/2.
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, timeid, corner, edges,var, iret)

      var(1,1)=toffset
      do n=2,nt
       nn=mod(n-2,12)+1; 
       var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, tstrtid, corner, edges,var, iret)

      do n=1,nt
       nn=mod(n-1,12)+1; 
       var(n,1)=dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, taveid, corner, edges,var, iret)
      deallocate(var)

       print*,' done '
      else
       iret=nf_inq_varid(ncid,'temp_blue',tid)
       iret=nf_inq_varid(ncid,'salt_blue',sid)
      endif !month == 1

      print*,' writing T/S for BLUE and month=',month
      allocate(var(imt,jmt) )
      do n=1,km
       edges = (/imt,jmt,1,1/)
       corner = (/1,1,n,month/)
       var=temp(:,:,n)
       call ncvpt(ncid,tid, corner, edges,var, iret)
       var=salt(:,:,n)
       call ncvpt(ncid,sid, corner, edges,var, iret)
      enddo
      call ncclos (ncid, iret)
      deallocate(var)

      end



      subroutine write_ic_to_cdf(tr,key)
!     write 3-D tracer fields
!     to netcdf file which is defined in init_out_cdf
!     either a certain month as initial conditions or annual values

      use prep_module
      implicit none
#include "netcdf.inc"
      character (len=*),intent(in) :: key 
      integer n,k,m
      real :: tr(imt,jmt,km,number_tr)
      integer  ncid1,iret,i,ncid2
      integer  trid(number_tr)
      integer  lon_tdim,lat_tdim,depth_dim
      integer  corner(4), edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4) , allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      character(len=80) :: name,unit

      if (key == 'initial') then
       print*,' writing initial conditions to NetCDF file '
      elseif (key == 'mean') then
       print*,' writing mean tracer to NetCDF file '
      else
       print*,' ERROR: wrong key in write_ic_to_cdf'
       print*,' got ',key
       print*,' but should be either mean or initial'
       call halt_stop('in write_ic_to_cdf')
      endif

      iret=nf_open('forcing_ic.cdf',NF_WRITE,ncid1)
      iret=nf_set_fill(ncid1, NF_NOFILL, iret)
      iret=nf_redef(ncid1)
c
      iret=nf_inq_dimid(ncid1,'Longitude_t',lon_tdim)
      iret=nf_inq_dimid(ncid1,'Latitude_t',lat_tdim)
      iret=nf_inq_dimid(ncid1,'depth_t',depth_dim)

      if (number_tr>2) then
       iret=nf_open('forcing_ic_tracer.cdf',NF_WRITE,ncid2)
       iret=nf_set_fill(ncid2, NF_NOFILL, iret)
       iret=nf_redef(ncid2)
c
       iret=nf_inq_dimid(ncid2,'Longitude_t',lon_tdim)
       iret=nf_inq_dimid(ncid2,'Latitude_t',lat_tdim)
       iret=nf_inq_dimid(ncid2,'depth_t',depth_dim)
      endif

      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = depth_dim

      if (key == 'initial') then
       trid(1)   = ncvdef (ncid1,'temp_ic', NCFLOAT,3,dims,iret)
       trid(2)   = ncvdef (ncid1,'salt_ic', NCFLOAT,3,dims,iret)

       name = 'Initial condition temperature'
       unit = 'deg C'
       call dvcdf(ncid1,trid(1),name,len_trim(name),
     &            unit,len_trim(unit),spval)

       name = 'Initial condition salinity'
       unit = 'psu'
       call dvcdf(ncid1,trid(2),name,len_trim(name),
     &            unit,len_trim(unit),spval)

       do m=3,number_tr

        write(name,'("tracer_",i2,"_ic")') m
        call replace_space_zero(name)
        trid(m)  = ncvdef (ncid2,name, NCFLOAT,3,dims,iret)

        write(name,'("tracer_",i2)') m
        call replace_space_zero(name)
        name = 'Initial condition for '//name
        unit = 'unknown'
        call dvcdf(ncid2,trid(m),name,len_trim(name),
     &             unit,len_trim(unit),spval)

       enddo

      elseif (key == 'mean') then

       trid(1)   = ncvdef (ncid1,'temp_mean', NCFLOAT,3,dims,iret)
       trid(2)   = ncvdef (ncid1,'salt_mean', NCFLOAT,3,dims,iret)

       name = 'Annual mean temperature'
       unit = 'deg C'
       call dvcdf(ncid1,trid(1),name,len_trim(name),
     &            unit,len_trim(unit),spval)

       name = 'Annual mean salinity'
       unit = 'psu'
       call dvcdf(ncid1,trid(2),name,len_trim(name),
     &            unit,len_trim(unit),spval)

       do m=3,number_tr

        write(name,'("tracer_",i2,"_mean")') m
        call replace_space_zero(name)
        trid(m)  = ncvdef (ncid2,name, NCFLOAT,3,dims,iret)

        write(name,'("tracer_",i2)') m
        call replace_space_zero(name)
        name = 'Annual mean '//name
        unit = 'unknown'
        call dvcdf(ncid2,trid(m),name,len_trim(name),
     &            unit,len_trim(unit),spval)

       enddo

      endif

      iret=nf_enddef(ncid1)

      edges(1)=imt; edges(2)=jmt; edges(3)=km; corner=1
      
      allocate(var(imt,jmt) )
      do k=1,km
       corner(3)=k; edges(3)=1
c       do m=1,number_tr
       do m=1,2
         var=tr(:,:,k,m)
         call ncvpt(ncid1,trid(m), corner, edges,var, iret)
       enddo
      enddo
      call ncclos (ncid1, iret)

      if (number_tr>2) then
       iret=nf_enddef(ncid2)
       do k=1,km
        corner(3)=k; edges(3)=1
        do m=3,number_tr
         var=tr(:,:,k,m)
         call ncvpt(ncid2,trid(m), corner, edges,var, iret)
        enddo
       enddo
       call ncclos (ncid2, iret)
      endif

      deallocate(var)
      end subroutine





      subroutine write_blue_mean_to_cdf(temp,salt)
!     write 3-D temperature and salinity fields
!     to netcdf file which is defined in init_out_cdf
!     here the annual values for BLUE mean

      use prep_module
      implicit none
#include "netcdf.inc"
      integer n,k
      real :: temp(imt,jmt,km),salt(imt,jmt,km)
      integer  ncid,iret,i
      integer  itid,isid
      integer  lon_tdim,lat_tdim,depth_dim
      integer  corner(4), edges(4),dims(4)
#ifdef netcdf_real4
      real (kind=4) , allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      character(len=80) :: name,unit

      print*,' writing mean T/S for BLUE mean to NetCDF file '

      iret=nf_open('forcing_ic.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      iret=nf_redef(ncid)
c
      iret=nf_inq_dimid(ncid,'Longitude_t',lon_tdim)
      iret=nf_inq_dimid(ncid,'Latitude_t',lat_tdim)
      iret=nf_inq_dimid(ncid,'depth_t',depth_dim)
      dims(1) = Lon_tdim; dims(2) = Lat_tdim; dims(3) = depth_dim; i=3


      itid   = ncvdef (ncid,'temp_blue_mean', NCFLOAT,i,dims,iret)
      isid   = ncvdef (ncid,'salt_blue_mean', NCFLOAT,i,dims,iret)

      name = 'Annual mean correction temperature'
      unit = 'deg C'
      call dvcdf(ncid,itid,name,
     &     len_trim(name),unit,len_trim(unit),spval)

      name = 'Annual mean correction salinity'
      unit = 'psu'
      call dvcdf(ncid,isid,name,
     &     len_trim(name),unit,len_trim(unit),spval)

      iret=nf_enddef(ncid)

      edges(1)=imt; edges(2)=jmt; edges(3)=km; corner=1
      
      allocate(var(imt,jmt) )
      do k=1,km
       corner(3)=k; edges(3)=1
       var=temp(:,:,k)
       call ncvpt(ncid,itid, corner, edges,var, iret)
       var=salt(:,:,k)
       call ncvpt(ncid,isid, corner, edges,var, iret)
      enddo
      call ncclos (ncid, iret)
      deallocate(var)
      end subroutine


      subroutine write_ts_to_file(n,tr)
c
c     write all tracer to temporary file for month n
c
      use prep_module
      implicit none
      integer n,k,nn,m
      real :: tr(imt,jmt,km,number_tr)
      integer :: io
      print*,' writing TS for time step ',n,' to file ts.dta'

      call getunit(io,'ts.dta','usr ieee')
      do nn=1,n-1
       do k=1,km
        do m=1,number_tr
         read(io)
        enddo
       enddo
      enddo
      do k=1,km
       do m=1,number_tr
         write(io) tr(1:imt,1:jmt,k,m)
       enddo
      enddo
      close(io)
      end subroutine

      subroutine read_ts_from_file(n,tr)
c
c     read all tracer from temporary file for month n
c
      use prep_module
      implicit none
      integer n,k,nn,m
      real :: tr(imt,jmt,km,number_tr)
      integer :: io
      print*,' reading TS for time step ',n,' from file ts.dta'

      call getunit(io,'ts.dta','usr ieee')
      do nn=1,n-1
       do k=1,km
        do m=1,number_tr
         read(io)
        enddo
       enddo
      enddo
      do k=1,km
       do m=1,number_tr
         read(io) tr(1:imt,1:jmt,k,m)
       enddo
      enddo
      close(io)
      end subroutine

      subroutine read_atr_from_file(n,ntr,tr)
c
c     read a single tracer from temporary file for month n
c
      use prep_module
      implicit none
      integer n,k,nn,m,ntr
      real :: tr(imt,jmt,km)
      integer :: io
      print*,' reading TS for time step ',n,' from file ts.dta'

      call getunit(io,'ts.dta','usr ieee')
      do nn=1,n-1
       do k=1,km
        do m=1,number_tr
         read(io)
        enddo
       enddo
      enddo
      do k=1,km
       do m=1,ntr-1
         read(io) 
       enddo
       read(io) tr(1:imt,1:jmt,k)
       do m=ntr+1,number_tr
         read(io) 
       enddo
      enddo
      close(io)
      end subroutine


       subroutine write_obc_to_cdf(psi,orient,nt)
c
c      take psi profile as input for OBC and write
c      to netcdf file.
c
c      Tracer data are read from ts.dta
c
       use prep_module
       implicit none
       character (len=1) ::  orient  ! is 'n' for north, 's','w' or 'e'
       integer ::nt
c       real :: psi(nt,max(imt,jmt))
       real :: psi(nt,*)

#include "netcdf.inc"
       integer iret,ncid,timedim,dims(3),timeid,tstrtid,taveid
       integer zdim,xdim,ydim,trid(number_tr),psiid
       character (len=80) :: border,name,unit
       character (len=4) :: tr_name(number_tr)
#ifdef netcdf_real4
       real (kind=4), allocatable :: var(:,:)
#else
       real , allocatable :: var(:,:)
#endif
       integer edges(3),corner(3)
       integer :: dpm(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
       integer :: toffset = 0*365,n,k,nn,i
       integer :: io,m
       real :: ts(imt,jmt)

       if (orient=='s') border='south'
       if (orient=='n') border='north'
       if (orient=='w') border='west'
       if (orient=='e') border='east'

       iret=nf_open('forcing_obc.cdf',NF_WRITE,ncid)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)
       iret=nf_inq_dimid(ncid,'Longitude_t',xdim)
       iret=nf_inq_dimid(ncid,'Latitude_t',ydim)
       iret=nf_inq_dimid(ncid,'depth_t',zdim)

       iret=nf_redef(ncid)
       timedim  = ncddef(ncid, 'time_obc_'//border, nt, iret)
       dims(1)=timedim
       timeid = ncvdef (ncid,'time_obc_'//border, NCFLOAT,1,dims,iret)
       tstrtid= ncvdef(ncid,'tstrt_obc_'//border, NCFLOAT,1,dims,iret)
       taveid = ncvdef (ncid,'tave_obc_'//border, NCFLOAT,1,dims,iret)


       name = 'Time'; i=len_trim(name)
       call ncaptc(ncid, timeid, 'long_name', NCCHAR, i, name, iret) 
       name = 'Start of averaging period'; i=len_trim(name)
       call ncaptc(ncid, tstrtid, 'long_name', NCCHAR, i, name, iret) 
       name = 'averaging period'; i=len_trim(name)
       call ncaptc(ncid, taveid, 'long_name', NCCHAR, i, name, iret) 

       name = 'days'; i=len_trim(name)
       call ncaptc(ncid, timeid, 'units', NCCHAR, i, name, iret) 
       call ncaptc(ncid, tstrtid,'units', NCCHAR, i, name, iret) 
       call ncaptc(ncid, taveid, 'units', NCCHAR, i, name, iret) 
       name = '01-JAN-0001 00:00:00'; i=len_trim(name)
       call ncaptc(ncid, timeid, 'time_origin', NCCHAR, i, name, iret) 
       call ncaptc(ncid, tstrtid,'time_origin', NCCHAR, i, name, iret) 

       name = 'noleap'; i=len_trim(name)
       call ncaptc(ncid, timeid, 'calendar',NCCHAR,i,name,iret) 
       name = 'tstrt_obc_'//border; i=len_trim(name)
       call ncaptc(ncid, timeid, 'start_ave_period',NCCHAR,i,name,iret) 
       name = 'tave_obc_'//border; i=len_trim(name)
       call ncaptc(ncid, timeid, 'ave_period',NCCHAR,i,name,iret) 
c
       dims=(/xdim,zdim,timedim/)
       if (orient=='w'.or.orient=='e') dims(1)=ydim

       do m=1,number_tr

        if (m==1) then
         tr_name(m) = 'temp'
        elseif (m==2) then
         tr_name(m) = 'salt'
        else
         write(tr_name(m),'("tr",i2)') m
         call replace_space_zero(tr_name(m))
        endif

        trid(m)= ncvdef (ncid,tr_name(m)//'_obc_'//border,
     &                   NCFLOAT,3,dims,iret)
       enddo


       dims(2)=timedim
       psiid  = ncvdef (ncid,'psi_obc_'//border,NCFLOAT,2,dims,iret)

       name = 'Temperature for open boundary at the '//border
       unit = 'deg C'
       call dvcdf(ncid,trid(1),name,len_trim(name),unit,
     &            len_trim(unit),spval)

       name = 'Salinity for open boundary at the '//border
       unit = 'psu'
       call dvcdf(ncid,trid(2),name,len_trim(name),unit,
     &            len_trim(unit),spval)

       do m=1,number_tr
        name = tr_name(m)//' for open boundary at the '//border
        unit = 'psu'
        call dvcdf(ncid,trid(m),name,len_trim(name),unit,
     &             len_trim(unit),spval)
       enddo


       name = 'Streamfunction for open boundary at the '//border
       unit = '1^12 Sv'
       call dvcdf(ncid,psiid,name,len_trim(name),unit,
     &            len_trim(unit),spval)

       iret=nf_enddef(ncid)

c write time variables
       allocate(var(nt,1)); var(1,1)=dpm(1)+toffset
       do n=2,nt
        nn=mod(n-1,12)+1; var(n,1)=var(n-1,1)+dpm(nn)
       enddo
       do n=1,nt
        nn=mod(n-1,12)+1; var(n,1)=var(n,1)-dpm(nn)/2.
       enddo
       corner=1;edges=nt
       call ncvpt(ncid, timeid, corner, edges,var, iret)

       var(1,1)=toffset
       do n=2,nt
        nn=mod(n-2,12)+1; 
        var(n,1)=var(n-1,1)+dpm(nn)
       enddo
       corner=1;edges=nt
       call ncvpt(ncid, tstrtid, corner, edges,var, iret)

       do n=1,nt
        nn=mod(n-1,12)+1; 
        var(n,1)=dpm(nn)
       enddo
       corner=1;edges=nt
       call ncvpt(ncid, taveid, corner, edges,var, iret)
       deallocate(var)

c write psi

       corner=1; edges(2)=1
       if (orient=='w'.or.orient=='e') then
         allocate(var(jmt,1)) 
         edges(1)=jmt
       else
         allocate(var(imt,1)) 
         edges(1)=imt
       endif
       do n=1,nt
        corner(2)=n
        if (orient=='n') var(:,1)=psi(n,1:imt)
        if (orient=='s') var(:,1)=psi(n,1:imt)
        if (orient=='e') var(:,1)=psi(n,1:jmt)
        if (orient=='w') var(:,1)=psi(n,1:jmt)
        call ncvpt(ncid, psiid, corner, edges,var, iret)
       enddo
       deallocate(var)

c write temp/sal
      
       corner=1; edges(2:3)=(/1,1/)
       if (orient=='w'.or.orient=='e') then
         allocate(var(jmt,1)) 
         edges(1)=jmt
       else
         allocate(var(imt,1)) 
         edges(1)=imt
       endif

       call getunit(io,'ts.dta','usr ieee')
       do n=1,nt
        corner(3)=n
        do k=1,km
         corner(2)=k
         do m=1,number_tr
          read(io) ts(:,:)
          if (orient=='n') var(:,1)=ts(:,jmt-1)
          if (orient=='s') var(:,1)=ts(:,2)
          if (orient=='e') var(:,1)=ts(imt-1,:)
          if (orient=='w') var(:,1)=ts(2,:)
          call ncvpt(ncid, trid(m), corner, edges,var, iret)
         enddo ! m
        enddo ! k
       enddo ! n
       close(io)
       deallocate(var)

       call ncclos (ncid, iret)

       end subroutine write_obc_to_cdf



      subroutine write_spg_to_cdf(tscl,tr,is,ie,js,je,nt,nl,ntr)
      use prep_module
      implicit none
      integer , intent(in) :: nl,ntr
      integer is,ie,js,je,nt
      real tscl(is:ie,js:je,km)
      real tr(is:ie,js:je,km)
#include "netcdf.inc"
      integer ncid,iret,nsp,i
      character(len=2):: number
      character(len=4):: tr_name
      character(len=80):: name,unit
      integer londim,latdim,depthdim,lonid,latid,trid,tsclid
      integer timedim,timeid,tstrtid,taveid
      integer dims(4),edges(4),corner(4)
#ifdef netcdf_real4
      real (kind=4), allocatable :: var(:,:)
#else
      real , allocatable :: var(:,:)
#endif
      integer :: dpm(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)
      integer :: toffset = 0*365,nn,n,k
      
c see how many sponge layers are already defined
      iret=nf_open('forcing_sponge.cdf',NF_noWRITE,ncid)
      iret= nf_get_att_int(ncid,nf_global,'number_of_sponge_layers',nsp)
      if (iret /= 0) nsp = 0
      call ncclos (ncid, iret)

      if (nl==1 .and. ntr==1) then
       nsp = nsp+1
       print*,' defining sponge layer # ',nsp
       print*,' for tracer #',ntr
      elseif (nl==1 .and. ntr>1) then
       print*,' defining tracer #',ntr,' in sponge layer #',nsp
      else
       print*,' writing data for sponge layer # ',nsp
       print*,' for tracer #',ntr
       print*,' for month = ',nl
      endif ! nl==1

      write(number,'(i2)') nsp
      if (number(1:1) == ' ') number(1:1)='0'

      if (ntr==1) then
         tr_name = 'temp'
      elseif (ntr==2) then
         tr_name = 'salt'
      else
       write(tr_name,'("tr",i2)') ntr
       call replace_space_zero(tr_name)
      endif

      iret=nf_open('forcing_sponge.cdf',NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
  
      if (nl==1) then

      iret=nf_redef(ncid)
c redefine number of sponge layers
      iret= nf_put_att_int(ncid,nf_global,'number_of_sponge_layers',
     &       nf_int,1,nsp)

c define time variables for the sponge layer
      name = 'time_spg_'//number//'_'//tr_name
      timedim  = ncddef(ncid, name, nt, iret)

      dims(1)=timedim
      name = 'time_spg_'//number//'_'//tr_name
      timeid = ncvdef (ncid,name, NCFLOAT,1,dims,iret)
      name = 'tstrt_spg_'//number//'_'//tr_name
      tstrtid= ncvdef(ncid,name, NCFLOAT,1,dims,iret)
      name = 'tave_spg_'//number//'_'//tr_name
      taveid = ncvdef (ncid,name, NCFLOAT,1,dims,iret)

      name = 'Time'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'long_name', NCCHAR, i, name, iret) 
      name = 'Start of averaging period'; i=len_trim(name)
      call ncaptc(ncid, tstrtid, 'long_name', NCCHAR, i, name, iret) 
      name = 'averaging period'; i=len_trim(name)
      call ncaptc(ncid, taveid, 'long_name', NCCHAR, i, name, iret) 

      name = 'days'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid,'units', NCCHAR, i, name, iret) 
      call ncaptc(ncid, taveid, 'units', NCCHAR, i, name, iret) 
      name = '01-JAN-0001 00:00:00'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'time_origin', NCCHAR, i, name, iret) 
      call ncaptc(ncid, tstrtid,'time_origin', NCCHAR, i, name, iret) 

      name = 'noleap'; i=len_trim(name)
      call ncaptc(ncid, timeid, 'calendar',NCCHAR,i,name,iret) 
      name = 'tstrt_spg_'//number//'_'//tr_name; i=len_trim(name)
      call ncaptc(ncid, timeid, 'start_ave_period',NCCHAR,i,name,iret) 
      name = 'tave_spg_'//number//'_'//tr_name; i=len_trim(name)
      call ncaptc(ncid, timeid, 'ave_period',NCCHAR,i,name,iret) 

      if (ntr==1) then
c
c define grid variables for the sponge layer
c
       i=ie-is+1
       londim  = ncddef(ncid, 'Lon_spg_'//number,i, iret)
       i=je-js+1
       latdim  = ncddef(ncid, 'Lat_spg_'//number,i, iret)
       iret=nf_inq_dimid(ncid,'depth_t',depthdim)

       dims(1)=londim
       Lonid  = ncvdef (ncid,'Lon_spg_'//number,NCFLOAT,1,dims,iret)
       dims(1)=latdim
       Latid  = ncvdef (ncid,'Lat_spg_'//number,NCFLOAT,1,dims,iret)

       name = 'Longitude of sponge layer #'//number
       unit = 'degrees_W       '
       i=len_trim(name)
       call ncaptc(ncid, Lonid, 'long_name', NCCHAR, i, name, iret) 
       i=len_trim(unit)
       call ncaptc(ncid, Lonid, 'units',     NCCHAR, i, unit, iret) 

       name = 'Latitude of sponge layer #'//number
       unit = 'degrees_N       '
       i=len_trim(name)
       call ncaptc(ncid, Latid, 'long_name', NCCHAR, i, name, iret) 
       i=len_trim(unit)
       call ncaptc(ncid, Latid, 'units',     NCCHAR, i, unit, iret) 
      else
       iret=nf_inq_dimid(ncid,'Lon_spg_'//number,londim)
       iret=nf_inq_dimid(ncid,'Lat_spg_'//number,latdim)
       iret=nf_inq_dimid(ncid,'depth_t',depthdim)
      endif
c
c define variable for tracers and time scale
c
      dims(1)=londim; dims(2)=latdim; dims(3)=depthdim; dims(4)=timedim
      trid = ncvdef (ncid,tr_name//'_spg_'//number,NCFLOAT,4,dims,iret)


      dims(1)=londim; dims(2)=latdim; dims(3)=depthdim; dims(4)=timedim
      tsclid  = ncvdef (ncid,
     &          tr_name//'_tscl_spg_'//number,NCFLOAT,4,dims,iret)

      if (ntr==1) then
      name = 'Temperature for sponge layer #'//number
      unit = 'deg C'
      elseif (ntr==2) then
      name = 'Salinity for sponge layer #'//number
      unit = 'psu'
      else
       name = tr_name//' for sponge layer #'//number
       unit = 'unknown'
      endif
      call dvcdf(ncid,trid,name,len_trim(name),unit,
     &           len_trim(unit),spval)
      dims=(/is,ie,js,je/)
      iret= nf_put_att_int(ncid,trid,'range',nf_int,4,dims)

      name = 'Inverse time scale for '//tr_name
     &         //' of sponge layer #'//number
      unit = '1/s'
      call dvcdf(ncid,tsclid,name,len_trim(name),unit,
     &           len_trim(unit),spval)
      iret= nf_put_att_int(ncid,tsclid,'range',nf_int,4,dims)

      iret=nf_enddef(ncid)

      if (ntr==1) then
c write grid variables

       allocate(var(is:ie,1)); var(is:ie,1)=xt(is:ie)
       corner=1;edges=ie-is+1
       call ncvpt(ncid, lonid, corner, edges,var(is,1), iret)
       deallocate(var)

       allocate(var(js:je,1)); var(js:je,1)=yt(js:je)
       corner=1;edges=je-js+1
       call ncvpt(ncid, latid, corner, edges,var(js,1), iret)
       deallocate(var)

      endif

c write time variables
      allocate(var(nt,1)); var(1,1)=dpm(1)+toffset
      do n=2,nt
       nn=mod(n-1,12)+1; var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      do n=1,nt
       nn=mod(n-1,12)+1; var(n,1)=var(n,1)-dpm(nn)/2.
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, timeid, corner, edges,var, iret)

      var(1,1)=toffset
      do n=2,nt
       nn=mod(n-2,12)+1; 
       var(n,1)=var(n-1,1)+dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, tstrtid, corner, edges,var, iret)

      do n=1,nt
       nn=mod(n-1,12)+1; 
       var(n,1)=dpm(nn)
      enddo
      corner=1;edges=nt
      call ncvpt(ncid, taveid, corner, edges,var, iret)
      deallocate(var)

      endif ! nl==1

c write temp/sal
      iret=nf_inq_varid(ncid,tr_name//'_spg_'//number,trid)
      iret=nf_inq_varid(ncid,tr_name//'_tscl_spg_'//number,tsclid)

      allocate(var(is:ie,js:je)) 
      corner=1;
      edges(1)=ie-is+1;edges(2)=je-js+1; 
      edges(3)=1; edges(4)=1
      corner(4)=nl
      do k=1,km
        corner(3)=k
        var(is:ie,js:je)=tr(is:ie,js:je,k)
        call ncvpt(ncid, trid, corner, edges,var(is,js), iret)
        var(is:ie,js:je)=tscl(is:ie,js:je,k)
        call ncvpt(ncid, tsclid, corner, edges,var(is,js), iret)
      enddo

      deallocate(var)
      call ncclos (ncid, iret)

      print*,'done'

      end subroutine



      subroutine dvcdf(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c     define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character (len=*) :: name, unit
      real :: spval
#ifdef netcdf_real4
      real (kind=4) :: vv
#else
      real :: vv
#endif
#include "netcdf.inc"
      vv=spval
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncapt (ncid,ivarid, 'missing_value',NCFLOAT,1,vv,iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncapt (ncid,ivarid, '_FillValue', NCFLOAT, 1,vv, iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf

#include "options.inc"

c
c local defines for isopycnal mixing
c
c


c standard MOM tapering of diff. in case of strong slopes
#define dm_taper
c gerdes koeberle willebrand tapering, however does not work good
c#define gkw_taper

c disable vertical tapering for ahsteep
c does not work for athkdf = ahsteep
#define disable_vertical_tapering_ahsteep
c
c disable entire module for quicker compilation
c
c#define disable_isoneutral_module

c
      module isoneutral_module
c
c-----------------------------------------------------------------------
c     Isoneutral diffusion module for SPFLAME taken from MOM 3
c
c     Original authors:
c           R.C.Pacanowski   rcp@gfdl.gov 
c           S.M.Griffies     smg@gfdl.gov 
c
c     subroutine isoneutral_init is called within routine setup
c
c     subroutine isoneutral is called within routine spflame
c
c     subroutine isoneutralflux is called within tracer
c     see also some other modifications in tracer
c
c     subroutine isoneutral_add_K33 is called from vmixc.F
c
c     subroutine isoneutral_adv is called from diag_snap
c
c     four parameters has to be specified in main namelist 
c     parameters are in spflame_module as well as a switch to
c     enable isoneutral diffusion
c
c                               Jul 2001   c.eden
c-----------------------------------------------------------------------
c

#ifndef disable_isoneutral_module

c      private

#if defined  IRIX_host || defined ALPHA_host || defined LINUX_host || defined SUN_host 
      real,parameter :: epsln=1.0e-15  ! for single precision
#else
      real,parameter :: epsln=1.0e-20  ! for double precision
#endif

c-----------------------------------------------------------------------
c Arrays and scalars used for all isoneutral mixing schemes.
c-----------------------------------------------------------------------

      real, allocatable :: drho(:,:,:,:)
      real, allocatable :: ddxt(:,:,:,:)
      real, allocatable :: ddyt(:,:,:,:)
      real, allocatable :: ddzt(:,:,:,:)
      real, allocatable :: fzisop(:),agm(:,:)
      real redi_gm(6)
c
c-----------------------------------------------------------------------
c Arrays for either Redi diffusion or Gent McWilliams stirring
c     Ai_ez  = slope*diffusion coefficient on eastern face of T cell
c     Ai_nz  = slope*diffusion coefficient on northern face of T cell
c     Ai_bx  = slope*diffusion coefficient on bottom face of T cell
c     Ai_by  = slope*diffusion coefficient on bottom face of T cell
c-----------------------------------------------------------------------
c
      real, allocatable :: Ai_ez(:,:,:,:,:)
      real, allocatable :: Ai_nz(:,:,:,:,:)
      real, allocatable :: Ai_bx(:,:,:,:,:)
      real, allocatable :: Ai_by(:,:,:,:,:)
c
c-----------------------------------------------------------------------
c Arrays and scalars for just Redi diffusion
c
c Arrays
c     K11,K22,K33 = diagonal components to the Redi diffusion tensor.
c-----------------------------------------------------------------------
c
      real, allocatable :: K11(:,:,:)
      real, allocatable :: K22(:,:,:)
      real, allocatable :: K33(:,:,:)
#ifdef partial_cell
c
c     twice the thickness of quarter cells within T-cells
c     0 is for upper quarter cell and 1 is for lower quarter cell
c
      real, allocatable         :: delqc(:,:,:,:)
#endif
c
#endif

      end module isoneutral_module
c
      subroutine isoneutral_init
c
c=======================================================================
c
c      Initialization for isoneutral mixing schemes.  Each scheme
c      can be turned on alone, or in combination with any of 
c      the others.
c           R.C.Pacanowski   rcp@gfdl.gov 
c           S.M.Griffies     smg@gfdl.gov 
c=======================================================================
c
#ifndef disable_isoneutral_module
      use spflame_module
      use isoneutral_module
      implicit none
      real :: c0=0.,c1=1.0,c2=2.0
      integer :: stdout=6
      integer is,ie,js,je
      integer i,j,k
      real delta1a,delta1b,ft1,delta_iso1
      integer i_delta1,j_delta1,k_delta1

      if (my_pe==0) then
       print*,''
       print*,' Initialization of isoneutral mixing scheme' 
       print*,''
       print*,'   ahisop  = ',ahisop, ' cm^2/s '
       print*,'   athkdf  = ',athkdf, ' cm^2/s '
       print*,'   ahsteep = ',ahsteep,' cm^2/s '
       print*,'   slmx    = ',slmx
       print*,'   del_dm  = ',del_dm
       print*,'   s_dm    = ',s_dm
       print*,''
#if defined gkw_taper
       print*, ' Gerdes, Koberle, and Willebrand taper is used.'
#endif
#if defined dm_taper
       print*,'  Danabasoglu and McWilliams taper is used.'
#endif
#ifdef disable_vertical_tapering_ahsteep
       print*,' vertical tapering disabled for ahsteep '
       if (athkdf == ahisop .and. athkdf == ahsteep) then
        print*,' WARNING: does not work for',
     &    ' ahisop=athkdf = ahsteep'
       endif
#endif
       print*,''
      endif
c
c-----------------------------------------------------------------------
c     Compute the grid factors which set the maximum slopes available
c     for the mixing schemes. 
c-----------------------------------------------------------------------
c
      ft1 = c1/(4.0*max(ahisop,athkdf)*dt + epsln)
      delta_iso1  = dzt(1)*ft1*dxt(1)*cst(jmt/2)
      i_delta1 = 1
      j_delta1 = 1
      k_delta1 = 1
c
      do j=2,jmt-1
        do i=2,imt-1
	  do k=1,km
	    delta1a = dxt(i)*cst(j)*dzt(k)*ft1
	    delta1b = dyt(j)*dzt(k)*ft1
	    if ( delta_iso1 .ge. delta1a
     &      .or. delta_iso1 .ge. delta1b) then
              i_delta1 = i
              j_delta1 = j
              k_delta1 = k
	      delta_iso1  = min(delta1a,delta1b)
	    endif 
	  enddo
        enddo
      enddo
c
      if (my_pe==0) then
      write(stdout,'(a)')
      write(stdout,'(a,e14.7)')
     &'The diffusion grid factor delta_iso1 =',delta_iso1
      write(stdout,'(a)')
     &'was determined at the grid point'
      write(stdout,'(a,i4,a,e14.7)')
     &'dxt(',i_delta1,') = ',dxt(i_delta1)
      write(stdout,'(a,i4,a,e14.7)')
     &'dyt(',j_delta1,') = ',dyt(j_delta1)
      write(stdout,'(a,i4,a,e14.7)')
     &'dzt(',k_delta1,') = ',dzt(k_delta1)
      write(stdout,'(a,i4,a,e14.7)')
     &'cst(',j_delta1,') = ',cst(j_delta1)
      write(stdout,*)
     &'Without latitudinal filtering, delta_iso1 is the steepest'
      write(stdout,*)
     &'isoneutral slope available for linear stab of Redi and GM.'
      write(stdout,'(/a,e14.7/)')
     & 'Maximum allowable isoneutral slope is specified as slmx = ',slmx
      endif
c
c-----------------------------------------------------------------------
c     vertical structure function for the isoneutral diffusion coeff.
c-----------------------------------------------------------------------
c
      allocate(fzisop(km))
c      fzisop = c1   ! change this for a vertical dependency
      do k=1,km
        fzisop(k)=1.0*(1.-exp(-zt(k)/100.e2))*
     &       ( 0.25+0.75*(1.-tanh((zt(k)-2000.e2)/1000.e2))/2. )
      enddo
c
      if (my_pe==0) then
      write (stdout,'(a)') '  '
      write (stdout,'(a)') ' Vertical structure function "fzisop(k)"='
      write (stdout,'(5(1x,e12.6))') (fzisop(k),k=1,km)
      endif
c
c-----------------------------------------------------------------------
c     initialize arrays
c-----------------------------------------------------------------------
c
      is=max(is_pe,1); ie=min(ie_pe,imt)
      js=max(1,js_pe); je=min(je_pe,jmt)

      allocate( drho(is-1:ie+1,  km,js-1:je+1,2) )
      drho=c0
      allocate( ddxt(is-1:ie+1,  km,js-1:je+1,2) )
      ddxt=c0
      allocate( ddyt(is-1:ie+1,  km,js-1:je+1,2) )
      ddyt=c0
      allocate( ddzt(is-1:ie+1,0:km,js-1:je+1,2) )
      ddzt=c0

      allocate( Ai_ez(is-1:ie,km,js:je,0:1,0:1) )
      Ai_ez=c0
      allocate( K11(is-1:ie,km,js:je) )
      K11=c0

      allocate( Ai_bx(is:ie,km,js:je,0:1,0:1) )
      Ai_bx=c0
      allocate( Ai_by(is:ie,km,js:je,0:1,0:1) )
      Ai_by=c0
      allocate( K33(is:ie,km,js:je) )
      K33=c0

      allocate( Ai_nz(is:ie,km,js-1:je,0:1,0:1) )
      Ai_nz=c0
      allocate( K22(is:ie,km,js-1:je) )
      K22=c0

      redi_gm = c0
c!!!!!!!!!!!!!!!!  here was a bug
      redi_gm(1) = c1
      redi_gm(2) = c1
c
      if(athkdf .eq. ahisop) then
        redi_gm(3) = c0
        redi_gm(4) = c1
      else
        redi_gm(3) = c1
        redi_gm(4) = c0
      endif
      if(athkdf .eq. ahsteep) then
        redi_gm(5) = c0
        redi_gm(6) = c1
      else
        redi_gm(5) = c1
        redi_gm(6) = c0
      endif
      if (my_pe==0) then
      write(stdout,*)' '
      write(stdout,*)'The Redi/GM algorithm coefficients are:'
      do i=1,6
        write(stdout,*)'redi_gm(',i,') = ',redi_gm(i)
      enddo
      endif
c
      allocate( agm(is-1:ie,js-1:je) )
      agm=athkdf   ! change this for horizontal dependency
c
#ifdef partial_cell

      allocate(delqc(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1,0:1) )
c     twice the thickness of quarter cells within T-cells
c     0 is for upper quarter cell and 1 is for lower quarter cell
      delqc=0.

      do j=js_pe,je_pe
         do k=1,km
	  do i=is_pe,ie_pe
            delqc(i,k,j,0) = 2.*fracdz(k,0)*dht(i,k,j)
            delqc(i,k,j,1) = 2.*fracdz(k,1)*dht(i,k,j)
	  enddo
	 enddo
      enddo

      call border_exchg(delqc(:,:,:,0),km,1)
      call border_exchg(delqc(:,:,:,1),km,1)
      if (cyclic) call set_cyclic(delqc(:,:,:,0),km,1)
      if (cyclic) call set_cyclic(delqc(:,:,:,1),km,1)

#endif

      if (my_pe == 0) then
         print*,''
         print*,' done'
         print*,''
      endif
#else
      if (my_pe == 0) then
         print*,''
         print*,' ERROR: isoneutral module disabled'
         print*,''
      endif
      call halt_stop(' in isoneutral_init')
#endif

      end subroutine isoneutral_init



      subroutine isoneutral

#ifndef disable_isoneutral_module
c
c=======================================================================
c
c     Compute isoneutral mixing coefficients.
c
c     input:
c       joff = offset relating row "j" in the MW to latitude "jrow"
c       js   = starting row within the MW for calculations
c       je   = ending row within the MW for calculations
c       is   = starting index longitude within the MW
c       ie   = ending index longitude within the MW
c
c     output:
c       Ai_ez = diffusivity*tapered slope
c               centered on east face of T cells
c       Ai_nz = diffusivity*tapered slope
c               centered on north face of T cells
c       Ai_bx = diffusivity*tapered slope
c               centered on bottom face of T cells
c       Ai_by = diffusivity*tapered slope
c               centered on bottom face of T cells
c            
c=======================================================================
c
c-----------------------------------------------------------------------
c     estimate drho and gradients on sides of T cells 
c-----------------------------------------------------------------------
c
      call isoneutral_elements
c
c-----------------------------------------------------------------------
c     compute Ai_ez and Bi_ez centered on eastern face of T cells
c-----------------------------------------------------------------------
c
      call isoneutral_ai_east 
c
c-----------------------------------------------------------------------
c     compute Ai_nz and Bi_nz centered on the northern face of T cells
c-----------------------------------------------------------------------
c
      call isoneutral_ai_north 
c
c-----------------------------------------------------------------------
c     evaluate Ai_bx, Ai_by, Bi_bx, and Bi_by
c     centered on bottom face of T cells
c-----------------------------------------------------------------------
c
      call isoneutral_ai_bottom
c
#endif
      end subroutine isoneutral



      subroutine isoneutral_elements 
#ifndef disable_isoneutral_module
      use spflame_module
      use isoneutral_module
      implicit none
      integer :: is,ie,js,je
      integer :: i,j,k,n,kp1
      real    :: tprime,sprime
      real T_i,T_j
      integer ip,jp
#ifdef partial_cell
      real dhte,dhtn,dhwe,dhwn
      dhte(i,k,j)   = min(dht(i+1,k,j),dht(i,k,j))
      dhtn(i,k,j)   = min(dht(i,k,j+1),dht(i,k,j))
      dhwe(i,k,j)   = min(dhwt(i+1,k,j),dhwt(i,k,j))
      dhwn(i,k,j)   = min(dhwt(i,k,j+1),dhwt(i,k,j))
      T_i(i,k,j,n,ip) = t(i+ip,max(1,k-1),j,n,taum1) - dhwe(i,k-1,j)
     &            *(t(i+ip,max(1,k-1),j,n,taum1) - t(i+ip,k,j,n,taum1))
     &               /dhwt(i+ip,k-1,j)
      T_j(i,k,j,n,jp) = t(i,max(1,k-1),j+jp,n,taum1) - dhwn(i,k-1,j)
     &            *(t(i,max(1,k-1),j+jp,n,taum1) - t(i,k,j+jp,n,taum1))
     &               /dhwt(i,k-1,j+jp)
#else
      T_i(i,k,j,n,ip) = t(i+ip,k,j,n,taum1)
      T_j(i,k,j,n,jp) = t(i,k,j+jp,n,taum1)
#endif
c
c=======================================================================
c     Estimate drho and normal gradients on faces of T cells
c=======================================================================
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     drho_dt and drho_ds at centers of T cells
c-----------------------------------------------------------------------
c
      do j=js-1,je+1
        do k=1,km
         call drhodt(t(is-1,k,j,1,taum1),t(is-1,k,j,2,taum1),
     &             drho(is-1,k,j,1),k,ie-is+3
#ifdef partial_cell
     &                       ,ztp(is-1,k,j)
#endif
     &                       )
         call drhods(t(is-1,k,j,1,taum1),t(is-1,k,j,2,taum1),
     &             drho(is-1,k,j,2),k,ie-is+3
#ifdef partial_cell
     &                       ,ztp(is-1,k,j)
#endif
     &                       )
        enddo
      enddo
      call set_cyclic(drho(:,:,:,1),km,1)
      call set_cyclic(drho(:,:,:,2),km,1)
c
c-----------------------------------------------------------------------
c     gradients at bottom face of T cells
c-----------------------------------------------------------------------
c
      do n=1,2
        do j=js-1,je+1
          do k=1,km
            kp1 = min(k+1,km)
            do i=is-1,ie+1
	      ddzt(i,k,j,n) = tmask(i,kp1,j)*
     &                        (t(i,k,j,n,taum1) - t(i,kp1,j,n,taum1))
#ifdef partial_cell
     &                      /dhwt(i,k,j)
#else
     &                      *dzwr(k)
#endif
            enddo
          enddo
          do i=is,ie
	    ddzt(i,0,j,n) = 0.
	  enddo
        enddo
        call set_cyclic(ddzt(:,:,:,n),km+1,1)
      enddo
c
c-----------------------------------------------------------------------
c     gradients at eastern face of T cells
c-----------------------------------------------------------------------
c
      do n=1,2
        do j=js-1,je+1
          do k=1,km
            do i=is-1,ie
	      ddxt(i,k,j,n) = tmask(i,k,j)*tmask(i+1,k,j)*cstr(j)*
     &              dxur(i)*(t_i(i,k,j,n,1) - t_i(i,k,j,n,0))
            enddo
          enddo
	enddo
        call set_cyclic(ddxt(:,:,:,n),km,1)
      enddo
c
c-----------------------------------------------------------------------
c     gradients at northern face of T cells
c-----------------------------------------------------------------------
c
      do n=1,2
        do j=js-1,je
          do k=1,km
            kp1 = min(k+1,km)
            do i=is-1,ie+1
	      ddyt(i,k,j,n) = tmask(i,k,j)*tmask(i,k,j+1)*dyur(j)*
     &                 (t_j(i,k,j,n,1) - t_j(i,k,j,n,0))  
            enddo
          enddo
	enddo
        call set_cyclic(ddyt(:,:,:,n),km,1)
      enddo
#endif
      end subroutine isoneutral_elements


      subroutine isoneutral_ai_east 
#ifndef disable_isoneutral_module
      use spflame_module
      use isoneutral_module
      implicit none
      integer is,ie,js,je
      integer i,j,k,kp2
      integer ip,kr
c
      real drodxe
      drodxe(i,k,j,ip) =    drho(i+ip,k,j,1)*ddxt(i,k,j,1) + 
     &                      drho(i+ip,k,j,2)*ddxt(i,k,j,2) 
      real drodze
      drodze(i,k,j,ip,kr) = drho(i+ip,k,j,1)*ddzt(i+ip,k-1+kr,j,1) + 
     &                      drho(i+ip,k,j,2)*ddzt(i+ip,k-1+kr,j,2)

      real Ai11,Ai13,Asteep,sumz,sxe,taper,fact1,fact2
c
c=======================================================================
c     Compute Ai_ez, Bi_ez, and K11 on center of east face of T cell.
c     Note re-scaling factor which reduces diffusivity where abs slope
c     "sxe"  exceeds the critical slope "sc" for the small slope approx.
c=======================================================================
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
        do k=1,km
          kp2 = min(km,k+2) 
          do i=is-1,ie
            Ai11 = (redi_gm(3)*ahisop+redi_gm(4)*agm(i,j))
            if(athkdf.eq.ahisop .and. athkdf.eq.ahsteep) then
    	      K11(i,k,j) = Ai11*tmask(i,k,j)*tmask(i+1,k,j)*fzisop(k)
            else
#ifdef disable_vertical_tapering_ahsteep
              Asteep = redi_gm(5)*ahsteep+redi_gm(6)*agm(i,j)
     &                  *fzisop(k)
#else
              Asteep = (redi_gm(5)*ahsteep+redi_gm(6)*agm(i,j))
     &                  *fzisop(k)
#endif
              Ai13   = (redi_gm(1)*Ai11-redi_gm(2)*agm(i,j))
     &                  *fzisop(k)
	      sumz = 0.
              do kr=0,1
                do ip=0,1
                  sxe    = -drodxe(i,k,j,ip)/(drodze(i,k,j,ip,kr)-epsln)
#ifdef dm_taper 
                  fact1 = (abs(sxe)-del_dm)/s_dm   
                  fact2 = sign(1.0,fact1)*min(19.0,abs(fact1)) 
                  taper = 0.5*(1.-tanh(fact2))   
#endif
#ifdef gkw_taper
                  if (abs(sxe) .gt. slmx) then
                    taper = (slmx/(abs(sxe) + epsln))**2
                  else
                    taper = 1.
                  endif
#endif
	          sumz = sumz +
#ifdef partial_cell
     &                 min(delqc(i,k,j,kr),delqc(i+1,k,j,kr))
#else          
     &                 dzw(k-1+kr)
#endif         
     &                 *tmask(i,k,j)*tmask(i+1,k,j)
     &                 *max(Asteep,Ai11*taper)
	          Ai_ez(i,k,j,ip,kr) = 
     &                 Ai13*taper*sxe*tmask(i,k,j)*tmask(i+1,k,j)
	        enddo
	      enddo
#ifdef partial_cell
              K11(i,k,j) = 0.25*sumz
#else      
              K11(i,k,j) = .5*dzt2r(k)*sumz
#endif     
            endif
          enddo
        enddo
c        call setbcx (Ai_ez(1,1,j,0,0), imt, km)
c        call setbcx (Ai_ez(1,1,j,1,0), imt, km)
c        call setbcx (Ai_ez(1,1,j,0,1), imt, km)
c        call setbcx (Ai_ez(1,1,j,1,1), imt, km)
c        call setbcx (K11(1,1,j), imt, km)
      enddo
c     
#endif
      end subroutine isoneutral_ai_east


      subroutine isoneutral_ai_north
#ifndef disable_isoneutral_module
      use spflame_module
      use isoneutral_module
      implicit none
      integer is,ie,js,je
      integer i,j,k,kp2
      integer kr,jq
      real drodyn
      drodyn(i,k,j,jq) =    drho(i,k,j+jq,1)*ddyt(i,k,j,1) + 
     &                      drho(i,k,j+jq,2)*ddyt(i,k,j,2) 
      real drodzn
      drodzn(i,k,j,jq,kr) = drho(i,k,j+jq,1)*ddzt(i,k-1+kr,j+jq,1) + 
     &                      drho(i,k,j+jq,2)*ddzt(i,k-1+kr,j+jq,2)

      real Ai22,Asteep,Ai23,sumz,taper,syn,fact1,fact2
c     
c=======================================================================
c     Compute "Ai_nz" and "Bi_nz" on center of north face of T cell.
c     Note re-scaling factor which reduces diffusivity where abs slope
c     "syn"  exceeds the critical slope "sc" for the small slope approx.
c=======================================================================
c     
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
      do j=js-1,je

        do k=1,km
          kp2 = min(km,k+2) 
          do i=is,ie
            Ai22 = (redi_gm(3)*ahisop+redi_gm(4)*agm(i,j))
            if(athkdf.eq.ahisop .and. athkdf.eq.ahsteep) then
    	      K22(i,k,j) = Ai22*tmask(i,k,j)*tmask(i,k,j+1)*fzisop(k)
            else
#ifdef disable_vertical_tapering_ahsteep
              Asteep = redi_gm(5)*ahsteep+redi_gm(6)*agm(i,j)
     &                  *fzisop(k)
#else
              Asteep = (redi_gm(5)*ahsteep+redi_gm(6)*agm(i,j))
     &                  *fzisop(k)
#endif
              Ai23   = (redi_gm(1)*Ai22-redi_gm(2)*agm(i,j))
     &                  *fzisop(k)
  	      sumz = 0.
              do kr=0,1
                do jq=0,1
                  syn    = -drodyn(i,k,j,jq)/(drodzn(i,k,j,jq,kr)-epsln)
#ifdef dm_taper 
                  fact1 = (abs(syn)-del_dm)/s_dm   
                  fact2 = sign(1.0,fact1)*min(19.0,abs(fact1)) 
                  taper = .5*(1.-tanh(fact2))   
#endif
#ifdef gkw_taper
                  if (abs(syn) .gt. slmx) then
                    taper = (slmx/(abs(syn) + epsln))**2
                  else
                    taper = 1.
                  endif
#endif
  	          sumz = sumz +
#ifdef partial_cell
     &                 min(delqc(i,k,j,kr),delqc(i,k,j+1,kr))
#else           
     &                 dzw(k-1+kr)
#endif          
     &                 *tmask(i,k,j)*tmask(i,k,j+1)
     &                 *max(Asteep,Ai22*taper)
	          Ai_nz(i,k,j,jq,kr) = 
     &                 Ai23*taper*syn*tmask(i,k,j)*tmask(i,k,j+1)
	        enddo
	      enddo
#ifdef partial_cell
              K22(i,k,j) = 0.25*sumz
#else      
              K22(i,k,j) = .5*dzt2r(k)*sumz
#endif     
            endif
          enddo
        enddo
c        call setbcx (Ai_nz(1,1,j,0,0), imt, km)
c        call setbcx (Ai_nz(1,1,j,1,0), imt, km)
c        call setbcx (Ai_nz(1,1,j,0,1), imt, km)
c        call setbcx (Ai_nz(1,1,j,1,1), imt, km)
c        call setbcx (K22(1,1,j), imt, km)
      enddo
#endif     
      end subroutine isoneutral_ai_north


      subroutine isoneutral_ai_bottom 
#ifndef disable_isoneutral_module
      use spflame_module
      use isoneutral_module
      implicit none
      integer is,ie,js,je
      integer i,j,k,kp2,kp1
      integer kr,jq,ip
      real drodxb
      drodxb(i,k,j,ip,kr) = drho(i,k+kr,j,1)*ddxt(i-1+ip,k+kr,j,1) + 
     &                      drho(i,k+kr,j,2)*ddxt(i-1+ip,k+kr,j,2) 
      real drodyb
      drodyb(i,k,j,jq,kr) = drho(i,k+kr,j,1)*ddyt(i,k+kr,j-1+jq,1) + 
     &                      drho(i,k+kr,j,2)*ddyt(i,k+kr,j-1+jq,2) 
      real drodzb
      drodzb(i,k,j,kr) =    drho(i,k+kr,j,1)*ddzt(i,k,j,1) + 
     &                      drho(i,k+kr,j,2)*ddzt(i,k,j,2)
      real fzisopb
      real Ai31,Ai32,Ai33,sumx,sxb,taper,facty,syb,sumy
      real fact1,fact2
c
c=======================================================================
c     compute Ai_bx, Ai_by, Bi_bx, Bi_by, and K33 at the center
c     of the bottom face of T cells.
c=======================================================================
c
c-----------------------------------------------------------------------
c     compute "Ai_bx", "Ai_by", "Bi_bx", "Bi_by", & K33 on bottom face
c     of T cell. Note re-scaling factor to reduce mixing coefficient
c     "Ai" where slopes excede the critical slope "sc" for the small
c     slope approx, gm_skew, or biharmonic_rm.  
c-----------------------------------------------------------------------
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
      do j=js,je
        do k=1,km-1
	  kp1   = min(k+1,km)
	  kp2   = min(k+2,km)
	  fzisopb = .5*(fzisop(k+1)+fzisop(k))
          do i=is,ie
            Ai31  = fzisopb
     &       *(  redi_gm(1)*(redi_gm(3)*ahisop+redi_gm(4)*agm(i,j))
     &         + redi_gm(2)*agm(i,j))
            Ai32  = Ai31
            Ai33  = (redi_gm(3)*ahisop+redi_gm(4)*agm(i,j))*fzisopb
c           eastward slopes at the base of T cells
            sumx  = 0.
            do ip=0,1
              do kr=0,1
                sxb = -drodxb(i,k,j,ip,kr)/(drodzb(i,k,j,kr)-epsln)
#ifdef dm_taper
                fact1 = (abs(sxb)-del_dm)/s_dm 
                fact2 = sign(1.0,fact1)*min(19.0,abs(fact1))
                taper = .5*(1.-tanh(fact2))   
#endif
#ifdef gkw_taper
                if (abs(sxb) .gt. slmx) then
                  taper = (slmx/(abs(sxb) + epsln))**2
                else
                  taper = 1.
                endif
#endif
	        sumx = sumx
     &          + dxu(i-1+ip)*tmask(i,k+1,j)*Ai33*taper*sxb**2
#ifdef partial_cell
     &          *min(delqc(i-1+ip,k+kr,j,1-kr),delqc(i+ip,k+kr,j,1-kr))
#endif
	        Ai_bx(i,k,j,ip,kr) =
     &               Ai31*taper*sxb*tmask(i,k+1,j)
c
              enddo
            enddo
c           northward slopes at the base of T cells
            sumy  = 0.
            do jq=0,1
	      facty = csu(j-1+jq)*dyu(j-1+jq)
              do kr=0,1
                syb = -drodyb(i,k,j,jq,kr)/(drodzb(i,k,j,kr)-epsln)
#ifdef dm_taper
                fact1 = (abs(syb)-del_dm)/s_dm
                fact2 = sign(1.0,fact1)*min(19.0,abs(fact1))
                taper =  .5*(1.-tanh(fact2))  
#endif
#ifdef gkw_taper
                if (abs(syb) .gt. slmx) then
                  taper = (slmx/(abs(syb) + epsln))**2
                else
                  taper = 1.
                endif
#endif
	        sumy = sumy
     &          + facty*tmask(i,k+1,j)*Ai33*taper*syb**2
#ifdef partial_cell
     &          *min(delqc(i,k+kr,j-1+jq,1-kr),delqc(i,k+kr,j+jq,1-kr))
#endif
	        Ai_by(i,k,j,jq,kr) =
     &               Ai32*taper*syb*tmask(i,k+1,j)
              enddo
            enddo
            K33(i,k,j) = (dxt4r(i)*sumx + dyt4r(j)*cstr(j)*sumy)
#ifdef partial_cell
     &                   /dhwt(i,k,j)
#endif
          enddo
        enddo
c        call setbcx (Ai_bx(1,1,j,1,0), imt, km)
c        call setbcx (Ai_bx(1,1,j,0,0), imt, km)
c        call setbcx (Ai_bx(1,1,j,1,1), imt, km)
c        call setbcx (Ai_bx(1,1,j,0,1), imt, km)
c        call setbcx (Ai_by(1,1,j,1,0), imt, km)
c        call setbcx (Ai_by(1,1,j,0,0), imt, km)
c        call setbcx (Ai_by(1,1,j,1,1), imt, km)
c        call setbcx (Ai_by(1,1,j,0,1), imt, km)
c        call setbcx (K33(1,1,j), imt, km)
      enddo
#endif
      end subroutine isoneutral_ai_bottom 



      subroutine isoneutral_flux(n,diff_fe,diff_fn,diff_fb)
c
c=======================================================================
c     isopycnal diffusive tracer fluxes are computed.
c     horizontal fluxes are added (!) to diff_fe and diff_fn
c     while diff_fb is set (!) to K13 and K23 components which
c     are solved explicitly. 
c=======================================================================
c
c     K11(is_pe-1:ie_pe,km,js_pe:je_pe)
c     Ai_ez(is_pe-1:ie_pe,km,js_pe:je_pe,0:1,0:1)
c
c     K22(is_pe:ie_pe,km,js_pe-1:je_pe)
c     Ai_nz(is_pe:ie_pe,km,js_pe-1:je_pe,0:1,0:1)
c
      use spflame_module
      use isoneutral_module
      implicit none
      integer :: n
      real diff_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real diff_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real diff_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
#ifndef disable_isoneutral_module
      integer is,ie,js,je
      integer i,j,k
      integer km1,km1kr,kpkr,jm1,kr,ip,jq,jp
      real sumz,sumx,sumy

      real T_i,T_j
#ifdef partial_cell
      real dhte,dhtn,dhwe,dhwn
      dhte(i,k,j)   = min(dht(i+1,k,j),dht(i,k,j))
      dhtn(i,k,j)   = min(dht(i,k,j+1),dht(i,k,j))
      dhwe(i,k,j)   = min(dhwt(i+1,k,j),dhwt(i,k,j))
      dhwn(i,k,j)   = min(dhwt(i,k,j+1),dhwt(i,k,j))
      T_i(i,k,j,n,ip) = t(i+ip,max(1,k-1),j,n,taum1) - dhwe(i,k-1,j)
     &            *(t(i+ip,max(1,k-1),j,n,taum1) - t(i+ip,k,j,n,taum1))
     &               /dhwt(i+ip,k-1,j)
      T_j(i,k,j,n,jp) = t(i,max(1,k-1),j+jp,n,taum1) - dhwn(i,k-1,j)
     &            *(t(i,max(1,k-1),j+jp,n,taum1) - t(i,k,j+jp,n,taum1))
     &               /dhwt(i,k-1,j+jp)
#else
      T_i(i,k,j,n,ip) = t(i+ip,k,j,n,taum1)
      T_j(i,k,j,n,jp) = t(i,k,j+jp,n,taum1)
#endif

c
c=======================================================================
c     isoneutral diffusive tracer fluxes are computed.
c=======================================================================
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     construct total isoneutral tracer flux at east face of "T" cells 
c-----------------------------------------------------------------------
c
      if (athkdf .ne. ahisop) then     
        do j=js,je
          do k=1,km
            km1 = max(k-1,1)
            do i=is-1,ie
	      sumz    = 0.
              do kr=0,1
	        km1kr = max(k-1+kr,1)
	        kpkr  = min(k+kr,km)
                do ip=0,1
	          sumz = sumz + Ai_ez(i,k,j,ip,kr)
#ifdef partial_cell
     &                *min(delqc(i,k,j,kr),delqc(i+1,k,j,kr))
     &                /dhwt(i+ip,km1kr,j)
c      dz_wtr(i,k,j) = c1/dhwt(i,k,j)
#endif
     &             *(t(i+ip,km1kr,j,n,taum1)-t(i+ip,kpkr,j,n,taum1))
                enddo
	      enddo
              diff_fe(i,k,j) = diff_fe(i,k,j)+ 
#ifdef partial_cell
     &                                     0.25*sumz
#else
     &                                     sumz*.5*dzt2r(k)
#endif
     &         + cstr(j)*dxur(i)*(T_i(i,k,j,n,1) - T_i(i,k,j,n,0))
     &                          *K11(i,k,j)
            enddo
          enddo
c          call setbcx (diff_fe(1,1,j), imt, km)
        enddo
      else 
        do j=js,je
          do k=1,km
            do i=is-1,ie
              diff_fe(i,k,j) = diff_fe(i,k,j)+ 
     &              K11(i,k,j)*cstr(j)*dxur(i)
     &             *(T_i(i,k,j,n,1) - T_i(i,k,j,n,0))
#ifdef partial_cell
ce    I just try to debug here without knowing what I do
c     &             *dhte(i,k,j)
#endif
            enddo
          enddo
c          call setbcx (diff_fe(1,1,j), imt, km)
        enddo
      endif
c
c-----------------------------------------------------------------------
c     construct total isoneutral tracer flux at north face of "T" cells 
c-----------------------------------------------------------------------
c    
      if (athkdf .ne. ahisop) then     
        do j=js-1,je
          jm1 = max(1,j-1)
          do k=1,km
            do i=is,ie
	      sumz    = 0.
              do kr=0,1
	        km1kr = max(k-1+kr,1)
	        kpkr = min(k+kr,km)
                do jq=0,1
	         sumz = sumz + Ai_nz(i,k,j,jq,kr)
#ifdef partial_cell
     &                *min(delqc(i,k,j,kr),delqc(i,k,j+1,kr))
     &                /dhwt(i,km1kr,j+jq)
#endif
     &                 *(t(i,km1kr,j+jq,n,taum1)-t(i,kpkr,j+jq,n,taum1))
                enddo
	      enddo
             diff_fn(i,k,j) = diff_fn(i,k,j)+
#ifdef partial_cell
     &                 csu(j)*0.25*sumz
#else
     &                sumz*csu(j)*0.5*dzt2r(k)
#endif
     &        + (T_j(i,k,j,n,1)-T_j(i,k,j,n,0))*csu_dyur(j)
     &          *K22(i,k,j)
            enddo
          enddo
c          call setbcx (diff_fn(1,1,j), imt, km)
        enddo
      else 
        do j=js-1,je
          do k=1,km
            do i=is,ie
              diff_fn(i,k,j) = diff_fn(i,k,j)+
     &         K22(i,k,j)*csu_dyur(j)
     &        *(T_j(i,k,j,n,1)-T_j(i,k,j,n,0))
#ifdef partial_cell
ce    I just try to debug here without knowing what I do
c     &        *dhtn(i,k,j)
#endif
            enddo
          enddo
c          call setbcx (diff_fn(1,1,j), imt, km)
        enddo
      endif

c
c-----------------------------------------------------------------------
c     compute the vertical tracer flux "diff_fbiso" containing the K31
c     and K32 components which are to be solved explicitly. The K33
c     component will be treated implicitly. Note that there are some
c     cancellations of dxu(i-1+ip) and dyu(jrow-1+jq) 
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
	    sumx    = 0.
            do ip=0,1
              do kr=0,1
	        sumx = sumx
     &            + Ai_bx(i,k,j,ip,kr)*cstr(j)*
#ifdef partial_cell
     &          min(delqc(i-1+ip,k+kr,j,1-kr),delqc(i+ip,k+kr,j,1-kr))*
#endif
     &             (T_i(i-1+ip,k+kr,j,n,1) - T_i(i-1+ip,k+kr,j,n,0))
              enddo
	    enddo
	    sumy    = 0.
            do jq=0,1
              do kr=0,1
	        sumy    = sumy 
     &           + Ai_by(i,k,j,jq,kr)*csu(j-1+jq)*
#ifdef partial_cell
     &          min(delqc(i,k+kr,j-1+jq,1-kr),delqc(i,k+kr,j+jq,1-kr))*
#endif
     &            (T_j(i,k+kr,j-1+jq,n,1)-T_j(i,k+kr,j-1+jq,n,0))
              enddo
	    enddo
            diff_fb(i,k,j) = (dxt4r(i)*sumx +dyt4r(j)*cstr(j)*sumy)
#ifdef partial_cell
     &                          /dhwt(i,k,j)
#endif
          enddo
        enddo
c        call setbcx (diff_fb(1,0,j), imt, km+1)
      enddo
#endif
      end subroutine isoneutral_flux



      subroutine isoneutral_add_K33
#ifndef disable_isoneutral_module
      use spflame_module
      use isoneutral_module
      implicit none
      integer is,ie,js,je
      integer i,j,k

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
        do k=1,km-1
          do i=is,ie
            diff_cbt(i,k,j) = 
     &            (diff_cbt(i,k,j) + K33(i,k,j))*tmask(i,k+1,j)
          enddo
        enddo
      enddo
#endif
      end subroutine isoneutral_add_K33




      subroutine isoneutral_adv(adv_vetiso,adv_vntiso,adv_vbtiso)
c=======================================================================
c     compute GM eddy-induced transport velocities.
c     author:  R.C. Pacanowski e-mail => rcp@gfdl.gov 
c=======================================================================
      use spflame_module
      use isoneutral_module
      implicit none

      real :: adv_vetiso(is_pe-1:ie_pe,  km,js_pe  :je_pe) 
      real :: adv_vntiso(is_pe  :ie_pe,  km,js_pe-1:je_pe) 
      real :: adv_vbtiso(is_pe  :ie_pe,0:km,js_pe  :je_pe) 

#ifndef disable_isoneutral_module
      integer is,ie,js,je
      integer i,j,k,km1,kp1
      real ath0,at,bt,stn,ab,bb,sbn,ath_t,ath_b
      real ste,sbe,fact_t1,fact_b1,fact_t,fact_b
c
c-----------------------------------------------------------------------
c Arrays for GM.  Note, the advection velocities are still needed 
c with the default gm_skew approach, since generally wish to map 
c these velocities in snapshots.
c
c     adv_vetiso = zonal isopycnal mixing velocity computed at the 
c                  center of the eastern face of the "t" cells
c     adv_vntiso = meridional isopycnal mixing velocity computed at
c                  the center of the northern face of the "t" cells
c                  (Note: this includes the cosine as in "adv_vnt")
c     adv_vbtiso = vertical isopycnal mixing velocity computed at the
c                  center of the top face of the "t" cells
c     adv_fbiso  = "adv_vbtiso" * (tracer) evaluated at the center of
c                  the bottom face of the "t" cells
c-----------------------------------------------------------------------
c
      real top_bc(km), bot_bc(km)

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
      top_bc = 1.; bot_bc = 1.
      top_bc(1)  = 0.; bot_bc(km) = 0.
c
c-----------------------------------------------------------------------
c     compute the meridional component of the isoneutral mixing velocity
c     at the center of the northern face of the "T" cells.
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=1,km
          km1 = max(k-1,1)
          kp1 = min(k+1,km)
          do i=is,ie
            Ath0 = agm(i,j)*fzisop(k)
            at =     (drho(i,k,j,1) + drho(i,k,j+1,1) + drho(i,km1,j,1)
     &              + drho(i,km1,j+1,1))
            bt =     (drho(i,k,j,2) + drho(i,k,j+1,2) + drho(i,km1,j,2)
     &              + drho(i,km1,j+1,2))
            stn = -(at*(ddyt(i,k,j,1) + ddyt(i,km1,j,1))
     &               + bt*(ddyt(i,k,j,2) + ddyt(i,km1,j,2))) /
     &                (at*(ddzt(i,km1,j,1) + ddzt(i,km1,j+1,1))
     &               + bt*(ddzt(i,km1,j,2) + ddzt(i,km1,j+1,2))-epsln)
            ab =     (drho(i,k,j,1) + drho(i,k,j+1,1) + drho(i,kp1,j,1)
     &              + drho(i,kp1,j+1,1))
            bb =     (drho(i,k,j,2) + drho(i,k,j+1,2) + drho(i,kp1,j,2)
     &              + drho(i,kp1,j+1,2))
            sbn = -(ab*(ddyt(i,k,j,1) + ddyt(i,kp1,j,1))
     &               + bb*(ddyt(i,k,j,2) + ddyt(i,kp1,j,2))) /
     &                (ab*(ddzt(i,k,j,1) + ddzt(i,k,j+1,1))
     &               + bb*(ddzt(i,k,j,2) + ddzt(i,k,j+1,2))-epsln)
#ifdef dm_taper
            fact_t1 =  (abs(stn)-del_dm)/s_dm
            fact_b1 =  (abs(sbn)-del_dm)/s_dm
            fact_t =  sign(1.0,fact_t1)*min(19.0,abs(fact_t1))
            fact_b =  sign(1.0,fact_b1)*min(19.0,abs(fact_b1))
	    ath_t = Ath0*tmask(i,k,j)*tmask(i,k,j+1)
     &             *.5*(1.-tanh(fact_t))
	    ath_b = Ath0*tmask(i,kp1,j)*tmask(i,kp1,j+1)
     &             *.5*(1.-tanh(fact_b))
#endif
#ifdef gkw_taper
            if (abs(stn) .gt. slmx) then
	      ath_t = Ath0*tmask(i,k,j)*tmask(i,k,j+1)
     &              *(slmx/(abs(stn) + epsln))**2
	    else
	      ath_t = Ath0*tmask(i,k,j)*tmask(i,k,j+1)
	    endif
            if (abs(sbn) .gt. slmx) then
	      ath_b = Ath0*tmask(i,kp1,j)*tmask(i,kp1,j+1)
     &              *(slmx/(abs(sbn) + epsln))**2
	    else
	      ath_b = Ath0*tmask(i,kp1,j)*tmask(i,kp1,j+1)
	    endif
#endif
            adv_vntiso(i,k,j) = -(ath_t*stn*top_bc(k) -
     &                            ath_b*sbn*bot_bc(k))*dztr(k)*csu(j)
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     compute the zonal component of the isoneutral mixing velocity
c     at the center of the eastern face of the "T" grid cell.
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
          km1 = max(k-1,1)
          kp1 = min(k+1,km)
          do i=is-1,ie
            Ath0 = agm(i,j)*fzisop(k)
            at =     (drho(i,k,j,1) + drho(i+1,k,j,1) + drho(i,km1,j,1)
     &              + drho(i+1,km1,j,1))
            bt =     (drho(i,k,j,2) + drho(i+1,k,j,2) + drho(i,km1,j,2)
     &              + drho(i+1,km1,j,2))
            ste =-(at*(ddxt(i,k,j,1) + ddxt(i,km1,j,1))
     &           + bt*(ddxt(i,k,j,2) + ddxt(i,km1,j,2)))
     &          / (at*(ddzt(i,km1,j,1) + ddzt(i+1,km1,j,1))
     &           + bt*(ddzt(i,km1,j,2) + ddzt(i+1,km1,j,2))-epsln)
            ab =     (drho(i,k,j,1) + drho(i+1,k,j,1) + drho(i,kp1,j,1)
     &              + drho(i+1,kp1,j,1))
            bb =     (drho(i,k,j,2) + drho(i+1,k,j,2) + drho(i,kp1,j,2)
     &              + drho(i+1,kp1,j,2))
            sbe =-(ab*(ddxt(i,k,j,1) + ddxt(i,kp1,j,1))
     &           + bb*(ddxt(i,k,j,2) + ddxt(i,kp1,j,2))) /
     &            (ab*(ddzt(i,k,j,1) + ddzt(i+1,k,j,1))
     &           + bb*(ddzt(i,k,j,2) + ddzt(i+1,k,j,2))-epsln)

#ifdef dm_taper
            fact_t1 =  (abs(ste)-del_dm)/s_dm
            fact_b1 =  (abs(sbe)-del_dm)/s_dm
            fact_t =  sign(1.0,fact_t1)*min(19.0,abs(fact_t1))
            fact_b =  sign(1.0,fact_b1)*min(19.0,abs(fact_b1))
	    ath_t = Ath0*tmask(i,k,j)*tmask(i+1,k,j)
     &             *.5*(1.-tanh(fact_t))
	    ath_b = Ath0*tmask(i,kp1,j)*tmask(i+1,kp1,j)
     &             *.5*(1.-tanh(fact_b))
#endif
#ifdef gkw_taper
            if (abs(ste) .gt. slmx) then
	      ath_t = Ath0*tmask(i,k,j)*tmask(i+1,k,j)
     &              *(slmx/(abs(ste) + epsln))**2
	    else
	      ath_t = Ath0*tmask(i,k,j)*tmask(i+1,k,j)
	    endif
            if (abs(sbe) .gt. slmx) then
	      ath_b = Ath0*tmask(i,kp1,j)*tmask(i+1,kp1,j)
     &              *(slmx/(abs(sbe) + epsln))**2
	    else
	      ath_b = Ath0*tmask(i,kp1,j)*tmask(i+1,kp1,j)
	    endif
#endif
            adv_vetiso(i,k,j) = -(ath_t*ste*top_bc(k) - 
     &                            ath_b*sbe*bot_bc(k))*dztr(k)
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     compute the vertical component of the isoneutral mixing velocity
c     at the center of the bottom face of the "T" cells, using the
c     continuity equation for the GM velocities
c-----------------------------------------------------------------------
c
      do j=js,je
        do i=is,ie
          adv_vbtiso(i,0,j) = 0.
        enddo
      enddo
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
            adv_vbtiso(i,k,j) = dzt(k)*cstr(j)*(
     &      (adv_vetiso(i,k,j) - adv_vetiso(i-1,k,j))*dxtr(i) + 
     &      (adv_vntiso(i,k,j) - adv_vntiso(i,k,j-1))*dytr(j)) 
          enddo
        enddo
      enddo
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
            adv_vbtiso(i,k,j) = adv_vbtiso(i,k,j) + adv_vbtiso(i,k-1,j)
          enddo
        enddo
      enddo
c
      do j=js,je
        do i=is,ie
          adv_vbtiso(i,kmt(i,j),j) = 0.
        enddo
      enddo

#endif
      end subroutine isoneutral_adv 

#include "options.inc"

c
c     convert unformatted written data containing
c     float positions to NetCDF format
c

      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end


      program cv_float
      implicit none
      character (len=80) :: infile,outfile
      integer :: ierr
      character (len=32) :: stamp
      integer :: nfl,itm
      integer :: io,k

#include "netcdf.inc"
      integer :: iret,ncid,timedim,nrdim,xid,yid,zid,timeid,dims(4)
      integer :: corner(2), edges(2)
      character (len=80) :: name,unit
      real :: tt

      real (kind=4) , allocatable :: pxyz(:,:)
      real (kind=4) :: time,spval = -1.e20

      print*,' Converting float data written by SPFLAME ',
     &       ' to NetCDF file '

      call get_commandline_arg(1,infile,ierr)
      if (ierr/=0) goto 99
      print*,' reading from file ',infile(1:len_trim(infile))
      call get_commandline_arg(2,outfile,ierr)
      if (ierr/=0) goto 99
      print*,' writing to file ',outfile(1:len_trim(outfile))

      call getunit (io, infile,'u s r ieee')

      itm=0
 10   continue
      do k=1,3; read (io,end=20); enddo
      itm=itm+1
      goto 10
 20   continue

      print*,' found ',itm,' time steps in file ',infile
      rewind(io)
      read(io) stamp
      read(io) nfl
      rewind(io)
      print*,' found ',nfl,' floats in file ',infile

      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c     dimensions
      Timedim   = ncddef(ncid,'Time', nf_unlimited, iret)
      nrdim     = ncddef(ncid,'Nr  ', nfl, iret)
c     variables
      Timeid   =  ncvdef(ncid,'Time', NCFLOAT,1,timedim,iret)
      name = 'Time'; unit = 'days'
      call ncaptc(ncid,Timeid, 'long_name', NCCHAR,4, name, iret) 
      call ncaptc(ncid,Timeid, 'units',    NCCHAR,4, unit, iret) 
      call ncaptc(ncid,Timeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
      dims=(/nrdim,timedim,1,1/)
      xid=ncvdef (ncid,'lon', NCFLOAT,2,dims,iret)
      yid=ncvdef (ncid,'lat', NCFLOAT,2,dims,iret)
      zid=ncvdef (ncid,'depth', NCFLOAT,2,dims,iret)
      name = 'Longitude on T grid'; unit = 'degrees_W'
      call dvcdf_here(ncid,xid,name,len_trim(name),unit,
     &            len_trim(unit),spval)
      name = 'Latitude on T grid'; unit = 'degrees_N'
      call dvcdf_here(ncid,yid,name,len_trim(name),unit,
     &            len_trim(unit),spval)
      name = 'Depth on T grid'; unit = 'm'
      call dvcdf_here(ncid,zid,name,len_trim(name),unit,
     &            len_trim(unit),spval)
      call ncendf(ncid, iret)

      allocate( pxyz(3,nfl) )

      do k=1,itm
       read (io) stamp
       call read_stamp(stamp,tt); time=tt
       print*,' at stamp=',stamp,
     &          ' (days since origin : ',time,')'
       read (io)
       read (io) pxyz

       iret= nf_put_vara_real (ncid,timeid, k,1,time)
       corner=(/1,k/); edges = (/nfl,1/)
       pxyz(1,:)=pxyz(1,:)-360.
       iret= nf_put_vara_real (ncid,xid,corner,edges,pxyz(1,:))
       iret= nf_put_vara_real (ncid,yid,corner,edges,pxyz(2,:))
       pxyz(3,:)=pxyz(3,:)/(-100.)
       iret= nf_put_vara_real (ncid,zid,corner,edges,pxyz(3,:))
      enddo

      call ncclos (ncid, iret)
      print*,' done'
      stop

 99   print*,' program needs command line parameter'
      print*,' 1. input binary file name (written by spflame)'
      print*,' 2. output NetCDF file name '

      end program cv_float



      subroutine dvcdf_here(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c     define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character*(*) name, unit
      real (kind=4):: spval,vv
#include "netcdf.inc"
      vv=spval
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncapt (ncid,ivarid, 'missing_value',NCFLOAT,1,vv,iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      call ncapt (ncid,ivarid, '_FillValue', NCFLOAT, 1,vv, iret)
        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf_here

#include "options.inc"
c
c
c see also below for a second module blue_mean_module
c
c-----------------------------------------------------------------------
c     This module implements the BLUE approach
c     by J.Sheng and R.J. Greatbatch, JGR, 2000
c     to get a semi diagnostic model in certain
c     regions of the model domain dependend on 
c     the parameter blue_alpha.
c
c     if blue_alpha = 1.  fully prognostic
c     if blue_alpha = 0.5 semi prognostic or diagnostic
c     if blue_alpha = 0.  fully diagnostic
c
c     additional options: 
c
c        use constant (diagnosed) forcing
c        smooth climatological rho with a grid point smoother
c
c     linked in the code in setup, call of blue_init
c                        in clinic, call of add_blue_to_rho
c                        in domain_exchg, send/rec. blue_rho
c
c     four parameters can be set in spflame_module (namelist)
c         enable_blue, 
c         enable_blue_smooth, 
c         enable_blue_const, 
c         enable_blue_tapered, 
c         ismooth_blue
c         ilook_blue
c         enable_blue_simple
c         enable_diag_blue
c
c                                      c eden
c-----------------------------------------------------------------------
c
c
c local defines
c
c#define prognostic_below_200m
c
c

      module blue_module
      implicit none

      real, allocatable :: blue_rho  (:,:,:,:)
      real, allocatable :: blue_alpha(:,:,:)
      real, allocatable :: blue_rhom (:,:,:)

      character (len=80) :: blue_temp_file
      character (len=80) :: blue_salt_file

      integer :: blue_interp_index
      integer :: blue_cache_pointer(2)
      real    :: blue_f1,blue_f2
      integer :: blue_p1,blue_p2

      end module blue_module


      subroutine blue_init
c-----------------------------------------------------------------------
c     initialisation for BLUE
c-----------------------------------------------------------------------
      use spflame_module
      use blue_module
      implicit none
      type( time_type) :: start
      type( time_type), allocatable :: interval(:)
      integer :: io,len,n
      real, allocatable  :: aprec(:)
      character (len=32) :: stamp
c
c     hardwired file names
c 
      blue_temp_file = 'blue_temp.mom'
      if (enable_blue_const) blue_temp_file = 'blue_const.mom'
      blue_salt_file = 'blue_salt.mom'
c
c     informative output about configuration
c
      if (my_pe == 0) then
       print*,  ''
       print*,  ' Initialization of BLUE'
       print*,  ''
       if (mother < 0) then 
        if (enable_blue_simple) then
         print*,' using simple T/S fields for BLUE, as specified'
         print*,' in file setup_template.F'
        else
         if (enable_blue_const) then
          print*,  ' reading momentum corr. from file ',
     &     blue_temp_file(1:len_trim(blue_temp_file))
         else
          print*,  ' reading temp/sal from files ',
     &     blue_temp_file(1:len_trim(blue_temp_file)),' and ',
     &     blue_salt_file(1:len_trim(blue_salt_file))
         endif
        endif
       else
        print*,' receiving blue density from mother domain '
       endif

       if (enable_blue_smooth) then
        print*,' using the smoothed version of BLUE'
        print*,' ismooth_blue =',ismooth_blue
       endif
       if (enable_blue_const) then
        print*,' using the constant forcing '
       endif
       if (enable_blue_tapered) then
        print*,' using boundary tapering '
        print*,' ilook_blue = ',ilook_blue
       endif
       print*,  ''
       if (enable_blue_smooth .and. enable_blue_const) then
        print*,' smoothed version and constant forcing of BLUE'
        print*,' are incompatible '
       endif

      endif
c
c     checks
c
      if (enable_blue_smooth .and. enable_blue_const) then
        call halt_stop(' in blue_init')
      endif
c
c     allocate permanent memory
c
      allocate( blue_rho(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1,2) )
      allocate( blue_alpha(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) )
      blue_rho = 0.; blue_alpha = 1.

      if (enable_blue_smooth) then
       allocate( blue_rhom(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) )
       blue_rhom=0.
      endif

      if (mother < 0) then 

       if (.not. enable_blue_simple) then
c
c       initialize time interpolation for blue density
c
        call getunit(io,blue_temp_file,'usr ieee')
        read (io) len
        rewind(io)
        allocate(interval(len), aprec(len))
        read (io)  len,stamp,aprec

        do n=1,len
         call set_time(interval(n),
     &                 int((aprec(n)-int(aprec(n)))*24*60*60),
     &                 int(aprec(n)))
        enddo
        start= get_stamp (stamp)
        call init_forcing_interp(len,.true.,
     &                     start,interval,blue_interp_index)
        deallocate(interval,aprec)
        close(io)

       else
c
c       use simple setup here
c
        call blue_template()

       endif

      else
c
c       child domains receive their value from the mother domain
c
      endif
c
c     set the BLUE  parameter
c     (see also sub_domain_exchg for BLUE and BLUE parameter)
c
      blue_alpha=0.5

#ifdef prognostic_below_200m
c
c     use BLUE only above 200m
c
      blue_alpha(:,13:km,:)=1.0
#endif

      if (enable_blue_tapered) call blue_alpha_tapering()

      if (my_pe == 0) print*,  'done'
      end subroutine blue_init




      subroutine blue_alpha_tapering
      use spflame_module
      use blue_module
      implicit none
      integer :: i,k,j,ii,jj,iii,jjj

c      do j=js_pe-1,je_pe+1
c       do k=1,km
c        do i=is_pe-1,ie_pe+1
c         if (kmt_big(i,j)<k) blue_alpha(i,k,j)=1. ! land
c        enddo
c       enddo
c      enddo

      do j=js_pe-1,je_pe+1
       do k=1,km
        do i=is_pe-1,ie_pe+1
         ii=i
         jj=j
         if (cyclic) then
            if (ii>imt) ii=ii-imt+2
            if (ii<1)   ii=ii+imt-2
         else
            ii = min(imt,ii)
            ii = max(1  ,ii)
         endif
         jj = min(jmt,jj)
         jj = max(1  ,jj)
         if (kmt_big(ii,jj)<k) blue_alpha(i,k,j)=1. ! land
        enddo
       enddo
      enddo


      do jj=-ilook_blue,ilook_blue
       do ii=-ilook_blue,ilook_blue
        do j=js_pe-1,je_pe+1
         do k=1,km
          do i=is_pe-1,ie_pe+1
           iii=ii+i
           jjj=jj+j
           if (cyclic) then
            if (iii>imt) iii=iii-imt+2
            if (iii<1)   iii=iii+imt-2
           else
            iii = min(imt,iii)
            iii = max(1  ,iii)
           endif
           jjj = min(jmt,jjj)
           jjj = max(1  ,jjj)
           ! near land and above land
           if (kmt_big(iii,jjj)<=k) blue_alpha(i,k,j)=1. 
          enddo
         enddo
        enddo
       enddo
      enddo
      end subroutine blue_alpha_tapering



      subroutine read_blue
      use spflame_module
      use blue_module
      implicit none
c-----------------------------------------------------------------------
c     read in BLUE T/S fields from binary files
c     (or momentum corr. for blue_const version
c-----------------------------------------------------------------------
      real    :: f1,f2
      integer :: p1,p2,io1,io2,n,i,k,j
      logical load(2)
      character(len=80) :: text = 'BLUE'
      real, allocatable :: temp(:,:),salt(:,:)
      integer :: is,ie,js,je

      is=max(1,is_pe-1); ie = min(imt,ie_pe+1)
      js=max(1,js_pe-1); je = min(jmt,je_pe+1)

      if (mother < 0) then 
c
c      decide whether to read data or not
c
       call forcing_interp(blue_interp_index,
     &                     blue_p1,blue_p2,blue_f1,blue_f2)

       call update_forcing_cache(blue_interp_index,blue_p1,blue_p2,
     &                           blue_cache_pointer(:),load,text)

       do n=1,2
        if (load(n)) then
c
c        read in data
c
         if (enable_blue_const) then
c
c         read only from first file
c
          if (my_pe==0) then
           call getunit(io1,blue_temp_file,'usr ieee')
           read(io1)  ! len et al
           do k=1,blue_cache_pointer(n)-1
            do j=1,jmt
             read(io1)  ! skip all previous time steps
            enddo
           enddo
          endif ! my_pe==0
          allocate( temp(imt,km) )

          do j=1,jmt
           if (my_pe==0) read (io1) temp  ! these are the data for this time step
           call barrier
           call bcast_real(temp,imt*km,0) 
c
c          transfer to BLUE correction array
c          
           if (j>=js .and. j<=je) then
            do k=1,km
             do i=is,ie
              blue_rho(i,k,j,n)=temp(i,k)
             enddo
            enddo
           endif
          enddo ! do j=1,jmt

          deallocate( temp) 
          if (my_pe==0) close(io1)

         else ! if enable_blue_const
c
c         read T/S from two files
c
          if (my_pe==0) then
           call getunit(io1,blue_temp_file,'usr ieee')
           call getunit(io2,blue_salt_file,'usr ieee')
           read(io1)  ! len et al
           read(io2)  ! len et al
           do k=1,blue_cache_pointer(n)-1
            do j=1,jmt
             read(io1)  ! skip all previous time steps
             read(io2)
            enddo
           enddo
          endif ! my_pe==0

          allocate( temp(imt,km), salt(imt,km) )
          do j=1,jmt
           if (my_pe==0) then
            read (io1)    temp  ! these are the data for this time step
            read (io2)    salt
           endif
           ! assuming that broadcasting is quicker than file IO
           call barrier
           call bcast_real(temp,imt*km,0) 
           call bcast_real(salt,imt*km,0) 
c
c          now calculate BLUE density from T/S fields
c          
           if (j>=js .and. j<=je) then
            do k=1,km
             call model_dens(temp(is,k), salt(is,k),
     &                  blue_rho(is,k,j,n),k,ie-is+1
#ifdef partial_cell
     &                       ,ztp(is,k,j)
#endif
     &                       )
            enddo
           endif
          enddo ! do j=1,jmt

          deallocate( temp,salt) 
          if (my_pe==0) then
           close(io1); close(io2)
          endif

         endif ! if enable_blue_const
        endif ! if load
       enddo ! n

      else ! mother < 0
c
c      childs get their blue_rho in sub_domain_exghc
c
       blue_p1=1; blue_p2=1; blue_f1=1.0; blue_f2=0.0 

      endif
      end subroutine read_blue





      subroutine add_blue_to_rho()
c-----------------------------------------------------------------------
c     add BLUE density in different formulation to model density
c-----------------------------------------------------------------------
      use spflame_module
      use blue_module
      implicit none
      integer :: i,k,j
      real :: a

      if (.not. enable_blue_simple) then
c
c      consider to read in data or not
c
       call read_blue

      endif
 
      if (enable_blue_smooth) then
c
c      smoothed version, calculate smoothed density first
c
       call calc_smooth_blue
       do j=js_pe-1,je_pe+1
        do k=1,km
         do i=is_pe-1,ie_pe+1
          rho(i,k,j) = rho(i,k,j)+blue_rhom(i,k,j) 
         enddo
        enddo
       enddo
      elseif (enable_blue_const) then
c
c      constant forcing, just add to model density
c
       do j=js_pe-1,je_pe+1
        do k=1,km
         do i=is_pe-1,ie_pe+1
          rho(i,k,j) = rho(i,k,j) + 
     &               (blue_rho(i,k,j,blue_p1)*blue_f1+
     &                blue_rho(i,k,j,blue_p2)*blue_f2)
         enddo
        enddo
       enddo
      else
c
c      the normal version
c
       do j=js_pe-1,je_pe+1
        do k=1,km
         do i=is_pe-1,ie_pe+1
          a=blue_alpha(i,k,j)
          rho(i,k,j) = a*rho(i,k,j) + 
     &        (1-a)* (blue_rho(i,k,j,blue_p1)*blue_f1+
     &                blue_rho(i,k,j,blue_p2)*blue_f2)
         enddo
        enddo
       enddo
      endif
      end subroutine add_blue_to_rho



      subroutine calc_smooth_blue
c-----------------------------------------------------------------------
c     calculate a smoothed version of density correction
c-----------------------------------------------------------------------
      use spflame_module
      use blue_module
      implicit none
      real, allocatable :: blue_rhoc(:,:,:)
      integer :: i,j,k,jj,ii
c
c     allocate work space
c
      allocate( blue_rhoc(is_pe-ismooth_blue:ie_pe+ismooth_blue
     &       ,km,js_pe-ismooth_blue:je_pe+ismooth_blue) )
      blue_rhoc=0.
c
c     density correction can be formulated as
c       rho_star = (1-alpha) ( rho_clim - rho_model)
c
      do j=js_pe,je_pe
        do k=1,km
          do i=is_pe,ie_pe
            blue_rhoc(i,k,j) = (1-blue_alpha(i,k,j))*
     &      (  (blue_rho(i,k,j,blue_p1)*blue_f1+
     &         blue_rho(i,k,j,blue_p2)*blue_f2)
     &        -rho(i,k,j) )
          enddo
        enddo
      enddo
c
c     boundary exchanges
c
      call border_exchg(blue_rhoc,km,ismooth_blue)
      call set_cyclic_nx(blue_rhoc,km,ismooth_blue)
c
c     now smooth rho_star
c
      blue_rhom=0.
      do jj=-ismooth_blue,ismooth_blue
       do j=js_pe,je_pe
        do k=1,km
         do ii=-ismooth_blue,ismooth_blue
          do i=is_pe,ie_pe
           blue_rhom(i,k,j)=blue_rhom(i,k,j)+blue_rhoc(i+ii,k,j+jj)
          enddo
         enddo
        enddo
       enddo
      enddo
      blue_rhom=blue_rhom /( 2.*ismooth_blue+1.)**2
      deallocate(blue_rhoc)
c
c     again boundary exchange
c
      call border_exchg(blue_rhom,km,1)
      call set_cyclic(blue_rhom,km,1)
      end subroutine calc_smooth_blue



c
c
c-----------------------------------------------------------------------
c     This module implements the BLUE approach
c     by J.Sheng and R.J. Greatbatch, JGR, 2000
c     to get a semi diagnostic model in certain
c     regions of the model domain dependend on 
c     the parameter blue_alpha.
c
c     if blue_alpha = 1.  fully prognostic
c     if blue_alpha = 0.5 semi prognostic or diagnostic
c     if blue_alpha = 0.  fully diagnostic
c
c     additional options: 
c
c      smooth correction a grid point smoother
c      taper alpha at lateral boundaries
c
c     linked in the code in setup, call of blue_mean_init
c                        in clinic, call of add_blue_mean_to_rho
c                        in domain_exchg, send/rec. blue_rho
c                           (not yet implemented)
c
c     parameters can be set in spflame_module (namelist)
c
c        enable_blue_mean
c        enable_blue_smooth
c        enable_blue_tapered
c        ilook_blue, ismooth_blue
c
c                                      c eden
c-----------------------------------------------------------------------
c

      module blue_mean_module
      implicit none

      real, allocatable :: blue_rho  (:,:,:) ! the clim. density
      real, allocatable :: blue_alpha(:,:,:)   ! the parameter alpha
      real, allocatable :: blue_rhom (:,:,:) ! the mean correction
      real, allocatable :: model_rhom (:,:,:) ! the mean model density

      character (len=80) :: blue_file
      integer :: counter 

      end module blue_mean_module


      subroutine blue_mean_init
c-----------------------------------------------------------------------
c     initialisation for BLUE
c-----------------------------------------------------------------------
      use spflame_module
      use blue_mean_module
      implicit none
      integer :: io,js,je,is,ie,i,j,k
      real, allocatable :: temp(:,:),salt(:,:)
      character (len=80) :: name

      is=max(1,is_pe-1); ie = min(imt,ie_pe+1)
      js=max(1,js_pe-1); je = min(jmt,je_pe+1)
c
c     hardwired file names
c 
      blue_file = 'blue_mean.mom'

      if (my_pe == 0) then
       print*,  ''
       print*,  ' Initialization of BLUE mean'
       print*,  ''
       if (mother < 0) then 
        print*,  ' reading temp/sal from file'
        print*,  blue_file
       else
        print*,' receiving blue density from mother domain '
       endif

       if (enable_blue_smooth) then
        print*,' using the smoothed version of BLUE mean'
        print*,' ismooth_blue =',ismooth_blue
       endif
       if (enable_blue_tapered) then
        print*,' using boundary tapering '
        print*,' ilook_blue = ',ilook_blue
       endif

      endif

      if (mother>0) then
        print*,' sub domain does not work yet'
        call halt_stop(' in blue_mean_init')
      endif
c
c     allocate permanent memory
c
      allocate( blue_rho(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) )
      allocate( blue_alpha(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) )
      blue_rho = 0.; blue_alpha = 1.

      allocate( blue_rhom(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) )
      blue_rhom=0.
      allocate( model_rhom(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) )
      model_rhom=0.

      if (mother < 0) then 
c
c      read blue density
c
       call getunit(io,blue_file,'usr ieee')

       allocate( temp(imt,km), salt(imt,km) )

       do j=1,jmt

          if (my_pe==0) read (io)    temp  ,salt

          call barrier
          call bcast_real(temp,imt*km,0) ! assuming that broadcasting is quicker than 
          call bcast_real(salt,imt*km,0) ! file IO
c
c         now calculate BLUE density from T/S fields
c          
          if (j>=js .and. j<=je) then
           do k=1,km
            call model_dens(temp(is,k), salt(is,k),
     &                  blue_rho(is,k,j),k,ie-is+1
#ifdef partial_cell
     &                       ,ztp(is,k,j)
#endif
     &                       )
           enddo
          endif

       enddo
       deallocate( temp,salt) 

       close(io)

      else
c
c       child domains receive their value from the mother domain
c
      endif
c
c     set the BLUE  parameter
c     (see also sub_domain_exchg for BLUE and BLUE parameter)
c
      blue_alpha=0.5


#ifdef prognostic_below_200m
c
c     use BLUE only above 200m
c
c      blue_alpha(:,13:km,:)=1.0
c      blue_alpha=1.0; blue_alpha(:,13:24,:)=0.5
      blue_alpha=1.0; blue_alpha(:,1:24,:)=0.5
#endif

      if (enable_blue_tapered) then
        call blue_mean_alpha_tapering()
      endif
c
c     read written data from previous run (if any)
c
      counter=0; blue_rhom = 0.; model_rhom = 0.

      write(name,'("bluerest_",i3,".dta")') sub_domain
      do i=1,len_trim(name); if (name(i:i) == ' ') name(i:i)='0'; enddo

      if (my_pe==0) then
        print*,''
        print*,' reading averaged model density from file ',
     &          name(1:len_trim(name))
      endif
      call get_free_iounit(io)
      open(io,file=name,form='unformatted',status='old',err=20)
      read(io) counter
      allocate( temp(imt,jmt), salt(imt,jmt) )
      do k=1,km
          if (my_pe==0) read (io) temp,salt
          call pe0_send_2D(temp)
          call pe0_send_2D(salt)
          do j=js,je
            do i=is,ie
              model_rhom(i,k,j) = temp(i,j)
              blue_rhom(i,k,j)  = salt(i,j)
            enddo
          enddo
      enddo
      deallocate( temp, salt) 
      close(io)
c
      call border_exchg(blue_rhom,km,1)
      call set_cyclic(blue_rhom,km,1)
      call border_exchg(model_rhom,km,1)
      call set_cyclic(model_rhom,km,1)
c
      if (my_pe == 0) print*,  'done'
      return

 20   if (my_pe==0) then
        print*,''
        print*,'---------------------------------------------'
        print*,' WARNING : cannot read file ',name(1:len_trim(name))
        print*,'---------------------------------------------'
        print*,''
      endif

      end subroutine blue_mean_init



      subroutine add_blue_mean_to_rho()
c-----------------------------------------------------------------------
c     add BLUE density in different formulation to model density
c-----------------------------------------------------------------------
      use spflame_module
      use blue_mean_module
      implicit none
      integer :: io,js,je,is,ie,i,j,k
      real, allocatable :: temp(:,:),salt(:,:)
      character (len=80) :: name

      is=max(1,is_pe-1); ie = min(imt,ie_pe+1)
      js=max(1,js_pe-1); je = min(jmt,je_pe+1)
c
c     continue to average model density
c
      if (.not. eulerback1 ) then

        counter=counter+1

        do j=js_pe-1,je_pe+1
          do k=1,km
           do i=is_pe-1,ie_pe+1
             model_rhom(i,k,j) = model_rhom(i,k,j) + rho(i,k,j)
           enddo
          enddo
        enddo
 
      endif
c
c     consider to calculate new mean correction
c
      if (end_of_year ) call change_blue_mean()
c
c     add correction to model density
c
      do j=js_pe-1,je_pe+1
       do k=1,km
        do i=is_pe-1,ie_pe+1
          rho(i,k,j) = rho(i,k,j) + blue_rhom(i,k,j)
        enddo
       enddo
      enddo
c
c     write a restart if end of run is reached
c
      if (last_time_step) then

       write(name,'("bluerest_",i3,".dta")') sub_domain
       do i=1,len_trim(name); if (name(i:i) == ' ') name(i:i)='0'; enddo

       if (my_pe==0) then
        print*,''
        print*,' writing averaged model density to file ',
     &          name(1:len_trim(name))
        call get_free_iounit(io)
        open(io,file=name,form='unformatted')
        write(io) counter
       endif

       allocate( temp(imt,jmt), salt(imt,jmt) )
       do k=1,km
         do j=js,je
          do i=is,ie
            temp(i,j)=model_rhom(i,k,j)
            salt(i,j)=blue_rhom(i,k,j)
          enddo
         enddo
         call pe0_recv_2D(temp)
         call pe0_recv_2D(salt)
         if (my_pe==0) write (io) temp,salt
       enddo
       deallocate( temp, salt) 
       if (my_pe == 0) then
        print*,  'done'
        close(io)
       endif

      endif ! last time step

      end subroutine add_blue_mean_to_rho



      subroutine change_blue_mean
c-----------------------------------------------------------------------
c     calculate a smoothed version of density correction
c     at the end of each year
c-----------------------------------------------------------------------
      use spflame_module
      use blue_mean_module
      implicit none
      real, allocatable :: blue_rhoc(:,:,:)
      integer :: i,j,k,jj,ii

      integer :: io,year,month,day
      character (len=80) :: name
      real, allocatable ::  buf(:,:)

      if (enable_blue_smooth) then
c
c      allocate work space for smoothing
c
       allocate( blue_rhoc(is_pe-ismooth_blue:ie_pe+ismooth_blue,
     &           km,js_pe-ismooth_blue:je_pe+ismooth_blue) )
       blue_rhoc=0.
c
c      density correction can be formulated as
c       rho_star = (1-alpha) ( rho_clim - rho_model)
c
       do j=js_pe,je_pe
        do k=1,km
          do i=is_pe,ie_pe
            blue_rhoc(i,k,j) = (1-blue_alpha(i,k,j))*
     &      (  blue_rho(i,k,j) -model_rhom(i,k,j)/counter )
          enddo
        enddo
       enddo
c
c      boundary exchanges
c
       call border_exchg(blue_rhoc,km,ismooth_blue)
       call set_cyclic_nx(blue_rhoc,km,ismooth_blue)
c
c      now smooth rho_star
c
       blue_rhom=0.
       do jj=-ismooth_blue,ismooth_blue
        do j=js_pe,je_pe
         do k=1,km
          do ii=-ismooth_blue,ismooth_blue
           do i=is_pe,ie_pe
            blue_rhom(i,k,j)=blue_rhom(i,k,j)+blue_rhoc(i+ii,k,j+jj)
           enddo
          enddo
         enddo
        enddo
       enddo
       blue_rhom=blue_rhom /( 2.*ismooth_blue+1.)**2
       deallocate(blue_rhoc)
c
c      again boundary exchange
c
       call border_exchg(blue_rhom,km,1)
       call set_cyclic(blue_rhom,km,1)

      else
c
c      no smoothing
c
       do j=js_pe,je_pe
        do k=1,km
          do i=is_pe,ie_pe
            blue_rhom(i,k,j) = (1-blue_alpha(i,k,j))*
     &      (  blue_rho(i,k,j) -model_rhom(i,k,j)/counter )
          enddo
        enddo
       enddo
c
c      boundary exchanges
c
       call border_exchg(blue_rhom,km,1)
       call set_cyclic(blue_rhom,km,1)

      endif
c
c     write the new correction to another binary file
c

#ifdef netcdf_diagnostics
c      not yet implemented
#endif

      year  = get_year(get_current_time())
      month = get_month_of_year(get_current_time())
      day   = get_day_of_month(get_current_time())
      write(name,'("blue_mean_corr_",i3,"_y",i4,"m",i2,"d",i2,".dta")') 
     &            sub_domain,year,month,day
      call replace_space_zero(name)

      if (my_pe==0) then
         print*,' writing BLUE mean correction to file ',
     &          name(1:len_trim(name))
         call getunit(io, name,'u s r ieee')
         write(io) imt,jmt,km
         write(io) xt,yt,zt
         write(io) counter
         write(io) kmt_big
      endif
      allocate( buf(imt,jmt) ); buf=0.
      do k=1,km
       buf(is_pe:ie_pe,js_pe:je_pe)=blue_rhom(is_pe:ie_pe,k,js_pe:je_pe)
       call pe0_recv_2D(buf)
       if (my_pe==0) write(io) buf
      enddo
      deallocate(buf)
      if (my_pe==0) then
       close(io)
       print*,'done'
      endif
c
c     zerofy counter and average field
c
      counter = 0
      model_rhom = 0.
      end subroutine change_blue_mean




      subroutine blue_mean_alpha_tapering
      use spflame_module
      use blue_mean_module
      implicit none
      integer :: i,k,j,ii,jj,iii,jjj

      do j=js_pe-1,je_pe+1
       do k=1,km
        do i=is_pe-1,ie_pe+1
         ii=i
         jj=j
         if (cyclic) then
            if (ii>imt) ii=ii-imt+2
            if (ii<1)   ii=ii+imt-2
         else
            ii = min(imt,ii)
            ii = max(1  ,ii)
         endif
         jj = min(jmt,jj)
         jj = max(1  ,jj)
         if (kmt_big(ii,jj)<k) blue_alpha(i,k,j)=1. ! land
        enddo
       enddo
      enddo

      do jj=-ilook_blue,ilook_blue
       do ii=-ilook_blue,ilook_blue
        do j=js_pe-1,je_pe+1
         do k=1,km
          do i=is_pe-1,ie_pe+1
           iii=ii+i
           jjj=jj+j
           if (cyclic) then
            if (iii>imt) iii=iii-imt+2
            if (iii<1)   iii=iii+imt-2
           else
            iii = min(imt,iii)
            iii = max(1  ,iii)
           endif
           jjj = min(jmt,jjj)
           jjj = max(1  ,jjj)
           if (kmt_big(iii,jjj)<=k) blue_alpha(i,k,j)=1. ! near land and above land
          enddo
         enddo
        enddo
       enddo
      enddo
      end subroutine blue_mean_alpha_tapering

#define skip_interp_details


      subroutine tmp_filename(name)
c--------------------------------------------------------------
c    returns temporary file name
c--------------------------------------------------------------
      implicit none
      character (len=*) :: name
      integer :: i
      real :: x
      logical :: ex=.true.
      do while (ex) 
       do i=1,len(name)
         call random_number(x)
         name(i:i)=char(int(x*25)+65)
       enddo
       inquire(file=name,exist=ex)
      end do
      end subroutine tmp_filename

      subroutine get_commandline_argnr(nr)
c--------------------------------------------------------------
c   returns number of command line arguments
c--------------------------------------------------------------
      integer, intent(out)  :: nr
      integer :: ierr
      character (len=80)   :: arg
      ierr=0; nr=0
 20   call get_commandline_arg(nr,arg,ierr)
      if (ierr==0 .and. arg /= '') then
         nr=nr+1; goto 20
      endif
      nr=nr-1
      end subroutine get_commandline_argnr

      subroutine get_commandline_arg(nr,arg,ierr)
c--------------------------------------------------------------
c     reads command line argument # nr
c     on error ierr is greater than zero
c--------------------------------------------------------------
      integer, intent(in)  :: nr
      integer, intent(out) :: ierr
      character (len=80)   :: arg
      integer :: ilen

      ierr=0
#if defined C90_host || defined T3E_host || defined IRIX_host
      call pxfgetarg(nr,arg,ilen,ierr)
#elif defined SR8000_host
      call getarg(nr+1,arg)
#else
      call getarg(nr,arg)
#endif
      end subroutine get_commandline_arg

      subroutine get_commandline_arg_int(nr,out,ierr)
c--------------------------------------------------------------
c     reads an integer from command line argument # nr
c     return integer out, on error ierr is greater than zero
c--------------------------------------------------------------
      integer, intent(in) :: nr
      integer, intent(out) :: out,ierr
      character (len=80) :: arg
      integer :: ilen
      ierr=0
#if defined C90_host || defined T3E_host || defined IRIX_host
      call pxfgetarg(nr,arg,ilen,ierr)
      if (ierr/=0) return
      read(arg,'(i)',err=9999,end=9999) out
#elif defined ALPHA_host || defined SX5_host
      call getarg(nr,arg)
      read(arg,'(i)',err=9999,end=9999) out
#elif defined SR8000_host
      call getarg(nr+1,arg)
      read(arg,*,err=9999,end=9999) out
#else
      call getarg(nr,arg)
      read(arg,*,err=9999,end=9999) out
#endif
      return
 9999 ierr=1;return
      end subroutine get_commandline_arg_int


      subroutine sub_flush(io)
c-----------------------------------------------------------------------
c     flushes IO unit io to disk
c-----------------------------------------------------------------------
      implicit none
      integer, intent(in) :: io
      integer :: iret
#if defined IRIX_host || defined SX5_host|| defined SR8000_host
      call flush(io,iret)
#elif defined T3E_host
      call flush(io,iret)
#elif defined C90_host
      call flush(io,iret)
#elif defined ALPHA_host
      call flush(io)
#elif defined SUN_host
      call flush(io)
#elif defined AIX_host
      call flush_(io)
#else
      ! do nothing
#endif
      end subroutine sub_flush


      subroutine get_free_iounit (nu)
c-----------------------------------------------------------------------
c     returns the first free IO unit number in nu
c-----------------------------------------------------------------------
      implicit none
      integer nu,n
      logical in_use
      character (len=80) :: name
      do n=7,99
        inquire (n, OPENED=in_use, NAME=name)
#if defined C90_host || defined T3E_host
	if (name .ne. '') then
	  in_use = .true.
	endif
#endif
	if (.not. in_use) then
	  nu = n
	  go to 10
	endif
      enddo
      print *,'Error: exhausted available unit numbers'
      print *,'       Are you forgetting to close units?'
      call halt_stop(' in get_free_iounit')
10    continue
      end subroutine get_free_iounit



      subroutine tolower (string)
      implicit none
      character (len=*) :: string
      character (len=1) :: c
      integer, parameter :: lcshift=32
      integer :: i
      do i=1,len(string)
        c = string(i:i)
        if ('A' .le. c .and. c .le. 'Z') then
          string(i:i) = char(ichar(c) + lcshift)
        end if
      end do
      end subroutine tolower

      subroutine replace_space_zero(name)
      implicit none
      character (len=*) :: name
      integer  :: i
      do i=1,len_trim(name)
          if (name(i:i)==' ')name(i:i)='0'
      enddo
      end subroutine replace_space_zero

      subroutine no_space_chars (string)
      implicit none
      character (len=*) :: string
      integer :: i
      do i=1,len(string)
       if (string(i:i).eq.' ') then
        string(i:len(string)-1)=string(i+1:len(string))
       endif
      enddo 
      end subroutine no_space_chars


      subroutine find_number (number, string)
      implicit none
      character (len=*) :: string
      character (len=1) :: c
      integer :: i,lens,is,ie,number
      do i=len(string),1,-1
        if (string(i:i) .ne. ' ') then
	  lens = i; go to 10
	endif
      enddo
10    is = index (string, '=')
      if (is /= 0) then
        do i=is,lens
          c = string(i:i)
          if (c .ge. '0' .and. c .le. '9') go to 20
        enddo
      else
        print *,' Error: need "=" sign when specifying record length'
	print *,' attributes = ',string
	call halt_stop(' in find_number')
      endif
20    is=i; ie = lens
      do i=is,lens
        c = string(i:i)
        if (c .lt. '0' .or. c .gt. '9') then
	  ie = i-1; go to 30
	endif
      enddo
30    continue
      if (ie .ne. 0) then
        read (string(is:ie), *) number 
      else
        print *,' Error: cannot find record length: string=',string
	call halt_stop(' in find_number')
      endif
      end subroutine find_number


      subroutine getunit (nu, filename, optionlist)
c
c-----------------------------------------------------------------------
c     connect unit number "nu" to "filename" and open the file with
c     the requested options in the string optionlist
c     the options might be:
c     fsr | formatted sequential rewind   : write new formatted file
c     fsa | formatted sequential append   : append to formatted file
c     usr | unformatted sequential rewind : write new unformatted file
c     usa | unformatted sequential append : append to unformatted file
c     ud = recln | unformatted direct words= recln : write to direct access file
# if defined C90_host  || defined T3E_host || defined IRIX_host
c     There are three different assign types which can be specified
c     after the other options:   ieee, t3e, f77  and cray 
#endif
c     Default options are : formatted, sequential, rewind
c-----------------------------------------------------------------------
c
      implicit none
      integer :: nu
      character (len=*) :: filename,optionlist
      character (len=128) :: options,string
      logical :: file_exists = .false., direct = .false.
      character (len=20) :: form, position, access, status
      integer :: len_bytes,ierr,number,len_words
      call get_free_iounit (nu)
c     check for STATUS
      inquire ( FILE=filename, EXIST=file_exists )
      status='old'; if ( .not. file_exists) status='new'
c     prepare options to parse
      options=optionlist
      call tolower (options)
      call no_space_chars (options)
c     Formatted or unformatted
      if     ( index(options,'unformatted').gt.0) then
         form = 'unformatted'
      elseif ( index(options,'formatted').gt.0)   then
         form = 'formatted'
      elseif ( options(1:1).eq.'u') then
         form = 'unformatted'
      elseif ( options(1:1).eq.'f') then
         form = 'formatted'
      else
       print*,' in getunit : '
       print*,' cannot read optionlist (formatted or unformatted)'
       print*,' assuming formatted '
       form = 'formatted'
      endif
c     direct or sequential
      if     ( index(options,'direct').gt.0)      then
        direct = .true.
      elseif ( index(options,'sequential').gt.0)  then
         direct = .false.
      elseif ( options(2:2).eq.'d') then
         direct=.true.
      elseif ( options(2:2).eq.'s') then
         direct=.false.
      else
       print*,' in getunit : '
       print*,' cannot read optionlist (direct or sequential)'
       print*,' assuming sequential '
       direct = .false.
      endif
c     Sequential or direct access
      if (direct) then
        access = 'direct'
	call find_number (len_words, options)
c       convert to bytes assuming 8 bytes per word
        len_bytes = 8*len_words
      else
        access = 'sequential'
        if     ( index(options,'append').gt.0)   then
          position = 'append'
        elseif ( index(options,'rewind').gt.0)   then
          position = 'rewind'
        elseif ( options(3:3).eq.'a') then
          position = 'append'
        elseif ( options(3:3).eq.'r') then
          position = 'rewind'
        else
          print*,' in getunit : '
          print*,' cannot read optionlist (append or rewind)'
          print*,' assuming rewind'
          position = 'rewind'
        endif
      endif
# if defined C90_host  || defined T3E_host || defined IRIX_host
c     parse options for assign statements
       string=' '
       if  ( index(options,'ieee').gt.0) then
	  string = 'assign -F f77 -N ieee f:'//filename
       elseif  ( index(options,'t3e').gt.0) then
	  string = 'assign -N t3e f:'//filename
       elseif  ( index(options,'cray').gt.0) then
	  string = 'assign -N cray f:'//filename
       elseif  ( index(options,'f77').gt.0) then
	  string = 'assign -F f77 f:'//filename
       endif
       if (string /= ' ') then
        call assign (string, ierr)
        if (ierr .ne. 0) then
         print *,' assign failed: ierr=', ierr, ' string=',string
         call assign ('assign -V', ierr)
         call halt_stop(' in getunit')
        endif
       endif
# endif
c      Now open the file 
#  if defined test_iomngr 
       print*,'UNIT    =',nu
       print*,'FILE    = ',filename(1:len_trim(filename))
       print*,'FORM    =',form(1:len_trim(form))
       print*,'ACCESS  =',access(1:len_trim(access))
       print*,'STATUS  =',status(1:len_trim(status))
       print*,'POSITION=',position(1:len_trim(position))
       print*,'RECL    =',len_bytes
#  endif
      if (direct) then
       open (nu, FILE=filename, FORM=form, ACCESS=access
     &,       STATUS=status,RECL=len_bytes)
      else
c    some f77-compilers like GNUs g77 do not like POSITION, 
c    use ACCESS instead
c       open (nu, FILE=filename, FORM=form, ACCESS=position
c     &,       STATUS=status)
       open (nu, FILE=filename, FORM=form, ACCESS=access
     &,       STATUS=status,POSITION=position)
      endif
      end subroutine getunit




      function indp (value, array, ia)
c
c=======================================================================
c
c     indp = index of nearest data point within "array" corresponding to
c            "value".
c
c     inputs:
c
c     value  = arbitrary data...same units as elements in "array"
c     array  = array of data points  (must be monotonically increasing)
c     ia     = dimension of "array"
c
c     output:
c
c     indp =  index of nearest data point to "value"
c             if "value" is outside the domain of "array" then indp = 1
c             or "ia" depending on whether array(1) or array(ia) is
c             closest to "value"
c
c             note: if "array" is dimensioned array(0:ia) in the calling
c                   program, then the returned index should be reduced
c                   by one to account for the zero base.
c
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c
c     example:
c
c     let model depths be defined by the following:
c     parameter (km=5)
c     dimension z(km)
c     data z /5.0, 10.0, 50.0, 100.0, 250.0/
c
c     k1 = indp (12.5, z, km)
c     k2 = indp (0.0, z, km)
c
c     k1 would be set to 2, & k2 would be set to 1 so that
c     z(k1) would be the nearest data point to 12.5 and z(k2) would
c     be the nearest data point to 0.0
c
c=======================================================================
c
      integer indp
      integer :: stdout=6
      dimension array(ia)
c
      do i=2,ia
        if (array(i) .lt. array(i-1)) then
	  write (stdout,*)
     &   ' => Error: array must be monotonically increasing in "indp"' 
     &,  '           when searching for nearest element to value=',value 
	  write (stdout,*) '           array(i) < array(i-1) for i=',i 
          write (stdout,*) '           array(i) for i=1..ia follows:'
	  do ii=1,ia
	    write (stdout,*) 'i=',ii, ' array(i)=',array(ii)
          enddo
	  stop
	endif
      enddo
      if (value .lt. array(1) .or. value .gt. array(ia)) then
        if (value .lt. array(1))  indp = 1
        if (value .gt. array(ia)) indp = ia
        return
      else
        do i=2,ia
          if (value .le. array(i)) then
            indp = i
            if (array(i)-value .gt. value-array(i-1)) indp = i-1
            go to 101
          endif
        enddo
101     continue
      endif
      end function indp



      subroutine ftc(f, if, jf, xf, yf, c, ic, jc, istart, iend
     &,               jstart, jend, xc, yc, init, work, lenw,spval)
c
c=======================================================================
c
c     "ftc" is a nemonic for "fine to coarse".
c
c     obtain a coarse grid representaion of a fine grid dataset by area
c     averaging grid boxe values on the fine grid which overlay coarse 
c     grid boxes. note: the coarse grid boxes do not have to contain an
c     integral number of fine grid boxes.
c
c
c     inputs:
c
c     f      = data on fine grid
c     if     = inner dimension of "f"
c     jf     = outer dimension of "f"
c     xf     = coordinates for inner dimension of "f" (eg: longitues)
c     yf     = coordinates for outer dimension of "f" (eg: latitues)
c
c     ic     = inner dimension of coarse grid "c"
c     jc     = outer dimension of coarse grid "c"
c     istart = starting index along inner dimension of "c" for which
c              averaged values are desired
c     iend   = ending index along inner dimension of "c" for which
c              averaged values are desired
c     jstart = starting index along outer dimension of "c" for which
c              averaged values are desired
c     jend   = ending index along outer dimension of "c" for which
c              averaged values are desired
c     xc     = coordinates for inner dimension of "c" (eg: longitues)    
c     yc     = coordinates for outer dimension of "c" (eg: latitues)    
c     init   = initialize the averaging factors
c              "init" should be set = 1 on the first call. 
c              "init" <> 1 uses the previously computed factors stored
c              in "work" array.
c     work   = work array of averaging factors when "init" <> 1
c              (previously calculated by "ftc" when "init" = 1)
c     lenw   = size of work array. lenw should be >= 9*max(if,jf)
c     spval  = special value masking out dry points
c       
c     output:
c
c     c  = coarse grid average of "f" defined over
c          ((c(i,j),i=istart,iend),j=jstart,jend)
c     work   = work array of averaging factors when "init" = 1
c
c     restrictions:
c
c     fine and coarse grids are assumed rectangular with "xf" and "xc"
c     having the same units. "yf" and "yc" must also have the same units
c     the coarse domain xc(istart)...xc(iend) must be within 
c     the fine domain xf(1)...xf(if). similarly,
c     yc(jstart)...yc(jend) must be within yf(1)...yf(jf). all 
c     coordinates must be strictly monotonically increasing.
c 
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
!     modified:    J. Dengg, jdengg@awi-bremerhaven.de
!                  Sep-97
c=======================================================================
c
      integer :: stdout=6,indp
      logical error, show_coord
      parameter (len=10000, p5=0.5, c0=0.0)
      dimension iso(0:len), ieo(0:len), jso(0:len), jeo(0:len)
     &,         dx(0:len,2), dy(0:len,2), edgecx(0:len), edgecy(0:len)
     &,         edgefx(0:len), edgefy(0:len)
      dimension f(if,jf), xf(if), yf(jf)
      dimension c(ic,jc), xc(ic), yc(jc)
      dimension work(lenw)
      real,intent(in) :: spval
c
c-----------------------------------------------------------------------
c     initialize weights or use previously calculated weights
c-----------------------------------------------------------------------
c
      if (init .eq. 1) then
        error = .false.
c	write (stdout,*)
c     & '              (initializing the averaging weights)'
c        write (stdout,*) ' '
c
c       test to verify that array sizes do not exceed limits
c
        if (if .gt. len .or. jf .gt. len) then
          i = max(if,jf)
          write (stdout,*) '=>Error: increase "len" in "ftc" to ',i
          stop '=>ftc'        
        endif
	if (lenw .lt. 9*max(if,jf)) then
          write (stdout,*) '=>Error: increase size of "work" array',
     &      ' to at least ',9*max(if,jf),' for calls to "ftc"'
	  error = .true.
        endif
c
c       verify that the "coarse" grid lies within the "fine" grid
c
        if (xf(1) .gt. xc(istart) .or. xf(if) .lt. xc(iend)) then
          write (stdout,*)
     &     '=>Warning: Coarse grid "xc" is outside "fine" grid "xf".'
          if (xf(1) .gt. xc(istart)) then
	    write (stdout,*) '  xc(',istart,')  .lt.  xf(1)'  
	  endif
          if (xf(if) .lt. xc(iend)) then
	    write (stdout,*) '  xc(',iend,')  .gt.  xf(',if,')'  
	  endif
        endif 
        if (yf(1) .gt. yc(jstart) .or. yf(jf) .lt. yc(jend)) then
          write (stdout,*)
     &     '=>Warning: Coarse grid "yc" is outside "fine" grid "yf".'
          if (yf(1) .gt. yc(jstart)) then
	    write (stdout,*) '  yc(',jstart,') .lt. yf(1)' 
	  endif
          if (yf(jf) .lt. yc(jend)) then
	    write (stdout,*) '  yc(',jend,')  .gt.  yf(',jf,')'  
	  endif
        endif
c
c       construct edges of "coarse" grid boxes
c
        do i=1,ic-1
	  edgecx(i) = p5*(xc(i) + xc(i+1))
        enddo
        edgecx(0)  = xc(1) - (edgecx(1) - xc(1))
	edgecx(ic) = xc(ic) + (xc(ic) - edgecx(ic-1))
c
        do j=1,jc-1
	  edgecy(j) = p5*(yc(j) + yc(j+1))
        enddo
        edgecy(0)  = yc(1) - (edgecy(1) - yc(1))
	edgecy(jc) = yc(jc) + (yc(jc) - edgecy(jc-1))
c
c       construct edges of "fine" grid boxes
c
        do i=1,if-1
	  edgefx(i) = p5*(xf(i) + xf(i+1))
        enddo
        edgefx(0)  = xf(1) - (edgefx(1) - xf(1))
	edgefx(if) = xf(if) + (xf(if) - edgefx(if-1))
c
        do j=1,jf-1
	  edgefy(j) = p5*(yf(j) + yf(j+1))
        enddo
        edgefy(0)  = yf(1) - (edgefy(1) - yf(1))
	edgefy(jf) = yf(jf) + (yf(jf) - edgefy(jf-1))
c
c       calculate "dx" and "dy" for the "fine" grid boxes
c
	do i=1,if
	  dx(i,1) = edgefx(i) - edgefx(i-1)       
	  dx(i,2) = dx(i,1)
        enddo
	dx(0,1) = dx(1,1)
	dx(0,2) = dx(1,2)
c
	do j=1,jf
	  dy(j,1) = edgefy(j) - edgefy(j-1)
	  dy(j,2) = dy(j,1)
        enddo
	dy(0,1) = dy(1,1)
	dy(0,2) = dy(1,2)
c
c       modify "dx" and "dy" for possibly partial "fine" grid boxes 
c       near the edges of each coarse grid box.
c       "ii" is the index of the fine grid box which contains the
c       eastern edge of coarse grid box with index "i".
c       dx(ii,1) is the portion of the fine grid box to the west of the
c       edge and dx(ii,2) is the portion to the east. similarly,
c       dy(jj,1) is to the south and dy(jj,2) is to the north of the
c       northern edge of coarse box with index "j".
c        
c       note: edgefx and edgefy are zero based and need the -1 when
c       using "indp" 
c
        do i=0,ic
	  ii   = indp (edgecx(i), edgefx, if+1) - 1
	  frac = abs(edgecx(i) - edgefx(ii))
	  if (edgefx(ii) .lt. edgecx(i)) then
	    ii = ii + 1
	    dx(ii,2) = (edgefx(min(if,ii)) - edgefx(ii-1)) - frac
	    dx(ii,1) = frac
	  else
	    dx(ii,2) = frac
	    dx(ii,1) = (edgefx(ii) - edgefx(max(ii-1,0))) - frac
	  endif
	  ieo(i) = min(if,max(1,ii))
        enddo
        do i=1,ic
	  iso(i) = max(1,ieo(i-1))
        enddo
        iso(0) = ieo(0)
c
        do j=0,jc
	  jj   = indp (edgecy(j), edgefy, jf+1) - 1
	  frac = abs(edgecy(j) - edgefy(jj))
	  if (edgefy(jj) .lt. edgecy(j)) then
	    jj = jj + 1
	    dy(jj,2) = (edgefy(min(jf,jj)) - edgefy(jj-1)) - frac
	    dy(jj,1) = frac
	  else
	    dy(jj,2) = frac
	    dy(jj,1) = (edgefy(jj) - edgefy(max(jj-1,0))) - frac
	  endif
	  jeo(j) = min(jf,max(1,jj))
        enddo
        do j=1,jc
	  jso(j) = max(1,jeo(j-1))
        enddo
        jso(0) = jeo(0)
c
c       store the weights into the "work" array
c
        indx = 1
        do j=0,jc
	  work(indx)   = jso(j)
	  work(indx+1) = jeo(j)
	  indx         = indx + 2
        enddo
c
        do i=0,ic
	  work(indx)   = iso(i)
	  work(indx+1) = ieo(i)
	  indx         = indx + 2
        enddo
c
        do j=0,jf
	  work(indx)   = dy(j,1)
	  work(indx+1) = dy(j,2)
	  indx         = indx + 2
        enddo
c
        do i=0,if
	  work(indx)   = dx(i,1)
	  work(indx+1) = dx(i,2)
	  indx         = indx + 2
        enddo
c
c       verify that coarse grid is coarser than the fine grid
c
        do j=jstart,jend
	  if ((jso(j) .eq. jso(j+1)) .and. (yc(j) .ge. yf(1))
     &      .and. (yc(j) .le. yf(jf))) then
            write (stdout,*)
     &         '=>Warning: "Coarse" grid is finer than "fine" grid'
     &,     ' near yf(',jso(j),') =',yf(jso(j))
     &,     ' (average may not be accurate)'
	  endif
        enddo
c
        do i=istart,iend
	  if ((iso(i) .eq. iso(i+1)) .and. (xc(i) .ge. xf(1))
     &      .and. (xc(i) .le. xf(if))) then
            write (stdout,*)
     &      '=>Warning: "Coarse" grid is finer than "fine" grid'
     &,     ' near xf(',iso(i),') = ',xf(iso(i))
     &,     ' (average may not be accurate)'
	  endif
        enddo
#ifdef skip_interp_details
        show_coord = .false.
c        print '(/a/)'
c     &,   'Remove -Dskip_interp_details to show the indices'
#else
        show_coord = .true.
        print '(/a/)'
     &,   'Use -Dskip_interp_details to not show the following'
#endif
        if (error .or. show_coord) then
          write (stdout,*)
     & ' Indices for averaging fine grid to coarse grid:'
          write (stdout,*)
     & ' (fractional grid boxes are accounted for)'
          write (stdout,8700)
          write (stdout,9000) (m,iso(m),ieo(m),m=istart,iend)
	  write (stdout,*) ' '
          write (stdout,*) ' Coordinates for coarse grid points "xc" ='
          write (stdout,8500) xc
          write (stdout,*) ' Coordinates for fine grid points "xf" ='
          write (stdout,8500) xf
c
          write (stdout,8800)
          write (stdout,9000) (m,jso(m),jeo(m),m=jstart,jend)
	  write (stdout,*) ' '
          write (stdout,*) ' Coordinates for coarse grid points "yc" ='
          write (stdout,8500) yc
          write (stdout,*) ' Coordinates for fine grid points "yf" ='
          write (stdout,8500) yf
        endif
        if (error) stop '=>ftc'
      else
c	write (stdout,*)
c     & '              (using previously initialized averaging weights)'
c        write (stdout,*) ' '
c
c       extract the weights from the "work" array
c
        indx = 1
        do j=0,jc
	  jso(j) = nint(work(indx))   
	  jeo(j) = nint(work(indx+1))
	  indx   = indx + 2
        enddo
c
        do i=0,ic
	  iso(i) = nint(work(indx))
	  ieo(i) = nint(work(indx+1))
	  indx   = indx + 2
        enddo
c
        do j=0,jf
	  dy(j,1) = work(indx)
	  dy(j,2) = work(indx+1)
	  indx    = indx + 2
        enddo
c
        do i=0,if
	  dx(i,1) = work(indx)
	  dx(i,2) = work(indx+1)
	  indx    = indx + 2
        enddo
      endif
c
c-----------------------------------------------------------------------
c     average the "fine" grid to the "coarse" grid
c-----------------------------------------------------------------------
c
      nd = 0              ! initialize counter
      do m=jstart,jend
        do i=istart,iend
          weight = c0
          sum    = c0
          do j=jso(m),jeo(m)
	    indy = 2
	    if (j .eq. jeo(m)) indy = 1
	    wty = dy(j,indy)
            do ii=iso(i),ieo(i)
	      indx = 2
	      if (ii .eq. ieo(i)) indx = 1
              if (f(ii,j).eq.spval) then
                area = c0
              else
                area = dx(ii,indx)*wty
              end if
              weight = weight + area
              sum    = sum + f(ii,j)*area
            enddo
          enddo
          if (weight .ne. c0) then 
            c(i,m) = sum/weight
          else
            c(i,m) = spval
            nd = nd+1
          end if
        enddo
      enddo
#ifndef skip_interp_details
      if (nd.ne.0) write(stdout,'(i8,a,e15.5,a/)')
     &     nd,' points set to special value ', spval, ' during ftc!'
#endif
      return
8500  format (1x,10g11.4)
8700  format (/' Along the 1st dimension, the form is (Coarse grid'
     &,' point "xc": range of fine grid points "xf" to average)'/)
8800  format (/' Along the 2nd dimension, the form is (Coarse grid'
     &,' point "yc": range of fine grid points "yf" to average)'/)
9000  format (5(1x,'(',i4,': ',i4,' to ',i4,')'),/)
      end subroutine ftc




      subroutine ctf(c, ic, jc, xc, yc, f, if, jf, istart, iend
     &,               jstart, jend, xf, yf, init, work, lenw,spval)
c
c=======================================================================
c
c     "ctf" is a nemonic for "coarse to fine".
c
c     obtain a fine grid representaion of a coarse grid dataset by 
c     linear interpolation of grid box values on the coarse grid to grid   
c     boxes on the fine grid.
c
c
c     inputs:
c
c     c      = coarse grid data
c     ic     = inner dimension of coarse grid "c"
c     jc     = outer dimension of coarse grid "c"
c     xc     = coordinates for inner dimension of "c" (eg: longitues)    
c     yc     = coordinates for outer dimension of "c" (eg: latitues)    
c
c     if     = inner dimension of "f"
c     jf     = outer dimension of "f"
c     xf     = coordinates for inner dimension of "f" (eg: longitues)
c     yf     = coordinates for outer dimension of "f" (eg: latitues)
c
c     istart = starting index along inner dimension of "f" for which
c              interpolated values are desired
c     iend   = ending index along inner dimension of "f" for which
c              interpolated values are desired
c     jstart = starting index along outer dimension of "f" for which
c              interpolated values are desired
c     jend   = ending index along outer dimension of "f" for which
c              interpolated values are desired
c     init   = initialize the interpolation factors
c              "init" should be set = 1 on the first call. 
c              "init" <> 1 uses the previously computed factors stored
c              in "work" array.
c     work   = work array of interpolation factors when "init" <> 1
c              (previously calculated by "ctf" when "init" = 1)
c     lenw   = size of work array. lenw should be >= 8*max(if,jf)
c     spval  = special value masking out dry points
c       
c     output:
c
c     f      = interplated data on fine grid defined over
c              ((f(i,j),i=istart,iend),j=jstart,jend)
c     work   = work array of interpolation factors when "init" = 1
c
c     restrictions:
c
c     fine and coarse grids are assumed rectangular with "xf" and "xc"
c     having the same units. "yf" and "yc" must also have the same units
c     the fine domain xf(istart)...xf(iend) must be within 
c     the coarse domain xc(1)...xc(ic). Similarly,   
c     and yc(js)...yc(je) must be within yf(1)...yf(jf). all coordinates
c     must be strictly monotonically increasing.
c 
c
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
!     modified:    J. Dengg, jdengg@awi-bremerhaven.de
!                  Sep-97
c=======================================================================
c
      integer :: stdout=6,indp
      logical error, show_coord
      parameter (len=10000, p5=0.5, c0=0.0)
      dimension indxi(len), indxj(len), dnorth(len), dsouth(len)
     &,         deast(len), dwest(len), width(len), height(len)
      dimension f(if,jf), xf(if), yf(jf)
      dimension c(ic,jc), xc(ic), yc(jc)
      dimension work(lenw)
      real,intent(in) :: spval
c
c-----------------------------------------------------------------------
c     initialize weights or use previously calculated weights
c-----------------------------------------------------------------------
c
      if (init .eq. 1) then
        error = .false.
c
c       test to verify that array sizes do not exceed limits
c
        if (if .gt. len .or. jf .gt. len) then
          i = max(if,jf)
          write (stdout,*) '=>Error: increase "len" in "ctf" to ',i
	  error = .true.
        endif
	if (lenw .lt. 8*max(if,jf)) then
          write (stdout,*) '=>Error: increase size of "work" array',
     &      ' to at least ',8*max(if,jf),' for calls to "ctf"'
	  error = .true.
        endif
c
c       verify that the "fine" grid lies within the "coarse" grid
c
        epsilon = 1.e-5
        xcminus = xc(1) - epsilon*(xc(2)-xc(1))
	xcplus = xc(ic) + epsilon*(xc(ic)-xc(ic-1))
        if (xf(istart) .lt. xcminus .or. xf(iend) .gt. xcplus) then
	  error = .true.
        write (stdout,*)
     &    '=>Warning: "fine" grid outside "coarse" grid in "ctf".'
          if (xf(istart) .lt. xc(1)) then
	    write (stdout,*) '  xf(',istart,')  .lt.  xc(1)'  
	  endif
          if (xc(ic) .lt. xf(iend)) then
	    write (stdout,*) '  xf(',iend,')  .gt.  xc(',ic,')'  
	  endif
        endif 
        ycminus = yc(1) - epsilon*(yc(2)-yc(1))
	ycplus = yc(jc) + epsilon*(yc(jc)-yc(jc-1))
        if (ycminus .gt. yf(jstart) .or. ycplus .lt. yf(jend)) then
	  error = .true.
          write (stdout,*)
     &    '=>Warning: "fine" grid outside "coarse" grid in "ctf".'
          if (yc(1) .gt. yf(jstart)) then
	    write (stdout,*) '  yf(',jstart,') .lt. yc(1)' 
	  endif
          if (yc(jc) .lt. yf(jend)) then
	    write (stdout,*) '  yf(',jend,')  .gt.  yc(',jc,')'  
	  endif
        endif
c
c       find interpolation factors 
c
        indx = 1
        do j=jstart,jend
	  jj = indp (yf(j), yc, jc)
	  if (yc(jj) .gt. yf(j) .or. jj .eq. jc) jj = jj - 1
	  indxj(j) = jj
	  dnorth(j) = yc(jj+1) - yf(j)
	  dsouth(j) = yf(j) - yc(jj)
	  height(j) = yc(jj+1) - yc(jj)
c
c         store into "work" array for future use (when "init" <> 1)
c
          work(indx)   = indxj(j)
	  work(indx+1) = dnorth(j)
	  work(indx+2) = dsouth(j)
	  work(indx+3) = height(j)
	  indx         = indx + 4
        enddo
c
        do i=istart,iend
	  ii = indp (xf(i), xc, ic)
	  if (xc(ii) .gt. xf(i) .or. ii .eq. ic) ii = ii - 1
	  indxi(i) = ii
	  deast(i) = xc(ii+1) - xf(i)
	  dwest(i) = xf(i) - xc(ii)
	  width(i) = xc(ii+1) - xc(ii)
c
c         store into "work" array for future use (when "init" <> 1)
c
          work(indx)   = indxi(i)
	  work(indx+1) = deast(i)
	  work(indx+2) = dwest(i)
	  work(indx+3) = width(i)
	  indx         = indx + 4
        enddo
#ifdef skip_interp_details
        show_coord = .false.
c        print '(/a/)'
c     &,   'Remove -Dskip_interp_details to show the coordinates'
#else
        show_coord = .true.
        print '(/a/)'
     &,   'Use -Dskip_interp_details to not show the following'
#endif
        if (error .or. show_coord) then
	  write (stdout,*) ' '
          write (stdout,*) ' Coordinates for coarse grid points "xc" ='
          write (stdout,8500) xc
	  write (stdout,*) ' Coordinates for fine grid points "xf" ='
          write (stdout,8500) xf

          write (stdout,*) ' Coordinates for coarse grid points "yc" ='
          write (stdout,8500) yc
          write (stdout,*) ' Coordinates for fine grid points "yf" ='
          write (stdout,8500) yf
        endif
	if (error) stop '=>ctf'
      else
c
c       extract previously calculated interpolation weights from "work"
c
        indx = 1
        do j=jstart,jend
          indxj(j)  = nint(work(indx))
	  dnorth(j) = work(indx+1)
	  dsouth(j) = work(indx+2)
	  height(j) = work(indx+3)
	  indx      = indx + 4
        enddo
c
        do i=istart,iend 
          indxi(i) = nint(work(indx))
	  deast(i) = work(indx+1)
	  dwest(i) = work(indx+2)
	  width(i) = work(indx+3)
	  indx     = indx + 4
        enddo
      endif
c
c-----------------------------------------------------------------------
c     interpolate data from "coarse" to "fine" grid
c-----------------------------------------------------------------------
c
      nd = 0
      do jj=jstart,jend
        j = indxj(jj)
        do ii=istart,iend
	  i = indxi(ii)
          if (c(i,j) .eq. spval) then 
             w1=c0; w11=c0
          else
             w1=c(i,j)*deast(ii)*dnorth(jj)
            w11=deast(ii)*dnorth(jj)
          end if 
          if (c(i+1,j) .eq. spval) then
             w2=c0; w22=c0
          else
             w2=c(i+1,j)*dwest(ii)*dnorth(jj)
            w22=dwest(ii)*dnorth(jj)
          end if
          if (c(i,j+1) .eq. spval) then
             w3=c0; w33=c0
          else
             w3=c(i,j+1)*deast(ii)*dsouth(jj)
            w33=deast(ii)*dsouth(jj)
          end if
          if (c(i+1,j+1) .eq. spval) then
             w4=c0; w44=c0
          else
             w4=c(i+1,j+1)*dwest(ii)*dsouth(jj)
            w44=dwest(ii)*dsouth(jj)
          end if
          weight = w11+w22+w33+w44
          if (weight .ne. c0) then
            f(ii,jj)= (w1+w2+w3+w4)/weight   
          else
            f(ii,jj) = spval
            nd = nd+1
          end if
        enddo
      enddo
#ifndef skip_interp_details
      if (nd.ne.0) write(stdout,'(i8,a,e15.5,a/)')
     &     nd,' land points set to special value ', spval,
     &     ' during ctf!'
#endif
c
8500  format (1x,10g11.3)
      end subroutine ctf


      subroutine rotate (glt, gln, phir, thetar, psir, rlt, rln)
c
c=======================================================================
c     subroutine rotate takes a geographic latitude and longitude and 
c     finds the the equivalent latitude and longitude on a rotated grid.
c     when going from a geographic grid to a rotated grid, all of the 
c     defined rotation angles given to rotate by the calling program 
c     are positive, but when going from a rotated grid back to the 
c     geographic grid, the calling program must reverse the angle order 
c     (phir and psir are switched) and all of the angles made negative.
c
c     the first rotation angle phir is defined as a rotation about the
c     original z axis. the second rotation angle thetar is defined as a
c     rotation about the new x axis. the final rotation angle psir is
c     defined as a rotation about the new z axis. these rotation angles
c     are just the Euler angles as defined in "classical mechanics"
c     Goldstein (1951).
c
c     author:   M. Eby            e-mail eby@uvic.ca
c=======================================================================
c
c     g...  = geographic value
c     r...  = rotated value
c     ...lt = latitude (or equivalent spherical coordinate)
c     ...ln = longitude (or equivalent spherical coordinate)
c     ...x  = x coordinate
c     ...y  = y coordinate
c     ...z  = z coordinate
c     psir, thetar, phir = Euler angles defining rotation
c
c     define rad for conversion to radians.
      implicit none
      real (kind=8) glt, gln, phir, thetar, psir, rlt, rln
      real (kind=8) rad,thetas,phis,gx,gy,gz,rx,ry,rz
      real (kind=8) :: c1=1.
c
      rad = acos(-1.)/180.
c
c     convert latitude and longitude to spherical coordinates
      thetas = gln
      if (thetas .gt. 180.) thetas = thetas - 360.
      if (thetas .lt. -180.) thetas = thetas + 360.
      phis = (90. - glt)*rad
      thetas = thetas*rad
c
c     translate point into Cartesian coordinates for rotation.
      gx = sin(phis)*cos(thetas)
      gy = sin(phis)*sin(thetas)
      gz = cos(phis)
c
c     rotate the point (gx, gy, gz) about the z axis by phir then the x
c     axis by thetar and finally about the z axis by psir.
c 
      rx = gx*(cos(psir)*cos(phir) - cos(thetar)*sin(phir)*sin(psir)) +
     &     gy*(cos(psir)*sin(phir) + cos(thetar)*cos(phir)*sin(psir)) +
     &     gz*sin(psir)*sin(thetar)
c
      ry = gx*(-sin(psir)*cos(phir) - cos(thetar)*sin(phir)*cos(psir)) +
     &     gy*(-sin(psir)*sin(phir) + cos(thetar)*cos(phir)*cos(psir)) +
     &     gz*(cos(psir)*sin(thetar))
c
      rz = gx*(sin(thetar)*sin(phir)) + gy*(-sin(thetar)*cos(phir)) +
     &     gz*(cos(thetar))
c
c     convert rotated point back to spherical coordinates
c
c     check for rounding error (arccos(x): abs(x) must be .le. 1)
      rz = min(rz, c1)
      rz = max(rz, -c1)
      rlt = acos(rz)
c     if point is at a pole set rotated longitude equal to initial.
      if (rlt .le. 0. .or. rlt .ge. 180.*rad) then
        rln = thetas
      else
c     if rln lies between -135 and -45 or between 45 and 135 degrees
c     it is more accurate to use an arccos calculation.
        if (abs(rx/sin(rlt)) .lt. cos(45.*rad)) then
          rln = rx/sin(rlt)
c     check for rounding error (arccos(x): abs(x) must be .le. 1)
          rln = min(rln, c1)
          rln = max(rln, -c1)
          rln = acos(rln)
c     arccos will give rln between 0 and 180 degrees.  if the point
c     is negative in y, rln must be equal to negative rln.
          if (ry .lt. 0.) rln = -rln
        else
c     if rln lies between -45 and 45 or between 135 and -135 degrees
c     it is more accurate to use an arcsin calculation.
          rln = ry/sin(rlt)
c     check for rounding error (arcsin(x): abs(x) must be .le. 1)
          rln = min(rln, c1)
          rln = max(rln, -c1)
          rln = asin(rln)
c     arcsin will give rln between -90 and 90 degrees. if the point
c     is negative in x, rln must be equal to 180 degrees minus rln.
          if (rx .lt. 0.) rln = 180.*rad - rln
        endif
      endif
c
c     convert back to degrees of latitude and longitude.
      rlt = 90. - rlt/rad
      rln = rln/rad
      if (rln .gt. 180.) rln = rln - 360.
      if (rln .le. -180.) rln = rln + 360.
      end subroutine rotate






      subroutine rot_intrp_sclr(g_in, xg_in, yg, ig, jg, r, xr, yr
     &,        ir, jr, psir, thetar, phir,spval,verbose)
c
c=======================================================================
c     interpolate scaler data from an geographic data grid to a 
c     rotated model grid
c
c     input
c     psir, thetar, phir = Euler angles defining rotation
c     g  = scaler on geographic data grid
c     xg = longitude of data points on geographic data grid
c     yg = latitude of data points on geographic data grid
c     ig = number of longitudes in on geographic data grid 
c     jg = number of latitudes in on geographic data grid 
c     xr = longitude of points on rotated model grid
c     yr = latitude of points on rotated model grid
c     ir = number of longitudes in rotated model grid 
c     jr = number of latitudes in rotated model grid 
c
c     output
c     r  = scaler on rotated model grid
c
c     internal
c     (rln,rlt) = (longitude,latitude) in rotated coordinates
c     (gln,glt) = (longitude,latitude) in geographic coordinates
c     xg(iw) = point on the geographic grid to the west of (gln,glt)
c     xg(ie) = point on the geographic grid to the east of (gln,glt)
c     yg(js) = point on the geographic grid to the south of (gln,glt)
c     yg(jn) = point on the geographic grid to the north of (gln,glt)
c
c=======================================================================
c
      implicit none
      integer ir,jr,ig,jg
      real g_in(ig,jg), xg_in(ig)
c      real ::  g(ig,jg), xg(ig) 
      real,allocatable ::  g(:,:), xg(:) 
      real yg(jg), r(ir,jr), xr(ir), yr(jr)
      real (kind=8) psir,thetar,phir
      real ::  spval
      logical :: verbose

      real (kind=8) epsln,glt_min,glt_max,gln_min,gln_max,ln_err,lt_err
      integer :: stdout = 6,indp
      integer istrt,i,iend,iw,ie
      integer jstrt,j,jend,js,jn
      real (kind=8) del,wtw,wte,wts,wtn
      real (kind=8) glt,gln,rlt,rln
      real  glt4,gln4
      real (kind=8) wtne,wtse,wtnw,wtsw,wall

      allocate( g(ig,jg), xg(ig) )
c      print*,'ok'

c     make sure that longitudes begin around 0deg

      if (xg_in(ig)>360.) then
       j=1; do i=1,ig
        if (xg_in(i)<=360.)  j=i
       enddo 
       if (verbose) then
         print*,' have to shift geographic data by ',j,' points'
         print*,' assuming cyclic boundary conditions'
       endif
       g(1:ig-(j+1)+1,:)= g_in(j+1:ig,:)
       g(ig-(j+1)+2:ig,:)=g_in(1:j,:) 
       xg(1:ig-(j+1)+1)= xg_in(j+1:ig)-360. 
       xg(ig-(j+1)+2:ig)=xg_in(1:j) 
      else
        xg=xg_in; g=g_in
      endif

c
      epsln = 1.e-10; 
      glt_min = 90.; glt_max = -90.; gln_min = 360.
      gln_max = -360.; ln_err = 0; lt_err = 0
c
c     find longitude points of data within interval [0., 360.]
      istrt = 1; do i=2,ig
        if (xg(i-1) .lt. 0. .and. xg(i) .ge. 0.) istrt = i
      enddo 
      iend = ig; do i=2,ig
        if (xg(i-1) .lt. 360. .and. xg(i) .ge. 360.) iend = i
      enddo
c
c     find latitude points of data within interval [-90., 90.]
      jstrt = 1; do j=2,jg
        if (yg(j-1) .lt. -90. .and. yg(j) .ge. -90.) jstrt = j
      enddo 
      jend = jg; do j=2,jg
        if (yg(j-1) .lt. 90. .and. yg(j) .ge. 90.) jend = j
      enddo
c
c     interpolate data to model grid 
c
      do j=1,jr
        do i=1,ir
          rlt=yr(j);rln=xr(i)
          call rotate (rlt, rln, -psir, -thetar, -phir, glt, gln)
          if (gln .lt. 0.) gln = gln + 360.
          if (gln .ge. 360.) gln = gln - 360.
          glt_min = min(glt,glt_min); glt_max = max(glt,glt_max)
          gln_min = min(gln,gln_min); gln_max = max(gln,gln_max)
          gln4=gln
          iw = indp (gln4, xg(istrt), iend-istrt+1)+istrt-1
          if (xg(iw) .gt. gln) iw = iw - 1
	  ie = iw + 1
	  if (iw .ge. istrt .and. ie .le. iend) then
	    del = xg(ie) - xg(iw); wtw = (xg(ie) - gln)/del
	  else
c     east or west of the last data value. this could be because a
c     cyclic condition is needed or the dataset is too small. in either 
c     case apply a cyclic condition
            ln_err = 1; iw = iend; ie = istrt
	    del = xg(ie) + 360. + epsln - xg(iw) 
            if (xg(ie) .ge. gln) then
  	      wtw = (xg(ie) - gln)/del
            else
	      wtw = (xg(ie) + 360. + epsln - gln)/del
            endif
	  endif
	  wte = 1. - wtw
          glt4=glt
          js = indp (glt4, yg(jstrt), jend-jstrt+1)+jstrt-1
	  if (yg(js) .gt. glt) js = max(js - 1,jstrt)
	  jn = min(js + 1,jend)
	  if (yg(jn) .ne. yg(js) .and. yg(js) .le. glt) then
            wts = (yg(jn) - glt)/(yg(jn) - yg(js))
          else
c     north or south of the last data value. this could be because a
c     pole is not included in the data set or the dataset is too small.
c     in either case extrapolate north or south
            lt_err = 1; wts = 1.
          endif
	  wtn = 1. - wts
          if (g(ie,jn)==spval.or.g(iw,jn)==spval.or.
     &        g(ie,js)==spval.or.g(iw,js)==spval) then
c          care about spvals
c          first approach, leaves many points with sp values
c           r(i,j)=spval
c          second approach
           wtne=wtn*wte;if (g(ie,jn)==spval) wtne=0.
           wtse=wts*wte;if (g(ie,js)==spval) wtse=0.
           wtnw=wtn*wtw;if (g(iw,jn)==spval) wtnw=0.
           wtsw=wts*wtw;if (g(iw,js)==spval) wtsw=0.
           wall = wtne+wtse+wtnw+wtsw
           if (wall /= 0.) then
            r(i,j) = (g(ie,jn)*wtne + g(ie,js)*wtse
     &              + g(iw,jn)*wtnw + g(iw,js)*wtsw)/wall
           else
            r(i,j)=spval
           endif
          else
           r(i,j) = g(ie,jn)*wte*wtn + g(ie,js)*wte*wts
     &            + g(iw,jn)*wtw*wtn + g(iw,js)*wtw*wts
          endif
        enddo
      enddo
c
      if (ln_err .eq. 1 .and. verbose) then
        write (stdout,'(/,(1x,a))')
     &    '==> Warning: the geographic data set does not extend far   '
     &,   '             enough east or west - a cyclic boundary       '
     &,   '             condition was applied. check if appropriate   '
        write (stdout,'(/,(1x,a,2f8.2))')
     &    '    data required between longitudes:', gln_min, gln_max
     &,   '      data set is between longitudes:', xg(istrt), xg(iend)
c        stop
      endif
c
      if (lt_err .eq. 1 .and. verbose) then
        write (stdout,'(/,(1x,a))')
     &    '==> Warning: the geographic data set does not extend far   '
     &,   '             enough north or south - extrapolation from    '
     &,   '             the nearest data was applied. this may create '
     &,   '             artificial gradients near a geographic pole   ' 
        write (stdout,'(/,(1x,a,2f8.2))')
     &    '    data required between latitudes:', glt_min, glt_max
     &,   '      data set is between latitudes:', yg(jstrt), yg(jend)
c        stop
      endif
      deallocate( g, xg )
      end subroutine rot_intrp_sclr




      subroutine rot_intrp_vctr (g, xg, yg, ig, jg, r, xr, yr
     &,           ir, jr, psir, thetar, phir,spval,verbose)
c
c=======================================================================
c     interpolate vector data from an geographic data grid to a
c     rotated model grid
c
c     input
c     psir, thetar, phir = Euler angles defining rotation
c     g  = vector on geographic data grid
c     xg = longitude of data points on geographic data grid
c     yg = latitude of data points on geographic data grid
c     ig = number of longitudes in geographic data grid 
c     jg = number of latitudes in geographic data grid 
c     xr = longitude of points on rotated model grid
c     yr = latitude of points on rotated model grid
c     ir = number of longitudes in rotated model grid 
c     jr = number of latitudes in rotated model grid 
c
c     output
c     r  = vector on rotated model grid
c
c     internal
c     (rln,rlt) = (longitude,latitude) in rotated coordinates
c     (gln,glt) = (longitude,latitude) in geographic coordinates
c     xg(iw) = point on the geographic grid to the west of (gln,glt)
c     xg(ie) = point on the geographic grid to the east of (gln,glt)
c     yg(js) = point on the geographic grid to the south of (gln,glt)
c     yg(jn) = point on the geographic grid to the north of (gln,glt)
c
c=======================================================================
c
      implicit none
      integer ig,jg,ir,jr
      real g(ig,jg,2), xg(ig), yg(jg), r(ir,jr,2), xr(ir), yr(jr)
      real (kind=8) psir,thetar,phir
      real spval
      logical verbose

      integer :: stdout = 6,i,j
      real (kind=8) rad,vmag,a,glt,gln,angle,rln,rlt
      real (kind=8) :: c1=1.
c
      rad = acos(-1.)/180.

!      print*,' rot_intrp_vec'
c
c     interpolate vector components as scalers on rotated model grid 
c
      call rot_intrp_sclr (g(1,1,1), xg, yg, ig, jg, r(1,1,1), xr, yr
     &,                    ir, jr, psir, thetar, phir,spval,verbose)
      call rot_intrp_sclr (g(1,1,2), xg, yg, ig, jg, r(1,1,2), xr, yr
     &,                    ir, jr, psir, thetar, phir,spval,verbose)
c
c     correct vector direction
c
      do j=1,jr
        do i=1,ir
         if (r(i,j,1)/=spval.and.r(i,j,2)/=spval) then
          vmag = sqrt(r(i,j,1)**2 + r(i,j,2)**2)
          if (vmag >  0.) then 
            a = r(i,j,1)/vmag
            a = min(a, c1)
            a = max(a, -c1)
            a = acos(a)
            if (r(i,j,2) < 0.) a = -a
            rlt=yr(j);rln=xr(i)
            call rotate(rlt, rln, -psir, -thetar, -phir, glt, gln)
            call rotvec(glt, gln, phir, thetar, psir, angle)
            a = a + angle*rad
            r(i,j,1) = vmag*cos(a)
            r(i,j,2) = vmag*sin(a)
          else
	    r(i,j,1) = 0.
	    r(i,j,2) = 0.
          endif
         endif
        enddo
      enddo
!      print*,' rot_intrp_vec done'
      end subroutine rot_intrp_vctr


      subroutine rotvec (glt, gln, phir, thetar, psir, angle)
c
c=======================================================================
c     subroutine rotvec takes a geographic latitude and longitude and 
c     finds the the vector rotation angle angle (in degrees) for a 
c     vector on the rotated grid. when going from the geographic to a 
c     rotated grid, all of the defined rotation angles given to rotvec 
c     by the calling program are positive, but when going from a 
c     rotated grid back to the geographic grid, the calling program 
c     must reverse the angle order (phir and psir are switched) and all 
c     of the angles made negative. if a pole is detected then an angle 
c     of zero is returned.
c
c     rotvec rotates the point defining the head of a very short north
c     or south pointing geographic vector. the angle between this 
c     vector and a similar direction vector defined in the new grid is 
c     calculated using the law of cosines. the accuracy of this 
c     calculation depends on the size of the direction vector (delta) 
c     and the precision of the computation. the smaller the vector the 
c     more accurate the calculation but then the more precision 
c     required. double precision is strongly recommended.
c
c     author:   M. Eby            e-mail eby@uvic.ca
c=======================================================================
c
c     g...   = geographic value
c     r...   = rotated value
c     ...lt  = latitude
c     ...ln  = longitude
c     ...lth = latitude of head of vector
c     ...lnh = longitude of head of vector
c     dst    = distance between heads of vectors
c     delta  = length of vector
c     angle  = angle to rotate vectors back to original orientation
c     psir, thetar, phir = Euler angles defining rotation
c
c     define multiplier rad for conversion to radians.
      implicit none
      real (kind=8) rad,t,rlnh,rlth, delta
      real (kind=8) glt,gln,phir,thetar,psir,rlt
      real (kind=8) rln,glth,dst,angle,glnh
      real (kind=8) :: c1=1.

      rad = acos(-1.)/180.
c
c     define length of direction vector (single precision may require a 
c     longer and thus less accurate vector length).
      delta = 0.001
c
c     if the base is in the north of the geographic grid use a south 
c     pointing vector to avoid any possibility of going over the pole.
      if (glt .ge. 0.) delta = -delta
c
c     find the base of the direction vectors in the rotated grid.
      call rotate (glt, gln, phir, thetar, psir, rlt, rln)
c
c     if base in the rotated grid is near a pole return an angle of zero
      if (abs(rlt) .ge. 90.-abs(delta)) then
        angle = 0.
        return
      endif
c
c     find the head of the geographic grid direction vector in the 
c     rotated grid.
      call rotate (glt+delta, gln, phir, thetar, psir, glth, glnh)
c
c     if the base is in opposite hemispheres switch the vector
c     direction for better accuracy.
      if (glt*rlt .lt. 0) delta = -delta
c
c     find the head of the rotated grid direction vector.
      rlth = rlt + delta
      rlnh = rln
c
c     find the distance between the heads of the direction vectors.
      call dist (glth, glnh, rlth, rlnh, dst)
c
c     find the angle between direction vectors with the law of cosines.
      delta = abs(delta)
      angle = (cos(dst)-cos(delta)**2)/(sin(delta)**2)
      angle = min(angle, c1)
      angle = max(angle, -c1)
      angle = acos(angle)/rad
      t = abs(delta)
c
c     adjust the angle if the direction vectors are opposite.
      if (glt*rlt .lt. 0) angle = 180. - angle
c     determine the sign of the angle by checking the offset longitudes.
      if (glnh+360. .gt. rlnh+360.) angle = -angle
c     change sign if the original direction vector was pointing south.
      if (glt .ge. 0.) angle = -angle
      end subroutine rotvec


      subroutine dist (lat1, lng1, lat2, lng2, dst)
c
c=======================================================================
c     subroutine dist calculates the arc distance between two 
c     points given their latitudes and longitudes
c=======================================================================
c
      implicit none
      real (kind=8) lat1, lng1, lat2, lng2, dst, rad
      real (kind=8) :: c1=1.,c90=90.
c
c     define multiplier rad for conversion to radians.
      rad = acos(-1.)/180.
c
c     check input.
      lat1 = min(lat1, c90)
      lat1 = max(lat1, -c90)
      if (lng1 .lt. 0.) lng1 = lng1 + 360.
      if (lng1 .gt. 360.) lng1 = lng1 - 360.
      lat2 = min(lat2, c90)
      lat2 = max(lat2, -c90)
      if (lng2 .lt. 0.) lng2 = lng2 + 360.
      if (lng2 .gt .360.) lng2 = lng2 - 360.
c
      dst = sin(lat1*rad)*sin(lat2*rad)+cos(lat1*rad)*
     &      cos(lat2*rad)*cos((lng1-lng2)*rad)
      dst = min(dst, c1)
      dst = max(dst, -c1)
      dst = (acos(dst)/rad)
      end subroutine dist



      subroutine tranlon (c, ic, il, jl, cx, fx, ifl, tx)
c
c-----------------------------------------------------------------------
c     translate longitudes  "cx" to "tx" so that tx(i) i=1..ic
c     completely encloses model longitudes  fx(i) i=1..ifl
c     note that "tx" may extend beyond 360 degrees to contain "fx".
c     use same mapping to translate data in "c"
c
c     input:
c     c  = original data array
c     cx = original data longitudes
c     tx = translated data longitudes
c     fx = model longitudes
c
c     output
c     c  = translated data array
c-----------------------------------------------------------------------
c
      implicit none
      integer :: ic,il,jl,ifl
      real ::  c(ic,jl), t(ic), tx(ic), cx(ic), fx(ifl)
      integer :: indp,i,j,iw,im1
c
c-----------------------------------------------------------------------
c     find the index of the 1st model grid point on the data grid
c-----------------------------------------------------------------------
c
      iw = indp (fx(1), cx, ic)
      if (cx(iw) .gt. fx(1)) iw = max(1,iw-1)
c
c-----------------------------------------------------------------------
c     translate data longitudes so that tx(1) = cx(iw), tx(2) = cx(iw+1)
c-----------------------------------------------------------------------
c
      do i=1,ic
        tx(i) = cx(mod(i+iw-2,il) + 1)
        im1   = max(1,i-1)
        if (tx(i) .lt. tx(im1)) tx(i) = tx(i) + 360.0
      enddo
      if (fx(ifl) .gt. tx(ic)) then
        write (6,997) iw, ic, ifl
        write (6,998) 'tx= ',(tx(i),i=1,ic)
        write (6,998) 'fx= ',(fx(i),i=1,ifl)
        stop
      endif
c
c-----------------------------------------------------------------------
c     translate data to match translated longitudes
c-----------------------------------------------------------------------
c
      do j=1,jl
        do i=1,ic
          t(i) = c(mod(i+iw-2,il) + 1,j)
        enddo
        do i=1,ic
          c(i,j) = t(i)
        enddo
      enddo
c
      return
997   format (1x, ' ===>  tx(ic) < fx(ifl) in tranlon. iw=',i6,
     1         ' il=',i6,' ifl=',i6)
998   format (1x,a4,(5x,10e11.4))
      end subroutine tranlon




      subroutine fillgaps(imt, jmt, km, kloc, kmsk, 
     &                    dat, spval, ldoc,stop_on_error)

!------------------------------------------------------------------------
!
!     check a 2-dimensional data field dat(imt,jmt) for data  
!     gaps (marked by special value spval) at wet points (kmsk>kloc, 
!     i.e. where the bottom is deeper than the local k); fill gaps with 
!     arithmetic mean of available points among the 8 nearest horizontal 
!     neighbors, if possible. If no neighbors are available, retain the 
!     gap and repeat the process in the hope that larger gaps will be 
!     filled consecutively from the sides.
!
!     Mask out land/topography with special values after processing 
!     the data field.
!
!     At the moment, this routine is only intended for horizontal 
!     fields! Only maxcount=5000 gaps are allowed, and the routine will 
!     iterate the fill procedure only maxdo=500 times. Any remaining gaps
!     will be reported to the user.
!
!     Variable ldoc determines the level of output documentation:
!     for ldoc.ge.4, the locations of all gaps will be reported. 
!     For ldoc.ge.2, locations of the remaining gaps will be reported.
!
!     Input:  imt, jmt, km, kloc, kmsk, dat, spval, ldoc
!     Output: dat
!
!     J. Dengg, jdengg@awi_bremerhaven.de
!     Nov-97
!
!------------------------------------------------------------------------

      integer :: stdout = 6
      integer,intent(in) :: imt, jmt, km           ! field dimensions
      integer,intent(in) :: kloc                   ! index vertical position

      integer,parameter :: maxcount = 50000
      integer,parameter :: maxdo = 500             ! max. no. iterations

      integer :: igap(maxcount), jgap(maxcount)    ! gap coordinates

      integer,intent(in) :: kmsk(imt,jmt)          ! kmt- or kmu- field
      real,intent(inout) :: dat(imt,jmt)           ! data
      real,intent(in)    :: spval                  ! special value for 
!                                                  !         data gaps
      integer,intent(in) :: ldoc                   ! level of documentation
      logical,intent(in) :: stop_on_error          ! stop if gaps remain

      integer :: ngaps                             ! no. of initial gaps
      integer :: icount                            ! no. of remaining gaps


!     Security Check
!     --------------

      if (kloc > km) then
        write (stdout,*) 'Illegal k-index. ',
     &                   'Error in subroutine fillgaps.' 
        stop '==> fillgaps'
      end if



!     Count gaps
!     ----------

      icount = 0                                 ! initialize counters
        igap = 0
        jgap = 0
       ngaps = 0

      do j=1, jmt
        do i=1, imt
          if (kmsk(i,j)>=kloc .and. dat(i,j)==spval) then
            icount = icount + 1
            igap(icount) = i                     ! register position
            jgap(icount) = j
            if (ldoc.ge.4) write (stdout,*) 'gap #', icount,
     &         'at i=', igap(icount), ', j=', jgap(icount),
     &         ', k=', kloc
          end if
          if (icount>=maxcount) then
            write (stdout,*) 'Sorry, too many data gaps! ',
     &                       'Adjust dimension maxcount !'
            stop '==> fillgaps'
          end if
        end do
      end do

      ngaps = icount
      if (ldoc>=1) write (stdout,*) 'Data gaps: ', ngaps



!     Fill gaps with average of nearest neighbours
!     --------------------------------------------
!           ('maxdo' iterations only)

!        use all 8 adjacent grid points, unless gap is at boundary

      if (ngaps /= 0) then

        do n=1, maxdo                ! repeat process several times
          do ng=1, ngaps

            if (igap(ng)/=0 .and. jgap(ng)/=0) then

              is = max(igap(ng)-1, 1)
              ie = min(igap(ng)+1, imt)
              js = max(jgap(ng)-1, 1)
              je = min(jgap(ng)+1, jmt)
               sum = 0.
              isum = 0

              do j=js, je
                do i=is, ie
                  if (dat(i,j)/=spval) then
                     sum = sum + dat(i,j)
                    isum = isum + 1
                  end if
                end do
              end do

              if (isum/=0) then
                dat(igap(ng),jgap(ng)) = 1.*(sum/isum)
                igap(ng) = 0
                jgap(ng) = 0
                icount = icount-1
              end if

            end if        ! if (igap(ng)/=0 .and. jgap(ng)/=0) 
          end do          ! ng-loop

          if (icount==0) then
            if (ldoc>=1) 
     &      write (stdout,'(a/)') '           all gaps eliminated'
            goto 900
          end if

        end do            ! n-loop

        if (ldoc>=1) 
     &  write (stdout,*) '            ', icount, ' gaps remaining'

        if (ldoc >= 2) then                   ! report remaining gaps 
          do ng=1, ngaps
            if (igap(ng)/=0 .and. jgap(ng)/=0) then
              write (stdout,*) 'i=', igap(ng), ', j=', jgap(ng),
     &                       ', k=', kloc
            end if
          end do
        end if

        if (stop_on_error) stop

      end if              ! if (ngaps /= 0)



!     Assign special value to land/topography points
!     ----------------------------------------------

  900 where (kmsk < kloc) dat = spval

      end subroutine fillgaps


      subroutine fillgaps_poisson(imt, jmt, km, kloc, kmsk, 
     &                    dat, spval, ldoc,stop_on_error)

!------------------------------------------------------------------------
      implicit none

      integer :: stdout = 6
      integer,intent(in) :: imt, jmt, km           ! field dimensions
      integer,intent(in) :: kloc                   ! index vertical position

      integer,intent(in) :: kmsk(imt,jmt)          ! kmt- or kmu- field
      real,intent(inout) :: dat(imt,jmt)           ! data
      real,intent(in)    :: spval                  ! special value for 
!                                                  !         data gaps
      integer,intent(in) :: ldoc                   ! level of documentation
      logical,intent(in) :: stop_on_error          ! stop if gaps remain

      integer :: i,j,itt,max_itts=100
      integer, dimension(imt,jmt) :: ip,im,jp,jm,count
      real :: resid,omega,anorm,anormf,eps_sor=0.1
      integer :: mask(imt,jmt)

c    solve nabla^2 dat = 0 with neumann boundary conditions
c    and dx=dy=1

      where (kmsk < kloc) dat = spval
      mask = 0
      where (dat == spval .and. kmsk >= kloc ) mask=1
      where (mask == 1) dat = 0

      ip=0;im=0;jp=0;jm=0
      do i=2,imt-1
       do j=2,jmt-1
         if (dat(i+1,j) /=spval ) ip(i,j) = 1
         if (dat(i-1,j) /=spval ) im(i,j) = 1
         if (dat(i,j+1) /=spval ) jp(i,j) = 1
         if (dat(i,j-1) /=spval ) jm(i,j) = 1
       enddo
      enddo
      count=ip+jp+im+jm
      where (mask == 0) count = 1
      where (count == 0 .and. mask == 1) count = 1
      where (count == 0) 
        mask = 0
        count = 1
      end where
      
      omega=1.000001
      anormf=0
      anorm=1
      itt = 0
      do while (anorm>anormf*eps_sor .and. itt < max_itts ) 
       anorm=0
       do i=2,imt-1
        do j=2,jmt-1
         resid=dat(i+1,j)*ip(i,j)+dat(i-1,j)*im(i,j)+
     &         dat(i,j+1)*jp(i,j)+dat(i,j-1)*jm(i,j)-count(i,j)*dat(i,j)
         dat(i,j)=dat(i,j)+omega*resid/count(i,j)*mask(i,j)
         anorm=anorm + abs(resid)*mask(i,j)
        enddo
       enddo
       if (anormf==0) anormf=anorm
       print*,' itt=',itt,' anorm = ',anorm
        call sub_flush(6)
       itt=itt+1
      enddo

      if (itt >= max_itts) then
        print*,' solver did not converge'
        call sub_flush(6)
        if (stop_on_error) stop
      endif

      print*,' itt = ',itt
      call sub_flush(6)

      end subroutine fillgaps_poisson



      subroutine fillholes(imt, jmt, km, jloc, kmsk, 
     &                     dat, spval, ldoc, stop_on_error)

!------------------------------------------------------------------------
!
!     Check a 2-dimensional data field dat(imt,km) for data  
!     holes (marked by special value spval) at wet points (kmsk>k, 
!     i.e. where the bottom is deeper than the local k); fill holes  
!     consecutively with the neighbour values from above.
!
!     This leads to labile layered water columns!
!
!     After fillgaps there may be data gaps left, where the topography
!     contain deep holes and the interpolated data set provides no data.
!     A purely horizontal extrapolation does not fill these holes.
!
!     Does not mask out land/topography with special values. This must
!     be done before. It is assumed here that another routine (fillgaps)
!     has seen the data, before you decide to fill data holes in this
!     desperate way.
!
!     At the moment, this routine is only intended for vertical 
!     fields! Before you adapt this routine for horizontal fields
!     be aware that you will get uniform distributed values. 
!
!     Variable ldoc determines the level of output documentation:
!     In any case, if there are remaining holes this number will be reported.
!     for ldoc.ge.1, the locations of remaining holes will be reported.
!     for ldoc.ge.2, the number of initial holes will be reported.
!     for ldoc.ge.3, the locations of initial holes will be reported.
!     for ldoc.ge.4, reports, that all holes has been filled.
!
!     Input:  imt, jmt, km, jloc, kmsk, dat, spval, ldoc
!     Output: dat
!
!     Adapted from fillgaps by
!
!     J. Dengg, jdengg@awi_bremerhaven.de
!     Oct-97
!
!     Christian Dieterich Wed Oct 15 15:42:56 MET DST 1997
!     Modified Thu Oct 16 10:34:47 MET DST 1997
!
!------------------------------------------------------------------------

      integer :: stdout = 6
      integer,intent(in) :: imt, jmt, km           ! field dimensions
      integer,intent(in) :: jloc                   ! index meridional position

      integer,intent(in) :: kmsk(imt,jmt)          ! kmt- or kmu- field
      real,intent(inout) :: dat(imt,km)            ! data
      real,intent(in)    :: spval                  ! special value for 
!                                                  !         data holes
      integer,intent(in) :: ldoc                   ! level of documentation
      logical,intent(in) :: stop_on_error          ! stop if gaps remain

      integer :: nholes                            ! no. of initial holes
      integer :: icount                            ! no. of remaining holes



!     Security Check
!     --------------

      if (jloc > jmt) then
        write (stdout,*) 'Illegal j-index. ',
     &                   'Error in subroutine fillholes.' 
        stop '==> fillholes'
      end if



!     Count and fill holes with nearest neighbour from above
!     ------------------------------------------------------

      icount = 0                                 ! initialize counters
        igap = 0
        kgap = 0
       nholes = 0

      do k=1, km
        do i=1, imt
          if (kmsk(i,jloc)>=k .and. dat(i,k)==spval) then
            icount = icount + 1
            if (ldoc.ge.3) write (stdout,*) 'gap #', icount,
     &      'at i=', i, ', k=', k, ', j=', jloc
            if(k>1)dat(i,k)=dat(i,k-1)
          end if
        end do
      end do

      nholes = icount

      if (ldoc.ge.2) write (stdout,*) 'Data holes: ', nholes

      icount = 0                                 ! initialize counters

      do k=1, km
        do i=1, imt
          if (kmsk(i,jloc)>=k .and. dat(i,k)==spval) then
            icount = icount + 1
            if (ldoc.ge.1) write (stdout,*) 'gap #', icount,
     &      'at i=', i, ', k=', k, ', j=', jloc, ' remaining'
          end if
        end do
      end do
      if (icount==0) then
        if (ldoc.ge.4)
     &  write (stdout,'(a/)') '           all holes eliminated'
        goto 900
      end if

      if (ldoc>=1) 
     &write (stdout,*) '           ', icount, ' holes remaining'
      if (stop_on_error) stop

  900 continue

      end subroutine fillholes




      subroutine read_stamp(stamp, time )
      implicit none
      character*32, intent(in) :: stamp
      real, intent(out) :: time

      character *6  junk6
      character *8  junk8
      character *1  junk1
      integer       year, month, day, hour, min, sec

      integer nmonth
      parameter (nmonth = 12)
      integer daypm(nmonth), msum(nmonth), yrlen
      data daypm /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
      logical leap
      integer i,iyr,nfh,nday

      read  (stamp, '(a6,i2,a1,i2,a1,i4,a8,i2,a1,i2,a1,i2)')
     &       junk6, month, junk1, day, junk1, year, junk8, hour,
     &       junk1, min, junk1, sec
      msum(1) = 0
      do i = 2,nmonth
        msum(i) = msum(i-1) + daypm(i-1)
      enddo
      yrlen = msum(nmonth) + daypm(nmonth)
      if (mod (year, 400) .eq. 0) then
        leap = .true.
      elseif ((mod(year,4) .eq. 0) .and. (mod(year,100) .ne. 0)) then
        leap = .true.
      else
        leap = .false.
      endif
      nday = day + msum(month)
      if (leap .and. (month .gt. 2)) then
        nday = nday + 1
      endif
      iyr = year - 1601
c-----------------------------------------------------------------------
c     make corrections for years before 1601.
c-----------------------------------------------------------------------
      if (iyr .lt. 0) then
        nfh  = 1 + (-iyr)/400
        nday = nday - 146097*nfh
        iyr  = iyr + 400*nfh
      endif
      nday = nday + 365*iyr
c-----------------------------------------------------------------------
c     correct for leap-years between 1601 and iyear-1.
c     A virtual calendar consistent with current leap-year systems
c     is used to extend backwards.  (ie. 1700, 1800, 1900 are not
c     considered leap-year but 2000 is a leap-year)
c-----------------------------------------------------------------------
      iyr = iyr/4
      nday = nday + iyr
      iyr = iyr/25
      nday = nday - iyr
      iyr = iyr/4
      nday = nday + iyr
c-----------------------------------------------------------------------
c     nday is now in days since Dec. 31, 1600.  Convert to days since
c     Dec 31, 1899.
c-----------------------------------------------------------------------
      nday = nday - 109207
      time=float(nday)
     &  + (float(hour) + (float(min)+ float(sec)/60.)/60.  )/24.
      end subroutine read_stamp

c
c----------------------------------------------------------------
c     Timing module for SPFLAME
c
c     A timer is turned on by a call to the subroutine "tic" and turned
c     off by a call to the subroutine "toc".
c
c          call tic ('name')
c          ...code to be timed....
c          call toc ('name')
c
c     Note that the code fragment could be inside a loop.
c     The function timing_secs gives the cpu time spend 
c     between the two calls. 
c
c     Notes: the user may has to supply a function
c     which measure the cpu time on a certain (unknown) machine.
c
c
c                                 Mar 2002, C.Eden
c----------------------------------------------------------------
c
       module timing_module
       implicit none

       integer, parameter, private :: max_counter = 1000
       integer,private             :: act_counter = 0

       character (len=80),private  :: ref_counter(max_counter)
       real,private                :: counter(0:max_counter)
       real,private                :: now(0:max_counter)

       private elapsed
       public tic,toc

       contains

       function elapsed()
c
c      elapsed should give the elasped cpu (user) time
c
       real :: elapsed
c      a function which gives elapsed cpu time is needed here
#if defined IRIX_host || defined T3E_host || defined C90_host 
       real (kind=4) :: second
       elapsed = second()
#elif defined LINUX_host || defined LINUX_real8_host
c       real (kind=4) :: secnds
c       real (kind=4), save :: h_time= 0.0
c       elapsed = secnds(h_time)
c       real (kind=8) :: dclock
c       elapsed =dclock()
       real (kind=4) :: etime,tarray(2)
       elapsed=etime(tarray)
#elif defined SX5_host 
       real tarray(2),etime,sec
       sec=etime(tarray)
       elapsed=tarray(1)
#elif defined SR8000_host 
       integer :: i
       call clock(i,2)
       elapsed = i
#elif defined ALPHA_host 
       real (kind=4) :: etime,tarray(2)
       elapsed=etime(tarray)
#elif defined SUN_host 
       real (kind=4) :: etime,tarray(2)
       elapsed=etime(tarray)
#elif defined AIX_host 
       REAL (kind=4) :: etime_
       TYPE TB_TYPE
         SEQUENCE
         REAL (kind=4) :: USRTIME
         REAL (kind=4) :: SYSTIME
       END TYPE
       TYPE (TB_TYPE) ETIME_STRUCT
       elapsed = etime_(ETIME_STRUCT)
       elapsed = etime_struct%usrtime
#else
       elapsed =0.0
#endif
       end function elapsed


       subroutine tic(ref)
       character (len=*), intent(in)  :: ref
       integer :: n,len
       now(0)=elapsed()
       len=len_trim(ref)
       do n=1,act_counter
        if (ref(1:len) == ref_counter(n)(1:len) ) then
         now(n) = now(0)
         counter(0) = counter(0)+elapsed()-now(0)
         return
        endif
       enddo
       if (act_counter == max_counter ) then
        print*,' ERROR:'
        print*,' number of counters exceeds max_counter = ',max_counter
        print*,' in tic'
        print*,' ref = ',ref
c        call sub_flush(6)
c        call halt_stop(' in timing (1) ')
       endif
       act_counter = act_counter + 1
       ref_counter(act_counter) = ref
       now(act_counter) = elapsed()
       counter(0) = counter(0)+elapsed()-now(0)
       end subroutine tic

       subroutine toc(ref)
       character (len=*), intent(in) :: ref
       integer :: n,len

       now(0)=elapsed()
       len=len_trim(ref)
       do n=1,act_counter
        if (ref(1:len) == ref_counter(n)(1:len) ) then
         counter(n) = counter(n)+now(0)-now(n)
         counter(0) = counter(0)+elapsed()-now(0)
         return
        endif
       enddo
       print*,' ERROR:'
       print*,' cannot find ',ref(1:len),' in my list'
       print*,' in toc'
c       call sub_flush(6)
c       call halt_stop(' in timing (2) ')
       end subroutine toc

       function timing_secs(ref)
       character (len=*), intent(in) :: ref
       real :: timing_secs
       integer :: n,len
       if (ref=='tictoc') then
         timing_secs = counter(0)
         return
       endif
       len=len_trim(ref)
       do n=1,act_counter
        if (ref(1:len) == ref_counter(n)(1:len) ) then
         timing_secs = counter(n)
         return
        endif
       enddo
       print*,' ERROR:'
       print*,' cannot find ',ref(1:len),' in my list'
       print*,' in timing_secs'
c       call sub_flush(6)
c       call halt_stop(' in timing (3) ')
       end function timing_secs

       end module timing_module

#include "options.inc"

c
c     convert unformatted written data containing
c     meridional heat transport to NetCDF format
c
c  real variables are 8 or 4 bytes long set by
c#define real_8


      module kind_mod
#ifdef real_8
      integer, parameter::  r_knd  = selected_real_kind(13)
#else
      integer, parameter::  r_knd  = selected_real_kind(6)
#endif
      end module kind_mod



      module cv_gyre_module
      use kind_mod
      use time_manager_module
      integer :: imt,jmt,km,itm,nt
      real (kind=r_knd) ,allocatable :: xt(:), yt(:), xu(:), yu(:),
     & dxtdeg(:), dytdeg(:), dxudeg(:), dyudeg(:),
     & dxt(:), dyt(:), dxu(:), dyu(:),
     & zt(:),zw(:),dzt(:),dzw(:)
      real (kind=r_knd), parameter :: radius   = 6370.0e5
      real (kind=r_knd), parameter :: pi       = 
     &        3.14159265358979323846264338327950588
      real (kind=r_knd), parameter :: radian   = 360./(2.*pi)
      real (kind=r_knd), parameter :: degtcm   = radius/radian
      real (kind=r_knd) :: spval
      real (kind=r_knd), allocatable :: time(:)
      real (kind=r_knd),dimension(:,:,:),allocatable::over_tr,gyre_tr
      real (kind=r_knd),dimension(:,:,:),allocatable::adv_tr
      real (kind=r_knd),dimension(:,:,:),allocatable::diff_tr,barotr_tr
      real (kind=r_knd),dimension(:,:,:),allocatable::total_tr,ekm_tr
      real (kind=r_knd),dimension(:,:,:),allocatable::barocl_tr
      character (len=32) :: istamp ='m/d/y= 1/ 1/1900, h:m:s= 0: 0: 0' 
      end module cv_gyre_module





      program cv_gyre
      use cv_gyre_module
      implicit none
      character (len=80) :: infile,outfile
      integer :: ierr
      print*,' Converting heat transport written by SPFLAME ',
     &       ' to NetCDF file '
      call set_calendar_type(no_leap)
      call get_commandline_arg(1,infile,ierr)
      if (ierr/=0) goto 99
      print*,' reading from file ',infile(1:len_trim(infile))
      call get_commandline_arg(2,outfile,ierr)
      if (ierr/=0) goto 99
      print*,' writing to file ',outfile(1:len_trim(outfile))
      spval=-9.9e12
      call read_grid
      call read_gyre(infile)
      call write_gyre(outfile)
      stop
 99   print*,' program needs command line parameter'
      print*,' 1. input binary file name (written by spflame)'
      print*,' 2. output NetCDF file name '
      end program cv_gyre



      subroutine read_gyre(infile)
      use cv_gyre_module
      implicit none
      character (len=*) :: infile
      character (len=32) :: stamp
      type( time_type ) :: t
      integer :: io,k,n,j,i
      real (kind=r_knd), allocatable :: buf(:,:,:)
      call getunit (io, infile,'u s r ieee')
      read (io)
      read (io) j,nt
      if (j/=jmt)  then
        print*,' found jmt=',j,' km=',k,' in file ',infile
        print*,' previous definition was jmt=',jmt,' km=',km
        stop
      endif
      rewind(io)
      itm=0
 10   continue
      do k=1,6; read (io,end=20); enddo
      itm=itm+1
      goto 10
 20   continue
      rewind(io)
      print*,' found ',itm,' time steps in file ',infile
      print*,' number of tracers  ',nt
      allocate(buf(8,jmt,nt), time(itm) )
      allocate(over_tr(jmt,nt,itm) )
      allocate(gyre_tr(jmt,nt,itm) )
      allocate(adv_tr(jmt,nt,itm) )
      allocate(diff_tr(jmt,nt,itm) )
      allocate(barotr_tr(jmt,nt,itm) )
      allocate(total_tr(jmt,nt,itm) )
      allocate(ekm_tr(jmt,nt,itm) )
      allocate(barocl_tr(jmt,nt,itm) )
      do n=1,itm
       read (io) stamp ! iotext, expnam
       t =  get_stamp (stamp) - get_stamp(istamp)
       time(n)=t%days + t%seconds/60./60./24.
       print*,' n=',n,' days since origin=',time(n),' date ',stamp
       read (io) ! jmt,nt,retim
       read (io) ! stamp ! iotext, expnam
       read (io) buf
       read (io) !current_stamp, iotext, expnam
       read (io) ! buf, dummy
       do j=1,jmt
       over_tr(j,:,n)  =buf(1,j,:); gyre_tr(j,:,n)  =buf(2,j,:);
       barotr_tr(j,:,n)=buf(3,j,:); barocl_tr(j,:,n)=buf(4,j,:);
       ekm_tr(j,:,n)   =buf(5,j,:); adv_tr(j,:,n)   =buf(6,j,:);
       diff_tr(j,:,n)  =buf(7,j,:); total_tr(j,:,n) =buf(8,j,:);
       enddo
      enddo
      close(io)
      deallocate( buf)
      end subroutine read_gyre



      subroutine write_gyre(outfile)
      use cv_gyre_module
      implicit none
      character (len=*) :: outfile
#include "netcdf.inc"
      integer ncid,iret,i,j,k
      integer lat_udim,itimedim,lat_uid,itimeid
      integer n,id, advid, diffid, overid, gyreid, ekmid
      integer btrid,bclid
      integer dims(4), corner(4), edges(4)
      character name*24, unit*16,lname*24
      real (kind=r_knd)::factor, small=1.e-10
      real (kind=r_knd)::pwatts = 4.186e-15, csalt  = 1.e-10

      print*,' writing to NetCDF file ',outfile
      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c     dimensions
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c     grid variables
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims=(/lat_udim,itimedim,1,1/)
c     attributes of the grid
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c     attributes of variables
      do n=1,nt
      name='heat';unit='PW'
      if (n==2) name='salt'
      if (n==2) unit='10^10cm^2/s'
      if (n>2)  write(name,'("tracer_",i2)') n
      if (n>2) unit=' '
      do i=1,len_trim(name); if (name(i:i)==' ')name(i:i)='0'
      enddo
      k=len_trim(name)
      id=ncvdef (ncid,name(1:k)//'_tr', NCFLOAT,2,dims,iret)
      advid =ncvdef (ncid,name(1:k)//'_tr_adv', NCFLOAT,2,dims,iret)
      diffid=ncvdef (ncid,name(1:k)//'_tr_diff', NCFLOAT,2,dims,iret)
      overid=ncvdef (ncid,name(1:k)//'_tr_over', NCFLOAT,2,dims,iret)
      gyreid=ncvdef (ncid,name(1:k)//'_tr_gyre', NCFLOAT,2,dims,iret)
      ekmid =ncvdef (ncid,name(1:k)//'_tr_ekm', NCFLOAT,2,dims,iret)
      btrid =ncvdef (ncid,name(1:k)//'_tr_btr', NCFLOAT,2,dims,iret)
      bclid =ncvdef (ncid,name(1:k)//'_tr_bcl', NCFLOAT,2,dims,iret)
      lname = 'Northward '//name(1:k)//' transport'; 
      call dvcdf_here(ncid,id,lname,24,unit,16,spval)
      lname = 'Advective '//name(1:k)//' transport'; 
      call dvcdf_here(ncid,advid,lname,24,unit,16,spval)
      lname = 'Diffusive '//name(1:k)//' transport'; 
      call dvcdf_here(ncid,diffid,lname,24,unit,16,spval)
      lname = 'Overturning '//name(1:k)//' transport'; 
      call dvcdf_here(ncid,overid,lname,24,unit,16,spval)
      lname = 'Gyre '//name(1:k)//' transport';
      call dvcdf_here(ncid,gyreid,lname,24,unit,16,spval)
      lname = 'Ekman '//name(1:k)//' transport'; 
      call dvcdf_here(ncid,ekmid,lname,24,unit,16,spval)
      lname = 'Barotropic '//name(1:k)//' transport'; 
      call dvcdf_here(ncid,btrid,lname,24,unit,16,spval)
      lname = 'Baroclinic '//name(1:k)//' transport'; 
      call dvcdf_here(ncid,bclid,lname,24,unit,16,spval)
      enddo ! n
      call ncendf(ncid, iret)
#ifdef real_8
      iret= nf_put_vara_double(ncid,lat_uid ,1, jmt,yu)
      iret= nf_put_vara_double(ncid,itimeid ,1, itm,time)
#else
      iret= nf_put_vara_real(ncid,lat_uid ,1, jmt,yu)
      iret= nf_put_vara_real(ncid,itimeid ,1, itm,time)
#endif

      do n=1,nt
        name='heat'
        if (n==2) name='salt'
        if (n>2)  write(name,'("tracer_",i2)') n
        do i=1,len_trim(name); if (name(i:i)==' ')name(i:i)='0'
        enddo
        k=len_trim(name)
        print*,' Tracer ',name(1:k)
        corner=(/1,1,1,1/); edges=(/jmt,itm,1,1/)


#ifdef real_8
        iret=nf_inq_varid(ncid,name(1:k)//'_tr',id)
        iret= nf_put_vara_double (ncid,id ,corner, edges,
     &                          total_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_adv',id)
        iret= nf_put_vara_double (ncid,id ,corner, edges,
     &                          adv_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_diff',id)
        iret= nf_put_vara_double (ncid,id ,corner, edges,
     &                          diff_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_over',id)
        iret= nf_put_vara_double (ncid,id ,corner, edges,
     &                          over_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_gyre',id)
        iret= nf_put_vara_double (ncid,id ,corner, edges,
     &                          gyre_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_ekm',id)
        iret= nf_put_vara_double (ncid,id ,corner, edges,
     &                          ekm_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_btr',id)
        iret= nf_put_vara_double (ncid,id ,corner, edges,
     &                          barotr_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_bcl',id)
        iret= nf_put_vara_double (ncid,id ,corner, edges,
     &                          barocl_tr(:,n,:))
#else
        iret=nf_inq_varid(ncid,name(1:k)//'_tr',id)
        iret= nf_put_vara_real (ncid,id ,corner, edges,
     &                          total_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_adv',id)
        iret= nf_put_vara_real (ncid,id ,corner, edges,
     &                          adv_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_diff',id)
        iret= nf_put_vara_real (ncid,id ,corner, edges,
     &                          diff_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_over',id)
        iret= nf_put_vara_real (ncid,id ,corner, edges,
     &                          over_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_gyre',id)
        iret= nf_put_vara_real (ncid,id ,corner, edges,
     &                          gyre_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_ekm',id)
        iret= nf_put_vara_real (ncid,id ,corner, edges,
     &                          ekm_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_btr',id)
        iret= nf_put_vara_real (ncid,id ,corner, edges,
     &                          barotr_tr(:,n,:))
        iret=nf_inq_varid(ncid,name(1:k)//'_tr_bcl',id)
        iret= nf_put_vara_real (ncid,id ,corner, edges,
     &                          barocl_tr(:,n,:))
#endif
      enddo
      call ncclos (ncid, iret)
      end subroutine write_gyre






      subroutine read_grid ()
c
c-----------------------------------------------------------------------
c     read in the grid from a binary file
c-----------------------------------------------------------------------
c
      use cv_gyre_module
      implicit none
      integer i,j,k,io,kb
      print*,
     & ' =>Reading the grid definition from file grid.dta'
      call getunit (io, 'grid.dta', 'u s r ieee')
      read (io) ! no checks for awi id
      read (io) imt, jmt, km
      allocate( xt(imt), yt(jmt), xu(imt), yu(jmt))
      allocate( dxtdeg(imt), dytdeg(jmt), dxudeg(imt), dyudeg(jmt))
      allocate( dxt(imt), dyt(jmt), dxu(imt), dyu(jmt))
      allocate( zt(km),zw(km),dzt(km),dzw(0:km) )
      read (io) (dxtdeg(i),i=1,imt)
     &,         (dytdeg(j),j=1,jmt)
     &,         (dxudeg(i),i=1,imt)
     &,         (dyudeg(j),j=1,jmt)
     &,         (dzt(k),k=1,km)
     &,         (dzw(k),k=0,km)
     &,         (xt(i),i=1,imt)
     &,         (xu(i),i=1,imt)
     &,         (yt(j),j=1,jmt)
     &,         (yu(j),j=1,jmt)
     &,         (zt(k),k=1,km)
     &,         (zw(k),k=1,km)

      do j=1,jmt
        dyt(j) = dytdeg(j)*degtcm
        dyu(j) = dyudeg(j)*degtcm
      enddo
      do i=1,imt
        dxt(i) = dxtdeg(i)*degtcm
        dxu(i) = dxudeg(i)*degtcm
      enddo
      close (io)
      end subroutine read_grid



      subroutine dvcdf_here(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      use kind_mod
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character*(*) name, unit
      real (kind=r_knd):: spval
#include "netcdf.inc"
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
#ifdef real_8
      iret=nf_put_att_double(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_double(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#else
      iret=nf_put_att_real(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_real(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#endif
c        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf_here



      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"


      module passive_tracer_module
c-----------------------------------------------------------------------
c   Module for passive tracer stuff
c-----------------------------------------------------------------------
      implicit none
      logical :: enable_cfc11 = .false.
      integer :: ref_year_cfc11 = 1900   ! model year of CFC11 time series
                                            ! corresponding to 1931 in reality
      integer :: n_cfc11  = 3            ! number of tracer used for CFC11
      logical :: enable_cfc12 = .false.
      integer :: ref_year_cfc12 = 1900   ! reference year
      integer :: n_cfc12  = 4            ! number of tracer used for CFC12

      logical :: enable_npzd = .false. ! activate the ecosystem model (4-7 tracer)
      logical :: enable_doc  = .false. ! activate DOC in the ecosystem model
      logical :: enable_co2  = .false. ! activate CO2 in the ecosystem model
      logical :: enable_o2   = .false. ! activate O2 as well
      integer :: nt_npzd = 4             ! Number of tracers in NPZD model
      integer, allocatable :: n_npzd(:)  ! mapping of tracer number to biological var.
                                            ! (n_npzd lists all tracers in NPZD)
      integer :: n_nutrient,n_phyto      ! again the mapping
      integer :: n_zoo,n_detritus        ! but with explicit naming 
      integer :: n_co2,n_o2,n_doc
      integer :: ref_year_co2 = 1900     ! reference year for atmospheric CO2
      logical :: enable_pco2_series = .false. ! use fixed value for atmos CO2

      logical :: enable_diag_npzd = .false.  ! some diagnostics for npzd model

      end module passive_tracer_module


      subroutine passive_tracer_init
c-----------------------------------------------------------------------
c   setup all passive tracers here
c   called by setup
c-----------------------------------------------------------------------
      use spflame_module
      use passive_tracer_module
      implicit none

      namelist /passive_tracer_nml/ 
     &    enable_cfc11,ref_year_cfc11,
     &    enable_cfc12,ref_year_cfc12,
     &    enable_npzd,enable_co2,enable_o2,enable_doc,
     &    ref_year_co2,enable_pco2_series,enable_diag_npzd
      integer :: k = 3, kk,io

      if (nt <=2) then
       if (my_pe==0) print*,' no passive tracers to be initialized'
       return
      endif

      if (my_pe==0) then
       print*,' '
       print*,' initialization of passive tracers'
       print*,' '
       print*,' reading namelist file namelist.passive_tracer'
      endif
c
c   read in namelist parameter for passive tracers
c
      call getunit(io,'namelist.passive_tracer','fsr')
      read(io, nml = passive_tracer_nml) 
      close(io)

      if (my_pe==0) then
       print*,' read the following namelist parameter: '
       write(6, nml = passive_tracer_nml ) 
      endif

      if (enable_cfc11) then 
        n_cfc11 = k
        call cfc11_init()
        k=k+1
      endif
        
      if (enable_cfc12) then
        n_cfc12 = k
        call cfc12_init()
        k=k+1
      endif

      if (enable_npzd)  then
        nt_npzd=4
        if (enable_co2)  nt_npzd=nt_npzd+1
        if (enable_o2 )  nt_npzd=nt_npzd+1
        if (enable_doc ) nt_npzd=nt_npzd+1
        allocate(n_npzd(nt_npzd))
        do kk=1,nt_npzd
         n_npzd(kk) = kk+k-1    
        enddo
        n_nutrient = n_npzd(1)
        n_phyto    = n_npzd(2)
        n_zoo      = n_npzd(3)
        n_detritus = n_npzd(4)
        kk=n_npzd(4)+1
        if (enable_co2)  then
          n_co2=kk; kk=kk+1
        endif
        if (enable_o2)  then
          n_o2=kk; kk=kk+1
        endif
        if (enable_doc)  then
          n_doc=kk; kk=kk+1
        endif
        call npzd_init()
        k=k+nt_npzd
      endif
        
      if (my_pe==0) then
       k=k-1
       print*,' recognized altogether ',k,' tracers (incl. temp/sal)'
c
c     check number of tracers
c
       if (nt < k) then
        if (my_pe==0) print*,' ERROR: number of tracer is only ',nt
        call halt_stop(' in passive_tracer_init ')
       endif

       if ((nt > k).and.(my_pe==0)) then
         print*,' Note: cannot recognize the rest of the tracers'
       endif

      endif

      if (my_pe==0) print*,' passive tracer initialization done'

      end subroutine passive_tracer_init


      subroutine passive_tracer_add()
c-----------------------------------------------------------------------
c   add to tracer at tau+1 whats necessary for
c   each passive tracer
c-----------------------------------------------------------------------
      use spflame_module
      use passive_tracer_module
      implicit none
      if (nt <=2) return
      if (enable_npzd) call npzd_model()
      end subroutine passive_tracer_add



      subroutine passive_tracer_sflx
c-----------------------------------------------------------------------
c   apply surface fluxes to passive tracers
c   (called by setvbc, icemask is applied afterwards)
c-----------------------------------------------------------------------
      use spflame_module
      use passive_tracer_module
      implicit none
      if (nt <=2) return
      if (enable_npzd)  call npzd_sflx() 
      if (enable_cfc11) call cfc_sflx(n_cfc11 ,'CFC11')
      if (enable_cfc12) call cfc_sflx(n_cfc12 ,'CFC12')
      end subroutine passive_tracer_sflx


      subroutine wanninkhof(tc,u,kw,len)
c-----------------------------------------------------------------------
c   Piston velocity for surface fluxes a la Wanninkhof , 1992
c-----------------------------------------------------------------------
      implicit none
      integer :: len,i
      real :: tc(len),u(len)   ! temperature, wind speed (input)
      real :: kw(len)          ! piston velocity (output)
      do i=1,len
       kw(i) = 0.39*u(i)*u(i)
      enddo
      end subroutine wanninkhof


      subroutine wanninkhof99(tc,u,kw,len)
c-----------------------------------------------------------------------
c   Piston velocity for surface fluxes a la Wanninkhof+McGillis , 1999
c-----------------------------------------------------------------------
      implicit none
      integer :: len,i
      real :: tc(len),u(len)   ! temperature, wind speed (input)
      real :: kw(len)          ! piston velocity (output)
      real :: uu
      do i=1,len
       uu=u(i)*u(i)
       kw(i) = 1.09*u(i)-0.333*uu+0.078*u(i)*uu
      enddo
      end subroutine wanninkhof99



      subroutine flux_delimit_init
c-----------------------------------------------------------------------
c   flux delimiter module
c   linked in the code in tracer and setup
c                               c eden
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      if (my_pe==0) then
       print*,' Initialisation of flux delimiter'
       print*,''
       print*,' limiting advective fluxes for passive tracers'
       print*,' using the multidimensional positive definite'
       print*,' advection scheme (MPDCD) by Lafore, et al 1998 '
       print*,''
       if (nt<=2) then
        print*,' however, there are no passive tracers to limit '
       endif
       if (enable_diffusion_biharmonic) then
        print*,' limiting also biharmonic diffusion scheme '
        print*,' which is also not positiv definite '
       endif
       print*,' done '
      endif
      end subroutine flux_delimit_init


      subroutine delimit_adv_flux(n,adv_fe,adv_fn,adv_fb)
c-----------------------------------------------------------------------
c   delimit advective fluxes for passive tracers
c   using the multidimensional positive definite
c   advection scheme (MPDCD) by Lafore, et al 1998
c   SPFLAME version : c.eden
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      integer, intent(in) :: n
      real adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
c     local array
      real betaf(is_pe-1:ie_pe+1,0:km+1,js_pe-1:je_pe+1)
      integer is,ie,js,je
      integer i,j,k
      real :: fxa,denom
      real, parameter :: small = 1.e-15

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c   compute delimiter for outgoing flux
c
      betaf=2.
      do j=js,je
        do k=1,km
          do i=is,ie
           denom =       max(0.,adv_fe(i  ,k,j)*cstdxt2r(i,j))
           denom = denom-min(0.,adv_fe(i-1,k,j)*cstdxt2r(i,j)) 

           denom = denom+max(0.,adv_fn(i,k,j  )*cstdyt2r(j))
           denom = denom-min(0.,adv_fn(i,k,j-1)*cstdyt2r(j))

           denom = denom-min(0.,adv_fb(i,k,j)*dzt2r(k))
           denom = denom+max(0.,adv_fb(i,k-1,j)*dzt2r(k))

           denom=denom*c2dt
           denom = sign(1.,denom)*max(small,abs(denom)) ! should be positive anyway

           betaf(i,k,j)=t(i,k,j,n,taum1)/denom
          enddo
        enddo
      enddo

      call border_exchg(betaf,km+2,1)
      call set_cyclic(betaf,km+2,1)
c
c   delimit zonal flux
c
      do j=js,je
        do k=1,km
          do i=is-1,ie
           adv_fe(i,k,j)=
     &         min(1.,betaf(i  ,k,j))*max(0.,adv_fe(i,k,j))
     &       + min(1.,betaf(i+1,k,j))*min(0.,adv_fe(i,k,j))
          enddo
        enddo
      enddo
c
c   delimit meridional flux
c
      do j=js-1,je
        do k=1,km
          do i=is,ie
           adv_fn(i,k,j)=
     &         min(1.,betaf(i,k,j  ))*max(0.,adv_fn(i,k,j))
     &       + min(1.,betaf(i,k,j+1))*min(0.,adv_fn(i,k,j))
          enddo
        enddo
      enddo
c
c   delimit vertical flux
c
      do j=js,je
        do k=0,km
          do i=is,ie
           adv_fb(i,k,j)=
     &         min(1.,betaf(i,k  ,j))*min(0.,adv_fb(i,k,j))
     &       + min(1.,betaf(i,k+1,j))*max(0.,adv_fb(i,k,j))
          enddo
        enddo
      enddo
      end subroutine delimit_adv_flux





      subroutine delimit_all_fluxes(n,adv_fe,adv_fn,adv_fb,
     &                                         diff_fe,diff_fn,diff_fb)
c-----------------------------------------------------------------------
c   delimit diffusive fluxes for passive tracers
c   using the multidimensional positive definite
c   advection scheme (MPDCD) by Lafore, et al 1998
c   SPFLAME version : c.eden
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      integer, intent(in) :: n
      real adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
      real diff_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real diff_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real diff_fb(is_pe:ie_pe,0:km,js_pe:je_pe)

      integer is,ie,js,je
      integer i,j,k
      real :: fxa,denom, small = 1.e-15
c     local array
      real betaf(is_pe-1:ie_pe+1,0:km+1,js_pe-1:je_pe+1)

      real adv_tx
      ADV_Tx(i,k,j) = (adv_fe(i,k,j) - adv_fe(i-1,k,j))*cstdxt2r(i,j)
#ifdef partial_cell
     &                             /dht(i,k,j)
#endif
      real adv_ty
      ADV_Ty(i,k,j) = (adv_fn(i,k,j) - adv_fn(i,k,j-1))*cstdyt2r(j)
# ifdef partial_cell
     &                             /dht(i,k,j)
# endif
      real adv_tz
      ADV_Tz(i,k,j) = (adv_fb(i,k-1,j) - adv_fb(i,k,j))
#ifdef partial_cell
     &               *.5/dht(i,k,j)
#else
     &               *dzt2r(k)
#endif


      diff_fn=diff_fn*(-1)
      diff_fe=diff_fe*(-1)
      diff_fb=diff_fb*(-1)

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c   compute delimiter for outgoing flux
c
      betaf=2.
      do j=js,je
        do k=1,km
          do i=is,ie

           denom=      max(0.,
     &                diff_fe(i  ,k,j)*tmask(i+1,k,j)*cstdxtr(i,j))
           denom=denom-min(0.,
     &                diff_fe(i-1,k,j)*tmask(i-1,k,j)*cstdxtr(i,j)) 

           denom=denom+max(0.,
     &                   diff_fn(i,k,j  )*tmask(i,k,j+1)*cstdytr(j))
           denom=denom-min(0.,
     &                   diff_fn(i,k,j-1)*tmask(i,k,j-1)*cstdytr(j))

           denom=denom-min(0.,diff_fb(i,k  ,j)*dztr(k))
           denom=denom+max(0.,diff_fb(i,k-1,j)*dztr(k))

           denom=denom*c2dt
           denom = sign(1.,denom)*max(small,abs(denom)) ! should be positive anyway

           betaf(i,k,j)=(t(i,k,j,n,taum1)
     &  -c2dt*(ADV_Tx(i,k,j)+ADV_Ty(i,k,j)+ADV_Tz(i,k,j))*tmask(i,k,j) )
     &                    /denom
          enddo
        enddo
      enddo

      call border_exchg(betaf,km+2,1)
      call set_cyclic(betaf,km+2,1)
c
c   delimit zonal flux
c
      do j=js,je
        do k=1,km
          do i=is-1,ie
           diff_fe(i,k,j)=
     &         min(1.,betaf(i  ,k,j))*max(0.,diff_fe(i,k,j))
     &       + min(1.,betaf(i+1,k,j))*min(0.,diff_fe(i,k,j))
          enddo
        enddo
      enddo
c
c   delimit meridional flux
c
      do j=js-1,je
        do k=1,km
          do i=is,ie
           diff_fn(i,k,j)=
     &         min(1.,betaf(i,k,j  ))*max(0.,diff_fn(i,k,j))
     &       + min(1.,betaf(i,k,j+1))*min(0.,diff_fn(i,k,j))
          enddo
        enddo
      enddo
c
c   delimit vertical flux
c
      do j=js,je
        do k=0,km
          do i=is,ie
           diff_fb(i,k,j)=
     &         min(1.,betaf(i,k  ,j))*min(0.,diff_fb(i,k,j))
     &       + min(1.,betaf(i,k+1,j))*max(0.,diff_fb(i,k,j))
          enddo
        enddo
      enddo

      diff_fn=diff_fn*(-1)
      diff_fe=diff_fe*(-1)
      diff_fb=diff_fb*(-1)

      end subroutine delimit_all_fluxes

#include "options.inc"


c
c-----------------------------------------------------------------------
c     implicit vertical mixing module
c
c     linked in the code in setup, tracer and clinic
c
c                     c eden
c-----------------------------------------------------------------------
c
      subroutine implicitvmix_init
      use spflame_module
      implicit none

      if (my_pe==0) then
       print*,' Initialisation of implicit vertical mixing'
      endif
     
      if (enable_implicit_vert_diff) then
c         aidif_tracer = 0.5  ! Crank Nicholsen, semi implicit
         aidif_tracer = 1.0  
      else
         aidif_tracer = 0.0  ! explicit
      endif

      if (enable_implicit_vert_fric) then
c         aidif_momentum = 0.5
         aidif_momentum = 1.0
      else
         aidif_momentum = 0.0
      endif

      if (my_pe==0) then
       print*,' aidif_tracer  =',aidif_tracer
       print*,' aidif_momentum=',aidif_momentum
       print*,' 0.5 means semi-implicit, 0.0 explicit '
       print*,' done '
      endif

      end subroutine implicitvmix_init


      subroutine implicit_vert_diff(n,is,ie,js,je)
c
c-----------------------------------------------------------------------
c     solve vertical diffusion of tracers implicitly
c     author:   r.c.pacanowski       e-mail rcp@gfdl.gov
c     Klaus Ketelsen     29.1.99   Loop order changed
c     Klaus Ketelsen     02.2.99   setup of equation, and 1. step invert mixed
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer , intent(in) :: n,is,ie,js,je
#ifndef vector_host
c
c-----------------------------------------------------------------------
c     risc version of the code
c-----------------------------------------------------------------------
c
      integer              :: i,j,k,kz
      real                                     :: a,b,c,d,g,fxa
      real, dimension(0:km)                    :: e,f
# ifdef partial_cell
      real ::  dhw_ut(0:km)
      real ::  dhut  (  km)
# endif

      fxa = c2dt*aidif_tracer
c
c     add in the implicit vertical diffusion
c
      do j=js,je
       do i=is,ie
# ifdef partial_cell
          do k=1,km
           dhut(k) = dht(i,k,j)
	  enddo
          do k=0,km
	   dhw_ut(k) = dhwt(i,k,j)
	  enddo
# endif
        kz = kmt(i,j)
        do k=kz+1,km
           e(k-1) = 0.
           f(k-1) = 0.
        end do
!       b. c. at bottom
        if (kz .ne. 0) then
# ifdef partial_cell
          a     = diff_cbt(i,kz-1,j)*fxa/(dhw_ut(kz-1)*dhut(kz))
          c     = fxa/dhut(kz)
# else
          a     = diff_cbt(i,kz-1,j)*dztur(kz)*fxa
          c     = dztr(kz)*fxa
# endif
          b     = 1. + a
          e     = 0.
          d     = t(i,kz,j,n,taup1)
          f(kz) = -btf(i,j,n)
          k = kz 
          g      = 1./(b-c*e(k))
          e(k-1) = a*g
          f(k-1) = (d+c*f(k))*g
        endif
!       interior
        do k=kz-1,2,-1
# ifdef partial_cell
           a      = diff_cbt(i,k-1,j)*fxa/(dhw_ut(k-1)*dhut(k))
           c      = diff_cbt(i,k,j)*fxa/(dhw_ut(k)*dhut(k)) 
# else
           a      = diff_cbt(i,k-1,j)*dztur(k)*fxa
           c      = diff_cbt(i,k,j)*dztlr(k)*fxa
# endif
           b      = 1. + a + c
           d      = t(i,k,j,n,taup1)
           g      = 1./(b-c*e(k))
           e(k-1) = a*g
           f(k-1) = (d+c*f(k))*g
        enddo
!       b. c. at top
        if(kz.ne.1)   then
           k = 1
# ifdef partial_cell
           a      = fxa/dhut(k)
           c      = diff_cbt(i,k,j)*fxa/(dhw_ut(k)*dhut(k))
# else
           a      = dztr(k)*fxa
           c      = diff_cbt(i,k,j)*dztlr(k)*fxa
# endif
           b      = 1. + c
           d      = t(i,k,j,n,taup1)
!       now invert
           g      = 1./(b-c*e(k))
           e(k-1) = a*g
           f(k-1) = (d+c*f(k))*g
        end if
!       b.c. at surface
        t(i,1,j,n,taup1) = (e(0)*stf(i,j,n) + f(0))*tmask(i,1,j)
        do k=2,km
         t(i,k,j,n,taup1) = (e(k-1)*t(i,k-1,j,n,taup1) 
     &                       + f(k-1))*tmask(i,k,j)
        enddo
       enddo    ! end i-loop
      enddo     ! end j-loop
#else
c
c-----------------------------------------------------------------------
c     vector version of the code
c-----------------------------------------------------------------------
c
      real, dimension(is:ie,km)   :: a,b,c,d
      real, dimension(is:ie,0:km) :: e,f
      real, dimension(is:ie)      :: g
      integer i,j,k,kz
      real fxa
c
      fxa = c2dt*aidif_tracer
c
      do j=js,je
       do k=2,km
          do i=is,ie
#ifdef partial_cell
            a(i,k)   = diff_cbt(i,k-1,j)*fxa/(dhwt(i,k-1,j)*dht(i,k,j))
            c(i,k)   = diff_cbt(i,k,j)*fxa/(dhwt(i,k,j)*dht(i,k,j))
#else
            a(i,k)   = diff_cbt(i,k-1,j)*dztur(k)*fxa
            c(i,k)   = diff_cbt(i,k,j)*dztlr(k)*fxa
#endif
            b(i,k)   = 1. + a(i,k) + c(i,k)
            d(i,k)   = t(i,k,j,n,taup1)
            e(i,k-1) = 0.
            f(i,k-1) = 0.
          enddo
       enddo
c      b. c. at top
       k = 1
       do i=is,ie
#ifdef partial_cell
          a(i,k)   = fxa/dht(i,k,j)
          c(i,k)   = diff_cbt(i,k,j)*fxa/(dhwt(i,k,j)*dht(i,k,j))
#else
          a(i,k)   = dztr(k)*fxa
          c(i,k)   = diff_cbt(i,k,j)*dztlr(k)*fxa
#endif
          b(i,k)   = 1. + c(i,k)
          d(i,k)   = t(i,k,j,n,taup1)
          e(i,k-1) = 0.
          f(i,k-1) = 0.
       enddo
c      b. c. at bottom
       do i=is,ie
         kz = kmt(i,j)
         if (kz .ne. 0) then
            b(i,kz) = 1. + a(i,kz)
#ifdef partial_cell
            c(i,kz) = fxa/dht(i,kz,j)
#else
            c(i,kz) = dztr(kz)*fxa
#endif
            e(i,kz) = 0.
            f(i,kz) = -btf(i,j,n)
         endif
       enddo
c      now invert
       do k=km,1,-1
         do i=is,ie
          if (k .le. kmt(i,j)) then
              g(i)     = 1./(b(i,k)-c(i,k)*e(i,k))
              e(i,k-1) = a(i,k)*g(i)
              f(i,k-1) = (d(i,k)+c(i,k)*f(i,k))*g(i)
          endif
         enddo
       enddo
c      b.c. at surface
       do i=is,ie
         t(i,1,j,n,taup1) = (e(i,0)*stf(i,j,n) + f(i,0))*tmask(i,1,j)
       enddo
       do k=2,km
        do i=is,ie
          t(i,k,j,n,taup1) = (e(i,k-1)*t(i,k-1,j,n,taup1) 
     &                        + f(i,k-1))*tmask(i,k,j)
        enddo
       enddo
      enddo ! j-loop
#endif
      end subroutine implicit_vert_diff



      subroutine implicit_vert_fric(n,is,ie,js,je)
c
c-----------------------------------------------------------------------
c     solve vertical diffusion of velocity implicitly
c     author:   r.c.pacanowski       e-mail rcp@gfdl.gov
c     Klaus Ketelsen     29.1.99   Loop order changed
c     Klaus Ketelsen     02.2.99   setup of equation, and 1. step invert mixed
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer , intent(in) :: is,ie,js,je,n
      real                 :: fxa
      integer              :: i,j,k,kz
#ifndef vector_host
c
c-----------------------------------------------------------------------
c     risc version arrays
c-----------------------------------------------------------------------
c
      real                                     :: a,b,c,d
      real, dimension(0:km)                    :: e,f
      real                                     :: g
# ifdef partial_cell
      real ::  dhw_ut(0:km)
      real ::  dhut  (  km)
# endif
#else
c
c-----------------------------------------------------------------------
c     vector version arrays
c-----------------------------------------------------------------------
c
      real, dimension(is:ie,km)   :: a,b,c,d
      real, dimension(is:ie,0:km) :: e,f
      real, dimension(is:ie)      :: g
# ifdef partial_cell
      real ::  dhw_ut(is:ie,0:km)
# endif
#endif
c
c     construct the "tau+1" velocity without implicit vertical diffusion
c
      do j=js,je
        do k=1,km
          do i=is,ie
            u(i,k,j,n,taup1) = u(i,k,j,n,taum1)+c2dt*u(i,k,j,n,taup1)
          enddo
        enddo
      enddo
      fxa = rho0r*c2dt*aidif_momentum
c
c     add in the implicit vertical diffusion
c
#ifndef vector_host
c
c-----------------------------------------------------------------------
c     Risc version of code
c-----------------------------------------------------------------------
c
      do j=js,je
       do i=is,ie
# ifdef partial_cell
        do k=1,km
	      dhut(k) = dhu(i,k,j)
        enddo
        do k=0,km
	      dhw_ut(k) = min(dhwt(i,k,j),   dhwt(i+1,k,j)
     &,                       dhwt(i,k,j+1), dhwt(i+1,k,j+1))
	enddo
# endif
        kz = kmu(i,j)
        do k=kz+1,km
           e(k-1) = 0.
           f(k-1) = 0.
        end do
!   b. c. at bottom
        if (kz .ne. 0) then
# ifdef partial_cell
          a     = visc_cbu(i,kz-1,j)*fxa/(dhw_ut(kz-1)*dhut(kz))
          c     = fxa/dhut(kz)
# else
          a     = visc_cbu(i,kz-1,j)*dztur(kz)*fxa
          c     = dztr(kz)*fxa
# endif
          b     = 1. + a
          e     = 0.
          d     = u(i,kz,j,n,taup1)
          f(kz) = -bmf(i,j,n)
          k = kz 
          g      = 1./(b-c*e(k))
          e(k-1) = a*g
          f(k-1) = (d+c*f(k))*g
        endif
!       interior
        do k=kz-1,2,-1
# ifdef partial_cell
           a      = visc_cbu(i,k-1,j)*fxa/(dhw_ut(k-1)*dhut(k))
           c      = visc_cbu(i,k,j)*fxa/(dhw_ut(k)*dhut(k)) 
# else
           a      = visc_cbu(i,k-1,j)*dztur(k)*fxa
           c      = visc_cbu(i,k,j)*dztlr(k)*fxa
# endif
           b      = 1. + a + c
           d      = u(i,k,j,n,taup1)
           g      = 1./(b-c*e(k))
           e(k-1) = a*g
           f(k-1) = (d+c*f(k))*g
        enddo
!     b. c. at top
        if(kz.ne.1)   then
           k = 1
# ifdef partial_cell
           a      = fxa/dhut(k)
           c      = visc_cbu(i,k,j)*fxa/(dhw_ut(k)*dhut(k))
# else
           a      = dztr(k)*fxa
           c      = visc_cbu(i,k,j)*dztlr(k)*fxa
# endif
           b      = 1. + c
           d      = u(i,k,j,n,taup1)
!     now invert
           g      = 1./(b-c*e(k))
           e(k-1) = a*g
           f(k-1) = (d+c*f(k))*g
        end if
!     b.c. at surface
        u(i,1,j,n,taup1) = (e(0)*smf(i,j,n) + f(0))*umask(i,1,j)
        do k=2,km
         u(i,k,j,n,taup1) = (e(k-1)*u(i,k-1,j,n,taup1) 
     &                       + f(k-1))*umask(i,k,j)
        enddo
       enddo    ! end i-loop
      enddo     ! end j-loop
#else
c
c-----------------------------------------------------------------------
c    vector version of code
c-----------------------------------------------------------------------
c
      do j=js,je

# ifdef partial_cell
       do k=0,km
        do i=is,ie
	    dhw_ut(i,k) = min(dhwt(i,k,j),   dhwt(i+1,k,j),
     &                        dhwt(i,k,j+1), dhwt(i+1,k,j+1))
        enddo
       enddo
# endif

       do k=2,km
          do i=is,ie
#ifdef partial_cell
            a(i,k)   = visc_cbu(i,k-1,j)*fxa/(dhw_ut(i,k-1)*dhu(i,k,j))
            c(i,k)   = visc_cbu(i,k,j)*fxa/(dhw_ut(i,k)*dhu(i,k,j))
#else
            a(i,k)   = visc_cbu(i,k-1,j)*dztur(k)*fxa
            c(i,k)   = visc_cbu(i,k,j)*dztlr(k)*fxa
#endif
            b(i,k)   = 1. + a(i,k) + c(i,k)
            d(i,k)   = u(i,k,j,n,taup1)
            e(i,k-1) = 0.
            f(i,k-1) = 0.
          enddo
       enddo
c      b. c. at top
       k = 1
       do i=is,ie
#ifdef partial_cell
          a(i,k)   = fxa/dhu(i,k,j)
          c(i,k)   = visc_cbu(i,k,j)*fxa/(dhw_ut(i,k)*dhu(i,k,j))
#else
          a(i,k)   = dztr(k)*fxa
          c(i,k)   = visc_cbu(i,k,j)*dztlr(k)*fxa
#endif
          b(i,k)   = 1. + c(i,k)
          d(i,k)   = u(i,k,j,n,taup1)
          e(i,k-1) = 0.
          f(i,k-1) = 0.
       enddo
c      b. c. at bottom
       do i=is,ie
         kz = kmu(i,j)
         if (kz .ne. 0) then
            b(i,kz) = 1. + a(i,kz)
#ifdef partial_cell
            c(i,kz) = fxa/dhu(i,kz,j)
#else
            c(i,kz) = dztr(kz)*fxa
#endif
            e(i,kz) = 0.
            f(i,kz) = -bmf(i,j,n)
         endif
       enddo
c      now invert
       do k=km,1,-1
         do i=is,ie
          if (k .le. kmu(i,j)) then
              g(i)     = 1./(b(i,k)-c(i,k)*e(i,k))
              e(i,k-1) = a(i,k)*g(i)
              f(i,k-1) = (d(i,k)+c(i,k)*f(i,k))*g(i)
          endif
         enddo
       enddo
c      b.c. at surface
       do i=is,ie
         u(i,1,j,n,taup1) = (e(i,0)*smf(i,j,n) + f(i,0))*umask(i,1,j)
       enddo
       do k=2,km
        do i=is,ie
          u(i,k,j,n,taup1) = (e(i,k-1)*u(i,k-1,j,n,taup1) 
     &                        + f(i,k-1))*umask(i,k,j)
        enddo
       enddo
      enddo ! j-loop
#endif
c
c-----------------------------------------------------------------------
c     convert back to time change of velocity
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
          do i=is,ie
            u(i,k,j,n,taup1) =(u(i,k,j,n,taup1)-u(i,k,j,n,taum1))/c2dt
          enddo
        enddo
      enddo
      end subroutine implicit_vert_fric

#include "options.inc"


      subroutine vmixc()
c
c=======================================================================
c     set the vertical diffusivity and viscosity
c     by choosing one of several possible parameterisations
c=======================================================================
c
      use spflame_module
      implicit none

      if (enable_cgh_vert_mixing) then
        call cghmix()
      elseif (enable_const_vert_mixing) then
        visc_cbu=kappa_m
        diff_cbt=kappa_h
        visc_cbu(:,km,:)=0.
        diff_cbt(:,km,:)=0.
        if (enable_impl_convection) then
          call implicit_convection()
        endif
      elseif (enable_tkemix) then
        call tkemix()
      endif

      if (enable_diffusion_isoneutral) call isoneutral_add_K33  
      if (enable_diffusion_isopycnic)  call isopycnic_add_K33  
      end subroutine vmixc


      subroutine setvbc
c
c=======================================================================
c     set the vertical boundary conditions
c=======================================================================
c
      use spflame_module
      implicit none
      real            :: uvmag,tshift
      integer         :: i,j,is,ie,js,je,n,kz
      real, parameter :: rinf = 1.0e+32
      real :: frozen(is_pe:ie_pe),cd

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c     the surface fluxes
c
      if (mother<0) then

#ifdef couple
#else
       if (enable_simple_sbc) then

         call sbc_template()

       else
c
c       read in SBC conditions
c
        call sbc_read

       endif ! enable_simple_sbc
#endif

      else
c
c      sub domains get taux/tauy, ustar, stf_clim and stf_rest
c      from mother domain
c
      endif ! mother <0


#ifndef couple
c
c     apply restoring boundary conditions for T and S
c
      do j=js,je
       do i=is,ie
        stf(i,j,1)=stf_rest(i,j,1)*(stf_clim(i,j,1)-t(i,1,j,1,taum1))
        stf(i,j,2)=stf_rest(i,j,2)*(stf_clim(i,j,2)-t(i,1,j,2,taum1))
       enddo
      enddo

      if (nt>2) then
c
c      apply surface boundary conditions for other tracers
c
       call passive_tracer_sflx()

      endif

#endif


c
c     the bottom fluxes are zero
c
      btf=0.; bmf=0.
c
c     set bottom drag 
c
      do j=js,je
       do i=is,ie
        kz = kmu(i,j)
        if (kz .ne. 0) then
         uvmag    = sqrt(u(i,kz,j,1,taum1)**2 + 
     &                   u(i,kz,j,2,taum1)**2 + tidaloff**2)
         bmf(i,j,1) = cdbot*u(i,kz,j,1,taum1)*uvmag
         bmf(i,j,2) = cdbot*u(i,kz,j,2,taum1)*uvmag
        endif
       enddo
      enddo

      if (enable_windstress_feedback) then
       do j=js,je
        do i=is,ie
         kz = kmu(i,j)
         if (kz .ne. 0) then
          uvmag = sqrt(u(i,kz,j,1,taum1)**2 + 
     &                 u(i,kz,j,2,taum1)**2 + 1.e-8)/100. ! in m/s
          cd = (0.52+1.56/uvmag)/1000. *1.35 *10./100. ! C_d * rho *10/100 (to convert )
          smf(i,j,1) = smf(i,j,1)+cd*u(i,1,j,1,taum1)*uvmag
          smf(i,j,2) = smf(i,j,2)+cd*u(i,1,j,2,taum1)*uvmag
         endif
        enddo
       enddo
      endif


      if (enable_icemask) then
c
c      apply ice mask, momentum and salt fluxes are not affected
c
       do j=js,je
        call freezing_point(t(is_pe,1,j,2,tau),frozen,ie_pe-is_pe+1)
        do i=is,ie
c        set tshift  = 0    when T <= frozen
c            tshift  = huge when T  > frozen 
         tshift = rinf * amax1((t(i,1,j,1,tau)-frozen(i)), 0.) 
c        set icemask = 0 when tshift = 0 
c            icemask = 1 when tshift = huge
         icemask(i,j) = amin1(tshift,1.)* tmask(i,1,j)
        enddo
       enddo
c
c     apply icemask to heat fluxes only if there are cooling
c
       where (stf(is:ie,js:je,1) < 0.)
     &        stf(is:ie,js:je,1) =
     &        stf(is:ie,js:je,1) * icemask(is:ie,js:je)
c
c      apply icemask to other tracer fluxes
c
       do n=2,nt
        stf(is:ie,js:je,n) =
     &  stf(is:ie,js:je,n) * icemask(is:ie,js:je)
       enddo
c
c     apply icemask to wind stirring
c
       if (enable_ktmix.or.enable_tkemix) then
        ustar(is:ie,js:je) = ustar(is:ie,js:je)*icemask(is:ie,js:je)
       endif

      endif  ! enable icemask

      end subroutine setvbc



      subroutine init_cghmix 
      use spflame_module
      implicit none
c
c=======================================================================
c     Initialization for the Cummins/Holloway/Gargett vertical mixing
c     scheme
c     Cummins, Holloway and Gargett (JPO, 20, 1990, 817-830).
c    
c     Christian Dieterich Tue Nov 11 17:25:58 MET 1997
c     adapted from "ppmixi" by
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c     SPFLAME version : c.eden
c=======================================================================
c
      if (my_pe==0) then
       print*,''
       print*,' Initialization of Cummins et al vertical mixing scheme' 
       print*,''
       print*,' proportionality factors to the inverse of the'
       print*,' square root of Brunt-Vaisaelae frequency ='
       print*,' (for diffusivity/viscosity) ',cgh_vdcfac,' '
       print*,' min value for mixing at surface to simulate high freq'
       print*,' wind mixing (if absent in forcing)= ',wndmix,' cm^2/s'
       print*,' diffusivity is bounded by ',
     &          diff_cbt_back,diff_cbt_cut,' cm^2/s'
       print*,' viscosity is bounded by ',
     &          visc_cbu_back,visc_cbu_cut,' cm^2/s'
       if (enable_cgh_vert_momentum_mixing) then
         print*,' using Cummins et al also for momentum'
       endif
       if (enable_cgh_impl_convection) then
         print*,' using high vertical diffusivities in case of'
         print*,' an unstable stratification '
       endif
       print*,''
       print*,' done' 
       print*,''
      endif
      end subroutine init_cghmix 


      subroutine cghmix
      use spflame_module
      implicit none
c
c=======================================================================
c     Compute vertical mixing coefficients based on...
c     Cummins, Holloway and Gargett (JPO, 20, 1990, 817-830).
c
c     Note: By default only vertical diffusivities are computed as a
c     function of Brunt-Vaisaelae frequency. Vertical viscosity is set
c     to the constant value "kappa_m".
c     If "cghvmix_momentum" is enabled the vertical viscosities also
c     dependend on stability.  
c
c     inputs:
c
c      cgh_vdcfac     = proportionality factor to the inverse of the
c                       square root of Brunt-Vaisaelae frequency
c      diff_cbt_cut   = maximum "diff_cbt" (cm**2/sec)
c      diff_cbt_back  = background "diff_cbt" (cm**2/sec)
c if enable_cgh_vert_momentum_mixing
c      wndmix         = min value for mixing at surface to simulate high freq
c                       wind mixing (if absent in forcing). (cm**2/sec)
c      visc_cbu_cut   = maximum "visc_cbu" (cm**2/sec)
c      visc_cbu_back  = background "visc_cbu" (cm**2/sec)
c else
c      kappa_m        = constant "visc_cbu" (cm**2/sec)
c endif
c
c     outputs:
c
c      visc_cbu = viscosity coefficient at bottom of "u" cells (cm**2/s)
c      diff_cbt = diffusion coefficient at bottom of "t" cells (cm**2/s)
c
c     Christian Dieterich Tue Nov 11 17:02:23 MET 1997
c     adapted from "ppmix" by
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c=======================================================================
c
      integer :: is,ie,js,je,i,j,k
      real    :: ro1(is_pe:ie_pe+1),ro2(is_pe:ie_pe+1)
      real    :: bvfrqs(is_pe:ie_pe+1,km,js_pe:je_pe+1)
      real    :: fx,diff_loc, visc_loc
      real    :: bvfrqs_cbu
      real    :: diff_cbt_limit

      diff_cbt_limit = diff_cbt_cut
      if (enable_cgh_impl_convection) diff_cbt_limit = 1.0e6
         
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     compute squared Brunt-Vaisaelae frequency across bottom of "t"
c     cells at tau-1 for rows js through je in the MW. Set squared
c     Brunt-Vaisaelae frequency = zero across bottom and in land areas 
c-----------------------------------------------------------------------
c
      do j=js,je+1
       do k=1,km-1
        call model_dens(t(is,k  ,j,1,taum1),t(is,k  ,j,2,taum1),
     &                  ro1(is),k,ie-is+2
#ifdef partial_cell
     &                       ,ztp(is,k,j)
#endif
     &                       )
        call model_dens(t(is,k+1,j,1,taum1),t(is,k+1,j,2,taum1),
     &                  ro2(is),k,ie-is+2
#ifdef partial_cell
     &                       ,ztp(is,k,j)
#endif
     &                       )
        do i=is,ie+1
#ifdef partial_cell
         fx = -grav/(rho0*dhwt(i,k,j))
#else
         fx = -grav/rho0*dzwr(k)
#endif
         bvfrqs(i,k,j) =fx*(ro1(i)-ro2(i))*tmask(i,k+1,j)
        enddo
       enddo
      enddo
c
c-----------------------------------------------------------------------
c     set no-flux condition on density difference across bottom level
c-----------------------------------------------------------------------
c
      bvfrqs(:,km,:) = 0.
c
c-----------------------------------------------------------------------
c     compute vertical diffusivity coeff on "t" cell bottoms
c     in regions of gravitational instability, reset the vertical
c     mixing coefficient to the limit
c     Cummins, Holloway and Gargett (JPO, 20, 1990, 817-830). Eq: 10
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
            diff_cbt(i,k,j) = diff_cbt_cut
            if (bvfrqs(i,k,j) > 0.) then
              diff_loc = cgh_vdcfac(1)/sqrt(bvfrqs(i,k,j))
              diff_loc = max(diff_loc, diff_cbt_back)
              diff_loc = min(diff_loc, diff_cbt_cut)
              diff_cbt(i,k,j) = diff_loc
            elseif (bvfrqs(i,k,j) < 0.) then !????? ----- <<<<<
c             set kappa to a high value for unstable stratification
c             (just in case of enable_cgh_impl_convection = .true.)
c             (else diff_cbt_cut )
              diff_cbt(i,k,j) = diff_cbt_limit
            endif
          enddo
        enddo
      enddo

      if (enable_cgh_vert_momentum_mixing) then
c
c-----------------------------------------------------------------------
c     compute vertical viscosity coeff on "u" cell bottoms
c     in regions of gravitational instability, reset the vertical
c     mixing coefficient to the limit
c     Cummins, Holloway and Gargett (JPO, 20, 1990, 817-830). Eq: 10
c-----------------------------------------------------------------------
c
       do j=js,je
        do k=1,km-1
          do i=is,ie
            visc_cbu(i,k,j) = visc_cbu_cut
            bvfrqs_cbu = .25*(bvfrqs(i,k,j)+
     &           bvfrqs(i+1,k,j)+bvfrqs(i,k,j+1)+bvfrqs(i+1,k,j+1))
            if (bvfrqs_cbu .gt. 0.) then
              visc_loc = cgh_vdcfac(2)/sqrt(bvfrqs_cbu)
              visc_loc = max(visc_loc, visc_cbu_back)
              visc_loc = min(visc_loc, visc_cbu_cut)
              visc_cbu(i,k,j) = visc_loc
            else
              visc_cbu(i,k,j) = visc_cbu_cut
            endif
          enddo
        enddo
       enddo
      else
c
c-----------------------------------------------------------------------
c     set vertical viscosity coeff on "u" cell bottoms
c-----------------------------------------------------------------------
c
       visc_cbu=kappa_m
      endif
c
c-----------------------------------------------------------------------
c     if enable_cgh_vert_momentum_mixing
c      approximation for high freq wind mixing near the surface
c     endif
c     set no flux through bottom of bottom level "km"
c-----------------------------------------------------------------------
c
      if (enable_cgh_vert_momentum_mixing) then
       do j=js,je
        do i=is,ie
          if (visc_cbu(i,1,j) .lt. wndmix) visc_cbu(i,1,j) = wndmix
c   account for deeper ekman layer in sub_domain with higher
c   vertical resolution
          if (mother >= 0 .and. km>km_mother) then
           do k=1,zoom_fac_k
            if (visc_cbu(i,k,j) .lt. wndmix) visc_cbu(i,k,j) = wndmix
           enddo
          endif
        enddo
       enddo
      endif

      do j=js,je
        do i=is,ie
	  diff_cbt(i,km,j) = 0.
	  visc_cbu(i,km,j) = 0.
        enddo
      enddo
c
c-----------------------------------------------------------------------
c       set diffusion and viscosity coeffs to zero on land box bottoms
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
            visc_cbu(i,k,j) = umask(i,k+1,j)*visc_cbu(i,k,j)
            diff_cbt(i,k,j) = tmask(i,k+1,j)*diff_cbt(i,k,j)
          enddo
        enddo
      enddo
      end subroutine cghmix

      
      subroutine implicit_convection
      use spflame_module
      implicit none
c
c=======================================================================
c     set kappa to diff_cbt_cut for unstable stratification
c=======================================================================
c
      integer :: is,ie,js,je,i,j,k
      real    :: ro1(is_pe:ie_pe+1),ro2(is_pe:ie_pe+1)
      real    :: bvfrqs(is_pe:ie_pe+1,km,js_pe:je_pe+1)
      real    :: fx

         
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     compute squared Brunt-Vaisaelae frequency across bottom of "t"
c     cells at tau-1 for rows js through je in the MW. Set squared
c     Brunt-Vaisaelae frequency = zero across bottom and in land areas 
c-----------------------------------------------------------------------
c
      do j=js,je+1
       do k=1,km-1
        call model_dens(t(is,k  ,j,1,taum1),t(is,k  ,j,2,taum1),
     &                  ro1(is),k,ie-is+2
#ifdef partial_cell
     &                       ,ztp(is,k,j)
#endif
     &                       )
        call model_dens(t(is,k+1,j,1,taum1),t(is,k+1,j,2,taum1),
     &                  ro2(is),k,ie-is+2
#ifdef partial_cell
     &                       ,ztp(is,k,j)
#endif
     &                       )
        do i=is,ie+1
#ifdef partial_cell
         fx = -grav/(rho0*dhwt(i,k,j))
#else
         fx = -grav/rho0*dzwr(k)
#endif
         bvfrqs(i,k,j) =fx*(ro1(i)-ro2(i))*tmask(i,k+1,j)
        enddo
       enddo
      enddo
c
c-----------------------------------------------------------------------
c     set no-flux condition on density difference across bottom level
c-----------------------------------------------------------------------
c
      bvfrqs(:,km,:) = 0.
c
c-----------------------------------------------------------------------
c     set kappa to a high value for unstable stratification
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
            if (bvfrqs(i,k,j) <=0.) then
              diff_cbt(i,k,j) = diff_cbt_cut
            endif
          enddo
        enddo
      enddo

      do j=js,je
        do i=is,ie
	  diff_cbt(i,km,j) = 0.
        enddo
      enddo
c
c-----------------------------------------------------------------------
c       set diffusion coeffs to zero on land box bottoms
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
            diff_cbt(i,k,j) = tmask(i,k+1,j)*diff_cbt(i,k,j)
          enddo
        enddo
      enddo
      end subroutine implicit_convection


#if !defined vector_host || !defined flame_density || defined partial_cell

      subroutine convect (tauxx)
c
c-----------------------------------------------------------------------
c     The following convection scheme is an alternative to the
c     standard scheme. In contrast to the standard scheme,
c     it totally removes all gravitational instability in the
c     water column. It does that in one pass, so the parameter
c     ncon becomes irrelevant if this option is selected.
c     The scheme is equivalent to those used by Rahmstorf 
c     (jgr 96,6951-6963) and by Marotzke (jpo 21,903-907).
c     It is discussed in a note to Ocean Modelling (101). It uses
c     as much cpu time as 1-3 passes of the standard scheme, 
c     depending on the amount of static instability found in the
c     model, and is much faster than using "implicitvmix".
c
c     Written by Stefan Rahmstorf, Institut fuer Meereskunde,
c     Kiel, Germany.            Comments welcome:
c                         srahmstorf@meereskunde.uni-kiel.d400.de
c
c     definition of internal variables:
c     kcon = maximum number of levels at this location
c     lcon = counts levels down
c     lcona = upper layer of a convective part of water column
c     lconb = lower layer of a convective part of water column
c     rhoup = density referenced to same level
c     rholo = density referenced to level below
c                (note that densities are not absolute!)
c     dztsum = sum of layer thicknesses
c     trasum = sum of layer tracer values
c     tramix = mixed tracer value after convection
ce    the following two arrays are now in spflame_module
c     lctot = total of number of levels involved in convection
c     lcven = number of levels ventilated (convection to surface)
c     note: lctot can in rare cases count some levels twice, if they
c           get involved in two originally separate, but then
c           overlapping convection areas in the water column! It
c           is a control parameter; the sensible parameter to plot
c           is lcven. Lcven is 0 on land, 1 on ocean points with no
c           convection, and anything up to km on convecting points. 
c
c     Written by Stefan Rahmstorf, Institut fuer Meereskunde,
c                         srahmstorf@meereskunde.uni-kiel.d400.de
c     SPFLAME version : c.eden
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer :: is,ie,js,je,tauxx
      real :: rhoup(is_pe:ie_pe,km), rholo(is_pe:ie_pe,km)
      real :: trasum(nt), tramix,dztsum
      integer :: n,i,j,k,l,l1,kcon,lcon,lcona,lconb,lmix
c
c     check each row column by column; note that 'goto 1310'
c     finishes a particular column and moves to the next one.
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
c
c       find density of entire row for stability determination
c
        do l=1,km-1
          l1=l+1
          call model_dens(t(is,l1,j,1,tauxx), t(is,l1,j,2,tauxx),
     &                    rhoup(is,l1),l1,ie-is+1
#ifdef partial_cell
     &                       ,ztp(is,l1,j)
#endif
     &                       )
          call model_dens(t(is,l ,j,1,tauxx), t(is,l ,j,2,tauxx),
     &                    rholo(is,l ),l1,ie-is+1
#ifdef partial_cell
     &                       ,ztp(is,l1,j)
#endif
     &                       )
	enddo

        do i=is,ie
          kcon     = kmt(i,j)
          lctot(i,j) = 0
          lcven(i,j) = 0
	  if (kcon == 0) goto 1310
          lcven(i,j) = 1
          lcon     = 0
c
c         1. initial search for uppermost unstable pair; if none is
c            found, move on to next column
c
          do k=kcon-1,1,-1
            if (rholo(i,k) .gt. rhoup(i,k+1)) lcon = k
          enddo
c
          if (lcon .eq. 0) goto 1310
c
1319      lcona = lcon
          lconb = lcon + 1
c
c         2. mix the first two unstable layers
c
#ifdef partial_cell
          dztsum = dht(i,lcona,j) + dht(i,lconb,j)
#else
          dztsum = dzt(lcona) + dzt(lconb)
#endif
          do n=1,nt
#ifdef partial_cell
            trasum(n)        = t(i,lcona,j,n,tauxx)*dht(i,lcona,j) + 
     &                         t(i,lconb,j,n,tauxx)*dht(i,lconb,j)
#else
            trasum(n)        = t(i,lcona,j,n,tauxx)*dzt(lcona) + 
     &                         t(i,lconb,j,n,tauxx)*dzt(lconb)
#endif
            tramix           = trasum(n) / dztsum
            t(i,lcona,j,n,tauxx) = tramix
            t(i,lconb,j,n,tauxx) = tramix
          enddo
c
c         3. test layer below lconb
c
1306      continue
          if (lconb .eq. kcon) goto 1308
c
          l1 = lconb + 1
          rholo(i,lconb) = model_dens_scalar (t(i,lconb,j,1,tauxx)
     &,                              t(i,lconb,j,2,tauxx), l1
#ifdef partial_cell
     &                       ,ztp(i,l1,j)
#endif
     &                       )
c
          if (rholo(i,lconb) .gt. rhoup(i,l1)) then
            lconb = lconb+1
#ifdef partial_cell
            dztsum = dztsum + dht(i,lconb,j)
#else
            dztsum = dztsum + dzt(lconb)
#endif
            do n=1,nt
#ifdef partial_cell
          trasum(n) = trasum(n) + t(i,lconb,j,n,tauxx)*dht(i,lconb,j)
#else
              trasum(n) = trasum(n) + t(i,lconb,j,n,tauxx)*dzt(lconb)
#endif
              tramix = trasum(n) / dztsum
              do lmix=lcona,lconb
                t(i,lmix,j,n,tauxx) = tramix
              enddo
            enddo
            goto 1306
          end if
c
c         4. test layer above lcona
c
1308      continue
          if (lcona .gt. 1) then
            l1 = lcona-1
            rholo(i,l1) = model_dens_scalar(t(i,l1,j,1,tauxx) 
     &,                            t(i,l1,j,2,tauxx),lcona
#ifdef partial_cell
     &                       ,ztp(i,lcona,j)
#endif
     &                       )
            rhoup(i,lcona) = model_dens_scalar(t(i,lcona,j,1,tauxx)
     &,                               t(i,lcona,j,2,tauxx),lcona
#ifdef partial_cell
     &                       ,ztp(i,lcona,j)
#endif
     &                       )
            if (rholo(i,lcona-1) .gt. rhoup(i,lcona)) then
              lcona = lcona-1
#ifdef partial_cell
              dztsum = dztsum + dht(i,lcona,j)
#else
              dztsum = dztsum + dzt(lcona)
#endif
              do n=1,nt
#ifdef partial_cell
            trasum(n) = trasum(n) + t(i,lcona,j,n,tauxx)*dht(i,lcona,j)
#else
                trasum(n) = trasum(n) + t(i,lcona,j,n,tauxx)*dzt(lcona)
#endif
                tramix = trasum(n) / dztsum 
                do lmix=lcona,lconb
                  t(i,lmix,j,n,tauxx) = tramix
                enddo
              enddo
              goto 1306
            end if
          end if
c
c         5. remember the total number of levels mixed by convection
c            in this water column, as well as the ventilated column
c
          lctot(i,j) = lctot(i,j) + lconb - lcona + 1
          if (lcona .eq. 1) lcven(i,j) = lconb - lcona + 1
c
c         6. resume search if step 3. and 4. have been passed and this
c            unstable part of the water column has thus been removed,
c            i.e. find further unstable areas further down the column
c
          if (lconb .eq. kcon) goto 1310
          lcon = lconb
c
1302      continue
          lcon = lcon + 1
c
          if (lcon .eq. kcon) goto 1310
c
          if (rholo(i,lcon) .le. rhoup(i,lcon+1)) goto 1302
c
          goto 1319

1310      continue
        enddo
      enddo
      end subroutine convect

#else

c !!! partly vectorized version !!!

      subroutine convect(tauxx)

!-----------------------------------------------------------------------
!   the following code acts only for the first kmax levels
!   therefore, another scheme is necessary below 
!   intention is to use it with ktmix scheme (see below) only
!
!   Changes made at CSIRO Marine Research:
!   The main loop of the original routine cannot be vectorized. However,
!   it is possible to vectorize part of the algorithm. If convective mixing
!   occurs it is nearly always due to surface cooling rather than an internal 
!   instability. We need only search in downwards in this case. As soon as
!   a column is stabilised the search is discontinued for that column. Once
!   all columns have been 'ventilated' we then proceed to the original
!   algorithm. Since we have removed the surface instabilities it is highly
!   unlikely that we enter the main loop. If no convection at all occurs then
!   there is a small overhead equivalent to calculating a row of densities.
!   It may be worthwhile escaping the vectorized ventilation section when the
!   number of unstable columns is below some threshold and enter an optimised
!   scalar section of code.
!
!   Note: Some Fortran90 constructs have been used for clarity. It is
!   straightforward to recode in f77.
!   
!   icasc  = logical variable indicating whether a column is still unstable
!   lcven1 = levels ventilated in in new 'cascade' sweep. Plot the maximum
!            of lcven and lcven1 now.
!
!   author: Russ Fiedler fiedler@marine.csiro.au
!
c     SPFLAME version : c.eden
!-----------------------------------------------------------------------

      use spflame_module
      implicit none
      integer :: tauxx
      integer,parameter :: kmax=15
      integer :: is,ie,js,je,i,j,k,k2,n,lev,l1
      integer :: kcon,lcon(is_pe:ie_pe),lcona,lconb,lmix
      integer :: lcven1(is_pe:ie_pe)
      real :: rhoup(is_pe:ie_pe,km), rholo(is_pe:ie_pe,km)
      real :: trasum(nt), tramix,dztsum
      real :: dzsum, dzsum1, ratio1, ratio2
      logical :: icasc(is_pe:ie_pe)
      real :: tq,sq,dens
      dens(tq,sq,k)  = (dn_coef(k,1) + 
     &    (dn_coef(k,4)+dn_coef(k,7)*sq)*sq +
     &    (dn_coef(k,3)+dn_coef(k,8)*sq+dn_coef(k,6)*tq)*tq)*tq +
     &    (dn_coef(k,2)+(dn_coef(k,5)+ dn_coef(k,9)*sq)*sq)*sq

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      if (kmax >km ) then
        if(my_pe==0) print*,' parameter kmax greater than km  '
        call halt_stop(' in convect (vector version)')
      endif

#ifdef partial_cell
        call halt_stop(' in convect (vector version) -- 4')
#endif
#ifndef flame_density
        call halt_stop(' in convect (vector version) -- 5')
#endif

      do j=js,je

! 0. Pre search for upper levels. And allow cascade downwards.
!    Most convection will occur here. if we can stabilize
!    then the next search will skip the scalar loop

        lcven1(is:ie)=0.0
        do i=is,ie
          icasc(i)=.false.
          if ( kmt(i,j) /= 0 ) icasc(i)=.true.
        enddo

        dzsum1=dzt(1)
        do lev=1,kmax-1
          dzsum=dzsum1
          dzsum1=dzsum1+dzt(lev+1)
          ratio1=dzsum/dzsum1
          ratio2=dzt(lev+1)/dzsum1
          do i=is,ie
! Test if cascade is possible
            if( lev >= kmt(i,j) ) icasc(i) = .false.
            if (icasc(i)) then
          rhoup(i,lev+1)=dens(t(i,lev+1,j,1,tauxx)-dn_to(lev+1)
     &,                       t(i,lev+1,j,2,tauxx)-dn_so(lev+1),lev+1)
          rholo(i,lev)  =dens(t(i,lev  ,j,1,tauxx)-dn_to(lev+1)
     &,                       t(i,lev  ,j,2,tauxx)-dn_so(lev+1),lev+1)
! Test whether to mix else mark end of cascade
! NB only need to adjust lower value. Will do last part of mixing later.
              if( rholo(i,lev) >= rhoup(i,lev+1) ) then
                t(i,lev+1,j,1,tauxx)   = t(i,lev  ,j,1,tauxx)*ratio1 + 
     &                                   t(i,lev+1,j,1,tauxx)*ratio2
                t(i,lev+1,j,2,tauxx)   = t(i,lev  ,j,2,tauxx)*ratio1 + 
     &                                   t(i,lev+1,j,2,tauxx)*ratio2
                lcven1(i)=lev+1      
              else
                icasc(i)=.false.
              endif
            endif
          enddo ! i
          if( .not. any(icasc(is:ie)) ) exit
        enddo ! lev

!     the other tracers
       do n = 3, nt
        dzsum1=dzt(1)
        do lev=1,kmax-1
          dzsum=dzsum1
          dzsum1=dzsum1+dzt(lev+1)
          ratio1=dzsum/dzsum1
          ratio2=dzt(lev+1)/dzsum1
          do i=is,ie
            if(lev <= lcven1(i)-1) then
                t(i,lev+1,j,n,tauxx)   = t(i,lev  ,j,n,tauxx)*ratio1 + 
     &                                   t(i,lev+1,j,n,tauxx)*ratio2
            endif
          enddo
        enddo
       enddo

! Adjust values up the column 

       do n = 1, nt
        do lev=1,maxval(lcven1(is:ie))-1
          do i=is,ie
            if(lev.le.lcven1(i)-1) then
               t(i,lev,j,n,tauxx) = t(i,lcven1(i),j,n,tauxx)
            endif
          enddo
        enddo
       enddo

! Redo all the densities 

        do k=1,kmax-1
         do i=is,ie
          k2=k+1
          rhoup(i,k2) = dens(t(i,k2,j,1,tauxx)-dn_to(k2)
     &,                      t(i,k2,j,2,tauxx)-dn_so(k2), k2)
          rholo(i,k)  = dens(t(i,k ,j,1,tauxx)-dn_to(k2)
     &,                      t(i,k ,j,2,tauxx)-dn_so(k2), k2)
	 enddo
	enddo

!     check each row column by column; note that 'goto 1310'
!     finishes a particular column and moves to the next one.

!         1. initial search for uppermost unstable pair;

        lcon(is:ie)=0
        lctot(is:ie,j) = 0
        lcven(is:ie,j) = 0

        do k=kmax-1,1,-1
          do i=is,ie
            if ( rholo(i,k) > rhoup(i,k+1)) lcon(i) = k
          enddo
        enddo
! Correct for land and get flag to bail out of 
        do i=is,ie
          if( lcon(i) >= kmt(i,j) .or. lcon(i) >= kmax ) lcon(i)=0
        enddo

       if( maxval(lcon(is:ie)) /= 0 ) then 

        do i=is,ie
          if ( lcon(i) == 0 ) goto 1310

          kcon     = min(kmax,kmt(i,j))
          lcven(i,j) = 1

1319      lcona = lcon(i)
          lconb = lcon(i) + 1

!         2. mix the first two unstable layers

          dztsum = dzt(lcona) + dzt(lconb)
          do n=1,nt
            trasum(n)        = t(i,lcona,j,n,tauxx)*dzt(lcona) + 
     &                         t(i,lconb,j,n,tauxx)*dzt(lconb)
            tramix           = trasum(n) / dztsum
            t(i,lcona,j,n,tauxx) = tramix
            t(i,lconb,j,n,tauxx) = tramix
          enddo

!         3. test layer below lconb

1306      continue
          if ( lconb == kcon ) goto 1308

          l1 = lconb + 1
          rholo(i,lconb) = dens(t(i,lconb,j,1,tauxx)-dn_to(l1)
     &,                      t(i,lconb,j,2,tauxx)-dn_so(l1), l1)
          if ( rholo(i,lconb) > rhoup(i,l1) ) then
            lconb = lconb+1
            dztsum = dztsum + dzt(lconb)
            do n=1,nt
              trasum(n) = trasum(n) + t(i,lconb,j,n,tauxx)*dzt(lconb)
              tramix = trasum(n) / dztsum
              do lmix=lcona,lconb
                t(i,lmix,j,n,tauxx) = tramix
              enddo
            enddo
            goto 1306
          end if

!         4. test layer above lcona

1308      continue
          if ( lcona > 1 ) then
            l1 = lcona-1
            rholo(i,l1) = dens(t(i,l1,j,1,tauxx) -dn_to(lcona)
     &,                       t(i,l1,j,2,tauxx)-dn_so(lcona),lcona)
            rhoup(i,lcona) = dens(t(i,lcona,j,1,tauxx)-dn_to(lcona)
     &,                       t(i,lcona,j,2,tauxx)-dn_so(lcona),lcona)
            if ( rholo(i,lcona-1) > rhoup(i,lcona) ) then
              lcona = lcona-1
              dztsum = dztsum + dzt(lcona)
              do n=1,nt
                trasum(n) = trasum(n) + t(i,lcona,j,n,tauxx)*dzt(lcona)
                tramix = trasum(n) / dztsum 
                do lmix=lcona,lconb
                  t(i,lmix,j,n,tauxx) = tramix
                enddo
              enddo
              goto 1306
            end if
          end if

!         5. remember the total number of levels mixed by convection
!            in this water column, as well as the ventilated column

          lctot(i,j) = lctot(i,j) + lconb - lcona + 1
          if ( lcona == 1 ) lcven(i,j) = lconb

!         6. resume search if step 3. and 4. have been passed and this
!            unstable part of the water column has thus been removed,
!            i.e. find further unstable areas further down the column

          if ( lconb == kcon ) goto 1310
          lcon(i) = lconb

1302      continue
          lcon(i) = lcon(i) + 1

          if (lcon(i) .eq. kcon) goto 1310

          if ( rholo(i,lcon(i)) <= rhoup(i,lcon(i)+1) ) goto 1302

          goto 1319

1310      continue
        enddo

       endif

c       do i=is,ie
c         lctot(i,j)=zt(max(1,min(km,lcven1(i))))/100.  +lcven(i,j)
c       enddo
      enddo ! jrow
      end subroutine convect
#endif




      subroutine Ktmix
 
!------------------------------------------------------------------------------
! 
!     Kraus-Turner mixing, wind-driven part only, 
!     Sterl & Kattenberg numerical scheme.
! 
!     Subroutine for GFDL-MOM, V. 2.1
! 
!     Doc. of equations used:           LaTeX-file "Ktmix.tex".
!     Doc. of changes in code:          ASCII-file "Changes_Ktmix.doc"
! 
!     original version:           M. Cox, 1986
!                   Joachim Dengg, jdengg@awi-bremerhaven.de
!     SPFLAME version : c.eden
!
!------------------------------------------------------------------------------
!
      use spflame_module
      implicit none

!     -------------------------------------------------------------------------
!     Specify some necessary parameters:
!     -------------------------------------------------------------------------

!     - Maximum level of penetration of wind mixing
!
!       (to avoid penetrative mixing to too large depths due to asymptotic
!        decay of TKE-profile, choose the depth where TKE has decayed to 
!        -say - 1 percent of its surface value:  zt(kmax) = z_scale*ln(0.01) )
 
      integer,parameter :: kmax = 15       ! 250m: 1% level for z_scale=50m

!     - Small number to prevent floating overflows in layers
!       that are already mixed

      real,parameter :: small1 = 1.e-20
!     -------------------------------------------------------------------------
!     Define model variables
!     -------------------------------------------------------------------------

      real ::       pe(is_pe:ie_pe,kmax)   ! potential energy of water column 
!                                    !                  down to level k
      real ::      dPE(is_pe:ie_pe,kmax)   ! difference of PE before and after
!                                    !                            mixing
      real ::      TKE(is_pe:ie_pe)        ! turbulent kinetic energy
!                                    !      available from wind
      real ::     dTKE(is_pe:ie_pe,kmax)   ! difference between available
!                                    ! TKE and energy necessary to
!                                    ! mix next level completely

      real ::   rho_kt(is_pe:ie_pe,kmax)   ! pot. density [g/cm**3], 
!                                    !       referenced to z=0
      real ::     mass(is_pe:ie_pe,kmax)   ! mass in level k
      real :: sum_mass(is_pe:ie_pe,kmax)   ! total mass down to level k

      real ::    delta(is_pe:ie_pe)        ! thickness of partial mixing [cm]
      real ::     frac(is_pe:ie_pe)        ! fract. of level thickness [%] 
      real ::  c1mfrac(is_pe:ie_pe)        ! (1.-frac)

      real ::    cmask(is_pe:ie_pe,kmax)   ! mask for completely mixed levels
      real ::    pmask(is_pe:ie_pe,kmax)   ! mask for partially  mixed levels
      real ::   cpmask(is_pe:ie_pe,kmax)   ! mask for completely or 
!                                    !          partially  mixed levels
!                                    ! (0.: do not mix, 1.: mix)

      real ::     ztot(is_pe:ie_pe)        ! total depth of completely 
!                                    !                   mixed layers
      real ::      zcp(is_pe:ie_pe)        ! total depth of completely and 
!                                    !         partially mixed layers
      real ::     rzcp(is_pe:ie_pe)        ! (1./zcp)
      real ::    rztot(is_pe:ie_pe)        ! (1./ztot)

      real ::  dml_new(is_pe:ie_pe)        ! new depth of mixed layer [cm]

      real ::      t_c(is_pe:ie_pe,nt)     ! tracer on completely mixed levels
      real ::     t_cp(is_pe:ie_pe,nt)     ! tracer on comp. or part. 
!                                    !                      mixed levels

      real :: fxa, fxb               ! auxiliary variables

      logical, save :: first_time = .true.

!     - depth of center of gravity of vertical T-boxes [cm]
!           (In MOM2, T-points do not necessarily coincide with
!            midpoints of layers.)
      real, allocatable, save :: zkt(:)
!
!     ustar(:,:)  =  ustar**3 [(cm/s)**3]
!     effwind     =  m1, coefficient of effectiveness of wind forcing
!     z_scale     =  vertical scale length of TKE dissipation [cm]
!     c2dtts      =  2*timestep for MOM leapfrog, 1*timestep for Euler
!     rho0        =  reference density: physically almost irrelevant, 
!                    but numerically useful for greater precision.
!                    (physical importance: computation of TKE)
!     dml         =  old depth of mixed layer (only used to calculate 
!                    dissipation of TKE with exponential length scale) [cm]
!
!     tmask(i,k)  =  MOM`s land mask; prevents mixing into topography
!                 =  (0., 1.) over "t" grid (land, ocean) points
!     t(k,nt)     =  tracers from MOM (nt=1: T, nt=2: S)

      integer is,ie,js,je,i,j,k,m

#ifdef partial_cell
c      would have to define 3D array here ... skip this
c      anyway   zw(k) -> zw(k-1)+dhwt(i,k,j)
c      anyway   zkt(k) = zw(k-1)+dhwt(i,k,j)-0.5*dht(i,k,j)
#else
      if (first_time) then
c       if (my_pe == 0) print*, 'Initialization for Mixed Layer ktmix'
       first_time = .false.
       allocate( zkt(km))
!      define new vertical axis for centre of gravity of each T-box
       do k=1, km
       enddo
       do k=1, km
        zkt(k) = zw(k)-0.5*dzt(k)
       enddo
      endif
#endif

!     -------------------------------------------------------------------------
!     limit the longitude indices
!     -------------------------------------------------------------------------
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

!     -------------------------------------------------------------------------
!     Apply Ktmix to the whole memory window
!     -------------------------------------------------------------------------

      j_loop: do j=js, je

!     -------------------------------------------------------------------------
!     Compute TKE provided by the wind 
!     -------------------------------------------------------------------------

      fxa = effwind * rho0 * c2dt / grav  
      fxb = -1./z_scale

#ifdef testktmix
      do i=is, ie  
        if (ustar(i,j) == -1.e10 .and. tmask(i,1,j) == 1.)
     &       write (6,*) 'ALARM: i,j,tmask: ',
     &                                i,j,tmask(i,1,j)
      end do
#endif
      TKE=0.
      TKE(is:ie) = fxa * exp(fxb*dml(is:ie,j)) * ustar(is:ie,j)

!     -------------------------------------------------------------------------
!     Compute potential densities referenced to the surface
!     -------------------------------------------------------------------------

      rho_kt=0.
      do k=1, kmax
       call model_dens(t(is,k,j,1,taup1),t(is,k,j,2,taup1),
     &                 rho_kt(is,k),1,ie-is+1 
#ifdef partial_cell
     &                       ,ztp(is,1,j)
#endif
     &                       )
      end do

!     -------------------------------------------------------------------------
!     Compute cumulative mass and PE from surface to maximum depth of ML
!     -------------------------------------------------------------------------

!     ... to determine how many layers can be mixed completely.

!     (Note: all sums are calculated down to level kmax to
!            allow vectorization.)

      mass=0.
      do k=1, kmax
#ifdef partial_cell
        mass(:,k) = rho_kt(:,k)*dht(is_pe:ie_pe,k,j)
#else
        mass(:,k) = rho_kt(:,k)*dzt(k)             ! rho(k)*dz(k)
#endif
      end do
 
      sum_mass=0.;pe=0.
      sum_mass(:,1) = mass(:,1)                    ! rho(1)     *dz(1)
#ifdef partial_cell
      pe(:,1) = mass(:,1)*
     &       (dhwt(is_pe:ie_pe,1,j)-0.5*dht(is_pe:ie_pe,1,j)) 
#else
      pe(:,1) = mass(:,1)*zkt(1)             ! rho(1)*z(1)*dz(1)
#endif

!                                                  ! Sum(rho(k)*dz(k))
!                                                  ! Sum(rho(k)*z(k)*dz(k))
      do k=2, kmax
        sum_mass(:,k) = sum_mass(:,k-1) + mass(:,k)  
#ifdef partial_cell
              pe(:,k) =       pe(:,k-1) + mass(:,k)*
     &       (zw(k-1)+dhwt(is_pe:ie_pe,k,j)-0.5*dht(is_pe:ie_pe,k,j)) 
#else
              pe(:,k) =       pe(:,k-1) + mass(:,k)*zkt(k)  
#endif
      end do

!     -------------------------------------------------------------------------
!     Compute difference dTKE between available TKE 
!                                 and PE necessary to mix next level
!     -------------------------------------------------------------------------
!
!     del TKE = TKE - del PE(k) 

      dPe=0.
      do k=1, kmax
#ifdef partial_cell
        fxa = zw(max(1,k-1)); if (k==1) fxa=0.
        dPE(:,k) = pe(:,k) 
     &      -0.5*(fxa+dhwt(is_pe:ie_pe,k,j))*sum_mass(:,k)
#else
        dPE(:,k) = pe(:,k) - 0.5*zw(k)*sum_mass(:,k)
#endif
      end do

      dPE = max(dPE, 0.)                        ! limit dPE to positive 

      dTKE=0.
      do k=1, kmax
        dTKE(:,k) = TKE(:) - dPE(:,k)
      end do

!     -------------------------------------------------------------------------
!     Compute mask for layers which are to be completely mixed
!     -------------------------------------------------------------------------
!
!     Stop mixing at the depth where del TKE is smaller than 0!
!
!     (Note: even if the density is already homogenized, del PE(k)
!            may not be exactly equal to zero due to round-off errors 
!            in the computation of PE. Patch: Check density as well.)
!
!      Also: the computation starts at k=2, because even without any 
!            exterior forcing, the mixing mask for level k=1 will always 
!            be 1 and the partial mixing for level 2 will be turned 
!            on, because at level 1, dPE=0. This does not have any  
!            serious consequences, though, because the partial mixing 
!            depth of level 2 still depends on the energy actually  
!            available, which in this case is negligible.)
       
      pmask = 0.; cmask=0.
      cmask(is:ie,1:kmax) = tmask(is:ie,1:kmax,j)        ! defaults

      where (dTKE(:,2:kmax) < 0. .and.           ! eliminate spurious cases
     &       rho_kt(:,2:kmax)-rho_kt(:,1:kmax-1) == 0.)
         dTKE(:,2:kmax) = 0.
      end where

      where (dTKE(:,2:kmax) < 0.) cmask(:,2:kmax) = 0.

      do k=2, kmax                               ! fill spurious gaps
        cmask(:,k) = cmask(:,k-1)*cmask(:,k)
      end do

!     -------------------------------------------------------------------------
!     Compute mask for layers which are to be partially mixed
!     -------------------------------------------------------------------------

      do k=2, kmax
        pmask(is:ie,k) = (cmask(is:ie,k-1)-cmask(is:ie,k)) 
     &                   * tmask(is:ie,k,j)
      end do

      if (minval(pmask) < -tiny(pmask)) then              ! security check
        write (6,*) 'Ktmix probably received an unstable ',
     &                   'density profile at:'
        do k=2, kmax
          do i=is,ie
            if (pmask(i,k)==-1.)
     &           write (6,*) 'i, j, k:', i, j, k
          end do
        end do

#ifdef testktmix
        do i=is, ie                                  ! test
          if (minval(pmask(i,:)) < -tiny(pmask)) then
            do k=1, kmax
              write (6,*) 'i,k:  ', i, k
              write (6,*) 'rho:  ', rho_kt(i,k)
              write (6,*) 'PE:   ', pe(i,k), .5*zw(k)*sum_mass(i,k)
              write (6,*) 'dPE:  ', dpe(i,k)
              write (6,*) 'dTKE: ', dTKE(i,k)
              write (6,*) 'mask: ', cmask(i,k), pmask(i,k)
            end do
          end if
        end do
#endif

        write (6,*) 'make sure that convct2 is called!'
        write (6,*) 

        call halt_stop('ktmix ==> partial mixing mask negative!')

      end if

!     -------------------------------------------------------------------------
!     Compute mask for either complete or partial mixing
!     -------------------------------------------------------------------------

      cpmask = cmask + pmask

!     -------------------------------------------------------------------------
!     Find depth of penetration of mixing
!
!      ... using the scheme described in Sterl and Kattenberg, 1994,
!                                                JGR, 99, 1439-14157
!     -------------------------------------------------------------------------
!
!     frac = fraction =  thickness of sublayer to be partially mixed relative
!                        to thickness of corresponding model level [%]
!          = (left-over energy del TKE after mixing last level completely)
!          / (energy needed to completely mix the partially mixed level 
!             at the base of the mixed layer)


         frac = 0.
        delta = 0.
#ifdef partial_cell
      dml_new = dht(is_pe:ie_pe,1,j)
          zcp = dht(is_pe:ie_pe,1,j)
         ztot = dht(is_pe:ie_pe,1,j)
#else
      dml_new = dzt(1)
          zcp = dzt(1)
         ztot = dzt(1)
#endif

      do k=2, kmax
!                                      ! frac=0 for completely mixed levels
          frac =    frac +  pmask(:,k)*dTKE(:,k-1)/     
     &                                (dTKE(:,k-1)-dTKE(:,k)+small1)
#ifdef partial_cell
         delta =   delta +  pmask(:,k)*frac*dht(is_pe:ie_pe,k,j)
       dml_new = dml_new +  cmask(:,k)*dht(is_pe:ie_pe,k,j) 
     &                   + pmask(:,k)*delta
          ztot =    ztot +  cmask(:,k)*dht(is_pe:ie_pe,k,j)
           zcp =     zcp + cpmask(:,k)*dht(is_pe:ie_pe,k,j)
#else
         delta =   delta +  pmask(:,k)*frac*dzt(k)
       dml_new = dml_new +  cmask(:,k)*dzt(k) + pmask(:,k)*delta
          ztot =    ztot +  cmask(:,k)*dzt(k)
           zcp =     zcp + cpmask(:,k)*dzt(k)
#endif
      end do

!     -------------------------------------------------------------------------
!     Assign new mixed-layer depth 
!     -------------------------------------------------------------------------

      dml(is:ie,j) = dml_new(is:ie)

!     -------------------------------------------------------------------------
!     Mix tracers
!
!      (Note: this scheme ensures that the potential energy created
!             exactly equals the TKE put in)
!     -------------------------------------------------------------------------

      c1mfrac = 1.-frac                 ! Speed up calculation by
        rztot = 1./ztot                 ! pre-computing constants
         rzcp = 1./zcp

      t_cp=0.; t_c=0.
      m_loop: do m=1, nt


!       Calculate mean values of tracers:
!         for mixing of completely mixed layers only:          t_c
!         for mixing of completely and partially mixed layers: t_cp

#ifdef partial_cell
        t_cp(is:ie,m) = t(is:ie,1,j,m,taup1)*dht(is:ie,1,j)
         t_c(is:ie,m) = t(is:ie,1,j,m,taup1)*dht(is:ie,1,j)
#else
        t_cp(is:ie,m) = t(is:ie,1,j,m,taup1)*dzt(1)
         t_c(is:ie,m) = t(is:ie,1,j,m,taup1)*dzt(1)
#endif

        do k=2, kmax
#ifdef partial_cell
          t_cp(is:ie,m) = t_cp(is:ie,m)
     &                    + cpmask(is:ie,k)*t(is:ie,k,j,m,taup1)
     &                     *dht(is:ie,k,j)
           t_c(is:ie,m) = t_c(is:ie,m)
     &                    +  cmask(is:ie,k)*t(is:ie,k,j,m,taup1)
     &                     *dht(is:ie,k,j)
#else
          t_cp(is:ie,m) = t_cp(is:ie,m)
     &                    + cpmask(is:ie,k)*t(is:ie,k,j,m,taup1)*dzt(k)
           t_c(is:ie,m) = t_c(is:ie,m)
     &                    +  cmask(is:ie,k)*t(is:ie,k,j,m,taup1)*dzt(k)
#endif
        end do

        t_cp(:,m) = t_cp(:,m)*rzcp
         t_c(:,m) =  t_c(:,m)*rztot

!       Assign new tracer values to layers by 
!
!         (a) leaving unaffected layers unchanged,
!         (b) interpolating between t_c and t_cp 
!                for completely mixed layers,
!         (c) interpolating between the old tracer value t of this level 
!             and t_cp for the partially mixed layer.

        do k=1, kmax
          t(is:ie,k,j,m,taup1) =
     &      (1.-cpmask(is:ie,k))*t(is:ie,k,j,m,taup1)      ! (a)
     &    + cmask(is:ie,k)                                 ! (b)
     &            *(c1mfrac(is:ie)*t_c(is:ie,m)            ! (b)
     &             +frac(is:ie)*t_cp(is:ie,m))             ! (b)
     &    + pmask(is:ie,k)                                 ! (c)
     &            *(c1mfrac(is:ie)*t(is:ie,k,j,m,taup1)    ! (c)
     &             +frac(is:ie)*t_cp(is:ie,m))             ! (c)
        end do

!       (rely on calling routine to apply horizontal boundary 
!        conditions for tracers)

      end do m_loop
      end do j_loop
      end subroutine Ktmix



      subroutine tkemix_init()
      use spflame_module
      implicit none
      !
      !----------------------------------------------------------------
      ! Document parameters for TKE scheme in output
      !
      ! wrapping of parameters to the old MOM1/OPA code of A.Oschlies:
      !
      ! C_eps        = ediss
      ! C_tke        = efave
      ! C_kappa      = ediff
      ! tke_surf_fac = ebb
      ! tke_min      = emin
      ! tke_min_surf = emin0
      !----------------------------------------------------------------
      !
      if (my_pe==0) then
       print*,''
       print*,' Initialization of the Gaspar et al.',
     &          ' vertical mixing scheme' 
       print*,' Coefficient for the Kolmogoroff dissipation',C_eps
       print*,' Coefficient for vertical eddy viscosity', C_kappa
       print*,' Coefficient for vertical TKE viscosity', C_tke
       print*,' Minimum value of TKE', tke_min,' cm^2/s^2'
       print*,' Minimum value of TKE at the surface', tke_min_surf,
     &              ' cm^2/s^2'
       print*,' Coefficient for input of TKE at surface ',tke_surf_fac
       if (nmxl==0) then
        print*,' mixing length is bound by distance to surface/bottom'
       elseif (nmxl == 1) then
        print*,' mixing length is bound by vertical scale factor'
       elseif (nmxl == 2) then
        print*,' abs( d/dz(mixing length) ) is bounded by dzt'
       endif
       print*,' diffusivity is bounded by ',
     &          diff_cbt_back,diff_cbt_cut,' cm^2/s'
       print*,' viscosity is bounded by ',
     &          visc_cbu_back,visc_cbu_cut,' cm^2/s'
       print*,''
       print*,' done' 
       print*,''
      endif
      end subroutine tkemix_init



      subroutine tkemix()

!-----------------------------------------------------------------------
!     Compute the vertical eddy viscosity and diffusivity coefficients
!     using a 1.5 turbulent closure scheme after
!     Gaspar et al., jgr, 95, 1990 and Blanke and Delecluse, jpo, 1991
!
!     The time evolution of the Turbulent Kinetic Energy (TKE) is
!     computed from the following equation:
!
!     d(tke)/dt = C_tke d( K_m d(tke)/dz )/dz + K_m (d(U)/dz)**2
!               +g/rho_0 /P_rt K_m d(RHO)/dz   - C_eps tke**(2/3) / mxl
!
!           K_m =  C_kappa mxl tke**(1/2) 
!           mxl = 1/(sqrt(tke)*N)
!     with the boundary conditions:
!     tke = max( tke_min_surf,tke_surf_fac (TAUX**2 + TAUY**2)**(1/2) 
!                                                     at the surface
!     tke = tke_min                                   at the bottom
!   
!     The time differencing is implicit for the vertical diffusion
!     term, implicit and linearized for the Kolmogoroff dissipation
!     term, and explicit forward for both buoyancy and dynamic
!     production terms.
!
!     The mixing length is the usual bouyancy length scale
!               mxl = 1/(sqrt(tke)*N)
!     where N is the Brunt-Vaisala frequency.
!     Three different physical limitations can be imposed on the
!     mixing length depending on NMXL:
!           NMXL=0 : mxl bounded by the distance to surface/bottom
!           NMXL=1 : mxl bounded by the vertical scale factor
!           NMXL=2 : vertical derivative of mxl bounded by 1.
!
!     The eddy diffusion coefficients are deduced from TKE using
!     the following equations:
!           visc_cbu = max( visc_cbu_back, C_kappa mxl tke**(1/2) )
!           diff_cbt = max( diff_cbt_back, visc_cbu/P_rt )
!           K_m = max( diff_cbu_back, visc_cbu)
!
!     diff_cbt and visc_cbu are horizontally averaged to avoid numerical
!     instabilities, K_m is not averaged.
!
!     Code was taken from OPA and/or MOM1
!     original author B. Blanke, G. Madec, ... A. Oschlies 
!     adapted for SPFLAME:   C. Eden
!-----------------------------------------------------------------------
      use spflame_module
      implicit none

#if defined  IRIX_host || defined ALPHA_host || defined LINUX_host ||defined SUN_host
!     single precision calculation
      real,parameter :: eps   =1.e-15
      real,parameter :: eps2  =1.e-15
#else
!     double precision calculation
      real,parameter :: eps   =1.e-23
      real,parameter :: eps2  =1.e-20
#endif
      real :: K_m(is_pe-1:ie_pe+1,0:km,js_pe-1:je_pe+1) 
      real :: mxl(is_pe:ie_pe,km,js_pe:je_pe)  
      real :: shear(is_pe:ie_pe,km,js_pe:je_pe)
      real :: Nsqr(is_pe:ie_pe,km,js_pe:je_pe)  
      real :: wkx(is_pe:ie_pe,km), wky(is_pe:ie_pe,km) 
      real, dimension(is_pe:ie_pe,km) :: wi,ws,wd,wy,wx,wt
      real, dimension(is_pe:ie_pe)    :: ro1,ro2
      real :: w_surf(is_pe:ie_pe)   
      real,parameter :: zmlmin=1.e-8*100.
      real :: fxa, P_rt, Ri
      integer :: is,ie,js,je,i,j,k

!     -------------------------------------------------------------------------
!     limit the longitude indices
!     -------------------------------------------------------------------------
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
!
!     1. Mixing length
!     ----------------
!     1.1 Brunt-Vaisala frequency
!
      Nsqr=0.
      do j=js,je
       do k=1,km-1
        call model_dens(t(is,k  ,j,1,tau),t(is,k  ,j,2,tau),
     &                  ro1(is),k, ie-is+1
#ifdef partial_cell
     &                       ,ztp(is,k,j)
#endif
     &                       )
        call model_dens(t(is,k+1,j,1,tau),t(is,k+1,j,2,tau),
     &                  ro2(is),k, ie-is+1
#ifdef partial_cell
     &                       ,ztp(is,k,j)
#endif
     &                       )
        do i=is,ie
#ifndef partial_cell
         fxa = -grav/rho0*dzwr(k)
#endif
#ifdef partial_cell
         fxa = -grav/(rho0*dhwt(i,k,j))
#endif
         Nsqr(i,k,j) =fxa*(ro1(i)-ro2(i))*tmask(i,k+1,j)
        enddo
       enddo
       Nsqr(is:ie,km,j)=0.
      enddo

      do j=js,je
!
!     1.2 bouyancy length scale
!
       do k=1,km-1
        do i=is,ie
          mxl(i,k,j) = sqrt( 2.*eke(i,k,j,tau)/max(Nsqr(i,k,j),eps))
     &                                       *tmask(i,k+1,j)
          mxl(i,k,j) = max(mxl(i,k,j),zmlmin)
        enddo
       enddo
       mxl(is:ie,km,j) = zmlmin
!
!      1.3 physical limits for mixing length
!
       if (nmxl==0) then
!
!       bounded by the distance to surface/bottom
!
        do k=1,km-1
          do i=is,ie
#ifdef partial_cell
            fxa = zw(max(1,k-1)); if (k==1) fxa=0.
            fxa = fxa + dhwt(i,k,j)
            mxl(i,k,j) = min(fxa,mxl(i,k,j),htp(i,j)-fxa)
#else
            mxl(i,k,j) = min(zw(k),mxl(i,k,j),zw(kmt(i,j))-zw(k))
#endif
            mxl(i,k,j) = max(mxl(i,k,j),zmlmin)
          enddo
        enddo

       elseif (nmxl == 1) then
!
!       bounded by the vertical scale factor
!
        do k=1,km-1
          do i=is,ie
#ifdef partial_cell
            mxl(i,k,j) = min(mxl(i,k,j),dhwt(i,k,j))
#else
            mxl(i,k,j) = min(mxl(i,k,j),dzw(k))
#endif
          enddo
        enddo

       elseif (nmxl == 2) then
!
!      abs( d/dz(EXML) ) bounded by dzt
!
!      top to bottom
!
        do i=is,ie
#ifdef partial_cell
          mxl(i,1,j) = min(dht(i,1,j),mxl(i,1,j))
#else
          mxl(i,1,j) = min(zw(1),mxl(i,1,j))
#endif
        enddo
        do k=2,km-1
          do i=is,ie
#ifdef partial_cell
            mxl(i,k,j) = min(mxl(i,k-1,j)+dht(i,k,j),mxl(i,k,j))
#else
            mxl(i,k,j) = min(mxl(i,k-1,j)+dzt(k),mxl(i,k,j))
#endif
          enddo
        enddo
!
!       bottom to top
!
        do k=km-1,1,-1
          do i=is,ie
#ifdef partial_cell
            mxl(i,k,j) = min(mxl(i,k+1,j)+dht(i,k+1,j),mxl(i,k,j))
#else
            mxl(i,k,j) = min(mxl(i,k+1,j)+dzt(k+1),mxl(i,k,j))
#endif
          enddo
        enddo

       endif

      enddo ! j
!
!     2. vertical eddy diffusivity and viscosity
!     ----------------------------------------
!
      K_m=0.
      do j=js,je
       do k=1,km-1
        do i=is,ie
          fxa = C_kappa*mxl(i,k,j)*sqrt(eke(i,k,j,tau))
          K_m(i,k,j) = max(fxa,diff_cbt_back)*tmask(i,k+1,j)
        enddo
       enddo
!
!      set minimum mixing length at surface
!
       K_m(is:ie,0,j) = K_m(is:ie,1,j)
      enddo

      call border_exchg(K_m,km+1,1)
      call set_cyclic(K_m,km+1,1)
!
!     2.2 eddy viscosity: horizontal average
!
      do j=js,je
       do k=1,km-1
        do i=is,ie ! imt-1
          visc_cbu(i,k,j) = (K_m(i,k,j)+K_m(i+1,k,j)
     &                      +K_m(i,k,j+1)+K_m(i+1,k,j+1))/
     &  max(1.,tmask(i,k+1,j)+tmask(i,k+1,j+1)+
     &         tmask(i+1,k+1,j)+tmask(i+1,k+1,j+1) )
          visc_cbu(i,k,j) = max(visc_cbu_back,visc_cbu(i,k,j))
          visc_cbu(i,k,j) = min(visc_cbu(i,k,j),visc_cbu_cut)
     &                      *umask(i,k+1,j)
        enddo
       enddo
       visc_cbu(is:ie,km,j)= 0.
      enddo
!
!     2.3 eddy diffusivity: horizontal average
!
      do j=js,je
       do k=1,km-1
        do i=is,ie 
          diff_cbt(i,k,j) = ( K_m(i-1,k,j)+K_m(i,k,j)+K_m(i+1,k,j)
     &             + K_m(i-1,k,j+1)+K_m(i,k,j+1)+K_m(i+1,k,j+1)
     &             + K_m(i-1,k,j-1)+K_m(i,k,j-1)+K_m(i+1,k,j-1) )/
     &  max(1.,tmask(i-1,k+1,j)+tmask(i,k+1,j)+tmask(i+1,k+1,j)
     &     +tmask(i-1,k+1,j+1)+tmask(i,k+1,j+1)+tmask(i+1,k+1,j+1)
     &     +tmask(i-1,k+1,j-1)+tmask(i,k+1,j-1)+tmask(i+1,k+1,j-1) )
          diff_cbt(i,k,j) = max(diff_cbt_back,diff_cbt(i,k,j)) 
          diff_cbt(i,k,j) = min(diff_cbt(i,k,j),diff_cbt_cut)
     &                     *tmask(i,k+1,j)
        enddo
       enddo
       diff_cbt(is:ie,km,j)= 0.
      enddo
!
!     3. square of vertical shear of horizontal velocity at T-points
!     --------------------------------------------------------------
!
      do j=js,je
       do k=1,km
        do i=is,ie
          wkx(i,k) = 0.25*(u(i-1,k,j-1,1,tau) + u(i,k,j-1,1,tau)
     &                   + u(i-1,k,j  ,1,tau) + u(i,k,j  ,1,tau))
          wky(i,k) = 0.25*(u(i-1,k,j-1,2,tau) + u(i,k,j-1,2,tau)
     &                   + u(i-1,k,j  ,2,tau) + u(i,k,j  ,2,tau))
        enddo
       enddo
       do k=1,km-1
        do i=is,ie
#ifdef partial_cell
          shear(i,k,j) = ( (wkx(i,k)-wkx(i,k+1))/dhwt(i,k,j) )**2
     &                  +( (wky(i,k)-wky(i,k+1))/dhwt(i,k,j) )**2
#else
          shear(i,k,j) = ( (wkx(i,k)-wkx(i,k+1))*dzwr(k) )**2
     &                  +( (wky(i,k)-wky(i,k+1))*dzwr(k) )**2
#endif
     &                 *tmask(i,k+1,j)
        enddo
       enddo
      enddo
!
!     5.  multiplying Nsqr and VVC by the inverse of the Prandtl number.
!     ------------------------------------------------------------------
!     The Prandtl number is given by an empirical function of the
!     Richardson number and is bounded by 10.
!
      do j=js,je
       do k=1,km-1
        do i=is,ie
          Ri  = max(Nsqr(i,k,j),eps2)/(shear(i,k,j)+eps2)
          P_rt = 1./max(1.,5.*Ri)
          P_rt = max(0.1,P_rt)
          Nsqr(i,k,j)      = P_rt*Nsqr(i,k,j)
          diff_cbt(i,k,j)  = max( diff_cbt_back,P_rt*diff_cbt(i,k,j) )
     &                      *tmask(i,k+1,j)
        enddo
       enddo
      enddo
!
!     6. surface boundary condition on TKE
!     ------------------------------------
!
      do j=js,je 

       do i=is,ie
        fxa = ustar(i,j) *tke_surf_fac*tmask(i,k,j)
#ifdef partial_cell
        w_surf(i) = eke(i,1,j,taum1)+dht(i,1,j)
#else
        w_surf(i) = eke(i,1,j,taum1)+dzt(1)
#endif
     &     /(C_tke*max(diff_cbt_back ,K_m(i,1,j)) )*fxa
        w_surf(i) = max(w_surf(i),tke_min_surf)
       enddo
!
!      7. implicit solution for TKE
!      ----------------------------
!      computation from level 1 to km-1 (tke(0) is given above,
!      and tke(km)=0)
!      The coefficients of the tridiagonal matrix are in WI, WS,
!      and WD. The right hand side (explicit part) is in WY.
!      The result is given in WX.
!
       do k=1,km-1
        do i=is,ie 
         fxa = -0.5*c2dt*C_tke
        wi(i,k) =fxa*( K_m(i,k  ,j)+K_m(i,k-1,j)) 
#ifdef partial_cell
     &                /(dht(i,k,j)*dhwt(i,k,j)) *tmask(i,k+1,j)
#else
     &                /(dzt(k  )*dzw(k)) *tmask(i,k+1,j)
#endif
        ws(i,k) =fxa*( K_m(i,k+1,j)+K_m(i,k  ,j) )
#ifdef partial_cell
     &                /(dht(i,k+1,j)*dhwt(i,k,j)) *tmask(i,k+1,j)
#else
     &                /(dzt(k+1)*dzw(k)) *tmask(i,k+1,j)
#endif
        fxa=sqrt(eke(i,k,j,tau))/mxl(i,k,j)
        wd(i,k) = 1. - wi(i,k) - ws(i,k) +1.5*c2dt*C_eps*fxa
        wy(i,k) = eke(i,k,j,taum1) + 0.5*c2dt*C_eps*fxa*eke(i,k,j,tau)
     &                + c2dt*K_m(i,k,j)*( shear(i,k,j)-Nsqr(i,k,j) )
        enddo
       enddo
!
!      7.1 surface boundary conditions on TKE
!
       wy(is:ie,1) = wy(is:ie,1) - wi(is:ie,1)*w_surf(is:ie)
!
!      7.2 matrix inversion
!
!      Solve M*X = Y , where M is a tri-diagonal K*K matrix (K=km-1)
!
!      ( wd1 ws1  0   0   0  )( wx1 ) ( wy1 )
!      ( wi2 wd2 ws2  0   0  )( wx2 ) ( wy2 )
!      (  0  wi3 wd3 ws3  0  )( wx3 )=( wy3 )
!      (       ...           )( ... ) ( ... )
!      (  0   0   0  wiK wdK )( wxK ) ( wyK )
!
!      M is decomposed into the product of an upper and a lower
!      diagonal matrix.
!
       wt(is:ie,1) = wd(is:ie,1)
       do k=2,km-1
        wt(is:ie,k)= wd(is:ie,k)-wi(is:ie,k)*ws(is:ie,k-1)/wt(is:ie,k-1)
       enddo
       wd(is:ie,1) = wy(is:ie,1)
       do k=2,km-1
        wd(is:ie,k)= wy(is:ie,k)-wi(is:ie,k)/wt(is:ie,k-1)*wd(is:ie,k-1)
       enddo
       wx(is:ie,km-1) = wd(is:ie,km-1)/wt(is:ie,km-1)
       do k= km-2,1,-1
        wx(is:ie,k)= (wd(is:ie,k)-ws(is:ie,k)*wx(is:ie,k+1))/wt(is:ie,k)
       enddo
!
!      7.3 minimum value of TKE : tke_min
!
       do k=1,km-1
        do i=is,ie
          eke(i,k,j,taup1) = max(wx(i,k),tke_min)
        enddo
       enddo
       eke(is:ie,km,j,taup1) = 0.

      enddo ! j

      end subroutine tkemix

#include "options.inc"


      subroutine checks()
      use spflame_module
      implicit none
      integer :: is,ie,js,je,i,j,k
      real :: dxsq,dysq,h1,h2,clix,hx,dfdy
c
c-----------------------------------------------------------------------
c     some checks
c     SPFLAME version:   c.eden
c-----------------------------------------------------------------------
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      call barrier
      call sub_flush(6)

c
c     check consistency of the vertical mixing setup
c
      if (.not. enable_const_vert_mixing .and.
     &    .not. enable_cgh_vert_mixing   .and.
     &    .not. enable_tkemix ) then
        if (my_pe==0) 
     &   print*,' you have to specify one of the vertical mixing',
     &   ' schemes in the namelist input'
        call sub_flush(6)
        call halt_stop(' in checks')
      endif

      if (enable_const_vert_mixing .and.
     &    enable_cgh_vert_mixing) then
       if (my_pe==0) then
        print*,' specify either constant or CGH vertical mixing'
        print*,' not both '
       endif
       call sub_flush(6)
       call halt_stop(' in checks')
      endif

      if (enable_impl_convection .and.
     &    enable_expl_convection) then
       if (my_pe==0) then
        print*,' specify either implicit of exlicit convection'
        print*,' not both '
       endif
       call sub_flush(6)
       call halt_stop(' in checks')
      endif

      if (enable_impl_convection .and.
     &    .not. enable_const_vert_mixing) then
       if (my_pe==0) then
        print*,' implicit mixing depends on constant parameters'
        print*,' switch on enable_const_vert_mixing  '
       endif
       call sub_flush(6)
       call halt_stop(' in checks')
      endif

      if (enable_const_vert_mixing .and.
     &    enable_tkemix) then
       if (my_pe==0) then
        print*,' specify either constant or TKE vertical mixing'
        print*,' not both '
       endif
       call sub_flush(6)
       call halt_stop(' in checks')
      endif

      if (enable_cgh_vert_mixing .and.
     &    enable_tkemix) then
       if (my_pe==0) then
        print*,' specify either CGH or TKE vertical mixing'
        print*,' not both '
       endif
       call sub_flush(6)
       call halt_stop(' in checks')
      endif

      if (enable_ktmix .and. .not. enable_expl_convection) then
       if (my_pe==0) then
        print*,'Kraus Turner wind induced stirring depends on a',
     & ' stable stratification and thus on explicit convection'
        print*,' enable explicit convection scheme with KTmix '
       endif
       call sub_flush(6)
       call halt_stop(' in checks')
      endif
c
c     check consistency of the horizontal mixing setup
c
      if (enable_diffusion_isoneutral .and.
     &    enable_diffusion_isopycnic)  then
       if (my_pe==0) then
        print*,' specify either isoneutral mixing or isopynic mixing'
        print*,' not both '
       endif
       call sub_flush(6)
       call halt_stop(' in checks')
      endif

      if ((enable_diffusion_isoneutral .or.
     &     enable_diffusion_isopycnic)
     &     .and. .not. enable_implicit_vert_diff)  then
       if (my_pe==0) then
        print*,' use implicit vertical mixing with isoneutral mixing '
        print*,' or isopynic mixing (option enable_implicit_vert_diff) '
       endif
       call sub_flush(6)
       call halt_stop(' in checksp')
      endif

#ifdef partial_cell

      if (enable_diffusion_isopycnic) then
       if (my_pe==0) then
        print*,' partial cells with isopycnic mixing '
        print*,' not yet implemented, use isoneutral mixing'
       endif
       call sub_flush(6)
       call halt_stop(' in checks')
      endif

c      if (enable_bbl) then
c       if (my_pe==0) then
c        print*,' partial cells with Beckmann/Doescher BBL '
c        print*,' not yet implemented'
c       endif
c       call sub_flush(6)
c       call halt_stop(' in checks')
c      endif

#endif
c
c     Check some numerical criteria
c
      if (my_pe==0) print*,' Checking Killworths topographic critrium'

      do j=js,je
        do i=is,ie
         dysq=dyt(j)**2

         if ((kmt_big(i+1,j-1)/=0).and.(kmt_big(i+1,j)/=0) ) then 

          dxsq = (dxt(i)*cst(j))**2
          clix = am*dt/dxsq
          h1   = zt(kmt_big(i+1,j-1))
          h2   = zt(kmt_big(i+1,j) )
          hx   = (8.0*h1*h2/(h1+h2)**2+dxsq/dysq)/(4.0 + dxsq/dysq)

          if (clix .ge. hx .and. enable_friction_harmonic ) then
           print*,' criterium exceeded at i=',i,' j=',j,
     &             'kmt(i,j)=',kmt_big(i,j),' h=',zt(kmt_big(i,j)),' cm'
           print*,' clix=',clix,' hx=',hx
           call sub_flush(6)
           call halt_stop(' in checks')
          endif
         endif
        enddo
      enddo

      if (my_pe==0) print*,' ok'

      call barrier; call sub_flush(6)

c       what happens for biha ??
c
      if (my_pe==0) print*,' Checking horizontal diffusive criteria'

      do j=js,je
        do i=is,ie
         hx=(ah+1.e-5)  ! if ah is zero
     &                         *ah_scale(i,j)
         if (enable_diffusion_harmonic .and. 
     &         ( dt*tmask(i,1,j) > (dxt(i)*cst(j))**2/(2.*hx) ) ) then
           print*,' criterium exceeded for T grid at i=',i,' j=',j
           print*,' dt = ',dt
           print*,' dx^2/2/ah=', (dxt(i)*cst(j))**2/(2.*hx) 
           call sub_flush(6)
           call halt_stop(' in checks')
         endif
         hx=(am+1.e-5)*am_scale(i,j)
         if (enable_friction_harmonic .and. 
     &         ( dt*umask(i,1,j) > (dxu(i)*csu(j))**2/(2.*hx) ) ) then
           print*,' criterium exceeded for U grid at i=',i,' j=',j
           print*,' dt = ',dt
           print*,' dx^2/2/am=', (dxu(i)*csu(j))**2/(2.*hx) ,hx
           call sub_flush(6)
           call halt_stop(' in chekcs')
         endif
        enddo
      enddo
      if (my_pe==0) print*,' ok'

      call barrier; call sub_flush(6)


#ifdef notdef
      if (enable_friction_harmonic .and. 
     &   .not. enable_friction_biharmonic .and. 
     &   .not. enable_rotated_grid) then
      if (my_pe==0) print*,' Checking Munck criteria'
c
c   what happens if am=0?? and for biha?
c   and for a rotated grid ?
c
      do j=js,je
        do i=is,ie
         hx=(am+1e-5)*am_scale(i,j)
         dfdy   = (2.*omega*csu(j)/radius+1e-15)
         if  ( (hx/dfdy)**(1./3.) <= 0.5*dxu(i)*csu(j) ) then
          print*,' criterium exceeded for dxu at i=',i,' j=',j
          print*,' viscous boundary layer: ',  (hx/dfdy)**(1./3.) 
          print*,' dxu = ', 0.5*dxu(i)*csu(j) 
           call sub_flush(6)
          call halt_stop(' in checks'   )
         endif
         if  ( (hx/dfdy)**(1./3.) <= 0.5*dyu(j) ) then
          print*,' criterium exceeded for dyu at i=',i,' j=',j
          print*,' viscous boundary layer: ',  (hx/dfdy)**(1./3.) 
          print*,' dyu = ', 0.5*dyu(j) 
           call sub_flush(6)
          call halt_stop(' in checks'   )
         endif
c         print*, i,j, (hx/dfdy)**(1./3.) , 0.5*dyu(j) ,hx,dfdy
        enddo
      enddo
      if (my_pe==0) print*,' ok'
      elseif (my_pe==0) then
         print*,' do not checking Munck criteria '
      endif
#endif

      call barrier; call sub_flush(6)

      if (my_pe==0) then 
       print*,' Checking vertical diffusive criteria'

       do k=1,km

        if (.not. enable_implicit_vert_fric) then
         hx=kappa_m
         if (enable_cgh_vert_mixing .and. 
     &        enable_cgh_vert_momentum_mixing ) hx=max(hx,visc_cbu_cut)
         if (enable_tkemix)                      hx=max(hx,visc_cbu_cut)
         if ((dt*hx)/dzt(k)**2 >= .25) then
          print*,' momentum criterium exceeded at k=',k
          print*,' use option enable_implicit_vert_fric'
          call halt_stop(' in checks'   )
         endif
        endif

        if (.not. enable_implicit_vert_diff) then
         hx=kappa_h
         if (enable_cgh_vert_mixing ) hx=max(hx,diff_cbt_cut)
         if (enable_impl_convection) hx=max(hx,diff_cbt_cut)
         if (enable_cgh_vert_mixing .and. 
     &       enable_cgh_impl_convection ) hx=max(hx,1.0e6)
         if (enable_tkemix)       hx = max(hx,diff_cbt_cut)
         if ((dt*hx)/dzt(k)**2 >= .25) then
          print*,' tracer criterium exceeded at k=',k
          print*,' use option enable_implicit_vert_diff'
          call halt_stop(' in checks'   )
         endif
        endif

       enddo
       print*,' ok'
      endif

      call barrier; call sub_flush(6)

      if (enable_obc_south.or.enable_obc_north.or.
     &    enable_obc_west.or. enable_obc_east) then
       if (my_pe==0) then 
        print*,' Checking vertical diffusive criteria for obc'

        do k=1,km
         hx=kappa_h
         if ((dt*hx)/dzt(k)**2 >= .25) then
          print*,' tracer criterium exceeded at k=',k
          print*,' change kappa_h or time step'
          call halt_stop(' in checks'   )
         endif
        enddo

        if (kappa_h == 0.) then
          print*,' kappa_h is zero for open boundaries'
          print*,' this will not work'
          call halt_stop(' in checks'   )
        endif

        print*,' ok'
       endif
      endif
c
      print*,' pe # ',my_pe,' checks done '
      call sub_flush(6)

      end subroutine checks

#include "options.inc"

c
c=======================================================================
c     convert binary output of averaged quantities 
c     to NetCDF format
c     real variables are 8 or 4 bytes long set by
c=======================================================================
c
c#define real_8
c
c     use less memory 
#define low_memory
c
c    unfold domain
#define unfold

      module kind_mod
#ifdef real_8
      integer, parameter::  r_knd  = selected_real_kind(13)
#else
      integer, parameter::  r_knd  = selected_real_kind(6)
#endif
      end module kind_mod

      module cv_ave_module
      use kind_mod
      integer :: imt,jmt,km,nt,imtf

      real (kind=r_knd),allocatable,dimension(:,:,:,:):: mean_u,mean_t
      real (kind=r_knd),allocatable,dimension(:,:)    :: mean_psi
      real (kind=r_knd), allocatable, dimension(:,:,:):: mean_stf
      real (kind=r_knd), allocatable, dimension(:,:,:):: mean_smf
      real (kind=r_knd), allocatable, dimension(:) :: xt,yt,xu,yu,zt,zw
      real (kind=r_knd), allocatable, dimension(:) :: csu
      real (kind=r_knd), allocatable, dimension(:,:,:):: mean_ka
      real (kind=r_knd), allocatable, dimension(:,:,:,:):: mean_ugm
      real (kind=r_knd), allocatable, dimension(:,:):: mean_pco2
      real (kind=r_knd), allocatable, dimension(:,:):: mean_dco2
      real (kind=r_knd), allocatable, dimension(:,:):: mean_o2
      real (kind=r_knd) :: mean_pco2_air
      logical :: found_kappa = .false.
      logical :: found_gm    = .false.
      logical :: found_pco2  = .false.
      logical :: found_o2    = .false.

      integer :: counter
      integer, allocatable, dimension(:,:)     :: kmt,kmu
      logical :: enable_monthly_averages = .false.
      logical :: enable_annual_averages = .false.
      logical :: enable_daily_averages = .false.
      logical :: enable_seasonal_averages = .false.
      logical :: enable_freesurf = .false.
      real, parameter :: pi       = 
     &        3.14159265358979323846264338327950588
      end module cv_ave_module



      program cv_ave
      use cv_ave_module
      implicit none
      character (len=80) :: infile,outfile
      integer :: ierr,i
      character (len=9) :: c9
      character (len=1) :: c1
      character (len=2) :: c2
      character (len=4) :: c4
      integer :: year,month,day,domain

      print*,' Converting averaged quantities written by SPFLAME ',
     &       ' to NetCDF file '

      call get_commandline_arg(1,infile,ierr)
      if (ierr/=0) goto 99
      print*,' reading from file ',infile(1:len_trim(infile))

      read(infile,'(a9,i3,a2,i4,a1,i2,a1,i2,a4)') 
     &            c9,domain,c2,year,c1,month,c1,day,c4
      write(outfile,'("averages_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            domain,year,month,day
      do i=1,len_trim(outfile);
        if (outfile(i:i)==' ')outfile(i:i)='0';
      enddo
      print*,' sub domain = ',domain
      print*,' year/month/day  = ',year,month,day
      print*,' writing to file ',outfile
#ifdef unfold
      print*,' unfolding file using kmt/grid.ufl'
#endif
      call read_averages(infile)
      call write_averages(infile,outfile,year,month,day,domain)
      stop

 99   print*,' program needs command line parameter'
      print*,' 1. input binary file name (written by spflame)'
      end program cv_ave


      subroutine read_averages(infile)
      use cv_ave_module
      implicit none
      character (len=*) :: infile
      character (len=3) :: ssh
      integer :: i,j,k,io=10,n,iok=20,iog=30
      character (len=80) :: ident
      logical :: ok
      real (kind=r_knd) :: xx

      open(io,file=infile,form='unformatted')
      read(io) imtf,jmt,km,nt
      imt=imtf

#ifdef unfold
      print*,' reading from file kmt.ufl and grid.ufl'
      open(iok,file='kmt.ufl',form='unformatted')
      read (iok)
      read (iok) 
      read (iok) imt
      print*,' folded imt = ',imtf,' found in kmt.ufl imt = ',imt
      open(iog,file='grid.ufl',form='unformatted')
      read (iog)
      read (iog) imt
      print*,' folded imt = ',imtf,' found in grid.ufl imt = ',imt
#endif


      print*,' imt=',imt,' jmt=',jmt,' km=',km,' nt=',nt
#ifdef low_memory
      allocate( mean_t(imt,1,jmt,nt) )
      allocate( mean_u(imt,1,jmt,2) )
#else
      allocate( mean_t(imt,km,jmt,nt) )
      allocate( mean_u(imt,km,jmt,2) )
#endif
      allocate( mean_psi(imt,jmt) )
      allocate( mean_stf(imt,jmt,nt) )
      allocate( mean_smf(imt,jmt,2) )
      allocate( xt(imt),yt(jmt),xu(imt),yu(jmt),zt(km),zw(km),csu(jmt))
      allocate( kmt(imt,jmt),kmu(imt,jmt) ); kmu=0

      read(io) xt(1:imtf),yt,xu(1:imtf),yu,zt,zw
#ifdef unfold
c   overwrite with full grid
      read (iog) (xx,i=1,(imt+jmt)*2+km*2+1),xt, xu
      close(iog)
#endif
      read(io) counter
      print*,' counter for averages=',counter
      read(io) enable_daily_averages
      read(io) enable_monthly_averages
      read(io) enable_seasonal_averages
      read(io) enable_annual_averages
      read(io) kmt(1:imtf,:)

#ifdef unfold
c   overwrite with full topography
      read (iok) 
      read (iok) kmt
      close(iok)
#endif

      read(io) mean_psi(1:imtf,:),ssh
#ifdef unfold
      mean_psi(imtf-1:imt,:)= mean_psi(1:imt-imtf+2,:)
#endif
      if (ssh == 'ssh') then
        enable_freesurf=.true.
        print*,'found sea surface height in file'
      else
        enable_freesurf=.false.
        print*,'found streamfunction in file'
      endif
      do n=1,2
       read(io) mean_smf(1:imtf,:,n)
#ifdef unfold
       mean_smf(imtf-1:imt,:,n)= mean_smf(1:imt-imtf+2,:,n)
#endif
       do k=1,km
#ifdef low_memory
         read(io) 
#else
         read(io) mean_u(1:imtf,k,:,n)
#ifdef unfold
         mean_u(imtf-1:imt,k,:,n)= mean_u(1:imt-imtf+2,k,:,n)
#endif
#endif
       enddo
      enddo
      do n=1,nt
       read(io) mean_stf(1:imtf,:,n)
#ifdef unfold
       mean_stf(imtf-1:imt,:,n)= mean_stf(1:imt-imtf+2,:,n)
#endif
       do k=1,km
#ifdef low_memory
         read(io) 
#else
         read(io) mean_t(1:imtf,k,:,n)
#ifdef unfold
         mean_t(imtf-1:imt,k,:,n)= mean_t(1:imt-imtf+2,k,:,n)
#endif
#endif
       enddo
      enddo

 10    ident=''; ok = .true.
       read(io,end=20,err=50) ident
       goto 30
 20    ok = .false.
 30    continue

       if (ident(1:8) == 'diff_cbt') then
        print*, ' found vertical diffusivity in file'
        found_kappa = .true.
        allocate(mean_ka(imt,km,jmt) )
        do k=1,km
          read(io) mean_ka(1:imtf,k,:)
#ifdef unfold
          mean_ka(imtf-1:imt,k,:)= mean_ka(1:imt-imtf+2,k,:)
#endif
        enddo
       elseif (ident(1:4) == 'u_gm') then
        print*, ' found GM bolus velocities in file'
        found_gm = .true.
        allocate(mean_ugm(imt,km,jmt,3) )
        do k=1,km
          read(io) mean_ugm(1:imtf,k,:,1)
          read(io) mean_ugm(1:imtf,k,:,2)
          read(io) mean_ugm(1:imtf,k,:,3)
#ifdef unfold
          mean_ugm(imtf-1:imt,k,:,:)= mean_ugm(1:imt-imtf+2,k,:,:)
#endif
        enddo
       elseif (ident(1:10) == 'pco2_water' ) then
        found_pco2=.true.
        print*,' found sea surface CO2 in file'
        allocate(mean_pco2(imt,jmt) )
        allocate(mean_dco2(imt,jmt) )
        read(io) mean_pco2(1:imtf,:)
        read(io) mean_dco2(1:imtf,:)
#ifdef unfold
          mean_pco2(imtf-1:imt,:)= mean_pco2(1:imt-imtf+2,:)
          mean_dco2(imtf-1:imt,:)= mean_dco2(1:imt-imtf+2,:)
#endif
        read(io) mean_pco2_air
       elseif (ident(1:6) == 'o2_sat' ) then
        found_o2=.true.
        print*,' found sea surface O2 in file'
        allocate(mean_o2(imt,jmt) )
        read(io) mean_o2(1:imtf,:)
#ifdef unfold
          mean_o2(imtf-1:imt,:)= mean_o2(1:imt-imtf+2,:)
#endif
       else
         print*,' cannot read ',ident,' in file '
       endif
       if (ok) goto 10  ! read next item til end of file

      close(io)
c
c   construct other variables
c
      do j=1,jmt
       csu(j)   = cos(yu(j)/180*pi)
      enddo
      do j=1,jmt-1
        do i=1,imt-1
           kmu(i,j) = min (kmt(i,j), kmt(i+1,j), 
     &                     kmt(i,j+1), kmt(i+1,j+1))
        enddo
      enddo
      return
 50    print*,' unexpected end of file '
      end subroutine read_averages


      subroutine write_averages(infile,outfile,year,month,day,domain)
      use cv_ave_module
      implicit none
      character (len=80) :: infile,outfile,name,unit
      integer :: year,month,day,domain
#include "netcdf.inc"
      integer ncid,iret,i,j,k,dims(4),start(4),count(4)
      real (kind=r_knd) :: spval=-9.9e12, tt

      integer :: lon_tdim,lon_tid
      integer :: lon_udim,lon_uid
      integer :: lat_tdim,lat_tid
      integer :: lat_udim,lat_uid
      integer :: depth_tdim,depth_tid
      integer :: depth_wdim,depth_wid
      integer :: itimedim,itimeid
      integer :: uid,vid,trid(nt),n,len,diff_cbtid
      integer :: psiid,tauxid, tauyid,strid(nt)
      integer :: ugm_id,vgm_id,wgm_id,pco2_id,o2_id,dco2_id,airco2_id,kk
      integer :: 
     &days_in_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)

      tt=(year-1900)*365 + day
      do n=1,month-1
       tt=tt+days_in_month(n)
      enddo

      if (enable_daily_averages) then
        tt=tt-0.5
      elseif (enable_monthly_averages) then
        tt=tt-days_in_month(month)/2.
      elseif (enable_seasonal_averages) then
        tt=tt-(days_in_month(month)    ! month should be always ge 3
     &        +days_in_month(month-1)
     &        +days_in_month(month-2))/2.
      elseif (enable_annual_averages) then
        tt=tt-365./2.
      endif

      print*,' writing to file ',outfile

      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c       dimensions
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', 1, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
      dims(1)  = Lon_udim
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_wdim
      depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c     attributes of the grid
      name = 'Longitude on T grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on U grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
      name = 'Depth of W Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
      call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &'31-DEC-1899 00:00:00', iret)
c     variables
      dims=(/lon_udim,lat_udim,depth_tdim,itimedim/)
      uid=ncvdef (ncid,'u', NCFLOAT,4,dims,iret)
      vid=ncvdef (ncid,'v', NCFLOAT,4,dims,iret)
      do n=1,nt
         name='temp';if (n==2) name='salt'
         if (n>2) then
          write(name,'("tracer_",i2)') n
          call replace_space_zero(name)
         endif
         dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
         trid(n)=ncvdef (ncid,name, NCFLOAT,4,dims,iret)
         name='heat_fl';if (n==2) name='salt_fl'
         if (n>2) then
          write(name,'("tr",i2,"_flux")') n
          call replace_space_zero(name)
         endif
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         strid(n)=ncvdef (ncid,name, NCFLOAT,3,dims,iret)
      enddo
      dims=(/lon_udim,lat_udim,itimedim,1/)
      tauxid=ncvdef (ncid,'taux', NCFLOAT,3,dims,iret)
      tauyid=ncvdef (ncid,'tauy', NCFLOAT,3,dims,iret)
      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      if (enable_freesurf) then
       psiid=ncvdef (ncid,'ssh', NCFLOAT,3,dims,iret)
      else
       psiid=ncvdef (ncid,'psi', NCFLOAT,3,dims,iret)
      endif
      if (found_kappa) then
       dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
       diff_cbtid=ncvdef (ncid,'diff_cbt', NCFLOAT,4,dims,iret)
      endif
      if (found_gm) then
       dims=(/lon_udim,lat_tdim,depth_tdim,itimedim/)
       ugm_id=ncvdef (ncid,'u_gm', NCFLOAT,4,dims,iret)
       dims=(/lon_tdim,lat_udim,depth_tdim,itimedim/)
       vgm_id=ncvdef (ncid,'v_gm', NCFLOAT,4,dims,iret)
       dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
       wgm_id=ncvdef (ncid,'w_gm', NCFLOAT,4,dims,iret)
      endif
      if (found_pco2) then
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         pco2_id=ncvdef (ncid,'pco2_water', NCFLOAT,3,dims,iret)
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         dco2_id=ncvdef (ncid,'dco2', NCFLOAT,3,dims,iret)
         dims=(/itimedim,1,1,1/)
         airco2_id=ncvdef (ncid,'pco2_air', NCFLOAT,1,dims,iret)
      endif
      if (found_o2) then
       dims=(/lon_tdim,lat_tdim,itimedim,1/)
       o2_id=ncvdef (ncid,'o2_sat', NCFLOAT,3,dims,iret)
      endif
c     attributes of variables
      name = 'Zonal velocity'; unit = 'm/s'
      call dvcdf_here(ncid,uid,name,24,unit,16,spval)
      name = 'Meridional velocity'; unit = 'm/s'
      call dvcdf_here(ncid,vid,name,24,unit,16,spval)
      do n=1,nt
         name = 'Potential temperature'; unit = 'deg C'
         if (n==2) then
          name = 'Salinity'; unit = 'psu'
         elseif (n>2) then
          write(name,'("Passive tracer ",i2)') n
          unit = '?'
         endif
         call dvcdf_here(ncid,trid(n),name,len_trim(name),
     &              unit,len_trim(unit),spval)
         name = 'Surface heat flux'; unit = 'W/m^2'
         if (n==2) then
          name = 'Surface salt flux'; unit = 'kg/m^2/s'
         elseif (n>2) then
          write(name,'("Surface flux passive tracer ",i2)') n
          unit = '?'
         endif
         call dvcdf_here(ncid,strid(n),name,len_trim(name),
     &              unit,len_trim(unit),spval)
      enddo
      if (enable_freesurf) then
       name = 'Sea Surface height'; unit = 'm'
      else
       name = 'Barotropic streamfunction'; unit = 'Sv'
      endif
      call dvcdf_here(ncid,psiid,name,24,unit,16,spval)
      name = 'Zonal wind stress'; unit = 'N/m^2'
      call dvcdf_here(ncid,tauxid,name,24,unit,16,spval)
      name = 'Meridional wind stress'; unit = 'N/m^2'
      call dvcdf_here(ncid,tauyid,name,24,unit,16,spval)

      if (found_kappa) then
       name = 'Vertical diffusivity'; unit = 'm^2/s'
       call dvcdf_here(ncid,diff_cbtid,name,24,unit,16,spval)
      endif
      if (found_gm) then
       name = 'Zonal bolus velocity'; unit = 'm/s'
       call dvcdf_here(ncid,ugm_id,name,24,unit,16,spval)
       name = 'Meridional bolus velocity'; unit = 'm/s'
       call dvcdf_here(ncid,vgm_id,name,24,unit,16,spval)
       name = 'Vertical bolus velocity'; unit = 'm/s'
       call dvcdf_here(ncid,wgm_id,name,24,unit,16,spval)
      endif
      if (found_pco2) then
         name = 'Sea surface CO2 partial pressure'; unit = 'ppmv'
         call dvcdf_here(ncid,pco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
         name = 'Air/Sea difference in CO2 concentration'
          unit = 'mol/m^3'
         call dvcdf_here(ncid,dco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
         name = 'Atmospheric CO2 partial pressure'; unit = 'ppmv'
         call dvcdf_here(ncid,airco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
      endif
      if (found_o2) then
         name = 'Sea surface O2 saturation concentration'; 
         unit = 'mol/m^3'
         call dvcdf_here(ncid,o2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
      endif
      iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        if (iret.ne.0) print*,nf_strerror(iret)

      write( name,'("SFLAME sub domain # ",i3)') domain
      if (enable_daily_averages) 
     &   name=name(1:len_trim(name))//' daily means'
      if (enable_monthly_averages) 
     &   name=name(1:len_trim(name))//' monthly means'
      if (enable_seasonal_averages) 
     &   name=name(1:len_trim(name))//' seasonal means'
      if (enable_annual_averages) 
     &   name=name(1:len_trim(name))//' annual means'
      len=len_trim(name)
      iret= nf_put_att_text(ncid,nf_global,'history',len,name)

      call ncendf(ncid, iret)

      zt=zt/100.; zw=zw/100.

#ifdef real_8
      iret= nf_put_vara_double (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_double (ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_double (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_double (ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_double (ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_double (ncid,depth_wid,1,km,zw)
      iret= nf_put_vara_double (ncid,itimeid,1,1,tt)
#else
      iret= nf_put_vara_real (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_real (ncid,lon_uid,1,imt,xu)
      iret= nf_put_vara_real (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_real (ncid,lat_uid,1,jmt,yu)
      iret= nf_put_vara_real (ncid,depth_tid,1,km,zt)
      iret= nf_put_vara_real (ncid,depth_wid,1,km,zw)
      iret= nf_put_vara_real (ncid,itimeid,1,1,tt)
#endif


c     convert to SI units and divide by N
#ifdef low_memory
#else
      mean_u=mean_u/100.   /counter
      mean_t = mean_t/counter
      mean_t(:,:,:,2)=mean_t(:,:,:,2)*1000.+35.
#endif
      mean_stf=mean_stf/counter
      mean_stf(:,:,1)=mean_stf(:,:,1)*41868.
      mean_stf(:,:,2)=mean_stf(:,:,2)*10. 

      mean_smf=mean_smf/10. /counter
      if (enable_freesurf) then
       mean_psi=mean_psi/100. /counter
      else
       mean_psi=mean_psi/1.e12 /counter
      endif
c     apply land mask and write to file
      do k=1,km
#ifdef low_memory
         call read_tsuv(infile,k)
         kk=1
      mean_u=mean_u/100.   /counter
      mean_t = mean_t/counter
      mean_t(:,:,:,2)=mean_t(:,:,:,2)*1000.+35.
#else
         kk=k
#endif
         do n=1,nt
          where( kmt <k ) mean_t(:,kk,:,n) = spval
         enddo
         do n=1,2
          where( kmu <k ) mean_u(:,kk,:,n) = spval
         enddo
         start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
         iret=nf_put_vara_double(ncid,uid,start,count,mean_u(:,kk,:,1))
         iret=nf_put_vara_double(ncid,vid,start,count,mean_u(:,kk,:,2))
#else
         iret= nf_put_vara_real (ncid,uid,start,count,mean_u(:,kk,:,1))
         iret= nf_put_vara_real (ncid,vid,start,count,mean_u(:,kk,:,2))
#endif
         do n=1,nt
#ifdef real_8
          iret=nf_put_vara_double(ncid,trid(n),
     &                          start,count,mean_t(:,kk,:,n))
#else
          iret=nf_put_vara_real(ncid,trid(n),
     &                          start,count,mean_t(:,kk,:,n))
#endif
         enddo
      enddo
      where( kmt == 0) mean_psi = spval
      do n=1,nt
       where( kmt == 0) mean_stf(:,:,n) = spval
      enddo
      do n=1,2
       where( kmu == 0) mean_smf(:,:,n) = spval
      enddo
      start=(/1,1,1,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
      iret= nf_put_vara_double (ncid,psiid,start,count,mean_psi)
#else
      iret= nf_put_vara_real (ncid,psiid,start,count,mean_psi)
#endif
      do n=1,nt
#ifdef real_8
      iret=nf_put_vara_double(ncid,strid(n),start,count,mean_stf(:,:,n))
#else
       iret=nf_put_vara_real(ncid,strid(n),start,count,mean_stf(:,:,n))
#endif
      enddo
#ifdef real_8
      iret= nf_put_vara_double (ncid,tauxid,start,count,mean_smf(:,:,1))
      iret= nf_put_vara_double (ncid,tauyid,start,count,mean_smf(:,:,2))
#else
      iret= nf_put_vara_real (ncid,tauxid,start,count,mean_smf(:,:,1))
      iret= nf_put_vara_real (ncid,tauyid,start,count,mean_smf(:,:,2))
#endif
      if (found_kappa) then
       mean_ka=mean_ka/1.0e4 /counter
       do k=1,km
        where( kmt <k ) mean_ka(:,k,:) = spval
        start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
         iret= nf_put_vara_double (ncid,
     &                 diff_cbtid,start,count,mean_ka(:,k,:))
#else
         iret= nf_put_vara_real (ncid,
     &                 diff_cbtid,start,count,mean_ka(:,k,:))
#endif
       enddo
      endif
      if (found_gm) then
       mean_ugm=mean_ugm/100.0/counter
       do k=1,km
        where( kmt <k ) mean_ugm(:,k,:,1) = spval
        where( kmt <k ) mean_ugm(:,k,:,2) = spval
        where( kmt <k ) mean_ugm(:,k,:,3) = spval
        start=(/1,1,k,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
        iret= nf_put_vara_double(ncid,
     &           ugm_id,start,count,mean_ugm(:,k,:,1))
        iret= nf_put_vara_double(ncid,
     &           vgm_id,start,count,mean_ugm(:,k,:,2))
        iret= nf_put_vara_double(ncid,
     &           wgm_id,start,count,mean_ugm(:,k,:,3))
#else
        iret= nf_put_vara_real(ncid,
     &           ugm_id,start,count,mean_ugm(:,k,:,1))
        iret= nf_put_vara_real(ncid,
     &           vgm_id,start,count,mean_ugm(:,k,:,2))
        iret= nf_put_vara_real(ncid,
     &           wgm_id,start,count,mean_ugm(:,k,:,3))
#endif
       enddo        
      endif
      if (found_pco2) then
        mean_pco2=mean_pco2/counter
        mean_dco2=mean_dco2/counter
        mean_pco2_air=mean_pco2_air/counter
        where(kmt==0.) mean_pco2 = spval
        where(kmt==0.) mean_dco2 = spval
        start=(/1,1,1,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
        iret= nf_put_vara_double(ncid,pco2_id,start,count,mean_pco2)
        iret= nf_put_vara_double(ncid,dco2_id,start,count,mean_dco2)
        iret= nf_put_vara_double(ncid,airco2_id,1,1,mean_pco2_air )
#else
        iret= nf_put_vara_real(ncid,pco2_id,start,count,mean_pco2)
        iret= nf_put_vara_real(ncid,dco2_id,start,count,mean_dco2)
        iret= nf_put_vara_real(ncid,airco2_id,1,1,mean_pco2_air )
#endif
      endif
      if (found_pco2) then
        mean_o2=mean_o2/counter
        where(kmt==0.) mean_o2 = spval
        start=(/1,1,1,1/); count=(/imt,jmt,1,1/)
#ifdef real_8
        iret= nf_put_vara_double(ncid,o2_id,start,count,mean_o2)
#else
        iret= nf_put_vara_real(ncid,o2_id,start,count,mean_o2)
#endif
      endif
      call ncclos (ncid, iret)
      end subroutine write_averages







      subroutine read_tsuv(infile,kk)
      use cv_ave_module
      implicit none
      character (len=*) :: infile
      character (len=3) :: ssh
      integer :: i,j,k,io,n,kk
      character (len=80) :: ident
      logical :: ok

      io=10
      print*,'reading from file ',infile(1:len_trim(infile)),
     &      ' UVTS at level ',kk
      open(io,file=infile,form='unformatted')
      read(io) !i,j,k,n
      read(io) !xt,yt,xu,yu,zt,zw
      read(io) !counter
      read(io) !enable_daily_averages
      read(io) !enable_monthly_averages
      read(io) !enable_seasonal_averages
      read(io) !enable_annual_averages
      read(io) !kmt
      read(io) !mean_psi,ssh
      do n=1,2
       read(io) !mean_smf(:,:,n)
       do k=1,kk-1
         read(io) 
       enddo
       read(io) mean_u(1:imtf,1,:,n)
#ifdef unfold
       mean_u(imtf-1:imt,1,:,n)= mean_u(1:imt-imtf+2,1,:,n)
#endif
       do k=kk+1,km
         read(io) 
       enddo
      enddo
      do n=1,nt
       read(io) !mean_stf(:,:,n)
       do k=1,kk-1
         read(io) !mean_t(:,k,:,n)
       enddo
       read(io) mean_t(1:imtf,1,:,n)
#ifdef unfold
       mean_t(imtf-1:imt,1,:,n)= mean_t(1:imt-imtf+2,1,:,n)
#endif
       do k=kk+1,km
         read(io) 
       enddo
      enddo

      close(io)
      end subroutine read_tsuv












      subroutine dvcdf_here(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      use kind_mod
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character*(*) name, unit
      real (kind=r_knd):: spval
#include "netcdf.inc"
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
#ifdef real_8
      iret=nf_put_att_double(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_double(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#else
      iret=nf_put_att_real(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_real(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#endif
c        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf_here


      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"


      program nc_ufo
c=======================================================================
c     unfold netcdf variable 
c=======================================================================
      implicit none
      real,parameter :: version = 0.1
      integer :: ncin,varin,dimid(10),count(10),start(10)
      integer :: ncout,varout,imtf,imt,jmt,jmtf,km,itm
      integer :: nr_com,n,ierr,iok,i,j,ndims
      integer, allocatable :: kmt(:,:),kmu(:,:)
      character (len=80) :: fname,varname,infile,outfile
#include "netcdf.inc"
      integer :: iret,xtype,k,xid
      real, allocatable :: bufin(:,:,:,:),bufout(:,:,:,:)
      real, allocatable :: xt(:),xu(:)
      logical :: ugrid = .false.
      real :: spval

      print'(" This is nc_ufo.x :: version ",f5.3)',version
c  read command line input
      call get_commandline_argnr(nr_com)
      if (nr_com<3) goto 100

      call get_commandline_arg(1,infile,ierr)
      print*,' reading from file ',infile(1:len_trim(infile))
      call get_commandline_arg(2,outfile,ierr)
      print*,' writing to file ',outfile(1:len_trim(outfile))
      call get_commandline_arg(3,varname,ierr)
      print*,' variable ',varname(1:len_trim(varname))
      if (nr_com>3) then
        call get_commandline_arg(4,fname,ierr)
        if (fname == 'ugrid' ) ugrid=.true.
      endif
      if (ugrid) print*,' variable is on ugrid '
       
c   open KMT mask file
      print*,' reading from file kmt.ufl '
      iok=10
      open(iok,file='kmt.ufl',form='unformatted',status='old')
      read (iok); read (iok); read (iok) imt,jmt,km
      print*,' found in kmt.ufl imt=',imt,' jmt=',jmt,' km=',km
      allocate( kmt(imt,jmt), kmu(imt,jmt) )
      read (iok) ; read (iok) kmt
      close(iok)
      print*,' reading from file grid.ufl '
      open(iok,file='grid.ufl',form='unformatted',status='old')
      read (iok)
      read (iok) i,j,k
      if (i/=imt.or.j/=jmt.or.k/=km) then
        print*,' grid.ufl does not match kmt.ufl '
        stop
      endif
      allocate(xt(imt),xu(imt) )
      read (iok) (spval,i=1,(imt+jmt)*2+km*2+1),xt, xu
      close(iok)
      kmu=0.
      do j=1,jmt-1
        do i=1,imt-1
           kmu(i,j) = min (kmt(i,j), kmt(i+1,j), 
     &                     kmt(i,j+1), kmt(i+1,j+1))
        enddo
      enddo
      if (ugrid) then 
        kmt=kmu
        xt=xu
      endif

c   open input files and search for variable
      iret=nf_open(infile,NF_NOWRITE,ncin)
      if (iret /=0 ) goto 110
      iret=nf_inq_varid(ncin,varname,varin)
      if (iret /=0 ) goto 120

c   create output file
      ncout = nccre (outfile, NCNOCLOB, iret)
      if (iret /=0 ) goto 110
      iret=nf_set_fill(ncout, NF_NOFILL, iret)
      call copy_file_attributes(ncin,ncout)
c   define unfolded Longitude
      iret=nf_inq_vardimid(ncin,varin,dimid)
      iret=nf_inq_dimlen(ncin,dimid(1),imtf)
      iret=nf_inq_dimlen(ncin,dimid(2),jmtf)
      print*,' found imtf = ',imtf
      if (imt <= imtf ) then
       print*,' variable already unfolded or wrong kmt mask'
       stop
      endif
      if (jmt /= jmtf) then
       print*,' wrong kmt mask'
       stop
      endif
      iret=NF_INQ_DIMNAME (NCin, dimid(1), fname)
      call copy_dimension(ncin,ncout,fname,.true.,imt)
c   copy rest of dimensions and variables 
      call copy_variable_novalues(ncin,ncout,varname,.false.,0)
      iret = nf_enddef(ncout)

      print*,' writing new x--coord ',fname(1:len_trim(fname))
      iret=nf_inq_varid(ncout,fname,xid)
        if (iret.ne.0) print*,nf_strerror(iret)
      iret= nf_put_vara_real(ncout,xid,1,imt,xt)
        if (iret.ne.0) print*,nf_strerror(iret)

      print*,' writing new variable ',varname(1:len_trim(varname))
      start=1
      iret=nf_inq_varid(ncout,varname,varout)
      iret=nf_inq_vardimid(ncin,varin,dimid)
      iret = NF_INQ_VARTYPE (ncin, VARin,xtype)
      iret= nf_get_att_real (ncin,varin ,'missing_value',spval)
      iret=nf_inq_varndims(ncin,varin,ndims)
      if (ndims == 3) then
       iret=nf_inq_dimlen(ncin,dimid(3),itm)
       allocate( bufin(imtf,jmt,itm,1) )
       allocate( bufout(imt,jmt,itm,1) )
       iret= nf_get_vara_real(ncin,varin,start,(/imtf,jmt,itm/),bufin)
       bufout(1:imtf,:,:,1)= bufin(1:imtf,:,:,1)
c       bufout(imtf-1:imt,:,:,1)= bufout(1:imt-imtf+2,:,:,1)
       bufout(imtf:imt,:,:,1)= bufout(2:imt-imtf+2,:,:,1)
       do n=1,itm
          where( kmt ==0 ) bufout(:,:,n,1) = spval
       enddo
       iret= nf_put_vara_real(ncout,varout,start,(/imt,jmt,itm/),bufout)
      elseif (ndims==4) then
       iret=nf_inq_dimlen(ncin,dimid(4),itm)
       allocate( bufin(imtf,jmt,km,itm) )
       allocate( bufout(imt,jmt,km,itm) )
       iret= nf_get_vara_real(
     &             ncin,varin,start,(/imtf,jmt,km,itm/),bufin)
       bufout(1:imtf,:,:,:)= bufin(1:imtf,:,:,:)
c       bufout(imtf-1:imt,:,:,:)= bufout(1:imt-imtf+2,:,:,:)
       bufout(imtf:imt,:,:,:)= bufout(2:imt-imtf+2,:,:,:)
       do n=1,itm
        do k=1,km
         where( kmt <k ) bufout(:,:,k,n) = spval
        enddo
       enddo
       iret= nf_put_vara_real(
     &             ncout,varout,start,(/imt,jmt,km,itm/),bufout)
      endif
      print*,' ok'

      call ncclos (ncout, iret); if (iret /=0 ) goto 130
      call ncclos (ncin, iret); if (iret /=0 ) goto 130
      print*,'all done, bye'
      stop

 100  print*,' program needs command line parameter'
      print*,' input netcdf file names, output netcdf file name,'
      print*,' variable name to be unfolded [and switch ugrid]'
      stop
 110  print*,' problem opening NetCDF file ',fname(1:len_trim(fname))
      print*,' netcdf lib says: ',nf_strerror(iret)
      stop
 120  print*,' problem finding variable ',varname(1:len_trim(varname)),
     &   ' in file ',fname(1:len_trim(fname))
      print*,' netcdf lib says: ',nf_strerror(iret)
      stop
 130  print*,' problem closing NetCDF file '
      print*,' netcdf lib says: ',nf_strerror(iret)
      stop
      end program nc_ufo





c   dummy routines

      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"

      subroutine grids
c
c=======================================================================
c     set up a staggered "B" grid for MOM and compute grid related
c     variables
c     original author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c     SPFLAME version : c.eden
c=======================================================================
c
      use spflame_module
      implicit none
      real y,dfdy,amix
      integer is,ie,js,je,i,j,k,jm1,jp1,im1,ip1,io
      integer :: ii,jj
      real :: scal , scal_length, fxa , fxb, degtcm, distance, dstnc
      real, allocatable:: glat(:,:)

      degtcm   = radius/180*pi

      if (mother<0) then
c
c-----------------------------------------------------------------------
c      read in or set up the grid for the mother domain
c-----------------------------------------------------------------------
c
       if (enable_simple_grid)  then
        call grid_template()
       else
        call read_grid
       endif

      endif
c
c-----------------------------------------------------------------------
c     exchange grid over sub domains
c-----------------------------------------------------------------------
c
      call exchg_sub_grid
c
c-----------------------------------------------------------------------
c     convert grid resolution to cm
c-----------------------------------------------------------------------
c
      do j=1,jmt
        dyt(j) = dytdeg(j)*degtcm
        dyu(j) = dyudeg(j)*degtcm
      enddo
      do i=1,imt
        dxt(i) = dxtdeg(i)*degtcm
        dxu(i) = dxudeg(i)*degtcm
      enddo
      if (cyclic) then
       dxt(1)   = dxt(imt-1)
       dxt(imt) = dxt(2)
       dxu(1)   = dxu(imt-1)
       dxu(imt) = dxu(2)
      endif
c
c-----------------------------------------------------------------------
c     compute all quantities derived from the grid spacings
c-----------------------------------------------------------------------
c
      do k=1,km
        c2dzt(k) = 2.*dzt(k)
        dzt2r(k) = 1./c2dzt(k)
      enddo
      dzwr(km)  = 1./dzw(km)
      dzw2r(km) = 0.5/dzw(km)
      do k=1,km
        dzwr(k-1)    = 1./dzw(k-1)
        dzw2r(k-1)   = 0.5/dzw(k-1)
      enddo
      do k=1,km
        dztr(k)  = 1./dzt(k)
        rho0dztr(k) = 1./(rho0*dzt(k))
        dztur(k) = 1./(dzw(k-1)*dzt(k))
        dztlr(k) = 1./(dzw(k)*dzt(k))
      enddo
c
      if (enable_beta_plane .or. enable_f_plane) then
       do j=1,jmt
        phi(j)   = yu(beta_plane_j0)/180*pi
	phit(j)  = yt(beta_plane_j0)/180*pi
       enddo
      else
       do j=1,jmt
        phi(j)   = yu(j)/180*pi
	phit(j)  = yt(j)/180*pi
       enddo
      endif

      do j=1,jmt
        dytr(j)  = 1./dyt(j)
        dyt2r(j) = 0.5/dyt(j)
        dyt4r(j) = 0.25/dyt(j)
        dyur(j)  = 1./dyu(j)
        dyu2r(j) = 0.5/dyu(j)
        dyu4r(j) = 0.25/dyu(j)
        cst(j)   = cos(phit(j))
        csu(j)   = cos(phi (j))
        sine(j)  = sin(phi(j))
        cstr(j)     = 1./cst(j)
        csur(j)     = 1./csu(j)
        tng(j)      = sine(j)/csu(j)
	cstdytr(j)  = 1./(cst(j)*dyt(j))
	cstdyt2r(j) = cstdytr(j)*0.5
        rho0csudyur(j)  = 1./(rho0*csu(j)*dyu(j))
        csudyur(j) = 1./(csu(j)*dyu(j))
        csudyu2r(j) = 0.5/(csu(j)*dyu(j))
        cst_dytr(j) = cst(j)/dyt(j)
        csu_dyur(j) = csu(j)/dyu(j)
      enddo

      do i=1,imt
        dxtr(i)  = 1./dxt(i)
        dxt2r(i) = 0.5/dxt(i)
        dxt4r(i) = 0.25/dxt(i)
        dxur(i)  = 1./dxu(i)
        dxu2r(i) = 0.5/dxu(i)
        dxu4r(i) = 0.25/dxu(i)
      enddo
      do i=2,imt-1
        dxmetr(i) = 1./(dxt(i) + dxt(i+1))
      enddo
      do i=1,imt
        duw(i) = (xu(i) - xt(i))*degtcm
      enddo
      do i=1,imt-1
	due(i) = (xt(i+1) - xu(i))*degtcm
      enddo
      if (cyclic) then
       due(imt) = due(2)
      else
       due(imt) = due(imt-1)
      endif
      do j=1,jmt
        dus(j) = (yu(j) - yt(j))*degtcm
      enddo
      do j=1,jmt-1
	dun(j) = (yt(j+1) - yu(j))*degtcm
      enddo
      dun(jmt) = dun(jmt-1)
c
c-----------------------------------------------------------------------
c     build coefficients to minimize advection and diffusion computation 
c-----------------------------------------------------------------------
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js-1,je+1
        do i=is-1,ie+1
          ip1=min(i+1,imt)
	  rho0csudxur(i,j) = rho0r*csur(j)*dxur(i)
	  csudxu2r(i,j)    = csur(j)*dxur(i)*0.5
	  am_csudxtr(i,j)  = am*csur(j)*dxtr(ip1)
	enddo
      enddo

      do j=js-1,je+1
        do i=is-1,ie+1
	  cstdxtr(i,j)    = cstr(j)*dxtr(i)
	  cstdxt2r(i,j)   = cstr(j)*dxtr(i)*.5
	  ah_cstdxur(i,j) = ah*cstr(j)*dxur(i)
	enddo
      enddo
c
c-----------------------------------------------------------------------
c     coriolis factors
c-----------------------------------------------------------------------
c
      if (enable_beta_plane .or. enable_f_plane) then
c
c      beta plane with f = f0 + beta*y where f0 is at yu(1)
c      if f_plane then beta = 0
c
       if (enable_f_plane) then
        dfdy   = 0.
        if (my_pe==0) then
         print*,''
         print*,' using a f-plane approximation '
         print*,' referenced to latitude ',yu(beta_plane_j0)
         print*,' f0=',2*omega*sine(beta_plane_j0),' 1/s'
         print*,''
        endif
       else
        dfdy   = 2.*omega*csu(beta_plane_j0)/radius
        if (my_pe==0) then
         print*,''
         print*,' using a beta-plane approximation '
         print*,' referenced to latitude ',yu(beta_plane_j0)
         print*,' f0=',2*omega*sine(beta_plane_j0),' 1/s'
         print*,' beta=',dfdy,' 1/s/cm'
         print*,''
        endif
       endif
       do j=js_pe,je_pe
        y            = (yu(j)-yu(beta_plane_j0))*degtcm
        cori(:,j,1) = 2.*omega*sine(beta_plane_j0) + y*dfdy
        cori(:,j,2) = -(2.*omega*sine(beta_plane_j0) + y*dfdy)
       enddo
        
      elseif (enable_rotated_grid) then

       if (my_pe==0) then
         print*,''
         print*,' using a rotated grid '
         print*,''
       endif

       if (mother>=0) then
        print*,' rotated grid for sub domains not yet'
        print*,' implemented' ! but possible,
!       exchange glat over sub domains here, but interpolation
c       of glat is no good ...
        call halt_stop('in grids (glat)')
       endif

       allocate(glat(imt,jmt))
       if (my_pe==0) print*,
     &  ' =>Reading a "glat" field from binary file glat.dta'
       call getunit (io, 'glat.dta', 'usr ieee')
       read (io) ! flame id
c       skip header record and read dimensional info
       read (io) ! iotext
       read (io) i, j, k
       if (i/=imt .or. j /= jmt .or. k/= km) then
c      check i,j,k
        if (my_pe==0) then
         print*,' Error: '
         print*,' read imt,jmt,km=',i,j,k
         print*,' but input from namelist was ',imt,jmt,km
         call sub_flush(6)
        endif
        call halt_stop(' reading glat file ')
       endif
       read (io) ! iotext
       read (io) glat
       close(io)
       if (my_pe==0) print*,' done'

       do j=js_pe,je_pe
	do i=is_pe,ie_pe
         cori(i,j,1) = 2.0*omega*sin(glat(i,j)/180*pi)
	 cori(i,j,2) = -cori(i,j,1)
	enddo
       enddo
       deallocate(glat)

      else

       do j=js_pe,je_pe
        cori(:,j,1) = 2.*omega*sine(j)
        cori(:,j,2) = -2.*omega*sine(j)
       enddo

      endif
c
c-----------------------------------------------------------------------
c     metric diffusion factors and metric advection factors
c-----------------------------------------------------------------------
c
      amix = sqrt(abs(ambi))
      if (enable_beta_plane .or. enable_f_plane) then
       do j=1,jmt
c
c       set metric factors = 0 on beta and f plane
c       (strictly, they should be non zero... but they are small)
c
	am3_biha(j)   = 0.; am4_biha(j,1) = 0.; am4_biha(j,2) = 0.
	am3_ha(j)   = 0.; am4_ha(j,1) = 0.; am4_ha(j,2) = 0.
        advmet(j,1) = 0.; advmet(j,2) = 0.
       enddo
      else
       do j=1,jmt
	am3_biha(j)   = amix*(1.-tng(j)*tng(j))/(rho0*radius**2)
	am4_biha(j,1) = -amix*2.*sine(j)/(rho0*radius*csu(j)*csu(j))
	am4_biha(j,2) = -am4_biha(j,1)
	am3_ha(j)   = am*(1.-tng(j)*tng(j))/(rho0*radius**2)
	am4_ha(j,1) = -am*2.*sine(j)/(rho0*radius*csu(j)*csu(j))
	am4_ha(j,2) = -am4_ha(j,1)
        advmet(j,1) = tng(j)/radius
        advmet(j,2) = -advmet(j,1)
       enddo
      endif
c
c     for momentum
c
      visc_cnu = sqrt(abs(ambi)); visc_ceu = sqrt(abs(ambi))
c
      do j=1,jmt
	jm1 = max(1,j-1); jp1 = min(jmt,j+1)
	amc_north_ha(j) = am/rho0*cst(jp1)*dytr(jp1)*csur(j)*dyur(j)
	amc_south_ha(j) = am/rho0*cst(j)*dytr(j)*csur(j)*dyur(j)
      enddo
c
c     for tracers
c
      diff_cet = sqrt(abs(ahbi)); diff_cnt = sqrt(abs(ahbi))
c
      do j=1,jmt
          jm1 = max(1,j-1); jp1 = min(jmt,j+1)
          ahc_north_ha(j) = ah*csu(j)*dyur(j)*cstr(j)*dytr(j)
          ahc_south_ha(j) = ah*csu(jm1)*dyur(jm1)*cstr(j)*dytr(j)
      enddo

      if (enable_obc_south) then 
       amc_south_ha(2) = 0.; ahc_south_ha(2) = 0.
      endif
      if (enable_obc_north) then 
       amc_north_ha(jmt-2) = 0.; amc_north_ha(jmt-1) = 0.
c      ahc_north_ha(jmt-2) = 0.; ahc_north_ha(jmt-1) = 0.
      endif
c
c-----------------------------------------------------------------------
c     scaling of am/ah/ambi/ahbi
c-----------------------------------------------------------------------
c
      if (mother<0 .and. (enable_obc_south_sponge .or. 
     &                      enable_obc_south_sponge_harm)) then
c
c      define a frictional (bi)-harmonic sponge layer for obc south
c      set scaling for mother domain only
c
       if (my_pe==0) then
        print*,''
        if (enable_obc_south_sponge) then
         print*,' defining a frictional biharm. sponge layer for',
     &    ' southern open boundary'
        endif
        if (enable_obc_south_sponge_harm) then
         print*,' defining a frictional harm. sponge layer for',
     &    ' southern open boundary'
        endif
        if (enable_obc_south_sponge_diff) then
          print*,' scaling also (z-level) diffusivity'
        endif
        print*,' width in zonal slabs : ',obc_south_sponge_width
        print*,' e folding scale, same unit :',obc_south_sponge_scale
        print*,' factor for increased harm. frict. :',
     &              obc_south_sponge_fac 

        if (.not.enable_friction_biharmonic) then
         print*,' However, the biharm. sponge layer will not work'
         print*,' if you do not enable biharmonic friction '
        endif
        if (.not.enable_friction_harmonic) then
         print*,' However, the harm. sponge layer will not work'
         print*,' if you do not enable harmonic friction '
        endif
        print*,''
       endif

       do j=js_pe-2,je_pe+2
          fxa = 1.0
          if (j < obc_south_sponge_width) then   
            fxb   = -float(j-1)/obc_south_sponge_scale
            fxa = 1.0 + (obc_south_sponge_fac - 1.0) * exp(fxb) 
          end if
          if (enable_obc_south_sponge) then
            ambi_scale(:,j) = sqrt( abs(fxa) )
            if (enable_obc_south_sponge_diff) then
             ahbi_scale(:,j) = sqrt( abs(fxa) )
            endif
          endif
          if (enable_obc_south_sponge_harm) then
            am_scale(:,j) = abs(fxa) 
            if (enable_obc_south_sponge_diff) then
             ah_scale(:,j) = abs(fxa)
            endif
          endif
       end do

      endif

      if (mother<0 .and. (enable_obc_north_sponge.or.
     &                      enable_obc_north_sponge_harm) ) then
c
c      define a frictional (bi)harmonic sponge layer for obc north
c      set scaling for mother domain only
c
       if (my_pe==0) then
        print*,''
        if (enable_obc_north_sponge) then
         print*,' defining a frictional biharm. sponge layer for',
     &    ' northern open boundary'
        endif
        if (enable_obc_north_sponge_harm) then
         print*,' defining a frictional harm. sponge layer for',
     &    ' northern open boundary'
        endif
        if (enable_obc_north_sponge_diff) then
          print*,' scaling also (z-level) diffusivity'
        endif
        print*,' width in zonal slabs : ',obc_north_sponge_width
        print*,' e folding scale, same unit :',obc_north_sponge_scale
        print*,' factor for increased harm. frict. :',
     &              obc_north_sponge_fac 

        if (.not.enable_friction_biharmonic) then
         print*,' However, the biharm. sponge layer will not work'
         print*,' if you do not enable biharmonic friction '
        endif
        if (.not.enable_friction_harmonic) then
         print*,' However, the harm. sponge layer will not work'
         print*,' if you do not enable harmonic friction '
        endif
        print*,''
       endif

       do j=js_pe-2,je_pe+2
          fxa = 1.0
          if (j > jmt-obc_north_sponge_width) then   
            fxb   = -float(jmt-j)/obc_north_sponge_scale
            fxa = 1.0 + (obc_north_sponge_fac - 1.0) * exp(fxb) 
          end if
          if (enable_obc_north_sponge) then
           ambi_scale(:,j) = ambi_scale(:,j)*sqrt( abs(fxa) )
           if (enable_obc_north_sponge_diff) then
            ahbi_scale(:,j) = ahbi_scale(:,j)*sqrt( abs(fxa) )
           endif
          endif
          if (enable_obc_north_sponge_harm) then
           am_scale(:,j) = am_scale(:,j)*abs(fxa) 
           if (enable_obc_north_sponge_diff) then
            ah_scale(:,j) = ah_scale(:,j)*abs(fxa) 
           endif
          endif
       end do

      endif


      if (mother<0 .and. (enable_obc_east_sponge.or.
     &                      enable_obc_east_sponge_harm) ) then
c
c      define a frictional (bi)harmonic sponge layer for obc east
c      set scaling for mother domain only
c
       if (my_pe==0) then
        print*,''
        if (enable_obc_east_sponge) then
         print*,' defining a frictional biharm. sponge layer for',
     &    ' eastern open boundary'
        endif
        if (enable_obc_east_sponge_harm) then
         print*,' defining a frictional harm. sponge layer for',
     &    ' eastern open boundary'
        endif
        if (enable_obc_east_sponge_diff) then
          print*,' scaling also (z-level) diffusivity'
        endif
        print*,' width in meridional slabs : ',obc_east_sponge_width
        print*,' e folding scale, same unit :',obc_east_sponge_scale
        print*,' factor for increased harm. frict. :',
     &              obc_east_sponge_fac 

        if (.not.enable_friction_biharmonic) then
         print*,' However, the biharm. sponge layer will not work'
         print*,' if you do not enable biharmonic friction '
        endif
        if (.not.enable_friction_harmonic) then
         print*,' However, the harm. sponge layer will not work'
         print*,' if you do not enable harmonic friction '
        endif
        print*,''
       endif

       do i=is_pe-2,ie_pe+2
c
c       add here amplification factor 
c
          fxa = 0.0
          if (i > imt-obc_east_sponge_width) then   
            fxb   = -float(imt-i)/obc_east_sponge_scale
            fxa = obc_east_sponge_fac * exp(fxb) 
          end if
          if (enable_obc_east_sponge) then
           ambi_scale(i,:) = ambi_scale(i,:)+sqrt( abs(fxa) )
           if (enable_obc_east_sponge_diff) then
            ahbi_scale(i,:) = ahbi_scale(i,:)+sqrt( abs(fxa) )
           endif
          endif
          if (enable_obc_east_sponge_harm) then
           am_scale(i,:) = am_scale(i,:)+abs(fxa) 
           if (enable_obc_east_sponge_diff) then
            ah_scale(i,:) = ah_scale(i,:)+abs(fxa) 
           endif
          endif
       end do

      endif

      if (mother<0 .and. (enable_obc_west_sponge.or.
     &                      enable_obc_west_sponge_harm) ) then
c
c      define a frictional (bi)harmonic sponge layer for obc east
c      set scaling for mother domain only
c
       if (my_pe==0) then
        print*,''
        if (enable_obc_west_sponge) then
         print*,' defining a frictional biharm. sponge layer for',
     &    ' western open boundary'
        endif
        if (enable_obc_west_sponge_harm) then
         print*,' defining a frictional harm. sponge layer for',
     &    ' western open boundary'
        endif
        if (enable_obc_west_sponge_diff) then
          print*,' scaling also (z-level) diffusivity'
        endif
        print*,' width in meridional slabs : ',obc_west_sponge_width
        print*,' e folding scale, same unit :',obc_west_sponge_scale
        print*,' factor for increased harm. frict. :',
     &              obc_west_sponge_fac 

        if (.not.enable_friction_biharmonic) then
         print*,' However, the biharm. sponge layer will not work'
         print*,' if you do not enable biharmonic friction '
        endif
        if (.not.enable_friction_harmonic) then
         print*,' However, the harm. sponge layer will not work'
         print*,' if you do not enable harmonic friction '
        endif
        print*,''
       endif

       do i=is_pe-2,ie_pe+2
c
c       add here amplification factor 
c
          fxa = 0.0
          if (i < obc_west_sponge_width) then   
            fxb   = -float(i-1)/obc_west_sponge_scale
            fxa = obc_west_sponge_fac * exp(fxb) 
          end if
          if (enable_obc_west_sponge) then
           ambi_scale(i,:) = ambi_scale(i,:)+sqrt( abs(fxa) )
           if (enable_obc_west_sponge_diff) then
            ahbi_scale(i,:) = ahbi_scale(i,:)+sqrt( abs(fxa) )
           endif
          endif
          if (enable_obc_west_sponge_harm) then
           am_scale(i,:) = am_scale(i,:)+abs(fxa) 
           if (enable_obc_west_sponge_diff) then
            ah_scale(i,:) = ah_scale(i,:)+abs(fxa) 
           endif
          endif
       end do

      endif


      if (enable_friction_cosine_scal)  then

       if (my_pe==0) then
         print*,''
         print*,
     &    ' scaling hor. friction parameter with cosine of latitude'
         print*,''
       endif

       do j=js_pe-2,je_pe+2
        i=min(max(1,j),jmt)
        am_scale(:,j)  =am_scale(:,j)*csu(i)
        ambi_scale(:,j)=ambi_scale(:,j)*csu(i)**1.5
       enddo
      endif

      if (enable_diffusion_cosine_scal)  then

       if (my_pe==0) then
         print*,''
         print*,
     &    ' scaling hor. diffusion parameter with cosine of latitude'
         print*,''
       endif

       do j=js_pe-2,je_pe+2
        i=min(max(1,j),jmt)
        ah_scale(:,j)  =ah_scale(:,j)*cst(i)
        ahbi_scale(:,j)=ahbi_scale(:,j)*cst(i)**1.5
       enddo
      endif

      if (enable_no_isopyc_medwater) then

       if (my_pe==0) then
         print*,''
         print*,
     &    ' increasing hor. harm. diffusivity in medwater outflow-area'
         print*,''
       endif

       do j=js_pe-2,je_pe+2 
        do i=is_pe-2,ie_pe+2
c     position Gibraltar: for HS_4 i,j = 112,682 (folded)      
c        distance = dstnc(yt(j),xt(i),yt(682),xt(112))
         distance = dstnc(yt(j),xt(i),35.8585,269.2083)
         if (distance < 500.0) then
          if (distance <= 300.0) then
           ah_scale(i,j) = ah_scale(i,j)*14.
          else
           ah_scale(i,j) = ah_scale(i,j)*(0.07*(500.0-distance))
          endif
         endif 
        enddo
       enddo
      endif  
c
      end subroutine grids



      function dstnc(phi1,rla1,phi2,rla2)
c returns distance (in km) between two geographical
c points
c        written by   p.herrmann
c      phi1 : first latitude
c      rla1 : first longitude
c      phi2 : second latitude
c      rla2 : second longitude

       real p1,p2,rl1,rl2,x,xx
       data s/0.0174533/
       p1=phi1*s; p2=phi2*s; rl1=rla1*s; rl2=rla2*s
       x=sin(p1)*sin(p2)+cos(p1)*cos(p2)*cos(rl2-rl1)
       xx=abs(x)
       if(xx.gt.1.0) x=1.0
       d=atan(sqrt((1-x)/(1+x)))*222.24/s; dstnc=d
       end function dstnc



      subroutine read_grid ()
c
c-----------------------------------------------------------------------
c     read in the grid from a binary file
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer i,j,k,imt2,jmt2,km2,io

      if (my_pe==0) print*,
     & ' =>Reading the grid definition from file grid.dta'
      call getunit (io, 'grid.dta', 'u s r ieee')
      read (io) ! no checks for awi id
      read (io) imt2, jmt2, km2
      if (imt2/=imt .or. jmt2 /= jmt .or. km2 /= km) then
c      check imt2,jmt2,km2
       if (my_pe==0) then
        print*,' Error: '
        print*,' read imt,jmt,km=',imt2,jmt2,km2
        print*,' but input from namelist was ',imt,jmt,km
        call sub_flush(6)
       endif
       call halt_stop(' reading grid file ')
      endif
      read (io) (dxtdeg(i),i=1,imt)
     &,         (dytdeg(j),j=1,jmt)
     &,         (dxudeg(i),i=1,imt)
     &,         (dyudeg(j),j=1,jmt)
     &,         (dzt(k),k=1,km)
     &,         (dzw(k),k=0,km)
     &,         (xt(i),i=1,imt)
     &,         (xu(i),i=1,imt)
     &,         (yt(j),j=1,jmt)
     &,         (yu(j),j=1,jmt)
     &,         (zt(k),k=1,km)
     &,         (zw(k),k=1,km)
      close (io)
      if (my_pe==0) print*,' done'
      end subroutine read_grid




      subroutine topog 
c
c-----------------------------------------------------------------------
c     construct the topographic mask "kmt" which determines the geometry
c     and topography by defining the number of vertical levels on model
c     T points. Construct also other topography related variables
c     SPFLAME version : c.eden
c---------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer i,j,k,io,kk,jj,ii,is,ie,js,je,kb
      integer kmu_big(imt,jmt),indp
      real p_cell_min,hy,hcm
#ifdef partial_cell
      real dhue,dhun
      dhue(i,k,j)   = min(dhu(i+1,k,j),dhu(i,k,j))
      dhun(i,k,j)   = min(dhu(i,k,j+1),dhu(i,k,j))
#endif

      if (mother<0 ) then
c
c---------------------------------------------------------------------
c     read or construct the kmt-mask
c---------------------------------------------------------------------
c
       if (enable_simple_topo) then

         call kmt_template()

       else

        if (my_pe==0) print*,
     &   ' =>Reading a "kmt" field from binary file kmt.dta'
        call getunit (io, 'kmt.dta', 'usr ieee')
        read (io) ! no checks
c       skip header record and read dimensional info
        read (io) 
        read (io) i, j, k
        if (i/=imt .or. j /= jmt .or. k/= km) then
c        check i,j,k
        if (my_pe==0) then
         print*,' Error: '
         print*,' read imt,jmt,km=',i,j,k
         print*,' but input from namelist was ',imt,jmt,km
         call sub_flush(6)
        endif
        call halt_stop(' reading kmt file ')
       endif
       read (io) 
       read (io) kmt_big
       close(io)
       if (my_pe==0) print*,' done'
      endif
     
#ifdef partial_cell
c
c---------------------------------------------------------------------
c     read or contruct  htp = depth to ocean bottom at T-cells (cm)
c---------------------------------------------------------------------
c
      if (enable_simple_topo) then

        call htp_template()

      else

       if (my_pe==0) print*,
     & ' =>Reading a "htp" field from binary file htp.dta'
       call getunit (io, 'htp.dta', 'usr ieee')
       read (io) ! no checks
c       skip header record and read dimensional info
       read (io) 
       read (io) i, j, k
       if (i/=imt .or. j /= jmt .or. k/= km) then
c       check i,j,k
        if (my_pe==0) then
         print*,' Error: '
         print*,' read imt,jmt,km=',i,j,k
         print*,' but input from namelist was ',imt,jmt,km
         call sub_flush(6)
        endif
        call halt_stop(' reading htp file ')
       endif
       read (io) 
       read (io) htp
       close(io)
       if (my_pe==0) print*,' done'
      endif
#endif

      endif  ! mother<0
c
c---------------------------------------------------------------------
c     exchange kmt over sub domains
c---------------------------------------------------------------------
c
      call exchg_sub_topo   ! exchange also ht 
c
c---------------------------------------------------------------------
c     check kmt at the boundaries
c---------------------------------------------------------------------
c
      if (enable_obc_south) then
       j=2
       do i=1,imt
        k=min(min(kmt_big(i,j),kmt_big(i,j+1)),
     &        min(kmt_big(i,j),kmt_big(i,j+2)))
        if (k /= kmt_big(i,j)) then
         if (my_pe==0) then
          write(6,*)' WARNING: Changing Topography at southern OB. '
          print*,'  at i=',i,' j=',j
          print*,'  new kmt(i,j)=',k
         endif
         kmt_big(i,j)=k
         kmt_big(i,j-1)=kmt_big(i,j)
         kmt_big(i,j+1)=kmt_big(i,j)
         kmt_big(i,j+2)=kmt_big(i,j+1)
#ifdef partial_cell
         do jj=j-1,j+2; htp(i,jj) = zw(k); enddo
#endif
        endif
       enddo
      else
       kmt_big(:,1)=0.
#ifdef partial_cell
       htp(:,1)=0.
#endif
      endif

      if (enable_obc_north) then
       j=jmt-1
       do i=1,imt
        k=min(min(kmt_big(i,j),kmt_big(i,j-1)),
     &        min(kmt_big(i,j),kmt_big(i,j-2)))
        if (k /= kmt_big(i,j)) then
         if (my_pe==0) then
          write(6,*)' WARNING: Changing Topography at northern OB. '
          print*,'  at i=',i,' j=',j
          print*,'  new kmt(i,j)=',k
         endif
         kmt_big(i,j)=k
         kmt_big(i,j+1)=kmt_big(i,j)
         kmt_big(i,j-1)=kmt_big(i,j)
         kmt_big(i,j-2)=kmt_big(i,j-1)
#ifdef partial_cell
         do jj=j-2,j+1; htp(i,jj) = zw(k); enddo
#endif
        endif
       enddo
      else
       kmt_big(:,jmt)=0
#ifdef partial_cell
       htp(:,jmt)=0.
#endif
      endif

      if (enable_obc_west) then
       i=2
       do j=1,jmt
        k=min(min(kmt_big(i,j),kmt_big(i+1,j)),
     &        min(kmt_big(i,j),kmt_big(i+2,j)))
        if (k /= kmt_big(i,j)) then
         if (my_pe==0) then
          write(6,*)' WARNING: Changing Topography at western OB. '
          print*,'  at i=',i,' j=',j
          print*,'  new kmt(i,j)=',k
         endif
         kmt_big(i,j)=k
         kmt_big(i-1,j)=kmt_big(i,j)
         kmt_big(i+1,j)=kmt_big(i,j)
         kmt_big(i+2,j)=kmt_big(i+1,j)
#ifdef partial_cell
         do ii=i-1,i+2; htp(ii,j) = zw(k); enddo
#endif
        endif
       enddo
      elseif (cyclic) then
        kmt_big(1,:)=kmt_big(imt-1,:)
#ifdef partial_cell
        htp(1,:)=htp(imt-1,:)
#endif
      else
        kmt_big(1,:)=0
#ifdef partial_cell
        htp(1,:)=0.
#endif
      endif

      if (enable_obc_east) then
       i=imt-1
       do j=1,jmt
        k=min(min(kmt_big(i,j),kmt_big(i-1,j)),
     &        min(kmt_big(i,j),kmt_big(i-2,j)))
        if (k /= kmt_big(i,j)) then
         if (my_pe==0) then
          write(6,*)' WARNING: Changing Topography at eastern OB. '
          print*,'  at i=',i,' j=',j
          print*,'  new kmt(i,j)=',k
         endif
         kmt_big(i,j)=k
         kmt_big(i+1,j)=kmt_big(i,j)
         kmt_big(i-1,j)=kmt_big(i,j)
         kmt_big(i-2,j)=kmt_big(i-1,j)
#ifdef partial_cell
         do ii=i-2,i+1; htp(ii,j) = zw(k); enddo
#endif
        endif
       enddo
      elseif (cyclic) then
       kmt_big(imt,:)=kmt_big(2,:)
#ifdef partial_cell
       htp(imt,:)=htp(imt,:)
#endif
      else
       kmt_big(imt,:)=0
#ifdef partial_cell
       htp(imt,:)=0.
#endif
      endif

      if ((enable_obc_north .or. enable_obc_south .or.
     &  enable_obc_west .or. enable_obc_east) .and. .not.cyclic ) then 
c      last checks in case of o.b.c
       kmt_big(imt,1)=0
       kmt_big(imt,jmt)=0
       kmt_big(1,jmt)=0
       kmt_big(1,1)=0
#ifdef partial_cell
       htp(imt,1)=0.
       htp(imt,jmt)=0.
       htp(1,jmt)=0.
       htp(1,1)=0.
#endif
c      done
      endif
c
      kmt=kmt_big(is_pe:ie_pe,js_pe:je_pe)
c
c---------------------------------------------------------------------
c     construct topography for u grid
c---------------------------------------------------------------------
c
      kmu_big=0
      do j=1,jmt-1
        do i=1,imt-1
           kmu_big(i,j) = min (kmt_big(i,j), kmt_big(i+1,j), 
     &                         kmt_big(i,j+1), kmt_big(i+1,j+1))
        enddo
      enddo

      if (enable_obc_north) kmu_big(:,jmt) = kmu_big(:,jmt-1)
      if (enable_obc_south) kmu_big(:,1) = kmu_big(:,2)
      if (enable_obc_west) kmu_big(1,:) = kmu_big(2,:)
      if (enable_obc_east) kmu_big(imt,:) = kmu_big(imt-1,:)

      if ((enable_obc_north .or. enable_obc_south .or.
     &  enable_obc_west.or.enable_obc_east).and. .not.cyclic) then 
c      checks in case of o.b.c
       kmu_big(imt-1:imt,1)=0.
       kmu_big(1,1)=0.
       kmu_big(1,jmt-1:jmt)=0.
c      done
      endif

      if (cyclic) kmu_big(imt,:) = kmu_big(2,:)

      kmu=kmu_big(is_pe:ie_pe,js_pe:je_pe)

#ifdef partial_cell
c
c---------------------------------------------------------------------
c     a check
c---------------------------------------------------------------------
c
      if (my_pe==0) print*,' checking consitency of htp/kmt masks'
      do j=1,jmt
       do i=1,imt
        if (kmt_big(i,j)/=0) then
         if (htp(i,j)>zw(max(1,kmt_big(i,j)))) then
          print*,' error at i=',i,' j=',j
          print*,' htp(i,j)=',htp(i,j)
          print*,' zw(kmt(i,j))=',zw(max(1, kmt_big(i,j) ))
          stop
         endif
         if (htp(i,j)<=zw(max(1, kmt_big(i,j)-1 ))) then
          print*,' error at i=',i,' j=',j
          print*,' htp(i,j)=',htp(i,j)
          print*,' zw(kmt(i,j)-1)=',zw(max(1, kmt_big(i,j)-1 ))
          print*,' kmt(i,j)=',kmt_big(i,j)
          stop
         endif
        endif
       enddo
      enddo
c
c---------------------------------------------------------------------
c     do not allow partial cells thickness less than min(dzt(k))
c     (arbitrarily 50m minimum in coarse models ... otherwise dzt(1))
c---------------------------------------------------------------------
c
      p_cell_min = min(10.0e2,zw(1)) ! schiet wat
      do k=2,km
        if (p_cell_min .gt. (zw(k)-zw(k-1))) p_cell_min = zw(k)-zw(k-1) 
      enddo
      do j=2,jmt-1
        do i=2,imt-1
	  k = kmt_big(i,j)
	  if (k .lt. 2) then
	    htp(i,j) = 0.0
	  else
	    if ((htp(i,j)-zw(k-1)) .lt. p_cell_min) then
              if (my_pe==0) then
               print*,' WARNING: partial cell limit violated'
               print*,' at i=',i,' j=',j,' htp(i,j)=',htp(i,j)
               print*,' zw(k-1)=',zw(k-1)
               print*,' zw(k)=',zw(k),' p_cell_min',p_cell_min
              endif
	      htp(i,j) = zw(k-1) + p_cell_min
	    endif
	  endif
        enddo
      enddo 
      if (my_pe==0) print*,' done'
c
c-----------------------------------------------------------------------
c     construct hu as the depth to bottom on U cells
c-----------------------------------------------------------------------
c
      hup=0.
      do j=1,jmt-1
        do i=2,imt-1
          hup(i,j) = min( htp(i,j),htp(i+1,j),htp(i,j+1),htp(i+1,j+1))
	enddo
      enddo

      if (enable_obc_north) hup(:,jmt) = hup(:,jmt-1)
      if (enable_obc_south) hup(:,1)   = hup(:,2)
      if (enable_obc_west)  hup(1,:)   = hup(2,:)
      if (enable_obc_east)  hup(imt,:) = hup(imt-1,:)

      if ((enable_obc_north .or. enable_obc_south .or.
     &     enable_obc_west  .or. enable_obc_east).and..not.cyclic) then 
c      checks in case of o.b.c
       hup(imt-1:imt,1)=0.
       hup(1,1)=0.
       hup(1,jmt-1:jmt)=0.
c      done
      endif

      if (cyclic) hup(imt,:) = hup(2,:)
      if (cyclic) hup(1,:) = hup(imt-1,:)
c
c     fracdz(k,0) = fractional distance between grid point and cell top
c     fracdz(k,1) = fractional distance between grid point and cell bot
c
      do k=1,km
        if (k .gt. 1) then
          fracdz(k,0) = (zt(k) - zw(k-1))/dzt(k)
        else
          fracdz(k,0) = (zt(k) - 0.)/dzt(k)
        endif
        fracdz(k,1) = (zw(k) - zt(k))/dzt(k)
      enddo
c
c-----------------------------------------------------------------------
c     construct thickness of T cells and U cells
c     (an aberration of the canonical indexing is used here)
c-----------------------------------------------------------------------
c
      do k=1,km
       dht(:,k,:)=dzt(k)
       dhu(:,k,:)=dzt(k)
       ztp(:,k,:)=zt(k)
      enddo
      do k=0,km
       dhwt(:,k,:)=dzw(k)
      enddo

      do j=js_pe,je_pe
	do i=is_pe,ie_pe
	  kb = kmt_big(i,j)
	  if (kb .gt. 1) then
	    dht(i,kb,j) = htp(i,j) - zw(kb-1)
	  endif
	enddo
      enddo
      call border_exchg(dht,km,2)
      if (cyclic) call set_cyclic(dht,km,2)
c
      do j=js_pe,je_pe
	do i=is_pe,ie_pe
	  kb = kmt_big(i,j)
	  if (kb .gt. 1) then
	    ztp(i,kb,j) = zw(kb-1) + fracdz(kb,0)*dht(i,kb,j)
            dhwt(i,kb-1,j) = ztp(i,kb,j) - zt(kb-1)
	  endif
	enddo
      enddo

      call border_exchg(dhwt,km+1,2)
      call border_exchg(ztp,km,1)
      if (cyclic) call set_cyclic(dhwt,km+1,2)
      if (cyclic) call set_cyclic(ztp,km,1)

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
        do k=1,km
          do i=is,ie
	    dhu(i,k,j) = min(dht(i,k,j), dht(i+1,k,j), dht(i,k,j+1)
     &,                      dht(i+1,k,j+1))
	  enddo
          if (my_blk_i==1)       dhu(1,k,j)   = dht(1,k,j)
          if (my_blk_i==n_pes_i) dhu(imt,k,j) = dht(imt,k,j)
	enddo
      enddo

      call border_exchg(dhu,km,2)
      if (cyclic) call set_cyclic(dhu,km,2)
      if (my_blk_j==1) dhu(:,:,1)=dhu(:,:,2)
      if (my_blk_j==n_pes_j) dhu(:,:,jmt)=dhu(:,:,jmt-1)
c
c       compute momentum sink by partial-cells
c
c from here:   dhu(is_pe-2:ie_pe+2,km,js_pe-2:je_pe+2)
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      if (enable_friction_biharmonic) then
        do j=js,je
           do k=1,km
              do i=is,ie
                pc_sink_biha(i,k,j) =
     &           - visc_ceu*         
     &          (csur(j)*dxur(i)/dhu(i,k,j))*
     &          (csur(j)*dxtr(i+1)*(dhu(i,k,j)-dhue(i,k,j))
     &         + csur(j)*dxtr(i)*(dhu(i,k,j)-dhue(i-1,k,j)))
     &         - visc_cnu*
     &          (csudyur(j)/dhu(i,k,j))*
     &          (cst_dytr(j+1)*(dhu(i,k,j)-dhun(i,k,j))
     &         + cst_dytr(j)*(dhu(i,k,j)-dhun(i,k,j-1)))
              enddo
           enddo
        enddo
        call border_exchg(pc_sink_biha,km,1)
        if (cyclic) call set_cyclic(pc_sink_biha,km,1)
      endif

      if (enable_friction_harmonic) then
        do j=js,je
         do k=1,km
              do i=is,ie
                pc_sink_ha(i,k,j) =
     &           - am*         
     &          (csur(j)*dxur(i)/dhu(i,k,j))*
     &          (csur(j)*dxtr(i+1)*(dhu(i,k,j)-dhue(i,k,j))
     &         + csur(j)*dxtr(i)*(dhu(i,k,j)-dhue(i-1,k,j)))
     &         - am*
     &          (csudyur(j)/dhu(i,k,j))*
     &          (cst_dytr(j+1)*(dhu(i,k,j)-dhun(i,k,j))
     &         + cst_dytr(j)*(dhu(i,k,j)-dhun(i,k,j-1)))
              enddo
         enddo
        enddo
      endif
#endif

c---------------------------------------------------------------------
c     compute depths and reciprocal depths over "u" cells
c---------------------------------------------------------------------

      hr=0.
      do j=max(1,js_pe-1),min(je_pe+1,jmt)
        do i=max(is_pe-1,1),min(ie_pe+1,imt)
          if (kmu_big(i,j) .ne. 0) then
#ifdef partial_cell
            hr(i,j) = 1./hup(i,j)
#else
            hr(i,j) = 1./zw(kmu_big(i,j))
#endif
          endif
        enddo
      enddo
c
c---------------------------------------------------------------------
c     contruct masks for tracer and velocities
c---------------------------------------------------------------------
c
      umask=0.; tmask=0.
      if ( mother<0 ) then
        kk = 2
      else 
        kk = max(2,zoom_fac/2)
      endif
      do j=max(1,js_pe-kk),min(je_pe+kk,jmt)
        do k=1,km
           do i=max(is_pe-kk,1),min(ie_pe+kk,imt)
              if (kmt_big(i,j) .ge. k) then
                tmask(i,k,j) = 1.
              else
                tmask(i,k,j) = 0.
              endif
              if (kmu_big(i,j) .ge. k) then
                umask(i,k,j) = 1.
              else
                umask(i,k,j) = 0.
              endif
           enddo
        enddo
      enddo
c
c     we are using partially a 4th order scheme
c
      if (enable_quicker_advection) 
     &      call set_cyclic_4th_order(tmask,km,kk)

c-----------------------------------------------------------------------
c     compute surface area and volume of ocean ("t" cells and "u" cells)
c     (note that areas are defined at each level)
c-----------------------------------------------------------------------
c
      tcella=0.; ucella=0.; tcellv = 0.; ucellv = 0.
      do j=js_pe,je_pe
        do i=is_pe,ie_pe
          if (kmt(i,j) .gt. 0) then
	    do k=1,kmt(i,j)
              tcella(k) = tcella(k) + cst(j)*dxt(i)*dyt(j)
	    enddo
            tcellv = tcellv +cst(j)*dxt(i)*dyt(j)
#ifdef partial_cell
     &              *htp(i,j)
#else
     &              *zw(kmt(i,j))
#endif
          endif
          if (kmu(i,j) .gt. 0) then
	    do k=1,kmu(i,j)
              ucella(k) = ucella(k) + csu(j)*dxu(i)*dyu(j)
	    enddo
            ucellv = ucellv +csu(j)*dxu(i)*dyu(j)
#ifdef partial_cell
     &              *hup(i,j)
#else
     &              *zw(kmu(i,j))
#endif
          endif
        enddo
      enddo
      call global_sum(tcellv)
      call global_sum(ucellv)
      do k=1,km
       call global_sum(tcella(k))
       call global_sum(ucella(k))
      enddo
      if (my_pe==0) write (6,9341) tcella(1), tcellv, ucella(1), ucellv
9341  format (//,'  Global ocean statistics:'
     &/,'  the total ocean surface area (t cells) =',1pe15.8,'cm**2'
     &/,'  the total ocean volume (t cells)       =',1pe15.8,'cm**3'
     &/,'  the total ocean surface area (u cells) =',1pe15.8,'cm**2'
     &/,'  the total ocean volume (u cells)       =',1pe15.8,'cm**3')
      end subroutine topog

#include "options.inc"


      module diag_float_module

c-----------------------------------------------------------------------
c     Floats are assumed to be of zero mass, neutrally buoyant and move
c     with the local three dimensional flow during each time step.
c     Initially, particles are randomly distributed within
c     the volume given by ptslon,ptelon, ...
c
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c
c     linked in the code in init_diag (initialization)
c     and diag (integration)
c     namelist parameter in spflame_module:
c        enable_diag_float (logical, .false. at default)
c        diag_float_file   (character, 'float.cdf' at default)
c
c     adapted to SPFLAME : mar 2002, C Eden
c-----------------------------------------------------------------------

      implicit none
      integer :: nptraj ! number of float
      real    :: ptslon, ptelon, ptslat, ptelat, ptsdpt, ptedpt
c     ptslon  = starting longitude for initial particle distribution
c     ptelon  = ending longitude for initial particle distribution
c     ptslat  = starting latitude for initial particle distribution
c     ptelat  = ending latitude for initial particle distribution
c     ptsdpt  = starting depth for initial particle distribution
c     ptedpt  = ending depth for initial particle distribution
c
      real, allocatable :: pxyz(:,:) 
c     pxyz    = particle coordinates. index (1,2,3) is for particle 
c               (longitude, latitude, depth).

      integer, allocatable :: pijk(:,:) 
c     pijk    = the particle is bounded by the volume with vertices
c               given by the eight nearest surrounding model grid points
c               on the "xu","yu", and "z" grids. index (1,2,3) locates
c               the (longitude, latitude, depth) index of the deepest 
c               northeast corner of this bounding volume.

      real, allocatable :: pdens(:)  ! potential density of particle
      real, allocatable :: pvolu(:)  ! volume transport of particle
      real, allocatable :: pvolv(:)  ! volume transport of particle

      real :: spval = -1.0e20
      logical, allocatable :: ptlost(:)

      logical :: set_dens_time_step_for_floats = .true.
      integer :: dens_time_step_for_floats = 0
      end module diag_float_module


      subroutine diag_float_init
      use spflame_module
      use diag_float_module
      implicit none
      integer :: io,n,i,j
      character (len=80) :: name,unit
      character (len=32) :: stamp
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer :: iret,ncid,timedim,nrdim,xid,yid,zid,timeid,dims(4)
      integer :: rhoid,lat_tdim,lon_tdim,lat_tid,lon_tid,topoid
      integer :: voluid, volvid
#ifdef netcdf_real4
      real (kind=4), allocatable :: v2(:),v4(:,:)
#else
      real, allocatable          :: v2(:),v4(:,:)
#endif
#endif


      write(name,'("floats_",i3,".dta")') sub_domain
      call replace_space_zero(name)
      if (my_pe==0) then
        print*,' --> reading float data from restart file ',
     &        name(1:len_trim(name))
      endif

      call get_free_iounit(io)
      open(io,file=name,form='unformatted',status='old',err=20)
      read (io) stamp
      read (io) nptraj
      if (my_pe==0) print*,' found ',nptraj,' in file (at ',stamp,')'
      allocate( pxyz(3,nptraj) )
      allocate( pijk(3,nptraj) )
      allocate( ptlost(nptraj) ); ptlost = .false.
      allocate( pdens(nptraj) )
      allocate( pvolu(nptraj) )
      allocate( pvolv(nptraj) )

      if (my_pe==0) read (io) pxyz,pijk,pvolu,pvolv
      close (io)

      call bcast_real(pxyz,3*nptraj,0)
      call bcast_integer(pijk,3*nptraj,0)
      call bcast_real(pvolu,nptraj,0)
      call bcast_real(pvolv,nptraj,0)

      goto 30

 20   if (my_pe==0) then
        print*,''
        print*,'---------------------------------------------'
        print*,' WARNING : cannot read file ',name(1:len_trim(name))
        print*,'---------------------------------------------'
        print*,''
        print*,' initialising floats therefore as follows'
      endif
c      
c-----------------------------------------------------------------------
c     distribute particles within volume defined using starting and
c     ending longitudes, latitudes, and depths given by 
c     ptslon, ptelon, ptslat, ptelat. ptsdpt, and ptedpt.
c-----------------------------------------------------------------------
c
c     begin of USER input
c
c      nptraj = 500
c      ptslon = 303.9   ! 
c      ptelon = 304.1   ! 
c      ptslat = 9.0
c      ptelat = 10.0
c      ptsdpt = 1000.e2
c      ptedpt = 3200.e2

      allocate( pxyz(3,nptraj) )
      allocate( pijk(3,nptraj) )
      allocate( pdens(nptraj) )
      allocate( pvolu(nptraj) )
      allocate( pvolv(nptraj) )
      allocate( ptlost(nptraj) ); ptlost = .false.
      call diag_float_dist (1, nptraj)    
      if (ptslat==ptelat) then
        call diag_float_dist_meridional (1,nptraj)
      else
       call diag_float_dist (1, nptraj)    
      endif
      call diag_float_vol     
c
c     end of USER input
c
 30   continue

#ifdef netcdf_diagnostics
c
c     initialize netcdf file
c
      if (my_pe == 0) then
       print*,' initializing NetCDF output file ',
     &          diag_float_file(1:len_trim(diag_float_file))
       ncid = nccre (diag_float_file, NCCLOB, iret)
       iret=nf_set_fill(ncid, NF_NOFILL, iret)
       call store_info_cdf(ncid)
c      dimensions
       Timedim   = ncddef(ncid,'Time', nf_unlimited, iret)
       nrdim     = ncddef(ncid,'Nr  ', nptraj, iret)
       lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
       lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
c      variables
       Lon_tid = ncvdef(ncid,'Longitude_t',NCFLOAT,1,lon_tdim,iret)
       Lat_tid = ncvdef(ncid,'Latitude_t', NCFLOAT,1,lat_tdim,iret)
       Timeid   =  ncvdef(ncid,'Time', NCFLOAT,1,timedim,iret)
       name = 'Time'; unit = 'days'
       call ncaptc(ncid,Timeid, 'long_name', NCCHAR,4, name, iret) 
       call ncaptc(ncid,Timeid, 'units',    NCCHAR,4, unit, iret) 
       call ncaptc(ncid,Timeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
       dims=(/nrdim,timedim,1,1/)
       xid=ncvdef (ncid,'lon', NCFLOAT,2,dims,iret)
       yid=ncvdef (ncid,'lat', NCFLOAT,2,dims,iret)
       zid=ncvdef (ncid,'depth', NCFLOAT,2,dims,iret)
       rhoid=ncvdef (ncid,'rho', NCFLOAT,2,dims,iret)
       voluid=ncvdef (ncid,'volu', NCFLOAT,1,dims,iret)
       volvid=ncvdef (ncid,'volv', NCFLOAT,1,dims,iret)
       name = 'Longitude on T grid'; unit = 'degrees_W'
       call dvcdf(ncid,xid,name,len_trim(name),unit,
     &            len_trim(unit),spval)
       name = 'Latitude on T grid'; unit = 'degrees_N'
       call dvcdf(ncid,yid,name,len_trim(name),unit,
     &            len_trim(unit),spval)
       name = 'Depth on T grid'; unit = 'm'
       call dvcdf(ncid,zid,name,len_trim(name),unit,
     &            len_trim(unit),spval)
       name = 'Potential density'; unit = 'kg/m^3'
       call dvcdf(ncid,rhoid,name,len_trim(name),unit,
     &            len_trim(unit),spval)
       name = 'Zonal volume transport of particle'; unit = 'm^3/s'
       call dvcdf(ncid,voluid,name,len_trim(name),unit,
     &            len_trim(unit),spval)
       name = 'Meridional volume transport of particle'; unit = 'm^3/s'
       call dvcdf(ncid,volvid,name,len_trim(name),unit,
     &            len_trim(unit),spval)
       dims=(/lon_tdim,lat_tdim,1,1/)
       topoid=ncvdef (ncid,'topo', NCFLOAT,2,dims,iret)
       call ncendf(ncid, iret)
       allocate( v4(imt,jmt) ); v4=0.0
       do i=1,imt
        do j=1,jmt
          if (kmt_big(i,j)>0) v4(i,j)=zw(kmt_big(i,j) )/100.0
        enddo
       enddo
       call ncvpt(ncid, topoid, (/1,1/), (/imt,jmt/),v4, iret)
       deallocate(v4)
       allocate( v2(max(imt,jmt,km)) )
       v2(1:imt)=xt
       call ncvpt(ncid, Lon_tid, 1, imt,v2, iret)
       v2(1:jmt)=yt
       call ncvpt(ncid, Lat_tid, 1, jmt,v2, iret)
       deallocate(v2)

       allocate( v2(nptraj) )
       v2=pvolu; call ncvpt(ncid, voluid, 1, nptraj,v2, iret)
       v2=pvolv; call ncvpt(ncid, volvid, 1, nptraj,v2, iret)
       deallocate(v2)

       call ncclos (ncid, iret)
      endif
#endif
      end subroutine diag_float_init




      subroutine diag_float_vol
c
c-----------------------------------------------------------------------
c    relate transport to particles
c-----------------------------------------------------------------------
c
      use spflame_module
      use diag_float_module
      implicit none
      integer :: i,j,k,count,m,n
      logical, dimension(nptraj) :: ptdone
      integer :: is,ie,js,je

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      ptdone(1:nptraj) = .false.
      do n=1,nptraj
       if (pijk(1,n) >= is .and. pijk(1,n) <= ie_pe .and.
     &      pijk(2,n) >= js .and. pijk(2,n) <= je_pe .and.
     &      pijk(3,n) > 1   .and. pijk(3,n) <= km    ) then
          count=0
          i  = pijk(1,n)
          j  = pijk(2,n)
          k  = pijk(3,n)
          do m=1,nptraj
            if ( pijk(1,m) == i .and.
     &            pijk(2,m) == j .and.
     &            pijk(3,m) == k ) count=count+1
          enddo
          pvolv(n)=0.5*( u(i,k,j,2,tau)+u(i,k+1,j,2,tau) )/count
     &         *dxu(i)*csu(j)*dzw(k)/1e6
          pvolu(n)=0.5*( u(i,k,j,1,tau)+u(i,k+1,j,1,tau) )/count
     &         *dyu(j)*dzw(k)/1e6
          ptdone(n)=.true.
       endif
      enddo
c
c-----------------------------------------------------------------------
c     exchange informations around the PEs
c-----------------------------------------------------------------------
c
      do n=1,nptraj
        if (.not. ptdone(n) ) then
          pvolu(n)=0.
          pvolv(n)=0
        endif
        call global_sum_vec(pvolu(n),1)
        call global_sum_vec(pvolv(n),1)
      enddo
      end subroutine diag_float_vol


      subroutine diag_float_dist (ns, ne)
c
c=======================================================================
c     distribute n particles (ne-ns+1) within volume given by
c     ptslon, ptelon, ptslat, ptelat, ptsdpt, ptedpt by uniformly
c     placing approximately n**(1/3) particles along each dimension
c
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c=======================================================================
c
      use spflame_module
      use diag_float_module
      implicit none
      integer :: ns,ne,n,i,k,j,indp
      real :: fxa,cubr,distx,disty,distz

c
      if (ns .gt. nptraj .or. ne .gt. nptraj) then
        write (6,*) ' => Error: ns=',ns,', ne=',ne
	call halt_stop(' in diag_pdist')
      endif
c
c-----------------------------------------------------------------------
c     constrain the volume (containing starting positions of
c     particles) to lie within the model domain.      
c-----------------------------------------------------------------------
c
      if (ptslon .lt. xu(2))     ptslon = xu(2)
      if (ptslon .gt. xu(imt-1)) ptslon = xu(imt-1)
      if (ptslat .lt. yu(1))     ptslat = yu(1)
      if (ptslat .gt. yu(jmt-1)) ptslat = yu(jmt-1)
      if (ptsdpt .lt. zt(1))     ptsdpt = zt(1)
      if (ptsdpt .gt. zt(km))    ptsdpt = zt(km)
c
      if (ptelon .lt. xu(2))     ptelon = xu(2)
      if (ptelon .gt. xu(imt-1)) ptelon = xu(imt-1)
      if (ptelat .lt. yu(1))     ptelat = yu(1)
      if (ptelat .gt. yu(jmt-1)) ptelat = yu(jmt-1)
      if (ptedpt .lt. zt(1))     ptedpt = zt(1)
      if (ptedpt .gt. zt(km))    ptedpt = zt(km)
c
      if (ptslon .gt. ptelon) then
        fxa    = ptslon
        ptslon = ptelon
        ptelon = fxa
      endif
      if (ptslat .gt. ptelat) then
        fxa    = ptslat
        ptslat = ptelat
        ptelat = fxa
      endif
      if (ptsdpt .gt. ptedpt) then
        fxa    = ptsdpt
        ptsdpt = ptedpt
        ptedpt = fxa
      endif
c
c-----------------------------------------------------------------------
c     distribute the particles throughout the volume
c-----------------------------------------------------------------------
c
      cubr       = (float(ne-ns+1))**0.333333
      distx      = (ptelon - ptslon)/cubr
      disty      = (ptelat - ptslat)/cubr
      distz      = (ptedpt - ptsdpt)/cubr
      pxyz(1,ns) = .5*distx + ptslon
      pxyz(2,ns) = .5*disty + ptslat
      pxyz(3,ns) = .5*distz + ptsdpt
      do n=ns,ne
        if (n .gt. ns) then
	  pxyz(1,n) = pxyz(1,n-1)
	  pxyz(2,n) = pxyz(2,n-1)
	  pxyz(3,n) = pxyz(3,n-1)
	endif
	pxyz(1,n)  = pxyz(1,n) + distx
	if (pxyz(1,n) .gt. ptelon) then
	  pxyz(1,n) = ptslon + (pxyz(1,n)-ptelon)
	  pxyz(2,n) = pxyz(2,n) + disty
	  if (pxyz(2,n) .gt. ptelat) then
	    pxyz(2,n) = ptslat + (pxyz(2,n)-ptelat)
	    pxyz(3,n) = pxyz(3,n) + distz
	  endif
	endif
c
        i = indp (pxyz(1,n), xu, imt)
        if (xu(i) .gt. pxyz(1,n)) then
          pijk(1,n) = i
        else
          pijk(1,n) = i+1
        endif
c
        j = indp (pxyz(2,n), yu, jmt)
        if (yu(j) .gt. pxyz(2,n)) then
          pijk(2,n) = j
        else
          pijk(2,n) = j+1
        endif
c
        k = indp (pxyz(3,n), zt, km)
        if (zt(k) .gt. pxyz(3,n)) then
          pijk(3,n) = k
        else
          pijk(3,n) = k+1
        endif
      enddo


      if (my_pe==0) then
       write (6,9000)
       write (6,*) ne-ns+1,' particles were initialized',
     &           ' to lie within the volume described by:'
       write (6,'(1x,f8.2," < lon <",f8.2)') ptslon, ptelon
       write (6,'(1x,f8.2," < lat <",f8.2)') ptslat, ptelat
       write (6,'(1x,e10.3," < dpt < ",e10.3)') ptsdpt, ptedpt
       write (6,*) ' '
      endif

9000  format (/20x,'P A R T I C L E    I N I T I A L I Z A T I O N'/)

      end subroutine diag_float_dist 




      subroutine diag_float_dist_meridional (ns, ne)
c
c=======================================================================
c     distribute n particles (ne-ns+1) within volume given by
c     ptslon, ptelon, ptslat, ptelat, ptsdpt, ptedpt by uniformly
c     placing approximately n**(1/2) particles along each dimension
c
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c=======================================================================
c
      use spflame_module
      use diag_float_module
      implicit none
      integer :: ns,ne,n,i,k,j,indp
      real :: fxa,cubr,distx,disty,distz

c
      if (ns .gt. nptraj .or. ne .gt. nptraj) then
        write (6,*) ' => Error: ns=',ns,', ne=',ne
	call halt_stop(' in diag_pdist')
      endif
c
c-----------------------------------------------------------------------
c     constrain the volume (containing starting positions of
c     particles) to lie within the model domain.      
c-----------------------------------------------------------------------
c
      if (ptslon .lt. xu(2))     ptslon = xu(2)
      if (ptslon .gt. xu(imt-1)) ptslon = xu(imt-1)
      if (ptslat .lt. yu(1))     ptslat = yu(1)
      if (ptslat .gt. yu(jmt-1)) ptslat = yu(jmt-1)
      if (ptsdpt .lt. zt(1))     ptsdpt = zt(1)
      if (ptsdpt .gt. zt(km))    ptsdpt = zt(km)
c
      if (ptelon .lt. xu(2))     ptelon = xu(2)
      if (ptelon .gt. xu(imt-1)) ptelon = xu(imt-1)
      if (ptelat .lt. yu(1))     ptelat = yu(1)
      if (ptelat .gt. yu(jmt-1)) ptelat = yu(jmt-1)
      if (ptedpt .lt. zt(1))     ptedpt = zt(1)
      if (ptedpt .gt. zt(km))    ptedpt = zt(km)
c
      if (ptslon .gt. ptelon) then
        fxa    = ptslon
        ptslon = ptelon
        ptelon = fxa
      endif
      if (ptslat .gt. ptelat) then
        fxa    = ptslat
        ptslat = ptelat
        ptelat = fxa
      endif
      if (ptsdpt .gt. ptedpt) then
        fxa    = ptsdpt
        ptsdpt = ptedpt
        ptedpt = fxa
      endif
c
c-----------------------------------------------------------------------
c     distribute the particles throughout the volume
c-----------------------------------------------------------------------
c
      cubr       = (float(ne-ns+1))**0.5
      distx      = (ptelon - ptslon)/cubr
      disty      = (ptelat - ptslat)/cubr
      distz      = (ptedpt - ptsdpt)/cubr
      pxyz(1,ns) = .5*distx + ptslon
      pxyz(2,ns) = ptslat
      pxyz(3,ns) = .5*distz + ptsdpt
      do n=ns,ne
        if (n .gt. ns) then
	  pxyz(1,n) = pxyz(1,n-1)
	  pxyz(2,n) = pxyz(2,n-1)
	  pxyz(3,n) = pxyz(3,n-1)
	endif
	pxyz(1,n)  = pxyz(1,n) + distx
	if (pxyz(1,n) .gt. ptelon) then
	  pxyz(1,n) = ptslon + (pxyz(1,n)-ptelon)
	  pxyz(3,n) = pxyz(3,n) + distz
	endif
c
        i = indp (pxyz(1,n), xu, imt)
        if (xu(i) .gt. pxyz(1,n)) then
          pijk(1,n) = i
        else
          pijk(1,n) = i+1
        endif
c
        j = indp (pxyz(2,n), yu, jmt)
        if (yu(j) .gt. pxyz(2,n)) then
          pijk(2,n) = j
        else
          pijk(2,n) = j+1
        endif
c
        k = indp (pxyz(3,n), zt, km)
        if (zt(k) .gt. pxyz(3,n)) then
          pijk(3,n) = k
        else
          pijk(3,n) = k+1
        endif
      enddo


      if (my_pe==0) then
       write (6,9000)
       write (6,*) ne-ns+1,' particles were initialized',
     &           ' to lie within the section described by:'
       write (6,'(1x,f8.2," < lon <",f8.2)') ptslon, ptelon
       print*, 'lat=',ptslat
       write (6,'(1x,e10.3," < dpt < ",e10.3)') ptsdpt, ptedpt
       write (6,*) ' '
      endif

9000  format (/20x,'P A R T I C L E    I N I T I A L I Z A T I O N'/)

      end subroutine diag_float_dist_meridional






      subroutine diag_float
c=======================================================================
c     integrate particle trajectories
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c=======================================================================
      use spflame_module
      use diag_float_module
      implicit none
      integer :: n,j,i,k,m
      real :: cmdeg, rcos
      real :: xold,yold,zold
      real :: xe,xw,yn,ys,za,zb,dv
      real :: xeyszb, xwyszb, xeysza, xwysza, xeynzb, xwynzb 
      real :: xeynza, xwynza , uu, vv, ww
      logical, dimension(nptraj) :: ptdone
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer :: iret,ncid,timedim,xid,yid,zid,timeid
      integer :: rhoid
      integer :: corner(2),edges(2)
#ifdef netcdf_real4
      real (kind=4) :: v4(nptraj)
#else
      real          :: v4(nptraj)
#endif
#else
      integer :: io
#endif
      integer :: is,ie,js,je

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c     boundary exchange for vertical velocity
c     (this is a bit odd but no way around)
c
      call border_exchg(adv_vbu,km+1,1)
      call set_cyclic(adv_vbu,km+1,1)
c
c
      ptdone(1:nptraj) = .false.
      cmdeg  = 8.982799e-8
c
c-----------------------------------------------------------------------
c    calculate trajectory for all particles 
c-----------------------------------------------------------------------
c
      do n=1,nptraj

        if (.not. ptlost(n) .and.
     &      pijk(1,n) >= is .and. pijk(1,n) <= ie_pe .and.
     &      pijk(2,n) >= js .and. pijk(2,n) <= je_pe .and.
     &      pijk(3,n) > 1   .and. pijk(3,n) <= km    ) then

          ptdone(n) = .true.
c
c-----------------------------------------------------------------------
c         the particle is bounded by the volume with vertices given by
c         the eight nearest surrounding model grid points on the "xu",
c         "yu", and "zt" grids. (i,j,k) is the index of the deepest 
c         northeast corner of this bounding volume.
c-----------------------------------------------------------------------
c         
          i  = pijk(1,n)
          j  = pijk(2,n)
          k  = pijk(3,n)
c
c-----------------------------------------------------------------------
c         compute volume weights for linear interpolation of velocity
c         at vertices of bounding volume to the particle position.
c
c         distances between particle and bounding volume faces
c
c         xe = distance to the east face
c         xw = distance to the west face
c         yn = distance to the north face
c         ys = distance to the south face
c         za = distance above to the top face
c         zb = distance below to the bottom face
c-----------------------------------------------------------------------
c

          xe = (xu(i) - pxyz(1,n))
          xw = (pxyz(1,n) - xu(i-1))
          yn = (yu(j) - pxyz(2,n))
          ys = (pxyz(2,n) - yu(j-1))
          za = (pxyz(3,n) - zt(k-1))
          zb = (zt(k) - pxyz(3,n))
	  dv = 1./((xu(i)-xu(i-1))*(yu(j)-yu(j-1))*(zt(k)-zt(k-1)))
c
c-----------------------------------------------------------------------
c         construct velocity at position of particle by 3-d linear
c         interpolation. 
c-----------------------------------------------------------------------
c
          xeyszb = xe*ys*zb*dv
          xwyszb = xw*ys*zb*dv
          xeysza = xe*ys*za*dv
          xwysza = xw*ys*za*dv
          xeynzb = xe*yn*zb*dv
          xwynzb = xw*yn*zb*dv
          xeynza = xe*yn*za*dv
          xwynza = xw*yn*za*dv
c          
          uu = u(i-1,k-1,j,1,tau)*xeyszb   + u(i,k-1,j,1,tau)*xwyszb
     &        +u(i-1,k  ,j,1,tau)*xeysza   + u(i,k  ,j,1,tau)*xwysza
     &        +u(i-1,k-1,j-1,1,tau)*xeynzb + u(i,k-1,j-1,1,tau)*xwynzb
     &        +u(i-1,k  ,j-1,1,tau)*xeynza + u(i,k  ,j-1,1,tau)*xwynza
c
          vv = u(i-1,k-1,j,2,tau)*xeyszb   + u(i,k-1,j,2,tau)*xwyszb
     &        +u(i-1,k  ,j,2,tau)*xeysza   + u(i,k  ,j,2,tau)*xwysza
     &        +u(i-1,k-1,j-1,2,tau)*xeynzb + u(i,k-1,j-1,2,tau)*xwynzb
     &        +u(i-1,k  ,j-1,2,tau)*xeynza + u(i,k  ,j-1,2,tau)*xwynza
c
c         interpolate vertical velocities at the bases of
c         the "u" cells.
c
          if (pxyz(3,n) .gt. zw(k-1)) then
	    za = pxyz(3,n) - zw(k-1)
	    zb = zw(k) - pxyz(3,n)
	    dv = 1./((xu(i)-xu(i-1))*(yu(j)-yu(j-1))
     &              *(zw(k)-zw(k-1)))
            xeyszb = xe*ys*zb*dv
            xwyszb = xw*ys*zb*dv
            xeysza = xe*ys*za*dv
            xwysza = xw*ys*za*dv
            xeynzb = xe*yn*zb*dv
            xwynzb = xw*yn*zb*dv
            xeynza = xe*yn*za*dv
            xwynza = xw*yn*za*dv
            ww=  adv_vbu(i-1,k-1,j)*xeyszb   + adv_vbu(i,k-1,j)*xwyszb
     &          +adv_vbu(i-1,k  ,j)*xeysza   + adv_vbu(i,k  ,j)*xwysza
     &          +adv_vbu(i-1,k-1,j-1)*xeynzb + adv_vbu(i,k-1,j-1)*xwynzb
     &          +adv_vbu(i-1,k  ,j-1)*xeynza + adv_vbu(i,k  ,j-1)*xwynza
	  else
	    if (k-2 .eq. 0) then
	      za = pxyz(3,n)
	      zb = zw(k-1) - pxyz(3,n)
	      dv = 1./((xu(i)-xu(i-1))*(yu(j)-yu(j-1))
     &              *(zw(k-1)-0.0))
	    else
	      za = pxyz(3,n) - zw(k-2)
	      zb = zw(k-1) - pxyz(3,n)
	      dv = 1./((xu(i)-xu(i-1))*(yu(j)-yu(j-1))
     &              *(zw(k-1)-zw(k-2)))
	    endif
            xeyszb = xe*ys*zb*dv
            xwyszb = xw*ys*zb*dv
            xeysza = xe*ys*za*dv
            xwysza = xw*ys*za*dv
            xeynzb = xe*yn*zb*dv
            xwynzb = xw*yn*zb*dv
            xeynza = xe*yn*za*dv
            xwynza = xw*yn*za*dv
            ww  =adv_vbu(i-1,k-2,j)*xeyszb   + adv_vbu(i,k-2,j)*xwyszb
     &          +adv_vbu(i-1,k-1,j)*xeysza   + adv_vbu(i,k-1,j)*xwysza
     &          +adv_vbu(i-1,k-2,j-1)*xeynzb + adv_vbu(i,k-2,j-1)*xwynzb
     &          +adv_vbu(i-1,k-1,j-1)*xeynza + adv_vbu(i,k-1,j-1)*xwynza
	  endif

c       if (my_pe==0.and.n==1) then
c        print*,' Float #1:',pxyz(1,1)-360.,pxyz(2,1),pxyz(3,1)
c        print*,' Float #1:',uu,vv,ww
c       endif
c
c-----------------------------------------------------------------------
c         remember where the particle was
c-----------------------------------------------------------------------
c
          xold = pxyz(1,n)
          yold = pxyz(2,n)
          zold = pxyz(3,n)
c
c-----------------------------------------------------------------------
c         integrate the particle trajectory forward for one time step
c         taking convergence of meridians into account.
c-----------------------------------------------------------------------
c
          rcos      = cmdeg/cos(pxyz(2,n)/180.*pi)
          pxyz(1,n) = pxyz(1,n) + dt*uu*rcos
          pxyz(2,n) = pxyz(2,n) + dt*vv*cmdeg
          pxyz(3,n) = pxyz(3,n) - dt*ww
c
c-----------------------------------------------------------------------
c         update bottom most northeast index of bounding volume
c-----------------------------------------------------------------------
c
          if (pxyz(1,n) .ge. xu(i)) then
            pijk(1,n) = i + 1
          else if (pxyz(1,n) .lt. xu(i-1)) then
            pijk(1,n) = i - 1
          endif
c
          if (pxyz(2,n) .ge. yu(j)) then
            pijk(2,n) = j + 1
          else if (pxyz(2,n) .lt. yu(j-1)) then
            pijk(2,n) = j - 1
          endif
c
          if (pxyz(3,n) .ge. zt(k)) then
            pijk(3,n) = k + 1
          else if (pxyz(3,n) .lt. zt(k-1)) then
            pijk(3,n) = k - 1
          endif
c
c-----------------------------------------------------------------------
c         do not allow any component of the trajectory to enter
c         land. If it does, reset it to its previous value
c         thereby simulating free slip conditions. hey... not perfect, 
c         but beats loosing particles in land. Also if the grid has
c         isolated "T,S" cells (ones where all eight surrounding
c         velocities are on land), replace references to "tmask(i,k,j)"
c         by umask(i,k,j) + umask(i-1,k,j) + umask(i,k,j-1) + 
c         umask(i-1,k,j-1) to prevent stagnation of particles if this
c         is a problem.
c-----------------------------------------------------------------------
c
          if (cyclic) then

           if (pijk(1,n) .gt. imt) then
c            if (tmask(3,k,j) .ne. 0) then
            if (kmt_big(3,j) >=k ) then
              pijk(1,n) = pijk(1,n) - (imt-2)
              i         = pijk(1,n)
              pxyz(1,n) = xu(i-1) + (pxyz(1,n)-xu(imt))
            else
              pijk(1,n) = i
              pxyz(1,n) = xold
            endif
           endif

           if (pijk(1,n) .lt. 2) then
c            if (tmask(imt-2,k,j) .ne. 0) then
            if (kmt_big(imt-2,j) >= k) then
              pijk(1,n) = pijk(1,n) + (imt-2)
              i         = pijk(1,n)
              pxyz(1,n) = xu(i-1) + (pxyz(1,n)-xu(1))
            else
              pijk(1,n) = i
              pxyz(1,n) = xold
            endif
           endif

          endif
c
c-----------------------------------------------------------------------
c         constrain particles vertically to lie within ocean
c-----------------------------------------------------------------------
c
          if (pijk(3,n) .ne. k) then
            if (pijk(3,n) .eq. 1 .or. pijk(3,n) .gt. km) then
              pxyz(3,n) = zold
              pijk(3,n) = k
            else if (pijk(3,n) .gt. k .and. tmask(i,k+1,j) ==0.) then
              pxyz(3,n) = zold
              pijk(3,n) = k
            endif
          endif
c
c-----------------------------------------------------------------------
c         constrain particles longitudinally to stay within ocean 
c-----------------------------------------------------------------------
c
          if (pijk(1,n) .ne. i) then
            if (pijk(1,n) .gt. i .and. tmask(i+1,k,j) ==0.) then
              pxyz(1,n) = xold
              pijk(1,n) = i
            else if (pijk(1,n) .lt. i .and. tmask(i-1,k,j) ==0.) then
              pxyz(1,n) = xold
              pijk(1,n) = i
            endif 
          endif 
c
c-----------------------------------------------------------------------
c         constrain particles latitudinally to stay within ocean 
c-----------------------------------------------------------------------
c
          if (pijk(2,n) .ne. j) then
            if (pijk(2,n) .gt. j .and. tmask(i,k,j+1) == 0. ) then
              pxyz(2,n) = yold
              pijk(2,n) = j
            else if (pijk(2,n) .lt. j .and. tmask(i,k,j-1) == 0.)
     &        then
              pxyz(2,n) = yold
              pijk(2,n) = j
            endif 
          endif 

c
c    potential density
c
         if (snapshot_time_step) then
          if (set_dens_time_step_for_floats) then
           m=tau
          else
           m=dens_time_step_for_floats
          endif
          i=pijk(1,n)
          j=pijk(2,n)
          k=pijk(3,n)
          pdens(n)=model_dens_scalar(t(i,k,j,1,m),t(i,k,j,2,m),1)
         endif

        endif ! inside model domain

      enddo ! nptraj
c
c-----------------------------------------------------------------------
c     exchange informations around the PEs
c-----------------------------------------------------------------------
c
      do n=1,nptraj

        if (.not. ptdone(n) ) then
          pxyz(:,n)=0.
          pijk(:,n)=0
          pdens(n)=0.
        endif

        call global_lor(ptdone(n))

        if (.not. ptdone(n) ) then

          if (my_pe==0 .and. .not. ptlost(n)  ) 
     &          print*,' Oops, float #',n,' was lost'

          ptlost(n) = .true.
          pxyz(:,n) = spval
          pijk(:,n) = -99

        else

          call global_sum_vec(pxyz(:,n),3)
          call global_sum_int(pijk(1,n))
          call global_sum_int(pijk(2,n))
          call global_sum_int(pijk(3,n))
          call global_sum_vec(pdens(n),1)
c
c         check positions to be safe, however no floats should be lost
c
          if (pxyz(1,n)<xu(1)  -dxudeg(1) .or.
     &        pxyz(1,n)>xu(imt)+dxudeg(imt)) then
           if (my_pe==0) then
            print*,' Oops, float #',n,' dropped outside domain'
            print*,' (zonally, positions : ',pxyz(:,n),' )'
           endif
           ptlost(n)= .true.; pxyz(:,n)=spval; pijk(:,n)=-99
          endif

          if ((pxyz(2,n) < yu(1)  -dyudeg(1) .or.
     &         pxyz(2,n)>yu(jmt)+dyudeg(jmt)).and.
     &        .not. ptlost(n) ) then
           if (my_pe==0) then
            print*,' Oops, float #',n,' dropped outside domain'
            print*,' (meridionally, positions : ',pxyz(:,n),' )'
           endif
           ptlost(n)= .true.; pxyz(:,n)=spval; pijk(:,n)=-99
          endif

          if ((pxyz(3,n) < zt(1) -dzt(1) .or.
     &         pxyz(3,n) > zt(km)+dzt(km))   .and.
     &        .not. ptlost(n) ) then
           if (my_pe==0) then
            print*,' Oops, float #',n,' dropped outside domain'
            print*,' (vertically, positions : ',pxyz(:,n),' )'
           endif
           ptlost(n)= .true.; pxyz(:,n)=spval; pijk(:,n)=-99
          endif

        endif

      enddo
c
c     Output to either NetCDF or binary file
c
      if (snapshot_time_step) then

       za=0.
       do n=1,nptraj
        if (ptlost(n)) za=za+1.
       enddo
       za=za/nptraj*100.

       if (my_pe==0) then
        print*,' --> writing float data to file ',
     &        diag_float_file(1:len_trim(diag_float_file))
        print*,'    (# of floats: ',nptraj,' ',za,'% already lost)'
       endif

#ifdef netcdf_diagnostics
c
c       write trajectories to NetCDF file
c
       if (my_pe==0) then
        iret=nf_open(diag_float_file,NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_varid(ncid,'lon',xid)
        iret=nf_inq_varid(ncid,'lat',yid)
        iret=nf_inq_varid(ncid,'depth',zid)
        iret=nf_inq_varid(ncid,'rho',rhoid)
        iret=nf_inq_varid(ncid,'Time',timeid)
        iret=nf_inq_dimid(ncid,'Time',timedim)
        iret=nf_inq_dimlen(ncid, timedim,k)
        k=k+1
        call read_stamp(current_stamp,za)
        print*,' at stamp=',current_stamp,
     &          ' (days since origin : ',za,')',
     &          ' (time steps in file : ',k,')'
        v4(1)=za
        iret= nf_put_vara_real (ncid,timeid, k,1,v4)
        corner=(/1,k/); edges = (/nptraj,1/)
        v4=pxyz(1,:)-360.
        iret= nf_put_vara_real (ncid,xid,corner,edges,v4)
        v4=pxyz(2,:)
        iret= nf_put_vara_real (ncid,yid,corner,edges,v4)
        v4=pxyz(3,:)/(-100.)
        iret= nf_put_vara_real (ncid,zid,corner,edges,v4)
        v4=pdens(:)*1000.0
        iret= nf_put_vara_real (ncid,rhoid,corner,edges,v4)
        call ncclos (ncid, iret)
       endif 

#else
c
c      write trajectories to binary file
c
       if (my_pe==0) then
        call getunit(io,diag_float_file,'usa ieee')
        write (io) current_stamp, itt
        write (io) nptraj
        write (io) pxyz
        close (io)
       endif
#endif
      endif
c
c     write a restart which can be read at the next run
c
      if (last_time_step) call write_float_restart()
      end subroutine diag_float



      subroutine write_float_restart
      use spflame_module
      use diag_float_module
      implicit none
      integer :: io
      character (len=80) :: name
      write(name,'("floats_",i3,".dta")') sub_domain
      call replace_space_zero(name)
      if (my_pe==0) then
        print*,' writing float data to restart file ',
     &        name(1:len_trim(name))
        call get_free_iounit(io)
        open(io,file=name,form='unformatted',status='unknown')
        write (io) current_stamp,itt
        write (io) nptraj
        write (io) pxyz,pijk,pvolu,pvolv
        close (io)
      endif
      end subroutine write_float_restart

#include "options.inc"


      module nc_util_module
      implicit none
      integer ::  memory = 1 !  0 high memory, 1 low memory
      logical :: verbose = .false.
!      logical :: verbose = .true.
      end module nc_util_module


      subroutine mult_variable(ncin,name,fx)
c=======================================================================
c   multiply variable name in open netcdf file ncin with 
c   constant factor fx
c=======================================================================
      use nc_util_module
      implicit none
      integer :: ncin
      character (len=*) :: name
      integer, parameter :: ndmax=100
      integer, dimension(ndmax)  :: dims,start,count,start2,count2
      integer :: iret,ndims,xtype,varin,n
      real , allocatable :: buf(:)
      integer :: buflen,i1,i2
      real :: spval,fx
#include "netcdf.inc"

      if (verbose) print*,' multiply variable ',name(1:len_trim(name)),
     &   ' with ',fx
      iret = NF_INQ_VARID(NCin,name,varin) 
      if (iret/=0) goto 20
      iret = NF_INQ_VARNDIMS(NCin, VARin, ndims)
      if (iret/=0) goto 20
      if (ndims>ndmax) then
        print*,' ERROR: number of dims exceed ',ndmax
        stop
      endif
      iret = NF_INQ_VARTYPE (NCin, VARin, xtype)
      iret = NF_INQ_VARdimid (NCin, VARin,dims)
      buflen=1
      if (memory==0 .or. ndims < 3) then
       do n=1,ndims
        start(n)=1
        iret=NF_INQ_DIMlen (NCin, DIMs(n), count(n))
        buflen=buflen*count(n)
       enddo
       allocate(buf(buflen))
       iret= nf_get_vara_real(ncin,varin,start,count,buf)
       iret = nf_get_att_real(ncin,varin, 'missing_value', spval) 
       if (iret==0) then
        if (verbose) print*,' found special value of ',spval
        where(buf/=spval) buf =buf*fx
       else
         buf =buf*fx
       endif
       iret= nf_put_vara_real(ncin,varin,start,count,buf)
       deallocate(buf)
      elseif (memory == 1) then

       do n=1,ndims
        start2(n)=1
        iret=NF_INQ_DIMlen (NCin, DIMs(n), count2(n))
       enddo
       do n=1,ndims-1
         buflen=buflen*count2(n)
       enddo
       allocate(buf(buflen))
       do i1=1,count2(ndims)
         if (verbose) print'(a,i5,a,i5)','  i=',i1,'/',count2(ndims)
         start=start2; count=count2
         start(ndims)=i1; count(ndims)=1
         iret= nf_get_vara_real(ncin,varin,start,count,buf)
         iret = nf_get_att_real(ncin,varin, 'missing_value', spval) 
         if (iret==0) then
           where(buf/=spval) buf =buf*fx
         else
           buf =buf*fx
         endif
         iret= nf_put_vara_real(ncin,varin,start,count,buf)
       enddo
       deallocate(buf)

      else
        print*,' ERROR: memory flag >1 '
        stop
      endif
      return
 20   print*,'ERROR: netcdf lib says:',nf_strerror(iret)
      stop
      end subroutine mult_variable


      subroutine add_to_variable(ncin,ncout,name)
c=======================================================================
c   add variable name in open netCDF file ncin to same
c   variable in open file ncout and store results in ncout
c   both file must be in data mode
c=======================================================================
      use nc_util_module
      implicit none
      integer :: ncin,ncout
      character (len=*) :: name
      integer, parameter :: ndmax=100
      integer, dimension(ndmax)  :: dims,start,count,start2,count2
      integer :: iret,ndims,xtype,varin,varout,n
      real , allocatable :: buf(:),buf2(:)
      integer :: buflen,i1,i2
      real :: spval
#include "netcdf.inc"

      if (verbose) print*,' adding to variable ',name(1:len_trim(name))
      iret = NF_INQ_VARID(NCin,name,varin) 
      if (iret/=0) goto 20
      iret = NF_INQ_VARNDIMS(NCin, VARin, ndims)
      if (ndims>ndmax) then
        print*,' ERROR: number of dims exceed ',ndmax
        stop
      endif
      iret = NF_INQ_VARTYPE (NCin, VARin, xtype)
      iret = NF_INQ_VARdimid (NCin, VARin,dims)
      iret = NF_INQ_VARID(NCout,name,varout) 
      if (iret/=0) goto 20
      buflen=1
      if (memory==0 .or. ndims < 3) then
       do n=1,ndims
        start(n)=1
        iret=NF_INQ_DIMlen (NCin, DIMs(n), count(n))
        buflen=buflen*count(n)
       enddo
       allocate(buf(buflen),buf2(buflen))
       iret= nf_get_vara_real(ncin,varin,start,count,buf)
       iret= nf_get_vara_real(ncout,varout,start,count,buf2)
       iret = nf_get_att_real(ncin,varin, 'missing_value', spval) 
       if (iret==0) then
        if (verbose) print*,' found special value of ',spval
        where(buf/=spval) buf =buf+buf2
       else
        buf =buf+buf2
       endif
       iret= nf_put_vara_real(ncout,varout,start,count,buf)
       deallocate(buf,buf2)
      elseif (memory == 1) then

       do n=1,ndims
        start2(n)=1
        iret=NF_INQ_DIMlen (NCin, DIMs(n), count2(n))
       enddo
       do n=1,ndims-1
         buflen=buflen*count2(n)
       enddo
       allocate(buf(buflen),buf2(buflen))
       do i1=1,count2(ndims)
         if (verbose) print'(a,i5,a,i5)','  i=',i1,'/',count2(ndims)
         start=start2; count=count2
         start(ndims)=i1; count(ndims)=1
         iret= nf_get_vara_real(ncin,varin,start,count,buf)
         iret= nf_get_vara_real(ncout,varout,start,count,buf2)
         iret = nf_get_att_real(ncin,varin, 'missing_value', spval) 
         if (iret==0) then
          where(buf/=spval) buf =buf+buf2
         else
           buf =buf+buf2
         endif
         iret= nf_put_vara_real(ncout,varout,start,count,buf)
       enddo
       deallocate(buf,buf2)
      else
        print*,' ERROR: memory flag >1 '
        stop
      endif
      return
 20   print*,'ERROR: netcdf lib says:',nf_strerror(iret)
      stop
      end subroutine add_to_variable



      recursive subroutine copy_variable(ncin,ncout,name,expand,nlen)
c=======================================================================
c   define variable name in ncin in ncout.
c   copy also values. both files must be in definition mode.
c   if expand = true then expand last dimension to nlen
c=======================================================================
      use nc_util_module
      implicit none
      integer  :: ncin,ncout
      character (len=*) :: name
      logical :: expand
      integer :: nlen
      integer :: iret,varin,xtype,ndims,natts,varout,n
      integer, parameter :: ndmax=100
      integer, dimension(ndmax)  :: dimin,dimout,start,count
      real , allocatable :: buf(:)
      integer :: buflen
      character (len=80) :: dimname
#include "netcdf.inc"
c    inquire
      iret=nf_sync(ncout)
      iret = NF_INQ_VARID(NCin,name,varin) 
      if (iret/=0) goto 20
      iret = NF_INQ_VARNDIMS(NCin, VARin, ndims)
      if (ndims>ndmax) then
        print*,' ERROR: number of dims exceed ',ndmax
        stop
      endif
      iret = NF_INQ_VAR (NCin, VARin,name,xtype, ndims,dimin, natts)
      if (verbose) then 
         print'(a,a,a,i3,a,i3,a,i3,a)',
     &  ' copying variable ',name(1:len_trim(name)),
     & ' (# of dims :',ndims,' # of attr :',natts,' type :',xtype,')'
         if (expand) print*,' expanding last dimension to ',nlen
      endif
c   define dimensions if needed, expand last dimension if requested
      do n=1,ndims
        dimname=''
        iret=NF_INQ_DIMNAME (NCin, DIMIn(n), dimname)
        iret=NF_INQ_DIMID(NCout,dimname,dimout(n)) 
        if (iret/=0) then 
          if (n==ndims) then
           call copy_dimension(ncin,ncout,dimname,expand,nlen)
          else
           call copy_dimension(ncin,ncout,dimname,.false.,0)
          endif
        endif
      enddo
c   define variable
      if (verbose) print*,' variable ',name(1:len_trim(name)),
     &            ' resides on the following dimensions'
      do n=1,ndims
        dimname=''
        iret=NF_INQ_DIMNAME (NCin, DIMIn(n), dimname)
        if (verbose) print*,dimname(1:len_trim(dimname))
        iret=NF_INQ_DIMID(NCout,dimname,dimout(n)) 
      enddo
      iret=NF_INQ_VARID(NCout,name,varout) 
      if (iret==0) return
      if (verbose) print*,' defining variable ',name(1:len_trim(name)),
     &   ' in output file'
      varout = ncvdef (ncout,name, xtype,ndims,dimout,iret)
c   define attributes
      do n=1,natts
       dimname=''
       iret= NF_INQ_ATTNAME (NCin, varin, n, dimname)
       iret= NF_COPY_ATT(NCIN, varin, dimname, NCOUT, varout)
      enddo
c   copy values of variable 
      iret = nf_enddef(ncout)
      buflen=1; start=1
      do n=1,ndims
        iret=NF_INQ_DIMlen (NCin, DIMIn(n), count(n))
        buflen=buflen*count(n)
      enddo
      if (xtype == ncdouble) buflen=buflen*2
      allocate(buf(buflen))
      if (xtype == nf_int .or. xtype == nf_float  .or.
     &    xtype == nf_byte .or. xtype == nf_short  .or.
     &    xtype == nf_char  ) then
       iret= nf_get_vara_real(ncin,varin,start,count,buf)
       iret= nf_put_vara_real(ncout,varout,start,count,buf)
      elseif (xtype == nf_double) then
       iret= nf_get_vara_double(ncin,varin,start,count,buf)
       iret= nf_put_vara_double(ncout,varout,start,count,buf)
      else
       print*,' do not know how to handle NCtype ',xtype
       stop
      endif
      deallocate(buf)
      iret = nf_redef(ncout)
      iret=nf_sync(ncout)
      return
 20   print*,'ERROR: netcdf lib says:',nf_strerror(iret)
      stop
      end subroutine copy_variable

      recursive subroutine copy_variable_novalues
&                         (ncin,ncout,name,expand,nlen)
c=======================================================================
c   define variable name in ncin in ncout.
c   but do not copy values of variable. both files must be in definition mode.
c   if expand = true then expand last dimension to nlen
c=======================================================================
      use nc_util_module
      implicit none
      integer  :: ncin,ncout
      character (len=*) :: name
      logical :: expand
      integer :: nlen
      integer :: iret,varin,xtype,ndims,natts,varout,n
      integer, parameter :: ndmax=100
      integer, dimension(ndmax)  :: dimin,dimout,start,count
      real , allocatable :: buf(:)
      integer :: buflen
      character (len=80) :: dimname
#include "netcdf.inc"
c    inquire
      iret=nf_sync(ncout)
      iret = NF_INQ_VARID(NCin,name,varin) 
      if (iret/=0) goto 20
      iret = NF_INQ_VARNDIMS(NCin, VARin, ndims)
      if (ndims>ndmax) then
        print*,' ERROR: number of dims exceed ',ndmax
        stop
      endif
      iret = NF_INQ_VAR (NCin, VARin,name,xtype, ndims,dimin, natts)
      if (verbose) then 
         print'(a,a,a,i3,a,i3,a,i3,a)',
     &  ' copying variable ',name(1:len_trim(name)),
     & ' (# of dims :',ndims,' # of attr :',natts,' type :',xtype,')'
         if (expand) print*,' expanding last dimension to ',nlen
      endif
c   define dimensions if needed, expand last dimension if requested
      do n=1,ndims
        dimname=''
        iret=NF_INQ_DIMNAME (NCin, DIMIn(n), dimname)
        iret=NF_INQ_DIMID(NCout,dimname,dimout(n)) 
        if (iret/=0) then 
          if (n==ndims) then
           call copy_dimension(ncin,ncout,dimname,expand,nlen)
          else
           call copy_dimension(ncin,ncout,dimname,.false.,0)
          endif
        endif
      enddo
c   define variable
      if (verbose) print*,' variable ',name(1:len_trim(name)),
     &            ' resides on the following dimensions'
      do n=1,ndims
        dimname=''
        iret=NF_INQ_DIMNAME (NCin, DIMIn(n), dimname)
        if (verbose) print*,dimname(1:len_trim(dimname))
        iret=NF_INQ_DIMID(NCout,dimname,dimout(n)) 
      enddo
      iret=NF_INQ_VARID(NCout,name,varout) 
      if (iret==0) return
      if (verbose) print*,' defining variable ',name(1:len_trim(name)),
     &   ' in output file'
      varout = ncvdef (ncout,name, xtype,ndims,dimout,iret)
c   define attributes
      do n=1,natts
       dimname=''
       iret= NF_INQ_ATTNAME (NCin, varin, n, dimname)
       iret= NF_COPY_ATT(NCIN, varin, dimname, NCOUT, varout)
      enddo
      iret=nf_sync(ncout)
      return
 20   print*,'ERROR: netcdf lib says:',nf_strerror(iret)
      stop
      end subroutine copy_variable_novalues


      
      recursive subroutine copy_dimension(ncin,ncout,name,expand,nlen)
c=======================================================================
c   copy dimension name from ncin to ncout
c   both files must be in definition mode
c   if expand = true then dimension to nlen
c=======================================================================
      use nc_util_module
      implicit none
      integer :: ncin,ncout
      character (len=*) :: name
      logical :: expand
      integer :: nlen
      integer :: iret,dimin,dimout,len,varin,varout,n,natts
      character (len=80) :: attname,s
#include "netcdf.inc"
      iret=nf_sync(ncout)
      iret=NF_INQ_DIMID(NCin,name,dimin) 
      if (iret/=0) goto 20
      iret= NF_INQ_DIMLEN (NCin, DIMin, len)
      if (verbose) then
       print*,' copying dimension ',name(1:len_trim(name)),
     &      ' (length :',len,')'
       if (expand) print*,' expanding dimension to ',nlen
      endif
      if (expand) len=nlen
      dimout = ncddef(ncout,name,len,iret)
      if (iret/=0) goto 20
      iret=NF_INQ_VARID(NCin,name,varin) 
      if (iret==0) then 
        iret=NF_INQ_VARID(NCout,name,varout) 
        if (iret/=0) call copy_variable(ncin,ncout,name,expand,nlen)       
c     care about pointers to other axis
        iret=NF_INQ_VARnatts(ncin,varin,natts) 
        do n=1,natts
         attname=''; iret= NF_INQ_ATTNAME (NCin, varin, n, attname)
         if (attname == 'edges' .or. attname == 'EDGES' ) then
          s='';iret= nf_get_att_text(ncin,varin,attname,s)
          if (verbose) print*,' found edges definition :', 
     &           s(1:len_trim(s)),', defining as well'
          iret=NF_INQ_varid(NCin,s,varin) 
          if (iret==0) then 
            call copy_variable(ncin,ncout,s,.false.,0)
          else
            if (verbose) print*,' cannot find variable ',
     &                   s(1:len_trim(s)),' in file'
          endif
         endif
        enddo

      endif
      iret=nf_sync(ncout)
      return
 20   print*,'ERROR: netcdf lib says:',nf_strerror(iret)
      stop
      end subroutine copy_dimension




      subroutine copy_file_attributes(ncin,ncout)
c=======================================================================
c   copy global attributes from ncin to ncout
c   both files must be in definition mode.
c=======================================================================
      use nc_util_module
      implicit none
      integer  :: ncin,ncout
      integer :: iret,natts,n
      character (len=80) :: name
#include "netcdf.inc"
c    inquire
      iret = NF_INQ_natts(NCin,natts) 
      if (iret/=0) goto 20
c   define attributes
      do n=1,natts
       name=''
       iret= NF_INQ_ATTNAME (NCin, nf_global, n, name)
       if (verbose) print*,'copying attribute : ',name
       iret= NF_COPY_ATT(NCIN, nf_global, name, NCOUT, nf_global)
      enddo
      return
 20   print*,'ERROR: netcdf lib says:',nf_strerror(iret)
      stop
      end subroutine copy_file_attributes





      subroutine search_nr_variables(ncin,nr)
c=======================================================================
c=======================================================================
      use nc_util_module
      implicit none
      integer :: ncin,nr,iret
      integer :: nd,n,m,nr2,i
      character (len=80) :: name,dname
#include "netcdf.inc"

      iret = NF_INQ_nvars(NCin,nr) 
      iret = NF_INQ_ndims(NCin,nd) 
      if (iret/=0) goto 20
c   search for axis variables
      nr2=nr
      do m=1,nr
        iret = NF_INQ_varname(NCin,m,name) 
        i=len_trim(name)
        do n=1,nd
         iret = NF_INQ_dimname(NCin,n,dname) 
         if (name(1:i) == dname(1:i) ) nr2=nr2-1
        enddo
      enddo
      nr=max(0,nr2)
      return
 20   print*,'ERROR: netcdf lib says:',nf_strerror(iret)
      stop
      end subroutine search_nr_variables




      subroutine search_variables(ncin,nri,name)
c=======================================================================
c=======================================================================
      use nc_util_module
      implicit none
      integer :: ncin,nr,iret,m,nd,nr2,nri,nn,n
      character (len=*) :: name(nri)
      character (len=80) :: vname,dname
      integer :: i
#include "netcdf.inc"
      iret = NF_INQ_nvars(NCin,nr) 
      iret = NF_INQ_ndims(NCin,nd) 
      nr2=nr
      if (iret/=0) goto 20
c   search for axis variables
      nn=1
      do m=1,nr
        iret = NF_INQ_varname(NCin,m,vname) 
        name(nn)=vname
        i=len_trim(vname)
        do n=1,nd
         iret = NF_INQ_dimname(NCin,n,dname) 
         if (vname(1:i) == dname(1:i) ) then
          nr2=nr2-1
          nn=nn-1
         endif
        enddo
        nn=nn+1
        if (nn>nri) goto 30
      enddo
      nr=max(0,nr2)


      return
 20   print*,'ERROR: netcdf lib says:',nf_strerror(iret)
      stop
 30   print*,'ERROR: variables count wrong'
      stop
      end subroutine search_variables

#include "options.inc"

c#define test_exchg
c
c-----------------------------------------------------------------------
c     all the routines which serve for the communication
c     between the sub domains are located here
c     c.eden
c-----------------------------------------------------------------------
c


      subroutine nmax_exchg(nmax)
c
c-----------------------------------------------------------------------
c     exchange number of time steps before communicate
c     over sub domain
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer nmax
#ifndef no_mpp
#include "sub_mpif.h"
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      integer ierr,tag,nchild,all_pes
      tag=0; if (mother<0) nmax=1
c     see if there is anybody out there
      call mpi_comm_size(mpi_comm_world,all_pes,ierr)
      if (all_pes == n_pes) return
      if (mother>0) then
       if (my_pe==0)
     &  call mpi_recv(nmax,1,impiinteger,sub_domain_pe0(mother),
     &                tag,mpi_comm_world,status,ierr)
       call mpi_bcast(nmax,1,impiinteger,0,my_comm,ierr)
       nmax=nmax*zoom_fac
      endif
      do nchild=1,nr_childs
        if (my_pe == 0)
     &   call mpi_send(nmax,1,impiinteger,
     &        sub_domain_pe0(childs(nchild)),
     &                 tag,mpi_comm_world,ierr)
      enddo
#else
      nmax=1
#endif
      end subroutine nmax_exchg

 
      subroutine index_send(is,ie,js,je)
c
c-----------------------------------------------------------------------
c     send starting and end indicees of this sub domain to mother
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer is,ie,js,je
#ifndef no_mpp
#include "sub_mpif.h"
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      integer ierr,tag,all_pes

      tag=101

      if (my_pe == 0) then
       call mpi_send(is_zoom,1,impiinteger,sub_domain_pe0(mother),
     &               tag,mpi_comm_world,ierr)
       call mpi_send(ie_zoom,1,impiinteger,sub_domain_pe0(mother),
     &              tag,mpi_comm_world,ierr)
       call mpi_send(js_zoom,1,impiinteger,sub_domain_pe0(mother),
     &               tag,mpi_comm_world,ierr)
       call mpi_send(je_zoom,1,impiinteger,sub_domain_pe0(mother),
     &               tag,mpi_comm_world,ierr)
      endif
#endif
      end subroutine index_send


 
      subroutine index_get(is,ie,js,je,n_domain)
c
c-----------------------------------------------------------------------
c     get the starting and end indicees of sub domain
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer is,ie,js,je,n_domain
#ifndef no_mpp
#include "sub_mpif.h"
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      integer ierr,tag,all_pes

      tag=101

      if (my_pe == 0) then
       call mpi_recv(is,1,impiinteger,sub_domain_pe0(n_domain),
     &               tag,mpi_comm_world,status,ierr)
       call mpi_recv(ie,1,impiinteger,sub_domain_pe0(n_domain),
     &               tag,mpi_comm_world,status,ierr)
       call mpi_recv(js,1,impiinteger,sub_domain_pe0(n_domain),
     &               tag,mpi_comm_world,status,ierr)
       call mpi_recv(je,1,impiinteger,sub_domain_pe0(n_domain),
     &               tag,mpi_comm_world,status,ierr)
      endif
      call mpi_bcast(is,1,impiinteger,0,my_comm,ierr)
      call mpi_bcast(ie,1,impiinteger,0,my_comm,ierr)
      call mpi_bcast(js,1,impiinteger,0,my_comm,ierr)
      call mpi_bcast(je,1,impiinteger,0,my_comm,ierr)
c      check for consistency
      if (is<1 .or. ie>imt .or. js<1 .or. je>jmt) then
        print*,' sub domain chosen by ',
     &         'is_zoom,ie_zoom,js_zoom,je_zoom=',is,ie,js,je
        print*,' must be inside mother domain given by imt,jmt=1,1,',
     &         imt,jmt
        print*,' adjust namelist input for sub_domain '
        call halt_stop(' in index_get')
      endif
#endif
      end subroutine index_get





      subroutine initial_exchg
c
c---------------------------------------------------------------
c     Exchange initial conditions over sub domains
c---------------------------------------------------------------
c
      use spflame_module
      implicit none
#ifndef no_mpp
#include "sub_mpif.h"
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      integer ierr,tag,all_pes,len
      integer is,ie,js,je,n,nn,nchild
      integer i,j,ii,jj,ismooth,k,kk
      real, allocatable :: buf(:,:,:,:,:),buf2(:,:,:,:)
      real, allocatable :: mbuf(:,:),cbuf(:,:)

c  see if there is anybody out there
      call mpi_comm_size(mpi_comm_world,all_pes,ierr)
      if (all_pes == n_pes) return
      tag=0

      if (mother>0) then
c
c      send a flag if initial conditions are needed
c
       i=1; if (read_restart) i=0
       if (my_pe==0) call send_world_integer(i,1,
     &                      sub_domain_pe0(mother),0)

       if (read_restart) then
c
c       read the restart 
c
        call read_restart_file
       else

        if (my_pe==0) print*,
     &     ' receiving initial conditions from mother domain'

c
c       get initial conditions from mother domain
c
        call index_send(is,ie,js,je)
c
c       receive T and S
c
        allocate(buf(is_zoom:ie_zoom,km_mother,js_zoom:je_zoom,2,2))
        buf=0.
        len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)*km_mother*2*2
        if (my_pe==0) 
     &   call mpi_recv(buf,len,impireal,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
        call mpi_bcast(buf,len,impireal,0,my_comm,ierr)
c
c       transfer coarse grid data to fine grid
c
        do k=1,km_mother
         do kk=(k-1)*zoom_fac_k + 1,k*zoom_fac_k  
          do j=js_zoom,je_zoom
           do ii=-zoom_fac/2,zoom_fac/2
            do jj=-zoom_fac/2,zoom_fac/2
             js=(j-js_zoom)*zoom_fac +jj+1
             do i=is_zoom,ie_zoom
              is=(i-is_zoom)*zoom_fac +ii+1
              if (is>=is_pe.and.is<=ie_pe.and.
     &            js>=js_pe.and.js<=je_pe ) then
                 t(is,kk,js,1:2,taum1)=buf(i,k,j,1:2,1)
                 t(is,kk,js,1:2,tau  )=buf(i,k,j,1:2,2)
              endif
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
c
c       extrapolate into blank areas and smooth
c
        is=zoom_fac/2
        allocate( mbuf(is_pe-is:ie_pe+is,js_pe-is:je_pe+is) )
        mbuf=0.
        do n=1,nt
         do k=1,km
          mbuf(is_pe:ie_pe,js_pe:je_pe)= 
     &             t(is_pe:ie_pe,k,js_pe:je_pe,n,tau)
          call border_exchg(mbuf,1,is)
          call extrapolate_hor(mbuf,is,-1.e23,'T',k)
          call border_exchg(mbuf,1,is)
          call smooth_hor(mbuf,is,'T',k)
          t(is_pe:ie_pe,k,js_pe:je_pe,n,tau)=
     &          mbuf(is_pe:ie_pe,js_pe:je_pe) 
          mbuf(is_pe:ie_pe,js_pe:je_pe)= 
     &             t(is_pe:ie_pe,k,js_pe:je_pe,n,taum1)
          call border_exchg(mbuf,1,is)
          call extrapolate_hor(mbuf,is,-1.e23,'T',k)
          call border_exchg(mbuf,1,is)
          call smooth_hor(mbuf,is,'T',k)
          t(is_pe:ie_pe,k,js_pe:je_pe,n,taum1)=
     &          mbuf(is_pe:ie_pe,js_pe:je_pe) 
         enddo
        enddo
        deallocate( mbuf)
c
c       receive U and V
c
        len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)
     &      *km_mother*2*2
        if (my_pe==0) 
     &   call mpi_recv(buf,len,impireal,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
        call mpi_bcast(buf,len,impireal,0,my_comm,ierr)
c
c       Note: velocity is only projected onto finer grid
c             errors arising since necessary extrapolating
c             is avoided here. However the blank areas should be
c             zero which is good.
c
c
c       transfer coarse grid data to fine grid
c
        do k=1,km_mother
         do kk=(k-1)*zoom_fac_k + 1,k*zoom_fac_k  
          do j=js_zoom,je_zoom
           do ii=-zoom_fac/2,zoom_fac/2
            do jj=-zoom_fac/2,zoom_fac/2
             js=(j-js_zoom)*zoom_fac + jj+1+zoom_fac/2
             do i=is_zoom,ie_zoom
              is=(i-is_zoom)*zoom_fac + ii+1+zoom_fac/2
              if (is>=is_pe.and.is<=ie_pe.and.
     &            js>=js_pe.and.js<=je_pe ) then
                 u(is,kk,js,1:2,taum1)=buf(i,k,j,1:2,1)
                 u(is,kk,js,1:2,tau  )=buf(i,k,j,1:2,2)
              endif
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
c
c       smooth velocity components
c
        is=zoom_fac/2
        allocate( mbuf(is_pe-is:ie_pe+is,js_pe-is:je_pe+is) )
        mbuf=0.
        do k=1,km
         do n=1,2
          mbuf(is_pe:ie_pe,js_pe:je_pe)= 
     &             u(is_pe:ie_pe,k,js_pe:je_pe,n,tau)
          call border_exchg(mbuf,1,is)
          call smooth_hor(mbuf,is,'U',k)
          u(is_pe:ie_pe,k,js_pe:je_pe,n,tau)=
     &          mbuf(is_pe:ie_pe,js_pe:je_pe) 
          mbuf(is_pe:ie_pe,js_pe:je_pe)= 
     &             u(is_pe:ie_pe,k,js_pe:je_pe,n,taum1)
          call border_exchg(mbuf,1,is)
          call smooth_hor(mbuf,is,'U',k)
          u(is_pe:ie_pe,k,js_pe:je_pe,n,taum1)=
     &          mbuf(is_pe:ie_pe,js_pe:je_pe) 
         enddo
        enddo
        deallocate( buf,mbuf)
c
c       receive psi
c
        allocate(buf(is_zoom:ie_zoom,1,js_zoom:je_zoom,1,1) )
        buf=0.; len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)
        if (my_pe==0) 
     &   call mpi_recv(buf,len,impireal,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
        call mpi_bcast(buf,len,impireal,0,my_comm,ierr)
c
c       transfer coarse grid data to fine grid
c
        do j=js_zoom,je_zoom
         do ii=-zoom_fac/2,zoom_fac/2
          do jj=-zoom_fac/2,zoom_fac/2
           js=(j-js_zoom)*zoom_fac +jj+1
           do i=is_zoom,ie_zoom
              is=(i-is_zoom)*zoom_fac +ii+1
              if (is>=is_pe.and.is<=ie_pe.and.
     &            js>=js_pe.and.js<=je_pe ) then
                psi(is,js,1)=buf(i,1,j,1,1)
                psi(is,js,2)=buf(i,1,j,1,1)
              endif
           enddo
          enddo
         enddo
        enddo
        deallocate(buf)
c
c       smooth psi, we have to adjust the boundary conditions
c       here in principle. However, neglect this at the moment
c
        is=zoom_fac/2
        allocate( mbuf(is_pe-is:ie_pe+is,js_pe-is:je_pe+is) )
        mbuf=0.
        mbuf(is_pe:ie_pe,js_pe:je_pe)= 
     &             psi(is_pe:ie_pe,js_pe:je_pe,1)
        call border_exchg(mbuf,1,is)
        call smooth_hor(mbuf,is,'T',1)
        psi(is_pe:ie_pe,js_pe:je_pe,1)=
     &          mbuf(is_pe:ie_pe,js_pe:je_pe) 
        mbuf(is_pe:ie_pe,js_pe:je_pe)= 
     &             psi(is_pe:ie_pe,js_pe:je_pe,2)
        call border_exchg(mbuf,1,is)
        call smooth_hor(mbuf,is,'T',1)
        psi(is_pe:ie_pe,js_pe:je_pe,2)=
     &          mbuf(is_pe:ie_pe,js_pe:je_pe) 
        deallocate( mbuf)

c       I do not care about that
        if (enable_ktmix) dml=0.

        itt_restart=1 ! restart_stamp, etc is exchanged afterwards
                      ! but here we have to make sure that mixing time
                      ! steps are reproducable, so do not exhange
                      ! itt_restart read from a restart

        if (my_pe==0) print*, ' done'

       endif  ! read_restart
c
c      receive informations about viscosity in mother domain
c
       call visc_parameter_exchg(-1)
c 
c      receive time stepping related stuff from mother
c
       if (my_pe == 0) then
        call mpi_recv(restart_stamp,32,mpi_character,
     &        sub_domain_pe0(mother),tag,mpi_comm_world,status,ierr)
        call mpi_recv(time_step,1,impireal,
     &        sub_domain_pe0(mother),tag,mpi_comm_world,status,ierr)
        call mpi_recv(runlen,1,impireal,
     &        sub_domain_pe0(mother),tag,mpi_comm_world,status,ierr)
        call mpi_recv(snap_int,1,impireal,
     &        sub_domain_pe0(mother),tag,mpi_comm_world,status,ierr)
       endif
       call mpi_bcast(restart_stamp,32,mpi_character,0,my_comm,ierr)
       call mpi_bcast(time_step,1,impireal,0,my_comm,ierr)
       call mpi_bcast(runlen,1,impireal,0,my_comm,ierr)
       call mpi_bcast(snap_int,1,impireal,0,my_comm,ierr)
       time_step=time_step/zoom_fac

      endif  ! mother >0
c
c     send initial conditions to sub domains
c
      do nchild=1,nr_childs
c
c      receive the flag from child
c
       if (my_pe==0) call recv_world_integer(i,1,
     &                      sub_domain_pe0(childs(nchild)),0)
       call bcast_integer(i,1,0)

       if (i==1) then

        if (my_pe==0) print*,
     &    ' sending initial conditions to child domain #',nchild
c
c       the child needs its initial conditions
c
        call index_get(is,ie,js,je,childs(nchild))
        allocate(buf(is:ie,km,js:je,2,2)); buf=0.
        allocate(cbuf(imt,jmt));cbuf=0.
c       collect t and s in buf
        do k=1,km
         do n=1,2
          do j=max(js_pe,js),min(je_pe,je)
           do i=max(is,is_pe),min(ie,ie_pe)
            cbuf(i,j)=t(i,k,j,n,tau)             
c           send also a mask
            if (tmask(i,k,j)==0.)cbuf(i,j)=-1e23
           enddo
          enddo
          call pe0_recv_2D(cbuf);
          buf(is:ie,k,js:je,n,1)=cbuf(is:ie,js:je) ! send just tau
          buf(is:ie,k,js:je,n,2)=cbuf(is:ie,js:je) ! instead of tau and taum1
         enddo
        enddo
c       send this stuff
        len=(ie-is+1)*(je-js+1)*km*2*2; 
        if (my_pe==0) 
     &   call mpi_send(buf,len,impireal,sub_domain_pe0(childs(nchild)),
     &                 tag,mpi_comm_world,ierr)
c       collect U and V in buf
        do k=1,km
         do n=1,2
          do j=max(js_pe,js),min(je_pe,je)
           do i=max(is,is_pe),min(ie,ie_pe)
            cbuf(i,j)=u(i,k,j,n,tau)            
           enddo
          enddo
          call pe0_recv_2D(cbuf);
          buf(is:ie,k,js:je,n,1)=cbuf(is:ie,js:je) ! send just tau
          buf(is:ie,k,js:je,n,2)=cbuf(is:ie,js:je) ! instead of tau and taum1
         enddo
        enddo
c       send this stuff
        len=(ie-is+1)*(je-js+1)*km*2*2; 
        if (my_pe==0) 
     &   call mpi_send(buf,len,impireal,sub_domain_pe0(childs(nchild)),
     &                 tag,mpi_comm_world,ierr)
c       collect psi
        do j=max(js_pe,js),min(je_pe,je)
          do i=max(is,is_pe),min(ie,ie_pe)
            cbuf(i,j)=psi(i,j,1)            
          enddo
        enddo
        call pe0_recv_2D(cbuf);
        buf(is:ie,1,js:je,1,1)=cbuf(is:ie,js:je)
c       send this stuff
        len=(ie-is+1)*(je-js+1); 
        if (my_pe==0) 
     &   call mpi_send(buf(is:ie,1,js:je,1,1),len,impireal,
     &                 sub_domain_pe0(childs(nchild)),tag,
     &                 mpi_comm_world,ierr)
        deallocate(buf,cbuf)

        if (my_pe==0) print*,' done '

       endif ! i==1
c
c      send informations about viscosity in this domain
c
       call visc_parameter_exchg(childs(nchild))
c 
c      send time stepping related stuff to child
c
       if (my_pe==0) then
        call mpi_send(restart_stamp,32,mpi_character,
     &   sub_domain_pe0(childs(nchild)),tag,mpi_comm_world,ierr)
        call mpi_send(time_step,1,impireal,
     &   sub_domain_pe0(childs(nchild)),tag,mpi_comm_world,ierr)
        call mpi_send(runlen,1,impireal,
     &   sub_domain_pe0(childs(nchild)),tag,mpi_comm_world,ierr)
        call mpi_send(snap_int,1,impireal,
     &   sub_domain_pe0(childs(nchild)),tag,mpi_comm_world,ierr)
       endif
      enddo ! nchild
#endif
      end subroutine initial_exchg



      subroutine domain_exchg
c
c---------------------------------------------------------------
c     Exchange necessary data over sub domains
c---------------------------------------------------------------
c
      use spflame_module
      use blue_module
      implicit none
#ifndef no_mpp
#include "sub_mpif.h"
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      integer :: ierr,tag,all_pes,nchild,pe_child
      integer :: is,ie,js,je,len,idoit
      integer :: i,j,ii,jj,n,ismooth,k,nn,kk
      integer :: send_rho
      real, allocatable :: p_s(:),p_n(:),p_e(:),p_w(:)
      real, allocatable :: buf(:,:,:),buf2(:,:),buf3(:,:,:)
      real, allocatable :: buf4(:,:,:,:)
      real, allocatable :: cbuf(:,:)

c  see if there is anybody out there
      call mpi_comm_size(mpi_comm_world,all_pes,ierr)
      if (all_pes == n_pes) return
      tag=0

#ifdef test_exchg
      if (my_pe==0) print*,' exchanging data across sub domains '
#endif

      if (mother>0) then
c
c       send/receive data to/from mother
c
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' index exchg'
#endif
        call index_send(is,ie,js,je)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe, ' done'
#endif
        ismooth=zoom_fac/2
c       Note: if ismooth is greater than zoom_fac/2
c             umask/tmask must be also redimensioned
c
c       receive northern and southern streamfunction values
c
        allocate(p_s(is_zoom:ie_zoom),p_n(is_zoom:ie_zoom) )
        p_s=0.; p_n=0.; len=ie_zoom-is_zoom+1
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' receive psi 1'
#endif
        if (my_pe == 0) then
         call mpi_recv(p_s,len,impireal,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
         call mpi_recv(p_n,len,impireal,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
        endif
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe, ' done'
#endif
        call mpi_bcast(p_s,len,impireal,0,my_comm,ierr)
        call mpi_bcast(p_n,len,impireal,0,my_comm,ierr)
        do ii=-zoom_fac/2,zoom_fac/2
          do i=is_zoom,ie_zoom
           is=(i-is_zoom)*zoom_fac + ii+1
           if (is>=1.and.is<=imt) then
               psi_wall_south(is)=p_s(i)
               psi_wall_north(is)=p_n(i)
           endif
          enddo
        enddo
        deallocate( p_s,p_n)
c
c       smooth streamfunction at southern and northern border
c         
        is=ismooth
        call smooth_zonal(psi_wall_south(is_pe:ie_pe),is,2,1)
        call smooth_zonal(psi_wall_north(is_pe:ie_pe),is,jmt-1,1)
c
c       receive western and eastern streamfunction values
c
        allocate(p_w(js_zoom:je_zoom),p_e(js_zoom:je_zoom) )
        p_w=0.; p_e=0.; len=je_zoom-js_zoom+1
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' receive psi 2'
#endif
        if (my_pe == 0) then
         call mpi_recv(p_w,len,impireal,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
         call mpi_recv(p_e,len,impireal,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
        endif
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,' done'
#endif
        call mpi_bcast(p_w,len,impireal,0,my_comm,ierr)
        call mpi_bcast(p_e,len,impireal,0,my_comm,ierr)
        do jj=-zoom_fac/2,zoom_fac/2
           do j=js_zoom,je_zoom
            js=(j-js_zoom)*zoom_fac + jj+1
            if (js>=1.and.js<=jmt) then
               psi_wall_east(js)=p_e(j)
               psi_wall_west(js)=p_w(j)
            endif
           enddo
        enddo
        deallocate( p_e,p_w)
c
c       smooth streamfunction at eastern and western border
c         
        is=ismooth
        call smooth_merid(psi_wall_west(js_pe:je_pe),is,2,1)
        call smooth_merid(psi_wall_east(js_pe:je_pe),is,imt-1,1)
c
c       receive surface momentum fluxes values
c
        allocate(buf(is_zoom:ie_zoom,js_zoom:je_zoom,2) )
        buf=0.; len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)*2
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' reiceive tau'
#endif
        if (my_pe == 0) then
         call mpi_recv(buf,len,impireal,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
        endif
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,' done'
#endif
        call mpi_bcast(buf,len,impireal,0,my_comm,ierr)
        is=ismooth
        allocate(buf2(is_pe-is:ie_pe+is,js_pe-is:je_pe+is) )
        buf2=-1e23
        do n=1,2
c
c        transfer coarse grid wind stress to fine grid
c
         do j=js_zoom,je_zoom
          do ii=-zoom_fac/2,zoom_fac/2
           do jj=-zoom_fac/2,zoom_fac/2
             js=(j-js_zoom)*zoom_fac + jj+1+zoom_fac/2
             do i=is_zoom,ie_zoom
              is=(i-is_zoom)*zoom_fac + ii+1+zoom_fac/2
              if (is>=is_pe.and.is<=ie_pe.and.
     &            js>=js_pe.and.js<=je_pe ) buf2(is,js)=buf(i,j,n)
            enddo
           enddo
          enddo
         enddo
c
c        extrapolate wind stress into blank areas
c
         call border_exchg(buf2,1,ismooth)
         call extrapolate_hor(buf2,ismooth,-1.e23,'U',1)
c
c        now smooth surface momentum fluxes
c        which has nearly the same effect as interpolating
c
         call border_exchg(buf2,1,ismooth)
         call smooth_hor(buf2,ismooth,'U',1)
         smf(is_pe:ie_pe,js_pe:je_pe,n)=buf2(is_pe:ie_pe,js_pe:je_pe)

        enddo !n=1,2
        deallocate( buf,buf2)
c
c       receive restoring time scales and climatogical values
c       for the tracer fluxes 
c
        allocate(buf(is_zoom:ie_zoom,js_zoom:je_zoom,nt*2) )
        buf=0.
        len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)*nt*2
c
c       get number of tracers for which the fluxes are meant
c
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' receive tracer fluxes'
#endif
        if (my_pe == 0) 
     &    call mpi_recv(i,1,impiinteger,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,status,ierr)
        call mpi_bcast(i,1,impiinteger,0,my_comm,ierr)
        if (i/=nt) then
         if (my_pe==0) then
           print*,' ERROR:'
           print*,' number of restoring time scales and clim.'
           print*,' values do not match the number of tracer'
           print*,' in sub domain '
         endif
         call halt_stop(' in domain_exchg ')
        endif
        if (my_pe == 0) 
     &   call mpi_recv(buf,len,impireal,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,' done'
#endif
        call mpi_bcast(buf,len,impireal,0,my_comm,ierr)
c
c       transfer coarse grid data to fine grid
c
        do n=1,nt 
         do j=js_zoom,je_zoom
          do ii=-zoom_fac/2,zoom_fac/2
           do jj=-zoom_fac/2,zoom_fac/2
            js=(j-js_zoom)*zoom_fac + jj+1
            do i=is_zoom,ie_zoom
             is=(i-is_zoom)*zoom_fac + ii+1
             if (is>=is_pe.and.is<=ie_pe.and.
     &            js>=js_pe.and.js<=je_pe ) then
               stf_rest(is,js,n)=buf(i,j,n)
               stf_clim(is,js,n)=buf(i,j,n+nt)
             endif
            enddo
           enddo
          enddo
         enddo
        enddo
        deallocate( buf)
c
c       smooth tracer fluxes 
c
        is=zoom_fac/2
        allocate( buf2(is_pe-is:ie_pe+is,js_pe-is:je_pe+is) )
        buf2=0.
        do n=1,nt
         buf2(is_pe:ie_pe,js_pe:je_pe)= 
     &             stf_rest(is_pe:ie_pe,js_pe:je_pe,n)
         call border_exchg(buf2,1,is)
         call smooth_hor(buf2,is,'T',1)
         stf_rest(is_pe:ie_pe,js_pe:je_pe,n)= 
     &             buf2(is_pe:ie_pe,js_pe:je_pe)
         buf2(is_pe:ie_pe,js_pe:je_pe)= 
     &             stf_clim(is_pe:ie_pe,js_pe:je_pe,n)
         call border_exchg(buf2,1,is)
         call smooth_hor(buf2,is,'T',1)
         stf_clim(is_pe:ie_pe,js_pe:je_pe,n)= 
     &             buf2(is_pe:ie_pe,js_pe:je_pe)
        enddo
        deallocate( buf2)

        if (enable_ktmix.or.enable_tkemix) then
c
c        receive ustar fluxes
c
#ifdef test_exchg
         print*,' DOMAIN=',sub_domain, ' PE=',my_pe,' receive ktmix'
#endif
         allocate(buf(is_zoom:ie_zoom,js_zoom:je_zoom,1) )
         buf=0.; len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)
c
c        shake hands with mother domain
c
         if (my_pe == 0) then; i=1
          call mpi_send(i,1,impiinteger,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,ierr)
         endif
         if (my_pe == 0) 
     &   call mpi_recv(buf,len,impireal,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
         call mpi_bcast(buf,len,impireal,0,my_comm,ierr)
c
c        transfer coarse grid data to fine grid
c
         do j=js_zoom,je_zoom
          do ii=-zoom_fac/2,zoom_fac/2
           do jj=-zoom_fac/2,zoom_fac/2
            js=(j-js_zoom)*zoom_fac + jj+1
            do i=is_zoom,ie_zoom
             is=(i-is_zoom)*zoom_fac + ii+1
             if (is>=is_pe.and.is<=ie_pe.and.
     &            js>=js_pe.and.js<=je_pe ) then
               ustar(is,js)=buf(i,j,1)
             endif
            enddo
           enddo
          enddo
         enddo
         deallocate( buf)
c
c        smooth ustar 
c
         is=zoom_fac/2
         allocate( buf2(is_pe-is:ie_pe+is,js_pe-is:je_pe+is) )
         buf2=0.
         buf2(is_pe:ie_pe,js_pe:je_pe)=ustar(is_pe:ie_pe,js_pe:je_pe)
         call border_exchg(buf2,1,is)
         call smooth_hor(buf2,is,'T',1)
         ustar(is_pe:ie_pe,js_pe:je_pe)=buf2(is_pe:ie_pe,js_pe:je_pe)
         deallocate( buf2)

#ifdef test_exchg
         print*,' DOMAIN=',sub_domain, ' PE=',my_pe,' done'
#endif
        elseif (my_pe==0) then
c
c        send a signal that no ustar is wanted
c
         i=0; call mpi_send(i,1,impiinteger,sub_domain_pe0(mother),
     &                      tag,mpi_comm_world,ierr)

        endif ! enable_ktmix.or.enable_tkemix

#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' receive T.S. o.b.c.'
#endif
        allocate(buf(km_mother,js_zoom:je_zoom,2) ); buf=0.

        if (restore_TS_obc_west) then
c
c        receive western TS boundaries
c
         i=1; if (my_pe==0) 
     &    call mpi_send(i,1,impiinteger,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,ierr)
         len=(je_zoom-js_zoom+1)*2*km_mother
         if (my_pe == 0) 
     &    call mpi_recv(buf,len,impireal,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,status,ierr)
         call mpi_bcast(buf,len,impireal,0,my_comm,ierr)
c
c        transfer coarse grid data to fine grid
c
         do k=1,km_mother
          do kk=(k-1)*zoom_fac_k + 1,k*zoom_fac_k  
           do jj=-zoom_fac/2,zoom_fac/2
            do j=js_zoom,je_zoom
             js=(j-js_zoom)*zoom_fac + jj+1
             if (js>=js_pe.and.js<=je_pe ) then
              ts_obc_west(js,kk,1)=buf(k,j,1)
              ts_obc_west(js,kk,2)=buf(k,j,2)
             endif
            enddo
           enddo
          enddo
         enddo
c
c        smooth T and S
c
         ismooth=zoom_fac/2; is=ismooth
         call smooth_merid(ts_obc_west(:,:,1),is,2,km)
         call smooth_merid(ts_obc_west(:,:,2),is,2,km)

        else
         i=0   ! a signal that no western TS b.c. are needed
         if (my_pe==0) 
     &    call mpi_send(i,1,impiinteger,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,ierr)
        endif

        if (restore_TS_obc_east) then
c
c        receive eastern TS boundaries
c
         i=1; if (my_pe==0) 
     &    call mpi_send(i,1,impiinteger,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,ierr)
         len=(je_zoom-js_zoom+1)*2*km_mother
         if (my_pe == 0)
     &    call mpi_recv(buf,len,impireal,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,status,ierr)
         call mpi_bcast(buf,len,impireal,0,my_comm,ierr)
c
c        transfer coarse grid data to fine grid
c
         do k=1,km_mother
          do kk=(k-1)*zoom_fac_k + 1,k*zoom_fac_k  
           do jj=-zoom_fac/2,zoom_fac/2
            do j=js_zoom,je_zoom
             js=(j-js_zoom)*zoom_fac + jj+1
             if (js>=js_pe.and.js<=je_pe ) then
              ts_obc_east(js,kk,1)=buf(k,j,1)
              ts_obc_east(js,kk,2)=buf(k,j,2)
             endif
            enddo
           enddo
          enddo
         enddo
c
c        smooth T and S
c
         ismooth=zoom_fac/2; is=ismooth
         call smooth_merid(ts_obc_east(:,:,1),is,imt-1,km)
         call smooth_merid(ts_obc_east(:,:,2),is,imt-1,km)

        else
         i=0; if (my_pe==0) 
     &    call mpi_send(i,1,impiinteger,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,ierr)
        endif

        deallocate( buf)
        allocate(buf(is_zoom:ie_zoom,km_mother,2) ); buf=0.

        if (restore_TS_obc_south) then
c
c        receive southern TS boundaries
c
         i=1; if (my_pe==0) 
     &    call mpi_send(i,1,impiinteger,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,ierr)
         len=(ie_zoom-is_zoom+1)*2*km_mother
         if (my_pe == 0) 
     &     call mpi_recv(buf,len,impireal,sub_domain_pe0(mother),
     &                   tag,mpi_comm_world,status,ierr)
         call mpi_bcast(buf,len,impireal,0,my_comm,ierr)
c
c        transfer coarse grid data to fine grid
c
         do k=1,km_mother
          do kk=(k-1)*zoom_fac_k + 1,k*zoom_fac_k  
           do ii=-zoom_fac/2,zoom_fac/2
            do i=is_zoom,ie_zoom
             is=(i-is_zoom)*zoom_fac + ii+1
             if (is>=is_pe.and.is<=ie_pe ) then
              ts_obc_south(is,kk,1)=buf(i,k,1)
              ts_obc_south(is,kk,2)=buf(i,k,2)
             endif
            enddo
           enddo
          enddo
         enddo
c
c        smooth T and S
c
         ismooth=zoom_fac/2; is=ismooth
         call smooth_zonal(ts_obc_south(:,:,1),is,2,km)
         call smooth_zonal(ts_obc_south(:,:,2),is,2,km)

        else
         i=0; if (my_pe==0) 
     &    call mpi_send(i,1,impiinteger,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,ierr)
        endif

        if (restore_TS_obc_north) then
c
c        receive northern TS boundaries
c
         i=1; if (my_pe==0) 
     &    call mpi_send(i,1,impiinteger,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,ierr)
         len=(ie_zoom-is_zoom+1)*2*km_mother
         if (my_pe == 0) 
     &     call mpi_recv(buf,len,impireal,sub_domain_pe0(mother),
     &                   tag,mpi_comm_world,status,ierr)
         call mpi_bcast(buf,len,impireal,0,my_comm,ierr)
c
c        transfer coarse grid data to fine grid
c
         do k=1,km_mother
          do kk=(k-1)*zoom_fac_k + 1,k*zoom_fac_k  
           do ii=-zoom_fac/2,zoom_fac/2
            do i=is_zoom,ie_zoom
             is=(i-is_zoom)*zoom_fac + ii+1
             if (is>=is_pe.and.is<=ie_pe ) then
              ts_obc_north(is,kk,1)=buf(i,k,1)
              ts_obc_north(is,kk,2)=buf(i,k,2)
             endif
            enddo
           enddo
          enddo
         enddo
c
c        smooth T and S
c
         ismooth=zoom_fac/2; is=ismooth
         call smooth_zonal(ts_obc_north(:,:,1),is,jmt-1,km)
         call smooth_zonal(ts_obc_north(:,:,2),is,jmt-1,km)

        else
         i=0; if (my_pe==0) 
     &    call mpi_send(i,1,impiinteger,sub_domain_pe0(mother),
     &                  tag,mpi_comm_world,ierr)
        endif
        deallocate( buf)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif
c
c       send density for BLUE
c
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' send blue '
#endif
        if (my_pe==0) 
     &   call mpi_recv(idoit,1,impiinteger,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
        call mpi_bcast(idoit,1,impiinteger,0,my_comm,ierr)
        if (idoit==1) then
c
c        send flag whether rho or T and S is sended
c
#ifdef flame_density
         send_rho=1
#else
         send_rho=0
#endif
         if (my_pe == 0) call mpi_send(send_rho,1,impiinteger,
     &         sub_domain_pe0(mother), tag,mpi_comm_world,ierr)
         if (send_rho == 1) then
          allocate(buf4(is_zoom:ie_zoom,km_mother,js_zoom:je_zoom,1))
         else
          allocate(buf4(is_zoom:ie_zoom,km_mother,js_zoom:je_zoom,2))
         endif
         allocate(buf3(is_zoom:ie_zoom,km_mother,js_zoom:je_zoom) )
         allocate(buf2(is_zoom:ie_zoom,js_zoom:je_zoom) )
         buf2=0.; buf4=0.; buf3=0.
         do k=1,km_mother
          do i=is_zoom,ie_zoom
           do j=js_zoom,je_zoom
            n=0
            do ii=-zoom_fac/2,zoom_fac/2
             do jj=-zoom_fac/2,zoom_fac/2
              is=(i-is_zoom)*zoom_fac + ii+1
              js=(j-js_zoom)*zoom_fac + jj+1
              if (is>=is_pe.and.is<=ie_pe.and.
     &            js>=js_pe.and.js<=je_pe )  then
               if (send_rho==1) then
                buf4(i,k,j,1)=buf4(i,k,j,1)+rho(is,k,js)*tmask(is,k,js)
                n=n+tmask(is,k,js)
               else
                do kk=(k-1)*zoom_fac_k + 1,k*zoom_fac_k  
                 buf4(i,k,j,1)=buf4(i,k,j,1)+
     &                         t(is,kk,js,1,tau)*tmask(is,kk,js)
                 buf4(i,k,j,2)=buf4(i,k,j,2)+
     &                         t(is,kk,js,2,tau)*tmask(is,kk,js)
                 n=n+tmask(is,kk,js)
                enddo
               endif
              endif
             enddo
            enddo
            if (n>0) then
             buf4(i,k,j,:)=buf4(i,k,j,:)/n
             if (k==1) buf2(i,j)=1.
            endif
           enddo
          enddo
         enddo
         do n=1,n_pes-1
          if (my_pe==n) then
           len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)
           call mpi_send(buf2,len,impireal,0,
     &                   tag,my_comm,ierr)
           len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)*km_mother
           call mpi_send(buf4(:,:,:,1),len,impireal,0,
     &                   tag,my_comm,ierr)
           if (send_rho==0) then
            call mpi_send(buf4(:,:,:,2),len,impireal,0,
     &                    tag,my_comm,ierr)
           endif
          elseif (my_pe ==0) then
           len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)
           call mpi_recv(buf2,len,impireal,n,
     &                   tag,my_comm,status,ierr)
           len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)*km_mother
           call mpi_recv(buf3,len,impireal,n,
     &                   tag,my_comm,status,ierr)
           do k=1,km_mother
             where( buf2 == 1.) buf4(:,k,:,1)=buf3(:,k,:)
           enddo
           if (send_rho==0) then
            call mpi_recv(buf3,len,impireal,n,
     &                    tag,my_comm,status,ierr)
            do k=1,km_mother
             where( buf2 == 1.) buf4(:,k,:,2)=buf3(:,k,:)
            enddo
           endif
          endif
         enddo
         len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)*km_mother
         if (send_rho==0) len=len*2
         if (my_pe == 0) 
     &     call mpi_send(buf4,len,impireal,sub_domain_pe0(mother),
     &                   tag,mpi_comm_world,ierr)
         deallocate(buf4,buf2,buf3)
        endif ! idoit

#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done '
#endif

      endif ! mother>0


      do nchild=1,nr_childs
c
c       send/receive data to/from child
c
        allocate(cbuf(imt,jmt));cbuf=0.
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' domain_exchg, index_exchg'
#endif
        call index_get(is,ie,js,je,childs(nchild))
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif
        pe_child=sub_domain_pe0(childs(nchild))
c
c        send the streamfunction
c
        allocate(p_s(is:ie),p_n(is:ie),p_w(js:je),p_e(js:je) )
        p_s=0.; p_n=0.; p_w=0.; p_e=0.
c       get psi from other pes 
        do j=max(js_pe,js),min(je_pe,je)
          do i=max(is,is_pe),min(ie,ie_pe)
            cbuf(i,j)=psi(i,j,1)            
          enddo
        enddo
        call pe0_recv_2D(cbuf)
        p_s=cbuf(is:ie,js); p_n=cbuf(is:ie,je)
        p_w=cbuf(is,js:je); p_e=cbuf(ie,js:je)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' send psi'
#endif
        if (my_pe == 0) then
         len=ie-is+1
         call mpi_send(p_s,len,impireal,pe_child,
     &                 tag,mpi_comm_world,ierr)
         call mpi_send(p_n,len,impireal,pe_child,
     &                 tag,mpi_comm_world,ierr)
         len=je-js+1
         call mpi_send(p_w,len,impireal,pe_child,
     &                 tag,mpi_comm_world,ierr)
         call mpi_send(p_e,len,impireal,pe_child,
     &                 tag,mpi_comm_world,ierr)
        endif
        deallocate( p_n,p_s,p_e,p_w)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif
c
c       send the surface momentum fluxes
c
        allocate(buf(is:ie,js:je,2) );buf=0.
        do n=1,2
         do j=max(js_pe,js),min(je_pe,je)
          do i=max(is,is_pe),min(ie,ie_pe)
            cbuf(i,j)=smf(i,j,n)            
c           this is needed as a mask in sub domain
            if (umask(i,1,j)==0.) cbuf(i,j)=-1e23
          enddo
         enddo
         call pe0_recv_2D(cbuf)
         buf(is:ie,js:je,n)=cbuf(is:ie,js:je)
        enddo
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' send tau'
#endif
        if (my_pe == 0) then
         len=(ie-is+1)*(je-js+1)*2
         call mpi_send(buf,len,impireal,pe_child,
     &                 tag,mpi_comm_world,ierr)
        endif
        deallocate(buf)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif
c
c       send restoring time scales and climatogical values
c       for the tracer fluxes also
c
        allocate(buf(is:ie,js:je,nt*2) );buf=0.
        do n=1,nt
         do j=max(js_pe,js),min(je_pe,je)
          do i=max(is,is_pe),min(ie,ie_pe)
            cbuf(i,j)=stf_rest(i,j,n)            
          enddo
         enddo
         call pe0_recv_2D(cbuf)
         buf(is:ie,js:je,n)=cbuf(is:ie,js:je)
         do j=max(js_pe,js),min(je_pe,je)
          do i=max(is,is_pe),min(ie,ie_pe)
            cbuf(i,j)=stf_clim(i,j,n)            
          enddo
         enddo
         call pe0_recv_2D(cbuf)
         buf(is:ie,js:je,n+nt)=cbuf(is:ie,js:je)
        enddo
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' send tracer fluxes'
#endif
        if (my_pe == 0) then
c        numer of tracer fluxes which are send
         call mpi_send(nt,1,impiinteger,pe_child,
     &                 tag,mpi_comm_world,ierr)
         len=(ie-is+1)*(je-js+1)*nt*2
         call mpi_send(buf,len,impireal,pe_child,
     &                 tag,mpi_comm_world,ierr)
        endif
        deallocate(buf)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif
c
c       send ustar fluxes if requested
c
        if (my_pe == 0) call mpi_recv(i,1,impiinteger,pe_child,
     &                 tag,mpi_comm_world,status,ierr)
        call mpi_bcast(i,1,impiinteger,0,my_comm,ierr)
        if (i==1.and.(enable_ktmix.or.enable_tkemix)) then
#ifdef test_exchg
         print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &      ' send ktmix'
#endif
         allocate(buf(is:ie,js:je,1) ); buf=0.
         do j=max(js_pe,js),min(je_pe,je)
          do i=max(is,is_pe),min(ie,ie_pe)
            cbuf(i,j)=ustar(i,j)            
          enddo
         enddo
         call pe0_recv_2D(cbuf)
         buf(is:ie,js:je,1)=cbuf(is:ie,js:je)
         if (my_pe == 0) then
          len=(ie-is+1)*(je-js+1)
          call mpi_send(buf,len,impireal,pe_child,
     &                  tag,mpi_comm_world,ierr)
         endif
         deallocate(buf)
#ifdef test_exchg
         print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &      ' done'
#endif
        elseif (i==1 .and. .not. (enable_ktmix.or.enable_tkemix)) then
          print*,' cannot send ustar to sub domain '
          print*,' since sub domain #',sub_domain,
     &           ' has not Kraus Truner model or TKE scheme enabled'
          call halt_stop(' in domain_exchg ')
        endif
c
c       send TS at open boundaries
c
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' send TS o.b.c.'
#endif
        allocate(buf(km,js:je,2) );
        buf=0.; len=(je-js+1)*km*2
        if (my_pe == 0) call mpi_recv(i,1,impiinteger,pe_child,
     &                 tag,mpi_comm_world,status,ierr)
        call mpi_bcast(i,1,impiinteger,0,my_comm,ierr)
        if (i==1) then
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' send TS west'
#endif
         do n=1,2
          do k=1,km
           if (is>=is_pe.and.is<=ie_pe) then
            do j=max(js_pe,js),min(je_pe,je)
             cbuf(is,j)=t(is,k,j,n,tau)
            enddo
           endif
           call pe0_recv_2D(cbuf)
           buf(k,js:je,n)=cbuf(is,js:je)
          enddo
         enddo
         if (my_pe == 0) call mpi_send(buf,len,impireal,pe_child,
     &                   tag,mpi_comm_world,ierr)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif
        endif
        if (my_pe == 0) call mpi_recv(i,1,impiinteger,pe_child,
     &                 tag,mpi_comm_world,status,ierr)
        call mpi_bcast(i,1,impiinteger,0,my_comm,ierr)
        if (i==1) then
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' send TS east'
#endif
         do n=1,2
          do k=1,km
           if (ie>=is_pe.and.ie<=ie_pe) then
            do j=max(js_pe,js),min(je_pe,je)
             cbuf(ie,j)=t(ie,k,j,n,tau)
            enddo
           endif
           call pe0_recv_2D(cbuf)
           buf(k,js:je,n)=cbuf(ie,js:je)
          enddo
         enddo
         if (my_pe == 0) call mpi_send(buf,len,impireal,pe_child,
     &                   tag,mpi_comm_world,ierr)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif
        endif

        deallocate(buf); 
c        print*,'allocating',is,ie,km
        allocate(buf(is:ie,km,2) ); 
c        print*,' done'
        buf=0.; len=(ie-is+1)*km*2
        if (my_pe == 0) call mpi_recv(i,1,impiinteger,pe_child,
     &                 tag,mpi_comm_world,status,ierr)
        call mpi_bcast(i,1,impiinteger,0,my_comm,ierr)
        if (i==1) then
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' send TS southt'
#endif
         do n=1,2
          do k=1,km
           if (js>=js_pe.and.js<=je_pe) then
            do i=max(is_pe,is),min(ie_pe,ie)
             cbuf(i,js)=t(i,k,js,n,tau)
            enddo
           endif
           call pe0_recv_2D(cbuf)
           buf(is:ie,k,n)=cbuf(is:ie,js)
          enddo
         enddo
         if (my_pe == 0) call mpi_send(buf,len,impireal,pe_child,
     &                  tag,mpi_comm_world,ierr)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif
        endif
        if (my_pe == 0) call mpi_recv(i,1,impiinteger,pe_child,
     &                 tag,mpi_comm_world,status,ierr)
        call mpi_bcast(i,1,impiinteger,0,my_comm,ierr)
        if (i==1) then
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' send TS north'
#endif
         do n=1,2
          do k=1,km
           if (je>=js_pe.and.je<=je_pe) then
            do i=max(is_pe,is),min(ie_pe,ie)
             cbuf(i,je)=t(i,k,je,n,tau)
            enddo
           endif
           call pe0_recv_2D(cbuf)
           buf(is:ie,k,n)=cbuf(is:ie,je)
          enddo
         enddo
         if (my_pe == 0) call mpi_send(buf,len,impireal,pe_child,
     &                  tag,mpi_comm_world,ierr)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif
        endif
        deallocate(buf)
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif
#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' receive blue'
#endif
        if (enable_blue) then
c
c        receive density for BLUE
c
         idoit=1; if (my_pe==0) 
     &     call mpi_send(idoit,1,impiinteger,pe_child,
     &                   tag,mpi_comm_world,ierr)
c        receive flag whether rho or T/S is sended
c        i=0 TS, i=1 rho is coming
         if (my_pe==0) 
     &    call mpi_recv(i,1,impiinteger,pe_child,
     &                  tag,mpi_comm_world,status,ierr)
         call mpi_bcast(i,1,impiinteger,0,my_comm,ierr)
         if (i==0) then; allocate(buf4(is:ie,km,js:je,2) )
         elseif (i==1) then; allocate(buf4(is:ie,km,js:je,1) )
         else
          if (my_pe==0) print*,' expecting either 0 or 1 here'
          call halt_stop(' in domain_exchg')
         endif
         buf4=0.; len=(ie-is+1)*(je-js+1)*km
         if (i==0) len=len*2
         if (my_pe==0) call mpi_recv(buf4,len,impireal,pe_child,
     &                 tag,mpi_comm_world,status,ierr)
c        broadcast result
         call bcast_real(buf4,len,0)
c
         if (i==0) then
          do k=1,km
           do j=js+1,je-1
            call model_dens(buf4(is+1,k,j,1),buf4(is+1,k,j,2),
     &                      blue_rho(is+1,k,j,1),k,ie-is-1
#ifdef partial_cell
     &                       ,ztp(is+1,k,j)
#endif
     &                       )
           enddo
          enddo
         else
          blue_rho(is+1:ie-1,:,js+1:je-1,1)=
     &                       buf4(is+1:ie-1,:,js+1:je-1,1)
         endif
         blue_alpha(is+1:ie-1,:,js+1:je-1)=0.1
         blue_rho(:,:,:,2)=blue_rho(:,:,:,1)

         deallocate(buf4)

        else ! enable_blue

         idoit=0; if (my_pe==0) 
     &     call mpi_send(idoit,1,impiinteger,pe_child,
     &                   tag,mpi_comm_world,ierr)
        endif ! enable_blue


#ifdef test_exchg
        print*,' DOMAIN=',sub_domain, ' PE=',my_pe,
     &     ' done'
#endif

       deallocate(cbuf)
      enddo ! nchilds

#ifdef test_exchg
      if (my_pe==0) print*,' done exchanging data across sub domains '
#endif

#endif
      end subroutine domain_exchg





      subroutine exchg_sub_grid ()
c
c---------------------------------------------------------------
c     Exchange grid data over sub domains
c---------------------------------------------------------------
c
      use spflame_module
      implicit none
#ifndef no_mpp
# include "sub_mpif.h"
      integer ierr,tag,all_pes,nchild
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      integer is,ie,js,je,len,ii,jj,kk,i,j,iii,jjj,k
      real yt_buf(js_zoom:je_zoom)
      real xt_buf(is_zoom:ie_zoom)
      real dyt_buf(js_zoom:je_zoom)
      real dxt_buf(is_zoom:ie_zoom)
      real dzt_buf(km_mother),sumu,sumt,tolr,dxubar,dyubar,dzwbar

c  see if there is anybody out there
      call mpi_comm_size(mpi_comm_world,all_pes,ierr)
      if (all_pes == n_pes) return
      tag=0
       
      if (my_pe==0) print*,' exchanging grid over sub domains'

      if (mother >0 ) then
c
c      get grid from mother domain first
c
       call index_send(is,ie,js,je)
       if (my_pe == 0) then
        len=ie_zoom-is_zoom+1
        call mpi_recv(xt_buf,len,impireal,sub_domain_pe0(mother),
     &                tag,mpi_comm_world,status,ierr)
        len=je_zoom-js_zoom+1
        call mpi_recv(yt_buf,len,impireal,sub_domain_pe0(mother),
     &                tag,mpi_comm_world,status,ierr)
        len=ie_zoom-is_zoom+1
        call mpi_recv(dxt_buf,len,impireal,sub_domain_pe0(mother),
     &                tag,mpi_comm_world,status,ierr)
        len=je_zoom-js_zoom+1
        call mpi_recv(dyt_buf,len,impireal,sub_domain_pe0(mother),
     &                tag,mpi_comm_world,status,ierr)
        call mpi_recv(dzt_buf,km_mother,impireal,
     &                sub_domain_pe0(mother),
     &                tag,mpi_comm_world,status,ierr)
        len=ie_zoom-is_zoom+1
        dxt_buf=dxt_buf/(zoom_fac*1.0)
        call gcell_sub_domain (imt, len, xt_buf, dxt_buf, 
     &                         ii, dxtdeg, dxudeg)
        if (ii /= imt-1) then
          print*,' error for xt in sub grid generation'
          print*,ii,imt
c          call flush(6,ierr)
          call halt_stop('stop')
        else
          dxtdeg(imt)=dxtdeg(imt-1)
          dxudeg(imt)=dxudeg(imt-1)
        endif
        len=je_zoom-js_zoom+1
        dyt_buf=dyt_buf/(zoom_fac*1.0)
        call gcell_sub_domain (jmt, len, yt_buf, dyt_buf, 
     &                         ii, dytdeg, dyudeg)
        if (ii /= jmt-1) then
          print*,' error for yt in sub grid generation'
          print*,ii,jmt
c          call flush(6,ierr)
          call halt_stop('stop')
        else
          dytdeg(jmt)=dytdeg(jmt-1)
          dyudeg(jmt)=dyudeg(jmt-1)
        endif
        if (km==km_mother) then
          dzt=dzt_buf
        else
         do ii=1,km_mother
          do kk=(ii-1)*zoom_fac_k + 1,ii*zoom_fac_k  
           dzt(kk)=dzt_buf(ii)/zoom_fac_k
          enddo
         enddo
        endif
       endif
       call mpi_bcast(dxtdeg,imt,impireal,0,my_comm,ierr)
       call mpi_bcast(dxudeg,imt,impireal,0,my_comm,ierr)
       call mpi_bcast(dytdeg,jmt,impireal,0,my_comm,ierr)
       call mpi_bcast(dyudeg,jmt,impireal,0,my_comm,ierr)
       call mpi_bcast(xt_buf,1,impireal,0,my_comm,ierr)
       call mpi_bcast(yt_buf,1,impireal,0,my_comm,ierr)
       call mpi_bcast(dzt,km,impireal,0,my_comm,ierr)
       xt(1)=xt_buf(is_zoom)
       xu(1)=xt_buf(is_zoom)+dxtdeg(1)/2.
       do ii=2,imt
c        xt(ii)=xt(ii-1)+dxtdeg(ii)
c        xu(ii)=xu(ii-1)+dxudeg(ii)
        xt(ii)=xt(ii-1)+dxudeg(ii-1)
        xu(ii)=xu(ii-1)+dxtdeg(ii)
       enddo
       yt(1)=yt_buf(js_zoom)
       yu(1)=yt_buf(js_zoom)+dytdeg(1)/2.
       do ii=2,jmt
c        yt(ii)=yt(ii-1)+dytdeg(ii)
c        yu(ii)=yu(ii-1)+dyudeg(ii)
        yt(ii)=yt(ii-1)+dyudeg(ii-1)
        yu(ii)=yu(ii-1)+dytdeg(ii)
       enddo 
       dzw(1) = dzt(1)
       sumt = dzt(1)
       sumu = 0.5*dzt(1) + dzw(1)
       do ii=2,km
        sumt = sumt + dzt(ii)
        dzw(ii) = 2*(sumt-sumu)
        sumu = sumu + dzw(ii)
       enddo
       zt(1) = 0.5*dzt(1)
       zw(1) = dzt(1)
       do ii=2,km
        zw(ii) = zw(ii-1) + dzt(ii)
        zt(ii) = zt(ii-1) + dzw(ii-1)
       enddo
       dzw(0)  = zt(1)
       dzw(km) = zw(km) - zt(km)

       if (my_pe==0) then
        print*,' sub grid generation results : '
        print*,' Longitude T grid:'
#ifdef notdef
        do i=is_zoom,ie_zoom
         do ii=-zoom_fac/2,zoom_fac/2
          iii=(i-is_zoom)*zoom_fac +1+ii
          if (iii>=1.and.iii<=imt) then
           print*,' i=',iii,' xt(i)=',xt(iii),' dxtdeg(i)=',dxtdeg(iii),
     &     ' ic=',i,' c_xt(ic)=', xt_buf(i),
     &     ' c_dxtdeg(ic)=', dxt_buf(i)*zoom_fac
          endif
         enddo
        enddo
#else
        print*,''
        print*,' this grid: '
        print*,' xt(1)    =',xt(1),     ' xt(imt)    =',xt(imt)
        print*,' dxtdeg(1)=',dxtdeg(1), ' dxtdeg(imt)=',dxtdeg(imt)
        print*,''
        print*,' mothers grid:'
        print*,' xt(1)    =',xt_buf(is_zoom),     
     &         ' xt(imt)    =',xt_buf(ie_zoom)
        print*,' dxtdeg(1)=',dxt_buf(is_zoom),
     &         ' dxtdeg(imt)=',dxt_buf(ie_zoom)
        print*,''
#endif
        print*,' Longitude U grid:'
#ifdef notdef
        do i=is_zoom,ie_zoom
         do ii=-zoom_fac/2,zoom_fac/2
          iii=(i-is_zoom)*zoom_fac +1+ii
          if (iii>=1.and.iii<=imt) then
           print*,' i=',iii,' xu(i)=',xu(iii),' dxudeg(i)=',dxudeg(iii),
     &     ' ic=',i
          endif
         enddo
        enddo
#else
        print*,''
        print*,' this grid: '
        print*,' xu(1)    =',xu(1),     ' xu(imt)    =',xu(imt)
        print*,' dxudeg(1)=',dxudeg(1), ' dxudeg(imt)=',dxudeg(imt)
        print*,''
#endif
        print*,' Latitude T grid:'
#ifdef notdef
        do j=js_zoom,je_zoom
         do jj=-zoom_fac/2,zoom_fac/2
          jjj=(j-js_zoom)*zoom_fac +1+jj
          if (jjj>=1.and.jjj<=jmt) then
           print*,' j=',jjj,' yt(j)=',yt(jjj),' dytdeg(j)=',dytdeg(jjj),
     &     ' jc=',j,' c_yt(jc)=', yt_buf(j),
     &     ' c_dytdeg(jc)=', dyt_buf(j)*zoom_fac
          endif
         enddo
        enddo
#else
        print*,''
        print*,' this grid: '
        print*,' yt(1)    =',yt(1),     ' yt(jmt)    =',yt(jmt)
        print*,' dytdeg(1)=',dytdeg(1), ' dytdeg(jmt)=',dytdeg(jmt)
        print*,''
        print*,' mothers grid:'
        print*,' yt(1)    =',yt_buf(js_zoom),     
     &         ' yt(jmt)    =',yt_buf(je_zoom)
        print*,' dytdeg(1)=',dyt_buf(js_zoom),
     &         ' dytdeg(jmt)=',dyt_buf(je_zoom)
        print*,''
#endif
        print*,' Latitude U grid:'
#ifdef notdef
        do j=js_zoom,je_zoom
         do jj=-zoom_fac/2,zoom_fac/2
          jjj=(j-js_zoom)*zoom_fac +1+jj
          if (jjj>=1.and.jjj<=jmt) then
           print*,' j=',jjj,' yu(j)=',yu(jjj),' dyudeg(j)=',dyudeg(jjj),
     &     ' jc=',j
          endif
         enddo
        enddo
#else
        print*,''
        print*,' this grid: '
        print*,' yu(1)    =',yu(1),     ' yu(jmt)    =',yu(jmt)
        print*,' dyudeg(1)=',dyudeg(1), ' dyudeg(jmt)=',dyudeg(jmt)
        print*,''
#endif
       endif
c
c-----------------------------------------------------------------------
c     Check if the T grid resolution is an average of the
c     U cell resolution. This insures more accurate advection of
c     tracers within a stretched grid.
c-----------------------------------------------------------------------
c
      tolr = 1.e-5
      do i=2,imt-1
        dxubar = 0.5*(dxudeg(i) + dxudeg(i-1))
        if (abs(dxubar-dxtdeg(i)) .gt. tolr) then
          if (my_pe==0) write (6,'(a,i5,a)')
     &    '=>Warning: T cell delta x at i=',i
     &,   ' is not an average of adjacent U cell delta x`s'     
        endif     
      enddo
c
      do j=2,jmt-1
        dyubar = 0.5*(dyudeg(j) + dyudeg(j-1))
        if (abs(dyubar-dytdeg(j)) .gt. tolr) then
          if (my_pe==0) write (6,'(a,i5,a)')
     &    '=>Warning: T cell delta y at j=',j
     &,   ' is not an average of adjacent U cell delta y`s' 
        endif     
      enddo
c
      tolr = 1.e0
      do k=2,km-1
        dzwbar = 0.5*(dzw(k) + dzw(k-1))
        if (abs(dzwbar-dzt(k)) .gt. tolr) then
          if (my_pe==0) write (6,'(a,i5,a)')
     &    '=>Warning: T cell delta z at k=',k
     &,   ' is not an average of adjacent W cell delta z`s'     
        endif     
      enddo


      endif ! mother >0
c
c     now send grid to children
c
      do nchild=1,nr_childs
        call index_get(is,ie,js,je,childs(nchild))
        if (my_pe == 0) then
          call mpi_send(xt(is:ie),ie-is+1,impireal,
     &                  sub_domain_pe0(childs(nchild)),
     &                  tag,mpi_comm_world,ierr)
          call mpi_send(yt(js:je),je-js+1,impireal,
     &                  sub_domain_pe0(childs(nchild)),
     &                  tag,mpi_comm_world,ierr)
          call mpi_send(dxtdeg(is:ie),ie-is+1,impireal,
     &                  sub_domain_pe0(childs(nchild)),
     &                  tag,mpi_comm_world,ierr)
          call mpi_send(dytdeg(js:je),je-js+1,impireal,
     &                  sub_domain_pe0(childs(nchild)),
     &                  tag,mpi_comm_world,ierr)
          call mpi_send(dzt,km,impireal,
     &                  sub_domain_pe0(childs(nchild)),
     &                  tag,mpi_comm_world,ierr)
        endif
      enddo

      if (my_pe==0) print*,' done'

#endif
      end subroutine exchg_sub_grid



      subroutine exchg_sub_topo 
c
c---------------------------------------------------------------
c     Exchange kmt mask data over sub domains
c---------------------------------------------------------------
c
      use spflame_module
      use island_module
      implicit none
#ifndef no_mpp
# include "sub_mpif.h"
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      integer ierr,tag,all_pes,nchild
      integer is,ie,js,je,len,ii,i,j,jj,ismooth,k,kk,n
      integer kmt_buf(is_zoom:ie_zoom,js_zoom:je_zoom)
#ifdef partial_cell
      real :: htp_buf(is_zoom:ie_zoom,js_zoom:je_zoom)
      integer :: passes = 0
#endif
      real, allocatable :: buf(:,:)
      real z,tol

c  see if there is anybody out there
      call mpi_comm_size(mpi_comm_world,all_pes,ierr)
      if (all_pes == n_pes) return
      tag=0
      if (mother>0 ) then
c
c      get the kmt mask from mother domain first
c
       if (my_pe==0) print*,' receiving kmt mask from mother domain'

       call index_send(is,ie,js,je)
       len=(ie_zoom-is_zoom+1)*(je_zoom-js_zoom+1)
       if (my_pe == 0) 
     &   call mpi_recv(kmt_buf,len,impiinteger,sub_domain_pe0(mother),
     &                 tag,mpi_comm_world,status,ierr)
       call mpi_bcast(kmt_buf,len,impiinteger,0,my_comm,ierr)

#ifdef partial_cell
       if (my_pe == 0)  then
        print*,' receiving also htp mask'
        call mpi_recv(htp_buf,len,impireal,sub_domain_pe0(mother),
     &                tag,mpi_comm_world,status,ierr)
       endif
       call mpi_bcast(htp_buf,len,impireal,0,my_comm,ierr)
#endif

       do j=js_zoom,je_zoom
        do ii=-zoom_fac/2,zoom_fac/2
         do jj=-zoom_fac/2,zoom_fac/2
          js=(j-js_zoom)*zoom_fac + jj+1
          do i=is_zoom,ie_zoom
           is=(i-is_zoom)*zoom_fac + ii+1
           if (is>=1.and.is<=imt.and.
     &            js>=1.and.js<=jmt ) kmt_big(is,js)=kmt_buf(i,j)
          enddo
         enddo
        enddo
       enddo

#ifdef partial_cell
       do j=js_zoom,je_zoom
        do ii=-zoom_fac/2,zoom_fac/2
         do jj=-zoom_fac/2,zoom_fac/2
          js=(j-js_zoom)*zoom_fac + jj+1
          do i=is_zoom,ie_zoom
           is=(i-is_zoom)*zoom_fac + ii+1
           if (is>=1.and.is<=imt.and.
     &            js>=1.and.js<=jmt ) htp(is,js)=htp_buf(i,j)
          enddo
         enddo
        enddo
       enddo
#endif

       if (zoom_fac_k>1) then
        do i=1,imt
         do j=1,jmt
          kmt_big(i,j)=max(0,kmt_big(i,j)*zoom_fac_k-1)
         enddo
        enddo
#ifdef partial_cell
        call halt_stop(
     & ' use of zoom_fac_k>1 not possible with partial cells'//
     &                        ' -> error in topog_exchg ')
#endif
       endif

#ifdef sub_use_ref_topo_in_sub_domain
#ifdef partial_cell
      call halt_stop(' cannot use other kmt mask with partial cells'//
     &               ' -> error in topog_exchg ')
#endif
       call add_other_topo
#endif
c
c      do smoothing X times, but do not produce
c      deeper cells than coarse grid boxes
c      preserve also topography at open boundaries
c
       if (my_pe==0) then
         print*,''
         print*,' Note: smoothing topography in sub domain #',
     &    sub_domain,' ',topo_smooth_iterations,' times '
         print*,''
       endif

       allocate(buf(imt,jmt) ); buf=0
       do n=1,topo_smooth_iterations
        ismooth=zoom_fac/2
        do j=1,jmt
          do i=1,imt
           is=0; buf(i,j)=0.
           do jj=-ismooth,ismooth
            do ii=-ismooth,ismooth
             if (ii+i>=1.and.ii+i<=imt.and.
     &          jj+j>=1.and.jj+j<=jmt ) then
#ifdef partial_cell
              buf(i,j)=buf(i,j)+htp(i+ii,j+jj)
#else
              z=0.
              if (kmt_big(i+ii,j+jj).ge.1) z=zt(kmt_big(i+ii,j+jj))
              buf(i,j)=buf(i,j)+z
#endif
              is=is+1
             endif
            enddo
           enddo
           buf(i,j)=buf(i,j)/max(is,1)
          enddo
        enddo

#ifdef partial_cell

        do i=1,imt
         do j=1,jmt
          if ((enable_obc_west .and.i<5)    .or.
     &        (enable_obc_east .and.i>imt-4).or.
     &        (enable_obc_south.and.j<5)    .or.
     &        (enable_obc_north.and.j>jmt-4) ) then
           htp(i,j)=min(htp(i,j),buf(i,j))
          else
           htp(i,j)=buf(i,j)
          endif
         enddo
        enddo
#else
        tol = 1. ! cm
        do i=1,imt
         do j=1,jmt
           kk=0
           do k=1,km
            if (buf(i,j)+tol>=zt(k) ) kk=k
           enddo
           if (kmt_big(i,j) > 0 ) then
             if ((enable_obc_west .and.i<5)    .or.
     &           (enable_obc_east .and.i>imt-4).or.
     &           (enable_obc_south.and.j<5)    .or.
     &           (enable_obc_north.and.j>jmt-4) ) then
              kmt_big(i,j)=min(kk,kmt_big(i,j))
             else
              kmt_big(i,j)=kk
             endif
           endif
         enddo
        enddo
#endif

       enddo

#ifdef partial_cell
c
c      adjust htp and kmt masks
c
        passes = 0
 10     kk=0
        do j=1,jmt
         do i=1,imt
          if (kmt_big(i,j)==0) then
           htp(i,j)=0.  ! preserve coastline
          else
           if (zw(kmt_big(i,j)) < htp(i,j).and.kmt_big(i,j)<km ) then
            kmt_big(i,j)=kmt_big(i,j)+1 ! increase depth level by one
            kk=1
           endif
           if (zw(kmt_big(i,j)) < htp(i,j).and.kmt_big(i,j)==km ) then
            htp(i,j)=zw(kmt_big(i,j)) ! max depth reached
           endif
           if (htp(i,j) < zw(kmt_big(i,j)-1).and.kmt_big(i,j)>4 ) then
            kmt_big(i,j)=kmt_big(i,j)-1 ! decrease depth level by one
            kk=1
           endif
           if (htp(i,j) < zw(kmt_big(i,j)-1).and.kmt_big(i,j)==4) then
            htp(i,j)=zw(kmt_big(i,j)) ! min depth reached
           endif
          endif
         enddo
        enddo
        passes = passes +1       
        if (kk==1) goto 10

        if (my_pe==0) 
     & print*,' number of passes while adjusting htp/kmt mask:',passes

#endif
c
c     apply condition on topography for o.b.
c
       if (enable_obc_south) then
        j=2
        do i=1,imt
         kmt_big(i,j-1)=kmt_big(i,j)
#ifdef partial_cell
         htp(i,j-1)=htp(i,j)
#endif
         k=min(min(kmt_big(i,j),kmt_big(i,j+1)),
     &         min(kmt_big(i,j),kmt_big(i,j+2)))
         if (k /= kmt_big(i,j)) then
          kmt_big(i,j-1:j+2)=k
#ifdef partial_cell
          do jj=j-1,j+2; htp(i,jj) = zw(k); enddo
#endif
         endif
        enddo
       endif
       if (enable_obc_north) then
        j=jmt-1
        do i=1,imt
         kmt_big(i,j+1)=kmt_big(i,j)
#ifdef partial_cell
         htp(i,j+1)=htp(i,j)
#endif
         k=min(min(kmt_big(i,j),kmt_big(i,j-1)),
     &         min(kmt_big(i,j),kmt_big(i,j-2)))
         if (k /= kmt_big(i,j)) then
          kmt_big(i,j-2:j+1)=k
#ifdef partial_cell
          do jj=j-2,j+1; htp(i,jj) = zw(k); enddo
#endif
         endif
        enddo
       endif
       if (enable_obc_west) then
        i=2
        do j=1,jmt
         kmt_big(i-1,j)=kmt_big(i,j)
#ifdef partial_cell
         htp(i-1,j)=htp(i,j)
#endif
         k=min(min(kmt_big(i,j),kmt_big(i+1,j)),
     &         min(kmt_big(i,j),kmt_big(i+2,j)))
         if (k /= kmt_big(i,j)) then
          kmt_big(i-1:i+2,j)=k
#ifdef partial_cell
          do ii=i-1,i+2; htp(ii,j) = zw(k); enddo
#endif
         endif
        enddo
       endif
       if (enable_obc_east) then
        i=imt-1
        do j=1,jmt
         kmt_big(i+1,j)=kmt_big(i,j)
#ifdef partial_cell
         htp(i+1,j)=htp(i,j)
#endif
         k=min(min(kmt_big(i,j),kmt_big(i-1,j)),
     &         min(kmt_big(i,j),kmt_big(i-2,j)))
         if (k /= kmt_big(i,j)) then
          kmt_big(i-2:i+1,j)=k
#ifdef partial_cell
          do ii=i-2,i+1; htp(ii,j) = zw(k); enddo
#endif
         endif
        enddo
       endif
c
c      a test for blue to mother domain
c
       z=1.
       do i=is_zoom+1,ie_zoom-1
         do j=js_zoom+1,je_zoom-1
           kk=0
           do ii=-zoom_fac/2,zoom_fac/2
            do jj=-zoom_fac/2,zoom_fac/2
              is=(i-is_zoom)*zoom_fac + ii+1
              js=(j-js_zoom)*zoom_fac + jj+1
              if (is>=1.and.is<=imt.and.
     &            js>=1.and.js<=jmt ) then
c               if ( kmt_big(is,js) >= kmt_buf(i,j) ) kk=1
               if ( (kmt_big(is,js)+zoom_fac_k-1)/zoom_fac_k 
     &               >= kmt_buf(i,j) ) kk=1
              endif
            enddo
           enddo
           if (kk==0)  then
            if (my_pe == 0) then
             print*,''
             print*,
     &    ' WARNING: found no boxes with enough depth in sub domain #',
     &       sub_domain
             print*,' for (i,j)=(',i,',',j,') of coarse grid'
             print*,' possible reason: topo_smooth_iterations too high'
             print*,' coarse topography: kmt(i,j)=',kmt_buf(i,j),
     &            ' = ',zt(kmt_buf(i,j)),' cm'
             is=(i-is_zoom)*zoom_fac -zoom_fac/2+1
             js=(j-js_zoom)*zoom_fac -zoom_fac/2+1
             ie=(i-is_zoom)*zoom_fac +zoom_fac/2+1
             je=(j-js_zoom)*zoom_fac +zoom_fac/2+1
             do jj=js,je
              print*,' fine topography (at xt=',xt(is),':',xt(ie),
     &           ' yt=',yt(jj),')'
              print*,'  kmt(',is,':',ie,',',jj,')=',kmt_big(is:ie,jj)
              do ii=is,ie
            print*,'  zt(kmt(',ii,',',jj,')=',zt(max(1,kmt_big(ii,jj)))
              enddo
              print*,' =',buf(is:ie,jj), ' cm (undiscretized)'
             enddo
             print*,''
            endif  
            z=0.
           endif
         enddo
       enddo
c       if (z==0.) call halt_stop(' in exchg_topog')
c
c      another  test for the open boundary conditions
c
       if (enable_obc_south) then
        do i=is_zoom+1,ie_zoom-1
         kk=0
         do ii=-zoom_fac/2,zoom_fac/2
           is=(i-is_zoom)*zoom_fac + ii+1
           if (is>=1.and.is<=imt) then
c            if ( kmt_big(is,2) > kmt_buf(i,js_zoom) ) kk=1
            if ( (kmt_big(is,2)+zoom_fac_k-1)/zoom_fac_k 
     &            > kmt_buf(i,js_zoom) ) kk=1
           endif
         enddo
         if (kk==1) then
          if (my_pe==0) print*,' inconsistent southern obc '
          call barrier
          call halt_stop(' in exchg_topog')
         endif
        enddo
       endif
       if (enable_obc_north) then
        do i=is_zoom+1,ie_zoom-1
         kk=0
         do ii=-zoom_fac/2,zoom_fac/2
           is=(i-is_zoom)*zoom_fac + ii+1
           if (is>=1.and.is<=imt) then
c            if ( kmt_big(is,jmt-1) > kmt_buf(i,je_zoom) ) kk=1
            if ( (kmt_big(is,jmt-1)+zoom_fac_k-1)/zoom_fac_k 
     &            > kmt_buf(i,je_zoom) ) kk=1
           endif
         enddo
         if (kk==1) then
          if (my_pe==0) print*,' inconsistent northern obc '
          call barrier
          call halt_stop(' in exchg_topog')
         endif
        enddo
       endif
       if (enable_obc_west) then
        do j=js_zoom+1,je_zoom-1
         kk=0
         do jj=-zoom_fac/2,zoom_fac/2
           js=(j-js_zoom)*zoom_fac + jj+1
           if (js>=1.and.js<=jmt) then
c            if ( kmt_big(2,js) > kmt_buf(is_zoom,j) ) kk=1
            if ( (kmt_big(2,js)+zoom_fac_k-1)/zoom_fac_k 
     &           > kmt_buf(is_zoom,j) ) kk=1
           endif
         enddo
         if (kk==1) then
          if (my_pe==0) print*,' inconsistent western obc '
          call barrier
          call halt_stop(' in exchg_topog')
         endif
        enddo
       endif
       if (enable_obc_east) then
        do j=js_zoom+1,je_zoom-1
         kk=0
         do jj=-zoom_fac/2,zoom_fac/2
           js=(j-js_zoom)*zoom_fac + jj+1
           if (js>=1.and.js<=jmt) then
c            if ( kmt_big(imt-1,js) > kmt_buf(ie_zoom,j) ) kk=1
            if ( (kmt_big(imt-1,js)+zoom_fac_k-1)/zoom_fac_k 
     &        > kmt_buf(ie_zoom,j) ) kk=1
           endif
         enddo
         if (kk==1) then
          if (my_pe==0) print*,' inconsistent eastern obc '
          call barrier
          call halt_stop(' in exchg_topog')
         endif
        enddo
       endif

       deallocate( buf)

       if (my_pe==0) print*,' done'

      endif  ! mother >0
c
c     now send kmt to child domains
c
      do nchild=1,nr_childs
       if (my_pe==0) print*,' sending kmt-mask to child domain #',nchild
       call index_get(is,ie,js,je,childs(nchild))
       if (my_pe == 0) then
        len=(ie-is+1)*(je-js+1)
        call mpi_send(kmt_big(is:ie,js:je),len,
     &                impiinteger,sub_domain_pe0(childs(nchild)),
     &                tag,mpi_comm_world,ierr)
#ifdef partial_cell
        print*,' sending also htp mask'
        call mpi_send(htp(is:ie,js:je),len,
     &                impireal,sub_domain_pe0(childs(nchild)),
     &                tag,mpi_comm_world,ierr)
#endif
       endif
       if (my_pe==0) print*,' done'
      enddo


#endif
      end subroutine exchg_sub_topo 





      subroutine visc_parameter_exchg(n_domain)
c
c---------------------------------------------------------------
c     Exchange viscous parameter over sub domains
c     if n_domain <0 then pe will expect data from mother
c     if n_domain >=0 then pe expect to send data to child n_domain
c---------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer :: n_domain
#ifndef no_mpp
# include "sub_mpif.h"
 
      integer,dimension(MPI_STATUS_SIZE)  :: Status
      integer ierr,tag,all_pes
      integer is,ie,js,je,i,j,ii,jj
      logical biha
      real visc,dx,my_dx,my_am,scal,scal_length,scal_fac

c  see if there is anybody out there
      call mpi_comm_size(mpi_comm_world,all_pes,ierr)
      if (all_pes == n_pes) return

      tag=0
      if (n_domain>=0) then
       call index_get(is,ie,js,je,n_domain)
       if (my_pe == 0) then
        biha=.false.; visc=am
        if (enable_friction_biharmonic) then
         biha=.true.; visc=ambi
        endif
        dx=dxu(1)*csu(js+(je-js)/2)
        call mpi_send(biha,1,mpi_logical,sub_domain_pe0(n_domain),
     &                tag,mpi_comm_world,ierr)
        call mpi_send(visc,1,impireal,sub_domain_pe0(n_domain),
     &                tag,mpi_comm_world,ierr)
        call mpi_send(dx,1,impireal,sub_domain_pe0(n_domain),
     &                tag,mpi_comm_world,ierr)
       endif
      elseif (n_domain<0) then
       call index_send(is,ie,js,je)
       if (my_pe == 0) then
        call mpi_recv(biha,1,mpi_logical,sub_domain_pe0(mother),
     &                tag,mpi_comm_world,status,ierr)
        call mpi_recv(visc,1,impireal,sub_domain_pe0(mother),
     &                tag,mpi_comm_world,status,ierr)
        call mpi_recv(dx,1,impireal,sub_domain_pe0(mother),
     &                tag,mpi_comm_world,status,ierr)
       endif
       call mpi_bcast(biha,1,mpi_logical,0,my_comm,ierr)
       call mpi_bcast(visc,1,impireal,0,my_comm,ierr)
       call mpi_bcast(dx,1,impireal,0,my_comm,ierr)
c
c      scale near open boundaries the hor. harm. viscosity
c      so that the frictional time scale on the grid scale
c      of the mother domain becomes the same in the sub domain
c
       if (.not. enable_friction_harmonic) then
        print*,' need harmonic friction for sub domain #',sub_domain
        call halt_stop(' in visc_parameter_exchg')
       endif
       am=max(1e-5,am); my_dx=dxu(1)*csu(jmt/2)
       my_am=visc; if (biha) my_am=visc/dx**2
       if (my_pe==0) then
         print*,''
         print*,' Harmonic viscosity scaling near open boundaries:'
         if (biha) then
          print*,' biharmonic viscosity in mother domain = ',visc
          print*,' which corresponds to harmonic viscosity'
          print*,' on the grid scale of  mother domain   = ',my_am
         else
          print*,' harmonic viscosity in mother domain = ',my_am
         endif
         print*,''
         print*,' harmonic viscosity in sub domain    = ',am
         if (enable_friction_biharmonic) then
          print*,' biharmonic viscosity in sub domain    = ',ambi
         endif
         print*,''
         print*,' friction time scale (on grid of sub domain) [h]'
         print*,' harmonic in interior     : ',my_dx**2/am/60./60.
         print*,' harmonic near boundaries : ',my_dx**2/my_am/60./60.
         if (enable_friction_biharmonic) then
          print*,' biharmonic in interior   : ',my_dx**4/ambi/60./60.
         endif
         print*,''
       endif
       scal_length=0.25; scal_fac=1.0
#ifdef sub_wide_obc_friction_zone
       scal_length=2.0
#endif
#ifdef sub_narrow_obc_friction_zone
       scal_length=0.10
#endif
#ifdef sub_high_obc_friction_zone
       scal_fac=5.0
#endif
#ifdef sub_low_obc_friction_zone
       scal_fac=0.2
#endif
       my_am=my_am*scal_fac
       if (my_pe==0 ) then
         print*,' using a length scale for high harm. viscosity '
         print*,' near the open boundaries of ',scal_length,' deg'
         print*,''
         print*,' scaling the harm. viscosity near the open'
         print*,' boundaries also with ',scal_fac
         print*,' such that friction time scale near boundaries '
         print*,' becomes ',my_dx**2/my_am/60./60.,' h'
         print*,''
       endif
       do j=js_pe-2,je_pe+2
        do i=is_pe-2,ie_pe+2
          scal=1e4; ii=min(max(1,i),imt); jj=min(max(1,j),jmt)
          if (enable_obc_north) scal=min(scal,yt(jmt-4)-yt(jj))
          if (enable_obc_south) scal=min(scal,yt(jj)    -yt(5))
          if (enable_obc_west)  scal=min(scal,xt(ii)    -xt(5))
          if (enable_obc_east)  scal=min(scal,xt(imt-4)-xt(ii))
c       without cosine dependency
c          scal=0.5-atan(scal/scal_length)/pi
c          am_scale(i,j) = 1./am*(am*(1.-scal)+my_am*scal)
c       account for cosine dependency and other scaling in am_scale
          scal=(0.5-atan(scal/scal_length)/pi)
#ifdef sub_quadratic_obc_friction_zone
          scal=scal**2
#endif
          am_scale(i,j) = 
     &   (1.-scal)*am_scale(i,j)+my_am/am*csu(jj)/csu(jmt/2)*scal
        enddo
       enddo

      endif ! n_domain
#endif
      end subroutine visc_parameter_exchg




      subroutine add_other_topo
      use spflame_module
      implicit none
      integer io,i,j,k,imt2,jmt2,km2,is,ie,js,je
      integer,allocatable :: other_kmt(:,:)
      real,allocatable :: other_depth(:,:),depth(:,:)

      real, allocatable :: oxt(:),oyt(:),ozt(:),oxt2(:)
      real dummy,tol
      integer lenw,kk,indp
      real,allocatable :: work(:)


      if (my_pe==0) then
       print*,''
       print*,' Note: using other topography for sub domain #'
     &          ,sub_domain
      endif

#if defined C90_host || defined T3E_host
      call assign('assign -F f77 -N ieee f:sub_other_kmt.dta',i)
      call assign('assign -F f77 -N ieee f:sub_other_grid.dta',i)
#endif

      call get_free_iounit(io)
      open(io,file='sub_other_kmt.dta',form='unformatted')
      read (io) ! no checks
      read (io) 
      read (io) imt2, jmt2, km2
      read (io) 
      allocate( other_kmt(imt2,jmt2),other_depth(imt2,jmt2) )
      read (io) other_kmt
      close (io)

      allocate( oxt(imt2),oyt(jmt2),ozt(km2),oxt2(imt2) )

      call get_free_iounit (io)
      open (io,file='sub_other_grid.dta',form='unformatted')
      read (io) ! no checks
      read (io) imt2, jmt2, km2
      read (io) (dummy,i=1,imt2)
     &,         (dummy,j=1,jmt2)
     &,         (dummy,i=1,imt2)
     &,         (dummy,j=1,jmt2)
     &,         (dummy,k=1,km2)
     &,         (dummy,k=0,km2)
     &,         (oxt(i),i=1,imt2)
     &,         (dummy,i=1,imt2)
     &,         (oyt(j),j=1,jmt2)
     &,         (dummy,j=1,jmt2)
     &,         (ozt(k),k=1,km2)
     &,         (dummy,k=1,km2)
      close (io)


      do i=1,imt2
       do j=1,jmt2
        if (other_kmt(i,j)>0) then
         other_depth(i,j)=ozt(other_kmt(i,j))
        else
         other_depth(i,j)=0.0
        endif
       enddo
      enddo

      call tranlon (other_depth,imt2, imt2-2, jmt2, 
     &              oxt, xt(2), imt-2, oxt2)

      lenw=10*imt2
      allocate(depth(imt,jmt),work(lenw))

      if (oxt2(2)-oxt2(1) >= xt(2)-xt(1) ) then
       if (my_pe==0) print*,' assuming coarser grid of ref. topogr.'
       call ctf (other_depth, imt2, jmt2, oxt2, oyt, 
     &           depth, imt, jmt, 2, imt-1, 1, jmt,
     &           xt, yt, 1, work, lenw)
      else
       if (my_pe==0) print*,' assuming finer grid of ref. topogr.'
       call ftc (other_depth, imt2, jmt2, oxt2, oyt, 
     &           depth, imt, jmt, 2, imt-1, 1, jmt,
     &           xt, yt, 1, work, lenw)
      endif
      tol = 1. ! cm
      is=5; ie=imt-4; js=5; je=jmt-4
      do i=is,ie
        do j=js,je
           kk=0
           do k=1,km
            if (depth(i,j)+tol>=zt(k) ) kk=k
           enddo
           if (kmt_big(i,j) > 0 ) then
            kmt_big(i,j)=max(4,kk)
c            kmt_big(i,j) =max(kmt_big(i,j),kk)
           endif
        enddo
      enddo

#ifdef sub_hand_tuning_topo_in_sub_domain
c     apply hand tuning of topography here

c      i=60,61,64
c      j=71,72,75
      kmt_big(60,71)=21
      kmt_big(61,72)=21
      kmt_big(64,75)=21

c      i=62,63
c      j=70,71
      kmt_big(62,70)=21
      kmt_big(63,71)=21
c      i=65,66,67
c      j=73,74,75
      kmt_big(65,73)=21
      kmt_big(66,74)=21
      kmt_big(67,75)=21

#endif

      deallocate(depth,work)
      deallocate(other_kmt,other_depth,oxt,oyt,ozt,oxt2)

      end subroutine add_other_topo




      subroutine extrapolate_hor(d,k,spval,grid,klevel)
      use spflame_module
      implicit none
      integer :: k       ! number of grids points overlapping in other PE domains
      integer :: klevel  ! the vertical level of this slice
      real    :: spval   ! special value in data
      character (len=1) :: grid ! which grid: can be U or T
      real    ::    d(is_pe-k:ie_pe+k,js_pe-k:je_pe+k) ! data to be extrapolated

      integer :: mask(is_pe-k:ie_pe+k,js_pe-k:je_pe+k)  
      integer :: isum(is_pe  :ie_pe  ,js_pe  :je_pe  )
      real    ::   dm(is_pe  :ie_pe  ,js_pe  :je_pe  )
      integer :: i,j,ii,jj
      integer :: pass 
      integer, parameter :: maxpass = 100
      real :: clean

      pass = 1
 10   continue

c
c     construct a mask
c
      mask =1
      where( d == spval ) mask = 0
c
c     number of valid points in the surrounding
c
      isum=0
      do ii=-1,1
       do jj=-1,1
        do j=js_pe,je_pe
         do i=is_pe,ie_pe
           isum(i,j)=isum(i,j)+mask(i+ii,j+jj)
         enddo
        enddo
       enddo
      enddo
c
c     mean of valid data in the surrounding
c
      dm=0.
      do ii=-1,1
       do jj=-1,1
        do j=js_pe,je_pe
         do i=is_pe,ie_pe
           dm(i,j)=dm(i,j)+d(i+ii,j+jj)*mask(i+ii,j+jj)
         enddo
        enddo
       enddo
      enddo

      where( isum == 0 ) 
        dm = spval 
      elsewhere 
        dm = dm / isum 
      end where
c
c     set missing data to mean value of surrounding
c
      do j=js_pe,je_pe
       do i=is_pe,ie_pe
           d(i,j)=d(i,j)*mask(i,j) + (1.-mask(i,j))*dm(i,j)
       enddo
      enddo
c
c     check for missing values
c
      clean = 0.
      if     (grid == 'U' .or. grid == 'u') then
       do j=js_pe,je_pe
        do i=is_pe,ie_pe
         if (umask(i,klevel,j) == 1. .and. d(i,j) == spval) then
          clean = 1.
         endif
        enddo
       enddo
      elseif (grid == 'T' .or. grid == 't') then
       do j=js_pe,je_pe
        do i=is_pe,ie_pe
         if (tmask(i,klevel,j) == 1. .and. d(i,j) == spval) then
          clean = 1.
         endif
        enddo
       enddo
      else
       if (my_pe == 0) print*,' cannot recognize type of grid '
       call halt_stop(' in extrapolate_hor ')
      endif

      call global_max(clean)

      if (clean > 0.) then
        call border_exchg(d,1,k)
        pass = pass+1
        if (pass > maxpass ) then
          if (my_pe==0) print*,' WARNING:'
          if (my_pe==0) print*,' number of maximal passes exceeded in'
          if (my_pe==0) print*,' extrapolate_hor'
        else
         goto 10
        endif
      endif

c      if (my_pe==0) print*,' number of passes in extrapol_hor : ',pass

      end subroutine extrapolate_hor



      subroutine smooth_hor(d,k,grid,klevel)
      use spflame_module
      implicit none
      integer :: k       ! number of grids points overlapping in other PE domains
                         ! which is also the smoothing length in grid points
      integer :: klevel  ! the vertical level of this slice
      character (len=1) :: grid ! which grid: can be U or T
      real    ::    d(is_pe-k:ie_pe+k,js_pe-k:je_pe+k) ! data to be extrapolated

      integer :: isum(is_pe  :ie_pe  ,js_pe  :je_pe  )
      real    ::   dm(is_pe  :ie_pe  ,js_pe  :je_pe  )
      integer :: i,j,ii,jj


      if (grid == 'U' .or. grid == 'u') then

       if ( ( lbound( umask, 1 ) >  is_pe-k ) .or.
     &      ( ubound( umask, 1 ) <  ie_pe+k ) ) then
        if (my_pe==0) print*,
     &   ' umask array in spflame_module is too small ',
     &   ' for smoothing operation of ',k,' grid points '
         call halt_stop(' in smooth_hor ')
       endif
c
c      number of valid points in the surrounding
c
       isum=0
       do ii=-k,k
        do jj=-k,k
         do j=js_pe,je_pe
          do i=is_pe,ie_pe
            isum(i,j)=isum(i,j)+umask(i+ii,klevel,j+jj)
          enddo
         enddo
        enddo
       enddo
c
c      mean of valid data in the surrounding
c
       dm=0.
       do ii=-k,k
        do jj=-k,k
         do j=js_pe,je_pe
          do i=is_pe,ie_pe
            dm(i,j)=dm(i,j)+d(i+ii,j+jj)*umask(i+ii,klevel,j+jj)
          enddo
         enddo
        enddo
       enddo

      elseif (grid == 'T' .or. grid == 't') then

       if ( ( lbound( tmask, 1 ) >  is_pe-k ) .or.
     &      ( ubound( tmask, 1 ) <  ie_pe+k ) ) then
        if (my_pe==0) print*,
     &   ' tmask array in spflame_module is too small ',
     &   ' for smoothing operation of ',k,' grid points '
         call halt_stop(' in smooth_hor ')
       endif
c
c      number of valid points in the surrounding
c
       isum=0
       do ii=-k,k
        do jj=-k,k
         do j=js_pe,je_pe
          do i=is_pe,ie_pe
            isum(i,j)=isum(i,j)+tmask(i+ii,klevel,j+jj)
          enddo
         enddo
        enddo
       enddo
c
c      mean of valid data in the surrounding
c
       dm=0.
       do ii=-k,k
        do jj=-k,k
         do j=js_pe,je_pe
          do i=is_pe,ie_pe
            dm(i,j)=dm(i,j)+d(i+ii,j+jj)*tmask(i+ii,klevel,j+jj)
          enddo
         enddo
        enddo
       enddo

      else
       if (my_pe == 0) print*,' cannot recognize type of grid '
       call halt_stop(' in smooth_hor ')
      endif

      where( isum /= 0 )  dm = dm/isum
c      elsewhere dm=0.
c      end where
c
c     set missing data to mean value of surrounding
c
      do j=js_pe,je_pe
       do i=is_pe,ie_pe
         d(i,j)=dm(i,j)
       enddo
      enddo

      end subroutine smooth_hor



      subroutine smooth_merid(d,m,i,kk)
      use spflame_module
      implicit none
      integer :: m  ! number of grid points to be smoothed
      integer :: i  ! zonal index of section
      integer :: kk ! vertical extend of section
      real :: d(js_pe:je_pe,kk) ! data to be smoothed

      real :: b(is_pe-m:ie_pe+m,js_pe-m:je_pe+m)
      integer :: j,jj,k,isum(js_pe:je_pe)

      if ( ( lbound( tmask, 1 ) >  is_pe-m ) .or.
     &      ( ubound( tmask, 1 ) <  ie_pe+m ) ) then
        if (my_pe==0) print*,
     &   ' tmask array in spflame_module is too small ',
     &   ' for smoothing operation of ',m,' grid points '
         call halt_stop(' in smooth_merid ')
      endif

      do k=1,kk
       b=0.
       if (i>=is_pe .and. i<=ie_pe)
     &     b(i,js_pe:je_pe)= d(js_pe:je_pe,k)

       call border_exchg(b,1,m)

       if (i>=is_pe .and. i<=ie_pe) then
        d(:,k)=0.
        isum=0
        do jj=-m,m
         do j=js_pe,je_pe
          d(j,k) = d(j,k)+b(i,j+jj)*tmask(i,k,j+jj)
          isum(j) = isum(j)+tmask(i,k,j+jj)
         enddo
        enddo
        where( isum /=0 ) d(:,k)=d(:,k)/isum
       endif

      enddo

      end subroutine smooth_merid



      subroutine smooth_zonal(d,m,j,kk)
      use spflame_module
      implicit none
      integer :: m  ! number of grid points to be smoothed
      integer :: j  ! meridional index of section
      integer :: kk ! vertical extend of section
      real :: d(is_pe:ie_pe,kk) ! data to be smoothed

      real :: b(is_pe-m:ie_pe+m,js_pe-m:je_pe+m)
      integer :: i,ii,k,isum(is_pe:ie_pe)

      if ( ( lbound( tmask, 1 ) >  is_pe-m ) .or.
     &      ( ubound( tmask, 1 ) <  ie_pe+m ) ) then
        if (my_pe==0) print*,
     &   ' tmask array in spflame_module is too small ',
     &   ' for smoothing operation of ',m,' grid points '
         call halt_stop(' in smooth_zonal ')
      endif

      do k=1,kk
       b=0.
       if (j>=js_pe .and. j<=je_pe)
     &     b(is_pe:ie_pe,j)= d(is_pe:ie_pe,k)

       call border_exchg(b,1,m)

       if (j>=js_pe .and. j<=je_pe) then
        d(:,k)=0.
        isum=0
        do ii=-m,m
         do i=is_pe,ie_pe
          d(i,k) = d(i,k)+b(i+ii,j)*tmask(i+ii,k,j)
          isum(i) = isum(i)+tmask(i+ii,k,j)
         enddo
        enddo
        where( isum /=0 ) d(:,k)=d(:,k)/isum
       endif

      enddo

      end subroutine smooth_zonal



      subroutine gcell_sub_domain(maxlen, n_bounds, bounds, 
     &                                d_bounds,num, deltat, deltau)
c
c=======================================================================
c     (changed version of gcell for grid construction for
c      sub domains )
c=======================================================================
c
      implicit none
      integer maxlen,n_bounds,num
      real deltat(maxlen), deltau(maxlen)
      real d_bounds(n_bounds), bounds(n_bounds)

      real avg_res, wid, del
      integer l,n,i,ierr,m
c
c     Do all regions, one at a time, to construct the domain
c
      num  = 1
      do l=1,n_bounds-1
c       avg_res = average resolution of T cells within region
c       wid     = width of region
        avg_res = .5*(d_bounds(l) + d_bounds(l+1))
        wid = abs(bounds(l+1) - bounds(l))
        n   = nint(wid/avg_res)
        del=wid/n
        do i=1,n
          deltau(num+i-1) = del
        enddo 
        num = num + n
      enddo
c
c     adjust "num" to reflect the total number of cells contained in
c     all regions
c
      num = num - 1
c
      do i=1,num
c
c       build resolution for T cells: "deltat". Note that
c       variable resolution (stretched grid) implies T points are
c       off center
c
        if (i .eq. 1) then
          deltat(i) = 0.5*(d_bounds(1) + deltau(i))
        else
          deltat(i) = 0.5*(deltau(i) + deltau(i-1))
        endif
      enddo     
      end subroutine gcell_sub_domain

#include "options.inc"


c-----------------------------------------------------------------------
! Time filtering a la Killworth
! to data where it is apropriate
! which means taux,tauy and ustar and maybe obc psi
! Notes:
! program uses LAPACK routines to invert tridiagonal matrix
! a calendar with non equal months but equal years is assumed
c-----------------------------------------------------------------------

      program killfilt
      implicit none

      call killfilt_it('forcing_folded_wind.cdf','taux')
      call killfilt_it('forcing_folded_wind.cdf','tauy')
      call killfilt_it('forcing_folded_wind.cdf','ustar')
      call cut_negative_values('forcing_folded_wind.cdf','ustar')
      call killfilt_it('forcing_folded_obc.cdf','psi_obc_south')


      call killfilt_it('forcing_folded.cdf','tauxBB')
      call killfilt_it('forcing_folded.cdf','tauyBB')
      call killfilt_it('forcing_folded.cdf','hflxBB')
      call killfilt_it('forcing_folded.cdf','sstm_BB')

      call killfilt_it('forcing_folded_sflx.cdf','sst_flux')
      call killfilt_it('forcing_folded_sflx.cdf','sss_flux')

      end program killfilt
 

      subroutine killfilt_it(fname,vname)
      implicit none
      character (len=*) :: fname, vname
#include "netcdf.inc"
      integer :: iret,ncid,vid,dimid(5),dim(5),ndim,n,xtype
      integer :: start(5),count(5)
      real (kind=4), allocatable :: buf(:,:,:)
      real (kind=4) :: spval
      character (len=80) :: s

      print*,' applying time filter a la Killworth et al to ',
     &  'variable ',vname(1:len_trim(vname)),' in file ',
     &   fname(1:len_trim(fname))

      iret=nf_open(fname,NF_WRITE,ncid)
      if (iret/=0) then
        print*,' ERROR: cannot open file'
        stop
      endif
      iret=nf_set_fill(ncid, NF_NOFILL, iret)

      iret=nf_inq_varid(ncid,vname,vid)
      if (iret/=0) then
        print*,' ERROR: cannot find variable'
        call ncclos (ncid, iret)
        return
      endif
      iret=NF_INQ_VARNDIMS(ncid,vid, ndim)
      if (ndim>3) then
        print*,' more than 3 dimensions are not allowed so far'
        print*,' but found ',ndim
        call ncclos (ncid, iret)
        stop
      endif
      if (ndim==1) then
        print*,' less than 2 dimensions are not allowed so far'
        print*,' but found ',ndim
        call ncclos (ncid, iret)
        stop
      endif
      iret=NF_INQ_VARTYPE(ncid,vid, xtype)
      if (xtype /= ncfloat) then
        print*,' cannot handle other types than ncfloat=',ncfloat
        print*,' but found ',xtype
        call ncclos (ncid, iret)
        stop
      endif

      iret = nf_get_att_real(ncid, vid, 'missing_value', spval)
      if (iret/=0) then
        print*,' ERROR: cannot find attribute missing value'
        print*,' for variable'
        call ncclos (ncid, iret)
        stop
      endif

      iret = nf_get_att_text(ncid, vid, 'killworth_filtered', s)
      if (iret==0) then
        print*,' ERROR: variable was already filtered'
        call ncclos (ncid, iret)
        stop
      endif

      iret=NF_INQ_VARDIMID (ncid,vid,dimid)
      dim=1
      do n=1,ndim
       iret=NF_INQ_DIMLEN(ncid, dimid(n), dim(n))
      enddo
      print*,' dimensions : ',dim(1:ndim)

      allocate( buf(dim(1),dim(2),dim(3)) )
      start=1; count=dim;
      iret= nf_get_vara_real(ncid,vid,start,count,buf)
      if (ndim==3) then
         call prep_killfilt(dim(ndim),dim(1),dim(2),buf,buf,spval)
      elseif (ndim==2) then
       call prep_killfilt(dim(ndim),dim(1),1,buf,buf,spval)
      else
       stop
      endif
      iret= nf_put_vara_real(ncid,vid,start,count,buf)

      deallocate(buf)

      iret = nf_redef(ncid)
      iret= nf_put_att_text(ncid,vid ,'killworth_filtered',4,'yeah')
      iret = nf_enddef(ncid)

      call ncclos (ncid, iret)

      end subroutine


      subroutine cut_negative_values(fname,vname)
      implicit none
      character (len=*) :: fname, vname
#include "netcdf.inc"
      integer :: iret,ncid,vid,dimid(5),dim(5),ndim,n,xtype
      integer :: start(5),count(5)
      real (kind=4), allocatable :: buf(:,:,:)
      real (kind=4):: spval
      character (len=80) :: s

      print*,' setting negative values to zero for ',
     &  'variable ',vname(1:len_trim(vname)),' in file ',
     &   fname(1:len_trim(fname))

      iret=nf_open(fname,NF_WRITE,ncid)
      if (iret/=0) then
        print*,' ERROR: cannot open file'
        stop
      endif
      iret=nf_set_fill(ncid, NF_NOFILL, iret)

      iret=nf_inq_varid(ncid,vname,vid)
      if (iret/=0) then
        print*,' ERROR: cannot find variable'
        call ncclos (ncid, iret)
        return
      endif
      iret=NF_INQ_VARNDIMS(ncid,vid, ndim)
      if (ndim>3) then
        print*,' more than 3 dimensions are not allowed so far'
        print*,' but found ',ndim
        call ncclos (ncid, iret)
        stop
      endif
      if (ndim==1) then
        print*,' less than 2 dimensions are not allowed so far'
        print*,' but found ',ndim
        call ncclos (ncid, iret)
        stop
      endif
      iret=NF_INQ_VARTYPE(ncid,vid, xtype)
      if (xtype /= ncfloat) then
        print*,' cannot handle other types than ncfloat=',ncfloat
        print*,' but found ',xtype
        call ncclos (ncid, iret)
        stop
      endif

      iret = nf_get_att_real(ncid, vid, 'missing_value', spval)
      if (iret/=0) then
        print*,' ERROR: cannot find attribute missing value'
        print*,' for variable'
        call ncclos (ncid, iret)
        stop
      endif

      iret = nf_get_att_text(ncid, vid, 'negative_values_cutted', s)
      if (iret==0) then
        print*,' ERROR: neg. values of variable already cutted'
        call ncclos (ncid, iret)
        stop
      endif

      iret=NF_INQ_VARDIMID (ncid,vid,dimid)
      dim=1
      do n=1,ndim
       iret=NF_INQ_DIMLEN(ncid, dimid(n), dim(n))
      enddo
      print*,' dimensions : ',dim(1:ndim)

      allocate( buf(dim(1),dim(2),dim(3)) )
      start=1; count=dim;
      iret= nf_get_vara_real(ncid,vid,start,count,buf)
      where( buf /=spval .and. buf <0.) buf=0.
      iret= nf_put_vara_real(ncid,vid,start,count,buf)

      deallocate(buf)

      iret = nf_redef(ncid)
      iret= nf_put_att_text(ncid,vid ,'negative_values_cutted',4,'yeah')
      iret = nf_enddef(ncid)

      call ncclos (ncid, iret)

      end subroutine


      subroutine prep_killfilt(itm,idim, jdim, rawdata, outdata, 
     &                         spval)
      implicit none
      integer :: itm,idim,jdim
      real (kind=4) :: rawdata(idim,jdim,itm), outdata(idim,jdim,itm)
      real (kind=4) :: spval
      real (kind=4) :: datold(itm),datnew
      real (kind=4), save, allocatable, dimension(:,:) :: pkf       
      logical,save :: first=.true.
      integer, save :: itm_save 
      integer i,j,m,l

      if (first .or. itm/=itm_save) then
        if (.not. first ) deallocate(pkf)
        allocate(pkf(itm,itm))
        call prep_killfilt_init (itm,pkf)
        first = .false.
        itm_save = itm
      end if

      do j=1, jdim
        do i=1, idim
          do m=1,itm
           datold(m) = rawdata(i,j,m)
          enddo
          do m=1, itm
            datnew = 0.
            do l=1, itm
              if (datold(l) .ne. spval) then
                datnew = datnew + pkf(m,l)*datold(l)
              else
                datnew = spval
              end if
            end do
            outdata(i,j,m) = datnew
          end do
        end do
      end do
      end subroutine prep_killfilt


      subroutine prep_killfilt_init (itm,pkf)
      implicit none
      real (kind=4), parameter :: r8 = 0.125,  p75 = 0.75
      real (kind=4), parameter :: c0 = 0., c1 = 1.
      integer :: itm
      integer :: indx (itm)
      real (kind=4) :: fkp (itm,itm)  ! interpolation matrix, automatic array
      real (kind=4) :: pkf (itm,itm)   !       inverse matrix
      real (kind=4) :: month(itm)
      real (kind=4) :: mmonth(12)
      data  mmonth/31.,28.,31.,30.,31.,30.,31.,31.,30.,31.,30.,31./
      integer :: lwork ,m,n,i,info

      print*,' initializing time interpolation matrix'
      lwork=itm*itm
      do m=1,12
       do n=m,itm,12
        month(n)=mmonth(m)
       enddo
      enddo
      fkp = c0
      do i=2,itm
       fkp(i,i-1)=month(i)/( 4.0*(month(i-1)+month(i)))
      enddo
      fkp(1,itm)=month(1)/( 4.0*(month(itm)+month(1)))
      do i=1,itm-1
       fkp(i,i+1)=month(i)/( 4.0*(month(i)+month(i+1) ))
      enddo
      fkp(itm,1)=month(itm)/( 4.0*(month(itm)+month(1)))
      do  i=2,itm-1
       fkp(i,i)=1.0-fkp(i,i-1)-fkp(i,i+1)
      enddo
      fkp(1,1)=1.0-fkp(1,itm)-fkp(1,2)
      fkp(itm,itm)=1.0-fkp(itm,itm-1)-fkp(itm,1)
      print*,' inverting matrix using lapack '
      call sgetrf(itm,itm,fkp,itm,indx,info)
      call sgetri(itm,fkp,itm,indx,pkf,lwork,info)
      print*,' done'
      pkf = fkp
      end  subroutine prep_killfilt_init

#include "options.inc"


      program nc_cat
c=======================================================================
c  concatenate netcdf variable in several files along last dimension
c=======================================================================
      implicit none
      real,parameter :: version = 0.1
      integer,allocatable :: ncin(:),varin(:)
      integer :: ncout,varout,nr_infiles
      integer :: nr_com,n,ierr
      character (len=80) :: fname,varname,dimname
      character (len=2000) :: outstr,str2
#include "netcdf.inc"
      integer :: iret,ndims,dimlen,len,m,istart
      integer, parameter :: ndmax=100
      integer, dimension(ndmax)  :: dimid,start,count
      real :: fx
      real , allocatable :: buf(:)
      integer :: buflen

      print'(" This is nc_cat.x :: version ",f5.3)',version
c  read command line input
      call get_commandline_argnr(nr_com)
      if (nr_com<4) goto 100
      nr_infiles = nr_com-2
      allocate( ncin(nr_infiles), varin(nr_infiles) )
      call get_commandline_arg(nr_com,varname,ierr)
c    write some information to stdout
      outstr=' concatenating variable '//varname(1:len_trim(varname))
      outstr = outstr(1:len_trim(outstr))//' in files :'
      do n=1,nr_infiles
       call get_commandline_arg(n,fname,ierr)
       outstr=outstr(1:len_trim(outstr))//fname(1:len_trim(fname))//','
      enddo
      call get_commandline_arg(nr_com-1,fname,ierr)
      outstr=outstr(1:len_trim(outstr)-1)//' and writing to file '//
     &   fname(1:len_trim(fname))
      print*,outstr(1:len_trim(outstr))

c   open input files and search for variable
      do n=1,nr_infiles
       call get_commandline_arg(n,fname,ierr)
       iret=nf_open(fname,NF_NOWRITE,ncin(n))
       if (iret /=0 ) goto 110
       iret=nf_inq_varid(ncin(n),varname,varin(n))
       if (iret /=0 ) goto 120
      enddo
c   create output file
      call get_commandline_arg(nr_com-1,fname,ierr)
      ncout = nccre (fname, NCNOCLOB, iret)
      if (iret /=0 ) goto 110
      iret=nf_set_fill(ncout, NF_NOFILL, iret)
c   determine overall length of last dimension
      len=0
      do n=1,nr_infiles
       iret=nf_inq_varndims(ncin(n),varin(n),ndims)
       if (ndims>ndmax) then
        print*,' ERROR: number of dims exceed ',ndmax
        stop
       endif
       iret=nf_inq_vardimid(ncin(n),varin(n),dimid)
       iret=nf_inq_dimlen(ncin(n),dimid(ndims),dimlen)
       len=len+dimlen
      enddo
c      print*,' determine overall length of ',len
c   copy dimensions and variables needed
      call get_commandline_arg(1,fname,ierr)
      print*,'defining output file like ',fname(1:len_trim(fname))
      call copy_variable(ncin(1),ncout,varname,.true.,len)
      call copy_file_attributes(ncin(1),ncout)
c   add another entry to attribute history
      iret = NF_GET_ATT_TEXT (NCin(1), nf_global, 'history',str2)
      iret = NF_inq_ATTlen (NCin(1), nf_global, 'history',n)
      if (iret/=0) n=0
      outstr=str2(1:n)//'\n nc_cat.x : '//outstr(1:len_trim(outstr))
      iret = NF_PUT_ATT_TEXT (NCout, nf_global, 
     &       'history',len_trim(outstr) , outstr)
      iret = nf_enddef(ncout)
      print*,' ok'

      iret=nf_inq_varid(ncout,varname,varout)
      iret=nf_inq_varndims(ncin(1),varin(1),ndims)
      iret=nf_inq_vardimid(ncin(1),varin(1),dimid)
      iret=NF_INQ_DIMlen (NCin, DIMId(ndims), istart)
      istart=istart+1
c   now append variables
      do n=2,nr_infiles
       call get_commandline_arg(n,fname,ierr)
       print*,'copying file ',fname(1:len_trim(fname))
       iret=nf_inq_vardimid(ncin(n),varin(n),dimid)
       buflen=1; start=1
       do m=1,ndims
        iret=NF_INQ_DIMlen (NCin(n), DIMId(m), count(m))
        buflen=buflen*count(m)
       enddo
       iret=NF_INQ_DIMname(NCin(n), DIMId(ndims),dimname)
       iret=nf_inq_varid(ncin(n),dimname,dimid(1))
       if (iret==0) then
        allocate(buf(count(ndims)))
        iret= nf_get_vara_real(ncin(n),dimid(1),1,count(ndims),buf)
        iret=nf_inq_varid(ncout,dimname,dimid(1))
        iret= nf_put_vara_real(ncout,dimid(1),istart,count(ndims),buf)
        deallocate(buf)
       endif
       allocate(buf(buflen))
       iret= nf_get_vara_real(ncin(n),varin(n),start,count,buf)
       start(ndims)=istart
       iret= nf_put_vara_real(ncout,varout,start,count,buf)
       istart=istart+count(ndims)
       deallocate(buf)
      enddo

c   close all files
      call ncclos (ncout, iret); if (iret /=0 ) goto 130
      do n=1,nr_infiles
       call ncclos (ncin(n), iret); if (iret /=0 ) goto 130
      enddo
      print*,'all done, bye'
      stop

 100  print*,' program needs command line parameter'
      print*,' input netcdf file names, output netcdf file name,'
      print*,' and variable name to be concatenated'
      stop
 110  print*,' problem opening NetCDF file ',fname(1:len_trim(fname))
      print*,' netcdf lib says: ',nf_strerror(iret)
      stop
 120  print*,' problem finding variable ',varname(1:len_trim(varname)),
     &   ' in file ',fname(1:len_trim(fname))
      print*,' netcdf lib says: ',nf_strerror(iret)
      stop
 130  print*,' problem closing NetCDF file '
      print*,' netcdf lib says: ',nf_strerror(iret)
      stop
      end program nc_cat





c   dummy routines

      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"

c
c-----------------------------------------------------------------------
c     Time series diagnostics.
c     Linked in the code in diag.F 
c     Activated by namelist parameter enable_timeseries
c     Binary data can be converted to NetCDF with ../cv_cdf/cv_anna.F
c-----------------------------------------------------------------------
c 
c ===== local defines ======
c
c The following defines can be either switched on or off
c to specify the data to be written out
c
c
c write u,v,t,s and tracer completely
c-------------------------
#define write_uvts_complete
c
c mixed layer depth 
c-------------------------
#define write_dml
c
c temperature in 100m depth
c-------------------------
c#define write_t100
c
c U,V in 100m depth
c-------------------------
c#define write_uv100
c
c T,S,U,V in 50m depth
c-------------------------
c#define write_tsuv50
c
c T,S,U,V in 0m depth
c-------------------------
c#define write_tsuv0
c
c u/viscosity at Eq.
c -------------------------
c#define write_u0N
c#define write_Av0N
c
c u/v/w at 35W
c -------------------------
c#define write_u35W
c#define write_v35W
c#define write_w35W
c
c zonal velocity at 5W 
c -------------------------
c#define write_u5W
c
c section at 57N
c -------------------------
c#define write_T57N
c
c pot. vorticity (times f)
c -------------------------
c#define write_pot_vort
c#define write_pot_vort_35W
c#define write_pot_vort_0N
c
c Tracer at BATS station (65W, 32N)
c -------------------------
c#define write_BATS
c
c ====== end of local defines ======



      module timeserie_module
      real :: spval=-9.9e12,tt
      real,allocatable :: dmix(:,:),potv(:,:,:),bvort(:,:,:)
      integer :: k_t100,k_t50,k_t10,k_t0
      integer :: j_u0N,j_t0N
      integer :: i_u35W,i_t35W
      integer :: i_u5W
      integer :: j_t57N
      integer :: i_bats,j_bats
      integer :: nr_var
      character (len=80) :: outfile
      end module timeserie_module


      subroutine init_diag_timeserie
      use spflame_module
      use timeserie_module
      implicit none
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer :: ncid,iret,i,j,k,n
      integer :: lat_tdim,itimedim, lon_tdim,lat_udim,lon_udim
      integer :: depth_wdim,depth_tdim,lat_uid,lon_uid
      integer :: depth_wid,depth_tid, lat_tid,itimeid,lon_tid
      integer :: dims(4), corner(4), edges(4)
      character :: name*24, unit*16, text*80
#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:)
#else
      real         , allocatable :: v4(:)
#endif
#endif
      integer :: indp,year,month,day,io,varid

      year  = get_year(get_current_time())
      month = get_month_of_year(get_current_time())
      day   = get_day_of_month(get_current_time())

#ifdef netcdf_diagnostics
      write(outfile,'("anna_",i3,"_y",i4,"m",i2,"d",i2,"_",i8,".cdf")') 
#else
      write(outfile,'("anna_",i3,"_y",i4,"m",i2,"d",i2,"_",i8,".dta")') 
#endif
     &            sub_domain,year,month,day,itt

      call replace_space_zero(outfile)

      if (my_pe == 0) then
        print*,''
        print*,' Setting up time series diagnostics:'
        print*,'  writing to file ',
     &         outfile(1:len_trim(outfile)),
#ifdef netcdf_diagnostics
     &         '  (netcdf format)'
#else
     &         '  (binary output)'
#endif
      endif

      nr_var=0

      k_t100 = indp(100.0*100.0,zt,km)
      k_t50  = indp(50.0*100.0,zt,km)
      k_t10  = indp(10.0*100.0,zt,km)
      k_t0   = indp(0.0*100.0,zt,km)

      i_t35W  = indp(360.0-35.0,xt,imt)
      i_u35W  = indp(360.0-35.0,xu,imt)
      i_u5W  = indp(360.0-5.0,xu,imt)
      j_t0N   = indp(0.0,yt,jmt)
      j_u0N  = indp(0.0,yu,jmt)
      j_t57N  = indp(0.0,yt,jmt)

#ifdef write_uvts_complete
      if (my_pe == 0) print*,'  writing u,v,t,s,... completely'
      nr_var=nr_var+1
#endif

#ifdef write_dml
      if (my_pe == 0) print*,'  writing mixed layer depth'
      allocate(dmix(is_pe:ie_pe,js_pe:je_pe) )
      dmix=0.
      nr_var=nr_var+1
#endif

#if defined write_pot_vort 
      if (my_pe == 0) print*,'  writing potential vorticity'
      nr_var=nr_var+2
#endif
#if defined write_pot_vort_35W
      if (my_pe == 0) print*,'  writing potential vorticity at 35W'
      nr_var=nr_var+2
#endif
#if defined write_pot_vort_0N
      if (my_pe == 0) print*,'  writing potential vorticity at 0N'
      nr_var=nr_var+2
#endif
#if defined write_pot_vort || defined write_pot_vort_35W || defined write_pot_vort_0N 
      allocate(potv(is_pe:ie_pe,km,js_pe:je_pe) )
      allocate(bvort(is_pe:ie_pe,km,js_pe:je_pe) )
      potv=0.0; bvort=0.0
#endif

#ifdef write_t100
      if (my_pe == 0) print*,'  writing temperature in ',
     &   zt(k_t100)/100.0,'m depth'
      nr_var=nr_var+1
#endif

#ifdef write_uv100
      if (my_pe == 0) print*,'  writing velocity in ',
     &   zt(k_t100)/100.0,'m depth'
      nr_var=nr_var+2
#endif

#ifdef write_tsuv50
      if (my_pe == 0) print*,'  writing velocity,T,S in ',
     &   zt(k_t50)/100.0,'m depth'
      nr_var=nr_var+4
#endif

#ifdef write_tsuv0
      if (my_pe == 0) print*,'  writing velocity,T,S in ',
     &   zt(k_t0)/100.0,'m depth'
      nr_var=nr_var+4
#endif

#ifdef write_u0N
      if (my_pe == 0) print*,'  writing zonal velocity at ',
     &   yu(j_u0N),' N'
      nr_var=nr_var+1
#endif

#ifdef write_Av0N
      if (my_pe == 0) print*,'  writing vert. viscosity at ',
     &   yu(j_u0N),' N'
      nr_var=nr_var+1
#endif

#ifdef write_T57N
      if (my_pe == 0) print*,'  writing temperature at ',
     &   yt(j_t57N),' N'
      nr_var=nr_var+1
#endif

#ifdef write_u35W
      if (my_pe == 0) print*,'  writing zonal velocity at ',
     &   xu(i_u35W),' W'
      nr_var=nr_var+1
#endif

#ifdef write_v35W
      if (my_pe == 0) print*,'  writing merid. velocity at ',
     &   xu(i_u35W),' W'
      nr_var=nr_var+1
#endif

#ifdef write_w35W
      if (my_pe == 0) print*,'  writing vert. velocity at ',
     &   xu(i_u35W),' W'
      nr_var=nr_var+1
#endif

#ifdef write_u5W
      if (my_pe == 0) print*,'  writing zonal velocity at ',
     &   xu(i_u5W),' W'
      nr_var=nr_var+1
#endif

#ifdef write_BATS
      i_bats  = indp(360.0-65.0,xt,imt)
      j_bats  = indp(32.0,yt,jmt)
      if (my_pe == 0) print*,'  writing tracer at station BATS '
      nr_var=nr_var+1
#endif

      if (my_pe==0) print*,'  writing altogether ',nr_var,' variables'

#ifdef netcdf_diagnostics
      if (my_pe == 0) then
      print*,'  initializing NetCDF output file ',
     &         outfile(1:len_trim(outfile))
      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call store_info_cdf(ncid)
c     dimensions
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lon_udim
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = depth_wdim
      depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)

c     attributes of the grid
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on T grid      '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on U grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of W Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_wid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_wid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c
c     define variables
c
#ifdef write_uvts_complete
      dims=(/lon_udim,lat_udim,depth_tdim,itimedim/)
      varid=ncvdef (ncid,'u', NCFLOAT,4,dims,iret)
      name = 'Zonal velocity'; unit = 'm/s'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      varid=ncvdef (ncid,'v', NCFLOAT,4,dims,iret)
      name = 'Meridional velocity'; unit = 'm/s'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
      varid=ncvdef (ncid,'temp', NCFLOAT,4,dims,iret)
      name = 'Temperature'; unit = 'deg C'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      varid=ncvdef (ncid,'salt', NCFLOAT,4,dims,iret)
      name = 'Salinity'; unit = 'psu'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      if (nt>2) then
        do n=3,nt
          write(name,'("tracer_",i2)') n
          call replace_space_zero(name)
          varid=ncvdef (ncid,name, NCFLOAT,4,dims,iret)
          name = 'Passive tracer'; unit = ' '
          call dvcdf(ncid,varid,name,len_trim(name),
     &               unit,len_trim(unit),spval)
        enddo
      endif
#endif

#ifdef write_dml
      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      varid=ncvdef (ncid,'dml', NCFLOAT,3,dims,iret)
      name = 'Mixed layer depth'; unit = 'm'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_pot_vort
      dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
      varid=ncvdef (ncid,'potv', NCFLOAT,4,dims,iret)
      name = 'Potential Vorticity'; unit = '1/s^2/m'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      varid=ncvdef (ncid,'bvort', NCFLOAT,4,dims,iret)
      name = 'Barotropic Vorticity'; unit = '1/s^2/m'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_pot_vort_35W
      dims=(/lat_tdim,depth_tdim,itimedim,1/)
      varid=ncvdef (ncid,'potv35W', NCFLOAT,3,dims,iret)
      name = 'Potential Vorticity at 35W'; unit = '1/s^2/m'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      varid=ncvdef (ncid,'bvort35W', NCFLOAT,3,dims,iret)
      name = 'Barotropic Vorticity at 35W'; unit = '1/s^2/m'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_pot_vort_0N
      dims=(/lon_tdim,depth_tdim,itimedim,1/)
      varid=ncvdef (ncid,'potv0N', NCFLOAT,3,dims,iret)
      name = 'Potential Vorticity at 0N'; unit = '1/s^2/m'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      varid=ncvdef (ncid,'bvort0N', NCFLOAT,3,dims,iret)
      name = 'Barotropic Vorticity at 0N'; unit = '1/s^2/m'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_t100
      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      varid =ncvdef (ncid,'t100', NCFLOAT,3,dims,iret)
      name = 'Temperature in 100m'; unit = 'deg C'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_uv100
      dims=(/lon_udim,lat_udim,itimedim,1/)
      varid =ncvdef (ncid,'u100', NCFLOAT,3,dims,iret)
      name = 'Zonal velocity in 100m'; unit = 'm/s'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      dims=(/lon_udim,lat_udim,itimedim,1/)
      varid =ncvdef (ncid,'v100', NCFLOAT,3,dims,iret)
      name = 'Meridional velocity in 100m'; unit = 'm/s'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_tsuv50
      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      varid =ncvdef (ncid,'s50', NCFLOAT,3,dims,iret)
      name = 'Salinity in 50m'; unit = 'psu'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      varid =ncvdef (ncid,'t50', NCFLOAT,3,dims,iret)
      name = 'Temperature in 50m'; unit = 'deg C'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      dims=(/lon_udim,lat_udim,itimedim,1/)
      varid =ncvdef (ncid,'u50', NCFLOAT,3,dims,iret)
      name = 'Zonal velocity in 50m'; unit = 'm/s'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      dims=(/lon_udim,lat_udim,itimedim,1/)
      varid =ncvdef (ncid,'v50', NCFLOAT,3,dims,iret)
      name = 'Meridional velocity in 50m'; unit = 'm/s'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_tsuv0
      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      varid =ncvdef (ncid,'s0', NCFLOAT,3,dims,iret)
      name = 'Salinity in 0m'; unit = 'psu'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      varid =ncvdef (ncid,'t0', NCFLOAT,3,dims,iret)
      name = 'Temperature in 0m'; unit = 'deg C'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      dims=(/lon_udim,lat_udim,itimedim,1/)
      varid =ncvdef (ncid,'u0', NCFLOAT,3,dims,iret)
      name = 'Zonal velocity in 0m'; unit = 'm/s'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      dims=(/lon_udim,lat_udim,itimedim,1/)
      varid =ncvdef (ncid,'v0', NCFLOAT,3,dims,iret)
      name = 'Meridional velocity in 0m'; unit = 'm/s'
      call dvcdf(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif


#ifdef write_u0N
      dims=(/lon_udim,depth_tdim,itimedim,1/)
      varid=ncvdef (ncid,'u0N', NCFLOAT,3,dims,iret)
      name = 'Zonal velocity at Eq.'; unit = 'm/s'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_Av0N
      dims=(/lon_udim,depth_wdim,itimedim,1/)
      varid=ncvdef (ncid,'Av0N', NCFLOAT,3,dims,iret)
      name = 'Vert. viscosity at Eq.'; unit = 'm^2/s'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_T57N
      dims=(/lon_tdim,depth_tdim,itimedim,1/)
      varid=ncvdef (ncid,'T57N', NCFLOAT,3,dims,iret)
      name = 'Temperature at 57N'; unit = 'deg C'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_u35W
      dims=(/lat_udim,depth_tdim,itimedim,1/)
      varid=ncvdef (ncid,'u35W', NCFLOAT,3,dims,iret)
      name = 'Zonal velocity at 35W'; unit = 'm/s'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_v35W
      dims=(/lat_udim,depth_tdim,itimedim,1/)
      varid=ncvdef (ncid,'v35W', NCFLOAT,3,dims,iret)
      name = 'Merid. velocity at 35W'; unit = 'm/s'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_w35W
      dims=(/lat_udim,depth_wdim,itimedim,1/)
      varid=ncvdef (ncid,'w35W', NCFLOAT,3,dims,iret)
      name = 'Vert. velocity at 35W'; unit = 'm/s'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_u5W
      dims=(/lat_udim,depth_tdim,itimedim,1/)
      varid=ncvdef (ncid,'u5W', NCFLOAT,3,dims,iret)
      name = 'Zonal velocity at 5W'; unit = 'm/s'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
#endif

#ifdef write_BATS
      dims=(/depth_tdim,itimedim,1,1/)
      varid=ncvdef (ncid,'t_bats', NCFLOAT,2,dims,iret)
      name = 'Temperature at 65W, 32N'; unit = 'deg C'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      varid=ncvdef (ncid,'s_bats', NCFLOAT,2,dims,iret)
      name = 'Salinity at 65W, 32N'; unit = 'psu'
      call dvcdf(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
      do n=3,nt
       write(name,'("tr",i2,"_bats")') n
       call replace_space_zero(name)
       varid=ncvdef (ncid,name, NCFLOAT,2,dims,iret)
       write(name,'("Passive tracer ",i2)') n; unit = ' '
       call dvcdf(ncid,varid,name,len_trim(name),
     &            unit,len_trim(unit),spval)
      enddo
#endif

      call ncendf(ncid, iret)

      allocate( v4(max(imt,jmt,km)) )
      corner(1) = 1; edges(1) = jmt
      v4(1:jmt)=yt
      call ncvpt(ncid, Lat_tid, corner, edges,v4, iret)
      v4(1:jmt)=yu
      call ncvpt(ncid, Lat_uid, corner, edges,v4, iret)
      corner(1) = 1; edges(1) = imt
      v4(1:imt)=xt
      call ncvpt(ncid, lon_tid, corner, edges,v4, iret)
      v4(1:imt)=xu
      call ncvpt(ncid, Lon_uid, corner, edges,v4, iret)
      corner(1) = 1; edges(1) = km
      v4(1:km)=zt/100.
      call ncvpt(ncid, depth_tid, corner, edges,v4, iret)
      corner(1) = 1; edges(1) = km
      v4(1:km)=zw/100.
      call ncvpt(ncid, depth_wid, corner, edges,v4, iret)
      deallocate(v4)
      call ncclos (ncid, iret)
      print*,' done'
      endif ! my_pe==0
#else
c
c     write a header
c
      if (my_pe==0) then
       print*,'  initializing binary output file ',
     &         outfile(1:len_trim(outfile))
       call getunit(io,outfile,'usr ieee')
       write(io) imt,jmt,km,nt,nr_var
       write(io) xt,yt,xu,yu,zt,zw,spval
       close(io)
      endif
#endif

      if (my_pe == 0) then
        print*,' done setting up time series diagnostics'
        print*,''
      endif


      end subroutine init_diag_timeserie



      subroutine diag_timeserie
      use spflame_module
      use timeserie_module
      implicit none
      real    :: ro(is_pe:ie_pe,km)
      integer :: m1(is_pe:ie_pe,km),i,j,k
      integer :: kd(is_pe:ie_pe)
      real, parameter :: delta = 0.01/1000. ! [g/cm^3] mixed layer depth criterium
#if defined write_pot_vort || defined write_pot_vort_35W || defined write_pot_vort_0N
      real ::  fxf(is_pe-1:ie_pe+1,   js_pe-1:je_pe+1),f
      real :: sig0(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1),rx,ry
      real ::  frz(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1),uz,vz
      real ::  fuy(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1),uy
      real ::  fvx(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1),vx

#endif
      integer :: is,ie,js,je

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
#ifdef write_dml
      dmix=0.
      do j=js,je
c      calculate sigma theta  [g/cm^3]
       do k=1,km
        call model_dens(t(is,k,j,1,tau),
     &                  t(is,k,j,2,tau),
     &                  ro(is,k),1,ie-is+1
#ifdef partial_cell
     &                       ,ztp(is,k,j)
#endif
     &                       )
       enddo
c      compute the mixed layer dmix from sigma theta (vector code here)
       m1(:,1)=1
       do k=2,km
        do i=is,ie
         m1(i,k)=1*m1(i,k-1) ! if the above is already zero do not go further
         if (ro(i,k) > ro(i,1) +delta ) m1(i,k)=0
        enddo
       enddo
       kd(:)=1
       do k=2,km
        do i=is,ie
         kd(i)=kd(i)+m1(i,k)
        enddo
       enddo
       do i=is,ie
        k = min( max(2,kd(i)),kmt(i,j) )
        dmix(i,j)=zt(k)/100.
       enddo
      enddo
#endif


#if defined write_pot_vort || defined write_pot_vort_35W || defined write_pot_vort_0N
c
c   ------------------------
c     calculate potential vorticity:
c   ------------------------
c
c     Q = 1/rho_0 ( u_z rho_y - v_z rho_x + rho_z( v_x-u_y +f) )
c
c     get potential density referenced to k=1


      do j=js,je
       do k=1,km
        call model_dens(t(is-1,k,j,1,tau),
     &                  t(is-1,k,j,2,tau),
     &                  sig0(is-1,k,j),1,ie-is+3
#ifdef partial_cell
     &                       ,ztp(is-1,k,j)
#endif
     &                       )
       enddo
      enddo
c
c     drhodz
c   ------------------------
      do j=js,je
       do k=2,km
        do i=is,ie
         frz(i,k,j) = -(sig0(i,k-1,j)-sig0(i,k,j))*dzwr(k)
     &                  *tmask(i,k,j)*tmask(i,k-1,j)
        enddo
       enddo
       frz(:,1,j)=0.0
      enddo 
c     interpolate rho_z to t grid
      do j=js,je
       do k=1,km-1
        do i=is,ie
         frz(i,k,j) = (frz(i,k,j)+frz(i,k+1,j))*0.5
     &                 *tmask(i,k,j)*tmask(i,k+1,j)
        enddo
       enddo
       frz(:,km,j)=0.0
      enddo 
c
c     dudy      
c   ------------------------
      do j=js,je
       do k=1,km
        do i=is-1,ie
         fuy(i,k,j) = (u(i,k,j,1,tau)-u(i,k,j-1,1,tau))*dytr(j)
        enddo
       enddo
      enddo 
c
c     dvdx
c   ------------------------
      do j=js-1,je
       do k=1,km
        do i=is,ie
         fvx(i,k,j) =  (u(i,k,j,2,tau)-u(i-1,k,j,2,tau))
     &        *dxtr(i)*cstr(max(1,j))
        enddo
       enddo
      enddo 
c
c     Coriolis factor
      fxf=0.0
      do j=js,je
       do i=is,ie
        fxf(i,j)=cori(i,j,1)
       enddo 
      enddo 
      call set_cyclic(fxf,1,1)
      call border_exchg(fxf,1,1)
c
c     calculate  rho_z ( v_x - u_y + f)
c   ------------------------
      do j=js,je
       do k=1,km
        do i=is,ie
         f = (fxf(i,j)+fxf(i-1,j)+fxf(i,j-1)+fxf(i-1,j-1) )*0.25
         uy= (fuy(i,k,j)+fuy(i-1,k,j))*0.5
         vx= (fvx(i,k,j)+fvx(i,k,j-1))*0.5
         potv(i,k,j)=frz(i,k,j)*( vx -uy+ f)
         bvort(i,k,j)=f*( vx -uy+ f)
        enddo 
       enddo 
      enddo 
c
c     dudz
c   ------------------------
      do j=js-1,je
       do k=2,km
        do i=is-1,ie
         frz(i,k,j) = (u(i,k-1,j,1,tau)-u(i,k,j,1,tau))
     &                 *dzwr(k)*umask(i,k,j)*umask(i,k-1,j)
        enddo
       enddo
       frz(:,1,j)=0.0
      enddo 
c     interpolate u_z to t grid vertically
      do j=js-1,je
       do k=1,km-1
        do i=is-1,ie
         frz(i,k,j) = (frz(i,k,j)+frz(i,k+1,j))*0.5
     &                 *umask(i,k,j)*umask(i,k+1,j)
        enddo
       enddo
       frz(:,km,j)=0.0
      enddo 
c
c     drhody      
c   ------------------------
      do j=js-1,je
       do k=1,km
        do i=is,ie
         fuy(i,k,j) = -(sig0(i,k,j+1)-sig0(i,k,j))*dyur(max(1,j))
        enddo
       enddo
      enddo 
c
c     add u_z rho_y to pot. vorticity
c   ------------------------
      do j=js,je
       do k=1,km
        do i=is,ie
         ry = (fuy(i,k,j)+fuy(i,k,j-1))*0.5
         uz = (frz(i  ,k,j)+frz(i  ,k,j-1)+
     &         frz(i-1,k,j)+frz(i-1,k,j-1))*0.25
         potv(i,k,j)=potv(i,k,j)+uz*ry
        enddo 
       enddo 
      enddo 
c
c     dvdz
c   ------------------------
      do j=js-1,je
       do k=2,km
        do i=is-1,ie
         frz(i,k,j) = (u(i,k-1,j,2,tau)-u(i,k,j,2,tau))
     &                 *dztr(k)*umask(i,k,j)*umask(i,k-1,j)
        enddo
       enddo
       frz(:,1,j)=0.0
      enddo 
c     interpolate v_z to t grid vertically
      do j=js-1,je
       do k=1,km-1
        do i=is-1,ie
         frz(i,k,j) = (frz(i,k,j)+frz(i,k+1,j))*0.5
     &                 *umask(i,k,j)*umask(i,k+1,j)
        enddo
       enddo
       frz(i,:,j)=0.0
      enddo 
c
c     drhodx      
c   ------------------------
      do j=js,je
       do k=1,km
        do i=is-1,ie
         fvx(i,k,j) = -(sig0(i+1,k,j)-sig0(i,k,j))
     &                    *dxtr(max(1,i))*cstr(j)
        enddo
       enddo
      enddo 
c
c     add  - v_z rho_x to pot. vorticity
c   ------------------------
      do j=js,je
       do k=1,km
        do i=is,ie
         rx = (fvx(i,k,j)+fvx(i-1,k,j))*0.5
         vz = (frz(i  ,k,j)+frz(i  ,k,j-1)+
     &         frz(i-1,k,j)+frz(i-1,k,j-1))*0.25
         f = (fxf(i,j)+fxf(i-1,j)+fxf(i,j-1)+fxf(i-1,j-1) )*0.25
c        multiply pot. vort with f
         potv(i,k,j)=(potv(i,k,j)-vz*rx)*rho0r*f
        enddo 
       enddo 
      enddo 

#endif

      call diag_timeserie_output

      end subroutine diag_timeserie




      subroutine diag_timeserie_output
      use spflame_module
      use timeserie_module
      implicit none

#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer :: npe,ncid,iret,timedim,timeid,varid
      integer :: corner(4),edges(4)
      character (len=80) :: name

#ifdef netcdf_real4
      real (kind=4), allocatable :: v4(:,:)
#else
      real         , allocatable :: v4(:,:)
#endif

#else
      integer :: io
      real         , allocatable :: buf(:,:)
      character (len=80) :: ident
#endif
      integer :: i,j,k,n,m

#ifdef netcdf_diagnostics
c
c     write to netcdf format here
c
      if (my_pe==0) print*,' --> writing time serie to file ',
     &         outfile(1:len_trim(outfile))
      do npe=0,n_pes
       call barrier
       if (my_pe==npe) then
        iret=nf_open(outfile,NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_varid(ncid,'Time',timeid)
        iret=nf_inq_dimid(ncid,'Time',timedim)
        iret=nf_inq_dimlen(ncid, timedim,n)
        allocate( v4(1,1) )
        if (my_pe==0) then
         n=n+1
         corner(1)=n
         edges(1)=1
         call read_stamp(current_stamp,tt)
         print*,' at stamp=',current_stamp,
     &          ' (days since origin : ',tt,')',
     &          ' (time steps in file : ',n,')'
         v4(1,1)=tt
         iret= nf_put_vara_real (ncid,timeid, corner,edges,v4)
        endif
        deallocate(v4)

#ifdef write_uvts_complete
        allocate( v4(is_pe:ie_pe,js_pe:je_pe) )
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        do k=1,km
         corner=(/is_pe,js_pe,k,n/); 

         v4=u(is_pe:ie_pe,k,js_pe:je_pe,1,tau)
         where( umask(is_pe:ie_pe,k,js_pe:je_pe)==0) v4=spval
         iret=nf_inq_varid(ncid,'u',varid)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)

         v4=u(is_pe:ie_pe,k,js_pe:je_pe,2,tau)
         where( umask(is_pe:ie_pe,k,js_pe:je_pe)==0) v4=spval
         iret=nf_inq_varid(ncid,'v',varid)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)

         v4=t(is_pe:ie_pe,k,js_pe:je_pe,1,tau)
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe)==0) v4=spval
         iret=nf_inq_varid(ncid,'temp',varid)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)

         v4=t(is_pe:ie_pe,k,js_pe:je_pe,2,tau)
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe)==0) v4=spval
         iret=nf_inq_varid(ncid,'salt',varid)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)

         if (nt>2) then 
          do m=3,nt
           v4=t(is_pe:ie_pe,k,js_pe:je_pe,m,tau)
           where( tmask(is_pe:ie_pe,k,js_pe:je_pe)==0) v4=spval
           write(name,'("tracer_",i2)') m
           call replace_space_zero(name)
           iret=nf_inq_varid(ncid,name,varid)
           iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
          enddo
         endif

        enddo
        deallocate(v4)
#endif

#ifdef write_dml
        allocate( v4(is_pe:ie_pe,js_pe:je_pe) )
        v4=dmix(is_pe:ie_pe,js_pe:je_pe)
        where( tmask(is_pe:ie_pe,1,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'dml',varid)
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
        deallocate(v4)
#endif

#ifdef write_pot_vort
        allocate( v4(is_pe:ie_pe,js_pe:je_pe) )
        iret=nf_inq_varid(ncid,'potv',varid)
        v4=spval
        corner=(/is_pe,js_pe,1,n/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
        corner=(/is_pe,js_pe,km,n/); 
        iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
        do k=2,km-1
         v4=potv(is_pe:ie_pe,k,js_pe:je_pe)
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe)==0)   v4=spval
         where( tmask(is_pe:ie_pe,k-1,js_pe:je_pe)==0) v4=spval
         where( tmask(is_pe:ie_pe,k+1,js_pe:je_pe)==0) v4=spval
         corner=(/is_pe,js_pe,k,n/); 
         edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
        enddo

        iret=nf_inq_varid(ncid,'bvort',varid)
        v4=spval
        corner=(/is_pe,js_pe,1,n/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
        corner=(/is_pe,js_pe,km,n/); 
        iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
        do k=2,km-1
         v4=bvort(is_pe:ie_pe,k,js_pe:je_pe)
         where( tmask(is_pe:ie_pe,k,js_pe:je_pe)==0)   v4=spval
         where( tmask(is_pe:ie_pe,k-1,js_pe:je_pe)==0) v4=spval
         where( tmask(is_pe:ie_pe,k+1,js_pe:je_pe)==0) v4=spval
         corner=(/is_pe,js_pe,k,n/); 
         edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
        enddo
        deallocate(v4)
#endif

#ifdef write_pot_vort_35W
        if (is_pe <= i_t35W .and. ie_pe >= i_t35W ) then
         allocate( v4(js_pe:je_pe,km) )
         do j=js_pe,je_pe
          do k=1,km
           v4(j,k)=potv(i_t35W,k,j)
           if (tmask(i_t35W,k,j)==0) v4(j,k)=spval
          enddo
         enddo
         iret=nf_inq_varid(ncid,'potv35W',varid)
         corner=(/js_pe,1,n,1/); 
         edges=(/je_pe-js_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         do j=js_pe,je_pe
          do k=1,km
           v4(j,k)=bvort(i_t35W,k,j)
           if (tmask(i_t35W,k,j)==0) v4(j,k)=spval
          enddo
         enddo
         iret=nf_inq_varid(ncid,'bvort35W',varid)
         corner=(/js_pe,1,n,1/); 
         edges=(/je_pe-js_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         deallocate(v4)
        endif
#endif

#ifdef write_pot_vort_0N
        if (js_pe <= j_t0N .and. je_pe >= j_t0N ) then
         allocate( v4(is_pe:ie_pe,km) )
         do k=1,km
          do i=is_pe,ie_pe
           v4(i,k)=potv(i,k,j_t0N)
           if (tmask(i,k,j_t0N)==0) v4(i,k)=spval
          enddo
         enddo
         iret=nf_inq_varid(ncid,'potv0N',varid)
         corner=(/is_pe,1,n,1/); 
         edges=(/ie_pe-is_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         do k=1,km
          do i=is_pe,ie_pe
           v4(i,k)=bvort(i,k,j_t0N)
           if (tmask(i,k,j_t0N)==0) v4(i,k)=spval
          enddo
         enddo
         iret=nf_inq_varid(ncid,'bvort0N',varid)
         corner=(/is_pe,1,n,1/); 
         edges=(/ie_pe-is_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         deallocate(v4)
        endif
#endif

#ifdef write_t100
        allocate( v4(is_pe:ie_pe,js_pe:je_pe) )
        v4=t(is_pe:ie_pe,k_t100,js_pe:je_pe,1,tau)
        where( tmask(is_pe:ie_pe,k_t100,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'t100',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        deallocate(v4)
#endif

#ifdef write_uv100
        allocate( v4(is_pe:ie_pe,js_pe:je_pe) )
        v4=u(is_pe:ie_pe,k_t100,js_pe:je_pe,1,tau)
        where( umask(is_pe:ie_pe,k_t100,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'u100',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        v4=u(is_pe:ie_pe,k_t100,js_pe:je_pe,2,tau)
        where( umask(is_pe:ie_pe,k_t100,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'v100',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        deallocate(v4)
#endif

#ifdef write_tsuv50
        allocate( v4(is_pe:ie_pe,js_pe:je_pe) )
        v4=t(is_pe:ie_pe,k_t50,js_pe:je_pe,2,tau)
        where( tmask(is_pe:ie_pe,k_t50,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'s50',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        v4=t(is_pe:ie_pe,k_t50,js_pe:je_pe,1,tau)
        where( tmask(is_pe:ie_pe,k_t50,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'t50',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        v4=u(is_pe:ie_pe,k_t50,js_pe:je_pe,1,tau)
        where( umask(is_pe:ie_pe,k_t50,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'u50',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        v4=u(is_pe:ie_pe,k_t50,js_pe:je_pe,2,tau)
        where( umask(is_pe:ie_pe,k_t50,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'v50',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        deallocate(v4)
#endif

#ifdef write_tsuv0
        allocate( v4(is_pe:ie_pe,js_pe:je_pe) )
        v4=t(is_pe:ie_pe,k_t0,js_pe:je_pe,2,tau)
        where( tmask(is_pe:ie_pe,k_t0,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'s0',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        v4=t(is_pe:ie_pe,k_t0,js_pe:je_pe,1,tau)
        where( tmask(is_pe:ie_pe,k_t0,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'t0',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        v4=u(is_pe:ie_pe,k_t0,js_pe:je_pe,1,tau)
        where( umask(is_pe:ie_pe,k_t0,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'u0',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        v4=u(is_pe:ie_pe,k_t0,js_pe:je_pe,2,tau)
        where( umask(is_pe:ie_pe,k_t0,js_pe:je_pe)==0) v4=spval
        iret=nf_inq_varid(ncid,'v0',varid )
        corner=(/is_pe,js_pe,n,1/); 
        edges=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret= nf_put_vara_real (ncid,varid  ,corner, edges,v4)
        deallocate(v4)
#endif

#ifdef write_u0N
        if (js_pe <= j_u0N .and. je_pe >= j_u0N ) then
         allocate( v4(is_pe:ie_pe,km) )
         v4=u(is_pe:ie_pe,1:km,j_u0N,1,tau)/100.0
         where( umask(is_pe:ie_pe,1:km,j_u0N)==0) v4=spval
         iret=nf_inq_varid(ncid,'u0N',varid)
         corner=(/is_pe,1,n,1/); 
         edges=(/ie_pe-is_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         deallocate(v4)
        endif
#endif

#ifdef write_Av0N
        if (js_pe <= j_u0N .and. je_pe >= j_u0N ) then
         allocate( v4(is_pe:ie_pe,km) )
         v4=visc_cbu(is_pe:ie_pe,1:km,j_u0N)/1.0e4
         where( umask(is_pe:ie_pe,1:km,j_u0N)==0) v4=spval
         iret=nf_inq_varid(ncid,'Av0N',varid)
         corner=(/is_pe,1,n,1/); 
         edges=(/ie_pe-is_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         deallocate(v4)
        endif
#endif

#ifdef write_T57N
        if (js_pe <= j_t57N .and. je_pe >= j_t57N ) then
         allocate( v4(is_pe:ie_pe,km) )
         v4=t(is_pe:ie_pe,1:km,j_t57N,1,tau)
         where( tmask(is_pe:ie_pe,1:km,j_t57N)==0) v4=spval
         iret=nf_inq_varid(ncid,'T57N',varid)
         corner=(/is_pe,1,n,1/); 
         edges=(/ie_pe-is_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         deallocate(v4)
        endif
#endif

#ifdef write_u35W
        if (is_pe <= i_u35W .and. ie_pe >= i_u35W ) then
         allocate( v4(js_pe:je_pe,km) )
         do j=js_pe,je_pe
          do k=1,km
           v4(j,k)=u(i_u35W,k,j,1,tau)/100.0
           if (umask(i_u35W,k,j)==0) v4(j,k)=spval
          enddo
         enddo
         iret=nf_inq_varid(ncid,'u35W',varid)
         corner=(/js_pe,1,n,1/); 
         edges=(/je_pe-js_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         deallocate(v4)
        endif
#endif

#ifdef write_v35W
        if (is_pe <= i_u35W .and. ie_pe >= i_u35W ) then
         allocate( v4(js_pe:je_pe,km) )
         do j=js_pe,je_pe
          do k=1,km
           v4(j,k)=u(i_u35W,k,j,2,tau)/100.0
           if (umask(i_u35W,k,j)==0) v4(j,k)=spval
          enddo
         enddo
         iret=nf_inq_varid(ncid,'v35W',varid)
         corner=(/js_pe,1,n,1/); 
         edges=(/je_pe-js_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         deallocate(v4)
        endif
#endif

#ifdef write_w35W
        if (is_pe <= i_u35W .and. ie_pe >= i_u35W ) then
         allocate( v4(js_pe:je_pe,km) )
         do j=js_pe,je_pe
          do k=1,km
           v4(j,k)=adv_vbu(i_u35W,k,j)/100.0
           if (umask(i_u35W,k,j)==0) v4(j,k)=spval
          enddo
         enddo
         iret=nf_inq_varid(ncid,'w35W',varid)
         corner=(/js_pe,1,n,1/); 
         edges=(/je_pe-js_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         deallocate(v4)
        endif
#endif

#ifdef write_u5W
        if (is_pe <= i_u5W .and. ie_pe >= i_u5W ) then
         allocate( v4(js_pe:je_pe,km) )
         do j=js_pe,je_pe
          do k=1,km
           v4(j,k)=u(i_u5W,k,j,1,tau)/100.0
           if (umask(i_u5W,k,j)==0) v4(j,k)=spval
          enddo
         enddo
         iret=nf_inq_varid(ncid,'u5W',varid)
         corner=(/js_pe,1,n,1/); 
         edges=(/je_pe-js_pe+1,km,1,1/)
         iret= nf_put_vara_real (ncid,varid ,corner, edges,v4)
         deallocate(v4)
        endif
#endif

#ifdef write_BATS
        if (is_pe <= i_bats .and. ie_pe >= i_bats .and.
     &      js_pe <= j_bats .and. je_pe >= j_bats ) then

         allocate( v4(km,1) )
         corner=(/1,n,1,1/); edges=(/km,1,1,1/)
         do n=1,nt
           if (n==1) then
            name='t_bats'
           elseif (n==2) then
            name='s_bats'
           else
            write(name,'("tr",i2,"_bats")') n
            call replace_space_zero(name)
           endif
           iret= nf_inq_varid(ncid,name,varid)
           v4(1:km,1)  = t(i_bats,1:km,j_bats,n,tau)
           if (n==2) v4=v4*1000.0+35.0
           where( tmask(i_bats,1:km,j_bats)==0) v4(1:km,1)=spval
           iret= nf_put_vara_real (ncid,varid,corner, edges,v4)
         enddo
         deallocate(v4)
        endif
#endif
        call ncclos (ncid, iret)
       endif
       call barrier
      enddo
#else
c
c     Write unformatted binary output here
c
      if (my_pe==0) then
       print*,' --> writing time serie to file ',
     &         outfile(1:len_trim(outfile))
       call getunit(io,outfile,'usa ieee')
       write (io) current_stamp, itt
      endif

#ifdef write_uvts_complete
      ident='uvts'
      if (my_pe==0) write(io) ident
      allocate( buf(imt,jmt) )
      do k=1,km
       buf(is_pe:ie_pe,js_pe:je_pe)=u(is_pe:ie_pe,k,js_pe:je_pe,1,tau)
       where(umask(is_pe:ie_pe,k,js_pe:je_pe)==0) 
     &                      buf(is_pe:ie_pe,js_pe:je_pe)=spval
       call pe0_recv_2D(buf); if (my_pe==0) write(io) buf

       buf(is_pe:ie_pe,js_pe:je_pe)=u(is_pe:ie_pe,k,js_pe:je_pe,2,tau)
       where(umask(is_pe:ie_pe,k,js_pe:je_pe)==0) 
     &                      buf(is_pe:ie_pe,js_pe:je_pe)=spval
       call pe0_recv_2D(buf); if (my_pe==0) write(io) buf

       do n=1,nt
        buf(is_pe:ie_pe,js_pe:je_pe)=t(is_pe:ie_pe,k,js_pe:je_pe,n,tau)
        where(tmask(is_pe:ie_pe,k,js_pe:je_pe)==0) 
     &                      buf(is_pe:ie_pe,js_pe:je_pe)=spval
        call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
       enddo
      enddo
      deallocate(buf)
#endif

#ifdef write_dml
      ident='dml'
      if (my_pe==0) write(io) ident
      allocate( buf(imt,jmt) )
      buf(is_pe:ie_pe,js_pe:je_pe)=dmix(is_pe:ie_pe,js_pe:je_pe)
      where(tmask(is_pe:ie_pe,1,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_pot_vort
      ident='potv'
      if (my_pe==0) write(io) ident
      allocate( buf(imt,jmt) )
      do k=1,km
       buf(is_pe:ie_pe,js_pe:je_pe)=potv(is_pe:ie_pe,k,js_pe:je_pe)
       where(tmask(is_pe:ie_pe,k,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
       call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      enddo

      ident='bvor'
      if (my_pe==0) write(io) ident
      do k=1,km
       buf(is_pe:ie_pe,js_pe:je_pe)=bvort(is_pe:ie_pe,k,js_pe:je_pe)
       where(tmask(is_pe:ie_pe,k,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
       call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      enddo
      deallocate(buf)
#endif


#ifdef write_pot_vort_35W
      ident='pv35'
      if (my_pe==0) write(io) ident
      allocate( buf(jmt,km) )
      if (is_pe <= i_t35W .and. ie_pe >= i_t35W ) then
       do j=js_pe,je_pe
        do k=1,km
          buf(j,k)=potv(i_t35W,k,j)
          if (tmask(i_t35W,k,j)==0) buf(j,k)=spval
        enddo
       enddo
      endif
      call pe0_recv_merid_vec(buf,km,i_t35W)
      if (my_pe==0) write(io) buf

      ident='bv35'
      if (my_pe==0) write(io) ident
      if (is_pe <= i_t35W .and. ie_pe >= i_t35W ) then
       do j=js_pe,je_pe
        do k=1,km
          buf(j,k)=bvort(i_t35W,k,j)
          if (tmask(i_t35W,k,j)==0) buf(j,k)=spval
        enddo
       enddo
      endif
      call pe0_recv_merid_vec(buf,km,i_t35W)
      if (my_pe==0) write(io) buf

      deallocate(buf)
#endif

#ifdef write_pot_vort_0N

      ident='pv0N'
      if (my_pe==0) write(io) ident
      allocate( buf(imt,km) )
      if (js_pe <= j_t0N .and. je_pe >= j_t0N ) then
       buf(is_pe:ie_pe,:)=potv(is_pe:ie_pe,1:km,j_t0N)
       where( tmask(is_pe:ie_pe,1:km,j_t0N)==0) 
     &         buf(is_pe:ie_pe,:)=spval
      endif
      call pe0_recv_zonal_vec(buf,km,j_t0N)
      if (my_pe==0) write(io) buf

      ident='bv0N'
      if (my_pe==0) write(io) ident
      if (js_pe <= j_t0N .and. je_pe >= j_t0N ) then
       buf(is_pe:ie_pe,:)=bvort(is_pe:ie_pe,1:km,j_t0N)
       where( tmask(is_pe:ie_pe,1:km,j_t0N)==0) 
     &         buf(is_pe:ie_pe,:)=spval
      endif
      call pe0_recv_zonal_vec(buf,km,j_t0N)
      if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_t100
      ident='t100'
      if (my_pe==0) write(io) ident
      allocate( buf(imt,jmt) )
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  t(is_pe:ie_pe,k_t100,js_pe:je_pe,1,tau)
      where(tmask(is_pe:ie_pe,k_t100,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_uv100
      allocate( buf(imt,jmt) )
      ident='u100'
      if (my_pe==0) write(io) ident
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  u(is_pe:ie_pe,k_t100,js_pe:je_pe,1,tau)
      where(umask(is_pe:ie_pe,k_t100,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      ident='v100'
      if (my_pe==0) write(io) ident
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  u(is_pe:ie_pe,k_t100,js_pe:je_pe,2,tau)
      where(umask(is_pe:ie_pe,k_t100,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_tsuv50
      allocate( buf(imt,jmt) )
      ident='s50'
      if (my_pe==0) write(io) ident
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  t(is_pe:ie_pe,k_t50,js_pe:je_pe,2,tau)
      where(tmask(is_pe:ie_pe,k_t50,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      ident='t50'
      if (my_pe==0) write(io) ident
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  t(is_pe:ie_pe,k_t50,js_pe:je_pe,1,tau)
      where(tmask(is_pe:ie_pe,k_t50,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      ident='u50'
      if (my_pe==0) write(io) ident
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  u(is_pe:ie_pe,k_t50,js_pe:je_pe,1,tau)
      where(umask(is_pe:ie_pe,k_t50,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      ident='v50'
      if (my_pe==0) write(io) ident
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  u(is_pe:ie_pe,k_t50,js_pe:je_pe,2,tau)
      where(umask(is_pe:ie_pe,k_t50,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_tsuv0
      allocate( buf(imt,jmt) )
      ident='s0'
      if (my_pe==0) write(io) ident
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  t(is_pe:ie_pe,k_t0,js_pe:je_pe,2,tau)
      where(tmask(is_pe:ie_pe,k_t0,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      ident='t0'
      if (my_pe==0) write(io) ident
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  t(is_pe:ie_pe,k_t0,js_pe:je_pe,1,tau)
      where(tmask(is_pe:ie_pe,k_t0,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      ident='u0'
      if (my_pe==0) write(io) ident
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  u(is_pe:ie_pe,k_t0,js_pe:je_pe,1,tau)
      where(umask(is_pe:ie_pe,k_t0,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      ident='v0'
      if (my_pe==0) write(io) ident
      buf(is_pe:ie_pe,js_pe:je_pe)=
     &  u(is_pe:ie_pe,k_t0,js_pe:je_pe,2,tau)
      where(umask(is_pe:ie_pe,k_t0,js_pe:je_pe)==0) 
     &  buf(is_pe:ie_pe,js_pe:je_pe)=spval
      call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_u0N
      ident='u0N'
      if (my_pe==0) write(io) ident
      allocate( buf(imt,km) )
      if (js_pe <= j_u0N .and. je_pe >= j_u0N ) then
       buf(is_pe:ie_pe,:)=u(is_pe:ie_pe,1:km,j_u0N,1,tau)/100.0
       where( umask(is_pe:ie_pe,1:km,j_u0N)==0) 
     &         buf(is_pe:ie_pe,:)=spval
      endif
      call pe0_recv_zonal_vec(buf,km,j_u0N)
      if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_Av0N
      ident='Av0N'
      if (my_pe==0) write(io) ident
      allocate( buf(imt,km) )
      if (js_pe <= j_u0N .and. je_pe >= j_u0N ) then
       buf(is_pe:ie_pe,:)=visc_cbu(is_pe:ie_pe,1:km,j_u0N)/1.0e4
       where( umask(is_pe:ie_pe,1:km,j_u0N)==0) 
     &         buf(is_pe:ie_pe,:)=spval
      endif
      call pe0_recv_zonal_vec(buf,km,j_u0N)
      if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_T57N
      ident='T57N'
      if (my_pe==0) write(io) ident
      allocate( buf(imt,km) )
      if (js_pe <= j_t57N .and. je_pe >= j_t57N ) then
       buf(is_pe:ie_pe,:)=t(is_pe:ie_pe,1:km,j_t57N,1,tau)
       where( tmask(is_pe:ie_pe,1:km,j_t57N)==0) 
     &         buf(is_pe:ie_pe,:)=spval
      endif
      call pe0_recv_zonal_vec(buf,km,j_t57N)
      if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_u35W
      ident='u35W'
      if (my_pe==0) write(io) ident
      allocate( buf(jmt,km) )
      if (is_pe <= i_u35W .and. ie_pe >= i_u35W ) then
       do j=js_pe,je_pe
        do k=1,km
          buf(j,k)=u(i_u35W,k,j,1,tau)/100.0
          if (umask(i_u35W,k,j)==0) buf(j,k)=spval
        enddo
       enddo
      endif
      call pe0_recv_merid_vec(buf,km,i_u35W)
      if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_v35W
      ident='v35W'
      if (my_pe==0) write(io) ident
      allocate( buf(jmt,km) )
      if (is_pe <= i_u35W .and. ie_pe >= i_u35W ) then
       do j=js_pe,je_pe
        do k=1,km
          buf(j,k)=u(i_u35W,k,j,2,tau)/100.0
          if (umask(i_u35W,k,j)==0) buf(j,k)=spval
        enddo
       enddo
      endif
      call pe0_recv_merid_vec(buf,km,i_u35W)
      if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_w35W
      ident='w35W'
      if (my_pe==0) write(io) ident
      allocate( buf(jmt,km) )
      if (is_pe <= i_u35W .and. ie_pe >= i_u35W ) then
       do j=js_pe,je_pe
        do k=1,km
          buf(j,k)=adv_vbu(i_u35W,k,j)/100.0
          if (umask(i_u35W,k,j)==0) buf(j,k)=spval
        enddo
       enddo
      endif
      call pe0_recv_merid_vec(buf,km,i_u35W)
      if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_u5W
      ident='u5W'
      if (my_pe==0) write(io) ident
      allocate( buf(jmt,km) )
      if (is_pe <= i_u5W .and. ie_pe >= i_u5W ) then
       do j=js_pe,je_pe
        do k=1,km
          buf(j,k)=u(i_u5W,k,j,1,tau)/100.0
          if (umask(i_u5W,k,j)==0) buf(j,k)=spval
        enddo
       enddo
      endif
      call pe0_recv_merid_vec(buf,km,i_u5W)
      if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

#ifdef write_BATS
      ident='bats'
      if (my_pe==0) write(io) ident
      allocate( buf(km,nt) )
      if (is_pe <= i_bats .and. ie_pe >= i_bats .and.
     &    js_pe <= j_bats .and. je_pe >= j_bats ) then
       do n=1,nt
        buf(:,n) = t(i_bats,1:km,j_bats,n,tau)
        where( tmask(i_bats,1:km,j_bats)==0) buf(:,n)=spval
       enddo
      endif
      call pe0_recv_depth_vec(buf,nt,i_bats,j_bats)
      if (my_pe==0) write(io) buf
      deallocate(buf)
#endif

      if (my_pe==0) close(io)
#endif

      end subroutine diag_timeserie_output

#include "options.inc"


       module averages_module
c
c=======================================================================
c      perform averages over U/V T and S
c      and write to NetCDF or binary files
c      SPFLAME version:   c.eden
c=======================================================================
c
c      local cpp directives:
c
c      write vertical diffusivities:
#define write_vert_diff
c
c      write GM velocities
#define write_gm_vel
c
c      write CO2 partial pressure at the surface
#define write_pco2
c
c      write oxygen saturation concentration at the surface
#define write_o2
c
c      write tracer stuff in separate netcdf file
c#define splitup_netcdf_file
c
       implicit none
 
       real, allocatable, dimension(:,:,:,:) :: umean,tmean
       real, allocatable, dimension(:,:)     :: psimean
       real, allocatable, dimension(:,:,:)   :: stfmean,smfmean
       integer :: counter 
       logical :: active = .false.
       real, allocatable, dimension(:,:,:) :: ka_mean
       real, allocatable, dimension(:,:,:,:) :: ugm_mean
       real, allocatable, dimension(:,:) :: pco2_mean,o2_mean,dco2_mean
       real :: airco2_mean
       logical :: gm_active = .false.
       logical :: pco2_active = .false.
       logical :: o2_active   = .false.
       end module averages_module


       subroutine init_averages
       use spflame_module
       use averages_module
       implicit none
       if (enable_daily_averages .or.
     &     enable_monthly_averages .or.
     &     enable_seasonal_averages .or.
     &     enable_annual_averages ) active = .true.
       if (active) then
        if (my_pe==0) print*,' initialising diagnostic averages'
        allocate( umean(is_pe:ie_pe,km,js_pe:je_pe,2) )
        allocate( tmean(is_pe:ie_pe,km,js_pe:je_pe,nt) )
        allocate( stfmean(is_pe:ie_pe,js_pe:je_pe,nt) )
        allocate( smfmean(is_pe:ie_pe,js_pe:je_pe,2) )
        allocate( psimean(is_pe:ie_pe,js_pe:je_pe) )
        umean=0.; tmean=0.; stfmean=0.;smfmean=0.; psimean=0.
        counter = 0
#ifdef write_vert_diff
        if (my_pe==0) print*,' (averaging also vertical diffusivity)'
        allocate( ka_mean(is_pe:ie_pe,km,js_pe:je_pe) ); ka_mean=0.
#endif
#ifdef write_gm_vel
        if (enable_diffusion_isopycnic) gm_active = .true.
#endif
#ifdef write_pco2
        pco2_active = .true.
#endif
#ifdef write_o2
        o2_active = .true.
#endif

        if (gm_active) then
         if (my_pe==0) print*,' (averaging also GM bolus velocities)'
         allocate( ugm_mean(is_pe:ie_pe,km,js_pe:je_pe,3) ); ugm_mean=0.
        endif
        if (pco2_active) then
         if (my_pe==0) print*,' (averaging also surface pCO2)'
         allocate( pco2_mean(is_pe:ie_pe,js_pe:je_pe) ); pco2_mean=0.
         allocate( dco2_mean(is_pe:ie_pe,js_pe:je_pe) ); dco2_mean=0.
         airco2_mean=0.0
        endif
        if (o2_active) then
         if (my_pe==0) print*,' (averaging also surface O2 saturation)'
         allocate( o2_mean(is_pe:ie_pe,js_pe:je_pe) ); o2_mean=0.
        endif

        call read_unfinished_averages()
        if (my_pe==0) print*,' done initialising diagnostic averages'
       endif
       end subroutine init_averages


       subroutine averages
       use spflame_module
       use averages_module
       use freesurf_module
       use isopycnic_module
       use passive_tracer_module
       use npzd_module
       implicit none
       if (active) then
        if (.not. eulerback1 ) then
         counter=counter+1
         umean=umean+u(is_pe:ie_pe,1:km,js_pe:je_pe,1:2,tau)
         tmean=tmean+t(is_pe:ie_pe,1:km,js_pe:je_pe,1:nt,tau)
         if (enable_freesurf) then
          psimean=psimean+etat(is_pe:ie_pe,js_pe:je_pe,3)
         else
          psimean=psimean+psi(is_pe:ie_pe,js_pe:je_pe,1)
         endif
         stfmean=stfmean+stf(is_pe:ie_pe,js_pe:je_pe,1:nt)
         smfmean=smfmean+smf(is_pe:ie_pe,js_pe:je_pe,1:2)
#ifdef write_vert_diff
         ka_mean=ka_mean+diff_cbt(is_pe:ie_pe,1:km,js_pe:je_pe)
#endif
         if (gm_active) then
          ugm_mean(:,:,:,1)=ugm_mean(:,:,:,1)
     &              +adv_vetiso(is_pe:ie_pe,1:km,js_pe:je_pe)
          ugm_mean(:,:,:,2)=ugm_mean(:,:,:,2)
     &              +adv_vntiso(is_pe:ie_pe,1:km,js_pe:je_pe)
          ugm_mean(:,:,:,3)=ugm_mean(:,:,:,3)
     &              +adv_vbtiso(is_pe:ie_pe,1:km,js_pe:je_pe)
         endif
         if (pco2_active .and. enable_co2) then
          pco2_mean(is_pe:ie_pe,js_pe:je_pe)= 
     &       pco2_mean(is_pe:ie_pe,js_pe:je_pe)+
     &       pco2_water(is_pe:ie_pe,js_pe:je_pe)
          dco2_mean(is_pe:ie_pe,js_pe:je_pe)= 
     &       dco2_mean(is_pe:ie_pe,js_pe:je_pe)+
     &       diff_co2(is_pe:ie_pe,js_pe:je_pe)
          airco2_mean = airco2_mean + pco2_air
         endif
         if (o2_active .and. enable_o2) then
          o2_mean(is_pe:ie_pe,js_pe:je_pe)= 
     &       o2_mean(is_pe:ie_pe,js_pe:je_pe)
     &      +o2_sat(is_pe:ie_pe,js_pe:je_pe)
         endif
        endif ! eulerback1

        if ((end_of_day   .and. enable_daily_averages).or. 
     &      (end_of_month .and. enable_monthly_averages).or. 
     &      (end_of_season.and. enable_seasonal_averages).or. 
     &      (end_of_year  .and. enable_annual_averages) ) then
         call write_averages_cdf()
         counter=0 
         umean=0.; tmean=0.; psimean=0.;stfmean=0.;smfmean=0.
#ifdef write_vert_diff
         ka_mean=0.
#endif
         if (gm_active) ugm_mean=0.
         if (pco2_active) then
              pco2_mean=0.0; dco2_mean=0.0; airco2_mean = 0.0
         endif
         if (o2_active) o2_mean=0.0
        endif
        if (last_time_step) call write_unfinished_averages()
       endif
       end subroutine averages


       subroutine write_unfinished_averages()
       use spflame_module
       use averages_module
       implicit none
       character (len=80) :: name,ident
       integer i,j,k,io,n,is,ie,js,je
       real, allocatable ::  buf(:,:)
       is=is_pe; ie=ie_pe; js=js_pe; je=je_pe
       write(name,'("averages_",i3,".dta")') sub_domain
       do i=1,len_trim(name); if (name(i:i) == ' ') name(i:i)='0'; enddo
       if (my_pe==0) then
        print*,''
        print*,' writing unfinished averages of U/T/S to file ',
     &          name(1:len_trim(name))
        call get_free_iounit(io)
        open(io,file=name,form='unformatted',status='unknown')
        write(io) counter
       endif
       allocate( buf(imt,jmt) )
       buf(is:ie,js:je)=psimean(is:ie,js:je)
       call pe0_recv_2D(buf)
       if (my_pe==0) write(io) buf
       do n=1,2
        buf(is:ie,js:je)=smfmean(is:ie,js:je,n)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
       enddo
       do n=1,nt
        buf(is:ie,js:je)=stfmean(is:ie,js:je,n)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
       enddo
       do k=1,km
        do n=1,2
         buf(is:ie,js:je)=umean(is:ie,k,js:je,n)
         call pe0_recv_2D(buf)
         if (my_pe==0) write(io) buf
        enddo
        do n=1,nt
         buf(is:ie,js:je)=tmean(is:ie,k,js:je,n)
         call pe0_recv_2D(buf)
         if (my_pe==0) write(io) buf
        enddo
       enddo
#ifdef write_vert_diff
       ident = 'diff_cbt'
       if (my_pe==0) write(io) ident
       do k=1,km
         buf(is:ie,js:je)=ka_mean(is:ie,k,js:je)
         call pe0_recv_2D(buf)
         if (my_pe==0) write(io) buf
       enddo
#endif
       if (gm_active) then
        ident = 'u_gm'
        if (my_pe==0) write(io) ident
        do k=1,km
         buf(is:ie,js:je)=ugm_mean(is:ie,k,js:je,1)
         call pe0_recv_2D(buf)
         if (my_pe==0) write(io) buf
         buf(is:ie,js:je)=ugm_mean(is:ie,k,js:je,2)
         call pe0_recv_2D(buf)
         if (my_pe==0) write(io) buf
         buf(is:ie,js:je)=ugm_mean(is:ie,k,js:je,3)
         call pe0_recv_2D(buf)
         if (my_pe==0) write(io) buf
        enddo
       endif
       if (pco2_active) then
        ident = 'pco2_water'
        if (my_pe==0) write(io) ident
        buf(is:ie,js:je)=pco2_mean(is:ie,js:je)
        call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
        buf(is:ie,js:je)=dco2_mean(is:ie,js:je)
        call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
                                     if (my_pe==0) write(io) airco2_mean
       endif
       if (o2_active) then
        ident = 'o2_sat'
        if (my_pe==0) write(io) ident
        buf(is:ie,js:je)=o2_mean(is:ie,js:je)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
       endif
       if (my_pe==0) close(io)
       deallocate( buf )
       end subroutine write_unfinished_averages


       subroutine read_unfinished_averages()
       use spflame_module
       use averages_module
       implicit none
       character (len=80) :: name,ident
       integer i,j,k,io,n,is,ie,js,je
       real, allocatable ::  buf(:,:)
       logical :: ok
       is=is_pe; ie=ie_pe; js=js_pe; je=je_pe
       write(name,'("averages_",i3,".dta")') sub_domain
       do i=1,len_trim(name); if (name(i:i) == ' ') name(i:i)='0'; enddo
       if (my_pe==0) then
        print*,''
        print*,' reading averaged U/T/S from file ',
     &          name(1:len_trim(name))
c        call get_free_iounit(io)
       endif

       call get_free_iounit(io)
       open(io,file=name,form='unformatted',status='old',err=200)
       read(io) counter
       allocate( buf(imt,jmt) )
       if (my_pe==0) read(io) buf
       call pe0_send_2D(buf)
       psimean(is:ie,js:je)=buf(is:ie,js:je)
       do n=1,2
        if (my_pe==0) read(io) buf
        call pe0_send_2D(buf)
        smfmean(is:ie,js:je,n)=buf(is:ie,js:je)
       enddo
       do n=1,nt
        if (my_pe==0) read(io) buf
        call pe0_send_2D(buf)
        stfmean(is:ie,js:je,n)=buf(is:ie,js:je)
       enddo
       do k=1,km
        do n=1,2
         if (my_pe==0) read(io) buf
         call pe0_send_2D(buf)
         umean(is:ie,k,js:je,n)=buf(is:ie,js:je)
        enddo
        do n=1,nt
         if (my_pe==0) read(io) buf
         call pe0_send_2D(buf)
         tmean(is:ie,k,js:je,n)= buf(is:ie,js:je)
        enddo
       enddo


 10    ident=''; ok = .true.
       if (my_pe==0) then 
        read(io,end=20) ident
        goto 30
 20     ok = .false.
 30     continue
       endif
       call bcast_logical(ok,1,0)
       call bcast_char(ident,80,0)

       if (ident(1:8) == 'diff_cbt') then
        do k=1,km
         if (my_pe==0) read(io) buf
#ifdef write_vert_diff
         call pe0_send_2D(buf)
         ka_mean(is:ie,k,js:je)= buf(is:ie,js:je)
#endif
        enddo
       elseif (ident(1:4) == 'u_gm') then
        do k=1,km
         if (my_pe==0) read(io) buf
         if (gm_active) then
          call pe0_send_2D(buf)
          ugm_mean(is:ie,k,js:je,1)= buf(is:ie,js:je)
         endif
         if (my_pe==0) read(io) buf
         if (gm_active) then
          call pe0_send_2D(buf)
          ugm_mean(is:ie,k,js:je,2)= buf(is:ie,js:je)
         endif
         if (my_pe==0) read(io) buf
         if (gm_active) then
          call pe0_send_2D(buf)
          ugm_mean(is:ie,k,js:je,3)= buf(is:ie,js:je)
         endif
        enddo
       elseif (ident(1:10) == 'pco2_water' ) then
        if (my_pe==0) read(io) buf; call pe0_send_2D(buf)
        if (pco2_active) pco2_mean(is:ie,js:je)=buf(is:ie,js:je)
        if (my_pe==0) read(io) buf; call pe0_send_2D(buf)
        if (pco2_active) dco2_mean(is:ie,js:je)=buf(is:ie,js:je)
        if (my_pe==0) read(io) airco2_mean
        call bcast_real(airco2_mean,1,0)
       elseif (ident(1:6) == 'o2_sat' ) then
        if (my_pe==0) read(io) buf; call pe0_send_2D(buf)
        if (o2_active) o2_mean(is:ie,js:je)=buf(is:ie,js:je)
       else
         if (my_pe==0) print*,' cannot read ',ident,' in ',name
       endif
       if (ok) goto 10  ! read next item til end of file

       close(io)
       if (my_pe==0) then
        print*,' done '
        print*,''
       endif
       deallocate( buf )
       return

 200   if (my_pe==0) then
        print*,''
        print*,'---------------------------------------------'
        print*,' WARNING : cannot read file ',name(1:len_trim(name))
        print*,'---------------------------------------------'
        print*,''
       endif

       end subroutine read_unfinished_averages


       subroutine write_averages_cdf()
       use spflame_module
       use averages_module
       implicit none
#ifdef netcdf_diagnostics
c
c      write averaged quantities to a nice NetCDF file
#ifdef splitup_netcdf_file
c     but not the tracer stuff
#endif
c
       character (len=80) :: fname,name,unit
       integer :: year,month,day
#include "netcdf.inc"
       integer :: ncid,iret,i,j,k,dims(4),start(4),count(4)
       real    :: spval=-9.9e12, tt
       integer :: lon_tdim,lon_tid,lon_udim,lon_uid
       integer :: lat_tdim,lat_tid,lat_udim,lat_uid
       integer :: depth_tdim,depth_tid,depth_wdim,depth_wid
       integer :: itimedim,itimeid,uid,vid,trid(nt),npe,n
       integer :: psiid,tauxid, tauyid,strid(nt),diff_cbtid
       integer :: ugm_id,vgm_id,wgm_id,pco2_id,o2_id,dco2_id,airco2_id
       integer :: is,ie,js,je
#ifdef netcdf_real4
      real (kind=4) :: var(is_pe:ie_pe,js_pe:je_pe)
      real (kind=4) , allocatable :: v2(:)
#else
      real          :: var(is_pe:ie_pe,js_pe:je_pe)
      real          , allocatable :: v2(:)
#endif

       is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

       year  = get_year(get_current_time())
       month = get_month_of_year(get_current_time())
       day   = get_day_of_month(get_current_time())
       write(fname,'("averages_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            sub_domain,year,month,day
       do i=1,len_trim(fname);if (fname(i:i)==' ')fname(i:i)='0';enddo

       if (my_pe == 0) then
        print*,' Writing averages to  NetCDF output file ',
     &         fname(1:len_trim(fname))
        ncid = nccre (fname, NCCLOB, iret)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        call store_info_cdf(ncid)
c       dimensions
        lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
        Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
        Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
        Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
        depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
        depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
        iTimedim  = ncddef(ncid, 'Time', 1, iret)
c       grid variables
        dims(1)  = Lon_tdim
        Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
        dims(1)  = Lon_udim
        Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
        dims(1)  = Lat_tdim
        Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
        dims(1)  = Lat_udim
        Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
        dims(1)  = iTimedim
        iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
        dims(1)  = depth_wdim
        depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
        dims(1)  = depth_tdim
        depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c       attributes of the grid
        name = 'Longitude on T grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Longitude on U grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on T grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on U grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Depth of T Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
        call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
        name = 'Depth of W Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
        call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
        name = 'Time                    '; unit = 'days            '
        call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
        call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c       variables
        dims=(/lon_udim,lat_udim,depth_tdim,itimedim/)
        uid=ncvdef (ncid,'u', NCFLOAT,4,dims,iret)
        vid=ncvdef (ncid,'v', NCFLOAT,4,dims,iret)
#ifdef splitup_netcdf_file
        do n=1,2
#else
        do n=1,nt
#endif
         name='temp';if (n==2) name='salt'
         if (n>2) then
          write(name,'("tracer_",i2)') n
          call replace_space_zero(name)
         endif
         dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
         trid(n)=ncvdef (ncid,name, NCFLOAT,4,dims,iret)
         name='heat_fl';if (n==2) name='salt_fl'
         if (n>2) then
          write(name,'("tr",i2,"_flux")') n
          call replace_space_zero(name)
         endif
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         strid(n)=ncvdef (ncid,name, NCFLOAT,3,dims,iret)
        enddo
        dims=(/lon_udim,lat_udim,itimedim,1/)
        tauxid=ncvdef (ncid,'taux', NCFLOAT,3,dims,iret)
        tauyid=ncvdef (ncid,'tauy', NCFLOAT,3,dims,iret)
        dims=(/lon_tdim,lat_tdim,itimedim,1/)
        if (enable_freesurf) then
         psiid=ncvdef (ncid,'ssh', NCFLOAT,3,dims,iret)
        else
         psiid=ncvdef (ncid,'psi', NCFLOAT,3,dims,iret)
        endif
#ifdef write_vert_diff
        dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
        diff_cbtid=ncvdef (ncid,'diff_cbt', NCFLOAT,4,dims,iret)
#endif
        if (gm_active) then
         dims=(/lon_udim,lat_tdim,depth_tdim,itimedim/)
         ugm_id=ncvdef (ncid,'u_gm', NCFLOAT,4,dims,iret)
         dims=(/lon_tdim,lat_udim,depth_tdim,itimedim/)
         vgm_id=ncvdef (ncid,'v_gm', NCFLOAT,4,dims,iret)
         dims=(/lon_tdim,lat_tdim,depth_wdim,itimedim/)
         wgm_id=ncvdef (ncid,'w_gm', NCFLOAT,4,dims,iret)
        endif
#ifndef splitup_netcdf_file
        if (pco2_active) then
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         pco2_id=ncvdef (ncid,'pco2_water', NCFLOAT,3,dims,iret)
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         dco2_id=ncvdef (ncid,'dco2', NCFLOAT,3,dims,iret)
         dims=(/itimedim,1,1,1/)
         airco2_id=ncvdef (ncid,'pco2_air', NCFLOAT,1,dims,iret)
        endif
        if (o2_active) then
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         o2_id=ncvdef (ncid,'o2_sat', NCFLOAT,3,dims,iret)
        endif
#endif
c       attributes of variables
        name = 'Zonal velocity'; unit = 'm/s'
        call dvcdf(ncid,uid,name,24,unit,16,spval)
        name = 'Meridional velocity'; unit = 'm/s'
        call dvcdf(ncid,vid,name,24,unit,16,spval)
#ifdef splitup_netcdf_file
        do n=1,2
#else
        do n=1,nt
#endif
         name = 'Potential temperature'; unit = 'deg C'
         if (n==2) then
          name = 'Salinity'; unit = 'psu'
         elseif (n>2) then
          write(name,'("Passive tracer ",i2)') n
          unit = ' '
         endif
         call dvcdf(ncid,trid(n),name,len_trim(name),
     &              unit,len_trim(unit),spval)
         name = 'Surface heat flux'; unit = 'W/m^2'
         if (n==2) then
          name = 'Surface salt flux'; unit = 'kg/m^2/s'
         elseif (n>2) then
          write(name,'("Surface flux passive tracer ",i2)') n
          unit = ' '
         endif
         call dvcdf(ncid,strid(n),name,len_trim(name),
     &              unit,len_trim(unit),spval)
        enddo
        if (enable_freesurf) then
         name = 'Sea Surface height'; unit = 'm'
        else
         name = 'Barotropic streamfunction'; unit = 'Sv'
        endif
        call dvcdf(ncid,psiid,name,24,unit,16,spval)
        name = 'Zonal wind stress'; unit = 'N/m^2'
        call dvcdf(ncid,tauxid,name,24,unit,16,spval)
        name = 'Meridional wind stress'; unit = 'N/m^2'
        call dvcdf(ncid,tauyid,name,24,unit,16,spval)
#ifdef write_vert_diff
        name = 'Vertical diffusivity'; unit = 'm^2/s'
        call dvcdf(ncid,diff_cbtid,name,24,unit,16,spval)
#endif
        if (gm_active) then
         name = 'Zonal bolus velocity'; unit = 'm/s'
         call dvcdf(ncid,ugm_id,name,24,unit,16,spval)
         name = 'Meridional bolus velocity'; unit = 'm/s'
         call dvcdf(ncid,vgm_id,name,24,unit,16,spval)
         name = 'Vertical bolus velocity'; unit = 'm/s'
         call dvcdf(ncid,wgm_id,name,24,unit,16,spval)
        endif
#ifndef splitup_netcdf_file
        if (pco2_active) then
         name = 'Sea surface CO2 partial pressure'; unit = 'ppmv'
         call dvcdf(ncid,pco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
         name = 'Air/Sea difference in CO2 concentration'
          unit = 'mol/m^3'
         call dvcdf(ncid,dco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
         name = 'Atmospheric CO2 partial pressure'; unit = 'ppmv'
         call dvcdf(ncid,airco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
        endif
        if (o2_active) then
         name = 'Sea surface O2 saturation concentration'; 
         unit = 'mol/m^3'
         call dvcdf(ncid,o2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
        endif
#endif
c       global attrubutes
        iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        call ncendf(ncid, iret)
c       write grid
        allocate( v2(max(imt,jmt,km)) )
        v2(1:imt)=xt
        call ncvpt(ncid, Lon_tid, 1, imt,v2, iret)
        v2(1:imt)=xu
        call ncvpt(ncid, Lon_uid, 1, imt,v2, iret)
        v2(1:jmt)=yt
        call ncvpt(ncid, Lat_tid, 1, jmt,v2, iret)
        v2(1:jmt)=yu
        call ncvpt(ncid, Lat_uid, 1, jmt,v2, iret)
        v2(1:km)=zt/100.
        call ncvpt(ncid, depth_tid, 1, km,v2, iret)
        v2(1:km)=zw/100.
        call ncvpt(ncid, depth_wid, 1, km,v2, iret)
        call read_stamp(current_stamp,tt ); v2(1)=tt
        call ncvpt(ncid, itimeid, 1, 1,v2, iret)
        deallocate(v2)
        call ncclos (ncid, iret)
       endif
c      loop over PEs
       do npe=0,n_pes
        call barrier
        if (my_pe==npe) then
         iret=nf_open(fname,NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         iret=nf_inq_varid(ncid,'u',uid)
         iret=nf_inq_varid(ncid,'v',vid)
#ifdef splitup_netcdf_file
         do n=1,2
#else
         do n=1,nt
#endif
          name='temp'
          if (n==2) then
           name='salt'
          elseif (n>2) then
           write(name,'("tracer_",i2)') n
           call replace_space_zero(name)
          endif
          iret=nf_inq_varid(ncid,name,trid(n))
          name = 'heat_fl'
          if (n==2) then
           name='salt_fl'
          elseif (n>2) then
           write(name,'("tr",i2,"_flux")') n
           call replace_space_zero(name)
          endif
          iret=nf_inq_varid(ncid,name,strid(n))
         enddo
         if (enable_freesurf) then
          iret=nf_inq_varid(ncid,'ssh',psiid)
         else
          iret=nf_inq_varid(ncid,'psi',psiid)
         endif
         iret=nf_inq_varid(ncid,'taux',tauxid)
         iret=nf_inq_varid(ncid,'tauy',tauyid)
#ifdef write_vert_diff
         iret=nf_inq_varid(ncid,'diff_cbt',diff_cbtid)
#endif
         if (gm_active) then
          iret=nf_inq_varid(ncid,'u_gm',ugm_id)
          iret=nf_inq_varid(ncid,'v_gm',vgm_id)
          iret=nf_inq_varid(ncid,'w_gm',wgm_id)
         endif
#ifndef splitup_netcdf_file
         if (pco2_active) then
          iret=nf_inq_varid(ncid,'pco2_water',pco2_id)
          iret=nf_inq_varid(ncid,'dco2',dco2_id)
          iret=nf_inq_varid(ncid,'pco2_air',airco2_id)
         endif
         if (o2_active) iret=nf_inq_varid(ncid,'o2_sat',o2_id)
#endif
c        divide with number of averaged time steps 
         umean=umean/counter
         psimean=psimean/counter
         smfmean=smfmean/counter
         tmean=tmean/counter
         stfmean=stfmean/counter
c        convert to SI units
         umean=umean/100.
         tmean(:,:,:,2)=tmean(:,:,:,2)*1000+35.
         stfmean(:,:,1)=stfmean(:,:,1)*41868.
         stfmean(:,:,2)=stfmean(:,:,2)*10.
         smfmean=smfmean/10.
         if (enable_freesurf) then
          psimean=psimean/100.
         else
          psimean=psimean/1.e12
         endif
c        apply land mask
         where( umask(is:ie,1:km,js:je) == 0. ) umean(:,:,:,1) = spval
         where( umask(is:ie,1:km,js:je) == 0. ) umean(:,:,:,2) = spval
         do n=1,nt
          where( tmask(is:ie,1:km,js:je) == 0. ) tmean(:,:,:,n) = spval
          where( tmask(is:ie,1,js:je) == 0. )    stfmean(:,:,n) = spval
         enddo
         where( tmask(is:ie,1,js:je) == 0. ) psimean = spval
         where( umask(is:ie,1,js:je) == 0. ) smfmean(:,:,1) = spval
         where( umask(is:ie,1,js:je) == 0. ) smfmean(:,:,2) = spval
#ifdef write_vert_diff
         ka_mean=ka_mean/counter
         ka_mean=ka_mean/1.0e4
         where( tmask(is:ie,1:km,js:je) == 0. ) ka_mean(:,:,:) = spval
#endif
         if (gm_active) then
          ugm_mean=ugm_mean/counter
          ugm_mean=ugm_mean/100.0
          do j=js,je
            ugm_mean(:,:,j,2)=ugm_mean(:,:,j,2)/csu(j)
          enddo
          where(tmask(is:ie,1:km,js:je)==0.) ugm_mean(:,:,:,1) = spval
          where(tmask(is:ie,1:km,js:je)==0.) ugm_mean(:,:,:,2) = spval
          where(tmask(is:ie,1:km,js:je)==0.) ugm_mean(:,:,:,3) = spval
         endif
         if (pco2_active) then
          pco2_mean=pco2_mean/counter
          dco2_mean=dco2_mean/counter
          airco2_mean=airco2_mean/counter
          where(tmask(is:ie,1,js:je)==0.) pco2_mean(is:ie,js:je) = spval
          where(tmask(is:ie,1,js:je)==0.) dco2_mean(is:ie,js:je) = spval
         endif
         if (o2_active) then 
          o2_mean=o2_mean/counter
          where(tmask(is:ie,1,js:je)==0.) o2_mean(is:ie,js:je) = spval
         endif
         ! write PE domain to file
         do k=1,km
          start=(/is,js,k,1/); count=(/ie-is+1,je-js+1,1,1/)
          var=umean(:,k,:,1)
          iret= nf_put_vara_real (ncid,uid,start,count,var )
          var=umean(:,k,:,2)
          iret= nf_put_vara_real (ncid,vid,start,count,var )
#ifdef splitup_netcdf_file
          do n=1,2
#else
          do n=1,nt
#endif
           var=tmean(:,k,:,n)
           iret= nf_put_vara_real (ncid,trid(n),start,count,var )
          enddo
         enddo
         start=(/is,js,1,1/); count=(/ie-is+1,je-js+1,1,1/)
         var=psimean
         iret= nf_put_vara_real (ncid,psiid,start,count,var)
#ifdef splitup_netcdf_file
         do n=1,2
#else
         do n=1,nt
#endif
          var=stfmean(:,:,n)
          iret= nf_put_vara_real (ncid,strid(n),start,count,var )
         enddo
         var=smfmean(:,:,1)
         iret= nf_put_vara_real (ncid,tauxid,start,count,var )
         var=smfmean(:,:,2)
         iret= nf_put_vara_real (ncid,tauyid,start,count,var )
#ifdef write_vert_diff
         do k=1,km
          start=(/is,js,k,1/); count=(/ie-is+1,je-js+1,1,1/)
          var=ka_mean(:,k,:)
          iret= nf_put_vara_real (ncid,diff_cbtid,start,count,var )
         enddo
#endif
         if (gm_active) then
          do k=1,km
           start=(/is,js,k,1/); count=(/ie-is+1,je-js+1,1,1/)
           var=ugm_mean(:,k,:,1)
           iret= nf_put_vara_real(ncid,ugm_id,start,count,var )
           var=ugm_mean(:,k,:,2)
           iret= nf_put_vara_real(ncid,vgm_id,start,count,var )
           var=ugm_mean(:,k,:,3)
           iret= nf_put_vara_real(ncid,wgm_id,start,count,var )
          enddo
         endif
#ifndef splitup_netcdf_file
         if (pco2_active) then
          var(is:ie,js:je)=pco2_mean(is:ie,js:je)
          start=(/is,js,1,1/); count=(/ie-is+1,je-js+1,1,1/)
          iret= nf_put_vara_real (ncid,pco2_id,start,count,var )
          var(is:ie,js:je)=dco2_mean(is:ie,js:je)
          iret= nf_put_vara_real (ncid,dco2_id,start,count,var )
          var(is,js)=airco2_mean
          iret= nf_put_vara_real(ncid,airco2_id,1,1,var(is,js) )
         endif
         if (o2_active) then
          var=o2_mean(:,:)
          start=(/is,js,1,1/); count=(/ie-is+1,je-js+1,1,1/)
          iret= nf_put_vara_real (ncid,o2_id,start,count,var )
         endif
#endif
         call ncclos (ncid, iret)
        endif
        call barrier
       enddo
#ifdef splitup_netcdf_file
       call write_averages_tracer
#endif
       if (my_pe==0) then
        print*,'done'
       endif
#else
c
c      write averaged quantities to a binary file
c
       integer :: is,ie,js,je
       integer :: year,month,day
       character (len=80) :: fname,ident
       integer :: io,n,i,k,j
       real, allocatable    :: buf(:,:)

       is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

       year  = get_year(get_current_time())
       month = get_month_of_year(get_current_time())
       day   = get_day_of_month(get_current_time())
       write(fname,'("averages_",i3,"_y",i4,"m",i2,"d",i2,".dta")') 
     &            sub_domain,year,month,day
       do i=1,len_trim(fname);if (fname(i:i)==' ')fname(i:i)='0';enddo

       if (my_pe==0) then
         print*,' writing averages to file ',fname(1:len_trim(fname))
         call getunit(io, fname,'u s r ieee')
         write(io) imt,jmt,km,nt
         write(io) xt,yt,xu,yu,zt,zw
         write(io) counter
         write(io) enable_daily_averages
         write(io) enable_monthly_averages
         write(io) enable_seasonal_averages
         write(io) enable_annual_averages
         write(io) kmt_big
       endif
       allocate( buf(imt,jmt) ); buf=0.

       buf(is:ie,js:je)=psimean
       call pe0_recv_2D(buf)
       if (enable_freesurf) then
        if (my_pe==0) write(io) buf,'ssh'
       else
        if (my_pe==0) write(io) buf,'psi'
       endif

       do n=1,2
        buf(is:ie,js:je)=smfmean(:,:,n)
        call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
        do k=1,km
         do j=js,je
          do i=is,ie
            buf(i,j)=umean(i,k,j,n)
          enddo
         enddo
         call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
        enddo
       enddo
       do n=1,nt
        buf(is:ie,js:je)=stfmean(:,:,n)
        call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
        do k=1,km
         do j=js,je
          do i=is,ie
           buf(i,j)=tmean(i,k,j,n)
          enddo
         enddo
         call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
        enddo
      enddo
#ifdef write_vert_diff
      ident = 'diff_cbt'
      if (my_pe==0) write(io) ident
      do k=1,km
         do j=js,je
          do i=is,ie
            buf(i,j)=ka_mean(i,k,j)
          enddo
         enddo
         call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      enddo
#endif
      if (gm_active) then
       ident = 'u_gm'
       if (my_pe==0) write(io) ident
       do k=1,km
         buf(is:ie,js:je)=ugm_mean(is:ie,k,js:je,1)
         call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
         buf(is:ie,js:je)=ugm_mean(is:ie,k,js:je,2)
         call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
         buf(is:ie,js:je)=ugm_mean(is:ie,k,js:je,3)
         call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
       enddo
      endif
      if (pco2_active) then
       ident = 'pco2_water'
       if (my_pe==0) write(io) ident
       buf(is:ie,js:je)=pco2_mean(is:ie,js:je)
       call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
       buf(is:ie,js:je)=dco2_mean(is:ie,js:je)
       call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
                                    if (my_pe==0) write(io) airco2_mean
      endif
      if (o2_active) then
       ident = 'o2_sat'
       if (my_pe==0) write(io) ident
       buf(is:ie,js:je)=o2_mean(is:ie,js:je)
       call pe0_recv_2D(buf); if (my_pe==0) write(io) buf
      endif

      if (my_pe==0)  close(io)
      deallocate(buf)
      if (my_pe==0) then
        print*,'done'
      endif
#endif
      end subroutine write_averages_cdf





#if defined netcdf_diagnostics && defined splitup_netcdf_file
       subroutine write_averages_tracer
       use spflame_module
       use averages_module
       implicit none
c
c      write averaged quantities to a nice NetCDF file
c      here the tracer stuff
c
       character (len=80) :: fname,name,unit
       integer :: year,month,day
#include "netcdf.inc"
       integer :: ncid,iret,i,j,k,dims(4),start(4),count(4)
       real    :: spval=-9.9e12, tt
       integer :: lon_tdim,lon_tid,lon_udim,lon_uid
       integer :: lat_tdim,lat_tid,lat_udim,lat_uid
       integer :: depth_tdim,depth_tid,depth_wdim,depth_wid
       integer :: itimedim,itimeid,trid(nt),npe,n
       integer :: strid(nt)
       integer :: pco2_id,o2_id,dco2_id,airco2_id
       integer :: is,ie,js,je
#ifdef netcdf_real4
      real (kind=4) :: var(is_pe:ie_pe,js_pe:je_pe)
      real (kind=4) , allocatable :: v2(:)
#else
      real          :: var(is_pe:ie_pe,js_pe:je_pe)
      real          , allocatable :: v2(:)
#endif

       is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

       year  = get_year(get_current_time())
       month = get_month_of_year(get_current_time())
       day   = get_day_of_month(get_current_time())
       write(fname,'("traverages_",i3,"_y",i4,"m",i2,"d",i2,".cdf")') 
     &            sub_domain,year,month,day
       do i=1,len_trim(fname);if (fname(i:i)==' ')fname(i:i)='0';enddo

       if (my_pe == 0) then
        print*,' Writing averages to  NetCDF output file ',
     &         fname(1:len_trim(fname))
        ncid = nccre (fname, NCCLOB, iret)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        call store_info_cdf(ncid)
c       dimensions
        lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
        Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
        Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
        Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
        depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
        depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
        iTimedim  = ncddef(ncid, 'Time', 1, iret)
c       grid variables
        dims(1)  = Lon_tdim
        Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
        dims(1)  = Lon_udim
        Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
        dims(1)  = Lat_tdim
        Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
        dims(1)  = Lat_udim
        Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
        dims(1)  = iTimedim
        iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
        dims(1)  = depth_wdim
        depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
        dims(1)  = depth_tdim
        depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
c       attributes of the grid
        name = 'Longitude on T grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Longitude on U grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on T grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on U grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Depth of T Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
        call ncaptc(ncid, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
        name = 'Depth of W Grid points  '; unit = 'm '
        call ncaptc(ncid, depth_wid, 'long_name', NCCHAR,24, name, iret) 
        call ncaptc(ncid, depth_wid, 'units',     NCCHAR,16, unit, iret) 
        name = 'Time                    '; unit = 'days            '
        call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
        call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c       variables
        do n=3,nt
         write(name,'("tracer_",i2)') n
         call replace_space_zero(name)
         dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
         trid(n)=ncvdef (ncid,name, NCFLOAT,4,dims,iret)
         write(name,'("tr",i2,"_flux")') n
         call replace_space_zero(name)
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         strid(n)=ncvdef (ncid,name, NCFLOAT,3,dims,iret)
        enddo
        if (pco2_active) then
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         pco2_id=ncvdef (ncid,'pco2_water', NCFLOAT,3,dims,iret)
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         dco2_id=ncvdef (ncid,'dco2', NCFLOAT,3,dims,iret)
         dims=(/itimedim,1,1,1/)
         airco2_id=ncvdef (ncid,'pco2_air', NCFLOAT,1,dims,iret)
        endif
        if (o2_active) then
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         o2_id=ncvdef (ncid,'o2_sat', NCFLOAT,3,dims,iret)
        endif
c       attributes of variables
        do n=3,nt
         write(name,'("Passive tracer ",i2)') n
         unit = ' '
         call dvcdf(ncid,trid(n),name,len_trim(name),
     &              unit,len_trim(unit),spval)
         write(name,'("Surface flux passive tracer ",i2)') n
         unit = ' '
         call dvcdf(ncid,strid(n),name,len_trim(name),
     &              unit,len_trim(unit),spval)
        enddo
        if (pco2_active) then
         name = 'Sea surface CO2 partial pressure'; unit = 'ppmv'
         call dvcdf(ncid,pco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
         name = 'Air/Sea difference in CO2 concentration'
          unit = 'mol/m^3'
         call dvcdf(ncid,dco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
         name = 'Atmospheric CO2 partial pressure'; unit = 'ppmv'
         call dvcdf(ncid,airco2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
        endif
        if (o2_active) then
         name = 'Sea surface O2 saturation concentration'; 
         unit = 'mol/m^3'
         call dvcdf(ncid,o2_id,name,
     &            len_trim(name),unit,len_trim(unit),spval)
        endif
c       global attrubutes
        iret= nf_put_att_int(ncid,nf_global,
     &   'Number_of_averaged_time_steps ',nf_int,1,counter)
        call ncendf(ncid, iret)
c       write grid
        allocate( v2(max(imt,jmt,km)) )
        v2(1:imt)=xt
        call ncvpt(ncid, Lon_tid, 1, imt,v2, iret)
        v2(1:imt)=xu
        call ncvpt(ncid, Lon_uid, 1, imt,v2, iret)
        v2(1:jmt)=yt
        call ncvpt(ncid, Lat_tid, 1, jmt,v2, iret)
        v2(1:jmt)=yu
        call ncvpt(ncid, Lat_uid, 1, jmt,v2, iret)
        v2(1:km)=zt/100.
        call ncvpt(ncid, depth_tid, 1, km,v2, iret)
        v2(1:km)=zw/100.
        call ncvpt(ncid, depth_wid, 1, km,v2, iret)
        call read_stamp(current_stamp,tt ); v2(1)=tt
        call ncvpt(ncid, itimeid, 1, 1,v2, iret)
        deallocate(v2)
        call ncclos (ncid, iret)
       endif
c      loop over PEs
       do npe=0,n_pes
        call barrier
        if (my_pe==npe) then
         iret=nf_open(fname,NF_WRITE,ncid)
         iret=nf_set_fill(ncid, NF_NOFILL, iret)
         do n=3,nt
          write(name,'("tracer_",i2)') n
          call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,trid(n))
          write(name,'("tr",i2,"_flux")') n
          call replace_space_zero(name)
          iret=nf_inq_varid(ncid,name,strid(n))
         enddo
         if (pco2_active) then
          iret=nf_inq_varid(ncid,'pco2_water',pco2_id)
          iret=nf_inq_varid(ncid,'dco2',dco2_id)
          iret=nf_inq_varid(ncid,'pco2_air',airco2_id)
         endif
         if (o2_active) iret=nf_inq_varid(ncid,'o2_sat',o2_id)
         ! write PE domain to file
         do k=1,km
          do n=3,nt
           var=tmean(:,k,:,n)
           start=(/is,js,k,1/); count=(/ie-is+1,je-js+1,1,1/)
           iret= nf_put_vara_real (ncid,trid(n),start,count,var )
          enddo
         enddo
         start=(/is,js,1,1/); count=(/ie-is+1,je-js+1,1,1/)
         do n=3,nt
          var=stfmean(:,:,n)
          iret= nf_put_vara_real (ncid,strid(n),start,count,var )
         enddo
         if (pco2_active) then
          var(is:ie,js:je)=pco2_mean(is:ie,js:je)
          start=(/is,js,1,1/); count=(/ie-is+1,je-js+1,1,1/)
          iret= nf_put_vara_real (ncid,pco2_id,start,count,var )
          var(is:ie,js:je)=dco2_mean(is:ie,js:je)
          iret= nf_put_vara_real (ncid,dco2_id,start,count,var )
          var(is,js)=airco2_mean
          iret= nf_put_vara_real(ncid,airco2_id,1,1,var(is,js) )
         endif
         if (o2_active) then
          var=o2_mean(:,:)
          start=(/is,js,1,1/); count=(/ie-is+1,je-js+1,1,1/)
          iret= nf_put_vara_real (ncid,o2_id,start,count,var )
         endif
         call ncclos (ncid, iret)
        endif
        call barrier
       enddo
       end subroutine write_averages_tracer
#endif

#include "options.inc"

c#define weird_option

      module isopycnic_module
c
c-----------------------------------------------------------------------
c     Isopycnic diffusion module for SPFLAME taken from MOM 2
c     ( the old Redi/Cox code)
c
c     Original authors:
c             R.C.Pacanowski  (implemented Gokhans version for MOM 2)
c                              rcp@gfdl.gov
c             Gokhan Danabasoglu (pre MOM 2 version including
c                                 Gent/Mcwilliams transport velocities) 
c                                 gokhan@isis.cgd.ucar.edu
c             K. Dixon        (implemented Cox version in MOM 1)
c                              kd@gfdl.gov
c             M. Cox          (original isopycnal code in COX model)
c
c     subroutine isopycnic_init is called within routine setup
c
c     subroutine isopycnic is called within routine spflame
c
c     subroutine isopycnic_flux is called within tracer
c     see also some other modifications in tracer
c
c     subroutine isopycnic_add_K33 is called from vmixc.F
c
c     four parameters has to be specified in main namelist 
c
c
c     parameters are in spflame_module as well as a switch to
c     enable isopycnic diffusion
c
c                               aug 2001   c.eden
c-----------------------------------------------------------------------
c
      implicit none

#if defined  IRIX_host || defined ALPHA_host || defined LINUX_host || defined SUN_host 
      real,parameter :: epsln   = 1.0e-15  !  for single precision
#else
      real,parameter :: epsln   = 1.0e-25  !  for double precision
#endif

      integer, parameter :: nrpl = 11
      real :: dptlim(nrpl+1)=(/0.0e2, 500.0e2, 1000.0e2, 1500.0e2, 
     &                       2000.0e2, 2500.0e2, 3000.0e2, 3500.0e2, 
     &                       4000.0e2, 4500.0e2, 5000.0e2, 5500.0e2/)

      integer :: krplin(nrpl)=0
      integer, allocatable  :: kisrpl(:)

      real, allocatable :: fzisop(:)

      real, allocatable :: K1(:,:,:,:) 
      real, allocatable :: K2(:,:,:,:) 
      real, allocatable :: K3(:,:,:,:) 

      real, allocatable        :: adv_vetiso(:,:,:) 
      real, allocatable        :: adv_vntiso(:,:,:) 
      real, allocatable        :: adv_vbtiso(:,:,:) 

      real, allocatable :: dciso1(:,:,:) 
      real, allocatable :: dciso2(:,:,:) 

      real, allocatable :: rhoi(:,:,:,:) 
      real :: dslope=0.0008, slopec=0.007

      real, allocatable :: krit(:,:) 

      end module isopycnic_module

      subroutine isopycnic_init 
      use spflame_module
      use isopycnic_module
      implicit none
      integer :: k,m
      real ::  dptmid,t1,t2
      integer is,ie,js,je
      real :: ft1, delta_iso1  ,delta1a,delta1b
      integer :: i_delta1, j_delta1, k_delta1,i,j

      slopec=del_dm
      dslope=s_dm

      if (my_pe==0) then
       print*,''
       print*,' Initialization of isopycnal mixing scheme' 
       print*,'  (the old Redi/Cox code)'
       print*,''
       print*,'   ahisop  = ',ahisop, ' cm^2/s '
       print*,'   athkdf  = ',athkdf, ' cm^2/s '
       print*,'   slmx    = ',slmx
       print*,'   del_dm  = ',slopec
       print*,'   s_dm    = ',dslope
       print*,''
       if (enable_isopycnic_horvar) then
          print*,' horizontal varying thickness diffusion coeff.'
          print*,' and isopycnic diffusion coeff.'
          print*,' depending on local Rossby radius'
          print*,' (meant for eddy-permitting cases only)'
       endif
       if (enable_no_isopyc_medwater) then
        print*,''
        print*,
     &    ' decreasing isopycnal diffusivity in medwater outflow-area'
        print*,''
       endif
      endif
c
c   checks
c
      if (enable_rotated_grid .and.enable_isopycnic_horvar) then
         print*,' ERROR in isopycnic: horvar thicknes diff'
         print*,' does not work with rotated grid'
         call halt_stop('in isopycnic')
      endif
#ifdef partial_cell
         print*,' ERROR in isopycnic: partial cells '
         print*,' do not work with old Redi/Cox scheme'
         call halt_stop('in isopycnic')
#endif

c
c-----------------------------------------------------------------------
c     Compute the grid factors which set the maximum slopes available
c     for the mixing schemes. 
c-----------------------------------------------------------------------
c
      ft1 = 1.0/(4.0*max(ahisop,athkdf)*dt + epsln)
      delta_iso1  = dzt(1)*ft1*dxt(1)*cst(jmt/2)
      i_delta1 = 1
      j_delta1 = 1
      k_delta1 = 1
c
      do j=2,jmt-1
        do i=2,imt-1
	  do k=1,km
	    delta1a = dxt(i)*cst(j)*dzt(k)*ft1
	    delta1b = dyt(j)*dzt(k)*ft1
	    if ( delta_iso1 .ge. delta1a
     &      .or. delta_iso1 .ge. delta1b) then
              i_delta1 = i
              j_delta1 = j
              k_delta1 = k
	      delta_iso1  = min(delta1a,delta1b)
	    endif 
	  enddo
        enddo
      enddo
c
      if (my_pe==0) then
       print'(a)',' '
       print'(a,e14.7)',
     &'The diffusion grid factor delta_iso1 =',delta_iso1
       print'(a)', 'was determined at the grid point'
       print'(a,i4,a,e14.7)', 'dxt(',i_delta1,') = ',dxt(i_delta1)
       print'(a,i4,a,e14.7)', 'dyt(',j_delta1,') = ',dyt(j_delta1)
       print'(a,i4,a,e14.7)', 'dzt(',k_delta1,') = ',dzt(k_delta1)
       print'(a,i4,a,e14.7)', 'cst(',j_delta1,') = ',cst(j_delta1)
       print*,
     &'Without latitudinal filtering, delta_iso1 is the steepest'
       print*,
     &'isoneutral slope available for linear stab of Redi and GM.'
       print'(/a,e14.7/)',
     &'Maximum allowable isoneutral slope is specified as slmx = ',slmx
      endif


c
c-----------------------------------------------------------------------
c     determine the isopycnal reference pressure levels for the "t"
c     grid point levels, using the depths at the "t" grid points as the
c     reference depth (pressure)
c-----------------------------------------------------------------------
c
      dptlim(1)    = 0.
      dptlim(nrpl+1) = zw(km)
      allocate( kisrpl(km) )

      do k=1,km
        do m=2,nrpl+1
          if (zt(k).gt.dptlim(m-1) .and. zt(k).le.dptlim(m)) then
            kisrpl(k) = m-1
            go to 101
          endif
        enddo
101     continue
        if (kisrpl(k) .lt. 1 .or. kisrpl(k) .gt. nrpl) then
          print*,' =>Error: kisrpl is ',kisrpl(k),' at k ',k
          call halt_stop(' in isopycnic_init')
        endif
      enddo
c
c-----------------------------------------------------------------------
c     the indices used in isopycnal mixing indicating the location of
c     the reference pressure levels in the 20-level table of polynomial
c     expansion variables are computed
c
c     REMARK: because the polynomial expansion coefficients are
c             functions of the reference potential temperature and
c             salinity profiles, at the reference pressure level
c             the corresponding potential temperature and salinity
c             values will be used.
c-----------------------------------------------------------------------
c
c
      do m=2,nrpl+1
        dptmid = .5*(dptlim(m-1)+dptlim(m))
        if (dptmid .le. zt(1)) then
          krplin(m-1) = 1
        elseif (dptmid .gt. zt(km)) then
          krplin(m-1) = km
        elseif (dptmid.gt.zt(1) .and. dptmid.le.zt(km)) then
          do k=2,km
            if (zt(k) .ge. dptmid) then
              t1 = zt(k)-dptmid
              t2 = dptmid-zt(k-1)
              if (t1 .gt. t2) then
                krplin(m-1) = k-1
              else
                krplin(m-1) = k
              endif
              go to 102 
            endif
          enddo
102       continue
        endif
        if (krplin(m-1) .lt. 1 .or. krplin(m-1) .gt. km) then
          print*,' Error: krplin is ', krplin(m-1),' at m ',m-1
          call halt_stop(' in isopycnic_init')
        endif
      enddo
c
  96  format (/,' isopycnal reference pressure levels (kisrpl) = ',
     &        20(1x,i4))
  97  format (/,' reference pressure level indices (krplin) = ',
     &        20(1x,i4))

      if (my_pe==0) then
       print 96, (kisrpl(k),k=1,km)
       print 97, (krplin(m),m=1,nrpl)
      endif
c
c
      allocate( fzisop(km) ); fzisop=1.0
      do k=1,km
        fzisop(k)=1.0*(1.-exp(-zt(k)/100.e2))*
     &       ( 0.25+0.75*(1.-tanh((zt(k)-2000.e2)/1000.e2))/2. )
      enddo

      if (my_pe==0) then
       print'(a)', '  '
       print'(a)', ' Vertical structure function "fzisop(k)"='
       print'(5(1x,e12.6))', (fzisop(k),k=1,km)
      endif

c-----------------------------------------------------------------------
c     initialize arrays
c-----------------------------------------------------------------------
      is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      allocate( rhoi(is-1:ie+1,km,js-1:je+1,nrpl));   rhoi=0.

      allocate( K1(is-1:ie,km,js  :je,3:3));      K1=0.
      allocate( K2(is  :ie,km,js-1:je,3:3));      K2=0.
      allocate( K3(is  :ie,km,js  :je,1:3));      K3=0.
      allocate( dciso1(is-1:ie,km,js  :je));      dciso1=0.
      allocate( dciso2(is  :ie,km,js-1:je));      dciso2=0.

      allocate( adv_vetiso(is-1:ie,  km,js  :je));adv_vetiso=0.
      allocate( adv_vntiso(is  :ie,  km,js-1:je));adv_vntiso=0.
      allocate( adv_vbtiso(is  :ie,0:km,js  :je));adv_vbtiso=0.
c
      allocate(krit(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) ); krit=1.0
c
      if (enable_isopycnic_horvar)  then
c        call isopycnic_write_krit_init
      endif

      if (my_pe == 0) then
        print*,''
        print*,' done'
        print*,''
      endif

      end subroutine isopycnic_init




      subroutine isopycnic ()
      use spflame_module
      use isopycnic_module
      implicit none
      integer is,ie,js,je,m,i,j,k
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     compute normalized densities for each isopycnal reference pressure
c     level using a 3rd order polynomial fit to the equation of state.
c     for each isopycnal reference pressure level, the same reference
c     potential temperature, reference salinity and expansion coeff
c     values are used at all of the vertical levels.
c-----------------------------------------------------------------------
c
      do m=1,nrpl
	do j=js-1,je+1
          do k=1,km
            call model_dens(t(is-1,k,j,1,taum1), t(is-1,k,j,2,taum1),
     &            rhoi(is-1,k,j,m), krplin(m) ,ie-is+3
#ifdef partial_cell
     &                       ,ztp(is-1,krplin(m),j)
#endif
     &                       )
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
      if (enable_isopycnic_horvar)  then
        call isopycnic_krit
c        if (snapshot_time_step) call isopycnic_write_krit
      endif
c-----------------------------------------------------------------------
c
      if (enable_no_isopyc_medwater) then
        call isopycnic_krit_med
      endif 
c
c-----------------------------------------------------------------------
c     evaluate K2(,,3) centered on the northern face of "T" cells
c-----------------------------------------------------------------------
c
      call isopycnic_k2_3 
c
c-----------------------------------------------------------------------
c     evaluate K1(,,3) centered on eastern face of "T" cells
c-----------------------------------------------------------------------
c
      call isopycnic_k1_3 
c
c-----------------------------------------------------------------------
c     evaluate K3(,,1..3) centered on bottom face of "T" cells
c-----------------------------------------------------------------------
c
      call isopycnic_k3_123
c
c-----------------------------------------------------------------------
c     compute isopycnal advective velocities for tracers
c-----------------------------------------------------------------------
c
      call isopycnic_adv 
c
      end subroutine isopycnic


      subroutine isopycnic_krit
c
c=======================================================================
c     compute isopycnal transport velocities 
c=======================================================================
c
      use spflame_module
      use isopycnic_module
      implicit none

      integer is,ie,js,je,i,j,k
      real :: fxa,lm,cm,beta,Kr,dy
      real, allocatable :: ro1(:),ro2(:),bvfrqs(:,:,:)
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
      allocate(  ro1(is_pe-1:ie_pe+1),ro2(is_pe-1:ie_pe+1) )
      allocate( bvfrqs(is_pe-1:ie_pe+1,km,js_pe-1:je_pe+1) )
      ro1=0.;ro2=0.; bvfrqs=0.;
c
c    compute N2
c
      do j=js-1,je
        do k=1,km-1
         call model_dens(t(is-1,k  ,j,1,tau),t(is-1,k  ,j,2,tau),
     &                  ro1(is-1),k,ie-is+2
#ifdef partial_cell
     &                       ,ztp(is-1,k,j)
#endif
     &                       )
         call model_dens(t(is-1,k+1,j,1,tau),t(is-1,k+1,j,2,tau),
     &                  ro2(is-1),k,ie-is+2
#ifdef partial_cell
     &                       ,ztp(is-1,k,j)
#endif
     &                       )
         do i=is-1,ie
#ifdef partial_cell
          fxa = -grav/(rho0*dhwt(i,k,j))
#else
          fxa = -grav/rho0*dzwr(k)
#endif
          bvfrqs(i,k,j) =fxa*(ro1(i)-ro2(i))*tmask(i,k+1,j)
         enddo
        enddo
      enddo
       bvfrqs(:,km,:) = 0.  ! lower boundary condition
c
c    now N
c
      do j=js-1,je
        do k=1,km
         do i=is-1,ie
           if (bvfrqs(i,k,j) >=0.) then
             bvfrqs(i,k,j)=sqrt(bvfrqs(i,k,j))
           else
             bvfrqs(i,k,j)=0.
           endif
         enddo
        enddo
      enddo
c
c    now integrate N
c
      krit=0.0
      do j=js-1,je
        do k=1,km
         do i=is-1,ie
           krit(i,j)=krit(i,j)+bvfrqs(i,k,j)*dzt(k)
         enddo
        enddo
      enddo
c
c    now compute local Rossby radius approximated as in 
c    Chelton, et al. 1998, JPO 28 and compare with grid 
c
      do j=js,je
        beta  = 2.*omega*csu(j)/radius
        do i=is,ie
         CM = krit(i,j)/PI
         lm = MIN( CM/(ABS(cori(i,j,1))+epsln), sqrt(CM/2.0/BETA) )
         dy=max( dxt(i)*cst(j),dyt(j) )
         Kr = (LM/DY-isohv_a1)*isohv_a2 
         krit(i,j)=1.-( (exp(kr)-exp(-kr))/(exp(kr)+exp(-kr))+1.0)/2.0
        enddo
      enddo
      deallocate(ro1,ro2,bvfrqs)

      call border_exchg(krit,1,1)
      call set_cyclic(krit,1,1)

      end subroutine isopycnic_krit


      subroutine isopycnic_krit_med
c
c=======================================================================
c    special for HS4 model and Gibraltar region
c=======================================================================
c
      use spflame_module
      use isopycnic_module
      implicit none
      integer is,ie,js,je,i,j,k
      real distance,dstnce_isopyc
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js-1,je
         do i=is-1,ie
c           distance = dstnce(yt(j),xt(i),yt(682),xt(112))
          distance = dstnce_isopyc(yt(j),xt(i),35.8585,269.2083)
           if (distance < 500.0) then
             if (distance <= 300.0) then
               krit(i,j)=krit(i,j)*0.00001
             else
               krit(i,j)=krit(i,j)*(200.0-(500.0-distance)*0.005)
             endif
           endif           
         enddo
       enddo
       end subroutine isopycnic_krit_med


       real function dstnce_isopyc(phi1,rla1,phi2,rla2)
c returns distance (in km) between two geographical
c points
c        written by   p.herrmann
c      phi1 : first latitude
c      rla1 : first longitude
c      phi2 : second latitude
c      rla2 : second longitude
       implicit none
       real :: p1,p2,rl1,rl2,x,xx, phi1,phi2,rla1,rla2,d
       real, parameter :: s=0.0174533 
       p1=phi1*s; p2=phi2*s; rl1=rla1*s; rl2=rla2*s
       x=sin(p1)*sin(p2)+cos(p1)*cos(p2)*cos(rl2-rl1)
       xx=abs(x)
       if(xx.gt.1.0) x=1.0
       d=atan(sqrt((1-x)/(1+x)))*222.24/s; dstnce_isopyc=d
      end function dstnce_isopyc


      subroutine isopycnic_k1_3 
c
c=======================================================================
c     
c     compute "K1(,,3)" at the center of the eastern face of "T" cells
c     use "c1e10" to keep the exponents in range.
c
c=======================================================================
c
      use spflame_module
      use isopycnic_module
      implicit none
      integer is,ie,js,je,m,i,j,k
      real :: c1e10 = 1.0e10, fxd, fxe, olmask
      real :: fxa, fxb, fxc, slope
      real :: e(is_pe-1:ie_pe,km,js_pe:je_pe,3)
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     d(rho_barx_barz)/dz centered on eastern face of "t" cells
c     Note: values involving ocean surface and ocean bottom are
c           estimated afterwards using a linear extrapolation
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=2,km-1
          m = kisrpl(k)
          fxd = c1e10*0.5*dzt2r(k)
          do i=is-1,ie
            e(i,k,j,3) = fxd*(rhoi(i  ,k-1,j,m) - rhoi(i  ,k+1,j,m)
     &                       +rhoi(i+1,k-1,j,m) - rhoi(i+1,k+1,j,m))
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     linearly extrapolate densities to ocean surface for calculation
c     of d(rho_barx_barz)/dz involving level 1.
c
c     REMARK: requires min(kmt(i,jrow)) = 2 cells in ocean.
c-----------------------------------------------------------------------
c
      k   = 1
      fxd = c1e10*dztr(k)
      fxe = dzw(k-1)+dzw(k)
      m   = kisrpl(k)
      do j=js,je
        do i=is-1,ie
          fxa        = 0.5*(rhoi(i,k+1,j,m) + rhoi(i+1,k+1,j,m))
          fxb        = 0.5*(rhoi(i,k,j,m) + rhoi(i+1,k,j,m))
          fxc        = dzwr(k)*(fxb*fxe - fxa*dzw(k-1))
          e(i,k,j,3) = fxd*(fxc - 0.5*(fxa+fxb))
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     linearly extrapolate densities to ocean bottom for calculation
c     of d(rho_barx_barz)/dz involving bottom level.
c-----------------------------------------------------------------------
c
      e(:,km,:,3) = 0.
c
      do j=js,je
        do i=is-1,ie
          k = min(kmt_big(i,j),kmt_big(i+1,j))
          if (k .ne. 0) then
            fxe        = dzw(k-1)+dzw(k)
            m          = kisrpl(k)
            fxa        = 0.5*(rhoi(i,k-1,j,m) + rhoi(i+1,k-1,j,m))
            fxb        = 0.5*(rhoi(i,k  ,j,m) + rhoi(i+1,k  ,j,m))
            fxc        = dzwr(k-1)*(fxb*fxe - fxa*dzw(k))
            e(i,k,j,3) = dztr(k)*c1e10*(0.5*(fxa+fxb) - fxc)
          endif
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     "e(,,,1)" = d(rho)/dx centered on east face of "T" cells
c     "e(,,,2)" = d(rho_barx_bary)/dy centered on east face of "T" cells
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
          m = kisrpl(k)
          do i=is-1,ie
            e(i,k,j,1) = tmask(i,k,j)*tmask(i+1,k,j)*cstr(j)*dxur(i)
     &                     *c1e10*(rhoi(i+1,k,j,m) - rhoi(i,k,j,m))
            e(i,k,j,2) = dyt4r(j)*c1e10*(
     &                     rhoi(i  ,k,j+1,m) - rhoi(i  ,k,j-1,m)
     &                   + rhoi(i+1,k,j+1,m) - rhoi(i+1,k,j-1,m))
           enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     if any one of the 4 neighboring corner grid points is a land point,
c     set "e(i,k,j,2)" to zero. note that "e(i,k,j,2)" will be used
c     only in the slope check.
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
          do i=is-1,ie
            olmask = tmask(i,k,j-1)*tmask(i,k,j+1)*tmask(i+1,k,j-1)
     &   	    *tmask(i+1,k,j+1)
            if (olmask .eq. 0.0)  e(i,k,j,2) = 0.0
           enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     compute "K1", using "slmxr" to limit vertical slope of isopycnal
c     to guard against numerical instabilities. 
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km
          do i=is-1,ie
            fxa = 0.
            fxb = sign(1.,e(i,k,j,3))/(abs(e(i,k,j,3))+epsln)
            slope = fxb*sqrt(e(i,k,j,1)**2+e(i,k,j,2)**2)
            if (slope .le. 0. .and. slope .ge. (-slmx)) then
              fxa = 0.5*(1.+tanh((slope+slopec)/dslope))
            endif
            dciso1(i,k,j) = fxa*fzisop(k)
            K1(i,k,j,3)  = -fxb*e(i,k,j,1)*dciso1(i,k,j)
          enddo
        enddo
      enddo
      end subroutine  isopycnic_k1_3



      subroutine isopycnic_k2_3 
c     
c=======================================================================
c     compute "K2(,,3)" at the center of the northern face of "T" cells
c     use "c1e10" to keep the exponents in range.
c=======================================================================
c
      use spflame_module
      use isopycnic_module
      implicit none
      integer is,ie,js,je,m,i,j,k
      real :: c1e10 = 1.0e10, fxd, fxe, olmask
      real :: fxa, fxb, fxc, slope
      real :: e(is_pe:ie_pe,km,js_pe-1:je_pe,3)
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     d(rho_bary_barz)/dz centered on northern face of "T" cells
c     Note: values involving ocean surface and ocean bottom are
c           estimated afterwards using a linear extrapolation
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=2,km-1
          m = kisrpl(k)
          fxd = c1e10*0.5*dzt2r(k)
          do i=is,ie
            e(i,k,j,3) = fxd*(rhoi(i,k-1,j  ,m) - rhoi(i,k+1,j  ,m)
     &                       +rhoi(i,k-1,j+1,m) - rhoi(i,k+1,j+1,m))
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     linearly extrapolate densities to ocean surface for calculation
c     of d(rho_bary_barz)/dz involving level 1.
c
c     REMARK: requires min(kmt(i,jrow)) = 2 cells in ocean.
c-----------------------------------------------------------------------
c
      k   = 1
      fxd = c1e10*dztr(k) 
      fxe = dzw(k-1)+dzw(k)
      m   = kisrpl(k)
      do j=js-1,je
        do i=is,ie
          fxa        = 0.5*(rhoi(i,k+1,j,m) + rhoi(i,k+1,j+1,m))
          fxb        = 0.5*(rhoi(i,k  ,j,m) + rhoi(i,k  ,j+1,m))
          fxc        = dzwr(k)*(fxb*fxe - fxa*dzw(k-1))
          e(i,k,j,3) = fxd*(fxc - 0.5*(fxa+fxb))
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     linearly extrapolate densities to ocean bottom for calculation
c     of d(rho_bary_barz)/dz involving bottom level.
c-----------------------------------------------------------------------
c
      e(:,km,:,3) = 0.
c
      do j=js-1,je
        do i=is,ie
          k = min(kmt_big(i,j),kmt_big(i,j+1))
          if (k .ne. 0) then
            fxe        = dzw(k-1)+dzw(k)
            m          = kisrpl(k)
            fxa        = 0.5*(rhoi(i,k-1,j,m) + rhoi(i,k-1,j+1,m))
            fxb        = 0.5*(rhoi(i,k  ,j,m) + rhoi(i,k  ,j+1,m))
            fxc        = dzwr(k-1)*(fxb*fxe - fxa*dzw(k))
            e(i,k,j,3) = dztr(k)*c1e10*(0.5*(fxa+fxb) - fxc)
          endif
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     "e(,,,1)" = d(rho_barx_bary)/dx centered on north face of "T" cells
c     "e(,,,2)" = d(rho)/dy on north face of "T" cells
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=1,km
          m = kisrpl(k)
          do i=is,ie
            e(i,k,j,1) = csur(j)*dxt4r(i)*c1e10*(
     &                    rhoi(i+1,k,j+1,m) - rhoi(i-1,k,j+1,m)
     &                  + rhoi(i+1,k,j  ,m) - rhoi(i-1,k,j  ,m))
            e(i,k,j,2) = tmask(i,k,j)*tmask(i,k,j+1)*dyur(j)*c1e10
     &                  *(rhoi(i,k,j+1,m) - rhoi(i,k,j,m))   
           enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     if any one of the 4 neighboring corner grid points is a land point,
c     set "e(i,k,j,1)" to zero. note that "e(i,k,j,1)" will be used
c     only in the slope check.
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=1,km
          do i=is,ie
            olmask = tmask(i-1,k,j+1)*tmask(i+1,k,j+1)*tmask(i-1,k,j)
     &              *tmask(i+1,k,j)
            if (olmask == 0.)  e(i,k,j,1) = 0.
           enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     compute "K2", using "slmxr" to limit vertical slope of isopycnal
c     to guard against numerical instabilities. 
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=1,km
          do i=is,ie
            fxa = 0.
            fxb = sign(1.,e(i,k,j,3))/(abs(e(i,k,j,3))+epsln)
            slope = fxb*sqrt(e(i,k,j,1)**2+e(i,k,j,2)**2)
            if (slope .le. 0. .and. slope .ge. (-slmx)) then
              fxa = 0.5*(1.+tanh((slope+slopec)/dslope))
            endif
            dciso2(i,k,j) = fxa *fzisop(k)
            K2(i,k,j,3)  = -fxb*e(i,k,j,2)*dciso2(i,k,j)
          enddo
        enddo
      enddo
      end subroutine isopycnic_k2_3







      subroutine isopycnic_k3_123 
c
c=======================================================================
c     compute K2(,,,1:3) at the center of the bottom face of "T" cells
c     use "c1e10" to keep the exponents in range.
c=======================================================================
c
      use spflame_module
      use isopycnic_module
      implicit none
      integer is,ie,js,je,m,i,j,k
      real :: c1e10 = 1.0e10, fxd, fxe, olmask
      real :: fxa, fxb, fxc, slope
      real :: e(is_pe:ie_pe,km,js_pe:je_pe,3)

c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
      do j=js,je
        do k=2,km
          m = kisrpl(k)
          do i=is,ie
            e(i,k-1,j,1) = cstr(j)*dxt4r(i)*c1e10
     &               *(tmask(i-1,k-1,j)*tmask(i,k-1,j)*(rhoi(i,k-1,j,m)
     &               -rhoi(i-1,k-1,j,m))
     &               +tmask(i,k-1,j)*tmask(i+1,k-1,j)*(rhoi(i+1,k-1,j,m)
     &               -rhoi(i,k-1,j,m))
     &               +tmask(i-1,k,j)*tmask(i,k,j)*(rhoi(i,k,j,m)
     &               -rhoi(i-1,k,j,m))
     &               +tmask(i,k,j)*tmask(i+1,k,j)*(rhoi(i+1,k,j,m)
     &               -rhoi(i,k,j,m)))
            e(i,k-1,j,2) = dyt4r(j)*c1e10
     &               *(tmask(i,k-1,j-1)*tmask(i,k-1,j)*(rhoi(i,k-1,j,m)
     &               -rhoi(i,k-1,j-1,m))
     &               +tmask(i,k-1,j)*tmask(i,k-1,j+1)*(rhoi(i,k-1,j+1,m)
     &               -rhoi(i,k-1,j,m))
     &               +tmask(i,k,j-1)*tmask(i,k,j)*(rhoi(i,k,j,m)
     &               -rhoi(i,k,j-1,m))
     &               +tmask(i,k,j)*tmask(i,k,j+1)*(rhoi(i,k,j+1,m)
     &               -rhoi(i,k,j,m)))
            e(i,k-1,j,3) = dzwr(k-1)*tmask(i,k-1,j)*tmask(i,k,j)*c1e10
     &               *(rhoi(i,k-1,j,m) - rhoi(i,k,j,m))
           enddo
        enddo
        k = km
	e(:,k,j,1) = 0.
	e(:,k,j,2) = 0.
        e(:,k,j,3) = 0.
      enddo
c
c-----------------------------------------------------------------------
c     compute "K3", using "slmxr" to limit vertical slope of isopycnal
c     to guard against numerical instabilities.  
c-----------------------------------------------------------------------
c

      do j=js,je
        do k=1,km
          do i=is,ie
            fxa = 0.
            fxb = sign(1.,e(i,k,j,3))/(abs(e(i,k,j,3))+epsln)
            slope = fxb*sqrt(e(i,k,j,1)**2+e(i,k,j,2)**2)
            if (slope .le. 0. .and. slope .ge. (-slmx)) then
              fxa = 0.5*(1.+tanh((slope+slopec)/dslope))
            endif
            fxc = fxb*fxa
ce            scaling with fzisop
ce            same form as without isopycmixspatialvar
ce            correct ??
     &         *0.5*(fzisop(min(km,k+1))+fzisop(k))
            K3(i,k,j,1) = -fxc*e(i,k,j,1)
            K3(i,k,j,2) = -fxc*e(i,k,j,2)
            K3(i,k,j,3) = fxb*fxb*(e(i,k,j,1)**2+e(i,k,j,2)**2)
     &                    *fxa
ce             fxc is not used, so scale fxa again with fzisop
     &         *0.5*(fzisop(min(km,k+1))+fzisop(k))
          enddo
        enddo
      enddo
c
      end subroutine isopycnic_K3_123




      subroutine isopycnic_adv
c
c=======================================================================
c     compute isopycnal transport velocities 
c=======================================================================
c
      use spflame_module
      use isopycnic_module
      implicit none

      integer is,ie,js,je,m,i,j,k
      real :: fxa,fxb
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     compute the meridional component of the isopycnal mixing velocity
c     at the center of the northern face of the "t" cells.
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=2,km-1
          fxa = -dzt2r(k)*athkdf*csu(j)
          do i=is,ie
            adv_vntiso(i,k,j) = fxa*tmask(i,k,j)*tmask(i,k,j+1)*(
     &                          K2(i,k-1,j,3) - K2(i,k+1,j,3))
     &                          *krit(i,j)
          enddo
        enddo
      enddo
c
c     consider the top and bottom levels. "K2" is assumed to be zero
c     at the ocean top and bottom.
c
      k = 1
      fxa = -dzt2r(k)*athkdf
      do j=js-1,je
        do i=is,ie
          adv_vntiso(i,k,j) = -fxa*tmask(i,k,j)*tmask(i,k,j+1)*csu(j)
     &                        *(K2(i,k,j,3) + K2(i,k+1,j,3))
     &                        *krit(i,j)
        enddo
      enddo
c
      adv_vntiso(:,km,:) = 0.
c
      do j=js-1,je
        do i=is,ie
          k = min(kmt_big(i,j),kmt_big(i,j+1))
          if (k .ne. 0) then
            adv_vntiso(i,k,j) = -dzt2r(k)*athkdf*csu(j)*tmask(i,k,j)
     &                                          *krit(i,j)
     &                   *tmask(i,k,j+1)*(K2(i,k,j,3) + K2(i,k-1,j,3))
          endif
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     compute the zonal component of the isopycnal mixing velocity
c     at the center of the eastern face of the "t" grid box.
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=2,km-1
          fxa = -dzt2r(k)*athkdf
          do i=is-1,ie
            adv_vetiso(i,k,j) = fxa*tmask(i,k,j)*tmask(i+1,k,j)
     &                          *krit(i,j)
     &                          *(K1(i,k-1,j,3) - K1(i,k+1,j,3))
          enddo
        enddo
      enddo
c
c     consider the top and bottom levels. "K1" is assumed to be zero
c     at the ocean top and bottom.
c
      k = 1
      fxa = -dzt2r(k)*athkdf
      do j=js,je
        do i=is-1,ie
          adv_vetiso(i,k,j) = -fxa*tmask(i,k,j)*tmask(i+1,k,j)
     &                        *(K1(i,k,j,3)+K1(i,k+1,j,3))
     &                        *krit(i,j)
        enddo
      enddo
c
      adv_vetiso(:,km,:) = 0.
c
      do j=js,je
        do i=is-1,ie
          k = min(kmt_big(i,j),kmt_big(i+1,j))
          if (k .ne. 0) then
            adv_vetiso(i,k,j) = -dzt2r(k)*athkdf*tmask(i,k,j)
     &                     *tmask(i+1,k,j)*(K1(i,k,j,3)+K1(i,k-1,j,3))
     &                     *krit(i,j)
          endif
        enddo
      enddo

#ifdef weird_option
      do j=js,je  ! note the error in boundaries
       do k=1,km
        do i=is,ie
            fxa = adv_vntiso(i,k,j) 
            fxb = adv_vetiso(i,k,j) 
            adv_vntiso(i,k,j) = fxa + fxb
            adv_vetiso(i,k,j) = fxb - fxa
        enddo
       enddo
      enddo
#endif
c
c
c-----------------------------------------------------------------------
c     compute the vertical component of the isopycnal mixing velocity
c     at the center of the bottom face of the "t" cells, using the
c     continuity equation for the isopycnal mixing velocities
c-----------------------------------------------------------------------
c
      adv_vbtiso(:,0,:) = 0.
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
            adv_vbtiso(i,k,j) = dzt(k)*cstr(j)*(
     &      (adv_vetiso(i,k,j) - adv_vetiso(i-1,k,j))*dxtr(i) + 
     &      (adv_vntiso(i,k,j) - adv_vntiso(i,k,j-1))*dytr(j)) 
          enddo
        enddo
      enddo
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
            adv_vbtiso(i,k,j) = adv_vbtiso(i,k,j) + adv_vbtiso(i,k-1,j)
          enddo
        enddo
      enddo
c
      do j=js,je
        do i=is,ie
          adv_vbtiso(i,kmt_big(i,j),j) = 0.
        enddo
      enddo
c
      end subroutine isopycnic_adv



      subroutine isopycnic_flux (m,diff_fe,diff_fn,diff_fb)
c
c=======================================================================
c     isopycnal diffusive tracer fluxes are computed.
c     horizontal fluxes are added (!) to diff_fe and diff_fn
c     while diff_fb is set (!) to K13 and K23 components which
c     are solved explicitly. 
c=======================================================================
c
      use spflame_module
      use isopycnic_module
      implicit none
      integer, intent(in) :: m
      real diff_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real diff_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real diff_fb(is_pe:ie_pe,0:km,js_pe:je_pe)

      integer is,ie,js,je,i,j,k
      real :: fxa,fxb,fxc,fxe
      real temp(is_pe-1:ie_pe,km,js_pe-1:je_pe)
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     first compute the vertical tracer flux "temp" at the northern
c     face of "t" cells.
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=2,km-1
          do i=is,ie
            temp(i,k,j) = 0.5*dzt2r(k)*(
     &                      t(i,k-1,j+1,m,taum1) - t(i,k+1,j+1,m,taum1)
     &                     +t(i,k-1,j  ,m,taum1) - t(i,k+1,j  ,m,taum1))
     &                     
           enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     now consider the top level, assuming that the surface tracer 
c     values are the same as the ones at "k"=1
c-----------------------------------------------------------------------
c
      k = 1
      do j=js-1,je
        do i=is,ie
          temp(i,k,j) = 0.5*dzt2r(k)*(
     &                     t(i,k,j+1,m,taum1) - t(i,k+1,j+1,m,taum1)
     &                    +t(i,k,j  ,m,taum1) - t(i,k+1,j  ,m,taum1))
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     finally, consider the bottom level. the extrapolative estimator
c     is used to compute the tracer values at the ocean bottom.
c-----------------------------------------------------------------------
c
      temp(:,km,:) = 0.
c
      do j=js-1,je
        do i=is,ie
          k = min(kmt_big(i,j),kmt_big(i,j+1))
          if (k .ne. 0) then
            fxe = dzw(k-1)+dzw(k)
            fxa = 0.5*(t(i,k-1,j+1,m,taum1) + t(i,k-1,j,m,taum1))
            fxb = 0.5*(t(i,k  ,j+1,m,taum1) + t(i,k  ,j,m,taum1))
            fxc = dzwr(k-1)*(fxb*fxe-fxa*dzw(k))
            temp(i,k,j) = dztr(k)*(0.5*(fxa+fxb) - fxc)
          endif
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     compute of meridional tracer flux at northern face of "T" cells.
c     first calculate the effects of purely horizontal diffusion, using
c     the sum of the along isopycnal and background horizontal diffusion
c     coefficients as the total diffusion coefficient.     
c     add in the effects of the along isopycnal diffusion computed
c     using "K2" component of the tensor and apply land/sea masks
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do k=1,km
          do i=is,ie
            fxa = ahisop*dciso2(i,k,j)
            fxa = fxa*krit(i,j)
            diff_fn(i,k,j) = diff_fn(i,k,j)+(fxa*dyur(j)*(
     &                        t(i,k,j+1,m,taum1)-t(i,k,j,m,taum1))
     &                        + ahisop*K2(i,k,j,3)*temp(i,k,j)
     &                          *krit(i,j)
     &                       )*csu(j)*tmask(i,k,j+1)*tmask(i,k,j)
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     compute the vertical tracer flux "temp" at the eastern
c     face of "t" cells.
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=2,km-1
          do i=is-1,ie
            temp(i,k,j) = 0.5*dzt2r(k)*(
     &                    t(i+1,k-1,j,m,taum1) - t(i+1,k+1,j,m,taum1)
     &                   +t(i  ,k-1,j,m,taum1) - t(i  ,k+1,j,m,taum1))
          enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     now consider the top level, assuming that the surface tracer 
c     values are the same as the ones at "k"=1
c-----------------------------------------------------------------------
c
      k = 1
      do j=js,je
        do i=is-1,ie
          temp(i,k,j) = 0.5*dzt2r(k)*(
     &                  t(i+1,k,j,m,taum1) -t(i+1,k+1,j,m,taum1)
     &                 +t(i  ,k,j,m,taum1) -t(i  ,k+1,j,m,taum1))
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     finally, consider the bottom level. the extrapolative estimator
c     is used to compute the tracer values at the ocean bottom.
c-----------------------------------------------------------------------
c
      temp(:,km,:) = 0.
c
      do j=js,je
        do i=is-1,ie
          k = min(kmt_big(i,j),kmt_big(i+1,j))
          if (k .ne. 0) then
            fxe          = dzw(k-1)+dzw(k)
            fxa          = 0.5*(t(i,k-1,j,m,taum1)+t(i+1,k-1,j,m,taum1))
            fxb          = 0.5*(t(i,k,j,m,taum1)+t(i+1,k,j,m,taum1))
            fxc          = dzwr(k-1)*(fxb*fxe - fxa*dzw(k))
            temp(i,k,j) = dztr(k)*(0.5*(fxa+fxb)-fxc)
          endif
        enddo
      enddo
c
c-----------------------------------------------------------------------
c     compute of zonal tracer flux at eastern face of "T" cells.
c     first calculate the effects of purely horizontal diffusion, using
c     the sum of the along isopycnal and background horizontal diffusion
c     coefficients as the total diffusion coefficient.     
c     add in the effects of the along isopycnal diffusion computed
c     using "K1" component of the tensor and apply land/sea masks      
c-----------------------------------------------------------------------
c      
      do j=js,je
        do k=1,km
          do i=is-1,ie
            fxa = ahisop*dciso1(i,k,j)
            fxa = fxa*krit(i,j)
            diff_fe(i,k,j) = diff_fe(i,k,j)+(fxa*cstr(j)*dxur(i)*(
     &                        t(i+1,k,j,m,taum1) - t(i,k,j,m,taum1))
     &                        + ahisop*K1(i,k,j,3)*temp(i,k,j)
     &                          *krit(i,j)
     &                       )*tmask(i+1,k,j)*tmask(i,k,j)
          enddo
        enddo
      enddo

c
c-----------------------------------------------------------------------
c     compute the vertical tracer flux "diff_fbiso" containing the K31
c     and K32 components which are to be solved explicitly. The K33
c     component will be treated semi-implicitly by diff_fb.
c-----------------------------------------------------------------------
c

      do j=js,je
        do k=2,km
          do i=is,ie
            diff_fb(i,k-1,j) = 
     &                 tmask(i,k-1,j)*tmask(i,k,j)
     &                  *(ahisop*
     &                           krit(i,j)*
     &                           K3(i,k-1,j,1)*cstr(j)*dxt4r(i)*(
     &      tmask(i-1,k,j)*(t(i,k,j,m,taum1)-t(i-1,k,j,m,taum1))
     &     +tmask(i-1,k-1,j)*(t(i,k-1,j,m,taum1)-t(i-1,k-1,j,m,taum1))
     &     +tmask(i+1,k,j)*(t(i+1,k,j,m,taum1)-t(i,k,j,m,taum1))
     &     +tmask(i+1,k-1,j)*(t(i+1,k-1,j,m,taum1)-t(i,k-1,j,m,taum1)))
     &                   +ahisop*
     &                           krit(i,j)*
     &                           K3(i,k-1,j,2)*dyt4r(j)*(
     &      tmask(i,k,j-1)*(t(i,k,j,m,taum1)-t(i,k,j-1,m,taum1))
     &     +tmask(i,k-1,j-1)*(t(i,k-1,j,m,taum1)-t(i,k-1,j-1,m,taum1))
     &     +tmask(i,k,j+1)*(t(i,k,j+1,m,taum1)-t(i,k,j,m,taum1))
     &     +tmask(i,k-1,j+1)*(t(i,k-1,j+1,m,taum1)-t(i,k-1,j,m,taum1)))
     &                   )
          enddo
        enddo
      enddo
      end subroutine isopycnic_flux




      subroutine isopycnic_add_K33
c
c-----------------------------------------------------------------------
c     add K33 component of isopycnal slope to vertical diffusion coeff
c-----------------------------------------------------------------------
c
      use spflame_module
      use isopycnic_module
      implicit none
      integer is,ie,js,je
      integer i,j,k

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
        do k=1,km-1
          do i=is,ie
            diff_cbt(i,k,j) = (ahisop*K3(i,k,j,3)
     &                          *krit(i,j)
     &                         + diff_cbt(i,k,j) )*tmask(i,k+1,j)


          enddo
        enddo
      enddo
      end subroutine isopycnic_add_K33



      subroutine isopycnic_add_gm(n,adv_fe,adv_fn,adv_fb)
c
c=======================================================================
c     add isopycnal transport velocities to advective fluxes
c=======================================================================
c
      use spflame_module
      use isopycnic_module
      implicit none
      integer, intent(in) :: n
      real :: adv_fe(is_pe-1:ie_pe,km,js_pe:je_pe)
      real :: adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real :: adv_fb(is_pe:ie_pe,0:km,js_pe:je_pe)
      integer :: is,ie,js,je,i,j,k
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     calculate 2*advective flux across eastern face of "T" cells.
c-----------------------------------------------------------------------
c
       do j=js,je
        do k=1,km
         do i=is-1,ie
	   adv_fe(i,k,j) = adv_fe(i,k,j)+
     &                     adv_vetiso(i,k,j)*(t(i,  k,j,n,taum1) + 
     &                                        t(i+1,k,j,n,taum1))
         enddo
        enddo
      enddo
c
c-----------------------------------------------------------------------
c    calculate 2*advective flux across northern face of "T" cells 
c-----------------------------------------------------------------------
c
      do j=js-1,je
       do k=1,km
        do i=is,ie
	 adv_fn(i,k,j) = adv_fn(i,k,j)+
     &                   adv_vntiso(i,k,j)*(t(i,k,j  ,n,taum1) + 
     &                                      t(i,k,j+1,n,taum1))
        enddo
       enddo
      enddo
c
c-----------------------------------------------------------------------
c     compute advective tracer flux at the center of the bottom face of
c     the "T" cells
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
            adv_fb(i,k,j) = adv_fb(i,k,j)+adv_vbtiso(i,k,j)*
     &                         (t(i,k,j,n,taum1) + t(i,k+1,j,n,taum1))
          enddo
        enddo
      enddo
      end subroutine isopycnic_add_gm


      subroutine isopycnic_add_div_gm(n,is,ie,js,je)
c
c=======================================================================
c     add divergence of bolus transport fluxes
c=======================================================================
c
      use spflame_module
      use isopycnic_module
      implicit none
      integer, intent(in) :: n,is,ie,js,je
      integer i,j,k
      real adv_fbiso(is:ie,0:km,js:je),xh(is:ie)
      real ADV_Tx,ADV_Ty,ADV_Tz

      ADV_Tx(i,k,j) = cstdxt2r(i,j)*
     &                   (adv_vetiso(i,k,j)*
     &                    (t(i+1,k,j,n,taum1) + t(i,k,j,n,taum1))
     &                   -adv_vetiso(i-1,k,j)*
     &                    (t(i,k,j,n,taum1) + t(i-1,k,j,n,taum1)))
      ADV_Ty(i,k,j) = cstdyt2r(j)*
     &                   (adv_vntiso(i,k,j)*
     &                   (t(i,k,j+1,n,taum1) + t(i,k,j,n,taum1))
     &                  -adv_vntiso(i,k,j-1)*
     &                   (t(i,k,j,n,taum1) + t(i,k,j-1,n,taum1)))   
      ADV_Tz(i,k,j) = dzt2r(k)*(adv_fbiso(i,k-1,j)-adv_fbiso(i,k,j))
c
c-----------------------------------------------------------------------
c     compute advective tracer flux at the center of the bottom face of
c     the "T" cells
c-----------------------------------------------------------------------
c
      do j=js,je
        do k=1,km-1
          do i=is,ie
            adv_fbiso(i,k,j) = adv_vbtiso(i,k,j)*
     &                         (t(i,k,j,n,taum1) + t(i,k+1,j,n,taum1))
          enddo
        enddo
      enddo
c
c     now consider the top and bottom boundaries
c
      adv_fbiso(:,0,:)  = 0.
      adv_fbiso(:,km,:) = 0.
c
      do j=js,je
       do k=1,km
        do i=is, ie
         xh(i) = -ADV_Tx(i,k,j) - ADV_Ty(i,k,j)
        enddo
        do i=is, ie
         xh(i) = xh(i) - ADV_Tz(i,k,j)
        enddo
        do i=is, ie
         t(i,k,j,n,taup1)=t(i,k,j,n,taup1)+xh(i)*c2dt*tmask(i,k,j)
        enddo
       enddo
      enddo
      end subroutine isopycnic_add_div_gm





#ifdef notdef

      subroutine isopycnic_write_krit_init
      use spflame_module
      use isopycnic_module
      implicit none
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer :: ncid,iret,lat_tdim,lon_tdim,itimedim
      integer :: dims(4),lon_tid,lat_tid,itimeid,kritid
      real :: spval=-9.9e12
      character name*24, unit*16, text*80

      if (my_pe==0) then
        print*,' Writing krit to  NetCDF output file '
        ncid = nccre ('krit.cdf', NCCLOB, iret)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        call store_info_cdf(ncid)
c       dimensions
        lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
        Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
        iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c       grid variables
        dims(1)  = Lon_tdim
        Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,dims,iret)
        dims(1)  = Lat_tdim
        Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
        dims(1)  = iTimedim
        iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
c       attributes of the grid
        name = 'Longitude on T grid     '; unit = 'degrees_W       '
        call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Latitude on T grid      '; unit = 'degrees_N       '
        call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
        name = 'Time                    '; unit = 'days            '
        call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
        call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
        call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c       variables
        dims=(/lon_tdim,lat_tdim,itimedim,1/)
        kritid=ncvdef (ncid,'krit', NCFLOAT,3,dims,iret)
        call dvcdf(ncid,kritid,'Kriterium',9,' ',1,spval)
        call ncendf(ncid, iret)
        call ncvpt(ncid, Lon_tid, 1, imt,xt, iret)
        call ncvpt(ncid, Lat_tid, 1, jmt,yt, iret)
        call ncclos (ncid, iret)
      endif
#endif
      end subroutine isopycnic_write_krit_init

      subroutine isopycnic_write_krit
      use spflame_module
      use isopycnic_module
      implicit none
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer :: ncid,iret,npe
      integer :: kritid,itdimid,m,start(4),count(4),itimeid
      real :: spval=-9.9e12,fxa

      do npe=0,n_pes
       call barrier
       if (my_pe==npe) then

        iret=nf_open('krit.cdf',NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_varid(ncid,'krit',kritid)
        iret=nf_inq_varid(ncid,'Time',itimeid)

        iret=nf_inq_dimid(ncid,'Time',itdimid)
        iret=nf_inq_dimlen(ncid, itdimid,m)
        if (my_pe==0) then
         m=m+1
         call read_stamp(current_stamp,fxa)
         print*,' at stamp=',current_stamp,
     &          ' (days since origin : ',fxa,')',
     &          ' (time steps in file : ',m,')'
         iret= nf_put_vara_real (ncid,itimeid,m,1,fxa)
        endif
        start=(/is_pe,js_pe,m,1/)
        count=(/ie_pe-is_pe+1,je_pe-js_pe+1,1,1/)
        iret=nf_put_vara_real(ncid,kritid,start,count,
     &           krit(is_pe:ie_pe,js_pe:je_pe))
        call ncclos (ncid, iret)
       endif
       call barrier
      enddo
#endif
      end subroutine isopycnic_write_krit

#endif

#include "options.inc"

      program nc_test
c=======================================================================
c    test netcdf utility functions
c=======================================================================
      implicit none
      integer :: imt=10,jmt=12,km=5,itm=3
      real,parameter :: version = 0.1
#include "netcdf.inc"
      integer :: iret,ncout,dims(4),i,ncin
      integer :: lon_tdim,lat_tdim,depth_tdim,itimedim
      integer :: lon_tid,lat_tid,depth_tid,itimeid,varid
      character (len=80) :: fname = 'nc_test.cdf',name,unit
      real          , allocatable :: v2(:)
      character(len=32) :: stamp

      print'(" This is nc_test.x :: version ",f5.3)',version

       
      print*,' creating file ',fname(1:len_trim(fname))
      ncout = nccre (fname, NCNOCLOB, iret)
      if (iret /=0 ) goto 110
      iret=nf_set_fill(ncout, NF_NOFILL, iret)

      lon_tdim  = ncddef(ncout, 'Longitude_t', imt, iret)
      Lat_tdim  = ncddef(ncout, 'Latitude_t',  jmt, iret)
      depth_tdim= ncddef(ncout, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncout, 'Time', nf_unlimited, iret)
c      grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncout,'Longitude_t',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncout,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncout,'Time',       NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncout,'depth_t', NCFLOAT,1,dims,iret)
c       attributes of the grid
      name = 'Longitude on T grid     '; unit = 'degrees_W       '
      call ncaptc(ncout, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncout, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncout, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncout, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncout, depth_tid, 'long_name',NCCHAR, 24, name, iret) 
      call ncaptc(ncout, depth_tid, 'units',    NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncout, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncout, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncout, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c       variables
      dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
      varid=ncvdef (ncout,'test', NCFLOAT,4,dims,iret)
      name='Explicit vertical diffusivity'; unit = 'cm**2/s'
      call ncaptc(ncout, varid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncout, varid, 'units',    NCCHAR, 16, unit, iret) 
      call ncendf(ncout, iret)

      allocate( v2(max(imt,jmt,km)) )
      do i=1,max(imt,jmt,km)
       v2(i)=i
      enddo
      iret= nf_put_vara_real (ncout,lon_tid, 1,imt,v2)
      iret= nf_put_vara_real (ncout,lat_tid, 1,jmt,v2)
      iret= nf_put_vara_real (ncout,depth_tid, 1,km,v2)

      stamp ='m/d/y= 1/ 1/1900, h:m:s= 0: 0: 0' 
      call read_stamp(stamp,v2(1))
      iret= nf_put_vara_real (ncout,itimeid, 1,1,v2)

      deallocate(v2)
      allocate( v2(imt*jmt*km) )
      v2=5.2
      iret=nf_put_vara_real(ncout,varid,(/1,1,1,1/),(/imt,jmt,km,1/),v2)

      call ncclos (ncout, iret)




      print*,' reading file ',fname(1:len_trim(fname))
      iret=nf_open(fname,NF_NOWRITE,ncin)

      name='test'

      fname='nc_test2.cdf'
      print*,' creating file ',fname(1:len_trim(fname))
      ncout = nccre (fname, NCNOCLOB, iret)
      call copy_variable(ncin,ncout,name,.false.,0)
      iret = nf_enddef(ncout)

      call add_to_variable(ncin,ncout,name)
      call mult_variable(ncout,name,2.0)

      call ncclos (ncout, iret)
      call ncclos (ncin, iret)


      print*,'all done, bye'
      stop

 110  print*,' problem opening NetCDF file ',fname(1:len_trim(fname))
      print*,' netcdf lib says: ',nf_strerror(iret)
      stop
      end program nc_test



c   dummy routines

      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"
c
c-----------------------------------------------------------------------
c      Templates for hardwired grid, topography, surface boundary
c      and initial concitions.
c-----------------------------------------------------------------------
c

      subroutine grid_template()
c-----------------------------------------------------------------------
c     set up a grid here
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      real :: dx=0.,dy=0.,dz=0.,x0=0.,y0=0.,sumt,sumu
      integer i,k

#ifdef notdef
c
c     vertical grid same as in FLAME
c
      logical :: flame_grid = .true.
      integer,parameter :: km_in = 45
      real ddz(km_in)
      data ddz/ 
     &  1000.0,   1044.051, 1102.236, 1169.269, 1246.635, 1336.169,
     &  1440.147, 1561.417, 1703.569, 1871.169, 2070.068, 2307.849,
     &  2594.425, 2992.892, 3518.793, 4100.175, 4863.114, 5680.496,
     &  6513.772, 7038.668, 7397.827, 7758.212, 8130.866, 8726.499,
     &  9576.454,10908.060,12732.562,15187.976,18426.63,
     &  22000.,  24182.902,24817.098, 13*250.00e2 /
#endif

c#ifdef notdef
c
c     equidistant vertical grid
c
      logical :: flame_grid = .false.
      integer,parameter :: km_in = 50
      real ddz(km_in)
      data ddz/ 50*20.e2/
c#endif
c
c     horizontal grid
c
c      midlatidude basin
c      x0=280.; y0=30.; dx = 50./jmt; dy = dx*cos(y0/180.*pi)
c
c     equatorial basin
c      x0=280.; dx=2.;dy=2.; y0=-jmt/2.*dy + dy/2.
c
c     small eddy resolving region
c      x0=280.; y0=30.; dx = 1./3.; dy = dx*cos(y0/180.*pi)
      x0=280.; y0=-15.0; dx = 1./3.; dy = dx

      if (my_pe==0) then
        print*,''
        print*,'setting up a simple grid '
        print*,' dx= ',dx,' dy= ',dy
        print*,''
      endif
      dxtdeg =  dx  ; dytdeg =  dy  ; dxudeg =  dx  ; dyudeg =  dy  
      xt(1)=x0; xu(1)=x0+dxtdeg(1)/2.
      do i=2,imt
        xt(i)=xt(i-1)+dxtdeg(i); xu(i)=xu(i-1)+dxudeg(i)
      enddo
      yt(1)=y0; yu(1)=y0+dytdeg(1)/2.
      do i=2,jmt
        yt(i)=yt(i-1)+dytdeg(i); yu(i)=yu(i-1)+dyudeg(i)
      enddo
      if (my_pe==0 .and. flame_grid) then
        print*,''
        print*,' using vertical FLAME grid'
        print*,''
      endif
      if (km /= km_in ) then
        print*,' km must be ',km_in
        stop
      endif
      dzt=ddz; dzw(1) = dzt(1); sumt = dzt(1)
      sumu = 0.5*dzt(1) + dzw(1)
      do i=2,km
       sumt = sumt + dzt(i)
       dzw(i) = 2*(sumt-sumu)
       sumu = sumu + dzw(i)
      enddo
      zt(1) = 0.5*dzt(1); zw(1) = dzt(1)
      do i=2,km
        zw(i) = zw(i-1) + dzt(i); zt(i) = zt(i-1) + dzw(i-1)
      enddo
      dzw(0)  = zt(1); dzw(km) = zw(km) - zt(km)
      end subroutine grid_template





      subroutine kmt_template
c-----------------------------------------------------------------------
c     set up a simple topography
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      integer :: i,j,indp
      real :: hy,hcm

c     flat bottom
      kmt_big=km

#ifdef notdef
      do i=1,imt
       do j=1,jmt
          hy = (j-1.)/(jmt-1.)
          hcm=( zw(km)-zw(km)/2.* exp(- (xt(i)-xt(imt/2+1))**2/2.**2 ))
          kmt_big(i,j) = indp (hcm, zw, km)
       enddo
      enddo
#endif

#ifdef notdef
c     a ridge 
      do i=1,imt
       do j=1,jmt
          hy = (j-1.)/(jmt-1.)
          hcm=( 5500-3000.* exp(- (xt(i)-xt(imt/2+1))**2/15.**2 ) )*100.
          kmt_big(i,j) = indp (hcm, zw, km)
       enddo
      enddo
#endif

#ifdef notdef
c     a  north-south slope
      do i=1,imt
       do j=1,jmt
          hy = (j-1.)/(jmt-1.)
          hcm=(5500.0-5500.0/2*hy)*100.
          kmt_big(i,j) = indp (hcm, zw, km)
       enddo
      enddo
#endif

#ifdef notdef
c       a slope at the western boundary
        kmt_big(2,:)=indp(200*100.,zw,km)
        kmt_big(3,:)=indp(200*100.,zw,km)
        kmt_big(4,:)=indp(1000*100.,zw,km)
        kmt_big(5,:)=indp(2000*100.,zw,km)
        kmt_big(6,:)=indp(3000*100.,zw,km)
        kmt_big(7,:)=indp(4000*100.,zw,km)
#endif

      end subroutine kmt_template




      subroutine htp_template
c-----------------------------------------------------------------------
c     set up a simple topography for partial cells
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      integer :: i,j,indp
      real :: hy,hcm

       htp=0.
       do i=1,imt
        do j=1,jmt
           if (kmt_big(i,j)>0)  htp(i,j)=zw(kmt_big(i,j))
        enddo
       enddo

#ifdef notdef
c       a ridge 
        htp=0.; kmt_big=0
        do i=2,imt-1
         do j=2,jmt-1
          htp(i,j)=5500-3000.* exp(- (xt(i)-xt(imt/2+1))**2/15.**2 )
          htp(i,j)=htp(i,j)*100.
          kmt_big(i,j) = indp (htp(i,j), zw, km)
          if (zw( kmt_big(i,j) ) < htp(i,j) )
     &       kmt_big(i,j) = kmt_big(i,j)+1
         enddo
        enddo
#endif
c
#ifdef notdef
c       flat bottom
        kmt_big(2:imt-1,2:jmt-1)=km
        htp(2:imt-1,2:jmt-1) = zw(km)
#endif
      end subroutine htp_template




      subroutine init_cond_template
c-----------------------------------------------------------------------
c     setup simple initial conditions
c     for temperature, salinity and velocity
c     Note that streamfunction is diagnosed from full velocities.
c-----------------------------------------------------------------------
      use spflame_module
      use freesurf_module
      implicit none
      integer :: i,j,k,io
      real    :: baru(is_pe:ie_pe)
      real    :: Bv0,T0,g,stoe,x,y,z,h_W
      integer :: ii,jj,kk,indp
      real :: delta = 0.0e-13 ! 1/s /cm
      real :: u_y   = 5.0e-6  ! 1/s
      real :: u_0   = 0.0     ! cm/s
      real :: u_z   = 1.0e-3  ! 1/s
      real :: amp   = 0.1     ! cm/s
      real :: tscl   = 1.0/(3.0*86400.0)   ! 1/s
      real :: Bvsqr(km)
      namelist /equat/ delta,u_y,u_0,u_z,Bv0,amp,h_W,tscl

c#ifdef notdef
c-----------------------------------------------------------------------
c     inertial instability
c-----------------------------------------------------------------------
      g=9.81e2 ! cm/s^2
      Bv0 = 0.002 ! 1/s
      h_W = 300.0e2

      call getunit(io,'namelist.equat','fsr' )
      read(io, nml = equat )
      close(io)

      Bvsqr(1)= Bv0**2*dzw(0)
      do k=2,km
       Bvsqr(k)= Bvsqr(k-1)+Bv0**2*exp(-zw(k-1)/h_W) *dzw(k-1)
      enddo

      do j=js_pe,je_pe
        do k=1,km
         do i=is_pe,ie_pe
           y=yu(j)* radius/180.0*pi  ! in centimeters
           u(i,k,j,1,:) = u_0 + u_y*y+ delta*y*y/2.0 
c     &       + u_z*zt(k)
     &       + amp*(sin(  zt(k)/120.0e2  *2*pi)
     &       +      sin(  zt(k)/220.0e2  *2*pi)
     &       +      sin(  zt(k)/320.0e2  *2*pi)
     &       +      sin(  zt(k)/420.0e2  *2*pi)
     &       +      sin(  zt(k)/520.0e2  *2*pi)
     &       +      sin(  zt(k)/620.0e2  *2*pi)  )
c           u(i,k,j,1,:) = min(u(i,k,j,1,:),20.0)
c           u(i,k,j,1,:) = max(u(i,k,j,1,:),-20.0)

           u(i,k,j,2,:) = 0.   

           y     =  yt(j)* radius/180.0*pi  ! in centimeters
           t(i,k,j,1,:) = 20.0+rho0/(g*alpha_lin)*Bvsqr(k)
           t(i,k,j,2,:) = 0.   ! salinity equals 35 PSU

           t(i,k,j,1,:) = t(i,k,j,1,:)*tmask(i,k,j)
           t(i,k,j,2,:) = t(i,k,j,2,:)*tmask(i,k,j)
           u(i,k,j,1,:) = u(i,k,j,1,:)*umask(i,k,j)
           u(i,k,j,2,:) = u(i,k,j,2,:)*umask(i,k,j)

         enddo 
        enddo
      enddo

c#endif

#ifdef notdef
c
c-----------------------------------------------------------------------
c       a constant background stratification (const N^2)
c-----------------------------------------------------------------------
c
         Bv0 = 0.0026; T0=20.0; g=9.81; 
c         Bv0 = 0.0015; T0=20.0; g=9.81; 
c         Bv0=0. ! no stratification

         do j=js_pe,je_pe
          do k=1,km
           do i=is_pe,ie_pe
            t(i,k,j,2,:) = 0.   ! salinity equals 35 PSU
            h_W = 500.
            x=(float(i)/float(imt)-0.5)*2.
            y=(float(j)/float(jmt)-0.5)*2.

c        no pertubation
            stoe = 0. 
c        a small but large scale gaussian pertubation
c            stoe = 0.5*exp(-(x-0.5)**2*10.)*exp(-(y)**2*10.)
c        a greater large scale gaussian pertubation
c            stoe = 20.*exp(-(x-0.5)**2*10.)*exp(-(y)**2*10.)
c        a meridional gradient with a small pertubation
c            stoe = 4.*y+0.2*exp(-(x-0.5)**2/0.01)*exp(-(y)**2/0.01)
            T0=20.0
#ifdef partial_cell
            T0 = T0+stoe*exp(-ztp(i,k,j)/100. /h_W )
            t(i,k,j,1,:) = T0+1/(g*alpha_lin)*ztp(i,k,j)/100.*Bv0**2
#else
            T0 = T0+stoe*exp(-zt(k)/100. /h_W )
            t(i,k,j,1,:) = T0+1/(g*alpha_lin)*zt(k)/100.*Bv0**2
#endif
            t(i,k,j,1,:) = t(i,k,j,1,:)*tmask(i,k,j)

c            u(i,k,j,1,:) = 30. ! cm/s
c            u(i,k,j,2,:) = 0.  ! cm/s

           enddo 
          enddo
         enddo
#endif
c
#ifdef notdef
c-----------------------------------------------------------------------
c        A mesoscale front
c-----------------------------------------------------------------------
c
         Bv0 = 0.0000; T0=20.0; g=9.81; 
         do j=js_pe,je_pe
          do k=1,km
           do i=is_pe,ie_pe
            t(i,k,j,2,:) = 0.   ! salinity equals 35 PSU
            x=float(i)/float(imt)
            y=zt(km)/100.
            h_w = y/2.+tanh( (x-0.5)/0.3 )*y/5.
            T0=20 + 1.-tanh( (zt(k)/100.-h_w)/(y/5.)  )
            t(i,k,j,1,:) = T0+1/(g*alpha_lin)*zt(k)/100.*Bv0**2
            t(i,k,j,1,:) = t(i,k,j,1,:)*tmask(i,k,j)
           enddo 
          enddo
         enddo
#endif

#ifdef notdef
c
c-----------------------------------------------------------------------
c        Dammbruch exp.
c-----------------------------------------------------------------------
c
         ii = indp(330.5,xt,imt) 
         jj = indp(66.0,yt,jmt) 
         do j=js_pe,je_pe
          do k=1,km
           do i=is_pe,ie_pe
            t(i,k,j,2,:) = 0.   ! salinity equals 35 PSU
            if (j>=jj .and. i>=ii .and. k>=17) then
c            if (k>=17) then
              t(i,k,j,1,:) = 0.   
            else
              t(i,k,j,1,:) = 5.
            endif
           enddo
          enddo
         enddo
#endif


c-----------------------------------------------------------------------
c        barotropic mode
c-----------------------------------------------------------------------

         if (enable_freesurf) then
c
c         set the free surface
c
#ifdef notdef
          ubar=0.
          do j=js_pe,je_pe
           do i=is_pe,ie_pe
            y=(float(j)/float(jmt)-0.5)*2.
            etat(i,j,:)=0.
            if (j<jmt/2) etat(i,j,:)= 50.
            T0= model_dens_scalar(
     &           t(i,1,j,1,tau), t(i,1,j,2,tau),1
#ifdef partial_cell
     &                       ,ztp(i-1,1,j)
#endif
     &                       )
            ps(i,j,:) = etat(i,j,1)*grav*T0/rho0
           enddo
          enddo
#endif

         else ! enable_freesurf
c
c        diagnose streamfunction from full velocities
c        (works only for du/dx=0)
c
         psi = 0.0
         do j=js_pe,je_pe
c         depth integrated velocity
          baru=0.
          do k=1,km
           do i=is_pe,ie_pe
            baru(i) = baru(i) + u(i,k,j,1,0)*umask(i,k,j)
#ifdef partial_cell
     &                                    *dhu(i,k,j)
#else
     &                                    *dzt(k)
#endif
           enddo
          enddo
c         local integrant
          do i=is_pe,ie_pe
            psi(i,j+1,1) = -dyu(j)*baru(i)*umask(i,1,j)
          enddo
         enddo
         call border_exchg(psi(:,:,1),1,1)
         call set_cyclic(  psi(:,:,1),1,1)
c        Meridionally integrate psiu.
         do j=js_pe,je_pe
          do i=is_pe,ie_pe
            psi(i,j,1) = psi(i,j,1) + psi(i,j-1,1)
            psi(i,j,2) = psi(i,j,1) 
          enddo
         enddo
        endif ! enable_freesurf

      end subroutine init_cond_template



      subroutine sbc_template
c-----------------------------------------------------------------------
c     setup simple surface boundary conditions
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      integer :: i,j,k,is,ie,js,je
      real            :: y,x

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

c     no wind stress      
      smf=0.

#ifdef notdef
c     cosine shaped zonal wind stress
      do j=js,je
       do i=is,ie
          y = (yu(j)-yu(1))/ (yu(jmt)*1.0-yu(1)) ! cosine shaped wind stress
          smf(i,j,1) =-0.6*cos(2*pi*y)*umask(i,1,j) ! in taux only
          smf(i,j,2) =0.
       enddo
      enddo
#endif

#ifdef notdef
c       zonal wind stress in western part of domain, El Nino setup
	is=1;   is=max(is,is_pe)
	ie = nint(imt/6.) ; ie = min(ie,ie_pe)
 	if (is<=ie) smf(is:ie,js:je,1)=-0.5*umask(is:ie,1,js:je)
        is=max(is_pe,2); ie=min(ie_pe,imt-1)
#endif

c#ifdef notdef
c       no heat or salt fluxes
        stf_clim=0.
        stf_rest=0.
c#endif


#ifdef notdef
c       restoring to a profile
        do j=js,je
         do i=is,ie
c          y = (yt(j)-yt(1))/ (yt(jmt)*1.0-yt(1))
          y = ((j-1.)/(jmt-1.)-0.5)*2/1000.*2 ! this is a density -2:2, rho/alpha=  T
          stf_clim(i,j,1)=20.+y/alpha_lin
          stf_clim(i,j,2)=0.        ! 35 psu for flame density
          stf_rest(i,j,:)=1./(10.*86400.)*dzt(1)  ! 10 days
         enddo
        enddo
#endif
#ifdef notdef
c       restoring to a profile
        do j=js,je
         do i=is,ie
c        stf=stf_rest*(stf_clim-t)
          y = (yt(j)-yt(1))/ (yt(jmt)*1.0-yt(1))
          stf_clim(i,j,1)=t(i,1,j,1,taum1)+1
          stf_rest(i,j,1)=-500.*(y-0.5)/41868.
c          stf_clim(i,j,2)=t(i,1,j,2,taum1)+1.
c          stf_rest(i,j,2)=-5e-6
         enddo
        enddo
#endif

c       no wind stirring
        do j=js,je
         do i=is,ie
          if (enable_ktmix.or.enable_tkemix) ustar(i,j)=0.     ! no wind stirring
         enddo
        enddo

      end subroutine sbc_template



      subroutine blue_template
c-----------------------------------------------------------------------
c     setup simple temp / salinity arrays for BLUE
c-----------------------------------------------------------------------
      use spflame_module
      use blue_module
      implicit none
      integer :: i,j,k,is,ie,js,je
      real :: Bv0,T0,g
      real :: temp(is_pe-1:ie_pe+1), salt(is_pe-1:ie_pe+1)

#ifdef notdef
      is=max(1,is_pe-1); ie = min(imt,ie_pe+1)
      js=max(1,js_pe-1); je = min(jmt,je_pe+1)
c
c-----------------------------------------------------------------------
c     a constant background stratification (const N^2)
c-----------------------------------------------------------------------
c
      blue_p1 = 1
      blue_p2 = 2
      blue_f1 = 0.5
      blue_f2 = 0.5

      Bv0 = 0.0026; T0=20.0; g=9.81; 
      do j=js,je
       do k=1,km
         do i=is,ie
            salt(i) = 0.   ! salinity equals 35 PSU
#ifdef partial_cell
            temp(i) = T0+1/(g*alpha_lin)*ztp(i,k,j)/100.*Bv0**2
#else
            temp(i) = T0+1/(g*alpha_lin)*zt(k)/100.*Bv0**2
#endif
            temp(i) = temp(i)*tmask(i,k,j)
         enddo 
         call model_dens(temp(is), salt(is),
     &                  blue_rho(is,k,j,blue_p1),k,ie-is+1
#ifdef partial_cell
     &                       ,ztp(is,k,j)
#endif
     &                       )
       enddo
      enddo
      blue_rho(:,:,:,blue_p2)=blue_rho(:,:,:,blue_p1)
#endif

      end subroutine blue_template



      subroutine sponge_template(n)
c-----------------------------------------------------------------------
c     setup simple sponge layers. 
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      integer, intent(in) :: n ! number of the tracer
      logical, save :: init = .true.

      integer :: i,j,k,io,is,ie,js,je
      real :: y,z,fx,tstar
      real,save :: g   = 9.81e2 ! cm/s^2
      real,save :: Bv0 = 0.002 ! 1/s
      real,save :: h_W = 300.0e2
      real,save :: delta = 0.0e-13 ! 1/s /cm
      real,save :: u_y   = 5.0e-6  ! 1/s
      real,save :: u_0   = 0.0     ! cm/s
      real,save :: u_z   = 1.0e-3  ! 1/s
      real,save :: amp   = 0.1     ! cm/s
      real,save,allocatable :: Bvsqr(:)
      real,save :: tscl   = 1.0/(3.0*86400.0)   ! 1/s

      namelist /equat/ delta,u_y,u_0,u_z,Bv0,amp,h_W,tscl

c-----------------------------------------------------------------------
c     inertial instability
c-----------------------------------------------------------------------

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      if (init) then

       call getunit(io,'namelist.equat','fsr' )
       read(io, nml = equat )
       close(io)
       allocate(Bvsqr(km))

       Bvsqr(1)= Bv0**2*dzw(0)
       do k=2,km
        Bvsqr(k)= Bvsqr(k-1)+Bv0**2*exp(-zw(k-1)/h_W) *dzw(k-1)
       enddo
       init = .false.
      endif

      if (n==1) then
       do j=js,je
        do k=1,km
         do i=is,ie
           y     =  yt(j)* radius/180.0*pi  ! in centimeters
           fx    =  (cori(i,j-1,1)+cori(i,j,1))/2.0
           tstar = 20.0+rho0/(g*alpha_lin)*(Bvsqr(k)-fx*u_z*y)
           source(i,k,j)=source(i,k,j)+
     &        tscl*(tstar-t(i,k,j,n,taum1))*tmask(i,k,j)
         enddo 
        enddo
       enddo
      endif

      end subroutine sponge_template

#include "options.inc"

c
c-----------------------------------------------------------------------
c   Templates to read streamfunction for open boundaries
c   from external files.
c
c   Notes:
c      two subroutines are defined at the moment: 
c       "read_psi_south" and "read_psi_north"
c      Borth called by prep_obc (in prep_main.F)
c      psi should be in cm^3/s = 1e-12 Sv
c      Header of subroutines should not be touched.
c      CPP directives are set in prep_template.F
c
c                            c.eden  nov 2002
c-----------------------------------------------------------------------
c
       subroutine read_psi_south(psi,kmt,imt)
       implicit none
       integer, intent(in) :: imt, kmt(imt)
       real                :: psi(12,imt)
       integer             :: n,i

#if defined read_psi_for_E1 ||defined read_psi_for_E7
       character (len=80) :: name
       character (len=32) :: stamp
       integer,parameter :: imtf=263,imtuf=348
       integer :: j,k
       real (kind=4) psiD3(imtuf),dpm
       name='data/PSI/D3_psi_south.mom'
       print*,' reading streamfct data from file ',name
       open(10,file=name,form='unformatted')
c      read data from FLAME D grid
       read(10) ! awi_id 
       do n=1,12
        read(10) ! iotext 
        read(10) stamp,dpm,i,j,k,psiD3(1:imtf)
c       unfold
        do i=imtf-1,imtuf
         psiD3(i)=psiD3(i-imtf+2)
        enddo
c       transfer to FLAME E grid
        do i=1,imt
         psi(n,i)=(psiD3(i*4)+psiD3(i*4-1)+psiD3(i*4-2)+psiD3(i*4-3))/4.
         if (kmt(i)==0) psi(n,i)=0.
        enddo
       enddo
       close(10)
#elif defined read_psi_for_D3 || defined read_psi_for_D4
       character (len=80) :: name
       character (len=32) :: stamp
       integer,parameter :: imtf=263,imtuf=348
       integer :: j,k
       real (kind=4) psiD3(imtuf),dpm
       name='data/PSI/D3_psi_south.mom'
       print*,' reading streamfct data from file ',name
       open(10,file=name,form='unformatted')
c      read data from FLAME D grid
       read(10) ! awi_id 
       do n=1,12
        read(10) ! iotext 
        read(10) stamp,dpm,i,j,k,psiD3(1:imtf)
c       unfold
        do i=imtf-1,imtuf
         psiD3(i)=psiD3(i-imtf+2)
        enddo
c       transfer
        do i=1,imt
         psi(n,i)=psiD3(i)
         if (kmt(i)==0) psi(n,i)=0.
        enddo
       enddo
       close(10)
#elif defined read_psi_for_HS2 || defined read_psi_for_HS3 || defined read_psi_for_HS4
       character (len=80) :: name
       character (len=32) :: stamp
       integer,parameter :: imtf=1021,imtuf=1394
       integer :: j,k
       real (kind=4) psiD3(imtuf),dpm
       name='data/PSI/H2_psi_south.mom'
       print*,' reading streamfct data from file ',name
       call sub_flush(6)
       open(10,file=name,form='unformatted')
c      read data from FLAME D grid
       read(10) ! awi_id 
       do n=1,12
        read(10) ! iotext 
        read(10) stamp,dpm,i,j,k,psiD3(1:imtf)
c       unfold
        do i=imtf-1,imtuf
         psiD3(i)=psiD3(i-imtf+2)
        enddo
c       transfer
        do i=1,imt
         psi(n,i)=psiD3(i)
         if (kmt(i)==0) psi(n,i)=0.
        enddo
       enddo
       close(10)
#elif defined read_psi_for_K1
       character (len=80) :: name
       name='data/PSI/K1_psi_south.dat'
       print*,' reading streamfct data from file ',name
       open(10,file=name,form='formatted')
       do n=1,12
        read(10,*) (psi(n,i),i=1,imt)
       enddo
       close(10)
c      convert to model units
       psi=psi*1e12
#elif defined read_psi_for_Q1
       character (len=80) :: name
       name='data/PSI/Q1_psi_south.dat'
       print*,' reading streamfct data from file ',name
       open(10,file=name,form='formatted')
       do n=1,12
        read(10,*) (psi(n,i),i=1,imt)
       enddo
       close(10)
c      convert to model units
       psi=psi*1e12
#endif
c
c      make sure that boundary cond. for psi  is met
c
       do n=1,12
        do i=2,imt-1
         if (kmt(i)>0 .and. kmt(i-1) ==0) psi(n,i)=0.
         if (kmt(i)>0 .and. kmt(i+1) ==0) psi(n,i)=0.
        enddo
       enddo
       end subroutine read_psi_south




       subroutine read_psi_north(psi,kmt,imt)
       implicit none
       integer, intent(in) :: imt, kmt(imt)
       real                :: psi(12,imt)
       integer             :: n,i

#ifdef read_psi_for_Q1
       character (len=80) :: name
       name='data/PSI/Q1_psi_north.dat'
       print*,' reading streamfct data from file ',name
       open(10,file=name,form='formatted')
       do n=1,12
        read(10,*) (psi(n,i),i=1,imt)
       enddo
       close(10)
c      convert to model units
       psi=psi*1e12
#elif defined read_psi_for_D4
       character (len=80) :: name
       real :: x
       name='data/PSI/D4_psi_north.dat'
       print*,' reading streamfct data from file ',name
       open(10,file=name,form='formatted')
       do n=1,12
        read(10,*) (psi(n,i),i=1,imt)
       enddo
       close(10)
c      care about transports near coast
       do i=232,244
        x= (i-232.0)/12.0
c        psi(:,i) = psi(:,i)*exp( - (1.0-x)*10.0 )
        psi(:,i) = psi(:,i)*x
       enddo
c      enhance transports artifically
       psi=psi*2.0

       do i=335,346
        x= (i-335.0)/11.0
        psi(:,i) = psi(:,i)*(1.0-x)
       enddo
c      convert to model units
       psi=psi*1e12
#elif defined read_psi_for_E7
       character (len=80) :: name
       real :: x
       name='data/PSI/E7_psi_north.dat'
       print*,' reading streamfct data from file ',name
       open(10,file=name,form='formatted')
       do n=1,12
        read(10,*) (psi(n,i),i=1,imt)
       enddo
       close(10)
c      care about transports near coast
       psi(:,59)= 0.0
       psi(:,60)=-2.0
c      enhance transports artifically
       psi=psi*2.0
c      convert to model units
       psi=psi*1e12
#elif defined read_psi_for_HS3
       character (len=80) :: name
#include "netcdf.inc"
       integer :: iret,ncid,vid
#ifdef netcdf_real4
      real (kind=4) :: sp,v4(imt)
#else
      real          :: sp,v4(imt)
#endif
      real :: x

       name='data/PSI/HS3_psi_north.cdf'
       print*,' reading streamfct data from file ',name
       call sub_flush(6)
       iret=nf_open(name,NF_nowrite,ncid)
       if (iret/=0) then; print*,nf_strerror(iret);stop;endif
       iret=nf_inq_varid(ncid,'psi',vid)
       iret= nf_get_att_real (ncid,vid ,'missing_value',sp)
       do n=1,12
        iret= nf_get_vara_real(ncid,vid,(/1,9,n/),(/imt,1,1/),v4)
        where ( v4 == sp ) v4=0.0
        psi(n,:)=v4
       enddo
       call ncclos (ncid, iret)
c      care about transports near coast
       psi=min(0.0,psi) 
       do i=1350,1390
        x= (i-1350.0)/40.0
        psi(:,i) = psi(:,i)*(1.0-x)
       enddo
       psi(:,1390:imt)=0.0
c      convert to model units
       psi=psi*1e12

#elif defined read_psi_for_LS1
       character (len=80) :: name
       real :: x
       name='data/PSI/LS1_psi_north.dat'
       print*,' reading streamfct data from file ',name
       open(10,file=name,form='formatted')
       do n=1,12
        read(10,*) (psi(n,i),i=1,imt)
       enddo
       close(10)
c      care about transports near coast
       do i=582,627
        x= (i-582.0)/(627.0-582.0)
        psi(:,i) = psi(:,i)*x
       enddo
c      enhance transports artifically
       psi=psi*2.0

       do i=995,1040
        x= (i-995.0)/(1040.-995)
        psi(:,i) = psi(:,i)*(1.0-x)
       enddo
c      convert to model units
       psi=psi*1e12

#elif defined read_psi_for_HS4
       character (len=80) :: name
       real :: x
       name='data/PSI/HS4_psinorth_j2.dat'
       print*,' reading streamfct data from file ',name
       open(10,file=name,form='formatted')
       do n=1,12
        read(10,*) (psi(n,i),i=1,imt)
       enddo
       close(10)
c      care about transports near coast
       do i=931,976
        x= (i-931.0)/(976.0-931.0)
        psi(:,i) = psi(:,i)*x
       enddo
c      enhance transports artifically
       psi=psi*2.0

       do i=1344,1389
        x= (i-1344.0)/(1389.0-1344.0)
        psi(:,i) = psi(:,i)*(1.0-x)
       enddo
c      convert to model units
       psi=psi*1e12
#elif defined read_psi_for_A1
c     ACC model
       character (len=80) :: name
       real :: x
       name='data/PSI/nonmae.dat'
       print*,' reading streamfct data from file ',name
c       open(10,file=name,form='formatted')
c       do n=1,12
c        read(10,*) (psi(n,i),i=1,imt)
c       enddo
c       close(10)
c      care about transports near coast

c      convert to model units
       psi=0*psi*1e12

#endif
c
c      make sure that boundary cond. for psi  is met
c
       do n=1,12
        do i=2,imt-1
         if (kmt(i)>0 .and. kmt(i-1) ==0) psi(n,i)=0.
         if (kmt(i)>0 .and. kmt(i+1) ==0) psi(n,i)=0.
        enddo
       enddo
       end subroutine read_psi_north

#include "options.inc"


      subroutine prep_grid
      use prep_module
      implicit none

      integer,parameter :: maxlen = 2000
      real :: dxtdeg_t(maxlen),dxudeg_t(maxlen)
      real :: dytdeg_t(maxlen),dyudeg_t(maxlen)
      real :: dzt_t(maxlen),dzw_t(0:maxlen)
      real :: yt_t(maxlen),yu_t(0:maxlen)
c
c     FLAME vertical grid
      integer, parameter :: km_flame = 45
      real dz_flame(km_flame)
      data dz_flame/ 
     &  1000.0,   1044.051, 1102.236, 1169.269, 1246.635, 1336.169,
     &  1440.147, 1561.417, 1703.569, 1871.169, 2070.068, 2307.849,
     &  2594.425, 2992.892, 3518.793, 4100.175, 4863.114, 5680.496,
     &  6513.772, 7038.668, 7397.827, 7758.212, 8130.866, 8726.499,
     &  9576.454,10908.060,12732.562,15187.976,18426.63,
     &  22000.,  24182.902,24817.098, 13*250.00e2 /
  
c   POP 1/10 deg vertical grid
      integer, parameter :: km_pop = 40
      real dz_pop(km_pop)
      data dz_pop/ 
     &   10.01244e+2, 10.11258e+2, 10.31682e+2, 10.6333e+2, 11.0751e+2, 
     &   11.6615e+2, 12.4193e+2, 13.3861e+2, 14.6140e+2, 16.1756e+2,
     &   18.1737e+2, 20.7556e+2, 24.1368e+2, 28.6382e+2, 34.7464e+2,
     &   43.2086e+2, 55.1681e+2, 72.3046e+2, 96.7490e+2, 130.039e+2,
     &   170.049e+2, 207.993e+2, 233.569e+2, 245.272e+2, 248.980e+2,
     &   249.832e+2, 249.979e+2, 249.998e+2, 250.000e+2, 250.000e+2,
     &   250.000e+2, 250.000e+2, 250.000e+2, 250.000e+2, 250.000e+2,
     &   250.000e+2, 250.000e+2, 250.000e+2, 250.000e+2, 250.000e+2  /

      integer i,j,n,m,k
      integer :: nbpts =2
      real :: offset=0.
      real :: stretch_x=1.0, stretch_y=1.0,stretch_z=1.0
      real :: num=0.,tolr=1.e-5,dxubar,dyubar,dzwbar,zz
      real sumt,sumu

      print*,''
      print*,' Setting up the grid'
      print*,''
      if (centered_t) then 
         print*,' T grid points are centered in their boxes'
         print*,' while U grid points are uncentered'
         print*,' Note that this is non-standard in MOM2'
      else
         print*,' U grid points are centered in their boxes'
         print*,' while T grid points are uncentered'
         print*,' This is standard setting in MOM2'
      endif

      if (read_grid_topo) then

       call  read_grid_bin()

      else
c
c-----------------------------------------------------------------------
c     Calculate resolution in longitude. Add one boundary cell at the
c     start and end of the domain so that calculations are meaningful
c     for grid cells i=2,imt-1
c-----------------------------------------------------------------------
c
      nbpts = 2
      write (6,'(/a,i1,a)')
     & ' Generating the longitudinal resolution ( ', nbpts
     &, ' extra boundary points will be used).'
c
c     convert negative longitudes (degrees west of Greenwich) to
c     positive longitudes
c
      do n=1,nxlon
        if (x_lon(n) < 0.0) then
          offset = 360.0
        endif
      enddo
      if (offset > 0.0) then
          write (6,'(/,a/,a/,a)')
     &    '=>Warning: adding 360.0 degrees to all longitudes to convert'
     &,   '           negative values (degrees west of Greenwich) to'
     &,   '           positive values (degrees east of Greenwich)'
      endif
      x_lon = x_lon + offset
c
c     if a region contains the greenwich meridian, compensate by adding
c     360.0 degrees to all remaining regions
c
      do n=2,nxlon
        if (x_lon(n-1) >  x_lon(n)) then
          x_lon(n) = x_lon(n) + 360.0
          write (6,'(/,a,i1,a,a/)')
     &    ' Warning: adding 360.0 degrees to x_lon(',n,')'
     &,   ' to insure region boundaries increase monotonically'
        endif
      enddo
c
c     if width of domain exceeds 360.0 deg... limit width to 360.0
c
      if (x_lon(nxlon) - x_lon(1) .gt. 360.0) then
        write (6,'(/a,a,g14.7/)')
     &  '=>Warning: Domain width exceeds 360 deg. Restricting last'
     &, ' x_lon to ',x_lon(1)+360.0
          do n=1,nxlon
            write (6,'(i3,f10.5)') n, x_lon(n)
          end do
      endif
      if (x_lon(nxlon) - x_lon(1) .eq. 360.0) then
        if (dx_lon(nxlon) .ne. dx_lon(1)) then
          write (6,'(/a,a)')
     &    '=>Error: dx_lon(1) must equal dx_lon(last) when domain'
     &,   ' width = 360.0 degrees'
          stop
        endif
      endif

      if (centered_t) then
       call gcell_centered_t (maxlen, nxlon, x_lon,  dx_lon, nbpts,
     &           imt, dxtdeg_t, dxudeg_t, stretch_x,0,tol_gcell )
      else
       call gcell (maxlen, nxlon, x_lon,  dx_lon, nbpts,
     &           imt, dxtdeg_t, dxudeg_t, stretch_x,0,tol_gcell )
      endif

      allocate( dxtdeg(imt), dxudeg(imt), xt(imt), xu(imt))
      dxtdeg=dxtdeg_t(1:imt)
      dxudeg=dxudeg_t(1:imt)
c
c-----------------------------------------------------------------------
c     Build the longitudinal grid points for a "B" grid
c     (account for an extra boundary point at the start)
c-----------------------------------------------------------------------
c
      xt(1) = x_lon(1) - 0.5*dx_lon(1)
      xu(1) = x_lon(1)
c
      do i=2,imt
        xu(i) = xu(i-1) +  dxtdeg(i)
        xt(i) = xt(i-1) +  dxudeg(i-1)
      enddo
c
c-----------------------------------------------------------------------
c     Calculate resolution in latitude. Add one boundary cell at the
c     start and end of the domain so that calculations are meaningful
c     for grid cells jrow=2,jmt-1
c-----------------------------------------------------------------------
c
      nbpts = 2
      write (6,'(/a,i1,a)')
     & ' Generating the latitudinal resolution ( ', nbpts
     &, ' extra boundary points will be used).'
c
c     if width of domain exceeds 180.0 deg... limit width to 180.0
c
      if (y_lat(nylat) - y_lat(1) .gt. 180.0) then
        write (6,'(/a,a,g14.7/)')
     &  '=>Warning: Latitudinal domain width exceeds 180 deg.'
     &, ' Restricting last y_lat to ',y_lat(1)+180.0
      endif

      if (isotropic) then

        print*,' constructing a Mercator grid '
c
c       this subroutine from MOM 3 seem to be buggy
c
c       call iso_grid (maxlen, nylat, y_lat, dy_lat, jmt, 
c     &                dytdeg_t, dyudeg_t, yt_t, yu_t)
c       allocate( dytdeg(jmt), dyudeg(jmt), yt(jmt), yu(jmt))
c       dytdeg=dytdeg_t(1:jmt)
c       dyudeg=dyudeg_t(1:jmt)
c       yt=yt_t(1:jmt)
c       yu=yu_t(1:jmt)
c      bugfix
c       if (yu(jmt) == 0) yu(jmt)=yu(jmt-1)+dyudeg(jmt)

c
c      use the old MOM2 routine here
c
       if (centered_t) then
        call isotro_centered_t(maxlen, nylat, y_lat, dy_lat, 
     &                 jmt, dytdeg_t, dyudeg_t)
       else
        call sub_isotro(maxlen, nylat, y_lat, dy_lat, 
     &                  jmt, dytdeg_t, dyudeg_t)
       endif
       allocate( dytdeg(jmt), dyudeg(jmt), yt(jmt), yu(jmt))
       dytdeg=dytdeg_t(1:jmt); dyudeg=dyudeg_t(1:jmt)
       yu(1) = y_lat(1) + dytdeg(1)
       yt(1) = y_lat(1) + dy_lat(1)
       do j=2,jmt
        yu(j) = yu(j-1) +  dytdeg(j)
        yt(j) = yt(j-1) +  dyudeg(j-1)
        if (abs(yu(j)).lt.1.0e-10)  yu(j) = 0.0
       enddo

      else

       do n=2,nylat
        if (y_lat(n-1) .gt. y_lat(n)) then
          write (6,'(/,a,/a/)')
     &    ' =>Error: latitude boundaries must increase monotonically'
     &,   '          check the specifications in the USER INPUT section'
          do m=1,nylat
            write (6,'(i3,f10.5)') m, y_lat(m)
          end do
          stop
        endif
       enddo

      if (centered_t) then
       call gcell_centered_t (maxlen, nylat, y_lat, dy_lat, nbpts,
     &            jmt, dytdeg_t, dyudeg_t, stretch_y,0,tol_gcell)
      else
       call gcell (maxlen, nylat, y_lat, dy_lat, nbpts,
     &            jmt, dytdeg_t, dyudeg_t, stretch_y,0,tol_gcell)
       endif

       allocate( dytdeg(jmt), dyudeg(jmt), yt(jmt), yu(jmt))
       dytdeg=dytdeg_t(1:jmt)
       dyudeg=dyudeg_t(1:jmt)
c
c-----------------------------------------------------------------------
c     Build the latitudinal grid points on a "B" grid
c     (account for an extra boundary point at the start)
c-----------------------------------------------------------------------
c
       yt(1) = y_lat(1) - 0.5*dy_lat(1)
       yu(1) = y_lat(1)
       do j=2,jmt
        yu(j) = yu(j-1) +  dytdeg(j)
        yt(j) = yt(j-1) +  dyudeg(j-1)
       enddo

      endif 

c
c-----------------------------------------------------------------------
c     Calculate resolution in depth. No boundary cells added here so
c     calculations are meaningful for k=1,km. Allow the bottom region 
c     to be stretched further if desired.
c-----------------------------------------------------------------------
c
      if (flame_vert_grid) then
       km=km_flame
       allocate( dzt(km), dzw(0:km), zt(km), zw(km))
       dzt(1:km)=dz_flame
       dzw(1) = dzt(1)
       sumt = dzt(1)
       sumu = 0.5*dzt(1) + dzw(1)
       do i=2,km
        sumt = sumt + dzt(i)
        dzw(i) = 2*(sumt-sumu)
        sumu = sumu + dzw(i)
       enddo
       zt(1) = 0.5*dzt(1)
       zw(1) = dzt(1)
       do i=2,km
        zw(i) = zw(i-1) + dzt(i)
        zt(i) = zt(i-1) + dzw(i-1)
       enddo
       dzw(0)  = zt(1)
       dzw(km) = zw(km) - zt(km)
      elseif (pop_vert_grid) then
       km=km_pop ! POP is t centered 
       allocate( dzt(km), dzw(0:km), zt(km), zw(km))
       do k=1,km
        dzt(k)=dz_pop(k)
       enddo
       sumt = 0.0
       do k=1,km-1
        dzw(k) = 0.5*(dzt(k+1) + dzt(k))
        sumt = sumt + dzt(k)
       enddo
       dzw(km) = .5*(dzt(km))
       sumt = sumt + dzt(km)
       zt(1) = .5*dzt(1)
       zw(1) = dzt(1)
       do k=2,km
        zw(k) = zw(k-1) + dzt(k)
        zt(k) = zt(k-1) + dzw(k-1)
       enddo
       dzw(0)  = zt(1)
       dzw(km) = zw(km) - zt(km)
      else
       nbpts = 0
       write (6,'(/a,i1,a)')
     & ' Generating the vertical resolution ( ', nbpts
     &, ' extra boundary points will be used).'
       do n=2,nzdepth
        if (z_depth(n-1) .gt. z_depth(n)) then
          write (6,'(/,a,/a/)')
     &    ' =>Error: depth boundaries must increase monotonically'
     &,   '          check the specifications in the USER INPUT section'
          stop
        endif
       enddo

      if (centered_t) then
       call gcell_centered_t(maxlen, nzdepth, z_depth, dz_depth, nbpts,
     &            km, dzt_t, dzw_t(1), stretch_z,0,tol_gcell)
      else
       call gcell(maxlen, nzdepth, z_depth, dz_depth, nbpts,
     &            km, dzt_t, dzw_t(1), stretch_z,0,tol_gcell)
      endif

       allocate( dzt(km), dzw(0:km), zt(km), zw(km))
       dzt=dzt_t(1:km)
       dzw=dzw_t(0:km)
c
c-----------------------------------------------------------------------
c     Build the vertical grid points on a "B" grid. The T and U
c     cells are staggered in the horizontal but at the same level in
c     the vertical. However, the W cells here refer to the vertical
c     advection velocities at the bottoms of the U and T cells.
c     (no extra boundary point at the start)
c-----------------------------------------------------------------------
c
       zt(1) = z_depth(1) + 0.5*dz_depth(1)
       zw(1) = z_depth(1) + dzt(1)
       do k=2,km
        zw(k) = zw(k-1) + dzt(k)
        zt(k) = zt(k-1) + dzw(k-1)
       enddo
c
c     set W cell thickness at surface and bottom to ocean part of cell
c
       dzw(0)  = zt(1)
       dzw(km) = zw(km) - zt(km)
      endif
c
c-----------------------------------------------------------------------
c     Check if the T grid resolution is an average of the
c     U cell resolution. This insures more accurate advection of
c     tracers within a stretched grid.
c-----------------------------------------------------------------------
c
      tolr=1.e-5
      write (6,'(/)')
      do i=2,imt-1
        dxubar = 0.5*(dxudeg(i) + dxudeg(i-1))
        if (abs(dxubar-dxtdeg(i)) .gt. tolr) then
          num = num + 1
          write (6,'(a,i5,a)')
     &    '=>Warning: T cell delta x at i=',i
     &,   ' is not an average of adjacent U cell delta x`s'     
        endif     
      enddo
c
      do j=2,jmt-1
        dyubar = .5*(dyudeg(j) + dyudeg(j-1))
        if (abs(dyubar-dytdeg(j)) .gt. tolr) then
          num = num + 1
          write (6,'(a,i5,a)')
     &    '=>Warning: T cell delta y at jrow=',j
     &,   ' is not an average of adjacent U cell delta y`s' 
        endif     
      enddo
c
      tolr = 1.e0
      do k=2,km-1
        dzwbar = 0.5*(dzw(k) + dzw(k-1))
        if (abs(dzwbar-dzt(k)) .gt. tolr) then
          num = num + 1
          write (6,'(a,i5,a)')
     &    '=>Warning: T cell delta z at k=',k
     &,   ' is not an average of adjacent W cell delta z`s'     
        endif     
      enddo

      endif ! read_grid_topo 
c
c-----------------------------------------------------------------------
c     write the old mom output file
c-----------------------------------------------------------------------
c
      call write_grid_bin()
c
c-----------------------------------------------------------------------
c     Print all grid coordinates
c-----------------------------------------------------------------------
c
      zz = 0.0
      write (6
     &,'(//,40x,a,//,a,g14.7,a,/a/,a,g14.7,a/a,/,a,g14.7,a/)') 
     &  ' Grid Point Coordinate details: '
     &, ' The western edge of the T-cell at i=2 is at:'
     &,  xu(1),' (deg) longitude',' (the 1st T-cell is a boundary cell)'
     &, ' The southern edge of the T-cell at jrow=2 is at:'
     &,  yu(1),' (deg) latitude',' (the 1st T-cell is a boundary cell)'
     &,' The top edge of the T-cell at k=1 is at z =',zz,' (cm)'
      write (6,'(a,i4,a,g14.7,a/a,i4,a)') 
     & ' The eastern edge of the T-cell at i=',imt-1,' is at:'
     &,  xu(imt-1),' (deg) longitude'
     &,' (the last T-cell (imt=',imt,') is a boundary cell)'
     &, ' The northern edge of the T-cell at jrow=',jmt-1,' is at:'
     &,  yu(jmt-1),' (deg) latitude'
     &,' (the last T-cell (jmt=',jmt,') is a boundary cell)'
     &,' The bottom edge of T-cell at k=',km,' is at z ='
     &,  zw(km),' (cm)'
      write (6,'(/,a,g14.7,a/a/,a,g14.7,a/a/,a,g14.7,a/)') 
     &  ' The western edge of the U-cell at i=2 is at:', xt(1)
     &, ' (deg) longitude',' (the 1st U-cell is a boundary point)'
     &, ' The southern edge of the U cell at jrow=1 is at:', yt(1)
     &, ' (deg) latitude',' (the 1st U cell is a boundary point)'
     &, ' The top edge of the W-cell at k=1 is at z =',zt(1),' (cm)'
      write (6,'(a,i4,a,g14.7,a/a,i4,a)') 
     & ' The eastern edge of the U-cell at i=',imt-1,' is at:'
     &,  xt(imt),' (deg) longitude'
     &,' (the last U-cell (imt=',imt,') is a boundary cell)'
     &, ' The northern edge of the U-cell at jrow=',jmt-1,' is at:'
     &,  yt(jmt),' (deg) latitude'
     &,' (the last U-cell (jmt=',jmt,') is a boundary cell)'
     &,' The bottom edge of W-cell at k=',km,' is at z ='
     &,  zw(km),' (cm)'
      write (6,9103) km
      write (6,9002) (zt(k),k=1,km)
      write (6     ,9104) km
      write (6     ,9002) (zw(k),k=1,km)
      write (6     ,9105) jmt
      write (6     ,9001) (yt(j),j=1,jmt)
      write (6     ,9106) jmt
      write (6     ,9001) (yu(j),j=1,jmt)
      write (6     ,9107) imt
      write (6     ,9001) (xt(i),i=1,imt)
      write (6     ,9108) imt
      write (6     ,9001) (xu(i),i=1,imt)

      print*,' '
      print*,' grid generation done ...'
      print*,' '

9001  format (1x,10f10.4)
9002  format (1x,10f10.2)
9101  format (/,  a,i4,' in units of ',a,' as follows:')
9103  format (/,' Depth to T & U grid points (cm): zt(k) k=1,',i3)
9104  format (/,' Depth to W grid points (cm): zw(k) k=1,',i3)
9105  format (/,' Latitude of T points (deg): yt(j) j=1,',i4)
9106  format (/,' Latitude of U points (deg): yu(j) j=1,',i4)
9107  format (/,' Longitude of T points (deg): xt(i) i=1,',i4)
9108  format (/,' Longitude of U points (deg): xu(i) i=1,',i4)


      end 
      




      subroutine gcell (maxlen, n_bounds, bounds, d_bounds, nbpts
     &,                 num, deltat, deltau, stretch,my_pe,tol_in)
c
c=======================================================================
c
c              G R I D   C E L L   C O N S T R U C T I O N
c
c     A domain is composed of one or more regions:
c     Build "num" T  cells with resolution "deltat(n) n=1,num" 
c     within the domain composed of regions bounded by "bounds".
c     Also construct "num" U  cells of resolution "deltau(n) n=1,num"
c     with the relation between T and U cells given by:
c     deltat(n) = 0.5*(deltau(n-1) + deltau(n))
c     Resolution may be constant or smoothly varying within each
c     region AND there must be an integral number of grid cells within 
c     each region. The domain is the sum of all regions.
c
c     inputs:
c
c     maxlen   = maximum length of "deltat" and "deltau"
c     n_bounds = number of bounds needed to define the regions
c     bounds   = latitude, longitude, or depth at each bound
c     d_bounds = delta (resolution) at each of the "bounds"
c     nbpts    = number of extra boundary cells to add to the domain.
c                (usually one at the beginning and end)
c     stretch  = stretching factor for last region (should only be used
c                in the vertical to provide increased stretching of grid
c                points. "stretch" = 1.0 gives no increased stretching.
c                "stretch" = 1.2 gives increased stretching...etc
c             
c     outputs:
c
c     num    = total number of grid cells within the domain
c     deltau = resolution of U grid cells: n=1,num
c     deltat = resolution of T grid cells: n=1,num
c
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c=======================================================================
c
      implicit none
      integer stdout,maxlen,n_bounds,num,nbpts,my_pe
      parameter( stdout=6)
      real deltat(maxlen), deltau(maxlen)
      real d_bounds(n_bounds), bounds(n_bounds), stretch,tol_in

      logical keep_going
      double precision p5,pi ,avg_res, chg_res, tol, wid, an
      double precision del,d_new,sum
      integer l,n,i,ierr,m
c
c     Set some constants
c
      p5 = 0.5d0
      pi = 4.0d0*atan(1.0d0)
c
c     Do all regions, one at a time, to construct the domain
c
      num  = 1
      do l=1,n_bounds-1
c
       if (my_pe == 0) 
     &  write (stdout,'(2x,a,i2,a,g14.7,a,g14.7,a,g14.7,a,g14.7,a)')
     & ' region # ',l,'  going from ',bounds(l),' (res=',d_bounds(l)
     &,') to ',  bounds(l+1),' (res=',d_bounds(l+1),')' 
c
c       avg_res = average resolution of T cells within region
c       chg_res = change in resolution across the region
c       wid     = width of region
c       tol     = tolerance for fitting T cels within region width
c
c       provide for stretching last region if needed
c
        if (l .eq. n_bounds-1) then
          avg_res = p5*(d_bounds(l) + stretch*d_bounds(l+1))
          chg_res = (stretch*d_bounds(l+1) - d_bounds(l))
        else
          avg_res = p5*(d_bounds(l) + d_bounds(l+1))
          chg_res = (d_bounds(l+1) - d_bounds(l))
        endif
c
c
c       had to change this ...
c        tol = 1.d-3
c      all the time
        tol=tol_in
c
        wid = abs(bounds(l+1) - bounds(l))
        an  = wid/avg_res
        m   = nint(an)
c
c       Calculate resolution of U cells: "deltau"
c       U grid points will be centered in these cells
c       n = number of T cells fitting within the region boundaries
c       note: "sum" initially discounts half of the U cells widths
c       at the boundaries
c
        sum = p5*d_bounds(l) - p5*d_bounds(l+1)
        n   = 0
        i = 0
        keep_going = .true.
        do while (i .le. 100000 .and. keep_going)
          i = i + 1
          del = avg_res - p5*chg_res*cos((pi/m)*i)
          if (sum + del .le. wid*(1.0d0 + tol)) then
            sum = sum + del
            if (num+i-1 .gt. maxlen) then
              write (stdout,*) "=>Error: maxlen exceeded in gcell. "
     &,                        " ...increase size of maxlen"
             stop
            endif
            deltau(num+i-1) = del
            n = n + 1
          else
            keep_going = .false.
          endif
        enddo 

        if (l .eq. n_bounds-1 .and. stretch .ne. 1.0) then
       if (my_pe == 0) 
     &    write (stdout,'(a,i3,a,f5.2)')
     & '    constructed ',n,' cells with a stretch factor of ', stretch
       if (my_pe == 0) 
     &    write (stdout,'(/2(a,g14.7),/2(a,g14.7),/a,a/)')
     &    'Note: you specified the ocean bottom at ',bounds(l+1)
     &,   ' cm with a bottom cell thickness of ',d_bounds(l+1)
     &,   '      The stretch factor puts the bottom at ',bounds(l)+sum
     &,   ' cm with a bottom cell thickness of '
     &,   p5*(deltau(num+n-1) + deltau(num+n-2))
     &,   '      Adjust "stretch_z" in subroutine "gcoord" to get'
     &,   ' closer to the desired specifications if needed.'

        else
       if (my_pe == 0) 
     &    write (stdout,'(a,g14.7,a)')
     &   '    constructed ',an,' grid cells for this region'
       if (my_pe == 0) print*,' abs(an-n) = ',abs(an-n)
          if (abs(an-n) .gt. 0.01d0) then
       if (my_pe == 0) 
     &      write (stdout, '(/,a,i2,/,a,g14.7/,a,g14.7,a//a/a)')
     & '==>Error: non integral number of cells in region #',l
     &,'          average resolution within region =',avg_res
     &,'          this implies ',an,' grid cells'
     &,'          Change grid specifications within USER INPUT section'
     &,'          Here is some help...'
            d_new = (2.0*wid)/(n-1) - d_bounds(l)
       if (my_pe == 0) 
     &      write (stdout,'(/a,i4,a,i2,a,1pe14.7,a,1pe14.7/)')
     &      ' Note: to get ',n-1,' grid cells within region ',l
     &,     ', change resolution from ', d_bounds(l+1), ' to ', d_new
            d_new = (2.0*wid)/n - d_bounds(l)
       if (my_pe == 0) 
     &      write (stdout,'(/a,i4,a,i2,a,1pe14.7,a,1pe14.7/)')
     &      ' Note: to get ',n,' grid cells within region ',l
     &,     ', change resolution from ', d_bounds(l+1), ' to ', d_new
            d_new = (2.0*wid)/(n+1) - d_bounds(l)
       if (my_pe == 0) 
     &      write (stdout,'(/a,i4,a,i2,a,1pe14.7,a,1pe14.7/)')
     &      ' Note: to get ',n+1,' grid cells within region ',l
     &,     ', change resolution from ', d_bounds(l+1), ' to ', d_new
             stop
          endif
        endif
        num = num + n
      enddo
c
c     adjust "num" to reflect the total number of cells contained in
c     all regions
c
      num = num - 1
c
      do i=1,num
c
c       build resolution for T cells: "deltat". Note that
c       variable resolution (stretched grid) implies T points are
c       off center
c
        if (i .eq. 1) then
          deltat(i) = p5*(d_bounds(1) + deltau(i))
        else
          deltat(i) = p5*(deltau(i) + deltau(i-1))
        endif
      enddo     
c
c     add boundary points if needed
c
      if (nbpts .ne. 0) then
        do i=num,1,-1
          deltat(i+1) = deltat(i) 
          deltau(i+1) = deltau(i)
        enddo
        deltat(1)     = deltat(2)
        deltau(1)     = d_bounds(1)
        deltat(num+2) = deltat(num+1) 
        deltau(num+2) = deltau(num+1)
        num           = num + 2 
      endif
      end subroutine gcell





      subroutine gcell_centered_t 
     &                 (maxlen, n_bounds, bounds, d_bounds, nbpts
     &,                 num, deltat, deltau, stretch,my_pe,tol_in)
c
c=======================================================================
c
c              G R I D   C E L L   C O N S T R U C T I O N
c
c     A domain is composed of one or more regions:
c     Build "num" T  cells with resolution "deltat(n) n=1,num" 
c     within the domain composed of regions bounded by "bounds".
c     Also construct "num" U  cells of resolution "deltau(n) n=1,num"
c     with the relation between T and U cells given by:
c     deltau(n) = 0.5*(deltat(n+1) + deltat(n))
c     Resolution may be constant or smoothly varying within each
c     region AND there must be an integral number of grid cells within 
c     each region. The domain is the sum of all regions.
c
c     inputs:
c
c     maxlen   = maximum length of "deltat" and "deltau"
c     n_bounds = number of bounds needed to define the regions
c     bounds   = latitude, longitude, or depth at each bound
c     d_bounds = delta (resolution) at each of the "bounds"
c     nbpts    = number of extra boundary cells to add to the domain.
c                (usually one at the beginning and end)
c     stretch  = stretching factor for last region (should only be used
c                in the vertical to provide increased stretching of grid
c                points. "stretch" = 1.0 gives no increased stretching.
c                "stretch" = 1.2 gives increased stretching...etc
c             
c     outputs:
c
c     num    = total number of grid cells within the domain
c     deltau = resolution of U grid cells: n=1,num
c     deltat = resolution of T grid cells: n=1,num
c
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c=======================================================================
c
      implicit none
      integer stdout,maxlen,n_bounds,num,nbpts,my_pe
      parameter( stdout=6)
      real deltat(maxlen), deltau(maxlen)
      real d_bounds(n_bounds), bounds(n_bounds), stretch,tol_in

      logical keep_going
      double precision p5,pi ,avg_res, chg_res, tol, wid, an
      double precision del,d_new,sum
      integer l,n,i,ierr,m
c
c     Set some constants
c
      p5 = 0.5d0
      pi = 4.0d0*atan(1.0d0)
c
c     Do all regions, one at a time, to construct the domain
c
      num  = 1
      do l=1,n_bounds-1
c
       if (my_pe == 0) 
     &  write (stdout,'(2x,a,i2,a,g14.7,a,g14.7,a,g14.7,a,g14.7,a)')
     & ' region # ',l,'  going from ',bounds(l),' (res=',d_bounds(l)
     &,') to ',  bounds(l+1),' (res=',d_bounds(l+1),')' 
c
c       avg_res = average resolution of T cells within region
c       chg_res = change in resolution across the region
c       wid     = width of region
c       tol     = tolerance for fitting T cels within region width
c
c       provide for stretching last region if needed
c
        if (l .eq. n_bounds-1) then
          avg_res = p5*(d_bounds(l) + stretch*d_bounds(l+1))
          chg_res = (stretch*d_bounds(l+1) - d_bounds(l))
        else
          avg_res = p5*(d_bounds(l) + d_bounds(l+1))
          chg_res = (d_bounds(l+1) - d_bounds(l))
        endif
c
c
c       had to change this ...
c        tol = 1.d-3
c      all the time
        tol=tol_in
c
        wid = abs(bounds(l+1) - bounds(l))
        an  = wid/avg_res
        m   = nint(an)


c
c       Calculate resolution of "T" cells: "deltat". Note that
c       "T" grid points are centered in these cells (as in MOM 1)
c       n = number of "t" cells fitting within the region boundaries
c
        sum = 0.0
	n   = 0
        do i = 1,100000
	  if (m.le.1) m=2
	  del = avg_res - p5*chg_res*cos((pi/(m-1))*(i-1))
	  if (sum + del .le. wid*(1.0 + tol)) then
	    sum = sum + del
	    if (num+i-1 .gt. maxlen) then
	      write (stdout,*) "=>Error: maxlen exceeded in gcell. "
     &,                        " ...increase size of maxlen"
	      stop
	    endif
	    deltat(num+i-1) = del
	    n = n + 1
	  else
	    go to 100
	  endif
	enddo 
 100    continue


        if (l .eq. n_bounds-1 .and. stretch .ne. 1.0) then
       if (my_pe == 0) 
     &    write (stdout,'(a,i3,a,f5.2)')
     & '    constructed ',n,' cells with a stretch factor of ', stretch
       if (my_pe == 0) 
     &    write (stdout,'(/2(a,g14.7),/2(a,g14.7),/a,a/)')
     &    'Note: you specified the ocean bottom at ',bounds(l+1)
     &,   ' cm with a bottom cell thickness of ',d_bounds(l+1)
     &,   '      The stretch factor puts the bottom at ',bounds(l)+sum
     &,   ' cm with a bottom cell thickness of ',deltat(num+n-1)
     &,   '      Adjust "stretch_z" in subroutine "gcoord" to get'
     &,   ' closer to the desired specifications if needed.'

        else
       if (my_pe == 0) 
     &    write (stdout,'(a,g14.7,a)')
     &   '    constructed ',an,' grid cells for this region'
       if (my_pe == 0) print*,' abs(an-n) = ',abs(an-n)
          if (abs(an-n) .gt. 0.01d0) then
       if (my_pe == 0) 
     &      write (stdout, '(/,a,i2,/,a,g14.7/,a,g14.7,a//a/a)')
     & '==>Error: non integral number of cells in region #',l
     &,'          average resolution within region =',avg_res
     &,'          this implies ',an,' grid cells'
     &,'          Change grid specifications within USER INPUT section'
     &,'          Here is some help...'
            d_new = (2.0*wid)/(n-1) - d_bounds(l)
       if (my_pe == 0) 
     &      write (stdout,'(/a,i4,a,i2,a,1pe14.7,a,1pe14.7/)')
     &      ' Note: to get ',n-1,' grid cells within region ',l
     &,     ', change resolution from ', d_bounds(l+1), ' to ', d_new
            d_new = (2.0*wid)/n - d_bounds(l)
       if (my_pe == 0) 
     &      write (stdout,'(/a,i4,a,i2,a,1pe14.7,a,1pe14.7/)')
     &      ' Note: to get ',n,' grid cells within region ',l
     &,     ', change resolution from ', d_bounds(l+1), ' to ', d_new
            d_new = (2.0*wid)/(n+1) - d_bounds(l)
       if (my_pe == 0) 
     &      write (stdout,'(/a,i4,a,i2,a,1pe14.7,a,1pe14.7/)')
     &      ' Note: to get ',n+1,' grid cells within region ',l
     &,     ', change resolution from ', d_bounds(l+1), ' to ', d_new
             stop
          endif
        endif
        num = num + n
      enddo
c
c     adjust "num" to reflect the total number of cells contained in
c     all regions
c
      num = num - 1
c
      do i=1,num
c
c       build resolution for "u" cells: "deltau". Note that
c       variable resolution (stretched grid) implies "u" points are
c       off center as in MOM 1
c
        if (i .eq. num) then
          deltau(i) = d_bounds(n_bounds)
        else
	  deltau(i) = p5*(deltat(i+1) + deltat(i))
        endif
      enddo     
c
c     add boundary points if needed
c
      if (nbpts .ne. 0) then
        do i=num,1,-1
          deltat(i+1) = deltat(i) 
          deltau(i+1) = deltau(i)
        enddo
        deltat(1)     = deltat(2)
        deltau(1)     = d_bounds(1)
        deltat(num+2) = deltat(num+1) 
        deltau(num+2) = deltau(num+1)
        num           = num + 2 
      endif
      end subroutine gcell_centered_t





      subroutine iso_grid (maxlen, nylats, y_lat, dy_lat, jmt
     &,                    dytdeg, dyudeg, yt, yu)
c
c=======================================================================
c     compute latitude resolution of grid cells to match the convergence
c     of meridians.
c     
ce    Note: this routine was taken from MOM 3 and seems to be buggy
c     
c     inputs:
c
c     maxlen   = maximum length of "dytdeg" and "dyudeg"
c     nylats   = should equal 2 (defines one region)
c     dy_lat   = latitudinal resolution of grid cell on equator
c     y_lat(1) = southern boundary of the domain (it will be adjusted
c                to fit an integral number of cells)
c     y_lat(2) = northern boundary of the domain (it will be adjusted
c                to fit an integral number of cells)
c
c     outputs:
c
c     jmt  = number of grid cells
c     dytdeg = resolution of T cells (degrees)
c     dyudeg = resolution of U cells (degrees)
c     yt     = latitude of point within T cell (degrees)
c     yu     - latitude of point within U cell (degrees)
c
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c=======================================================================
c
      implicit none

      integer maxlen,nylats,jmt
      real y_lat(nylats), dy_lat(nylats)
      real dytdeg(maxlen), dyudeg(maxlen)
      real yt(maxlen), yu(maxlen)

      integer, parameter :: jmaxlat = 1000, lenjmax = 2*jmaxlat+1
      real dusq(-jmaxlat-1:jmaxlat+1), dtsq(-jmaxlat-1:jmaxlat+1)
      real usq(-jmaxlat-1:jmaxlat+1), tsq(-jmaxlat-1:jmaxlat+1)
      real y_bound(2), dy_bound(2)
c
      real pi, rrad
      integer n,n1,n2,j

      if (nylats .gt. 2) then
        write (6,'(/a,a/)')
     &  '=>Error: Must only have nylats=2 when option isotropic_grid'
     &,' is enabled'
        call abort()
      endif
      if (dy_lat(1) .ne. dy_lat(2)) then
        write (6,'(/a,a/)')
     &  '=>Error: dy_lat(1) must equal dy_lat(2) when option '
     &,' isotropic_grid is enabled'
        call abort()
      endif
      pi   = 4.0*atan(1.0)
      rrad = pi/180.0
c
c     build an isotropic grid
c
      usq(0)  = 0.0
      dusq(0) = dy_lat(1)
      tsq(1)  = 0.5*dusq(0)
      tsq(0)  = -tsq(1)
      dtsq(1) = dusq(0)*cos(tsq(1)*rrad)
      dtsq(0) = dtsq(1)
      do n=1,jmaxlat
        dusq(n)   = 2.0*dtsq(n) - dusq(n-1)
	usq(n)    = tsq(n) + 0.5*dusq(n)
	if (tsq(n) .lt. 90) then
	  tsq(n+1)  = tsq(n) + dusq(n)
	  dtsq(n+1) = dusq(0)*cos(tsq(n+1)*rrad)
	else
	  tsq(n+1)  = tsq(n)
	  dtsq(n+1) = 0.0
	endif
      enddo
      do n=-1,-jmaxlat,-1
        dusq(n) = dusq(-n)
	usq(n)  = -usq(-n)
	dtsq(n) = dtsq(-(n-1)) 
	tsq(n)  = -tsq(-(n-1))
      enddo
c
c     pick out cells between bounding latitudes
c
      n1 = -jmaxlat
      n2 = jmaxlat
      do n=-jmaxlat,jmaxlat
        if (usq(n) .lt. y_lat(1)) n1 = n
	if (usq(n) .lt. y_lat(2)) n2 = n+1
      enddo
c
c     re-define bounding latitudes to match isotropic boundaries
c
      y_lat(1) = usq(n1)
      y_lat(2) = usq(n2) 
c
      if (n1 .eq. -jmaxlat .or. n2 .eq. jmaxlat) then
        write (6,'(/a,a/)')
     &  '=>Error: Need to increase jmaxlat to reach the max latitude'
     &,' of the domain specified for option isotropic_grid.'
        call abort()
      endif

      jmt = n2 - n1 + 1
      do j=1,jmt
        dytdeg(j) = dtsq(j+n1-1)
	dyudeg(j) = dusq(j+n1-1)
        yu(j) = usq(j+n1-1)
        yt(j) = tsq(j+n1-1)
      enddo
      return
      end



      subroutine read_grid_bin()
      use prep_module
      implicit none
      integer  :: io,i,j,k
      character(len=80) :: FLAME_ID ='no flame id '

      real (kind=4), allocatable  :: xt4(:),xu4(:), yt4(:),yu4(:)
      real (kind=4), allocatable  :: zt4(:),zw4(:),dzt4(:),dzw4(:)
      real (kind=4), allocatable  :: dxtdeg4(:),dxudeg4(:)
      real (kind=4), allocatable  :: dytdeg4(:),dyudeg4(:)

      print*,' reading grid infos from file ',
     &       old_grid_file(1:len_trim(old_grid_file))

      call getunit(io,old_grid_file,'usr ieee')
      read (io) flame_id   ! this the the flame ID check
      read (io) imt, jmt, km

      allocate( dxtdeg(imt), dxudeg(imt), xt(imt), xu(imt))
      allocate( dytdeg(jmt), dyudeg(jmt), yt(jmt), yu(jmt))
      allocate( dzt(km), dzw(0:km), zt(km), zw(km))

      allocate( dxtdeg4(imt), dxudeg4(imt), xt4(imt), xu4(imt))
      allocate( dytdeg4(jmt), dyudeg4(jmt), yt4(jmt), yu4(jmt))
      allocate( dzt4(km), dzw4(0:km), zt4(km), zw4(km))

      read (io)(dxtdeg4(i),i=1,imt)
     &,        (dytdeg4(j),j=1,jmt)
     &,        (dxudeg4(i),i=1,imt)
     &,        (dyudeg4(j),j=1,jmt)
     &,        (dzt4(k),k=1,km)
     &,        (dzw4(k),k=0,km)
     &,        (xt4(i),i=1,imt)
     &,        (xu4(i),i=1,imt)
     &,        (yt4(j),j=1,jmt)
     &,        (yu4(j),j=1,jmt)
     &,        (zt4(k),k=1,km)
     &,        (zw4(k),k=1,km)
       close (io)

      dxtdeg=dxtdeg4; dxudeg=dxudeg4; xt= xt4; xu= xu4
      dytdeg=dytdeg4; dyudeg=dyudeg4; yt= yt4; yu= yu4
      dzt=dzt4; dzw= dzw4;zt= zt4; zw=zw4

      deallocate( dxtdeg4, dxudeg4, xt4, xu4)
      deallocate( dytdeg4, dyudeg4, yt4, yu4)
      deallocate( dzt4, dzw4, zt4, zw4)
      end subroutine


      subroutine write_grid_bin()
      use prep_module
      implicit none

      integer :: i,j,k,io
      character(len=80) :: FLAME_ID ='no flame id '
      real (kind=4) :: xt4(imt),xu4(imt), yt4(jmt),yu4(jmt)
      real (kind=4) :: zt4(km),zw4(km),dzt4(km),dzw4(0:km)
      real (kind=4) :: dxtdeg4(imt),dxudeg4(imt)
      real (kind=4) :: dytdeg4(jmt),dyudeg4(jmt)

      print*,' writing grid infos to file ',
     &       new_grid_file(1:len_trim(new_grid_file))

      dxtdeg4=dxtdeg; dxudeg4=dxudeg; xt4= xt; xu4= xu
      dytdeg4=dytdeg; dyudeg4=dyudeg; yt4= yt; yu4= yu
      dzt4=dzt; dzw4= dzw;zt4= zt; zw4=zw

      call getunit(io,new_grid_file,'usr ieee')
      write (io) flame_id   ! this the the flame ID check
      write (io) imt, jmt, km
      write (io) (dxtdeg4(i),i=1,imt)
     &,         (dytdeg4(j),j=1,jmt)
     &,         (dxudeg4(i),i=1,imt)
     &,         (dyudeg4(j),j=1,jmt)
     &,         (dzt4(k),k=1,km)
     &,         (dzw4(k),k=0,km)
     &,         (xt4(i),i=1,imt)
     &,         (xu4(i),i=1,imt)
     &,         (yt4(j),j=1,jmt)
     &,         (yu4(j),j=1,jmt)
     &,         (zt4(k),k=1,km)
     &,         (zw4(k),k=1,km)
       close (io)

       end subroutine



      subroutine sub_isotro(maxlen, n_bounds, bounds, d_bounds, 
     &                      num, deltat, deltau)
c
c=======================================================================
c
c Subroutine to determine the fine resolution DYNAMO-2 grid
c The ARAKAWA B grid is a mesh of velocity grid cells, with tracer
c points in the corners of a cell. The zonal width of a velocity grid
c cell dxu is given by the distance of the two surrounding meridians,
c while the meridional extent is given by the distance of the two 
c westernmost tracer points:
c
c      +->  T(i,j+1) -------------- T(i+1,j+1)
c      |    |                                |
c   dyu(j)  |              U(i,j)            |
c      |    |                                |
c      +->  T(i,j) ------------------ T(i+1,j)
c
c           ^                                ^
c           |                                |
c           +------------ dxu(i) ------------+
c
c
c There arises no problem from the zonal grid, because it is defined to
c be a regular third (or four third in the coarse resolution case) 
c degree grid. To yield an isotropic grid, the meridional extent of a 
c grid cell has to be a function of latitude. Let phi_s denote
c the southern edge of the gridcell, and phi_n the northern one. We are 
c now looking for the latitude phi_c of the center of the gridcell,
c which is defined by 
c
c  phi_s + 0.5*dyu = phi_c   ; dyu=dxu*cos(phi_c)      and thus
c  phi_s + 0.5*dxu*cos(phi_c) - phi_c = 0
c
c This equation will be solved by an iteration. We will start at the 
c Equator, proceeding north until bounds(2) is reached. Then, all until
c bounds(1) will be mirrored at the Equator.
c
c     The relation between "t" and "u" cells is given by:
c     deltat(n) = 0.5*(deltau(n-1) + deltau(n))
c
c     There must be an integral number of grid cells within 
c     the region to provide an easy switch between coarse and fine 
c     grid-resolution. 
c
c     inputs:
c
c     maxlen   = maximum length of "deltat" and "deltau"
c     n_bounds = number of bounds needed to define the regions
c     bounds   = latitude, longitude, or depth at each bound
c     d_bounds = delta (resolution) at the equator: d_bounds(1)
c     nbpts    = number of extra boundary cells to add to the domain.
c
c     outputs:
c
c     num      = total number of grid cells within the domain
c     deltau   = resolution of "u" grid cells: n=1,num
c     deltat   = resolution of "t" grid cells: n=1,num
c     bounds   = new latitude at each bound
c     d_bounds = resolution between yu(0) and yt(1): d_bounds(1)
c
c     author:      j.kroeger    e-mail=> jkroeger@ifm.uni-kiel.de
c=======================================================================
c
c
      implicit none
      integer :: nbpts = 0, stdout = 6, maxlen, n_bounds, num
      integer :: i,j,k,jmt,nrc,itc,nrs
      real :: hdtone,endlat,soubou,stlat,dummy,p5
      real deltat(maxlen), deltau(maxlen)
      real d_bounds(n_bounds), bounds(n_bounds)
      double precision dely(maxlen)
      double precision hdy0,pi,pifac,phi_n,phi_s,phi_c,abort,
     &                 hdcos,residual,dxt,dynew
c
      dummy=-9999.0
      dxt=d_bounds(1)
      hdy0=0.5*dxt         ! half dy cosine amplitude
      p5 = 0.5
      pi = 4.0*atan(1.0)
      pifac=pi/180.0
      nrc=0                ! gridcell counter
      abort=1.0d-12        ! should be small enough
      phi_n=hdy0           ! let`s start north of the Equator
  100 phi_s=phi_n          ! define new southern edge
      phi_c=phi_s+hdy0*dcos(phi_s*pifac)
      itc=0                ! iteration counter
  200 hdcos=hdy0*dcos(phi_c*pifac)
      residual=phi_c-hdcos-phi_s
      itc=itc+1            ! increase iteration counter 
      if(dabs(residual).lt.abort)then
       goto 300           ! fine, we did convergence
      else
       phi_c=phi_c-0.5*residual ! new estimate
       goto 200                 ! next iterative step
      endif
  300 phi_n=phi_s+2.0*hdcos     ! new northern edge
      nrc=nrc+1                 ! nr of grid cells
      dely(nrc)=2.0*hdcos
ce      if ((phi_c.ge.bounds(2)).and.(mod(nrc,4).eq.0)) goto 500
      if ((phi_c.ge.bounds(2))) goto 500
      goto 100
  500 continue
      phi_s=hdy0      ! hit northern edge, now look for southern
      nrs=0
      soubou=abs(bounds(1))
  600 nrs=nrs+1       ! number of tracer cells south of the Equator
      phi_c=phi_s+p5*dely(nrs)
      phi_s=phi_s+dely(nrs)
c      if((phi_c.ge.soubou).and.(mod(nrs,4).eq.0))goto 700
      if((phi_c.ge.soubou))goto 700
      goto 600
  700 continue
      stlat=-phi_c    ! hit southern edge
      do i=nrc,1,-1   ! shift northern hemisphere 
       dely(i+nrs)=dely(i)
      end do
      dely(nrs)=2*hdy0
      do i=1,nrs      ! mirror southern region at Equator
       dely(i)=dely(2*nrs-i)
      end do
      jmt=nrs+nrc
c      build resolution for "t" cells: "deltat".
      do j=1,jmt
       deltau(j)=dely(j)
      enddo
      deltat(1) = p5*(dely(2*nrs)+deltau(1))
      do i=2,jmt
       deltat(i) = p5*(deltau(i-1) + deltau(i))
      enddo
      hdtone=p5*deltau(2*nrs)  ! halfdeltatone
      write (stdout,'(a,g14.7,a)')
     &   '    constructed ',jmt,' meridional grid cells '
      endlat=stlat
      do j=1,jmt
        endlat=endlat+deltat(j)
      end do
      write (stdout,'(a,g14.7,a,g14.7)')
     &   ' startlatitude =    ',stlat,
     &   ' endlatitude   =    ',endlat
      bounds(1)=stlat
      bounds(2)=endlat
      d_bounds(1)=hdtone
      num=jmt
      end subroutine
c


      subroutine isotro_centered_t
     &   (maxlen, n_bounds, bounds, d_bounds,num, deltat, deltau)
c
c=======================================================================
c
c Subroutine to determine the fine resolution DYNAMO-2 grid
c The ARAKAWA B grid is a mesh of tracer grid cells, with velocity 
c points in the corners of a cell. The zonal width of a tracer grid
c cell dxt is given by the distance of the two surrounding meridians,
c while the meridional extent is given by the distance of the two 
c easternmost velocity points:
c
c      +->  U(i-1,j  ) ------------ U(i  ,j  )
c      |    |                                |
c   dyt(j)  |              T(i,j)            |
c      |    |                                |
c      +->  U(i-1,j-1) ------------ U(i  ,j-1)
c
c           ^                                ^
c           |                                |
c           +------------ dxt(i) ------------+
c
c There arises no problem from the zonal grid, because it is defined to
c be a regular third (or four third in the coarse resolution case) 
c degree grid. To yield an isotropic grid, the meridional extent of a 
c grid cell has to be a function of latitude. Let phi_s denote
c the southern edge of the gridcell, and phi_n the northern one. We are 
c now looking for the latitude phi_c of the center of the gridcell,
c which is defined by 
c
c  phi_s + 0.5*dyt = phi_c   ; dyt=dxt*cos(phi_c)      and thus
c  phi_s + 0.5*dxt*cos(phi_c) - phi_c = 0
c
c This equation will be solved by an iteration. We will start at the 
c Equator, proceeding north until bounds(2) is reached. Then, all until
c bounds(1) will be mirrored at the Equator.
c
c     The relation between "t" and "u" cells is given by:
c     deltau(n) = 0.5*(deltat(n+1) + deltat(n))
c
c     There must be an integral number of grid cells within 
c     the region to provide an easy switch between coarse and fine 
c     grid-resolution. 
c
c     inputs:
c
c     maxlen   = maximum length of "deltat" and "deltau"
c     n_bounds = number of bounds needed to define the regions
c     bounds   = latitude, longitude, or depth at each bound
c     d_bounds = delta (resolution) at the equator: d_bounds(1)
c     nbpts    = number of extra boundary cells to add to the domain.
c                (usually one at the beginning and end)
c     outputs:
c
c     num      = total number of grid cells within the domain
c     deltau   = resolution of "u" grid cells: n=1,num
c     deltat   = resolution of "t" grid cells: n=1,num
c     bounds   = new latitude at each bound
c     d_bounds = resolution between yu(0) and yt(1): d_bounds(1)
c
c     author:      j.kroeger    e-mail=> jkroeger@ifm.uni-kiel.de
c=======================================================================
c
      implicit none
      integer :: nbpts = 0, stdout = 6, maxlen, n_bounds, num
      integer :: i,j,k,jmt,nrc,itc,nrs
      real :: hdtone,endlat,soubou,stlat,dummy,p5
      real deltat(maxlen), deltau(maxlen)
      real d_bounds(n_bounds), bounds(n_bounds)
      double precision dely(maxlen)
      double precision hdy0,pi,pifac,phi_n,phi_s,phi_c,abort,
     &                 hdcos,residual,dxt,dynew
c
      dummy=-9999.0
      dxt=d_bounds(1)
      hdy0=0.5*dxt         ! half dy cosine amplitude
      p5 = 0.5
      pi = 4.0*atan(1.0)
      pifac=pi/180.0
      nrc=0                ! gridcell counter
      abort=1.0d-12        ! should be small enough
      phi_n=0.0            ! let`s start at the Equator
  100 phi_s=phi_n          ! define new southern edge
      phi_c=phi_s+hdy0*dcos(phi_s*pifac)
      itc=0                ! iteration counter
  200 hdcos=hdy0*dcos(phi_c*pifac)
      residual=phi_c-hdcos-phi_s
      itc=itc+1            ! increase iteration counter 
      if(dabs(residual).lt.abort)then
       goto 300           ! fine, we did convergence
      else
       phi_c=phi_c-0.5*residual ! new estimate
       goto 200                 ! next iterative step
      endif
  300 phi_n=phi_s+2.0*hdcos     ! new northern edge
      nrc=nrc+1                 ! nr of grid cells
      dely(nrc)=2.0*hdcos
      if ((phi_n.ge.bounds(2)).and.(mod(nrc,4).eq.0)) goto 500
      goto 100
  500 continue
      phi_s=0.0       ! hit northern edge, now look for southern
      nrs=0
      soubou=abs(bounds(1))
  600 nrs=nrs+1       ! number of tracer cells south of the Equator
      phi_c=phi_s+p5*dely(nrs)
      phi_s=phi_s+dely(nrs)
      if((phi_s.ge.soubou).and.(mod(nrs,4).eq.0))goto 700
      goto 600
  700 continue
      stlat=-phi_s    ! hit southern edge
      do i=nrc,1,-1   ! shift northern hemisphere 
       dely(i+nrs)=dely(i)
      end do
      dely(nrs)=2*hdy0
      do i=1,nrs      ! mirror southern region at Equator
       dely(i)=dely(2*nrs-i+1)
      end do
c
      jmt=nrs+nrc
c
c       build resolution for "u" cells: "deltau". Note that
c       variable resolution (stretched grid) implies "u" points are
c       off center as in MOM 1
c
      do j=1,jmt
       deltat(j)=dely(j)
      enddo
c
      hdtone=p5*deltat(1)  ! halfdeltatone
c
      do i=1,jmt-1
       deltau(i) = p5*(deltat(i+1) + deltat(i))
      enddo
      deltau(jmt) = deltat(jmt)
c
c
          write (stdout,'(a,g14.7,a)')
     &   '    constructed ',jmt,' meridional grid cells '
c
      endlat=stlat
      do j=1,jmt
        endlat=endlat+deltat(j)
      end do
c
          write (stdout,'(a,g14.7,a,g14.7)')
     &   ' startlatitude =    ',stlat,
     &   ' endlatitude   =    ',endlat
c
      bounds(1)=stlat
      bounds(2)=endlat
      d_bounds(1)=hdtone
      num=jmt
      end subroutine
c


      subroutine gcell_old (maxlen, n_bounds, bounds, d_bounds, nbpts
     &,                 num, deltat, deltau, stretch,my_pe)
c
c=======================================================================
c
c              G R I D   C E L L   C O N S T R U C T I O N
c
c     A domain is composed of one or more regions:
c     Build "num" T  cells with resolution "deltat(n) n=1,num" 
c     within the domain composed of regions bounded by "bounds".
c     Also construct "num" U  cells of resolution "deltau(n) n=1,num"
c     with the relation between T and U cells given by:
c     deltat(n) = 0.5*(deltau(n-1) + deltau(n))
c     Resolution may be constant or smoothly varying within each
c     region AND there must be an integral number of grid cells within 
c     each region. The domain is the sum of all regions.
c
c     inputs:
c
c     maxlen   = maximum length of "deltat" and "deltau"
c     n_bounds = number of bounds needed to define the regions
c     bounds   = latitude, longitude, or depth at each bound
c     d_bounds = delta (resolution) at each of the "bounds"
c     nbpts    = number of extra boundary cells to add to the domain.
c                (usually one at the beginning and end)
c     stretch  = stretching factor for last region (should only be used
c                in the vertical to provide increased stretching of grid
c                points. "stretch" = 1.0 gives no increased stretching.
c                "stretch" = 1.2 gives increased stretching...etc
c             
c     outputs:
c
c     num    = total number of grid cells within the domain
c     deltau = resolution of U grid cells: n=1,num
c     deltat = resolution of T grid cells: n=1,num
c
c     author:      r. c. pacanowski      e-mail=> rcp@gfdl.gov
c=======================================================================
c
      implicit none
      integer stdout,maxlen,n_bounds,num,nbpts,my_pe
      parameter( stdout=6)
      real deltat(maxlen), deltau(maxlen)
      real d_bounds(n_bounds), bounds(n_bounds), stretch

      logical keep_going
      double precision p5,pi ,avg_res, chg_res, tol, wid, an
      double precision del,d_new,sum
      integer l,n,i,ierr,m
c
c     Set some constants
c
      p5 = 0.5d0
      pi = 4.0d0*atan(1.0d0)
c
c     Do all regions, one at a time, to construct the domain
c
      num  = 1
      do l=1,n_bounds-1
c
       if (my_pe == 0) 
     &  write (stdout,'(2x,a,i2,a,g14.7,a,g14.7,a,g14.7,a,g14.7,a)')
     & ' region # ',l,'  going from ',bounds(l),' (res=',d_bounds(l)
     &,') to ',  bounds(l+1),' (res=',d_bounds(l+1),')' 
c
c       avg_res = average resolution of T cells within region
c       chg_res = change in resolution across the region
c       wid     = width of region
c       tol     = tolerance for fitting T cels within region width
c
c       provide for stretching last region if needed
c
        if (l .eq. n_bounds-1) then
          avg_res = p5*(d_bounds(l) + stretch*d_bounds(l+1))
          chg_res = (stretch*d_bounds(l+1) - d_bounds(l))
        else
          avg_res = p5*(d_bounds(l) + d_bounds(l+1))
          chg_res = (d_bounds(l+1) - d_bounds(l))
        endif
c
c
c       had to change this ...
c        tol = 1.d-5
        tol = 1.d-3
c
        wid = abs(bounds(l+1) - bounds(l))
        an  = wid/avg_res
        m   = nint(an)
c
c       Calculate resolution of U cells: "deltau"
c       U grid points will be centered in these cells
c       n = number of T cells fitting within the region boundaries
c       note: "sum" initially discounts half of the U cells widths
c       at the boundaries
c
        sum = p5*d_bounds(l) - p5*d_bounds(l+1)
        n   = 0
        i = 0
        keep_going = .true.
        do while (i .le. 100000 .and. keep_going)
          i = i + 1
          del = avg_res - p5*chg_res*cos((pi/m)*i)
          if (sum + del .le. wid*(1.0d0 + tol)) then
            sum = sum + del
            if (num+i-1 .gt. maxlen) then
              write (stdout,*) "=>Error: maxlen exceeded in gcell. "
     &,                        " ...increase size of maxlen"
              call halt_stop(' in gcell')
            endif
            deltau(num+i-1) = del
            n = n + 1
          else
            keep_going = .false.
          endif
        enddo 

        if (l .eq. n_bounds-1 .and. stretch .ne. 1.0) then
       if (my_pe == 0) 
     &    write (stdout,'(a,i3,a,f5.2)')
     & '    constructed ',n,' cells with a stretch factor of ', stretch
       if (my_pe == 0) 
     &    write (stdout,'(/2(a,g14.7),/2(a,g14.7),/a,a/)')
     &    'Note: you specified the ocean bottom at ',bounds(l+1)
     &,   ' cm with a bottom cell thickness of ',d_bounds(l+1)
     &,   '      The stretch factor puts the bottom at ',bounds(l)+sum
     &,   ' cm with a bottom cell thickness of '
     &,   p5*(deltau(num+n-1) + deltau(num+n-2))
     &,   '      Adjust "stretch_z" in subroutine "gcoord" to get'
     &,   ' closer to the desired specifications if needed.'

        else
       if (my_pe == 0) 
     &    write (stdout,'(a,g14.7,a)')
     &   '    constructed ',an,' grid cells for this region'
       if (my_pe == 0) print*,' abs(an-n) = ',abs(an-n)
          if (abs(an-n) .gt. 0.01) then
       if (my_pe == 0) 
     &      write (stdout, '(/,a,i2,/,a,g14.7/,a,g14.7,a//a/a)')
     & '==>Error: non integral number of cells in region #',l
     &,'          average resolution within region =',avg_res
     &,'          this implies ',an,' grid cells'
     &,'          Change grid specifications within USER INPUT section'
     &,'          Here is some help...'
            d_new = (2.0*wid)/(n-1) - d_bounds(l)
       if (my_pe == 0) 
     &      write (stdout,'(/a,i4,a,i2,a,1pe14.7,a,1pe14.7/)')
     &      ' Note: to get ',n-1,' grid cells within region ',l
     &,     ', change resolution from ', d_bounds(l+1), ' to ', d_new
            d_new = (2.0*wid)/n - d_bounds(l)
       if (my_pe == 0) 
     &      write (stdout,'(/a,i4,a,i2,a,1pe14.7,a,1pe14.7/)')
     &      ' Note: to get ',n,' grid cells within region ',l
     &,     ', change resolution from ', d_bounds(l+1), ' to ', d_new
            d_new = (2.0*wid)/(n+1) - d_bounds(l)
       if (my_pe == 0) 
     &      write (stdout,'(/a,i4,a,i2,a,1pe14.7,a,1pe14.7/)')
     &      ' Note: to get ',n+1,' grid cells within region ',l
     &,     ', change resolution from ', d_bounds(l+1), ' to ', d_new
            call sub_flush(6)
            call halt_stop(' in gcell')
          endif
        endif
        num = num + n
      enddo
c
c     adjust "num" to reflect the total number of cells contained in
c     all regions
c
      num = num - 1
c
      do i=1,num
c
c       build resolution for T cells: "deltat". Note that
c       variable resolution (stretched grid) implies T points are
c       off center
c
        if (i .eq. 1) then
          deltat(i) = p5*(d_bounds(1) + deltau(i))
        else
          deltat(i) = p5*(deltau(i) + deltau(i-1))
        endif
      enddo     
c
c     add boundary points if needed
c
      if (nbpts .ne. 0) then
        do i=num,1,-1
          deltat(i+1) = deltat(i) 
          deltau(i+1) = deltau(i)
        enddo
        deltat(1)     = deltat(2)
        deltau(1)     = d_bounds(1)
        deltat(num+2) = deltat(num+1) 
        deltau(num+2) = deltau(num+1)
        num           = num + 2 
      endif
      end subroutine gcell_old

#include "options.inc"


c=======================================================================
c    simple program to concatenate sbc forcing files 
c=======================================================================
c
c#define real_8
c
      module kind_mod
#ifdef real_8
      integer, parameter::  r_knd  = selected_real_kind(13)
#else
      integer, parameter::  r_knd  = selected_real_kind(6)
#endif

      end module kind_mod


      program cat_sbc
      use kind_mod
      implicit none
      real,parameter :: version = 0.1
      integer :: nr_com,nr_infiles,io
      character (len=80), allocatable :: infile(:)
      character (len=80) :: outfile
      character (len=2000) :: outstr
      character (len=32) :: stamp,stamp2
      integer :: i,itm,j,io2,imt,jmt,ierr,n
      real (kind=r_knd), allocatable :: buf(:,:),aprec(:)

      print'(" This is cat_sbc.x :: version ",f5.3)',version

c  read command line input
      call get_commandline_argnr(nr_com)
      if (nr_com<3) goto 100
      nr_infiles = nr_com-3
      allocate( infile(nr_infiles)  )
      call get_commandline_arg(nr_com-2,outfile,ierr)
      call get_commandline_arg_int(nr_com-1,imt,ierr)
      call get_commandline_arg_int(nr_com,jmt,ierr)
c    write some information to stdout
      print*,' outfile : ',outfile
      print*,' imt x jmt : ',imt,jmt
      outstr=' concatenating forcing in files :'
      do n=1,nr_infiles
       call get_commandline_arg(n,infile(n),ierr)
       outstr=outstr(1:len_trim(outstr))//
     &            infile(n)(1:len_trim(infile(n)))//','
      enddo
      outstr=outstr(1:len_trim(outstr)-1)//' and writing to file '//
     &   outfile(1:len_trim(outfile))
      print*,outstr(1:len_trim(outstr))

c   open input files 
      itm=0
      do n=1,nr_infiles
       call getunit(io,infile(n),'usr ieee')
       if (n==1) then
        read (io) i,stamp
       else
        read (io) i
       endif
       close(io)
       itm=itm+i
      enddo
      print*,' altogether ',itm,' time steps '
      allocate( aprec(itm), buf(imt,jmt) )
      j=1
      do n=1,nr_infiles
       call getunit(io,infile(n),'usr ieee')
       read (io) i
       rewind(io)
       read (io) i,stamp2,aprec(j:j+i-1)
       close(io)
       j=j+i
      enddo

      call getunit(io2,outfile,'usr ieee')
      write (io) itm,stamp,aprec
      do n=1,nr_infiles
       call getunit(io,infile(n),'usr ieee')
       read (io) i
       do j=1,i
        read (io) buf
        write (io2) buf
       enddo
       close(io)
      enddo
      close(io2)

      print*,'all done, bye'
      stop

 100  print*,' program needs command line parameter'
      print*,' input file names, output file name, imt, jmt'
      print*,' files must be sbc forcing files for SPFLAME'
      stop
      end program cat_sbc



c   dummy routines

      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

c
c-----------------------------------------------------------------------
c     Island and Island Perimeter Mapping Routines
c     now contained in a module. Original code taken from GFDL MOM2.1.
c
c     Note: this version applies changes to the kmt mask
c   
c     SPFLAME version : c.eden
c                C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c-----------------------------------------------------------------------
c
      module island_module

      public :: isleperim,showmap

      private :: mmm, expand, qinit, qpush,
     &           qpop, qempty, jn, js, ie, iw

      logical :: cyclic,change_kmt=.false.
      private :: cyclic,change_kmt

      contains
 
      subroutine isleperim(kmt,map, iperm, jperm, iofs, 
     &                     nippts, nisle
     &,       imt, jmt, mnisle, maxipp,my_pe,cyclic_bc,
     &        obc_north,obc_south,obc_west,obc_east,change_kmt_in)

c
c=======================================================================
c         Island and Island Perimeter Mapping Routines
c         December 1993/revised February 1995
c=======================================================================
c
      common /qsize/ maxqsize
c
      integer kmt(imt,jmt), map(imt,jmt), iperm(maxipp)
      integer jperm(maxipp), nippts(mnisle), iofs(mnisle)
      integer nisle,imt,jmt,mnisle,maxipp
      logical cyclic_bc,obc_north,obc_south,obc_west,obc_east
      logical change_kmt_in
c
      parameter (maxq=10000)
c
      dimension iq(maxq)
      dimension jq(maxq)
      integer qfront, qback
      integer ocean,my_pe
c
      parameter (land=1, ocean=0)
      parameter (kmt_land=0, kmt_ocean=1)
c

      cyclic=cyclic_bc
      change_kmt = change_kmt_in

      if (my_pe==0) 
     &      print '(/,a)','Finding perimeters of all land masses'
      if (my_pe==0.and. cyclic) 
     &      print '(a,/)',' using cyclic boundary conditions'
      if (my_pe==0.and. change_kmt) 
     &      print '(a,/)',' applying changes to kmt mask    '
c
c     initialize number of changes to kmt
c
      nchanges = 0
c
    1 continue
c
c-----------------------------------------------------------------------
c     copy kmt to map changing notation
c     initially, 0 means ocean and 1 means unassigned land in map
c     as land masses are found, they are labeled 2, 3, 4, ...,
c     and their perimeter ocean cells -2, -3, -4, ...,
c     when no land points remain unassigned, land mass numbers are
c     reduced by 1 and their perimeter ocean points relabelled accordingly
c-----------------------------------------------------------------------
c
      do i=1,imt
        do j=1,jmt
          if (kmt(i,j) .gt. 0) then
            map(i,j) = ocean
          else
            map(i,j) = land
          end if
        end do
      end do

c-----------------------------------------------------------------------
c     first row is land for calculating poisson equation
c-----------------------------------------------------------------------
      if (obc_south) map(:,1)     = land
c-----------------------------------------------------------------------
c     last row is land for calculating poisson equation
c-----------------------------------------------------------------------
      if (obc_north) map(:,jmt)   = land
c-----------------------------------------------------------------------
c     first column is land for calculating poisson equation
c-----------------------------------------------------------------------
      if (obc_west)  map(1,:)     = land
c-----------------------------------------------------------------------
c     last column is land for calculating poisson equation
c-----------------------------------------------------------------------
      if (obc_east)  map(imt,:)   = land
c
c-----------------------------------------------------------------------
c     find unassigned land points and expand them to continents
c-----------------------------------------------------------------------
c
      maxqsize = 0
      call qinit (iq, jq, qfront, qback)
      label = 2
      iofs(label) = 0
      nippts(label) = 0
      nerror = 0
      jnorth = jmt
      if (cyclic) then
       iwest = 2
       ieast = imt-1
      else
       iwest = 1
       ieast = imt
      endif
      do j=jnorth,1,-1
        do i=iwest,ieast
          if (map(i,j) .eq. land) then
            call qpush (i, j, iq, jq, qfront, qback)
            call expand (map, label, iq, jq, qfront, qback, nerror
     &,                  iperm, jperm, iofs, nippts
     &,                  imt, jmt, mnisle, maxipp, kmt)
           if (my_pe==0)
     &      print '(a,i2,a,i6)',
     &        'number of island perimeter points: nippts(',label-1,')=',
     &         nippts(label)
            label = label + 1
            if (label .gt. mnisle) then
              print '(a,i3,a)','ERROR==> mnisle=',mnisle,' is too small'
              stop '==> expand'
            end if
            iofs(label) = iofs(label-1) + nippts(label-1)
            nippts(label) = 0
          end if
        end do
      end do
      nisle = label - 1
c
c-----------------------------------------------------------------------
c     relabel land masses and their ocean perimeters
c------------------------------------------------------------------------
c
      do i=iwest,ieast
        do j=1,jnorth
          if (map(i,j) .ne. 0) then
            map(i,j) = map(i,j) - sign(1, map(i,j))
          end if
        end do
      end do
      do isle=2,nisle
        iofs(isle-1) = iofs(isle)
        nippts(isle-1) = nippts(isle)
      end do
      nisle = nisle - 1

      if (cyclic) then
       do j=1,jmt
         map(1,j) = map(imt-1,j)
         map(imt,j) = map(2,j)
       end do
      endif
c
c      print '(/a)',
c     &       'The following changes fix "PERIMETER VIOLATIONS"'
c
      if (nerror .gt. 0) then
       if (change_kmt) then
        if (my_pe ==0) print *
     &, '==>Remapping land masses to see if PERIMETER VIOLATIONS remain'
        if (my_pe ==0) print *, ' '
        goto 1
       endif
       if (my_pe==0) call showmap(map,imt,jmt)
       call barrier
       call halt_stop(' in isleperim')
      end if
c
      if (my_pe==0) then
       print *,' Island perimeter statistics:'
       print *,'maximum queue size was ',maxqsize
       print *,'number of land masses is ', nisle
       print *,'number of island perimeter points is ',
     &         nippts(nisle) + iofs(nisle)
      endif
c

      return
      end subroutine isleperim


      subroutine showmap (map, imt, jmt)
      dimension map(imt,jmt)
      linewidth = 125
      print '(/,132a)',(' ',l=1,5+min(linewidth,imt)/2-13)
     &,     'Land Masses and Perimeters'
      istart = 0
      iremain = imt
      do isweep=1,imt/linewidth + 1
        iline = min(iremain, linewidth)
        iremain = iremain - iline
        if (iline .gt. 0) then
          print *, ' '
          print '(t6,32i5)', (istart+i+4,i=1,iline,5)
          do j=jmt,1,-1
            print '(i4,t6,160i1)', j,(mmm(map(istart+i,j)),i=1,iline)
          end do
          print '(t6,32i5)', (istart+i+4,i=1,iline,5)
          istart = istart + iline
        end if
      end do
      print *, ' '
      return
      end subroutine showmap



      function mmm(m)
      if (m .eq. 0) then
        mmm = 0
      else if (m .gt. 0) then
        mmm = mod(m,10)
      else
        mmm = m
      end if
      return
      end function mmm




      subroutine expand (map, label, iq, jq, qfront, qback, nerror
     &,                  iperm, jperm, iofs, nippts
     &,                  imt, jmt, mnisle, maxipp, kmt)
c
c-----------------------------------------------------------------------
c          The subroutine expand uses a "flood fill" algorithm
c          to expand one previously unmarked land
c          point to its entire connected land mass and its perimeter
c          ocean points.   Diagonally adjacent land points are
c          considered connected.  Perimeter "collisions" (i.e.,
c          ocean points that are adjacent to two unconnected
c          land masses) are detected and error messages generated.
c
c          The subroutine expand uses a queue of size maxq of
c          coordinate pairs of candidate points.  Suggested
c          size for maxq is 4*(imt+jmt).  Queue overflow stops
c          execution with a message to increase the size of maxq.
c          Similarly a map with more that maxipp island perimeter
c          points or more than mnisle land masses stops execution
c          with an appropriate error message.
c-----------------------------------------------------------------------
c
      dimension map(imt,jmt), kmt(imt,jmt)

      dimension iperm(maxipp)
      dimension jperm(maxipp)
      dimension nippts(mnisle)
      dimension iofs(mnisle)


      character * 32 problem

      parameter (maxq=10000)
      dimension iq(maxq)
      dimension jq(maxq)
      integer qfront, qback
c      logical qempty

      integer offmap, ocean
      parameter (offmap = -1)
      parameter (land = 1, ocean = 0)

      parameter (mnisle2=500)
      logical bridge_to(1:mnisle2)
c
c      print '(a,i3)', 'Exploring land mass ',label-1
c
      if (mnisle2 .lt. mnisle) then 
        print '(a,i4,a)', 
     & 'ERROR:  change parameter (mnisle2=',mnisle,') in isleperim.F'
        stop '==>isleperim'
      end if
c
      do isle=1,mnisle
        bridge_to(isle) = .false.
      end do
c
c-----------------------------------------------------------------------
c     main loop:
c        Pop a candidate point off the queue and process it.
c-----------------------------------------------------------------------
c
 1000 continue

      if (qempty (iq, jq, qfront, qback)) then
        call qinit (iq, jq, qfront, qback)
        return
      else
        call qpop (i, j, iq, jq, qfront, qback)
c
c       case: (i,j) is off the map
        if (i .eq. offmap .or. j .eq. offmap) then
          goto 1000
c
c       case: map(i,j) is already labeled for this land mass
        else if (map(i,j) .eq. label) then
          goto 1000
c
c       case: map(i,j) is an ocean perimeter point of this land mass
        else if (map(i,j) .eq. -label) then
          goto 1000
c
c       case: map(i,j) is an unassigned land point
        else if (map(i,j) .eq. land) then
          map(i,j) = label
c         print *, 'labeling ',i,j,' as ',label
          call qpush (i,         jn(j,jmt), iq, jq, qfront, qback)
          call qpush (ie(i,imt), jn(j,jmt), iq, jq, qfront, qback)
          call qpush (ie(i,imt), j,         iq, jq, qfront, qback)
          call qpush (ie(i,imt), js(j,jmt), iq, jq, qfront, qback)
          call qpush (i,         js(j,jmt), iq, jq, qfront, qback)
          call qpush (iw(i,imt), js(j,jmt), iq, jq, qfront, qback)
          call qpush (iw(i,imt), j,         iq, jq, qfront, qback)
          call qpush (iw(i,imt), jn(j,jmt), iq, jq, qfront, qback)
          goto 1000
c
c       case: map(i,j) is an ocean point adjacent to this land mass
        else if (map(i,j) .eq. ocean .or. map(i,j) .lt. 0) then

c         subcase: map(i,j) is a perimeter ocean point of another mass
          if (map(i,j) .lt. 0) then
            nerror = nerror + 1
            print '(a,a,i3,a,i3,a,a,i3,a,i3)',
     &            'PERIMETER VIOLATION==> ',
     &            'map(',i,',',j,') is in the perimeter of both ',
     &            'land masses ', -map(i,j)-1, ' and ', label-1
c           if we just quit processing this point here, problem points
c           will be flagged several times.
c           if we relabel them, then they are only flagged once, but
c           appear in both island perimeters, which causes problems in
c           island integrals.  current choice is quit processing.
c
c           only fill first common perimeter point detected.
c           after the first land bridge is built, subsequent collisions
c           are not problems.
c
            if (.not. bridge_to(-map(i,j)-1)) then
c             option 1: fill common perimeter point to make land bridge
                  kmt(i,j)= 0
                  bridge_to(-map(i,j)-1) = .true.

c              do n=1,nchanges
c                if (kmt_changes(n,1) .eq.i .and.
c     &              kmt_changes(n,2) .eq.j .and.
c     &              kmt_changes(n,4) .eq.0) then
c                  bridge_to(-map(i,j)-1) = .true.
c                end if
c              end do

            end if
c
            goto 1000
          end if

c         case: map(i,j) is a ocean point--label it for current mass
          map(i,j) = -label
          nippts(label) = nippts(label) + 1
c         print *, 'iofs(label)=',iofs(label)
c         print *, 'nippts(label)=',nippts(label)
          if (iofs(label) + nippts(label) .gt. maxipp) then
            print *, 'ERROR==>  maxipp=',maxipp,' is not large enough'
            stop '==>expand'
          end if
          iperm(iofs(label) + nippts(label)) = i
          jperm(iofs(label) + nippts(label)) = j
          goto 1000
c
c       case: map(i,j) is probably labeled for another land mass
c       ************* this case should not happen **************
        else
          nerror = nerror + 1
          print '(a,a,i3,a,i3,a,a,i3,a,i3)',
     &          'ERROR ==>  ',
     &          'map(',i,',',j,') is labeled for both ',
     &          'land masses ', map(i,j)-1,' and ',label-1
        end if
        goto 1000
c
      end if

      return
      end subroutine expand


      subroutine qinit (iq, jq, qfront, qback)
      parameter (maxq=10000)
      dimension iq(maxq)
      dimension jq(maxq)
      integer qfront, qback
c
      qfront = 1
      qback = 0
c
c     fake assignments to iq and jq to avoid "flint" warning
c
      iq(qfront) = 0
      jq(qfront) = 0
c
      return
      end subroutine qinit


      subroutine qpush (i, j, iq, jq, qfront, qback)
c
      common /qsize/ maxqsize
c
      parameter (maxq=10000)
      dimension iq(maxq)
      dimension jq(maxq)
      integer qfront, qback
c
      qback = qback + 1
      if (qback .gt. maxq) then
        if (qfront .ne. 1) then
c         shift queue left to make room
          ishift = qfront - 1
          do ip=qfront,qback-1
            iq(ip-ishift) = iq(ip)
            jq(ip-ishift) = jq(ip)
          end do
          qfront = 1
          qback = qback - ishift
        else
          print *, 'queue fault in qpush'
          stop '==>qpush'
        end if
      end if
      iq(qback) = i
      jq(qback) = j
c
      maxqsize = max(maxqsize, (qback-qfront))
c
      return
      end subroutine qpush



      subroutine qpop (i, j, iq, jq, qfront, qback)
c
      parameter (maxq=10000)
      dimension iq(maxq)
      dimension jq(maxq)
      integer qfront, qback
c
      i = iq(qfront)
      j = jq(qfront)
      qfront = qfront + 1
      return
      end subroutine qpop


      function qempty (iq, jq, qfront, qback)
c
      parameter (maxq=10000)
      dimension iq(maxq)
      dimension jq(maxq)
      integer qfront, qback
      logical qempty
c
      qempty = (qfront .gt. qback)
c      
      return
      end function qempty



      function jn(j,jmt)

c     j coordinate to the north of j

      integer offmap
      parameter (offmap = -1)

      if (j .lt. jmt) then
        jn = j + 1
      else
        jn = offmap
      end if
      return
      end function jn


      function js(j,jmt)

c     j coordinate to the south of j

      integer offmap
      parameter (offmap = -1)

      if (j .gt. 1) then
        js = j - 1
      else
        js = offmap
      end if

      return
      end function js



      function ie(i,imt)

c     i coordinate to the east of i

      integer offmap
      parameter (offmap = -1)

      if (cyclic) then
       if (i .lt. imt-1) then
         ie = i + 1
       else
         ie = (i+1) - imt + 2
       end if
      else
       if (i .lt. imt) then
        ie = i + 1
       else
        ie = offmap
       end if
      end if
      return
      end function ie



      function iw(i,imt)

c     i coordinate to the west of i

      integer offmap
      parameter (offmap = -1)

      if (cyclic) then
       if (i .gt. 2) then
        iw = i - 1
       else
        iw = (i-1) + imt - 2
       end if
      else
       if (i .gt. 1) then
        iw = i - 1
       else
        iw = offmap
       end if
      end if
      return
      end function iw


      end module island_module

#include "options.inc"
c
c-----------------------------------------------------------------------
c     diagnose merdional heat transport and various decompositions
c     and write to either NetCDF or binary file
c-----------------------------------------------------------------------
c
      subroutine init_heat_tr_cdf
      use spflame_module
      implicit none
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer ncid,iret,i,j,k
      real :: spval=-9.9e12
      integer lat_udim,itimedim,lat_uid,itimeid
      integer n,id, advid, diffid, overid, gyreid, ekmid
      integer dims(4), corner(4), edges(4)
      character name*24, unit*16,lname*24
#ifdef netcdf_real4
      real (kind=4)  :: v2(jmt)
#else
      real           :: v2(jmt)
#endif

      if (my_pe == 0) then
      print*,' initializing NetCDF output file ',heat_tr_file
      ncid = nccre (heat_tr_file, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
      call store_info_cdf(ncid)
c     dimensions
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c     grid variables
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)
      dims=(/lat_udim,itimedim,1,1/)
c     attributes of the grid
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c     attributes of variables
      do n=1,nt
      name='heat';unit='PW'
      if (n==2) name='salt'
      if (n==2) unit='10^10cm^2/s'
      if (n>2)  then
        write(name,'("tracer_",i2)') n
        call replace_space_zero(name)
        unit= ' '
      endif
      k=len_trim(name)
      id=ncvdef (ncid,name(1:k)//'_tr', NCFLOAT,2,dims,iret)
      advid =ncvdef (ncid,name(1:k)//'_tr_adv', NCFLOAT,2,dims,iret)
      diffid=ncvdef (ncid,name(1:k)//'_tr_diff', NCFLOAT,2,dims,iret)
      overid=ncvdef (ncid,name(1:k)//'_tr_over', NCFLOAT,2,dims,iret)
      gyreid=ncvdef (ncid,name(1:k)//'_tr_gyre', NCFLOAT,2,dims,iret)
      ekmid =ncvdef (ncid,name(1:k)//'_tr_ekm', NCFLOAT,2,dims,iret)
      lname = 'Northward '//name(1:k)//' transport'; 
      call dvcdf(ncid,id,lname,24,unit,16,spval)
      lname = 'Advective '//name(1:k)//' transport'; 
      call dvcdf(ncid,advid,lname,24,unit,16,spval)
      lname = 'Diffusive '//name(1:k)//' transport'; 
      call dvcdf(ncid,diffid,lname,24,unit,16,spval)
      lname = 'Overturning '//name(1:k)//' transport'; 
      call dvcdf(ncid,overid,lname,24,unit,16,spval)
      lname = 'Gyre '//name(1:k)//' transport';
      call dvcdf(ncid,gyreid,lname,24,unit,16,spval)
      lname = 'Ekman '//name(1:k)//' transport'; 
      call dvcdf(ncid,ekmid,lname,24,unit,16,spval)
      enddo ! n
      call ncendf(ncid, iret)
      corner(1) = 1; edges(1) = jmt
      v2=yu
      call ncvpt(ncid, Lat_uid, corner, edges,v2, iret)
      call ncclos (ncid, iret)
      print*,' done'
      endif! my_pe==0
#else
c     needs no intialisaztion
#endif
      end subroutine init_heat_tr_cdf


      subroutine diag_heat_tr(n,adv_fn,diff_fn)
      use spflame_module
      implicit none
      integer, intent(in) :: n
      real, intent(in) :: adv_fn(is_pe:ie_pe,km,js_pe-1:je_pe)
      real, intent(in) :: diff_fn(is_pe:ie_pe,km,js_pe-1:je_pe)

      integer i,j,k, is,ie,js,je
#ifdef netcdf_diagnostics
#include "netcdf.inc"
      integer ncid,iret,npe, htrid,timeid,timedim,len
      real :: spval=-9.9e12, tt
      integer corner(4), edges(4)

#ifdef netcdf_real4
      real (kind=4) :: var(js_pe:je_pe)
#else
      real          :: var(js_pe:je_pe)
#endif


#else
      integer :: io,m
      character (len=80) :: iotext
      character (len=60) :: expnam
      real :: reltim = 0.
#endif
      character (len=80) name
      real :: totdxn,totdxs,vbr,tbrs,tbrn,totz,vbrz,tbrz,mask
      real :: tempdiff_fn,tempadv_fn,factor
      real,dimension(:,:),save,allocatable :: over_tr,gyre_tr,adv_tr
      real,dimension(:,:),save,allocatable :: diff_tr,barotr_tr
      real,dimension(:,:),save,allocatable :: total_tr,ekm_tr,barocl_tr
      real,dimension(:,:,:),allocatable :: buf
      logical, save :: first=.true.
      real :: pwatts = 4.186e-15, csalt  = 1.e-10, small=1.e-10

      if (first) then
       first=.false.
       allocate(over_tr(jmt,nt), gyre_tr(jmt,nt), adv_tr(jmt,nt) )
       allocate(diff_tr(jmt,nt), barotr_tr(jmt,nt) )
       allocate(total_tr(jmt,nt), ekm_tr(jmt,nt), barocl_tr(jmt,nt))
      endif

      over_tr(:,n) = 0. ; gyre_tr(:,n) = 0.        
      adv_tr(:,n) = 0.   ; diff_tr(:,n) = 0.        
      total_tr(:,n) = 0. ; ekm_tr(:,n) = 0.        
      barocl_tr(:,n) = 0. ; barotr_tr(:,n) = 0.        

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(js_pe,2); je=min(je_pe,jmt-1)

      do j=js,je

        do k=1,km
         totdxn = small; totdxs = small
         vbr    = 0.; tbrs   = 0.; tbrn   = 0.
         do i=is,ie
           totdxn = totdxn + dxt(i)*tmask(i,k,j+1)
#ifdef partial_cell
     &                 *dht(i,k,j+1)
#endif
           totdxs = totdxs + dxt(i)*tmask(i,k,j)
#ifdef partial_cell
     &                 *dht(i,k,j)
#endif
           vbr    = vbr  + u(i,k,j,2,tau)*dxu(i)*csu(j)
#ifdef partial_cell
     &                 *dhu(i,k,j)
#endif
           tbrn   = tbrn + t(i,k,j+1,n,tau)*tmask(i,k,j+1)*dxt(i)
#ifdef partial_cell
     &                 *dht(i,k,j+1)
#endif
           tbrs   = tbrs + t(i,k,j,n,tau)*tmask(i,k,j)*dxt(i)
#ifdef partial_cell
     &                 *dht(i,k,j)
#endif
	 enddo
         tbrn = tbrn/totdxn; tbrs = tbrs/totdxs
         over_tr(j,n) = over_tr(j,n) + vbr*0.5*(tbrn+tbrs)
#ifndef partial_cell
     &                                                *dzt(k)
#endif
         do i=is,ie
	  tempdiff_fn =      diff_fn(i,k,j)*
     &                           tmask(i,k,j+1)*tmask(i,k,j)*
     &                           dxt(i)*csu(j)
#ifndef partial_cell
     &                                        *dzt(k)
#endif
c	  tempadv_fn       = 0.5*adv_vnt(i,k,j)*(t(i,k,j,n,tau) +
c     &                           t(i,k,j+1,n,tau))*dxt(i)
	  tempadv_fn       = 0.5*adv_fn(i,k,j)*dxt(i)
#ifndef partial_cell
     &                                                   *dzt(k)
#endif
          adv_tr(j,n)    = adv_tr(j,n)  + tempadv_fn
          diff_tr(j,n)   = diff_tr(j,n) - tempdiff_fn
c          fxb = adv_vntiso(i,k,j)*
c     &              (t(i,k,j,n,taum1)+t(i,k,j+1,n,taum1))
c     &              *0.5*dxt(i)*csu(j)
#ifndef partial_cell
c     &                                                       *dzt(k)
#endif
c              ttn2(9,j,n) = ttn2(9,j,n) + fxb

         enddo
        enddo
        call sum_along_jrow(adv_tr(j,n),1)
        call sum_along_jrow(diff_tr(j,n),1)
        call sum_along_jrow(over_tr(j,n),1)

        gyre_tr(j,n) = adv_tr(j,n)-over_tr(j,n)
        total_tr(j,n) = adv_tr(j,n)+diff_tr(j,n)

        do i=is,ie

         factor=4.*cori(i,j,1)
c        limit coriolis factor
         factor = sign(1.,factor)*max(1.e-5,abs(factor)) 

         totz = 0.; vbrz = 0.; tbrz = 0.
         do k=1,km
	  mask = tmask(i,k,j)*tmask(i,k,j+1)
          vbrz = vbrz + adv_vnt(i,k,j)*dxt(i)
#ifndef partial_cell
     &                                       *dzt(k)
#endif
          tbrz = tbrz +mask*(t(i,k,j,n,tau)+t(i,k,j+1,n,tau))
#ifdef partial_cell
     &                           *min(dht(i,k,j),dht(i,k,j+1))
#else
     &                           *dzt(k)
#endif
          totz = totz + mask
#ifdef partial_cell
     &                          *min(dht(i,k,j),dht(i,k,j+1))
#else
     &                          *dzt(k)
#endif
         enddo
         if (totz /=0.0) then
           tbrz = tbrz/totz
           barotr_tr(j,n) = barotr_tr(j,n) + vbrz*tbrz*0.5
           ekm_tr(j,n) = ekm_tr(j,n) - 
     &          (smf(i,j,1)*dxu(i)*umask(i,1,j) + 
     &           smf(i-1,j,1)*dxu(i-1)*umask(i-1,1,j))*(t(i,1,j,n,tau)
     &                        +t(i,1,j+1,n,tau)-tbrz)
     &         *csu(j)/factor
         endif
        enddo
        call sum_along_jrow(barotr_tr(j,n),1)
        call sum_along_jrow(ekm_tr(j,n),1)
        barocl_tr(j,n) = barocl_tr(j,n)-barotr_tr(j,n)-ekm_tr(j,n)
      enddo

      if (my_pe==0.and.n==1)
     &  print*,' --> writing heat_tr to file ',
     &        heat_tr_file(1:len_trim(heat_tr_file))

#ifdef netcdf_diagnostics
c     write to netcdf format here
      do npe=0,n_pes,n_pes_i
       call barrier
       if (my_pe==npe) then
        iret=nf_open(heat_tr_file,NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
        iret=nf_inq_varid(ncid,'Time',timeid)
        iret=nf_inq_dimid(ncid,'Time',timedim)
        iret=nf_inq_dimlen(ncid, timedim,len)
        if (my_pe==0.and.n==1) then
         len=len+1
         corner(1)=len
         edges(1)=1
         call read_stamp(current_stamp,tt)
         print*,' at stamp=',current_stamp,
     &          ' (days since origin : ',tt,')',
     &          ' (time steps in file : ',len,')'
         iret= nf_put_vara_real (ncid,timeid, corner,edges,tt)
        endif

        if (n==1) then
         name='heat'
         factor=pwatts
        elseif (n==2) then
         name='salt'
         factor=csalt
        else
         write(name,'("tracer_",i2)') n
         call replace_space_zero(name)
         factor=1.
        endif
        iret=nf_inq_varid(ncid,name(1:len_trim(name))//'_tr',htrid)
        corner=(/js_pe,len,1,1/); edges=(/je_pe-js_pe+1,1,1,1/)
        var= total_tr(js_pe:je_pe,n)*factor
        iret= nf_put_vara_real (ncid,htrid ,corner, edges,var)

        iret=nf_inq_varid(ncid,name(1:len_trim(name))//'_tr_adv',htrid)
        corner=(/js_pe,len,1,1/); edges=(/je_pe-js_pe+1,1,1,1/)
        var =  adv_tr(js_pe:je_pe,n)*factor
        iret= nf_put_vara_real (ncid,htrid ,corner, edges, var)

        iret=nf_inq_varid(ncid,name(1:len_trim(name))//'_tr_diff',htrid)
        corner=(/js_pe,len,1,1/); edges=(/je_pe-js_pe+1,1,1,1/)
        var =  diff_tr(js_pe:je_pe,n)*factor
        iret= nf_put_vara_real (ncid,htrid ,corner, edges,var)

        iret=nf_inq_varid(ncid,name(1:len_trim(name))//'_tr_over',htrid)
        corner=(/js_pe,len,1,1/); edges=(/je_pe-js_pe+1,1,1,1/)
        var =   over_tr(js_pe:je_pe,n)*factor
        iret= nf_put_vara_real (ncid,htrid ,corner, edges,var)

        iret=nf_inq_varid(ncid,name(1:len_trim(name))//'_tr_gyre',htrid)
        corner=(/js_pe,len,1,1/); edges=(/je_pe-js_pe+1,1,1,1/)
        var =  gyre_tr(js_pe:je_pe,n)*factor
        iret= nf_put_vara_real (ncid,htrid ,corner, edges, var)

        iret=nf_inq_varid(ncid,name(1:len_trim(name))//'_tr_ekm',htrid)
        corner=(/js_pe,len,1,1/); edges=(/je_pe-js_pe+1,1,1,1/)
        var =  ekm_tr(js_pe:je_pe,n)*factor
        iret= nf_put_vara_real (ncid,htrid ,corner, edges,var)

        call ncclos (ncid, iret)
       endif
       call barrier
      enddo
#else
c     write the old flame format here

      if (n==1) then
        over_tr(:,n)=over_tr(:,n)*pwatts
        gyre_tr(:,n)=gyre_tr(:,n)*pwatts
        barotr_tr(:,n)=barotr_tr(:,n)*pwatts
        barocl_tr(:,n)=barocl_tr(:,n)*pwatts
        ekm_tr(:,n)=ekm_tr(:,n)*pwatts
        adv_tr(:,n)=adv_tr(:,n)*pwatts
        diff_tr(:,n)=diff_tr(:,n)*pwatts
        total_tr(:,n)=total_tr(:,n)*pwatts
      endif
      if (n==2) then
        over_tr(:,n)=over_tr(:,n)*csalt 
        gyre_tr(:,n)=gyre_tr(:,n)*csalt 
        barotr_tr(:,n)=barotr_tr(:,n)*csalt 
        barocl_tr(:,n)=barocl_tr(:,n)*csalt 
        ekm_tr(:,n)=ekm_tr(:,n)*csalt 
        adv_tr(:,n)=adv_tr(:,n)*csalt 
        diff_tr(:,n)=diff_tr(:,n)*csalt 
        total_tr(:,n)=total_tr(:,n)*csalt 
      endif

      if (n==nt) then
       if (my_pe == 0)  then
        call getunit (io, heat_tr_file,'u s a ieee')
        iotext = 'no iotext'
        expnam = 'SPFLAME, some experiment'
        write (io) current_stamp, iotext, expnam
        write (io) jmt, nt, reltim    
       endif
c       call pe0_recv_vec_along_jrow(over_tr,nt)
       call pe0_recv_merid_vec(over_tr,nt,1)
c       call pe0_recv_vec_along_jrow(gyre_tr,nt)
       call pe0_recv_merid_vec(gyre_tr,nt,1)
c       call pe0_recv_vec_along_jrow(barotr_tr,nt)
       call pe0_recv_merid_vec(barotr_tr,nt,1)
c       call pe0_recv_vec_along_jrow(barocl_tr,nt)
       call pe0_recv_merid_vec(barocl_tr,nt,1)
c       call pe0_recv_vec_along_jrow(ekm_tr,nt)
       call pe0_recv_merid_vec(ekm_tr,nt,1)
c       call pe0_recv_vec_along_jrow(adv_tr,nt)
       call pe0_recv_merid_vec(adv_tr,nt,1)
c       call pe0_recv_vec_along_jrow(diff_tr,nt)
       call pe0_recv_merid_vec(diff_tr,nt,1)
c       call pe0_recv_vec_along_jrow(total_tr,nt)
       call pe0_recv_merid_vec(total_tr,nt,1)
c
       if (my_pe == 0)  then
        allocate(buf(8,jmt,nt))
        buf(1,:,:)=over_tr; buf(2,:,:)=gyre_tr;
        buf(3,:,:)=barotr_tr; buf(4,:,:)=barocl_tr;
        buf(5,:,:)=ekm_tr; buf(6,:,:)=adv_tr;
        buf(7,:,:)=diff_tr; buf(8,:,:)=total_tr;
        write (io) current_stamp, iotext, expnam
c        write (io) (((over_tr(j,m),gyre_tr(j,m),barotr_tr(j,m),
c     &             barocl_tr(j,m),ekm_tr(j,m),adv_tr(j,m),
c     &             diff_tr(j,m),total_tr(j,m)),j=1,jmt),m=1,nt)
        write(io) buf
        write (io) current_stamp, iotext, expnam
c        write (io) (((over_tr(j,m),gyre_tr(j,m),barotr_tr(j,m),
c     &             barocl_tr(j,m)),j=1,jmt),m=1,nt)
        write (io) buf(1,1,1)
        deallocate(buf)
        close(io)
       endif
      endif

#endif
      end subroutine diag_heat_tr

#include "options.inc"




      subroutine rigid_lid
c
c=======================================================================
c     Solve for the barotropic velocities for "tau+1"
c     original author:   r.c.pacanowski       e-mail rcp@gfdl.gov
c     SPFLAME version : c.eden
c=======================================================================
c
      use spflame_module
      implicit none
      real, dimension(is_pe:ie_pe,js_pe:je_pe,-1:1,-1:1) :: coef
c     Note: coefficients could be saved and computed only once
      real, dimension(is_pe:ie_pe,js_pe:je_pe)           :: forc
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1)   :: res
      integer   is,ie,js,je,i,j
c
c-----------------------------------------------------------------------
c     prepare for a mixing time step
c-----------------------------------------------------------------------
c
      if (eulerfore .or. eulerback1) then
        psi(:,:,2) = psi(:,:,1)
        ptd=ptd/2.
        guess=guess/2.
      endif

#ifdef detailed_timing
      call tic('tropic zu exchg')
#endif
      call border_exchg(zu(:,:,1),1,1)
      call border_exchg(zu(:,:,2),1,1)
      call set_cyclic(zu(:,:,1),1,1)
      call set_cyclic(zu(:,:,2),1,1)
#ifdef detailed_timing
      call toc('tropic zu exchg')
#endif
c
c-----------------------------------------------------------------------
c     construct the forcing for the stream function equation
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
      call tic('tropic forc')
#endif
      call sfforc (forc)
c
c-----------------------------------------------------------------------
c     initialize coefficients using 9 point numerics
c-----------------------------------------------------------------------
c
      call sfc9pt (coef)
c
c-----------------------------------------------------------------------
c     linear extrapolation between the last two solution for the
c     purpose of computing an initial guess for the present solution.
c-----------------------------------------------------------------------
c
      res = ptd; ptd = (2.*ptd- guess); guess=res ; res=0.

      call border_exchg(ptd,1,1)
      call set_cyclic(ptd,1,1)
#ifdef detailed_timing
      call toc('tropic forc')
#endif
c
c-----------------------------------------------------------------------
c     solving for the "tau+1" stream function change
c-----------------------------------------------------------------------
c
#ifdef detailed_timing
      call tic('tropic congr')
#endif
      call congr (ptd, res, forc, coef, eps_solver,.true.)
#ifdef detailed_timing
      call toc('tropic congr')
#endif
c
c     Distribute new solution
c
      call border_exchg(ptd,1,1)
      call set_cyclic(ptd,1,1)
c
c     calculate first the phase velocities for psi
c
#ifdef detailed_timing
      call tic('tropic phase')
#endif
      call phase_velocities_psi
#ifdef detailed_timing
      call toc('tropic phase')
#endif
c
c-----------------------------------------------------------------------
c     update the stream function based upon the solution
c-----------------------------------------------------------------------
c
      if (eulerback2) then
        psi(:,:,1)=psi(:,:,2)+ptd
      else
        res(:,:)    = psi(:,:,2) + ptd
        psi(:,:,2)  = psi(:,:,1)
        psi(:,:,1)  = res(:,:)
      endif
c
c     apply open boundary conditions
c
#ifdef detailed_timing
      call tic('tropic obc')
#endif
      call addobcpsi
#ifdef detailed_timing
      call toc('tropic obc')
#endif
c
c     Distribute psi
c
      call border_exchg(psi(:,:,1),1,1)
      call set_cyclic(psi(:,:,1),1,1)
c
c     add external mode to the internal velocities
c
#ifdef detailed_timing
      call tic('tropic addext')
#endif
      call add_ext_mode
#ifdef detailed_timing
      call toc('tropic addext')
#endif
c
c-----------------------------------------------------------------------
c     save ptd to compute 1st guess for relaxation next timestep
c     (..note.. on 1st pass of euler backward timestep, bypass this
c            save, since it will be done on the 2nd pass)
c     (..note.. on a mixing timestep, alter ptd to be consistent with
c            normal, leap-frog stepping)
c-----------------------------------------------------------------------
c
      if( eulerfore .or. eulerback2 ) then
         ptd=2.*ptd
         guess=guess*2.
      endif

      end subroutine rigid_lid




      subroutine add_ext_mode ()
      use spflame_module
      implicit none
      integer i,j,n,k,is,ie,js,je
      real diag1,diag0,ext1,ext2

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
        do i=is,ie
         diag1       = psi(i+1,j+1,1) - psi(i  ,j,1)
         diag0       = psi(i  ,j+1,1) - psi(i+1,j,1)
	 ext1  = -(diag1+diag0)*dyu2r(j)*hr(i,j)
	 ext2  =  (diag1-diag0)*dxu2r(i)*hr(i,j)*csur(j)
         do k=1,km
          u(i,k,j,1,taup1) = (u(i,k,j,1,taup1)+ext1)*umask(i,k,j)
          u(i,k,j,2,taup1) = (u(i,k,j,2,taup1)+ext2)*umask(i,k,j)
         enddo
	enddo
      enddo

      do n=1,2
       call set_cyclic(u(:,:,:,n,taup1),km,2)
       if (my_blk_j == 1 .and. enable_obc_south) 
     &        u(:,:,1,n,taup1) = u(:,:,2,n,taup1)
       if (my_blk_j == n_pes_j .and. enable_obc_north) then
              u(:,:,jmt-1,n,taup1) = u(:,:,jmt-2,n,taup1)
              u(:,:,jmt  ,n,taup1) = u(:,:,jmt-2,n,taup1)
       endif
       if (my_blk_i == 1 .and. enable_obc_west) 
     &        u(1,:,:,n,taup1) = u(2,:,:,n,taup1)
       if (my_blk_i == n_pes_i .and. enable_obc_east) then
              u(imt  ,:,:,n,taup1) = u(imt-2,:,:,n,taup1)
              u(imt-1,:,:,n,taup1) = u(imt-2,:,:,n,taup1)
       endif
       call border_exchg(u(:,:,:,n,taup1),km,2)
      enddo

      end subroutine add_ext_mode


      subroutine sfforc (forc)
      use spflame_module
      implicit none
c
c=======================================================================
c           S T R E A M   F U N C T I O N   F O R C I N G
c=======================================================================
c
      real, dimension(is_pe:ie_pe,js_pe:je_pe)   :: forc
      real, dimension(is_pe-1:ie_pe,js_pe-1:je_pe) :: ustuff, vstuff
      real, dimension( 0:1, 0:1)     :: cddxu,  cddyu
      real, dimension(-1:0,-1:0)     :: cddxt,  cddyt
      real :: p5=0.5
      integer i,j,i1,j1,is,ie,js,je
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     initialize the forcing
c-----------------------------------------------------------------------
      ustuff=0.; vstuff=0.; forc=0.
      cddxu( 0, 0) = -p5; cddxu( 0, 1) = -p5
      cddxu( 1, 0) =  p5; cddxu( 1, 1) =  p5
      cddxt(-1,-1) = -p5; cddxt(-1, 0) = -p5
      cddxt( 0,-1) =  p5; cddxt( 0, 0) =  p5
      cddyu( 0, 0) = -p5; cddyu( 0, 1) =  p5
      cddyu( 1, 0) = -p5; cddyu( 1, 1) =  p5
      cddyt(-1,-1) = -p5; cddyt(-1, 0) =  p5
      cddyt( 0,-1) = -p5; cddyt( 0, 0) =  p5
c
c-----------------------------------------------------------------------
c     multiply the u eqn by dx*cos, the v eqn by dy, then subtract their 
c     partial differences to eliminate the unknown surface pressure from 
c     the resulting equation
c-----------------------------------------------------------------------
c
      do j=js-1,je
        do i=is-1,ie
          ustuff(i,j) = zu(i,j,1)*dxu(i)*csu(j)
          vstuff(i,j) = zu(i,j,2)*dyu(j)
        end do
      end do
      do j1=-1,0
        do j=js,je
          do i=is,ie
            do i1=-1,0
              forc(i,j) = forc(i,j) 
     &                     - cddyt(i1,j1)*ustuff(i+i1,j+j1)
     &                     + cddxt(i1,j1)*vstuff(i+i1,j+j1)
            end do
          end do
        end do
      end do
      end subroutine sfforc



      subroutine spforc (nabla_p, forc)
c
c=======================================================================
c           S U R F A C E   P R E S S U R E   F O R C I N G
c     author:      c. h. goldberg      e-mail=> chg@gfdl.gov
c=======================================================================
c
      use spflame_module
      implicit none
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1,2) :: nabla_p
      real, dimension(is_pe:ie_pe,js_pe:je_pe)   :: forc
      real, dimension(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) :: ustuff,vstuff
      real, dimension( 0:1, 0:1)     :: cddxu,  cddyu
      real, dimension(-1:0,-1:0)     :: cddxt,  cddyt
      real :: h
      real, parameter :: p5=0.5
      integer ::  i,j,i1,j1,is,ie,js,je
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

c
      cddxu( 0, 0) = -p5; cddxu( 0, 1) = -p5;
      cddxu( 1, 0) =  p5; cddxu( 1, 1) =  p5
      cddxt(-1,-1) = -p5; cddxt(-1, 0) = -p5
      cddxt( 0,-1) =  p5; cddxt( 0, 0) =  p5
      cddyu( 0, 0) = -p5; cddyu( 0, 1) =  p5
      cddyu( 1, 0) = -p5; cddyu( 1, 1) =  p5
      cddyt(-1,-1) = -p5; cddyt(-1, 0) =  p5
      cddyt( 0,-1) = -p5; cddyt( 0, 0) =  p5

      forc = 0.; ustuff=0.; vstuff=0.

      do j=js,je
        do i=is,ie
#ifdef partial_cell
          h = hup(i,j)
#else
          h = zw(max(1,kmu(i,j)))*umask(i,1,j)
          
#endif
	  ustuff(i,j) = h*nabla_p(i,j,1)*dyu(j)
	  vstuff(i,j) = h*nabla_p(i,j,2)*dxu(i)*csu(j)
        end do
      end do
      call border_exchg(ustuff,1,1)
      call set_cyclic(  ustuff,1,1)
      call border_exchg(vstuff,1,1)
      call set_cyclic(  vstuff,1,1)
c
      do j1=-1,0
	do j=js,je
	  do i=is,ie
             do i1=-1,0
	      forc(i,j) = forc(i,j)
     &                     + cddxt(i1,j1)*ustuff(i+i1,j+j1)
     &                     + cddyt(i1,j1)*vstuff(i+i1,j+j1)
	    end do
	  end do
	end do
      end do
      end subroutine spforc


      subroutine sfc9pt  (coef)
      use spflame_module
      implicit none
c
c=======================================================================
c
c     9  P T    C O E F F I C I E N T   I N I T I A L I A Z A T I O N
c
c=======================================================================
c
      real coef  (is_pe:ie_pe,js_pe:je_pe,-1:1,-1:1)
      real ustuff(is_pe-1:ie_pe+1,js_pe-1:je_pe+1)
      real vstuff(is_pe-1:ie_pe+1,js_pe-1:je_pe+1)
      real cddxu(0:1,0:1), cddyu(0:1,0:1)
      real cddxt(-1:0,-1:0), cddyt(-1:0,-1:0)
      real :: p5=0.5
      integer is,ie,js,je, i,j,i1,j1,i2,j2
c
      js = max(2,js_pe); je = min(jmt-1,je_pe)
      is = max(2,is_pe); ie = min(imt-1,ie_pe)
c
c-----------------------------------------------------------------------
c     initialize the work area
c-----------------------------------------------------------------------
      coef=0.
      cddxu( 0, 0) = -p5; cddxu( 0, 1) = -p5
      cddxu( 1, 0) =  p5; cddxu( 1, 1) =  p5
      cddxt(-1,-1) = -p5; cddxt(-1, 0) = -p5
      cddxt( 0,-1) =  p5; cddxt( 0, 0) =  p5
      cddyu( 0, 0) = -p5; cddyu( 0, 1) =  p5
      cddyu( 1, 0) = -p5; cddyu( 1, 1) =  p5
      cddyt(-1,-1) = -p5; cddyt(-1, 0) =  p5
      cddyt( 0,-1) = -p5; cddyt( 0, 0) =  p5
c
c-----------------------------------------------------------------------
c     compute coefficients for all points
c-----------------------------------------------------------------------
c
      do i=max(1,is_pe-1),min(imt-1,ie_pe+1)
        do j=max(1,js_pe-1),min(jmt-1,je_pe+1)
          ustuff(i,j) = dxu(i)*csu(j)*hr(i,j) / (c2dt*dyu(j))
          vstuff(i,j) = dyu(j)*hr(i,j) / (c2dt*dxu(i)*csu(j))
        end do
      end do
c
c---------------------------------------------------------------------
c     calculate 9 point coefficients
c---------------------------------------------------------------------
c
        do j1=0,1
            do j2=-1,0
              do j=js,je
      do i1=0,1
          do i2=-1,0
                do  i=is,ie
                  coef(i,j,i1+i2,j1+j2) = coef(i,j,i1+i2,j1+j2) +
     &               cddyu(i1,j1)*cddyt(i2,j2)*ustuff(i+i2,j+j2)  +
     &               cddxu(i1,j1)*cddxt(i2,j2)*vstuff(i+i2,j+j2)
                end do
              end do
            end do
          end do
        end do
      end do
      end subroutine sfc9pt




      subroutine spc9pt (coef)
c
c=======================================================================
c     S U R F A C E   P R E S S U R E    C O E F F I C I E N T
c     author: c.h. goldberg         e-mail => chg@gfdl.gov
c=======================================================================
c
      use spflame_module
      implicit none

      real coef  (is_pe:ie_pe,js_pe:je_pe,-1:1,-1:1)
      real ustuff(is_pe-1:ie_pe+1,js_pe-1:je_pe+1)
      real vstuff(is_pe-1:ie_pe+1,js_pe-1:je_pe+1)

      real :: cddxu(0:1,0:1),   cddyu(0:1,0:1)
      real :: cddxt(-1:0,-1:0), cddyt(-1:0,-1:0)
      real :: h
      real, parameter :: p5=0.5
      integer :: i,j,i1,j1,i2,j2,is,ie,js,je
c
      js = max(2,js_pe); je = min(jmt-1,je_pe)
      is = max(2,is_pe); ie = min(imt-1,ie_pe)
c
      cddxu( 0, 0) = -p5; cddxu( 0, 1) = -p5
      cddxu( 1, 0) =  p5; cddxu( 1, 1) =  p5
      cddxt(-1,-1) = -p5; cddxt(-1, 0) = -p5
      cddxt( 0,-1) =  p5; cddxt( 0, 0) =  p5
      cddyu( 0, 0) = -p5; cddyu( 0, 1) =  p5
      cddyu( 1, 0) = -p5; cddyu( 1, 1) =  p5
      cddyt(-1,-1) = -p5; cddyt(-1, 0) =  p5
      cddyt( 0,-1) = -p5; cddyt( 0, 0) =  p5
c
      coef = 0.0; ustuff = 0.0; vstuff = 0.0
      do j=js,je
        do i=is,ie
#ifdef partial_cell
          h = hup(i,j)
#else
          h = zw(max(1,kmu(i,j)))*umask(i,1,j)
#endif
          ustuff(i,j) = h*dyu(j)/(dxu(i)*csu(j))
          vstuff(i,j) = h*dxu(i)*csu(j)/dyu(j)
        end do
      end do
      call border_exchg(ustuff,1,1)
      call set_cyclic(  ustuff,1,1)
      call border_exchg(vstuff,1,1)
      call set_cyclic(  vstuff,1,1)
c
c     calculate divergence = ddx (ddx (ustuff)) + ddy( ddy (vstuff))
c
      do j1=0,1
        do j2=-1,0
          do j=js,je
            do i1=0,1
              do i2=-1,0
                do  i=is,ie
                  coef(i,j,i1+i2,j1+j2) = coef(i,j,i1+i2,j1+j2)
     &                 + cddxu(i1,j1) * cddxt(i2,j2) * ustuff(i+i2,j+j2)
     &                 + cddyu(i1,j1) * cddyt(i2,j2) * vstuff(i+i2,j+j2)
                end do
              end do
            end do
          end do
        end do
      end do
      end subroutine spc9pt 



      subroutine phase_velocities_psi
      use spflame_module
      implicit none
      real var,var1
      integer i,j
c
c-----------------------------------------------------------------------
c     calculate phase velocities for psi
c     Orlanski radiation condition (passive open boundary)   
c-----------------------------------------------------------------------
c
      if (my_blk_j == 1 .and. enable_obc_south
     &     .and. .not. prescribe_psi_obc_south ) then
       var=-dyu(3)/dt
       do 4030 i=is_pe,ie_pe
         var1=psi(i,4,2)-psi(i,3,2)
         if (var1== 0.) then
           c1ps(i)=var
           goto 4030
         endif
         c1ps(i)=var*(psi(i,3,1)-psi(i,3,2))/var1
         if (c1ps(i).ge. 0.) c1ps(i)=0.
         if (c1ps(i).lt.var) c1ps(i)=var
4030   continue
      endif
c
      if (my_blk_j == n_pes_j .and. enable_obc_north
     &    .and. .not. prescribe_psi_obc_north) then
       var=dyu(jmt-2)/dt
       do 4031 i=is_pe,ie_pe
         var1=psi(i,jmt-2,2)-psi(i,jmt-3,2)
         if (var1.eq.0.) then
           c1pn(i)=var
           goto 4031
         endif
         c1pn(i)=-var*(psi(i,jmt-2,1)-psi(i,jmt-2,2))/var1
         if (c1pn(i).le. 0.) c1pn(i)=0.
         if (c1pn(i).gt.var) c1pn(i)=var
4031   continue
      endif
c
      if (my_blk_i == 1 .and. enable_obc_west
     &    .and. .not. prescribe_psi_obc_west ) then
       do 4032 j=js_pe,je_pe
         var=-dxu(3)*csu(j)/dt
         var1=psi(4,j,2)-psi(3,j,2)
         if (var1.eq.0.) then
           c1pw(j)=var
           goto 4032
         endif
         c1pw(j)=var*(psi(3,j,1)-psi(3,j,2))/var1
         if (c1pw(j).ge. 0.) c1pw(j)=0.
         if (c1pw(j).lt.var) c1pw(j)=var
4032   continue
      endif
c
      if (my_blk_i == n_pes_i .and. enable_obc_east
     &    .and. .not. prescribe_psi_obc_east ) then
       do 4033 j=js_pe,je_pe
         var=dxu(imt-2)*csu(j)/dt
         var1=psi(imt-2,j,2)-psi(imt-3,j,2)
         if (var1.eq.0.) then
           c1pe(j)=var
           goto 4033
         endif
         c1pe(j)=-var*(psi(imt-2,j,1)-psi(imt-2,j,2))/var1
         if (c1pe(j).le. 0.) c1pe(j)=0.
         if (c1pe(j).gt.var) c1pe(j)=var
4033   continue
      endif
      end subroutine phase_velocities_psi


      subroutine addobcpsi
      use spflame_module
      implicit none
      integer is,ie,js,je,i,j
      real data
c
c-----------------------------------------------------------------------
c     add open boundary values to the solution (active open boundary)
c-----------------------------------------------------------------------
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c-----------------------------------------------------------------------
c     passive Orlanski radiation condition (passive open boundary)   
c-----------------------------------------------------------------------
c
      if (my_blk_j == 1 .and. enable_obc_south
     &     .and. .not. prescribe_psi_obc_south ) then
        do i=is,ie
         psi(i,2,1) =psi(i,2,2)  - c1ps(i)*dt*dyur(2)
     &                          *(psi(i,3,2)-psi(i,2,2))
         psi(i,1,1) =psi(i,2,1)
        enddo
      endif

      if (my_blk_j == n_pes_j .and. enable_obc_north
     &    .and. .not. prescribe_psi_obc_north) then
       do i=is,ie
         psi(i,jmt-1,1)=psi(i,jmt-1,2)- c1pn(i)*dt*dyur(jmt-1)
     &                          *(psi(i,jmt-1,2)- psi(i,jmt-2,2))
         psi(i,jmt,1)  =psi(i,jmt-1,1)
       enddo
      endif
c
      if (my_blk_i == 1 .and. enable_obc_west
     &    .and. .not. prescribe_psi_obc_west ) then
       do j=js,je
         psi(2,j,1)   = psi(2,j,2)
     &                       - c1pw(j)*dt*dxur(2)*csur(j)
     &                       *(psi(3,j,2) -psi(2,j,2))
         psi(1,j,1)   = psi(2,j,1)
       enddo
      endif

      if (my_blk_i == n_pes_i .and. enable_obc_east
     &    .and. .not. prescribe_psi_obc_east ) then
       do j=js,je
         psi(imt-1,j,1) = psi(imt-1  ,j,2)
     &                    - c1pe(j)*dt*dxur( imt-1 )*csur(j)
     &                    *(psi(imt-1,j,2)- psi(imt-2,j,2))
         psi(imt,j,1)     = psi(imt-1,j,1)
       enddo
      endif
c
c-----------------------------------------------------------------------
c prescribed streamfunction at open boundary
c (which is however not exact, in a strict mathematically sense
c  since the solver assumes zero boundary conditions for the
c  time tendency of psi )
c-----------------------------------------------------------------------
c

      if (my_blk_j == 1 .and. enable_obc_south
     &     .and. prescribe_psi_obc_south ) then
        do i=is,ie
           psi(i,1:2,1) = psi_wall_south(i)
        enddo
      endif
c
      if (my_blk_j == n_pes_j .and. enable_obc_north
     &    .and. prescribe_psi_obc_north) then
        do i=is,ie
           psi(i,jmt-1:jmt,1) = psi_wall_north(i)
        enddo
      endif
c
      if (my_blk_i == 1 .and. enable_obc_west
     &    .and. prescribe_psi_obc_west ) then
        do j=js,je
          psi(1:2,j,1) = psi_wall_west(j)
        enddo
      endif

      if (my_blk_i == n_pes_i .and. enable_obc_east
     &    .and. prescribe_psi_obc_east ) then
        do j=js,je
          psi(imt-1:imt,j,1) = psi_wall_east(j)
        enddo
      endif
      call adjust_islands_obc
      end subroutine addobcpsi


      subroutine adjust_islands_obc
      use spflame_module
      use island_module
      implicit none
c
c-----------------------------------------------------------------------
c     set southern land masses and perimeter points to southern values
c     of the meridional open boundaries
c-----------------------------------------------------------------------
c
      integer i,j,isle,n,ierr,ii,jj,nn,ifound
      logical connected
      real flow
      logical :: first = .true.
      integer, allocatable :: map_big(:,:)
      integer mnisle_obc,maxipp_obc
      parameter ( mnisle_obc=500,maxipp_obc=40000)
      integer,allocatable ::  iperm_all(:),jperm_all(:)
      integer,allocatable ::  iofs_all(:),nippts_all(:)
      integer, save ::  iperm_obc(maxipp_obc),jperm_obc(maxipp_obc)
      integer, save ::  iofs_obc(mnisle_obc),nippts_obc(mnisle_obc)
      integer, save :: nisle_obc

      if (first) then
       allocate ( map_big(imt,jmt) )
       allocate(  iperm_all(maxipp_obc),jperm_all(maxipp_obc) )
       allocate(  iofs_all(mnisle_obc),nippts_all(mnisle_obc))

       call isleperim (kmt_big, map_big, 
     &    iperm_all, jperm_all, iofs_all, nippts_all, nisle_obc,
     &    imt, jmt,  mnisle_obc, maxipp_obc,1,cyclic,
     &    .false.,.false.,.false.,.false.,.false.)
c
c    Get the island perimeter points on the actual PE
c
       nn = 0
       do isle=1,nisle_obc
        iofs_obc(isle) = nn
        do n=1,nippts_all(isle)
          i = iperm_all(iofs_all(isle)+n)
          j = jperm_all(iofs_all(isle)+n)
          if(i.ge.is_pe.and.i.le.ie_pe.and.
     +       j.ge.js_pe.and.j.le.je_pe) then
            nn = nn+1
            iperm_obc(nn) = i
            jperm_obc(nn) = j
          endif
        end do
        nippts_obc(isle) = nn - iofs_obc(isle)
       end do
       deallocate( map_big,iperm_all,jperm_all, iofs_all,nippts_all)
      endif

      if (enable_obc_east) then
c      see with which islands the obc is connected to
        do isle=1,nisle_obc
         connected=.false.

         do n=1,nippts_obc(isle)
          i = iperm_obc(iofs_obc(isle)+n)
          if (i==imt) connected=.true.
         end do

         call global_lor(connected)

         if (connected) then
c         determine the boundary value for each connected island
          flow=0.
          ifound=0
          do n=1,nippts_obc(isle)
           i = iperm_obc(iofs_obc(isle)+n)
           j = jperm_obc(iofs_obc(isle)+n)
           if (i==imt) then
             ifound=1
             flow=psi(i,j,1)
           endif
          end do

          call global_sum_int(ifound)
          call global_sum(flow)

          if (ifound>0) then
            flow=flow/(1.*ifound)
          else
            print*,' cannot find a boundary value for island',isle
            call halt_stop(' in adjust_islands_obc ')
          endif
c       set all connected island points which are not the obc
c       to the boundary value
          do n=1,nippts_obc(isle)
           i = iperm_obc(iofs_obc(isle)+n)
           j = jperm_obc(iofs_obc(isle)+n)
           psi(i,j,1)=flow
          enddo
         endif  ! connected
        end do ! isle
      endif ! enable_obc_east



      if (enable_obc_west) then
c      see with which islands the obc is connected to
        do isle=1,nisle_obc
         connected=.false.

         do n=1,nippts_obc(isle)
          i = iperm_obc(iofs_obc(isle)+n)
          if (i==1) connected=.true.
         end do

         call global_lor(connected)

         if (connected) then
c         determine the boundary value for each connected island
          flow=0.
          ifound=0
          do n=1,nippts_obc(isle)
           i = iperm_obc(iofs_obc(isle)+n)
           j = jperm_obc(iofs_obc(isle)+n)
           if (i==1) then
             ifound=1
             flow=psi(i,j,1)
           endif
          end do

          call global_sum_int(ifound)
          call global_sum(flow)

          if (ifound>0) then
            flow=flow/(1.*ifound)
          else
            print*,' cannot find a boundary value for island',isle
            call halt_stop(' in adjust_islands_obc ')
          endif
c       set all connected island points which are not the obc
c       to the boundary value
          do n=1,nippts_obc(isle)
           i = iperm_obc(iofs_obc(isle)+n)
           j = jperm_obc(iofs_obc(isle)+n)
           psi(i,j,1)=flow
          enddo
         endif  ! connected
        end do ! isle
      endif ! enable_obc_west


      if ( (enable_obc_south .and. .not. cyclic).or.
     &     (enable_obc_south .and. enable_obc_adjust_islands)
     &            ) then
c      see with which islands the obc is connected to
        do isle=1,nisle_obc
         connected=.false.

         do n=1,nippts_obc(isle)
          j = jperm_obc(iofs_obc(isle)+n)
          if (j==1) connected=.true.
         end do

         call global_lor(connected)

         if (connected) then
c         determine the boundary value for each connected island
          flow=0.
          ifound=0
          do n=1,nippts_obc(isle)
           i = iperm_obc(iofs_obc(isle)+n)
           j = jperm_obc(iofs_obc(isle)+n)
           if (j==1) then
             ifound=1
             flow=psi(i,j,1)
           endif
          end do

          call global_sum_int(ifound)
          call global_sum(flow)

          if (ifound>0) then
            flow=flow/(1.*ifound)
          else
            print*,' cannot find a boundary value for island',isle
            call halt_stop(' in adjust_islands_obc ')
          endif
c       set all connected island points which are not the obc
c       to the boundary value
          do n=1,nippts_obc(isle)
           i = iperm_obc(iofs_obc(isle)+n)
           j = jperm_obc(iofs_obc(isle)+n)
           psi(i,j,1)=flow
          enddo
         endif  ! connected
        end do ! isle
      endif ! enable_obc_souht



      if ((enable_obc_north .and. .not. cyclic ) .or.
     &    (enable_obc_north .and. enable_obc_adjust_islands)
     &   ) then
c      see with which islands the obc is connected to
        do isle=1,nisle_obc
         connected=.false.

         do n=1,nippts_obc(isle)
          j = jperm_obc(iofs_obc(isle)+n)
          if (j==jmt) connected=.true.
         end do

         call global_lor(connected)

         if (connected) then
c         determine the boundary value for each connected island
          flow=0.
          ifound=0
          do n=1,nippts_obc(isle)
           i = iperm_obc(iofs_obc(isle)+n)
           j = jperm_obc(iofs_obc(isle)+n)
           if (j==jmt) then
             ifound=1
             flow=psi(i,j,1)
           endif
          end do

          call global_sum_int(ifound)
          call global_sum(flow)

          if (ifound>0) then
            flow=flow/(1.*ifound)
          else
            print*,' cannot find a boundary value for island',isle
            call halt_stop(' in adjust_islands_obc ')
          endif
c       set all connected island points which are not the obc
c       to the boundary value
          do n=1,nippts_obc(isle)
           i = iperm_obc(iofs_obc(isle)+n)
           j = jperm_obc(iofs_obc(isle)+n)
           psi(i,j,1)=flow
          enddo
         endif  ! connected
        end do ! isle
      endif ! enable_obc_north


      first=.false.
      end subroutine adjust_islands_obc





      subroutine checkerboard (solution)
c-----------------------------------------------------------------------
c     removes "checkboard" null space from an array "solution"
c     author              c.h. goldberg    e-mail => chg@gfdl.gov
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      real    :: solution(is_pe-1:ie_pe+1,js_pe-1:je_pe+1)
      real    :: sum(0:1,0:1)
      integer :: noceansum(0:1,0:1)
      real    :: correction(0:1,0:1),c,redsum,blacksum,diff,x
      integer :: nred,nblack,i1,j1,i,j
c
      sum = 0.0; noceansum = 0
c
      do i1=0,1
        do j1=0,1
          do j=js_pe+j1,je_pe,2
            do i=is_pe+i1,ie_pe,2
              sum(i1,j1) = sum(i1,j1) + solution(i,j)
	      if (map(i,j) .le. 0) then
		noceansum(i1,j1) = noceansum(i1,j1) + 1
              end if
            end do
          end do
        end do
      end do
c
      do i1=0,1
        do j1=0,1
          call global_sum(sum(i1,j1))
          x=noceansum(i1,j1)
          call global_sum(x)
          noceansum(i1,j1)=int(x)
        enddo
      enddo

      redsum   = sum(0,0) + sum(1,1)
      blacksum = sum(1,0) + sum(0,1)
      nred     = noceansum(0,0) + noceansum(1,1)
      nblack   = noceansum(1,0) + noceansum(0,1)
      diff = redsum/nred - blacksum/nblack
      c    = diff / 2.0
c
      if (my_pe==0) then
      print *, ' '
      print '(a,i6,a,i6,a,e14.7)'
     &,         '=> checkerboard: nred = ',nred, ', nblack = ',nblack
     &,         ', removing a checkerboard correction of ', c
      endif
c
      correction (0,0) = -c; correction (1,1) = -c
      correction (1,0) =  c; correction (0,1) =  c
c
      do i1=0,1
        do j1=0,1
          do j=js_pe+j1,je_pe,2
            do i=is_pe+i1,ie_pe,2
              if (map(i,j) .le. 0) then
		solution(i,j) = solution(i,j) + correction(i1,j1)
              end if
            end do
          end do
        end do
      end do
      end subroutine checkerboard



      subroutine zero_level(surfpres, variable)
      use spflame_module
      implicit none
      real :: surfpres(is_pe-1:ie_pe+1,js_pe-1:je_pe+1)
      character (len=*) :: variable
      real :: sum=0., area_ocean=0., area, surfpres0
      integer :: i,j
c
c     this does not correctly handle multiple basins
c
      do i=is_pe,ie_pe
        do j=js_pe,je_pe
	  if (map(i,j) .le. 0) then
            area = dxt(i)*cst(j)*dyt(j)
            sum = sum + surfpres(i,j)*area
            area_ocean = area_ocean + area
	  end if
        end do
      end do
      call global_sum(sum) 
      call global_sum(area_ocean)
      surfpres0 = sum / area_ocean
      do i=is_pe,ie_pe
        do j=js_pe,je_pe
	  if (map(i,j) .le. 0) then
            surfpres(i,j) = surfpres(i,j) - surfpres0
	  end if
        end do
      end do
      if (my_pe==0) then
       print '(a,e14.7,a,a/)'
     & , '=> zero_level: removing a mean of ', surfpres0, ' from '
     & , variable
      endif
      end subroutine zero_level

#include "options.inc"

c
c     convert binary output of time series written by SPFLAME
c     to NetCDF format
c
c     real variables are 8 or 4 bytes long set by
c#define real_8



      module kind_mod
#ifdef real_8
      integer, parameter::  r_knd  = selected_real_kind(13)
#else
      integer, parameter::  r_knd  = selected_real_kind(6)
#endif
      end module kind_mod



      module cv_anna_module
      use kind_mod
      integer :: imt,jmt,km,nr_var,itm,nt,nr_var_given,itt
      real (kind=r_knd),allocatable::xt(:),yt(:),xu(:),yu(:),zt(:),zw(:)
      real (kind=r_knd) :: spval
      integer :: year,month,day,domain,min,sec,hour
      character (len=80) :: infile,outfile
      integer :: block_size=0
      end module cv_anna_module

      program cv_anna
      use cv_anna_module
      implicit none
#include "netcdf.inc"

      character (len=80) :: ident
      character  :: c9*9, c1*1, c2*2, c4*4,c8*8,c6*6
      integer :: i,j,k,n,nn,ierr,io,fsize
      character (len=32) :: stamp
      real (kind=r_knd) :: time,tt
      real (kind=r_knd) ,allocatable :: buf(:,:)

      integer :: ncid,iret,varid
      integer :: dims(4), corner(4), edges(4)
      character (len=80) :: name, unit, text

      print*,' Converting averaged quantities written by SPFLAME ',
     &       ' to NetCDF file '

      call get_commandline_arg(1,infile,ierr)
      if (ierr/=0) goto 99
      nr_var_given = -999
      call  get_commandline_arg_int(2,nr_var_given,iret)

      print*,' reading from file ',infile(1:len_trim(infile))
      read(infile,'(a5,i3,a2,i4,a1,i2,a1,i2,a1,i8)') 
     &            c9,domain,c2,year,c1,month,c1,day,c1,itt
      write(outfile,'("anna_",i3,"_y",i4,"m",i2,"d",i2,"_",i8,".cdf")') 
     &            domain,year,month,day,itt
      call replace_space_zero(outfile)


      print*,' writing to file ',outfile(1:len_trim(outfile))

      call getunit(io,infile,'usr ieee')

      read(io) imt,jmt,km,nt,nr_var
c      read(io) imt,jmt,km,nr_var; nt=2
      print*,' imt=',imt,' jmt=',jmt,' km=',km,' nt=',nt
      if (nr_var_given /= nr_var .and. nr_var_given >0) then
       print*,' file says that ',nr_var,' variables in file '
       print*,' however, that was overuled by command line input'
       nr_var = nr_var_given
       print*,' -> searching for ',nr_var,' variables in file '
      else
       print*,' found ',nr_var,' variables in file '
      endif

      allocate( xt(imt),yt(jmt),xu(imt),yu(jmt),zt(km),zw(km))
      read(io) xt,yt,xu,yu,zt,zw,spval
      zt=zt/100.
      zw=zw/100.

      call cv_anna_define(io)

      fsize=(imt*2+jmt*2+km*2)*4+1024

      itm=0
      iret=nf_open(outfile,NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)

 20   continue
      read(io,end=30) stamp,itt

      print*,' reading time step ', stamp
      print*,' estimated file size: ',fsize/1e6,' Mbytes'


c    check is file is too large 
      fsize=fsize+block_size*4
      if (fsize> 1500e6) then
        print*,' NetCDF file is getting too large'
        print*,' (estimated file size is ',fsize/1e6, 'Mbytes)'
        print*,' closing file ',outfile(1:len_trim(outfile))
        call ncclos (ncid, iret)
         read  (stamp, '(a6,i2,a1,i2,a1,i4,a8,i2,a1,i2,a1,i2)')
     &       c6, month, c1, day, c1, year, c8, hour,
     &       c1, min, c1, sec
        write(outfile,
     &        '("anna_",i3,"_y",i4,"m",i2,"d",i2,"_",i8,".cdf")') 
     &            domain,year,month,day,itt
        call replace_space_zero(outfile)
        print*,' opening file ',outfile(1:len_trim(outfile))
        backspace (io)
        call cv_anna_define(io)
        read(io)
        fsize=(imt*2+jmt*2+km*2)*4+1024
        itm=0
        iret=nf_open(outfile,NF_WRITE,ncid)
        iret=nf_set_fill(ncid, NF_NOFILL, iret)
      endif



      itm=itm+1

      call read_stamp(stamp,tt); time=tt
      iret=nf_inq_varid(ncid,'Time',varid)
      call nf_put_var(ncid,varid, itm,1,time)

      do n=1,nr_var

        read(io) ident

        if (ident(1:3) == 'dml' ) then
         allocate( buf(imt,jmt) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'dml',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'uvts') then
         allocate( buf(imt,jmt) )
         do k=1,km
          corner=(/1,1,k,itm/); edges=(/imt,jmt,1,1/)
          read(io) buf
          iret=nf_inq_varid(ncid,'u',varid)
          call  nf_put_var(ncid,varid ,corner, edges,buf)
          read(io) buf
          iret=nf_inq_varid(ncid,'v',varid)
          call  nf_put_var(ncid,varid ,corner, edges,buf)
          do nn=1,nt
           read(io) buf
           if (nn==1) then 
              name='temp'
           elseif (nn==2) then  
               name = 'salt'
           else
            write(name,'("tracer_",i2)') nn
            call replace_space_zero(name)
           endif
           iret=nf_inq_varid(ncid,name,varid)
           call  nf_put_var(ncid,varid ,corner, edges,buf)
          enddo
         enddo
         deallocate( buf)
        elseif (ident(1:4) == 'potv') then
         allocate( buf(imt,jmt) )
         do k=1,km
          read(io) buf
          corner=(/1,1,k,itm/); edges=(/imt,jmt,1,1/)
          iret=nf_inq_varid(ncid,'potv',varid)
          call  nf_put_var(ncid,varid ,corner, edges,buf)
         enddo
         deallocate( buf)
        elseif (ident(1:4) == 'bvor') then
         allocate( buf(imt,jmt) )
         do k=1,km
          read(io) buf
          corner=(/1,1,k,itm/); edges=(/imt,jmt,1,1/)
          iret=nf_inq_varid(ncid,'bvort',varid)
          call  nf_put_var(ncid,varid ,corner, edges,buf)
         enddo
         deallocate( buf)
        elseif (ident(1:4) == 'pv35') then
         allocate( buf(jmt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/jmt,km,1,1/)
         iret=nf_inq_varid(ncid,'potv35W',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'bv35') then
         allocate( buf(jmt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/jmt,km,1,1/)
         iret=nf_inq_varid(ncid,'bvort35W',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'pv0N') then
         allocate( buf(imt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/imt,km,1,1/)
         iret=nf_inq_varid(ncid,'potv0N',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'bv0N') then
         allocate( buf(imt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/imt,km,1,1/)
         iret=nf_inq_varid(ncid,'bpot0N',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 't100') then
         allocate( buf(imt,jmt) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'t100',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'u100') then
         allocate( buf(imt,jmt) )
         read(io) buf ; where (buf /= spval) buf=buf/100.0
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'u100',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'v100') then
         allocate( buf(imt,jmt) )
         read(io) buf; where (buf /= spval) buf=buf/100.0
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'v100',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:3) == 's50') then
         allocate( buf(imt,jmt) )
         read(io) buf; where ( buf /=spval) buf=buf*1000.0+35.0
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'s50',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:3) == 't50') then
         allocate( buf(imt,jmt) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'t50',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:3) == 'u50') then
         allocate( buf(imt,jmt) )
         read(io) buf; where (buf /= spval) buf=buf/100.0
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'u50',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:3) == 'v50') then
         allocate( buf(imt,jmt) )
         read(io) buf; where (buf /= spval) buf=buf/100.0
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'v50',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:2) == 's0') then
         allocate( buf(imt,jmt) )
         read(io) buf; where ( buf /=spval) buf=buf*1000.0+35.0
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'s0',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:2) == 't0') then
         allocate( buf(imt,jmt) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'t0',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:2) == 'u0' .and. ident(1:3) /= 'u0N' ) then
         allocate( buf(imt,jmt) )
         read(io) buf; where (buf /= spval) buf=buf/100.0
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'u0',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:2) == 'v0') then
         allocate( buf(imt,jmt) )
         read(io) buf; where (buf /= spval) buf=buf/100.0
         corner=(/1,1,itm,1/); edges=(/imt,jmt,1,1/)
         iret=nf_inq_varid(ncid,'v0',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:3) == 'u0N') then
         allocate( buf(imt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/imt,km,1,1/)
         iret=nf_inq_varid(ncid,'u0N',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'Av0N') then
         allocate( buf(imt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/imt,km,1,1/)
         iret=nf_inq_varid(ncid,'Av0N',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'T57N') then
         allocate( buf(imt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/imt,km,1,1/)
         iret=nf_inq_varid(ncid,'T57N',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'u35W') then
         allocate( buf(jmt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/jmt,km,1,1/)
         iret=nf_inq_varid(ncid,'u35W',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'v35W') then
         allocate( buf(jmt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/jmt,km,1,1/)
         iret=nf_inq_varid(ncid,'v35W',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'w35W') then
         allocate( buf(jmt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/jmt,km,1,1/)
         iret=nf_inq_varid(ncid,'w35W',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:3) == 'u5W') then
         allocate( buf(jmt,km) )
         read(io) buf
         corner=(/1,1,itm,1/); edges=(/jmt,km,1,1/)
         iret=nf_inq_varid(ncid,'u5W',varid)
         call  nf_put_var(ncid,varid ,corner, edges,buf)
         deallocate( buf)
        elseif (ident(1:4) == 'bats') then
         allocate( buf(km,nt) )
         read(io) buf
         corner=(/1,itm,1,1/); edges=(/km,1,1,1/)
         do k=1,nt
          if (k==1) then
           name='t_bats'
          elseif (k==2) then
           name='s_bats'
          else
           write(name,'("tr",i2,"_bats")') k
           call replace_space_zero(name)
          endif
          iret= nf_inq_varid(ncid,name,varid)
          call  nf_put_var(ncid,varid ,corner, edges,buf(:,k))
         enddo
         deallocate( buf)

        else ! ident == 
         print*,' problem reading variable ',ident,' from file'
        endif

      enddo



      goto 20

 30   close(io)
      call ncclos (ncid, iret)
      print*,' done'
      stop

 99   print*,' program needs command line parameter'
      print*,' 1. input binary file name (written by spflame)'
      print*,' 2. (optional) number of variables in file'
      end program cv_anna






      subroutine cv_anna_define(io)
      use cv_anna_module
      implicit none
#include "netcdf.inc"

      character (len=80) :: ident
      integer :: ncid,iret,io
      integer :: n,k,nn
      integer :: lat_tdim,lat_udim,lon_tdim,lon_udim
      integer :: lat_tid,lat_uid,lon_tid,lon_uid
      integer :: depth_tdim,depth_wdim,depth_tid,depth_wid
      integer :: itimedim,itimeid,varid
      integer :: dims(4)
      character (len=80) :: name, unit
      integer :: blk 

      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c     dimensions
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      depth_wdim = ncddef(ncid, 'depth_w',  km, iret)
      depth_tdim = ncddef(ncid, 'depth_t',  km, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lon_udim
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lat_udim
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,dims,iret)
      dims(1)  = depth_wdim
      depth_wid = ncvdef (ncid,'depth_w', NCFLOAT,1,dims,iret)
      dims(1)  = depth_tdim
      depth_tid = ncvdef (ncid,'depth_t', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)

c     attributes of the grid
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Latitude on U grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on T grid      '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on U grid     '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of T Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Depth of W Grid points  '; unit = 'm '
      call ncaptc(ncid, depth_wid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, depth_wid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)


      block_size= 2048

      read(io) ! stamp
      blk=1 ! number of blocks to rewind
      do n=1,nr_var
        read(io) ident
        read(io)
        blk=blk+2
        if     (ident(1:3) == 'dml' ) then
         print*,' found mixed layer depth '
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         varid=ncvdef (ncid,'dml', NCFLOAT,3,dims,iret)
         name = 'Mixed layer depth'; unit = 'm'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
         block_size=block_size+imt*jmt
        elseif (ident(1:4) == 'uvts') then
         print*,' found complete u,v,t,s fields '
         dims=(/lon_udim,lat_udim,depth_tdim,itimedim/)
         varid=ncvdef (ncid,'u', NCFLOAT,4,dims,iret)
         name = 'Zonal velocity'; unit = 'm/s'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
         varid=ncvdef (ncid,'v', NCFLOAT,4,dims,iret)
         name = 'Meridional velocity'; unit = 'm/s'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
         dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
         varid=ncvdef (ncid,'temp', NCFLOAT,4,dims,iret)
         name = 'Temperature'; unit = 'deg C'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
         varid=ncvdef (ncid,'salt', NCFLOAT,4,dims,iret)
         name = 'Salinity'; unit = 'psu'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
         if (nt>2) then
          do nn=3,nt
           write(name,'("tracer_",i2)') nn
           call replace_space_zero(name)
           varid=ncvdef (ncid,name, NCFLOAT,4,dims,iret)
           name = 'Passive tracer'; unit = ' '
           call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
          enddo
         endif
         block_size=block_size+imt*jmt*km*(2+nt)

         do k=1,km
          read(io); 
          if (k>1) read(io)
          do nn=1,nt
           read(io)
          enddo
          blk=blk+nt+1
          if (k>1) blk=blk+1
         enddo

        elseif (ident(1:4) == 'potv') then
         print*,' found potential vorticity'
         block_size=block_size+imt*jmt*km
         do k=2,km
          blk=blk+1
          read(io)
         enddo
         dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
         varid=ncvdef (ncid,'potv', NCFLOAT,4,dims,iret)
         name = 'Potential vorticity'; unit = '1/m/s^2'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)

        elseif (ident(1:4) == 'bvor') then
         print*,' found barotropic vorticity'
         block_size=block_size+imt*jmt*km
         do k=2,km
          blk=blk+1
          read(io)
         enddo
         dims=(/lon_tdim,lat_tdim,depth_tdim,itimedim/)
         varid=ncvdef (ncid,'bvort', NCFLOAT,4,dims,iret)
         name = 'Barotropic vorticity'; unit = '1/m/s^2'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'pv35') then
         block_size=block_size+jmt*km
         print*,' found potential vorticity at 35W'
         dims=(/lat_udim,depth_tdim,itimedim,1/)
         varid=ncvdef (ncid,'potv35W', NCFLOAT,3,dims,iret)
         name = 'Potential Vorticity at 35W'; unit = '1/m/s^2'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'bv35') then
         block_size=block_size+jmt*km
         print*,' found barotropic vorticity at 35W'
         dims=(/lat_udim,depth_tdim,itimedim,1/)
         varid=ncvdef (ncid,'bvort35W', NCFLOAT,3,dims,iret)
         name = 'Potential Vorticity at 35W'; unit = '1/m/s^2'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'pv0N') then
         block_size=block_size+imt*km
         print*,' found potential vorticity at 0N'
         dims=(/lon_tdim,depth_tdim,itimedim,1/)
         varid=ncvdef (ncid,'potv0N', NCFLOAT,3,dims,iret)
         name = 'Potential vorticity at Eq.'; unit = '1/m/s^2'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'bv0N') then
         block_size=block_size+imt*km
         print*,' found barotropic vorticity at 0N'
         dims=(/lon_tdim,depth_tdim,itimedim,1/)
         varid=ncvdef (ncid,'bpot0N', NCFLOAT,3,dims,iret)
         name = 'Barotropic vorticity at Eq.'; unit = '1/m/s^2'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 't100') then
         block_size=block_size+imt*jmt
         print*,' found temperature in 100m depth '
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         varid=ncvdef (ncid,'t100', NCFLOAT,3,dims,iret)
         name = 'Temperature in 100m'; unit = 'deg C'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'u100') then
         block_size=block_size+imt*jmt
         print*,' found zonal velocity in 100m depth '
         dims=(/lon_udim,lat_udim,itimedim,1/)
         varid =ncvdef (ncid,'u100', NCFLOAT,3,dims,iret)
         name = 'Zonal velocity in 100m'; unit = 'm/s'
         call dvcdf_here(ncid,varid ,name,len_trim(name),
     &                  unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'v100') then
         print*,' found meridional velocity in 100m depth '
         block_size=block_size+imt*jmt
         dims=(/lon_udim,lat_udim,itimedim,1/)
         varid =ncvdef (ncid,'v100', NCFLOAT,3,dims,iret)
         name = 'Meridional velocity in 100m'; unit = 'm/s'
         call dvcdf_here(ncid,varid ,name,len_trim(name),
     &                  unit,len_trim(unit),spval)
        elseif (ident(1:3) == 's50') then
         print*,' found salinity in 50m depth '
         block_size=block_size+imt*jmt
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         varid =ncvdef (ncid,'s50', NCFLOAT,3,dims,iret)
         name = 'Salinity in 50m'; unit = 'psu'
         call dvcdf_here(ncid,varid ,name,len_trim(name),
     &                 unit,len_trim(unit),spval)
        elseif (ident(1:3) == 't50') then
         print*,' found temperature in 50m depth '
         block_size=block_size+imt*jmt
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         varid =ncvdef (ncid,'t50', NCFLOAT,3,dims,iret)
         name = 'Temperature in 50m'; unit = 'deg C'
         call dvcdf_here(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:3) == 'u50') then
         print*,' found zonal velocity in 50m depth '
         block_size=block_size+imt*jmt
         dims=(/lon_udim,lat_udim,itimedim,1/)
         varid =ncvdef (ncid,'u50', NCFLOAT,3,dims,iret)
         name = 'Zonal velocity in 50m'; unit = 'm/s'
         call dvcdf_here(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:3) == 'v50') then
         print*,' found meridional velocity in 50m depth '
         block_size=block_size+imt*jmt
         dims=(/lon_udim,lat_udim,itimedim,1/)
         varid =ncvdef (ncid,'v50', NCFLOAT,3,dims,iret)
         name = 'Meridional velocity in 50m'; unit = 'm/s'
         call dvcdf_here(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:2) == 's0') then
         print*,' found salinity in 0m depth '
         block_size=block_size+imt*jmt
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         varid =ncvdef (ncid,'s0', NCFLOAT,3,dims,iret)
         name = 'Salinity in 0m'; unit = 'psu'
         call dvcdf_here(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:2) == 't0') then
         print*,' found temperature in 0m depth '
         dims=(/lon_tdim,lat_tdim,itimedim,1/)
         varid =ncvdef (ncid,'t0', NCFLOAT,3,dims,iret)
         name = 'Temperature in 0m'; unit = 'deg C'
         call dvcdf_here(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:2) == 'u0' .and. ident(1:3) /= 'u0N' ) then
         print*,' found zonal velocity in 0m depth '
         block_size=block_size+imt*jmt
         dims=(/lon_udim,lat_udim,itimedim,1/)
         varid =ncvdef (ncid,'u0', NCFLOAT,3,dims,iret)
         name = 'Zonal velocity in 0m'; unit = 'm/s'
         call dvcdf_here(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:2) == 'v0') then
         print*,' found meridional velocity in 0m depth '
         block_size=block_size+imt*jmt
         dims=(/lon_udim,lat_udim,itimedim,1/)
         varid =ncvdef (ncid,'v0', NCFLOAT,3,dims,iret)
         name = 'Meridional velocity in 0m'; unit = 'm/s'
         call dvcdf_here(ncid,varid ,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:3) == 'u0N')  then
         print*,' found zonal vel. at eq.'
         block_size=block_size+imt*km
         dims=(/lon_udim,depth_tdim,itimedim,1/)
         varid=ncvdef (ncid,'u0N', NCFLOAT,3,dims,iret)
         name = 'Zonal velocity at Eq.'; unit = 'm/s'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'Av0N')  then
         print*,' found vertical viscosity at eq.'
         block_size=block_size+imt*km
         dims=(/lon_udim,depth_wdim,itimedim,1/)
         varid=ncvdef (ncid,'Av0N', NCFLOAT,3,dims,iret)
         name = 'Vertical viscosity at Eq.'; unit = 'm/s'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'T57N')  then
         print*,' found temperature at 57N'
         block_size=block_size+imt*km
         dims=(/lon_tdim,depth_tdim,itimedim,1/)
         varid=ncvdef (ncid,'T57N', NCFLOAT,3,dims,iret)
         name = 'Temperature at 57N'; unit = 'deg C'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'u35W') then
         print*,' found zonal vel. at 35W'
         block_size=block_size+jmt*km
         dims=(/lat_udim,depth_tdim,itimedim,1/)
         varid=ncvdef (ncid,'u35W', NCFLOAT,3,dims,iret)
         name = 'Zonal velocity at 35W'; unit = 'm/s'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'v35W') then
         print*,' found merid vel. at 35W'
         block_size=block_size+jmt*km
         dims=(/lat_udim,depth_tdim,itimedim,1/)
         varid=ncvdef (ncid,'v35W', NCFLOAT,3,dims,iret)
         name = 'Merid. velocity at 35W'; unit = 'm/s'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'w35W') then
         print*,' found vert. vel. at 35W'
         block_size=block_size+jmt*km
         dims=(/lat_udim,depth_wdim,itimedim,1/)
         varid=ncvdef (ncid,'w35W', NCFLOAT,3,dims,iret)
         name = 'Vertical velocity at 35W'; unit = 'm/s'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:3) == 'u5W') then
         print*,' found zonal vel. at 5W'
         block_size=block_size+jmt*km
         dims=(/lat_udim,depth_tdim,itimedim,1/)
         varid=ncvdef (ncid,'u5W', NCFLOAT,3,dims,iret)
         name = 'Zonal velocity at 5W'; unit = 'm/s'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &              unit,len_trim(unit),spval)
        elseif (ident(1:4) == 'bats') then
         print*,' found station BATS'
         block_size=block_size+km*nt
         dims=(/depth_tdim,itimedim,1,1/)
         varid=ncvdef (ncid,'t_bats', NCFLOAT,2,dims,iret)
         name = 'Temperature at 65W, 32N'; unit = 'deg C'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &                    unit,len_trim(unit),spval)
         varid=ncvdef (ncid,'s_bats', NCFLOAT,2,dims,iret)
         name = 'Salinity at 65W, 32N'; unit = 'psu'
         call dvcdf_here(ncid,varid,name,len_trim(name),
     &                    unit,len_trim(unit),spval)
         do k=3,nt
          write(name,'("tr",i2,"_bats")') k
          call replace_space_zero(name)
          varid=ncvdef (ncid,name, NCFLOAT,2,dims,iret)
          write(name,'("Passive tracer ",i2)') k; unit = ' '
          call dvcdf_here(ncid,varid,name,len_trim(name),
     &                    unit,len_trim(unit),spval)
         enddo
        else
          print*,' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
          print*,' Warning: do not know how to read ',ident,' from file'
          print*,' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        endif

      enddo

      call ncendf(ncid, iret)

      call  nf_put_var(ncid,lat_tid ,1, jmt,yt)
      call  nf_put_var(ncid,lat_uid ,1, jmt,yu)
      call  nf_put_var(ncid,lon_tid ,1, imt,xt)
      call  nf_put_var(ncid,lon_uid ,1, imt,xu)
      call  nf_put_var(ncid,depth_tid ,1, km,zt)
      call  nf_put_var(ncid,depth_wid ,1, km,zw)

      call ncclos (ncid, iret)


      do k=1,blk
         backspace(io) 
      enddo

      end subroutine cv_anna_define








      subroutine dvcdf_here(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      use kind_mod
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character*(*) name, unit
      real (kind=r_knd):: spval
#include "netcdf.inc"
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
#ifdef real_8
      iret=nf_put_att_double(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_double(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#else
      iret=nf_put_att_real(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_real(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#endif
c        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf_here



      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end


      subroutine nf_put_var(ncid,varid,corner,edges,dd)
      use kind_mod
      implicit none
#include "netcdf.inc"
      integer :: ncid,varid,corner,edges,iret
      real (kind=r_knd) :: dd
#ifdef real_8
      iret= nf_put_vara_double(ncid,varid,corner,edges,dd)
#else
      iret= nf_put_vara_real(ncid,varid,corner,edges,dd)
#endif
      end subroutine nf_put_var


      subroutine get_file_size(size)
c-----------------------------------------------------------------------
c     returns the file size in bytes
c-----------------------------------------------------------------------
      implicit none
      integer :: size
      
      end subroutine get_file_size

#include "options.inc"


      program driver
c
c--------------------------------------------------------------
c     drive SPFLAME from here
c     c.eden
c--------------------------------------------------------------
c
      use timing_module
      implicit none
      integer ierr,domains,my_comm,sub_domain,n
      integer,allocatable :: n_pes_domains(:)
      integer,allocatable :: sub_domain_pe0(:)
      logical :: eorun = .false.

      call mpi_init(ierr)
      call mpi_test()

      call tic('setup')
c
c     read the command line
c
      call get_commandline_arg_int(1,domains,ierr)
      if (ierr/=0) goto 999
      allocate(n_pes_domains(domains),sub_domain_pe0(domains))
      do n=1,domains
       call get_commandline_arg_int(n+1,n_pes_domains(n),ierr)
       if (ierr/=0) goto 999
      enddo
c
c     orchestrating all the processors
c
      call split_pes(domains,n_pes_domains,
     &                   my_comm,sub_domain,sub_domain_pe0)
c
c     redirect stdout to files for sub domains
c
      if (sub_domain >0) call redirect_stdout(sub_domain)
c
c     set up the model and do first domain exchange
c
      call setup(domains,sub_domain,sub_domain_pe0,my_comm)
      call setvbc
      call domain_exchg

      call toc('setup')
c
c     here is the main loop
c
  20  continue
      call spflame(eorun)
#ifdef couple
      if (.not.eorun) call sbc_couple
#endif
      if (.not. eorun ) goto 20
c
c     clean up, write restart
c
      call tic('cleanup')
#ifdef couple
c
c     write also restart for OASIS
c
      call sbc_couple_write_restart
#endif
      call write_restart_file
      call bcast_world_logical(eorun,1,0)  ! a barrier
      call toc('cleanup')

      call show_timing()
c
c     and stop
c
      call mpi_finalize(ierr)
      stop
 999  print*,' Usage:  ./program_name "Number of domains"',
     &       ' "Number of PEs for 1. domain"',
     &       ' "Number of PEs for 2. domain" ...'
      print*,' '
      call halt_stop('error in command line arguments')
      end program driver



      subroutine spflame(eorun)
c
c--------------------------------------------------------------
c     main loop for SPFLAME, measure time for the main routines
c--------------------------------------------------------------
c
      use spflame_module

      implicit none
      logical :: eorun 
      integer :: nmax,n
      character (len=32) :: stamp

      call tic('domexchg')
      call nmax_exchg(nmax)
      call toc('domexchg')

      call tic('main')
      do n=1,nmax
 20    call time_step_begin()

       if (enable_freesurf) call calc_thickness

       call tic('setvbc')
       call setvbc
       call toc('setvbc')

       call tic('isopyc')
       if (enable_diffusion_isoneutral) call isoneutral
       if (enable_diffusion_isopycnic)  call isopycnic
       call toc('isopyc')

       call tic('vmixc')
       call vmixc
       call toc('vmixc')
     
       call tic('adv_vel')
       call adv_vel
       call toc('adv_vel')

       call tic('clinic')
       call clinic
       call toc('clinic')

       call tic('tracer')
       call tracer
       call toc('tracer')

       call tic('tropic')
       if (enable_freesurf) then
        call freesurf
       else
        call rigid_lid
       endif
       call toc('tropic')


       call tic('diag')
       call diag
       call toc('diag')


       call time_step_end()
       if (eulerback2) goto 20    ! do the second part of the euler backw. 

      enddo
      call toc('main')

      call tic('domexchg')
      call domain_exchg
      call toc('domexchg')

      eorun=.false.;if (end_of_run) eorun=.true.
c
c     make sure that all pes quit their loops
c     PE 0 of sub domain 0 is the reference
c
      call bcast_world_logical(eorun,1,0) 
      call sub_flush(6)
      end subroutine spflame





      subroutine show_timing()
c
c--------------------------------------------------------------
c     show timing results here
c--------------------------------------------------------------
c
      use spflame_module
      implicit none
      real :: x1,x2,x3,x4
      integer :: npe,iret


#ifdef timing
      do npe = 0,n_pes
       call barrier

      if (my_pe == npe) then
      x1= timing_secs('main')/100.

      print*,''
      print*,'Timing summary for PE #',my_pe, 
     &  ' on sub_domain #',sub_domain

      print*,' MOM loop time summary    = ',
     &   timing_secs('main') ,' s'

      print*,' setup time summary       = ',
     &   timing_secs('setup'),' s'

      print*,' cleanup time summary     = ',
     &   timing_secs('cleanup'),' s'

      print*,' Domain exchange time     = ',
     &   timing_secs('domexchg'),' s',
     &   '=',timing_secs('domexchg')/x1, '%'

      print*,' adv_vel time summary     = ',
     &   timing_secs('adv_vel'),' s',' =',
     &   timing_secs('adv_vel')/x1,'%'

      print*,' clinic time summary      = ',
     &   timing_secs('clinic'),' s',' =',
     &   timing_secs('clinic')/x1,'%'

      print*,' tracer time summary      = ',
     &   timing_secs('tracer'),' s',' =',
     &   timing_secs('tracer')/x1,'%'

      print*,' passive tr. time summary = ',
     &   timing_secs('passive tracer'),' s',' =',
     &   timing_secs('passive tracer')/x1,'%'

      if (enable_freesurf) then
       print*,' free surf time summary  = ',
     &   timing_secs('tropic'),' s',' =',
     &   timing_secs('tropic')/x1,'%'
      else
       print*,' tropic time summary      = ',
     &   timing_secs('tropic'),' s',' =',
     &   timing_secs('tropic')/x1,'%'
      endif

      print*,' isopyc time summary      = ',
     &   timing_secs('isopyc'),' s',' =',
     &   timing_secs('isopyc')/x1,'%'

      print*,' setvbc time summary      = ',
     &   timing_secs('setvbc'),' s',' =',
     &   timing_secs('setvbc')/x1,'%'

      print*,' diag time summary        = ',
     &   timing_secs('diag'),' s',' =',
     &   timing_secs('diag')/x1,'%'

      print*,' vmixc time summary       = ',
     &   timing_secs('vmixc'),' s',' =',
     &   timing_secs('vmixc')/x1,'%'

      print*,' costs for measuring      = ',
     &   timing_secs('tictoc'),' s',' =',
     &   timing_secs('tictoc')/x1,'%'


#ifdef detailed_timing

        print*,''
        print*,'More details for PE #',my_pe
        print*,''
        print*,' for tracer :'
        x1=timing_secs('tracer main')/100.
        print*,' tend  = ',timing_secs('tracer tendency')/x1 
        print*,' convt = ',timing_secs('tracer convect')/x1 
        print*,' ktmix = ',timing_secs('tracer ktmix')/x1 
        print*,' adv   = ',timing_secs('tracer adv')/x1 
        print*,' diff  = ',timing_secs('tracer diff')/x1 
        print*,' mpp   = ',timing_secs('tracer mpp')/x1 
        print*,' obc   = ',timing_secs('tracer obc')/x1 
        print*,' impli = ',timing_secs('tracer implicit')/x1 
c        print*,' c rho = ',timing_secs('convect rho')/x1 
c        print*,' c mix = ',timing_secs('convect mix')/x1 

        x2=0.
        x2=x2+timing_secs('tracer tendency')/x1 
        x2=x2+timing_secs('tracer convect')/x1 
        x2=x2+timing_secs('tracer ktmix')/x1 
        x2=x2+timing_secs('tracer adv')/x1 
        x2=x2+timing_secs('tracer diff')/x1 
        x2=x2+timing_secs('tracer mpp')/x1 
        x2=x2+timing_secs('tracer obc')/x1 
        x2=x2+timing_secs('tracer implicit')/x1 
        print*,' sum = ',x2
        print*,' for clinic :'
        x1=timing_secs('clinic main')/100.
        print*,' dens = ',timing_secs('clinic density')/x1 
        print*,' tend = ',timing_secs('clinic tend')/x1 
        print*,' biha = ',timing_secs('clinic biha')/x1 
        print*,' adv  = ',timing_secs('clinic adv')/x1 
        print*,' diff = ',timing_secs('clinic diff')/x1 
        print*,' obc  = ',timing_secs('clinic obc')/x1 
        print*,' impli= ',timing_secs('clinic impli')/x1 
        if (enable_freesurf) then
         print*,' for free surface :'
        else
         print*,' for tropic :'
         x1=timing_secs('tropic')/100.
         print*,' zu exchg = ',timing_secs('tropic zu exchg')/x1 
         print*,' forcing  = ',timing_secs('tropic forc')/x1 
         print*,' congrad  = ',timing_secs('tropic congr')/x1 
         print*,' phase vel= ',timing_secs('tropic phase')/x1 
         print*,' obc      = ',timing_secs('tropic obc')/x1 
         print*,' add ext  = ',timing_secs('tropic addext')/x1 
        endif
#endif

       endif
       call sub_flush(6)
       call barrier
      enddo

#endif

      end subroutine show_timing

#include "options.inc"

c
c
c
c     changes in the main code:
c
c       zu and ubar in clinic are computed differently
c       in adv_vel call of convU and changed adv_vbt(:,0,:)
c       in spflame call of freesurf instead of tropic
c          (also changes for timing analysis)
c           and call of calc_thickness
c       in setup call of init_freesurf
c       in diag, write eta
c
c       to do : restart IO, diagnostics, domain exchg
c
c
      module freesurf_module
      implicit none

!----------------------------------------------------------------------------
c
c     Compute the barotropic fields:
c     vertically averaged velocity ubar and free surface height etat  
c
c     Two main options
c      
c     A. linear
c     Keeps the ocean volume constant.  Does not conserve tracers. 
c     Similar to the equations solved with Killworth etal
c     1991 and Dukowicz and Smith 1993.
c     Is enabled using not option partial_cell
c
c     B. nonlinear
c     Top ocean cell undulates in time using partial cell methods. 
c     Total tracers constant if no boundary fluxes and dtts=dtuv.
c     Is enabled using option partial_cell
c
c     Basics of the algorithm:
c
c     1. The baroclinic equations have been previously solved for
c     time taup1 = T0+dtuv = itt*dtuv. The vertically integrated
c     forcing terms zu, centered at baroclinic time tau=T0, are known.  
c
c     2. Using zu as forcing terms, held fixed at time tau=T0,
c     the barotropic equations are integrated for N=2*dtuv/dtsf 
c     barotropic timesteps t, each of length dtsf. 
c     The barotropic integration goes from baroclinic 
c     time T0 to T0+2*dtuv (tau to tau+2).
c
c     3. To update the ocean surface height onto the baroclinic
c     time step taup1=T0+dtuv, a leap-frog is used.  However, the 
c     eta(taum1) value is taken from the time averaged eta(taum1),
c     instead of using a Robert time filter.  This approach
c     leads to a smoother and more stable solution.  If the
c     nonlinear free surface is used, then eta(taup1) is used 
c     to update the top cell thicknesses dht(i,1,j) & dhu(i,1,j).
c
c     4. For the nonlinear free surface, the updated full velocity is
c     computed in loadmw.  The corrected updated barotropic velocity
c     is diagnosed from the updated full velocity and eta(taup1).
c     This corrected ubar is used to initialize the next barotropic
c     time step.  
c
c     For spin-ups to equlibrium in coarse models, long tracer 
c     time steps are available, so far as the scheme remains
c     numerically stable.  However, conservation is manifest
c     only with the nonlinear free surface and with dtts=dtuv.  
c
c     authors:
c             R. C. Pacanowski e-mail=> rcp@gfdl.gov    
c             S. M. Griffies   e-mail=> smg@gfdl.gov 
c
c     main variables
c
!     ps    = surface pressure (,,1) is for tau, (,,2) is for tau-1 
!     etat  = surface height on T-cell. 
!             (,,1) is for leap-frog tau and taup1,
!             (,,2) is for time mean tau and tau-1, 
!             (,,3) is for time mean tau and taup1
!     etau  = surface height on U-cells at tau.  diagnosed from etat
!     depthu = time varying depth of a U column; updated on baroclinic times.
!     depthur= 1/depthu
!     thicktau  =top level thickness at tau; from leap-frog etat 
!     emsk  = surface land/sea mask on T-cells
!     umsk  = surface land/sea mask on U-cells
!     ubar  = barotropic velocity defined on U point for "tau" 
!             (,,1) is zonal and (,,2) is meridional velocity
!     convU = convergence of vertically integrated flow (cm/sec)
!     rhosurf = density in surface level.
!----------------------------------------------------------------------------

      real :: volume_tot, salt_tot

      real, allocatable :: umsk(:,:),emsk(:,:)
      real, allocatable :: depthu(:,:),depthur(:,:)
      real, allocatable :: convU(:,:)
      real, allocatable :: rhosurf(:,:)
      real, allocatable :: etau(:,:)
      real, allocatable :: thicktau(:,:)

      real, allocatable :: ubar(:,:,:)
      real, allocatable :: etat(:,:,:)
      real, allocatable :: ps(:,:,:)

      real :: dt_fs 
      real, parameter :: thickmin = 10.0

      real :: obc_etanull = 0.            ! reference water level at open boundaries
c      real :: obc_rest    = 1./(86400.*5) ! restoring time scale for that reference
      real :: obc_rest    = 0.5 ! restoring time scale for that reference

      end module freesurf_module




      subroutine init_freesurf
      use spflame_module
      use freesurf_module
      implicit none
      integer i,j
      real :: dt_min,dt_loc,c_max,c_loc
c
c=======================================================================
c     Initialize some terms for free surface.
c=======================================================================
c
      if (my_pe==0) then
        print*,''
        print*,' Initialising free surface formulation '
        print*,''
      endif

      dt_min =  1e20; c_max  = -1e20
      do j=1,jmt
        do i=1,imt
         if (kmt_big(i,j) >0) then
          c_loc = sqrt(grav*zw(kmt_big(i,j) ))
          dt_loc=min(dxt(i)*cst(j),dyt(j)) / (2*c_loc)
          dt_min = min( dt_loc, dt_min)
          c_max  = max( c_loc , c_max)
         endif
        enddo
      enddo
      dt_fs = time_step / nint( time_step/dt_min ) 
      if (my_pe==0) then
        print*,' maxmimal gravity phase speed ',c_max/100.,' m/s'
        print*,' time step restriction        ',dt_min,' s'
        print*,' time step of barotropic mode ',dt_fs,' s'
        print*,' time step of baroclinic mode ',time_step,' s'
      endif

#ifdef partial_cell
      if (my_pe==0) then
       print*,' Using the nonlinear formulation: '
       print*,'  Top ocean cell undulates in time using partial cells.'
       print*,'  Total tracers should be constant now '
       print*,'  if no there are no boundary fluxes. '
      endif
#else
      if (my_pe==0) then
       print*,' Using the linear formulation: '
       print*,'  The ocean volume should be constant,'
       print*,'  however,  tracers are not conserved'
       print*,'  Similar to the equations solved with Killworth etal'
       print*,'  1991 and Dukowicz and Smith 1993.'
      endif
#endif

      volume_tot = 0.; salt_tot   = 0.

      allocate( umsk    (is_pe-1:ie_pe+1,js_pe-1:je_pe+1) )
      allocate( emsk    (is_pe-1:ie_pe+1,js_pe-1:je_pe+1) )
      allocate( depthu  (is_pe-1:ie_pe+1,js_pe-1:je_pe+1) )
      allocate( depthur (is_pe-1:ie_pe+1,js_pe-1:je_pe+1) )
      allocate( convU   (is_pe-1:ie_pe+1,js_pe-1:je_pe+1) )
      allocate( rhosurf (is_pe-1:ie_pe+1,js_pe-1:je_pe+1) )
      allocate( etau    (is_pe-1:ie_pe+1,js_pe-1:je_pe+1) )
      allocate( thicktau(is_pe-1:ie_pe+1,js_pe-1:je_pe+1) )

      allocate( ubar  (is_pe-1:ie_pe+1,js_pe-1:je_pe+1,2) )
      allocate( etat  (is_pe-1:ie_pe+1,js_pe-1:je_pe+1,3) )
      allocate( ps    (is_pe-1:ie_pe+1,js_pe-1:je_pe+1,2) )

      convU      = 0.
      etau       = 0.
      thicktau   = dzt(1)
      umsk=0.
      emsk=0.
      depthu=0.
      depthur=0.

      do j=js_pe,je_pe
        do i=is_pe,ie_pe
          umsk(i,j)       = min(kmu(i,j),1)
          emsk(i,j)       = min(kmt(i,j),1)
          depthur(i,j)    = hr(i,j)
        enddo
      enddo
      do j=js_pe,je_pe
        do i=is_pe,ie_pe
         if (kmu(i,j)>0) then
#ifdef partial_cell
          depthu(i,j) = hup(i,j)
#else
          depthu(i,j) = zw(kmu(i,j))
#endif
         else
          depthu(i,j) = 0.
         endif
        enddo
      enddo

      call border_exchg(umsk,1,1)
      call set_cyclic  (umask,1,1)
      call border_exchg(emsk,1,1)
      call set_cyclic  (emsk,1,1)
      call border_exchg(depthu,1,1)
      call set_cyclic  (depthu,1,1)
      call border_exchg(depthur,1,1)
      call set_cyclic  (depthur,1,1)
c
c     this is weird and taken from MOM3, no barotropic vel. at obc?
c     do not use that
c
      if (enable_obc_west.and.my_blk_i==1) then  
c       umsk(1,:)   = 0.; umsk(2,:)   = 0.
      endif
      if (enable_obc_east.and.my_blk_i==n_pes_i) then  
c       umsk(imt,:)   = 0.; umsk(imt-1,:) = 0.
      endif
      if (enable_obc_south.and.my_blk_j==1) then  
c       umsk(:,1)   = 0.; umsk(:,2)   = 0.
      endif
      if (enable_obc_north.and.my_blk_j==n_pes_j) then  
c       umsk(:,jmt)     = 0.; umsk(:,jmt-1)   = 0.
      endif

      rhosurf    = rho0*emsk
c
c     the following variables should be read from the restart
c     or set by as initial conditions
c
      ubar(:,:,:)   = 0.
      etat(:,:,:)   = 0.
      ps(:,:,:)     = 0.
c
      if (my_pe==0) then
        print*,''
        print*,' Free surface initialization done '
        print*,''
      endif
      end subroutine init_freesurf




      subroutine calc_convU 
      use spflame_module
      use freesurf_module
      implicit none
      integer :: is,ie,js,je
      integer :: i,j,jm1
      real :: factor
c
c=======================================================================
c     Compute surface vertical velocity centered on bottom of T-cell
c=======================================================================
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      do j=js,je
        jm1=max(1,j-1)
        do i=is,ie
          factor = cstr(j)*dxt2r(i)*dytr(j)
          convU(i,j) = -factor
     &         *(
     &         dyu(j)*(depthu(i,j)*ubar(i,j,1)
     &         -depthu(i-1,j)*ubar(i-1,j,1))
     &         + dyu(jm1)*(depthu(i,jm1)*ubar(i,jm1,1)
     &         -depthu(i-1,jm1)*ubar(i-1,jm1,1))
     &         + dxu(i)*(csu(j)*depthu(i,j)*ubar(i,j,2)
     &         -csu(jm1)*depthu(i,jm1)*ubar(i,jm1,2))
     &         + dxu(i-1)*(csu(j)*depthu(i-1,j)*ubar(i-1,j,2)
     &         -csu(jm1)*depthu(i-1,jm1)*ubar(i-1,jm1,2))
     &         )       
        enddo
      enddo
      call border_exchg(convU,1,1)
      call set_cyclic(  convU,1,1)
      end subroutine calc_convU




      subroutine freesurf
      use spflame_module
      use freesurf_module
      implicit none
c
c=======================================================================
c     time stepping of the explicit free surface
c=======================================================================
c
c     eta    = sea surface elevation in cm at barotropic time t
      real ::  eta   (is_pe-1:ie_pe+1,js_pe-1:je_pe+1)
c     etap   = sea surface elevation in cm at barotropic time t+1
      real ::  etap  (is_pe-1:ie_pe+1,js_pe-1:je_pe+1)
c     hubar  = depth over u-cells * barotropic velocity
      real ::  hubar(is_pe-1:ie_pe+1,js_pe-1:je_pe+1,2)
c
      real :: etarel(is_pe-1:ie_pe+1,js_pe-1:je_pe+1)
      real :: conv_hu(is_pe:ie_pe,js_pe:je_pe),conv_bar
      real :: utempm(is_pe:ie_pe,2)
      real :: gravrho0, gravrho0r  
      real :: fc,fx,fy
      integer :: is,ie,js,je,i,j,k,n,nb,itbt
      real :: de,cp,cmax,etamin,etamax,etashift

      gravrho0   = grav*rho0  
      gravrho0r  = 1./gravrho0

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      if (eulerback2) then
c
c       just add external mode to u at tau+1
c
        goto 20
      endif

      if (eulerback1 .or. eulerfore) then
c
c       just go ahead
c
      endif

      call border_exchg(zu(:,:,1),1,1)
      call border_exchg(zu(:,:,2),1,1)
      call set_cyclic(zu(:,:,1),1,1)
      call set_cyclic(zu(:,:,2),1,1)
c
c-----------------------------------------------------------------------
c     initialization for barotropic equations
c-----------------------------------------------------------------------
c
c     calculate surface density
c
      do j=js-1,je+1
       call model_dens(t(is-1,1,j,1,tau), t(is-1,1,j,2,tau),
     &                 rhosurf(is-1,j),1,ie-is+3
#ifdef partial_cell
     &                       ,ztp(is-1,1,j)
#endif
     &                       )
       rhosurf(is-1:ie+1,j) = (rhosurf(is-1:ie+1,j) + rho0)
     &                         *tmask(is-1:ie+1,1,j)      
      enddo
c
c     shift (tau) into (tau-1) for next baroclinic time step
c
      ps(:,:,2)     = ps(:,:,1) 
c
c     save leap-frog etat(tau) in thicktau
c     save time mean etat(tau) temporarily in etat(..,1)
c
      thicktau      = max(thickmin,dzt(1)+etat(:,:,1))
      etat(:,:,1)   = etat(:,:,3)
c
c     initialize fields used in the barotropic time stepping 
c
      eta           = etat(:,:,3)
      etap          = 0.
      hubar(:,:,1)  = depthu(:,:)*ubar(:,:,1)
      hubar(:,:,2)  = depthu(:,:)*ubar(:,:,2)
      etarel        = 0.
c
c     initialize ubar for temporary accumulation of hubar
c
      ubar = hubar 
c
c=======================================================================
c     integrate barotropic equations for "nb" barotropic time steps
c     using an Euler forward-backward scheme from baroclinic time T0
c     to baroclinic time T0+2*dtuv.  
c=======================================================================
c
      nb = 2*nint(dt/dt_fs)

      do itbt=1,nb
c
c-----------------------------------------------------------------------
c       time step free surface height using a forward barotropic step
c-----------------------------------------------------------------------
c
        do j=js,je
	  do i=is,ie
	    conv_hu(i,j)  = -dxt2r(i)*dytr(j)*cstr(j)
     &                    *( hubar(i  ,j,1  )*dyu(j)
     &                      +hubar(i,j-1,1  )*dyu(j-1)
     &                    -( hubar(i-1,j,1  )*dyu(j)
     &                      +hubar(i-1,j-1,1)*dyu(j-1))
     &                    +( hubar(i,j,2)*dxu(i) + 
     &                       hubar(i-1,j,2)*dxu(i-1))*csu(j)
     &                    -( hubar(i,j-1,2)*dxu(i) + 
     &                       hubar(i-1,j-1,2)*dxu(i-1))*csu(j-1))
	    etap(i,j) = emsk(i,j) * (eta(i,j) + dt_fs*conv_hu(i,j) )
	  enddo
        enddo
c
c-----------------------------------------------------------------------
c       radiation condition for free surface at open boundaries
c-----------------------------------------------------------------------
c
        if (enable_obc_south.and. my_blk_j==1) then  
         j = 2
         do i=is,ie
           de= eta(i,j+2) - eta(i,j+1)
#ifdef partial_cell
           cmax = -2.*sqrt(grav*htp(i,j) )    
#else
           cmax = -2.*sqrt(grav*zw(max(1,kmt(i,j))))    
#endif
           if (de == 0.) then
             cp = cmax
           else
            cp =-dyu(j+1)/dt_fs*(etap(i,j+1)-eta(i,j+1))/de
            if (cp >= 0.)  cp = 0.
            if (cp < cmax) cp = cmax
           endif
           etap(i,j)=eta(i,j)-cp*dt_fs*dyur(j)*(eta(i,j+1)-eta(i,j))
         enddo
        endif

        if (enable_obc_north.and.my_blk_j==n_pes_j) then
         j = jmt-1
         do i=is,ie
          de = eta(i,j-1) - eta(i,j-2)
#ifdef partial_cell
          cmax = 2.*sqrt(grav*htp(i,j))
#else
          cmax = 2.*sqrt(grav*zw(max(1,kmt(i,j))))
#endif
          if (de == 0.) then
           cp = cmax
          else
           cp = -dyu(j-1)/dt_fs*(etap(i,j-1)-eta(i,j-1))/de
           if (cp <= 0.)  cp = 0.
           if (cp > cmax) cp = cmax
          endif
          etap(i,j)=eta(i,j)-cp*dt_fs*dyur(j)*(eta(i,j)-eta(i,j-1))
         enddo
        endif

        if (enable_obc_west.and.my_blk_i==1) then
         i = 2
         do j=js,je
          de = etap(i+2,j) - etap(i+1,j)
#ifdef partial_cell
          cmax = -2.*sqrt(grav*htp(i,j))
#else
          cmax = -2.*sqrt(grav*zw(max(1,kmt(i,j))))
#endif
          if (de == 0.) then
           cp = cmax
          else
           cp=-dxu(i+1)*csu(j)/dt_fs*(etap(i+1,j)-eta(i+1,j))/de
           if (cp >= 0.)  cp = 0.
           if (cp < cmax) cp = cmax
          endif
          etap(i,j)=eta(i,j) -
     &              cp*dt_fs*dxur(i)*csur(j)*(eta(i+1,j)-eta(i,j))
         enddo
        endif


        if (enable_obc_east.and.my_blk_i==n_pes_i) then
         i = imt-1
         do j=js,je
          de= etap(i-1,j) - etap(i-2,j)
#ifdef partial_cell
          cmax = 2.*sqrt(grav*htp(i,j))
#else
          cmax = 2.*sqrt(grav*zw(max(1,kmt(i,j))))
#endif
          if (de == 0.) then
           cp = cmax
          else
           cp=-dxu(i-1)*csu(j)/dt_fs*(etap(i-1,j)-eta(i-1,j))/de
           if (cp <= 0.)  cp = 0.
           if (cp > cmax) cp = cmax
          endif
          etap(i,j)  = eta(i,j) -
     &      cp*dt_fs*dxur(i)*csur(j)*(eta(i,j)-eta(i-1,j))
         enddo
        endif
c
c-----------------------------------------------------------------------
c       boundary exchange for free surface
c-----------------------------------------------------------------------
c
        call border_exchg(etap,1,1)
        call set_cyclic(  etap,1,1)


#ifdef notdef
c
c        convergence of hubar over entire domain
c
         conv_bar=0.
         do j=js,je
          do i=is,ie
            fx=  dxt(i)*cst(j)*dyt(j)*tmask(i,1,j)
            conv_bar=conv_bar+ conv_hu(i,j)*fx
          enddo
         enddo
         call global_sum(conv_bar)
         conv_bar=conv_bar/tcella(1)
         if (my_pe==0) print*,' conv  = ',conv_bar

         conv_bar=0.
         do j=max(3,js),je
          do i=is,ie
            conv_bar=conv_bar+ (etap(i,j)-eta(i,j) )/dt_fs*emsk(i,j)
     &         *dxt(i)*cst(j)*dyt(j)*tmask(i,1,j)
          enddo
         enddo
         call global_sum(conv_bar)
         conv_bar=conv_bar/tcella(1)
         if (my_pe==0) print*,' eta_t = ',conv_bar
#endif

c
c-----------------------------------------------------------------------
c       diagnose surface pressure and absorb rho0
c-----------------------------------------------------------------------
c
        ps(:,:,1) = etap(:,:)*grav*rhosurf(:,:)/rho0


c#ifdef notdef
c
c-----------------------------------------------------------------------
c       calculate reference water level at open boundaries
c-----------------------------------------------------------------------
c
        if (enable_obc_south.and..not.prescribe_psi_obc_south) then

         if (my_blk_j == 1) then
          j  = 2 
          etamin = minval( eta(is:ie,j+1) )
          etamax = maxval( eta(is:ie,j+1) )
         else
          etamin = 1e20; etamax = -1e12
         endif

         call global_max(etamax)
         call global_min(etamin)

         if ( my_blk_j == 1) then
          etashift = etamin
          if (ABS(etamin) > ABS(etamax)) etashift = etamax
          etarel(:,j) = eta(:,j+1)-(etashift-obc_etanull)
         endif

        endif

        if (enable_obc_south.and.prescribe_psi_obc_south
     &      .and. my_blk_j == 1) then
         etarel(is:ie,2)    = psi_wall_south(is:ie)
        endif


        if (enable_obc_north.and..not.prescribe_psi_obc_north ) then
         if ( my_blk_j == n_pes_j) then
          j  = jmt-1
          etamin = minval( eta(is:ie,j-1) )
          etamax = maxval( eta(is:ie,j-1) )
         else
          etamin = 1e20; etamax = -1e12
         endif

         call global_max(etamax)
         call global_min(etamin)

         if ( my_blk_j == n_pes_j) then
          etashift = etamin
          if (ABS(etamin) > ABS(etamax)) etashift = etamax
          etarel(:,j) = eta(:,j-1)-(etashift-obc_etanull)
         endif
        endif

        if (enable_obc_north.and.prescribe_psi_obc_north
     &      .and. my_blk_j == n_pes_j) then
         etarel(is:ie,jmt-1) = psi_wall_north(is:ie)
        endif

        if (enable_obc_west.and..not.prescribe_psi_obc_west) then
         if ( my_blk_i == 1) then
          i  = 2
          etamin = minval( eta(i+1,js:je) )
          etamax = maxval( eta(i+1,js:je) )
         else
          etamin = 1e20; etamax = -1e12
         endif

         call global_max(etamax)
         call global_min(etamin)

         if (my_blk_i == 1) then
          etashift = etamin
          if (ABS(etamin) > ABS(etamax)) etashift = etamax
          etarel(i,:) = eta(i+1,:)-(etashift-obc_etanull)
         endif
        endif

        if (enable_obc_west.and.prescribe_psi_obc_west
     &      .and. my_blk_i == 1) then
          etarel(2,js:je) = psi_wall_west(js:je)
        endif

        if (enable_obc_east.and..not.prescribe_psi_obc_east) then
         if (my_blk_i == n_pes_i) then
          i  = imt-1
          etamin = minval( eta(i-1,js:je) )
          etamax = maxval( eta(i-1,js:je) )
         else
          etamin = 1e20; etamax = -1e12
         endif

         call global_max(etamax)
         call global_min(etamin)

         if ( my_blk_i == n_pes_i) then
          etashift = etamin
          if (ABS(etamin) > ABS(etamax)) etashift = etamax
          etarel(i,:) = eta(i-1,:)-(etashift-obc_etanull)
         endif
        endif

        if (enable_obc_east.and.prescribe_psi_obc_east
     &      .and. my_blk_i == n_pes_i) then
          etarel(imt-1,js:je) = psi_wall_east(js:je)
        endif

c#endif

c
c-----------------------------------------------------------------------
c       time step hubar using updated ps.
c       this is the "backward" step in the forward-backward scheme.
c-----------------------------------------------------------------------
c
        do j=js,je
	  do i=is,ie
	    fc = cori(i,j,1)*0.5
c
c           surface pressure gradients + forcing + explicit coriolis
c
	    utempm(i,1) = hubar(i,j,1) + dt_fs*(
     &                  - depthu(i,j)*csur(j)*dxu2r(i)
     &                  *( ps(i+1,j+1,1) + ps(i+1,j,1)
     &                   - ps(i  ,j+1,1) - ps(i  ,j,1) )
     &                  + zu(i,j,1)+fc*hubar(i,j,2)
     &                  )
	    utempm(i,2) = hubar(i,j,2) + dt_fs*(
     &                  - depthu(i,j)*dyu2r(j)
     &                  *( ps(i,j+1,1) + ps(i+1,j+1,1)
     &                   - ps(i,j,1) - ps(i+1,j,1) )
     &                  + zu(i,j,2)-fc*hubar(i,j,1)
     &                  )
	  enddo

c#ifdef notdef
c
c         restore to reference water level at open boundaries
c
          if (enable_obc_south .and. j == 2 ) then
	   do i=is,ie
             utempm(i,2) = utempm(i,2) - depthu(i,j)*grav*dyur(j)
     &              *dt_fs*(eta(i,j+1) - etarel(i,j)) * obc_rest
           enddo
          endif

          if (enable_obc_north .and. j == jmt-1) then
	   do i=is,ie
             utempm(i,2) = utempm(i,2) - depthu(i,j)*grav*dyur(j)
     &              *dt_fs*(etarel(i,j) - eta(i,j-1)) * obc_rest
           enddo
          endif
          if (enable_obc_west .and. my_blk_i==1) then
           i=2
           utempm(i,1) = utempm(i,1) - depthu(i,j)*grav*dxur(i)
     &              *csur(j)*dt_fs*(eta(i+1,j) - etarel(i,j)) 
     &              * obc_rest
          endif
          if (enable_obc_east .and. my_blk_i==n_pes_i) then
           i=imt-1
           utempm(i,1) = utempm(i,1)  - depthu(i,j)*grav*dxur(i)
     &              *csur(j)*dt_fs*(etarel(i,j) - eta(i-1,j))
     &              * obc_rest
          endif
c#endif
c
c         solve for hubar using implicit coriolis piece
c
	  do i=is,ie
	    fc = cori(i,j,1)*0.5
	    fx = fc*dt_fs
	    fy = 1./(1.+fx**2)
	    hubar(i,j,1) = umsk(i,j)*(utempm(i,1) + fx*utempm(i,2))*fy
	    hubar(i,j,2) = umsk(i,j)*(utempm(i,2) - fx*utempm(i,1))*fy
	  enddo
        enddo
c
c       boundary exchange
c
        call border_exchg(hubar(:,:,1),1,1)
        call set_cyclic(  hubar(:,:,1),1,1)
        call border_exchg(hubar(:,:,2),1,1)
        call set_cyclic(  hubar(:,:,2),1,1)

        if (enable_obc_south .and. my_blk_j==1) then
         hubar(:,1,:) = hubar(:,2,:)
        endif
        if (my_blk_j == n_pes_j .and. enable_obc_north) then
         hubar(:,jmt-1,:) = hubar(:,jmt-2,:)
         hubar(:,jmt  ,:) = hubar(:,jmt-2,:)
        endif
        if (my_blk_i == 1 .and. enable_obc_west) then
         hubar(1,:,:) = hubar(2,:,:)
        endif
        if (my_blk_i == n_pes_i .and. enable_obc_east) then
         hubar(imt  ,:,:) = hubar(imt-2,:,:)
         hubar(imt-1,:,:) = hubar(imt-2,:,:)
        endif
c
c-----------------------------------------------------------------------
c       accumulate hubar using ubar as a temporary field 
c       accumulate etat in etat(,,3)
c       shift etap = eta(t+1) into eta(t) for next barotropic step
c-----------------------------------------------------------------------
c
        ubar        = ubar        + hubar
        etat(:,:,3) = etat(:,:,3) + etap(:,:)
        eta         = etap           
c
      enddo  !end of barotropic time loop
c
c-----------------------------------------------------------------------
c     Compute time averaged ubar and eta centered at baroclinic 
c     step taup1 = T0+dtuv. 
c-----------------------------------------------------------------------
c    
      ubar(:,:,1) = ubar(:,:,1)*depthur(:,:) / (float(nb)+1.0)
      ubar(:,:,2) = ubar(:,:,2)*depthur(:,:) / (float(nb)+1.0)
      etat(:,:,3) = etat(:,:,3)              / (float(nb)+1.0)
c
c-----------------------------------------------------------------------
c     Update etat(,,1) to baroclinic time T0+dtuv using a leap-frog.  
c     convU, sff, and source_eta are at baroclinic time tau=T0.  
c     Also update etat(,,2) to be the time mean etat(tau).
c     No need to Robert time filter since the etat(taum1) value is
c     a time average.
c-----------------------------------------------------------------------
c
      eta(:,:)    = etat(:,:,1)
      etat(:,:,1) = etat(:,:,2) + c2dt*(convU(:,:))*emsk(:,:)
      etat(:,:,2) = eta(:,:)
      call border_exchg(etat(:,:,1),1,1)
      call set_cyclic(  etat(:,:,1),1,1)
c
c-----------------------------------------------------------------------
c     update surface pressure to new baroclinic time step taup1
c-----------------------------------------------------------------------
c
      ps(:,:,1) = etat(:,:,1)*grav*rhosurf(:,:)
c
c-----------------------------------------------------------------------
c     update internal velocities
c-----------------------------------------------------------------------
c
 20   continue   ! jump from above for eulerback2

      do n=1,2
       do j=js,je
        do k=1,km
         do i=is,ie
          u(i,k,j,n,taup1) = (u(i,k,j,n,taup1) + ubar(i,j,n))
     &                             *umask(i,k,j)
         enddo
        enddo
       enddo
      enddo

      do n=1,2
       call set_cyclic(u(:,:,:,n,taup1),km,2)
       if (my_blk_j == 1 .and. enable_obc_south) 
     &        u(:,:,1,n,taup1) = u(:,:,2,n,taup1)
       if (my_blk_j == n_pes_j .and. enable_obc_north) then
              u(:,:,jmt-1,n,taup1) = u(:,:,jmt-2,n,taup1)
              u(:,:,jmt  ,n,taup1) = u(:,:,jmt-2,n,taup1)
       endif
       if (my_blk_i == 1 .and. enable_obc_west) 
     &        u(1,:,:,n,taup1) = u(2,:,:,n,taup1)
       if (my_blk_i == n_pes_i .and. enable_obc_east) then
              u(imt  ,:,:,n,taup1) = u(imt-2,:,:,n,taup1)
              u(imt-1,:,:,n,taup1) = u(imt-2,:,:,n,taup1)
       endif
       call border_exchg(u(:,:,:,n,taup1),km,2)
      enddo
      end subroutine freesurf


    
      subroutine calc_thickness 
#if defined partial_cell 
      use spflame_module
      use freesurf_module
      use isoneutral_module
      implicit none
      integer :: is,ie,js,je,i,j,k,n
c
c=======================================================================
c     Update top grid cell thickness as well as ocean depth and volume
c     k=1 throughout this routine.  Uses partial cells.
c=======================================================================
c
      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)
c
c     thickness of upper t-cell at baroclinic time tau
c
      do j=js,je
       do i=is,ie
        dht(i,1,j) = max(thickmin,dzt(1)+etat(i,j,1))
       enddo
      enddo
      call border_exchg(dht(:,1,:),1,2)
      call set_cyclic(  dht(:,1,:),1,2)
c       
c     thickness of upper u-cell, isoneutral geometric factor,
c     and depth of u-cell ocean.
c
      if (enable_diffusion_isoneutral) then
       do j=js,je
        do i=is,ie
          delqc(i,1,j,0) = 2.*fracdz(1,0)*dht(i,1,j)
          delqc(i,1,j,1) = 2.*fracdz(1,1)*dht(i,1,j)
        enddo
       enddo
       call border_exchg(delqc(:,1,:,0),1,1)
       call border_exchg(delqc(:,1,:,1),1,1)
       call set_cyclic(  delqc(:,1,:,0),1,1)
       call set_cyclic(  delqc(:,1,:,1),1,1)
      endif   

      do j=js,je
       do i=is,ie
        dhu(i,1,j)     = min(dht(i,1,j), dht(i+1,1,j), dht(i,1,j+1),
     &                       dht(i+1,1,j+1))
       enddo
       if (my_blk_i==1)       dhu(1,1,j)   = dht(1,1,j)
       if (my_blk_i==n_pes_i) dhu(imt,1,j) = dht(imt,1,j)
      enddo
      call border_exchg(dhu(:,1,:),1,2)
      call set_cyclic(  dhu(:,1,:),1,2)

      do j=js,je
        do i=is-1,ie+1
          etau(i,j)   = (dhu(i,1,j)-dzt(1))*umsk(i,j)  
          depthu(i,j) = hup(i,j) + etau(i,j)
          if(umsk(i,j) == 1.) then  
            depthur(i,j) = 1./depthu(i,j)
          else
            depthur(i,j) = 0.
          endif
        enddo
      enddo
      call border_exchg(etau,1,1)
      call set_cyclic(  etau,1,1)
      call border_exchg(depthu,1,1)
      call set_cyclic(  depthu,1,1)
      call border_exchg(depthur,1,1)
      call set_cyclic(  depthur,1,1)
c
c     time dependent volume of the ocean for T and U cells
c
c
c     ignore this at the moment
c

c
c     diagnose ubar from full velocity
c
      do n=1,2
       do i=is,ie
        ubar(i,j,n) = 0.
	do k=1,km
         ubar(i,j,n) = ubar(i,j,n)+ u(i,k,j,n,tau)*dhu(i,k,j)
        enddo
        ubar(i,j,n)   = ubar(i,j,n)*depthur(i,j)
       enddo
       call border_exchg(ubar(:,:,n),1,1)
       call set_cyclic(  ubar(:,:,n),1,1)
      enddo

#endif
      end subroutine  calc_thickness

c   no cpp defines here

       module time_type_module
       implicit none
!====================================================================
! The module provides a single defined type, time_type, which is 
! used to store time and date quantities. A time_type is a positive 
! definite quantity that represents an interval of time. It can be most 
! easily thought of as representing the number of seconds in some time 
! interval. A time interval can be mapped to a date under a given calendar 
! definition by using it to represent the time that has passed since some 
! base date. A number of interfaces are provided to operate on time_type 
! variables and their associated calendars. Time intervals can be as large 
! as n days where n is the largest number represented by the default integer 
! type on a compiler. This is typically considerably greater than 10 million 
! years which is likely to be adequate for most applications. The 
! description of the interfaces is separated into two sections. The first 
! deals with operations on time intervals while the second deals with 
! operations that convert time intervals to dates for a given calendar.
!
!     author: Jeff Anderson         jla@gfdl.gov 
c     SPFLAME version : c.eden
!====================================================================

        public time_type
	type :: time_type
	   integer:: seconds
	   integer:: days
	end type time_type

	public operator( + ),  operator( - ),   operator( * ) 
        public operator( / )  
	public operator( > ),  operator( >= ),  operator( == )
        public operator( /= )
	public operator( < ),  operator( <= )

	interface operator (+) 
          module procedure time_plus
        end interface
	interface operator (-)   
          module procedure time_minus
        end interface
	interface operator (*)   
          module procedure time_scalar_mult 
          module procedure scalar_time_mult
        end interface
	interface operator (/)   
          module procedure time_scalar_divide
	  module procedure time_divide  
        end interface
	interface operator (>)   
          module procedure time_gt
        end interface
	interface operator (>=)  
          module procedure time_ge
        end interface
	interface operator (<)   
          module procedure time_lt
        end interface
	interface operator (<=)  
          module procedure time_le
        end interface
	interface operator (==)  
          module procedure time_eq
        end interface
	interface operator (/=)  
          module procedure time_ne
        end interface

	public  set_time 
        public  increment_time
        public  decrement_time
        public  time_in_days,time_in_secs

        public set_calendar_type
        public get_calendar_type

        public get_date
        private get_date_thirty,get_date_no_leap,get_date_julian

        public   set_date 
        private  set_date_thirty
        private  set_date_julian, set_date_no_leap

        public   increment_date 
        private  increment_thirty
        private  increment_julian
        private  increment_no_leap

        public   decrement_date 
        private  decrement_thirty
        private  decrement_julian
        private  decrement_no_leap

        private error_handler

	integer, parameter, public ::   
     &       THIRTY_DAY_MONTHS = 1, JULIAN = 2, 
     &	     NO_LEAP = 3,  NO_CALENDAR = 0

	integer,private ::calendar_type=NO_CALENDAR,max_type = 3

	integer, public  ::  
     &   days_per_month(12) = (/31,28,31,30,31,30,31,31,30,31,30,31/)

        contains


	subroutine set_time(time,seconds, days)
! Returns a time interval corresponding to this number of days and seconds.
! The arguments must not be negative but are otherwise unrestricted.
	implicit none
	type(time_type) :: time
	integer, intent(in) :: seconds, days
! Negative time offset is illegal
	if(seconds < 0 .or. days < 0) 
     &        call error_handler('Negative input in set_time')
! Make sure seconds greater than a day are fixed up
	time%seconds = seconds - seconds / (60*60*24) * (60*60*24)
	time%days = days + seconds / (60*60*24)
	end subroutine set_time

!-------------------------------------------------------------------------
	subroutine decrement_time(result,time, seconds, days)
! Decrements a time by seconds and days; decrements cannot be negative.
	implicit none
	type(time_type),intent(out) :: result
	type(time_type), intent(in) :: time
	integer, intent(in) :: seconds, days
	integer :: cseconds, cdays
! Decrement must be positive definite
	if(seconds < 0 .or. days < 0) 
     &	   call error_handler('Negative decrement in decrement_time')
	cseconds = time%seconds - seconds
	cdays = time%days - days
! Borrow if needed
	if(cseconds < 0) then
	   cdays = cdays - 1 + (cseconds + 1) / (60*60*24)
	   cseconds = cseconds - (60*60*24) * (-1 + (cseconds + 1) 
     &                   / (60*60*24))
	end if
! Check for illegal negative time
	if(cdays < 0) call error_handler(
     & 'Negative time results in decrement_time')
	result%seconds = cseconds
	result%days = cdays
	end subroutine decrement_time

	subroutine increment_time(result,time, seconds, days)
! Increments a time by seconds and days; increments cannot be negative.
	implicit none
	type( time_type),intent(out) :: result
	type(time_type), intent(in) :: time
	integer, intent(in) :: seconds, days
	integer :: s, d
! Increment must be positive definite
	if(seconds < 0 .or. days < 0) 
     &	   call error_handler('Negative increment in increment_time')
        s=time%seconds+seconds
        d=time%days+days
c	increment_time = set_time(s, d)
	call set_time(result,s, d)
c	increment_time%seconds = s - s / (60*60*24) * (60*60*24)
c	increment_time%days = d + s / (60*60*24)
	end subroutine increment_time

!-------------------------------------------------------------------------
        function time_in_days(time)
        implicit none
	type(time_type), intent(in) :: time
        real time_in_days
        time_in_days=time%days+time%seconds/24./60./60.
        end function time_in_days

        function time_in_secs(time)
        implicit none
	type(time_type), intent(in) :: time
        real time_in_secs
        time_in_secs=time%days*24.*60.*60.+time%seconds
        end function time_in_secs


!--------------------------------------------------------------------------
	function time_gt(time1, time2)
! Returns true if time1 > time2
	implicit none
	logical :: time_gt
	type(time_type), intent(in) :: time1, time2
	time_gt = (time1%days > time2%days)
	if(time1%days == time2%days) time_gt = (time1%seconds 
     &     > time2%seconds)
	end function time_gt
!--------------------------------------------------------------------------
	function time_ge(time1, time2)
! Returns true if time1 >= time2
	implicit none
	logical :: time_ge
	type(time_type), intent(in) :: time1, time2
	time_ge = (time_gt(time1, time2) .or. time_eq(time1, time2))
	end function time_ge
!--------------------------------------------------------------------------
	function time_lt(time1, time2)
! Returns true if time1 < time2
	implicit none
	logical :: time_lt
	type(time_type), intent(in) :: time1, time2
	time_lt = (time1%days < time2%days)
	if(time1%days == time2%days) time_lt = (time1%seconds 
     &               < time2%seconds)
	end function time_lt
!--------------------------------------------------------------------------
	function time_le(time1, time2)
! Returns true if time1 <= time2
	implicit none
	logical :: time_le
	type(time_type), intent(in) :: time1, time2
	time_le = (time_lt(time1, time2) .or. time_eq(time1, time2))
	end function time_le
!--------------------------------------------------------------------------
	function time_eq(time1, time2)
! Returns true if time1 == time2
	implicit none
	logical :: time_eq
	type(time_type), intent(in) :: time1, time2
	time_eq = (time1%seconds == time2%seconds .and. 
     &              time1%days == time2%days)
	end function time_eq
!--------------------------------------------------------------------------
	function time_ne(time1, time2)
! Returns true if time1 /= time2
	implicit none
	logical :: time_ne
	type(time_type), intent(in) :: time1, time2
	time_ne = (.not. time_eq(time1, time2))
	end function time_ne
!-------------------------------------------------------------------------
	function time_plus(time1, time2)
! Returns sum of two time_types
	implicit none
	type(time_type) :: time_plus
	type(time_type), intent(in) :: time1, time2
c	time_plus = increment_time(time1, time2%seconds, time2%days)
	call increment_time(time_plus ,time1, time2%seconds, time2%days)
	end function time_plus
!-------------------------------------------------------------------------
	function time_minus(time1, time2)
! Returns difference of two time_types. WARNING: a time type is positive 
! so by definition time1 - time2  is the same as time2 - time1.
	implicit none
	type(time_type) :: time_minus
	type(time_type), intent(in) :: time1, time2
	if(time1 > time2) then
c	   time_minus = decrement_time(time1, time2%seconds, time2%days)
        call decrement_time(time_minus,time1, time2%seconds, time2%days)
	else 
c	   time_minus = decrement_time(time2, time1%seconds, time1%days)
       call decrement_time(time_minus ,time2, time1%seconds, time1%days)
	endif
	end function time_minus
!--------------------------------------------------------------------------
	function time_scalar_mult(time, n)
	! Returns time multiplied by integer factor n
	implicit none
	type(time_type) :: time_scalar_mult,time2
	type(time_type), intent(in) :: time
	integer, intent(in) :: n
	integer :: days, seconds
	double precision :: sec_prod 
! Multiplying here in a reasonable fashion to avoid overflow is tricky
! Could multiply by some large factor n, and seconds could be up to 86399
! Need to avoid overflowing integers and wrapping around to negatives
	sec_prod = dble(time%seconds) * dble(n)
! If sec_prod is large compared to precision of double precision, things
! can go bad.  Need to warn and abort on this.
	if(sec_prod /= 0.0) then
	   if(log10(sec_prod) > precision(sec_prod) - 3) 
     & call error_handler(
     & 'Insufficient precision to handle scalar product in '//
     & 'time_scalar_mult; contact developer')
	end if
	days = sec_prod / dble(24. * 60. * 60.)
	seconds = sec_prod - dble(days) * dble(24. * 60. * 60.)
c	time_scalar_mult = set_time(seconds, time%days * n + days)
	call set_time(time2 ,seconds, time%days * n + days)
	time_scalar_mult =time2
	end function time_scalar_mult
!-------------------------------------------------------------------------
	function scalar_time_mult(n, time)
! Returns time multipled by integer factor n
	implicit none
	type(time_type) :: scalar_time_mult
	type(time_type), intent(in) :: time
	integer, intent(in) :: n
	scalar_time_mult = time_scalar_mult(time, n)
	end function scalar_time_mult
!-------------------------------------------------------------------------
	function time_divide(time1, time2)
! Returns the largest integer, n, for which time1 >= time2 * n.
	implicit none
	integer :: time_divide
	type(time_type), intent(in) :: time1, time2
	double precision :: d1, d2
! Convert time intervals to floating point days; risky for general performance?
	d1 = time1%days * dble(60. * 60. * 24.) + dble(time1%seconds)
	d2 = time2%days * dble(60. * 60. * 24.) + dble(time2%seconds) 
! Get integer quotient of this, check carefully to avoid round-off problems.
	time_divide = d1 / d2
! Verify time_divide*time2 is <= time1 and (time_divide + 1)*time2 is > time1
	if(time_divide * time2 > time1 .or. (time_divide + 1) 
     & * time2 <= time1)  call error_handler(
     & 'time_divide quotient error :: notify developer')
	end function time_divide
!-------------------------------------------------------------------------
c	function time_real_divide(time1, time2)
! Returns the double precision quotient of two times
c	implicit none
c	double precision :: time_real_divide
c	type(time_type), intent(in) :: time1, time2
c	double precision :: d1, d2
! Convert time intervals to floating point days; risky for general performance?
c	d1 = time1%days * dble(60. * 60. * 24.) + dble(time1%seconds)
c	d2 = time2%days * dble(60. * 60. * 24.) + dble(time2%seconds) 
c	time_real_divide = d1 / d2
c	end function time_real_divide
!-------------------------------------------------------------------------
	function time_scalar_divide(time, n)
! Returns the largest time, t, for which n * t <= time
	implicit none
	type(time_type) :: time_scalar_divide
	type(time_type), intent(in) :: time
	integer, intent(in) :: n
	double precision :: d, div
	integer :: days, seconds
	type(time_type) :: prod1, prod2
! Convert time interval to floating point days; risky for general performance?
	d = time%days * dble(60.*60.*24.) + dble(time%seconds)
	div = d / dble(1.0 * n)
	days = div / dble(60.*60.*24.)
	seconds = div - days * dble(60.*60.*24.)
c	time_scalar_divide = set_time(seconds, days)
	call set_time(time_scalar_divide ,seconds, days)
! Need to make sure that roundoff isn`t killing this
	prod1 = n * time_scalar_divide
c	prod2 = n * (increment_time(time_scalar_divide, 1, 0)) 
	call increment_time(prod2 ,time_scalar_divide, 1, 0) 
	prod2 = n * prod2
	if(prod1 > time .or. prod2 <= time) call error_handler(
     & 'time_scalar_divide quotient error :: notify developer')
	end function time_scalar_divide
!-------------------------------------------------------------------------




	subroutine set_calendar_type(type)
! Selects calendar for default mapping from time to date. 
	implicit none
	integer, intent(in) :: type
	if(type <= 0 .or. type > max_type) 
     &	   call error_handler('Illegal type in set_calendar_type')
	calendar_type = type
        if (type ==  THIRTY_DAY_MONTHS) then
         days_per_month = (/30,30,30,30,30,30,30,30,30,30,30,30/)
        else
         days_per_month = (/31,28,31,30,31,30,31,31,30,31,30,31/)
        endif
	end subroutine set_calendar_type

!------------------------------------------------------------------------
	function get_calendar_type()
! Returns default calendar type for mapping from time to date.
	implicit none
	integer :: get_calendar_type
	get_calendar_type = calendar_type
	end function get_calendar_type
!========================================================================
	subroutine get_date(time, year, month,day,hour,minute,second)
! Given a time, computes the corresponding date given the selected calendar
	implicit none
	type(time_type), intent(in) :: time
	integer, intent(out) :: second, minute, hour, day, month, year
	select case(calendar_type)
	case(THIRTY_DAY_MONTHS)
	   call get_date_thirty(time, year, month, day, hour,
     &  minute, second)
	case(JULIAN)
	   call get_date_julian(time, year, month, day, hour,
     &  minute, second)
	case(NO_LEAP)
	   call get_date_no_leap(time, year, month, day, hour, 
     &  minute, second)
	case default
	   call error_handler('Invalid calendar type in get_date')
	end select
	end subroutine get_date
!------------------------------------------------------------------------

	subroutine get_date_julian(time, year, month, day, hour, 
     & minute, second)
! Base date for Julian calendar is year 1 with all multiples of 4 
! years being leap years.
	implicit none
	type(time_type), intent(in) :: time
	integer, intent(out) :: second, minute, hour, day, month, year
	integer :: m, t, nfour, nex, days_this_month
	logical :: leap
! find number of four year periods; also get modulo number of days
	nfour = time%days / (4 * 365 + 1) 
	day = modulo(time%days, (4 * 365 + 1))
! Find out what year in four year chunk
	nex = day / 365
	if(nex == 4) then
	   nex = 3
	   day = 366
	else
	   day=modulo(day, 365) + 1
	endif
! Is this a leap year? 
	leap = (nex == 3)
	year = 1 + 4 * nfour + nex
! find month and day
	do m = 1, 12
	   month = m
	   days_this_month = days_per_month(m)
	   if(leap .and. m == 2) days_this_month = 29
	   if(day <= days_this_month) exit
	   day = day - days_this_month
	end do
! find hour,minute and second
	t = time%seconds
	hour = t / (60 * 60)
	t = t - hour * (60 * 60)
	minute = t / 60
	second = t - 60 * minute
	end subroutine get_date_julian
!------------------------------------------------------------------------
	subroutine get_date_thirty(time, year, month, day, hour, 
     & minute, second)
! Computes date corresponding to time interval for 30 day months, 12
! month years.
	implicit none
	type(time_type), intent(in) :: time
	integer, intent(out) :: second, minute, hour, day, month, year
	integer :: t, dmonth, dyear
	t = time%days
	dyear = t / (30 * 12)
	year = dyear + 1
	t = t - dyear * (30 * 12)
	dmonth = t / 30
	month = 1 + dmonth
	day = t -dmonth * 30 + 1
	t = time%seconds
	hour = t / (60 * 60) 
	t = t - hour * (60 * 60)
	minute = t / 60
	second = t - 60 * minute
	end subroutine get_date_thirty
!------------------------------------------------------------------------
	subroutine get_date_no_leap(time, year, month, day, hour, 
     &  minute, second)
! Base date for no_leap calendar is year 1.
	implicit none
	type(time_type), intent(in) :: time
	integer, intent(out) :: second, minute, hour, day, month, year
	integer :: m, t
! get modulo number of days
	year = time%days / 365 + 1
	day = modulo(time%days, 365) + 1
! find month and day
	do m = 1, 12
	   month = m
	   if(day <= days_per_month(m)) exit
	   day = day - days_per_month(m)
	end do
! find hour,minute and second
	t = time%seconds
	hour = t / (60 * 60)
	t = t - hour * (60 * 60)
	minute = t / 60
	second = t - 60 * minute
	end subroutine get_date_no_leap
!========================================================================
	function set_date(year, month, day, hours, minutes, seconds)
! Given a date, computes the corresponding time given the selected
! date time mapping algorithm.  Note that it is possible to specify
! any number of illegal dates; these should be checked for and generate
! errors as appropriate.
	implicit none
	type(time_type) :: set_date
	integer, intent(in) :: day, month, year
	integer, intent(in) :: seconds, minutes, hours
	select case(calendar_type)
	case(THIRTY_DAY_MONTHS)
	   set_date = set_date_thirty(year, month, day, hours, 
     &  minutes, seconds)
	case(JULIAN)
	   set_date = set_date_julian(year, month, day, hours, 
     &  minutes, seconds)
	case(NO_LEAP)
	   set_date = set_date_no_leap(year, month, day, hours, 
     &  minutes, seconds)
	case default
	   call error_handler('Invalid calendar type in set_date')
	end select
	end function set_date
!------------------------------------------------------------------------
	function set_date_julian(year, month, day, hours, 
     & minutes, seconds)
! Returns time corresponding to date for julian calendar.
	implicit none
	type(time_type) :: set_date_julian
	integer, intent(in) :: day, month, year
	integer, intent(in) :: seconds, minutes, hours
	integer ndays, m, nleapyr
	logical :: leap
! Need to check for bogus dates
	if(seconds > 59 .or. seconds < 0 .or. minutes > 59 
     & .or. minutes < 0 .or. hours > 23 .or. hours < 0 .or. day < 1 
     & .or. month > 12 .or. month < 1 .or. year < 1) 
     &	   call error_handler('Invalid date in set_date_julian')
	if(month /= 2 .and. day > days_per_month(month)) 
     &	   call error_handler('Invalid day in set_date_julian')
! Is this a leap year? 
	leap = (modulo(year,4) == 0)
! compute number of complete leap years from year 1
	nleapyr = (year - 1) / 4
! Finish checking for day specication errors
	if(month == 2 .and. (day > 29 .or. ((.not. leap) .and. 
     & day > 28))) call error_handler(
     & 'Invalid number of days in month 2 in set_date_julian')
	ndays = 0
	do m = 1, month - 1
	   ndays = ndays + days_per_month(m)
	   if(leap .and. m == 2) ndays = ndays + 1
	enddo
	set_date_julian%seconds = seconds + 60 * (minutes + 
     & 60 * hours)
	set_date_julian%days = day -1 + ndays + 365*(year - nleapyr 
     & - 1) + 366*(nleapyr)
	end function set_date_julian
!------------------------------------------------------------------------

	function set_date_thirty(year, month, day, hours, 
     &  minutes, seconds)
	! Computes time corresponding to date for thirty day months.
	implicit none
	type(time_type) :: set_date_thirty
	integer, intent(in) :: day, month, year
	integer, intent(in) :: seconds, minutes, hours
	! Need to check for bogus dates
	if(seconds > 59 .or. seconds < 0 .or. minutes > 59 .or. 
     &   minutes < 0 .or. hours > 23 .or. hours < 0 .or. day > 30 
     &   .or. day < 1 .or. month > 12 .or. month < 1 .or. year < 1) 
     &	      call error_handler('Invalid date in set_date_thirty')
	set_date_thirty%days = (day - 1) + 30 * ((month - 1) + 
     & 12 * (year - 1))
	set_date_thirty%seconds = seconds + 60 * (minutes + 
     & 60 * hours)
	end function set_date_thirty
!------------------------------------------------------------------------
	function set_date_no_leap(year, month, day, hours, 
     &   minutes, seconds)
! Computes time corresponding to date for fixed 365 day year calendar.
	implicit none
	type(time_type) :: set_date_no_leap,time2
	integer, intent(in) :: day, month, year
	integer, intent(in) :: seconds, minutes, hours
	integer ndays, m
	! Need to check for bogus dates
	if(seconds > 59 .or. seconds < 0 .or. minutes > 59 
     &  .or. minutes < 0 .or. hours > 23 .or. hours < 0 
     &  .or. day > 31 .or. day < 1 .or. month > 12 .or. month < 1 
     &   .or. year < 1) then
	   call error_handler('Invalid date in set_date_no_leap')
	endif
	ndays = 0
	do m = 1, month - 1
	   ndays = ndays + days_per_month(m)
	enddo
c	set_date_no_leap = set_time(seconds + 60 * 
	call set_time(time2 ,seconds + 60 * 
     &  (minutes + 60 * hours), day -1 + ndays + 365 * (year - 1))
        set_date_no_leap=time2
	end function set_date_no_leap
!------------------------------------------------------------------------
	function increment_date(time, years, months, days, 
     &  hours, minutes, seconds)
! Given a time and some date increment, computes a new time.  Depending
! on the mapping algorithm from date to time, it may be possible to specify
! undefined increments (i.e. if one increments by 68 days and 3 months in
! a Julian calendar, it matters which order these operations are done and
! we don`t want to deal with stuff like that, make it an error).
	implicit none
	type(time_type) :: increment_date
	type(time_type), intent(in) :: time
	integer, intent(in) :: seconds, minutes, hours, 
     &  days, months, years
	select case(calendar_type)
	case(THIRTY_DAY_MONTHS)
	   increment_date = increment_thirty(time, years, months, 
     &              days, hours, minutes, seconds)
	case(JULIAN)
	   increment_date = increment_julian(time, years, months, 
     &              days, hours, minutes, seconds)
	case(NO_LEAP)
	   increment_date = increment_no_leap(time, years, months, 
     &              days, hours, minutes, seconds)
	case default
	   call error_handler('Invalid calendar type in increment_date')
	end select
	end function increment_date
!-------------------------------------------------------------------------
	function increment_julian(time, years, months, days, 
     & hours, minutes, seconds)
	! Given time and some date increment, computes new time for julian calendar.
	implicit none
	type(time_type) :: increment_julian
	type(time_type), intent(in) :: time
	integer, intent(in) :: seconds, minutes, 
     &  hours, days, months, years
	integer :: csecond, cminute, chour, cday, cmonth, cyear, dyear
	type(time_type) :: t
! Increment must be positive definite
	if(seconds < 0 .or. minutes < 0 .or. hours < 0 
     & .or. days < 0 .or. months < 0 .or. years < 0) 
     &	   call error_handler('Illegal increment in increment_julian')
!  There are a number of other bad types of increments that should be
!  prohibited here; the addition is not associative
!  Easiest thing is to only let month and year be incremented by themselves
!  This is slight overkill since year is not really a problem.
	if(months /= 0 .and. (seconds /= 0 .or. minutes /= 0 
     & .or. hours /= 0 .or. days /= 0 .or. years /= 0)) 
     &  call error_handler (
     &'increment_julian:month must not be incremented with other units')
	if(years /= 0 .and. (seconds /= 0 .or. minutes /= 0 
     & .or. hours /= 0 .or. days /= 0 .or. months /= 0)) 
     &  call error_handler (
     &'increment_julian: year must not be incremented with other units')
!  For non-month and non-year part can just use increment_thirty
	t =  increment_thirty(time, 0, 0, days, hours, 
     & minutes, seconds)
!  For month or year increment, first convert to date
	call get_date_julian(t, cyear, cmonth, cday, chour, 
     & cminute, csecond)
	cmonth = cmonth + months
	cyear = cyear + years
! Check for months larger than 12 and fix
	if(cmonth > 12) then
	   dyear = (cmonth - 1) / 12 
	   cmonth = cmonth - 12 * dyear
	   cyear = cyear + dyear
	end if
! Convert this back into a time
	increment_julian = set_date_julian(cyear, cmonth, cday, chour, 
     & cminute, csecond)
	end function increment_julian
!-------------------------------------------------------------------------
	function increment_thirty(time, years, months, days, hours, 
     &  minutes, seconds)
! Given a time and some date increment, computes new time for thirty day months.
	implicit none
	type(time_type) :: increment_thirty,time2
	type(time_type), intent(in) :: time
	integer, intent(in):: seconds, minutes, hours, 
     & days, months, years
	integer :: csecond, cday
! Increment must be positive definite
	if(seconds < 0 .or. minutes < 0 .or. hours < 0 .or. 
     &   days < 0 .or. months < 0 .or. years < 0) 
     &	  call error_handler('Illegal increment in increment_thirty')
! Do increment to seconds portion first
	csecond = seconds + 60 * (minutes + 60 * hours)
	cday = days + 30 * (months + 12 * years)
c	increment_thirty = increment_time(time, csecond, cday)
	call increment_time(time2 ,time, csecond, cday)
	increment_thirty =time2
	end function increment_thirty
!-------------------------------------------------------------------------
	function increment_no_leap(time, years, months, days, 
     & hours, minutes, seconds)
! Given time and some date increment, computes new time for julian calendar.
	implicit none
        type(time_type) :: increment_no_leap
	type(time_type), intent(in) :: time
	integer, intent(in) :: seconds, minutes, hours, 
     & days, months, years
	integer :: csecond, cminute, chour, cday, cmonth, cyear, dyear
	type(time_type) :: t
! Increment must be positive definite
	if(seconds < 0 .or. minutes < 0 .or. hours < 0 .or. 
     & days < 0 .or. months < 0 .or. years < 0) 
     &  call error_handler('Illegal increment in increment_no_leap')
!  There are a number of other bad types of increments that should be
!  prohibited here; the addition is not associative
!  Easiest thing is to only let month and year be incremented by themselves
!  This is slight overkill since year is not really a problem.
	if(months /= 0 .and. (seconds /= 0 .or. minutes /= 0 
     & .or. hours /= 0 .or. days /= 0 .or. years /= 0)) 
     & call error_handler (
     &'increment_no_leap:month must notbe incremented with other units')
	if(years /= 0 .and. (seconds /= 0 .or. minutes /= 0 
     & .or. hours /= 0 .or. days /= 0 .or. months /= 0)) 
     & call error_handler (
     &'increment_no_leap:year must not be incremented with other units')
!  For non-month and non-year part can just use increment_thirty
	t =  increment_thirty(time, 0, 0, days, hours, 
     &  minutes, seconds)
!  For month or year increment, first convert to date
	call get_date_no_leap(t, cyear, cmonth, cday, chour, 
     & cminute, csecond)
	cmonth = cmonth + months
	cyear = cyear + years
	! Check for months larger than 12 and fix
	if(cmonth > 12) then
	   dyear = (cmonth - 1) / 12 
	   cmonth = cmonth - 12 * dyear
	   cyear = cyear + dyear
	end if
! Convert this back into a time
	increment_no_leap = set_date_no_leap(cyear, cmonth, cday, 
     &   chour, cminute, csecond)
	end function increment_no_leap
!=========================================================================
	function decrement_date(time, years, months, days, 
     &      hours, minutes, seconds)
! Given a time and some date decrement, computes a new time.  Depending
! on the mapping algorithm from date to time, it may be possible to specify
! undefined decrements (i.e. if one decrements by 68 days and 3 months in
! a Julian calendar, it matters which order these operations are done and
! we don`t want to deal with stuff like that, make it an error).
	implicit none
	type(time_type) :: decrement_date
	type(time_type), intent(in) :: time
	integer, intent(in) :: seconds, minutes, 
     &        hours, days, months, years
	select case(calendar_type)
	case(THIRTY_DAY_MONTHS)
	   decrement_date = decrement_thirty(time, years, months, 
     &       days, hours, minutes, seconds)
	case(JULIAN)
	   decrement_date = decrement_julian(time, years, months, 
     &       days, hours, minutes, seconds)
	case(NO_LEAP)
	   decrement_date = decrement_no_leap(time, years, months, 
     &       days, hours, minutes, seconds)
	case default
	   call error_handler('Invalid calendar type in decrement_date')
	end select
	end function decrement_date
!-------------------------------------------------------------------------
	function decrement_julian(time, years, months, days, hours, 
     &                            minutes, seconds)
! Given time and some date decrement, computes new time for julian calendar.
	implicit none
	type(time_type) :: decrement_julian
	type(time_type), intent(in) :: time
	integer, intent(in) :: seconds, minutes, hours, 
     &                     days, months, years
	integer :: csecond, cminute, chour, cday, cmonth, cyear
	type(time_type) :: t
! Increment must be positive definite
	if(seconds < 0 .or. minutes < 0 .or. hours < 0 
     &    .or. days < 0 .or. months < 0 .or. years < 0) 
     &	   call error_handler('Illegal increment in decrement_julian')
!  There are a number of other bad types of decrements that should be
!  prohibited here; the subtraction is not associative
!  Easiest thing is to only let month and year be decremented by themselves
!  This is slight overkill since year is not really a problem.
	if(months /= 0 .and. (seconds /= 0 .or. minutes /= 0 
     &         .or. hours /= 0 .or.  days /= 0 .or. years /= 0)) 
     &   call error_handler ('decrement_julian: month must not '//
     &   'be decremented with other units')
	if(years /= 0 .and. (seconds /= 0 .or. minutes /= 0 
     &   .or. hours /= 0 .or. days /= 0 .or. months /= 0)) 
     & call error_handler ('decrement_julian: year must not '//
     &   'be decremented with other units')
!  For non-month and non-year can just use decrement_thirty
	t = decrement_thirty(time, 0, 0, days, hours, 
     &                       minutes, seconds)
!  For month or year decrement, first convert to date
	call get_date_julian(t, cyear, cmonth, cday, chour, 
     &                       cminute, csecond)
	cmonth = cmonth - months
	cyear = cyear - years
! Check for months less than 12 and fix
	if(cmonth < 1) then
	   cyear = cyear - 1 + (cmonth) / 12
	   cmonth = cmonth - 12 * ( -1 + (cmonth) / 12)
	end if
! Check for negative years
	if(cyear < 1) 
     &   call error_handler('Illegal date results in decrement_julian')
! Convert this back into a time
	decrement_julian = set_date_julian(cyear, cmonth, cday, 
     &                  chour, cminute, csecond)
	end function decrement_julian
!-------------------------------------------------------------------------
	function decrement_thirty(time, years, months, days, 
     &                            hours, minutes, seconds)
! Given a time and some date decrement, computes new time for thirty day months.
	implicit none
	type(time_type) :: decrement_thirty,time2
	type(time_type), intent(in) :: time
	integer, intent(in) :: seconds, minutes, 
     &                         hours, days, months, years
	integer :: csecond, cday
! Increment must be positive definite
	if(seconds < 0 .or. minutes < 0 .or. hours < 0 
     &    .or. days < 0 .or. months < 0 .or. years < 0) 
     &	  call error_handler('Illegal decrement in decrement_thirty')
	csecond = seconds + 60 * (minutes + 60 * hours)
	cday = days + 30 * (months + 12 * years)
c	decrement_thirty = decrement_time(time, csecond, cday)
	call decrement_time(time2 ,time, csecond, cday)
	decrement_thirty =time2
	end function decrement_thirty
!-------------------------------------------------------------------------
	function decrement_no_leap(time, years, months, days, 
     &                             hours, minutes, seconds)
! Given time and some date decrement, computes new time for julian calendar.
	implicit none
	type(time_type) :: decrement_no_leap
	type(time_type), intent(in) :: time
	integer, intent(in) :: seconds, minutes, 
     &                                   hours, days, months, years
	integer :: csecond, cminute, chour, cday, cmonth, cyear
	type(time_type) :: t
! Increment must be positive definite
	if(seconds < 0 .or. minutes < 0 .or. hours < 0 
     &    .or. days < 0 .or. months < 0 .or. years < 0) 
     &	   call error_handler('Illegal increment in decrement_no_leap')
!  There are a number of other bad types of decrements that should be
!  prohibited here; the subtraction is not associative
!  Easiest thing is to only let month and year be decremented by themselves
!  This is slight overkill since year is not really a problem.
	if(months /= 0 .and. (seconds /= 0 .or. minutes /= 0 
     &      .or. hours /= 0 .or. days /= 0 .or. years /= 0)) 
     &    call error_handler('decrement_no_leap: month must not '//
     &  'be decremented with other units')
	if(years /= 0 .and. (seconds /= 0 .or. minutes /= 0 
     & .or. hours /= 0 .or. days /= 0 .or. months /= 0)) 
     &   call error_handler('decrement_no_leap: year must not '//
     &  'be decremented with other units')
!  For non-month and non-year can just use decrement_thirty
	t = decrement_thirty(time, 0, 0, days, hours, 
     &                       minutes, seconds)
!  For month or year decrement, first convert to date
	call get_date_no_leap(t, cyear, cmonth, cday, chour, 
     &                        cminute, csecond)
	cmonth = cmonth - months
	cyear = cyear - years
! Check for months less than 12 and fix
	if(cmonth < 1) then
	   cyear = cyear - 1 + (cmonth) / 12
	   cmonth = cmonth - 12 * ( -1 + (cmonth) / 12)
	end if
! Check for negative years
	if(cyear < 1) call 
     &        error_handler('Illegal date results in decrement_no_leap')
! Convert this back into a time
	decrement_no_leap = set_date_no_leap(cyear, cmonth, cday, 
     &   chour, cminute, csecond)
	end function decrement_no_leap

	subroutine error_handler(s)
	implicit none
	character (*), intent(in) :: s
c	write(*, *) 'ERROR: In time_type_mod: ', s
	call halt_stop('ERROR: In time_type_mod: '//s)

	end subroutine error_handler


	end module time_type_module

#include "options.inc"


      program nc_merge
c=======================================================================
c   merge netcdf variables distributed over several files
c   into s single file
c=======================================================================
      implicit none
      real,parameter :: version = 0.1
      integer :: ncin,varin,id
      integer :: ncout,varout,nr_infiles
      integer :: nr_com,n,ierr,m,nr
      character (len=80) :: fname,outstr
      character (len=80),allocatable :: varnames(:)
#include "netcdf.inc"
      integer :: iret

      print'(" This is nc_merge.x :: version ",f5.3)',version
c  read command line input
      call get_commandline_argnr(nr_com)
      if (nr_com<3) goto 100
      nr_infiles = nr_com-1

c   create output file
      call get_commandline_arg(nr_com,fname,ierr)
      print*,' creating file ',fname(1:len_trim(fname))
      ncout = nccre (fname, NCNOCLOB, iret)
      if (iret /=0 ) goto 110
      iret=nf_set_fill(ncout, NF_NOFILL, iret)

c   open input files and search for variables
      do n=1,nr_infiles
       call get_commandline_arg(n,fname,ierr)
       print*,' reading file ',fname(1:len_trim(fname))
       iret=nf_open(fname,NF_NOWRITE,ncin)
       if (iret /=0 ) goto 110
       call copy_file_attributes(ncin,ncout)
       call search_nr_variables(ncin,nr)
       allocate(varnames(nr))
       call search_variables(ncin,nr,varnames)
       do m=1,nr
        print*,' copying variable ',varnames(m)(1:len_trim(varnames(m)))
        iret=nf_inq_varid(ncin,varnames(m),id)
        if (iret /=0 ) goto 120
        call copy_variable(ncin,ncout,varnames(m),.false.,0)
       enddo
       deallocate(varnames)
       call ncclos (ncin, iret)
       if (iret /=0 ) goto 130
      enddo

      outstr='\n merged by nc_merge.x : '
      iret = NF_PUT_ATT_TEXT (NCout, nf_global, 
     &       'history',len_trim(outstr) , outstr)
      iret = nf_enddef(ncout)

c   close all files
      call ncclos (ncout, iret); if (iret /=0 ) goto 130
      print*,'all done, bye'
      stop

 100  print*,' program needs command line parameter'
      print*,' input netcdf file names, output netcdf file name'
      stop
 110  print*,' problem opening NetCDF file ',fname(1:len_trim(fname))
      print*,' netcdf lib says: ',nf_strerror(iret)
      stop
 120  print*,' problem finding variable '
      print*,' netcdf lib says: ',nf_strerror(iret)
      stop
 130  print*,' problem closing NetCDF file '
      print*,' netcdf lib says: ',nf_strerror(iret)
      stop
      end program nc_merge





c   dummy routines

      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"




      subroutine pe0_recv_2D(a)
c
c--------------------------------------------------------------
c     all PEs send their data of a 2D array to PE0
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"

      real, dimension(imt,jmt)     :: a
      integer                      :: is,ie,js,je,iproc
      integer                      :: tag, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status

      tag  = 0; is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      do iproc=1,n_pes-1
       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(is,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(ie,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(js,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(je,1,impiinteger,0,tag,my_comm,ierr)
        len=(ie-is+1)*(je-js+1)
        call mpi_send(a(is:ie,js:je),len,impireal,0,tag,my_comm,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(is,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(ie,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(js,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(je,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        len=(ie-is+1)*(je-js+1)
        call  mpi_recv(a(is:ie,js:je),len,impireal,iproc,tag,my_comm,
     &                  Status,ierr)
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_recv_2D




      subroutine pe0_send_2D(a)
c
c--------------------------------------------------------------
c     all PEs gets data of a 2D array from PE0
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"

      real, dimension(imt,jmt)     :: a
      integer                      :: is,ie,js,je,iproc
      integer                      :: tag, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status

      tag  = 0; is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      do iproc=1,n_pes-1
       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(is,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(ie,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(js,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(je,1,impiinteger,0,tag,my_comm,ierr)
        len=(ie-is+1)*(je-js+1)
        call mpi_recv(a(is:ie,js:je),len,impireal,0,tag,my_comm,
     &                status,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(is,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(ie,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(js,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(je,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        len=(ie-is+1)*(je-js+1)
        call mpi_send(a(is:ie,js:je),len,impireal,iproc,tag,my_comm,
     &                  ierr)
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_send_2D




      subroutine pe0_send_2D_overlp(a,nx)
c
c--------------------------------------------------------------
c     all PEs gets data of a 2D array from PE0
c     send nx j-and irows overlapping infromation
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      integer                      :: nx
      real, dimension(imt,jmt)     :: a
      integer                      :: is,ie,js,je,iproc
      integer                      :: tag, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status

      tag  = 0; 

      is=max(is_pe-nx,1); ie=min(ie_pe+nx,imt)
      js=max(js_pe-nx,1); je=min(je_pe+nx,jmt)

      do iproc=1,n_pes-1
       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(is,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(ie,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(js,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(je,1,impiinteger,0,tag,my_comm,ierr)
        len=(ie-is+1)*(je-js+1)
        call mpi_recv(a(is:ie,js:je),len,impireal,0,tag,my_comm,
     &                status,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(is,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(ie,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(js,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(je,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        len=(ie-is+1)*(je-js+1)
        call mpi_send(a(is:ie,js:je),len,impireal,iproc,tag,my_comm,
     &                  ierr)
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_send_2D_overlp


      subroutine border_exchg(a,kk,jx)
c
c--------------------------------------------------------------
c     Exchange overlapping areas of array a in all PEs of sub 
c     domain. Number of overlapping indicees are given by jx.
c     Second dimension is given by kk (maybe 1 for 2D array)
c--------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer jx ,kk
      real a(is_pe-jx:ie_pe+jx,kk,js_pe-jx:je_pe+jx)
#ifndef no_mpp
#include "sub_mpif.h"
      real       buffer(max(j_blk+jx*2+1,i_blk+jx*2+1)*jx)      
      integer    is,ie,js,je
      integer    i1,i2,k,len,jj,jxx,ii,j1,j2
      integer                             :: tag, ierr, req
      integer,dimension(MPI_STATUS_SIZE)  :: Status
c
      tag  = 0
      is = is_pe
      ie = ie_pe
      i1=max(1,is_pe-jx)
      i2=min(imt,ie_pe+jx)
      j1=js_pe-jx
      j2=je_pe+jx
      js=max(1,js_pe-jx)
      je=min(jmt,je_pe+jx)
      do k=1,kk
       if (n_pes_i .gt. 1) then
        jj=je-js+1
        len=jj*jx
        if (len > max(j_blk+jx*2+1,i_blk+jx*2+1)*jx ) 
     &      call halt_stop('in border_exchg (1)')
c      Austausch von Osten nach Westen
        call mpi_barrier(my_comm,ierr)
        if (my_blk_i /=1 ) then
         do jxx=1,jx
           buffer(jj*(jxx-1)+1:jj*jxx) =a(is+jxx-1,k,js:je)
         enddo
         call mpi_send(buffer,len,impireal,my_pe-1,
     &                 tag,my_comm,ierr)
        endif
        if (my_blk_i /= n_pes_i ) then
         call mpi_recv(buffer,len,impireal,my_pe+1,
     &                 tag,my_comm,status,ierr)
         do jxx=1,jx
          a(ie+jxx,k,js:je)    = buffer(jj*(jxx-1)+1:jj*jxx)
         enddo
        endif
c      Austausch von Westen nach Osten
        call mpi_barrier(my_comm,ierr)
        if (my_blk_i /= n_pes_i ) then
         do jxx=1,jx
          buffer(jj*(jxx-1)+1:jj*jxx)=a(ie-(jxx-1),k,js:je)   
         enddo
         call mpi_send(buffer,len,impireal,my_pe+1,
     &                 tag,my_comm,ierr)
        endif
        if (my_blk_i /=1 ) then
         call mpi_recv(buffer,len,impireal,my_pe-1,
     &                 tag,my_comm,status,ierr)
         do jxx=1,jx
          a(is-jxx,k,js:je)   = buffer(jj*(jxx-1)+1:jj*jxx)
         enddo
        endif
       endif
c
       if ( n_pes_j .gt. 1) then
        ii=i2-i1+1
        len=ii*jx
        if (len > max(j_blk+jx*2+1,i_blk+jx*2+1)*jx ) 
     &      call halt_stop('in border_exchg (2)')
c    Austausch von Norden nach Sueden
        call mpi_barrier(my_comm,ierr)
        if (my_blk_j /=1 ) then
         do jxx=2*jx-1,jx,-1
          call mpi_send(a(i1,k,j1+jxx),ii,impireal,my_pe-n_pes_i,
     &                  tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /= n_pes_j) then 
         do jxx=0,jx-1
          call mpi_recv(a(i1,k,j2-jxx),ii,
     &        impireal,my_pe+n_pes_i,tag,my_comm,Status,ierr)
         enddo
        endif
c     Austausch von Sueden nach Norden
        call mpi_barrier(my_comm,ierr)
        if (my_blk_j /= n_pes_j) then 
         do jxx=jx,2*jx-1
         call mpi_send(a(i1,k,j2-jxx),ii,impireal,my_pe+n_pes_i,
     &                tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /=1 ) then
         do jxx=jx-1,0,-1
          call mpi_recv(a(i1,k,j1+jxx),ii,
     &        impireal,my_pe-n_pes_i,tag,my_comm,Status,ierr)
         enddo
        endif
       endif
      enddo
#endif
      end subroutine border_exchg


      subroutine border_exchg_north(a,kk,jx)
c
c--------------------------------------------------------------
c     Exchange overlapping areas of array a(jmt,km) in all PEs of sub 
c     domain. Number of overlapping indicees are given by jx.
c     Second dimension is given by kk (maybe 1 for 2D array)
c     Diff to border_exchange: no i-dir here
c--------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer jx ,kk
      real a(js_pe-jx:je_pe+jx,kk)
#ifndef no_mpp
#include "sub_mpif.h"
      real       buffer(max(j_blk+jx*2+1,i_blk+jx*2+1)*jx)      
      integer    js,je
      integer    k,len,jj,jxx,j1,j2
      integer                             :: tag, ierr, req
      integer,dimension(MPI_STATUS_SIZE)  :: Status
c
      tag  = 0
      j1=js_pe-jx
      j2=je_pe+jx
      js=max(1,js_pe-jx)
      je=min(jmt,je_pe+jx)
      do k=1,kk
       if ( n_pes_j .gt. 1) then
        if (jx > max(j_blk+jx*2+1,i_blk+jx*2+1)*jx ) 
     &      call halt_stop('in border_exchg_north (2)')
c    Austausch von Norden nach Sueden
        call mpi_barrier(my_comm,ierr)
        if (my_blk_j /=1 ) then
         do jxx=2*jx-1,jx,-1
          call mpi_send(a(j1+jxx,k),1,impireal,my_pe-n_pes_i,
     &                  tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /= n_pes_j) then 
         do jxx=0,jx-1
          call mpi_recv(a(j2-jxx,k),1,
     &        impireal,my_pe+n_pes_i,tag,my_comm,Status,ierr)
         enddo
        endif
c     Austausch von Sueden nach Norden
        call mpi_barrier(my_comm,ierr)
        if (my_blk_j /= n_pes_j) then 
         do jxx=jx,2*jx-1
         call mpi_send(a(j2-jxx,k),1,impireal,my_pe+n_pes_i,
     &                tag,my_comm,ierr)
         enddo
        endif
        if (my_blk_j /=1 ) then
         do jxx=jx-1,0,-1
          call mpi_recv(a(j1+jxx,k),1,
     &        impireal,my_pe-n_pes_i,tag,my_comm,Status,ierr)
         enddo
        endif
       endif
      enddo
#endif
      end subroutine border_exchg_north



      subroutine set_cyclic(v,kx,jx)
c
c-----------------------------------------------------------------------
c     adjust borders of an array for cyclic and symmetry settings
c     Communicate in local sub domain.
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer kx,jx
      real, dimension(is_pe-jx:ie_pe+jx,kx,js_pe-jx:je_pe+jx) :: v
#ifndef no_mpp
#include "sub_mpif.h"
      integer tag,ierr,len
      integer,dimension(MPI_STATUS_SIZE)  :: Status
#endif
      if (cyclic) then
       if (n_pes_i == 1) then
        v(1,:,:)   = v(imt-1,:,:)
	v(imt,:,:) = v(2,:,:)
       else
#ifndef no_mpp
        len=kx*(je_pe-js_pe+1+2*jx)
        tag=1
        if (my_blk_i ==1 )        call mpi_send(v(2,:,:),len,
     &      impireal,my_pe+(n_pes_i-1),tag,my_comm,ierr)
        if (my_blk_i == n_pes_i ) call mpi_recv(v(imt,:,:),len,
     &      impireal,my_pe-(n_pes_i-1),tag,my_comm,status,ierr)
        tag=2
        if (my_blk_i ==n_pes_i )  call mpi_send(v(imt-1,:,:),len,
     &       impireal,my_pe-(n_pes_i-1),tag,my_comm,ierr)
        if (my_blk_i == 1 )       call mpi_recv(v(1,:,:),len,
     &       impireal,my_pe+(n_pes_i-1),tag,my_comm,status,ierr)
#else
        call halt_stop(' in set_cyclic')
#endif
       endif
      endif
      end subroutine set_cyclic



      subroutine set_cyclic_nx(v,kx,jx)
c
c-----------------------------------------------------------------------
c     adjust borders of an array for cyclic and symmetry settings
c     Communicate in local sub domain.
c     adjust for nx i-slabs at cyclic boundary
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer kx,jx
      real, dimension(is_pe-jx:ie_pe+jx,kx,js_pe-jx:je_pe+jx) :: v
      integer i
#ifndef no_mpp
#include "sub_mpif.h"
      integer tag,ierr,len
      integer,dimension(MPI_STATUS_SIZE)  :: Status
#endif

      if (cyclic) then
       if (n_pes_i == 1) then
        do i=1,jx
         v(1-i+1  ,:,:)= v(imt-i,:,:)
	 v(imt+i-1,:,:) = v(i+1,:,:)
        enddo
       else
#ifndef no_mpp
        len=kx*(je_pe-js_pe+1+2*jx)
        do i=1,jx
         tag=1
         if (my_blk_i ==1 )        call mpi_send(v(i+1,:,:),len,
     &      impireal,my_pe+(n_pes_i-1),tag,my_comm,ierr)
         if (my_blk_i == n_pes_i ) call mpi_recv(v(imt+i-1,:,:),len,
     &      impireal,my_pe-(n_pes_i-1),tag,my_comm,status,ierr)
         tag=2
         if (my_blk_i ==n_pes_i )  call mpi_send(v(imt-i,:,:),len,
     &       impireal,my_pe-(n_pes_i-1),tag,my_comm,ierr)
         if (my_blk_i == 1 )       call mpi_recv(v(1-i+1,:,:),len,
     &       impireal,my_pe+(n_pes_i-1),tag,my_comm,status,ierr)
        enddo
#else
        call halt_stop(' in set_cyclic_nx')
#endif
       endif
      endif
      end subroutine set_cyclic_nx



      subroutine set_cyclic_4th_order(v,kx,jx)
c
c-----------------------------------------------------------------------
c     adjust borders of an array for cyclic and symmetry settings
c     Communicate in local sub domain.
c     adjust for 4th order advection schemes
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer kx,jx
      real, dimension(is_pe-jx:ie_pe+jx,kx,js_pe-jx:je_pe+jx) :: v
#ifndef no_mpp
#include "sub_mpif.h"
      integer tag,ierr,len
      integer,dimension(MPI_STATUS_SIZE)  :: Status
#endif
      if (jx<2) then
        if (my_pe==0) then
          print*,' adjust arrays for 4th order advection schemes'
          print*,' only if they are dimensioned correctly.'
          print*,' (jx=',jx,' must be greater or equal 2)'
        endif
        call halt_stop(' in set_cyclic_4th_order')
      endif

      if (cyclic) then
       if (n_pes_i == 1) then
        v(0,:,:)   = v(imt-2,:,:)
	v(imt+1,:,:) = v(3,:,:)
       else
#ifndef no_mpp
        len=kx*(je_pe-js_pe+1+2*jx)
        tag=1
        if (my_blk_i ==1 )        call mpi_send(v(3,:,:),len,
     &      impireal,my_pe+(n_pes_i-1),tag,my_comm,ierr)
        if (my_blk_i == n_pes_i ) call mpi_recv(v(imt+1,:,:),len,
     &      impireal,my_pe-(n_pes_i-1),tag,my_comm,status,ierr)
        tag=2
        if (my_blk_i ==n_pes_i )  call mpi_send(v(imt-2,:,:),len,
     &       impireal,my_pe-(n_pes_i-1),tag,my_comm,ierr)
        if (my_blk_i == 1 )       call mpi_recv(v(0,:,:),len,
     &       impireal,my_pe+(n_pes_i-1),tag,my_comm,status,ierr)
#else
        call halt_stop(' in set_cyclic_4th_order')
#endif
       endif
      endif
      end subroutine set_cyclic_4th_order


      subroutine set_cyclic_int(v,kx,jx)
c
c-----------------------------------------------------------------------
c     adjust borders of an array for cyclic and symmetry settings
c     Communicate in local sub domain.
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer kx,jx
      integer, dimension(is_pe-jx:ie_pe+jx,kx,js_pe-jx:je_pe+jx) :: v
#ifndef no_mpp
#include "sub_mpif.h"
      integer tag,ierr,len
      integer,dimension(MPI_STATUS_SIZE)  :: Status
#endif
      if (cyclic) then
       if (n_pes_i == 1) then
        v(1,:,:)   = v(imt-1,:,:)
	v(imt,:,:) = v(2,:,:)
       else
#ifndef no_mpp
        len=kx*(je_pe-js_pe+1+2*jx)
        tag=1
        if (my_blk_i ==1 )        call mpi_send(v(2,:,:),len,
     &      impiinteger,my_pe+(n_pes_i-1),tag,my_comm,ierr)
        if (my_blk_i == n_pes_i ) call mpi_recv(v(imt,:,:),len,
     &      impiinteger,my_pe-(n_pes_i-1),tag,my_comm,status,ierr)
        tag=2
        if (my_blk_i ==n_pes_i )  call mpi_send(v(imt-1,:,:),len,
     &       impiinteger,my_pe-(n_pes_i-1),tag,my_comm,ierr)
        if (my_blk_i == 1 )       call mpi_recv(v(1,:,:),len,
     &       impiinteger,my_pe+(n_pes_i-1),tag,my_comm,status,ierr)
#else
        call halt_stop(' in set_cyclic_int')
#endif
       endif
      endif
      end subroutine set_cyclic_int




      subroutine   sum_along_jrow(v,k)
c
c-----------------------------------------------------------------------
c     sum over jrow, store result in v of the westernmost PE
c     all in local domain
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer k
      real v(k), buf(k)
#ifndef no_mpp
#include "sub_mpif.h"
      integer :: comm,i_first_pe,n,ierr
      integer :: status(MPI_STATUS_SIZE)

      if ( n_pes_i .gt. 1 ) then
        i_first_pe =  (my_blk_j - 1) * n_pes_i
        buf=v
        do n=i_first_pe+1, i_first_pe+n_pes_i-1
         if ( my_pe == n )  call mpi_send (buf,k,
     &         impireal,i_first_pe,1,my_comm,ierr)
         if ( my_pe == i_first_pe  ) call mpi_recv (buf,k,
     &         impireal,n,1,my_comm,status,ierr)
         if (my_pe == i_first_pe) v=v+buf
        enddo
      endif
#endif
      end subroutine sum_along_jrow



      subroutine   max_along_jrow(v,k)
c
c-----------------------------------------------------------------------
c     maximum over jrow, store result in v of the westernmost PE
c     all in local domain
c-----------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer k
      real v(k), buf(k)
#ifndef no_mpp
#include "sub_mpif.h"
      integer :: comm,i_first_pe,n,ierr
      integer :: status(MPI_STATUS_SIZE)

      if ( n_pes_i .gt. 1 ) then
        i_first_pe =  (my_blk_j - 1) * n_pes_i
        buf=v
        do n=i_first_pe+1, i_first_pe+n_pes_i-1
         if ( my_pe == n )  call mpi_send (buf,k,
     &         impireal,i_first_pe,1,my_comm,ierr)
         if ( my_pe == i_first_pe  ) call mpi_recv (buf,k,
     &         impireal,n,1,my_comm,status,ierr)
         if (my_pe == i_first_pe) v=max(v,buf)
        enddo
      endif
#endif
      end subroutine max_along_jrow



      subroutine pe0_recv_vec_along_jrow(a,sdim)
c
c--------------------------------------------------------------
c     all PEs send their data of a 2D vector along j to PE0
c     meant mainly for overturning and heat transport
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      integer                      :: sdim
      real, dimension(jmt,sdim)    :: a
      integer                      :: is,ie,js,je,iproc
      integer                      :: tag, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status

      tag  = 0; is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      do iproc=1,n_pes-1
       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        call mpi_send(js,1,impiinteger,0,tag,my_comm,ierr)
        call mpi_send(je,1,impiinteger,0,tag,my_comm,ierr)
        len=(sdim)*(je-js+1)
        call mpi_send(a(js:je,:),len,impireal,0,tag,my_comm,ierr)
       endif
       if ( my_pe == 0 ) then
        call mpi_recv(js,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        call mpi_recv(je,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        len=(sdim)*(je-js+1)
        call  mpi_recv(a(js:je,:),len,impireal,iproc,tag,my_comm,
     &                  Status,ierr)
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_recv_vec_along_jrow


      subroutine pe0_recv_merid_vec(a,sdim,i0)
c
c--------------------------------------------------------------
c     all PEs whos domains contain longitudinal slab i0
c     send their data of 2D vector a along j to PE0
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      integer                      :: sdim,i0
      real, dimension(jmt,sdim)    :: a
      integer                      :: is,ie,js,je
      integer                      :: is2,ie2,js2,je2,k
      integer                      :: iproc
      integer                      :: tag, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status

      tag  = 0; is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      do iproc=1,n_pes-1

       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        if (is <= i0 .and. ie >= i0 ) then
         k=1
         call mpi_send(k,1,impiinteger,0,tag,my_comm,ierr)
         call mpi_send(js,1,impiinteger,0,tag,my_comm,ierr)
         call mpi_send(je,1,impiinteger,0,tag,my_comm,ierr)
         len=(sdim)*(je-js+1)
         call mpi_send(a(js:je,:),len,impireal,0,tag,my_comm,ierr)
        else
         k=0
         call mpi_send(k,1,impiinteger,0,tag,my_comm,ierr)
        endif
       endif

       if ( my_pe == 0 ) then
        call mpi_recv(k,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        if (k==1) then
         call mpi_recv(js2,1,impiinteger,iproc,tag,my_comm,Status,ierr)
         call mpi_recv(je2,1,impiinteger,iproc,tag,my_comm,Status,ierr)
         len=(sdim)*(je2-js2+1)
         call  mpi_recv(a(js2:je2,:),len,impireal,iproc,tag,my_comm,
     &                   Status,ierr)
        endif
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_recv_merid_vec



      subroutine pe0_recv_zonal_vec(a,sdim,j0)
c
c--------------------------------------------------------------
c     all PEs whos domains contain latitudinal slab j0
c     send their data of 2D vector a along i to PE0
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      integer                      :: sdim,j0
      real, dimension(imt,sdim)    :: a
      integer                      :: is,ie,js,je
      integer                      :: is2,ie2,js2,je2,k
      integer                      :: iproc
      integer                      :: tag, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status

      tag  = 0; is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      do iproc=1,n_pes-1

       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        if (js <= j0 .and. je >= j0 ) then
         k=1
         call mpi_send(k,1,impiinteger,0,tag,my_comm,ierr)
         call mpi_send(is,1,impiinteger,0,tag,my_comm,ierr)
         call mpi_send(ie,1,impiinteger,0,tag,my_comm,ierr)
         len=(sdim)*(ie-is+1)
         call mpi_send(a(is:ie,:),len,impireal,0,tag,my_comm,ierr)
        else
         k=0
         call mpi_send(k,1,impiinteger,0,tag,my_comm,ierr)
        endif
       endif

       if ( my_pe == 0 ) then
        call mpi_recv(k,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        if (k==1) then
         call mpi_recv(is2,1,impiinteger,iproc,tag,my_comm,Status,ierr)
         call mpi_recv(ie2,1,impiinteger,iproc,tag,my_comm,Status,ierr)
         len=(sdim)*(ie2-is2+1)
         call  mpi_recv(a(is2:ie2,:),len,impireal,iproc,tag,my_comm,
     &                   Status,ierr)
        endif
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_recv_zonal_vec



      subroutine pe0_recv_depth_vec(a,sdim,i0,j0)
c
c--------------------------------------------------------------
c     the PE whos domain contain position i0,j0
c     send its data a(km,sdim) to PE0
c--------------------------------------------------------------
c
#ifndef no_mpp
      use spflame_module
      implicit none
#include "sub_mpif.h"
      integer                      :: sdim,j0,i0
      real, dimension(km,sdim)     :: a
      integer                      :: is,ie,js,je
      integer                      :: is2,ie2,js2,je2,k
      integer                      :: iproc
      integer                      :: tag, ierr,len
      integer, dimension(MPI_STATUS_SIZE) :: Status

      tag = 0; is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      do iproc=1,n_pes-1

       call mpi_barrier(my_comm,ierr)
       if ( my_pe == iproc ) then
        if (js <= j0 .and. je >= j0 .and. is <= i0 .and. ie >= i0 ) then
         k=1
         call mpi_send(k,1,impiinteger,0,tag,my_comm,ierr)
         len=sdim*km
         call mpi_send(a,len,impireal,0,tag,my_comm,ierr)
        else
         k=0
         call mpi_send(k,1,impiinteger,0,tag,my_comm,ierr)
        endif
       endif

       if ( my_pe == 0 ) then
        call mpi_recv(k,1,impiinteger,iproc,tag,my_comm,Status,ierr)
        if (k==1) then
         len=sdim*km
         call  mpi_recv(a,len,impireal,iproc,tag,my_comm,Status,ierr)
        endif
       endif
       call mpi_barrier(my_comm,ierr)
      enddo
#endif
      end subroutine pe0_recv_depth_vec

#include "options.inc"



      subroutine setup (domains_,sub_domain_,
     &                      sub_domain_pe0_,my_comm_)
c
c---------------------------------------------------------------------
c     set up everything for the ocean model
c     c.eden
c---------------------------------------------------------------------
c
      use spflame_module
      implicit none
      integer domains_,sub_domain_,sub_domain_pe0_(domains_),my_comm_

      domains=domains_
      sub_domain=sub_domain_
      sub_domain_pe0(1:domains)=sub_domain_pe0_(1:domains)
      my_comm=my_comm_
c
c-----------------------------------------------------------------------
c     set up main module, the grid, the equations of state,
c     the topography, the poisson solver or free surface, 
c     initial conditions and the diagnostic output.
c-----------------------------------------------------------------------
c
      call sub_flush(6)
      call init_spflame_module
      call sub_flush(6)
      call grids
      call init_dens_module(zt,km,my_pe)
      call topog
      call init_congrad
      if (enable_freesurf) call init_freesurf
      call initial_cond
c
c-----------------------------------------------------------------------
c     set up the time manager
c-----------------------------------------------------------------------
c
      time_manager_verbose=.false.               ! be quiet
      if (my_pe==0) time_manager_verbose=.true.  ! be verbose
      call init_time_manager(time_step,runlen,snap_int,
     &                       restart_stamp,itt_restart )
c
c-----------------------------------------------------------------------
c     set up various modules
c-----------------------------------------------------------------------
c
      call init_diag
      call sub_flush(6)
      if (enable_cgh_vert_mixing)      call init_cghmix 
      if (enable_tkemix)               call tkemix_init
      if (enable_bbl)                  call bbl_init
      if (enable_diffusion_isoneutral) call isoneutral_init
      if (enable_diffusion_isopycnic)  call isopycnic_init
      if (enable_blue)                 call blue_init
      if (enable_blue_mean)            call blue_mean_init
      if (enable_quicker_advection)    call init_quicker
      if (enable_upstream_advection)   call init_adv_flux_upstream
      if (enable_4th_advection)        call init_adv_flux_4th
      if (enable_fct_advection)        call init_adv_flux_fct
      if (enable_flux_delimiter)       call flux_delimit_init
                                       call implicitvmix_init()
                                       call passive_tracer_init()
      call sub_flush(6)
c
c-----------------------------------------------------------------------
c     set up the io-procedure for SBC/OBC and sponge layers
c-----------------------------------------------------------------------
c
      if (mother< 0) then
#ifdef couple
        call sbc_couple_init()
#else
       if (.not.enable_simple_sbc) call sbc_initialize
#endif
       if (.not.enable_simple_obc) call obc_initialize
      else
       ! child domains get their data for SBC and OBS from mother domain
      endif

      if (enable_sponge .and. .not. enable_simple_spg) then
        call sponge_initialize
      endif

      call sub_flush(6)

c
c-----------------------------------------------------------------------
c      some output about compiler directives
c-----------------------------------------------------------------------
c
      if (my_pe==0) then
       print*,' '
       print*,' you have switched on the following compiler directives:'
#ifdef partial_cell
       print*,'  -- partial_cell --'
       print*,'      enables partial filled bottom cells'
#endif
#ifdef relax_traditional_approx
       print*,'  -- relax_traditional_approx --'
       print*,'      relax traditional approximation'
#endif
       print*,' end of list'
       print*,' '
       print*,' the following compiler directives were derived:'
#ifdef vector_host
       print*,'  -- vector_host --'
       print*,'      enables vectorized code fragments '
#endif
       print*,' end of list'
       print*,' '
      endif
c
c-----------------------------------------------------------------------
c     some checks
c-----------------------------------------------------------------------
c
      call checks()

      if (my_pe==0) then
       print*,''
       print*,' ok, ready to launch the integration ...'
       print*,''
      endif
      call sub_flush(6)

      end subroutine setup



      subroutine initial_cond()
c
c-----------------------------------------------------------------------
c      set up initial conditions or read restart
c-----------------------------------------------------------------------
c
      use spflame_module
      use freesurf_module
      implicit none
      integer :: i,j,k,n, is,ie,js,je,ioT,ioS,kk
      real :: x
      character(len=32) :: s
      real, allocatable    :: buf(:,:)
      character (len=40) :: tr_name

      is=max(is_pe,2); ie=min(ie_pe,imt-1);
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      u=0.; t=0.; psi=0.

      if (mother<0) then ! mother domain reads first initial conditions

       if (read_restart) then
        call read_restart_file
       else

        restart_stamp ='m/d/y= 1/ 1/1900, h:m:s= 0: 0: 0' 
        itt_restart=1
        u=0.
        if (enable_ktmix) dml(is:ie,js:je)=0.
        if (enable_tkemix) eke=0.

        if (enable_simple_initial_cond) then

         call init_cond_template()

        else 
c
c-----------------------------------------------------------------------
c      read in T and S from files
c      which have to be prepared beforehand. Here we are using
c      the FLAME format for initial conditions.
c-----------------------------------------------------------------------
c
         allocate(buf(imt,km))
         do n=1,nt
          if (my_pe==0) then
           if (n==1) tr_name = 'temp.mom.ic'
           if (n==2) tr_name = 'salt.mom.ic'
           if (n>2) then
            write(tr_name, '("tracer_",i2,".mom.ic")') n
            do i=1,len_trim(tr_name)
              if (tr_name(i:i) == ' ') tr_name(i:i)='0'
            enddo
           endif
           print*,' '
           print*,' reading initial conditions from file ',
     &            tr_name(1:len_trim(tr_name))
           call getunit (ioT,tr_name, 'u s r ieee')
           read(ioT)  
          endif
          do j=1,jmt
           if (my_pe==0) then
            read(ioT)  
            read (ioT) s,x,kk,kk,kk,x,kk,(x,i=1,imt),(x,k=1,km),buf
           endif
           call bcast_real(buf,imt*km,0)
           if (js_pe  <= j .and. je_pe >= j ) then
            do i=is_pe,ie_pe
             t(i,:,j,n,0) = buf(i,:)*tmask(i,:,j)
             t(i,:,j,n,1) = buf(i,:)*tmask(i,:,j)
             t(i,:,j,n,2) = buf(i,:)*tmask(i,:,j)
            enddo
           endif
          enddo ! j loop
          if (my_pe==0) close(ioT)
         enddo ! n loop
         deallocate(buf)

         if (my_pe==0) then
           print*,' done '
           print*,' '
         endif

        endif ! enable_simple_initial_cond

       endif  ! read_restart

      endif  ! mother <0
c
c     exchange initial conditions and whatelse necessary
c     over the sub domains
c
      call initial_exchg
c
c     exchange inner boundaries here
c
      do n=1,nt
c       call border_exchg(t(:,:,:,n,0),km,2)
c       call border_exchg(t(:,:,:,n,1),km,2)
c       call border_exchg(t(:,:,:,n,2),km,2)
       call border_exchg(t(is_pe-2,1,js_pe-2,n,0),km,2)
       call border_exchg(t(is_pe-2,1,js_pe-2,n,1),km,2)
       call border_exchg(t(is_pe-2,1,js_pe-2,n,2),km,2)
      enddo
      do n=1,2
c       call border_exchg(u(:,:,:,n,0),km,2)
c       call border_exchg(u(:,:,:,n,1),km,2)
c       call border_exchg(u(:,:,:,n,2),km,2)
       call border_exchg(u(is_pe-2,1,js_pe-2,n,0),km,2)
       call border_exchg(u(is_pe-2,1,js_pe-2,n,1),km,2)
       call border_exchg(u(is_pe-2,1,js_pe-2,n,2),km,2)
      enddo

      if (enable_freesurf) then
       do n=1,2
        call border_exchg(ubar(:,:,n),1,1)
        call border_exchg(ps(:,:,n),1,1)
       enddo
       do n=1,3
        call border_exchg(etat(:,:,n),1,1)
       enddo
      else
       call border_exchg(ptd(:,:),1,1)
       call border_exchg(guess(:,:),1,1)
       call border_exchg(psi(:,:,1),1,1)
       call border_exchg(psi(:,:,2),1,1)
      endif
      is=max(is_pe,2); ie=min(ie_pe,imt-2) ! inconsistency with clinic !
      js=max(2,js_pe); je=min(je_pe,jmt-2)
      do j=js-1,je+1
       do k=1,km
        call model_dens(t(is-1,k,j,1,tau), t(is-1,k,j,2,tau),
     &                  rho(is-1,k,j),k,ie-is+3
#ifdef partial_cell
     &                       ,ztp(is-1,k,j)
#endif
     &                       )
       enddo
      enddo
      end subroutine initial_cond



      subroutine write_restart_file
c
c-----------------------------------------------------------------------
c      write a restart file
c-----------------------------------------------------------------------
c
      use spflame_module
      use freesurf_module
      implicit none
      integer i,j,k,io,n, is,ie,js,je
      character (len=80) :: filename
      real buf(imt,jmt)

      is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      write(filename, '("restart_",i3,".dta")') sub_domain
      do i=1,len_trim(filename)
         if (filename(i:i) == ' ') filename(i:i)='0'
      enddo

      if (my_pe==0) then
       print*,' writing to restart file ',filename(1:len_trim(filename))
      endif

      call get_free_iounit(io)
      open(io,file=filename,form='unformatted',status='unknown')

      if (my_pe==0) write(io) itt,current_stamp,nt

      if (enable_freesurf) then

       do n=1,2
        buf(is:ie,js:je)=ubar(is:ie,js:je,n)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf

        buf(is:ie,js:je)=ps(is:ie,js:je,n)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
       enddo

       do n=1,3
        buf(is:ie,js:je)=etat(is:ie,js:je,n)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
       enddo

      else

       buf(is:ie,js:je)=ptd(is:ie,js:je)
       call pe0_recv_2D(buf)
       if (my_pe==0) write(io) buf

       buf(is:ie,js:je)=guess(is:ie,js:je)
       call pe0_recv_2D(buf)
       if (my_pe==0) write(io) buf

       buf(is:ie,js:je)=psi(is:ie,js:je,1)
       call pe0_recv_2D(buf)
       if (my_pe==0) write(io) buf

       buf(is:ie,js:je)=psi(is:ie,js:je,2)
       call pe0_recv_2D(buf)
       if (my_pe==0) write(io) buf
      endif

      do k=1,km
       do n=1,nt
        buf(is:ie,js:je)=t(is:ie,k,js:je,n,taum1)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
        buf(is:ie,js:je)=t(is:ie,k,js:je,n,tau)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
       enddo
       do n=1,2
        buf(is:ie,js:je)=u(is:ie,k,js:je,n,taum1)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
        buf(is:ie,js:je)=u(is:ie,k,js:je,n,tau)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
       enddo
      enddo

      if (enable_ktmix) then
       buf(is:ie,js:je)=dml(is:ie,js:je)
       call pe0_recv_2D(buf)
       if (my_pe==0) write(io) buf
      endif

      if (enable_tkemix) then
       do k=1,km
        buf(is:ie,js:je)=eke(is:ie,k,js:je,taum1)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
        buf(is:ie,js:je)=eke(is:ie,k,js:je,tau)
        call pe0_recv_2D(buf)
        if (my_pe==0) write(io) buf
       enddo
      endif

      close(io)

      if (my_pe==0) then
c
c      write a little file indicating the itt of the last
c      time step. This file will only be written for a successful
c      end of the integration.
c
       write(filename, '("ritt_",i3)') sub_domain
       do i=1,len_trim(filename)
         if (filename(i:i) == ' ') filename(i:i)='0'
       enddo
       call get_free_iounit(io)
       open(io,file=filename,form='formatted',status='unknown')
       write(io,*) itt
       close(io)

       print*,' all done '
      endif

      end subroutine write_restart_file



      subroutine read_restart_file
c
c-----------------------------------------------------------------------
c      read a restart file
c-----------------------------------------------------------------------
c
      use spflame_module
      use freesurf_module
      implicit none
      integer i,j,k,io,n,is,ie,js,je,nt_in
      character (len=80) :: filename
      real buf(imt,jmt)
      logical :: okay=.true.

      is=is_pe; ie=ie_pe; js=js_pe; je=je_pe

      write(filename, '("restart_",i3,".dta")') sub_domain
      do i=1,len_trim(filename)
         if (filename(i:i) == ' ') filename(i:i)='0'
      enddo

      if (my_pe==0) then
       print*,' reading from restart file ',
     &          filename(1:len_trim(filename))
      endif

      call get_free_iounit(io)
      open(io,file=filename,form='unformatted',status='old')

      if (my_pe==0) read(io) itt_restart,restart_stamp,nt_in
      call bcast_integer(itt_restart,1,0)
      call bcast_char(restart_stamp,32,0)

      if (my_pe==0) then 
       print*,' time stamp = ',restart_stamp
       print*,' itt        = ',itt_restart
       print*,' nt         = ',nt_in
       print*,''
       if (nt_in<nt) then
        print*,''
        print*,' WARNING WARNING WARNING WARNING WARNING'
        print*,' found only ',nt_in,' tracer in file'
        print*,' but number of tracer was set to ',nt
        print*,' this means that the rest is set to zero'
        print*,' WARNING WARNING WARNING WARNING WARNING'
        print*,''
       endif
       if (nt_in>nt) then
        print*,''
        print*,' WARNING WARNING WARNING WARNING WARNING'
        print*,' found ',nt_in,' tracer in file'
        print*,' but number of tracer was set to ',nt
        print*,' this means that the rest is not read'
        print*,' WARNING WARNING WARNING WARNING WARNING'
        print*,''
        nt_in = nt      
       endif
      endif

      call bcast_integer(nt_in,1,0)

      if (enable_freesurf) then

       do n=1,2
        if (my_pe==0) read(io) buf
        call pe0_send_2D(buf)
        ubar(is:ie,js:je,n)=buf(is:ie,js:je)

        if (my_pe==0) read(io) buf
        call pe0_send_2D(buf)
        ps(is:ie,js:je,n)=buf(is:ie,js:je)
       enddo

       do n=1,3
        if (my_pe==0) read(io) buf
        call pe0_send_2D(buf)
        etat(is:ie,js:je,n)=buf(is:ie,js:je)
       enddo

      else
       if (my_pe==0) read(io) buf
       call pe0_send_2D(buf)
       ptd(is:ie,js:je)=buf(is:ie,js:je)

       if (my_pe==0) read(io) buf
       call pe0_send_2D(buf)
       guess(is:ie,js:je)=buf(is:ie,js:je)

       if (my_pe==0) read(io) buf
       call pe0_send_2D(buf)
       psi(is:ie,js:je,1)=buf(is:ie,js:je)

       if (my_pe==0) read(io) buf
       call pe0_send_2D(buf)
       psi(is:ie,js:je,2)=buf(is:ie,js:je)
      endif

      do k=1,km
       do n=1,nt_in ! read only nt_in tracers
        if (my_pe==0) read(io) buf
        call pe0_send_2D(buf)
        t(is:ie,k,js:je,n,taum1)=buf(is:ie,js:je)
        if (my_pe==0) read(io) buf
        call pe0_send_2D(buf)
        t(is:ie,k,js:je,n,tau)=buf(is:ie,js:je)
       enddo
c      set remaining tracers to zero
       do n=nt_in+1,nt
        t(is:ie,k,js:je,n,:)=0.
       enddo
c    skip remaining tracers in restart
       do n=nt+1,nt_in 
        if (my_pe==0) read(io) 
       enddo
       do n=1,2
        if (my_pe==0) read(io) buf
        call pe0_send_2D(buf)
        u(is:ie,k,js:je,n,taum1)=buf(is:ie,js:je)
        if (my_pe==0) read(io) buf
        call pe0_send_2D(buf)
        u(is:ie,k,js:je,n,tau)=buf(is:ie,js:je)
       enddo
      enddo

      if (enable_ktmix) then
       if (my_pe==0) read(io,end=2001) buf
       goto 2002
 2001  okay=.false. 
 2002  call bcast_logical(okay,1,0)
       if (.not. okay) goto 2099
       call pe0_send_2D(buf)
       dml(is:ie,js:je)=buf(is:ie,js:je)
      endif

      if (enable_tkemix) then
       do k=1,km
        if (my_pe==0) read(io,end=1001) buf
        goto 1002
 1001   okay=.false. 
 1002   call bcast_logical(okay,1,0)
        if (.not. okay) goto 1099
        call pe0_send_2D(buf)
        eke(is:ie,k,js:je,taum1)=buf(is:ie,js:je)

        if (my_pe==0) read(io,end=1011) buf
        goto 1012
 1011   okay = .false.
 1012   call bcast_logical(okay,1,0)
        if (.not. okay) goto 1099
        call pe0_send_2D(buf)
        eke(is:ie,k,js:je,tau)=buf(is:ie,js:je)
       enddo
      endif

      close(io)
      if (my_pe==0) then
       print*,' done'
      endif
      return

 1099 if (my_pe==0) then
       print*,''
       print*,'---------------------------------------------'
       print*,' WARNING : cannot read TKE from file '
       print*,' ', filename(1:len_trim(filename))
       print*,' setting TKE = 0 '
       print*,'---------------------------------------------'
       print*,''
      endif
      close(io)
      eke=0.
      return

 2099 if (my_pe==0) then
       print*,''
       print*,'---------------------------------------------'
       print*,' WARNING : cannot read mixed layer from file '
       print*,' ', filename(1:len_trim(filename))
       print*,' setting dml = 0 '
       print*,'---------------------------------------------'
       print*,''
      endif
      close(io)
      dml=0.
      return


      end subroutine read_restart_file

#include "options.inc"
c
c-----------------------------------------------------------------------
c    inertial instability
c-----------------------------------------------------------------------
c
      module jets_module
c
c    u(t=0) = u_0 + u_y y + delta y**2 + amp noise
c    T(t=0) = 20.0+rho0/(g alpha)*N**2
c    T*     = 20.0+rho0/(g alpha)*(N**2- u_z f y)
c    N**2   = Bv0**2 int_(-h)^0  exp(-z/h_W)  dz
c
      real,parameter :: g   = 9.81e2 ! cm/s^2
      real,parameter :: Bv0 = 0.0005 ! 1/s
      real,parameter :: h_W = 300.0e12
      real,parameter :: delta = 0.0e-13 ! 1/s /cm
      real,parameter :: u_y   = 10.0e-6  ! 1/s
      real,parameter :: u_0   = 0.0     ! cm/s
      real,parameter :: u_z   = 0.0e-3  ! 1/s
      real,parameter :: amp   = 0.1     ! cm/s
      real,parameter :: tscl   = 1.0/(3.0*86400.0)   ! 1/s
      end module jets_module



      subroutine grid_template()
c-----------------------------------------------------------------------
c     set up a grid here
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      real :: dx=0.,dy=0.,dz=0.,x0=0.,y0=0.,sumt,sumu
      integer i,k
c     equidistant vertical grid
      logical :: flame_grid = .false.
      integer,parameter :: km_in = 200
      real ddz(km_in)
      data ddz/ 200*5.e2/
c
      x0=280.; y0=-3.0; dx = 1./6.; dy = dx
      if (my_pe==0) then
        print*,''
        print*,'setting up a simple grid '
        print*,' dx= ',dx,' dy= ',dy
        print*,''
      endif
      dxtdeg =  dx  ; dytdeg =  dy  ; dxudeg =  dx  ; dyudeg =  dy  
      xt(1)=x0; xu(1)=x0+dxtdeg(1)/2.
      do i=2,imt
        xt(i)=xt(i-1)+dxtdeg(i); xu(i)=xu(i-1)+dxudeg(i)
      enddo
      yt(1)=y0; yu(1)=y0+dytdeg(1)/2.
      do i=2,jmt
        yt(i)=yt(i-1)+dytdeg(i); yu(i)=yu(i-1)+dyudeg(i)
      enddo
      if (km /= km_in ) then
        print*,' km must be ',km_in
        stop
      endif
      dzt=ddz; dzw(1) = dzt(1); sumt = dzt(1)
      sumu = 0.5*dzt(1) + dzw(1)
      do i=2,km
       sumt = sumt + dzt(i)
       dzw(i) = 2*(sumt-sumu)
       sumu = sumu + dzw(i)
      enddo
      zt(1) = 0.5*dzt(1); zw(1) = dzt(1)
      do i=2,km
        zw(i) = zw(i-1) + dzt(i); zt(i) = zt(i-1) + dzw(i-1)
      enddo
      dzw(0)  = zt(1); dzw(km) = zw(km) - zt(km)
      end subroutine grid_template



      subroutine kmt_template
c-----------------------------------------------------------------------
c     set up a simple topography
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      kmt_big=km
      end subroutine kmt_template




      subroutine htp_template
c-----------------------------------------------------------------------
c     set up a simple topography for partial cells
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      integer :: i,j
      htp=0.
      do i=1,imt
        do j=1,jmt
           if (kmt_big(i,j)>0)  htp(i,j)=zw(kmt_big(i,j))
        enddo
      enddo
      end subroutine htp_template




      subroutine init_cond_template
c-----------------------------------------------------------------------
c     setup simple initial conditions
c     for temperature, salinity and velocity
c     Note that streamfunction is diagnosed from full velocities.
c-----------------------------------------------------------------------
      use spflame_module
      use freesurf_module
      use jets_module
      implicit none
      integer :: i,j,k,io,n
      real    :: baru(is_pe:ie_pe)
      real    :: x,y,z,Bvsqr(km)

      Bvsqr(1)= Bv0**2*dzw(0)
      do k=2,km
        Bvsqr(k)= Bvsqr(k-1)+Bv0**2*exp(-zw(k-1)/h_W) *dzw(k-1)
      enddo

      do j=js_pe,je_pe
        do k=1,km
         do i=is_pe,ie_pe
           y=yu(j)* radius/180.0*pi  ! in centimeters
           u(i,k,j,1,:) = u_0 + u_y*y+ delta*y*y/2.0 
     &       + amp*(sin(  zt(k)/120.0e2  *2*pi)
     &       +      sin(  zt(k)/60.0e2  *2*pi)
     &       +      sin(  zt(k)/30.0e2  *2*pi)
     &       +      sin(  zt(k)/15.0e2  *2*pi)
     &       +      sin(  zt(k)/7.5e2  *2*pi)
     &       +      sin(  zt(k)/220.0e2  *2*pi)
     &       +      sin(  zt(k)/320.0e2  *2*pi)
     &       +      sin(  zt(k)/420.0e2  *2*pi)
     &       +      sin(  zt(k)/520.0e2  *2*pi)
     &       +      sin(  zt(k)/620.0e2  *2*pi)  )
c           u(i,k,j,1,:) = min(u(i,k,j,1,:),20.0)
c           u(i,k,j,1,:) = max(u(i,k,j,1,:),-20.0)
           y=y/100./1000. ! in km
           u(i,k,j,1,:) = u(i,k,j,1,:)*exp(-(y/200.)**2)

           u(i,k,j,2,:) = 0.   

           y     =  yt(j)* radius/180.0*pi  ! in centimeters
           t(i,k,j,1,:) = 20.0+rho0/(g*alpha_lin)*Bvsqr(k)
           t(i,k,j,2,:) = 0.   ! salinity equals 35 PSU

           t(i,k,j,1,:) = t(i,k,j,1,:)*tmask(i,k,j)
           t(i,k,j,2,:) = t(i,k,j,2,:)*tmask(i,k,j)
           u(i,k,j,1,:) = u(i,k,j,1,:)*umask(i,k,j)
           u(i,k,j,2,:) = u(i,k,j,2,:)*umask(i,k,j)

         enddo 
        enddo
      enddo

      do n=1,nt
       call set_cyclic_4th_order(t(:,:,:,n,0),km,2)
       call set_cyclic_4th_order(t(:,:,:,n,1),km,2)
      enddo
      do n=1,2
       call set_cyclic_4th_order(u(:,:,:,n,0),km,2)
       call set_cyclic_4th_order(u(:,:,:,n,1),km,2)
      enddo

c-----------------------------------------------------------------------
c        barotropic mode
c-----------------------------------------------------------------------

         if (enable_freesurf) then
c
c         set the free surface
c

         else ! enable_freesurf
c
c        diagnose streamfunction from full velocities
c        (works only for du/dx=0)
c
         psi = 0.0
         do j=js_pe,je_pe
c         depth integrated velocity
          baru=0.
          do k=1,km
           do i=is_pe,ie_pe
            baru(i) = baru(i) + u(i,k,j,1,0)*umask(i,k,j)
#ifdef partial_cell
     &                                    *dhu(i,k,j)
#else
     &                                    *dzt(k)
#endif
           enddo
          enddo
c         local integrant
          do i=is_pe,ie_pe
            psi(i,j+1,1) = -dyu(j)*baru(i)*umask(i,1,j)
          enddo
         enddo
         call border_exchg(psi(:,:,1),1,1)
         call set_cyclic(  psi(:,:,1),1,1)
c        Meridionally integrate psiu.
         do j=js_pe,je_pe
          do i=is_pe,ie_pe
            psi(i,j,1) = psi(i,j,1) + psi(i,j-1,1)
            psi(i,j,2) = psi(i,j,1) 
          enddo
         enddo
        endif ! enable_freesurf
      end subroutine init_cond_template



      subroutine sbc_template
c-----------------------------------------------------------------------
c     setup simple surface boundary conditions
c-----------------------------------------------------------------------
      use spflame_module
      implicit none
      smf=0.
      stf_clim=0.
      stf_rest=0.
      if (enable_ktmix.or.enable_tkemix) ustar=0.     ! no wind stirring
      end subroutine sbc_template



      subroutine blue_template
c-----------------------------------------------------------------------
c     setup simple temp / salinity arrays for BLUE
c-----------------------------------------------------------------------
      use spflame_module
      use blue_module
      implicit none
      end subroutine blue_template


      subroutine sponge_template(n)
c-----------------------------------------------------------------------
c     setup simple sponge layers. 
c-----------------------------------------------------------------------
      use spflame_module
      use jets_module
      implicit none
      integer, intent(in) :: n ! number of the tracer
      integer :: i,j,k,is,ie,js,je
      real :: y,fx,tstar,Bvsqr(km)

c-----------------------------------------------------------------------
c     inertial instability
c-----------------------------------------------------------------------

      is=max(is_pe,2); ie=min(ie_pe,imt-1)
      js=max(2,js_pe); je=min(je_pe,jmt-1)

      if (n==1) then

       Bvsqr(1)= Bv0**2*dzw(0)
       do k=2,km
        Bvsqr(k)= Bvsqr(k-1)+Bv0**2*exp(-zw(k-1)/h_W) *dzw(k-1)
       enddo

       do j=js,je
        do k=1,km
         do i=is,ie
           y     =  yt(j)* radius/180.0*pi  ! in centimeters
           fx    =  (cori(i,j-1,1)+cori(i,j,1))/2.0
           tstar = 20.0+rho0/(g*alpha_lin)*(Bvsqr(k)-fx*u_z*y )
           source(i,k,j)=source(i,k,j)+
     &        tscl*(tstar-t(i,k,j,n,taum1))*tmask(i,k,j)
         enddo 
        enddo
       enddo
      endif

      end subroutine sponge_template

#include "options.inc"

c
c     convert unformatted written data containing
c     surface and hydrostatic pressure to NetCDF format
c

c     real variables are 8 or 4 bytes long set by
c#define real_8
c
c
      module kind_mod
#ifdef real_8
      integer, parameter::  r_knd  = selected_real_kind(13)
#else
      integer, parameter::  r_knd  = selected_real_kind(6)
#endif
      end module kind_mod


      program cv_press
      use kind_mod
      implicit none
      character (len=80) :: infile,outfile
      integer :: ierr
      character (len=32) :: stamp
      integer :: imt,jmt,km,itm
      real (kind=r_knd),allocatable :: xt(:), yt(:), time(:)
      real (kind=r_knd), dimension(:,:,:), allocatable :: sfp, hsp
      real (kind=r_knd) :: spval
      real (kind=r_knd) :: tt
      integer :: io,n
#include "netcdf.inc"
      integer ncid,iret,i,j,k
      integer lat_tdim,itimedim, lon_tdim
      integer lat_tid,itimeid,lon_tid,sfpid,hspid
      integer dims(4), corner(4), edges(4)
      character name*24, unit*16, text*80
      print*,' Converting surface pressure written by SPFLAME ',
     &       ' to NetCDF file '
      call get_commandline_arg(1,infile,ierr)
      if (ierr/=0) goto 99
      print*,' reading from file ',infile(1:len_trim(infile))
      call get_commandline_arg(2,outfile,ierr)
      if (ierr/=0) goto 99
      print*,' writing to file ',outfile(1:len_trim(outfile))
      call getunit (io, infile,'u s r ieee')
      itm=0
 10   continue
      do k=1,6; read (io,end=20); enddo
      itm=itm+1
      goto 10
 20   continue
      print*,' found ',itm,' time steps in file ',infile
      rewind(io)
      read(io) stamp
      read(io) imt,jmt
      read(io) spval
      allocate( xt(imt), yt(jmt) )
      read(io) xt,yt
      rewind(io)
      allocate( time(itm), sfp(imt,jmt,itm), hsp(imt,jmt,itm) )
      do n=1,itm
       read(io) stamp
       call read_stamp(stamp,tt)
       time(n)=tt
       print*,' at stamp=',stamp,
     &          ' (days since origin : ',time(n),')'

       do k=1,3; read(io); enddo
       read(io) sfp(:,:,n)
       read(io) hsp(:,:,n)
      enddo
      close(io)


      ncid = nccre (outfile, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, iret)
c     dimensions
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      iTimedim  = ncddef(ncid, 'Time', nf_unlimited, iret)
c     grid variables
      dims(1)  = Lon_tdim
      Lon_tid  = ncvdef (ncid,'Longitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = Lat_tdim
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,dims,iret)
      dims(1)  = iTimedim
      iTimeid   = ncvdef(ncid,'Time',       NCFLOAT,1,dims,iret)

      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      sfpid=ncvdef (ncid,'sfp', NCFLOAT,3,dims,iret)
      dims=(/lon_tdim,lat_tdim,itimedim,1/)
      hspid=ncvdef (ncid,'hsp', NCFLOAT,3,dims,iret)
c     attributes of the grid
      name = 'Latitude on T grid      '; unit = 'degrees_N       '
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Longitude on T grid      '; unit = 'degrees_W       '
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, 16, unit, iret) 
      name = 'Time                    '; unit = 'days            '
      call ncaptc(ncid, iTimeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, iTimeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, iTimeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c     attributes of variables
      name = 'Sea surface pressure'; unit = 'bar'
      call dvcdf_here(ncid,sfpid,name,24,unit,16,spval)
      name = 'Hydrostatic pressure'; unit = 'bar'
      call dvcdf_here(ncid,hspid,name,24,unit,16,spval)
      call ncendf(ncid, iret)

      corner=(/1,1,1,1/); 
      edges=(/imt,jmt,itm,1/)
#ifdef real_8
      iret= nf_put_vara_double (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_double (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_double (ncid,itimeid,1,itm,time)
      iret= nf_put_vara_double (ncid,sfpid ,corner, edges,sfp)
      iret= nf_put_vara_double (ncid,hspid ,corner, edges,hsp)
#else
      iret= nf_put_vara_real (ncid,lat_tid,1,jmt,yt)
      iret= nf_put_vara_real (ncid,lon_tid,1,imt,xt)
      iret= nf_put_vara_real (ncid,itimeid,1,itm,time)
      iret= nf_put_vara_real (ncid,sfpid ,corner, edges,sfp)
      iret= nf_put_vara_real (ncid,hspid ,corner, edges,hsp)
#endif
      call ncclos (ncid, iret)

      stop

 99   print*,' program needs command line parameter'
      print*,' 1. input binary file name (written by spflame)'
      print*,' 2. output NetCDF file name '

      end program cv_press





      subroutine dvcdf_here(ncid,ivarid,name,iname,unit,iunit,spval)
c-----------------------------------------------------------------------
c define some standard attributes of variable ivarid in NetCDF file ncid 
c-----------------------------------------------------------------------
      use kind_mod
      implicit none
      integer ncid,ivarid,iname,iunit,iret
      character*(*) name, unit
      real (kind=r_knd):: spval
#include "netcdf.inc"
      call ncaptc(ncid,ivarid, 'long_name', NCCHAR,iname , name, iret) 
      call ncaptc(ncid,ivarid, 'units',     NCCHAR,iunit, unit, iret) 
#ifdef real_8
      iret=nf_put_att_double(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_double(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#else
      iret=nf_put_att_real(NCID,iVARID, 'missing_value', NCFLOAT, 
     &                       1,spval)
      iret=nf_put_att_real(NCID,iVARID, '_FillValue', NCFLOAT, 
     &                       1,spval)
#endif
c        if (iret.ne.0) print*,nf_strerror(iret)
      end subroutine dvcdf_here



      subroutine barrier
      end

      subroutine halt_stop(s)
      character*(*) s
      print*,s
      stop
      end

#include "options.inc"

c
c ------------------------------------------------------
c   Templates to create restoring zones (sponge layers) 
c   for tracers in the model domain.
c
c   Notes:
c    uses  "write_spg_to_cdf" (in prep_out.F) to
c    write out the sponge layer to netcdf output file.
c    temperature should be potential temperature in
c    deg C, salinity in (psu-35)/1000.
c    A single subroutine is defined "prep_sponge"
c    Header of subroutines should not be touched.
c    CPP directives are set in prep_template.F
c
c                            c.eden  nov 2002
c ------------------------------------------------------
c

       subroutine prep_sponge
       use prep_module
       implicit none
       real, allocatable :: time_scale(:,:,:,:)
       real, allocatable :: tr(:,:,:,:)
       real, allocatable :: trbuf(:,:,:,:)
       integer is,ie,js,je,js2,j1,i,j,k
       real :: dstnce
       integer :: n,indp,m
       real, allocatable :: buf(:,:,:,:)

       call init_forcing_file('forcing_sponge.cdf')

       allocate(  buf(imt,jmt,km,number_tr) )


#ifdef prep_sponge_for_K1

c sponge layer number 1 in the Greenland Sea
c use the same restoring timescales as in DYNAMO I
c (from file interpol.f written by P.Herrmann) 
c and also the same data !!
      js=indp(60.5,yt,jmt); je=jmt-1 
      is=indp(320.0,xt,imt); ie=imt
      allocate(time_scale(is:ie,js:je,km,number_tr) )
      time_scale=0. ! set inverse time scale to zero for passive tracers
      call peters_rest_time_scale(time_scale,is,ie,js,je)
      time_scale(:,:,:,2)=time_scale(:,:,:,1)
      allocate(tr(is:ie,js:je,km,number_tr) ); tr=0.
      do n=1,12
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
c sponge layer 2 for the med sea
c search for point (i,j) of med sea outflow
      ie=indp(354.0,xt,imt)
      j1=indp(36.0,yt,jmt)
c search for southernmost and northernmost jrows for rest. zone
      js=indp(yt(j1)-7.,yt,jmt) 
      je=indp(yt(j1)+7.,yt,jmt)
      is=ie-3
      allocate(time_scale(is:ie,js:je,km,number_tr) ); time_scale=0.
      do i=is,ie; do j=js,je
        if (dstnce(yt(j),xt(i),yt(j1),xt(ie))<=600.0) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(10.0*86400.0)
     &             *exp(- (zt(k)/100.0-1200.0)**2/400.0**2 )
         enddo
        endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr) )
      do n=1,12
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
#endif




#if defined prep_sponge_for_E1 || defined prep_sponge_for_E0

c sponge layer number 1 in the Greenland Sea
c use the same restoring timescales as in DYNAMO I
c (from file interpol.f written by P.Herrmann) 
c and also the same data !!
      print*,' setting up sponge 1 for E1/E0 setup'
      js=indp(60.5,yt,jmt); je=jmt-1 
      is=indp(320.0,xt,imt); ie=imt
      allocate(time_scale(is:ie,js:je,km,number_tr) )
      time_scale=0. ! set inverse time scale to zero for passive tracers
      call peters_rest_time_scale(time_scale,is,ie,js,je)
      time_scale(:,:,:,2)=time_scale(:,:,:,1)
      allocate(tr(is:ie,js:je,km,number_tr) )
      allocate(trbuf(imt,jmt,km,number_tr) )
      tr=0.;trbuf=0.
      do n=1,12
       call read_ts_from_file(n,trbuf)
       call read_schiller_sponges(trbuf(:,:,:,1),trbuf(:,:,:,2),n)
       tr=trbuf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale,trbuf)
      print*,'done'
c sponge layer 2 for the med sea
c search for point (i,j) of med sea outflow
      print*,' setting up sponge 2 for E1/E0 setup'
      ie=indp(354.0,xt,imt)
      j1=indp(36.0,yt,jmt)
c search for southernmost and northernmost jrows for rest. zone
      js=indp(yt(j1)-7.,yt,jmt) 
      je=indp(yt(j1)+7.,yt,jmt)
      is=ie-3
      allocate(time_scale(is:ie,js:je,km,number_tr) ); time_scale=0.
      do i=is,ie; do j=js,je
        if (dstnce(yt(j),xt(i),yt(j1),xt(ie))<=600.0) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(10.0*86400.0)
     &             *exp(- (zt(k)/100.0-1200.0)**2/400.0**2 )
         enddo
        endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr) )
      do n=1,12
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
      print*,'done'
#endif

#if defined prep_sponge_for_E0
c
c sponge layer 3 for southern boundary
c
      print*,' setting up sponge 3 for E0 setup'
      is=2; ie=imt-1; js=2; je=5
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(3.0*86400.0)
        enddo
#ifdef  prep_for_NPZD
        if (number_tr >=3) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,3)=1.0/(3.0*86400.0)
         enddo
        endif
        if (number_tr >=7) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,7:numbert_tr)=1.0/(3.0*86400.0)
         enddo
        endif
c        if (number_tr >=8) then
c         do k=1,kmt(i,j)
c          time_scale(i,j,k,8)=1.0/(3.0*86400.0)
c         enddo
c        endif
#endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
      print*,'done'
#endif

#ifdef prep_sponge_for_E7

c sponge layer 1 for the med sea
      print*,'generating sponge for E7: Med outflow'
c search for point (i,j) of med sea outflow
      ie=indp(354.0,xt,imt)
      j1=indp(36.0,yt,jmt)
c search for southernmost and northernmost jrows for rest. zone
      js=indp(yt(j1)-7.,yt,jmt) 
      je=indp(yt(j1)+7.,yt,jmt)
      is=ie-3
      allocate(time_scale(is:ie,js:je,km,number_tr) ); time_scale=0.
      do i=is,ie; do j=js,je
        if (dstnce(yt(j),xt(i),yt(j1),xt(ie))<=600.0) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(10.0*86400.0)
     &             *exp(- (zt(k)/100.0-1200.0)**2/400.0**2 )
         enddo
        endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr) )
      do n=1,12
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
#endif



#ifdef prep_sponge_for_D3

c sponge layer number 1 in the Greenland Sea
c use the same restoring timescales as in DYNAMO I
c (from file interpol.f written by P.Herrmann) 
      js=indp(60.5,yt,jmt); je=jmt-1 
      is=indp(320.0,xt,imt); ie=imt
      allocate(tr(is:ie,js:je,km,1) ); tr=0.
      call peters_rest_time_scale(tr,is,ie,js,je)
      js2=jmt-10
      allocate(time_scale(is:ie,js2:je,km,number_tr) )
      time_scale=0.
      time_scale(is:ie,js2:je,1:km,1) = tr(is:ie,js2:je,1:km,1)
      time_scale(is:ie,js2:je,1:km,2) = tr(is:ie,js2:je,1:km,1)
      deallocate( tr) 
      js=js2
      allocate(tr(is:ie,js:je,km,number_tr) )
      allocate(trbuf(imt,jmt,km,number_tr)  )
      tr=0.;trbuf=0.
      do n=1,12
       call read_ts_from_file(n,trbuf)
       call read_schiller_sponges(trbuf(1,1,1,1),trbuf(1,1,1,2),n)
       tr=trbuf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale,trbuf)
c sponge layer 2 is for the med sea
c search for point (i,j) of med sea outflow
      ie=282
      j1=172
c search for southernmost and northernmost jrows for rest. zone
      js=152
      je=192
      is=263 ! = imtf
      allocate(time_scale(is:ie,js:je,km,number_tr) ); time_scale=0.
      do i=is,ie; do j=js,je
        if (dstnce(yt(j),xt(i),yt(j1),xt(ie))<=600.0) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(10.0*86400.0)
     &             *exp(- (zt(k)/100.0-1200.0)**2/400.0**2 )
         enddo
        endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
#endif


#ifdef prep_sponge_for_D4

      print*,' setting up Med Sea sponge for D4 setup'
c sponge layer 1 is for the med sea
c search for point (i,j) of med sea outflow
      ie=282
      j1=172
c search for southernmost and northernmost jrows for rest. zone
      js=152
      je=192
      is=263 ! = imtf
      allocate(time_scale(is:ie,js:je,km,number_tr) ); time_scale=0.
      do i=is,ie; do j=js,je
        if (dstnce(yt(j),xt(i),yt(j1),xt(ie))<=600.0) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(10.0*86400.0)
     &             *exp(- (zt(k)/100.0-1200.0)**2/400.0**2 )
         enddo
        endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)

#ifdef  prep_for_NPZD
      print*,' setting up northern NO3 sponge for D4 setup'
      is=2; ie=imt-1; js=jmt-1-10; je=jmt-1
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        if (number_tr >=3) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,3)=1.0/(3.0*86400.0)
         enddo
        endif
        if (number_tr >=7) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,7)=1.0/(3.0*86400.0)
         enddo
        endif
        if (number_tr >=8) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,8)=1.0/(3.0*86400.0)
         enddo
        endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)


      print*,' setting up southern NO3 sponge for D4 setup'
      is=2; ie=imt-1; js=2; je=5*2
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        if (number_tr >=3) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,3)=1.0/(3.0*86400.0)
         enddo
        endif
        if (number_tr >=7) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,7)=1.0/(3.0*86400.0)
         enddo
        endif
        if (number_tr >=8) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,8)=1.0/(3.0*86400.0)
         enddo
        endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
#endif
      print*,'done'
#endif



#ifdef prep_sponge_for_HS2

c sponge layer number 1 in the Greenland Sea
c use the same restoring timescales as in DYNAMO I
c (from file interpol.f written by P.Herrmann) 
      js=indp(60.5,yt,jmt); je=jmt-1 
      is=indp(320.0,xt,imt); ie=imt
      allocate(tr(is:ie,js:je,km,1) ); tr=0.
      call peters_rest_time_scale(tr,is,ie,js,je)
      js2=jmt-37
      allocate(time_scale(is:ie,js2:je,km,number_tr) )
      time_scale=0.
      time_scale(is:ie,js2:je,1:km,1) = tr(is:ie,js2:je,1:km,1)
      time_scale(is:ie,js2:je,1:km,2) = tr(is:ie,js2:je,1:km,1)
      deallocate( tr) 
      js=js2
      allocate(tr(is:ie,js:je,km,number_tr) )
      allocate(trbuf(imt,jmt,km,number_tr)  )
      tr=0.;trbuf=0.
      do n=1,12
       call read_ts_from_file(n,trbuf)
       call read_schiller_sponges(trbuf(1,1,1,1),trbuf(1,1,1,2),n)
       tr=trbuf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale,trbuf)

c sponge layer 2 is for the med sea
c search for point (i,j) of med sea outflow
      ie=1127
      j1=indp(36.0,yt,jmt)
c search for southernmost and northernmost jrows for rest. zone
      js=603
      je=763
      is=1051 ! = imtf
      allocate(time_scale(is:ie,js:je,km,number_tr) ); time_scale=0.
      do i=is,ie; do j=js,je
        if (dstnce(yt(j),xt(i),yt(j1),xt(ie))<=600.0) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(10.0*86400.0)
     &             *exp(- (zt(k)/100.0-1200.0)**2/400.0**2 )
         enddo
        endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
#endif

#ifdef prep_sponge_for_HS3

      print*,' setting up sponge 1 for HS3 setup'
      call sub_flush(6)

c the only sponge layer is in the med sea

      is=1280;ie=1315; js=695; je=817 
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(3.0*86400.0)
        enddo
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call sub_flush(6)
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)

#ifdef  prep_for_NPZD
      print*,' setting up northern NO3 sponge for HS3 setup'
      is=2; ie=imt-1; js=jmt-1-10; je=jmt-1
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        if (number_tr >=3) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,3)=1.0/(3.0*86400.0)
         enddo
        endif
        if (number_tr >=7) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,7)=1.0/(3.0*86400.0)
         enddo
        endif
        if (number_tr >=8) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,8)=1.0/(3.0*86400.0)
         enddo
        endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)


      print*,' setting up southern NO3 sponge for HS3 setup'
      is=2; ie=imt-1; js=2; je=5*2
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        if (number_tr >=3) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,3)=1.0/(3.0*86400.0)
         enddo
        endif
        if (number_tr >=7) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,7)=1.0/(3.0*86400.0)
         enddo
        endif
        if (number_tr >=8) then
         do k=1,kmt(i,j)
          time_scale(i,j,k,8)=1.0/(3.0*86400.0)
         enddo
        endif
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
#endif
      print*,'done'

#endif

#ifdef prep_sponge_for_PAC

c sponge layer 1 is for Indonesian throughflow

      print*,' setting up sponge 1 for PACific setup'
      is=2; ie=4; js=45; je=66
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(3.0*86400.0)
        enddo
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
      print*,'done'

      print*,' setting up sponge 2 for PACific setup'
      is=5; ie=15; js=48; je=50 !/i=5:15/j=48:50
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(3.0*86400.0)
        enddo
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
      print*,'done'
#endif

#ifdef prep_sponge_for_I1

c sponge layer 1 is for Red Sea

      print*,' setting up sponge 1 for Indic setup'
      is=22; ie=35; js=143; je=154
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(3.0*86400.0)
        enddo
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
      print*,'done'

      print*,' setting up sponge 2 for Indic setup'
      is=75; ie=93; js=202; je=206 !/i=5:15/j=48:50
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(3.0*86400.0)
        enddo
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
      print*,'done'



      print*,' setting up sponge 3 for Indic setup'
      is=306; ie=337; js=71; je=77 
      allocate(time_scale(is:ie,js:je,km,number_tr) ); 
      time_scale=0.
      do i=is,ie; do j=js,je
        do k=1,kmt(i,j)
          time_scale(i,j,k,1:2)=1.0/(3.0*86400.0)
        enddo
      enddo; enddo
      allocate(tr(is:ie,js:je,km,number_tr)  )
      do n=1,12
       print*,' month=',n
       call read_ts_from_file(n,buf)
       tr(:,:,:,:)=buf(is:ie,js:je,:,:)
       do m=1,number_tr
        call write_spg_to_cdf(time_scale(:,:,:,m),
     &         tr(:,:,:,m),is,ie,js,je,12,n,m)
       enddo
      enddo
      deallocate(tr,time_scale)
      print*,'done'

#endif

      deallocate(buf)
      end subroutine prep_sponge

c
c    local functions and subroutines used by prep_sponge
c

      function dstnce(phi1,rla1,phi2,rla2)
c returns distance (in km) between two geographical
c points
c        written by   p.herrmann 
c      phi1 : first latitude 
c      rla1 : first longitude
c      phi2 : second latitude
c      rla2 : second longitude

      real p1,p2,rl1,rl2,x,xx
      data s/0.0174533/
      p1=phi1*s; p2=phi2*s; rl1=rla1*s; rl2=rla2*s
      x=sin(p1)*sin(p2)+cos(p1)*cos(p2)*cos(rl2-rl1)
      xx=abs(x)
      if(xx.gt.1.0) x=1.0
      d=atan(sqrt((1-x)/(1+x)))*222.24/s; dstnce=d
      end function dstnce


#if defined prep_sponge_for_E1 || defined prep_sponge_for_E0
      subroutine read_schiller_sponges(temp,salt,nl)
c      read the old schiller dataset from binary file
c      it is assumed that data are already interpolated
c      and folded. read data into temp and salt from prep_module
      use prep_module
      implicit none
      integer :: nl
      real :: temp(imt,jmt,km), salt(imt,jmt,km)
      integer (kind=4) :: io=10,jsx,jnx,m,i,k
c      integer :: imtf =67 ! imtf of FLAME E
c      integer :: imtuf=67 ! imtuf of FLAME E
c      integer :: jmtflame=89 ! imtuf of FLAME E
      integer :: imtf =79 ! imtf of FLAME B
      integer :: imtuf=98 ! imtuf of FLAME B
      integer :: jmtflame=150 ! imtuf of FLAME B
      character (len=32) s
      real (kind=4) dpm
      real (kind=4), allocatable :: bufn(:,:,:,:)
      integer j,jj
      character (len=80) :: infile = 'data/schiller/grid_B_folded.mom'
      print*,' reading TS data from file ',
     &       infile(1:len_trim(infile)),' for month=',nl
      open (io,file=infile,form='unformatted',status='old')
      read (io); read (io) jsx,jnx 
      allocate( bufn(imtuf,km,jnx,2) )
      do m=1,nl-1
       read (io) ; read (io)   ! data
      enddo
      read (io)   ! iotext
c      does not work for pflame option sponge1_converted
      read (io) s,dpm,i,i,i,i,i,i,
     &             (dpm,i=1,jmtflame),(dpm,i=1,jmtflame),
     &             (dpm,i=1,imtf*km*jsx*2),bufn(1:imtf,:,:,:)
c     unfold and transfer to temp/salt fields
      do i=imtf-1,imtuf
         bufn(i,:,:,:)= bufn(i-imtf+2,:,:,:)
      enddo
      do j=1,jnx
       jj=j+jmt-jnx-1
       do i=1,min(imt,imtuf)
        temp(i,jj,:)= bufn(i,:,j,1)
        salt(i,jj,:)= bufn(i,:,j,2)
       enddo
      enddo
      deallocate( bufn)
      close(io)
      do k=1,km
       where( k>kmt) temp(:,:,k)=spval
       where( k>kmt) salt(:,:,k)=spval
      enddo
      end subroutine  read_schiller_sponges
#endif

#if defined prep_sponge_for_D3 || defined prep_sponge_for_HS2

      subroutine read_schiller_sponges(temp,salt,nl)
c      read the old schiller dataset from binary file
c      it is assumed that data are already interpolated
c      and folded. read data into temp and salt from prep_module
      use prep_module
      implicit none
      integer :: nl
      real :: temp(imt,jmt,km), salt(imt,jmt,km)
      integer (kind=4) :: io=10,jsx,jnx,m,i,k
#ifdef prep_sponge_for_HS2
      integer :: imtf =1021 ! imtf of FLAME H
      integer :: imtuf=1394 ! imtuf of FLAME H
      integer :: jmtflame=1416 ! imtuf of FLAME H
      character (len=80) :: infile = 'data/schiller/grid_H_folded.mom'
#else
      integer :: imtf =263 ! imtf of FLAME D
      integer :: imtuf=348 ! imtuf of FLAME D
      integer :: jmtflame=356 ! imtuf of FLAME D
      character (len=80) :: infile = 'data/schiller/grid_D_folded.mom'
#endif
      character (len=32) s
      character(len=80) iotext
      real (kind=4) dpm
      real (kind=4), allocatable :: bufn(:,:,:,:)
      integer j,jj
      print*,' reading TS data from file ',
     &       infile(1:len_trim(infile)),' for month=',nl
      open (io,file=infile,form='unformatted',status='old')
      read (io) ! FLAME_ID
      read (io) jsx,jnx 
      allocate( bufn(imtuf,km,jnx,2) )
      do m=1,nl-1
       read (io) iotext
       read (io)   ! stamp et al
       do j=1,jsx
        read (io)   ! souther sponge  temp
        read (io)   ! souther sponge  salt
       enddo
       do j=1,jnx
        read (io)   ! northern sponge  temp
        read (io)   ! northern sponge  salt
       enddo
      enddo
      read (io)   iotext
c      print*,'iot-',iotext
      read (io)   ! stamp et al
      do j=1,jsx
        read (io)   ! souther sponge  temp
        read (io)   ! souther sponge  salt
      enddo
      do j=1,jnx
        read (io) ((bufn(i,k,j,1),i=1,imtf),k=1,km)
        read (io) ((bufn(i,k,j,2),i=1,imtf),k=1,km)
      enddo
c     unfold and transfer to temp/salt fields
      do i=imtf-1,imtuf
         bufn(i,:,:,:)= bufn(i-imtf+2,:,:,:)
      enddo
      do j=1,jnx
       jj=j+jmt-jnx-1
       do i=1,min(imt,imtuf)
        temp(i,jj,:)= bufn(i,:,j,1)
        salt(i,jj,:)= bufn(i,:,j,2)
       enddo
      enddo
      deallocate( bufn)
      do k=1,km
       where( k>kmt) temp(:,:,k)=spval
       where( k>kmt) salt(:,:,k)=spval
      enddo
      close(io)
      end subroutine  read_schiller_sponges
#endif




      subroutine peters_rest_time_scale(rest_tn,i1,ie,jsn,jen)
c    creates the time scale for the northern restoring
c    zone in the DYNAMO models.
      use prep_module
      implicit none
      integer i1,ie,jsn,jen
      real rest_tn(i1:ie,jsn:jen,km)
      integer i,j,k,j1,indp,i2
      real dx1,phi67,factor,south,dstnce
      i2=indp(350.0,xt,imt)
      j1=indp(67.0,yt,jmt)
      dx1=yt(jen)-yt(j1)
      do i=i1,i2
       do j=j1,jen
        do k=1,kmt(i,j)
         rest_tn(i,j,k)=
     &        1.0/((97.0/dx1*(yt(jen)-yt(j))+3.0)*86400.0)
        enddo
       enddo
      enddo
      phi67=yt(j1)
      factor=(yt(jsn)-yt(j1))/(xt(imt)-xt(i2))
      do i=i2+1,imt
       south=phi67+factor*(xt(i)-xt(i2))
       j1=indp(south,yt,jmt)
       dx1=yt(jen)-yt(j1)
       do j=j1,jen
        do k=1,kmt(i,j)
         rest_tn(i,j,k)=
     &    1.0/((97.0/dx1*(yt(jen)-yt(j))+3.0)*86400.0)
        enddo
       enddo
      enddo
      end subroutine peters_rest_time_scale
